/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ne=function(J){for(var e=[],S=0,R=J.length;S<R;S++)e[S]=ie[J[S]];return e};define(ie[134],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function S(m,w,d){const h=R(m,w);if(h!==-1)return m[h]}e.$fb=S;function R(m,w,d=m.length-1){for(let h=d;h>=0;h--){const l=m[h];if(w(l))return h}return-1}e.$gb=R;function s(m,w){const d=O(m,w);return d===-1?void 0:m[d]}e.$hb=s;function O(m,w,d=0,h=m.length){let l=d,E=h;for(;l<E;){const u=Math.floor((l+E)/2);w(m[u])?l=u+1:E=u}return l-1}e.$ib=O;function D(m,w){const d=P(m,w);return d===m.length?void 0:m[d]}e.$jb=D;function P(m,w,d=0,h=m.length){let l=d,E=h;for(;l<E;){const u=Math.floor((l+E)/2);w(m[u])?E=u:l=u+1}return l}e.$kb=P;function f(m,w,d=0,h=m.length){const l=P(m,w,d,h);return l===m.length?-1:l}e.$lb=f;class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!w(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const d=O(this.e,w,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$mb=c;function $(m,w){if(m.length===0)return;let d=m[0];for(let h=1;h<m.length;h++){const l=m[h];w(l,d)>0&&(d=l)}return d}e.$nb=$;function b(m,w){if(m.length===0)return;let d=m[0];for(let h=1;h<m.length;h++){const l=m[h];w(l,d)>=0&&(d=l)}return d}e.$ob=b;function y(m,w){return $(m,(d,h)=>-w(d,h))}e.$pb=y;function g(m,w){if(m.length===0)return-1;let d=0;for(let h=1;h<m.length;h++){const l=m[h];w(l,m[d])>0&&(d=h)}return d}e.$qb=g;function v(m,w){for(const d of m){const h=w(d);if(h!==void 0)return h}}e.$rb=v}),define(ie[135],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function S(D,P){const f=Object.create(null);for(const c of D){const $=P(c);let b=f[$];b||(b=f[$]=[]),b.push(c)}return f}e.$J=S;function R(D,P){const f=[],c=[];for(const $ of D)P.has($)||f.push($);for(const $ of P)D.has($)||c.push($);return{removed:f,added:c}}e.$K=R;function s(D,P){const f=[],c=[];for(const[$,b]of D)P.has($)||f.push(b);for(const[$,b]of P)D.has($)||c.push(b);return{removed:f,added:c}}e.$L=s;function O(D,P){const f=new Set;for(const c of P)D.has(c)&&f.add(c);return f}e.$M=O}),define(ie[136],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=e.$Us=void 0;function S(P,f){const c=Math.pow(10,f);return Math.round(P*c)/c}class R{constructor(f,c,$,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=S(Math.max(Math.min(1,b),0),3)}static equals(f,c){return f.r===c.r&&f.g===c.g&&f.b===c.b&&f.a===c.a}}e.$Us=R;class s{constructor(f,c,$,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.l=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(f,c){return f.h===c.h&&f.s===c.s&&f.l===c.l&&f.a===c.a}static fromRGBA(f){const c=f.r/255,$=f.g/255,b=f.b/255,y=f.a,g=Math.max(c,$,b),v=Math.min(c,$,b);let m=0,w=0;const d=(v+g)/2,h=g-v;if(h>0){switch(w=Math.min(d<=.5?h/(2*d):h/(2-2*d),1),g){case c:m=($-b)/h+($<b?6:0);break;case $:m=(b-c)/h+2;break;case b:m=(c-$)/h+4;break}m*=60,m=Math.round(m)}return new s(m,w,d,y)}static i(f,c,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?f+(c-f)*6*$:$<1/2?c:$<2/3?f+(c-f)*(2/3-$)*6:f}static toRGBA(f){const c=f.h/360,{s:$,l:b,a:y}=f;let g,v,m;if($===0)g=v=m=b;else{const w=b<.5?b*(1+$):b+$-b*$,d=2*b-w;g=s.i(d,w,c+1/3),v=s.i(d,w,c),m=s.i(d,w,c-1/3)}return new R(Math.round(g*255),Math.round(v*255),Math.round(m*255),y)}}e.$Vs=s;class O{constructor(f,c,$,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=S(Math.max(Math.min(1,c),0),3),this.v=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(f,c){return f.h===c.h&&f.s===c.s&&f.v===c.v&&f.a===c.a}static fromRGBA(f){const c=f.r/255,$=f.g/255,b=f.b/255,y=Math.max(c,$,b),g=Math.min(c,$,b),v=y-g,m=y===0?0:v/y;let w;return v===0?w=0:y===c?w=(($-b)/v%6+6)%6:y===$?w=(b-c)/v+2:w=(c-$)/v+4,new O(Math.round(w*60),m,y,f.a)}static toRGBA(f){const{h:c,s:$,v:b,a:y}=f,g=b*$,v=g*(1-Math.abs(c/60%2-1)),m=b-g;let[w,d,h]=[0,0,0];return c<60?(w=g,d=v):c<120?(w=v,d=g):c<180?(d=g,h=v):c<240?(d=v,h=g):c<300?(w=v,h=g):c<=360&&(w=g,h=v),w=Math.round((w+m)*255),d=Math.round((d+m)*255),h=Math.round((h+m)*255),new R(w,d,h,y)}}e.$Ws=O;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,c){return!f&&!c?!0:!f||!c?!1:f.equals(c)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:O.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof R)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof O)this.j=f,this.rgba=O.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&R.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&O.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),c=D.k(this.rgba.g),$=D.k(this.rgba.b),b=.2126*f+.7152*c+.0722*$;return S(b,4)}static k(f){const c=f/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(f){const c=this.getRelativeLuminance(),$=f.getRelativeLuminance();return c>$?(c+.05)/($+.05):($+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const c=this.getRelativeLuminance(),$=f.getRelativeLuminance();return c>$}isDarkerThan(f){const c=this.getRelativeLuminance(),$=f.getRelativeLuminance();return c<$}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:c,g:$,b,a:y}=this.rgba;return new D(new R(c,$,b,y*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const c=f.rgba,$=this.rgba.a,b=c.a,y=$+b*(1-$);if(y<1e-6)return D.transparent;const g=this.rgba.r*$/y+c.r*b*(1-$)/y,v=this.rgba.g*$/y+c.g*b*(1-$)/y,m=this.rgba.b*$/y+c.b*b*(1-$)/y;return new D(new R(g,v,m,y))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:c,g:$,b,a:y}=this.rgba;return new D(new R(f.rgba.r-y*(f.rgba.r-c),f.rgba.g-y*(f.rgba.g-$),f.rgba.b-y*(f.rgba.b-b),1))}flatten(...f){const c=f.reduceRight(($,b)=>D.o(b,$));return D.o(this,c)}static o(f,c){const $=1-f.rgba.a;return new D(new R($*c.rgba.r+f.rgba.a*f.rgba.r,$*c.rgba.g+f.rgba.a*f.rgba.g,$*c.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,c,$){if(f.isLighterThan(c))return f;$=$||.5;const b=f.getRelativeLuminance(),y=c.getRelativeLuminance();return $=$*(y-b)/y,f.lighten($)}static getDarkerColor(f,c,$){if(f.isDarkerThan(c))return f;$=$||.5;const b=f.getRelativeLuminance(),y=c.getRelativeLuminance();return $=$*(b-y)/b,f.darken($)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$Xs=D,function(P){let f;(function(c){let $;(function(b){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}b.formatRGB=y;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}b.formatRGBA=g;function v(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}b.formatHSL=v;function m(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}b.formatHSLA=m;function w(i){const a=i.toString(16);return a.length!==2?"0"+a:a}function d(i){return`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}`}b.formatHex=d;function h(i,a=!1){return a&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${w(i.rgba.r)}${w(i.rgba.g)}${w(i.rgba.b)}${w(Math.round(i.rgba.a*255))}`}b.formatHexA=h;function l(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}b.format=l;function E(i){const a=i.length;if(a===0||i.charCodeAt(0)!==35)return null;if(a===7){const o=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),t=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),n=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new P(new R(o,t,n,1))}if(a===9){const o=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),t=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),n=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),r=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new P(new R(o,t,n,r/255))}if(a===4){const o=u(i.charCodeAt(1)),t=u(i.charCodeAt(2)),n=u(i.charCodeAt(3));return new P(new R(16*o+o,16*t+t,16*n+n))}if(a===5){const o=u(i.charCodeAt(1)),t=u(i.charCodeAt(2)),n=u(i.charCodeAt(3)),r=u(i.charCodeAt(4));return new P(new R(16*o+o,16*t+t,16*n+n,(16*r+r)/255))}return null}b.parseHex=E;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=c.CSS||(c.CSS={}))})(f=P.Format||(P.Format={}))}(D||(e.$Xs=D={}))}),define(ie[54],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function S(D){return(P,f,c)=>{let $=null,b=null;if(typeof c.value=="function"?($="value",b=c.value):typeof c.get=="function"&&($="get",b=c.get),!b)throw new Error("not supported");c[$]=D(b,f)}}function R(D,P,f){let c=null,$=null;if(typeof f.value=="function"?(c="value",$=f.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(c="get",$=f.get),!$)throw new Error("not supported");const b=`$memoize$${P}`;f[c]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,y)}),this[b]}}e.$hh=R;function s(D,P,f){return S((c,$)=>{const b=`$debounce$${$}`,y=`$debounce$result$${$}`;return function(...g){this[y]||(this[y]=f?f():void 0),clearTimeout(this[b]),P&&(this[y]=P(this[y],...g),g=[this[y]]),this[b]=setTimeout(()=>{c.apply(this,g),this[y]=f?f():void 0},D)}})}e.$ih=s;function O(D,P,f){return S((c,$)=>{const b=`$throttle$timer$${$}`,y=`$throttle$result$${$}`,g=`$throttle$lastRun$${$}`,v=`$throttle$pending$${$}`;return function(...m){if(this[y]||(this[y]=f?f():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...m)),this[v])return;const w=this[g]+D;w<=Date.now()?(this[g]=Date.now(),c.apply(this,[this[y]]),this[y]=f?f():void 0):(this[v]=!0,this[b]=setTimeout(()=>{this[v]=!1,this[g]=Date.now(),c.apply(this,[this[y]]),this[y]=f?f():void 0},w-Date.now()))}})}e.$jh=O}),define(ie[14],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(a=>{a(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=S,e.$X=new S;function R(u){e.$X.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=R;function s(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function O(u){c(u)||e.$X.onUnexpectedError(u)}e.$1=O;function D(u){c(u)||e.$X.onUnexpectedExternalError(u)}e.$2=D;function P(u){if(u instanceof Error){const{name:i,message:a}=u,o=u.stacktrace||u.stack;return{$isError:!0,name:i,message:a,stack:o,noTelemetry:l.isErrorNoTelemetry(u)}}return u}e.$3=P;const f="Canceled";function c(u){return u instanceof $?!0:u instanceof Error&&u.name===f&&u.message===f}e.$4=c;class $ extends Error{constructor(){super(f),this.name=this.message}}e.$5=$;function b(){const u=new Error(f);return u.name=u.message,u}e.$6=b;function y(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$7=y;function g(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$8=g;class v extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function m(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$0=m;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=w;class d extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=d;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=h;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const a=new l;return a.message=i.message,a.stack=i.stack,a}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=l;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(ie[23],ne([0,1,14,134]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(N,B=0){return N[N.length-(1+B)]}e.$sb=s;function O(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.$tb=O;function D(N,B,V=(oe,de)=>oe===de){if(N===B)return!0;if(!N||!B||N.length!==B.length)return!1;for(let oe=0,de=N.length;oe<de;oe++)if(!V(N[oe],B[oe]))return!1;return!0}e.$ub=D;function P(N,B){const V=N.length-1;B<V&&(N[B]=N[V]),N.pop()}e.$vb=P;function f(N,B,V){return c(N.length,oe=>V(N[oe],B))}e.$wb=f;function c(N,B){let V=0,oe=N-1;for(;V<=oe;){const de=(V+oe)/2|0,ue=B(de);if(ue<0)V=de+1;else if(ue>0)oe=de-1;else return de}return-(V+1)}e.$xb=c;function $(N,B,V){if(N=N|0,N>=B.length)throw new TypeError("invalid index");const oe=B[Math.floor(B.length*Math.random())],de=[],ue=[],he=[];for(const ve of B){const be=V(ve,oe);be<0?de.push(ve):be>0?ue.push(ve):he.push(ve)}return N<de.length?$(N,de,V):N<de.length+he.length?he[0]:$(N-(de.length+he.length),ue,V)}e.$yb=$;function b(N,B){const V=[];let oe;for(const de of N.slice(0).sort(B))!oe||B(oe[0],de)!==0?(oe=[de],V.push(oe)):oe.push(de);return V}e.$zb=b;function*y(N,B){let V,oe;for(const de of N)oe!==void 0&&B(oe,de)?V.push(de):(V&&(yield V),V=[de]),oe=de;V&&(yield V)}e.$Ab=y;function g(N,B){for(let V=0;V<=N.length;V++)B(V===0?void 0:N[V-1],V===N.length?void 0:N[V])}e.$Bb=g;function v(N,B){for(let V=0;V<N.length;V++)B(V===0?void 0:N[V-1],N[V],V+1===N.length?void 0:N[V+1])}e.$Cb=v;function m(N,B,V){const oe=[];function de(ve,be,ye){if(be===0&&ye.length===0)return;const Ie=oe[oe.length-1];Ie&&Ie.start+Ie.deleteCount===ve?(Ie.deleteCount+=be,Ie.toInsert.push(...ye)):oe.push({start:ve,deleteCount:be,toInsert:ye})}let ue=0,he=0;for(;;){if(ue===N.length){de(ue,0,B.slice(he));break}if(he===B.length){de(ue,N.length-ue,[]);break}const ve=N[ue],be=B[he],ye=V(ve,be);ye===0?(ue+=1,he+=1):ye<0?(de(ue,1,[]),ue+=1):ye>0&&(de(ue,0,[be]),he+=1)}return oe}e.$Db=m;function w(N,B,V){const oe=m(N,B,V),de=[],ue=[];for(const he of oe)de.push(...N.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:de,added:ue}}e.$Eb=w;function d(N,B,V){if(V===0)return[];const oe=N.slice(0,V).sort(B);return l(N,B,oe,V,N.length),oe}e.top=d;function h(N,B,V,oe,de){return V===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const ve=N.length,be=N.slice(0,V).sort(B);for(let ye=V,Ie=Math.min(V+oe,ve);ye<ve;ye=Ie,Ie=Math.min(Ie+oe,ve)){if(ye>V&&await new Promise(Te=>setTimeout(Te)),de&&de.isCancellationRequested)throw new S.$5;l(N,B,be,ye,Ie)}return be})().then(ue,he)})}e.$Gb=h;function l(N,B,V,oe,de){for(const ue=V.length;oe<de;oe++){const he=N[oe];if(B(he,V[ue-1])<0){V.pop();const ve=(0,R.$kb)(V,be=>B(he,be)<0);V.splice(ve,0,he)}}}function E(N){return N.filter(B=>!!B)}e.$Hb=E;function u(N){let B=0;for(let V=0;V<N.length;V++)N[V]&&(N[B]=N[V],B+=1);N.length=B}e.$Ib=u;function i(N,B,V){N.splice(V,0,N.splice(B,1)[0])}e.$Jb=i;function a(N){return!Array.isArray(N)||N.length===0}e.$Kb=a;function o(N){return Array.isArray(N)&&N.length>0}e.$Lb=o;function t(N,B=V=>V){const V=new Set;return N.filter(oe=>{const de=B(oe);return V.has(de)?!1:(V.add(de),!0)})}e.$Mb=t;function n(N){const B=new Set;return V=>{const oe=N(V);return B.has(oe)?!1:(B.add(oe),!0)}}e.$Nb=n;function r(N,B){return N.length>0?N[0]:B}e.$Ob=r;function p(N,B){return N.length>0?N[N.length-1]:B}e.$Pb=p;function A(N,B,V=(oe,de)=>oe===de){let oe=0;for(let de=0,ue=Math.min(N.length,B.length);de<ue&&V(N[de],B[de]);de++)oe++;return oe}e.$Qb=A;function C(N){return[].concat(...N)}e.$Rb=C;function k(N,B){let V=typeof B=="number"?N:0;typeof B=="number"?V=N:(V=0,B=N);const oe=[];if(V<=B)for(let de=V;de<B;de++)oe.push(de);else for(let de=V;de>B;de--)oe.push(de);return oe}e.$Sb=k;function I(N,B,V){return N.reduce((oe,de)=>(oe[B(de)]=V?V(de):de,oe),Object.create(null))}e.$Tb=I;function j(N,B){return N.push(B),()=>U(N,B)}e.$Ub=j;function U(N,B){const V=N.indexOf(B);if(V>-1)return N.splice(V,1),B}e.$Vb=U;function z(N,B,V){const oe=N.slice(0,B),de=N.slice(B);return oe.concat(V,de)}e.$Wb=z;function x(N,B){let V;if(typeof B=="number"){let oe=B;V=()=>{const de=Math.sin(oe++)*179426549;return de-Math.floor(de)}}else V=Math.random;for(let oe=N.length-1;oe>0;oe-=1){const de=Math.floor(V()*(oe+1)),ue=N[oe];N[oe]=N[de],N[de]=ue}}e.$Xb=x;function X(N,B){const V=N.indexOf(B);V>-1&&(N.splice(V,1),N.unshift(B))}e.$Yb=X;function ae(N,B){const V=N.indexOf(B);V>-1&&(N.splice(V,1),N.push(B))}e.$Zb=ae;function se(N,B){for(const V of B)N.push(V)}e.$1b=se;function ce(N,B){return Array.isArray(N)?N.map(B):B(N)}e.$2b=ce;function Z(N){return Array.isArray(N)?N:[N]}e.$3b=Z;function Q(N){return N[Math.floor(Math.random()*N.length)]}e.$4b=Q;function K(N,B,V){const oe=W(N,B),de=N.length,ue=V.length;N.length=de+ue;for(let he=de-1;he>=oe;he--)N[he+ue]=N[he];for(let he=0;he<ue;he++)N[he+oe]=V[he]}e.$5b=K;function q(N,B,V,oe){const de=W(N,B);let ue=N.splice(de,V);return ue===void 0&&(ue=[]),K(N,de,oe),ue}e.$6b=q;function W(N,B){return B<0?Math.max(B+N.length,0):Math.min(B,N.length)}var G;(function(N){function B(ue){return ue<0}N.isLessThan=B;function V(ue){return ue<=0}N.isLessThanOrEqual=V;function oe(ue){return ue>0}N.isGreaterThan=oe;function de(ue){return ue===0}N.isNeitherLessOrGreaterThan=de,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function H(N,B){return(V,oe)=>B(N(V),N(oe))}e.$7b=H;function Y(...N){return(B,V)=>{for(const oe of N){const de=oe(B,V);if(!G.isNeitherLessOrGreaterThan(de))return de}return G.neitherLessOrGreaterThan}}e.$8b=Y;const re=(N,B)=>N-B;e.$9b=re;const L=(N,B)=>(0,e.$9b)(N?1:0,B?1:0);e.$0b=L;function M(N){return(B,V)=>-N(B,V)}e.$$b=M;class F{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let V=this.c;for(;V<this.g.length&&B(this.g[V]);)V++;const oe=V===this.c?null:this.g.slice(this.c,V);return this.c=V,oe}takeFromEndWhile(B){let V=this.d;for(;V>=0&&B(this.g[V]);)V--;const oe=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,oe}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const V=this.g.slice(this.c,this.c+B);return this.c+=B,V}}e.$_b=F;class T{static{this.empty=new T(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(V=>(B(V),!0))}toArray(){const B=[];return this.iterate(V=>(B.push(V),!0)),B}filter(B){return new T(V=>this.iterate(oe=>B(oe)?V(oe):!0))}map(B){return new T(V=>this.iterate(oe=>V(B(oe))))}some(B){let V=!1;return this.iterate(oe=>(V=B(oe),!V)),V}findFirst(B){let V;return this.iterate(oe=>B(oe)?(V=oe,!1):!0),V}findLast(B){let V;return this.iterate(oe=>(B(oe)&&(V=oe),!0)),V}findLastMaxBy(B){let V,oe=!0;return this.iterate(de=>((oe||G.isGreaterThan(B(de,V)))&&(oe=!1,V=de),!0)),V}}e.$ac=T}),define(ie[137],ne([0,1,14]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function R(f,c){if(!f)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=R;function s(f,c="Unreachable"){throw new Error(c)}e.$4c=s;function O(f){if(!f)throw new S.$cb("Assertion Failed")}e.$5c=O;function D(f){if(!f()){debugger;f(),(0,S.$1)(new S.$cb("Assertion Failed"))}}e.$6c=D;function P(f,c){let $=0;for(;$<f.length-1;){const b=f[$],y=f[$+1];if(!c(b,y))return!1;$++}return!0}e.$7c=P}),define(ie[83],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function S(R){const s=this;let O=!1,D;return function(){return O||(O=!0,D=R.apply(s,arguments)),D}}e.$db=S}),define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(R){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}R.is=s;const O=Object.freeze([]);function D(){return O}R.empty=D;function*P(u){yield u}R.single=P;function f(u){return s(u)?u:P(u)}R.wrap=f;function c(u){return u||O}R.from=c;function*$(u){for(let i=u.length-1;i>=0;i--)yield u[i]}R.reverse=$;function b(u){return!u||u[Symbol.iterator]().next().done===!0}R.isEmpty=b;function y(u){return u[Symbol.iterator]().next().value}R.first=y;function g(u,i){for(const a of u)if(i(a))return!0;return!1}R.some=g;function v(u,i){for(const a of u)if(i(a))return a}R.find=v;function*m(u,i){for(const a of u)i(a)&&(yield a)}R.filter=m;function*w(u,i){let a=0;for(const o of u)yield i(o,a++)}R.map=w;function*d(...u){for(const i of u)for(const a of i)yield a}R.concat=d;function h(u,i,a){let o=a;for(const t of u)o=i(o,t);return o}R.reduce=h;function*l(u,i,a=u.length){for(i<0&&(i+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);i<a;i++)yield u[i]}R.slice=l;function E(u,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,u];const o=u[Symbol.iterator]();for(let t=0;t<i;t++){const n=o.next();if(n.done)return[a,R.empty()];a.push(n.value)}return[a,{[Symbol.iterator](){return o}}]}R.consume=E})(S||(e.Iterable=S={}))}),define(ie[44],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function D(i,a=!1){let o=0;const t=i.length;let n="",r=0,p=16,A=0;function C(X){let ae=0,se=0;for(;ae<X;){const ce=i.charCodeAt(o);if(ce>=48&&ce<=57)se=se*16+ce-48;else if(ce>=65&&ce<=70)se=se*16+ce-65+10;else if(ce>=97&&ce<=102)se=se*16+ce-97+10;else break;o++,ae++}return ae<X&&(se=-1),se}function k(X){o=X,n="",r=0,p=16,A=0}function I(){const X=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&c(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&c(i.charCodeAt(o)))for(o++;o<i.length&&c(i.charCodeAt(o));)o++;else return A=3,i.substring(X,o);let ae=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&c(i.charCodeAt(o))){for(o++;o<i.length&&c(i.charCodeAt(o));)o++;ae=o}else A=3;return i.substring(X,ae)}function j(){let X="",ae=o;for(;;){if(o>=t){X+=i.substring(ae,o),A=2;break}const se=i.charCodeAt(o);if(se===34){X+=i.substring(ae,o),o++;break}if(se===92){if(X+=i.substring(ae,o),o++,o>=t){A=2;break}switch(i.charCodeAt(o++)){case 34:X+='"';break;case 92:X+="\\";break;case 47:X+="/";break;case 98:X+="\b";break;case 102:X+="\f";break;case 110:X+=`
`;break;case 114:X+="\r";break;case 116:X+="	";break;case 117:{const Z=C(4);Z>=0?X+=String.fromCharCode(Z):A=4;break}default:A=5}ae=o;continue}if(se>=0&&se<=31)if(f(se)){X+=i.substring(ae,o),A=2;break}else A=6;o++}return X}function U(){if(n="",A=0,r=o,o>=t)return r=t,p=17;let X=i.charCodeAt(o);if(P(X)){do o++,n+=String.fromCharCode(X),X=i.charCodeAt(o);while(P(X));return p=15}if(f(X))return o++,n+=String.fromCharCode(X),X===13&&i.charCodeAt(o)===10&&(o++,n+=`
`),p=14;switch(X){case 123:return o++,p=1;case 125:return o++,p=2;case 91:return o++,p=3;case 93:return o++,p=4;case 58:return o++,p=6;case 44:return o++,p=5;case 34:return o++,n=j(),p=10;case 47:{const ae=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<t&&!f(i.charCodeAt(o));)o++;return n=i.substring(ae,o),p=12}if(i.charCodeAt(o+1)===42){o+=2;const se=t-1;let ce=!1;for(;o<se;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,ce=!0;break}o++}return ce||(o++,A=1),n=i.substring(ae,o),p=13}return n+=String.fromCharCode(X),o++,p=16}case 45:if(n+=String.fromCharCode(X),o++,o===t||!c(i.charCodeAt(o)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),p=11;default:for(;o<t&&z(X);)o++,X=i.charCodeAt(o);if(r!==o){switch(n=i.substring(r,o),n){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return n+=String.fromCharCode(X),o++,p=16}}function z(X){if(P(X)||f(X))return!1;switch(X){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let X;do X=U();while(X>=12&&X<=15);return X}return{setPosition:k,getPosition:()=>o,scan:a?x:U,getToken:()=>p,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>o-r,getTokenError:()=>A}}e.$Um=D;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function c(i){return i>=48&&i<=57}var $;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})($||($={}));function b(i,a){const o=[],t=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function A(C,k,I,j){r.value=C,r.offset=k,r.length=I,r.type=j,r.colonOffset=void 0,n=r}try{l(i,{onObjectBegin:(C,k)=>{if(a<=C)throw t;n=void 0,p=a>C,o.push("")},onObjectProperty:(C,k,I)=>{if(a<k||(A(C,k,I,"property"),o[o.length-1]=C,a<=k+I))throw t},onObjectEnd:(C,k)=>{if(a<=C)throw t;n=void 0,o.pop()},onArrayBegin:(C,k)=>{if(a<=C)throw t;n=void 0,o.push(0)},onArrayEnd:(C,k)=>{if(a<=C)throw t;n=void 0,o.pop()},onLiteralValue:(C,k,I)=>{if(a<k||(A(C,k,I,u(C)),a<=k+I))throw t},onSeparator:(C,k,I)=>{if(a<=k)throw t;if(C===":"&&n&&n.type==="property")n.colonOffset=k,p=!1,n=void 0;else if(C===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:(p=!0,o[o.length-1]=""),n=void 0}}})}catch(C){if(C!==t)throw C}return{path:o,previousNode:n,isAtPropertyKey:p,matches:C=>{let k=0;for(let I=0;k<C.length&&I<o.length;I++)if(C[k]===o[I]||C[k]==="*")k++;else if(C[k]!=="**")return!1;return k===C.length}}}e.$Vm=b;function y(i,a=[],o=O.DEFAULT){let t=null,n=[];const r=[];function p(C){Array.isArray(n)?n.push(C):t!==null&&(n[t]=C)}return l(i,{onObjectBegin:()=>{const C={};p(C),r.push(n),n=C,t=null},onObjectProperty:C=>{t=C},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const C=[];p(C),r.push(n),n=C,t=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:p,onError:(C,k,I)=>{a.push({error:C,offset:k,length:I})}},o),n[0]}e.$Wm=y;function g(i,a=[],o=O.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(C){t.type==="property"&&(t.length=C-t.offset,t=t.parent)}function r(C){return t.children.push(C),C}l(i,{onObjectBegin:C=>{t=r({type:"object",offset:C,length:-1,parent:t,children:[]})},onObjectProperty:(C,k,I)=>{t=r({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:C,offset:k,length:I,parent:t})},onObjectEnd:(C,k)=>{t.length=C+k-t.offset,t=t.parent,n(C+k)},onArrayBegin:(C,k)=>{t=r({type:"array",offset:C,length:-1,parent:t,children:[]})},onArrayEnd:(C,k)=>{t.length=C+k-t.offset,t=t.parent,n(C+k)},onLiteralValue:(C,k,I)=>{r({type:u(C),offset:k,length:I,parent:t,value:C}),n(k+I)},onSeparator:(C,k,I)=>{t.type==="property"&&(C===":"?t.colonOffset=k:C===","&&n(k))},onError:(C,k,I)=>{a.push({error:C,offset:k,length:I})}},o);const A=t.children[0];return A&&delete A.parent,A}e.$Xm=g;function v(i,a){if(!i)return;let o=i;for(const t of a)if(typeof t=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const r of o.children)if(Array.isArray(r.children)&&r.children[0].value===t){o=r.children[1],n=!0;break}if(!n)return}else{const n=t;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}e.$Ym=v;function m(i){if(!i.parent||!i.parent.children)return[];const a=m(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;a.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&a.push(o)}return a}e.$Zm=m;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const a=Object.create(null);for(const o of i.children){const t=o.children[1];t&&(a[o.children[0].value]=w(t))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$1m=w;function d(i,a,o=!1){return a>=i.offset&&a<i.offset+i.length||o&&a===i.offset+i.length}e.$2m=d;function h(i,a,o=!1){if(d(i,a,o)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=a;n++){const r=h(t[n],a,o);if(r)return r}return i}}e.$3m=h;function l(i,a,o=O.DEFAULT){const t=D(i,!1);function n(H){return H?()=>H(t.getTokenOffset(),t.getTokenLength()):()=>!0}function r(H){return H?Y=>H(Y,t.getTokenOffset(),t.getTokenLength()):()=>!0}const p=n(a.onObjectBegin),A=r(a.onObjectProperty),C=n(a.onObjectEnd),k=n(a.onArrayBegin),I=n(a.onArrayEnd),j=r(a.onLiteralValue),U=r(a.onSeparator),z=n(a.onComment),x=r(a.onError),X=o&&o.disallowComments,ae=o&&o.allowTrailingComma;function se(){for(;;){const H=t.scan();switch(t.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:X||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(H){case 12:case 13:X?ce(10):z();break;case 16:ce(1);break;case 15:case 14:break;default:return H}}}function ce(H,Y=[],re=[]){if(x(H),Y.length+re.length>0){let L=t.getToken();for(;L!==17;){if(Y.indexOf(L)!==-1){se();break}else if(re.indexOf(L)!==-1)break;L=se()}}}function Z(H){const Y=t.getTokenValue();return H?j(Y):A(Y),se(),!0}function Q(){switch(t.getToken()){case 11:{let H=0;try{H=JSON.parse(t.getTokenValue()),typeof H!="number"&&(ce(2),H=0)}catch{ce(2)}j(H);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return se(),!0}function K(){return t.getToken()!==10?(ce(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(U(":"),se(),G()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function q(){p(),se();let H=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),U(","),se(),t.getToken()===2&&ae)break}else H&&ce(6,[],[]);K()||ce(4,[],[2,5]),H=!0}return C(),t.getToken()!==2?ce(7,[2],[]):se(),!0}function W(){k(),se();let H=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(H||ce(4,[],[]),U(","),se(),t.getToken()===4&&ae)break}else H&&ce(6,[],[]);G()||ce(4,[],[4,5]),H=!0}return I(),t.getToken()!==4?ce(8,[4],[]):se(),!0}function G(){switch(t.getToken()){case 3:return W();case 1:return q();case 10:return Z(!0);default:return Q()}}return se(),t.getToken()===17?o.allowEmptyContent?!0:(ce(4,[],[]),!1):G()?(t.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.$4m=l;function E(i,a){const o=D(i),t=[];let n,r=0,p;do switch(p=o.getPosition(),n=o.scan(),n){case 12:case 13:case 17:r!==p&&t.push(i.substring(r,p)),a!==void 0&&t.push(o.getTokenValue().replace(/[^\r\n]/g,a)),r=o.getPosition();break}while(n!==17);return t.join("")}e.$5m=E;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=u}),define(ie[138],ne([0,1,44]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9S=e.$8S=e.$7S=e.$6S=void 0;function R(c,$,b){let y,g,v,m,w;if($){for(m=$.offset,w=m+$.length,v=m;v>0&&!f(c,v-1);)v--;let p=w;for(;p<c.length&&!f(c,p);)p++;g=c.substring(v,p),y=D(g,b)}else g=c,y=0,v=0,m=0,w=c.length;const d=P(b,c);let h=!1,l=0,E;b.insertSpaces?E=O(" ",b.tabSize||4):E="	";const u=(0,S.$Um)(g,!1);let i=!1;function a(){return d+O(E,y+l)}function o(){let p=u.scan();for(h=!1;p===15||p===14;)h=h||p===14,p=u.scan();return i=p===16||u.getTokenError()!==0,p}const t=[];function n(p,A,C){!i&&A<w&&C>m&&c.substring(A,C)!==p&&t.push({offset:A,length:C-A,content:p})}let r=o();if(r!==17){const p=u.getTokenOffset()+v,A=O(E,y);n(A,v,p)}for(;r!==17;){let p=u.getTokenOffset()+u.getTokenLength()+v,A=o(),C="";for(;!h&&(A===12||A===13);){const I=u.getTokenOffset()+v;n(" ",p,I),p=u.getTokenOffset()+u.getTokenLength()+v,C=A===12?a():"",A=o()}if(A===2)r!==1&&(l--,C=a());else if(A===4)r!==3&&(l--,C=a());else{switch(r){case 3:case 1:l++,C=a();break;case 5:case 12:C=a();break;case 13:h?C=a():C=" ";break;case 6:C=" ";break;case 10:if(A===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?C=" ":A!==5&&A!==17&&(i=!0);break;case 16:i=!0;break}h&&(A===12||A===13)&&(C=a())}const k=u.getTokenOffset()+v;n(C,p,k),r=A}return t}e.$6S=R;function s(c,$){const b=JSON.stringify(c,void 0,$.insertSpaces?$.tabSize||4:"	");return $.eol!==void 0?b.replace(/\r\n|\r|\n/g,$.eol):b}e.$7S=s;function O(c,$){let b="";for(let y=0;y<$;y++)b+=c;return b}function D(c,$){let b=0,y=0;const g=$.tabSize||4;for(;b<c.length;){const v=c.charAt(b);if(v===" ")y++;else if(v==="	")y+=g;else break;b++}return Math.floor(y/g)}function P(c,$){for(let b=0;b<$.length;b++){const y=$.charAt(b);if(y==="\r")return b+1<$.length&&$.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return c&&c.eol||`
`}e.$8S=P;function f(c,$){return`\r
`.indexOf(c.charAt($))!==-1}e.$9S=f}),define(ie[139],ne([0,1,44,138]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bT=e.$aT=e.$_S=e.$$S=e.$0S=void 0;function s(c,$,b){return O(c,$,void 0,b)}e.$0S=s;function O(c,$,b,y,g){const v=$.slice(),m=[],w=(0,S.$Xm)(c,m);let d,h;for(;v.length>0&&(h=v.pop(),d=(0,S.$Ym)(w,v),d===void 0&&b!==void 0);)typeof h=="string"?b={[h]:b}:b=[b];if(d)if(d.type==="object"&&typeof h=="string"&&Array.isArray(d.children)){const l=(0,S.$Ym)(d,[h]);if(l!==void 0)if(b===void 0){if(!l.parent)throw new Error("Malformed AST");const E=d.children.indexOf(l.parent);let u,i=l.parent.offset+l.parent.length;if(E>0){const a=d.children[E-1];u=a.offset+a.length}else u=d.offset+1,d.children.length>1&&(i=d.children[1].offset);return D(c,{offset:u,length:i-u,content:""},y)}else return D(c,{offset:l.offset,length:l.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const E=`${JSON.stringify(h)}: ${JSON.stringify(b)}`,u=g?g(d.children.map(a=>a.children[0].value)):d.children.length;let i;if(u>0){const a=d.children[u-1];i={offset:a.offset+a.length,length:0,content:","+E}}else d.children.length===0?i={offset:d.offset+1,length:0,content:E}:i={offset:d.offset+1,length:0,content:E+","};return D(c,i,y)}}else if(d.type==="array"&&typeof h=="number"&&Array.isArray(d.children))if(b!==void 0){const l=`${JSON.stringify(b)}`;let E;if(d.children.length===0||h===0)E={offset:d.offset+1,length:0,content:d.children.length===0?l:l+","};else{const u=h===-1||h>d.children.length?d.children.length:h,i=d.children[u-1];E={offset:i.offset+i.length,length:0,content:","+l}}return D(c,E,y)}else{const l=h,E=d.children[l];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===l){const i=d.children[l-1],a=i.offset+i.length,o=d.offset+d.length;u={offset:a,length:o-2-a,content:""}}else u={offset:E.offset,length:d.children[l+1].offset-E.offset,content:""};return D(c,u,y)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${d.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return D(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(b)},y)}}e.$$S=O;function D(c,$,b){let y=P(c,$),g=$.offset,v=$.offset+$.content.length;if($.length===0||$.content.length===0){for(;g>0&&!(0,R.$9S)(y,g-1);)g--;for(;v<y.length&&!(0,R.$9S)(y,v);)v++}const m=(0,R.$6S)(y,{offset:g,length:v-g},b);for(let d=m.length-1;d>=0;d--){const h=m[d];y=P(y,h),g=Math.min(g,h.offset),v=Math.max(v,h.offset+h.length),v+=h.content.length-h.length}const w=c.length-(y.length-v)-g;return[{offset:g,length:w,content:y.substring(g,v)}]}e.$_S=D;function P(c,$){return c.substring(0,$.offset)+$.content+c.substring($.offset+$.length)}e.$aT=P;function f(c,$){const b=$.slice(0).sort((g,v)=>{const m=g.offset-v.offset;return m===0?g.length-v.length:m});let y=c.length;for(let g=b.length-1;g>=0;g--){const v=b[g];if(v.offset+v.length<=y)c=P(c,v);else throw new Error("Overlapping edit");y=v.offset}return c}e.$bT=f}),define(ie[71],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=S}),define(ie[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(O){this.element=O,this.next=S.Undefined,this.prev=S.Undefined}}class R{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let O=this.a;for(;O!==S.Undefined;){const D=O.next;O.prev=S.Undefined,O.next=S.Undefined,O=D}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,D){const P=new S(O);if(this.a===S.Undefined)this.a=P,this.b=P;else if(D){const c=this.b;this.b=P,P.prev=c,c.next=P}else{const c=this.a;this.a=P,P.next=c,c.prev=P}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==S.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==S.Undefined&&O.next!==S.Undefined){const D=O.prev;D.next=O.next,O.next.prev=D}else O.prev===S.Undefined&&O.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):O.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):O.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==S.Undefined;)yield O.element,O=O.next}}e.$2c=R}),define(ie[31],ne([0,1]),function(J,e){"use strict";var S,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function O(h,l,E){let u=h.get(l);return u===void 0&&(u=E,h.set(l,u)),u}e.$xc=O;function D(h){const l=[];return h.forEach((E,u)=>{l.push(`${u} => ${E}`)}),`Map(${h.size}) {${l.join(", ")}}`}e.$yc=D;function P(h){const l=[];return h.forEach(E=>{l.push(E)}),`Set(${h.size}) {${l.join(", ")}}`}e.$zc=P;class f{constructor(l,E){this.uri=l,this.value=E}}function c(h){return Array.isArray(h)}class ${static{this.a=l=>l.toString()}constructor(l,E){if(this[S]="ResourceMap",l instanceof $)this.b=new Map(l.b),this.c=E??$.a;else if(c(l)){this.b=new Map,this.c=E??$.a;for(const[u,i]of l)this.set(u,i)}else this.b=new Map,this.c=l??$.a}set(l,E){return this.b.set(this.c(l),new f(l,E)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,E){typeof E<"u"&&(l=l.bind(E));for(const[u,i]of this.b)l(i.value,i.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$Ac=$;class b{constructor(l,E){this[R]="ResourceSet",!l||typeof l=="function"?this.a=new $(l):(this.a=new $(E),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,E){this.a.forEach((u,i)=>l.call(E,i,i,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=b;var y;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class g{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,E=0){const u=this.a.get(l);if(u)return E!==0&&this.j(u,E),u.value}set(l,E,u=0){let i=this.a.get(l);if(i)i.value=E,u!==0&&this.j(i,u);else{switch(i={key:l,value:E,next:void 0,previous:void 0},u){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(l,i),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const E=this.a.get(l);if(E)return this.a.delete(l),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,E){const u=this.e;let i=this.b;for(;i;){if(E?l.bind(E)(i.value,i.key,this):l(i.value,i.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const l=this,E=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.key,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}values(){const l=this,E=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:u.value,done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}entries(){const l=this,E=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const a={value:[u.key,u.value],done:!1};return u=u.next,a}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let E=this.b,u=this.size;for(;E&&u>l;)this.a.delete(E.key),E=E.next,u--;this.b=E,this.d=u,E&&(E.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const E=l.next,u=l.previous;if(!E||!u)throw new Error("Invalid list");E.previous=u,u.next=E}l.next=void 0,l.previous=void 0,this.e++}j(l,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(l===this.b)return;const u=l.next,i=l.previous;l===this.c?(i.next=void 0,this.c=i):(u.previous=i,i.next=u),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(E===2){if(l===this.c)return;const u=l.next,i=l.previous;l===this.b?(u.previous=void 0,this.b=u):(u.previous=i,i.next=u),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((E,u)=>{l.push([u,E])}),l}fromJSON(l){this.clear();for(const[E,u]of l)this.set(E,u)}}e.$Cc=g;class v extends g{constructor(l,E=1){super(),this.k=l,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,E=2){return super.get(l,E)}peek(l){return super.get(l,0)}set(l,E){return super.set(l,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=v;class m{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let E=this.a.get(l)||0;return E===0?!1:(E--,E===0?this.a.delete(l):this.a.set(l,E),!0)}has(l){return this.a.has(l)}}e.$Ec=m;class w{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[E,u]of l)this.set(E,u)}clear(){this.a.clear(),this.b.clear()}set(l,E){this.a.set(l,E),this.b.set(E,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const E=this.a.get(l);return E===void 0?!1:(this.a.delete(l),this.b.delete(E),!0)}forEach(l,E){this.a.forEach((u,i)=>{l.call(E,u,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=w;class d{constructor(){this.a=new Map}add(l,E){let u=this.a.get(l);u||(u=new Set,this.a.set(l,u)),u.add(E)}delete(l,E){const u=this.a.get(l);u&&(u.delete(E),u.size===0&&this.a.delete(l))}forEach(l,E){const u=this.a.get(l);u&&u.forEach(E)}get(l){const E=this.a.get(l);return E||new Set}}e.$Gc=d}),define(ie[2],ne([0,1,23,135,31,83,70]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const P=!1;let f=null;class c{constructor(){this.b=new Map}static{this.a=0}c(I){let j=this.b.get(I);return j||(j={parent:null,source:null,isSingleton:!1,value:I,idx:c.a++},this.b.set(I,j)),j}trackDisposable(I){const j=this.c(I);j.source||(j.source=new Error().stack)}setParent(I,j){const U=this.c(I);U.parent=j}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,j){const U=j.get(I);if(U)return U;const z=I.parent?this.f(this.c(I.parent),j):I;return j.set(I,z),z}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,j){let U;if(j)U=j;else{const se=new Map,ce=[...this.b.values()].filter(Q=>Q.source!==null&&!this.f(Q,se).isSingleton);if(ce.length===0)return;const Z=new Set(ce.map(Q=>Q.value));if(U=ce.filter(Q=>!(Q.parent&&Z.has(Q.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(se){function ce(Q,K){for(;Q.length>0&&K.some(q=>typeof q=="string"?q===Q[0]:Q[0].match(q));)Q.shift()}const Z=se.source.split(`
`).map(Q=>Q.trim().replace("at ","")).filter(Q=>Q!=="");return ce(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const x=new s.$Gc;for(const se of U){const ce=z(se);for(let Z=0;Z<=ce.length;Z++)x.add(ce.slice(0,Z).join(`
`),se)}U.sort((0,S.$7b)(se=>se.idx,S.$9b));let X="",ae=0;for(const se of U.slice(0,I)){ae++;const ce=z(se),Z=[];for(let Q=0;Q<ce.length;Q++){let K=ce[Q];K=`(shared with ${x.get(ce.slice(0,Q+1).join(`
`)).size}/${U.length} leaks) at ${K}`;const W=x.get(ce.slice(0,Q).join(`
`)),G=(0,R.$J)([...W].map(H=>z(H)[Q]),H=>H);delete G[ce[Q]];for(const[H,Y]of Object.entries(G))Z.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${H}`);Z.unshift(K)}X+=`


==================== Leaking disposable ${ae}/${U.length}: ${se.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return U.length>I&&(X+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:X}}}e.$Hc=c;function $(k){f=k}if(e.$Ic=$,P){const k="__is_disposable_tracked__";$(new class{trackDisposable(I){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(j)},3e3)}setParent(I,j){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function b(k){return f?.trackDisposable(k),k}e.$Jc=b;function y(k){f?.markAsDisposed(k)}e.$Kc=y;function g(k,I){f?.setParent(k,I)}function v(k,I){if(f)for(const j of k)f.setParent(j,I)}function m(k){return f?.markAsSingleton(k),k}e.$Lc=m;function w(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Mc=w;function d(k){if(D.Iterable.is(k)){const I=[];for(const j of k)if(j)try{j.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Nc=d;function h(k){for(const I of k)w(I)&&I.dispose();return[]}e.$Oc=h;function l(...k){const I=E(()=>d(k));return v(k,I),I}e.$Pc=l;function E(k){const I=b({dispose:(0,O.$db)(()=>{y(I),k()})});return I}e.$Qc=E;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return g(I,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),g(I,null))}}e.$Rc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,b(this),g(this.q,this)}dispose(){y(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Sc=i;class a{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&g(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&g(I,null),I}}e.$Tc=a;class o{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=o;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(I){let j=I;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,y(this))},this}}e.$Vc=t;class n{constructor(){this.a=new Map}acquire(I,...j){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...j)},this.a.set(I,U));const{object:z}=U,x=(0,O.$db)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:z,dispose:x}}}e.$Wc=n;class r{constructor(I){this.a=I}async acquire(I,...j){const U=this.a.acquire(I,...j);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Xc=r;class p{constructor(I){this.object=I}dispose(){}}e.$Yc=p;function A(k){const I=new u;try{k(I)}finally{I.dispose()}}e.$Zc=A;class C{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,j,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,j)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=C}),define(ie[84],ne([0,1,31]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const R=new S.$Dc(1e4);function s(c){return f(c,"NFC",R)}e.$ol=s;const O=new S.$Dc(1e4);function D(c){return f(c,"NFD",O)}e.$pl=D;const P=/[^\u0000-\u0080]/;function f(c,$,b){if(!c)return c;const y=b.get(c);if(y)return y;let g;return P.test(c)?g=c.normalize($):g=c,b.set(c,g),g}e.$ql=function(){const c=/[\u0300-\u036f]/g;return function($){return D($).replace(c,"")}}()}),define(ie[140],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function S(P,f,c){return Math.min(Math.max(P,f),c)}e.$Ol=S;function R(P,f){return(f+P%f)%f}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=s;class O{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=O;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const c=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=D}),function(){function J(s){const O=[];typeof s=="number"&&O.push("code/timeOrigin",s);function D(f){O.push(f,Date.now())}function P(){const f=[];for(let c=0;c<O.length;c+=2)f.push({name:O[c],startTime:O[c+1]});return f}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))O.push({name:D.name,startTime:Math.round(s+D.startTime)});return O}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=S(R))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var R in S)(typeof exports=="object"?exports:J)[R]=S[R]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function S(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return J[R].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=J,S.c=e,S.d=function(R,s,O){S.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:O})},S.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},S.t=function(R,s){if(1&s&&(R=S(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)S.d(O,D,function(P){return R[P]}.bind(null,D));return O},S.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return S.d(s,"a",s),s},S.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},S.p="",S(S.s=0)}([function(J,e,S){(function(R){var s;e=J.exports=re,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],f=e.src=[],c=0,$=c++;f[$]="0|[1-9]\\d*";var b=c++;f[b]="[0-9]+";var y=c++;f[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=c++;f[g]="("+f[$]+")\\.("+f[$]+")\\.("+f[$]+")";var v=c++;f[v]="("+f[b]+")\\.("+f[b]+")\\.("+f[b]+")";var m=c++;f[m]="(?:"+f[$]+"|"+f[y]+")";var w=c++;f[w]="(?:"+f[b]+"|"+f[y]+")";var d=c++;f[d]="(?:-("+f[m]+"(?:\\."+f[m]+")*))";var h=c++;f[h]="(?:-?("+f[w]+"(?:\\."+f[w]+")*))";var l=c++;f[l]="[0-9A-Za-z-]+";var E=c++;f[E]="(?:\\+("+f[l]+"(?:\\."+f[l]+")*))";var u=c++,i="v?"+f[g]+f[d]+"?"+f[E]+"?";f[u]="^"+i+"$";var a="[v=\\s]*"+f[v]+f[h]+"?"+f[E]+"?",o=c++;f[o]="^"+a+"$";var t=c++;f[t]="((?:<|>)?=?)";var n=c++;f[n]=f[b]+"|x|X|\\*";var r=c++;f[r]=f[$]+"|x|X|\\*";var p=c++;f[p]="[v=\\s]*("+f[r]+")(?:\\.("+f[r]+")(?:\\.("+f[r]+")(?:"+f[d]+")?"+f[E]+"?)?)?";var A=c++;f[A]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[h]+")?"+f[E]+"?)?)?";var C=c++;f[C]="^"+f[t]+"\\s*"+f[p]+"$";var k=c++;f[k]="^"+f[t]+"\\s*"+f[A]+"$";var I=c++;f[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=c++;f[j]="(?:~>?)";var U=c++;f[U]="(\\s*)"+f[j]+"\\s+",P[U]=new RegExp(f[U],"g");var z=c++;f[z]="^"+f[j]+f[p]+"$";var x=c++;f[x]="^"+f[j]+f[A]+"$";var X=c++;f[X]="(?:\\^)";var ae=c++;f[ae]="(\\s*)"+f[X]+"\\s+",P[ae]=new RegExp(f[ae],"g");var se=c++;f[se]="^"+f[X]+f[p]+"$";var ce=c++;f[ce]="^"+f[X]+f[A]+"$";var Z=c++;f[Z]="^"+f[t]+"\\s*("+a+")$|^$";var Q=c++;f[Q]="^"+f[t]+"\\s*("+i+")$|^$";var K=c++;f[K]="(\\s*)"+f[t]+"\\s*("+a+"|"+f[p]+")",P[K]=new RegExp(f[K],"g");var q=c++;f[q]="^\\s*("+f[p]+")\\s+-\\s+("+f[p]+")\\s*$";var W=c++;f[W]="^\\s*("+f[A]+")\\s+-\\s+("+f[A]+")\\s*$";var G=c++;f[G]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)s(H,f[H]),P[H]||(P[H]=new RegExp(f[H]));function Y(_,le){if(_ instanceof re)return _;if(typeof _!="string"||_.length>O||!(le?P[o]:P[u]).test(_))return null;try{return new re(_,le)}catch{return null}}function re(_,le){if(_ instanceof re){if(_.loose===le)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof re))return new re(_,le);s("SemVer",_,le),this.loose=le;var ge=_.trim().match(le?P[o]:P[u]);if(!ge)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ae){if(/^[0-9]+$/.test(Ae)){var De=+Ae;if(De>=0&&De<D)return De}return Ae}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Y,e.valid=function(_,le){var ge=Y(_,le);return ge?ge.version:null},e.clean=function(_,le){var ge=Y(_.trim().replace(/^[=v]+/,""),le);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(_){return s("SemVer.compare",this.version,this.loose,_),_ instanceof re||(_=new re(_,this.loose)),this.compareMain(_)||this.comparePre(_)},re.prototype.compareMain=function(_){return _ instanceof re||(_=new re(_,this.loose)),M(this.major,_.major)||M(this.minor,_.minor)||M(this.patch,_.patch)},re.prototype.comparePre=function(_){if(_ instanceof re||(_=new re(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var le=0;do{var ge=this.prerelease[le],Ae=_.prerelease[le];if(s("prerelease compare",le,ge,Ae),ge===void 0&&Ae===void 0)return 0;if(Ae===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ae)return M(ge,Ae)}while(++le)},re.prototype.inc=function(_,le){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,le,ge,Ae){typeof ge=="string"&&(Ae=ge,ge=void 0);try{return new re(_,ge).inc(le,Ae).version}catch{return null}},e.diff=function(_,le){if(B(_,le))return null;var ge=Y(_),Ae=Y(le);if(ge.prerelease.length||Ae.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Ae[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Ae[De])return De},e.compareIdentifiers=M;var L=/^[0-9]+$/;function M(_,le){var ge=L.test(_),Ae=L.test(le);return ge&&Ae&&(_=+_,le=+le),ge&&!Ae?-1:Ae&&!ge?1:_<le?-1:_>le?1:0}function F(_,le,ge){return new re(_,ge).compare(new re(le,ge))}function T(_,le,ge){return F(_,le,ge)>0}function N(_,le,ge){return F(_,le,ge)<0}function B(_,le,ge){return F(_,le,ge)===0}function V(_,le,ge){return F(_,le,ge)!==0}function oe(_,le,ge){return F(_,le,ge)>=0}function de(_,le,ge){return F(_,le,ge)<=0}function ue(_,le,ge,Ae){var De;switch(le){case"===":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),De=_===ge;break;case"!==":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),De=_!==ge;break;case"":case"=":case"==":De=B(_,ge,Ae);break;case"!=":De=V(_,ge,Ae);break;case">":De=T(_,ge,Ae);break;case">=":De=oe(_,ge,Ae);break;case"<":De=N(_,ge,Ae);break;case"<=":De=de(_,ge,Ae);break;default:throw new TypeError("Invalid operator: "+le)}return De}function he(_,le){if(_ instanceof he){if(_.loose===le)return _;_=_.value}if(!(this instanceof he))return new he(_,le);s("comparator",_,le),this.loose=le,this.parse(_),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(_,le){return M(le,_)},e.major=function(_,le){return new re(_,le).major},e.minor=function(_,le){return new re(_,le).minor},e.patch=function(_,le){return new re(_,le).patch},e.compare=F,e.compareLoose=function(_,le){return F(_,le,!0)},e.rcompare=function(_,le,ge){return F(le,_,ge)},e.sort=function(_,le){return _.sort(function(ge,Ae){return e.compare(ge,Ae,le)})},e.rsort=function(_,le){return _.sort(function(ge,Ae){return e.rcompare(ge,Ae,le)})},e.gt=T,e.lt=N,e.eq=B,e.neq=V,e.gte=oe,e.lte=de,e.cmp=ue,e.Comparator=he;var ve={};function be(_,le){if(_ instanceof be)return _.loose===le?_:new be(_.raw,le);if(_ instanceof he)return new be(_.value,le);if(!(this instanceof be))return new be(_,le);if(this.loose=le,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function ye(_){return!_||_.toLowerCase()==="x"||_==="*"}function Ie(_,le,ge,Ae,De,Le,Oe,He,ze,ee,fe,$e,ke){return((le=ye(ge)?"":ye(Ae)?">="+ge+".0.0":ye(De)?">="+ge+"."+Ae+".0":">="+le)+" "+(He=ye(ze)?"":ye(ee)?"<"+(+ze+1)+".0.0":ye(fe)?"<"+ze+"."+(+ee+1)+".0":$e?"<="+ze+"."+ee+"."+fe+"-"+$e:"<="+He)).trim()}function Te(_,le){for(var ge=0;ge<_.length;ge++)if(!_[ge].test(le))return!1;if(le.prerelease.length){for(ge=0;ge<_.length;ge++)if(s(_[ge].semver),_[ge].semver!==ve&&_[ge].semver.prerelease.length>0){var Ae=_[ge].semver;if(Ae.major===le.major&&Ae.minor===le.minor&&Ae.patch===le.patch)return!0}return!1}return!0}function me(_,le,ge){try{le=new be(le,ge)}catch{return!1}return le.test(_)}function we(_,le,ge,Ae){var De,Le,Oe,He,ze;switch(_=new re(_,Ae),le=new be(le,Ae),ge){case">":De=T,Le=de,Oe=N,He=">",ze=">=";break;case"<":De=N,Le=oe,Oe=T,He="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(_,le,Ae))return!1;for(var ee=0;ee<le.set.length;++ee){var fe=le.set[ee],$e=null,ke=null;if(fe.forEach(function(Ce){Ce.semver===ve&&(Ce=new he(">=0.0.0")),$e=$e||Ce,ke=ke||Ce,De(Ce.semver,$e.semver,Ae)?$e=Ce:Oe(Ce.semver,ke.semver,Ae)&&(ke=Ce)}),$e.operator===He||$e.operator===ze||(!ke.operator||ke.operator===He)&&Le(_,ke.semver)||ke.operator===ze&&Oe(_,ke.semver))return!1}return!0}he.prototype.parse=function(_){var le=this.loose?P[Z]:P[Q],ge=_.match(le);if(!ge)throw new TypeError("Invalid comparator: "+_);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=ve},he.prototype.toString=function(){return this.value},he.prototype.test=function(_){return s("Comparator.test",_,this.loose),this.semver===ve||(typeof _=="string"&&(_=new re(_,this.loose)),ue(_,this.operator,this.semver,this.loose))},he.prototype.intersects=function(_,le){if(!(_ instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(_.value,le),me(this.value,ge,le);if(_.operator==="")return ge=new be(this.value,le),me(_.semver,ge,le);var Ae=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Le=this.semver.version===_.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),He=ue(this.semver,"<",_.semver,le)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),ze=ue(this.semver,">",_.semver,le)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Ae||De||Le&&Oe||He||ze},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(_){var le=this.loose;_=_.trim(),s("range",_,le);var ge=le?P[W]:P[q];_=_.replace(ge,Ie),s("hyphen replace",_),_=_.replace(P[K],"$1$2$3"),s("comparator trim",_,P[K]),_=(_=(_=_.replace(P[U],"$1~")).replace(P[ae],"$1^")).split(/\s+/).join(" ");var Ae=le?P[Z]:P[Q],De=_.split(" ").map(function(Le){return function(Oe,He){return s("comp",Oe),Oe=function(ze,ee){return ze.trim().split(/\s+/).map(function(fe){return function($e,ke){s("caret",$e,ke);var Ce=ke?P[ce]:P[se];return $e.replace(Ce,function(Fe,je,Ne,Ve,Ge){var Ke;return s("caret",$e,Fe,je,Ne,Ve,Ge),ye(je)?Ke="":ye(Ne)?Ke=">="+je+".0.0 <"+(+je+1)+".0.0":ye(Ve)?Ke=je==="0"?">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+".0 <"+(+je+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ke=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+Ve+Ge+" <"+je+"."+Ne+"."+(+Ve+1):">="+je+"."+Ne+"."+Ve+Ge+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+Ve+Ge+" <"+(+je+1)+".0.0"):(s("no pr"),Ke=je==="0"?Ne==="0"?">="+je+"."+Ne+"."+Ve+" <"+je+"."+Ne+"."+(+Ve+1):">="+je+"."+Ne+"."+Ve+" <"+je+"."+(+Ne+1)+".0":">="+je+"."+Ne+"."+Ve+" <"+(+je+1)+".0.0"),s("caret return",Ke),Ke})}(fe,ee)}).join(" ")}(Oe,He),s("caret",Oe),Oe=function(ze,ee){return ze.trim().split(/\s+/).map(function(fe){return function($e,ke){var Ce=ke?P[x]:P[z];return $e.replace(Ce,function(Fe,je,Ne,Ve,Ge){var Ke;return s("tilde",$e,Fe,je,Ne,Ve,Ge),ye(je)?Ke="":ye(Ne)?Ke=">="+je+".0.0 <"+(+je+1)+".0.0":ye(Ve)?Ke=">="+je+"."+Ne+".0 <"+je+"."+(+Ne+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ke=">="+je+"."+Ne+"."+Ve+Ge+" <"+je+"."+(+Ne+1)+".0"):Ke=">="+je+"."+Ne+"."+Ve+" <"+je+"."+(+Ne+1)+".0",s("tilde return",Ke),Ke})}(fe,ee)}).join(" ")}(Oe,He),s("tildes",Oe),Oe=function(ze,ee){return s("replaceXRanges",ze,ee),ze.split(/\s+/).map(function(fe){return function($e,ke){$e=$e.trim();var Ce=ke?P[k]:P[C];return $e.replace(Ce,function(Fe,je,Ne,Ve,Ge,Ke){s("xRange",$e,Fe,je,Ne,Ve,Ge,Ke);var Xe=ye(Ne),Ye=Xe||ye(Ve),it=Ye||ye(Ge);return je==="="&&it&&(je=""),Xe?Fe=je===">"||je==="<"?"<0.0.0":"*":je&&it?(Ye&&(Ve=0),it&&(Ge=0),je===">"?(je=">=",Ye?(Ne=+Ne+1,Ve=0,Ge=0):it&&(Ve=+Ve+1,Ge=0)):je==="<="&&(je="<",Ye?Ne=+Ne+1:Ve=+Ve+1),Fe=je+Ne+"."+Ve+"."+Ge):Ye?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":it&&(Fe=">="+Ne+"."+Ve+".0 <"+Ne+"."+(+Ve+1)+".0"),s("xRange return",Fe),Fe})}(fe,ee)}).join(" ")}(Oe,He),s("xrange",Oe),Oe=function(ze,ee){return s("replaceStars",ze,ee),ze.trim().replace(P[G],"")}(Oe,He),s("stars",Oe),Oe}(Le,le)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Le){return!!Le.match(Ae)})),De=De.map(function(Le){return new he(Le,le)})},be.prototype.intersects=function(_,le){if(!(_ instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ae){return _.set.some(function(De){return De.every(function(Le){return Ae.intersects(Le,le)})})})})},e.toComparators=function(_,le){return new be(_,le).set.map(function(ge){return ge.map(function(Ae){return Ae.value}).join(" ").trim().split(" ")})},be.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new re(_,this.loose));for(var le=0;le<this.set.length;le++)if(Te(this.set[le],_))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(_,le,ge){var Ae=null,De=null;try{var Le=new be(le,ge)}catch{return null}return _.forEach(function(Oe){Le.test(Oe)&&(Ae&&De.compare(Oe)!==-1||(De=new re(Ae=Oe,ge)))}),Ae},e.minSatisfying=function(_,le,ge){var Ae=null,De=null;try{var Le=new be(le,ge)}catch{return null}return _.forEach(function(Oe){Le.test(Oe)&&(Ae&&De.compare(Oe)!==1||(De=new re(Ae=Oe,ge)))}),Ae},e.validRange=function(_,le){try{return new be(_,le).range||"*"}catch{return null}},e.ltr=function(_,le,ge){return we(_,le,"<",ge)},e.gtr=function(_,le,ge){return we(_,le,">",ge)},e.outside=we,e.prerelease=function(_,le){var ge=Y(_,le);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(_,le,ge){return _=new be(_,ge),le=new be(le,ge),_.intersects(le)},e.coerce=function(_){if(_ instanceof re)return _;if(typeof _!="string")return null;var le=_.match(P[I]);return le==null?null:Y((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,S(1))},function(J,e){var S,R,s=J.exports={};function O(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(w){if(S===setTimeout)return setTimeout(w,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch{try{return S.call(null,w,0)}catch{return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var f,c=[],$=!1,b=-1;function y(){$&&f&&($=!1,f.length?c=f.concat(c):b=-1,c.length&&g())}function g(){if(!$){var w=P(y);$=!0;for(var d=c.length;d;){for(f=c,c=[];++b<d;)f&&f[b].run();b=-1,d=c.length}f=null,$=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(w)}}function v(w,d){this.fun=w,this.array=d}function m(){}s.nextTick=function(w){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];c.push(new v(w,d)),c.length!==1||$||P(g)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function(w){return[]},s.binding=function(w){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(w){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ie[141],ne([0,1]),function(J,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class R{constructor(P,f,c){this.level=P,this.key=f,this.value=c,this.forward=[]}}const s=void 0;class O{constructor(P,f=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(P){return!!O.g(this,P,this.comparator)}get(P){return O.g(this,P,this.comparator)?.value}set(P,f){return O.h(this,P,f,this.comparator)&&(this.f+=1),this}delete(P){const f=O.k(this,P,this.comparator);return f&&(this.f-=1),f}forEach(P,f){let c=this.e.forward[0];for(;c;)P.call(f,c.value,c.key,this),c=c.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",f=this.e.forward[0];for(;f;)P+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return P}static g(P,f,c){let $=P.e;for(let b=P.d-1;b>=0;b--)for(;$.forward[b]&&c($.forward[b].key,f)<0;)$=$.forward[b];if($=$.forward[0],$&&c($.key,f)===0)return $}static h(P,f,c,$){const b=[];let y=P.e;for(let g=P.d-1;g>=0;g--){for(;y.forward[g]&&$(y.forward[g].key,f)<0;)y=y.forward[g];b[g]=y}if(y=y.forward[0],y&&$(y.key,f)===0)return y.value=c,!1;{const g=O.j(P);if(g>P.d){for(let v=P.d;v<g;v++)b[v]=P.e;P.d=g}y=new R(g,f,c);for(let v=0;v<g;v++)y.forward[v]=b[v].forward[v],b[v].forward[v]=y;return!0}}static j(P,f=.5){let c=1;for(;Math.random()<f&&c<P.c;)c+=1;return c}static k(P,f,c){const $=[];let b=P.e;for(let y=P.d-1;y>=0;y--){for(;b.forward[y]&&c(b.forward[y].key,f)<0;)b=b.forward[y];$[y]=b}if(b=b.forward[0],!b||c(b.key,f)!==0)return!1;for(let y=0;y<P.d&&$[y].forward[y]===b;y++)$[y].forward[y]=b.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$yr=O}),define(ie[72],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(O){return new R(O)}constructor(O){this.c=S&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=R}),define(ie[3],ne([0,1,14,83,2,101,72]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const P=!1,f=!1;var c;(function(C){C.None=()=>s.$Sc.None;function k(ue){if(f){const{onDidAddListener:he}=ue,ve=v.create();let be=0;ue.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),he?.()}}}function I(ue,he){return Q(ue,()=>{},0,void 0,!0,void 0,he)}C.defer=I;function j(ue){return(he,ve=null,be)=>{let ye=!1,Ie;return Ie=ue(Te=>{if(!ye)return Ie?Ie.dispose():ye=!0,he.call(ve,Te)},null,be),ye&&Ie.dispose(),Ie}}C.once=j;function U(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>be.call(ye,he(Te)),null,Ie),ve)}C.map=U;function z(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>{he(Te),be.call(ye,Te)},null,Ie),ve)}C.forEach=z;function x(ue,he,ve){return ce((be,ye=null,Ie)=>ue(Te=>he(Te)&&be.call(ye,Te),null,Ie),ve)}C.filter=x;function X(ue){return ue}C.signal=X;function ae(...ue){return(he,ve=null,be)=>{const ye=(0,s.$Pc)(...ue.map(Ie=>Ie(Te=>he.call(ve,Te))));return Z(ye,be)}}C.any=ae;function se(ue,he,ve,be){let ye=ve;return U(ue,Ie=>(ye=he(ye,Ie),ye),be)}C.reduce=se;function ce(ue,he){let ve;const be={onWillAddFirstListener(){ve=ue(ye.fire,ye)},onDidRemoveLastListener(){ve?.dispose()}};he||k(be);const ye=new l(be);return he?.add(ye),ye.event}function Z(ue,he){return he instanceof Array?he.push(ue):he&&he.add(ue),ue}function Q(ue,he,ve=100,be=!1,ye=!1,Ie,Te){let me,we,_,le=0,ge;const Ae={leakWarningThreshold:Ie,onWillAddFirstListener(){me=ue(Le=>{le++,we=he(we,Le),be&&!_&&(De.fire(we),we=void 0),ge=()=>{const Oe=we;we=void 0,_=void 0,(!be||le>1)&&De.fire(Oe),le=0},typeof ve=="number"?(clearTimeout(_),_=setTimeout(ge,ve)):_===void 0&&(_=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&le>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,me.dispose()}};Te||k(Ae);const De=new l(Ae);return Te?.add(De),De.event}C.debounce=Q;function K(ue,he=0,ve){return C.debounce(ue,(be,ye)=>be?(be.push(ye),be):[ye],he,void 0,!0,void 0,ve)}C.accumulate=K;function q(ue,he=(be,ye)=>be===ye,ve){let be=!0,ye;return x(ue,Ie=>{const Te=be||!he(Ie,ye);return be=!1,ye=Ie,Te},ve)}C.latch=q;function W(ue,he,ve){return[C.filter(ue,he,ve),C.filter(ue,be=>!he(be),ve)]}C.split=W;function G(ue,he=!1,ve=[],be){let ye=ve.slice(),Ie=ue(we=>{ye?ye.push(we):me.fire(we)});be&&be.add(Ie);const Te=()=>{ye?.forEach(we=>me.fire(we)),ye=null},me=new l({onWillAddFirstListener(){Ie||(Ie=ue(we=>me.fire(we)),be&&be.add(Ie))},onDidAddFirstListener(){ye&&(he?setTimeout(Te):Te())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return be&&be.add(me),me.event}C.buffer=G;function H(ue,he){return(be,ye,Ie)=>{const Te=he(new re);return ue(function(me){const we=Te.evaluate(me);we!==Y&&be.call(ye,we)},void 0,Ie)}}C.chain=H;const Y=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push(ve=>(he(ve),ve)),this}filter(he){return this.f.push(ve=>he(ve)?ve:Y),this}reduce(he,ve){let be=ve;return this.f.push(ye=>(be=he(be,ye),be)),this}latch(he=(ve,be)=>ve===be){let ve=!0,be;return this.f.push(ye=>{const Ie=ve||!he(ye,be);return ve=!1,be=ye,Ie?ye:Y}),this}evaluate(he){for(const ve of this.f)if(he=ve(he),he===Y)break;return he}}function L(ue,he,ve=be=>be){const be=(...me)=>Te.fire(ve(...me)),ye=()=>ue.on(he,be),Ie=()=>ue.removeListener(he,be),Te=new l({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return Te.event}C.fromNodeEventEmitter=L;function M(ue,he,ve=be=>be){const be=(...me)=>Te.fire(ve(...me)),ye=()=>ue.addEventListener(he,be),Ie=()=>ue.removeEventListener(he,be),Te=new l({onWillAddFirstListener:ye,onDidRemoveLastListener:Ie});return Te.event}C.fromDOMEventEmitter=M;function F(ue){return new Promise(he=>j(ue)(he))}C.toPromise=F;function T(ue){const he=new l;return ue.then(ve=>{he.fire(ve)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}C.fromPromise=T;function N(ue,he,ve){return he(ve),ue(be=>he(be))}C.runAndSubscribe=N;function B(ue,he){let ve=null;function be(Ie){ve?.dispose(),ve=new s.$Rc,he(Ie,ve)}be(void 0);const ye=ue(Ie=>be(Ie));return(0,s.$Qc)(()=>{ye.dispose(),ve?.dispose()})}C.runAndSubscribeWithStore=B;class V{constructor(he,ve){this._observable=he,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};ve||k(be),this.emitter=new l(be),ve&&ve.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,ve){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function oe(ue,he){return new V(ue,he).emitter.event}C.fromObservable=oe;function de(ue){return he=>{let ve=0,be=!1;const ye={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(ue.reportChanges(),be&&(be=!1,he()))},handlePossibleChange(){},handleChange(){be=!0}};return ue.addObserver(ye),ue.reportChanges(),{dispose(){ue.removeObserver(ye)}}}}C.fromObservableLight=de})(c||(e.Event=c={}));class ${static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${$.f++}`,$.all.add(this)}start(k){this.g=new D.$Jd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Ld=$;let b=-1;function y(C){const k=b;return b=C,{dispose(){b=k}}}e.$Md=y;class g{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const j=this.threshold;if(j<=0||I<j)return;this.f||(this.f=new Map);const U=this.f.get(k.value)||0;if(this.f.set(k.value,U+1),this.g-=1,this.g<=0){this.g=j*.5;let z,x=0;for(const[X,ae]of this.f)(!z||x<ae)&&(z=X,x=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${x}):`),console.warn(z)}return()=>{const z=this.f.get(k.value)||0;this.f.set(k.value,z-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class w{constructor(k){this.value=k,this.id=m++}}const d=2,h=(C,k)=>{if(C instanceof w)k(C);else for(let I=0;I<C.length;I++){const j=C[I];j&&k(j)}};class l{constructor(k){this.w=0,this.f=k,this.g=b>0||this.f?.leakWarningThreshold?new g(this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const k=this.t;queueMicrotask(()=>{h(k,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Sc.None;if(this.m)return s.$Sc.None;I&&(k=k.bind(I));const U=new w(k);let z,x;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=v.create(),z=this.g.check(U.stack,this.w+1)),P&&(U.stack=x??v.create()),this.t?this.t instanceof w?(this.u??=new u,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,s.$Qc)(()=>{z?.(),this.x(U)});return j instanceof s.$Rc?j.add(X):Array.isArray(j)&&j.push(X),X},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,j=I.indexOf(k);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[j]=void 0;const U=this.u.current===this;if(this.w*d<=I.length){let z=0;for(let x=0;x<I.length;x++)I[x]?I[z++]=I[x]:U&&(this.u.end--,z<this.u.i&&this.u.i--);I.length=z}}y(k,I){if(!k)return;const j=this.f?.onListenerError||S.$1;if(!j){k.value(I);return}try{k.value(I)}catch(U){j(U)}}z(k){const I=k.current.t;for(;k.i<k.end;)this.y(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=l;const E=()=>new u;e.$Od=E;class u{constructor(){this.i=-1,this.end=0}enqueue(k,I,j){this.i=0,this.end=j,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends l{async fireAsync(k,I,j){if(this.t)for(this.h||(this.h=new O.$2c),h(this.t,U=>this.h.push([U.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[U,z]=this.h.shift(),x=[],X={...z,token:I,waitUntil:ae=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");j&&(ae=j(ae,U)),x.push(ae)}};try{U(X)}catch(ae){(0,S.$1)(ae);continue}Object.freeze(x),await Promise.allSettled(x).then(ae=>{for(const se of ae)se.status==="rejected"&&(0,S.$1)(se.reason)})}}}e.$Pd=i;class a extends l{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new O.$2c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Qd=a;class o extends a{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Rd=o;class t extends l{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Sd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const j=()=>{this.g&&this.o(I);const U=this.h.indexOf(I);this.h.splice(U,1)};return(0,s.$Qc)((0,R.$db)(j))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Td=n;class r{constructor(k,I,j,U){this.f=new s.$Rc;const z=this.f.add(new n),x=this.f.add(new s.$1c);function X(ae){x.set(ae,z.add(U(ae)))}for(const ae of k)X(ae);this.f.add(I(ae=>{X(ae)})),this.f.add(j(ae=>{x.deleteAndDispose(ae)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Ud=r;class p{constructor(){this.f=[]}wrapEvent(k){return(I,j,U)=>k(z=>{const x=this.f[this.f.length-1];x?x.push(()=>I.call(j,z)):I.call(j,z)},void 0,U)}bufferEvents(k){const I=[];this.f.push(I);const j=k();return this.f.pop(),I.forEach(U=>U()),j}}e.$Vd=p;class A{constructor(){this.f=!1,this.g=c.None,this.h=s.$Sc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=A}),define(ie[22],ne([0,1,3]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const R=Object.freeze(function(P,f){const c=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(c)}}});var s;(function(P){function f(c){return c===P.None||c===P.Cancelled||c instanceof O?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new S.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=s.None}}e.$Xd=D}),define(ie[142],ne([0,1,22]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$Xd,f=this.b(P.token);return this.a={promise:f,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$we=R;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const f=JSON.stringify(P);return this.b!==f&&(this.b=f,this.a=this.c(P)),this.a}}e.$xe=s;class O{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const f=this.b(P);return this.a.set(P,f),f}}e.$ye=O}),define(ie[61],ne([0,1,14,2]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function s(E){const u=E;return u?typeof u.read=="function":!1}e.$Yd=s;function O(E){const u=E;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}e.$Zd=O;function D(E){const u=E;return u?O(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$1d=D;function P(E,u){return new f(E,u)}e.$2d=P;class f{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,S.$1)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let a;switch(u){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const o=a.indexOf(i);o>=0&&a.splice(o,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,u){const i=[];let a;for(;(a=E.read())!==null;)i.push(a);return u(i)}e.$3d=c;function $(E,u,i){const a=[];let o;for(;(o=E.read())!==null&&a.length<i;)a.push(o);return o===null&&a.length>0?u(a):{read:()=>{if(a.length>0)return a.shift();if(typeof o<"u"){const t=o;return o=void 0,t}return E.read()}}}e.$4d=$;function b(E,u){return new Promise((i,a)=>{const o=[];y(E,{onData:t=>{u&&o.push(t)},onError:t=>{u?a(t):i(void 0)},onEnd:()=>{i(u?u(o):void 0)}})})}e.$5d=b;function y(E,u,i){E.on("error",a=>{i?.isCancellationRequested||u.onError(a)}),E.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),E.on("data",a=>{i?.isCancellationRequested||u.onData(a)})}e.$6d=y;function g(E,u){return new Promise((i,a)=>{const o=new R.$Rc,t=[],n=A=>{if(t.push(A),t.length>u)return o.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},r=A=>(o.dispose(),a(A)),p=()=>(o.dispose(),i({stream:E,buffer:t,ended:!0}));o.add((0,R.$Qc)(()=>E.removeListener("error",r))),E.on("error",r),o.add((0,R.$Qc)(()=>E.removeListener("end",p))),E.on("end",p),o.add((0,R.$Qc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$7d=g;function v(E,u){const i=P(u);return i.end(E),i}e.$8d=v;function m(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=m;function w(E){let u=!1;return{read:()=>u?null:(u=!0,E)}}e.$0d=w;function d(E,u,i){const a=P(i);return y(E,{onData:o=>a.write(u.data(o)),onError:o=>a.error(u.error?u.error(o):o),onEnd:()=>a.end()}),a}e.$$d=d;function h(E,u,i){let a=!1;return{read:()=>{const o=u.read();return a?o:(a=!0,o!==null?i([E,o]):E)}}}e.$_d=h;function l(E,u,i){let a=!1;const o=P(i);return y(u,{onData:t=>a?o.write(t):(a=!0,o.write(i([E,t]))),onError:t=>o.error(t),onEnd:()=>{a||(a=!0,o.write(E)),o.end()}}),o}e.$ae=l}),define(ie[17],ne([0,1,71,61]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const s=typeof Buffer<"u",O=new S.$V(()=>new Uint8Array(256));let D,P;class f{static alloc(I){return s?new f(Buffer.allocUnsafe(I)):new f(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new f(I)}static fromString(I,j){return!(j?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(I)):(D||(D=new TextEncoder),new f(D.encode(I)))}static fromByteArray(I){const j=f.alloc(I.length);for(let U=0,z=I.length;U<z;U++)j.buffer[U]=I[U];return j}static concat(I,j){if(typeof j>"u"){j=0;for(let x=0,X=I.length;x<X;x++)j+=I[x].byteLength}const U=f.alloc(j);let z=0;for(let x=0,X=I.length;x<X;x++){const ae=I[x];U.set(ae,z),z+=ae.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=f.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,j){return new f(this.buffer.subarray(I,j))}set(I,j){if(I instanceof f)this.buffer.set(I.buffer,j);else if(I instanceof Uint8Array)this.buffer.set(I,j);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),j);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return y(this.buffer,I)}writeUInt32BE(I,j){g(this.buffer,I,j)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,j){m(this.buffer,I,j)}readUInt8(I){return w(this.buffer,I)}writeUInt8(I,j){d(this.buffer,I,j)}indexOf(I,j=0){return c(this.buffer,I instanceof f?I.buffer:I,j)}}e.$be=f;function c(k,I,j=0){const U=I.byteLength,z=k.byteLength;if(U===0)return 0;if(U===1)return k.indexOf(I[0]);if(U>z-j)return-1;const x=O.value;x.fill(I.length);for(let ce=0;ce<I.length;ce++)x[I[ce]]=I.length-ce-1;let X=j+I.length-1,ae=X,se=-1;for(;X<z;)if(k[X]===I[ae]){if(ae===0){se=X;break}X--,ae--}else X+=Math.max(I.length-ae,x[k[X]]),ae=I.length-1;return se}e.$ce=c;function $(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$de=$;function b(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255}e.$ee=b;function y(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$fe=y;function g(k,I,j){k[j+3]=I,I=I>>>8,k[j+2]=I,I=I>>>8,k[j+1]=I,I=I>>>8,k[j]=I}e.$ge=g;function v(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$he=v;function m(k,I,j){k[j+0]=I&255,I=I>>>8,k[j+1]=I&255,I=I>>>8,k[j+2]=I&255,I=I>>>8,k[j+3]=I&255}e.$ie=m;function w(k,I){return k[I]}e.$je=w;function d(k,I,j){k[j]=I}e.$ke=d;function h(k){return R.$3d(k,I=>f.concat(I))}e.$le=h;function l(k){return R.$0d(k)}e.$me=l;function E(k){return R.$5d(k,I=>f.concat(I))}e.$ne=E;async function u(k){return k.ended?f.concat(k.buffer):f.concat([...k.buffer,await E(k.stream)])}e.$oe=u;function i(k){return R.$8d(k,I=>f.concat(I))}e.$pe=i;function a(k){return R.$$d(k,{data:I=>typeof I=="string"?f.fromString(I):f.wrap(I)},I=>f.concat(I))}e.$qe=a;function o(k){return R.$2d(I=>f.concat(I),k)}e.$re=o;function t(k,I){return R.$_d(k,I,j=>f.concat(j))}e.$se=t;function n(k,I){return R.$ae(k,I,j=>f.concat(j))}e.$te=n;function r(k){let I=0,j=0,U=0;const z=new Uint8Array(Math.floor(k.length/4*3)),x=ae=>{switch(j){case 3:z[U++]=I|ae,j=0;break;case 2:z[U++]=I|ae>>>2,I=ae<<6,j=3;break;case 1:z[U++]=I|ae>>>4,I=ae<<4,j=2;break;default:I=ae<<2,j=1}};for(let ae=0;ae<k.length;ae++){const se=k.charCodeAt(ae);if(se>=65&&se<=90)x(se-65);else if(se>=97&&se<=122)x(se-97+26);else if(se>=48&&se<=57)x(se-48+52);else if(se===43||se===45)x(62);else if(se===47||se===95)x(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ae]}`)}}const X=U;for(;j>0;)x(0);return f.wrap(z).slice(0,X)}e.$ue=r;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:k},I=!0,j=!1){const U=j?A:p;let z="";const x=k.byteLength%3;let X=0;for(;X<k.byteLength-x;X+=3){const ae=k[X+0],se=k[X+1],ce=k[X+2];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[(se<<2|ce>>>6)&63],z+=U[ce&63]}if(x===1){const ae=k[X+0];z+=U[ae>>>2],z+=U[ae<<4&63],I&&(z+="==")}else if(x===2){const ae=k[X+0],se=k[X+1];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[se<<2&63],I&&(z+="=")}return z}e.$ve=C}),define(ie[27],ne([0,1,142,71]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function s(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.$Be=s;const O=/{(\d+)}/g;function D(ee,...fe){return fe.length===0?ee:ee.replace(O,function($e,ke){const Ce=parseInt(ke,10);return isNaN(Ce)||Ce<0||Ce>=fe.length?$e:fe[Ce]})}e.$Ce=D;const P=/{([^}]+)}/g;function f(ee,fe){return ee.replace(P,($e,ke)=>fe[ke]??$e)}e.$De=f;function c(ee){return ee.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ee=c;function $(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=$;function b(ee,fe){let $e=0;const ke=fe.charCodeAt(0);for(let Ce=ee.length-1;Ce>=0;Ce--)ee.charCodeAt(Ce)===ke&&$e++;return $e}e.$Ge=b;function y(ee,fe,$e="\u2026"){return ee.length<=fe?ee:`${ee.substr(0,fe)}${$e}`}e.$He=y;function g(ee,fe=" "){const $e=v(ee,fe);return m($e,fe)}e.$Ie=g;function v(ee,fe){if(!ee||!fe)return ee;const $e=fe.length;if($e===0||ee.length===0)return ee;let ke=0;for(;ee.indexOf(fe,ke)===ke;)ke=ke+$e;return ee.substring(ke)}e.$Je=v;function m(ee,fe){if(!ee||!fe)return ee;const $e=fe.length,ke=ee.length;if($e===0||ke===0)return ee;let Ce=ke,Fe=-1;for(;Fe=ee.lastIndexOf(fe,Ce-1),!(Fe===-1||Fe+$e!==Ce);){if(Fe===0)return"";Ce=Fe}return ee.substring(0,Ce)}e.$Ke=m;function w(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=w;function d(ee){return ee.replace(/\*/g,"")}e.$Me=d;function h(ee,fe,$e={}){if(!ee)throw new Error("Cannot create regex from empty string");fe||(ee=$(ee)),$e.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ke="";return $e.global&&(ke+="g"),$e.matchCase||(ke+="i"),$e.multiline&&(ke+="m"),$e.unicode&&(ke+="u"),new RegExp(ee,ke)}e.$Ne=h;function l(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.$Oe=l;function E(ee){return ee.split(/\r\n|\r|\n/)}e.$Pe=E;function u(ee){for(let fe=0,$e=ee.length;fe<$e;fe++){const ke=ee.charCodeAt(fe);if(ke!==32&&ke!==9)return fe}return-1}e.$Qe=u;function i(ee,fe=0,$e=ee.length){for(let ke=fe;ke<$e;ke++){const Ce=ee.charCodeAt(ke);if(Ce!==32&&Ce!==9)return ee.substring(fe,ke)}return ee.substring(fe,$e)}e.$Re=i;function a(ee,fe=ee.length-1){for(let $e=fe;$e>=0;$e--){const ke=ee.charCodeAt($e);if(ke!==32&&ke!==9)return $e}return-1}e.$Se=a;function o(ee,fe,$e){const ke=[];let Ce=0;for(const Fe of ee.matchAll(fe)){if(ke.push(ee.slice(Ce,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Ce=Fe.index+Fe[0].length,ke.push($e(Fe[0],...Fe.slice(1),Fe.index,ee,Fe.groups))}return ke.push(ee.slice(Ce)),Promise.all(ke).then(Fe=>Fe.join(""))}e.$Te=o;function t(ee,fe){return ee<fe?-1:ee>fe?1:0}e.$Ue=t;function n(ee,fe,$e=0,ke=ee.length,Ce=0,Fe=fe.length){for(;$e<ke&&Ce<Fe;$e++,Ce++){const Ve=ee.charCodeAt($e),Ge=fe.charCodeAt(Ce);if(Ve<Ge)return-1;if(Ve>Ge)return 1}const je=ke-$e,Ne=Fe-Ce;return je<Ne?-1:je>Ne?1:0}e.$Ve=n;function r(ee,fe){return p(ee,fe,0,ee.length,0,fe.length)}e.$We=r;function p(ee,fe,$e=0,ke=ee.length,Ce=0,Fe=fe.length){for(;$e<ke&&Ce<Fe;$e++,Ce++){let Ve=ee.charCodeAt($e),Ge=fe.charCodeAt(Ce);if(Ve===Ge)continue;if(Ve>=128||Ge>=128)return n(ee.toLowerCase(),fe.toLowerCase(),$e,ke,Ce,Fe);C(Ve)&&(Ve-=32),C(Ge)&&(Ge-=32);const Ke=Ve-Ge;if(Ke!==0)return Ke}const je=ke-$e,Ne=Fe-Ce;return je<Ne?-1:je>Ne?1:0}e.$Xe=p;function A(ee){return ee>=48&&ee<=57}e.$Ye=A;function C(ee){return ee>=97&&ee<=122}e.$Ze=C;function k(ee){return ee>=65&&ee<=90}e.$1e=k;function I(ee,fe){return ee.length===fe.length&&p(ee,fe)===0}e.$2e=I;function j(ee,fe){const $e=fe.length;return fe.length>ee.length?!1:p(ee,fe,0,$e)===0}e.$3e=j;function U(ee,fe){const $e=Math.min(ee.length,fe.length);let ke;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(ke)!==fe.charCodeAt(ke))return ke;return $e}e.$4e=U;function z(ee,fe){const $e=Math.min(ee.length,fe.length);let ke;const Ce=ee.length-1,Fe=fe.length-1;for(ke=0;ke<$e;ke++)if(ee.charCodeAt(Ce-ke)!==fe.charCodeAt(Fe-ke))return ke;return $e}e.$5e=z;function x(ee){return 55296<=ee&&ee<=56319}e.$6e=x;function X(ee){return 56320<=ee&&ee<=57343}e.$7e=X;function ae(ee,fe){return(ee-55296<<10)+(fe-56320)+65536}e.$8e=ae;function se(ee,fe,$e){const ke=ee.charCodeAt($e);if(x(ke)&&$e+1<fe){const Ce=ee.charCodeAt($e+1);if(X(Ce))return ae(ke,Ce)}return ke}e.$9e=se;function ce(ee,fe){const $e=ee.charCodeAt(fe-1);if(X($e)&&fe>1){const ke=ee.charCodeAt(fe-2);if(x(ke))return ae(ke,$e)}return $e}class Z{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ce(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=se(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$0e=Z;class Q{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new Z(fe,$e)}nextGraphemeLength(){const fe=le.getInstance(),$e=this.c,ke=$e.offset;let Ce=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Fe=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(we(Ce,je)){$e.setOffset(Fe);break}Ce=je}return $e.offset-ke}prevGraphemeLength(){const fe=le.getInstance(),$e=this.c,ke=$e.offset;let Ce=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Fe=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(we(je,Ce)){$e.setOffset(Fe);break}Ce=je}return ke-$e.offset}eol(){return this.c.eol()}}e.$$e=Q;function K(ee,fe){return new Q(ee,fe).nextGraphemeLength()}e.$_e=K;function q(ee,fe){return new Q(ee,fe).prevGraphemeLength()}e.$af=q;function W(ee,fe){fe>0&&X(ee.charCodeAt(fe))&&fe--;const $e=fe+K(ee,fe);return[$e-q(ee,$e),$e]}e.$bf=W;function G(ee){const fe=new Q(ee);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}e.$cf=G;let H;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(ee){return H||(H=Y()),H.test(ee)}e.$df=re;const L=/^[\t\n\r\x20-\x7E]*$/;function M(ee){return L.test(ee)}e.$ef=M,e.$ff=/[\u2028\u2029]/;function F(ee){return e.$ff.test(ee)}e.$gf=F;function T(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.$hf=T;function N(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.$if=N;function B(ee,fe){if(ee.length<fe)return ee;const $e=/\b/g;let ke=0;for(;$e.test(ee)&&!(ee.length-$e.lastIndex<fe);)ke=$e.lastIndex,$e.lastIndex+=1;return ee.substring(ke).replace(/^\s/,"")}e.$jf=B;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,oe=/\x1b\].*?\x07/g;function de(ee){return ee&&(ee=ee.replace(V,"").replace(oe,"")),ee}e.$kf=de,e.$lf=String.fromCharCode(65279);function ue(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.$mf=ue;function he(ee){return ue(ee)?ee.substr(1):ee}e.$nf=he;function ve(ee,fe){if(!ee||!fe||ee.length<fe.length)return!1;const $e=fe.length,ke=ee.toLowerCase();let Ce=0,Fe=-1;for(;Ce<$e;){const je=ke.indexOf(fe[Ce],Fe+1);if(je<0)return!1;Fe=je,Ce++}return!0}e.$of=ve;function be(ee,fe=!1){return ee?(fe&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.$pf=be;function ye(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.$qf=ye;function Ie(ee,fe=1){if(fe===0)return"";let $e=-1;do $e=ee.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?ee:(ee[$e-1]==="\r"&&$e--,ee.substr(0,$e))}e.$rf=Ie;function Te(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.$sf=Te;function me(ee){return le.getInstance().getGraphemeBreakType(ee)}e.$tf=me;function we(ee,fe){return ee===0?fe!==5&&fe!==7:ee===2&&fe===3?!1:ee===4||ee===2||ee===3||fe===4||fe===2||fe===3?!0:!(ee===8&&(fe===8||fe===9||fe===11||fe===12)||(ee===11||ee===9)&&(fe===9||fe===10)||(ee===12||ee===10)&&fe===10||fe===5||fe===13||fe===7||ee===1||ee===13&&fe===14||ee===6&&fe===6)}var _;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=ge()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const $e=this.d,ke=$e.length/3;let Ce=1;for(;Ce<=ke;)if(fe<$e[3*Ce])Ce=2*Ce;else if(fe>$e[3*Ce+1])Ce=2*Ce+1;else return $e[3*Ce+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(ee,fe){if(ee===0)return 0;const $e=De(ee,fe);if($e!==void 0)return $e;const ke=new Z(fe,ee);return ke.prevCodePoint(),ke.offset}e.$uf=Ae;function De(ee,fe){const $e=new Z(fe,ee);let ke=$e.prevCodePoint();for(;Le(ke)||ke===65039||ke===8419;){if($e.offset===0)return;ke=$e.prevCodePoint()}if(!N(ke))return;let Ce=$e.offset;return Ce>0&&$e.prevCodePoint()===8205&&(Ce=$e.offset),Ce}function Le(ee){return 127995<=ee&&ee<=127999}var Oe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$vf="\xA0";class He{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$xe(fe=>{function $e(Ke){const Xe=new Map;for(let Ye=0;Ye<Ke.length;Ye+=2)Xe.set(Ke[Ye],Ke[Ye+1]);return Xe}function ke(Ke,Xe){const Ye=new Map(Ke);for(const[it,nt]of Xe)Ye.set(it,nt);return Ye}function Ce(Ke,Xe){if(!Ke)return Xe;const Ye=new Map;for(const[it,nt]of Ke)Xe.has(it)&&Ye.set(it,nt);return Ye}const Fe=this.c.value;let je=fe.filter(Ke=>!Ke.startsWith("_")&&Ke in Fe);je.length===0&&(je=["_default"]);let Ne;for(const Ke of je){const Xe=$e(Fe[Ke]);Ne=Ce(Ne,Xe)}const Ve=$e(Fe._common),Ge=ke(Ve,Ne);return new He(Ge)})}static getInstance(fe){return He.d.get(Array.from(fe))}static{this.e=new R.$V(()=>Object.keys(He.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return He.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=He;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$xf=ze}),define(ie[55],ne([0,1,27]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function R(d){return s(d,0)}e.$Di=R;function s(d,h){switch(typeof d){case"object":return d===null?O(349,h):Array.isArray(d)?f(d,h):c(d,h);case"string":return P(d,h);case"boolean":return D(d,h);case"number":return O(d,h);case"undefined":return O(937,h);default:return O(617,h)}}e.$Ei=s;function O(d,h){return(h<<5)-h+d|0}e.$Fi=O;function D(d,h){return O(d?433:863,h)}function P(d,h){h=O(149417,h);for(let l=0,E=d.length;l<E;l++)h=O(d.charCodeAt(l),h);return h}e.$Gi=P;function f(d,h){return h=O(104579,h),d.reduce((l,E)=>s(E,l),h)}function c(d,h){return h=O(181387,h),Object.keys(d).sort().reduce((l,E)=>(l=P(E,l),s(d[E],l)),h)}class ${constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Hi=$;var b;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y(d,h,l=32){const E=l-h,u=~((1<<E)-1);return(d<<h|(u&d)>>>E)>>>0}function g(d,h=0,l=d.byteLength,E=0){for(let u=0;u<l;u++)d[h+u]=E}function v(d,h,l="0"){for(;d.length<h;)d=l+d;return d}function m(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(l=>l.toString(16).padStart(2,"0")).join(""):v((d>>>0).toString(16),h/4)}e.$Ii=m;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const l=h.length;if(l===0)return;const E=this.p;let u=this.r,i=this.u,a,o;for(i!==0?(a=i,o=-1,i=0):(a=h.charCodeAt(0),o=0);;){let t=a;if(S.$6e(a))if(o+1<l){const n=h.charCodeAt(o+1);S.$7e(n)?(o++,t=S.$8e(a,n)):t=65533}else{i=a;break}else S.$7e(a)&&(t=65533);if(u=this.w(E,u,t),o++,o<l)a=h.charCodeAt(o);else break}this.r=u,this.u=i}w(h,l,E){return E<128?h[l++]=E:E<2048?(h[l++]=192|(E&1984)>>>6,h[l++]=128|(E&63)>>>0):E<65536?(h[l++]=224|(E&61440)>>>12,h[l++]=128|(E&4032)>>>6,h[l++]=128|(E&63)>>>0):(h[l++]=240|(E&1835008)>>>18,h[l++]=128|(E&258048)>>>12,h[l++]=128|(E&4032)>>>6,h[l++]=128|(E&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=w.g,l=this.q;for(let p=0;p<64;p+=4)h.setUint32(p,l.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)h.setUint32(p,y(h.getUint32(p-12,!1)^h.getUint32(p-32,!1)^h.getUint32(p-56,!1)^h.getUint32(p-64,!1),1),!1);let E=this.h,u=this.l,i=this.m,a=this.n,o=this.o,t,n,r;for(let p=0;p<80;p++)p<20?(t=u&i|~u&a,n=1518500249):p<40?(t=u^i^a,n=1859775393):p<60?(t=u&i|u&a|i&a,n=2400959708):(t=u^i^a,n=3395469782),r=y(E,5)+t+o+n+h.getUint32(p*4,!1)&4294967295,o=a,a=i,i=y(u,30),u=E,E=r;this.h=this.h+E&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+o&4294967295}}e.$Ji=w}),define(ie[73],ne([0,1,27]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const O="error",D="warning",P="warn",f="info",c="ignore";function $(y){return y?S.$2e(O,y)?s.Error:S.$2e(D,y)||S.$2e(P,y)?s.Warning:S.$2e(f,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=$;function b(y){switch(y){case s.Error:return O;case s.Warning:return D;case s.Info:return f;default:return c}}s.toString=b}(R||(R={})),e.default=R}),define(ie[143],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(ie[56],ne([0,1,23,27]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class s{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const v=g.charCodeAt(0),m=this.b.charCodeAt(this.c);return v-m}value(){return this.b[this.c]}}e.$Rh=s;class O{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,R.$Ve)(g,this.b,0,g.length,this.c,this.d):(0,R.$Xe)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=O;class D{constructor(g=!0,v=!0){this.f=g,this.g=v}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let v=g.length-1;v>=0;v--,this.c--){const m=this.b.charCodeAt(v);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,R.$Ve)(g,this.b,0,g.length,this.d,this.e):(0,R.$Xe)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=D;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class f{constructor(g,v){this.f=g,this.g=v,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,R.$We)(g,this.c.scheme);if(this.d[this.e]===2)return(0,R.$We)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,R.$Ue)(g,this.c.query);if(this.d[this.e]===5)return(0,R.$Ue)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=f;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})($||($={}));class b{static forUris(g=()=>!1,v=()=>!1){return new b(new f(g,v))}static forPaths(g=!1){return new b(new D(void 0,!g))}static forStrings(){return new b(new s)}static forConfigKeys(){return new b(new O)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,v){if(v){const m=v.slice(0);(0,S.$Xb)(m);for(const w of m)this.set(w,g)}else{const m=g.slice(0);(0,S.$Xb)(m);for(const w of m)this.set(w[0],w[1])}}set(g,v){const m=this.b.reset(g);let w;this.c||(this.c=new c,this.c.segment=m.value());const d=[];for(w=this.c;;){const l=m.cmp(w.segment);if(l>0)w.left||(w.left=new c,w.left.segment=m.value()),d.push([-1,w]),w=w.left;else if(l<0)w.right||(w.right=new c,w.right.segment=m.value()),d.push([1,w]),w=w.right;else if(m.hasNext())m.next(),w.mid||(w.mid=new c,w.mid.segment=m.value()),d.push([0,w]),w=w.mid;else break}const h=w.value;w.value=v,w.key=g;for(let l=d.length-1;l>=0;l--){const E=d[l][1];E.updateHeight();const u=E.balanceFactor();if(u<-1||u>1){const i=d[l][0],a=d[l+1][0];if(i===1&&a===1)d[l][1]=E.rotateLeft();else if(i===-1&&a===-1)d[l][1]=E.rotateRight();else if(i===1&&a===-1)E.right=d[l+1][1]=d[l+1][1].rotateRight(),d[l][1]=E.rotateLeft();else if(i===-1&&a===1)E.left=d[l+1][1]=d[l+1][1].rotateLeft(),d[l][1]=E.rotateRight();else throw new Error;if(l>0)switch(d[l-1][0]){case-1:d[l-1][1].left=d[l][1];break;case 1:d[l-1][1].right=d[l][1];break;case 0:d[l-1][1].mid=d[l][1];break}else this.c=d[0][1]}}return h}get(g){return this.d(g)?.value}d(g){const v=this.b.reset(g);let m=this.c;for(;m;){const w=v.cmp(m.segment);if(w>0)m=m.left;else if(w<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else break}return m}has(g){const v=this.d(g);return!(v?.value===void 0&&v?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,v){const m=this.b.reset(g),w=[];let d=this.c;for(;d;){const h=m.cmp(d.segment);if(h>0)w.push([-1,d]),d=d.left;else if(h<0)w.push([1,d]),d=d.right;else if(m.hasNext())m.next(),w.push([0,d]),d=d.mid;else break}if(d){if(v?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this.f(d.right);if(h.key){const{key:l,value:E,segment:u}=h;this.e(h.key,!1),d.key=l,d.value=E,d.segment=u}}else{const h=d.left??d.right;if(w.length>0){const[l,E]=w[w.length-1];switch(l){case-1:E.left=h;break;case 0:E.mid=h;break;case 1:E.right=h;break}}else this.c=h}for(let h=w.length-1;h>=0;h--){const l=w[h][1];l.updateHeight();const E=l.balanceFactor();if(E>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),w[h][1]=l.rotateLeft()):E<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),w[h][1]=l.rotateRight()),h>0)switch(w[h-1][0]){case-1:w[h-1][1].left=w[h][1];break;case 1:w[h-1][1].right=w[h][1];break;case 0:w[h-1][1].mid=w[h][1];break}else this.c=w[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const v=this.b.reset(g);let m=this.c,w;for(;m;){const d=v.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(v.hasNext())v.next(),w=m.value||w,m=m.mid;else break}return m&&m.value||w}findSuperstr(g){return this.g(g,!1)}g(g,v){const m=this.b.reset(g);let w=this.c;for(;w;){const d=m.cmp(w.segment);if(d>0)w=w.left;else if(d<0)w=w.right;else if(m.hasNext())m.next(),w=w.mid;else return w.mid?this.h(w.mid):v?w.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[v,m]of this)g(m,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const v=[];return this.j(g,v),v[Symbol.iterator]()}j(g,v){g&&(g.left&&this.j(g.left,v),g.value&&v.push([g.key,g.value]),g.mid&&this.j(g.mid,v),g.right&&this.j(g.right,v))}_isBalanced(){const g=v=>{if(!v)return!0;const m=v.balanceFactor();return m<-1||m>1?!1:g(v.left)&&g(v.right)};return g(this.c)}}e.$Vh=b}),define(ie[12],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function S(u){return typeof u=="string"}e.$yf=S;function R(u){return Array.isArray(u)&&u.every(i=>S(i))}e.$zf=R;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$Af=s;function O(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}e.$Bf=O;function D(u){return typeof u=="number"&&!isNaN(u)}e.$Cf=D;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Df=P;function f(u){return u===!0||u===!1}e.$Ef=f;function c(u){return typeof u>"u"}e.$Ff=c;function $(u){return!b(u)}e.$Gf=$;function b(u){return c(u)||u===null}e.$Hf=b;function y(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$If=y;function g(u){if(b(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$Jf=g;function v(...u){const i=[];for(let a=0;a<u.length;a++){const o=u[a];if(b(o))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);i.push(o)}return i}e.$Kf=v;const m=Object.prototype.hasOwnProperty;function w(u){if(!s(u))return!1;for(const i in u)if(m.call(u,i))return!1;return!0}e.$Lf=w;function d(u){return typeof u=="function"}e.$Mf=d;function h(...u){return u.length>0&&u.every(d)}e.$Nf=h;function l(u,i){const a=Math.min(u.length,i.length);for(let o=0;o<a;o++)E(u[o],i[o])}e.$Of=l;function E(u,i){if(S(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(d(i)){try{if(u instanceof i)return}catch{}if(!b(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=E}),define(ie[74],ne([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=void 0;const R=Object.create(null);function s(P,f){if((0,S.$yf)(f)){const c=R[f];if(c===void 0)throw new Error(`${P} references an unknown codicon: ${f}`);f=c}return R[P]=f,{id:P}}function O(){return R}e.$Sj=O;function D(){return Object.values(e.$Uj)}e.$Tj=D,e.$Uj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ie[37],ne([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([l,E])=>{h[l]=E&&typeof E=="object"?R(E):E}),h}e.$7m=R;function s(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const l=h.shift();Object.freeze(l);for(const E in l)if(O.call(l,E)){const u=l[E];typeof u=="object"&&!Object.isFrozen(u)&&!(0,S.$Bf)(u)&&h.push(u)}}return d}e.$8m=s;const O=Object.prototype.hasOwnProperty;function D(d,h){return P(d,h,new Set)}e.$9m=D;function P(d,h,l){if((0,S.$Hf)(d))return d;const E=h(d);if(typeof E<"u")return E;if(Array.isArray(d)){const u=[];for(const i of d)u.push(P(i,h,l));return u}if((0,S.$Af)(d)){if(l.has(d))throw new Error("Cannot clone recursive data-structure");l.add(d);const u={};for(const i in d)O.call(d,i)&&(u[i]=P(d[i],h,l));return l.delete(d),u}return d}function f(d,h,l=!0){return(0,S.$Af)(d)?((0,S.$Af)(h)&&Object.keys(h).forEach(E=>{E in d?l&&((0,S.$Af)(d[E])&&(0,S.$Af)(h[E])?f(d[E],h[E],l):d[E]=h[E]):d[E]=h[E]}),d):h}e.$0m=f;function c(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let l,E;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(l=0;l<d.length;l++)if(!c(d[l],h[l]))return!1}else{const u=[];for(E in d)u.push(E);u.sort();const i=[];for(E in h)i.push(E);if(i.sort(),!c(u,i))return!1;for(l=0;l<u.length;l++)if(!c(d[u[l]],h[u[l]]))return!1}return!0}e.$$m=c;function $(d){const h=new Set;return JSON.stringify(d,(l,E)=>{if((0,S.$Af)(E)||Array.isArray(E)){if(h.has(E))return"[Circular]";h.add(E)}return E})}e.$_m=$;function b(d,h){const l=Object.create(null);return!d||!h||Object.keys(h).forEach(u=>{const i=d[u],a=h[u];c(i,a)||(l[u]=a)}),l}e.$an=b;function y(d,h){const l=h.toLowerCase(),E=Object.keys(d).find(u=>u.toLowerCase()===l);return E?d[E]:d[h]}e.$bn=y;function g(d,h){const l=Object.create(null);for(const[E,u]of Object.entries(d))h(E,u)&&(l[E]=u);return l}e.$cn=g;function v(d){let h=[];for(;Object.prototype!==d;)h=h.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return h}e.$dn=v;function m(d){const h=[];for(const l of v(d))typeof d[l]=="function"&&h.push(l);return h}e.$en=m;function w(d,h){const l=u=>function(){const i=Array.prototype.slice.call(arguments,0);return h(u,i)},E={};for(const u of d)E[u]=l(u);return E}e.$fn=w}),define(ie[102],ne([0,1,74]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var R;(function(D){function P(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=P})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$Vj=s;var O;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(h){const l=P.exec(h.id);if(!l)return f(S.$Uj.error);const[,E,u]=l,i=["codicon","codicon-"+E];return u&&i.push("codicon-modifier-"+u.substring(1)),i}D.asClassNameArray=f;function c(h){return f(h).join(" ")}D.asClassName=c;function $(h){return"."+f(h).join(".")}D.asCSSSelector=$;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}D.isThemeIcon=b;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function g(h){const l=y.exec(h);if(!l)return;const[,E]=l;return{id:E}}D.fromString=g;function v(h){return{id:h}}D.fromId=v;function m(h,l){let E=h.id;const u=E.lastIndexOf("~");return u!==-1&&(E=E.substring(0,u)),l&&(E=`${E}~${l}`),{id:E}}D.modify=m;function w(h){const l=h.id.lastIndexOf("~");if(l!==-1)return h.id.substring(l+1)}D.getModifier=w;function d(h,l){return h.id===l.id&&h.color?.id===l.color?.id}D.isEqual=d})(O||(e.ThemeIcon=O={}))}),define(ie[32],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return S.test(s)}e.$dg=R,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let f=0;f<P.length;f++)P[f]=Math.floor(Math.random()*256);return P};const O=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){s(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let f=0,c="";return c+=D[O[f++]],c+=D[O[f++]],c+=D[O[f++]],c+=D[O[f++]],c+="-",c+=D[O[f++]],c+=D[O[f++]],c+="-",c+=D[O[f++]],c+=D[O[f++]],c+="-",c+=D[O[f++]],c+=D[O[f++]],c+="-",c+=D[O[f++]],c+=D[O[f++]],c+=D[O[f++]],c+=D[O[f++]],c+=D[O[f++]],c+=D[O[f++]],c}}()}),define(ie[144],ne([0,1,85,45,83]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lT=void 0;async function O(D,P){if(await new Promise(($,b)=>{const y=R.createReadStream(D),g=S.createHash("sha1");y.pipe(g);const v=(0,s.$db)((m,w)=>{y.removeAllListeners(),g.removeAllListeners(),m?b(m):$(w)});y.once("error",v),y.once("end",v),g.once("error",v),g.once("data",m=>v(void 0,m.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$lT=O}),define(ie[145],ne([0,1,28]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const P=D.replace(/\-/g,":").toLowerCase();return!R.has(P)}function O(){const D=(0,S.networkInterfaces)();for(const P in D){const f=D[P];if(f){for(const{mac:c}of f)if(s(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Qm=O}),define(ie[103],ne([0,1,86]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function R(P,f,c,$=1){let b=!1;return new Promise(y=>{const g=setTimeout(()=>{if(!b)return b=!0,y(0)},c);s(P,f,$,v=>{if(!b)return b=!0,clearTimeout(g),y(v)})})}e.$gg=R;function s(P,f,c,$){if(f===0)return $(0);const b=new S.Socket;b.once("connect",()=>(D(b),s(P+c,f-1,c,$))),b.once("data",()=>{}),b.once("error",y=>(D(b),y.code!=="ECONNREFUSED"?s(P+c,f-1,c,$):$(P))),b.connect(P,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(P,f,c,$="127.0.0.1"){let b=!1,y,g=1;const v=S.createServer({pauseOnConnect:!0});function m(w,d){b||(b=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),d(w))}return new Promise(w=>{y=setTimeout(()=>{m(0,w)},c),v.on("listening",()=>{m(P,w)}),v.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&g<f?(P++,g++,v.listen(P,$)):m(0,w)}),v.on("close",()=>{m(0,w)}),v.listen(P,$)})}e.$ig=O;function D(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function S(f){const c=new Set;if(Array.isArray(f))for(const $ of f)typeof $=="string"&&c.add($);return Array.from(c)}function R(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const c=e();if(c)if(typeof f=="string")c.add(f.toLowerCase());else for(const $ of S(f))s($)}function O(f){if(typeof f!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let $;for(const b of c){if(f.indexOf(b)!==0)continue;const g=f.indexOf("\\",b.length);if(g===-1)continue;const v=f.substring(b.length,g);if(v){$=v;break}}return $}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:O,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ie[146],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pT=e.$oT=void 0,e.$oT="vscode:contextmenu",e.$pT="vscode:onCloseContextMenu"}),define(ie[147],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wT=void 0;class S{constructor(s,O){this.a=s,this.onMessage=O}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$wT=S}),define(ie[148],ne([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[149],ne([0,1,148]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const R=60,s=R*60,O=s*24,D=O*7,P=O*30,f=O*365;function c(b,y,g,v){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,S.localize)(0,null,c(new Date().getTime()+m*1e3,!1));if(!v&&m<30)return(0,S.localize)(1,null);let w;return m<R?(w=m,y?w===1?g?(0,S.localize)(2,null,w):(0,S.localize)(3,null,w):g?(0,S.localize)(4,null,w):(0,S.localize)(5,null,w):w===1?g?(0,S.localize)(6,null,w):(0,S.localize)(7,null,w):g?(0,S.localize)(8,null,w):(0,S.localize)(9,null,w)):m<s?(w=Math.floor(m/R),y?w===1?g?(0,S.localize)(10,null,w):(0,S.localize)(11,null,w):g?(0,S.localize)(12,null,w):(0,S.localize)(13,null,w):w===1?g?(0,S.localize)(14,null,w):(0,S.localize)(15,null,w):g?(0,S.localize)(16,null,w):(0,S.localize)(17,null,w)):m<O?(w=Math.floor(m/s),y?w===1?g?(0,S.localize)(18,null,w):(0,S.localize)(19,null,w):g?(0,S.localize)(20,null,w):(0,S.localize)(21,null,w):w===1?g?(0,S.localize)(22,null,w):(0,S.localize)(23,null,w):g?(0,S.localize)(24,null,w):(0,S.localize)(25,null,w)):m<D?(w=Math.floor(m/O),y?w===1?(0,S.localize)(26,null,w):(0,S.localize)(27,null,w):w===1?(0,S.localize)(28,null,w):(0,S.localize)(29,null,w)):m<P?(w=Math.floor(m/D),y?w===1?g?(0,S.localize)(30,null,w):(0,S.localize)(31,null,w):g?(0,S.localize)(32,null,w):(0,S.localize)(33,null,w):w===1?g?(0,S.localize)(34,null,w):(0,S.localize)(35,null,w):g?(0,S.localize)(36,null,w):(0,S.localize)(37,null,w)):m<f?(w=Math.floor(m/P),y?w===1?g?(0,S.localize)(38,null,w):(0,S.localize)(39,null,w):g?(0,S.localize)(40,null,w):(0,S.localize)(41,null,w):w===1?g?(0,S.localize)(42,null,w):(0,S.localize)(43,null,w):g?(0,S.localize)(44,null,w):(0,S.localize)(45,null,w)):(w=Math.floor(m/f),y?w===1?g?(0,S.localize)(46,null,w):(0,S.localize)(47,null,w):g?(0,S.localize)(48,null,w):(0,S.localize)(49,null,w):w===1?g?(0,S.localize)(50,null,w):(0,S.localize)(51,null,w):g?(0,S.localize)(52,null,w):(0,S.localize)(53,null,w))}e.$dm=c;function $(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=$}),define(ie[150],ne([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[49],ne([0,1,23,12,150]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function O(b,y){return y&&(b.stack||b.stacktrace)?s.localize(0,null,P(b),D(b.stack)||D(b.stacktrace)):P(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?s.localize(1,null,b.message):b.message||s.localize(2,null)}function f(b=null,y=!1){if(!b)return s.localize(3,null);if(Array.isArray(b)){const g=S.$Hb(b),v=f(g[0],y);return g.length>1?s.localize(4,null,v,g.length):v}if(R.$yf(b))return b;if(b.detail){const g=b.detail;if(g.error)return O(g.error,y);if(g.exception)return O(g.exception,y)}return b.stack?O(b,y):b.message?b.message:s.localize(5,null)}e.$Ai=f;function c(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}e.$Bi=c;function $(b,y){let g;return typeof b=="string"?g=new Error(b):g=b,g.actions=y,g}e.$Ci=$}),define(ie[151],ne([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[152],ne([0,1,151]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;function R(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$wp=R}),define(ie[153],ne([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(ie[4],ne([0,1,153]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let R=!1,s=!1,O=!1,D=!1,P=!1,f=!1,c=!1,$=!1,b=!1,y=!1,g,v=e.$g,m=e.$g,w,d;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?h=e.$h.vscode.process:typeof process<"u"&&(h=process);const l=typeof h?.versions?.electron=="string",E=l&&h?.type==="renderer";if(typeof navigator=="object"&&!E)d=navigator.userAgent,R=d.indexOf("Windows")>=0,s=d.indexOf("Macintosh")>=0,$=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=d.indexOf("Linux")>=0,y=d?.indexOf("Mobi")>=0,f=!0,g=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,v=g,m=navigator.language;else if(typeof h=="object"){R=h.platform==="win32",s=h.platform==="darwin",O=h.platform==="linux",D=O&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,c=l,b=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.$g,v=e.$g;const A=h.env.VSCODE_NLS_CONFIG;if(A)try{const C=JSON.parse(A),k=C.availableLanguages["*"];g=C.locale,m=C.osLocale,v=k||e.$g,w=C._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var u;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(u||(e.Platform=u={}));function i(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=i;let a=0;s?a=1:R?a=3:O&&(a=2),e.$j=R,e.$k=s,e.$l=O,e.$m=D,e.$n=P,e.$o=c,e.$p=f,e.$q=f&&typeof e.$h.importScripts=="function",e.$r=$,e.$s=y,e.$t=b,e.$u=a,e.$v=d,e.$w=v;var o;(function(A){function C(){return e.$w}A.value=C;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=k;function I(){return e.$w==="en"}A.isDefault=I})(o||(e.Language=o={})),e.$x=g,e.$y=m,e.$z=w,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const A=[];e.$h.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let I=0,j=A.length;I<j;I++){const U=A[I];if(U.id===k.data.vscodeScheduleAsyncWork){A.splice(I,1),U.callback();return}}});let C=0;return k=>{const I=++C;A.push({id:I,callback:k}),e.$h.postMessage({vscodeScheduleAsyncWork:I},"*")}}return A=>setTimeout(A)})();var t;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=s||$?2:R?1:3;let n=!0,r=!1;function p(){if(!r){r=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,n=new Uint16Array(A.buffer)[0]===(2<<8)+1}return n}e.$D=p,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ie[35],ne([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.process<"u"){const s=S.$h.vscode.process;R={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return S.$j?"win32":S.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(ie[9],ne([0,1,35]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,O=90,D=122,P=46,f=47,c=92,$=58,b=63;class y extends Error{constructor(a,o,t){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const r=a.indexOf(".")!==-1?"property":"argument";let p=`The "${a}" ${r} ${n} of type ${o}`;p+=`. Received type ${typeof t}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,a){if(i===null||typeof i!="object")throw new y(a,"Object",i)}function v(i,a){if(typeof i!="string")throw new y(a,"string",i)}const m=S.$dc==="win32";function w(i){return i===f||i===c}function d(i){return i===f}function h(i){return i>=R&&i<=O||i>=s&&i<=D}function l(i,a,o,t){let n="",r=0,p=-1,A=0,C=0;for(let k=0;k<=i.length;++k){if(k<i.length)C=i.charCodeAt(k);else{if(t(C))break;C=f}if(t(C)){if(!(p===k-1||A===1))if(A===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const I=n.lastIndexOf(o);I===-1?(n="",r=0):(n=n.slice(0,I),r=n.length-1-n.lastIndexOf(o)),p=k,A=0;continue}else if(n.length!==0){n="",r=0,p=k,A=0;continue}}a&&(n+=n.length>0?`${o}..`:"..",r=2)}else n.length>0?n+=`${o}${i.slice(p+1,k)}`:n=i.slice(p+1,k),r=k-p-1;p=k,A=0}else C===P&&A!==-1?++A:A=-1}return n}function E(i,a){g(a,"pathObject");const o=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return o?o===a.root?`${o}${t}`:`${o}${i}${t}`:t}e.$fc={resolve(...i){let a="",o="",t=!1;for(let n=i.length-1;n>=-1;n--){let r;if(n>=0){if(r=i[n],v(r,"path"),r.length===0)continue}else a.length===0?r=S.cwd():(r=S.env[`=${a}`]||S.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===c)&&(r=`${a}\\`));const p=r.length;let A=0,C="",k=!1;const I=r.charCodeAt(0);if(p===1)w(I)&&(A=1,k=!0);else if(w(I))if(k=!0,w(r.charCodeAt(1))){let j=2,U=j;for(;j<p&&!w(r.charCodeAt(j));)j++;if(j<p&&j!==U){const z=r.slice(U,j);for(U=j;j<p&&w(r.charCodeAt(j));)j++;if(j<p&&j!==U){for(U=j;j<p&&!w(r.charCodeAt(j));)j++;(j===p||j!==U)&&(C=`\\\\${z}\\${r.slice(U,j)}`,A=j)}}}else A=1;else h(I)&&r.charCodeAt(1)===$&&(C=r.slice(0,2),A=2,p>2&&w(r.charCodeAt(2))&&(k=!0,A=3));if(C.length>0)if(a.length>0){if(C.toLowerCase()!==a.toLowerCase())continue}else a=C;if(t){if(a.length>0)break}else if(o=`${r.slice(A)}\\${o}`,t=k,k&&a.length>0)break}return o=l(o,!t,"\\",w),t?`${a}\\${o}`:`${a}${o}`||"."},normalize(i){v(i,"path");const a=i.length;if(a===0)return".";let o=0,t,n=!1;const r=i.charCodeAt(0);if(a===1)return d(r)?"\\":i;if(w(r))if(n=!0,w(i.charCodeAt(1))){let A=2,C=A;for(;A<a&&!w(i.charCodeAt(A));)A++;if(A<a&&A!==C){const k=i.slice(C,A);for(C=A;A<a&&w(i.charCodeAt(A));)A++;if(A<a&&A!==C){for(C=A;A<a&&!w(i.charCodeAt(A));)A++;if(A===a)return`\\\\${k}\\${i.slice(C)}\\`;A!==C&&(t=`\\\\${k}\\${i.slice(C,A)}`,o=A)}}}else o=1;else h(r)&&i.charCodeAt(1)===$&&(t=i.slice(0,2),o=2,a>2&&w(i.charCodeAt(2))&&(n=!0,o=3));let p=o<a?l(i.slice(o),!n,"\\",w):"";return p.length===0&&!n&&(p="."),p.length>0&&w(i.charCodeAt(a-1))&&(p+="\\"),t===void 0?n?`\\${p}`:p:n?`${t}\\${p}`:`${t}${p}`},isAbsolute(i){v(i,"path");const a=i.length;if(a===0)return!1;const o=i.charCodeAt(0);return w(o)||a>2&&h(o)&&i.charCodeAt(1)===$&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,o;for(let r=0;r<i.length;++r){const p=i[r];v(p,"path"),p.length>0&&(a===void 0?a=o=p:a+=`\\${p}`)}if(a===void 0)return".";let t=!0,n=0;if(typeof o=="string"&&w(o.charCodeAt(0))){++n;const r=o.length;r>1&&w(o.charCodeAt(1))&&(++n,r>2&&(w(o.charCodeAt(2))?++n:t=!1))}if(t){for(;n<a.length&&w(a.charCodeAt(n));)n++;n>=2&&(a=`\\${a.slice(n)}`)}return e.$fc.normalize(a)},relative(i,a){if(v(i,"from"),v(a,"to"),i===a)return"";const o=e.$fc.resolve(i),t=e.$fc.resolve(a);if(o===t||(i=o.toLowerCase(),a=t.toLowerCase(),i===a))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===c;)n++;let r=i.length;for(;r-1>n&&i.charCodeAt(r-1)===c;)r--;const p=r-n;let A=0;for(;A<a.length&&a.charCodeAt(A)===c;)A++;let C=a.length;for(;C-1>A&&a.charCodeAt(C-1)===c;)C--;const k=C-A,I=p<k?p:k;let j=-1,U=0;for(;U<I;U++){const x=i.charCodeAt(n+U);if(x!==a.charCodeAt(A+U))break;x===c&&(j=U)}if(U!==I){if(j===-1)return t}else{if(k>I){if(a.charCodeAt(A+U)===c)return t.slice(A+U+1);if(U===2)return t.slice(A+U)}p>I&&(i.charCodeAt(n+U)===c?j=U:U===2&&(j=3)),j===-1&&(j=0)}let z="";for(U=n+j+1;U<=r;++U)(U===r||i.charCodeAt(U)===c)&&(z+=z.length===0?"..":"\\..");return A+=j,z.length>0?`${z}${t.slice(A,C)}`:(t.charCodeAt(A)===c&&++A,t.slice(A,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=e.$fc.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===c){if(a.charCodeAt(1)===c){const o=a.charCodeAt(2);if(o!==b&&o!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(h(a.charCodeAt(0))&&a.charCodeAt(1)===$&&a.charCodeAt(2)===c)return`\\\\?\\${a}`;return i},dirname(i){v(i,"path");const a=i.length;if(a===0)return".";let o=-1,t=0;const n=i.charCodeAt(0);if(a===1)return w(n)?i:".";if(w(n)){if(o=t=1,w(i.charCodeAt(1))){let A=2,C=A;for(;A<a&&!w(i.charCodeAt(A));)A++;if(A<a&&A!==C){for(C=A;A<a&&w(i.charCodeAt(A));)A++;if(A<a&&A!==C){for(C=A;A<a&&!w(i.charCodeAt(A));)A++;if(A===a)return i;A!==C&&(o=t=A+1)}}}}else h(n)&&i.charCodeAt(1)===$&&(o=a>2&&w(i.charCodeAt(2))?3:2,t=o);let r=-1,p=!0;for(let A=a-1;A>=t;--A)if(w(i.charCodeAt(A))){if(!p){r=A;break}}else p=!1;if(r===-1){if(o===-1)return".";r=o}return i.slice(0,r)},basename(i,a){a!==void 0&&v(a,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(i.length>=2&&h(i.charCodeAt(0))&&i.charCodeAt(1)===$&&(o=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,A=-1;for(r=i.length-1;r>=o;--r){const C=i.charCodeAt(r);if(w(C)){if(!n){o=r+1;break}}else A===-1&&(n=!1,A=r+1),p>=0&&(C===a.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=A))}return o===t?t=A:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=o;--r)if(w(i.charCodeAt(r))){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let a=0,o=-1,t=0,n=-1,r=!0,p=0;i.length>=2&&i.charCodeAt(1)===$&&h(i.charCodeAt(0))&&(a=t=2);for(let A=i.length-1;A>=a;--A){const C=i.charCodeAt(A);if(w(C)){if(!r){t=A+1;break}continue}n===-1&&(r=!1,n=A+1),C===P?o===-1?o=A:p!==1&&(p=1):o!==-1&&(p=-1)}return o===-1||n===-1||p===0||p===1&&o===n-1&&o===t+1?"":i.slice(o,n)},format:E.bind(null,"\\"),parse(i){v(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const o=i.length;let t=0,n=i.charCodeAt(0);if(o===1)return w(n)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(w(n)){if(t=1,w(i.charCodeAt(1))){let j=2,U=j;for(;j<o&&!w(i.charCodeAt(j));)j++;if(j<o&&j!==U){for(U=j;j<o&&w(i.charCodeAt(j));)j++;if(j<o&&j!==U){for(U=j;j<o&&!w(i.charCodeAt(j));)j++;j===o?t=j:j!==U&&(t=j+1)}}}}else if(h(n)&&i.charCodeAt(1)===$){if(o<=2)return a.root=a.dir=i,a;if(t=2,w(i.charCodeAt(2))){if(o===3)return a.root=a.dir=i,a;t=3}}t>0&&(a.root=i.slice(0,t));let r=-1,p=t,A=-1,C=!0,k=i.length-1,I=0;for(;k>=t;--k){if(n=i.charCodeAt(k),w(n)){if(!C){p=k+1;break}continue}A===-1&&(C=!1,A=k+1),n===P?r===-1?r=k:I!==1&&(I=1):r!==-1&&(I=-1)}return A!==-1&&(r===-1||I===0||I===1&&r===A-1&&r===p+1?a.base=a.name=i.slice(p,A):(a.name=i.slice(p,r),a.base=i.slice(p,A),a.ext=i.slice(r,A))),p>0&&p!==t?a.dir=i.slice(0,p-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(m){const i=/\\/g;return()=>{const a=S.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>S.cwd()})();e.$gc={resolve(...i){let a="",o=!1;for(let t=i.length-1;t>=-1&&!o;t--){const n=t>=0?i[t]:u();v(n,"path"),n.length!==0&&(a=`${n}/${a}`,o=n.charCodeAt(0)===f)}return a=l(a,!o,"/",d),o?`/${a}`:a.length>0?a:"."},normalize(i){if(v(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===f,o=i.charCodeAt(i.length-1)===f;return i=l(i,!a,"/",d),i.length===0?a?"/":o?"./":".":(o&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return v(i,"path"),i.length>0&&i.charCodeAt(0)===f},join(...i){if(i.length===0)return".";let a;for(let o=0;o<i.length;++o){const t=i[o];v(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.$gc.normalize(a)},relative(i,a){if(v(i,"from"),v(a,"to"),i===a||(i=e.$gc.resolve(i),a=e.$gc.resolve(a),i===a))return"";const o=1,t=i.length,n=t-o,r=1,p=a.length-r,A=n<p?n:p;let C=-1,k=0;for(;k<A;k++){const j=i.charCodeAt(o+k);if(j!==a.charCodeAt(r+k))break;j===f&&(C=k)}if(k===A)if(p>A){if(a.charCodeAt(r+k)===f)return a.slice(r+k+1);if(k===0)return a.slice(r+k)}else n>A&&(i.charCodeAt(o+k)===f?C=k:k===0&&(C=0));let I="";for(k=o+C+1;k<=t;++k)(k===t||i.charCodeAt(k)===f)&&(I+=I.length===0?"..":"/..");return`${I}${a.slice(r+C)}`},toNamespacedPath(i){return i},dirname(i){if(v(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===f;let o=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===f){if(!t){o=n;break}}else t=!1;return o===-1?a?"/":".":a&&o===1?"//":i.slice(0,o)},basename(i,a){a!==void 0&&v(a,"ext"),v(i,"path");let o=0,t=-1,n=!0,r;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let p=a.length-1,A=-1;for(r=i.length-1;r>=0;--r){const C=i.charCodeAt(r);if(C===f){if(!n){o=r+1;break}}else A===-1&&(n=!1,A=r+1),p>=0&&(C===a.charCodeAt(p)?--p===-1&&(t=r):(p=-1,t=A))}return o===t?t=A:t===-1&&(t=i.length),i.slice(o,t)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===f){if(!n){o=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":i.slice(o,t)},extname(i){v(i,"path");let a=-1,o=0,t=-1,n=!0,r=0;for(let p=i.length-1;p>=0;--p){const A=i.charCodeAt(p);if(A===f){if(!n){o=p+1;break}continue}t===-1&&(n=!1,t=p+1),A===P?a===-1?a=p:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||t===-1||r===0||r===1&&a===t-1&&a===o+1?"":i.slice(a,t)},format:E.bind(null,"/"),parse(i){v(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const o=i.charCodeAt(0)===f;let t;o?(a.root="/",t=1):t=0;let n=-1,r=0,p=-1,A=!0,C=i.length-1,k=0;for(;C>=t;--C){const I=i.charCodeAt(C);if(I===f){if(!A){r=C+1;break}continue}p===-1&&(A=!1,p=C+1),I===P?n===-1?n=C:k!==1&&(k=1):n!==-1&&(k=-1)}if(p!==-1){const I=r===0&&o?1:r;n===-1||k===0||k===1&&n===p-1&&n===r+1?a.base=a.name=i.slice(I,p):(a.name=i.slice(I,n),a.base=i.slice(I,p),a.ext=i.slice(n,p))}return r>0?a.dir=i.slice(0,r-1):o&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(ie[33],ne([0,1,9,4,27,12]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function D(r){return r===47||r===92}e.$Qf=D;function P(r){return r.replace(/[\\/]/g,S.$gc.sep)}e.$Rf=P;function f(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Sf=f;function c(r,p=S.$gc.sep){if(!r)return"";const A=r.length,C=r.charCodeAt(0);if(D(C)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let I=3;const j=I;for(;I<A&&!D(r.charCodeAt(I));I++);if(j!==I&&!D(r.charCodeAt(I+1))){for(I+=1;I<A;I++)if(D(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,p)}}return p}else if(d(C)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+p:r.slice(0,2);let k=r.indexOf("://");if(k!==-1){for(k+=3;k<A;k++)if(D(r.charCodeAt(k)))return r.slice(0,k+1)}return""}e.$Tf=c;function $(r){if(!R.$j||!r||r.length<5)return!1;let p=r.charCodeAt(0);if(p!==92||(p=r.charCodeAt(1),p!==92))return!1;let A=2;const C=A;for(;A<r.length&&(p=r.charCodeAt(A),p!==92);A++);return!(C===A||(p=r.charCodeAt(A+1),isNaN(p)||p===92))}e.$Uf=$;const b=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(r,p=R.$j){const A=p?b:y;return!(!r||r.length===0||/^\s+$/.test(r)||(A.lastIndex=0,A.test(r))||p&&g.test(r)||r==="."||r===".."||p&&r[r.length-1]==="."||p&&r.length!==r.trim().length||r.length>255)}e.$Vf=v;function m(r,p,A){const C=r===p;return!A||C?C:!r||!p?!1:(0,s.$2e)(r,p)}e.$Wf=m;function w(r,p,A,C=S.sep){if(r===p)return!0;if(!r||!p||p.length>r.length)return!1;if(A){if(!(0,s.$3e)(r,p))return!1;if(p.length===r.length)return!0;let I=p.length;return p.charAt(p.length-1)===C&&I--,r.charAt(I)===C}return p.charAt(p.length-1)!==C&&(p+=C),r.indexOf(p)===0}e.$Xf=w;function d(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Yf=d;function h(r,p){return R.$j&&r.endsWith(":")&&(r+=S.sep),(0,S.$ic)(r)||(r=(0,S.$jc)(p,r)),r=(0,S.$hc)(r),R.$j?(r=(0,s.$Ke)(r,S.sep),r.endsWith(":")&&(r+=S.sep)):(r=(0,s.$Ke)(r,S.sep),r||(r=S.sep)),r}e.$Zf=h;function l(r){const p=(0,S.$hc)(r);return R.$j?r.length>3?!1:E(p)&&(r.length===2||p.charCodeAt(2)===92):p===S.$gc.sep}e.$1f=l;function E(r,p=R.$j){return p?d(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$2f=E;function u(r,p=R.$j){return E(r,p)?r[0]:void 0}e.$3f=u;function i(r,p,A){return p.length>r.length?-1:r===p?0:(A&&(r=r.toLowerCase(),p=p.toLowerCase()),r.indexOf(p))}e.$4f=i;function a(r){const p=r.split(":");let A,C,k;for(const I of p){const j=Number(I);(0,O.$Cf)(j)?C===void 0?C=j:k===void 0&&(k=j):A=A?[A,I].join(":"):I}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:C!==void 0?C:void 0,column:k!==void 0?k:C!==void 0?1:void 0}}e.$5f=a;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(r,p,A=8){let C="";for(let I=0;I<A;I++){let j;I===0&&R.$j&&!p&&(A===3||A===4)?j=t:j=o,C+=j.charAt(Math.floor(Math.random()*j.length))}let k;return p?k=`${p}-${C}`:k=C,r?(0,S.$jc)(r,k):k}e.$6f=n}),define(ie[75],ne([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function O(P,...f){const c=f.reduce((y,g)=>(y[g]=!0,y),{}),$=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!c[y]).forEach(y=>{for(let g=0;g<$.length;g++)if(y.search($[g])!==-1){delete P[y];break}})}e.$zl=O;function D(P){P&&(delete P.DEBUG,S.$k&&delete P.DYLD_LIBRARY_PATH,S.$l&&delete P.LD_PRELOAD)}e.$Al=D}),define(ie[7],ne([0,1,9,4]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,O=/^\//,D=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!O.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(t,n){return!t&&!n?"file":t}function c(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const $="",b="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,r,p,A,C,k=!1){typeof n=="object"?(this.scheme=n.scheme||$,this.authority=n.authority||$,this.path=n.path||$,this.query=n.query||$,this.fragment=n.fragment||$):(this.scheme=f(n,k),this.authority=r||$,this.path=c(this.scheme,p||$),this.query=A||$,this.fragment=C||$,P(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:r,authority:p,path:A,query:C,fragment:k}=n;return r===void 0?r=this.scheme:r===null&&(r=$),p===void 0?p=this.authority:p===null&&(p=$),A===void 0?A=this.path:A===null&&(A=$),C===void 0?C=this.query:C===null&&(C=$),k===void 0?k=this.fragment:k===null&&(k=$),r===this.scheme&&p===this.authority&&A===this.path&&C===this.query&&k===this.fragment?this:new w(r,p,A,C,k)}static parse(n,r=!1){const p=y.exec(n);return p?new w(p[2]||$,o(p[4]||$),o(p[5]||$),o(p[7]||$),o(p[9]||$),r):new w($,$,$,$,$)}static file(n){let r=$;if(R.$j&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const p=n.indexOf(b,2);p===-1?(r=n.substring(2),n=b):(r=n.substring(2,p),n=n.substring(p)||b)}return new w("file",r,n,$,$)}static from(n,r){return new w(n.scheme,n.authority,n.path,n.query,n.fragment,r)}static joinPath(n,...r){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return R.$j&&n.scheme==="file"?p=g.file(S.$fc.join(E(n,!0),...r)).path:p=S.$gc.join(n.path,...r),n.with({path:p})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const r=new w(n);return r._formatted=n.external??null,r._fsPath=n._sep===m?n.fsPath??null:null,r}}else return n}}e.URI=g;function v(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$vc=v;const m=R.$j?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,n,r){let p,A=-1;for(let C=0;C<t.length;C++){const k=t.charCodeAt(C);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||r&&k===91||r&&k===93||r&&k===58)A!==-1&&(p+=encodeURIComponent(t.substring(A,C)),A=-1),p!==void 0&&(p+=t.charAt(C));else{p===void 0&&(p=t.substr(0,C));const I=d[k];I!==void 0?(A!==-1&&(p+=encodeURIComponent(t.substring(A,C)),A=-1),p+=I):A===-1&&(A=C)}}return A!==-1&&(p+=encodeURIComponent(t.substring(A))),p!==void 0?p:t}function l(t){let n;for(let r=0;r<t.length;r++){const p=t.charCodeAt(r);p===35||p===63?(n===void 0&&(n=t.substr(0,r)),n+=d[p]):n!==void 0&&(n+=t[r])}return n!==void 0?n:t}function E(t,n){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,R.$j&&(r=r.replace(/\//g,"\\")),r}e.$wc=E;function u(t,n){const r=n?l:h;let p="",{scheme:A,authority:C,path:k,query:I,fragment:j}=t;if(A&&(p+=A,p+=":"),(C||A==="file")&&(p+=b,p+=b),C){let U=C.indexOf("@");if(U!==-1){const z=C.substr(0,U);C=C.substr(U+1),U=z.lastIndexOf(":"),U===-1?p+=r(z,!1,!1):(p+=r(z.substr(0,U),!1,!1),p+=":",p+=r(z.substr(U+1),!1,!0)),p+="@"}C=C.toLowerCase(),U=C.lastIndexOf(":"),U===-1?p+=r(C,!1,!0):(p+=r(C.substr(0,U),!1,!0),p+=C.substr(U))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const U=k.charCodeAt(1);U>=65&&U<=90&&(k=`/${String.fromCharCode(U+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const U=k.charCodeAt(0);U>=65&&U<=90&&(k=`${String.fromCharCode(U+32)}:${k.substr(2)}`)}p+=r(k,!0,!1)}return I&&(p+="?",p+=r(I,!1,!1)),j&&(p+="#",p+=n?j:h(j,!1,!1)),p}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(a)?t.replace(a,n=>i(n)):t}}),define(ie[154],ne([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Zp=e.$Yp=e.$Xp=void 0;function R(c){const $=c;return $&&typeof $.type=="string"&&typeof $.severity=="string"}e.$Xp=R;function s(c){const $=[];let b;try{const y=JSON.parse(c.arguments),g=y[y.length-1];g&&g.__$stack&&(y.pop(),b=g.__$stack),$.push(...y)}catch{$.push("Unable to log remote console arguments",c.arguments)}return{args:$,stack:b}}e.$Yp=s;function O(c){if(typeof c!="string")return O(s(c).stack);const $=c;if($){const b=D($),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$Zp=O;function D(c){if(!c)return c;const $=c.indexOf(`
`);return $===-1?c:c.substring(0,$)}function P(c,$){const{args:b,stack:y}=s(c),g=typeof b[0]=="string"&&b.length===1;let v=D(y);v&&(v=`(${v.trim()})`);let m=[];if(typeof b[0]=="string"?v&&g?m=[`%c[${$}] %c${b[0]} %c${v}`,f("blue"),f(""),f("grey")]:m=[`%c[${$}] %c${b[0]}`,f("blue"),f(""),...b.slice(1)]:m=[`%c[${$}]%`,f("blue"),...b],v&&!g&&m.push(v),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,m)}e.log=P;function f(c){return`color: ${c}`}}),define(ie[76],ne([0,1,17,7]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function s(f){return JSON.stringify(f,D)}e.$kh=s;function O(f){let c=JSON.parse(f);return c=P(c),c}e.$lh=O;function D(f,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function P(f,c=0){if(!f||c>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$be||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let $=0;$<f.length;++$)f[$]=P(f[$],c+1);else for(const $ in f)Object.hasOwnProperty.call(f,$)&&(f[$]=P(f[$],c+1))}return f}e.$mh=P}),define(ie[13],ne([0,1,14,4,7]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var O;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$7f="vscode-tkn",e.$8f="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${O.vscodeRemoteResource}`}set($,b,y){this.a[$]=b,this.b[$]=y}setConnectionToken($,b){this.c[$]=b}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(w){return S.$1(w),$}const b=$.authority;let y=this.a[b];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const g=this.b[b],v=this.c[b];let m=`path=${encodeURIComponent($.path)}`;return typeof v=="string"&&(m+=`&${e.$8f}=${encodeURIComponent(v)}`),s.URI.from({scheme:R.$p?this.d:O.vscodeRemoteResource,authority:`${y}:${g}`,path:this.f,query:m})}}e.$9f=new D,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class P{static{this.a=e.$bg}asBrowserUri($){const b=this.b($,J);return this.uriToBrowserUri(b)}uriToBrowserUri($){return $.scheme===O.vscodeRemote?e.$9f.rewrite($):$.scheme===O.file&&(R.$n||R.$q&&R.$h.origin===`${O.vscodeFileResource}://${P.a}`)?$.with({scheme:O.vscodeFileResource,authority:$.authority||P.a,query:null,fragment:null}):$}asFileUri($){const b=this.b($,J);return this.uriToFileUri(b)}uriToFileUri($){return $.scheme===O.vscodeFileResource?$.with({scheme:O.file,authority:$.authority!==P.a?$.authority:null,query:null,fragment:null}):$}b($,b){return s.URI.isUri($)?$:s.URI.parse(b.toUrl($))}}e.$cg=new P;var f;(function(c){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze($.get("3"));const b="vscode-coi";function y(v){let m;typeof v=="string"?m=new URL(v).searchParams:v instanceof URL?m=v.searchParams:s.URI.isUri(v)&&(m=new URL(v.toString(!0)).searchParams);const w=m?.get(b);if(w)return $.get(w)}c.getHeadersFromQuery=y;function g(v,m,w){if(!globalThis.crossOriginIsolated)return;const d=m&&w?"3":w?"2":"1";v instanceof URLSearchParams?v.set(b,d):v[b]=d}c.addSearchParam=g})(f||(e.COI=f={}))}),define(ie[19],ne([0,1,33,13,9,4,27,7]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function f(g){return(0,P.$wc)(g,!0)}e.$jg=f;class c{constructor(v){this.a=v}compare(v,m,w=!1){return v===m?0:(0,D.$Ue)(this.getComparisonKey(v,w),this.getComparisonKey(m,w))}isEqual(v,m,w=!1){return v===m?!0:!v||!m?!1:this.getComparisonKey(v,w)===this.getComparisonKey(m,w)}getComparisonKey(v,m=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,m,w=!1){if(v.scheme===m.scheme){if(v.scheme===R.Schemas.file)return S.$Xf(f(v),f(m),this.a(v))&&v.query===m.query&&(w||v.fragment===m.fragment);if((0,e.$Ag)(v.authority,m.authority))return S.$Xf(v.path,m.path,this.a(v),"/")&&v.query===m.query&&(w||v.fragment===m.fragment)}return!1}joinPath(v,...m){return P.URI.joinPath(v,...m)}basenameOrAuthority(v){return(0,e.$sg)(v)||v.authority}basename(v){return s.$gc.basename(v.path)}extname(v){return s.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let m;return v.scheme===R.Schemas.file?m=P.URI.file(s.$mc(f(v))).path:(m=s.$gc.dirname(v.path),v.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),m="/")),v.with({path:m})}normalizePath(v){if(!v.path.length)return v;let m;return v.scheme===R.Schemas.file?m=P.URI.file(s.$hc(f(v))).path:m=s.$gc.normalize(v.path),v.with({path:m})}relativePath(v,m){if(v.scheme!==m.scheme||!(0,e.$Ag)(v.authority,m.authority))return;if(v.scheme===R.Schemas.file){const h=s.$lc(f(v),f(m));return O.$j?S.$Rf(h):h}let w=v.path||"/";const d=m.path||"/";if(this.a(v)){let h=0;for(const l=Math.min(w.length,d.length);h<l&&!(w.charCodeAt(h)!==d.charCodeAt(h)&&w.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);w=d.substr(0,h)+w.substr(h)}return s.$gc.relative(w,d)}resolvePath(v,m){if(v.scheme===R.Schemas.file){const w=P.URI.file(s.$kc(f(v),m));return v.with({authority:w.authority,path:w.path})}return m=S.$Sf(m),v.with({path:s.$gc.resolve(v.path,m)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,m){return v===m||v!==void 0&&m!==void 0&&(0,D.$2e)(v,m)}hasTrailingPathSeparator(v,m=s.sep){if(v.scheme===R.Schemas.file){const w=f(v);return w.length>S.$Tf(w).length&&w[w.length-1]===m}else{const w=v.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,m=s.sep){return(0,e.$Bg)(v,m)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,m=s.sep){let w=!1;if(v.scheme===R.Schemas.file){const d=f(v);w=d!==void 0&&d.length===S.$Tf(d).length&&d[d.length-1]===m}else{m="/";const d=v.path;w=d.length===1&&d.charCodeAt(d.length-1)===47}return!w&&!(0,e.$Bg)(v,m)?v.with({path:v.path+"/"}):v}}e.$kg=c,e.$lg=new c(()=>!1),e.$mg=new c(g=>g.scheme===R.Schemas.file?!O.$l:!0),e.$ng=new c(g=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function $(g,v){const m=[];for(let w=0;w<g.length;w++){const d=v(g[w]);g.some((h,l)=>l===w?!1:(0,e.$pg)(d,v(h)))||m.push(g[w])}return m}e.$Eg=$;var b;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function v(m){const w=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(l=>{const[E,u]=l.split(":");E&&u&&w.set(E,u)});const h=m.path.substring(0,m.path.indexOf(";"));return h&&w.set(g.META_DATA_MIME,h),w}g.parseMetaData=v})(b||(e.DataUri=b={}));function y(g,v,m){if(v){let w=g.path;return w&&w[0]!==s.$gc.sep&&(w=s.$gc.sep+w),g.with({scheme:m,authority:v,path:w})}return g.with({scheme:m})}e.$Fg=y}),define(ie[8],ne([0,1,22,14,3,2,19,4,143]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function c(F){return!!F&&typeof F.then=="function"}e.$Gg=c;function $(F){const T=new S.$Xd,N=F(T.token),B=new Promise((V,oe)=>{const de=T.token.onCancellationRequested(()=>{de.dispose(),T.dispose(),oe(new R.$5)});Promise.resolve(N).then(ue=>{de.dispose(),T.dispose(),V(ue)},ue=>{de.dispose(),T.dispose(),oe(ue)})});return new class{cancel(){T.cancel()}then(V,oe){return B.then(V,oe)}catch(V){return this.then(void 0,V)}finally(V){return B.finally(V)}}}e.$Hg=$;function b(F,T,N){return new Promise((B,V)=>{const oe=T.onCancellationRequested(()=>{oe.dispose(),B(N)});F.then(B,V).finally(()=>oe.dispose())})}e.$Ig=b;function y(F,T){return new Promise((N,B)=>{const V=T.onCancellationRequested(()=>{V.dispose(),B(new R.$5)});F.then(N,B).finally(()=>V.dispose())})}e.$Jg=y;async function g(F){let T=-1;const N=F.map((B,V)=>B.then(oe=>(T=V,oe)));try{return await Promise.race(N)}finally{F.forEach((B,V)=>{V!==T&&B.cancel()})}}e.$Kg=g;function v(F,T,N){let B;const V=setTimeout(()=>{B?.(void 0),N?.()},T);return Promise.race([F.finally(()=>clearTimeout(V)),new Promise(oe=>B=oe)])}e.$Lg=v;function m(F){return new Promise((T,N)=>{const B=F();c(B)?B.then(T,N):T(B)})}e.$Mg=m;class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const N=()=>{if(this.b=null,this.f)return;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(N,N).then(B)})}return new Promise((N,B)=>{this.b.then(N,B)})}return this.a=T(),new Promise((N,B)=>{this.a.then(V=>{this.a=null,N(V)},V=>{this.a=null,B(V)})})}dispose(){this.f=!0}}e.$Ng=w;class d{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$Og=d;class h{constructor(){this.a=new Map}queue(T,N){const V=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(T)===V&&this.a.delete(T)});return this.a.set(T,V),V}}e.$Pg=h;const l=(F,T)=>{let N=!0;const B=setTimeout(()=>{N=!1,T()},F);return{isTriggered:()=>N,dispose:()=>{clearTimeout(B),N=!1}}},E=F=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,F())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class u{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,N=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((V,oe)=>{this.d=V,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const V=this.g;return this.g=null,V()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=N===f.$Kd?E(B):l(N,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=u;class i{constructor(T){this.a=new u(T),this.b=new w}trigger(T,N){return this.a.trigger(()=>this.b.queue(T),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=i;class a{constructor(){this.a=!1,this.b=new Promise((T,N)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=a;class o extends a{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$Tg=o;function t(F,T){return T?new Promise((N,B)=>{const V=setTimeout(()=>{oe.dispose(),N()},F),oe=T.onCancellationRequested(()=>{clearTimeout(V),oe.dispose(),B(new R.$5)})}):$(N=>t(F,N))}e.$Ug=t;function n(F,T=0,N){const B=setTimeout(()=>{F(),N&&V.dispose()},T),V=(0,O.$Qc)(()=>{clearTimeout(B),N?.deleteAndLeak(V)});return N?.add(V),V}e.$Vg=n;function r(F){const T=[];let N=0;const B=F.length;function V(){return N<B?F[N++]():null}function oe(de){de!=null&&T.push(de);const ue=V();return ue?ue.then(oe):Promise.resolve(T)}return Promise.resolve(null).then(oe)}e.$Wg=r;function p(F,T=B=>!!B,N=null){let B=0;const V=F.length,oe=()=>{if(B>=V)return Promise.resolve(N);const de=F[B++];return Promise.resolve(de()).then(he=>T(he)?Promise.resolve(he):oe())};return oe()}e.$Xg=p;function A(F,T=B=>!!B,N=null){if(F.length===0)return Promise.resolve(N);let B=F.length;const V=()=>{B=-1;for(const oe of F)oe.cancel?.()};return new Promise((oe,de)=>{for(const ue of F)ue.then(he=>{--B>=0&&T(he)?(V(),oe(he)):B===0&&oe(N)}).catch(he=>{--B>=0&&(V(),de(he))})})}e.$Yg=A;class C{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new s.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((N,B)=>{this.f.push({factory:T,c:N,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const N=T.factory();N.then(T.c,T.e),N.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=C;class k extends C{constructor(){super(1)}}e.$1g=k;class I{constructor(){this.a=new Q,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$2g=I;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new W;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,N=D.$lg){const B=N.getComparisonKey(T);let V=this.a.get(B);if(!V){V=new k;const oe=this.f++,de=s.Event.once(V.onDrained)(()=>{V?.dispose(),this.a.delete(B),this.h(),this.d?.deleteAndDispose(oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$1c),this.d.set(oe,de),this.a.set(B,V)}return V}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=j;class U{constructor(T,N){this.a=-1,typeof T=="function"&&typeof N=="number"&&this.setIfNotSet(T,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},N)}setIfNotSet(T,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},N))}}e.$4g=U;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,N){this.cancel(),this.a=setInterval(()=>{T()},N)}}e.$5g=z;class x{constructor(T,N){this.b=-1,this.a=T,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=x;class X{constructor(T,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=T,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=X;class ae extends x{constructor(T,N){super(T,N),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$8g=ae;class se extends O.$Sc{constructor(T,N){super(),this.g=T,this.h=N,this.a=[],this.b=this.B(new O.$Tc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const N of T)this.a.push(N);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=F=>{(0,P.$B)(()=>{if(T)return;const N=Date.now()+15;F(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$0g=(F,T)=>{const N=requestIdleCallback(F,typeof T=="number"?{timeout:T}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(N))}}}}();class ce{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(N){this.g=N}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=ce;async function Z(F,T,N){let B;for(let V=0;V<N;V++)try{return await F()}catch(oe){B=oe,await t(T)}throw B}e.$_g=Z;class Q{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,N,B){return this.a={taskId:T,cancel:()=>B?.(),promise:N},N.then(()=>this.d(T),()=>this.d(T)),N}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{let N,B;const V=new Promise((oe,de)=>{N=oe,B=de});this.b={run:T,promise:V,promiseResolve:N,promiseReject:B}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Q;class K{constructor(T,N=()=>Date.now()){this.d=T,this.f=N,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$bh=K;var q;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(q||(q={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,N)=>{this.a=T,this.b=N})}complete(T){return new Promise(N=>{this.a(T),this.d={outcome:0,value:T},N()})}error(T){return new Promise(N=>{this.b(T),this.d={outcome:1,value:T},N()})}cancel(){return this.error(new R.$5)}}e.$ch=W;var G;(function(F){async function T(B){let V;const oe=await Promise.all(B.map(de=>de.then(ue=>ue,ue=>{V||(V=ue)})));if(typeof V<"u")throw V;return oe}F.settled=T;function N(B){return new Promise(async(V,oe)=>{try{await B(V,oe)}catch(de){oe(de)}})}F.withAsyncBody=N})(G||(e.Promises=G={}));var H;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(H||(H={}));class Y{static fromArray(T){return new Y(N=>{N.emitMany(T)})}static fromPromise(T){return new Y(async N=>{N.emitMany(await T)})}static fromPromises(T){return new Y(async N=>{await Promise.all(T.map(async B=>N.emitOne(await B)))})}static merge(T){return new Y(async N=>{await Promise.all(T.map(async B=>{for await(const V of B)N.emitOne(V)}))})}static{this.EMPTY=Y.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new s.$Nd,queueMicrotask(async()=>{const N={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(T(N)),this.j()}catch(B){this.k(B)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(T,N){return new Y(async B=>{for await(const V of T)B.emitOne(N(V))})}map(T){return Y.map(this,T)}static filter(T,N){return new Y(async B=>{for await(const V of T)N(V)&&B.emitOne(V)})}filter(T){return Y.filter(this,T)}static coalesce(T){return Y.filter(T,N=>!!N)}coalesce(){return Y.coalesce(this)}static async toPromise(T){const N=[];for await(const B of T)N.push(B);return N}toPromise(){return Y.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$dh=Y;class re extends Y{constructor(T,N){super(N),this.l=T}cancel(){this.l.cancel()}}e.$eh=re;function L(F){const T=new S.$Xd,N=F(T.token);return new re(T,async B=>{const V=T.token.onCancellationRequested(()=>{V.dispose(),T.dispose(),B.reject(new R.$5)});try{for await(const oe of N){if(T.token.isCancellationRequested)return;B.emitOne(oe)}V.dispose(),T.dispose()}catch(oe){V.dispose(),T.dispose(),B.reject(oe)}})}e.$fh=L;class M{constructor(){this.a=new W,this.b=new Y(B=>{if(T){B.reject(T);return}return N&&B.emitMany(N),this.d=V=>B.reject(V),this.f=V=>B.emitOne(V),this.a.p});let T,N;this.f=B=>{N||(N=[]),N.push(B)},this.d=B=>{T||(T=B)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$gh=M}),define(ie[104],ne([0,1,23,8,33,31,9,4,27]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function c(){return Object.create(null)}e.$rj=c,e.$sj="**",e.$tj="/";const $="[/\\\\]",b="[^/\\\\]",y=/\//g;function g(Q,K){switch(Q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${$}|${b}+${$}${K?`|${$}${b}+`:""})*?`}}function v(Q,K){if(!Q)return[];const q=[];let W=!1,G=!1,H="";for(const Y of Q){switch(Y){case K:if(!W&&!G){q.push(H),H="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":G=!0;break;case"]":G=!1;break}H+=Y}return H&&q.push(H),q}e.$uj=v;function m(Q){if(!Q)return"";let K="";const q=v(Q,e.$tj);if(q.every(W=>W===e.$sj))K=".*";else{let W=!1;q.forEach((G,H)=>{if(G===e.$sj){if(W)return;K+=g(2,H===q.length-1)}else{let Y=!1,re="",L=!1,M="";for(const F of G){if(F!=="}"&&Y){re+=F;continue}if(L&&(F!=="]"||!M)){let T;F==="-"?T=F:(F==="^"||F==="!")&&!M?T="^":F===e.$tj?T="":T=(0,f.$Fe)(F),M+=T;continue}switch(F){case"{":Y=!0;continue;case"[":L=!0;continue;case"}":{const N=`(?:${v(re,",").map(B=>m(B)).join("|")})`;K+=N,Y=!1,re="";break}case"]":{K+="["+M+"]",L=!1,M="";break}case"?":K+=b;continue;case"*":K+=g(1);continue;default:K+=(0,f.$Fe)(F)}}H<q.length-1&&(q[H+1]!==e.$sj||H+2<q.length)&&(K+=$)}W=G===e.$sj})}return K}const w=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Dc(1e4),a=function(){return!1},o=function(){return null};function t(Q,K){if(!Q)return o;let q;typeof Q!="string"?q=Q.pattern:q=Q,q=q.trim();const W=`${q}_${!!K.trimForExclusions}`;let G=i.get(W);if(G)return n(G,Q);let H;return w.test(q)?G=p(q.substr(4),q):(H=d.exec(r(q,K)))?G=A(H[1],q):(K.trimForExclusions?l:h).test(q)?G=C(q,K):(H=E.exec(r(q,K)))?G=k(H[1].substr(1),q,!0):(H=u.exec(r(q,K)))?G=k(H[1],q,!1):G=I(q),i.set(W,G),n(G,Q)}function n(Q,K){if(typeof K=="string")return Q;const q=function(W,G){return(0,s.$Xf)(W,K.base,!P.$l)?Q((0,f.$Je)(W.substr(K.base.length),D.sep),G):null};return q.allBasenames=Q.allBasenames,q.allPaths=Q.allPaths,q.basenames=Q.basenames,q.patterns=Q.patterns,q}function r(Q,K){return K.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function p(Q,K){return function(q,W){return typeof q=="string"&&q.endsWith(Q)?K:null}}function A(Q,K){const q=`/${Q}`,W=`\\${Q}`,G=function(Y,re){return typeof Y!="string"?null:re?re===Q?K:null:Y===Q||Y.endsWith(q)||Y.endsWith(W)?K:null},H=[Q];return G.basenames=H,G.patterns=[K],G.allBasenames=H,G}function C(Q,K){const q=ce(Q.slice(1,-1).split(",").map(re=>t(re,K)).filter(re=>re!==o),Q),W=q.length;if(!W)return o;if(W===1)return q[0];const G=function(re,L){for(let M=0,F=q.length;M<F;M++)if(q[M](re,L))return Q;return null},H=q.find(re=>!!re.allBasenames);H&&(G.allBasenames=H.allBasenames);const Y=q.reduce((re,L)=>L.allPaths?re.concat(L.allPaths):re,[]);return Y.length&&(G.allPaths=Y),G}function k(Q,K,q){const W=D.sep===D.$gc.sep,G=W?Q:Q.replace(y,D.sep),H=D.sep+G,Y=D.$gc.sep+Q;let re;return q?re=function(L,M){return typeof L=="string"&&(L===G||L.endsWith(H)||!W&&(L===Q||L.endsWith(Y)))?K:null}:re=function(L,M){return typeof L=="string"&&(L===G||!W&&L===Q)?K:null},re.allPaths=[(q?"*/":"./")+Q],re}function I(Q){try{const K=new RegExp(`^${m(Q)}$`);return function(q){return K.lastIndex=0,typeof q=="string"&&K.test(q)?Q:null}}catch{return o}}function j(Q,K,q){return!Q||typeof K!="string"?!1:U(Q)(K,void 0,q)}e.$vj=j;function U(Q,K={}){if(!Q)return a;if(typeof Q=="string"||z(Q)){const q=t(Q,K);if(q===o)return a;const W=function(G,H){return!!q(G,H)};return q.allBasenames&&(W.allBasenames=q.allBasenames),q.allPaths&&(W.allPaths=q.allPaths),W}return ae(Q,K)}e.$wj=U;function z(Q){const K=Q;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.$xj=z;function x(Q){return Q.allBasenames||[]}e.$yj=x;function X(Q){return Q.allPaths||[]}e.$zj=X;function ae(Q,K){const q=ce(Object.getOwnPropertyNames(Q).map(re=>se(re,Q[re],K)).filter(re=>re!==o)),W=q.length;if(!W)return o;if(!q.some(re=>!!re.requiresSiblings)){if(W===1)return q[0];const re=function(F,T){let N;for(let B=0,V=q.length;B<V;B++){const oe=q[B](F,T);if(typeof oe=="string")return oe;(0,R.$Gg)(oe)&&(N||(N=[]),N.push(oe))}return N?(async()=>{for(const B of N){const V=await B;if(typeof V=="string")return V}return null})():null},L=q.find(F=>!!F.allBasenames);L&&(re.allBasenames=L.allBasenames);const M=q.reduce((F,T)=>T.allPaths?F.concat(T.allPaths):F,[]);return M.length&&(re.allPaths=M),re}const G=function(re,L,M){let F,T;for(let N=0,B=q.length;N<B;N++){const V=q[N];V.requiresSiblings&&M&&(L||(L=(0,D.$nc)(re)),F||(F=L.substr(0,L.length-(0,D.$oc)(re).length)));const oe=V(re,L,F,M);if(typeof oe=="string")return oe;(0,R.$Gg)(oe)&&(T||(T=[]),T.push(oe))}return T?(async()=>{for(const N of T){const B=await N;if(typeof B=="string")return B}return null})():null},H=q.find(re=>!!re.allBasenames);H&&(G.allBasenames=H.allBasenames);const Y=q.reduce((re,L)=>L.allPaths?re.concat(L.allPaths):re,[]);return Y.length&&(G.allPaths=Y),G}function se(Q,K,q){if(K===!1)return o;const W=t(Q,q);if(W===o)return o;if(typeof K=="boolean")return W;if(K){const G=K.when;if(typeof G=="string"){const H=(Y,re,L,M)=>{if(!M||!W(Y,re))return null;const F=G.replace("$(basename)",()=>L),T=M(F);return(0,R.$Gg)(T)?T.then(N=>N?Q:null):T?Q:null};return H.requiresSiblings=!0,H}}return W}function ce(Q,K){const q=Q.filter(re=>!!re.basenames);if(q.length<2)return Q;const W=q.reduce((re,L)=>{const M=L.basenames;return M?re.concat(M):re},[]);let G;if(K){G=[];for(let re=0,L=W.length;re<L;re++)G.push(K)}else G=q.reduce((re,L)=>{const M=L.patterns;return M?re.concat(M):re},[]);const H=function(re,L){if(typeof re!="string")return null;if(!L){let F;for(F=re.length;F>0;F--){const T=re.charCodeAt(F-1);if(T===47||T===92)break}L=re.substr(F)}const M=W.indexOf(L);return M!==-1?G[M]:null};H.basenames=W,H.patterns=G,H.allBasenames=W;const Y=Q.filter(re=>!re.basenames);return Y.push(H),Y}function Z(Q,K){return(0,S.$ub)(Q,K,(q,W)=>typeof q=="string"&&typeof W=="string"?q===W:typeof q!="string"&&typeof W!="string"?q.base===W.base&&q.pattern===W.pattern:!1)}e.$Aj=Z}),define(ie[46],ne([0,1,23,33,9,4,19,27]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function f(t,n){const{os:r,tildify:p,relative:A}=n;if(A){const I=c(t,A,r);if(typeof I=="string")return I}let C=t.fsPath;if(r===1&&!O.$j?C=C.replace(/\//g,"\\"):r!==1&&O.$j&&(C=C.replace(/\\/g,"/")),r!==1&&p?.userHome){const I=p.userHome.fsPath;let j;t.scheme!==p.userHome.scheme&&t.path.startsWith(s.$gc.sep)?j=p.userHome.with({path:t.path}).fsPath:j=t.fsPath,C=y(j,I,r)}return(r===1?s.$fc:s.$gc).normalize($(C,r===1))}e.$rv=f;function c(t,n,r){const p=r===1?s.$fc:s.$gc,A=r===3?D.$lg:D.$ng,C=n.getWorkspace(),k=(0,S.$Ob)(C.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path.startsWith(s.$gc.sep)&&(t=k.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let j;if(A.isEqual(I.uri,t)?j="":j=A.relativePath(I.uri,t)??"",j&&(j=p.normalize(j)),C.folders.length>1&&!n.noPrefix){const U=I.name?I.name:A.basenameOrAuthority(I.uri);j=j?`${U} \u2022 ${j}`:U}return j}function $(t,n=O.$j){return(0,R.$2f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$sv=$;let b=Object.create(null);function y(t,n,r=O.OS){if(r===1||!t||!n)return t;let p=b.original===n?b.normalized:void 0;p||(p=n,O.$j&&(p=(0,R.$Rf)(p)),p=`${(0,P.$Ke)(p,s.$gc.sep)}${s.$gc.sep}`,b={original:n,normalized:p});let A=t;return O.$j&&(A=(0,R.$Rf)(A)),(r===3?A.startsWith(p):(0,P.$3e)(A,p))?`~/${A.substr(p.length)}`:t}e.$tv=y;function g(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$uv=g;const v="\u2026",m="\\\\",w="~";function d(t,n=s.sep){const r=new Array(t.length);let p=!1;for(let A=0;A<t.length;A++){const C=t[A];if(C===""){r[A]=`.${n}`;continue}if(!C){r[A]=C;continue}p=!0;let k="",I=C;I.indexOf(m)===0?(k=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(w)===0&&(k=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length));const j=I.split(n);for(let U=1;p&&U<=j.length;U++)for(let z=j.length-U;p&&z>=0;z--){p=!1;let x=j.slice(z,z+U).join(n);for(let X=0;!p&&X<t.length;X++)if(X!==A&&t[X]&&t[X].indexOf(x)>-1){const ae=z+U===j.length,se=z>0&&t[X].indexOf(n)>-1?n+x:x,ce=t[X].endsWith(se);p=!ae||ce}if(!p){let X="";(j[0].endsWith(":")||k!=="")&&(z===1&&(z=0,U++,x=j[0]+n+x),z>0&&(X=j[0]+n),X=k+X),z>0&&(X=X+v+n),X=X+x,z+U<j.length&&(X=X+n+v),r[A]=X}}p&&(r[A]=C)}return r}e.$vv=d;var h;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function l(t,n=Object.create(null)){const r=[];let p=!1,A="";for(const C of t)if(C==="$"||p&&C==="{")A&&r.push({value:A,type:h.TEXT}),A="",p=!0;else if(C==="}"&&p){const k=n[A];if(typeof k=="string")k.length&&r.push({value:k,type:h.VARIABLE});else if(k){const I=r[r.length-1];(!I||I.type!==h.SEPARATOR)&&r.push({value:k.label,type:h.SEPARATOR})}A="",p=!1}else A+=C;return A&&!p&&r.push({value:A,type:h.TEXT}),r.filter((C,k)=>{if(C.type===h.SEPARATOR){const I=r[k-1],j=r[k+1];return[I,j].every(U=>U&&(U.type===h.VARIABLE||U.type===h.TEXT)&&U.value.length>0)}return!0}).map(C=>C.value).join("")}e.$wv=l;function E(t,n){return O.$k||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):t.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.$xv=E;function u(t,n){return O.$k||n?t.replace(/\(&&\w\)|&&/g,""):O.$j?t.replace(/&&|&/g,r=>r==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$yv=u;function i(t){return t.replace(/&/g,"&&")}e.$zv=i;function a(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const r=o(t.substring(0,n));return{name:r.name,parentPath:r.parentPath+t.substring(n)}}}return o(t)}e.$Av=a;function o(t){const n=t.indexOf("/")!==-1?s.$gc:s.$fc,r=n.basename(t),p=n.dirname(t);return r.length?{name:r,parentPath:p}:{name:p,parentPath:""}}}),define(ie[155],ne([0,1,17,7]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function s(b){return b.toJSON()}class O{constructor(y){this.a=y}transformIncoming(y){const g=this.a.transformIncoming(y);return g===y?y:s(R.URI.from(g))}transformOutgoing(y){const g=this.a.transformOutgoing(y);return g===y?y:s(R.URI.from(g))}transformOutgoingURI(y){const g=this.a.transformOutgoing(y);return g===y?y:R.URI.from(g)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Lm=O,e.$Mm=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function D(b,y,g){if(!b||g>200)return null;if(typeof b=="object"){if(b instanceof R.URI)return y.transformOutgoing(b);for(const v in b)if(Object.hasOwnProperty.call(b,v)){const m=D(b[v],y,g+1);m!==null&&(b[v]=m)}}return null}function P(b,y){const g=D(b,y,0);return g===null?b:g}e.$Nm=P;function f(b,y,g,v){if(!b||v>200)return null;if(typeof b=="object"){if(b.$mid===1)return g?R.URI.revive(y.transformIncoming(b)):y.transformIncoming(b);if(b instanceof S.$be)return null;for(const m in b)if(Object.hasOwnProperty.call(b,m)){const w=f(b[m],y,g,v+1);w!==null&&(b[m]=w)}}return null}function c(b,y){const g=f(b,y,!1,0);return g===null?b:g}e.$Om=c;function $(b,y){const g=f(b,y,!0,0);return g===null?b:g}e.$Pm=$}),define(ie[87],ne([0,1,28,56,32,145,4]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=void 0,e.$Rm=new class{c(y){return this.a||(this.a=R.$Vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,g=0;const v=(0,S.networkInterfaces)();for(const m in v){const w=v[m];if(w)for(const{mac:d,internal:h}of w)h||(g+=1,this.c(d.toUpperCase())&&(y+=1))}this.b=g>0?y/g:0}return this.b}};let P;async function f(y){return P||(P=(async()=>await c(y)||s.$eg())()),P}e.$Sm=f;async function c(y){try{const g=await new Promise((m,w)=>{J(["crypto"],m,w)}),v=(0,O.$Qm)();return g.createHash("sha256").update(v,"utf8").digest("hex")}catch(g){y(g);return}}const $="Software\\Microsoft\\SQMClient";async function b(y){if(D.$j){const g=await new Promise((v,m)=>{J(["@vscode/windows-registry"],v,m)});try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",$,"MachineId")||""}catch(v){return y(v),""}}return""}e.$Tm=b}),define(ie[21],ne([0,1,45,28,156,8,33,84,9,4,19,7]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function g(se,ce=y.UNLINK,Z){if((0,D.$1f)(se))throw new Error("rimraf - will refuse to recursively delete root");return ce===y.UNLINK?m(se):v(se,Z)}async function v(se,ce=(0,D.$6f)((0,R.tmpdir)())){try{try{await S.promises.rename(se,ce)}catch(Z){return Z.code==="ENOENT"?void 0:m(se)}m(ce).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function m(se){return(0,s.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,D.$1f)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function d(se,ce){return E(await(ce?h(se):(0,s.promisify)(S.readdir)(se)))}async function h(se){try{return await(0,s.promisify)(S.readdir)(se,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const ce=[],Z=await d(se);for(const Q of Z){let K=!1,q=!1,W=!1;try{const G=await e.Promises.lstat((0,f.$jc)(se,Q));K=G.isFile(),q=G.isDirectory(),W=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ce.push({name:Q,isFile:()=>K,isDirectory:()=>q,isSymbolicLink:()=>W})}return ce}function l(se){return E(S.readdirSync(se))}e.readdirSync=l;function E(se){return se.map(ce=>typeof ce=="string"?c.$k?(0,P.$ol)(ce):ce:(ce.name=c.$k?(0,P.$ol)(ce.name):ce.name,ce))}async function u(se){const ce=await d(se),Z=[];for(const Q of ce)await a.existsDirectory((0,f.$jc)(se,Q))&&Z.push(Q);return Z}function i(se,ce=1e3){return new Promise(Z=>{let Q=!1;const K=setInterval(()=>{Q||(Q=!0,S.access(se,q=>{Q=!1,q&&(clearInterval(K),Z(void 0))}))},ce)})}e.whenDeleted=i;var a;(function(se){async function ce(K){let q;try{if(q=await e.Promises.lstat(K),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(c.$j&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw G}throw W}}se.stat=ce;async function Z(K){try{const{stat:q,symbolicLink:W}=await se.stat(K);return q.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=Z;async function Q(K){try{const{stat:q,symbolicLink:W}=await se.stat(K);return q.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=Q})(a||(e.SymlinkSupport=a={}));const o=new O.$3g;function t(se,ce,Z){return o.queueFor(b.URI.file(se),$.$mg).queue(()=>{const Q=C(Z);return new Promise((K,q)=>p(se,ce,Q,W=>W?q(W):K()))})}let n=!0;function r(se){n=se}e.configureFlushOnWrite=r;function p(se,ce,Z,Q){if(!n)return S.writeFile(se,ce,{mode:Z.mode,flag:Z.flag},Q);S.open(se,Z.flag,Z.mode,(K,q)=>{if(K)return Q(K);S.writeFile(q,ce,W=>{if(W)return S.close(q,()=>Q(W));S.fdatasync(q,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),r(!1)),S.close(q,H=>Q(H))))})})}function A(se,ce,Z){const Q=C(Z);if(!n)return S.writeFileSync(se,ce,{mode:Q.mode,flag:Q.flag});const K=S.openSync(se,Q.flag,Q.mode);try{S.writeFileSync(K,ce);try{S.fdatasyncSync(K)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{S.closeSync(K)}}e.writeFileSync=A;function C(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function k(se,ce,Z=6e4){if(se!==ce)try{c.$j&&typeof Z=="number"?await I(se,ce,Date.now(),Z):await(0,s.promisify)(S.rename)(se,ce)}catch(Q){if(se.toLowerCase()!==ce.toLowerCase()&&Q.code==="EXDEV"||se.endsWith("."))await j(se,ce,{preserveSymlinks:!1}),await g(se,y.MOVE);else throw Q}}async function I(se,ce,Z,Q,K=0){try{return await(0,s.promisify)(S.rename)(se,ce)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-Z>=Q)throw console.error(`[node.js fs] rename failed after ${K} retries with error: ${q}`),q;if(K===0){let W=!1;try{const{stat:G}=await a.stat(ce);G.isFile()||(W=!0)}catch{}if(W)throw q}return await(0,O.$Ug)(Math.min(100,K*10)),I(se,ce,Z,Q,K+1)}}async function j(se,ce,Z){return z(se,ce,{root:{source:se,target:ce},options:Z,handledSourcePaths:new Set})}const U=511;async function z(se,ce,Z){if(Z.handledSourcePaths.has(se))return;Z.handledSourcePaths.add(se);const{stat:Q,symbolicLink:K}=await a.stat(se);if(K){if(Z.options.preserveSymlinks)try{return await ae(se,ce,Z)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(K.dangling)return}return Q.isDirectory()?x(se,ce,Q.mode&U,Z):X(se,ce,Q.mode&U)}async function x(se,ce,Z,Q){await e.Promises.mkdir(ce,{recursive:!0,mode:Z});const K=await d(se);for(const q of K)await z((0,f.$jc)(se,q),(0,f.$jc)(ce,q),Q)}async function X(se,ce,Z){await e.Promises.copyFile(se,ce),await e.Promises.chmod(ce,Z)}async function ae(se,ce,Z){let Q=await e.Promises.readlink(se);(0,D.$Xf)(Q,Z.root.source,!c.$l)&&(Q=(0,f.$jc)(Z.root.target,Q.substr(Z.root.source.length+1))),await e.Promises.symlink(Q,ce)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(se,ce,Z,Q,K)=>new Promise((q,W)=>{S.read(se,ce,Z,Q,K,(G,H,Y)=>G?W(G):q({bytesRead:H,buffer:Y}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(se,ce,Z,Q,K)=>new Promise((q,W)=>{S.write(se,ce,Z,Q,K,(G,H,Y)=>G?W(G):q({bytesWritten:H,buffer:Y}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return g}get rename(){return k}get copy(){return j}}}),define(ie[105],ne([0,1,45,9,4,27,21]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=void 0;function P(y){if(s.$l)return y;const g=(0,R.$mc)(y);if(y===g)return y;const v=((0,R.$nc)(y)||y).toLowerCase();try{const w=(0,D.readdirSync)(g).filter(d=>d.toLowerCase()===v);if(w.length===1){const d=P(g);if(d)return(0,R.$jc)(d,w[0])}else if(w.length>1){const d=w.indexOf(v);if(d>=0){const h=P(g);if(h)return(0,R.$jc)(h,w[d])}}}catch{}return null}e.$5p=P;async function f(y){if(s.$l)return y;const g=(0,R.$mc)(y);if(y===g)return y;const v=((0,R.$nc)(y)||y).toLowerCase();try{const w=(await D.Promises.readdir(g)).filter(d=>d.toLowerCase()===v);if(w.length===1){const d=await f(g);if(d)return(0,R.$jc)(d,w[0])}else if(w.length>1){const d=w.indexOf(v);if(d>=0){const h=await f(g);if(h)return(0,R.$jc)(h,w[d])}}}catch{}return null}e.$6p=f;async function c(y){try{return await D.Promises.realpath(y)}catch{const v=b(y);return await D.Promises.access(v,S.constants.R_OK),v}}e.$7p=c;function $(y){try{return S.realpathSync(y)}catch{const v=b(y);return S.accessSync(v,S.constants.R_OK),v}}e.$8p=$;function b(y){return(0,O.$Ke)((0,R.$hc)(y),R.sep)}}),define(ie[106],ne([0,1,28,9,21]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=void 0;const O=/^\d+$/,D=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(f||(f={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let $;process.env.PROCESSOR_ARCHITEW6432?$=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?$=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?$=1:$=0;class b{constructor(u,i,a){this.exePath=u,this.displayName=i,this.a=a}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?c===0?process.env["ProgramFiles(x86)"]||null:$===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:E=!1,findPreview:u=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const a=R.$jc(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(a))return null;let o=-1,t=null;for(const p of await s.Promises.readdir(a)){let A=-1;if(u){const k=p.indexOf("-");if(k<0)continue;const I=p.substring(0,k);if(!O.test(I)||p.substring(k+1)!=="preview")continue;A=parseInt(I,10)}else{if(!O.test(p))continue;A=parseInt(p,10)}if(A<=o)continue;const C=R.$jc(a,p,"pwsh.exe");await s.SymlinkSupport.existsFile(C)&&(t=C,o=A)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",r=u?" Preview":"";return new b(t,`PowerShell${r}${n}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await s.Promises.readdir(u))if(i.test(o)){const t=R.$jc(u,o,"pwsh.exe");return new b(t,a)}return null}function m(){const E=R.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new b(E,".NET Core PowerShell Global Tool")}function w(){const E=R.$jc(process.env.windir,c===1&&$!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(E,"Windows PowerShell",!0)}async function*d(){let E=await g();E&&(yield E),E=await g({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=m(),E&&(yield E),E=await g({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await g({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=w(),E&&(yield E)}async function*h(){for await(const E of d())await E.exists()&&(yield E)}e.$xl=h;async function l(){for await(const E of h())return E;return null}e.$yl=l}),define(ie[88],ne([0,1,9,4,35,75,12,21]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function f(b=s.env){return b.comspec||"cmd.exe"}e.$Bl=f;function c(b){let y=[],g=!1;const v=function(m){if(g){y.push(m);return}(!b.send(m,d=>{if(d&&console.error(d),g=!1,y.length>0){const h=y.slice(0);y=[],h.forEach(l=>v(l))}})||R.$j)&&(g=!0)};return{send:v}}e.$Cl=c;var $;(function(b){async function y(g,v,m){if(S.$ic(g))return g;if(v===void 0&&(v=s.cwd()),S.$mc(g)!=="."||(m===void 0&&D.$yf(s.env.PATH)&&(m=s.env.PATH.split(S.$tc)),m===void 0||m.length===0))return S.$jc(v,g);async function d(h){if(await P.Promises.exists(h)){let l;try{l=await P.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(l=await P.Promises.lstat(h))}return l?!l.isDirectory():!1}return!1}for(const h of m){let l;if(S.$ic(h)?l=S.$jc(h,g):l=S.$jc(v,h,g),await d(l))return l;let E=l+".com";if(await d(E)||(E=l+".exe",await d(E)))return E}return S.$jc(v,g)}b.findExecutable=y})($||(e.win32=$={}))}),define(ie[107],ne([0,1,47,13]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=void 0;function s(D){return new Promise((P,f)=>{let c;const $=new Map;function b(g,v,m,w,d){const h=$.get(v);if(g===D||h){const l={name:y(m),cmd:m,pid:g,ppid:v,load:w,mem:d};$.set(g,l),g===D&&(c=l),h&&(h.children||(h.children=[]),h.children.push(l),h.children.length>1&&(h.children=h.children.sort((E,u)=>E.pid-u.pid)))}}function y(g){const v=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,w=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(w.exec(g))return"electron-crash-reporter";if(d.exec(g))return"winpty-agent";if(h.exec(g))return"conpty-agent";let E=l.exec(g);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?v.exec(g)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const u=/[a-zA-Z-]+\.js/g;let i="";do E=u.exec(g),E&&(i+=E+" ");while(E);return i&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${i})`:m.exec(g)?`electron-nodejs (${g})`:g}if(process.platform==="win32"){const g=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,m)=>{J(["@vscode/windows-process-tree"],v,m)}).then(v=>{v.getProcessList(D,m=>{if(!m){f(new Error(`Root process ${D} not found`));return}v.getProcessCpuUsage(m,w=>{const d=new Map;w.forEach(h=>{const l=g(h.commandLine||"");d.set(h.pid,{name:y(l),cmd:l,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),c=d.get(D),c?(d.forEach(h=>{const l=d.get(h.ppid);l&&(l.children||(l.children=[]),l.children.push(h))}),d.forEach(h=>{h.children&&(h.children=h.children.sort((l,E)=>l.pid-E.pid))}),P(c)):f(new Error(`Root process ${D} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let g=function(){let v=[c];const m=[];for(;v.length;){const d=v.shift();d&&(m.push(d.pid),d.children&&(v=v.concat(d.children)))}let w=JSON.stringify(R.$cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+m.join(" "),(0,S.exec)(w,{},(d,h,l)=>{if(d||l)f(d||new Error(l.toString()));else{const E=h.toString().split(`
`);for(let u=0;u<m.length;u++){const i=$.get(m[u]);i.load=parseFloat(E[u])}if(!c){f(new Error(`Root process ${D} not found`));return}P(c)}})};(0,S.exec)("which ps",{},(v,m,w)=>{if(v||w)if(process.platform!=="linux")f(v||new Error(w.toString()));else{const d=JSON.stringify(R.$cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(d,{},(h,l,E)=>{h||E?f(h||new Error(E.toString())):(O(l,b),g())})}else{const d=m.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${d} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,E,u)=>{l||u&&!u.includes("screen size is bogus")?f(l||new Error(u.toString())):(O(E,b),process.platform==="linux"?g():c?P(c):f(new Error(`Root process ${D} not found`)))})}})}})}e.$Cr=s;function O(D,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=D.toString().split(`
`);for(const $ of c){const b=f.exec($.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ie[108],ne([0,1,28,4,106,88]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=void 0;async function D(b,y){return b===1?R.$j?$():O.$Bl(y):f(b,y)}e.$Dl=D;let P=null;function f(b,y){if(R.$l&&b===2||R.$k&&b===3)return"/bin/bash";if(!P){let g;if(R.$j)g="/bin/bash";else{if(g=y.SHELL,!g)try{g=(0,S.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let c=null;async function $(){return c||(c=(await(0,s.$yl)()).exePath),c}});var Ee=this&&this.__decorate||function(J,e,S,R){var s=arguments.length,O=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,S):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(J,e,S,R);else for(var P=J.length-1;P>=0;P--)(D=J[P])&&(O=(s<3?D(O):s>3?D(e,S,O):D(e,S))||O);return s>3&&O&&Object.defineProperty(e,S,O),O};define(ie[42],ne([0,1,23,8,17,22,54,14,3,2,76,27,12]),function(J,e,S,R,s,O,D,P,f,c,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var g;(function(K){K[K.Promise=100]="Promise",K[K.PromiseCancel=101]="PromiseCancel",K[K.EventListen=102]="EventListen",K[K.EventDispose=103]="EventDispose"})(g||(g={}));function v(K){switch(K){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(K){K[K.Initialize=200]="Initialize",K[K.PromiseSuccess=201]="PromiseSuccess",K[K.PromiseError=202]="PromiseError",K[K.PromiseErrorObj=203]="PromiseErrorObj",K[K.EventFire=204]="EventFire"})(m||(m={}));function w(K){switch(K){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(K){K[K.Uninitialized=0]="Uninitialized",K[K.Idle=1]="Idle"})(d||(d={}));function h(K){let q=0;for(let W=0;;W+=7){const G=K.read(1);if(q|=(G.buffer[0]&127)<<W,!(G.buffer[0]&128))return q}}const l=o(0);function E(K,q){if(q===0){K.write(l);return}let W=0;for(let H=q;H!==0;H=H>>>7)W++;const G=s.$be.alloc(W);for(let H=0;q!==0;H++)G.buffer[H]=q&127,q=q>>>7,q>0&&(G.buffer[H]|=128);K.write(G)}class u{constructor(q){this.b=q,this.a=0}read(q){const W=this.b.slice(this.a,this.a+q);return this.a+=W.byteLength,W}}e.$nh=u;class i{constructor(){this.a=[]}get buffer(){return s.$be.concat(this.a)}write(q){this.a.push(q)}}e.$oh=i;var a;(function(K){K[K.Undefined=0]="Undefined",K[K.String=1]="String",K[K.Buffer=2]="Buffer",K[K.VSBuffer=3]="VSBuffer",K[K.Array=4]="Array",K[K.Object=5]="Object",K[K.Int=6]="Int"})(a||(a={}));function o(K){const q=s.$be.alloc(1);return q.writeUInt8(K,0),q}const t={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object),Uint:o(a.Int)},n=typeof Buffer<"u";function r(K,q){if(typeof q>"u")K.write(t.Undefined);else if(typeof q=="string"){const W=s.$be.fromString(q);K.write(t.String),E(K,W.byteLength),K.write(W)}else if(n&&Buffer.isBuffer(q)){const W=s.$be.wrap(q);K.write(t.Buffer),E(K,W.byteLength),K.write(W)}else if(q instanceof s.$be)K.write(t.VSBuffer),E(K,q.byteLength),K.write(q);else if(Array.isArray(q)){K.write(t.Array),E(K,q.length);for(const W of q)r(K,W)}else if(typeof q=="number"&&(q|0)===q)K.write(t.Uint),E(K,q);else{const W=s.$be.fromString(JSON.stringify(q));K.write(t.Object),E(K,W.byteLength),K.write(W)}}e.$ph=r;function p(K){switch(K.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return K.read(h(K)).toString();case a.Buffer:return K.read(h(K)).buffer;case a.VSBuffer:return K.read(h(K));case a.Array:{const W=h(K),G=[];for(let H=0;H<W;H++)G.push(p(K));return G}case a.Object:return JSON.parse(K.read(h(K)).toString());case a.Int:return h(K)}}e.$qh=p;class A{constructor(q,W,G=null,H=1e3){this.h=q,this.j=W,this.k=G,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(q,W){this.b.set(q,W),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const W=this.o([q.type]);this.k?.logOutgoing(W,0,1,w(q.type));return}case 201:case 202:case 204:case 203:{const W=this.o([q.type,q.id],q.data);this.k?.logOutgoing(W,q.id,1,w(q.type),q.data);return}}}o(q,W=void 0){const G=new i;return r(G,q),r(G,W),this.p(G.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const W=new u(q),G=p(W),H=p(W),Y=G[0];switch(Y){case 100:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Y)}: ${G[2]}.${G[3]}`,H),this.s({type:Y,id:G[1],channelName:G[2],name:G[3],arg:H});case 102:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Y)}: ${G[2]}.${G[3]}`,H),this.t({type:Y,id:G[1],channelName:G[2],name:G[3],arg:H});case 101:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Y)}`),this.u({type:Y,id:G[1]});case 103:return this.k?.logIncoming(q.byteLength,G[1],1,`${v(Y)}`),this.u({type:Y,id:G[1]})}}s(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const G=new O.$Xd;let H;try{H=W.call(this.j,q.name,q.arg,G.token)}catch(L){H=Promise.reject(L)}const Y=q.id;H.then(L=>{this.m({id:Y,data:L,type:201})},L=>{L instanceof Error?this.m({id:Y,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:Y,data:L,type:203})}).finally(()=>{re.dispose(),this.d.delete(q.id)});const re=(0,c.$Qc)(()=>G.cancel());this.d.set(q.id,re)}t(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const G=q.id,Y=W.listen(this.j,q.name,q.arg)(re=>this.m({id:G,data:re,type:204}));this.d.set(q.id,Y)}u(q){const W=this.d.get(q.id);W&&(W.dispose(),this.d.delete(q.id))}v(q){let W=this.g.get(q.channelName);W||(W=[],this.g.set(q.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:q,timeoutTimer:G})}w(q){const W=this.g.get(q);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$rh=A;var C;(function(K){K[K.LocalSide=0]="LocalSide",K[K.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class k{constructor(q,W=null){this.l=q,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=W}getChannel(q){const W=this;return{call(G,H,Y){return W.a?Promise.reject(new P.$5):W.m(q,G,H,Y)},listen(G,H){return W.a?f.Event.None:W.o(q,G,H)}}}m(q,W,G,H=O.CancellationToken.None){const Y=this.g++,L={id:Y,type:100,channelName:q,name:W,arg:G};if(H.isCancellationRequested)return Promise.reject(new P.$5);let M;return new Promise((T,N)=>{if(H.isCancellationRequested)return N(new P.$5);const B=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(Y),T(he.data);break;case 202:{this.f.delete(Y);const ve=new Error(he.data.message);ve.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ve.name=he.data.name,N(ve);break}case 203:this.f.delete(Y),N(he.data);break}};this.f.set(Y,ue),this.p(L)};let V=null;this.b===d.Idle?B():(V=(0,R.$Hg)(ue=>this.u()),V.then(()=>{V=null,B()}));const oe=()=>{V?(V.cancel(),V=null):this.p({id:Y,type:101}),N(new P.$5)},de=H.onCancellationRequested(oe);M=(0,c.$Pc)((0,c.$Qc)(oe),de),this.d.add(M)}).finally(()=>{M.dispose(),this.d.delete(M)})}o(q,W,G){const H=this.g++,re={id:H,type:102,channelName:q,name:W,arg:G};let L=null;const M=new f.$Nd({onWillAddFirstListener:()=>{L=(0,R.$Hg)(T=>this.u()),L.then(()=>{L=null,this.d.add(M),this.p(re)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(M),this.p({id:H,type:103}))}}),F=T=>M.fire(T.data);return this.f.set(H,F),M.event}p(q){switch(q.type){case 100:case 102:{const W=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(W,q.id,0,`${v(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const W=this.q([q.type,q.id]);this.j?.logOutgoing(W,q.id,0,v(q.type));return}}}q(q,W=void 0){const G=new i;return r(G,q),r(G,W),this.r(G.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const W=new u(q),G=p(W),H=p(W),Y=G[0];switch(Y){case 200:return this.j?.logIncoming(q.byteLength,0,0,w(Y)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,G[1],0,w(Y),H),this.t({type:G[0],id:G[1],data:H})}}t(q){if(q.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$sh=k,Ee([D.$hh],k.prototype,"onDidInitializePromise",null);class I{get connections(){const q=[];return this.f.forEach(W=>q.push(W)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new f.$Nd,this.onDidAddConnection=this.g.event,this.h=new f.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(q(({protocol:W,onDidClientDisconnect:G})=>{const H=f.Event.once(W.onMessage);this.j.add(H(Y=>{const re=new u(Y),L=p(re),M=new A(W,L),F=new k(W);this.a.forEach((N,B)=>M.registerChannel(B,N));const T={channelServer:M,channelClient:F,ctx:L};this.f.add(T),this.g.fire(T),this.j.add(G(()=>{M.dispose(),F.dispose(),this.f.delete(T),this.h.fire(T)}))}))}))}getChannel(q,W){const G=this;return{call(H,Y,re){let L;if((0,y.$Mf)(W)){const F=(0,S.$4b)(G.connections.filter(W));L=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(G.onDidAddConnection,W))}else L=W.routeCall(G,H,Y);const M=L.then(F=>F.channelClient.getChannel(q));return U(M).call(H,Y,re)},listen(H,Y){if((0,y.$Mf)(W))return G.k(q,W,H,Y);const re=W.routeEvent(G,H,Y).then(L=>L.channelClient.getChannel(q));return U(re).listen(H,Y)}}}k(q,W,G,H){const Y=this;let re;const L=new f.$Nd({onWillAddFirstListener:()=>{re=new c.$Rc;const M=new f.$Td,F=new Map,T=B=>{const oe=B.channelClient.getChannel(q).listen(G,H),de=M.add(oe);F.set(B,de)},N=B=>{const V=F.get(B);V&&(V.dispose(),F.delete(B))};Y.connections.filter(W).forEach(T),f.Event.filter(Y.onDidAddConnection,W)(T,void 0,re),Y.onDidRemoveConnection(N,void 0,re),M.event(L.fire,L,re),re.add(M)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return L.event}registerChannel(q,W){this.a.set(q,W);for(const G of this.f)G.channelServer.registerChannel(q,W)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=I;class j{constructor(q,W,G=null){const H=new i;r(H,W),q.send(H.buffer),this.a=new k(q,G),this.d=new A(q,W,G)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,W){this.d.registerChannel(q,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=j;function U(K){return{call(q,W,G){return K.then(H=>H.call(q,W,G))},listen(q,W){const G=new f.$Wd;return K.then(H=>G.input=H.listen(q,W)),G.event}}}e.$vh=U;function z(K){let q=!1;return{call(W,G,H){return q?K.call(W,G,H):(0,R.$Ug)(0).then(()=>q=!0).then(()=>K.call(W,G,H))},listen(W,G){if(q)return K.listen(W,G);const H=new f.$Wd;return(0,R.$Ug)(0).then(()=>q=!0).then(()=>H.input=K.listen(W,G)),H.event}}}e.$wh=z;class x{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const W of q.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await f.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$xh=x;var X;(function(K){function q(Y,re,L){const M=Y,F=L&&L.disableMarshalling,T=new Map;for(const N in M)G(N)&&T.set(N,f.Event.buffer(M[N],!0,void 0,re));return new class{listen(N,B,V){const oe=T.get(B);if(oe)return oe;if(H(B)){const de=M[B];if(typeof de=="function")return de.call(M,V)}throw new P.$bb(`Event not found: ${B}`)}call(N,B,V){const oe=M[B];if(typeof oe=="function"){if(!F&&Array.isArray(V))for(let ue=0;ue<V.length;ue++)V[ue]=(0,$.$mh)(V[ue]);let de=oe.apply(M,V);return de instanceof Promise||(de=Promise.resolve(de)),de}throw new P.$bb(`Method not found: ${B}`)}}}K.fromService=q;function W(Y,re){const L=re&&re.disableMarshalling;return new Proxy({},{get(M,F){if(typeof F=="string")return re?.properties?.has(F)?re.properties.get(F):H(F)?function(T){return Y.listen(F,T)}:G(F)?Y.listen(F):async function(...T){let N;re&&!(0,y.$Hf)(re.context)?N=[re.context,...T]:N=T;const B=await Y.call(F,N);return L?B:(0,$.$mh)(B)};throw new P.$bb(`Property not found: ${String(F)}`)}})}K.toService=W;function G(Y){return Y[0]==="o"&&Y[1]==="n"&&b.$1e(Y.charCodeAt(2))}function H(Y){return/^onDynamic/.test(Y)&&b.$1e(Y.charCodeAt(9))}})(X||(e.ProxyChannel=X={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(K){if(Array.isArray(K))return K;if(K&&typeof K=="object"&&typeof K.toString=="function"){const q=K.toString();if(q!=="[object Object]")return q}return K}function ce(K){return Array.isArray(K)?K.map(se):se(K)}function Z(K,q,W,G,H,Y,re){re=ce(re);const L=ae[H],M=L[G%L.length];let F=[`%c[${K}]%c[${String(q).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(Y)?(F=F.concat(re),F.push(")")):F.push(re),console.log.apply(console,F)}class Q{constructor(q,W){this.d=q,this.f=W,this.a=0,this.b=0}logOutgoing(q,W,G,H,Y){this.b+=q,Z(this.d,this.b,q,W,G,H,Y)}logIncoming(q,W,G,H,Y){this.a+=q,Z(this.f,this.a,q,W,G,H,Y)}}e.$yh=Q}),define(ie[157],ne([0,1,17,3,42]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uT=e.$tT=void 0;class O{constructor(f){this.a=f,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",c=>S.$be.wrap(c.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$tT=O;class D extends s.$uh{constructor(f,c){const $=new O(f);super($,c),this.b=$}dispose(){this.b.disconnect(),super.dispose()}}e.$uT=D}),define(ie[109],ne([0,1,17,3,2,42]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let r=0;function p(C,k){if(!n.has(C)){const I=String(++r);n.set(C,I)}return n.get(C)}function A(C,k,I,j){if(!t.enableDiagnostics)return;const U=p(C,k);if(j instanceof S.$be||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const z=S.$be.alloc(j.byteLength);z.set(j),t.records.push({timestamp:Date.now(),id:U,label:k,type:I,buff:z})}else t.records.push({timestamp:Date.now(),id:U,label:k,type:I,data:j})}t.traceSocketEvent=A})(P||(e.SocketDiagnostics=P={}));var f;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let c=null;function $(){return c||(c=S.$be.alloc(0)),c}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,r){if(n===0)return $();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return r&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return r&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const p=S.$be.alloc(n);let A=0,C=0;for(;n>0;){const k=this.a[C];if(k.byteLength>n){const I=k.slice(0,n);p.set(I,A),A+=n,r&&(this.a[C]=k.slice(n),this.b-=n),n-=n}else p.set(k,A),A+=k.byteLength,r?(this.a.shift(),this.b-=k.byteLength):C++,n-=k.byteLength}return p}}e.$zh=b;var y;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(y||(y={}));function g(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class m{constructor(n,r,p,A){this.type=n,this.id=r,this.ack=p,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends s.$Sc{constructor(n){super(),this.f=this.B(new R.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new b,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,A=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new m(p,A,C,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=S.$be.alloc(13);r.writeUInt8(n.type,0),r.writeUInt32BE(n.id,1),r.writeUInt32BE(n.ack,5),r.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(r,n.data)}g(n,r){const p=this.f===0;return this.d.push(n,r),this.f+=n.byteLength+r.byteLength,p}h(){const n=S.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,r){this.g(n,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Sc{constructor(n){super(),this.f=new R.$Nd,this.onMessage=this.f.event,this.g=new R.$Nd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new d(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$Ah=h;class l extends O.$uh{static fromSocket(n,r){return new l(new h(n),r)}get onDidDispose(){return this.b.onDidDispose}constructor(n,r,p=null){super(n,r,p),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Bh=l;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Ch=E;class u{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,r=this.a;for(;r;)r=r.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let r=0,p=this.a;for(;p;)n[r++]=p.data,p=p.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const r=new u(n);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const n=Date.now();for(let r=0;r<a.a;r++)this.c[r]=n-1e3*r;setInterval(()=>{for(let r=a.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),r=(1+a.a)*1e3;let p=0;for(let A=0;A<a.a;A++)n-this.c[A]<=r&&p++;return 1-p/a.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??a.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Rc,this.o=n.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,$());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,$());this.p.write(n)}sendResume(){const n=new m(8,0,0,$());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,r){this.a=!0,this.r.dispose(),this.r=new s.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,$());this.p.write(n);const r=this.b.toArray();for(let p=0,A=r.length;p<A;p++)this.p.write(r[p]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const r=this.b.peek();if(r&&r.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new m(6,0,0,$())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let p=0,A=r.length;p<A;p++)this.p.write(r[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const r=++this.c;this.h=this.g;const p=new m(1,r,this.h,n);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(n){const r=new m(2,0,0,n);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),r=Date.now()-n.writtenTime,p=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(r>=2e4&&p>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:p});return}const C=Math.max(2e4-r,2e4-p,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,$());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,$());this.p.write(n)}}e.$Dh=o}),define(ie[38],ne([0,1,15,14,13]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qT=void 0;class O{constructor(){this.a=new WeakMap}on(P,f){const c=($,...b)=>{this.b(P,$)&&f($,...b)};return this.a.set(f,c),S.ipcMain.on(P,c),this}once(P,f){return S.ipcMain.once(P,(c,...$)=>{this.b(P,c)&&f(c,...$)}),this}handle(P,f){return S.ipcMain.handle(P,(c,...$)=>this.b(P,c)?f(c,...$):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,f){const c=this.a.get(f);return c&&(S.ipcMain.removeListener(P,c),this.a.delete(f)),this}b(P,f){if(!P||!P.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const c=f.senderFrame,$=c.url;if(!$||$==="about:blank")return!0;let b="unknown";try{b=new URL($).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${$}'.`),!1}return b!==s.$bg?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${b}'.`),!1):c.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$qT=new O}),define(ie[158],ne([0,1,15,38,146]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rT=void 0;function O(){R.$qT.on(s.$oT,(P,f,c,$,b)=>{const y=D(P,$,c);y.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{y&&P.sender.send(s.$pT,f)}})})}e.$rT=O;function D(P,f,c){const $=new S.Menu;return c.forEach(b=>{let y;b.type==="separator"?y=new S.MenuItem({type:b.type}):Array.isArray(b.submenu)?y=new S.MenuItem({submenu:D(P,f,b.submenu),label:b.label}):y=new S.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(g,v,m)=>P.sender.send(f,b.id,m)}),$.append(y)}),$}}),define(ie[159],ne([0,1,38,17,3,2,42,147]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xT=void 0;function f($,b){const y=s.Event.fromNodeEventEmitter(S.$qT,b,(v,m)=>({event:v,message:m})),g=s.Event.filter(y,({event:v})=>v.sender.id===$);return s.Event.map(g,({message:v})=>v&&R.$be.wrap(v))}class c extends D.$th{static{this.b=new Map}static d(){const b=s.Event.fromNodeEventEmitter(S.$qT,"vscode:hello",({sender:y})=>y);return s.Event.map(b,y=>{const g=y.id;c.b.get(g)?.dispose();const m=new s.$Nd;c.b.set(g,(0,O.$Qc)(()=>m.fire()));const w=f(g,"vscode:message"),d=s.Event.any(s.Event.signal(f(g,"vscode:disconnect")),m.event);return{protocol:new P.$wT(y,w),onDidClientDisconnect:d}})}constructor(){super(c.d())}}e.$xT=c}),define(ie[110],ne([0,1,38,3,32,157]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zT=e.$yT=void 0;class D extends O.$uT{constructor(c,$){super({addEventListener:(b,y)=>c.addListener(b,y),removeEventListener:(b,y)=>c.removeListener(b,y),postMessage:b=>c.postMessage(b),start:()=>c.start(),close:()=>c.close()},$)}}e.$yT=D;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,s.$eg)();f.webContents.send("vscode:createMessageChannel",c);const $=R.Event.fromNodeEventEmitter(S.$qT,"vscode:createMessageChannelResult",(y,g)=>({nonce:g,port:y.ports[0]})),{port:b}=await R.Event.toPromise(R.Event.once(R.Event.filter($,y=>y.nonce===c)));return b}e.$zT=P}),define(ie[160],ne([0,1,47,8,17,22,154,14,3,2,37,88,75,42]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class v extends g.$rh{constructor(d){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>s.$be.wrap(Buffer.from(h,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$2p=v;class m{constructor(d,h){this.i=d,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.$Nd,this.onDidProcessExit=this.h.event;const l=h&&h.timeout?h.timeout:6e4;this.b=new R.$Qg(l),this.d=null,this.f=null}getChannel(d){const h=this;return{call(l,E,u){return h.k(d,l,E,u)},listen(l,E){return h.l(d,l,E)}}}k(d,h,l,E=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const u=this.n(d),i=(0,R.$Hg)(t=>u.call(h,l,t)),a=E.onCancellationRequested(()=>i.cancel()),o=(0,c.$Qc)(()=>i.cancel());return this.c.add(o),i.finally(()=>{a.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(d,h,l){if(!this.b)return f.Event.None;this.b.cancel();let E;const u=new f.$Nd({onWillAddFirstListener:()=>{E=this.n(d).listen(h,l)(u.fire,u),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,$.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$Al)(h.env),this.d=(0,S.fork)(this.i,d,h);const l=new f.$Nd;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Xp)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}l.fire(s.$be.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,b.$Cl)(this.d):this.d,i=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),a=l.event,o={send:i,onMessage:a};this.f=new g.$sh(o);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",t),this.c.forEach(p=>(0,c.$Nc)(p)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(d){let h=this.g.get(d);return h||(h=this.m.getChannel(d),this.g.set(d,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$3p=m}),define(ie[111],ne([0,1,8,3,2,76,12]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.StorageState=e.$1o=e.StorageHint=void 0;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function f(y){const g=y;return g?.changed instanceof Map||g?.deleted instanceof Set}e.$1o=f;var c;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(c||(e.StorageState=c={}));class $ extends s.$Sc{static{this.a=100}constructor(g,v=Object.create(null)){super(),this.r=g,this.s=v,this.b=this.B(new R.$Qd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new S.$Rg($.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((v,m)=>this.w(m,v)),g.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(g,v){if(this.c===c.Closed)return;let m=!1;(0,D.$Hf)(v)?m=this.f.delete(g):this.f.get(g)!==v&&(this.f.set(g,v),m=!0),m&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,v){const m=this.f.get(g);return(0,D.$Hf)(m)?v:m}getBoolean(g,v){const m=this.get(g);return(0,D.$Hf)(m)?v:m==="true"}getNumber(g,v){const m=this.get(g);return(0,D.$Hf)(m)?v:parseInt(m,10)}getObject(g,v){const m=this.get(g);return(0,D.$Hf)(m)?v:(0,O.$lh)(m)}async set(g,v,m=!1){if(this.c===c.Closed)return;if((0,D.$Hf)(v))return this.delete(g,m);const w=(0,D.$Af)(v)||Array.isArray(v)?(0,O.$kh)(v):String(v);if(this.f.get(g)!==w)return this.f.set(g,w),this.j.set(g,w),this.h.delete(g),this.b.fire({key:g,external:m}),this.D()}async delete(g,v=!1){if(!(this.c===c.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:v}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(this.z)return this.D(g)}async D(g){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$2o=$;class b{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((v,m)=>this.a.set(m,v)),g.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$3o=b}),define(ie[161],ne([0,1,8,3,31,9,21]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VT=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor($,b=Object.create(null)){this.g=$,this.h=b,this.c=(0,O.$nc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const $=await this.f,b=new Map;return(await this.s($,"SELECT * FROM ItemTable")).forEach(g=>b.set(g.key,g.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems($){const b=await this.f;return this.j(b,$)}j($,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,s.$yc)(b.insert):"0"}), delete(${b.delete?(0,s.$zc)(b.delete):"0"})`),this.t($,()=>{const y=b.insert,g=b.delete;if(y&&y.size>0){const v=[];v.push([]);let m=0;y.forEach((w,d)=>{let h=v[m];h.length>P.b&&(m++,h=[],v.push(h)),h.push(d,w)}),v.forEach(w=>{this.u($,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,d=>d.run(w),()=>{const d=[];let h=0;return y.forEach((l,E)=>{d.push(E),h+=l.length}),`Keys: ${d.join(", ")} Length: ${h}`})})}if(g&&g.size){const v=[];v.push([]);let m=0;g.forEach(w=>{let d=v[m];d.length>P.b&&(m++,d=[],v.push(d)),d.push(w)}),v.forEach(w=>{this.u($,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,d=>d.run(w),()=>{const d=[];return g.forEach(h=>{d.push(h)}),`Keys: ${d.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const $=await this.f;return this.q($,"VACUUM")}async close($){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,$)}k($,b){return new Promise((y,g)=>{$.db.close(v=>(v&&this.o($,`[storage ${this.c}] close(): ${v}`),this.g===P.IN_MEMORY_PATH?y():!$.isErroneous&&!$.isInMemory?this.l().then(y,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),y())):typeof b=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const w=()=>this.k(m,void 0);return this.j(m,{insert:b()}).then(()=>w(),d=>(w(),Promise.reject(d)))})).then(y,g):g(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const $=this.m(this.g);return D.Promises.copy(this.g,$,{preserveSymlinks:!1})}m($){return`${$}.backup`}async checkIntegrity($){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${$})`);const b=await this.f,y=await this.r(b,$?"PRAGMA integrity_check":"PRAGMA quick_check"),g=$?y.integrity_check:y.quick_check;return b.isErroneous?`${g} (last error: ${b.lastError})`:b.isInMemory?`${g} (in-memory!)`:g}async n($,b=!0){this.d.trace(`[storage ${this.c}] open(${$}, retryOnBusy: ${b})`);try{return await this.p($)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&b)return await(0,S.$Ug)(P.a),this.n($,!1);try{await D.Promises.unlink($);try{await D.Promises.rename(this.m($),$,!1)}catch{}return await this.p($)}catch(g){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${g}`),this.p(P.IN_MEMORY_PATH)}}}o($,b){$.isErroneous=!0,$.lastError=b,this.d.error(b)}p($){return new Promise((b,y)=>{new Promise((g,v)=>{J(["@vscode/sqlite3"],g,v)}).then(g=>{const v={db:new(this.d.isTracing?g.verbose().Database:g.Database)($,m=>m?v.db&&m.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(m)):y(m):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(v),w=>v.db.close(()=>y(w)))),isInMemory:$===P.IN_MEMORY_PATH};v.db.on("error",m=>this.o(v,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&v.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},y)})}q($,b){return new Promise((y,g)=>{$.db.exec(b,v=>v?(this.o($,`[storage ${this.c}] exec(): ${v}`),g(v)):y())})}r($,b){return new Promise((y,g)=>{$.db.get(b,(v,m)=>v?(this.o($,`[storage ${this.c}] get(): ${v}`),g(v)):y(m))})}s($,b){return new Promise((y,g)=>{$.db.all(b,(v,m)=>v?(this.o($,`[storage ${this.c}] all(): ${v}`),g(v)):y(m))})}t($,b){return new Promise((y,g)=>{$.db.serialize(()=>{$.db.run("BEGIN TRANSACTION"),b(),$.db.run("END TRANSACTION",v=>v?(this.o($,`[storage ${this.c}] transaction(): ${v}`),g(v)):y())})})}u($,b,y,g){const v=$.db.prepare(b),m=w=>{this.o($,`[storage ${this.c}] prepare(): ${w} (${b}). Details: ${g()}`)};v.on("error",m),y(v),v.finalize(w=>{w&&m(w),v.removeListener("error",m)})}}e.$VT=P;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor($){$&&typeof $.logTrace=="function"&&process.env[f.a]&&(this.b=$.logTrace),$&&typeof $.logError=="function"&&(this.c=$.logError)}get isTracing(){return!!this.b}trace($){this.b?.($)}error($){this.c?.($)}}}),define(ie[162],ne([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(ie[163],ne([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[164],ne([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[165],ne([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[166],ne([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(ie[167],ne([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[168],ne([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ie[169],ne([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ie[170],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[171],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[172],ne([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[173],ne([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[174],ne([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[175],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[176],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ie[177],ne([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[178],ne([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[179],ne([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[180],ne([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[181],ne([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[182],ne([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[183],ne([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[184],ne([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[185],ne([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[186],ne([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ie[187],ne([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ie[188],ne([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[189],ne([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[190],ne([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[191],ne([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[192],ne([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[193],ne([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[194],ne([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[195],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=e.$LU=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$LU=S;function R(s){return s&&s.hasOwnProperty("workspace")}e.$MU=R}),define(ie[196],ne([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=e.$E6b=e.$D6b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$D6b=R;function s(D){let P=[];try{Array.isArray(D.workspaces)&&(P=D.workspaces.map(f=>({workspace:{id:f.id,configPath:S.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$E6b=s;function O(D){let P=[];try{Array.isArray(D.folders)&&(P=D.folders.map(f=>({folderUri:S.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return P}e.$F6b=O}),define(ie[197],ne([0,1,14,165]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var s;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(s||(e.TokenType=s={}));function O(...c){switch(c.length){case 1:return(0,R.localize)(0,null,c[0]);case 2:return(0,R.localize)(1,null,c[0],c[1]);case 3:return(0,R.localize)(2,null,c[0],c[1],c[2]);default:return}}const D=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return $.isTripleEq?"===":"==";case 4:return $.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return $.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return $.lexeme;case 18:return $.lexeme;case 19:return $.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const b=this.d,y=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:$}),this.f.push(g)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const b=this.c.substring(this.d,this.e),y=f.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,b=!1,y=!1;for(;;){if($>=this.c.length){this.e=$,this.l(P);return}const v=this.c.charCodeAt($);if(b)b=!1;else if(v===47&&!y){$++;break}else v===91?y=!0:v===92?b=!0:v===93&&(y=!1);$++}for(;$<this.c.length&&f.a.has(this.c.charCodeAt($));)$++;this.e=$;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=f}),define(ie[198],ne([0,1,3,2]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=void 0;class s{constructor(){this.a=new S.$Nd,this.b=new S.$Nd,this.c=new S.$Nd,this.d=new S.$Nd}static{this.ChannelName="extensionhostdebugservice"}call(P,f,c){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(P,f,c){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Mn=s;class O extends R.$Sc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,f,c){this.b.call("attach",[P,f,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,f){this.b.call("terminate",[P,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.b.call("openExtensionDevelopmentHostWindow",[P,f])}}e.$Nn=O}),define(ie[199],ne([0,1,149,54,13,9,35,19,7]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,O.$mc)(s.$cg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,O.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,P.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,S.$em)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$jc)(this.userDataPath,"logs",g)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$vg)(f.URI.file((0,O.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=D.env.VSCODE_PORTABLE;return g?f.URI.file((0,O.$jc)(g,"argv.json")):(0,P.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,O.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,O.$kc)(g):(0,O.$hc)((0,O.$jc)(s.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?f.URI.file((0,O.$kc)(g)):f.URI.file((0,O.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,O.$kc)(g);const v=D.env.VSCODE_EXTENSIONS;if(v)return v;const m=D.env.VSCODE_PORTABLE;return m?(0,O.$jc)(m,"extensions"):(0,P.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(v=>/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,O.$hc)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,O.$hc)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return $(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$fm.test(g))}get extensionLogLevel(){const g=[];for(const v of this.args.log||[]){const m=e.$fm.exec(v);m&&m[1]&&m[2]&&g.push([m[1],m[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.$vg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=D.env.VSCODE_PORTABLE;return g?f.URI.file((0,O.$jc)(g,"policy.json")):(0,P.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,v,m){this.a=g,this.b=v,this.c=m,this.editSessionId=this.args.editSessionId}}e.$gm=c,Ee([R.$hh],c.prototype,"appRoot",null),Ee([R.$hh],c.prototype,"userHome",null),Ee([R.$hh],c.prototype,"userDataPath",null),Ee([R.$hh],c.prototype,"appSettingsHome",null),Ee([R.$hh],c.prototype,"tmpDir",null),Ee([R.$hh],c.prototype,"cacheHome",null),Ee([R.$hh],c.prototype,"stateResource",null),Ee([R.$hh],c.prototype,"userRoamingDataHome",null),Ee([R.$hh],c.prototype,"userDataSyncHome",null),Ee([R.$hh],c.prototype,"sync",null),Ee([R.$hh],c.prototype,"machineSettingsResource",null),Ee([R.$hh],c.prototype,"workspaceStorageHome",null),Ee([R.$hh],c.prototype,"localHistoryHome",null),Ee([R.$hh],c.prototype,"keyboardLayoutResource",null),Ee([R.$hh],c.prototype,"argvResource",null),Ee([R.$hh],c.prototype,"isExtensionDevelopment",null),Ee([R.$hh],c.prototype,"untitledWorkspacesHome",null),Ee([R.$hh],c.prototype,"builtinExtensionsPath",null),Ee([R.$hh],c.prototype,"extensionsPath",null),Ee([R.$hh],c.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$hh],c.prototype,"extensionDevelopmentKind",null),Ee([R.$hh],c.prototype,"extensionTestsLocationURI",null),Ee([R.$hh],c.prototype,"debugExtensionHost",null),Ee([R.$hh],c.prototype,"logLevel",null),Ee([R.$hh],c.prototype,"extensionLogLevel",null),Ee([R.$hh],c.prototype,"serviceMachineIdResource",null),Ee([R.$hh],c.prototype,"disableTelemetry",null),Ee([R.$hh],c.prototype,"disableWorkspaceTrust",null),Ee([R.$hh],c.prototype,"useInMemorySecretStorage",null),Ee([R.$hh],c.prototype,"policyFile",null);function $(y,g){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,g,y.debugId,y.extensionEnvironment)}e.$hm=$;function b(y,g,v,m,w,d){const l=Number(g||y)||(m?null:v),E=l?!!g:!1;let u;if(d)try{u=JSON.parse(d)}catch{}return{port:l,break:E,debugId:w,env:u}}e.$im=b}),define(ie[112],ne([0,1,309,4,168]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=void 0;const O={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$El=["tunnel","serve-web"],e.$Fl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(m,w,d=D){const h=m.find(r=>r.length>0&&r[0]!=="-"),l={},E=["_"],u=[],i={};let a;for(const r in w){const p=w[r];p.type==="subcommand"?r===h&&(a=p):(p.alias&&(l[r]=p.alias),p.type==="string"||p.type==="string[]"?(E.push(r),p.deprecates&&E.push(...p.deprecates)):p.type==="boolean"&&(u.push(r),p.deprecates&&u.push(...p.deprecates)),p.global&&(i[r]=p))}if(a&&h){const r=i;for(const k in a.options)r[k]=a.options[k];const p=m.filter(k=>k!==h),A=d.getSubcommandReporter?d.getSubcommandReporter(h):void 0,C=P(p,r,A);return{[h]:C,_:[]}}const o=S(m,{string:E,boolean:u,alias:l}),t={},n=o;t._=o._.map(r=>String(r)).filter(r=>r.length>0),delete n._;for(const r in w){const p=w[r];if(p.type==="subcommand")continue;p.alias&&delete n[p.alias];let A=n[r];if(p.deprecates)for(const C of p.deprecates)n.hasOwnProperty(C)&&(A||(A=n[C],A&&d.onDeprecatedOption(C,p.deprecationMessage||(0,s.localize)(37,null,r))),delete n[C]);if(typeof A<"u"){if(p.type==="string[]"){if(Array.isArray(A)||(A=[A]),!p.allowEmptyValue){const C=A.filter(k=>k.length>0);C.length!==A.length&&(d.onEmptyValue(r),A=C.length>0?C:void 0)}}else p.type==="string"&&(Array.isArray(A)?(A=A.pop(),d.onMultipleValues(r,A)):!A&&!p.allowEmptyValue&&(d.onEmptyValue(r),A=void 0));t[r]=A,p.deprecationMessage&&d.onDeprecatedOption(r,p.deprecationMessage)}delete n[r]}for(const r in n)d.onUnknownOption(r);return t}e.$Gl=P;function f(m,w){let d="";return w.args&&(Array.isArray(w.args)?d=` <${w.args.join("> <")}>`:d=` <${w.args}>`),w.alias?`-${w.alias} --${m}${d}`:`--${m}${d}`}function c(m,w){const d=[];for(const h in m){const l=m[h],E=f(h,l);d.push([E,l.description])}return $(d,w)}e.$Hl=c;function $(m,w){const h=m.reduce((u,i)=>Math.max(u,i[0].length),12)+2+1;if(w-h<25)return m.reduce((u,i)=>u.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const l=w-h-1,E=[];for(const u of m){const i=u[0],a=y(u[1],l),o=b(h-i.length-2);E.push("  "+i+o+a[0]);for(let t=1;t<a.length;t++)E.push(b(h)+a[t])}return E}function b(m){return" ".repeat(m)}function y(m,w){const d=[];for(;m.length;){const h=m.length<w?m.length:m.lastIndexOf(" ",w),l=m.slice(0,h).trim();m=m.slice(h),d.push(l)}return d}function g(m,w,d,h,l){const E=process.stdout.isTTY&&process.stdout.columns||80,u=l?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${m} ${d}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${w} [${(0,s.localize)(40,null)}]${u}`),i.push(""),l?.noPipe!==!0&&(R.$j?i.push((0,s.localize)(41,null,w)):i.push((0,s.localize)(42,null,w)),i.push(""));const a={},o=[];for(const t in h){const n=h[t];if(n.type==="subcommand")n.description&&o.push({command:t,description:n.description});else if(n.description&&n.cat){let r=a[n.cat];r||(a[n.cat]=r={}),r[t]=n}}for(const t in a){const n=t,r=a[n];r&&(i.push(O[n]),i.push(...c(r,E)),i.push(""))}return o.length&&(i.push((0,s.localize)(43,null)),i.push(...$(o.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Il=g;function v(m,w){return`${m||(0,s.localize)(44,null)}
${w||(0,s.localize)(45,null)}
${process.arch}`}e.$Jl=v}),define(ie[200],ne([0,1,86,198,112]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;class O extends R.$Mn{constructor(P){super(),this.f=P}call(P,f,c){return f==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(P,f,c)}async g(P,f){const c=(0,s.$Gl)(P,s.$Fl);c.debugRenderer=f;const $=c.extensionDevelopmentPath;if(!$)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow($,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!f)return{success:!0};const y=b.win;if(!y)return{success:!0};const g=y.webContents.debugger;let v=g.isAttached()?1/0:0;const m=(0,S.createServer)(w=>{v++===0&&g.attach();let d=!1;const h=u=>{d||w.write(JSON.stringify(u)+"\0")},l=(u,i,a,o)=>h({method:i,params:a,sessionId:o});y.on("close",()=>{g.removeListener("message",l),w.end(),d=!0}),g.addListener("message",l);let E=Buffer.alloc(0);w.on("data",u=>{E=Buffer.concat([E,u]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let a;try{const o=E.slice(0,i).toString("utf8");E=E.slice(i+1),a=JSON.parse(o)}catch(o){console.error("error reading cdp line",o)}g.sendCommand(a.method,a.params,a.sessionId).then(o=>h({id:a.id,sessionId:a.sessionId,result:o})).catch(o=>h({id:a.id,sessionId:a.sessionId,error:{code:0,message:o.message}}))}}),w.on("error",u=>{console.error("error on cdp pipe:",u)}),w.on("close",()=>{d=!0,--v===0&&g.detach()})});return await new Promise(w=>m.listen(0,w)),y.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$66b=O}),define(ie[62],ne([0,1,310,169,112]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=e.$Kl=void 0;function O(b,y){const g=(l,E)=>{console.warn((0,R.localize)(0,null,l,E))},v=l=>{console.warn((0,R.localize)(1,null,l))},m=(l,E)=>{console.warn((0,R.localize)(2,null,l,E))},w=l=>({onUnknownOption:E=>{s.$El.includes(l)||console.warn((0,R.localize)(3,null,E,l))},onMultipleValues:g,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:s.$El.includes(l)?w:void 0}),d={onUnknownOption:l=>{console.warn((0,R.localize)(4,null,l))},onMultipleValues:g,onEmptyValue:v,onDeprecatedOption:m,getSubcommandReporter:w},h=(0,s.$Gl)(b,s.$Fl,y?d:void 0);return h.goto&&h._.forEach(l=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,R.localize)(5,null))),h}function D(b){const y=b.findIndex(g=>!/^-/.test(g));if(y>-1)return[...b.slice(0,y),...b.slice(y+1)]}function P(b){let[,...y]=b;process.env.VSCODE_DEV&&(y=D(y)||[]);const g=!$(process.env);return O(y,g)}e.$Kl=P;function f(b){let[,,...y]=b;return process.env.VSCODE_DEV&&(y=D(y)||[]),O(y,!0)}e.$Ll=f;function c(b,...y){const g=b.indexOf("--");return g===-1?b.push(...y):b.splice(g,0,...y),b}e.$Ml=c;function $(b){return b.VSCODE_CLI==="1"}e.$Nl=$}),function(){"use strict";function J(e,S,R){function s(D,P){const f=O(D,P),c=[f];return e.isAbsolute(f)||c.unshift(R),e.resolve(...c)}function O(D,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const $=D["user-data-dir"];if($)return $;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(b,"AppData","Roaming")}break;case"darwin":c=e.join(S.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ie[201],ne([113,28,35]),function(e,S,R){return J(e,S,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=J(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[89],ne([0,1,28,199,201]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lm=e.$km=e.$jm=void 0;class O extends R.$gm{constructor(c,$){super(c,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(c,$.nameShort)},$)}}e.$jm=O;function D(f,c){return(0,R.$im)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,c,f.extensionEnvironment)}e.$km=D;function P(f,c){return(0,R.$im)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,c,f.extensionEnvironment)}e.$lm=P}),define(ie[202],ne([0,1,45,28,33]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=void 0;function O(D){const P=(0,s.$6f)((0,R.tmpdir)());try{return(0,S.writeFileSync)(P,""),D&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$l8b=O}),define(ie[203],ne([0,1,12,171]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;function s(D,P,f,c){try{O(D,P,f,c)}catch($){D.error($?.message??$)}return P}e.$xp=s;function O(D,P,f,c){const $=(b,y,g)=>{const v=b[y];if((0,S.$yf)(v)){const m=v,w=m.length;if(w>1&&m[0]==="%"&&m[w-1]==="%"){const d=m.substr(1,w-2);let h=f[d];h===void 0&&c&&(h=c[d]);const l=typeof h=="string"?h:h?.message,E=c?.[d],u=typeof E=="string"?E:E?.message;if(!l){u||D.warn(`[${P.name}]: ${(0,R.localize)(0,null,d)}`);return}if(g&&(y==="title"||y==="category")&&u&&u!==l){const i={value:l,original:u};b[y]=i}else b[y]=l}}else if((0,S.$Af)(v))for(const m in v)v.hasOwnProperty(m)&&(m==="commands"?$(v,m,!0):$(v,m,g));else if(Array.isArray(v))for(let m=0;m<v.length;m++)$(v,m,g)};for(const b in P)P.hasOwnProperty(b)&&$(P,b)}}),define(ie[204],ne([0,1,19,73,173,205]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function f(d){return d=d.trim(),d==="*"||D.test(d)}e.$Lo=f;function c(d){if(!f(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(D);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Mo=c;function $(d){if(!d)return null;const h=d.majorBase,l=d.majorMustEqual,E=d.minorBase;let u=d.minorMustEqual;const i=d.patchBase;let a=d.patchMustEqual;d.hasCaret&&(h===0||(u=!1),a=!1);let o=0;if(d.preRelease){const t=P.exec(d.preRelease);if(t){const[,n,r,p]=t;o=Date.UTC(Number(n),Number(r)-1,Number(p))}}return{majorBase:h,majorMustEqual:l,minorBase:E,minorMustEqual:u,patchBase:i,patchMustEqual:a,isMinimum:d.hasGreaterEquals,notBefore:o}}e.$No=$;function b(d,h,l){let E;typeof d=="string"?E=$(c(d)):E=d;let u;h instanceof Date?u=h.getTime():typeof h=="string"&&(u=new Date(h).getTime());let i;if(typeof l=="string"?i=$(c(l)):i=l,!E||!i)return!1;const a=E.majorBase,o=E.minorBase,t=E.patchBase;let n=i.majorBase,r=i.minorBase,p=i.patchBase;const A=i.notBefore;let C=i.majorMustEqual,k=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?a>n?!0:a<n?!1:o>r?!0:o<r||u&&u<A?!1:t>=p:(a===1&&n===0&&(!C||!k||!I)&&(n=1,r=0,p=0,C=!0,k=!1,I=!1),a<n?!1:a>n?!C:o<r?!1:o>r?!k:t<p?!1:t>p?!I:!(u&&u<A))}e.$Oo=b;function y(d,h,l,E,u){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([R.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([R.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([R.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([R.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([R.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!w(E.extensionDependencies))return i.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!w(E.activationEvents))return i.push([R.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([R.default.Error,s.localize(9,null,"main")]),i;{const t=(0,S.$vg)(l,E.main);(0,S.$pg)(t,l)||i.push([R.default.Warning,s.localize(10,null,t.path,l.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([R.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,S.$vg)(l,E.browser);(0,S.$pg)(t,l)||i.push([R.default.Warning,s.localize(12,null,t.path,l.path)])}}if(!O.valid(E.version))return i.push([R.default.Error,s.localize(13,null)]),i;const a=[];if(!g(d,h,E,u,a))for(const t of a)i.push([R.default.Error,t]);return i}e.$Po=y;function g(d,h,l,E,u){return E||typeof l.main>"u"&&typeof l.browser>"u"?!0:m(d,h,l.engines.vscode,u)}e.$Qo=g;function v(d,h,l){return d==="*"||m(h,l,d)}e.$Ro=v;function m(d,h,l,E=[]){const u=$(c(l));if(!u)return E.push(s.localize(14,null,l)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(s.localize(15,null,l)),!1}else if(!u.majorMustEqual)return E.push(s.localize(16,null,l)),!1;return b(d,h,u)?!0:(E.push(s.localize(17,null,d,l)),!1)}function w(d){if(!Array.isArray(d))return!1;for(let h=0,l=d.length;h<l;h++)if(typeof d[h]!="string")return!1;return!0}}),define(ie[206],ne([0,1,17,32]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;async function s(O,D,P){let f=P&&P.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const $=(await D.readFile(O.serviceMachineIdResource)).value.toString();f=(0,R.$dg)($)?$:null}catch{f=null}if(!f){f=(0,R.$eg)();try{await D.writeFile(O.serviceMachineIdResource,S.$be.fromString(f))}catch{}}return P?.store("storage.serviceMachineId",f,-1,1),f}e.$_o=s}),define(ie[77],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class S{constructor(s,O=[],D=!1){this.ctor=s,this.staticArguments=O,this.supportsDelayedInstantiation=D}}e.$Mh=S}),define(ie[207],ne([0,1,77]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.InstantiationType=void 0;const R=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function O(P,f,c){f instanceof S.$Mh||(f=new S.$Mh(f,[],!!c)),R.push([P,f])}e.$wr=O;function D(){return R}e.$xr=D}),define(ie[208],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class S{constructor(O,D){this.key=O,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$bq=S;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const D of this.a.values())D.outgoing.size===0&&O.push(D);return O}insertEdge(O,D){const P=this.lookupOrInsertNode(O),f=this.lookupOrInsertNode(D);P.outgoing.set(f.key,f),f.incoming.set(P.key,P)}removeNode(O){const D=this.b(O);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(O){const D=this.b(O);let P=this.a.get(D);return P||(P=new S(D,O),this.a.set(D,P)),P}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[D,P]of this.a)O.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,D]of this.a){const P=new Set([O]),f=this.c(D,P);if(f)return f}}c(O,D){for(const[P,f]of O.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const c=this.c(f,D);if(c)return c;D.delete(P)}}}e.$cq=R}),define(ie[5],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(S||(e._util=S={})),e.$Oh=s("instantiationService");function R(D,P,f){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:D,index:f}):(P[S.DI_DEPENDENCIES]=[{id:D,index:f}],P[S.DI_TARGET]=P)}function s(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const P=function(f,c,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,f,$)};return P.toString=()=>D,S.serviceIds.set(D,P),P}e.$Ph=s;function O(D){return D}e.$Qh=O}),define(ie[90],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0,e.$Y6b=(0,S.$Ph)("auxiliaryWindowsMainService")}),define(ie[63],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0,e.$G6b=(0,S.$Ph)("backupMainService")}),define(ie[18],ne([0,1,12,7,5]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,s.$Ph)("configurationService");function O(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof R.URI)}e.$ki=O;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof R.URI)}e.$li=D;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function f(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=f;function c(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$ni=c;function $(d,h){const l=Object.create(null);for(const E in d)b(l,E,d[E],h);return l}e.$oi=$;function b(d,h,l,E){const u=h.split("."),i=u.pop();let a=d;for(let o=0;o<u.length;o++){const t=u[o];let n=a[t];switch(typeof n){case"undefined":n=a[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${h} as ${u.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[i]=l}catch{E(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(a)}`)}else E(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(a)}`)}e.$pi=b;function y(d,h){const l=h.split(".");g(d,l)}e.$qi=y;function g(d,h){const l=h.shift();if(h.length===0){delete d[l];return}if(Object.keys(d).indexOf(l)!==-1){const E=d[l];typeof E=="object"&&!Array.isArray(E)&&(g(E,h),Object.keys(E).length===0&&delete d[l])}}function v(d,h,l){function E(a,o){let t=a;for(const n of o){if(typeof t!="object"||t===null)return;t=t[n]}return t}const u=h.split("."),i=E(d,u);return typeof i>"u"?l:i}e.$ri=v;function m(d,h,l){Object.keys(h).forEach(E=>{E!=="__proto__"&&(E in d?S.$Af(d[E])&&S.$Af(h[E])?m(d[E],h[E],l):l&&(d[E]=h[E]):d[E]=h[E])})}e.$si=m;function w(d){return d.replace(/[\[\]]/g,"")}e.$ti=w}),define(ie[114],ne([0,1,4,27,197,5,164,14]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$k),f.set("isLinux",S.$l),f.set("isWindows",S.$j),f.set("isWeb",S.$p),f.set("isMacNative",S.$k&&!S.$p),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function c(L,M){if(f.get(L)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(L,M)}e.$Li=c;const $=Object.prototype.hasOwnProperty;var b;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},g=(0,D.localize)(0,null),v=(0,D.localize)(1,null),m=(0,D.localize)(2,null),w=(0,D.localize)(3,null),d=(0,D.localize)(4,null),h=(0,D.localize)(5,null),l=(0,D.localize)(6,null),E=(0,D.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(M=y){this.k=M,this.d=new s.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(M){if(M===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(M).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const T=this.D(),N=T.type===17?h:void 0;throw this.h.push({message:d,offset:T.offset,lexeme:s.$Ki.getLexeme(T),additionalInfo:N}),u.c}return F}catch(F){if(F!==u.c)throw F;return}}l(){return this.m()}m(){const M=[this.o()];for(;this.y(16);){const F=this.o();M.push(F)}return M.length===1?M[0]:i.or(...M)}o(){const M=[this.s()];for(;this.y(15);){const F=this.s();M.push(F)}return M.length===1?M[0]:i.and(...M)}s(){if(this.y(2)){const M=this.D();switch(M.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,w),F?.negate()}case 17:return this.z(),j.create(M.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",M)}}return this.t()}t(){const M=this.D();switch(M.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const F=this.l();return this.A(1,w),F}case 17:{const F=M.lexeme;if(this.z(),this.y(9)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==10)throw this.B("REGEX",N);const B=N.lexeme,V=B.lastIndexOf("/"),oe=V===B.length-1?void 0:this.w(B.substring(V+1));let de;try{de=new RegExp(B.substring(1,V),oe)}catch{throw this.B("REGEX",N)}return se.create(F,de)}switch(N.type){case 10:case 19:{const B=[N.lexeme];this.z();let V=this.D(),oe=0;for(let be=0;be<N.lexeme.length;be++)N.lexeme.charCodeAt(be)===40?oe++:N.lexeme.charCodeAt(be)===41&&oe--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:oe++;break;case 1:oe--;break;case 10:case 18:for(let be=0;be<V.lexeme.length;be++)V.lexeme.charCodeAt(be)===40?oe++:N.lexeme.charCodeAt(be)===41&&oe--}if(oe<0)break;B.push(s.$Ki.getLexeme(V)),this.z(),V=this.D()}const de=B.join(""),ue=de.lastIndexOf("/"),he=ue===de.length-1?void 0:this.w(de.substring(ue+1));let ve;try{ve=new RegExp(de.substring(1,ue),he)}catch{throw this.B("REGEX",N)}return i.regex(F,ve)}case 18:{const B=N.lexeme;this.z();let V=null;if(!(0,R.$Be)(B)){const oe=B.indexOf("/"),de=B.lastIndexOf("/");if(oe!==de&&oe>=0){const ue=B.slice(oe+1,de),he=B[de+1]==="i"?"i":"";try{V=new RegExp(ue,he)}catch{throw this.B("REGEX",N)}}}if(V===null)throw this.B("REGEX",N);return se.create(F,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const N=this.u();return i.notIn(F,N)}switch(this.D().type){case 3:{this.z();const N=this.u();if(this.x().type===18)return i.equals(F,N);switch(N){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,N)}}case 4:{this.z();const N=this.u();if(this.x().type===18)return i.notEquals(F,N);switch(N){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,N)}}case 5:return this.z(),X.create(F,this.u());case 6:return this.z(),ae.create(F,this.u());case 7:return this.z(),z.create(F,this.u());case 8:return this.z(),x.create(F,this.u());case 13:return this.z(),i.in(F,this.u());default:return i.has(F)}}case 20:throw this.h.push({message:l,offset:M.offset,lexeme:"",additionalInfo:E}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const M=this.D();switch(M.type){case 17:case 18:return this.z(),M.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(M){return M.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(M){return this.C(M)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(M,F){if(this.C(M))return this.z();throw this.B(F,this.D())}B(M,F,T){const N=(0,D.localize)(8,null,M,s.$Ki.getLexeme(F)),B=F.offset,V=s.$Ki.getLexeme(F);return this.h.push({message:N,offset:B,lexeme:V,additionalInfo:T}),u.c}C(M){return this.D().type===M}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=u;class i{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(M){return p.create(M)}static equals(M,F){return A.create(M,F)}static notEquals(M,F){return I.create(M,F)}static regex(M,F){return se.create(M,F)}static in(M,F){return C.create(M,F)}static notIn(M,F){return k.create(M,F)}static not(M){return j.create(M)}static and(...M){return Q.create(M,null,!0)}static or(...M){return K.create(M,null,!0)}static greater(M,F){return z.create(M,F)}static greaterEquals(M,F){return x.create(M,F)}static smaller(M,F){return X.create(M,F)}static smallerEquals(M,F){return ae.create(M,F)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(M){return M==null?void 0:this.c.parse(M)}}e.$Ni=i;function a(L){const M=new u({regexParsingWithErrorRecovery:!1});return L.map(F=>(M.parse(F),M.lexingErrors.length>0?M.lexingErrors.map(T=>({errorMessage:T.additionalInfo?(0,D.localize)(9,null,T.additionalInfo):(0,D.localize)(10,null),offset:T.offset,length:T.lexeme.length})):M.parsingErrors.length>0?M.parsingErrors.map(T=>({errorMessage:T.additionalInfo?`${T.message}. ${T.additionalInfo}`:T.message,offset:T.offset,length:T.lexeme.length})):[]))}e.$Oi=a;function o(L,M){const F=L?L.substituteConstants():void 0,T=M?M.substituteConstants():void 0;return!F&&!T?!0:!F||!T?!1:F.equals(T)}e.$Pi=o;function t(L,M){return L.cmp(M)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return r.INSTANCE}}e.$Qi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return n.INSTANCE}}e.$Ri=r;class p{static create(M,F=null){const T=f.get(M);return typeof T=="boolean"?T?r.INSTANCE:n.INSTANCE:new p(M,F)}constructor(M,F){this.key=M,this.c=F,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:W(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=f.get(this.key);return typeof M=="boolean"?M?r.INSTANCE:n.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Si=p;class A{static create(M,F,T=null){if(typeof F=="boolean")return F?p.create(M,T):j.create(M,T);const N=f.get(M);return typeof N=="boolean"?F===(N?"true":"false")?r.INSTANCE:n.INSTANCE:new A(M,F,T)}constructor(M,F,T){this.c=M,this.d=F,this.f=T,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=f.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?r.INSTANCE:n.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ti=A;class C{static create(M,F){return new C(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:G(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.f),T=M.getValue(this.d);return Array.isArray(F)?F.includes(T):typeof T=="string"&&typeof F=="object"&&F!==null?$.call(F,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Ui=C;class k{static create(M,F){return new k(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=11,this.c=C.create(M,F)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=k;class I{static create(M,F,T=null){if(typeof F=="boolean")return F?j.create(M,T):p.create(M,T);const N=f.get(M);return typeof N=="boolean"?F===(N?"true":"false")?n.INSTANCE:r.INSTANCE:new I(M,F,T)}constructor(M,F,T){this.c=M,this.d=F,this.f=T,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=f.get(this.c);if(typeof M=="boolean"){const F=M?"true":"false";return this.d===F?n.INSTANCE:r.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Wi=I;class j{static create(M,F=null){const T=f.get(M);return typeof T=="boolean"?T?n.INSTANCE:r.INSTANCE:new j(M,F)}constructor(M,F){this.c=M,this.d=F,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:W(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=f.get(this.c);return typeof M=="boolean"?M?n.INSTANCE:r.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Xi=j;function U(L,M){if(typeof L=="string"){const F=parseFloat(L);isNaN(F)||(L=F)}return typeof L=="string"||typeof L=="number"?M(L):n.INSTANCE}class z{static create(M,F,T=null){return U(F,N=>new z(M,N,T))}constructor(M,F,T){this.c=M,this.d=F,this.f=T,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Yi=z;class x{static create(M,F,T=null){return U(F,N=>new x(M,N,T))}constructor(M,F,T){this.c=M,this.d=F,this.f=T,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Zi=x;class X{static create(M,F,T=null){return U(F,N=>new X(M,N,T))}constructor(M,F,T){this.c=M,this.d=F,this.f=T,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$1i=X;class ae{static create(M,F,T=null){return U(F,N=>new ae(M,N,T))}constructor(M,F,T){this.c=M,this.d=F,this.f=T,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:G(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$2i=ae;class se{static create(M,F){return new se(M,F)}constructor(M,F){this.d=M,this.f=F,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const F=this.f?this.f.source:"",T=M.f?M.f.source:"";return F<T?-1:F>T?1:0}equals(M){if(M.type===this.type){const F=this.f?this.f.source:"",T=M.f?M.f.source:"";return this.d===M.d&&F===T}return!1}substituteConstants(){return this}evaluate(M){const F=M.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$3i=se;class ce{static create(M){return new ce(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(M){return new ce(this.c.map(M))}negate(){return this.c}}e.$4i=ce;function Z(L){let M=null;for(let F=0,T=L.length;F<T;F++){const N=L[F].substituteConstants();if(L[F]!==N&&M===null){M=[];for(let B=0;B<F;B++)M[B]=L[B]}M!==null&&(M[F]=N)}return M===null?L:M}class Q{static create(M,F,T){return Q.d(M,F,T)}constructor(M,F){this.expr=M,this.c=F,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,T=this.expr.length;F<T;F++){const N=t(this.expr[F],M.expr[F]);if(N!==0)return N}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,T=this.expr.length;F<T;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=Z(this.expr);return M===this.expr?this:Q.create(M,this.c,!1)}evaluate(M){for(let F=0,T=this.expr.length;F<T;F++)if(!this.expr[F].evaluate(M))return!1;return!0}static d(M,F,T){const N=[];let B=!1;for(const V of M)if(V){if(V.type===1){B=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){N.push(...V.expr);continue}N.push(V)}if(N.length===0&&B)return r.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(t);for(let V=1;V<N.length;V++)N[V-1].equals(N[V])&&(N.splice(V,1),V--);if(N.length===1)return N[0];for(;N.length>1;){const V=N[N.length-1];if(V.type!==9)break;N.pop();const oe=N.pop(),de=N.length===0,ue=K.create(V.expr.map(he=>Q.create([he,oe],null,T)),null,de);ue&&(N.push(ue),N.sort(t))}if(N.length===1)return N[0];if(T){for(let V=0;V<N.length;V++)for(let oe=V+1;oe<N.length;oe++)if(N[V].negate().equals(N[oe]))return n.INSTANCE;if(N.length===1)return N[0]}return new Q(N,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new Q(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());this.c=K.create(M,this,!0)}return this.c}}e.$5i=Q;class K{static create(M,F,T){return K.d(M,F,T)}constructor(M,F){this.expr=M,this.c=F,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let F=0,T=this.expr.length;F<T;F++){const N=t(this.expr[F],M.expr[F]);if(N!==0)return N}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let F=0,T=this.expr.length;F<T;F++)if(!this.expr[F].equals(M.expr[F]))return!1;return!0}return!1}substituteConstants(){const M=Z(this.expr);return M===this.expr?this:K.create(M,this.c,!1)}evaluate(M){for(let F=0,T=this.expr.length;F<T;F++)if(this.expr[F].evaluate(M))return!0;return!1}static d(M,F,T){let N=[],B=!1;if(M){for(let V=0,oe=M.length;V<oe;V++){const de=M[V];if(de){if(de.type===0){B=!0;continue}if(de.type===1)return r.INSTANCE;if(de.type===9){N=N.concat(de.expr);continue}N.push(de)}}if(N.length===0&&B)return n.INSTANCE;N.sort(t)}if(N.length!==0){if(N.length===1)return N[0];for(let V=1;V<N.length;V++)N[V-1].equals(N[V])&&(N.splice(V,1),V--);if(N.length===1)return N[0];if(T){for(let V=0;V<N.length;V++)for(let oe=V+1;oe<N.length;oe++)if(N[V].negate().equals(N[oe]))return r.INSTANCE;if(N.length===1)return N[0]}return new K(N,F)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const F of this.expr)M.push(...F.keys());return M}map(M){return new K(this.expr.map(F=>F.map(M)),null)}negate(){if(!this.c){const M=[];for(const F of this.expr)M.push(F.negate());for(;M.length>1;){const F=M.shift(),T=M.shift(),N=[];for(const B of re(F))for(const V of re(T))N.push(Q.create([B,V],null,!1));M.unshift(K.create(N,null,!1))}this.c=K.create(M,this,!0)}return this.c}}e.$6i=K;class q extends p{static{this.d=[]}static all(){return q.d.values()}constructor(M,F,T){super(M,null),this.f=F,typeof T=="object"?q.d.push({...T,key:M}):T!==!0&&q.d.push({key:M,description:T,type:F!=null?typeof F:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return A.create(this.key,M)}notEqualsTo(M){return I.create(this.key,M)}}e.$7i=q,e.$8i=(0,O.$Ph)("contextKeyService");function W(L,M){return L<M?-1:L>M?1:0}function G(L,M,F,T){return L<F?-1:L>F?1:M<T?-1:M>T?1:0}function H(L,M){if(L.type===0||M.type===1)return!0;if(L.type===9)return M.type===9?Y(L.expr,M.expr):!1;if(M.type===9){for(const F of M.expr)if(H(L,F))return!0;return!1}if(L.type===6){if(M.type===6)return Y(M.expr,L.expr);for(const F of L.expr)if(H(F,M))return!0;return!1}return L.equals(M)}e.$9i=H;function Y(L,M){let F=0,T=0;for(;F<L.length&&T<M.length;){const N=L[F].cmp(M[T]);if(N<0)return!1;N===0&&F++,T++}return F===L.length}function re(L){return L.type===9?L.expr:[L]}}),define(ie[91],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.ID=void 0,e.ID="diagnosticsService",e.$qm=(0,S.$Ph)(e.ID);function R(O){return!!O.hostName&&!!O.errorMessage}e.$rm=R;class s{async getPerformanceInfo(D,P){return{}}async getSystemInfo(D,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,P){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$sm=s}),define(ie[115],ne([0,1,19,73,166,5,46,4,37]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.ConfirmResult=e.$Dv=e.$Cv=e.$Bv=void 0,e.$Bv=(0,O.$Ph)("dialogService");var c;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(c||(c={}));class ${a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,d){const h=[];switch(d){case c.Confirmation:{const l=w;l.primaryButton?h.push(l.primaryButton):h.push((0,s.localize)(0,null)),l.cancelButton?h.push(l.cancelButton):h.push((0,s.localize)(1,null));break}case c.Prompt:{const l=w;Array.isArray(l.buttons)&&l.buttons.length>0&&h.push(...l.buttons.map(E=>E.label)),l.cancelButton&&(l.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof l.cancelButton=="string"?h.push(l.cancelButton):l.cancelButton.label?h.push(l.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case c.Input:{const l=w;l.primaryButton?h.push(l.primaryButton):h.push((0,s.localize)(5,null)),l.cancelButton?h.push(l.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===R.default.Info?"info":w===R.default.Error?"error":w===R.default.Warning?"warning":"none"}f(w,d,h){const l=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&l.push(w.cancelButton);let E=l[d]?.run({checkboxChecked:h});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:h}}}e.$Cv=$,e.$Dv=(0,O.$Ph)("fileDialogService");var b;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const y=10;function g(m){const w=[];return w.push(...m.slice(0,y).map(d=>typeof d=="string"?d:(0,S.$sg)(d))),m.length>y&&(m.length-y===1?w.push((0,s.localize)(7,null)):w.push((0,s.localize)(8,null,m.length-y))),w.push(""),w.join(`
`)}e.$Ev=g;function v(m,w){const d=(0,f.$7m)(m);let h=(d.buttons??[]).map(i=>(0,D.$yv)(i)),l=(m.buttons||[]).map((i,a)=>a),E=0,u=d.cancelId??h.length-1;if(h.length>1){const i=typeof u=="number"?h[u]:void 0;if(P.$l||P.$k){if(typeof i=="string"&&h.length>1&&u!==1){h.splice(u,1),h.splice(1,0,i);const a=l[u];l.splice(u,1),l.splice(1,0,a),u=1}P.$l&&h.length>1&&(h=h.reverse(),l=l.reverse(),E=h.length-1,typeof i=="string"&&(u=E-1))}else if(P.$j&&typeof i=="string"&&h.length>1&&u!==h.length-1){h.splice(u,1),h.push(i);const a=l[u];l.splice(u,1),l.push(a),u=h.length-1}}return d.buttons=h,d.defaultId=E,d.cancelId=u,d.noLink=!0,d.title=d.title||w.nameLong,{options:d,buttonIndeces:l}}e.$Fv=v}),define(ie[116],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aU=e.$_T=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$$T=e.$0T=void 0,e.$0T=(0,S.$Ph)("encryptionService"),e.$$T=(0,S.$Ph)("encryptionMainService");var R;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function O(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$_T=O;function D(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$aU=D}),define(ie[36],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,S.$Ph)("environmentService"),e.$Xh=(0,S.$Qh)(e.$Wh)}),define(ie[117],ne([0,1,170,5]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$0n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function s(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=s;function O(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=O;function D(d,h){switch(d){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=D;function P(d,h){return h==="web"&&!d.includes("web")}e.$7n=P;function f(d,h,l){return P(h,l)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===l}e.$8n=f;function c(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$9n=c;var $;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var b;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function(d){d.Install="install",d.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var g;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$0n=(0,R.$Ph)("extensionGalleryService");var v;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var m;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class w extends Error{constructor(h,l){super(h),this.code=l,this.name=l}}e.$$n=w,e.$_n=(0,R.$Ph)("extensionManagementService"),e.$ao="extensionsIdentifiers/disabled",e.$bo="extensionsIdentifiers/enabled",e.$co=(0,R.$Ph)("IGlobalExtensionEnablementService"),e.$do=(0,R.$Ph)("IExtensionTipsService"),e.$eo=(0,S.localize)(0,null),e.$fo={value:e.$eo,original:"Extensions"},e.$go={value:(0,S.localize)(1,null),original:"Preferences"}}),define(ie[209],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=e.$a7b=void 0,e.$a7b=(0,S.$Ph)("extensionHostStarter"),e.$b7b="extensionHostStarter"}),define(ie[210],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kYb=e.$jYb=void 0,e.$jYb=(0,S.$Ph)("externalTerminal"),e.$kYb="Terminal.app"}),define(ie[211],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=void 0,e.$d7b=(0,S.$Ph)("externalTerminal")}),define(ie[212],ne([0,1,47,13,9,4,75,21,88,174,210]),function(J,e,S,R,s,O,D,P,f,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=e.$f7b=e.$e7b=void 0;const b=c.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends y{static{this.b="cmd.exe"}openTerminal(E,u){return this.spawnTerminal(S,E,f.$Bl(),u)}spawnTerminal(E,u,i,a){const o=u.windowsExec||g.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const t=s.$nc(o,".exe").toLowerCase();if(t==="cmder")return E.spawn(o,a?[a]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return o.indexOf(" ")>=0&&n.push('""'),n.push(o),t==="wt"&&n.push("-d ."),new Promise((r,p)=>{const A=w(process),C=E.spawn(i,n,{cwd:a,env:A});C.on("error",p),C.on("exit",()=>r())})}runInTerminal(E,u,i,a,o){const t="windowsExec"in o&&o.windowsExec?o.windowsExec:g.getDefaultTerminalWindows();return new Promise((n,r)=>{const p=`"${u} - ${b}"`,A=`""${i.join('" "')}" & pause"`,C=Object.assign({},w(process),a);Object.keys(C).filter(z=>C[z]===null).forEach(z=>delete C[z]);const k={cwd:u,env:C,windowsVerbatimArguments:!0};let I,j;s.$nc(t,".exe")==="wt"?(I=t,j=["-d",".",g.b,"/c",A]):(I=g.b,j=["/c","start",p,"/wait",t,"/c",A]),S.spawn(I,j,k).on("error",z=>{r(d(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!g.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return g.d}}e.$e7b=g;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(E,u){return this.spawnTerminal(S,E,u)}runInTerminal(E,u,i,a,o){const t=o.osxExec||$.$kYb;return new Promise((n,r)=>{if(t===$.$kYb||t==="iTerm.app"){const p=t===$.$kYb?"TerminalHelper":"iTermHelper",C=[R.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`).fsPath,"-t",E||b,"-w",u];for(const j of i)C.push("-a"),C.push(j);if(a){const j=Object.assign({},w(process),a);for(const U in j){const z=j[U];z===null?(C.push("-u"),C.push(U)):(C.push("-e"),C.push(`${U}=${z}`))}}let k="";const I=S.spawn(v.b,C);I.on("error",j=>{r(d(j))}),I.stderr.on("data",j=>{k+=j.toString()}),I.on("exit",j=>{if(j===0)n(void 0);else if(k){const U=k.split(`
`,1);r(new Error(U[0]))}else r(new Error(c.localize(1,null,p,j)))})}else r(new Error(c.localize(2,null,t)))})}spawnTerminal(E,u,i){const a=u.osxExec||$.$kYb;return new Promise((o,t)=>{const n=["-a",a];i&&n.push(i);const r=w(process),p=E.spawn("/usr/bin/open",n,{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})}}e.$f7b=v;class m extends y{static{this.b=c.localize(3,null)}openTerminal(E,u){return this.spawnTerminal(S,E,u)}runInTerminal(E,u,i,a,o){const t=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,r)=>{const p=[];t.then(A=>{A.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const C=`${h(i)}; echo; read -p "${m.b}" -n1;`;p.push(`''${C}''`);const k=Object.assign({},w(process),a);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const I={cwd:u,env:k};let j="";const U=S.spawn(A,p,I);U.on("error",z=>{r(d(z))}),U.stderr.on("data",z=>{j+=z.toString()}),U.on("exit",z=>{if(z===0)n(void 0);else if(j){const x=j.split(`
`,1);r(new Error(x[0]))}else r(new Error(c.localize(4,null,A,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!O.$l)m.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");m.d=new Promise(u=>{E?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return m.d}spawnTerminal(E,u,i){const a=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,t)=>{a.then(n=>{const r=w(process),p=E.spawn(n,[],{cwd:i,env:r});p.on("error",t),p.on("exit",()=>o())})})}}e.$g7b=m;function w(l){const E={...l.env};return(0,D.$zl)(E),E}function d(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(c.localize(5,null,l.path)):l}function h(l){let E="";for(const u of l)u.indexOf(" ")>=0?E+='"'+u+'"':E+=u,E+=" ";return E}}),define(ie[16],ne([0,1,56,9,27,12,7,176,5,4,13,71]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,f.$Ph)("fileService");function y(H){return H.create===!0}e.$_j=y;var g;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var v;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function m(H){const Y=H;return!!Y&&typeof Y.onDidChange=="function"}e.$ak=m;var w;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function d(H){return!!(H.capabilities&2)}e.$bk=d;function h(H){return!!(H.capabilities&8)}e.$ck=h;function l(H){return!!(H.capabilities&131072)}e.$dk=l;function E(H){return!!(H.capabilities&4)}e.$ek=E;function u(H){return!!(H.capabilities&16)}e.$fk=u;function i(H){return d(H)?!!(H.capabilities&16384):!1}e.$gk=i;function a(H){return d(H)?!!(H.capabilities&32768):!1}e.$hk=a;function o(H){return!!(H.capabilities&65536)}e.$ik=o;function t(H){return!!(H.capabilities&2048)}e.$jk=t;var n;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class r extends Error{static create(Y,re){const L=new r(Y.toString(),re);return C(L,re),L}constructor(Y,re){super(Y),this.code=re}}e.$kk=r;function p(H,Y){return r.create(H,Y)}e.$lk=p;function A(H){return H||p((0,P.localize)(0,null),n.Unknown)}e.$mk=A;function C(H,Y){return H.name=Y?`${Y} (FileSystemError)`:"FileSystemError",H}e.$nk=C;function k(H){if(!H)return n.Unknown;if(H instanceof r)return H.code;const Y=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Y)return n.Unknown;switch(Y[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$ok=k;function I(H){if(H instanceof ae)return H.fileOperationResult;switch(k(H)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$pk=I;var j;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class U{constructor(Y,re,L){this.resource=Y,this.operation=re,this.target=L}isOperation(Y){return this.operation===Y}}e.$qk=U;var z;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class x{static{this.a=null}constructor(Y,re){this.c=re,this.b=void 0,this.d=new b.$V(()=>{const L=S.$Vh.forUris(()=>this.c);return L.fill(this.rawAdded.map(M=>[M,!0])),L}),this.f=new b.$V(()=>{const L=S.$Vh.forUris(()=>this.c);return L.fill(this.rawUpdated.map(M=>[M,!0])),L}),this.g=new b.$V(()=>{const L=S.$Vh.forUris(()=>this.c);return L.fill(this.rawDeleted.map(M=>[M,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of Y){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.b!==x.a&&(typeof L.cId=="number"?this.b===void 0?this.b=L.cId:this.b!==L.cId&&(this.b=x.a):this.b!==void 0&&(this.b=x.a))}}contains(Y,...re){return this.h(Y,{includeChildren:!1},...re)}affects(Y,...re){return this.h(Y,{includeChildren:!0},...re)}h(Y,re,...L){if(!Y)return!1;const M=L.length>0;return!!((!M||L.includes(1))&&(this.d.value.get(Y)||re.includeChildren&&this.d.value.findSuperstr(Y))||(!M||L.includes(0))&&(this.f.value.get(Y)||re.includeChildren&&this.f.value.findSuperstr(Y))||(!M||L.includes(2))&&(this.g.value.findSubstr(Y)||re.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}e.$rk=x;function X(H,Y,re){return!H||!Y||H===Y||Y.length>H.length?!1:(Y.charAt(Y.length-1)!==R.sep&&(Y+=R.sep),re?(0,s.$3e)(H,Y):H.indexOf(Y)===0)}e.$sk=X;class ae extends Error{constructor(Y,re,L){super(Y),this.fileOperationResult=re,this.options=L}}e.$tk=ae;class se extends ae{constructor(Y,re,L,M){super(Y,re,M),this.fileOperationResult=re,this.size=L}}e.$uk=se;class ce extends ae{constructor(Y,re,L){super(Y,2,L),this.stat=re}}e.$vk=ce;var Z;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var Q;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Dk="";function K(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$Ek=K;async function q(H,Y){if(!Y.hasProvider(D.URI.from({scheme:H.scheme})))return new Promise(re=>{const L=Y.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===H.scheme&&M.added&&(L.dispose(),re())})})}e.$Fk=q;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(Y){return(0,O.$Cf)(Y)||(Y=0),Y<W.KB?(0,P.localize)(1,null,Y.toFixed(0)):Y<W.MB?(0,P.localize)(2,null,(Y/W.KB).toFixed(2)):Y<W.GB?(0,P.localize)(3,null,(Y/W.MB).toFixed(2)):Y<W.TB?(0,P.localize)(4,null,(Y/W.GB).toFixed(2)):(0,P.localize)(5,null,(Y/W.TB).toFixed(2))}}e.$Gk=W;function G(H){const Y=typeof H=="string"||H?.scheme===$.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===$.Schemas.file?1024*W.MB:Y?10*W.MB:c.$p?50*W.MB:1024*W.MB}e.$Hk=G}),define(ie[118],ne([0,1,17,14,177,16]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function D($,b,y,g,v,m){let w;try{await P($,b,y,g,v,m)}catch(d){w=d}finally{w&&v.errorTransformer&&(w=v.errorTransformer(w)),typeof w<"u"&&y.error(w),y.end()}}e.$Mp=D;async function P($,b,y,g,v,m){f(m);const w=await $.open(b,{create:!1});try{f(m);let d=0,h=0,l=v&&typeof v.length=="number"?v.length:void 0,E=S.$be.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),u=v&&typeof v.position=="number"?v.position:0,i=0;do h=await $.read(w,u,E.buffer,i,E.byteLength-i),u+=h,i+=h,d+=h,typeof l=="number"&&(l-=h),i===E.byteLength&&(await y.write(g(E)),E=S.$be.alloc(Math.min(v.bufferSize,typeof l=="number"?l:v.bufferSize)),i=0);while(h>0&&(typeof l!="number"||l>0)&&f(m)&&c(d,v));if(i>0){let a=i;typeof l=="number"&&(a=Math.min(i,l)),y.write(g(E.slice(0,a)))}}catch(d){throw(0,O.$mk)(d)}finally{await $.close(w)}}function f($){if($.isCancellationRequested)throw(0,R.$6)();return!0}function c($,b){if(typeof b?.limits?.size=="number"&&$>b.limits.size)throw(0,O.$lk)((0,s.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[64],ne([0,1,104,2,9,4,7,16]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=void 0;function f(d){return d.recursive===!0}e.$Op=f;class c extends R.$Sc{static{this.a=5}constructor(h,l,E,u){super(),this.h=h,this.j=l,this.m=E,this.n=u,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const h=new R.$Rc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(l=>this.h(l))),h.add(this.b.onDidLogMessage(l=>this.j(l))),h.add(this.b.onDidError(l=>this.t(l)))}t(h){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Pp=c;class $ extends c{constructor(h,l,E){super(h,l,E,{type:"node.js",restartOnError:!1})}}e.$Qp=$;class b extends c{constructor(h,l,E){super(h,l,E,{type:"universal",restartOnError:!0})}}e.$Rp=b;function y(d){return d.map(h=>({type:h.type,resource:D.URI.revive(h.resource),cId:h.cId}))}e.$Sp=y;function g(d){const h=new w;for(const l of d)h.processEvent(l);return h.coalesce()}e.$Tp=g;function v(d,h){return typeof h=="string"&&!h.startsWith(S.$sj)&&!(0,s.$ic)(h)?{base:d,pattern:h}:h}e.$Up=v;function m(d,h){const l=[];for(const E of h)l.push((0,S.$wj)(v(d,E)));return l}e.$Vp=m;class w{constructor(){this.a=new Set,this.b=new Map}c(h){return O.$l?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const l=this.b.get(this.c(h));let E=!1;if(l){const u=l.type,i=h.type;l.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?E=!0:u===1&&i===2?(this.b.delete(this.c(h)),this.a.delete(l)):u===2&&i===1?l.type=0:u===1&&i===0||(l.type=i)}else E=!0;E&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],l=[];return Array.from(this.a).filter(E=>E.type!==2?(h.push(E),!1):!0).sort((E,u)=>E.resource.fsPath.length-u.resource.fsPath.length).filter(E=>l.some(u=>(0,P.$sk)(E.resource.fsPath,u,!O.$l))?!1:(l.push(E.resource.fsPath),!0)).concat(h)}}}),define(ie[213],ne([0,1,17,49,14,3,2,61,32,16,64]),function(J,e,S,R,s,O,D,P,f,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=void 0,e.$rN="localFilesystem";class b extends D.$Sc{constructor(g,v){super(),this.a=g,this.b=v,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$Nd),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$Nd),this.onDidWatchError=this.g.event,this.h=(0,f.$eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,v){const{buffer:m}=await this.a.call("readFile",[g,v]);return m}readFileStream(g,v,m){const w=(0,P.$2d)(h=>S.$be.concat(h.map(l=>S.$be.wrap(l))).buffer),d=new D.$Rc;return d.add(this.a.listen("readFileStream",[g,v])(h=>{if(h instanceof S.$be)w.write(h.buffer);else{if(h==="end")w.end();else{let l;if(h instanceof Error)l=h;else{const E=h;l=(0,c.$lk)(E.message??(0,R.$Ai)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}w.error(l),w.end()}d.dispose()}})),d.add(m.onCancellationRequested(()=>{w.error((0,s.$6)()),w.end(),d.dispose()})),w}writeFile(g,v,m){return this.a.call("writeFile",[g,S.$be.wrap(v),m])}open(g,v){return this.a.call("open",[g,v])}close(g){return this.a.call("close",[g])}async read(g,v,m,w,d){const[h,l]=await this.a.call("read",[g,v,d]);return m.set(h.buffer.slice(0,l),w),l}write(g,v,m,w,d){return this.a.call("write",[g,v,S.$be.wrap(m),w,d])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,v){return this.a.call("delete",[g,v])}rename(g,v,m){return this.a.call("rename",[g,v,m])}copy(g,v,m){return this.a.call("copy",[g,v,m])}cloneFile(g,v){return this.a.call("cloneFile",[g,v])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const v=g;this.f.fire((0,$.$Sp)(v))}else{const v=g;this.g.fire(v)}}))}watch(g,v){const m=(0,f.$eg)();return this.a.call("watch",[this.h,m,g,v]),(0,D.$Qc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$sN=b}),define(ie[214],ne([0,1,45,8,22,33,2,84,9,4,19,7,105,21,64]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0;class m extends D.$Sc{static{this.a=100}static{this.b=75}constructor(h,l,E,u){super(),this.m=h,this.n=l,this.r=E,this.s=u,this.c=this.B(new R.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new R.$8g(i=>this.z(i),m.b)),this.g=(0,v.$Vp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Vp)(this.m.path,this.m.includes):void 0,this.j=new s.$Xd,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await g.Promises.stat(h);this.B(await this.w(h,l.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let l=h.path;try{l=await g.Promises.realpath(h.path),h.path===l&&(l=await(0,y.$6p)(h.path)??h.path),h.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${l})`)}catch{}return l}async w(h,l){if(c.$k&&(0,O.$Xf)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Sc.None;const E=new s.$Xd(this.j.token),u=new D.$Rc;try{const i=b.URI.file(this.m.path),a=(0,f.$nc)(h),o=(0,S.watch)(h);u.add((0,D.$Qc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${h}'`);const t=new Set;if(l)try{for(const r of await g.Promises.readdir(h))t.add(r)}catch(r){this.D(r)}const n=new Map;u.add((0,D.$Qc)(()=>{for(const[,r]of n)r.dispose();n.clear()})),o.on("error",(r,p)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${r}, ${p})`),this.dispose()}),o.on("change",(r,p)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${p}`);let A="";if(p&&(A=p.toString(),c.$k&&(A=(0,P.$ol)(A))),!(!A||r!=="change"&&r!=="rename"))if(l)if(r==="rename"){n.get(A)?.dispose();const C=setTimeout(async()=>{if(n.delete(A),A===a&&!await g.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,f.$jc)(h,A));if(E.token.isCancellationRequested)return;let I;k?t.has(A)?I=0:(I=1,t.add(A)):(t.delete(A),I=2),this.y({resource:(0,$.$vg)(i,A),type:I,cId:this.m.correlationId})},m.a);n.set(A,(0,D.$Qc)(()=>clearTimeout(C)))}else{let C;t.has(A)?C=0:(C=1,t.add(A)),this.y({resource:(0,$.$vg)(i,A),type:C,cId:this.m.correlationId})}else if(r==="rename"||A!==a){const C=setTimeout(async()=>{const k=await g.Promises.exists(h);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),u.add(await this.w(h,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);u.clear(),u.add((0,D.$Qc)(()=>clearTimeout(C)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await g.Promises.exists(h)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${i.toString()})`)}return(0,D.$Qc)(()=>{E.dispose(!0),u.dispose()})}y(h,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!l&&this.g.some(E=>E(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(E=>E(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const l=(0,v.$Tp)(h);if(l.length>0){if(this.s)for(const u of l)this.G(` >> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(c.$l)return g.Promises.exists(h);try{const l=(0,f.$nc)(h);return(await g.Promises.readdir((0,f.$mc)(h))).some(u=>u===l)}catch(l){return this.G(l),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$9p=m;async function w(d,h,l,E,u=512){const i=await g.Promises.open(d,"r"),a=Buffer.allocUnsafe(u),o=new s.$Xd(E);let t,n=!1;const r={path:d,excludes:[],recursive:!1},p=new m(r,A=>{(async()=>{for(const{type:C}of A)if(C===0){if(n)return;n=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:k}=await g.Promises.read(i,a,0,u,null);if(!k||o.token.isCancellationRequested)break;h(a.slice(0,k))}}catch(k){t=new Error(k),o.dispose(!0)}finally{n=!1}}})()});return await p.ready,l(),new Promise((A,C)=>{o.token.onCancellationRequested(async()=>{p.dispose();try{await g.Promises.close(i)}catch(k){t=new Error(k)}t?C(t):A()})})}e.$0p=w}),define(ie[215],ne([0,1,3,104,2,4,214]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class P extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new S.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(c){const $=this.j(c),b=$.filter(g=>{const v=this.c.get(g.path);return v?!(0,R.$Aj)(v.request.excludes,g.excludes)||!(0,R.$Aj)(v.request.includes,g.includes):!0}),y=Array.from(this.c.values()).filter(({request:g})=>!$.find(v=>v.path===g.path&&(0,R.$Aj)(v.excludes,g.excludes)&&(0,R.$Aj)(v.includes,g.includes))).map(({request:g})=>g.path);b.length&&this.m(`Request to start watching: ${b.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"}, correlationId: ${typeof g.correlationId=="number"?g.correlationId:"<none>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const g of y)this.h(g);for(const g of b)this.g(g)}g(c){const $=new D.$9p(c,y=>this.a.fire(y),y=>this.b.fire(y),this.f),b={request:c,instance:$};this.c.set(c.path,b)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const $=this.c.get(c);$&&(this.c.delete(c),$.instance.dispose())}j(c){const $=new Map;for(const b of c){const y=O.$l?b.path:b.path.toLowerCase();let g=$.get(b.correlationId);g||(g=new Map,$.set(b.correlationId,g)),g.set(y,b)}return Array.from($.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,$]of this.c)$.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,$){return $?`[File Watcher (node.js)] ${c} (path: ${$.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$$p=P}),define(ie[216],ne([0,1,64,215]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class s extends S.$Qp{constructor(D,P,f){super(D,P,f),this.s()}r(D){return D.add(new R.$$p)}}e.$_p=s}),define(ie[217],ne([0,1,13,42,160,64]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class D extends O.$Rp{constructor(f,c,$){super(f,c,$),this.s()}r(f){const c=f.add(new s.$3p(S.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(c.onDidProcessExit(({code:$,signal:b})=>this.t(`terminated by itself with code ${$}, signal: ${b}`))),R.ProxyChannel.toService((0,R.$wh)(c.getChannel("watcher")))}}e.$4p=D}),define(ie[92],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class S{constructor(...s){this.a=new Map;for(const[O,D]of s)this.set(O,D)}set(s,O){const D=this.a.get(s);return this.a.set(s,O),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Nh=S}),define(ie[218],ne([0,1,8,14,2,77,208,5,92,101]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;const $=!1;class b extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class y{constructor(w=new f.$Nh,d=!1,h,l=$){this.f=w,this.g=d,this.h=h,this.i=l,this.o=new Set,this.f.set(P.$Oh,this),this._globalGraph=l?h?._globalGraph??new D.$cq(E=>E):void 0}createChild(w){return new y(w,this.g,this,this.i)}invokeFunction(w,...d){const h=v.traceInvocation(this.i,w);let l=!1;try{return w({get:u=>{if(l)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(u,h);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...d)}finally{l=!0,h.stop()}}createInstance(w,...d){let h,l;return w instanceof O.$Mh?(h=v.traceCreation(this.i,w.ctor),l=this.j(w.ctor,w.staticArguments.concat(d),h)):(h=v.traceCreation(this.i,w),l=this.j(w,d,h)),h.stop(),l}j(w,d=[],h){const l=P._util.getServiceDependencies(w).sort((i,a)=>i.index-a.index),E=[];for(const i of l){const a=this.m(i.id,h);a||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(a)}const u=l.length>0?l[0].index:d.length;if(d.length!==u){console.trace(`[createInstance] First service dependency of ${w.name} at position ${u+1} conflicts with ${d.length} static arguments`);const i=u-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,u)}return Reflect.construct(w,d.concat(E))}k(w,d){if(this.f.get(w)instanceof O.$Mh)this.f.set(w,d);else if(this.h)this.h.k(w,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const d=this.f.get(w);return!d&&this.h?this.h.l(w):d}m(w,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const h=this.l(w);return h instanceof O.$Mh?this.q(w,h,d.branch(w,!0)):(d.branch(w,!1),h)}q(w,d,h){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,d,h)}finally{this.o.delete(w)}}r(w,d,h){const l=new D.$cq(i=>i.id.toString());let E=0;const u=[{id:w,desc:d,_trace:h}];for(;u.length;){const i=u.pop();if(l.lookupOrInsertNode(i),E++>1e3)throw new b(l);for(const a of P._util.getServiceDependencies(i.desc.ctor)){const o=this.l(a.id);if(o||this.u(`[createInstance] ${w} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),o instanceof O.$Mh){const t={id:a.id,desc:o,_trace:i._trace.branch(a.id,!0)};l.insertEdge(i,t),u.push(t)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new b(l);break}for(const{data:a}of i){if(this.l(a.id)instanceof O.$Mh){const t=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,t)}l.removeNode(a)}}return this.l(w)}s(w,d,h=[],l,E){if(this.f.get(w)instanceof O.$Mh)return this.t(w,d,h,l,E);if(this.h)return this.h.s(w,d,h,l,E);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(w,d,h=[],l,E){if(l){const u=new y(void 0,this.g,this,this.i);u.c=String(w);const i=new Map,a=new S.$$g(()=>{const o=u.j(d,h,E);for(const[t,n]of i){const r=o[t];if(typeof r=="function")for(const p of n)r.apply(o,p)}return i.clear(),o});return new Proxy(Object.create(null),{get(o,t){if(!a.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let p=i.get(t);return p||(p=new c.$2c,i.set(t,p)),(C,k,I)=>{const j=p.push([C,k,I]);return(0,s.$Qc)(j)}}if(t in o)return o[t];const n=a.value;let r=n[t];return typeof r!="function"||(r=r.bind(n),o[t]=r),r},set(o,t,n){return a.value[t]=n,!0},getPrototypeOf(o){return d.prototype}})}else return this.j(d,h,E)}u(w,d){if(d&&console.warn(w),this.g)throw new Error(w)}}e.$dq=y;var g;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(g||(g={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,d){return w?new v(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(w,d){return w?new v(1,d.name):v.c}static{this.f=0}constructor(w,d){this.type=w,this.name=d,this.g=Date.now(),this.h=[]}branch(w,d){const h=new v(3,w.toString());return this.h.push([w,d,h]),h}stop(){const w=Date.now()-this.g;v.f+=w;let d=!1;function h(E,u){const i=[],a=new Array(E+1).join("	");for(const[o,t,n]of u.h)if(t&&n){d=!0,i.push(`${a}CREATES -> ${o}`);const r=h(E+1,n);r&&i.push(r)}else i.push(`${a}uses -> ${o}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(w>2||d)&&v.all.add(l.join(`
`))}}e.$eq=v}),define(ie[219],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bxb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$bxb=(0,S.$Ph)("issueService")}),define(ie[6],ne([0,1,49,3,55,2,31,4,19,12,7,114,5]),function(J,e,S,R,s,O,D,P,f,c,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,y.$Ph)("logService"),e.$$i=(0,y.$Ph)("loggerService");function g(){return new Date().toISOString()}function v(C){return(0,c.$Cf)(C)}e.$_i=v;var m;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$aj=m.Info;function w(C,k,I){switch(k){case m.Trace:C.trace(I);break;case m.Debug:C.debug(I);break;case m.Info:C.info(I);break;case m.Warning:C.warn(I);break;case m.Error:C.error(I);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=w;function d(C,k=!1){let I="";for(let j=0;j<C.length;j++){let U=C[j];if(U instanceof Error&&(U=(0,S.$Ai)(U,k)),typeof U=="object")try{U=JSON.stringify(U)}catch{}I+=(j>0?" ":"")+U}return I}class h extends O.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new R.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$cj=h;class l extends h{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(m.Trace)&&this.g(m.Trace,d([k,...I],!0))}debug(k,...I){this.f(m.Debug)&&this.g(m.Debug,d([k,...I]))}info(k,...I){this.f(m.Info)&&this.g(m.Info,d([k,...I]))}warn(k,...I){this.f(m.Warning)&&this.g(m.Warning,d([k,...I]))}error(k,...I){if(this.f(m.Error))if(k instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=k.stack,this.g(m.Error,d(j))}else this.g(m.Error,d([k,...I]))}flush(){}}e.$dj=l;class E extends h{constructor(k=e.$aj){super(),this.setLevel(k),this.g=!P.$j}trace(k,...I){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,k,...I):console.log(`[main ${g()}]`,k,...I))}debug(k,...I){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,k,...I):console.log(`[main ${g()}]`,k,...I))}info(k,...I){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,k,...I):console.log(`[main ${g()}]`,k,...I))}warn(k,...I){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,k,...I):console.warn(`[main ${g()}]`,k,...I))}error(k,...I){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,k,...I):console.error(`[main ${g()}]`,k,...I))}dispose(){}flush(){}}e.$ej=E;class u extends h{constructor(k=e.$aj,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$fj=u;class i extends h{constructor(k,I=e.$aj){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...I])}debug(k,...I){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...I])}info(k,...I){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...I])}warn(k,...I){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...I])}error(k,...I){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,S.$Ai)(k,this.f(m.Trace))}dispose(){}flush(){}}e.$gj=i;class a extends h{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const j of this.g)j.trace(k,...I)}debug(k,...I){for(const j of this.g)j.debug(k,...I)}info(k,...I){for(const j of this.g)j.info(k,...I)}warn(k,...I){for(const j of this.g)j.warn(k,...I)}error(k,...I){for(const j of this.g)j.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$hj=a;class o extends O.$Sc{constructor(k,I,j){if(super(),this.h=k,this.j=I,this.b=new D.$Ac,this.c=this.B(new R.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Nd),this.onDidChangeVisibility=this.g.event,j)for(const U of j)this.b.set(U.resource,{logger:void 0,info:U})}m(k){return(0,c.$yf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const j=this.n(k),U=(0,c.$yf)(k)?k:I?.id??(0,s.$Di)(j.toString()).toString(16);let z=this.b.get(j)?.logger;const x=I?.logLevel==="always"?m.Trace:I?.logLevel;z||(z=this.s(j,x??this.getLogLevel(j)??this.h,{...I,id:U}));const X={logger:z,info:{resource:j,id:U,logLevel:x,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(X.info),this.b.set(j,X),z}n(k){return(0,c.$yf)(k)?(0,f.$vg)(this.j,`${k}.log`):k}setLogLevel(k,I){if($.URI.isUri(k)){const j=k,U=I,z=this.b.get(j);z&&U!==z.info.logLevel&&(z.info.logLevel=U===this.h?void 0:U,z.logger?.setLevel(U),this.b.set(z.info.resource,z),this.f.fire([j,U]))}else{this.h=k;for(const[j,U]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const j=this.m(k);j&&I!==!j.info.hidden&&(j.info.hidden=!I,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=o;class t{constructor(){this.onDidChangeLogLevel=new R.$Nd().event}setLevel(k){}getLevel(){return m.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$jj=t;class n extends t{}e.$kj=n;function r(C){if(C.verbose)return m.Trace;if(typeof C.logLevel=="string"){const k=A(C.logLevel.toLowerCase());if(k!==void 0)return k}return e.$aj}e.$lj=r;function p(C){switch(C){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$mj=p;function A(C){switch(C){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$nj=A,e.$oj=new b.$7i("logLevel",p(m.Info))});var te=this&&this.__param||function(J,e){return function(S,R){e(S,R,J)}};define(ie[220],ne([0,1,15,4,6]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=void 0;const O=S.safeStorage;let D=class{constructor(f){this.a=f,S.app.commandLine.getSwitchValue("password-store")==="basic"&&O.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(O.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(f){let c;try{if(c=JSON.parse(f),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const $=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=O.decryptString($);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch($){throw this.a.error($),$}}isEncryptionAvailable(){return Promise.resolve(O.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$j)return Promise.resolve("dpapi");if(R.$k)return Promise.resolve("keychain_access");if(O.getSelectedStorageBackend)try{const f=O.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$j)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$k)throw new Error("Setting plain text encryption is not supported on macOS.");if(!O.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");O.setUsePlainTextEncryption(!0)}};e.$_6b=D,e.$_6b=D=Ee([te(0,s.$0i)],D)}),define(ie[221],ne([0,1,23,8,14,3,2,9,64,6]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class $ extends D.$Sc{constructor(y,g){super(),this.a=y,this.b=g,this.c=this.B(new O.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Rg(0)),this.w=[],this.y=this.B(new R.$Rg(0))}watch(y,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n(y,g):this.z(y,g)}n(y,g){const v={path:this.H(y),excludes:g.excludes,includes:g.includes,recursive:g.recursive,correlationId:g.correlationId},m=(0,S.$Ub)(this.j,v);return this.r(),(0,D.$Qc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$1)(y))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,f.$Sp)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const g of this.j)(0,f.$Op)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const g of this.j)(0,f.$Op)(g)&&y.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,g){const v={path:this.H(y),excludes:g.excludes,includes:g.includes,recursive:!1,correlationId:g.correlationId},m=(0,S.$Ub)(this.w,v);return this.C(),(0,D.$Qc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,f.$Sp)(y)),y=>this.G(y),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,P.$hc)(y.fsPath)}}e.$Wp=$}),define(ie[222],ne([0,1,23,8,17,22,3,55,70,2,56,13,65,19,61,175,16,118,6,14]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;let u=class extends c.$Sc{static{E=this}constructor(a){super(),this.b=a,this.a=256*1024,this.c=this.B(new D.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Nd),this.Y=this.B(new D.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$3g)}registerProvider(a,o){if(this.h.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${a}`);const t=new c.$Rc;return this.h.set(a,o),this.c.fire({added:!0,scheme:a,provider:o}),t.add(o.onDidChangeFile(n=>{const r=new w.$rk(n,!this.S(o));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof o.onDidWatchError=="function"&&t.add(o.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:a}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:a,provider:o}),this.h.delete(a),(0,c.$Nc)(t)})}getProvider(a){return this.h.get(a)}async activateProvider(a){const o=[];this.f.fire({scheme:a,join(t){o.push(t)}}),!this.h.has(a)&&await R.Promises.settled(o)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.h.has(a.scheme)}hasCapability(a,o){const t=this.h.get(a.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return f.Iterable.map(this.h,([a,o])=>({scheme:a,capabilities:o.capabilities}))}async j(a){if(!(0,g.$zg)(a))throw new w.$tk((0,m.localize)(0,null,this.sb(a)),8);await this.activateProvider(a.scheme);const o=this.h.get(a.scheme);if(!o){const t=new l.$bb;throw t.message=(0,m.localize)(1,null,a.toString()),t}return o}async m(a){const o=await this.j(a);if((0,w.$ek)(o)||(0,w.$bk)(o)||(0,w.$fk)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(a){const o=await this.j(a);if((0,w.$ek)(o)||(0,w.$bk)(o))return o;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,o){try{return await this.s(a,o)}catch(t){throw(0,w.$ok)(t)===w.FileSystemProviderErrorCode.FileNotFound?new w.$tk((0,m.localize)(2,null,this.sb(a)),1):(0,w.$mk)(t)}}async s(a,o){const t=await this.j(a),n=this.S(t),r=o?.resolveTo,p=o?.resolveSingleChildDescendants,A=o?.resolveMetadata,C=await t.stat(a);let k;return this.t(t,a,C,void 0,!!A,(I,j)=>(k||(k=$.$Vh.forUris(()=>!n),k.set(a,!0),r&&k.fill(!0,r)),k.get(I.resource)||k.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&p?j===1:!1))}async t(a,o,t,n,r,p){const{providerExtUri:A}=this.R(a),C={resource:o,name:A.basename(o),isFile:(t.type&w.FileType.File)!==0,isDirectory:(t.type&w.FileType.Directory)!==0,isSymbolicLink:(t.type&w.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&w.FilePermission.Readonly)||!!(a.capabilities&2048),locked:!!((t.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Ek)({mtime:t.mtime,size:t.size}),children:void 0};if(C.isDirectory&&p(C,n)){try{const k=await a.readdir(o),I=await R.Promises.settled(k.map(async([j,U])=>{try{const z=A.joinPath(o,j),x=r?await a.stat(z):{type:U};return await this.t(a,z,x,k.length,r,p)}catch(z){return this.b.trace(z),null}}));C.children=(0,S.$Hb)(I)}catch(k){this.b.trace(k),C.children=[]}return C}return C}async resolveAll(a){return R.Promises.settled(a.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(a){const o=await this.j(a),t=await o.stat(a);return this.t(o,a,t,void 0,!0,()=>!1)}async exists(a){const o=await this.j(a);try{return!!await o.stat(a)}catch{return!1}}async canCreateFile(a,o){try{await this.u(a,o)}catch(t){return t}return!0}async u(a,o){if(!o?.overwrite&&await this.exists(a))throw new w.$tk((0,m.localize)(3,null,this.sb(a)),3,o)}async createFile(a,o=s.$be.fromString(""),t){await this.u(a,t);const n=await this.writeFile(a,o);return this.r.fire(new w.$qk(a,0,n)),n}async writeFile(a,o,t){const n=this.qb(await this.n(a),a),{providerExtUri:r}=this.R(n);let p=t;if((0,w.$hk)(n)&&!p?.atomic){const A=n.enforceAtomicWriteFile?.(a);A&&(p={...t,atomic:A})}try{await this.w(n,a,p)||await this.U(n,r.dirname(a));let C;if((0,w.$bk)(n)&&!(o instanceof s.$be))if((0,v.$Zd)(o)){const k=await(0,v.$7d)(o,3);k.ended?C=s.$be.concat(k.buffer):C=k}else C=(0,v.$4d)(o,k=>s.$be.concat(k),3);else C=o;!(0,w.$ek)(n)||(0,w.$bk)(n)&&C instanceof s.$be||(0,w.$bk)(n)&&(0,w.$hk)(n)&&p?.atomic?await this.hb(n,a,p,C):await this.db(n,a,p,C instanceof s.$be?(0,s.$me)(C):C),this.r.fire(new w.$qk(a,4))}catch(A){throw new w.$tk((0,m.localize)(4,null,this.sb(a),(0,w.$mk)(A).toString()),(0,w.$pk)(A),p)}return this.resolve(a,{resolveMetadata:!0})}async w(a,o,t){const n=!!t?.unlock;if(n&&!(a.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(o)));if(!!t?.atomic){if(!(a.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(o)));if(!(a.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(o)));if(n)throw new Error((0,m.localize)(8,null,this.sb(o)))}let p;try{p=await a.stat(o)}catch{return}if(p.type&w.FileType.Directory)throw new w.$tk((0,m.localize)(9,null,this.sb(o)),0,t);if(this.rb(o,p),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==w.$Dk&&typeof p.mtime=="number"&&typeof p.size=="number"&&t.mtime<p.mtime&&t.etag!==(0,w.$Ek)({mtime:t.mtime,size:p.size}))throw new w.$tk((0,m.localize)(10,null),3,t);return p}async readFile(a,o,t){const n=await this.m(a);return o?.atomic?this.z(n,a,o,t):this.C(n,a,o,t)}async z(a,o,t,n){return new Promise((r,p)=>{this.cb.queueFor(o,this.R(a).providerExtUri).queue(async()=>{try{const A=await this.C(a,o,t,n);r(A)}catch(A){p(A)}})})}async C(a,o,t,n){const r=await this.D(a,o,{...t,preferUnbuffered:!0},n);return{...r,value:await(0,s.$ne)(r.value)}}async readFileStream(a,o,t){const n=await this.m(a);return this.D(n,a,o,t)}async D(a,o,t,n){const r=new O.$Xd(n);let p=t;(0,w.$gk)(a)&&a.enforceAtomicReadFile?.(o)&&(p={...t,atomic:!0});const A=this.J(o,p).then(k=>k,k=>{throw r.dispose(!0),k});let C;try{return typeof p?.etag=="string"&&p.etag!==w.$Dk&&await A,p?.atomic&&(0,w.$gk)(a)||!((0,w.$ek)(a)||(0,w.$fk)(a))||(0,w.$bk)(a)&&p?.preferUnbuffered?C=this.I(a,o,p):(0,w.$fk)(a)?C=this.G(a,o,r.token,p):C=this.H(a,o,r.token,p),C.on("end",()=>r.dispose()),C.on("error",()=>r.dispose()),{...await A,value:C}}catch(k){throw C&&await(0,v.$5d)(C),this.F(k,o,p)}}F(a,o,t){const n=(0,m.localize)(11,null,this.sb(o),(0,w.$mk)(a).toString());return a instanceof w.$vk?new w.$vk(n,a.stat,t):a instanceof w.$uk?new w.$uk(n,a.fileOperationResult,a.size,a.options):new w.$tk(n,(0,w.$pk)(a),t)}G(a,o,t,n=Object.create(null)){const r=a.readFileStream(o,n,t);return(0,v.$$d)(r,{data:p=>p instanceof s.$be?p:s.$be.wrap(p),error:p=>this.F(p,o,n)},p=>s.$be.concat(p))}H(a,o,t,n=Object.create(null)){const r=(0,s.$re)();return(0,d.$Mp)(a,o,r,p=>p,{...n,bufferSize:this.a,errorTransformer:p=>this.F(p,o,n)},t),r}I(a,o,t){const n=(0,v.$2d)(r=>s.$be.concat(r));return(async()=>{try{let r;t?.atomic&&(0,w.$gk)(a)?r=await a.readFile(o,{atomic:!0}):r=await a.readFile(o),typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.L(o,r.byteLength,t),n.end(s.$be.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(a,o){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new w.$tk((0,m.localize)(12,null,this.sb(a)),0,o);if(typeof o?.etag=="string"&&o.etag!==w.$Dk&&o.etag===t.etag)throw new w.$vk((0,m.localize)(13,null),t,o);return this.L(a,t.size,o),t}L(a,o,t){if(typeof t?.limits?.size=="number"&&o>t.limits.size)throw new w.$uk((0,m.localize)(14,null,this.sb(a)),7,o,t)}async canMove(a,o,t){return this.M(a,o,"move",t)}async canCopy(a,o,t){return this.M(a,o,"copy",t)}async M(a,o,t,n){if(a.toString()!==o.toString())try{const r=t==="move"?this.qb(await this.n(a),a):await this.m(a),p=this.qb(await this.n(o),o);await this.Q(r,a,p,o,t,n)}catch(r){return r}return!0}async move(a,o,t){const n=this.qb(await this.n(a),a),r=this.qb(await this.n(o),o),p=await this.N(n,a,r,o,"move",!!t),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$qk(a,p==="move"?2:3,A)),A}async copy(a,o,t){const n=await this.m(a),r=this.qb(await this.n(o),o),p=await this.N(n,a,r,o,"copy",!!t),A=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$qk(a,p==="copy"?3:2,A)),A}async N(a,o,t,n,r,p){if(o.toString()===n.toString())return r;const{exists:A,isSameResourceWithDifferentPathCase:C}=await this.Q(a,o,t,n,r,p);if(A&&!C&&p&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),r==="copy"){if(a===t&&(0,w.$ck)(a))await a.copy(o,n,{overwrite:p});else{const k=await this.resolve(o);k.isDirectory?await this.P(a,k,t,n):await this.O(a,o,t,n)}return r}else return a===t?(await a.rename(o,n,{overwrite:p}),r):(await this.N(a,o,t,n,"copy",p),await this.del(o,{recursive:!0}),"copy")}async O(a,o,t,n){if((0,w.$ek)(a)&&(0,w.$ek)(t))return this.jb(a,o,t,n);if((0,w.$ek)(a)&&(0,w.$bk)(t))return this.pb(a,o,t,n);if((0,w.$bk)(a)&&(0,w.$ek)(t))return this.nb(a,o,t,n);if((0,w.$bk)(a)&&(0,w.$bk)(t))return this.lb(a,o,t,n)}async P(a,o,t,n){await t.mkdir(n),Array.isArray(o.children)&&await R.Promises.settled(o.children.map(async r=>{const p=this.R(t).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(a,await this.resolve(r.resource),t,p):this.O(a,r.resource,t,p)}))}async Q(a,o,t,n,r,p){let A=!1;if(a===t){const{providerExtUri:k,isPathCaseSensitive:I}=this.R(a);if(I||(A=k.isEqual(o,n)),A&&r==="copy")throw new Error((0,m.localize)(15,null,this.sb(o),this.sb(n)));if(!A&&k.isEqualOrParent(n,o))throw new Error((0,m.localize)(16,null,this.sb(o),this.sb(n)))}const C=await this.exists(n);if(C&&!A){if(!p)throw new w.$tk((0,m.localize)(17,null,this.sb(o),this.sb(n)),4);if(a===t){const{providerExtUri:k}=this.R(a);if(k.isEqualOrParent(o,n))throw new Error((0,m.localize)(18,null,this.sb(o),this.sb(n)))}}return{exists:C,isSameResourceWithDifferentPathCase:A}}R(a){const o=this.S(a);return{providerExtUri:o?g.$lg:g.$ng,isPathCaseSensitive:o}}S(a){return!!(a.capabilities&1024)}async createFolder(a){const o=this.qb(await this.j(a),a);await this.U(o,a);const t=await this.resolve(a,{resolveMetadata:!0});return this.r.fire(new w.$qk(a,0,t)),t}async U(a,o){const t=[],{providerExtUri:n}=this.R(a);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await a.stat(o)).type&w.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(o)));break}catch(r){if((0,w.$ok)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(n.basename(o)),o=n.dirname(o)}for(let r=t.length-1;r>=0;r--){o=n.joinPath(o,t[r]);try{await a.mkdir(o)}catch(p){if((0,w.$ok)(p)!==w.FileSystemProviderErrorCode.FileExists)throw p}}}async canDelete(a,o){try{await this.W(a,o)}catch(t){return t}return!0}async W(a,o){const t=this.qb(await this.j(a),a),n=!!o?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(a)));const r=o?.atomic;if(r&&!(t.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(a)));if(n&&r)throw new Error((0,m.localize)(22,null,this.sb(a)));let p;try{p=await t.stat(a)}catch{}if(p)this.rb(a,p);else throw new w.$tk((0,m.localize)(23,null,this.sb(a)),1);if(!!!o?.recursive){const C=await this.resolve(a);if(C.isDirectory&&Array.isArray(C.children)&&C.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(a)))}return t}async del(a,o){const t=await this.W(a,o);let n=o;if((0,w.$ik)(t)&&!n?.atomic){const C=t.enforceAtomicDelete?.(a);C&&(n={...o,atomic:C})}const r=!!n?.useTrash,p=!!n?.recursive,A=n?.atomic??!1;await t.delete(a,{recursive:p,useTrash:r,atomic:A}),this.r.fire(new w.$qk(a,1))}async cloneFile(a,o){const t=await this.j(a),n=this.qb(await this.n(o),o);if(t===n&&this.R(t).providerExtUri.isEqual(a,o))return;if(t===n&&(0,w.$dk)(t))return t.cloneFile(a,o);await this.U(n,this.R(n).providerExtUri.dirname(o));const r=this.cb.queueFor(a,this.R(t).providerExtUri);return t===n&&(0,w.$ck)(t)?r.queue(()=>t.copy(a,o,{overwrite:!0})):r.queue(()=>this.O(t,a,n,o))}static{this.ab=0}createWatcher(a,o){return this.watch(a,{...o,correlationId:E.ab++})}watch(a,o={recursive:!1,excludes:[]}){const t=new c.$Rc;let n=!1,r=()=>{n=!0};t.add((0,c.$Qc)(()=>r())),(async()=>{try{const A=await this.bb(a,o);n?(0,c.$Nc)(A):r=()=>(0,c.$Nc)(A)}catch(A){this.b.error(A)}})();const p=o.correlationId;if(typeof p=="number"){const A=t.add(new D.$Nd);return t.add(this.X.event(k=>{k.correlates(p)&&A.fire(k)})),{onDidChange:A.event,dispose:()=>t.dispose()}}return t}async bb(a,o){const t=await this.j(a),n=(0,P.$Di)([this.R(t).providerExtUri.getComparisonKey(a),o]);let r=this.$.get(n);return r||(r={count:0,disposable:t.watch(a,o)},this.$.set(n,r)),r.count+=1,(0,c.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,a]of this.$)(0,c.$Nc)(a.disposable);this.$.clear()}async db(a,o,t,n){return this.cb.queueFor(o,this.R(a).providerExtUri).queue(async()=>{const r=await a.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,v.$Zd)(n)||(0,v.$1d)(n)?await this.eb(a,r,n):await this.fb(a,r,n)}catch(p){throw(0,w.$mk)(p)}finally{await a.close(r)}})}async eb(a,o,t){let n=0,r;if((0,v.$1d)(t)){if(t.buffer.length>0){const p=s.$be.concat(t.buffer);await this.gb(a,o,p,p.byteLength,n,0),n+=p.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((p,A)=>{(0,v.$6d)(r,{onData:async C=>{r.pause();try{await this.gb(a,o,C,C.byteLength,n,0)}catch(k){return A(k)}n+=C.byteLength,setTimeout(()=>r.resume())},onError:C=>A(C),onEnd:()=>p()})})}async fb(a,o,t){let n=0,r;for(;(r=t.read())!==null;)await this.gb(a,o,r,r.byteLength,n,0),n+=r.byteLength}async gb(a,o,t,n,r,p){let A=0;for(;A<n;){const C=await a.write(o,r+A,t.buffer,p+A,n-A);A+=C}}async hb(a,o,t,n){return this.cb.queueFor(o,this.R(a).providerExtUri).queue(()=>this.ib(a,o,t,n))}async ib(a,o,t,n){let r;n instanceof s.$be?r=n:(0,v.$Zd)(n)?r=await(0,s.$ne)(n):(0,v.$1d)(n)?r=await(0,s.$oe)(n):r=(0,s.$le)(n),await a.writeFile(o,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(a,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(a,o,t,n))}async kb(a,o,t,n){let r,p;try{r=await a.open(o,{create:!1}),p=await t.open(n,{create:!0,unlock:!1});const A=s.$be.alloc(this.a);let C=0,k=0,I=0;do I=await a.read(r,C,A.buffer,k,A.byteLength-k),await this.gb(t,p,A,I,C,k),C+=I,k+=I,k===A.byteLength&&(k=0);while(I>0)}catch(A){throw(0,w.$mk)(A)}finally{await R.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof p=="number"?t.close(p):Promise.resolve()])}}async lb(a,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(a,o,t,n))}async mb(a,o,t,n){return t.writeFile(n,await a.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(a,o,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(a,o,t,n))}async ob(a,o,t,n){const r=await t.open(n,{create:!0,unlock:!1});try{const p=await a.readFile(o);await this.gb(t,r,s.$be.wrap(p),p.byteLength,0,0)}catch(p){throw(0,w.$mk)(p)}finally{await t.close(r)}}async pb(a,o,t,n){const r=await(0,s.$ne)(this.H(a,o,O.CancellationToken.None));await this.hb(t,n,void 0,r)}qb(a,o){if(a.capabilities&2048)throw new w.$tk((0,m.localize)(25,null,this.sb(o)),6);return a}rb(a,o){if((o.permissions??0)&w.FilePermission.Readonly)throw new w.$tk((0,m.localize)(26,null,this.sb(a)),6)}sb(a){return a.scheme===b.Schemas.file?a.fsPath:a.toString(!0)}};e.$Np=u,e.$Np=u=E=Ee([te(0,h.$0i)],u)}),define(ie[93],ne([0,1,45,311,8,31,17,3,33,2,9,4,19,61,21,179,16,118,221,49,217,216]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0,(()=>{try{(0,R.gracefulify)(S)}catch(a){console.error(`Error enabling graceful-fs: ${(0,l.$Ai)(a)}`)}})();class i extends h.$Wp{static{this.I=!1}constructor(o,t){super(o,t),this.onDidChangeCapabilities=P.Event.None,this.N=new O.$Ac(n=>y.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,b.$l&&(this.J|=1024)),this.J}async stat(o){try{const{stat:t,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(o));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:w.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const t=await v.Promises.readdir(this.H(o),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async r=>{try{let p;r.isSymbolicLink()?p=(await this.stat((0,y.$vg)(o,r.name))).type:p=this.M(r),n.push([r.name,p])}catch(p){this.a.trace(p)}})),n}catch(t){throw this.fb(t)}}M(o,t){let n;return t?.dangling?n=w.FileType.Unknown:o.isFile()?n=w.FileType.File:o.isDirectory()?n=w.FileType.Directory:n=w.FileType.Unknown,t&&(n|=w.FileType.SymbolicLink),n}async O(o){const t=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const r=new s.$Sg;return this.N.set(o,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(o)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(o,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),n=await this.O(o));const r=this.H(o);return await v.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(o){i.I&&this.a.trace(o)}readFileStream(o,t,n){const r=(0,g.$2d)(p=>D.$be.concat(p.map(A=>D.$be.wrap(A))).buffer);return(0,d.$Mp)(this,o,r,p=>p.buffer,{...t,bufferSize:256*1024},n),r}async writeFile(o,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,y.$vg)((0,y.$ug)(o),`${(0,y.$sg)(o)}${n.atomic.postfix}`),t,n):this.S(o,t,n)}async Q(o){try{const t=this.H(o),{symbolicLink:n}=await v.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(o,t,n,r){const p=new c.$Rc;try{p.add(await this.O(o)),p.add(await this.O(t)),await this.S(t,n,r,!0);try{await this.rename(t,o,{overwrite:!0})}catch(A){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{p.dispose()}}async S(o,t,n,r){let p;try{const A=this.H(o);if(!n.create||!n.overwrite){if(await v.Promises.exists(A)){if(!n.overwrite)throw(0,w.$lk)((0,m.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,w.$lk)((0,m.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(o,{create:!0,unlock:n.unlock},r),await this.write(p,0,t,0,t.byteLength)}catch(A){throw await this.gb(o,A)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(o){i.Y=o}async open(o,t,n){const r=this.H(o);let p;(0,w.$_j)(t)&&!n&&(p=await this.O(o));let A;try{if((0,w.$_j)(t)&&t.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(r);k.mode&128||await v.Promises.chmod(r,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let C;if((0,w.$_j)(t)){if(b.$j)try{await v.Promises.truncate(r,0),C="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}C||(C="w")}else C="r";A=await v.Promises.open(r,C)}catch(C){throw p?.dispose(),(0,w.$_j)(t)?await this.gb(o,C):this.fb(C)}if(this.U.set(A,0),(0,w.$_j)(t)&&this.X.set(A,o),p){const C=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${r})`),this.W.set(A,p),C&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${r})`),C.dispose())}return A}async close(o){const t=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&i.Y)try{await v.Promises.fdatasync(o)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(o)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(o)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),t.dispose())}}async read(o,t,n,r,p){const A=this.Z(o,t);let C=null;try{C=(await v.Promises.read(o,n,r,p,A)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(o,A,C)}return C}Z(o,t){return t===this.U.get(o)?null:t}$(o,t,n){const r=this.U.get(o);typeof r=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(o,r+n):this.U.delete(o)))}async write(o,t,n,r,p){return(0,s.$_g)(()=>this.ab(o,t,n,r,p),100,3)}async ab(o,t,n,r,p){const A=this.Z(o,t);let C=null;try{C=(await v.Promises.write(o,n,r,p,A)).bytesWritten}catch(k){throw await this.gb(this.X.get(o),k)}finally{this.$(o,A,C)}return C}async mkdir(o){try{await v.Promises.mkdir(this.H(o))}catch(t){throw this.fb(t)}}async delete(o,t){try{const n=this.H(o);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,$.$jc)((0,$.$mc)(n),`${(0,$.$nc)(n)}${t.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,r)}else try{await v.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let p=!1;try{const{stat:A,symbolicLink:C}=await v.SymlinkSupport.stat(n);p=A.isDirectory()&&!C}catch{}if(p)await v.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"move",n.overwrite),await v.Promises.rename(r,p)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(2,null,(0,$.$nc)(r),(0,$.$nc)((0,$.$mc)(p)),A.toString()))),this.fb(A)}}async copy(o,t,n){const r=this.H(o),p=this.H(t);if(r!==p)try{await this.bb(o,t,"copy",n.overwrite),await v.Promises.copy(r,p,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(3,null,(0,$.$nc)(r),(0,$.$nc)((0,$.$mc)(p)),A.toString()))),this.fb(A)}}async bb(o,t,n,r){const p=this.H(o),A=this.H(t);let C=!1;if(!!(this.capabilities&1024)||(C=(0,f.$Wf)(p,A,!0)),C){if(n==="copy")throw(0,w.$lk)((0,m.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(o);if(!I)throw(0,w.$lk)((0,m.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(t);if(j){if(!r)throw(0,w.$lk)((0,m.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);I.type&w.FileType.File&&j.type&w.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,t){return this.cb(o,t,!1)}async cb(o,t,n){const r=this.H(o),p=this.H(t),A=!!(this.capabilities&1024);if((0,f.$Wf)(r,p,!A))return;const C=new c.$Rc;try{C.add(await this.O(o)),C.add(await this.O(t)),n&&await v.Promises.mkdir((0,$.$mc)(p),{recursive:!0}),await v.Promises.copyFile(r,p)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(o,t,!0);throw this.fb(k)}finally{C.dispose()}}t(o,t,n){return new E.$4p(r=>o(r),r=>t(r),n)}F(o,t,n){return new u.$_p(r=>o(r),r=>t(r),n)}fb(o){if(o instanceof w.$kk)return o;let t=o,n;switch(o.code){case"ENOENT":n=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=w.FileSystemProviderErrorCode.Unknown;break;default:n=w.FileSystemProviderErrorCode.Unknown}return(0,w.$lk)(t,n)}async gb(o,t){let n=this.fb(t);if(o&&n.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await v.SymlinkSupport.stat(this.H(o));r.mode&128||(n=(0,w.$lk)(t,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$aq=i}),define(ie[223],ne([0,1,3,93,2,17,61,22]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=e.$Ir=void 0;class f extends s.$Sc{constructor(b,y){super(),this.a=b,this.b=y,this.F=new Map,this.G=new Map}call(b,y,g){const v=this.c(b);switch(y){case"stat":return this.g(v,g[0]);case"readdir":return this.h(v,g[0]);case"open":return this.r(v,g[0],g[1]);case"close":return this.s(g[0]);case"read":return this.t(g[0],g[1],g[2]);case"readFile":return this.j(v,g[0],g[1]);case"write":return this.u(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.n(v,g[0],g[1],g[2]);case"rename":return this.z(v,g[0],g[1],g[2]);case"copy":return this.C(v,g[0],g[1],g[2]);case"cloneFile":return this.D(v,g[0],g[1]);case"mkdir":return this.w(v,g[0]);case"delete":return this.y(v,g[0],g[1]);case"watch":return this.I(v,g[0],g[1],g[2],g[3]);case"unwatch":return this.J(g[0],g[1])}throw new Error(`IPC Command ${y} not found`)}listen(b,y,g){const v=this.c(b);switch(y){case"fileChange":return this.H(v,g[0]);case"readFileStream":return this.m(v,g[0],g[1])}throw new Error(`Unknown event ${y}`)}g(b,y){const g=this.f(b,y,!0);return this.a.stat(g)}h(b,y){const g=this.f(b,y);return this.a.readdir(g)}async j(b,y,g){const v=this.f(b,y,!0),m=await this.a.readFile(v,g);return O.$be.wrap(m)}m(b,y,g){const v=this.f(b,y,!0),m=new P.$Xd,w=new S.$Nd({onDidRemoveLastListener:()=>{m.cancel()}}),d=this.a.readFileStream(v,g,m.token);return(0,D.$6d)(d,{onData:h=>w.fire(O.$be.wrap(h)),onError:h=>w.fire(h),onEnd:()=>{w.fire("end"),w.dispose(),m.dispose()}}),w.event}n(b,y,g,v){const m=this.f(b,y);return this.a.writeFile(m,g.buffer,v)}r(b,y,g){const v=this.f(b,y,!0);return this.a.open(v,g)}s(b){return this.a.close(b)}async t(b,y,g){const v=O.$be.alloc(g),m=0,w=await this.a.read(b,y,v.buffer,m,g);return[v,w]}u(b,y,g,v,m){return this.a.write(b,y,g.buffer,v,m)}w(b,y){const g=this.f(b,y);return this.a.mkdir(g)}y(b,y,g){const v=this.f(b,y);return this.a.delete(v,g)}z(b,y,g,v){const m=this.f(b,y),w=this.f(b,g);return this.a.rename(m,w,v)}C(b,y,g,v){const m=this.f(b,y),w=this.f(b,g);return this.a.copy(m,w,v)}D(b,y,g){const v=this.f(b,y),m=this.f(b,g);return this.a.cloneFile(v,m)}H(b,y){const g=new S.$Nd({onWillAddFirstListener:()=>{this.F.set(y,this.L(b,g))},onDidRemoveLastListener:()=>{(0,s.$Nc)(this.F.get(y)),this.F.delete(y)}});return g.event}async I(b,y,g,v,m){const w=this.F.get(y);if(w){const d=this.f(b,v),h=w.watch(g,d,m);this.G.set(y+g,h)}}async J(b,y){const g=b+y,v=this.G.get(g);v&&((0,s.$Nc)(v),this.G.delete(g))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Ir=f;class c extends s.$Sc{constructor(b,y,g,v){super(),this.c=b,this.f=g,this.g=v,this.a=new Map,this.b=this.B(new R.$aq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(b){const y=this.B(new S.$Nd);this.B(y.event(g=>{b.fire(g.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type,cId:v.cId})))})),this.B(this.b.onDidChangeFile(g=>y.fire(g))),this.B(this.b.onDidWatchError(g=>b.fire(g)))}j(b){}m(b){}watch(b,y,g){const v=this.m(this.g);return Array.isArray(v)&&(g.excludes=[...g.excludes,...v]),this.a.set(b,this.b.watch(y,g)),(0,s.$Qc)(()=>{(0,s.$Nc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Jr=c}),define(ie[224],ne([0,1,15,178,4,7,16,9,223,155]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=void 0;class $ extends f.$Ir{constructor(g,v,m){super(g,v),this.M=m}c(g){return c.$Mm}f(g,v){return O.URI.revive(v)}async y(g,v,m){if(!m.useTrash)return super.y(g,v,m);const w=this.f(g,v),d=(0,P.$hc)(w.fsPath);try{await S.shell.trashItem(d)}catch{throw(0,D.$lk)(s.$j?(0,R.localize)(0,null,(0,P.$nc)(d)):(0,R.localize)(1,null,(0,P.$nc)(d)),D.FileSystemProviderErrorCode.Unknown)}}L(g,v){return new b(g,v,this.b,this.M)}}e.$h7b=$;class b extends f.$Jr{watch(g,v,m){if(m.recursive)throw(0,D.$lk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(g,v,m)}}}),define(ie[225],ne([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$03b=void 0;class R extends S.$dj{constructor(O=S.$aj){super(),this.m=[],this.n=void 0,this.setLevel(O),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(O){this.n=O;for(const{level:D,message:P}of this.m)(0,S.log)(O,D,P);this.m=[]}g(O,D){this.n?(0,S.log)(this.n,O,D):this.getLevel()<=O&&this.m.push({level:O,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$03b=R}),define(ie[226],ne([0,1,7,3,6,2]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=void 0;class D extends s.$ij{constructor(b,y,g,v,m){super(y,g,v),this.r=b,this.t=m,this.B(m.listen("onDidChangeLogLevel",b)(w=>{(0,s.$_i)(w)?super.setLogLevel(w):super.setLogLevel(S.URI.revive(w[0]),w[1])})),this.B(m.listen("onDidChangeVisibility",b)(([w,d])=>super.setVisibility(S.URI.revive(w),d))),this.B(m.listen("onDidChangeLoggers",b)(({added:w,removed:d})=>{for(const h of w)super.registerLogger({...h,resource:S.URI.revive(h.resource)});for(const h of d)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$gj({log:(b,y)=>{this.t.call("consoleLog",[b,y])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,y){super.setLogLevel(b,y),this.t.call("setLogLevel",[b,y])}setVisibility(b,y){super.setVisibility(b,y),this.t.call("setVisibility",[this.n(b),y])}s(b,y,g){return new P(this.t,b,y,g,this.r)}static setLogLevel(b,y,g){return b.call("setLogLevel",[y,g])}}e.$$q=D;class P extends s.$dj{constructor(b,y,g,v,m){super(v?.logLevel==="always"),this.r=b,this.s=y,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[y,v,m]).then(()=>{this.u(this.n),this.m=!0})}g(b,y){const g=[[b,y]];this.m?this.u(g):this.n.push(...g)}u(b){this.r.call("log",[this.s,b])}}class f{constructor(b,y){this.a=b,this.b=y}listen(b,y){const g=this.b(b);switch(y){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(m=>this.c(m,g)),removed:[...v.removed].map(m=>this.c(m,g))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,v=>[g.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$_i)(v)?v:[g.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(b,y,g){const v=this.b(b);switch(y){case"setLogLevel":return(0,s.$_i)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(S.URI.revive(v.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,v)))}throw new Error(`Call not found: ${y}`)}c(b,y){return{...b,resource:y.transformOutgoingURI(b.resource)}}}e.$_q=f;class c extends O.$Sc{constructor(b,y){super(),y.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(g=>y.call("setLogLevel",[g]))),y.call("getRegisteredLoggers").then(g=>{for(const v of g)b.registerLogger({...v,resource:S.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([g,v])=>b.setVisibility(S.URI.revive(g),v))),this.B(y.listen("onDidChangeLoggers")(({added:g,removed:v})=>{for(const m of g)b.registerLogger({...m,resource:S.URI.revive(m.resource)});for(const m of v)b.deregisterLogger(m.resource)}))}}e.$ar=c}),define(ie[227],ne([0,1,2,6]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;class s extends S.$Sc{constructor(D,P=[]){super(),this.a=new R.$hj([D,...P]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.$JN=s}),define(ie[228],ne([0,1,31,7,6]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b8b=void 0;class O{constructor(P){this.b=P,this.a=new S.$Ac}listen(P,f,c){switch(f){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(P,f,c){switch(f){case"createLogger":this.c(R.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(R.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,s.$_i)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(R.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:R.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(c[0]))}throw new Error(`Call not found: ${f}`)}c(P,f,c){this.a.set(P,this.b.createLogger(P,f,c))}d(P,f){let c=console.log;switch(P){case s.LogLevel.Error:c=console.error;break;case s.LogLevel.Warning:c=console.warn;break;case s.LogLevel.Info:c=console.info;break}c.call(console,...f)}e(P,f){const c=this.a.get(P);if(!c)throw new Error("Create the logger before logging");for(const[$,b]of f)(0,s.log)(c,$,b)}}e.$b8b=O}),define(ie[229],ne([0,1,16,6]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;var s;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(s||(s={}));async function O(c,$,b,y,g){try{const v=await new Promise((w,d)=>{J(["@vscode/spdlog"],w,d)});v.setFlushOn(s.Trace);const m=await v.createAsyncRotatingLogger(c,$,b,y);return g?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(v){console.error(v)}return null}function D(c,$,b){switch($){case R.LogLevel.Trace:c.trace(b);break;case R.LogLevel.Debug:c.debug(b);break;case R.LogLevel.Info:c.info(b);break;case R.LogLevel.Warning:c.warn(b);break;case R.LogLevel.Error:c.error(b);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${$}`)}}function P(c,$){switch($){case R.LogLevel.Trace:c.setLevel(s.Trace);break;case R.LogLevel.Debug:c.setLevel(s.Debug);break;case R.LogLevel.Info:c.setLevel(s.Info);break;case R.LogLevel.Warning:c.setLevel(s.Warning);break;case R.LogLevel.Error:c.setLevel(s.Error);break;case R.LogLevel.Off:c.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${$}`)}}class f extends R.$dj{constructor($,b,y,g,v){super(),this.m=[],this.setLevel(v),this.n=this.s($,b,y,g),this.B(this.onDidChangeLogLevel(m=>{this.r&&P(this.r,m)}))}async s($,b,y,g){const v=y?6:1,m=30/v*S.$Gk.MB,w=await O($,b,m,v,g);if(w){this.r=w,P(this.r,this.getLevel());for(const{level:d,message:h}of this.m)D(this.r,d,h);this.m=[]}}g($,b){this.r?D(this.r,$,b):this.getLevel()<=$&&this.m.push({level:$,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$yN=f}),define(ie[230],ne([0,1,32,6,229]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=void 0;class O extends R.$ij{s(P,f,c){return new s.$yN((0,S.$eg)(),P.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,f)}}e.$zN=O}),define(ie[66],ne([0,1,31,3,5,6,230]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=e.$T6b=void 0,e.$T6b=(0,s.$Qh)(O.$$i);class P extends D.$zN{constructor(){super(...arguments),this.u=new S.$Ac}createLogger(c,$,b){b!==void 0&&this.u.set(this.n(c),b);try{return super.createLogger(c,$)}catch(y){throw this.u.delete(this.n(c)),y}}registerLogger(c,$){$!==void 0&&this.u.set(c.resource,$),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const $=[];for(const b of super.getRegisteredLoggers())c===this.u.get(b.resource)&&$.push(b);return $}getOnDidChangeLogLevelEvent(c){return R.Event.filter(this.onDidChangeLogLevel,$=>(0,O.$_i)($)||this.w($[0],c))}getOnDidChangeVisibilityEvent(c){return R.Event.filter(this.onDidChangeVisibility,([$])=>this.w($,c))}getOnDidChangeLoggersEvent(c){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,$=>({added:[...$.added].filter(y=>this.w(y.resource,c)),removed:[...$.removed].filter(y=>this.w(y.resource,c))})),$=>$.added.length>0||$.removed.length>0)}deregisterLoggers(c){for(const[$,b]of this.u)b===c&&this.deregisterLogger($)}w(c,$){const b=this.u.get(c);return b===void 0||b===$}dispose(){super.dispose(),this.u.clear()}}e.$U6b=P}),define(ie[231],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=e.$v7b=e.$u7b=e.$t7b=void 0;function S(D){return D.submenu!==void 0}e.$t7b=S;function R(D){return D.id==="vscode.menubar.separator"}e.$u7b=R;function s(D){return D.uri!==void 0}e.$v7b=s;function O(D){return!S(D)&&!R(D)&&!s(D)}e.$w7b=O}),define(ie[39],ne([0,1,3,70,2,5]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=void 0,e.$in=(0,O.$Ph)("policy");class D extends s.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const $=Object.keys(this.f).length;return this.f={...c,...this.f},$!==Object.keys(this.f).length&&await this.j(c),R.Iterable.reduce(this.g.entries(),(b,[y,g])=>({...b,[y]:g}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(c,[$,b])=>({...c,[$]:{definition:b,value:this.g.get($)}}),{})}}e.$jn=D;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$kn=P}),define(ie[232],ne([0,1,8,3,70,12,16,6,39]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=void 0;function c(b,y){const g=[];for(const v of new Set(s.Iterable.concat(b.keys(),y.keys())))b.get(v)!==y.get(v)&&g.push(v);return g}let $=class extends f.$jn{constructor(y,g,v){super(),this.m=y,this.n=g,this.s=v,this.c=this.B(new S.$Rg(500));const m=R.Event.filter(g.onDidFilesChange,w=>w.affects(y));this.B(g.watch(y)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const g=await this.n.readFile(this.m),v=JSON.parse(g.value.toString());if(!(0,O.$Af)(v))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(v))this.f[m]&&y.set(m,v[m])}catch(g){g.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",g)}return y}async w(){const y=await this.u(),g=c(this.g,y);this.g=y,g.length>0&&this.h.fire(g)}};e.$u8b=$,e.$u8b=$=Ee([te(1,D.$$j),te(2,P.$0i)],$)}),define(ie[233],ne([0,1,3,2,39]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=e.$57b=void 0;class O{constructor(f){this.b=f,this.a=new R.$Rc}listen(f,c){switch(c){case"onDidChange":return S.Event.map(this.b.onDidChange,$=>$.reduce((b,y)=>({...b,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(f,c,$){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions($)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$57b=O;class D extends s.$jn{constructor(f,c){super(),this.a=c;for(const $ in f){const{definition:b,value:y}=f[$];this.f[$]=b,y!==void 0&&this.g.set($,y)}this.a.listen("onDidChange")($=>{for(const b in $){const y=$[b];y===null?this.g.delete(b):this.g.set(b,y)}this.h.fire(Object.keys($))})}async j(f){const c=await this.a.call("updatePolicyDefinitions",f);for(const $ in c)this.g.set($,c[$])}}e.$67b=D}),define(ie[234],ne([0,1,39,8,312,2,6]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;let P=class extends S.$jn{constructor(c,$){super(),this.m=c,this.n=$,this.a=new R.$Ng,this.b=this.B(new O.$Tc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise(($,b)=>{try{this.b.value=(0,s.createWatcher)(this.n,c,y=>{this.t(y),$()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const $ in c){const b=c[$];b===void 0?this.g.delete($):this.g.set($,b)}this.h.fire(Object.keys(c))}};e.$t8b=P,e.$t8b=P=Ee([te(0,D.$0i)],P)}),define(ie[78],ne([0,1,4,35]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof S.$h.vscode<"u"&&typeof S.$h.vscode.context<"u"){const O=S.$h.vscode.context.configuration();if(O)s=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:O.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(ie[25],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,S.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"}),define(ie[235],ne([0,1,8,6]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;let s=class{constructor(D,P,f){this.a=D,this.b=P,this.c=f}async inspect(D){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Ug)(D);const f=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$k7b=s,e.$k7b=s=Ee([te(2,R.$0i)],s)}),define(ie[79],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=void 0,e.$J6b=(0,S.$Ph)("protocolMainService")}),define(ie[43],ne([0,1,137,12]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class s{constructor(){this.a=new Map}add(D,P){S.ok(R.$yf(D)),S.ok(R.$Af(P)),S.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$gn=new s}),define(ie[236],ne([0,1,3,43]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class O{constructor(){this.b=new S.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,c){this.a[s(f)]=c,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new O;R.$gn.add(e.$hn.JSONContribution,D)}),define(ie[57],ne([0,1,23,3,12,163,18,236,43]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var c;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$ln={Configuration:"base.contributions.configuration"};var $;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})($||(e.ConfigurationScope=$={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const b=f.$gn.as(P.$hn.JSONContribution);class y{constructor(){this.h=new Set,this.i=new R.$Nd,this.onDidSchemaChange=this.i.event,this.j=new R.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const o=new Set;this.n(i,a,o),b.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(i){const a=new Set;this.o(i,a),b.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:i,remove:a}){const o=new Set;this.o(a,o),this.n(i,!1,o),b.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(i){const a=new Set;this.k(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(i,a){const o=[];for(const{overrides:t,source:n}of i)for(const r in t)if(a.add(r),e.$vn.test(r)){const p=this.a.get(r),A=p?.valuesSources??new Map;if(n)for(const j of Object.keys(t[r]))A.set(j,n);const C={...p?.value||{},...t[r]};this.a.set(r,{source:n,value:C,valuesSources:A});const k=(0,D.$ti)(r),I={type:"object",default:C,description:O.localize(1,null,k),$ref:e.$sn,defaultDefaultValue:C,source:s.$yf(n)?void 0:n,defaultValueSource:n};o.push(...m(r)),this.d[r]=I,this.b.properties[r]=I}else{this.a.set(r,{value:t[r],source:n});const p=this.d[r];p&&(this.w(r,p),this.r(r,p))}this.m(o)}deregisterDefaultConfigurations(i){const a=new Set;this.l(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(i,a){for(const{overrides:o,source:t}of i)for(const n in o){const r=this.a.get(n),p=s.$yf(t)?t:t?.id,A=s.$yf(r?.source)?r?.source:r?.source?.id;if(p===A)if(a.add(n),this.a.delete(n),e.$vn.test(n))delete this.d[n],delete this.b.properties[n];else{const C=this.d[n];C&&(this.w(n,C),this.r(n,C))}}this.u()}deltaConfiguration(i){let a=!1;const o=new Set;i.removedDefaults&&(this.l(i.removedDefaults,o),a=!0),i.addedDefaults&&(this.k(i.addedDefaults,o),a=!0),i.removedConfigurations&&this.o(i.removedConfigurations,o),i.addedConfigurations&&this.n(i.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const a of i)this.h.add(a);this.u()}n(i,a,o){i.forEach(t=>{this.p(t,a,t.extensionInfo,t.restrictedProperties,void 0,o),this.c.push(t),this.q(t)})}o(i,a){const o=t=>{if(t.properties)for(const n in t.properties){a.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>o(n))};for(const t of i){o(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,a=!0,o,t,n=3,r){n=s.$Hf(i.scope)?n:i.scope;const p=i.properties;if(p)for(const C in p){const k=p[C];if(a&&l(C,k)){delete p[C];continue}if(k.source=o,k.defaultDefaultValue=p[C].default,this.w(C,k),e.$vn.test(C)?k.scope=void 0:(k.scope=s.$Hf(k.scope)?n:k.scope,k.restricted=s.$Hf(k.restricted)?!!t?.includes(C):k.restricted),p[C].hasOwnProperty("included")&&!p[C].included){this.f[C]=p[C],delete p[C];continue}else this.d[C]=p[C],p[C].policy?.name&&this.e.set(p[C].policy.name,C);!p[C].deprecationMessage&&p[C].markdownDeprecationMessage&&(p[C].deprecationMessage=p[C].markdownDeprecationMessage),r.add(C)}const A=i.allOf;if(A)for(const C of A)this.p(C,a,o,t,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const a=o=>{const t=o.properties;if(t)for(const r in t)this.r(r,t[r]);o.allOf?.forEach(a)};a(i)}r(i,a){switch(e.$mn.properties[i]=a,a.scope){case 1:e.$nn.properties[i]=a;break;case 2:e.$on.properties[i]=a;break;case 6:e.$pn.properties[i]=a;break;case 3:e.$qn.properties[i]=a;break;case 4:e.$rn.properties[i]=a;break;case 5:e.$rn.properties[i]=a,this.g.properties[i]=a;break}}s(i,a){switch(delete e.$mn.properties[i],a.scope){case 1:delete e.$nn.properties[i];break;case 2:delete e.$on.properties[i];break;case 6:delete e.$pn.properties[i];break;case 3:delete e.$qn.properties[i];break;case 4:case 5:delete e.$rn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const a=`[${i}]`,o={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$sn};this.w(a,o),e.$mn.properties[a]=o,e.$nn.properties[a]=o,e.$on.properties[a]=o,e.$pn.properties[a]=o,e.$qn.properties[a]=o,e.$rn.properties[a]=o}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=i,e.$nn.patternProperties[e.$un]=i,e.$on.patternProperties[e.$un]=i,e.$pn.patternProperties[e.$un]=i,e.$qn.patternProperties[e.$un]=i,e.$rn.patternProperties[e.$un]=i,this.i.fire()}w(i,a){const o=this.a.get(i);let t=o?.value,n=o?.source;s.$Ff(t)&&(t=a.defaultDefaultValue,n=void 0),s.$Ff(t)&&(t=d(a.type)),a.default=t,a.defaultValueSource=n}}const g="\\[([^\\]]+)\\]",v=new RegExp(g,"g");e.$un=`^(${g})+$`,e.$vn=new RegExp(e.$un);function m(u){const i=[];if(e.$vn.test(u)){let a=v.exec(u);for(;a?.length;){const o=a[1].trim();o&&i.push(o),a=v.exec(u)}}return(0,S.$Mb)(i)}e.$wn=m;function w(u){return u.reduce((i,a)=>`${i}[${a}]`,"")}e.$xn=w;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=d;const h=new y;f.$gn.add(e.$ln.Configuration,h);function l(u,i){return u.trim()?e.$vn.test(u)?O.localize(7,null,u):h.getConfigurationProperties()[u]!==void 0?O.localize(8,null,u):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,u,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}e.$zn=l;function E(){const u=[],i=h.getConfigurationProperties();for(const a of Object.keys(i))u.push([a,i[a].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$An=E}),define(ie[119],ne([0,1,23,3,44,2,31,37,12,7,18,57,43]),function(J,e,S,R,s,O,D,P,f,c,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function g(a){return Object.isFrozen(a)?a:P.$8m(a)}class v{constructor(o={},t=[],n=[],r){this.b=o,this.c=t,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(t=>{if(t instanceof v)return t;const n=new m("");return n.parseRaw(t),n.configurationModel});this.f=o.reduce((t,n)=>n===t?n:t.merge(n),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,$.$ri)(this.contents,o):this.contents}inspect(o,t){const n=this.rawConfiguration.getValue(o),r=t?this.rawConfiguration.getOverrideValue(o,t):void 0,p=t?this.rawConfiguration.override(t).getValue(o):n;return{value:n,override:r,merged:p}}getOverrideValue(o,t){const n=this.i(t);return n?o?(0,$.$ri)(n,o):n:void 0}getKeysForOverrideIdentifier(o){const t=[];for(const n of this.overrides)n.identifiers.includes(o)&&t.push(...n.keys);return S.$Mb(t)}getAllOverrideIdentifiers(){const o=[];for(const t of this.overrides)o.push(...t.identifiers);return S.$Mb(o)}override(o){let t=this.a.get(o);return t||(t=this.g(o),this.a.set(o,t)),t}merge(...o){const t=P.$7m(this.contents),n=P.$7m(this.overrides),r=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const A of o)if(p.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(t,A.contents);for(const C of A.overrides){const[k]=n.filter(I=>S.$ub(I.identifiers,C.identifiers));k?(this.h(k.contents,C.contents),k.keys.push(...C.keys),k.keys=S.$Mb(k.keys)):n.push(P.$7m(C))}for(const C of A.keys)r.indexOf(C)===-1&&r.push(C)}return new v(t,r,n,p.every(A=>A instanceof v)?void 0:p)}g(o){const t=this.i(o);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const r of S.$Mb([...Object.keys(this.contents),...Object.keys(t)])){let p=this.contents[r];const A=t[r];A&&(typeof p=="object"&&typeof A=="object"?(p=P.$7m(p),this.h(p,A)):p=A),n[r]=p}return new v(n,this.keys,this.overrides)}h(o,t){for(const n of Object.keys(t)){if(n in o&&f.$Af(o[n])&&f.$Af(t[n])){this.h(o[n],t[n]);continue}o[n]=P.$7m(t[n])}}i(o){let t=null,n=null;const r=p=>{p&&(n?this.h(n,p):n=P.$7m(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===o?t=p.contents:p.identifiers.includes(o)&&r(p.contents);return r(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,t){this.j(o,t,!0)}setValue(o,t){this.j(o,t,!1)}removeValue(o){const t=this.keys.indexOf(o);t!==-1&&(this.keys.splice(t,1),(0,$.$qi)(this.contents,o),b.$vn.test(o)&&this.overrides.splice(this.overrides.findIndex(n=>S.$ub(n.identifiers,(0,b.$wn)(o))),1))}j(o,t,n){(0,$.$pi)(this.contents,o,t,r=>console.error(r)),n=n||this.keys.indexOf(o)===-1,n&&this.keys.push(o),b.$vn.test(o)&&this.overrides.push({identifiers:(0,b.$wn)(o),keys:Object.keys(this.contents[o]),contents:(0,$.$oi)(this.contents[o],r=>console.error(r))})}}e.$Bn=v;class m{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,t){if(!f.$Hf(o)){const n=this.g(o);this.parseRaw(n,t)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,t){this.a=o;const{contents:n,keys:r,overrides:p,restricted:A,hasExcludedProperties:C}=this.h(o,t);this.b=new v(n,r,p,C?[o]:void 0),this.c=A||[]}g(o){let t={},n=null,r=[];const p=[],A=[];function C(I){Array.isArray(r)?r.push(I):n!==null&&(r[n]=I)}const k={onObjectBegin:()=>{const I={};C(I),p.push(r),r=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{r=p.pop()},onArrayBegin:()=>{const I=[];C(I),p.push(r),r=I,n=null},onArrayEnd:()=>{r=p.pop()},onLiteralValue:C,onError:(I,j,U)=>{A.push({error:I,offset:j,length:U})}};if(o)try{s.$4m(o,k),t=r[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(o,t){const n=y.$gn.as(b.$ln.Configuration).getConfigurationProperties(),r=this.i(o,n,!0,t);o=r.raw;const p=(0,$.$oi)(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),A=Object.keys(o),C=this.j(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:p,keys:A,overrides:C,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(o,t,n,r){let p=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:p};const A={},C=[];for(const k in o)if(b.$vn.test(k)&&n){const I=this.i(o[k],t,!1,r);A[k]=I.raw,p=p||I.hasExcludedProperties,C.push(...I.restricted)}else{const I=t[k],j=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&C.push(k),!r.exclude?.includes(k)&&(r.include?.includes(k)||(j===void 0||r.scopes===void 0||r.scopes.includes(j))&&!(r.skipRestricted&&I?.restricted))?A[k]=o[k]:p=!0}return{raw:A,restricted:C,hasExcludedProperties:p}}j(o,t){const n=[];for(const r of Object.keys(o))if(b.$vn.test(r)){const p={};for(const A in o[r])p[A]=o[r][A];n.push({identifiers:(0,b.$wn)(r),keys:Object.keys(p),contents:(0,$.$oi)(p,t)})}return n}}e.$Cn=m;class w extends O.$Sc{constructor(o,t,n,r){super(),this.c=o,this.f=t,this.g=r,this.b=this.B(new R.$Nd),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&n.isEqual(p.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=w;class d{constructor(o,t,n,r,p,A,C,k,I,j,U,z,x){this.a=o,this.b=t,this.c=n,this.overrideIdentifiers=r,this.d=p,this.f=A,this.g=C,this.h=k,this.i=I,this.j=j,this.k=U,this.l=z,this.m=x}get value(){return g(this.c)}n(o,t,n){const r=o.inspect(t,n);return{get value(){return g(r.value)},get override(){return g(r.override)},get merged(){return g(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(o,t,n,r,p=new v,A=new v,C=new D.$Ac,k=new v,I=new D.$Ac){this.c=o,this.d=t,this.f=n,this.g=r,this.h=p,this.i=A,this.j=C,this.l=k,this.m=I,this.a=null,this.b=new D.$Ac,this.n=null}getValue(o,t,n){return this.q(o,t,n).getValue(o)}updateValue(o,t,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new v,this.m.set(n.resource,r))):r=this.l,t===void 0?r.removeValue(o):r.setValue(o,t),n.resource||(this.a=null)}inspect(o,t,n){const r=this.q(o,t,n),p=this.u(t.resource,n),A=t.resource?this.m.get(t.resource)||this.l:this.l,C=new Set;for(const k of r.overrides)for(const I of k.identifiers)r.getOverrideValue(o,I)!==void 0&&C.add(I);return new d(o,t,r.getValue(o),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,p||void 0,A)}keys(o){const t=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,t){this.j.set(o,t),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,t){const n=[];if(!t){const{added:r,updated:p,removed:A}=u(this.c,o);t=[...r,...p,...A]}for(const r of t)for(const p of(0,b.$wn)(r)){const A=this.c.getKeysForOverrideIdentifier(p),C=o.getKeysForOverrideIdentifier(p),k=[...C.filter(I=>A.indexOf(I)===-1),...A.filter(I=>C.indexOf(I)===-1),...A.filter(I=>!P.$$m(this.c.override(p).getValue(I),o.override(p).getValue(I)))];n.push([p,k])}return this.updateDefaultConfiguration(o),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(o){const{added:t,updated:n,removed:r}=u(this.d,o),p=[...t,...n,...r];return p.length&&this.updatePolicyConfiguration(o),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=u(this.applicationConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateApplicationConfiguration(o),{keys:A,overrides:p}}compareAndUpdateLocalUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=u(this.localUserConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateLocalUserConfiguration(o),{keys:A,overrides:p}}compareAndUpdateRemoteUserConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=u(this.remoteUserConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateRemoteUserConfiguration(o),{keys:A,overrides:p}}compareAndUpdateWorkspaceConfiguration(o){const{added:t,updated:n,removed:r,overrides:p}=u(this.workspaceConfiguration,o),A=[...t,...n,...r];return A.length&&this.updateWorkspaceConfiguration(o),{keys:A,overrides:p}}compareAndUpdateFolderConfiguration(o,t){const n=this.p.get(o),{added:r,updated:p,removed:A,overrides:C}=u(n,t),k=[...r,...p,...A];return(k.length||!n)&&this.updateFolderConfiguration(o,t),{keys:k,overrides:C}}compareAndDeleteFolderConfiguration(o){const t=this.p.get(o);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:n,updated:r,removed:p,overrides:A}=u(t,void 0);return{keys:[...n,...r,...p],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,t,n){let r=this.r(t,n);return t.overrideIdentifier&&(r=r.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(r=r.merge(this.d)),r}r({resource:o},t){let n=this.s();if(t&&o){const r=t.getFolder(o);r&&(n=this.t(r.uri)||n);const p=this.m.get(o);p&&(n=n.merge(p))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let t=this.b.get(o);if(!t){const n=this.s(),r=this.j.get(o);r?(t=n.merge(r),this.b.set(o,t)):t=n}return t}u(o,t){if(t&&o){const n=t.getFolder(o);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,t)=>{const{contents:n,overrides:r,keys:p}=this.j.get(t);return o.push([t,{contents:n,overrides:r,keys:p}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(t=>o.add(t)),this.userConfiguration.keys.forEach(t=>o.add(t)),this.i.keys.forEach(t=>o.add(t)),this.j.forEach(t=>t.keys.forEach(n=>o.add(n))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>o.add(n))),[...o.values()]}w(o){const t=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(o).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r))),[...t.values()]}static parse(o){const t=this.x(o.defaults),n=this.x(o.policy),r=this.x(o.application),p=this.x(o.user),A=this.x(o.workspace),C=o.folders.reduce((k,I)=>(k.set(c.URI.revive(I[0]),this.x(I[1])),k),new D.$Ac);return new h(t,n,r,p,new v,A,C,new v,new D.$Ac)}static x(o){return new v(o.contents,o.keys,o.overrides)}}e.$En=h;function l(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const o=new Set,t=new Map;for(const r of a)r.keys.forEach(p=>o.add(p)),r.overrides.forEach(([p,A])=>{const C=(0,D.$xc)(t,p,new Set);A.forEach(k=>C.add(k))});const n=[];return t.forEach((r,p)=>n.push([p,[...r.values()]])),{keys:[...o.values()],overrides:n}}e.$Fn=l;class E{constructor(o,t,n,r){this.change=o,this.f=t,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of o.keys)this.affectedKeys.add(p);for(const[,p]of o.overrides)for(const A of p)this.affectedKeys.add(A);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(o,t){const n=this.a+o,r=this.d.indexOf(n);if(r<0)return!1;const p=r+n.length;if(p>=this.d.length)return!1;const A=this.d.charCodeAt(p);if(A!==this.b&&A!==this.c)return!1;if(t){const C=this.previousConfiguration?this.previousConfiguration.getValue(o,t,this.f?.workspace):void 0,k=this.g.getValue(o,t,this.h);return!P.$$m(C,k)}return!0}}e.$Gn=E;function u(a,o){const{added:t,removed:n,updated:r}=i(o?.rawConfiguration,a?.rawConfiguration),p=[],A=a?.getAllOverrideIdentifiers()||[],C=o?.getAllOverrideIdentifiers()||[];if(o){const k=C.filter(I=>!A.includes(I));for(const I of k)p.push([I,o.getKeysForOverrideIdentifier(I)])}if(a){const k=A.filter(I=>!C.includes(I));for(const I of k)p.push([I,a.getKeysForOverrideIdentifier(I)])}if(o&&a){for(const k of A)if(C.includes(k)){const I=i({contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)},{contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)});p.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:r,overrides:p}}function i(a,o){const t=a?o?a.keys.filter(p=>o.keys.indexOf(p)===-1):[...a.keys]:[],n=o?a?o.keys.filter(p=>a.keys.indexOf(p)===-1):[...o.keys]:[],r=[];if(a&&o){for(const p of o.keys)if(a.keys.indexOf(p)!==-1){const A=(0,$.$ri)(o.contents,p),C=(0,$.$ri)(a.contents,p);P.$$m(A,C)||r.push(p)}}return{added:t,removed:n,updated:r}}}),define(ie[237],ne([0,1,23,3,2,37,12,119,57,6,39,43]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=void 0;class y extends s.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Bn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.$gn.as(f.$ln.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:d})=>this.c(Array.from(w),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,d){this.h(w,b.$gn.as(f.$ln.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new P.$Bn;const w=b.$gn.as(f.$ln.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,d){const h=this.f();for(const l of w){const E=h[l],u=d[l];E!==void 0?this.b.addValue(l,E):u?this.b.addValue(l,u.default):this.b.removeValue(l)}}}e.$Hn=y;class g{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.$Bn}async initialize(){return this.configurationModel}}e.$In=g;let v=class extends s.$Sc{get configurationModel(){return this.b}constructor(w,d,h){super(),this.c=w,this.f=d,this.g=h,this.a=this.B(new R.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Bn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const d={},h=[],l=b.$gn.as(f.$ln.Configuration).getConfigurationProperties();for(const E of w){const u=l[E];if(!u){h.push(E);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}h.push(E),d[u.policy.name]={type:u.type}}}return(0,D.$Lf)(d)||await this.f.updatePolicyDefinitions(d),h}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const d=b.$gn.as(f.$ln.Configuration).getPolicyConfigurations(),h=(0,S.$Hb)(w.map(l=>d.get(l)));this.m(h,!0)}m(w,d){this.g.trace("PolicyConfiguration#update",w);const h=b.$gn.as(f.$ln.Configuration).getConfigurationProperties(),l=[],E=this.b.isEmpty();for(const u of w){const i=h[u]?.policy?.name;if(i){const a=this.f.getPolicyValue(i);(E?a!==void 0:!(0,O.$$m)(this.b.getValue(u),a))&&l.push([u,a])}else this.b.getValue(u)!==void 0&&l.push([u,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const u=this.b;this.b=new P.$Bn;for(const i of u.keys)this.b.setValue(i,u.getValue(i));for(const[i,a]of l)a===void 0?this.b.removeValue(i):this.b.setValue(i,a);d&&this.a.fire(this.b)}}};e.$Jn=v,e.$Jn=v=Ee([te(1,$.$in),te(2,c.$0i)],v)}),define(ie[238],ne([0,1,8,3,2,19,18,119,237,39]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class $ extends s.$Sc{constructor(y,g,v,m){super(),this.j=y,this.h=this.B(new R.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Hn),this.c=v instanceof c.$kn?new f.$In:this.B(new f.$Jn(this.b,v,m)),this.f=this.B(new P.$Dn(this.j,{},O.$mg,g)),this.a=new P.$En(this.b.configurationModel,this.c.configurationModel,new P.$Bn,new P.$Bn),this.g=this.B(new S.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:w,properties:d})=>this.n(w,d))),this.B(this.c.onDidChangeConfiguration(w=>this.r(w))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,g,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$En(y,g,new P.$Bn,v)}getConfigurationData(){return this.a.toData()}getValue(y,g){const v=typeof y=="string"?y:void 0,m=(0,D.$ki)(y)?y:(0,D.$ki)(g)?g:{};return this.a.getValue(v,m,void 0)}updateValue(y,g,v,m){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const g=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,g,2)}n(y,g){const v=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(y,g);this.s(m,v,7)}r(y){const g=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,g,7)}s(y,g,v){const m=new P.$Gn(y,{data:g},this.a);m.source=v,m.sourceConfig=this.t(v),this.h.fire(m)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Kn=$}),define(ie[239],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=e.$h8b=e.$g8b=void 0,e.$g8b="request",e.$h8b="remoteResourceHandler";class S{async routeCall(s,O,D){if(O!==e.$g8b)throw new Error(`Call not found: ${O}`);const P=D[0];if(P?.authority){const f=s.connections.find(c=>c.ctx===P.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,O){throw new Error(`Event not found: ${O}`)}}e.$i8b=S}),define(ie[240],ne([0,1,14,5]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,R.$Ph)("remoteAuthorityResolverService");var s;(function($){$[$.WebSocket=0]="WebSocket",$[$.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class O{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=O;class D{constructor(b,y){this.host=b,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=D;var P;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound",$.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class f extends S.$bb{static isNotAvailable(b){return b instanceof f&&b._code===P.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof f&&b._code===P.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof f&&b._code===P.NoResolverFound}static isInvalidAuthority(b){return b instanceof f&&b._code===P.InvalidAuthority}static isHandled(b){return b instanceof f&&b.isHandled}constructor(b,y=P.Unknown,g){super(b),this._message=b,this._code=y,this._detail=g,this.isHandled=y===P.NotAvailable&&g===!0,Object.setPrototypeOf(this,f.prototype)}}e.$Sk=f;function c($){const b=$.indexOf("+");return b===-1?$:$.substring(0,b)}e.$Tk=c}),define(ie[58],ne([0,1,13]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function R(c){return c.scheme===S.Schemas.vscodeRemote?c.authority:void 0}e.$Uk=R;function s(c){if(!c)return;const $=c.indexOf("+");return $<0?c:c.substr(0,$)}e.$Vk=s;function O(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Wk=O;function D(c){const{host:$,port:b}=f(c);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:$,port:b}}e.$Xk=D;function P(c,$){let{host:b,port:y}=f(c);return typeof y>"u"&&(y=$),{host:b,port:y}}e.$Yk=P;function f(c){const $=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const b=c.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=c.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:c,port:void 0}}}),define(ie[120],ne([0,1,27,5,58]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function O(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$4l=O,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(D||(e.ExtensionType=D={}));var P;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class f{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,d){if(typeof w>"u"||w===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof w=="string"||typeof d=="string"){const h=typeof w=="string"?w:w.value,l=typeof d=="string"?d:d.value;return S.$2e(h,l)}return w._lower===d._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$6l=f;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const d of w)this.add(d)}add(w){this.c.add(f.toKey(w))}delete(w){return this.c.delete(f.toKey(w))}has(w){return this.c.has(f.toKey(w))}}e.$7l=c;class ${constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(f.toKey(w))}get(w){return this.c.get(f.toKey(w))}has(w){return this.c.has(f.toKey(w))}set(w,d){this.c.set(f.toKey(w),d)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=$;function b(m){return y(m)}e.$9l=b;function y(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$0l=y;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$$l=g;function v(m,w){if(w){const d=`onResolveRemoteAuthority:${(0,s.$Vk)(w)}`;return!!m.activationEvents?.includes(d)}return!1}e.$_l=v,e.$am=(0,R.$Ph)("IBuiltinExtensionsScannerService")}),define(ie[241],ne([0,1,8,17,22,14,3,2,65,72,32,109,240,58]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const v=30*1e3;var m;(function(L){L[L.Management=1]="Management",L[L.ExtensionHost=2]="ExtensionHost",L[L.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function w(L){switch(L){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(L){const M=new s.$Xd;return setTimeout(()=>M.cancel(),L),M.token}function h(L,M){if(L.isCancellationRequested||M.isCancellationRequested)return s.CancellationToken.Cancelled;const F=new s.$Xd;return L.onCancellationRequested(()=>F.cancel()),M.onCancellationRequested(()=>F.cancel()),F.token}class l{get didTimeout(){return this.c==="timedout"}constructor(M){this.c="pending",this.d=new P.$Rc,this.promise=new Promise((F,T)=>{this.f=F,this.g=T}),M.isCancellationRequested?this.h():this.d.add(M.onCancellationRequested(()=>this.h()))}registerDisposable(M){this.c==="pending"?this.d.add(M):M.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const M=new Error("Time limit reached");return M.code="ETIMEDOUT",M.syscall="connect",M}resolve(M){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(M))}reject(M){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(M))}}function E(L,M){const F=new l(M);return F.registerDisposable(L.onControlMessage(T=>{const N=JSON.parse(T.toString()),B=q(N);B?F.reject(B):F.resolve(N)})),F.promise}function u(L,M,F,T,N,B,V,oe){const de=new l(oe),ue=c.$Jd.create(!1);return L.info(`Creating a socket (${V})...`),f.mark(`code/willCreateSocket/${B}`),M.connect(F,T,N,V).then(he=>{de.didTimeout?(f.mark(`code/didCreateSocketError/${B}`),L.info(`Creating a socket (${V}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(f.mark(`code/didCreateSocketOK/${B}`),L.info(`Creating a socket (${V}) was successful after ${ue.elapsed()} ms.`),de.resolve(he))},he=>{f.mark(`code/didCreateSocketError/${B}`),L.info(`Creating a socket (${V}) returned an error after ${ue.elapsed()} ms.`),L.error(he),de.reject(he)}),de.promise}function i(L,M){const F=new l(M);return L.then(T=>{F.didTimeout||F.resolve(T)},T=>{F.didTimeout||F.reject(T)}),F.promise}async function a(L,M,F,T){const N=Y(L,M);L.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let B;try{B=await u(L.logService,L.remoteSocketFactoryService,L.connectTo,(0,g.$Wk)(L),`reconnectionToken=${L.reconnectionToken}&reconnection=${L.reconnectionProtocol?"true":"false"}`,w(M),`renderer-${w(M)}-${L.reconnectionToken}`,T)}catch(he){throw L.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),L.logService.error(he),he}L.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let V,oe;L.reconnectionProtocol?(L.reconnectionProtocol.beginAcceptReconnection(B,null),V=L.reconnectionProtocol,oe=!1):(V=new b.$Dh({socket:B}),oe=!0),L.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const de=await i(L.signService.createNewMessage((0,$.$eg)()),T),ue={type:"auth",auth:L.connectionToken||"00000000000000000000",data:de.data};V.sendControl(R.$be.fromString(JSON.stringify(ue)));try{const he=await E(V,h(T,d(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(L.logService.trace(`${N} 4/6. received SignRequest control message.`),!await i(L.signService.validate(de,he.signedData),T)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const be=await i(L.signService.sign(he.data),T),ye={type:"connectionType",commit:L.commit,signedData:be,desiredConnectionType:M};return F&&(ye.args=F),L.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(R.$be.fromString(JSON.stringify(ye))),{protocol:V,ownsProtocol:oe}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(L.logService.error(`${N} the handshake timed out. Error:`),L.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(L.logService.error(`${N} received error control message when negotiating connection. Error:`),L.logService.error(he)),oe&&K(V),he}}async function o(L,M,F,T){const N=Date.now(),B=Y(L,M),{protocol:V,ownsProtocol:oe}=await a(L,M,F,T),de=new l(T);return de.registerDisposable(V.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ve=q(he);ve?(L.logService.error(`${B} received error control message when negotiating connection. Error:`),L.logService.error(ve),oe&&K(V),de.reject(ve)):(L.reconnectionProtocol?.endAcceptReconnection(),L.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${re(N)}!`),de.resolve({protocol:V,firstMessage:he}))})),de.promise}async function t(L,M){const{protocol:F}=await o(L,1,void 0,M);return{protocol:F}}async function n(L,M,F){const{protocol:T,firstMessage:N}=await o(L,2,M,F),B=N&&N.debugPort;return{protocol:T,debugPort:B}}async function r(L,M,F){const T=Date.now(),N=Y(L,3),{protocol:B}=await a(L,3,M,F);return L.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${re(T)}!`),B}async function p(L,M,F){const{connectTo:T,connectionToken:N}=await L.addressProvider.getAddress();return{commit:L.commit,quality:L.quality,connectTo:T,connectionToken:N,reconnectionToken:M,reconnectionProtocol:F,remoteSocketFactoryService:L.remoteSocketFactoryService,signService:L.signService,logService:L.logService}}async function A(L,M,F){return k(L,async T=>{const{protocol:N}=await t(T,s.CancellationToken.None);return new Z(L,M,F,T.reconnectionToken,N)})}e.$4k=A;async function C(L,M){return k(L,async F=>{const{protocol:T,debugPort:N}=await n(F,M,s.CancellationToken.None);return new Q(L,M,F.reconnectionToken,T,N)})}e.$5k=C;async function k(L,M){for(let T=1;;T++)try{const N=(0,$.$eg)(),B=await p(L,N,null);return await M(B)}catch(N){if(T<5)L.logService.error(`[remote-connection][attempt ${T}] An error occurred in initial connection! Will retry... Error:`),L.logService.error(N);else throw L.logService.error(`[remote-connection][attempt ${T}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),L.logService.error(N),ce.triggerPermanentFailure(0,0,y.$Sk.isHandled(N)),N}}async function I(L,M,F){const T=await p(L,(0,$.$eg)(),null);return await r(T,{host:M,port:F},s.CancellationToken.None)}e.$6k=I;function j(L){return(0,S.$Hg)(M=>new Promise((F,T)=>{const N=setTimeout(F,L*1e3);M.onCancellationRequested(()=>{clearTimeout(N),F()})}))}var U;(function(L){L[L.ConnectionLost=0]="ConnectionLost",L[L.ReconnectionWait=1]="ReconnectionWait",L[L.ReconnectionRunning=2]="ReconnectionRunning",L[L.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",L[L.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class z{constructor(M,F){this.reconnectionToken=M,this.millisSinceLastIncomingData=F,this.type=0}}e.$7k=z;class x{constructor(M,F,T,N){this.reconnectionToken=M,this.millisSinceLastIncomingData=F,this.durationSeconds=T,this.c=N,this.type=1}skipWait(){this.c.cancel()}}e.$8k=x;class X{constructor(M,F,T){this.reconnectionToken=M,this.millisSinceLastIncomingData=F,this.attempt=T,this.type=2}}e.$9k=X;class ae{constructor(M,F,T){this.reconnectionToken=M,this.millisSinceLastIncomingData=F,this.attempt=T,this.type=4}}e.$0k=ae;class se{constructor(M,F,T,N){this.reconnectionToken=M,this.millisSinceLastIncomingData=F,this.attempt=T,this.handled=N,this.type=3}}e.$$k=se;class ce extends P.$Sc{static triggerPermanentFailure(M,F,T){this._permanentFailure=!0,this.f=M,this.g=F,this.h=T,this.j.forEach(N=>N.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(M=>M.y())}static debugPauseSocketWriting(){this.j.forEach(M=>M.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(M,F,T,N,B){super(),this.t=M,this.u=F,this.reconnectionToken=T,this.protocol=N,this.w=B,this.m=this.B(new D.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(N.onSocketClose(V=>{const oe=H(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${oe} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${oe} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${oe} received socket close event.`),this.y()})),this.B(N.onSocketTimeout(V=>{const oe=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,P.$Qc)(()=>{const V=ce.j.indexOf(this);V>=0&&ce.j.splice(V,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const M=H(this.t,this.reconnectionToken,!0);this.u.logService.info(`${M} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const N=T<F.length?F[T]:F[F.length-1];try{if(N>0){const V=j(N);this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,V)),this.u.logService.info(`${M} waiting for ${N} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${M} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this.u.logService.info(`${M} resolving connection...`);const B=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${M} connecting to ${B.connectTo}...`),await this.G(B,d(v)),this.u.logService.info(`${M} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${M} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this.u.logService.error(`${M} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(y.$Sk.isTemporarilyNotAvailable(B)){this.u.logService.info(`${M} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.u.logService.info(`${M} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((0,O.$4)(B)){this.u.logService.info(`${M} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if(B instanceof y.$Sk){this.u.logService.error(`${M} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,y.$Sk.isHandled(B));break}this.u.logService.error(`${M} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!this.n&&!this.s)}C(M,F,T){this.w?ce.triggerPermanentFailure(M,F,T):this.D(M,F,T)}D(M,F,T){this.m.fire(new se(this.reconnectionToken,M,F,T)),K(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=ce;class Z extends ce{constructor(M,F,T,N,B){super(1,M,N,B,!0),this.client=this.B(new b.$Bh(B,{remoteAuthority:F,clientId:T},M.ipcLogger))}async G(M,F){await t(M,F)}}e.$al=Z;class Q extends ce{constructor(M,F,T,N,B){super(2,M,T,N,!1),this.H=F,this.debugPort=B}async G(M,F){await n(M,this.H,F)}}e.$bl=Q;function K(L){try{L.acceptDisconnect();const M=L.getSocket();L.dispose(),M.dispose()}catch(M){(0,O.$1)(M)}}function q(L){if(L&&L.type==="error"){const M=new Error(`Connection error: ${L.reason}`);return M.code="VSCODE_CONNECTION_ERROR",M}return null}function W(L,M){for(;L.length<M;)L+=" ";return L}function G(L,M){return`[remote-connection][${W(w(L),13)}][${M.substr(0,5)}\u2026]`}function H(L,M,F){return`${G(L,M)}[${F?"reconnect":"initial"}]`}function Y(L,M){return`${H(M,L.reconnectionToken,!!L.reconnectionProtocol)}[${L.connectTo}]`}function re(L){return`${Date.now()-L} ms`}}),define(ie[242],ne([0,1,2,5]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,R.$Ph)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,P){return this.a[D]??=[],this.a[D].push(P),(0,S.$Qc)(()=>{const f=this.a[D]?.indexOf(P);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,P,f,c){const $=this.b(D);if(!$)throw new Error(`No socket factory found for ${D}`);return $.connect(D,P,f,c)}}e.$1k=s}),define(ie[243],ne([0,1,28,47,21,113]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;let D;async function P(g=!1){return(D===void 0||g)&&(D=f()),D}e.$j7b=P;async function f(){const g=c();if(g===void 0)return!1;if(g>=22e3){const v=b();if(v)return new Promise(m=>{R.execFile(v,["--status"],w=>m(!w))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function c(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(g)return parseInt(g[3])}function $(g){const v=process.env.SystemRoot;if(v){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return O.join(v,m?"Sysnative":"System32",g)}}function b(){return $("wsl.exe")}function y(){return $("lxss\\LxssManager.dll")}}),define(ie[50],ne([0,1,17,14,2,183,57,5,6,43]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$So=(0,P.$Ph)("requestService");class ${constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?u[i]="*****":u[i]=this.b[i];this.a=u}return this.a}}class b extends s.$Sc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,O.localize)(0,null),when:f.$oj.isEqualTo((0,f.$mj)(f.LogLevel.Trace)).serialize()})}async c(u,i,a){const o=`${u} #${++this.b}: ${i.url}`;this.a.trace(`${o} - begin`,i.type,new $(i.headers??{}));try{const t=await a();return this.a.trace(`${o} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${o} - error`,i.type,(0,R.$0)(t)),t}}}e.$To=b;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Uo=y;function g(E){return E.res.statusCode===204}e.$Vo=g;async function v(E){return g(E)?null:(await(0,S.$ne)(E.stream)).toString()}e.$Wo=v;async function m(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}e.$Xo=m;async function w(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(g(E))return null;const i=(await(0,S.$ne)(E.stream)).toString();try{return JSON.parse(i)}catch(a){throw a.message+=`:
`+i,a}}e.$Yo=w;function d(E){l(E)}e.$Zo=d;let h;function l(E){const u=c.$gn.as(D.$ln.Configuration),i=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[h],remove:i?[i]:[]})}l(1)}),define(ie[244],ne([0,1,17,22]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=void 0;class s{constructor(P){this.a=P}listen(P,f){throw new Error("Invalid listen")}call(P,f,c,$=R.CancellationToken.None){switch(f){case"request":return this.a.request(c[0],$).then(async({res:b,stream:y})=>{const g=await(0,S.$ne)(y);return[{statusCode:b.statusCode,headers:b.headers},g]});case"resolveProxy":return this.a.resolveProxy(c[0])}throw new Error("Invalid call")}}e.$Vq=s;class O{constructor(P){this.a=P}async request(P,f){const[c,$]=await this.a.call("request",[P],f);return{res:c,stream:(0,S.$pe)($)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$Wq=O}),define(ie[245],ne([0,1,246,12]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=void 0;function s(D,P){return D.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:D.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function O(D,P,f={}){const c=(0,S.parse)(D),$=f.proxyUrl||s(c,P);if(!$)return null;const b=(0,S.parse)($);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,R.$Ef)(f.strictSSL)?f.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((g,v)=>{J(["http-proxy-agent"],g,v)})).HttpProxyAgent($,y):new(await new Promise((g,v)=>{J(["https-proxy-agent"],g,v)})).HttpsProxyAgent($,y)}e.$Xq=O}),define(ie[247],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=e.$D7b=e.$C7b=void 0,e.$C7b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$D7b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$E7b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ie[94],ne([0,1,47,9,184,22,49,14,4,32,108,62,8,140]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;let v;async function m(d,h,l,E){return l["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$j?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Nl)(E)&&!l["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Nl)(E)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(u,i)=>{const a=new O.$Xd;let o=1e4;const t=d.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(o=(0,g.$Ol)(t,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),i(new Error((0,s.localize)(0,null)))},o);try{u(await w(h,a.token))}catch(r){!(0,P.$4)(r)&&!a.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,D.$Ai)(r)))):u({})}finally{clearTimeout(n),a.dispose()}})),v)}e.$Tl=m;async function w(d,h){const l=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",l);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",E);const u=(0,c.$eg)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"({.*})"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",a);const o=await(0,$.$Dl)(f.OS,a);return d.trace("getUnixShellEnvironment#shell",o),new Promise((t,n)=>{if(h.isCancellationRequested)return n(new P.$5);const r=(0,R.$nc)(o);let p,A;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(p=`& '${process.execPath}' ${C} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,A=["-Login","-Command"]):r==="nu"?(p=`^'${process.execPath}' ${C} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,A=["-i","-l","-c"]):(p=`'${process.execPath}' ${C} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,r==="tcsh"||r==="csh"?A=["-ic"]:A=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),p);const k=(0,S.spawn)(o,[...A,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});h.onCancellationRequested(()=>(k.kill(),n(new P.$5))),k.on("error",U=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Ai)(U)),n(U)});const I=[];k.stdout.on("data",U=>I.push(U));const j=[];k.stderr.on("data",U=>j.push(U)),k.on("close",(U,z)=>{const x=Buffer.concat(I).toString("utf8");d.trace("getUnixShellEnvironment#raw",x);const X=Buffer.concat(j).toString("utf8");if(X.trim()&&d.trace("getUnixShellEnvironment#stderr",X),U||z)return n(new Error((0,s.localize)(2,null,U,z)));const ae=i.exec(x),se=ae?ae[1]:"{}";try{const ce=JSON.parse(se);l?ce.ELECTRON_RUN_AS_NODE=l:delete ce.ELECTRON_RUN_AS_NODE,E?ce.ELECTRON_NO_ATTACH_CONSOLE=E:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ce),t(ce)}catch(ce){d.error("getUnixShellEnvironment#errorCaught",(0,D.$Ai)(ce)),n(ce)}})})}}),define(ie[248],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y3b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const O=await this.c();if(O){const D=String(S.a++);return this.b.set(D,O),{id:D,data:O.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,O){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(O)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$y3b=S}),define(ie[95],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,S.$Ph)(e.$2k)}),define(ie[249],ne([0,1,248]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=void 0;class R extends S.$y3b{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(D=>new D.signer().sign(O))}h(){return new Promise((O,D)=>J(["vsda"],O,D))}}e.$s8b=R}),define(ie[34],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.$AN=void 0,e.$AN=(0,S.$Ph)("stateReadService"),e.$BN=(0,S.$Ph)("stateService")}),define(ie[121],ne([0,1,8,17,2,12,36,16,6]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.$CN=e.SaveStrategy=void 0;var c;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class $ extends s.$Sc{constructor(v,m,w,d){super(),this.h=v,this.j=w,this.m=d,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new S.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,m){const w=this.a[v];return(0,O.$Hf)(w)?m:w}setItem(v,m){this.setItems([{key:v,data:m}])}setItems(v){let m=!1;for(const{key:w,data:d}of v)this.a[w]!==d&&((0,O.$Hf)(d)?(0,O.$Ff)(this.a[w])||(this.a[w]=void 0,m=!0):(this.a[w]=d,m=!0));m&&this.r()}removeItem(v){(0,O.$Ff)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,R.$be.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$CN=$;let b=class extends s.$Sc{constructor(v,m,w,d){super(),this.a=this.B(new $(m.stateResource,v,w,d))}async init(){await this.a.init()}getItem(v,m){return this.a.getItem(v,m)}};e.$DN=b,e.$DN=b=Ee([te(1,D.$Wh),te(2,f.$0i),te(3,P.$$j)],b);class y extends b{setItem(v,m){this.a.setItem(v,m)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$EN=y}),define(ie[122],ne([0,1,4,35,32]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=void 0;function O(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,c,$,b,y,g,v,m,w){const d=Object.create(null);d["common.machineId"]=g,d["common.sqmId"]=v,d.sessionID=(0,s.$eg)()+Date.now(),d.commitHash=b,d.version=y,d["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,S.$i)(S.$u),d["common.nodePlatform"]=R.$dc,d["common.nodeArch"]=$,d["common.product"]=w||"desktop",m&&(d["common.msftInternal"]=m);let h=0;const l=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),S.$m&&(d["common.snap"]="true");const E=O(c);return E&&(d["common.platformDetail"]=E),d}e.$ho=D;function P(f){const c=R.env.USERDNSDOMAIN;if(!c)return!1;const $=c.toLowerCase();return f.some(b=>$===b)}e.$io=P}),define(ie[26],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,S.$Ph)("telemetryService"),e.$dl=(0,S.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ie[250],ne([0,1,28,8,44,13,9,4,7,87,21,107,91,16,25,26]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=e.$Fr=e.$Er=e.$Dr=void 0;const w=new Map;async function d(i,a){const o=`${i}::${a.join(":")}`,t=w.get(o);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,p=new Map,A=2e4;function C(I,j,U,z){const x=j.substring(I.length+1);return R.Promises.withAsyncBody(async X=>{let ae;try{ae=await $.Promises.readdir(j,{withFileTypes:!0})}catch{X();return}if(z.count>=A){z.count+=ae.length,z.maxReached=!0,X();return}let se=ae.length;if(se===0){X();return}let ce=ae;z.count+ae.length>A&&(z.maxReached=!0,se=A-z.count,ce=ae.slice(0,se)),z.count+=ae.length;for(const Z of ce)if(Z.isDirectory()){if(U.includes(Z.name)||await C(I,(0,D.$jc)(j,Z.name),U,z),--se===0){X();return}}else{const Q=Z.name.lastIndexOf(".");if(Q>=0){const K=Z.name.substring(Q+1);K&&r.set(K,(r.get(K)??0)+1)}for(const K of n)K.relativePathPattern?.test(x)!==!1&&K.filePattern.test(Z.name)&&p.set(K.tag,(p.get(K.tag)??0)+1);if(--se===0){X();return}}})}const k=R.Promises.withAsyncBody(async I=>{const j={count:0,maxReached:!1};await C(i,i,a,j);const U=await E(i);I({configFiles:h(p),fileTypes:h(r),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:U})});return w.set(o,k),k}e.$Dr=d;function h(i){return Array.from(i.entries(),([a,o])=>({name:a,count:o})).sort((a,o)=>o.count-a.count)}function l(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/g.$Gk.GB).toFixed(2)}GB (${(S.freemem()/g.$Gk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Rm.value()*100)}%`},a=S.cpus();return a&&a.length>0&&(i.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),i}e.$Er=l;async function E(i){try{const a=new Map,o=(0,D.$jc)(i,".vscode","launch.json"),t=await $.Promises.readFile(o),n=[],r=(0,s.$Wm)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,s.$6m)(r)==="object"&&r.configurations)for(const p of r.configurations){const A=p.type;A&&(a.has(A)?a.set(A,a.get(A)+1):a.set(A,1))}return h(a)}catch{return[]}}e.$Fr=E;let u=class{constructor(a,o){this.c=a,this.d=o}f(a){const o=[];return o.push(`OS Version:       ${a.os}`),o.push(`CPUs:             ${a.cpus}`),o.push(`Memory (System):  ${a.memory}`),o.push(`VM:               ${a.vmHint}`),o.join(`
`)}g(a){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const t=S.cpus();return t&&t.length>0&&o.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),o.push(`Memory (System):  ${(S.totalmem()/g.$Gk.GB).toFixed(2)}GB (${(S.freemem()/g.$Gk.GB).toFixed(2)}GB free)`),P.$j||o.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round(c.$Rm.value()*100)}%`),o.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${a.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(a,o){return Promise.all([(0,b.$Cr)(a.mainPID),this.k(a)]).then(async t=>{let[n,r]=t,p=this.m(a,n);return o.forEach(A=>{if((0,y.$rm)(A))p+=`
${A.errorMessage}`,r+=`
${A.errorMessage}`;else if(p+=`

Remote: ${A.hostName}`,A.processes&&(p+=`
${this.m(a,A.processes)}`),A.workspaceMetadata){r+=`
|  Remote: ${A.hostName}`;for(const C of Object.keys(A.workspaceMetadata)){const k=A.workspaceMetadata[C];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),r+=`|    Folder (${C}): ${I}`,r+=this.h(k)}}}),{processInfo:p,workspaceInfo:r}})}async getSystemInfo(a,o){const{memory:t,vmHint:n,os:r,cpus:p}=l(),A={os:r,memory:t,cpus:p,vmHint:n,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:o};return P.$j||(A.load=`${S.loadavg().map(C=>Math.round(C)).join(", ")}`),P.$l&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(a,o){const t=[];return(0,b.$Cr)(a.mainPID).then(async n=>(t.push(""),t.push(this.g(a)),t.push(""),t.push(this.m(a,n)),a.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(a))),o.forEach(r=>{if((0,y.$rm)(r))t.push(`
${r.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${r.hostName}`),t.push(this.f(r.machineInfo)),r.processes&&t.push(this.m(a,r.processes)),r.workspaceMetadata)for(const p of Object.keys(r.workspaceMetadata)){const A=r.workspaceMetadata[p];let C=`${A.fileCount} files`;A.maxFilesReached&&(C=`more than ${C}`),t.push(`Folder (${p}): ${C}`),t.push(this.h(A))}}),t.push(""),t.push(""),t.join(`
`)))}h(a){const o=[];let n=0;const r=(k,I)=>{const j=` ${k}(${I})`;n+j.length>60?(o.push(p),p="|                 ",n=p.length):n+=j.length,p+=j};let p="|      File types:";const A=10,C=a.fileTypes.length>A?A:a.fileTypes.length;for(let k=0;k<C;k++){const I=a.fileTypes[k];r(I.name,I.count)}if(o.push(p),a.configFiles.length>=0&&(p="|      Conf files:",n=0,a.configFiles.forEach(k=>{r(k.name,k.count)}),o.push(p)),a.launchConfigFiles.length>0){let k="|      Launch Configs:";a.launchConfigFiles.forEach(I=>{const j=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=j}),o.push(k)}return o.join(`
`)}j(a){const o=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(o-t.length)}  ${a[t]}`).join(`
                  `)}k(a){const o=[],t=[];return a.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(r=>{const p=f.URI.revive(r);if(p.scheme===O.Schemas.file){const A=p.fsPath;t.push(d(A,["node_modules",".git"]).then(C=>{let k=`${C.fileCount} files`;C.maxFilesReached&&(k=`more than ${k}`),o.push(`|    Folder (${(0,D.$nc)(A)}): ${k}`),o.push(this.h(C))}).catch(C=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${C.toString()})`)}))}else o.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(a,o){const t=new Map;a.windows.forEach(r=>t.set(r.pid,`window [${r.id}] (${r.title})`)),a.pidToNames.forEach(({pid:r,name:p})=>t.set(r,p));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(a.mainPID,t,n,o,0),n.join(`
`)}n(a,o,t,n,r){const p=r===0;let A;p?A=n.pid===a?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?A=o.get(n.pid):A=`${"  ".repeat(r)} ${n.name}`;const C=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(C/g.$Gk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(a,o,t,k,r+1))}async getWorkspaceFileExtensions(a){const o=new Set;for(const{uri:t}of a.folders){const n=f.URI.revive(t);if(n.scheme!==O.Schemas.file)continue;const r=n.fsPath;try{(await d(r,["node_modules",".git"])).fileTypes.forEach(A=>o.add(A.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(a){for(const{uri:o}of a.folders){const t=f.URI.revive(o);if(t.scheme!==O.Schemas.file)continue;const n=t.fsPath;try{const r=await d(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),r.fileTypes.forEach(p=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),r.launchConfigFiles.forEach(p=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})}),r.configFiles.forEach(p=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};e.$Gr=u,e.$Gr=u=Ee([te(0,m.$cl),te(1,v.$pj)],u)}),define(ie[251],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=e.$H7b=void 0;class S{constructor(O){this.b=O}listen(O,D){throw new Error(`Event not found: ${D}`)}call(O,D,{eventName:P,data:f}){return this.b.forEach(c=>c.log(P,f)),Promise.resolve(null)}}e.$H7b=S;class R{constructor(O){this.b=O}log(O,D){return this.b.call("log",{eventName:O,data:D}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$I7b=R}),define(ie[51],ne([0,1,37,12,3,18,58,122,26]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$jo=c;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ko=$,e.$lo=new $;class b{async publicLog(n,r,p){}async publicLogError(n,r,p){}}e.$mo=b,e.$no="telemetry",e.$oo="extensionTelemetryLog",e.$po={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(p,A)=>{const C=p?new Set([...p.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:C}},1e3,!0)(p=>{p.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,O.$mi)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$qo=y;function g(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$ro=g;function v(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$so=v;function m(t){const n=t.getValue(f.$kl),r=t.getValue(f.$ll);if(t.getValue(f.$ml)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$to=m;function w(t){const n={},r={},p={};l(t,p);for(let A in p){A=A.length>150?A.substr(A.length-149):A;const C=p[A];typeof C=="number"?r[A]=C:typeof C=="boolean"?r[A]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${C.length}`),n[A]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(n[A]=C)}return{properties:n,measurements:r}}e.$uo=w;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const n=(0,D.$Vk)(t);return d.has(n)?n:"other"}e.$vo=h;function l(t,n,r=0,p){if(t)for(const A of Object.getOwnPropertyNames(t)){const C=t[A],k=p?p+A:A;Array.isArray(C)?n[k]=(0,S.$_m)(C):C instanceof Date?n[k]=C.toISOString():(0,R.$Af)(C)?r<2?l(C,n,r+1,k+"."):n[k]=(0,S.$_m)(C):n[k]=C}}function E(t,n){const r=t.msftInternalDomains||[],p=n.getValue("telemetry.internalTesting");return(0,P.$io)(r)||p}e.$wo=E;function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$xo=u;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const p=[];for(const I of n)for(;;){const j=I.exec(t);if(!j)break;p.push([j.index,I.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(r="";;){const I=C.exec(t);if(!I)break;const j=p.some(([U,z])=>I.index<z&&U<C.lastIndex);!A.test(I[0])&&!j&&(r+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=C.lastIndex)}return k<t.length&&(r+=t.substr(k)),r}function a(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function o(t,n){return(0,S.$9m)(t,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let p=r.replaceAll("%20"," ");p=i(p,n);for(const A of n)p=p.replace(A,"");return p=a(p),p}})}e.$yo=o}),define(ie[123],ne([0,1,27,117,120,4,7,14,35,51]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;function $(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,S.$We)(o.id,t.id)===0}e.$zo=$;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const n=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,n,r)}static parse(t){const n=b.exec(t);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?$(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Ao=y;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=g.exec(o);return t&&t[1]?[w(t[1]),t[2]]:[w(o),void 0]}e.$Bo=v;function m(o,t){return`${o}.${t}`}e.$Co=m;function w(o){return o.toLowerCase()}e.$Do=w;function d(o,t){return w(m(o??s.$2l,t))}e.$Eo=d;function h(o,t){const n=[],r=p=>{for(const A of n)if(A.some(C=>$(t(C),t(p))))return A;return null};for(const p of o){const A=r(p);A?A.push(p):n.push([p])}return n}e.$Fo=h;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Go=l;function E(o){return{id:new c.$jo(o.identifier.id),name:new c.$jo(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Ho=E,e.$Io=new s.$6l("pprice.better-merge");function u(o,t){const n=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const p=r.shift();if(p&&n.every(A=>!$(A.identifier,{id:p}))){const A=o.filter(C=>$(C.identifier,{id:p}));A.length===1&&(n.push(A[0]),r.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Jo=u;async function i(o,t){if(!O.$l)return!1;let n;try{n=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){t.debug("Error while getting the os-release file.",(0,P.$0)(p))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(o,t){const n=await i(o,t),r=(0,R.$6n)(n?"alpine":O.$u,f.$ec);return t.debug("ComputeTargetPlatform:",r),r}e.$Ko=a}),define(ie[252],ne([0,1,206,51]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;async function s(O,D,P,f,c,$,b){const y={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${D.nameShort})`};if((0,R.$ro)(D,P)&&(0,R.$to)(f)===3){const g=await(0,S.$_o)(P,c,$);y["X-Market-User-Id"]=g,y["VSCode-SessionId"]=b.machineId||g}return y}e.$ap=s}),define(ie[253],ne([0,1,2,37,4,27,185,18,57,78,25,43,26,51]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,h,l){this.k=h,this.l=l,this.d={},this.i=new S.$Rc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,O.$Fe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$Fe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.$kl)||E.affectsConfiguration(y.$ml)||E.affectsConfiguration(y.$ll))&&this.m()}))}setExperimentProperty(d,h){this.d[d]=h}m(){let d=(0,g.$to)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const l=h.usage?3:h.error?2:0;d=Math.min(d,l)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,h,l){this.g<h||(l=(0,R.$0m)(l,this.d),l=(0,g.$yo)(l,this.j),l=(0,R.$0m)(l,this.c),this.b.forEach(E=>E.log(d,l)))}publicLog(d,h){this.n(d,3,h)}publicLog2(d,h){this.publicLog(d,h)}publicLogError(d,h){this.h&&this.n(d,2,h)}publicLogError2(d,h){this.publicLogError(d,h)}};e.$1q=v,e.$1q=v=Ee([te(1,P.$ji),te(2,$.$pj)],v);function m(){const w=(0,D.localize)(0,null,c.default.nameLong),d=c.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$p?"":(0,D.localize)(3,null),l=(0,D.localize)(4,null),E=(0,D.localize)(5,null),u=(0,D.localize)(6,null),i=(0,D.localize)(7,null),a=`
|       | ${l} | ${E} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,D.localize)(8,null);return`
${w} ${d} ${h}

&nbsp;

${i}
${a}

&nbsp;

${o}
`}b.$gn.as(f.$ln.Configuration).registerConfiguration({id:y.$jl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$kl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$gn.as(f.$ln.Configuration).registerConfiguration({id:y.$jl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$ml]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,D.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,D.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$kl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[254],ne([0,1,4,87,26]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=e.$07b=void 0;async function O(P,f){let c=P.getItem(s.$hl);return(typeof c!="string"||S.$k&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,R.$Sm)(f.error.bind(f))),c}e.$07b=O;async function D(P,f){let c=P.getItem(s.$il);return typeof c!="string"&&(c=await(0,R.$Tm)(f.error.bind(f))),c}e.$$7b=D}),define(ie[255],ne([0,1,26,254]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.$_7b=void 0;async function s(D,P){const f=await(0,R.$07b)(D,P);return D.setItem(S.$hl,f),f}e.$_7b=s;async function O(D,P){const f=await(0,R.$$7b)(D,P);return D.setItem(S.$il,f),f}e.$a8b=O}),define(ie[124],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ie[256],ne([0,1,4,124]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class O{constructor($){this.collections=$,this.a=new Map,this.b=new Map,$.forEach((b,y)=>{this.d(b,y);const g=b.map.entries();let v=g.next();for(;!v.done;){const m=v.value[1],w=v.value[0];let d=this.a.get(w);if(d||(d=[],this.a.set(w,d)),d.length>0&&d[0].type===R.EnvironmentVariableMutatorType.Replace){v=g.next();continue}const h={extensionIdentifier:y,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};h.scope||delete h.scope,d.unshift(h),v=g.next()}})}async applyToProcessEnvironment($,b,y){let g;S.$j&&(g={},Object.keys($).forEach(v=>g[v.toLowerCase()]=v));for(const[v,m]of this.getVariableMap(b)){const w=S.$j&&g[v.toLowerCase()]||v;for(const d of m){const h=y?await y(d.value):d.value;if(d.options?.applyAtProcessCreation??!0)switch(d.type){case R.EnvironmentVariableMutatorType.Append:$[w]=($[w]||"")+h;break;case R.EnvironmentVariableMutatorType.Prepend:$[w]=h+($[w]||"");break;case R.EnvironmentVariableMutatorType.Replace:$[w]=h;break}if(d.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${s.get(d.type)}`;$[l]=($[l]?$[l]+":":"")+v+"="+this.c(h)}}}}c($){return $.replaceAll(":","\\x3a")}diff($,b){const y=new Map,g=new Map,v=new Map;if($.getVariableMap(b).forEach((m,w)=>{const d=this.getVariableMap(b).get(w),h=P(m,d);h&&y.set(w,h)}),this.getVariableMap(b).forEach((m,w)=>{const d=$.getVariableMap(b).get(w),h=P(m,d);h&&v.set(w,h)}),this.getVariableMap(b).forEach((m,w)=>{const d=$.getVariableMap(b).get(w),h=f(m,d);h&&g.set(w,h)}),!(y.size===0&&g.size===0&&v.size===0))return{added:y,changed:g,removed:v}}getVariableMap($){const b=new Map;for(const y of this.a.values()){const g=y.filter(v=>D(v,$));g.length>0&&b.set(g[0].variable,g)}return b}getDescriptionMap($){const b=new Map;for(const y of this.b.values()){const g=y.filter(v=>D(v,$,!0));for(const v of g)b.set(v.extensionIdentifier,v.description)}return b}d($,b){if(!$.descriptionMap)return;const y=$.descriptionMap.entries();let g=y.next();for(;!g.done;){const v=g.value[1],m=g.value[0];let w=this.b.get(m);w||(w=[],this.b.set(m,w));const d={extensionIdentifier:b,scope:v.scope,description:v.description};d.scope||delete d.scope,w.push(d),g=y.next()}}}e.$qr=O;function D(c,$,b=!1){return c.scope?!!(c.scope.workspaceFolder&&$?.workspaceFolder&&c.scope.workspaceFolder.index===$.workspaceFolder.index):b?$===c.scope:!0}function P(c,$){if(!$)return c;const b=new Set;$.forEach(g=>b.add(g.extensionIdentifier));const y=[];return c.forEach(g=>{b.has(g.extensionIdentifier)||y.push(g)}),y.length===0?void 0:y}function f(c,$){if(!$)return;const b=new Map;$.forEach(g=>b.set(g.extensionIdentifier,g));const y=[];return c.forEach(g=>{const v=b.get(g.extensionIdentifier);v&&(g.type!==v.type||g.value!==v.value||g.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(ie[257],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=e.$mr=e.$lr=e.$kr=void 0;function S(f){return[...f.entries()]}e.$kr=S;function R(f){return f?[...f.entries()]:[]}e.$lr=R;function s(f){return new Map(f)}e.$mr=s;function O(f){return new Map(f??[])}e.$nr=O;function D(f){return Array.from(f.entries()).map(c=>[c[0],S(c[1].map),R(c[1].descriptionMap)])}e.$or=D;function P(f){return new Map(f.map(c=>[c[0],{map:s(c[1]),descriptionMap:O(c[2])}]))}e.$pr=P}),define(ie[258],ne([0,1,8,22,3,2,6]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;let P=class extends O.$Sc{constructor(c,$){super(),this.h=$,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Nd),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,O.$Qc)(()=>{for(const b of this.f.values())(0,O.$Nc)(b)}))}createRequest(c){return new Promise(($,b)=>{const y=++this.a;this.c.set(y,$),this.g.fire({requestId:y,...c});const g=new R.$Xd;(0,S.$Ug)(this.b,g.token).then(()=>b(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,O.$Qc)(()=>g.cancel())])})}acceptReply(c,$){const b=this.c.get(c);b?(this.c.delete(c),(0,O.$Nc)(this.f.get(c)||[]),this.f.delete(c),b($)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$br=P,e.$br=P=Ee([te(1,D.$0i)],P)}),define(ie[125],ne([0,1,5,114,43]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$7q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$6q=void 0,e.$6q=new R.$7i("terminalTabFocusMode",!1,!0);var O;(function(u){u.AutomationProfile="terminal.integrated.automationProfile.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var D;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var P;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(P||(e.PosixShellType=P={}));var f;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var c;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var $;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})($||(e.TerminalIpcChannels=$={}));var b;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$7q=(0,S.$Ph)("ptyService");var y;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var g;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(g||(e.TerminalLocation=g={}));var v;(function(u){u.TerminalView="view",u.Editor="editor"})(v||(e.TerminalLocationString=v={}));var m;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var w;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var d;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var h;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var l;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$8q={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const a=this.b(i.remoteAuthority);if(this.a.has(a))throw new Error(`A terminal backend with remote authority '${a}' was already registered.`);this.a.set(a,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$gn.add(e.$8q.Backend,new E),e.$9q=(0,S.$Ph)("localPtyService"),e.$0q=(0,S.$Ph)("terminalLogService")}),define(ie[259],ne([0,1,74,7,187,102]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=void 0;function D(y,g){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(m=>({name:m.profileName,description:P(m)}))),g&&v.push(...g.map(m=>({name:m.title,description:f(m)}))),{values:v.map(m=>m.name),markdownDescriptions:v.map(m=>m.description)}}e.$cr=D;function P(y){let g=`$(${O.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Uj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?g+=`
- args: "${y.args}"`:g+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(g+=`
- overrideName: ${y.overrideName}`),y.color&&(g+=`
- color: ${y.color}`),y.env&&(g+=`
- env: ${JSON.stringify(y.env)}`),g}function f(y){return`$(${O.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:S.$Uj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function c(y,g){if(!y&&!g)return!0;if(typeof y=="string"&&typeof g=="string")return y===g;if(Array.isArray(y)&&Array.isArray(g)){if(y.length!==g.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==g[v])return!1;return!0}return!1}e.$dr=c;function $(y,g){if(!y&&!g)return!0;if(!y||!g)return!1;if(O.ThemeIcon.isThemeIcon(y)&&O.ThemeIcon.isThemeIcon(g))return y.id===g.id&&y.color===g.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof g=="object"&&"light"in g&&"dark"in g){const v=y,m=g;if((R.URI.isUri(v.light)||b(v.light))&&(R.URI.isUri(v.dark)||b(v.dark))&&(R.URI.isUri(m.light)||b(m.light))&&(R.URI.isUri(m.dark)||b(m.dark)))return v.light.path===m.light.path&&v.dark.path===m.dark.path}if(R.URI.isUri(y)&&R.URI.isUri(g)||b(y)||b(g)){const v=y,m=g;return v.path===m.path&&v.scheme===m.scheme}return!1}e.$er=$;function b(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$fr=b}),define(ie[260],ne([0,1,74,4,186,57,43,259]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=e.$gr=void 0,e.$gr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$hr={type:"string",enum:Array.from((0,S.$Tj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,S.$Tj)(),w=>`$(${w.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$hr},color:{description:(0,s.localize)(3,null),...e.$gr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},$={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function b(w){const d=w===2?"linux":w===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$i)(w),'```json\n"terminal.integrated.profile.'+d+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){D.$gn.as(O.$ln.Configuration).registerConfiguration(y),m()}e.$ir=g;let v;function m(w,d){const h=D.$gn.as(O.$ln.Configuration);let l;w&&(l=(0,P.$cr)(w?.profiles,d));const E=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?l?.values:void 0,markdownEnumDescriptions:w?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?l?.values:void 0,markdownEnumDescriptions:w?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?l?.values:void 0,markdownEnumDescriptions:w?.os===1?l?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[v],remove:E?[E]:[]})}e.$jr=m}),define(ie[261],ne([0,1,28,13,37,9,4,35,27,12,21,124,257,256]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=e.$rr=void 0;function v(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$rr=v;async function m(t,n,r,p=P.env,A=$.Promises.exists){if(O.$ic(t))return await A(t)?t:void 0;if(n===void 0&&(n=P.cwd()),O.$mc(t)!=="."){const j=O.$jc(n,t);return await A(j)?j:void 0}const k=(0,s.$bn)(p,"PATH");if(r===void 0&&(0,c.$yf)(k)&&(r=k.split(O.$tc)),r===void 0||r.length===0){const j=O.$jc(n,t);return await A(j)?j:void 0}for(const j of r){let U;if(O.$ic(j)?U=O.$jc(j,t):U=O.$jc(n,j,t),await A(U))return U;if(D.$j){let z=U+".com";if(await A(z)||(z=U+".exe",await A(z)))return z}}const I=O.$jc(n,t);return await A(I)?I:void 0}e.$sr=m;function w(t,n,r,p,A){const C=D.$j&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||C)return;const k=t.args,I=P.$dc==="win32"?O.$nc(t.executable).toLowerCase():O.$nc(t.executable),j=O.$mc(R.$cg.asFileUri("").fsPath);let U;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),D.$j){if(I==="pwsh.exe"||I==="powershell.exe")return!k||a(k)?U=l.get(h.WindowsPwsh):i(k)&&(U=l.get(h.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!k||k.length===0?U=l.get(h.Bash):o(k)&&(z.VSCODE_SHELL_LOGIN="1",d(n,z),U=l.get(h.Bash)),U?(U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j),{newArgs:U,envMixin:z}):void 0;case"fish":{const x=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",X=O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${x}:${X}`,d(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!k||a(k)?U=l.get(h.Pwsh):i(k)&&(U=l.get(h.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j,""),{newArgs:U,envMixin:z}):void 0;case"zsh":{if(!k||k.length===0?U=l.get(h.Zsh):o(k)?(U=l.get(h.ZshLogin),d(n,z)):(k===l.get(h.Zsh)||k===l.get(h.ZshLogin))&&(U=k),!U)return;U=[...U],U[U.length-1]=(0,f.$Ce)(U[U.length-1],j);let x;try{x=S.userInfo().username}catch{x="unknown"}const X=O.$jc(S.tmpdir(),`${x}-${A.applicationName}-zsh`);z.ZDOTDIR=X;const ae=r?.ZDOTDIR??S.homedir()??"~";z.USER_ZDOTDIR=ae;const se=[];return se.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.$jc(X,".zshrc")}),se.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.$jc(X,".zprofile")}),se.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.$jc(X,".zshenv")}),se.push({source:O.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.$jc(X,".zlogin")}),{newArgs:U,envMixin:z,filesToCopy:se}}}p.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$tr=w;function d(t,n){if(D.$k&&t.environmentVariableCollections){const r=(0,y.$pr)(t.environmentVariableCollections),A=new g.$qr(r).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),C=[];if(A)for(const k of A)k.type===b.EnvironmentVariableMutatorType.Prepend&&C.push(k.value);C.length>0&&(n.VSCODE_PATH_PREFIX=C.join(""))}}var h;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(h||(h={}));const l=new Map;l.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(h.Zsh,["-i"]),l.set(h.ZshLogin,["-il"]),l.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],u=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(u.includes(t[0].toLowerCase())||u.includes(t[1].toLowerCase()))}function a(t){return typeof t=="string"?u.includes(t.toLowerCase()):t.length===0||t?.length===1&&u.includes(t[0].toLowerCase())}function o(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(ie[262],ne([0,1,47,74,9,4,12,21,106,261,113]),function(J,e,S,R,s,O,D,P,f,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;let b,y=!0;function g(n,r,p,A,C=process.env,k,I,j,U){return k=k||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},O.$j?v(p,k,C,I,A.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:A.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:A.getValue("terminal.integrated.defaultProfile.windows"),U,j):a(k,I,p,n&&typeof n=="object"?{...n}:A.getValue(O.$l?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:A.getValue(O.$l?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,j,C)}e.$ur=g;async function v(n,r,p,A,C,k,I,j,U){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let X=!1;(0,c.$rr)()>=16299&&(X=!0),await h(j);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:R.$Uj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Uj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:R.$Uj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Uj.terminalBash,isAutoDetected:!0});const ce=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",ce],requiresPath:process.env.CMDER_ROOT?ce:{path:ce,isUnsafe:!0},isAutoDetected:!0})}o(k,ae);const se=await m(ae.entries(),I,r,p,A,U);if(n&&C)try{const ce=await u(`${x}\\${X?"wsl":"bash"}.exe`,I);for(const Z of ce)(!k||!(Z.profileName in k))&&se.push(Z)}catch{y&&(A?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return se}async function m(n,r,p,A=process.env,C,k){const I=[];for(const[j,U]of n)I.push(w(j,U,r,p,A,C,k));return(await Promise.all(I)).filter(j=>!!j)}async function w(n,r,p,A,C=process.env,k,I){if(r===null)return;let j,U,z;if("source"in r&&!("path"in r)){const se=b?.get(r.source);if(!se)return;j=se.paths,U=r.args||se.args,r.icon?z=d(r.icon):se.icon&&(z=se.icon)}else j=Array.isArray(r.path)?r.path:[r.path],U=O.$j||Array.isArray(r.args)?r.args:void 0,z=d(r.icon);let x;if(I){const se=j.map(Z=>typeof Z=="string"?Z:Z.path),ce=await I(se);x=new Array(j.length);for(let Z=0;Z<j.length;Z++)typeof j[Z]=="string"?x[Z]=ce[Z]:x[Z]={path:ce[Z],isUnsafe:!0}}else x=j.slice();let X;if(r.requiresPath){let se;if((0,D.$yf)(r.requiresPath)?se=r.requiresPath:(se=r.requiresPath.path,r.requiresPath.isUnsafe&&(X=se)),!await A.existsFile(se))return}const ae=await t(n,p,x,A,C,U,r.env,r.overrideName,r.isAutoDetected,X);if(!ae){k?.debug("Terminal profile not validated",n,j);return}return ae.isAutoDetected=r.isAutoDetected,ae.icon=z,ae.color=r.color,ae}function d(n){return typeof n=="string"?{id:n}:n}async function h(n){if(b&&!n)return;const[r,p]=await Promise.all([l(),n||E()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:r,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:p,icon:R.$Uj.terminalPowershell})}async function l(){const n=new Set,r=await(0,c.$sr)("git.exe");if(r){const C=(0,$.dirname)(r);n.add((0,$.resolve)(C,"../.."))}function p(C,k){k&&C.add(k)}p(n,process.env.ProgramW6432),p(n,process.env.ProgramFiles),p(n,process.env["ProgramFiles(X86)"]),p(n,`${process.env.LocalAppData}\\Program`);const A=[];for(const C of n)A.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function E(){const n=[];for await(const r of(0,f.$xl)())n.push(r.exePath);return n}async function u(n,r){const p=[],A=await new Promise((I,j)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,z)=>{if(U)return j("Problem occurred when getting wsl distros");I(z)})});if(!A)return[];const C=new RegExp(/[\r?\n]/),k=A.split(C).filter(I=>I.trim().length>0&&I!=="");for(const I of k){if(I===""||I.startsWith("docker-desktop"))continue;const j=`${I} (WSL)`,U={profileName:j,path:n,args:["-d",`${I}`],isDefault:j===r,icon:i(I),isAutoDetected:!1};p.push(U)}return p}function i(n){return n.includes("Ubuntu")?R.$Uj.terminalUbuntu:n.includes("Debian")?R.$Uj.terminalDebian:R.$Uj.terminalLinux}async function a(n,r,p,A,C,k,I,j){const U=new Map;if(p){const z=(await n.readFile("/etc/shells")).toString(),x=(k||z.split(`
`)).map(ae=>{const se=ae.indexOf("#");return se===-1?ae:ae.substring(0,se)}).filter(ae=>ae.trim().length>0),X=new Map;for(const ae of x){let se=(0,s.$nc)(ae),ce=X.get(se)||0;ce++,ce>1&&(se=`${se} (${ce})`),X.set(se,ce),U.set(se,{path:ae,isAutoDetected:!0})}}return o(A,U),await m(U.entries(),C,n,j,r,I)}function o(n,r){if(n)for(const[p,A]of Object.entries(n))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?r.delete(p):(A.icon=A.icon||r.get(p)?.icon,r.set(p,A))}async function t(n,r,p,A,C,k,I,j,U,z){if(p.length===0)return Promise.resolve(void 0);const x=p.shift();if(x==="")return t(n,r,p,A,C,k,I,j,U);const X=typeof x!="string"&&x.isUnsafe,ae=typeof x=="string"?x:x.path,se={profileName:n,path:ae,args:k,env:I,overrideName:j,isAutoDetected:U,isDefault:n===r,isUnsafePath:X,requiresUnsafePath:z};if((0,s.$nc)(ae)===ae){const Z=C.PATH?C.PATH.split(s.$tc):void 0,Q=await(0,c.$sr)(ae,void 0,Z,void 0,A.existsFile);return Q?(se.path=Q,se.isFromPath=!0,se):t(n,r,p,A,C,k)}return await A.existsFile((0,s.$hc)(ae))?se:t(n,r,p,A,C,k,I,j,U)}}),define(ie[263],ne([0,1,3,2,4,42,18,6,226,94,258,125,260,262,108,72]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;var w;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let d=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,E,u,i){super(),this.M=l,this.N=E,this.O=u,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Nd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Nd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Nd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Nd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Nd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Nd),this.onProcessData=this.D.event,this.F=this.B(new S.$Nd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Nd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Nd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Nd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Nd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Nd),this.onProcessExit=this.L.event,(0,y.$ir)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new $.$br(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$j)return process.env;try{return await(0,c.$Tl)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),E=l.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),O.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(a=>{this.u.fire(a.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const i=O.ProxyChannel.toService(E.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(a=>this.D.fire(a))),this.B(i.onProcessReady(a=>this.F.fire(a))),this.B(i.onProcessExit(a=>this.L.fire(a))),this.B(i.onDidChangeProperty(a=>this.J.fire(a))),this.B(i.onProcessReplay(a=>this.G.fire(a))),this.B(i.onProcessOrphanQuestion(a=>this.H.fire(a))),this.B(i.onDidRequestDetach(a=>this.I.fire(a))),this.B(new f.$ar(this.P,E.getChannel(b.TerminalIpcChannels.Logger))),this.a=l,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,i]}async createProcess(l,E,u,i,a,o,t,n,r,p,A){const C=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(l,E,u,i,a,o,t,n,r,p,A);return clearTimeout(C),k}updateTitle(l,E,u){return this.f.updateTitle(l,E,u)}updateIcon(l,E,u,i){return this.f.updateIcon(l,E,u,i)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,E){return this.f.detachFromProcess(l,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,E){return this.f.shutdown(l,E)}input(l,E){return this.f.input(l,E)}processBinary(l,E){return this.f.processBinary(l,E)}resize(l,E,u){return this.f.resize(l,E,u)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,E){return this.f.acknowledgeDataEvent(l,E)}setUnicodeVersion(l,E){return this.f.setUnicodeVersion(l,E)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new m.$Jd,E=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...E]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,E){return this.f.installAutoReply(l,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,v.$Dl)(l??s.OS,process.env)}async getProfiles(l,E,u,i=!1){const a=await this.S();return(0,g.$ur)(E,u,i,this.N,a,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,E){return this.f.getWslPath(l,E)}getRevivedPtyNewId(l,E){return this.f.getRevivedPtyNewId(l,E)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,E){return this.f.requestDetachInstance(l,E)}async acceptDetachInstanceReply(l,E){return this.f.acceptDetachInstanceReply(l,E)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,E,u){return this.f.reviveTerminalProcesses(l,E,u)}async refreshProperty(l,E){return this.f.refreshProperty(l,E)}async updateProperty(l,E,u){return this.f.updateProperty(l,E,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,E){return this.j.createRequest({workspaceId:l,originalText:E})}async acceptPtyHostResolvedVariables(l,E){this.j.acceptReply(l,E)}};e.$vr=d,e.$vr=d=Ee([te(1,D.$ji),te(2,P.$0i),te(3,P.$$i)],d)}),define(ie[67],ne([0,1,15,3,2,4,18,5,34]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C6b=e.$B6b=void 0;const c="#FFFFFF",$="#1E1E1E",b="#000000",y="#FFFFFF",g="theme",v="themeBackground",m="windowSplash";e.$B6b=(0,P.$Ph)("themeMainService");let w=class extends s.$Sc{constructor(h,l){super(),this.b=h,this.c=l,this.a=this.B(new R.$Nd),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(O.$j){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(O.$k){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(O.$l&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?b:y;let l=this.b.getItem(v,null);if(!l)switch(this.b.getItem(g,"vs-dark").split(" ")[0]){case"vs":l=c;break;case"hc-black":l=b;break;case"hc-light":l=y;break;default:l=$}return O.$k&&l.toUpperCase()===$&&(l="#171717"),l}saveWindowSplash(h,l){this.b.setItems([{key:g,data:l.baseTheme},{key:v,data:l.colorInfo.background},{key:m,data:l}]),typeof h=="number"&&this.f(h,l)}f(h,l){for(const E of S.BrowserWindow.getAllWindows())if(E.id===h){E.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$C6b=w,e.$C6b=w=Ee([te(0,f.$BN),te(1,D.$ji)],w)}),define(ie[126],ne([0,1,3,18,5,6]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,s.$Ph)("tunnelService"),e.$$u=(0,s.$Ph)("sharedTunnelsService");var D;(function(w){w.Http="http",w.Https="https"})(D||(e.TunnelProtocol=D={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P||(e.TunnelPrivacyId=P={}));function f(w){return!!w.forwardPort}e.$_u=f;var c;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function $(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(d)return{address:d[1],port:+d[2]}}e.$av=$,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(w){return e.$bv.indexOf(w)>=0}e.$cv=b,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(w){return e.$dv.indexOf(w)>=0}e.$ev=y;function g(w,d,h,l){if(h===1)return!1;if(h===2&&y(d)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(E?.length===4&&parseInt(E[1])>=18)return!1}return w<1024}e.$fv=g;class v{constructor(d,h,l){this.remoteAddress=d,this.localAddress=h,this.b=l,this.a=new S.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=v;let m=class{constructor(d,h){this.j=d,this.k=h,this.a=new S.$Nd,this.onTunnelOpened=this.a.event,this.b=new S.$Nd,this.onTunnelClosed=this.b.event,this.c=new S.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const d=this.k.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.f=d,d?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.g=d.elevation,this.h=d.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const d=[],h=Array.from(this.e.values());for(const l of h){const E=Array.from(l.values());for(const u of E){const i=await u.value;i&&typeof i!="string"&&d.push(i)}}return d}async dispose(){for(const d of this.e.values()){for(const{value:h}of d.values())await h.then(l=>typeof l!="string"?l?.dispose():void 0);d.clear()}this.e.clear()}setEnvironmentTunnel(d,h,l,E,u){this.p(d,h,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:h,localAddress:l,privacy:E,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,h){(y(d)||b(d))&&(d=e.$bv[0]);const l=this.r(d,h);if(l)return++l.refcount,l.value}openTunnel(d,h,l,E,u,i=!1,a,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${l} on local port ${u}.`);const t=this.f??d;if(!t)return;if(h||(h="localhost"),E||(E=this.l),this.f&&this.i.has(l)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,h,l,E,u,i,a,o);return n?n.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,l),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,l);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(r);return(r.tunnelRemoteHost!==h||r.tunnelRemotePort!==l)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&r.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this.e.get(d.tunnelRemoteHost);if(h){const l=h.get(d.tunnelRemotePort);l&&(l.refcount--,await this.o(d.tunnelRemoteHost,d.tunnelRemotePort,l))}}}}async o(d,h,l){if(l.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const E=l.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(d)&&this.e.get(d).delete(h),E}}async closeTunnel(d,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const l=this.e.get(d);if(l&&l.has(h)){const E=l.get(h);E.refcount=0,await this.o(d,h,E)}}p(d,h,l){this.e.has(d)||this.e.set(d,new Map),this.e.get(d).set(h,{refcount:1,value:l})}async q(d,h){const l=this.e.get(d);if(l){const E=l.get(h),u=E?await E.value:void 0;(!u||typeof u=="string")&&l.delete(h),l.size===0&&this.e.delete(d)}}r(d,h){const l=[d];b(d)?(l.push(...e.$bv),l.push(...e.$dv)):y(d)&&l.push(...e.$dv);const E=l.map(u=>this.e.get(u));for(const u of E){const i=u?.get(h);if(i)return i}}canTunnel(d){return!!$(d)}t(d,h,l,E,u,i,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${l} on local port ${E}.`);const o=l;this.i.add(o);const t=E===void 0?l:E,n={elevationRequired:u?this.isPortPrivileged(t):!1},r={remoteAddress:{host:h,port:l},localAddressPort:E,privacy:i,public:i?i!==P.Private:void 0,protocol:a},p=d.forwardPort(r,n);return p?(this.p(h,l,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),p}};e.$hv=m,e.$hv=m=Ee([te(0,O.$0i),te(1,R.$ji)],m)}),define(ie[48],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=e.$pU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var O;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(O||(e.DisablementReason=O={})),e.$pU={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,P)=>({type:"idle",updateType:D,error:P}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$qU=(0,S.$Ph)("updateService")}),define(ie[264],ne([0,1,4,188,57,43]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),O.$gn.as(s.$ln.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:S.$j&&!S.$p},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[265],ne([0,1,3,48]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=e.$J7b=void 0;class s{constructor(P){this.a=P}listen(P,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,c){switch(f){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${f}`)}}e.$J7b=s;class O{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Nd,this.onStateChange=this.a.event,this.b=R.$pU.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$K7b=O}),define(ie[40],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,S.$Ph)("IUriIdentityService")}),define(ie[266],ne([0,1,40,207,16,19,141,3,2]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;class c{static{this._clock=0}constructor(y){this.uri=y,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let $=class{constructor(y){this.g=y,this.c=new f.$Rc,this.f=2**16;const g=new Map,v=m=>{let w=g.get(m.scheme);return w===void 0&&(w=y.hasProvider(m)&&!this.g.hasCapability(m,1024),g.set(m.scheme,w)),w};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(m=>{g.delete(m.scheme)})),this.extUri=new O.$kg(v),this.d=new D.$yr((m,w)=>this.extUri.compare(m,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,O.$wg)(y));const g=this.d.get(y);return g?g.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new c(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,m)=>v[1].time<m[1].time?1:v[1].time>m[1].time?-1:0);c._clock=0,this.d.clear();const g=this.f*.5;for(let v=0;v<g;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$zr=$,e.$zr=$=Ee([te(0,s.$$j)],$),(0,R.$wr)(S.$Ik,$,1)}),define(ie[127],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eU=void 0,e.$eU=(0,S.$Ph)("urlService")}),define(ie[267],ne([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=e.$S7b=e.$R7b=void 0;class R{constructor(P){this.a=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,c){switch(f){case"handleURL":return this.a.handleURL(S.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${f}`)}}e.$R7b=R;class s{constructor(P){this.a=P}handleURL(P,f){return this.a.call("handleURL",[P.toJSON(),f])}}e.$S7b=s;class O{constructor(P,f){this.a=P,this.b=f}async routeCall(P,f,c,$){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(c)&&c.length>0){const b=S.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const y=/\bwindowId=(\d+)/.exec(b.query);if(y){const g=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,b.toString(!0));const v=new RegExp(`window:${g}`),m=P.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),v.test(w.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,f,c,$)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.$T7b=O}),define(ie[268],ne([0,1,8,2,7,25]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gU=e.$fU=void 0;class D extends R.$Sc{constructor(){super(...arguments),this.a=new Set}open(c,$){const b=[...this.a.values()];return(0,S.$Xg)(b.map(y=>()=>y.handleURL(c,$)),void 0,!1).then(y=>y||!1)}registerHandler(c){return this.a.add(c),(0,R.$Qc)(()=>this.a.delete(c))}}e.$fU=D;let P=class extends D{constructor(c){super(),this.b=c}create(c){let{authority:$,path:b,query:y,fragment:g}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return $&&b&&b.indexOf("/")!==0&&(b=`/${b}`),s.URI.from({scheme:this.b.urlProtocol,authority:$,path:b,query:y,fragment:g})}};e.$gU=P,e.$gU=P=Ee([te(0,O.$pj)],P)}),define(ie[269],ne([0,1,15,8,3,2,4,7]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=void 0;class f extends O.$Sc{constructor($,b,y,g,v,m){if(super(),this.c=b,this.f=m,this.a=[],this.b=0,$&&(m.trace("ElectronURLListener initialUrisToHandle:",$.map(h=>h.originalUrl)),this.a=$),D.$j){const h=g.isBuilt?[]:[`"${g.appRoot}"`];h.push("--open-url","--"),S.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,h)}const w=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(h,l)=>({event:h,url:l})),({event:h,url:l})=>(h.preventDefault(),l));this.B(w(h=>{const l=this.g(h);l&&this.c.open(l,{originalUrl:h})})),y.getWindows().filter(h=>h.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(y.onDidSignalReadyWindow)(()=>this.h())))}g($){try{return P.URI.parse($)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const $=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),$.push(b));$.length!==0&&(this.a=$,(0,R.$Vg)(()=>this.h(),500,this.q))}}e.$U7b=f}),define(ie[270],ne([0,1,3,2,16,56,31]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=void 0;class P extends R.$Sc{constructor(c,$,b,y,g,v){super(),this.f=c,this.g=$,this.h=b,this.j=y,this.m=g,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Nd),this.onDidChangeFile=this.a.event,this.b=O.$Vh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,$){return this.g.open(this.t(c),$)}close(c){return this.g.close(c)}read(c,$,b,y,g){return this.g.read(c,$,b,y,g)}write(c,$,b,y,g){return this.g.write(c,$,b,y,g)}watch(c,$){this.b.set(c,c);const b=this.g.watch(this.t(c),$);return(0,R.$Qc)(()=>{this.b.delete(c),b.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,$,b){return this.g.rename(this.t(c),this.t($),b)}readFile(c,$){return this.g.readFile(this.t(c),$)}readFileStream(c,$,b){return this.g.readFileStream(this.t(c),$,b)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,$,b){return this.g.writeFile(this.t(c),$,b)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,$){return this.g.delete(this.t(c),$)}copy(c,$,b){if((0,s.$ck)(this.g))return this.g.copy(this.t(c),this.t($),b);throw new Error("copy not supported")}cloneFile(c,$){if((0,s.$dk)(this.g))return this.g.cloneFile(this.t(c),this.t($));throw new Error("clone not supported")}s(c){const $=[];for(const b of c){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&$.push({resource:y,type:b.type,cId:b.cId})}$.length&&(this.n.debug("User data changed"),this.a.fire($))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$v8b=P}),define(ie[271],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=void 0,e.$c8b="utilityProcessWorker"}),define(ie[272],ne([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=void 0,e.$V7b=(0,S.$Ph)("webviewManagerService")}),define(ie[273],ne([0,1,15,2,13,7]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W7b=void 0;class D extends R.$Sc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,c){try{const $=O.URI.parse(f.url),b=D.a.get($.path);if(typeof b=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${b}`,g=s.$cg.asFileUri(y);return c({path:g.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$W7b=D}),define(ie[68],ne([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=void 0,e.$fC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R($){return!!$.workspaceUri}e.$gC=R;function s($){return!!$.folderUri}e.$hC=s;function O($){return!!$.fileUri}e.$iC=O;function D($){const b=P($),y=$.getValue("window.menuBarVisibility");return y==="default"||b==="native"&&y==="compact"||S.$k&&S.$n?"classic":y}e.$jC=D;function P($){if(S.$p)return"custom";const b=$.getValue("window");if(b){if(S.$k&&b.nativeTabs===!0||S.$k&&b.nativeFullScreen===!1)return"native";const v=b.titleBarStyle;if(v==="native"||v==="custom")return v}return S.$l?"native":"custom"}e.$kC=P;function f($){return!(!S.$j||S.$p||P($)==="native")}e.$lC=f;function c($=0){return Math.pow(1.2,$)}e.$mC=c}),define(ie[128],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$m6b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var R;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$m6b=s;var O;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(O||(e.WindowMode=O={}));var D;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(ie[274],ne([0,1,8,3,2]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$37b=void 0;class O extends s.$Sc{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:c}){super(),this.a=this.B(new s.$Rc),R.Event.latch(R.Event.any(P,f))(this.f,this,this.a),this.b=(0,S.$Hg)(()=>c()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$37b=O}),define(ie[30],ne([0,1,192,9,56,19,7,5,13]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,P.$Ph)("contextService");function c(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Zh=c;function $(t){return typeof t?.id=="string"&&!c(t)&&!y(t)}e.$1h=$,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function b(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,R.$nc)(t)}:n?e.$2h:e.$3h;const r=t;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$4h=b;function y(t){const n=t;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$5h=y;function g(t){const n=t;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=t;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(t?.id)return{id:t.id}}e.$6h=g;var v;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function m(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$7h=m;function w(t){const n=t;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$8h=w;class d{constructor(n,r,p,A,C){this.h=n,this.j=p,this.k=A,this.l=C,this.c=s.$Vh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Vh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=d;class h{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=h;function l(t){return new h({uri:t,index:0,name:(0,O.$rg)(t)},{uri:t.toString()})}e.$$h=l,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,S.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function E(t,n){return O.$mg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$di=E;function u(t){let n;return D.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===f.Schemas.tmp}e.$ei=u,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$fi}e.$gi=i;function a(t,n){return!E(t,n)&&!u(t)}e.$hi=a;function o(t){return(typeof t=="string"?(0,R.$oc)(t):(0,O.$tg)(t))===e.$ai}e.$ii=o}),define(ie[59],ne([0,1,15,8,55,46,2,84,4,21,167,115,5,6,25,30]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.$H6b=void 0,e.$H6b=(0,y.$Ph)("dialogMainService");let w=class{constructor(h,l){this.d=h,this.e=l,this.a=new Map,this.b=new Map,this.c=new R.$1g}pickFileFolder(h,l){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,$.localize)(0,null)},l)}pickFolder(h,l){return this.f({...h,pickFolders:!0,title:(0,$.localize)(1,null)},l)}pickFile(h,l){return this.f({...h,pickFiles:!0,title:(0,$.localize)(2,null)},l)}pickWorkspace(h,l){const E=(0,$.localize)(3,null),u=(0,O.$yv)((0,$.localize)(4,null)),i=m.$bi;return this.f({...h,pickFiles:!0,title:E,filters:i,buttonLabel:u},l)}async f(h,l){const E={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(E.properties=void 0,h.pickFiles&&h.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$k&&E.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(E,(l||S.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(h){if(h){let l=this.b.get(h.id);return l||(l=new R.$1g,this.b.set(h.id,l)),l}else return this.c}showMessageBox(h,l){return this.g(l).queue(async()=>{const{options:E,buttonIndeces:u}=(0,b.$Fv)(h,this.e);let i;return l?i=await S.dialog.showMessageBox(l,E):i=await S.dialog.showMessageBox(E),{response:u[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(h,l){const E=this.j(h,l);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let u;return l?u=await S.dialog.showSaveDialog(l,h):u=await S.dialog.showSaveDialog(h),u.filePath=this.h(u.filePath),u})}finally{(0,D.$Nc)(E)}}h(h){return h&&f.$k&&(h=(0,P.$ol)(h)),h}i(h){return h.map(l=>this.h(l))}async showOpenDialog(h,l){h.defaultPath&&(await c.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const E=this.j(h,l);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let u;return l?u=await S.dialog.showOpenDialog(l,h):u=await S.dialog.showOpenDialog(h),u.filePaths=this.i(u.filePaths),u})}finally{(0,D.$Nc)(E)}}j(h,l){if(!l)return D.$Sc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let E=this.a.get(l.id);E||(E=new Set,this.a.set(l.id,E));const u=(0,s.$Di)(h);if(!E.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",h),E.add(u),(0,D.$Qc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),E?.delete(u),E?.size===0&&this.a.delete(l.id)})}};e.$I6b=w,e.$I6b=w=Ee([te(0,g.$0i),te(1,v.$pj)],w)}),define(ie[275],ne([0,1,3,2,76,30]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G7b=void 0;class D extends R.$Sc{static{this.a=100}constructor(f,c){super(),this.f=f,this.g=c,this.b=this.B(new S.$Nd),this.c=new Map,this.h(c.applicationStorage,this.b)}h(f,c){this.B(S.Event.debounce(f.onDidChangeStorage,($,b)=>($?$.push(b):$=[b],$),D.a)($=>{$.length&&c.fire(this.j($,f))}))}j(f,c){const $=new Map,b=new Set;return f.forEach(y=>{const g=c.get(y.key);typeof g=="string"?$.set(y.key,g):b.add(y.key)}),{changed:Array.from($.entries()),deleted:Array.from(b.values())}}listen(f,c,$){switch(c){case"onDidChangeStorage":{const b=$.profile?(0,s.$mh)($.profile):void 0;if(!b)return this.b.event;let y=this.c.get(b.id);return y||(y=this.B(new S.$Nd),this.h(this.g.profileStorage(b),y),this.c.set(b.id,y)),y.event}}throw new Error(`Event not found: ${c}`)}async call(f,c,$){const b=$.profile?(0,s.$mh)($.profile):void 0,y=(0,O.$6h)($.workspace),g=await this.m(b,y);switch(c){case"getItems":return Array.from(g.items.entries());case"updateItems":{const v=$;if(v.insert)for(const[m,w]of v.insert)g.set(m,w);v.delete?.forEach(m=>g.delete(m));break}case"optimize":return g.optimize();case"isUsed":{const v=$.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${c}`)}}async m(f,c){let $;c?$=this.g.workspaceStorage(c):f?$=this.g.profileStorage(f):$=this.g.applicationStorage;try{await $.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":f?"profile":"application"} storage due to ${b}`)}return $}}e.$G7b=D}),define(ie[41],ne([0,1,55,3,2,19,7,189,36,16,5,6,30,31,40,8,32,27,12]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var l;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Jk=E,e.$Kk=(0,$.$Ph)("IUserDataProfilesService");function u(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:D.URI.revive(t.location).with({scheme:n}),globalStorageHome:D.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Lk=u;function i(t,n,r,p,A,C){return{id:t,name:n,location:r,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:C&&A?.useDefaultFlags?.globalState?C.globalStorageHome:(0,O.$vg)(r,"globalStorage"),settingsResource:C&&A?.useDefaultFlags?.settings?C.settingsResource:(0,O.$vg)(r,"settings.json"),keybindingsResource:C&&A?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,O.$vg)(r,"keybindings.json"),tasksResource:C&&A?.useDefaultFlags?.tasks?C.tasksResource:(0,O.$vg)(r,"tasks.json"),snippetsHome:C&&A?.useDefaultFlags?.snippets?C.snippetsHome:(0,O.$vg)(r,"snippets"),extensionsResource:C&&A?.useDefaultFlags?.extensions?C.extensionsResource:(0,O.$vg)(r,"extensions.json"),cacheHome:(0,O.$vg)(p,t),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$Mk=i;let a=class extends s.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,p,A){super(),this.t=n,this.u=r,this.w=p,this.y=A,this.f=!0,this.h=this.B(new R.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new g.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,h.$yf)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}r.push(i((0,O.$sg)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},n))}}catch(C){this.y.error(C)}const p=new g.$Ac,A=new Map;if(r.length)try{const C=this.Q();if(C.workspaces)for(const[k,I]of Object.entries(C.workspaces)){const j=D.URI.parse(k),U=r.find(z=>z.id===I);U&&p.set(j,U)}if(C.emptyWindows)for(const[k,I]of Object.entries(C.emptyWindows)){const j=r.find(U=>U.id===I);j&&A.set(k,j)}}catch(C){this.y.error(C)}this.z={profiles:r,workspaces:p,emptyWindows:A}}return this.z}D(){const n=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",p=new RegExp(`${(0,d.$Fe)(r)}\\s(\\d+)`);let A=0;for(const k of this.profiles){const I=p.exec(k.name),j=I?parseInt(I[1]):0;A=j>A?j:A}const C=`${r} ${A+1}`;return this.createProfile((0,S.$Di)((0,w.$eg)()).toString(16),C,{transient:!0},n)}async createNamedProfile(n,r,p){return this.createProfile((0,S.$Di)((0,w.$eg)()).toString(16),n,r,p)}async createProfile(n,r,p,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(n,r,p);return A&&await this.setProfileForWorkspace(A,C),C}async F(n,r,p){if(!(0,h.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(r);return A||(A=(async()=>{try{const C=this.profiles.find(j=>j.name===r||j.id===n);if(C)return C;const k=i(n,r,(0,O.$vg)(this.profilesHome,n),this.g,p,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(j){I.push(j)}}),await m.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(r)}})(),this.r.set(r,A)),A}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(A=>A.id===n.id);if(!p)throw new Error(`Profile '${n.name}' does not exist`);return p=i(p.id,r.name??p.name,p.location,this.g,{shortName:r.shortName??p.shortName,icon:r.icon===null?void 0:r.icon??p.icon,transient:r.transient??p.isTransient,useDefaultFlags:r.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(A=>A.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const p=[];this.m.fire({profile:r,join(A){p.push(A)}});try{await Promise.allSettled(p)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(A){(0,c.$pk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(A=>A.id===r.id);if(!p)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,p)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,y.$Zh)(n)?n.uri:(0,y.$5h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,p){const A=[...this.profiles,...n],C=[];this.s.profiles=[];for(let k of A)k.isDefault||r.some(I=>k.id===I.id)||(k=p.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):C.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(C),this.z=void 0,this.J(n,r,p)}J(n,r,p){this.h.fire({added:n,removed:r,updated:p,all:this.profiles})}L(n,r,p){p=r?.isTransient?!0:p,p||this.L(n,void 0,!0);const A=this.G(n),C=p?this.s:this.C;D.URI.isUri(A)?(C.workspaces.delete(A),r&&C.workspaces.set(A,r)):(C.emptyWindows.delete(A),r&&C.emptyWindows.set(A,r)),p||this.M()}M(){const n={};for(const[p,A]of this.C.workspaces.entries())n[p.toString()]=A.id;const r={};for(const[p,A]of this.C.emptyWindows.entries())r[p.toString()]=A.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},p=this.D();if(n.workspaces)for(const[C,k]of Object.entries(n.workspaces)){const I=D.URI.parse(k);r[C]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}const A={};if(n.emptyWindows)for(const[C,k]of Object.entries(n.emptyWindows)){const I=D.URI.parse(k);A[C]=this.w.extUri.isEqual(I,p.location)?p.id:this.w.extUri.basename(I)}return{workspaces:r,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Nk=a,e.$Nk=a=Ee([te(0,f.$Wh),te(1,c.$$j),te(2,v.$Ik),te(3,b.$0i)],a);class o extends a{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ok=o}),define(ie[80],ne([0,1,8,17,2,3,31,7,117,123,16,5,6,41,40,12,14,26]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class l extends Error{constructor(o,t){super(o),this.code=t}}e.$tp=l,e.$up=(0,b.$Ph)("IExtensionsProfileScannerService");let E=class extends s.$Sc{constructor(o,t,n,r,p,A){super(),this.j=o,this.m=t,this.n=n,this.r=r,this.s=p,this.t=A,this.b=this.B(new O.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new O.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(o,t){return this.u(o,void 0,t)}async addExtensionsToProfile(o,t){const n=[],r=[];try{return await this.u(t,p=>{const A=[];for(const C of p)o.some(([k])=>(0,c.$zo)(k.identifier,C.identifier)&&k.manifest.version!==C.version)?n.push(C):A.push(C);for(const[C,k]of o){const I=A.findIndex(U=>(0,c.$zo)(U.identifier,C.identifier)&&U.version===C.manifest.version),j={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:k};I===-1?(r.push(j),A.push(j)):A.splice(I,1,j)}return r.length&&this.b.fire({extensions:r,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),A}),r.length&&this.c.fire({extensions:r,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),r}catch(p){throw r.length&&this.c.fire({extensions:r,error:p,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:p,profileLocation:t}),p}}async updateMetadata(o,t){const n=[];return await this.u(t,r=>{const p=[];for(const A of r){const C=o.find(([k])=>(0,c.$zo)(k.identifier,A.identifier)&&k.manifest.version===A.version);C&&(A.metadata={...A.metadata,...C[1]},n.push(A)),p.push(A)}return p}),n}async removeExtensionFromProfile(o,t){const n=[];try{await this.u(t,r=>{const p=[];for(const A of r)(0,c.$zo)(A.identifier,o.identifier)?n.push(A):p.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:t}),p}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:t}),r}}async u(o,t,n){return this.F(o).queue(async()=>{let r=[],p;try{const A=await this.m.readFile(o);p=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,$.$pk)(A)!==1)throw A;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(p=await this.D()),!p&&n?.bailOutWhenFileNotFound)throw new l((0,w.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(p){Array.isArray(p)||this.w(o);let A=!1;for(const C of p){u(C)||this.w(o);let k;if((0,m.$yf)(C.relativeLocation)&&C.relativeLocation)k=this.z(C.relativeLocation);else if((0,m.$yf)(C.location))k=this.z(C.location),A=!0,C.relativeLocation=C.location,C.location=k.toJSON();else{k=P.URI.revive(C.location);const I=this.y(k);I&&(A=!0,C.relativeLocation=I)}r.push({identifier:C.identifier,location:k,version:C.version,metadata:C.metadata})}A&&await this.m.writeFile(o,R.$be.fromString(JSON.stringify(p)))}if(t){r=t(r);const A=r.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(o,R.$be.fromString(JSON.stringify(A)))}return r})}w(o){const t=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch(p){if((0,$.$pk)(p)===1)return;throw p}this.t.info("Migrating extensions from old default profile location",o.toString());let r;try{const p=JSON.parse(n);Array.isArray(p)&&p.every(A=>u(A))?r=p:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",p)}catch(p){this.t.error(p)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(p){if((0,$.$pk)(p)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw p}try{await this.m.del(o)}catch(p){(0,$.$pk)(p)!==1&&this.t.error(p)}try{await this.m.del(t)}catch(p){(0,$.$pk)(p)!==1&&this.t.error(p)}return r})()),this.C}F(o){let t=this.h.get(o);return t||(t=new S.$1g,this.h.set(o,t)),t}};e.$vp=E,e.$vp=E=Ee([te(1,$.$$j),te(2,g.$Kk),te(3,v.$Ik),te(4,d.$cl),te(5,y.$0i)],E);function u(a){return(0,m.$Af)(a)&&(0,f.$9n)(a.identifier)&&(i(a.location)||(0,m.$yf)(a.location)&&a.location)&&((0,m.$Ff)(a.relativeLocation)||(0,m.$yf)(a.relativeLocation))&&a.version&&(0,m.$yf)(a.version)}function i(a){return a?(0,m.$yf)(a.path)&&(0,m.$yf)(a.scheme):!1}}),define(ie[129],ne([0,1,23,8,37,17,14,44,152,2,13,9,4,19,205,73,12,7,172,36,123,120,204,16,5,6,25,3,76,80,41,40,203]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i,a,o,t,n,r,p,A,C,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.Translations=void 0;var j;(function(ce){function Z(Q,K){if(Q===K)return!0;const q=Object.keys(Q),W=new Set;for(const G of Object.keys(K))W.add(G);if(q.length!==W.size)return!1;for(const G of q){if(Q[G]!==K[G])return!1;W.delete(G)}return W.size===0}ce.equals=Z})(j||(e.Translations=j={})),e.$yp=(0,o.$Ph)("IExtensionsScannerService");let U=class extends c.$Sc{constructor(Z,Q,K,q,W,G,H,Y,re,L,M,F){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=Q,this.r=K,this.s=q,this.t=W,this.u=G,this.w=H,this.y=Y,this.z=re,this.C=L,this.D=M,this.F=F,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,g.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(X,this.s,this.h)),this.m=this.B(this.F.createInstance(X,this.s,this.h)),this.n=this.B(this.F.createInstance(x,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Ko)(this.w,this.y)),this.G}async scanAllExtensions(Z,Q,K){const[q,W]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(Q)]),G=K?await this.scanExtensionsUnderDevelopment(Z,[...q,...W]):[];return this.L(q,W,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const Q=[];Q.push(this.M(!!Z.useCache,Z.language)),Q.push(this.N(Z.language,!!Z.checkControlFile));const[K,q]=await Promise.all(Q);return this.J([...K,...q],0,Z,!1)}async scanUserExtensions(Z){const Q=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const K=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(Q,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,K),W=Z.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let G;try{G=await W.scanExtensions(q)}catch(H){if(H instanceof A.$tp&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await W.scanExtensions(q);else throw H}return G=await this.J(G,1,Z,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Z,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const K=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===$.Schemas.file).map(async q=>{const W=await this.P(q,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(W)).map(H=>(H.type=Q.find(Y=>(0,E.$zo)(Y.identifier,H.identifier))?.type??H.type,this.n.validate(H,W)))}))).flat();return this.J(K,"development",Z,!0)}return[]}async scanExistingExtension(Z,Q,K){const q=await this.P(Z,!1,Q,!0,K.language,!0,void 0),W=await this.n.scanExtension(q);return!W||!K.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(Z,Q,K){const q=await this.P(Z,!1,Q,!0,K.language,!0,void 0),W=await this.n.scanOneOrMultipleExtensions(q);return this.J(W,Q,K,!0)}async scanMetadata(Z){const Q=(0,g.$vg)(Z,"package.json"),K=(await this.w.readFile(Q)).value.toString();return JSON.parse(K).__metadata}async updateMetadata(Z,Q){const K=(0,g.$vg)(Z,"package.json"),q=(await this.w.readFile(K)).value.toString(),W=JSON.parse(q);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,W.__metadata={...W.__metadata,...Q},await this.w.writeFile((0,g.$vg)(Z,"package.json"),O.$be.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof A.$tp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$be.fromString(JSON.stringify([])))}catch(Q){(0,a.$pk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,Q,K,q){return K.includeAllVersions||(Z=this.L(Q===0?Z:void 0,Q===1?Z:void 0,Q==="development"?Z:void 0,await this.getTargetPlatform(),q)),K.includeInvalid||(Z=Z.filter(W=>W.isValid)),Z.sort((W,G)=>{const H=b.$nc(W.location.fsPath),Y=b.$nc(G.location.fsPath);return H<Y?-1:H>Y?1:0})}L(Z,Q,K,q,W){const G=(Y,re,L)=>{if(Y.isValid&&!re.isValid)return!1;if(Y.isValid===re.isValid){if(W&&v.gt(Y.manifest.version,re.manifest.version))return this.y.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(v.eq(Y.manifest.version,re.manifest.version)){if(Y.type===0)return this.y.debug(`Skipping extension ${re.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===q)return this.y.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`),!1}}return L?this.y.warn(`Overwriting user extension ${Y.location.path} with ${re.location.path}.`):this.y.debug(`Overwriting user extension ${Y.location.path} with ${re.location.path}.`),!0},H=new u.$8l;return Z?.forEach(Y=>{const re=H.get(Y.identifier.id);(!re||G(re,Y,!1))&&H.set(Y.identifier.id,Y)}),Q?.forEach(Y=>{const re=H.get(Y.identifier.id);if(!re&&Z&&Y.type===0){this.y.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!re||G(re,Y,!1))&&H.set(Y.identifier.id,Y)}),K?.forEach(Y=>{const re=H.get(Y.identifier.id);(!re||G(re,Y,!0))&&H.set(Y.identifier.id,Y),H.set(Y.identifier.id,Y)}),[...H.values()]}async M(Z,Q){this.y.trace("Started scanning system extensions");const K=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),W=await(Z&&!K.devMode?this.j:this.n).scanExtensions(K);return this.y.trace("Scanned system extensions:",W.length),W}async N(Z,Q){const K=this.z.isBuilt?[]:this.C.builtInExtensions;if(!K?.length)return[];this.y.trace("Started scanning dev system extensions");const q=Q?await this.O():{},W=[],G=d.URI.file(b.$hc(b.$jc($.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of K){const re=q[Y.name]||"marketplace";switch(re){case"disabled":break;case"marketplace":W.push((0,g.$vg)(G,Y.name));break;default:W.push(d.URI.file(re));break}}const H=await Promise.all(W.map(async Y=>this.n.scanExtension(await this.P(Y,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",H.length),(0,S.$Hb)(H)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,Q,K,q,W,G,H){const Y=await this.f(W??y.$w),re=await this.Q(Z),L=Q&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,M=L?await this.Q(L):void 0;return new z(Z,re,L,M,Q,H,K,q,G,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,W,Y)}async Q(Z){try{const Q=await this.w.stat(Z);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$zp=U,e.$zp=U=Ee([te(4,C.$Kk),te(5,A.$up),te(6,a.$$j),te(7,t.$0i),te(8,l.$Wh),te(9,n.$pj),te(10,k.$Ik),te(11,o.$Oh)],U);class z{constructor(Z,Q,K,q,W,G,H,Y,re,L,M,F,T,N,B){this.location=Z,this.mtime=Q,this.applicationExtensionslocation=K,this.applicationExtensionslocationMtime=q,this.profile=W,this.profileScanOptions=G,this.type=H,this.excludeObsolete=Y,this.validate=re,this.productVersion=L,this.productDate=M,this.productCommit=F,this.devMode=T,this.language=N,this.translations=B}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,Q){return(0,g.$og)(Z.location,Q.location)&&Z.mtime===Q.mtime&&(0,g.$og)(Z.applicationExtensionslocation,Q.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&Z.profile===Q.profile&&s.$$m(Z.profileScanOptions,Q.profileScanOptions)&&Z.type===Q.type&&Z.excludeObsolete===Q.excludeObsolete&&Z.validate===Q.validate&&Z.productVersion===Q.productVersion&&Z.productDate===Q.productDate&&Z.productCommit===Q.productCommit&&Z.devMode===Q.devMode&&Z.language===Q.language&&j.equals(Z.translations,Q.translations)}}e.$Ap=z;let x=class extends c.$Sc{constructor(Z,Q,K,q,W){super(),this.f=Z,this.g=Q,this.h=K,this.j=q,this.m=W}async scanExtensions(Z){const Q=Z.profile?await this.r(Z):await this.n(Z);let K={};if(Z.excludeObsolete&&Z.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();K=JSON.parse(q)}catch{}return(0,w.$Lf)(K)?Q:Q.filter(q=>!K[E.$Ao.create(q).toString()])}async n(Z){const Q=await this.j.resolve(Z.location);if(!Q.children?.length)return[];const K=await Promise.all(Q.children.map(async q=>{if(!q.isDirectory||Z.type===1&&(0,g.$sg)(q.resource).indexOf(".")===0)return null;const W=new z(q.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(W)}));return(0,S.$Hb)(K).sort((q,W)=>q.location.path<W.location.path?-1:1)}async r(Z){let Q=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){Q=Q.filter(q=>!q.metadata?.isApplicationScoped);const K=await this.s(Z.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,Z);Q.push(...K)}return Q}async s(Z,Q,K){const q=await this.g.scanProfileExtensions(Z,K.profileScanOptions);if(!q.length)return[];const W=await Promise.all(q.map(async G=>{if(Q(G)){const H=new z(G.location,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(H,G.metadata)}return null}));return(0,S.$Hb)(W)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,g.$vg)(Z.location,"package.json"))){const Q=await this.scanExtension(Z);return Q?[Q]:[]}else return await this.scanExtensions(Z)}catch(Q){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,D.$0)(Q)),[]}}async scanExtension(Z,Q){try{let K=await this.scanExtensionManifest(Z.location);if(K){K.publisher||(K.publisher=u.$2l),Q=Q??K.__metadata,delete K.__metadata;const q=(0,E.$Eo)(K.publisher,K.name),W=Q?.id?{id:q,uuid:Q.id}:{id:q},G=Q?.isSystem?0:Z.type,H=G===0||!!Q?.isBuiltin;K=await this.t(Z.location,K,z.createNlsConfiguration(Z));const Y={type:G,identifier:W,manifest:K,location:Z.location,isBuiltin:H,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return Z.validate?this.validate(Y,Z):Y}}catch(K){Z.type!==0&&this.m.error(K)}return null}validate(Z,Q){let K=!0;const q=(0,i.$Po)(Q.productVersion,Q.productDate,Q.location,Z.manifest,Z.isBuiltin);for(const[W,G]of q)W===m.default.Error&&(K=!1,this.m.error(this.z(Q.location,G)));return Z.isValid=K,Z.validations=q,Z}async scanExtensionManifest(Z){const Q=(0,g.$vg)(Z,"package.json");let K;try{K=(await this.j.readFile(Q)).value.toString()}catch(W){return(0,a.$pk)(W)!==1&&this.m.error(this.z(Z,(0,h.localize)(0,null,Q.path,W.message))),null}let q;try{q=JSON.parse(K)}catch{const G=[];(0,P.$Wm)(K,G);for(const H of G)this.m.error(this.z(Z,(0,h.localize)(1,null,Q.path,H.offset,H.length,(0,f.$wp)(H.error))));return null}return(0,P.$6m)(q)!=="object"?(this.m.error(this.z(Z,(0,h.localize)(2,null,Q.path))),null):q}async t(Z,Q,K){const q=await this.u(Z,Q,K);if(q)try{const W=[],G=await this.w(q.default,W);if(W.length>0)return W.forEach(Y=>{this.m.error(this.z(Z,(0,h.localize)(3,null,q.default?.path,(0,f.$wp)(Y.error))))}),Q;if((0,P.$6m)(q)!=="object")return this.m.error(this.z(Z,(0,h.localize)(4,null,q.default?.path))),Q;const H=q.values||Object.create(null);return(0,I.$xp)(this.m,Q,H,G)}catch{}return Q}async u(Z,Q,K){const q=(0,g.$vg)(Z,"package.nls.json"),W=(re,L)=>{L.forEach(M=>{this.m.error(this.z(Z,(0,h.localize)(5,null,re?.path,(0,f.$wp)(M.error))))})},G=re=>{this.m.error(this.z(Z,(0,h.localize)(6,null,re?.path)))},H=`${Q.publisher}.${Q.name}`,Y=K.translations[H];if(Y)try{const re=d.URI.file(Y),L=(await this.j.readFile(re)).value.toString(),M=[],F=(0,P.$Wm)(L,M);return M.length>0?(W(re,M),{values:void 0,default:q}):(0,P.$6m)(F)!=="object"?(G(re),{values:void 0,default:q}):{values:F.contents?F.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let L;try{L=await this.y(Z,K)}catch{return}if(!L.localized)return{values:void 0,default:L.original};try{const M=(await this.j.readFile(L.localized)).value.toString(),F=[],T=(0,P.$Wm)(M,F);return F.length>0?(W(L.localized,F),{values:void 0,default:L.original}):(0,P.$6m)(T)!=="object"?(G(L.localized),{values:void 0,default:L.original}):{values:T,default:L.original}}catch{return{values:void 0,default:L.original}}}}async w(Z,Q){if(Z)try{const K=(await this.j.readFile(Z)).value.toString();return(0,P.$Wm)(K,Q)}catch{}}y(Z,Q){return new Promise((K,q)=>{const W=G=>{const H=(0,g.$vg)(Z,`package.nls.${G}.json`);this.j.exists(H).then(Y=>{Y&&K({localized:H,original:(0,g.$vg)(Z,"package.nls.json")});const re=G.lastIndexOf("-");re===-1?K({localized:(0,g.$vg)(Z,"package.nls.json"),original:null}):(G=G.substring(0,re),W(G))})};if(Q.devMode||Q.pseudo||!Q.language)return K({localized:(0,g.$vg)(Z,"package.nls.json"),original:null});W(Q.language)})}z(Z,Q){return`[${Z.path}]: ${Q}`}};x=Ee([te(1,A.$up),te(2,k.$Ik),te(3,a.$$j),te(4,t.$0i)],x);let X=class extends x{constructor(Z,Q,K,q,W,G,H){super(Q,q,W,G,H),this.G=Z,this.H=K,this.D=this.B(new R.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const Q=this.M(Z),K=await this.I(Q);if(this.C=Z,K&&K.input&&z.equals(K.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),K.result.map(W=>(W.location=d.URI.revive(W.location),W));const q=await super.scanExtensions(Z);return await this.J(Q,{input:Z,result:q}),q}async I(Z){try{const Q=await this.j.readFile(Z),K=JSON.parse(Q.value.toString());return{result:K.result,input:(0,p.$mh)(K.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",Z.path,(0,D.$0)(Q))}return null}async J(Z,Q){try{await this.j.writeFile(Z,O.$be.fromString(JSON.stringify(Q)))}catch(K){this.m.debug("Error while writing the extension cache file:",Z.path,(0,D.$0)(K))}}async L(){if(!this.C)return;const Z=this.M(this.C),Q=await this.I(Z);if(!Q)return;const K=Q.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$$m(q,K))try{this.m.info("Invalidating Cache",K,q),await this.j.del(Z),this.F.fire()}catch(W){this.m.error(W)}}M(Z){const Q=this.N(Z);return this.h.extUri.joinPath(Q.cacheHome,Z.type===0?u.$1l:u.$Zl)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(Z.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};X=Ee([te(2,C.$Kk),te(3,A.$up),te(4,k.$Ik),te(5,a.$$j),te(6,t.$0i)],X);function ae(ce,Z){const Q=(0,E.$Co)(ce.manifest.publisher,ce.manifest.name);return{id:Q,identifier:new u.$6l(Q),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:Z,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.$Bp=ae;class se extends U{constructor(Z,Q,K,q,W,G,H,Y,re,L,M,F){super(Z,Q,(0,g.$vg)(K,".vscode-oss-dev","extensions","control.json"),q,W,G,H,Y,re,L,M,F),this.R=(async()=>{if(y.$z)try{const T=await this.w.readFile(d.URI.file(y.$z));return JSON.parse(T.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$Cp=se}),define(ie[276],ne([0,1,6,41,40,26,80,16,36,7]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;let $=class extends D.$vp{constructor(y,g,v,m,w,d){super(c.URI.file(y.extensionsPath),g,v,m,w,d)}};e.$IN=$,e.$IN=$=Ee([te(0,f.$Xh),te(1,P.$$j),te(2,R.$Kk),te(3,s.$Ik),te(4,O.$cl),te(5,S.$0i)],$)}),define(ie[277],ne([0,1,7,36,80,129,16,5,6,25,40,41]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0;let y=class extends O.$Cp{constructor(v,m,w,d,h,l,E,u){super(S.URI.file(h.builtinExtensionsPath),S.URI.file(h.extensionsPath),h.userHome,v.defaultProfile,v,m,w,d,h,l,E,u)}};e.$77b=y,e.$77b=y=Ee([te(0,b.$Kk),te(1,s.$up),te(2,D.$$j),te(3,f.$0i),te(4,R.$Xh),te(5,c.$pj),te(6,$.$Ik),te(7,P.$Oh)],y)}),define(ie[278],ne([0,1,15,2,13,9,4,56,7,32,38,36,6,41]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=void 0;let v=class extends R.$Sc{constructor(w,d,h){super(),this.c=w,this.f=h,this.a=P.$Vh.forPaths(!D.$l),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(d.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=S.session;w.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(d,h)=>this.j(d,h)),w.protocol.interceptFileProtocol(s.Schemas.file,(d,h)=>this.h(d,h)),this.B((0,R.$Qc)(()=>{w.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(w){const d=(0,O.$hc)(w);return this.a.get(d)?R.$Sc.None:(this.a.set(d,!0),(0,R.$Qc)(()=>this.a.delete(d)))}h(w,d){const h=f.URI.parse(w.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${w.url})`),d({error:-3})}j(w,d){const h=this.m(w);let l;return this.c.crossOriginIsolated&&((0,O.$nc)(h)==="workbench.html"||(0,O.$nc)(h)==="workbench-dev.html"?l=s.COI.CoopAndCoep:l=s.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(h)?d({path:h,headers:l}):this.b.has((0,O.$oc)(h).toLowerCase())?d({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),d({error:-3}))}m(w){const d=f.URI.parse(w.url),h=s.$cg.uriToFileUri(d);return(0,O.$hc)(h.fsPath)}createIPCObjectUrl(){let w;const d=f.URI.from({scheme:"vscode",path:(0,c.$eg)()}),h=d.toString(),l=async()=>w;return $.$qT.handle(h,l),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:d,update:E=>w=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),$.$qT.removeHandler(h)}}}};e.$m8b=v,e.$m8b=v=Ee([te(0,b.$Xh),te(1,g.$Kk),te(2,y.$0i)],v)}),define(ie[96],ne([0,1,8,3,2,65,12,111,5,41]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$6o=e.$5o=e.$4o=void 0,e.$4o="__$__isNewStorageMarker",e.$5o="__$__targetStorageMarker",e.$6o=(0,f.$Ph)("storageService");var $;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})($||(e.WillSaveStateReason=$={}));var b;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function g(h){const l=h.get(e.$5o);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$7o=g;class v extends s.$Sc{static{this.a=60*1e3}constructor(l={flushInterval:v.a}){super(),this.m=l,this.b=this.B(new R.$Qd),this.c=this.B(new R.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,E,u){return R.Event.filter(this.b.event,i=>i.scope===l&&(E===void 0||i.key===E),u)}n(){this.j.value=(0,S.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,E){const{key:u,external:i}=E;if(u===e.$5o){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:u,target:this.J(l)[u],external:i})}w(l){this.f.fire({reason:l})}get(l,E,u){return this.P(E)?.get(l,u)}getBoolean(l,E,u){return this.P(E)?.getBoolean(l,u)}getNumber(l,E,u){return this.P(E)?.getNumber(l,u)}getObject(l,E,u){return this.P(E)?.getObject(l,u)}storeAll(l,E){this.y(()=>{for(const u of l)this.store(u.key,u.value,u.scope,u.target,E)})}store(l,E,u,i,a=!1){if((0,D.$Hf)(E)){this.remove(l,u,a);return}this.y(()=>{this.z(l,u,i),this.P(u)?.set(l,E,a)})}remove(l,E,u=!1){this.y(()=>{this.z(l,E,void 0),this.P(E)?.delete(l,u)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,E){const u=[],i=this.J(l);for(const a of Object.keys(i))i[a]===E&&u.push(a);return u}z(l,E,u,i=!1){const a=this.J(E);typeof u=="number"?a[l]!==u&&(a[l]=u,this.P(E)?.set(e.$5o,JSON.stringify(a),i)):typeof a[l]=="number"&&(delete a[l],this.P(E)?.set(e.$5o,JSON.stringify(a),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const E=this.P(l);return E?g(E):Object.create(null)}isNew(l){return this.getBoolean(e.$4o,l)===!0}async flush(l=$.NONE){this.f.fire({reason:l});const E=this.P(-1),u=this.P(0),i=this.P(1);switch(l){case $.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case $.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return d(l,E,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,E){return this.w($.NONE),(0,c.$Jk)(l)?this.R(l,E):this.S(l,E)}M(l,E){return!(l.id===E.id||m(E)&&m(l))}N(l,E,u){this.y(()=>{const i=new Set;for(const[a,o]of l)i.add(a),E.get(a)!==o&&this.u(u,{key:a,external:!0});for(const[a]of E.items)i.has(a)||this.u(u,{key:a,external:!0})})}}e.$8o=v;function m(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$9o=m;class w extends v{constructor(){super(),this.U=this.B(new P.$2o(new P.$3o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$2o(new P.$3o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$2o(new P.$3o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$0o=w;async function d(h,l,E,u,i,a){const o=j=>{try{return JSON.parse(j)}catch{return j}},t=new Map,n=new Map;h.forEach((j,U)=>{t.set(U,j),n.set(U,o(j))});const r=new Map,p=new Map;l.forEach((j,U)=>{r.set(U,j),p.set(U,o(j))});const A=new Map,C=new Map;E.forEach((j,U)=>{A.set(U,j),C.set(U,o(j))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const k=[];if(t.forEach((j,U)=>{k.push({key:U,value:j})}),console.table(k),console.groupEnd(),console.log(n),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const j=[];r.forEach((U,z)=>{j.push({key:z,value:U})}),console.table(j),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${a})`);const I=[];A.forEach((j,U)=>{I.push({key:U,value:j})}),console.table(I),console.groupEnd(),console.log(C)}e.$$o=d}),define(ie[279],ne([0,1,23,8,3,2,9,72,7,21,111,161,6,96,26,30,13]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=e.$t6b=e.$s6b=e.$r6b=void 0;class d extends O.$Sc{static{this.a=2e3}get storage(){return this.f}constructor(o,t){super(),this.m=o,this.n=t,this.b=this.B(new s.$Nd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Nd),this.onDidCloseStorage=this.c.event,this.f=this.B(new $.$2o(new $.$3o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$ch,this.whenInit=this.h.p,this.j=$.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===$.StorageState.None)try{const o=this.B(await this.t());this.f.dispose(),this.f=o,this.B(o.onDidChangeStorage(n=>this.b.fire(n))),await this.s(o);const t=o.getBoolean(g.$4o);t===void 0?o.set(g.$4o,!0):t&&o.set(g.$4o,!1)}catch(o){this.m.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.j=$.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?o=>this.m.trace(o):void 0,logError:o=>this.m.error(o)}}s(o){return o.init()}get items(){return this.f.items}get(o,t){return this.f.get(o,t)}set(o,t){return this.f.set(o,t)}delete(o){return this.f.delete(o)}optimize(){return this.f.optimize()}async close(){const o=new P.$Jd(!1);await this.w(),o.stop(),o.elapsed()>d.a&&await this.u(o),this.c.fire()}async u(o){if(this.path)try{const t=(0,S.top)(Array.from(this.f.items.entries()).map(([r,p])=>({key:r,length:p.length})),(r,p)=>p.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=$.StorageState.Closed,await this.f.close()}}class h extends d{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,h.y)}constructor(o,t,n,r){super(n,r),this.z=o,this.C=t}async t(){return new $.$2o(new b.$VT(this.path??b.$VT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:$.StorageHint.STORAGE_IN_MEMORY})}}class l extends h{constructor(o,t,n,r){super(o,t,n,r)}}e.$r6b=l;class E extends h{constructor(o,t,n,r){super(t.defaultProfile,o,n,r)}async s(o){await super.s(o),this.G(o)}G(o){o.get(v.$fl,void 0)===void 0&&o.set(v.$fl,new Date().toUTCString());const n=o.get(v.$el,void 0),r=new Date().toUTCString();o.set(v.$gl,typeof n>"u"?null:n),o.set(v.$el,r)}}e.$s6b=E;class u extends d{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,u.y)}constructor(o,t,n,r,p){super(n,p),this.C=o,this.D=t,this.F=r}async t(){const{storageFilePath:o,wasCreated:t}=await this.H();return new $.$2o(new b.$VT(o,{logging:this.r()}),{hint:this.D.useInMemoryStorage?$.StorageHint.STORAGE_IN_MEMORY:t?$.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$VT.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),t=(0,D.$jc)(o,u.y);return await c.Promises.exists(o)?{storageFilePath:t,wasCreated:!1}:(await c.Promises.mkdir(o,{recursive:!0}),this.I(o),{storageFilePath:t,wasCreated:!0})}async I(o){let t;if((0,m.$Zh)(this.C)?t={folder:this.C.uri.toString()}:(0,m.$5h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,D.$jc)(o,u.z);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$t6b=u;class i extends d{get path(){}async t(){return new $.$2o(new $.$3o,{hint:$.StorageHint.STORAGE_IN_MEMORY})}}e.$u6b=i}),define(ie[280],ne([0,1,3,2,96]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=void 0;class O extends R.$Sc{constructor(P,f,c){super(),this.b=P,this.c=f,this.f=c;const $=this.B(new R.$Tc);this.a=this.B(new S.$Nd({onWillAddFirstListener:()=>$.value=this.g(),onDidRemoveLastListener:()=>$.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new R.$Rc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,c)=>(f?f.push(c.key):f=[c.key],f),100)(f=>this.h(f))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(f,c)=>{f||(f=new Map);let $=f.get(c.profile.id);return $||f.set(c.profile.id,$={profile:c.profile,keys:[],storage:c.storage}),$.keys.push(c.key),f},100)(f=>this.j(f))),P}h(P){const f=P.includes(s.$5o)?[this.c.defaultProfile]:[],c=[];if(P=P.filter($=>$!==s.$5o),P.length){const $=(0,s.$7o)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:P.map(b=>({key:b,scope:0,target:$[b]}))})}this.m(f,c)}j(P){const f=[],c=new Map;for(const[$,b]of P.entries()){b.keys.includes(s.$5o)&&f.push(b.profile);const y=b.keys.filter(g=>g!==s.$5o);if(y.length){const g=(0,s.$7o)(b.storage.storage);c.set($,{profile:b.profile,changes:y.map(v=>({key:v,scope:0,target:g[v]}))})}}this.m(f,[...c.values()])}m(P,f){(P.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:P})}listen(P,f,c){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(P,f){throw new Error(`Call not found: ${f}`)}}e.$97b=O}),define(ie[281],ne([0,1,7,36,16,6,34,40,41,12,121]),function(J,e,S,R,s,O,D,P,f,c,$){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=e.$FN=void 0;let g=class extends f.$Nk{static{b=this}static{this.a="profileAssociationsMigration"}constructor(d,h,l,E,u){super(l,E,h,u),this.U=d,this.W=l}O(){return this.U.getItem(b.b,[]).map(h=>({...h,location:(0,c.$yf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):S.URI.revive(h.location)}))}Q(){const d=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$FN=g,e.$FN=g=b=Ee([te(0,D.$AN),te(1,P.$Ik),te(2,R.$Xh),te(3,s.$$j),te(4,O.$0i)],g);let v=y=class extends g{constructor(d,h,l,E,u){super(d,h,l,E,u),this.$=d}P(d){d.length?this.$.setItem(y.b,d.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(y.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(y.c,d):this.$.removeItem(y.c)}Q(){const d="workspaceAndProfileInfo",h=this.$.getItem(d,void 0);if(h){this.$.removeItem(d);const E=h.reduce((u,{workspace:i,profile:a})=>(u[S.URI.revive(i).toString()]=S.URI.revive(a).toString(),u),{});this.$.setItem(y.c,{workspaces:E})}const l=super.Q();return this.$.getItem(y.a,!1)||(this.R(l),this.$.setItem(y.a,!0)),l}};e.$GN=v,e.$GN=v=y=Ee([te(0,D.$BN),te(1,P.$Ik),te(2,R.$Xh),te(3,s.$$j),te(4,O.$0i)],v);let m=class extends v{constructor(d,h,l,E){super(new $.$EN(0,h,E,l),d,h,l,E)}async init(){return await this.$.init(),super.init()}};e.$HN=m,e.$HN=m=Ee([te(0,P.$Ik),te(1,R.$Xh),te(2,s.$$j),te(3,O.$0i)],m)}),define(ie[52],ne([0,1,36,16,5,6,40,41,281,34]),function(J,e,S,R,s,O,D,P,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=void 0,e.$v6b=(0,s.$Qh)(P.$Kk);let $=class extends f.$GN{constructor(y,g,v,m,w){super(y,g,v,m,w)}getAssociatedEmptyWindows(){const y=[];for(const g of this.C.emptyWindows.keys())y.push({id:g});return y}};e.$w6b=$,e.$w6b=$=Ee([te(0,c.$BN),te(1,D.$Ik),te(2,S.$Xh),te(3,R.$$j),te(4,O.$0i)],$)}),define(ie[130],ne([0,1,19,7,30]),function(J,e,S,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=e.$L6b=e.$K6b=void 0;async function O(f,c,$){for(const y of f){const g=y.openedWorkspace;if((0,s.$5h)(g)){const v=await $(g);if(v){if(v.folders.some(m=>S.$mg.isEqualOrParent(c,m.uri)))return y}else if(S.$mg.isEqualOrParent(c,g.configPath))return y}}const b=f.filter(y=>(0,s.$Zh)(y.openedWorkspace)&&S.$mg.isEqualOrParent(c,y.openedWorkspace.uri));if(b.length)return b.sort((y,g)=>-(y.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}e.$K6b=O;function D(f,c){for(const $ of f)if((0,s.$5h)($.openedWorkspace)&&S.$mg.isEqual($.openedWorkspace.configPath,c)||(0,s.$Zh)($.openedWorkspace)&&S.$mg.isEqual($.openedWorkspace.uri,c))return $}e.$L6b=D;function P(f,c){const $=b=>c.some(y=>S.$mg.isEqual(R.URI.file(y),R.URI.file(b)));for(const b of f)if(b.config?.extensionDevelopmentPath?.some(y=>$(y)))return b}e.$M6b=P}),define(ie[97],ne([0,1,33,44,139,46,13,9,4,19,7,5,58,30]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WU=e.$VU=e.$UU=e.$TU=e.$SU=e.$RU=e.$QU=e.$PU=e.$OU=e.$NU=void 0,e.$NU=(0,b.$Ph)("workspacesService");function v(C){return C.hasOwnProperty("workspace")}e.$OU=v;function m(C){return C.hasOwnProperty("folderUri")}e.$PU=m;function w(C){return C.hasOwnProperty("fileUri")}e.$QU=w;function d(C){return h(C)||l(C)}e.$RU=d;function h(C){const k=C;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function l(C){const k=C;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(C,k,I,j,U){if(C.scheme!==j.scheme)return{name:I,uri:C.toString(!0)};let z=k?void 0:U.relativePath(j,C);if(z!==void 0)z.length===0?z=".":f.$j&&(z=u(z));else if(C.scheme===D.Schemas.file)z=C.fsPath,f.$j&&(z=u(z));else if(U.isEqualAuthority(C.authority,j.authority))z=C.path;else return{name:I,uri:C.toString(!0)};return{name:I,path:z}}e.$SU=E;function u(C){return C=(0,O.$sv)(C),(0,S.$Uf)(C)||(C=(0,S.$Rf)(C)),C}function i(C,k,I){const j=[],U=new Set,z=I.dirname(k);for(const x of C){let X;if(h(x))x.path&&(X=I.resolvePath(z,x.path));else if(l(x))try{X=$.URI.parse(x.uri),X.path[0]!==P.$gc.sep&&(X=X.with({path:P.$gc.sep+X.path}))}catch(ae){console.warn(ae)}if(X){const ae=I.getComparisonKey(X);if(!U.has(ae)){U.add(ae);const se=x.name||I.basenameOrAuthority(X);j.push(new g.$0h({uri:X,name:se,index:j.length},x))}}}return j}e.$TU=i;function a(C,k,I,j,U){const z=o(k,C),x=U.dirname(k),X=U.dirname(j),ae=[];for(const Q of z.folders){const K=h(Q)?U.resolvePath(x,Q.path):$.URI.parse(Q.uri);let q;I?q=!1:q=!h(Q)||(0,P.$ic)(Q.path),ae.push(E(K,q,Q.name,X,U))}const se={insertSpaces:!1,tabSize:4,eol:f.$l||f.$k?`
`:`\r
`},ce=s.$$S(C,["folders"],ae,se);let Z=s.$bT(C,ce);return(0,c.$Ag)(z.remoteAuthority,(0,y.$Uk)(j))&&(Z=s.$bT(Z,s.$0S(Z,["remoteAuthority"],se))),Z}e.$UU=a;function o(C,k){const I=R.$Wm(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(j=>d(j));else throw new Error(`${C} looks like an invalid workspace file.`);return I}function t(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function n(C){return typeof C.folderUri=="string"}function r(C){return typeof C.fileUri=="string"}function p(C,k){const I={workspaces:[],files:[]};if(C){const j=function(z,x){for(let X=0;X<z.length;X++)try{x(z[X],X)}catch(ae){k.warn(`Error restoring recent entry ${JSON.stringify(z[X])}: ${ae.toString()}. Skip entry.`)}},U=C;Array.isArray(U.entries)&&j(U.entries,z=>{const x=z.label,X=z.remoteAuthority;t(z)?I.workspaces.push({label:x,remoteAuthority:X,workspace:{id:z.workspace.id,configPath:$.URI.parse(z.workspace.configPath)}}):n(z)?I.workspaces.push({label:x,remoteAuthority:X,folderUri:$.URI.parse(z.folderUri)}):r(z)&&I.files.push({label:x,remoteAuthority:X,fileUri:$.URI.parse(z.fileUri)})})}return I}e.$VU=p;function A(C){const k={entries:[]};for(const I of C.workspaces)m(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of C.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$WU=A}),define(ie[98],ne([0,1,85,13,4,19]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.$P6b=e.$O6b=e.$N6b=void 0,e.$N6b=128/4;function D(c){function $(){let b=c.scheme===R.Schemas.file?(0,O.$jg)(c):c.toString();return s.$l||(b=b.toLowerCase()),(0,S.createHash)("md5").update(b).digest("hex")}return{id:$(),configPath:c}}e.$O6b=D;function P(c,$){function b(){if(c.scheme!==R.Schemas.file)return(0,S.createHash)("md5").update(c.toString()).digest("hex");if(!$)return;let g;return s.$l?g=$.ino:s.$k?g=$.birthtime.getTime():s.$j&&(typeof $.birthtimeMs=="number"?g=Math.floor($.birthtimeMs):g=$.birthtime.getTime()),(0,S.createHash)("md5").update(c.fsPath).update(g?String(g):"").digest("hex")}const y=b();if(typeof y=="string")return{id:y,uri:c}}e.$P6b=P;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$Q6b=f}),define(ie[99],ne([0,1,85,86,28,282,17,14,3,2,9,4,32,42,109]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class m{traceSocketEvent(k,I){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,P.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=j=>{this.traceSocketEvent("read",j),k(D.$be.wrap(j))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=j=>{k({type:0,hadError:j,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,P.$1)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Eh=m;var w;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var d;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(d||(d={}));class h extends c.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,j,U){super(),this.f=this.B(new f.$Nd),this.g=this.B(new f.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:j?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new l(this,I,j,U,this.f,(z,x)=>this.m(z,x))),this.B(this.a.onError(z=>{console.error(z),(0,P.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$zh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(k,{compressed:I,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let U=2;k.byteLength<126?U+=0:k.byteLength<2**16?U+=2:U+=8;const z=D.$be.alloc(U),x=I?64:0,X=j&15;if(z.writeUInt8(128|x|X,0),k.byteLength<126)z.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){z.writeUInt8(126,1);let ae=1;z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}else{z.writeUInt8(127,1);let ae=1;z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(0,++ae),z.writeUInt8(k.byteLength>>>24&255,++ae),z.writeUInt8(k.byteLength>>>16&255,++ae),z.writeUInt8(k.byteLength>>>8&255,++ae),z.writeUInt8(k.byteLength>>>0&255,++ae)}this.socket.write(D.$be.concat([z,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),j=I.readUInt8(0),U=(j&128)>>>7,z=(j&64)>>>6,x=j&15,X=I.readUInt8(1),ae=(X&128)>>>7,se=X&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),j=I.readUInt8(1),U=(j&128)>>>7;let z=j&127,x=1;z===126?z=I.readUInt8(++x)*2**8+I.readUInt8(++x):z===127&&(z=I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x));let X=0;U&&(X=I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x)),this.j.state=3,this.j.readLen=z,this.j.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=h;class l extends c.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$be.alloc(0)}constructor(k,I,j,U,z,x){super(),this.n=k,this.r=z,this.s=x,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,U,j,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(k,I){this.g.push({data:k,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:I}=this.g.shift();if(this.f&&I.compressed){const j=await this.w(this.f,k);this.s(j,I)}else this.s(k,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((j,U)=>{k.write(I),k.flush(z=>j(z))})}acceptFrame(k,I,j){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,j){return new Promise((U,z)=>{k.write(I),j&&k.write(D.$be.fromByteArray([0,0,255,255])),k.flush(x=>U(x))})}}class E extends c.$Sc{get recordedInflateBytes(){return this.j?D.$be.concat(this.f):D.$be.alloc(0)}constructor(k,I,j,U){super(),this.h=k,this.j=I,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(U),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(D.$be.wrap(z))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=D.$be.concat(this.g);this.g.length=0,k(I)})}}class u extends c.$Sc{constructor(k,I){super(),this.g=k,this.a=this.B(new f.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$be.wrap(j))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=D.$be.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function i(C,k){if(k===0)return;const I=C.byteLength>>>2;for(let ae=0;ae<I;ae++){const se=C.readUInt32BE(ae*4);C.writeUInt32BE(se^k,ae*4)}const j=I*4,U=C.byteLength-j,z=k>>>24&255,x=k>>>16&255,X=k>>>8&255;U>=1&&C.writeUInt8(C.readUInt8(j)^z,j),U>=2&&C.writeUInt8(C.readUInt8(j+1)^x,j+1),U>=3&&C.writeUInt8(C.readUInt8(j+2)^X,j+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function o(){const C=(0,y.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const k=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,s.tmpdir)(),I=(0,$.$jc)(k,`vscode-ipc-${C}.sock`);return n(I),I}e.$Hh=o;function t(C,k,I){const j=(0,S.createHash)("md5").update(C).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${I}-${k}-sock`;const U=I.substr(0,4),z=k.substr(0,6),x=j.substr(0,8);let X;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?X=(0,$.$jc)(e.$Gh,`vscode-${x}-${U}-${z}.sock`):X=(0,$.$jc)(C,`${U}-${z}.sock`),n(X),X}e.$Ih=t;function n(C){const k=a[b.$u];typeof k=="number"&&C.length>=k&&console.warn(`WARNING: IPC handle "${C}" is longer than ${k} chars, try a shorter --user-data-dir`)}class r extends g.$th{static b(k){const I=f.Event.fromNodeEventEmitter(k,"connection");return f.Event.map(I,j=>({protocol:new v.$Ah(new m(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(k){super(r.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=r;function p(C){return new Promise((k,I)=>{const j=(0,R.createServer)();j.on("error",I),j.listen(C,()=>{j.removeListener("error",I),k(new r(j))})})}e.$Kh=p;function A(C,k){return new Promise((I,j)=>{const U=(0,R.createConnection)(C,()=>{U.removeListener("error",j),I(v.$Bh.fromSocket(new m(U,`ipc-client${k}`),k))});U.once("error",j)})}e.$Lh=A}),define(ie[24],ne([0,1,54,9,4,99,36,89,5]),function(J,e,S,R,s,O,D,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o6b=e.$n6b=void 0,e.$n6b=(0,f.$Qh)(D.$Wh);class c extends P.$jm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,O.$Ih)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$l){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const y=b.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[b]?process.env[y]=process.env[b]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$l)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$o6b=c,Ee([S.$hh],c.prototype,"cachedLanguagesPath",null),Ee([S.$hh],c.prototype,"backupHome",null),Ee([S.$hh],c.prototype,"mainIPCHandle",null),Ee([S.$hh],c.prototype,"mainLockfile",null),Ee([S.$hh],c.prototype,"disableUpdates",null),Ee([S.$hh],c.prototype,"crossOriginIsolated",null),Ee([S.$hh],c.prototype,"codeCachePath",null),Ee([S.$hh],c.prototype,"useCodeCache",null)}),define(ie[283],ne([0,1,85,33,13,9,4,19,21,196,18,24,34,16,6,195,30,98]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;let l=class{static{h=this}static{this.a="backupWorkspaces"}constructor(u,i,a,o){this.j=u,this.k=i,this.l=a,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$mg,this.i={isEqual:(t,n)=>(0,R.$Wf)(t,n,!D.$l)}}async initialize(){const u=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,c.$E6b)(u)),this.e=await this.v((0,c.$F6b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==g.$xk.OFF}q(){return this.s()===g.$xk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||g.$xk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,i){this.d.some(o=>u.workspace.id===o.workspace.id)||(this.d.push(u),this.C());const a=(0,O.$jc)(this.c,u.workspace.id);return i?this.t(a,i).then(()=>a):a}async t(u,i){if(await f.Promises.exists(u)&&await this.z(u),await f.Promises.exists(i))try{await f.Promises.rename(i,u,!1)}catch(a){this.l.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}registerFolderBackup(u){return this.e.some(i=>this.h.isEqual(u.folderUri,i.folderUri))||(this.e.push(u),this.C()),(0,O.$jc)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,O.$jc)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const i=new Set,a=[];for(const o of u){const t=o.workspace;if(!(0,w.$5h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,O.$jc)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await f.Promises.exists(t.configPath.fsPath)?a.push(o):await this.z(n):await this.x(n)}}return a}async v(u){if(!Array.isArray(u))return[];const i=[],a=new Set;for(const o of u){const t=o.folderUri,n=this.h.getComparisonKey(t);if(!a.has(n)){a.add(n);const r=(0,O.$jc)(this.c,this.D(o));await this.B(r)?t.scheme!==s.Schemas.file||await f.Promises.exists(t.fsPath)?i.push(o):await this.z(r):await this.x(r)}}return i}async w(u){if(!Array.isArray(u))return[];const i=[],a=new Set;for(const o of u){const t=o.backupFolder;if(typeof t!="string")return[];if(!a.has(t)){a.add(t);const n=(0,O.$jc)(this.c,t);await this.B(n)?i.push(o):await this.x(n)}}return i}async x(u){try{await f.Promises.rm(u,f.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let u=(0,d.$Q6b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,u.id));)u=(0,d.$Q6b)();return{backupFolder:u.id}}async z(u){const i=this.y(),a=(0,O.$jc)(this.c,i.backupFolder);try{await f.Promises.rename(u,a,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const u=[];for(const i of this.d)await this.A(i)&&u.push(i);for(const i of this.e)await this.A(i)&&u.push(i);return u}A(u){let i;return(0,c.$D6b)(u)?i=(0,O.$jc)(this.c,u.backupFolder):(0,m.$LU)(u)?i=(0,O.$jc)(this.c,this.D(u)):i=(0,O.$jc)(this.c,u.workspace.id),this.B(i)}async B(u){try{const i=await f.Promises.readdir(u);for(const a of i)try{if((await f.Promises.readdir((0,O.$jc)(u,a))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:i,remoteAuthority:a})=>{const o={id:i.id,configURIPath:i.configPath.toString()};return a&&(o.remoteAuthority=a),o}),folders:this.e.map(({folderUri:i,remoteAuthority:a})=>{const o={folderUri:i.toString()};return a&&(o.remoteAuthority=a),o}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:a})=>{const o={backupFolder:i};return a&&(o.remoteAuthority=a),o})};this.m.setItem(h.a,u)}D(u){const i=u.folderUri;let a;return i.scheme===s.Schemas.file?a=D.$l?i.fsPath:i.fsPath.toLowerCase():a=i.toString().toLowerCase(),(0,S.createHash)("md5").update(a).digest("hex")}};e.$56b=l,e.$56b=l=h=Ee([te(0,b.$n6b),te(1,$.$ji),te(2,v.$0i),te(3,y.$BN)],l)}),define(ie[20],ne([0,1,15,38,8,3,2,4,35,12,5,6,34,24]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.LifecycleMainPhase=e.ShutdownReason=e.$p6b=void 0,e.$p6b=(0,$.$Ph)("lifecycleMainService");var m;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var w;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let d=class extends D.$Sc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,E,u){super(),this.F=l,this.G=E,this.H=u,this.c=this.B(new O.$Nd),this.onBeforeShutdown=this.c.event,this.f=this.B(new O.$Nd),this.onWillShutdown=this.f.event,this.g=this.B(new O.$Nd),this.onWillLoadWindow=this.g.event,this.h=this.B(new O.$Nd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$k&&this.t===0&&this.L(1))};S.app.addListener("before-quit",l);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$k)&&S.app.quit()};S.app.addListener("window-all-closed",E),S.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",l),S.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(l){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:l,join(i,a){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),u.push(a.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let E=this.C.get(l);E||(E=new s.$Sg,this.C.set(l,E)),await E.wait()}registerWindow(l){const E=new D.$Rc;this.t++,E.add(l.onWillLoad(i=>this.g.fire({window:l,workspace:i.workspace,reason:i.reason})));const u=(0,c.$Jf)(l.win);u.on("close",i=>{const a=l.id;if(this.r.has(a)){this.r.delete(a);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),i.preventDefault(),this.unload(l,1).then(o=>{if(o){this.r.delete(a);return}this.r.add(a),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this.h.fire(l),l.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,E.dispose(),this.t===0&&(!P.$k||this.j)&&this.L(1)})}async reload(l,E){await this.unload(l,3)||l.reload(E)}unload(l,E){const u=this.z.get(l.id);if(u)return u;const i=this.M(l,E).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,i),i}async M(l,E){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const u=this.j?2:E,i=await this.P(l,u);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(i)):(await this.Q(l,u),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,E){return new Promise(u=>{const i=this.s++,a=`vscode:ok${i}`,o=`vscode:cancel${i}`;R.$qT.once(a,()=>{u(!1)}),R.$qT.once(o,()=>{u(!0)}),l.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:o,reason:E})})}Q(l,E){return new Promise(u=>{const a=`vscode:reply${this.s++}`;R.$qT.once(a,()=>u()),l.send("vscode:onWillUnload",{replyChannel:a,reason:E})})}quit(l){return this.R(l).then(E=>{if(!E&&l)try{if(P.$j){const u=(0,f.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return E})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(v.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(l?.addArgs&&E.push(...l.addArgs),l?.removeArgs)for(const a of l.removeArgs){const o=E.indexOf(a);o>=0&&E.splice(o,1)}const u=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:E}))};S.app.once("quit",u),await this.quit(!0)&&S.app.removeListener("quit",u)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Ug)(1e3),(async()=>{for(const E of S.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let u;E.webContents&&!E.webContents.isDestroyed()?u=new Promise(i=>E.once("closed",i)):u=Promise.resolve(),E.destroy(),await u}})()]),S.app.exit(l)}};e.$q6b=d,e.$q6b=d=v=Ee([te(0,b.$0i),te(1,y.$BN),te(2,g.$n6b)],d)}),define(ie[284],ne([0,1,4,3,2,5,20]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=e.$o7b=void 0,e.$o7b=(0,O.$Ph)("keyboardLayoutMainService");let P=class extends s.$Sc{constructor($){super(),this.a=this.B(new R.$Nd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,$.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const $=await new Promise((b,y)=>{J(["native-keymap"],b,y)});this.c=f($),S.$t||$.onDidChangeKeyboardLayout(()=>{this.c=f($),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$p7b=P,e.$p7b=P=Ee([te(0,D.$p6b)],P);function f(c){const $=c.getKeyMap(),b=c.getCurrentKeyboardLayout();return{keyboardMapping:$,keyboardLayoutInfo:b}}}),define(ie[285],ne([0,1,246,8,17,14,12,18,36,94,6,50,245,282]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;let v=class extends b.$To{constructor(h,l,E,u){super(u),this.m=h,this.n=l,this.r=E,this.s(),this.B(h.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,l){const{f:E,g:u}=this;let i;try{i=await(0,c.$Tl)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,O.$0)(t)))}const a={...process.env,...i},o=h.agent?h.agent:await(0,y.$Xq)(h.url||"",a,{proxyUrl:E,strictSSL:u});return h.agent=o,h.strictSSL=u,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>w(h,l))}async resolveProxy(h){}};e.$Yq=v,e.$Yq=v=Ee([te(0,P.$ji),te(1,f.$Xh),te(2,$.$0i),te(3,$.$$i)],v);async function m(d){return((0,S.parse)(d.url).protocol==="https:"?await new Promise((E,u)=>{J(["https"],E,u)}):await new Promise((E,u)=>{J(["http"],E,u)})).request}async function w(d,h){return R.Promises.withAsyncBody(async(l,E)=>{const u=(0,S.parse)(d.url),i=d.getRawRequest?d.getRawRequest(d):await m(d),a={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,D.$Ef)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(a.auth=d.user+":"+d.password);const o=i(a,t=>{const n=(0,D.$Cf)(d.followRedirects)?d.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)w({...d,url:t.headers.location,followRedirects:n-1},h).then(l,E);else{let r=t;!d.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(r=t.pipe((0,g.createGunzip)())),l({res:t,stream:(0,s.$qe)(r)})}});o.on("error",E),d.timeout&&o.setTimeout(d.timeout),d.isChromiumNetwork&&o.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&o.write(d.data),o.end(),h.onCancellationRequested(()=>{o.abort(),E(new O.$5)})})}e.$Zq=w}),define(ie[286],ne([0,1,15,285]),function(J,e,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=void 0;function s(D){return S.net.request}class O extends R.$Yq{request(P,f){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$r8b=O}),define(ie[81],ne([0,1,7,3,2,36,16,5,20,6,96,279,41,52,40,13]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=e.$z6b=e.$y6b=e.$x6b=void 0,e.$x6b=(0,P.$Ph)("storageMainService");let w=class extends s.$Sc{constructor(l,E,u,i,a,o){super(),this.c=l,this.f=E,this.g=u,this.h=i,this.j=a,this.m=o,this.a=void 0,this.b=this.B(new R.$Nd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)l.join("profileStorage",E.close());for(const[,E]of this.w)l.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const E=this.t.get(l.profile.id);E&&l.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new b.$s6b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,$.$9o)(l))return this.applicationStorage;let E=this.t.get(l.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),E=this.B(this.u(l)),this.t.set(l.id,E);const u=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:l})));this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),u.dispose()}))}return E}u(l){return this.a===2?new b.$u6b(this.c,this.j):new b.$r6b(l,this.n(),this.c,this.j)}workspaceStorage(l){let E=this.w.get(l.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),E=this.B(this.y(l)),this.w.set(l.id,E),this.B(R.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),E}y(l){return this.a===2?new b.$u6b(this.c,this.j):new b.$t6b(l,this.n(),this.c,this.f,this.j)}isUsed(l){const E=S.URI.file(l);for(const u of[this.applicationStorage,...this.t.values(),...this.w.values()])if(u.path&&this.m.extUri.isEqualOrParent(S.URI.file(u.path),E))return!0;return!1}};e.$y6b=w,e.$y6b=w=Ee([te(0,c.$0i),te(1,O.$Wh),te(2,g.$v6b),te(3,f.$p6b),te(4,D.$$j),te(5,v.$Ik)],w),e.$z6b=(0,P.$Ph)("applicationStorageMainService");let d=class extends $.$8o{constructor(l,E){super(),this.s=l,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$A6b=d,e.$A6b=d=Ee([te(0,y.$Kk),te(1,e.$x6b)],d)}),define(ie[287],ne([0,1,86,28,103,99,8,2,4,18,6,25,241,242,95,126,17]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=e.$p8b=e.$o8b=e.$n8b=void 0;async function d(i,a,o,t,n){let r;for(let p=3;p&&(r?.dispose(),r=await new h(i,a,o,t,n).waitForReady(),!(n&&s.$hg[n]||!s.$hg[r.tunnelLocalPort]));p--);return r}class h extends P.$Sc{constructor(a,o,t,n,r){super(),this.m=o,this.n=r,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=a,this.b=S.createServer(),this.c=new D.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const a=this.n??this.tunnelRemotePort,o=(0,m.$ev)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$ig)(a,2,1e3,o),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(a){a.pause();const o=(0,m.$cv)(this.tunnelRemoteHost)||(0,m.$ev)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,y.$6k)(this.a,o,this.tunnelRemotePort),n=t.getSocket(),r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&a.write(r.buffer),a.on("end",()=>{a.localAddress&&this.j.delete(a.localAddress),n.end()}),a.on("close",()=>n.end()),a.on("error",()=>{a.localAddress&&this.j.delete(a.localAddress),n instanceof O.$Eh?n.socket.destroy():n.end()}),n instanceof O.$Eh?this.t(a,n):this.s(a,n),a.localAddress&&this.j.set(a.localAddress,()=>{a.end(),n.end()})}s(a,o){o.onClose(()=>a.destroy()),o.onEnd(()=>a.end()),o.onData(t=>a.write(t.buffer)),a.on("data",t=>o.write(w.$be.wrap(t))),a.resume()}t(a,o){const t=o.socket;t.on("end",()=>a.end()),t.on("close",()=>a.end()),t.on("error",()=>{a.destroy()}),t.pipe(a),a.pipe(t)}}e.$n8b=h;let l=class extends m.$hv{constructor(a,o,t,n,r){super(o,r),this.u=a,this.v=t,this.w=n}isPortPrivileged(a){return(0,m.$fv)(a,this.l,f.OS,R.release())}s(a,o,t,n,r,p,A,C){const k=this.r(o,t);if(k)return++k.refcount,k.value;if((0,m.$_u)(a))return this.t(a,o,t,r,p,A,C);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${t} on local port ${r}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:a,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=d(I,n,o,t,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,t,j),j}}};e.$o8b=l,e.$o8b=l=Ee([te(0,g.$Zk),te(1,$.$0i),te(2,v.$3k),te(3,b.$pj),te(4,c.$ji)],l);let E=class extends l{constructor(a,o,t,n,r){super(a,o,t,n,r)}};e.$p8b=E,e.$p8b=E=Ee([te(0,g.$Zk),te(1,$.$0i),te(2,v.$3k),te(3,b.$pj),te(4,c.$ji)],E);let u=class extends P.$Sc{constructor(a,o,t,n,r){super(),this.b=a,this.c=o,this.f=t,this.g=n,this.h=r,this.a=new Map}async openTunnel(a,o,t,n,r,p,A,C,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${p}.`),!this.a.has(a)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(a,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(a))})}return this.a.get(a).openTunnel(o,t,n,r,p,A,C,k)}};e.$q8b=u,e.$q8b=u=Ee([te(0,g.$Zk),te(1,$.$0i),te(2,b.$pj),te(3,v.$3k),te(4,c.$ji)],u)}),define(ie[100],ne([0,1,8,22,3,18,24,20,6,25,50,48]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M7b=e.$L7b=void 0;function y(v,m,w){return`${w.updateUrl}/api/update/${v}/${m}/${w.commit}`}e.$L7b=y;let g=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,w,d,h,l,E){this.f=m,this.g=w,this.h=d,this.i=h,this.j=l,this.k=E,this.b=b.$pU.Uninitialized,this.c=new s.$Nd,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$pU.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$pU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$pU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),w=this.m(m);if(!w){this.d(b.$pU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(b.$pU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.$pU.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,d=>this.j.error(d))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,S.$Ug)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$M7b=g,e.$M7b=g=Ee([te(0,P.$p6b),te(1,O.$ji),te(2,D.$n6b),te(3,$.$So),te(4,f.$0i),te(5,c.$pj)],g)}),define(ie[288],ne([0,1,15,54,3,2,18,24,20,6,25,50,26,48,100]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=void 0;let m=class extends v.$M7b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(d,h)=>h)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(d,h,l)=>({url:h,version:l,productVersion:l}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(d,h,l,E)=>({releaseNotes:h,version:l,productVersion:l,date:E}))}constructor(d,h,l,E,u,i,a){super(d,h,E,u,i,a),this.z=l,this.u=new O.$Rc,d.setRelaunchHandler(this)}handleRelaunch(d){return d?.addArgs||d?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(d){this.j.error("UpdateService error:",d);const h=this.state.type==="checking for updates"&&this.state.explicit?d:void 0;this.d(g.$pU.Idle(1,h))}s(d){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,v.$L7b)(h,d,this.k);try{S.autoUpdater.setFeedURL({url:l})}catch(E){this.j.error("Failed to set update feed URL",E);return}return l}t(d){this.d(g.$pU.CheckingForUpdates(d)),S.autoUpdater.checkForUpdates()}E(d){this.state.type==="checking for updates"&&this.d(g.$pU.Downloading(d))}F(d){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:d.version}),this.d(g.$pU.Ready(d)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(g.$pU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$N7b=m,Ee([R.$hh],m.prototype,"v",null),Ee([R.$hh],m.prototype,"w",null),Ee([R.$hh],m.prototype,"x",null),Ee([R.$hh],m.prototype,"y",null),e.$N7b=m=Ee([te(0,f.$p6b),te(1,D.$ji),te(2,y.$cl),te(3,P.$n6b),te(4,b.$So),te(5,c.$0i),te(6,$.$pj)],m)}),define(ie[289],ne([0,1,47,45,8,3,9,24,20,6,26,48]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;let y=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,w,d){if(this.f=m,this.g=d,this.a=b.$pU.Uninitialized,this.b=new O.$Nd,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$pU.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(m=60*60*1e3){return(0,s.$Ug)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};y=Ee([te(0,f.$p6b),te(1,P.$n6b),te(2,c.$0i)],y);let g=class extends y{constructor(m,w,d,h,l,E){super(d,h,l),this.o=m,this.p=w,this.q=E;const u=(0,R.watch)(D.$mc(this.o)),i=O.Event.fromNodeEventEmitter(u,"change",(n,r)=>r),a=O.Event.filter(i,n=>n==="current"),t=O.Event.debounce(a,(n,r)=>r,2e3)(()=>this.checkForUpdates(!1));d.onWillShutdown(()=>{t.dispose(),u.close()})}m(){this.d(b.$pU.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(b.$pU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$pU.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$pU.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise((d,h)=>(0,R.realpath)(`${D.$mc(this.o)}/current`,(l,E)=>l?h(l):d(E))),w=D.$nc(m);return this.p!==w}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$P7b=g,e.$P7b=g=Ee([te(2,f.$p6b),te(3,P.$n6b),te(4,c.$0i),te(5,$.$cl)],g)}),define(ie[29],ne([0,1,4,5,68,67,25,18,24,9,90]),function(J,e,S,R,s,O,D,P,f,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=e.$16b=e.OpenContext=e.$Z6b=void 0,e.$Z6b=(0,R.$Ph)("windowsMainService");var b;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(b||(e.OpenContext=b={}));function y(m,w,d){const h=m.get(O.$B6b),l=m.get(D.$pj),E=m.get(P.$ji),u=m.get(f.$n6b),i=E.getValue("window"),a={backgroundColor:h.getBackgroundColor(),minWidth:s.$fC.WIDTH,minHeight:s.$fC.HEIGHT,title:l.nameLong,...d,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$mC)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...d?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return w&&(a.x=w.x,a.y=w.y,a.width=w.width,a.height=w.height),S.$l?a.icon=(0,c.$jc)(u.appRoot,"resources/linux/code.png"):S.$j&&!u.isBuilt&&(a.icon=(0,c.$jc)(u.appRoot,"resources/win32/code_150x150.png")),S.$k&&(a.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(a.acceptFirstMouse=!1)),a}e.$16b=y;function g(m){const w=m.get(e.$Z6b),d=m.get($.$Y6b),h=w.getFocusedWindow()??d.getFocusedWindow();if(h)return h;const l=w.getLastActiveWindow(),E=d.getLastActiveWindow();return l&&E?l.lastFocusTime<E.lastFocusTime?E:l:l??E}e.$26b=g;function v(m){let w,d=Number.MIN_VALUE;for(const h of m)h.lastFocusTime>d&&(d=h.lastFocusTime,w=h);return w}e.$36b=v}),define(ie[290],ne([0,1,15,22,3,55,2,32,116,6,81,29]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let g=class extends D.$Sc{constructor(m,w,d,h){super(),this.g=m,this.h=w,this.j=d,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(S.app,"login",(w,d,h,l,E)=>({event:w,webContents:d,req:h,authInfo:l,callback:E}));this.B(m(this.r,this))}async r({event:m,authInfo:w,req:d,callback:h}){if(!w.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&d.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{l=await this.b}finally{this.b=void 0}}h(l?.username,l?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(m);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const w=String((0,O.$Di)({scheme:m.scheme,host:m.host,port:m.port}));let d,h;try{const i=this.m.get(this.a+w,-1);if(i){const a=JSON.parse(await this.j.decrypt(i));d=a.username,h=a.password}}catch(i){this.g.error(i)}if(this.c!==y.StoredCredentialsUsed&&typeof d=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:d,password:h};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const E={authInfo:m,username:this.f?.username??d,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,P.$eg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,E),this.c=y.LoginDialogShown;const u=await new Promise(i=>{const a=async(o,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",a),n){const r={username:n.username,password:n.password};try{if(n.remember){const p=await this.j.encrypt(JSON.stringify(r));this.m.store(this.a+w,p,-1,1)}else this.m.remove(this.a+w,-1)}catch(p){this.g.error(p)}i({username:r.username,password:r.password})}else i(void 0)};l.win?.webContents.on("ipc-message",a)});return this.f=u,u}};e.$46b=g,e.$46b=g=Ee([te(0,c.$0i),te(1,b.$Z6b),te(2,f.$$T),te(3,$.$z6b)],g)}),define(ie[291],ne([0,1,15,23,4,7,21,18,62,5,6,127,29]),function(J,e,S,R,s,O,D,P,f,c,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=e.ID=void 0,e.ID="launchMainService",e.$r7b=(0,c.$Ph)(e.ID);let g=class{constructor(m,w,d,h){this.a=m,this.b=w,this.c=d,this.d=h}async start(m,w){this.a.trace("Received data from other instance: ",m,w),s.$k&&S.app.focus({steal:!0});const d=this.e(m);if(d.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));l&&(h=l.ready())}h.then(()=>{for(const{uri:l,originalUrl:E}of d)this.c.open(l,{originalUrl:E})})}else return this.f(m,w)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,R.$Hb)(m._urls.map(w=>{try{return{uri:O.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(m,w){const d=(0,f.$Nl)(w)?0:4;let h=[];const l=m.wait&&m.waitMarkerFilePath?O.URI.file(m.waitMarkerFilePath):void 0,E=m.remote||void 0,u={context:d,cli:m,userEnv:w,waitMarkerFileURI:l,remoteAuthority:E,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,u);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let i=!1;if(m["new-window"]||m["unity-launch"]||u.forceProfile||u.forceTempProfile)i=!0;else if(m["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$k}if(i)h=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,u),h=[a]):h=await this.b.open({...u,forceEmpty:!0})}}else h=await this.b.open({...u,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(l&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,D.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$s7b=g,e.$s7b=g=Ee([te(0,$.$0i),te(1,y.$Z6b),te(2,b.$eU),te(3,P.$ji)],g)}),define(ie[292],ne([0,1,2,20,52,30,8,29]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=void 0;let f=class extends S.$Sc{constructor($,b,y){super(),this.a=b,this.b=y,this.B($.onWillLoadWindow(g=>{g.reason===2&&this.c(g.window)})),this.B($.onBeforeCloseWindow(g=>this.c(g))),this.B(new D.$6g(()=>this.g(),30*1e3)).schedule()}async c($){const b=this.f($),y=this.a.getProfileForWorkspace(b);y?.isTransient&&(this.a.unsetWorkspace(b,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f($){return $.openedWorkspace??(0,O.$4h)($.backupPath,$.isExtensionDevelopmentHost)}g(){const $=this.a.getAssociatedEmptyWindows();if($.length===0)return;const b=this.b.getWindows().map(y=>this.f(y));for(const y of $)b.some(g=>g.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$87b=f,e.$87b=f=Ee([te(0,R.$p6b),te(1,s.$v6b),te(2,P.$Z6b)],f)}),define(ie[60],ne([0,1,15,2,3,6,313,8,13,29,73,26,20,75,37,4,131]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=e.$76b=void 0;function h(u){return typeof u.responseWindowId=="number"}let l=class extends R.$Sc{static{d=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(d.b.values())}constructor(i,a,o){super(),this.t=i,this.u=a,this.w=o,this.c=String(++d.a),this.f=this.B(new s.$Nd),this.onStdout=this.f.event,this.g=this.B(new s.$Nd),this.onStderr=this.g.event,this.h=this.B(new s.$Nd),this.onMessage=this.h.event,this.j=this.B(new s.$Nd),this.onExit=this.j.event,this.m=this.B(new s.$Nd),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(i,a){let o;switch(this.s?.correlationId?o=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`:o=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${i}`,a){case $.default.Error:this.t.error(o);break;case $.default.Warning:this.t.warn(o);break;case $.default.Info:this.t.trace(o);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",$.default.Error),!1):!0}start(i){const a=this.C(i);return a&&i.payload&&this.postMessage(i.payload),a}C(i){if(!this.z())return!1;this.s=i;const a=`${this.s.type}-${this.c}`,o=f.$cg.asFileUri("bootstrap-fork.js").fsPath,t=this.s.args??[],n=this.s.execArgv??[],r=this.s.allowLoadingUnsignedLibraries,p=this.s.forceAllocationsToV8Sandbox,A="pipe",C=this.D(i);return this.y("creating new...",$.default.Info),this.n=S.utilityProcess.fork(o,t,{serviceName:a,env:C,execArgv:n,allowLoadingUnsignedLibraries:r,forceAllocationsToV8Sandbox:p,stdio:A}),this.F(this.n,this.s,a),!0}D(i){const a=i.env?{...i.env}:{...(0,v.$7m)(process.env)};a.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(a.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),a.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,m.$j&&((0,w.isUNCAccessRestrictionsDisabled)()?a.NODE_DISABLE_UNC_ACCESS_CHECKS="1":a.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,g.$Al)(a);for(const o of Object.keys(a))a[o]=String(a[o]);return a}F(i,a,o){if(i.stdout){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.r=i.pid,typeof i.pid=="number"&&d.b.set(i.pid,{pid:i.pid,name:h(a)?`${a.type} [${a.responseWindowId}]`:a.type}),this.y("successfully created",$.default.Info)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.y(`received exit event with code ${t}`,$.default.Info),this.j.fire({pid:this.r,code:t,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===o&&(this.y(`crashed with code ${t.exitCode} and reason '${t.reason}'`,$.default.Error),this.u.publicLog2("utilityprocesscrash",{type:a.type,reason:t.reason,code:t.exitCode}),this.m.fire({pid:this.r,code:t.exitCode,reason:t.reason}),this.G())}))}once(i,a){const o=this.B(this.h.event(t=>{t===i&&(o.dispose(),a())}))}postMessage(i,a){this.n&&this.n.postMessage(i,a)}connect(i){const{port1:a,port2:o}=new S.MessageChannelMain;return this.postMessage(i,[o]),a}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",$.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",$.default.Info),this.n.kill()?(this.y("successfully killed the process",$.default.Info),this.G()):this.y("unable to kill the process",$.default.Warning)}G(){typeof this.r=="number"&&d.b.delete(this.r),this.n=void 0}async waitForExit(i){this.n&&(this.y("waiting to exit...",$.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Ug)(i)]),this.n&&(this.y(`did not exit within ${i}ms, will kill it now...`,$.default.Info),this.kill()))}};e.$76b=l,e.$76b=l=d=Ee([te(0,O.$0i),te(1,b.$cl),te(2,y.$p6b)],l);let E=class extends l{constructor(i,a,o,t){super(i,o,t),this.H=a}start(i){const a=this.H.getWindowById(i.responseWindowId);if(!a?.win||a.win.isDestroyed()||a.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",$.default.Error),!0;if(!super.C(i))return!1;this.I(a.win,i);const t=this.connect(i.payload);return a.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}I(i,a){a.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,o=>o.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$86b=E,e.$86b=E=Ee([te(0,O.$0i),te(1,c.$Z6b),te(2,b.$cl),te(3,y.$p6b)],E)}),define(ie[293],ne([0,1,14,6,20,8,60,29,26]),function(J,e,S,R,s,O,D,P,f){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=void 0;let $=class{static{c=this}static{this.a=0}constructor(y,g,v,m){this.d=y,this.f=g,this.g=v,this.h=m,this.b=new Map,this.c=!1,this.f.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const g=this.b.get(y);if(!g)throw new Error("Unknown extension host!");return g}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,S.$6)();const y=String(++c.a),g=new D.$86b(this.d,this.g,this.h,this.f);return this.b.set(y,g),g.onExit(({pid:v,code:m,signal:w})=>{this.d.info(`Extension host with pid ${v} exited with code: ${m}, signal: ${w}.`),setTimeout(()=>{g.dispose(),this.b.delete(y)})}),{id:y}}async start(y,g){if(this.c)throw(0,S.$6)();this.i(y).start({...g,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:g.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,S.$6)();const g=this.b.get(y);return g?g.enableInspectPort():!1}async kill(y){if(this.c)throw(0,S.$6)();const g=this.b.get(y);g&&g.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const g=[];for(const[,v]of this.b)g.push(v.waitForExit(y));return O.Promises.settled(g).then(()=>{})}};e.$c7b=$,e.$c7b=$=c=Ee([te(0,R.$0i),te(1,s.$p6b),te(2,P.$Z6b),te(3,f.$cl)],$)}),define(ie[294],ne([0,1,38,8,2,24,20,6,41,39,66,60,51,89,12,247]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;let w=class extends s.$Sc{constructor(h,l,E,u,i,a,o,t){super(),this.c=h,this.f=l,this.g=E,this.h=u,this.j=i,this.m=a,this.n=o,this.r=t,this.a=new R.$Sg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$qT.on(m.$D7b.request,(h,l)=>this.t(h,l,m.$D7b.response)),S.$qT.on(m.$E7b.request,(h,l)=>this.t(h,l,m.$E7b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(h,l,E){this.m.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(E);if(h.sender.isDestroyed())return u.close();h.sender.postMessage(E,l,[u])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$C7b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const h=new R.$ch;this.b?this.b.once(m.$C7b.initDone,()=>h.complete()):S.$qT.once(m.$C7b.initDone,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const h=new R.$ch;this.b?this.b.once(m.$C7b.ipcReady,()=>h.complete()):S.$qT.once(m.$C7b.ipcReady,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new b.$76b(this.m,y.$lo,this.j));const h=(0,g.$lm)(this.g.args,this.g.isBuilt);let l;h.port&&(l=["--nolazy"],h.break?l.push(`--inspect-brk=${h.port}`):l.push(`--inspect=${h.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:l})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(h){return await this.z,(0,v.$Jf)(this.b).connect(h)}};e.$F7b=w,e.$F7b=w=Ee([te(2,O.$n6b),te(3,f.$Kk),te(4,D.$p6b),te(5,P.$0i),te(6,$.$T6b),te(7,c.$in)],w)}),define(ie[295],ne([0,1,24,89,20,6,51,60,110,38,2,3,37,18,13]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;let m=class extends $.$Sc{constructor(d,h,l,E,u){super(),this.f=d,this.g=h,this.h=l,this.j=E,this.m=u,this.a=void 0,this.b=new b.$Nd,this.onRequestConnection=this.b.event,this.c=new b.$Nd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$qT.on("vscode:createPtyHostMessageChannel",(i,a)=>this.r(i,a)),this.B((0,$.$Qc)(()=>{c.$qT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$76b(this.m,D.$lo,this.j);const d=(0,R.$km)(this.h.args,this.h.isBuilt),h=d.port?["--nolazy",`--inspect${d.break?"-brk":""}=${d.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),E=new f.$yT(l,"ptyHost"),u=new $.$Rc;return u.add(E),u.add((0,$.$Qc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const d={...(0,y.$7m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(d.VSCODE_LATENCY=String(h));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&(d.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),d}r(d,h){this.b.fire();const l=this.a.connect();if(d.sender.isDestroyed()){l.close();return}d.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[l])}};e.$f8b=m,e.$f8b=m=Ee([te(1,g.$ji),te(2,S.$n6b),te(3,s.$p6b),te(4,O.$0i)],m)}),define(ie[296],ne([0,1,2,5,6,29,60,26,55,3,8,20]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e8b=e.$d8b=void 0,e.$d8b=(0,R.$Ph)("utilityProcessWorker");let y=class extends S.$Sc{constructor(m,w,d,h){super(),this.b=m,this.c=w,this.f=d,this.g=h,this.a=new Map}async createWorker(m){const w=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const d=this.h(m);this.a.has(d)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(m));const h=new g(this.b,this.c,this.f,this.g,m);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(d,h);const l=new $.$ch;return c.Event.once(h.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(d),l.complete({reason:E})}),l.p}h(m){return(0,f.$Di)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const w=this.h(m),d=this.a.get(w);d&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),d.kill(),this.a.delete(w))}};e.$e8b=y,e.$e8b=y=Ee([te(0,s.$0i),te(1,O.$Z6b),te(2,P.$cl),te(3,b.$p6b)],y);let g=class extends S.$Sc{constructor(m,w,d,h,l){super(),this.c=m,this.f=w,this.g=d,this.h=h,this.j=l,this.a=this.B(new c.$Nd),this.onDidTerminate=this.a.event,this.b=new D.$86b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};g=Ee([te(0,s.$0i),te(1,O.$Z6b),te(2,P.$cl),te(3,b.$p6b)],g)}),define(ie[297],ne([0,1,15,3,2,273,29]),function(J,e,S,R,s,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=void 0;let P=class extends s.$Sc{constructor(c){super(),this.b=c,this.a=this.B(new R.$Nd),this.onFoundInFrame=this.a.event,this.B(new O.$W7b)}async setIgnoreMenuShortcuts(c,$){let b;if(typeof c.windowId=="number"){const{windowId:y}=c,g=this.b.getWindowById(y);if(!g?.win)throw new Error(`Invalid windowId: ${y}`);b=g.win.webContents}else{const{webContentsId:y}=c;if(b=S.webContents.fromId(y),!b)throw new Error(`Invalid webContentsId: ${y}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts($)}async findInFrame(c,$,b,y){const v=this.c(c,$);if(typeof v.findInFrame=="function"){v.findInFrame(b,{findNext:y.findNext,forward:y.forward});const m=(w,d)=>{d.finalUpdate&&(this.a.fire(d),v.removeListener("found-in-frame",m))};v.on("found-in-frame",m)}}async stopFindInFrame(c,$,b){const g=this.c(c,$);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(c,$){const b=this.b.getWindowById(c.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${c}`);const y=b.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===$);if(!y)throw new Error(`Unknown frame: ${$}`);return y}};e.$X7b=P,e.$X7b=P=Ee([te(0,D.$Z6b)],P)}),define(ie[298],ne([0,1,15,2,4,19,7,18,20,6,34,29,128,30]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=e.$Y7b=void 0;let m=class extends R.$Sc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,i,a,o,t){super(),this.g=u,this.h=i,this.j=a,this.m=o,this.n=t,this.b=w(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&u.add(i.lastActiveWindow.uiState.display))}const a=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(i.lastPluginDevelopmentHostWindow=this.w(a),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$k&&!a.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$k&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const o=h(i);this.h.setItem(v.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(u){if(this.j.quitRequested)return;const i=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(a=>{const o=(0,g.$5h)(u.openedWorkspace)&&a.workspace?.id===u.openedWorkspace.id,t=(0,g.$Zh)(u.openedWorkspace)&&a.folderUri&&O.$mg.isEqual(a.folderUri,u.openedWorkspace.uri);(o||t)&&(a.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(u){return{windowId:u.id,workspace:(0,g.$5h)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,g.$Zh)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const i=this.z(u),a=this.n.getValue("window");if(i.mode===3){let o;i.hasDefaultState?o=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||a?.restoreFullscreen),o||(i.mode=1)}return i}z(u){const i=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const p=u.workspace;if((0,g.$5h)(p)){const C=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===p.id).map(k=>k.uiState);if(C.length)return C[0]}if((0,g.$Zh)(p)){const C=this.state.openedWindows.filter(k=>k.folderUri&&O.$mg.isEqual(k.folderUri,p.uri)).map(k=>k.uiState);if(C.length)return C[0]}else if(u.backupPath){const C=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(C.length)return C[0]}const A=this.c||this.state.lastActiveWindow;if(!i&&A)return A.uiState}let a;const o=S.screen.getAllDisplays();if(o.length===1)a=o[0];else{if(s.$k){const p=S.screen.getCursorScreenPoint();a=S.screen.getDisplayNearestPoint(p)}!a&&i&&(a=S.screen.getDisplayMatching(i.getBounds())),a||(a=S.screen.getPrimaryDisplay()||o[0])}let t=(0,y.$m6b)();t.x=Math.round(a.bounds.x+a.bounds.width/2-t.width/2),t.y=Math.round(a.bounds.y+a.bounds.height/2-t.height/2);const n=this.n.getValue("window");let r=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,r=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,r=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const p=i.serializeWindowState();p.mode===3?t.mode=3:t=p,r=t.mode!==3&&n.newWindowDimensions==="offset"}}return r&&(t=this.C(t)),t.hasDefaultState=!0,t}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const i=this.g.getWindows().map(a=>a.getBounds());for(;i.some(a=>a.x===u.x||a.y===u.y);)u.x+=30,u.y+=30;return u}};e.$Y7b=m,e.$Y7b=m=v=Ee([te(0,b.$Z6b),te(1,$.$BN),te(2,f.$p6b),te(3,c.$0i),te(4,P.$ji)],m);function w(E){const u={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(u.lastActiveWindow=d(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=d(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(u.openedWindows=i.openedWindows.map(a=>d(a))),u}e.$Z7b=w;function d(E){const u={uiState:E.uiState};return E.backupPath&&(u.backupPath=E.backupPath),E.remoteAuthority&&(u.remoteAuthority=E.remoteAuthority),E.folder&&(u.folderUri=D.URI.parse(E.folder)),E.workspaceIdentifier&&(u.workspace={id:E.workspaceIdentifier.id,configPath:D.URI.parse(E.workspaceIdentifier.configURIPath)}),u}function h(E){return{lastActiveWindow:E.lastActiveWindow&&l(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&l(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(u=>l(u))}}e.$17b=h;function l(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ie[53],ne([0,1,15,3,44,2,13,9,19,21,194,63,59,24,5,6,52,130,30,97,98]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=e.$R6b=void 0,e.$R6b=(0,v.$Ph)("workspacesManagementMainService");let u=class extends O.$Sc{constructor(a,o,t,n,r){super(),this.g=a,this.h=o,this.j=t,this.m=n,this.n=r,this.a=this.B(new R.$Nd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Nd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const a=(await c.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(o=>(0,f.$vg)(this.c,o,h.$ci));for(const o of a){const t=(0,E.$O6b)(o),n=await this.resolveLocalWorkspace(o);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(a){a.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${a}).`)}}resolveLocalWorkspace(a){return this.r(a,o=>c.Promises.readFile(o,"utf8"))}r(a,o){if(this.s(a)&&a.scheme===D.Schemas.file)try{const t=o(a.fsPath);return t instanceof Promise?t.then(n=>this.t(a,n),n=>{}):this.t(a,t)}catch{return}}s(a){return(0,h.$di)(a,this.g)||(0,h.$ii)(a)}t(a,o){try{const t=this.u(a,o),n=(0,E.$O6b)(a);return{id:n.id,configPath:n.configPath,folders:(0,l.$TU)(t.folders,n.configPath,f.$mg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(a,o){const t=(0,s.$Wm)(o);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,l.$RU)(n));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(a,o){const{workspace:t,storedWorkspace:n}=this.w(a,o),r=t.configPath.fsPath;return await c.Promises.mkdir((0,P.$mc)(r),{recursive:!0}),await c.Promises.writeFile(r,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:o}),t}w(a=[],o){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$vg)(this.c,t),r=(0,f.$vg)(n,h.$ci),p=[];for(const A of a)p.push((0,l.$SU)(A.uri,!0,A.name,n,f.$mg));return{workspace:(0,E.$O6b)(r),storedWorkspace:{folders:p,remoteAuthority:o}}}async getWorkspaceIdentifier(a){return(0,E.$O6b)(a)}isUntitledWorkspace(a){return(0,h.$di)(a.configPath,this.g)}async deleteUntitledWorkspace(a){this.isUntitledWorkspace(a)&&(await this.y(a),this.j.isEnabled()&&this.j.unsetWorkspace(a),this.a.fire(a))}async y(a){const o=(0,f.$jg)(a.configPath);try{await c.Promises.rm((0,P.$mc)(o));const t=(0,P.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,a.id);await c.Promises.exists(t)&&await c.Promises.writeFile((0,P.$jc)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==a.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${o} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(a,o,t){if(!a||!a.win||!a.isReady||!await this.z(a,o,t))return;const r=await this.C(a,(0,E.$O6b)(t));if(r)return this.b.fire({window:a,workspace:r.workspace}),r}async z(a,o,t){return t?(0,h.$5h)(a.openedWorkspace)&&f.$mg.isEqual(a.openedWorkspace.configPath,t)?!1:(0,d.$L6b)(o,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:(0,$.localize)(1,null,(0,f.$sg)(t)),detail:(0,$.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(a,o){if(!a.config)return;a.focus();let t;return a.config.extensionDevelopmentPath||(a.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:a.remoteAuthority},a.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:a.remoteAuthority})),(0,h.$5h)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&await this.deleteUntitledWorkspace(a.openedWorkspace),a.config.workspace=o,a.config.backupPath=t,{workspace:o,backupPath:t}}};e.$S6b=u,e.$S6b=u=Ee([te(0,g.$n6b),te(1,m.$0i),te(2,w.$v6b),te(3,b.$G6b),te(4,y.$H6b)],u)}),define(ie[132],ne([0,1,15,38,22,5,29,30,53,12,6,60]),function(J,e,S,R,s,O,D,P,f,c,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=e.$06b=e.ID=void 0,e.ID="diagnosticsMainService",e.$06b=(0,O.$Ph)(e.ID);let y=class{constructor(v,m,w){this.a=v,this.b=m,this.c=w}async getRemoteDiagnostics(v){const m=this.a.getWindows();return(await Promise.all(m.map(async d=>{const h=d.remoteAuthority;if(!h)return;const l=`vscode:getDiagnosticInfoResponse${d.id}`,E={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f(d):void 0};return new Promise(u=>{d.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:l,args:E}),R.$qT.once(l,(i,a)=>{a||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(a)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(d=>!!d)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const w of S.BrowserWindow.getAllWindows()){const d=this.a.getWindowById(w.id);d?v.push(await this.d(d)):v.push(this.e(w))}const m=[];for(const{pid:w,name:d}of b.$76b.getAll())m.push({pid:w,name:d});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:m,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(v){const m=await this.f(v),w=(0,c.$Jf)(v.win);return this.e(w,m,v.remoteAuthority)}e(v,m=[],w){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:m,remoteAuthority:w}}async f(v){const m=[],w=v.openedWorkspace;if((0,P.$Zh)(w))m.push(w.uri);else if((0,P.$5h)(w)){const d=await this.b.resolveLocalWorkspace(w.configPath);d&&d.folders.forEach(l=>{m.push(l.uri)})}return m}};e.$$6b=y,e.$$6b=y=Ee([te(0,D.$Z6b),te(1,f.$R6b),te(2,$.$0i)],y)}),define(ie[69],ne([0,1,47,15,28,156,54,3,2,13,9,4,7,105,87,21,103,182,59,24,5,20,6,25,67,29,30,53,17,243,235,90]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i,a,o,t,n,r,p,A,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=e.$l7b=void 0,e.$l7b=(0,E.$Ph)("nativeHostMainService");let I=class extends f.$Sc{constructor(U,z,x,X,ae,se,ce,Z,Q,K){super(),this.a=U,this.b=z,this.c=x,this.f=X,this.g=ae,this.h=se,this.j=ce,this.m=Z,this.n=Q,this.r=K,this.onDidOpenWindow=P.Event.map(this.a.onDidOpenWindow,q=>q.id),this.onDidTriggerSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:q,x:W,y:G})=>({windowId:q.id,x:W,y:G})),({windowId:q})=>!!this.a.getWindowById(q)),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-maximize",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-unmaximize",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(q,W)=>W.id),q=>!!this.a.getWindowById(q)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),q=>!!q),q=>q.id),P.Event.filter(P.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(q,W)=>W.id),q=>!!this.a.getWindowById(q))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new P.$Nd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(q,W,G)=>G),q=>!(Array.isArray(q)&&q.length===1&&q[0]==="workArea")),P.Event.fromNodeEventEmitter(R.screen,"display-added"),P.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(z=>({id:z.id,workspace:z.openedWorkspace??(0,n.$4h)(z.backupPath,z.isExtensionDevelopmentHost),title:z.win?.getTitle()??"",filename:z.getRepresentedFilename(),dirty:z.isDocumentEdited()}))}async getWindowCount(U){return this.a.getWindowCount()}async getActiveWindowId(U){const z=R.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(z)return z.id}openWindow(U,z,x){return Array.isArray(z)?this.t(U,z,x):this.u(U,z)}async t(U,z,x=Object.create(null)){z.length>0&&await this.a.open({context:5,contextWindowId:U,urisToOpen:z,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async u(U,z){await this.a.openEmptyWindow({context:5,contextWindowId:U},z)}async toggleFullScreen(U){this.F(U)?.toggleFullScreen()}async handleTitleDoubleClick(U){this.F(U)?.handleTitleDoubleClick()}async isMaximized(U){const z=this.F(U);return z?.win?z.win.isMaximized():!1}async maximizeWindow(U){const z=this.F(U);z?.win&&z.win.maximize()}async unmaximizeWindow(U){const z=this.F(U);z?.win&&z.win.unmaximize()}async minimizeWindow(U){const z=this.F(U);z?.win&&z.win.minimize()}async moveWindowTop(U,z){const x=this.D(z?.targetWindowId)??this.F(U);x?.win&&x.win.moveTop()}async positionWindow(U,z,x){const X=this.D(x?.targetWindowId)??this.F(U);if(X?.win){if(X.win.isFullScreen()){const ae=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(X.win,"leave-full-screen")));X.win.setFullScreen(!1),await ae}X.win.setBounds(z)}}async updateWindowControls(U,z){const x=this.F(U);x&&x.updateWindowControls(z)}async focusWindow(U,z){(this.D(z?.targetWindowId)??this.F(U))?.focus({force:z?.force??!1})}async setMinimumSize(U,z,x){const X=this.F(U);if(X?.win){const[ae,se]=X.win.getSize(),[ce,Z]=X.win.getMinimumSize(),[Q,K]=[z??ce,x??Z],[q,W]=[Math.max(ae,Q),Math.max(se,K)];(ce!==Q||Z!==K)&&X.win.setMinimumSize(Q,K),(ae!==q||se!==W)&&X.win.setSize(q,W)}}async saveWindowSplash(U,z){this.m.saveWindowSplash(U,z)}async installShellCommand(U){const{source:z,target:x}=await this.w();try{const{symbolicLink:X}=await m.SymlinkSupport.stat(z);if(X&&!X.dangling){const ae=await(0,g.$7p)(z);if(x===ae)return}await m.Promises.unlink(z)}catch(X){if(X.code!=="ENOENT")throw X}try{await m.Promises.symlink(x,z)}catch(X){if(X.code!=="EACCES"&&X.code!=="ENOENT")throw X;const{response:ae}=await this.showMessageBox(U,{type:"info",message:(0,d.localize)(0,null,this.j.nameShort),buttons:[(0,d.localize)(1,null),(0,d.localize)(2,null)]});if(ae===0)try{const se=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${z}'\\" with administrator privileges"`;await(0,O.promisify)(S.exec)(se)}catch{throw new Error((0,d.localize)(3,null,z))}}}async uninstallShellCommand(U){const{source:z}=await this.w();try{await m.Promises.unlink(z)}catch(x){switch(x.code){case"EACCES":{const{response:X}=await this.showMessageBox(U,{type:"info",message:(0,d.localize)(4,null,this.j.nameShort),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]});if(X===0)try{const ae=`osascript -e "do shell script \\"rm '${z}'\\" with administrator privileges"`;await(0,O.promisify)(S.exec)(ae)}catch{throw new Error((0,d.localize)(7,null,z))}break}case"ENOENT":break;default:throw x}}}async w(){const U=(0,$.$kc)(this.g.appRoot,"bin","code"),z=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(U))throw new Error((0,d.localize)(8,null,U));return{source:z,target:U}}async showMessageBox(U,z){const x=this.H(U);return this.c.showMessageBox(z,x?.win??void 0)}async showSaveDialog(U,z){const x=this.H(U);return this.c.showSaveDialog(z,x?.win??void 0)}async showOpenDialog(U,z){const x=this.H(U);return this.c.showOpenDialog(z,x?.win??void 0)}async pickFileFolderAndOpen(U,z){const x=await this.c.pickFileFolder(z);x&&await this.z(await Promise.all(x.map(async X=>await m.SymlinkSupport.existsDirectory(X)?{folderUri:y.URI.file(X)}:{fileUri:y.URI.file(X)})),z,U)}async pickFolderAndOpen(U,z){const x=await this.c.pickFolder(z);x&&await this.z(x.map(X=>({folderUri:y.URI.file(X)})),z,U)}async pickFileAndOpen(U,z){const x=await this.c.pickFile(z);x&&await this.z(x.map(X=>({fileUri:y.URI.file(X)})),z,U)}async pickWorkspaceAndOpen(U,z){const x=await this.c.pickWorkspace(z);x&&await this.z(x.map(X=>({workspaceUri:y.URI.file(X)})),z,U)}async z(U,z,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:U,forceNewWindow:z.forceNewWindow})}async showItemInFolder(U,z){R.shell.showItemInFolder(z)}async setRepresentedFilename(U,z){this.F(U)?.setRepresentedFilename(z)}async setDocumentEdited(U,z){this.F(U)?.setDocumentEdited(z)}async openExternal(U,z){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(z),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(U,z){return R.shell.trashItem(z)}async isAdmin(){let U;return b.$j?U=(await new Promise((z,x)=>{J(["native-is-elevated"],z,x)}))():U=process.getuid?.()===0,U}async writeElevated(U,z,x,X){const ae=await new Promise((se,ce)=>{J(["@vscode/sudo-prompt"],se,ce)});return new Promise((se,ce)=>{const Z=[`"${this.C}"`];X?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${z.fsPath}"`,`"${x.fsPath}"`);const Q={name:this.j.nameLong.replace("-",""),icns:b.$k&&this.g.isBuilt?(0,$.$jc)((0,$.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ae.exec(Z.join(" "),Q,(K,q,W)=>{q&&this.h.trace(`[sudo-prompt] received stdout: ${q}`),W&&this.h.trace(`[sudo-prompt] received stderr: ${W}`),K?ce(K):se(void 0)})})}async isRunningUnderARM64Translation(){return b.$l||b.$j?!1:R.app.runningUnderARM64Translation}get C(){return b.$j?this.g.isBuilt?(0,$.$jc)((0,$.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,$.$jc)(this.g.appRoot,"scripts","code-cli.bat"):b.$l?this.g.isBuilt?(0,$.$jc)((0,$.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,$.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,$.$jc)(this.g.appRoot,"bin","code"):(0,$.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Rm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return b.$j&&(0,A.$j7b)()}async killProcess(U,z,x){process.kill(z,x)}async readClipboardText(U,z){return R.clipboard.readText(z)}async writeClipboardText(U,z,x){return R.clipboard.writeText(z,x)}async readClipboardFindText(U){return R.clipboard.readFindText()}async writeClipboardFindText(U,z){return R.clipboard.writeFindText(z)}async writeClipboardBuffer(U,z,x,X){return R.clipboard.writeBuffer(z,Buffer.from(x.buffer),X)}async readClipboardBuffer(U,z){return p.$be.wrap(R.clipboard.readBuffer(z))}async hasClipboard(U,z,x){return R.clipboard.has(z,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,z){this.F(U)?.updateTouchBar(z)}async notifyReady(U){this.F(U)?.setReady()}async relaunch(U,z){return this.f.relaunch(z)}async reload(U,z){const x=this.F(U);if(x){if((0,n.$5h)(x.openedWorkspace)){const X=x.openedWorkspace.configPath;if(X.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(X))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,z?.disableExtensions!==void 0?{_:[],"disable-extensions":z.disableExtensions}:void 0)}}async closeWindow(U){this.closeWindowById(U,U)}async closeWindowById(U,z){return(this.D(z)??this.F(z))?.win?.close()}async quit(U){const z=this.a.getLastActiveWindow();z?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&z.win?z.win.close():this.f.quit()}async exit(U,z){await this.f.kill(z)}async resolveProxy(U,z){return this.F(U)?.win?.webContents?.session?.resolveProxy(z)}findFreePort(U,z,x,X,ae=1){return(0,w.$gg)(z,x,X,ae)}async openDevTools(U,z){this.H(U)?.win?.webContents.openDevTools(z)}async toggleDevTools(U){this.H(U)?.win?.webContents.toggleDevTools()}async sendInputEvent(U,z){const x=this.F(U);x?.win&&(z.type==="mouseDown"||z.type==="mouseUp")&&x.win.webContents.sendInputEvent(z)}async profileRenderer(U,z,x){const X=this.F(U);if(!X||!X.win)throw new Error;return await new C.$k7b(X.win,z,this.h).inspect(x)}async windowsGetStringRegKey(U,z,x,X){if(!b.$j)return;const ae=await new Promise((se,ce)=>{J(["@vscode/windows-registry"],se,ce)});try{return ae.GetStringRegKey(z,x,X)}catch{return}}D(U){return this.F(U)??this.G(U)}F(U){if(typeof U=="number")return this.a.getWindowById(U)}G(U){if(typeof U=="number")return this.b.getWindowById(U)}H(U){let z=this.r.invokeFunction(t.$26b);return z||(z=this.D(U)),z}};e.$m7b=I,Ee([D.$hh],I.prototype,"C",null),e.$m7b=I=Ee([te(0,t.$Z6b),te(1,k.$Y6b),te(2,h.$H6b),te(3,u.$p6b),te(4,l.$n6b),te(5,i.$0i),te(6,a.$pj),te(7,o.$B6b),te(8,r.$R6b),te(9,E.$Oh)],I)}),define(ie[299],ne([0,1,15,38,28,2,13,4,107,180,91,132,59,24,6,69,78,25,79,68,33,34,60,22,7,29,8]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i,a,o,t,n){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$n7b=void 0;const p="issue.processExplorerWindowState";let A=class{static{r=this}static{this.a="#1E1E1E"}constructor(I,j,U,z,x,X,ae,se,ce,Z,Q){this.g=I,this.h=j,this.i=U,this.j=z,this.k=x,this.l=X,this.m=ae,this.n=se,this.o=ce,this.p=Z,this.q=Q,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){R.$qT.on("vscode:listProcesses",async I=>{const j=[];try{j.push({name:(0,c.localize)(0,null),rootProcess:await(0,f.$Cr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,$.$rm)(z)?j.push({name:z.hostName,rootProcess:z}):z.processes&&j.push({name:z.hostName,rootProcess:z.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(I,"vscode:listProcessesResponse",j)}),R.$qT.on("vscode:workbenchCommand",(I,j)=>{const{id:U,from:z,args:x}=j;let X;switch(z){case"processExplorer":X=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}X?.webContents.send("vscode:runAction",{id:U,from:z,args:x})}),R.$qT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),R.$qT.on("vscode:pidToNameRequest",async I=>{const j=await this.k.getMainDiagnostics(),U=[];for(const z of j.windows)U.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:x}of i.$76b.getAll())U.push([z,x]);this.t(I,"vscode:pidToNameResponse",U)})}async openReporter(I){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const j=new O.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,U,{backgroundColor:I.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:w.default}),this.b.loadURL(D.$cg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const j=new O.$Rc,U=j.add(this.n.createIPCObjectUrl()),z=this.p.getItem(p,void 0),x=C(z)?z:this.v(this.f,800,500);this.d=this.u(x,U,{backgroundColor:I.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:w.default}),this.d.loadURL(D.$cg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const X=()=>{if(!this.d)return;const ae=this.d.getSize(),se=this.d.getPosition();if(!ae||!se)return;const ce={width:ae[0],height:ae[1],x:se[0],y:se[1]};this.p.setItem(p,ce)};this.d.on("moved",X),this.d.on("resized",X)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await S.contentTracing.stopRecording(`${(0,E.$6f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,I),buttons:[(0,c.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,j)}async $getSystemInfo(){const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,j)}async $getPerformanceInfo(){try{const[I,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,j)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.b);return I===0}return!1}async $getIssueReporterUri(I){if(!this.c)throw new Error("Issue reporter window not available");const j=this.q.getWindowById(this.c.id);if(!j)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return n.Promises.withAsyncBody(async(z,x)=>{const X=new a.$Xd;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",X.token,{replyChannel:U,extensionId:I}),R.$qT.once(U,(ae,se)=>{z(o.URI.parse(se))});try{await(0,n.$Ug)(5e3),X.cancel(),x(new Error("Timed out waiting for issue reporter URI"))}finally{R.$qT.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,j,...U){I.sender.isDestroyed()||I.sender.send(j,...U)}u(I,j,U,z){const x=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:U.title,backgroundColor:U.backgroundColor||r.a,webPreferences:{preload:D.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.$mC)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return x.setMenuBarVisibility(!1),x}v(I,j,U){let z;const x=S.screen.getAllDisplays();if(x.length===1)z=x[0];else{if(P.$k){const se=S.screen.getCursorScreenPoint();z=S.screen.getDisplayNearestPoint(se)}!z&&I&&(z=S.screen.getDisplayMatching(I.getBounds())),z||(z=S.screen.getPrimaryDisplay()||x[0])}const X=z.bounds,ae={width:j,height:U,x:X.x+X.width/2-j/2,y:X.y+X.height/2-U/2};return X.width>0&&X.height>0&&(ae.x<X.x&&(ae.x=X.x),ae.y<X.y&&(ae.y=X.y),ae.x>X.x+X.width&&(ae.x=X.x),ae.y>X.y+X.height&&(ae.y=X.y),ae.width>X.width&&(ae.width=X.width),ae.height>X.height&&(ae.height=X.height)),ae}};e.$n7b=A,e.$n7b=A=r=Ee([te(1,g.$n6b),te(2,v.$0i),te(3,$.$qm),te(4,b.$06b),te(5,y.$H6b),te(6,m.$l7b),te(7,h.$J6b),te(8,d.$pj),te(9,u.$BN),te(10,t.$Z6b)],A);function C(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(ie[300],ne([0,1,22,18,24,20,6,69,25,50,26,48,100]),function(J,e,S,R,s,O,D,P,f,c,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=void 0;let g=class extends y.$M7b{constructor(m,w,d,h,l,E,u,i){super(m,w,h,l,E,i),this.e=d,this.u=u}s(m){return(0,y.$L7b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(b.$pU.CheckingForUpdates(m)),this.i.request({url:this.a},S.CancellationToken.None).then(c.$Yo).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(b.$pU.Idle(1))):this.d(b.$pU.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w),this.e.publicLog2("update:notAvailable",{explicit:!!m});const d=m?w.message||w:void 0;this.d(b.$pU.Idle(1,d))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(b.$pU.Idle(1))}};e.$O7b=g,e.$O7b=g=Ee([te(0,O.$p6b),te(1,R.$ji),te(2,$.$cl),te(3,s.$n6b),te(4,c.$So),te(5,D.$0i),te(6,P.$l7b),te(7,f.$pj)],g)}),define(ie[301],ne([0,1,47,45,28,8,22,54,9,7,144,21,18,24,16,20,6,69,25,50,26,48,100]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;async function a(r,p=1e3){for(;!r();)await(0,O.$Ug)(p)}let o;function t(){return typeof o>"u"&&(o=R.existsSync(f.$jc(f.$mc(process.execPath),"unins000.exe"))?0:1),o}let n=class extends i.$M7b{get cachePath(){const p=f.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return b.Promises.mkdir(p,{recursive:!0}).then(()=>p)}constructor(p,A,C,k,I,j,U,z,x){super(p,A,k,I,j,x),this.u=C,this.v=U,this.w=z,p.setRelaunchHandler(this)}handleRelaunch(p){return p?.addArgs||p?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$pU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(p){let A=`win32-${process.arch}`;return t()===1?A+="-archive":this.k.target==="user"&&(A+="-user"),(0,i.$L7b)(A,p,this.k)}t(p){this.a&&(this.d(u.$pU.CheckingForUpdates(p)),this.i.request({url:this.a},D.CancellationToken.None).then(l.$Yo).then(A=>{const C=t();return!A||!A.url||!A.version||!A.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!p}),this.d(u.$pU.Idle(C)),Promise.resolve(null)):C===1?(this.d(u.$pU.AvailableForDownload(A)),Promise.resolve(null)):(this.d(u.$pU.Downloading(A)),this.C(A.version).then(()=>this.B(A.version).then(k=>b.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const j=A.url,U=A.hash,z=`${k}.tmp`;return this.i.request({url:j},D.CancellationToken.None).then(x=>this.v.writeFile(c.URI.file(z),x.stream)).then(U?()=>(0,$.$lT)(z,A.hash):()=>{}).then(()=>b.Promises.rename(z,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(u.$pU.Downloaded(A)):this.d(u.$pU.Ready(A))})))}).then(void 0,A=>{this.j.error(A),this.u.publicLog2("update:notAvailable",{explicit:!!p});const C=p?A.message||A:void 0;this.d(u.$pU.Idle(t(),C))}))}async o(p){p.update.url&&this.w.openExternal(void 0,p.update.url),this.d(u.$pU.Idle(t()))}async B(p){const A=await this.cachePath;return f.$jc(A,`CodeSetup-${this.k.quality}-${p}.exe`)}async C(p=null){const A=p?j=>!new RegExp(`${this.k.quality}-${p}\\.exe$`).test(j):()=>!0,C=await this.cachePath,I=(await b.Promises.readdir(C)).filter(A).map(async j=>{try{await b.Promises.unlink(f.$jc(C,j))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const p=this.state.update;this.d(u.$pU.Updating(p));const A=await this.cachePath;this.e.updateFilePath=f.$jc(A,`CodeSetup-${this.k.quality}-${p.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$pU.Idle(t()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((j,U)=>{J(["@vscode/windows-mutex"],j,U)});a(()=>I.isActive(k)).then(()=>this.d(u.$pU.Ready(p)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(p){if(this.state.type!=="idle")return;const A=this.g.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown"};this.d(u.$pU.Downloading(C)),this.e={packagePath:p},A?this.k.target==="user"?this.p():this.d(u.$pU.Downloaded(C)):this.d(u.$pU.Ready(C))}};e.$Q7b=n,Ee([P.$hh],n.prototype,"cachePath",null),e.$Q7b=n=Ee([te(0,m.$p6b),te(1,y.$ji),te(2,E.$cl),te(3,g.$n6b),te(4,l.$So),te(5,w.$0i),te(6,v.$$j),te(7,d.$l7b),te(8,h.$pj)],n)}),define(ie[133],ne([0,1,15,8,22,49,3,2,13,65,4,7,190,63,18,59,24,62,16,20,6,25,79,252,81,26,102,67,68,29,30,53,128,136,39,34,52,66,23,5]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i,a,o,t,n,r,p,A,C,k,I,j,U,z,x,X,ae,se){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=e.$V6b=void 0;var Z;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(Z||(Z={}));class Q extends P.$Sc{focus(W){$.$k&&W?.force&&S.app.focus({steal:!0});const G=this.a();G&&(G.isMinimized()&&G.restore(),G.focus())}}e.$V6b=Q;let K=class extends Q{static{ce=this}static{this.b="windowControlHeight"}get id(){return this.m}get win(){return this.n}a(){return this.n}get lastFocusTime(){return this.s}get backupPath(){return this.t?.backupPath}get openedWorkspace(){return this.t?.workspace}get profile(){if(!this.config)return;const W=this.U.profiles.find(G=>G.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&W?W:this.U.getProfileForWorkspace(this.config.workspace??(0,C.$4h)(this.backupPath,this.isExtensionDevelopmentHost))??this.U.defaultProfile}get remoteAuthority(){return this.t?.remoteAuthority}get config(){return this.t}get isExtensionDevelopmentHost(){return!!this.t?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.t?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.t?.debugId}constructor(W,G,H,Y,re,L,M,F,T,N,B,V,oe,de,ue,he,ve,be,ye,Ie,Te){super(),this.P=G,this.Q=H,this.R=Y,this.S=re,this.U=L,this.W=M,this.X=F,this.Y=T,this.Z=N,this.$=B,this.ab=V,this.bb=oe,this.db=de,this.eb=ue,this.fb=he,this.gb=ve,this.hb=be,this.ib=ye,this.jb=Ie,this.c=this.B(new D.$Nd),this.onWillLoad=this.c.event,this.f=this.B(new D.$Nd),this.onDidSignalReady=this.f.event,this.g=this.B(new D.$Nd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new D.$Nd),this.onDidClose=this.h.event,this.j=this.B(new D.$Nd),this.onDidDestroy=this.j.event,this.s=-1,this.z=void 0,this.C=void 0,this.G=!1,this.H=[],this.I=[],this.J=void 0,this.L=void 0,this.M=this.B(this.hb.createIPCObjectUrl()),this.O=!1,this.lb=0;{const[me,we]=this.vb(W.state);this.u=me,this.P.trace("window#ctor: using window state",me);const _=this.u.mode===0||this.u.mode===3,le=this.Z.getValue("window"),ge=Te.invokeFunction(A.$16b,this.u,{show:!_,webPreferences:{preload:f.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.M.resource.toString()}`],v8CacheOptions:this.R.useCodeCache?"bypassHeatCheck":"none"}});$.$k&&!this.Cb()&&(ge.fullscreenable=!1);const Ae=$.$k&&le?.nativeTabs===!0;Ae&&(ge.tabbingIdentifier=this.gb.nameShort);const De=(0,p.$kC)(this.Z)==="custom";if(De&&(ge.titleBarStyle="hidden",$.$k||(ge.frame=!1),(0,p.$lC)(this.Z))){const Le=this.$.getWindowSplash()?.colorInfo.titleBarBackground??this.$.getBackgroundColor(),Oe=j.$Xs.fromHex(Le).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:Le,symbolColor:Oe},this.G=!0}if((0,c.mark)("code/willCreateCodeBrowserWindow"),this.n=new S.BrowserWindow(ge),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.m=this.n.id,$.$k&&De&&this.n.setSheetOffset(22),De&&($.$j&&(0,p.$lC)(this.Z)||$.$k)){const Le=this.jb.getItem(ce.b);Le&&this.updateWindowControls({height:Le})}$.$j&&De&&this.n.hookWindowMessage(278,()=>{const[Oe,He]=this.n.getPosition(),ze=S.screen.getCursorScreenPoint(),ee=ze.x-Oe,fe=ze.y-He;return(()=>!(ee>30&&fe>=0&&fe<=Math.max(this.n.getBounds().height*.15,35)))()||(this.n.setEnabled(!1),this.n.setEnabled(!0),this.g.fire({x:ee,y:fe})),0}),($.$k||$.$j)&&we&&(!Ae||S.BrowserWindow.getAllWindows().length===1)&&[this.u.width,this.u.height,this.u.x,this.u.y].every(Le=>typeof Le=="number")&&this.n.setBounds({width:this.u.width,height:this.u.height,x:this.u.x,y:this.u.y}),_&&((0,c.mark)("code/willMaximizeCodeWindow"),this.n.maximize(),this.u.mode===3?(this.kb("WindowMode.Fullscreen"),this.yb(!0)):this.kb("WindowMode.Maximized"),this.n.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.s=Date.now()}this.R.args["open-devtools"]===!0&&this.n.webContents.openDevTools(),this.sb(),this.Gb(),this.mb()}kb(W){this.Z.getValue("window.logFullScreenTransitions")&&this.P.info(`window-fullscreen-bug: ${W})`)}setRepresentedFilename(W){$.$k?this.n.setRepresentedFilename(W):this.D=W}getRepresentedFilename(){return $.$k?this.n.getRepresentedFilename():this.D}setDocumentEdited(W){$.$k&&this.n.setDocumentEdited(W),this.F=W}isDocumentEdited(){return $.$k?this.n.isDocumentEdited():!!this.F}setReady(){for(this.P.trace(`window#load: window reported ready (id: ${this.m})`),this.lb=2;this.H.length;)this.H.pop()(this);this.f.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.H.push(W)})}get isReady(){return this.lb===2}get whenClosedOrLoaded(){return new Promise(W=>{function G(){H.dispose(),Y.dispose(),W()}const H=this.onDidClose(()=>G()),Y=this.onWillLoad(()=>G())})}mb(){this.n.on("unresponsive",()=>this.pb(1)),this.n.webContents.on("render-process-gone",(G,H)=>this.pb(2,{...H})),this.n.webContents.on("did-fail-load",(G,H,Y)=>this.pb(3,{reason:Y,exitCode:H})),this.n.webContents.on("will-prevent-unload",G=>{G.preventDefault()}),this.n.on("closed",()=>{this.h.fire(),this.dispose()}),this.n.webContents.on("did-finish-load",()=>{this.N&&(this.t=this.N,this.N=void 0)}),this.n.on("focus",()=>{this.s=Date.now()}),this.n.on("maximize",G=>{this.t&&(this.t.maximized=!0),S.app.emit("browser-window-maximize",G,this.n)}),this.n.on("unmaximize",G=>{this.t&&(this.t.maximized=!1),S.app.emit("browser-window-unmaximize",G,this.n)}),this.n.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.kb(`enter-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.n.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.kb(`leave-full-screen: ${Date.now()}`),this.C?.complete(),this.C=void 0}),this.B(this.Z.onDidChangeConfiguration(G=>this.sb(G))),this.B(this.ab.onDidDeleteUntitledWorkspace(G=>this.rb(G)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.n.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(G,H)=>{const Y=await this.ob();H({cancel:!1,requestHeaders:Object.assign(G.requestHeaders,Y)})})}ob(){return this.nb||(this.nb=(0,a.$ap)(this.gb.version,this.gb,this.R,this.Z,this.W,this.X,this.db)),this.nb}async pb(W,G){switch(W){case 2:this.P.error(`CodeWindow: renderer process gone (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break;case 1:this.P.error("CodeWindow: detected unresponsive");break;case 3:this.P.error(`CodeWindow: failed to load (reason: ${G?.reason||"<unknown>"}, code: ${G?.exitCode||"<unknown>"})`);break}switch(this.db.publicLog2("windowerror",{type:W,reason:G?.reason,code:G?.exitCode}),W){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.fb.kill(1);return}if(this.R.args["enable-smoke-test-driver"]){await this.qb(!1,!1),this.fb.quit();return}if(W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.n&&this.n.webContents&&this.n.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Y}=await this.eb.showMessageBox({type:"warning",buttons:[(0,y.localize)(0,null),(0,y.localize)(1,null),(0,y.localize)(2,null)],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),checkboxLabel:this.t?.workspace?(0,y.localize)(5,null):void 0},this.n);if(H!==2){const re=H===0;await this.qb(re,Y)}}else if(W===2){let H;G?H=(0,y.localize)(7,null,G.reason,G.exitCode??"<unknown>"):H=(0,y.localize)(6,null);const{response:Y,checkboxChecked:re}=await this.eb.showMessageBox({type:"warning",buttons:[this.t?.workspace?(0,y.localize)(8,null):(0,y.localize)(9,null),(0,y.localize)(10,null)],message:H,detail:this.t?.workspace?(0,y.localize)(11,null):(0,y.localize)(12,null),checkboxLabel:this.t?.workspace?(0,y.localize)(13,null):void 0},this.n),L=Y===0;await this.qb(L,re)}break}}async qb(W,G){const H=this.t?.workspace;if(G&&H)try{const Y=this.Y.workspaceStorage(H);await Y.init(),Y.delete("memento/workbench.parts.editor"),await Y.close()}catch(Y){this.P.error(Y)}if(this.j.fire(),this.n?.destroy(),W&&this.t){let Y,re;(0,C.$Zh)(H)?Y={folderUri:H.uri}:(0,C.$5h)(H)?Y={workspaceUri:H.configPath}:re=!0,(0,ae.$Ob)(await this.ib.open({context:5,userEnv:this.t.userEnv,cli:{...this.R.args,_:[]},urisToOpen:Y?[Y]:void 0,forceEmpty:re,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}rb(W){this.t?.workspace?.id===W.id&&(this.t.workspace=void 0)}sb(W){if(!W||W.affectsConfiguration("window.menuBarVisibility")){const G=this.Db();G!==this.w&&(this.w=G,this.Eb(G))}if(!W||W.affectsConfiguration("http.proxy")){let G=(this.Z.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;G?.endsWith("/")&&(G=G.substr(0,G.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((G||"").indexOf("@")===-1&&(G!==this.J||H!==this.L)){this.J=G,this.L=H;const Y=G||"",re=H?`${H},<local>`:"<local>";this.P.trace(`Setting proxy to '${Y}', bypassing '${re}'`),this.n.webContents.session.setProxy({proxyRules:Y,proxyBypassRules:re,pacScript:""})}}}addTabbedWindow(W){$.$k&&W.win&&this.n.addTabbedWindow(W.win)}load(W,G=Object.create(null)){this.P.trace(`window#load: attempt to load window (id: ${this.m})`),this.isDocumentEdited()&&(!G.isReload||!this.bb.isHotExitEnabled())&&this.setDocumentEdited(!1),G.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.n.setTitle(this.gb.nameLong)),this.tb(W,G),this.lb===0?this.t=W:this.N=W,this.lb=1,this.n.loadURL(f.$cg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.R.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.O;this.O=!0,!this.R.isBuilt&&!this.R.extensionTestsLocationURI&&this.B(new R.$6g(()=>{this.n&&!this.n.isVisible()&&!this.n.isMinimized()&&(this.n.show(),this.focus({force:!0}),this.n.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:W.workspace,reason:G.isReload?3:H?2:1})}tb(W,G){const H=(this.t??this.N)?.userEnv;if(H){const Y=(0,d.$Nl)(H)&&!(0,d.$Nl)(W.userEnv),re=this.isExtensionDevelopmentHost;(Y||re)&&(W.userEnv={...H,...W.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),G.disableExtensions!==void 0&&(W["disable-extensions"]=G.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this.n.isMaximized(),W.partsSplash=this.$.getWindowSplash(),(0,c.mark)("code/willOpenNewWindow"),W.perfMarks=(0,c.getMarks)(),this.M.update(W)}async reload(W){const G=Object.assign({},this.t);G.workspace=await this.ub(G),delete G.filesToOpenOrCreate,delete G.filesToDiff,delete G.filesToMerge,delete G.filesToWait,this.isExtensionDevelopmentHost&&W&&(G.verbose=W.verbose,G.debugId=W.debugId,G.extensionEnvironment=W.extensionEnvironment,G["inspect-extensions"]=W["inspect-extensions"],G["inspect-brk-extensions"]=W["inspect-brk-extensions"],G["extensions-dir"]=W["extensions-dir"]),G.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),G.isInitialStartup=!1,G.policiesData=this.S.serialize(),G.continueOn=this.R.continueOn,G.profiles={all:this.U.profiles,profile:this.profile||this.U.defaultProfile,home:this.U.profilesHome},G.logLevel=this.Q.getLogLevel(),G.loggers={window:this.Q.getRegisteredLoggers(this.id),global:this.Q.getRegisteredLoggers()},this.load(G,{isReload:!0,disableExtensions:W?.["disable-extensions"]})}async ub(W){if((0,C.$5h)(W.workspace)){const G=W.workspace.configPath;if(G.scheme===f.Schemas.file&&!await this.W.exists(G))return}else if((0,C.$Zh)(W.workspace)){const G=W.workspace.uri;if(G.scheme===f.Schemas.file&&!await this.W.exists(G))return}return W.workspace}serializeWindowState(){if(!this.n)return(0,I.$m6b)();if(this.isFullScreen){let H;try{H=S.screen.getDisplayMatching(this.getBounds())}catch{}const Y=(0,I.$m6b)();return{mode:3,display:H?H.id:void 0,width:this.u.width||Y.width,height:this.u.height||Y.height,x:this.u.x||0,y:this.u.y||0}}const W=Object.create(null);let G;if(!$.$k&&this.n.isMaximized()?G=0:G=1,G===0?W.mode=0:W.mode=1,G===1||G===0){let H;G===1?H=this.getBounds():H=this.n.getNormalBounds(),W.x=H.x,W.y=H.y,W.width=H.width,W.height=H.height}return W}updateWindowControls(W){if(W.height&&this.jb.setItem(ce.b,W.height),$.$j&&this.G)this.n.setTitleBarOverlay({color:W.backgroundColor?.trim()===""?void 0:W.backgroundColor,symbolColor:W.foregroundColor?.trim()===""?void 0:W.foregroundColor,height:W.height?W.height-1:void 0});else if($.$k&&W.height!==void 0){const G=(W.height-15)/2;G?this.n.setWindowButtonPosition({x:G,y:G}):this.n.setWindowButtonPosition(null)}}vb(W){(0,c.mark)("code/willRestoreCodeWindowState");let G=!1;if(W)try{const H=S.screen.getAllDisplays();G=H.length>1,W=this.wb(W,H)}catch(H){this.P.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,c.mark)("code/didRestoreCodeWindowState"),[W||(0,I.$m6b)(),G]}wb(W,G){if(this.P.trace(`window#validateWindowState: validating window state on ${G.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.P.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.P.trace("window#validateWindowState: unexpected negative values");return}if(G.length===1){const re=this.xb(G[0]);if(re){let L=function(){!W||typeof W.x!="number"||typeof W.y!="number"||!re||(W.x<re.x&&(W.x=re.x),W.y<re.y&&(W.y=re.y))};this.P.trace("window#validateWindowState: 1 monitor working area",re),L(),W.width>re.width&&(W.width=re.width),W.height>re.height&&(W.height=re.height),W.x>re.x+re.width-128&&(W.x=re.x+re.width-W.width),W.y>re.y+re.height-128&&(W.y=re.y+re.height-W.height),L()}return W}if(W.display&&W.mode===3){const re=G.find(L=>L.id===W.display);if(re&&typeof re.bounds?.x=="number"&&typeof re.bounds?.y=="number"){this.P.trace("window#validateWindowState: restoring fullscreen to previous display");const L=(0,I.$m6b)(3);return L.x=re.bounds.x,L.y=re.bounds.y,L}}let H,Y;try{H=S.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),Y=this.xb(H)}catch{}if(H&&Y&&W.x+W.width>Y.x&&W.y+W.height>Y.y&&W.x<Y.x+Y.width&&W.y<Y.y+Y.height)return this.P.trace("window#validateWindowState: multi-monitor working area",Y),W}xb(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,G]=this.n.getPosition(),[H,Y]=this.n.getSize();return{x:W,y:G,width:H,height:Y}}toggleFullScreen(){this.yb(!this.isFullScreen)}yb(W){this.Cb()?this.zb(W):this.Bb(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.w&&this.Eb(this.w,!1)}get isFullScreen(){if(this.kb(`isFullScreen(): begin at ${Date.now()}`),$.$k&&typeof this.z=="boolean")return this.kb(`isFullScreen(): returning transientIsNativeFullScreen = ${this.z}`),this.z;const W=this.n.isFullScreen(),G=this.n.isSimpleFullScreen();return this.kb(`isFullScreen(): returning natively, isFullScreen = ${W}, isSimpleFullScreen = ${G}`),W||G}zb(W){this.n.isSimpleFullScreen()&&this.n.setSimpleFullScreen(!1),this.Ab(W)}Ab(W){$.$k&&(this.kb(`doSetNativeFullScreen(${W}): begin at ${Date.now()}`),this.z=W,this.C=new R.$ch,Promise.race([this.C.p,(0,R.$Ug)(1e3)]).finally(()=>{this.kb(`doSetNativeFullScreen(${W}): finish at ${Date.now()}`),this.z=void 0})),this.n.setFullScreen(W)}Bb(W){this.n.isFullScreen()&&this.Ab(!1),this.n.setSimpleFullScreen(W),this.n.webContents.focus()}Cb(){const W=this.Z.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this.n.isMinimized()}Db(){let W=(0,p.$jC)(this.Z);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}Eb(W,G=!0){$.$k||(W==="toggle"&&G&&this.send("vscode:showInfoMessage",(0,y.localize)(14,null)),W==="hidden"?setTimeout(()=>{this.Fb(W)}):this.Fb(W))}Fb(W){const G=this.isFullScreen;switch(W){case"classic":this.n.setMenuBarVisibility(!G),this.n.autoHideMenuBar=G;break;case"visible":this.n.setMenuBarVisibility(!0),this.n.autoHideMenuBar=!1;break;case"toggle":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!0;break;case"hidden":this.n.setMenuBarVisibility(!1),this.n.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if($.$k)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.n.minimize();break;case"None":break;case"Maximize":default:this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}else this.n.isMaximized()?this.n.unmaximize():this.n.maximize()}close(){this.n?.close()}sendWhenReady(W,G,...H){this.isReady?this.send(W,...H):this.ready().then(()=>{G.isCancellationRequested||this.send(W,...H)})}send(W,...G){if(this.n){if(this.n.isDestroyed()||this.n.webContents.isDestroyed()){this.P.warn(`Sending IPC message to channel '${W}' for window that is destroyed`);return}try{this.n.webContents.send(W,...G)}catch(H){this.P.warn(`Error sending IPC message to channel '${W}' of window ${this.m}: ${(0,O.$Ai)(H)}`)}}}updateTouchBar(W){$.$k&&this.I.forEach((G,H)=>{const Y=W[H];G.segments=this.Ib(Y)})}Gb(){if($.$k){for(let W=0;W<10;W++){const G=this.Hb();this.I.push(G)}this.n.setTouchBar(new S.TouchBar({items:this.I}))}}Hb(W=[]){const G=this.Ib(W),H=new S.TouchBar.TouchBarSegmentedControl({segments:G,mode:"buttons",segmentStyle:"automatic",change:Y=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[Y].id,from:"touchbar"})}});return H}Ib(W=[]){return W.map(H=>{let Y;H.icon&&!n.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(Y=S.nativeImage.createFromPath(b.URI.revive(H.icon.dark).fsPath),Y.isEmpty()&&(Y=void 0));let re;return typeof H.title=="string"?re=H.title:re=H.title.value,{id:H.id,label:Y?void 0:re,icon:Y}})}dispose(){super.dispose(),this.Q.deregisterLoggers(this.id),this.n=null}};e.$W6b=K,e.$W6b=K=ce=Ee([te(1,E.$0i),te(2,X.$T6b),te(3,w.$n6b),te(4,U.$in),te(5,x.$v6b),te(6,h.$$j),te(7,o.$z6b),te(8,o.$x6b),te(9,v.$ji),te(10,r.$B6b),te(11,k.$R6b),te(12,g.$G6b),te(13,t.$cl),te(14,m.$H6b),te(15,l.$p6b),te(16,u.$pj),te(17,i.$J6b),te(18,A.$Z6b),te(19,z.$BN),te(20,se.$Oh)],K)}),define(ie[302],ne([0,1,15,3,24,133]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;let D=class extends O.$V6b{get win(){if(!this.c){const f=S.BrowserWindow.fromWebContents(this.h);f&&(this.c=f,this.n(f))}return this.c}a(){return this.win}get lastFocusTime(){return this.g}constructor(f,c){super(),this.h=f,this.j=c,this.id=this.h.id,this.b=this.B(new R.$Nd),this.onDidClose=this.b.event,this.c=null,this.g=Date.now(),this.m()}m(){this.j.args["open-devtools"]===!0&&this.h.openDevTools({mode:"bottom"})}n(f){f.on("closed",()=>{this.b.fire(),this.dispose()}),f.on("focus",()=>{this.g=Date.now()})}dispose(){super.dispose(),this.c=null}};e.$X6b=D,e.$X6b=D=Ee([te(1,s.$n6b)],D)}),define(ie[303],ne([0,1,15,3,13,302,5,29]),function(J,e,S,R,s,O,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=void 0;let f=class{constructor($){this.b=$,this.a=new Map}createWindow(){return this.b.invokeFunction(P.$16b,void 0,{webPreferences:{preload:s.$cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-slim.js").fsPath}})}registerWindow($){const b=this.b.createInstance(O.$X6b,$);this.a.set(b.id,b),R.Event.once(b.onDidClose)(()=>this.a.delete(b.id))}getWindowById($){return this.a.get($)}getFocusedWindow(){const $=S.BrowserWindow.getFocusedWindow();if($)return this.getWindowById($.id)}getLastActiveWindow(){return(0,P.$36b)(Array.from(this.a.values()))}};e.$j8b=f,e.$j8b=f=Ee([te(0,D.$Oh)],f)}),define(ie[82],ne([0,1,15,23,8,3,46,2,13,4,19,7,21,193,5,20,6,81,97,30,53,31]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=e.$x7b=void 0,e.$x7b=(0,v.$Ph)("workspacesHistoryMainService");let a=class extends P.$Sc{static{i=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(t,n,r,p){super(),this.f=t,this.g=n,this.h=r,this.j=p,this.c=this.B(new O.$Nd),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Rg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(t=>this.addRecentlyOpened([{workspace:t.workspace,remoteAuthority:t.window.remoteAuthority}])))}async addRecentlyOpened(t){let n=[],r=[];for(const A of t)if((0,h.$OU)(A))!this.g.isUntitledWorkspace(A.workspace)&&!this.u(n,A.workspace)&&n.push(A);else if((0,h.$PU)(A))this.w(n,A.folderUri)||n.push(A);else{const C=this.y(r,A.fileUri),k=A.fileUri.scheme===f.Schemas.file&&i.F.indexOf((0,$.$sg)(A.fileUri))>=0;!C&&!k&&(r.push(A),c.$j&&A.fileUri.scheme===f.Schemas.file&&S.app.addRecentDocument(A.fileUri.fsPath))}const p=await this.n({workspaces:n,files:r});n=p.workspaces,r=p.files,n.length>i.a&&(n.length=i.a),r.length>i.a&&(r.length=i.a),await this.s({workspaces:n,files:r}),this.c.fire(),c.$k&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(t){const n=C=>{const k=this.t(C);for(const I of t)if($.$mg.isEqual(I,k))return!1;return!0},r=await this.getRecentlyOpened(),p=r.workspaces.filter(n),A=r.files.filter(n);(p.length!==r.workspaces.length||A.length!==r.files.length)&&(await this.s({files:A,workspaces:p}),this.c.fire(),c.$k&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(t){const n=new u.$Ac(A=>$.$mg.getComparisonKey(A));if(t?.workspaces)for(const A of t.workspaces)n.set(this.t(A),A);const r=new u.$Ac(A=>$.$mg.getComparisonKey(A));if(t?.files)for(const A of t.files)r.set(this.t(A),A);const p=await this.r();for(const A of p.workspaces){const C=n.get(this.t(A));C?C.label=C.label??A.label:n.set(this.t(A),A)}for(const A of p.files){const C=r.get(this.t(A));C?C.label=C.label??A.label:r.set(this.t(A),A)}return{workspaces:[...n.values()],files:[...r.values()]}}async r(){await this.j.whenReady;let t;const n=this.j.get(i.b,-1);if(typeof n=="string")try{t=JSON.parse(n)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,h.$VU)(t,this.f)}async s(t){await this.j.whenReady,this.j.store(i.b,JSON.stringify((0,h.$WU)(t)),-1,1)}t(t){return(0,h.$PU)(t)?t.folderUri:(0,h.$QU)(t)?t.fileUri:t.workspace.configPath}u(t,n){return!!t.find(r=>(0,h.$OU)(r)&&r.workspace.id===n.id)}w(t,n){return!!t.find(r=>(0,h.$PU)(r)&&$.$mg.isEqual(r.folderUri,n))}y(t,n){return!!t.find(r=>$.$mg.isEqual(r.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){c.$j&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!c.$j)return;const t=[];if(t.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const A of S.app.getJumpListSettings().removedItems){const C=A.args;if(C){const k=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);k&&n.push(b.URI.parse(k[2]))}}await this.removeRecentlyOpened(n);let r=!1;const p=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,i.D).map(A=>{const C=(0,h.$OU)(A)?A.workspace:A.folderUri,{title:k,description:I}=this.J(C,A.label);let j;return b.URI.isUri(C)?j=`--folder-uri "${C.toString()}"`:(r=!0,j=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:k.substr(0,255),description:I.substr(0,255),program:process.execPath,args:j,iconPath:"explorer.exe",iconIndex:0}}));p.length>0&&t.push({type:"custom",name:r?(0,g.localize)(2,null):(0,g.localize)(3,null),items:p})}t.push({type:"recent"});try{const n=S.app.setJumpList(t);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(t,n){if(n)return{title:(0,D.$Av)(n).name,description:n};if(b.URI.isUri(t))return{title:(0,$.$sg)(t),description:this.L(t)};if(this.g.isUntitledWorkspace(t))return{title:(0,g.localize)(4,null),description:""};let r=(0,$.$sg)(t.configPath);return r.endsWith(l.$_h)&&(r=r.substr(0,r.length-l.$_h.length-1)),{title:(0,g.localize)(5,null,r),description:this.L(t.configPath)}}L(t){return t.scheme==="file"?(0,D.$sv)(t.fsPath):t.toString()}async M(){if(!c.$k)return;S.app.clearRecentDocuments();const t=await this.getRecentlyOpened(),n=[];let r=0;for(let A=0;A<t.workspaces.length&&r<i.z;A++){const C=this.t(t.workspaces[A]);if(C.scheme===f.Schemas.file){const k=(0,$.$jg)(C);await y.Promises.exists(k)&&(n.push(k),r++)}}const p=[];for(let A=0;A<t.files.length&&r<i.C;A++){const C=this.t(t.files[A]);if(C.scheme===f.Schemas.file){const k=(0,$.$jg)(C);if(i.F.includes((0,$.$sg)(C))||n.includes(k))continue;await y.Promises.exists(k)&&(p.push(k),r++)}}p.reverse().forEach(A=>S.app.addRecentDocument(A)),n.reverse().forEach(A=>S.app.addRecentDocument(A))}};e.$y7b=a,e.$y7b=a=i=Ee([te(0,w.$0i),te(1,E.$R6b),te(2,m.$p6b),te(3,d.$z6b)],a)}),define(ie[304],ne([0,1,15,8,22,46,4,7,181,18,24,20,6,231,69,25,34,26,48,68,29,82]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;const a="menu";let o=class{static{i=this}static{this.a="lastKnownMenubarData"}constructor(r,p,A,C,k,I,j,U,z,x,X){this.n=r,this.o=p,this.p=A,this.q=C,this.r=k,this.s=I,this.t=j,this.u=U,this.v=z,this.w=x,this.x=X,this.m=Object.create(null),this.g=new R.$6g(()=>this.E(),0),this.h=new R.$6g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$k||(0,l.$kC)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(i.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(I,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.newWindow"]=(I,j,U)=>this.p.openEmptyWindow({context:2,contextWindowId:j?.id}),this.m["workbench.action.files.openFileFolder"]=(I,j,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.files.openFolder"]=(I,j,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.openWorkspace"]=(I,j,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:a}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.youTubeUrl;r&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(r,"openYouTubeUrl"));const p=this.x.requestFeatureUrl;p&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(p,"openUserVoiceUrl"));const A=this.x.reportIssueUrl;A&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(A,"openReportIssues"));const C=this.x.licenseUrl;C&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const I=C.indexOf("?")>0?"&":"?";this.Z(`${C}${I}lang=${D.$w}`,"openLicenseUrl")}else this.Z(C,"openLicenseUrl")});const k=this.x.privacyStatementUrl;k&&C&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(k,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!D.$k)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,p){this.k=r.menus,this.l=r.keybindings,this.t.setItem(i.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){D.$k&&(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){D.$k&&(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=S.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(D.$k?new S.Menu:null);return}const p=new S.Menu;let A;if(D.$k){const k=new S.Menu;A=new S.MenuItem({label:this.x.nameShort,submenu:k}),this.I(k),p.append(A)}if(D.$k&&!this.c){this.c=!0;const k=new S.Menu;k.append(new S.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(k)}if(this.K("File")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(1,null)),submenu:k});this.M(k,"File"),p.append(I)}if(this.K("Edit")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(2,null)),submenu:k});this.M(k,"Edit"),p.append(I)}if(this.K("Selection")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(3,null)),submenu:k});this.M(k,"Selection"),p.append(I)}if(this.K("View")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(4,null)),submenu:k});this.M(k,"View"),p.append(I)}if(this.K("Go")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(5,null)),submenu:k});this.M(k,"Go"),p.append(I)}if(this.K("Run")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(6,null)),submenu:k});this.M(k,"Run"),p.append(I)}if(this.K("Terminal")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(7,null)),submenu:k});this.M(k,"Terminal"),p.append(I)}let C;if(this.K("Window")){const k=new S.Menu;C=new S.MenuItem({label:this.ab(f.localize(8,null)),submenu:k,role:"window"}),this.S(k)}if(C&&p.append(C),this.K("Help")){const k=new S.Menu,I=new S.MenuItem({label:this.ab(f.localize(9,null)),submenu:k,role:"help"});this.M(k,"Help"),p.append(I)}p.items&&p.items.length>0?S.Menu.setApplicationMenu(p):S.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const p=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),A=this.T();let C;if(this.K("Preferences")){const ae=new S.Menu;this.M(ae,"Preferences"),C=new S.MenuItem({label:this.ab(f.localize(11,null)),submenu:ae})}const k=new S.Menu,I=new S.MenuItem({label:f.localize(12,null),role:"services",submenu:k}),j=new S.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new S.MenuItem({label:f.localize(15,null),role:"unhide"}),x=new S.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ae,se,ce)=>{const Z=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||Z?.isMinimized())&&await this.J(ce)&&this.w.quit(void 0)}})),X=[p];X.push(...A),C&&X.push(t(),C),X.push(t(),I,t(),j,U,z,t(),x),X.forEach(ae=>r.append(ae))}async J(r){if(this.p.getWindowCount()===0)return!0;const p=this.o.getValue("window.confirmBeforeClose");if(p==="always"||p==="keyboardOnly"&&this.Q(r)){const{response:A}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return A===0}return!0}K(r){if(!D.$k&&(0,l.$kC)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(D.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(D.$k)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,p){p.forEach(A=>{if((0,g.$u7b)(A))r.append(t());else if((0,g.$t7b)(A)){const C=new S.Menu,k=new S.MenuItem({label:this.ab(A.label),submenu:C});this.L(C,A.submenu.items),r.append(k)}else(0,g.$v7b)(A)?r.append(this.O(A)):(0,g.$w7b)(A)&&(A.id==="workbench.action.showAboutDialog"&&this.N(r),D.$k?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[A.id]?r.append(new S.MenuItem(this.Y(A.id,{label:this.ab(A.label),click:this.m[A.id]}))):r.append(this.U(A.label,A.id,!1,A.checked)):r.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)):r.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)))})}M(r,p){this.k&&this.k[p]&&this.L(r,this.k[p].items)}N(r){const p=this.T();p.length&&(p.forEach(A=>r.append(A)),r.append(t()))}O(r){const p=P.URI.revive(r.uri),A=r.id,C=A==="openRecentFile"?{fileUri:p}:A==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new S.MenuItem(this.Y(A,{label:r.label,click:async(k,I,j)=>{const U=this.P(j);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[C],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([p])}},!1))}P(r){return!!(r&&(!D.$k&&(r.ctrlKey||r.shiftKey)||D.$k&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,p,A){const C={label:this.ab(r),role:A,enabled:!0};return new S.MenuItem(this.X(p,C))}S(r){const p=new S.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),A=new S.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),C=new S.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),k=this.U(f.localize(23,null),"workbench.action.switchWindow"),I=[];this.C&&(I.push(t()),I.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),I.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),I.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),I.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),I.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,A,t(),k,...I,t(),C].forEach(j=>r.append(j))}T(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(r,p,A,C){const k=this.ab(r),I=typeof p=="function"?p:(X,ae,se)=>{const ce=X?X.userSettingsLabel:null;let Z=p;Array.isArray(p)&&(Z=this.P(se)?p[1]:p[0]),ce&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ce}):this.W({type:"commandId",commandId:Z})},j=typeof A=="boolean"?A:this.p.getWindowCount()>0,U=typeof C=="boolean"?C:!1,z={label:k,click:I,enabled:j};U&&(z.type="checkbox",z.checked=U);let x;return typeof p=="string"?x=p:Array.isArray(p)&&(x=p[0]),D.$k&&(x==="editor.action.clipboardCutAction"?z.role="cut":x==="editor.action.clipboardCopyAction"?z.role="copy":x==="editor.action.clipboardPasteAction"&&(z.role="paste"),x==="undo"?z.click=this.V(I,{inDevTools:X=>X.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?z.click=this.V(I,{inDevTools:X=>X.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(z.click=this.V(I,{inDevTools:X=>X.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(x,z))}V(r,p){return(A,C,k)=>{const I=S.BrowserWindow.getFocusedWindow();if(!I)return p.inNoWindow();if(I.webContents.isDevToolsFocused()&&I.webContents.devToolsWebContents)return p.inDevTools(I.webContents.devToolsWebContents);r(A,C||I,k)}}W(r){let p=S.BrowserWindow.getFocusedWindow();if(!p){const C=this.p.getLastActiveWindow();C?.isMinimized()&&(p=C.win)}const A=p?this.p.getWindowById(p.id):void 0;if(A){if(this.v.trace("menubar#runActionInRenderer",r),D.$k&&!this.q.isBuilt&&!A.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const C={id:r.commandId,from:"menu"};A.sendWhenReady("vscode:runAction",s.CancellationToken.None,C)}else{const C={userSettingsLabel:r.userSettingsLabel};A.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,C)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,p){const A=typeof r=="string"?this.l[r]:void 0;if(A?.label){if(A.isNative!==!1)p.accelerator=A.label,p.userSettingsLabel=A.userSettingsLabel;else if(typeof p.label=="string"){const C=p.label.indexOf("[");C>=0?p.label=`${p.label.substr(0,C)} [${A.label}]`:p.label=`${p.label} [${A.label}]`}}else p.accelerator=void 0;return p}Y(r,p,A=!p.accelerator){A&&(p=this.X(r,p));const C=p.click;return p.click=(k,I,j)=>{this.$(r),C?.(k,I,j)},p}Z(r,p){this.w.openExternal(void 0,r),this.$(p)}$(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:a})}ab(r){return(0,O.$xv)(r,!this.B)}};e.$z7b=o,e.$z7b=o=i=Ee([te(0,h.$qU),te(1,c.$ji),te(2,E.$Z6b),te(3,$.$n6b),te(4,d.$cl),te(5,u.$x7b),te(6,w.$BN),te(7,b.$p6b),te(8,y.$0i),te(9,v.$l7b),te(10,m.$pj)],o);function t(){return new S.MenuItem({type:"separator"})}}),define(ie[305],ne([0,1,5,20,6,304]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=e.$A7b=void 0,e.$A7b=(0,S.$Ph)("menubarMainService");let D=class{constructor(f,c,$){this.b=f,this.c=c,this.d=$,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(O.$z7b)}async updateMenubar(f,c){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(c,f)}};e.$B7b=D,e.$B7b=D=Ee([te(0,S.$Oh),te(1,R.$p6b),te(2,s.$0i)],D)}),define(ie[306],ne([0,1,15,21,131,28,23,22,3,33,46,2,13,9,65,4,35,19,12,7,191,63,18,59,24,16,5,20,6,78,79,58,34,68,133,29,130,298,30,98,82,53,67,39,52,66]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i,a,o,t,n,r,p,A,C,k,I,j,U,z,x,X,ae,se,ce,Z,Q,K,q,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;function G(re){return(0,ae.$5h)(re?.workspace)}function H(re){return(0,ae.$Zh)(re?.workspace)}let Y=class extends b.$Sc{constructor(L,M,F,T,N,B,V,oe,de,ue,he,ve,be,ye,Ie,Te,me,we,_){super(),this.m=L,this.n=M,this.r=F,this.s=T,this.t=N,this.u=B,this.w=V,this.z=oe,this.C=de,this.D=ue,this.F=he,this.G=ve,this.H=be,this.I=ye,this.J=Ie,this.L=Te,this.M=me,this.N=we,this.O=_,this.a=this.B(new f.$Nd),this.onDidOpenWindow=this.a.event,this.b=this.B(new f.$Nd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new f.$Nd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new f.$Nd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new f.$Nd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new X.$Y7b(this,this.u,this.D,this.s,this.G)),this.P()}P(){this.B(this.I.onDidEnterWorkspace(L=>this.b.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const M=new b.$Rc;if(M.add(f.Event.any(L.onDidClose,L.onDidDestroy)(()=>M.dispose())),L.config.extensionDevelopmentPath)for(const F of L.config.extensionDevelopmentPath)M.add(this.N.addValidFileRoot(F));L.config.extensionTestsPath&&M.add(this.N.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,M){const F=this.z.args,T=M?.remoteAuthority||void 0,N=!0,B=M?.forceReuseWindow,V=!B;return this.open({...L,cli:F,forceEmpty:N,forceNewWindow:V,forceReuseWindow:B,remoteAuthority:T})}openExistingWindow(L,M){L.focus(),this.Q(M,[L])}async open(L){this.s.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const M=[],F=[],T=[],N=[],B=[];let V,oe=0;const de=await this.Y(L);this.s.trace("windowsManager#open pathsToOpen",de);for(const ye of de)H(ye)?L.addMode?M.push(ye):F.push(ye):G(ye)?T.push(ye):ye.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),V.filesToOpenOrCreate.push(ye)):ye.backupPath?B.push({backupFolder:(0,g.$nc)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):oe++;L.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),L.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&L.waitMarkerFileURI&&(V.filesToWait={paths:(0,D.$Hb)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(N.push(...this.I.getUntitledWorkspaces()),T.push(...N),B.push(...this.F.getEmptyWindowBackups())):B.length=0;const{windows:ue,filesOpenedInWindow:he}=await this.R(L,T,F,B,oe,V,M);if(this.s.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${F.length}, emptyToRestore: ${B.length}, emptyToOpen: ${oe})`),ue.length>1)if(he)he.focus();else{const ye=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ie=!0,Te=!0;if(ye){const me=ue.filter(we=>this.j.state.lastActiveWindow&&we.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ie=!1,Te=!1)}if(Ie)for(let me=ue.length-1;me>=0;me--){const we=ue[me];if(!(we.openedWorkspace&&N.some(_=>we.openedWorkspace&&_.workspace.id===we.openedWorkspace.id)||we.backupPath&&B.some(_=>we.backupPath&&_.backupFolder===(0,g.$nc)(we.backupPath)))){we.focus(),Te=!1;break}}Te&&ue[ue.length-1].focus()}const ve=V&&V.filesToDiff.length>0,be=V&&V.filesToMerge.length>0;if(!ue.some(ye=>ye.isExtensionDevelopmentHost)&&!ve&&!be&&!L.noRecentEntry){const ye=[];for(const Ie of de)G(Ie)&&!Ie.transient?ye.push({label:Ie.label,workspace:Ie.workspace,remoteAuthority:Ie.remoteAuthority}):H(Ie)?ye.push({label:Ie.label,folderUri:Ie.workspace.uri,remoteAuthority:Ie.remoteAuthority}):Ie.fileUri&&ye.push({label:Ie.label,fileUri:Ie.fileUri,remoteAuthority:Ie.remoteAuthority});this.H.addRecentlyOpened(ye)}return this.Q(L,ue),ue}Q(L,M){const F=L.waitMarkerFileURI;L.context===0&&F&&M.length===1&&M[0]&&(async()=>{await M[0].whenClosedOrLoaded;try{await this.M.del(F)}catch{}})()}async R(L,M,F,T,N,B,V){const oe=[];let de;function ue(me,we){oe.push(me),we&&(de=me,B=void 0)}let{openFolderInNewWindow:he,openFilesInNewWindow:ve}=this.jb(L);if(!L.initialStartup&&V.length>0){const me=V[0].remoteAuthority,we=this.ob(me);we&&ue(this.U(we,V.map(_=>_.workspace.uri)))}const be=F.length+M.length+T.length;if(B&&be===0){const me=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],we=this.getWindows().filter(le=>B&&(0,d.$Ag)(le.remoteAuthority,B.remoteAuthority));let _;me?.fileUri&&!ve&&((L.context===4||L.context===0||L.context===1)&&(_=await(0,x.$K6b)(we,me.fileUri,async le=>le.configPath.scheme===y.Schemas.file?this.I.resolveLocalWorkspace(le.configPath):void 0)),_||(_=this.pb(we))),_?(0,ae.$5h)(_.openedWorkspace)?M.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):(0,ae.$Zh)(_.openedWorkspace)?F.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):ue(this.S(L,_,B),!0):ue(await this.kb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const ye=(0,D.$Mb)(M,me=>me.workspace.id);if(ye.length>0){const me=(0,D.$Hb)(ye.map(we=>(0,x.$L6b)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],_=(0,d.$Ag)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;ue(this.S(L,we,_),!!_),he=!0}for(const we of ye){if(me.some(ge=>ge.openedWorkspace&&ge.openedWorkspace.id===we.workspace.id))continue;const _=we.remoteAuthority,le=(0,d.$Ag)(B?.remoteAuthority,_)?B:void 0;ue(await this.X(L,we,he,le),!!le),he=!0}}const Ie=(0,D.$Mb)(F,me=>d.$mg.getComparisonKey(me.workspace.uri));if(Ie.length>0){const me=(0,D.$Hb)(Ie.map(we=>(0,x.$L6b)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],_=(0,d.$Ag)(B?.remoteAuthority,we.remoteAuthority)?B:void 0;ue(this.S(L,we,_),!!_),he=!0}for(const we of Ie){if(me.some(ge=>(0,ae.$Zh)(ge.openedWorkspace)&&d.$mg.isEqual(ge.openedWorkspace.uri,we.workspace.uri)))continue;const _=we.remoteAuthority,le=(0,d.$Ag)(B?.remoteAuthority,_)?B:void 0;ue(await this.X(L,we,he,le),!!le),he=!0}}const Te=(0,D.$Mb)(T,me=>me.backupFolder);if(Te.length>0)for(const me of Te){const we=me.remoteAuthority,_=(0,d.$Ag)(B?.remoteAuthority,we)?B:void 0;ue(await this.W(L,!0,we,_,me),!!_),he=!0}if(oe.length===0||B){B&&!N&&N++;const me=B?B.remoteAuthority:L.remoteAuthority;for(let we=0;we<N;we++)ue(await this.W(L,he,me,B),!!B),he=!0}return{windows:(0,D.$Mb)(oe),filesOpenedInWindow:de}}S(L,M,F){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),M.focus();const T={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return M.sendWhenReady("vscode:openFiles",P.CancellationToken.None,T),M}U(L,M){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:M}),L.focus();const F={foldersToAdd:M};return L.sendWhenReady("vscode:addFolders",P.CancellationToken.None,F),L}W(L,M,F,T,N){this.s.trace("windowsManager#doOpenEmpty",{restore:!!N,remoteAuthority:F,filesToOpen:T,forceNewWindow:M});let B;return!M&&typeof L.contextWindowId=="number"&&(B=this.getWindowById(L.contextWindowId)),this.kb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:F,forceNewWindow:M,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:T,windowToUse:B,emptyWindowBackupInfo:N,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}X(L,M,F,T,N){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:M,filesToOpen:T}),!F&&!N&&typeof L.contextWindowId=="number"&&(N=this.getWindowById(L.contextWindowId)),this.kb({workspace:M.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:M.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:T,windowToUse:N,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async Y(L){let M,F=!1,T=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(M=await this.Z(L),F=!0):L.forceEmpty?M=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(M=await this.$(L.cli),M.length===0&&M.push(Object.create(null)),F=!0):(M=await this.bb(),M.length===0&&M.push(Object.create(null)),T=!0),!L.addMode&&F){const N=M.filter(B=>H(B));if(N.length>1){const B=N[0].remoteAuthority;if(N.every(V=>(0,d.$Ag)(V.remoteAuthority,B))){const V=await this.I.createUntitledWorkspace(N.map(oe=>({uri:oe.workspace.uri})));M.push({workspace:V,remoteAuthority:B}),M=M.filter(oe=>!H(oe))}}}if(L.initialStartup&&!T&&this.G.getValue("window")?.restoreWindows==="preserve"){const N=await this.bb();M.unshift(...N.filter(B=>G(B)||H(B)||B.backupPath))}return M}async Z(L){const M={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},F=await Promise.all((0,D.$Hb)(L.urisToOpen||[]).map(async T=>{const N=await this.db(T,M);if(N)return N.label=T.label,N;const B=this.fb(T);this.L.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:B.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:B.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,$.$rv)(B,{os:m.OS,tildify:this.z})):(0,E.localize)(4,null,B.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(F)}async $(L){const M=[],F={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},T=L["folder-uri"];if(T){const V=await Promise.all(T.map(oe=>{const de=this.ab(oe);if(de)return this.db({folderUri:de},F)}));M.push(...(0,D.$Hb)(V))}const N=L["file-uri"];if(N){const V=await Promise.all(N.map(oe=>{const de=this.ab(oe);if(de)return this.db((0,ae.$ii)(oe)?{workspaceUri:de}:{fileUri:de},F)}));M.push(...(0,D.$Hb)(V))}const B=await Promise.all(L._.map(V=>F.remoteAuthority?this.ib(V,F):this.gb(V,F)));return M.push(...(0,D.$Hb)(B)),M}ab(L){try{const M=l.URI.parse(L);if(!M.scheme){this.s.error(`Invalid URI input string, scheme missing: ${L}`);return}return M.path?M:M.with({path:"/"})}catch(M){this.s.error(`Invalid URI input string: ${L}, ${M.message}`)}}async bb(){const L=this.cb();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const M=[];L!=="one"&&M.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&M.push(this.j.state.lastActiveWindow);const F=await Promise.all(M.map(async T=>{if(T.workspace){const N=await this.db({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});if(G(N))return N}else if(T.folderUri){const N=await this.db({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});if(H(N))return N}else if(L!=="folders"&&T.backupPath)return{backupPath:T.backupPath,remoteAuthority:T.remoteAuthority}}));return(0,D.$Hb)(F)}}}cb(){let L;return this.D.wasRestarted?L="all":(L=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async db(L,M=Object.create(null)){const F=this.fb(L);return F.scheme===y.Schemas.file?((0,j.$iC)(L)&&(M={...M,forceOpenWorkspaceAsFile:!0}),this.gb(F.fsPath,M)):this.eb(L,M)}eb(L,M){let F=this.fb(L);const T=(0,k.$Uk)(F)||M.remoteAuthority;if(F=(0,d.$Cg)((0,d.$wg)(F)),(0,j.$iC)(L)){if(M.gotoLineMode){const{path:N,line:B,column:V}=(0,c.$5f)(F.path);return{fileUri:F.with({path:N}),options:{selection:B?{startLineNumber:B,startColumn:V||1}:void 0},remoteAuthority:T}}return{fileUri:F,remoteAuthority:T}}else if((0,j.$gC)(L))return{workspace:(0,se.$O6b)(F),remoteAuthority:T};return{workspace:(0,se.$P6b)(F),remoteAuthority:T}}fb(L){return(0,j.$gC)(L)?L.workspaceUri:(0,j.$hC)(L)?L.folderUri:L.fileUri}async gb(L,M,F){let T,N;M.gotoLineMode&&({path:L,line:T,column:N}=(0,c.$5f)(L)),L=(0,c.$Zf)((0,g.$hc)(L),(0,w.cwd)());try{const B=await R.Promises.stat(L);if(B.isFile()){if(!M.forceOpenWorkspaceAsFile){const V=await this.I.resolveLocalWorkspace(l.URI.file(L));if(V)return V.transient&&M.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:t.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:l.URI.file(L),type:t.FileType.File,exists:!0,options:{selection:T?{startLineNumber:T,startColumn:N||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,se.$P6b)(l.URI.file(L),B),type:t.FileType.Directory,exists:!0};if(!m.$j&&L==="/dev/null")return{fileUri:l.URI.file(L),type:t.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!F)return this.hb(L,M);const V=l.URI.file(L);if(this.H.removeRecentlyOpened([V]),M.ignoreFileNotFound)return{fileUri:V,type:t.FileType.File,exists:!1}}}async hb(L,M){const F=l.URI.file(L),{response:T,checkboxChecked:N}=await this.L.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,F.authority),detail:(0,E.localize)(9,null,(0,$.$rv)(F,{os:m.OS,tildify:this.z})),checkboxLabel:(0,E.localize)(10,null,F.authority),cancelId:1});if(T===0){if((0,s.addUNCHostToAllowlist)(F.authority),N){const B={channel:"vscode:configureAllowedUNCHost",args:F.authority};this.sendToFocused(B.channel,B.args),this.sendToOpeningWindow(B.channel,B.args)}return this.gb(L,M,!0)}if(T===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.hb(L,M)}ib(L,M){const F=L.charCodeAt(0),T=M.remoteAuthority;let N,B;M.gotoLineMode&&({path:L,line:N,column:B}=(0,c.$5f)(L)),F!==47&&((0,c.$Yf)(F)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,c.$Rf)(L)),L=`/${L}`);const V=l.URI.from({scheme:y.Schemas.vscodeRemote,authority:T,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,ae.$ii)(L))return M.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:N?{startLineNumber:N,startColumn:B||1}:void 0},remoteAuthority:M.remoteAuthority}:{workspace:(0,se.$O6b)(V),remoteAuthority:T};if(M.gotoLineMode||g.$gc.basename(L).indexOf(".")!==-1)return{fileUri:V,options:{selection:N?{startLineNumber:N,startColumn:B||1}:void 0},remoteAuthority:T}}return{workspace:(0,se.$P6b)(V),remoteAuthority:T}}jb(L){const M=this.G.getValue("window"),F=M?.openFoldersInNewWindow||"default",T=M?.openFilesInNewWindow||"off";let N=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(F==="on"||F==="off")&&(N=F==="on");let B=!1;return L.forceNewWindow||L.forceReuseWindow?B=!!L.forceNewWindow&&!L.forceReuseWindow:(m.$k?L.context===1&&(B=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!L.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(B=T==="on")),{openFolderInNewWindow:!!N,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(L,M){const F=(0,x.$M6b)(this.getWindows(),L);if(F)return this.D.reload(F,M.cli),F.focus(),[F];let T=M.cli["folder-uri"]||[],N=M.cli["file-uri"]||[],B=M.cli._;if(!B.length&&!T.length&&!N.length&&!M.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(l.URI.isUri(ue)?ue.scheme===y.Schemas.file?B=[ue.fsPath]:T=[ue.toString()]:ue.configPath.scheme===y.Schemas.file?B=[(0,d.$jg)(ue.configPath)]:N=[ue.configPath.toString()])}let V=M.remoteAuthority;for(const de of L)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=l.URI.parse(de),he=(0,k.$Uk)(ue);he&&(V?(0,d.$Ag)(he,V)||this.s.error("more than one extension development path authority"):V=he)}B=B.filter(de=>{const ue=l.URI.file(de);return(0,x.$L6b)(this.getWindows(),ue)?!1:(0,d.$Ag)((0,k.$Uk)(ue),V)}),T=T.filter(de=>{const ue=this.ab(de);return ue&&(0,x.$L6b)(this.getWindows(),ue)?!1:ue?(0,d.$Ag)((0,k.$Uk)(ue),V):!1}),N=N.filter(de=>{const ue=this.ab(de);return ue&&(0,x.$L6b)(this.getWindows(),ue)?!1:ue?(0,d.$Ag)((0,k.$Uk)(ue),V):!1}),M.cli._=B,M.cli["folder-uri"]=T,M.cli["file-uri"]=N;const oe={context:M.context,cli:M.cli,forceNewWindow:!0,forceEmpty:!B.length&&!T.length&&!N.length,userEnv:M.userEnv,noRecentEntry:!0,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:V,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile};return this.open(oe)}async kb(L){const M=this.G.getValue("window"),F=this.getLastActiveWindow(),T=F?.profile??this.C.defaultProfile;let N;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(N=L.windowToUse||F,N&&N.focus());const B={...this.z.args,...L.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,g.$jc)(this.z.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:T},homeDir:this.z.userHome.with({scheme:y.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:y.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.r,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:y.Schemas.file}).fsPath,product:A.default,isInitialStartup:L.initialStartup,perfMarks:(0,v.getMarks)(),os:{release:(0,O.release)(),hostname:(0,O.hostname)(),arch:(0,O.arch)()},zoomLevel:typeof M?.zoomLevel=="number"?M.zoomLevel:void 0,autoDetectHighContrast:M?.autoDetectHighContrast??!0,autoDetectColorScheme:M?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(N){const V=N.config;!B.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=V.extensionDevelopmentPath,B.extensionDevelopmentKind=V.extensionDevelopmentKind,B["enable-proposed-api"]=V["enable-proposed-api"],B.verbose=V.verbose,B["inspect-extensions"]=V["inspect-extensions"],B["inspect-brk-extensions"]=V["inspect-brk-extensions"],B.debugId=V.debugId,B.extensionEnvironment=V.extensionEnvironment,B["extensions-dir"]=V["extensions-dir"],B["disable-extensions"]=V["disable-extensions"]),B.loggers={global:B.loggers.global,window:V?.loggers.window??B.loggers.window}}else{const V=this.j.getNewWindowState(B);(0,v.mark)("code/willCreateCodeWindow");const oe=N=this.J.createInstance(U.$W6b,{state:V,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,v.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(oe),this.h.set(oe.id,oe),this.a.fire(oe),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new b.$Rc;de.add(oe.onDidSignalReady(()=>this.b.fire(oe))),de.add(f.Event.once(oe.onDidClose)(()=>this.nb(oe,de))),de.add(f.Event.once(oe.onDidDestroy)(()=>this.c.fire(oe))),de.add(oe.onDidTriggerSystemContextMenu(({x:he,y:ve})=>this.g.fire({window:oe,x:he,y:ve})));const ue=(0,h.$Jf)(oe.win?.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.D.reload(oe)),this.D.registerWindow(oe)}return B.windowId=N.id,N.isReady?this.D.unload(N,4).then(async V=>{V||await this.lb(N,B,L,T)}):await this.lb(N,B,L,T),N}async lb(L,M,F,T){if(M.extensionDevelopmentPath||((0,ae.$5h)(M.workspace)?M.backupPath=this.F.registerWorkspaceBackup({workspace:M.workspace,remoteAuthority:M.remoteAuthority}):(0,ae.$Zh)(M.workspace)?M.backupPath=this.F.registerFolderBackup({folderUri:M.workspace.uri,remoteAuthority:M.remoteAuthority}):M.backupPath=this.F.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,se.$Q6b)().id,remoteAuthority:M.remoteAuthority})),this.C.isEnabled()){const N=M.workspace??(0,ae.$4h)(M.backupPath,!1),B=this.mb(F,N,T),V=B instanceof Promise?await B:B;M.profiles.profile=V,M.extensionDevelopmentPath||await this.C.setProfileForWorkspace(N,V)}L.load(M)}mb(L,M,F){return L.forceProfile?this.C.profiles.find(T=>T.name===L.forceProfile)??this.C.createNamedProfile(L.forceProfile):L.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(M)??F}nb(L,M){this.h.delete(L.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),M.dispose()}getFocusedWindow(){const L=S.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.pb(this.getWindows())}ob(L){return this.pb(this.getWindows().filter(M=>(0,d.$Ag)(M.remoteAuthority,L)))}pb(L){return(0,z.$36b)(L)}sendToFocused(L,...M){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,P.CancellationToken.None,...M)}sendToOpeningWindow(L,...M){this.B(f.Event.once(this.onDidSignalReadyWindow)(F=>{F.sendWhenReady(L,P.CancellationToken.None,...M)}))}sendToAll(L,M,F){for(const T of this.getWindows())F&&F.indexOf(T.id)>=0||T.sendWhenReady(L,P.CancellationToken.None,M)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(L){return this.h.get(L)}getWindowByWebContents(L){const M=S.BrowserWindow.fromWebContents(L);if(M)return this.getWindowById(M.id)}};e.$27b=Y,e.$27b=Y=Ee([te(3,p.$0i),te(4,W.$T6b),te(5,I.$BN),te(6,K.$in),te(7,o.$n6b),te(8,q.$v6b),te(9,r.$p6b),te(10,u.$G6b),te(11,i.$ji),te(12,ce.$x7b),te(13,Z.$R6b),te(14,n.$Oh),te(15,a.$H6b),te(16,t.$$j),te(17,C.$J6b),te(18,Q.$B6b)],Y)}),define(ie[307],ne([0,1,63,29,82,53]),function(J,e,S,R,s,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=void 0;let D=class{constructor(f,c,$,b){this.a=f,this.b=c,this.c=$,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,c){const $=this.b.getWindowById(f);if($)return this.a.enterWorkspace($,this.b.getWindows(),c)}createUntitledWorkspace(f,c,$){return this.a.createUntitledWorkspace(c,$)}deleteUntitledWorkspace(f,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(f,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(f,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$47b=D,e.$47b=D=Ee([te(0,O.$R6b),te(1,R.$Z6b),te(2,s.$x7b),te(3,S.$G6b)],D)}),define(ie[308],ne([0,1,15,131,38,28,17,49,14,33,3,44,46,2,13,9,4,12,7,32,158,42,159,110,290,162,63,283,18,200,91,132,59,116,220,24,62,94,209,293,211,212,213,16,224,93,77,5,92,219,299,284,291,20,6,305,69,25,58,294,95,34,275,81,122,26,251,253,51,48,265,288,300,289,301,127,267,268,269,272,297,29,306,274,30,97,82,307,53,39,233,52,244,50,80,129,277,292,280,8,255,276,228,66,296,271,23,125,295,263,239,71,90,303]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i,a,o,t,n,r,p,A,C,k,I,j,U,z,x,X,ae,se,ce,Z,Q,K,q,W,G,H,Y,re,L,M,F,T,N,B,V,oe,de,ue,he,ve,be,ye,Ie,Te,me,we,_,le,ge,Ae,De,Le,Oe,He,ze,ee,fe,$e,ke,Ce,Fe,je,Ne,Ve,Ge,Ke,Xe,Ye,it,nt,wt,bt,pt,yt,vt,kt,Et,rt,ht,St,Pt,It,ot,At,ft,at,Ct,Dt,ct,Rt,dt,Ot){"use strict";var lt;Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=void 0;let ut=class extends g.$Sc{static{lt=this}static{this.a={[v.Schemas.file]:"security.promptForLocalFileProtocolHandling",[v.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Se,Pe,Re,pe,Me,Ue,Be,Je,qe,We,Qe,Ze){super(),this.g=Se,this.h=Pe,this.j=Re,this.m=pe,this.n=Me,this.s=Ue,this.t=Be,this.u=Je,this.w=qe,this.y=We,this.z=Qe,this.C=Ze,this.D(),this.F()}D(){const Se=qe=>qe?.startsWith(`${v.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((qe,We,Qe,Ze)=>Se(Ze.requestingUrl)?Qe(Pe.has(We)):Qe(!1)),S.session.defaultSession.setPermissionCheckHandler((qe,We,Qe,Ze)=>Se(Ze.requestingUrl)?Pe.has(We):!1);const Re=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),pe=qe=>{for(let We=qe;We;We=We.parent)if(We.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Me=qe=>qe.resourceType==="xhr"||pe(qe.frame),Ue=qe=>{const We=qe.frame;if(!We||!this.b)return!1;const Qe=S.BrowserWindow.getAllWindows();for(const Ze of Qe)if(We.processId===Ze.webContents.mainFrame.processId)return!0;return!1},Be=(qe,We)=>{if(qe.path!=="/index.html")return!0;const Qe=We.frame;if(!Qe||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Qe.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((qe,We)=>{const Qe=h.URI.parse(qe.url);return Qe.scheme===v.Schemas.vscodeWebview&&!Be(Qe,qe)?(this.m.error("Blocked vscode-webview request",qe.url),We({cancel:!0})):Qe.scheme===v.Schemas.vscodeFileResource&&!Ue(qe)?(this.m.error("Blocked vscode-file request",qe.url),We({cancel:!0})):Qe.path.endsWith(".svg")&&!Re.has(Qe.scheme)?We({cancel:!Me(qe)}):We({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((qe,We)=>{const Qe=qe.responseHeaders,Ze=Qe["content-type"]||Qe["Content-Type"];if(Ze&&Array.isArray(Ze)){const xe=h.URI.parse(qe.url);if(xe.path.endsWith(".svg")&&Re.has(xe.scheme))return Qe["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:Qe});if(!xe.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ze.some(et=>et.toLowerCase().includes("image/svg")))return We({cancel:!Me(qe)})}return We({cancel:!1})});const Je=S.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,m.$jc)(this.s.codeCachePath,"chrome")),w.$j&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,f.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,f.$Z)(Re)||(0,f.$1)(Re)}),process.on("unhandledRejection",Re=>(0,f.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$rT)(),S.app.on("accessibility-support-changed",(Re,pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",pe)}),S.app.on("activate",async(Re,pe)=>{this.m.trace("app#activate"),pe||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Re,pe)=>{pe?.opener?.url.startsWith(`${v.Schemas.vscodeFileResource}://${v.$bg}/`)&&this.c?.registerWindow(pe),pe.on("will-navigate",Ue=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ue.preventDefault()}),pe.setWindowOpenHandler(Ue=>Ue.url==="about:blank"?(this.m.trace("webContents#setWindowOpenHandler: Allowing about:blank window to open"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ue.url}}`),this.f?.openExternal(void 0,Ue.url),{action:"deny"}))});let Se=[],Pe;S.app.on("open-file",(Re,pe)=>{this.m.trace("app#open-file: ",pe),Re.preventDefault(),Se.push((0,Ne.$ii)(pe)?{workspaceUri:h.URI.file(pe)}:{fileUri:h.URI.file(pe)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Se,gotoLineMode:!1,preferNewWindow:!0}),Se=[],Pe=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$qT.handle("vscode:getWindowId",Re=>Promise.resolve(Re.sender.id)),s.$qT.handle("vscode:fetchShellEnv",Re=>{const pe=this.b?.getWindowByWebContents(Re.sender);let Me,Ue;return pe?.config?(Me=pe.config,Ue={...process.env,...pe.config.userEnv}):(Me=this.s.args,Ue=process.env),this.X(Me,Ue,!1)}),s.$qT.handle("vscode:writeNlsFile",(Re,pe,Me)=>{const Ue=this.G([pe]);if(!Ue||typeof Me!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ue,D.$be.fromString(Me))}),s.$qT.handle("vscode:readNlsFile",async(Re,...pe)=>{const Me=this.G(pe);if(!Me)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Me)).value.toString()}),s.$qT.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),s.$qT.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),s.$qT.on("vscode:reloadWindow",Re=>Re.sender.reload())}G(Se){let Pe;for(const Re of Se)typeof Re=="string"&&(typeof Pe!="string"?Pe=Re:Pe=(0,m.$jc)(Pe,Re));if(!(typeof Pe!="string"||!(0,m.$ic)(Pe)||!(0,c.$Xf)(Pe,this.s.cachedLanguagesPath,!w.$l)))return h.URI.file(Pe)}H(Se){if(Se){const Pe={message:`[uncaught exception in main]: ${Se.message}`,stack:Se.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.m.error(`[uncaught exception in main]: ${Se}`),Se.stack&&this.m.error(Se.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Se=this.z.win32AppUserModelId;w.$j&&Se&&S.app.setAppUserModelId(Se);try{w.$k&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Pe=new i.$xT;this.t.onWillShutdown(We=>{We.reason===2&&Pe.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,pe]=await Promise.all([(0,ht.$_7b)(this.w,this.m),(0,ht.$a8b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:Me,sharedProcessClient:Ue}=this.P(Re,pe),Be=await this.Q(Re,pe,Me);this.B(Be.createInstance(o.$46b)),this.B(Be.createInstance(kt.$87b)),Be.invokeFunction(We=>this.R(We,Pe,Ue));const Je=await Be.invokeFunction(We=>this.I(We,Pe));this.J(Pe),this.t.phase=2,await Be.invokeFunction(We=>this.S(We,Je)),this.t.phase=3,this.U(),this.B(new rt.$6g(()=>{this.B((0,rt.$0g)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Se,Pe){const Re=this.b=Se.get(Ce.$Z6b),pe=Se.get(He.$eU),Me=this.f=Se.get(V.$l7b),Ue=Se.get(I.$H6b),Be=this;pe.registerHandler({async handleURL(xe,et){return Be.O(Re,Ue,pe,xe,et)}});const Je=this.B(new je.$37b({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),qe=new u.$xh(xe=>Je.getActiveClientId().then(et=>xe===et)),We=new ze.$T7b(qe,this.m),Qe=Pe.getChannel("urlHandler",We);pe.registerHandler(new ze.$S7b(Qe));const Ze=await this.L(Re,Ue);return this.B(new fe.$U7b(Ze?.urls,pe,Re,this.s,this.z,this.m)),Ze}J(Se){const Pe=()=>({statusCode:404,data:"Not found"}),Re=new Rt.$V(()=>Se.getChannel(ct.$h8b,new ct.$i8b));S.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(pe,Me)=>{const Ue=h.URI.parse(pe.url);if(!Ue.authority.startsWith("window:"))return Me(Pe());Re.value.call(ct.$g8b,[Ue]).then(Be=>Me({...Be,data:Buffer.from(Be.body,"base64")}),Be=>{this.m.warn("error dispatching remote resource call",Be),Me({statusCode:500,data:String(Be)})})})}async L(Se,Pe){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const pe=global.getOpenUrls()||[];if(pe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",pe),Re.length+pe.length===0)return;const Me=[...Re,...pe].map(Je=>{try{return{uri:h.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),Ue=[],Be=[];for(const Je of Me){if(!Je)continue;if(await this.M(Je.uri,Se,Pe)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}const qe=this.N(Je.uri);qe?(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),qe),Ue.push(qe)):(this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),Be.push(Je))}return{urls:Be,openables:Ue}}async M(Se,Pe,Re){if(Se.authority!==v.Schemas.file&&Se.authority!==v.Schemas.vscodeRemote||this.u.getValue(lt.a[Se.authority])===!1)return!1;const{response:Me,checkboxChecked:Ue}=await Re.showMessageBox({type:"warning",buttons:[(0,t.localize)(0,null),(0,t.localize)(1,null)],message:(0,t.localize)(2,null,Se.authority===v.Schemas.file?(0,y.$rv)(Se,{os:w.OS,tildify:this.s}):Se.toString(!0),this.z.nameShort),detail:(0,t.localize)(3,null),checkboxLabel:Se.authority===v.Schemas.file?(0,t.localize)(4,null):(0,t.localize)(5,null),cancelId:1});if(Me!==0)return!0;if(Ue){const Be={channel:"vscode:disablePromptForProtocolHandling",args:Se.authority===v.Schemas.file?"local":"remote"};Pe.sendToFocused(Be.channel,Be.args),Pe.sendToOpeningWindow(Be.channel,Be.args)}return!1}N(Se){if(Se.path){if(Se.authority===v.Schemas.file){const Pe=h.URI.file(Se.fsPath);return(0,Ne.$ii)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Se.authority===v.Schemas.vscodeRemote){const Pe=Se.path.indexOf(m.$gc.sep,1);if(Pe!==-1){const Re=Se.path.substring(1,Pe),pe=Se.path.substring(Pe);let Me=Se.query;const Ue=new URLSearchParams(Se.query);Ue.get("windowId")==="_blank"&&(Ue.delete("windowId"),Me=Ue.toString());const Be=h.URI.from({scheme:v.Schemas.vscodeRemote,authority:Re,path:pe,query:Me,fragment:Se.fragment});return(0,Ne.$ii)(pe)?{workspaceUri:Be}:/:[\d]+$/.test(pe)?{fileUri:Be}:{folderUri:Be}}}}}async O(Se,Pe,Re,pe,Me){if(this.m.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.z.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:h.URI.parse(pe.query).path,query:""})),await this.M(pe,Se,Pe))return this.m.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Ue=!1;const Be=new URLSearchParams(pe.query);Be.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Be.delete("windowId"),pe=pe.with({query:Be.toString()}),Ue=!0):w.$k&&Se.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ue=!0);const Je=Be.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Be.delete("continueOn"),pe=pe.with({query:Be.toString()}),this.s.continueOn=Je??void 0);const qe=this.N(pe);return qe?(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",qe,pe.toString(!0)),(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},urisToOpen:[qe],forceNewWindow:Ue,gotoLineMode:!0}))?.focus(),!0):Ue?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ft.$Ob)(await Se.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.$Uk)(pe)}))?.ready(),Re.open(pe,Me)):(this.m.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}P(Se,Pe){const Re=this.B(this.j.createInstance(ue.$F7b,Se,Pe)),pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ue=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new a.$yT(Ue,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),pe))(),sharedProcessClient:pe}}async Q(Se,Pe,Re){const pe=new Y.$Nh;switch(process.platform){case"win32":pe.set(le.$qU,new G.$Mh(Oe.$Q7b));break;case"linux":w.$m?pe.set(le.$qU,new G.$Mh(Le.$P7b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(le.$qU,new G.$Mh(De.$O7b));break;case"darwin":pe.set(le.$qU,new G.$Mh(Ae.$N7b));break}pe.set(Ce.$Z6b,new G.$Mh(Fe.$27b,[Se,Pe,this.h],!1)),pe.set(dt.$Y6b,new G.$Mh(Ot.$j8b,void 0,!1));const Me=new I.$I6b(this.m,this.z);pe.set(I.$H6b,Me),pe.set(F.$r7b,new G.$Mh(F.$s7b,void 0,!1)),pe.set(k.$06b,new G.$Mh(k.$$6b,void 0,!1)),pe.set(C.$qm,u.ProxyChannel.toService((0,u.$vh)(Re.then(We=>We.getChannel("diagnostics"))))),pe.set(re.$bxb,new G.$Mh(L.$n7b,[this.h])),pe.set(j.$$T,new G.$Mh(U.$_6b)),pe.set(M.$o7b,new G.$Mh(M.$p7b)),pe.set(V.$l7b,new G.$Mh(V.$m7b,void 0,!1)),pe.set($e.$V7b,new G.$Mh(ke.$X7b)),pe.set(B.$A7b,new G.$Mh(B.$B7b)),pe.set(ae.$a7b,new G.$Mh(se.$c7b)),pe.set(ye.$x6b,new G.$Mh(ye.$y6b)),pe.set(ye.$z6b,new G.$Mh(ye.$A6b));const Ue=new Ct.$f8b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Be=new Dt.$vr(Ue,this.u,this.m,this.n);pe.set(at.$9q,Be),w.$j?pe.set(ce.$d7b,new G.$Mh(Z.$e7b)):w.$k?pe.set(ce.$d7b,new G.$Mh(Z.$f7b)):w.$l&&pe.set(ce.$d7b,new G.$Mh(Z.$g7b));const Je=new r.$56b(this.s,this.u,this.m,this.w);pe.set(n.$G6b,Je);const qe=new Xe.$S6b(this.s,this.m,this.C,Je,Me);if(pe.set(Xe.$R6b,qe),pe.set(Ve.$NU,new G.$Mh(Ke.$47b,void 0,!1)),pe.set(Ge.$x7b,new G.$Mh(Ge.$y7b,void 0,!1)),pe.set(He.$eU,new G.$Mh(ee.$gU,void 0,!1)),(0,_.$ro)(this.z,this.s)){const We=(0,_.$wo)(this.z,this.u),Qe=(0,u.$vh)(Re.then(st=>st.getChannel("telemetryAppender"))),Ze=new me.$I7b(Qe),xe=(0,Ie.$ho)((0,O.release)(),(0,O.hostname)(),process.arch,this.z.commit,this.z.version,Se,Pe,We),et=(0,_.$xo)(this.s),tt={appenders:[Ze],commonProperties:xe,piiPaths:et,sendErrorTelemetry:!0};pe.set(Te.$cl,new G.$Mh(we.$1q,[tt],!1))}else pe.set(Te.$cl,_.$lo);return pe.set(pt.$up,new G.$Mh(St.$IN,void 0,!0)),pe.set(yt.$yp,new G.$Mh(vt.$77b,void 0,!0)),pe.set(ot.$d8b,new G.$Mh(ot.$e8b,void 0,!0)),await rt.Promises.settled([Je.initialize(),qe.initialize()]),this.j.createChild(pe)}R(Se,Pe,Re){const pe=this.B(new g.$Rc),Me=u.ProxyChannel.fromService(Se.get(F.$r7b),pe,{disableMarshalling:!0});this.g.registerChannel("launch",Me);const Ue=u.ProxyChannel.fromService(Se.get(k.$06b),pe,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ue);const Be=new it.$57b(Se.get(Ye.$in));Pe.registerChannel("policy",Be),Re.then(_e=>_e.registerChannel("policy",Be));const Je=this.y.getProvider(v.Schemas.file);(0,d.$If)(Je instanceof W.$aq);const qe=new q.$h7b(Je,this.m,this.s);Pe.registerChannel(Q.$rN,qe),Re.then(_e=>_e.registerChannel(Q.$rN,qe));const We=u.ProxyChannel.fromService(Se.get(nt.$v6b),pe);Pe.registerChannel("userDataProfiles",We),Re.then(_e=>_e.registerChannel("userDataProfiles",We));const Qe=new wt.$Vq(Se.get(bt.$So));Re.then(_e=>_e.registerChannel("request",Qe));const Ze=new ge.$J7b(Se.get(le.$qU));Pe.registerChannel("update",Ze);const xe=u.ProxyChannel.fromService(Se.get(re.$bxb),pe);Pe.registerChannel("issue",xe);const et=u.ProxyChannel.fromService(Se.get(j.$$T),pe);Pe.registerChannel("encryption",et);const tt=u.ProxyChannel.fromService(Se.get(he.$3k),pe);Pe.registerChannel("sign",tt);const st=u.ProxyChannel.fromService(Se.get(M.$o7b),pe);Pe.registerChannel("keyboardLayout",st),this.f=Se.get(V.$l7b);const gt=u.ProxyChannel.fromService(this.f,pe);Pe.registerChannel("nativeHost",gt),Re.then(_e=>_e.registerChannel("nativeHost",gt));const Mt=u.ProxyChannel.fromService(Se.get(Ve.$NU),pe);Pe.registerChannel("workspaces",Mt);const jt=u.ProxyChannel.fromService(Se.get(B.$A7b),pe);Pe.registerChannel("menubar",jt);const Lt=u.ProxyChannel.fromService(Se.get(He.$eU),pe);Pe.registerChannel("url",Lt);const Nt=u.ProxyChannel.fromService(Se.get($e.$V7b),pe);Pe.registerChannel("webview",Nt);const $t=this.B(new be.$G7b(this.m,Se.get(ye.$x6b)));Pe.registerChannel("storage",$t),Re.then(_e=>_e.registerChannel("storage",$t));const Ut=this.B(new Et.$97b(Se.get(ye.$x6b),Se.get(nt.$v6b),this.m));Re.then(_e=>_e.registerChannel("profileStorageListener",Ut));const Ft=u.ProxyChannel.fromService(Se.get(at.$9q),pe);Pe.registerChannel(at.TerminalIpcChannels.LocalPty,Ft);const Wt=u.ProxyChannel.fromService(Se.get(ce.$d7b),pe);Pe.registerChannel("externalTerminal",Wt);const mt=new Pt.$b8b(Se.get(It.$T6b));Pe.registerChannel("logger",mt),Re.then(_e=>_e.registerChannel("logger",mt));const Tt=new A.$66b(Se.get(Ce.$Z6b));Pe.registerChannel("extensionhostdebugservice",Tt);const zt=u.ProxyChannel.fromService(Se.get(ae.$a7b),pe);Pe.registerChannel(ae.$b7b,zt);const Bt=u.ProxyChannel.fromService(Se.get(ot.$d8b),pe);Pe.registerChannel(At.$c8b,Bt)}async S(Se,Pe){const Re=this.b=Se.get(Ce.$Z6b);this.c=Se.get(dt.$Y6b);const pe=(0,x.$Nl)(process.env)?0:4,Me=this.s.args;if(Pe){if(Pe.openables.length>0)return Re.open({context:pe,cli:Me,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const tt of Pe.urls){const st=new URLSearchParams(tt.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:st.toString()}),Re.open({context:pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ue=global.macOpenFiles,Be=Me._.length,Je=!!Me["folder-uri"],qe=!!Me["file-uri"],We=Me["skip-add-to-recently-opened"]===!0,Qe=Me.wait&&Me.waitMarkerFilePath?h.URI.file(Me.waitMarkerFilePath):void 0,Ze=Me.remote||void 0,xe=Me.profile,et=Me["profile-temp"];if(!Be&&!Je&&!qe){if(Me["new-window"]||xe||et)return Re.open({context:pe,cli:Me,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:Qe,initialStartup:!0,remoteAuthority:Ze,forceProfile:xe,forceTempProfile:et});if(Ue.length)return Re.open({context:1,cli:Me,urisToOpen:Ue.map(tt=>(0,Ne.$ii)(tt)?{workspaceUri:h.URI.file(tt)}:{fileUri:h.URI.file(tt)}),noRecentEntry:We,waitMarkerFileURI:Qe,initialStartup:!0})}return Re.open({context:pe,cli:Me,forceNewWindow:Me["new-window"]||!Be&&Me["unity-launch"],diffMode:Me.diff,mergeMode:Me.merge,noRecentEntry:We,waitMarkerFileURI:Qe,gotoLineMode:Me.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:xe,forceTempProfile:et})}U(){this.W(),S.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Se,Pe)=>{Pe({url:Se.url.replace(/^vscode-remote-resource:/,"http:"),method:Se.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$k&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Se=this.z.win32MutexName;if(w.$j&&Se)try{const Pe=await new Promise((pe,Me)=>{J(["@vscode/windows-mutex"],pe,Me)}),Re=new Pe.Mutex(Se);$.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(Pe){this.m.error(Pe)}}async X(Se,Pe,Re){try{return await(0,X.$Tl)(this.u,this.m,Se,Pe)}catch(pe){const Me=(0,P.$Ai)(pe);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",Me):this.m.error(Me)}return{}}async Y(){try{const Pe=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,b.$5m)(Pe)),Me=(0,_.$to)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const Ue=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Me},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$eg)()}"`,"}"],Be=Pe.substring(0,Pe.length-2).concat(`,
`,Ue.join(`
`));await this.y.writeFile(this.s.argvResource,D.$be.fromString(Be))}else{const Ue=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Me},`);Ue!==Pe&&await this.y.writeFile(this.s.argvResource,D.$be.fromString(Ue))}}catch(Se){this.m.error(Se)}}};e.$k8b=ut,e.$k8b=ut=lt=Ee([te(2,H.$Oh),te(3,N.$0i),te(4,N.$$i),te(5,z.$n6b),te(6,T.$p6b),te(7,p.$ji),te(8,ve.$BN),te(9,K.$$j),te(10,oe.$pj),te(11,nt.$v6b)],ut)}),define(ie[314],ne([0,1,15,45,7,23,8,49,14,33,3,46,13,9,65,4,35,27,21,42,99,308,10,18,238,250,24,62,202,16,222,93,77,218,92,20,225,6,78,25,79,278,126,287,50,286,95,249,34,51,67,52,39,234,232,2,40,266,66,227,115,121,270,264]),function(J,e,S,R,s,O,D,P,f,c,$,b,y,g,v,m,w,d,h,l,E,u,i,a,o,t,n,r,p,A,C,k,I,j,U,z,x,X,ae,se,ce,Z,Q,K,q,W,G,H,Y,re,L,M,F,T,N,B,V,oe,de,ue,he,ve,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(me){console.error(me.message),S.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[me,we,_,le,ge,Ae,De,Le]=this.b();try{try{await this.d(_,Le,le,ge,De)}catch(Oe){throw this.f(_,De,Oe),Oe}await me.invokeFunction(async Oe=>{const He=Oe.get(X.$0i),ze=Oe.get(z.$p6b),ee=Oe.get(A.$$j),fe=Oe.get(X.$$i),$e=await this.e(He,_,ze,me,De,!0);return h.Promises.writeFile(_.mainLockfile,String(process.pid)).catch(ke=>{He.warn(`app#startup(): Error writing main lockfile: ${ke.stack}`)}),Ae.logger=fe.createLogger("main",{name:(0,i.localize)(0,null)}),$.Event.once(ze.onWillShutdown)(ke=>{ee.dispose(),le.dispose(),ke.join("instanceLockfile",h.Promises.unlink(_.mainLockfile).catch(()=>{}))}),me.createInstance(u.$k8b,$e,we).startup()})}catch(Oe){me.invokeFunction(this.i,Oe)}}b(){const me=new U.$Nh,we=new B.$Rc;process.once("exit",()=>we.dispose());const _={_serviceBrand:void 0,...ae.default};me.set(se.$pj,_);const le=new n.$o6b(this.j(),_),ge=this.c(le);me.set(n.$n6b,le);const Ae=new de.$U6b((0,X.$lj)(le),le.logsHome);me.set(de.$T6b,Ae);const De=new x.$03b(Ae.getLogLevel()),Le=we.add(new ue.$JN(De,[new X.$ej(Ae.getLogLevel())]));me.set(X.$0i,Le);const Oe=new C.$Np(Le);me.set(A.$$j,Oe);const He=new k.$aq(Le);Oe.registerProvider(y.Schemas.file,He);const ze=new oe.$zr(Oe);me.set(V.$Ik,ze);const ee=new ve.$EN(1,le,Le,Oe);me.set(Y.$AN,ee),me.set(Y.$BN,ee);const fe=new M.$w6b(ee,ze,le,Oe,Le);me.set(M.$v6b,fe),Oe.registerProvider(y.Schemas.vscodeUserData,new be.$v8b(y.Schemas.file,He,y.Schemas.vscodeUserData,fe,ze,Le));const $e=m.$j&&_.win32RegValueName?we.add(new T.$t8b(Le,_.win32RegValueName)):le.policyFile?we.add(new N.$u8b(le.policyFile,Oe,Le)):new F.$kn;me.set(F.$in,$e);const ke=new o.$Kn(fe.defaultProfile.settingsResource,Oe,$e,Le);return me.set(a.$ji,ke),me.set(z.$p6b,new I.$Mh(z.$q6b,void 0,!1)),me.set(q.$So,new I.$Mh(W.$r8b,void 0,!0)),me.set(L.$B6b,new I.$Mh(L.$C6b)),me.set(G.$3k,new I.$Mh(H.$s8b,void 0,!1)),me.set(Q.$0u,new I.$Mh(K.$p8b)),me.set(ce.$J6b,new Z.$m8b(le,fe,Le)),[new j.$dq(me,!0),ge,le,ke,ee,De,_,fe]}c(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(_=>{const le=process.env[_];typeof le=="string"&&(we[_]=le)}),Object.assign(process.env,we),we}async d(me,we,_,le,ge){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.with({scheme:y.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,me.backupHome].map(Ae=>Ae?h.Promises.mkdir(Ae,{recursive:!0}):void 0)),le.init(),_.initialize()]),we.init()}async e(me,we,_,le,ge,Ae){let De;try{(0,v.mark)("code/willStartMainServer"),De=await(0,E.$Kh)(we.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),$.Event.once(_.onWillShutdown)(()=>De.dispose())}catch(Le){if(Le.code!=="EADDRINUSE")throw this.f(we,ge,Le),Le;let Oe;try{Oe=await(0,E.$Lh)(we.mainIPCHandle,"main")}catch(fe){if(!Ae||m.$j||fe.code!=="ECONNREFUSED")throw fe.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),fe;try{(0,R.unlinkSync)(we.mainIPCHandle)}catch($e){throw me.warn("Could not delete obsolete instance handle",$e),$e}return this.e(me,we,_,le,ge,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const fe=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw me.error(fe),Oe.dispose(),new Error(fe)}let He;!we.args.wait&&!we.args.status&&(He=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=l.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),ee=l.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const fe=new t.$Gr(re.$lo,ge),$e=await ee.getMainDiagnostics(),ke=await ee.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ce=await fe.getDiagnostics($e,ke);throw console.log(Ce),new f.$ab});throw m.$j&&await this.h(ze,me),me.trace("Sending env to running instance..."),await ze.start(we.args,process.env),Oe.dispose(),He&&clearTimeout(He),new f.$ab("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new f.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),De}f(me,we,_){if(_.code==="EACCES"||_.code==="EPERM"){const le=(0,O.$Hb)([me.userDataPath,me.extensionsPath,E.$Gh]).map(ge=>(0,b.$rv)(s.URI.file(ge),{os:m.OS,tildify:me}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,P.$Ai)(_),le.join(`
`)),we)}}g(me,we,_){S.dialog.showMessageBoxSync((0,he.$Fv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:me,detail:we},_).options)}async h(me,we){if(m.$j){const _=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",_);try{(await new Promise((le,ge)=>{J(["windows-foreground-love"],le,ge)})).allowSetForegroundWindow(_)}catch(le){we.error(le)}}}i(me,we){const _=me.get(X.$0i),le=me.get(z.$p6b);let ge=0;we&&(we.isExpected?we.message&&_.trace(we.message):(ge=1,we.stack?_.error(we.stack):_.error(`Startup error: ${we.toString()}`))),le.kill(ge)}j(){const me=this.k((0,r.$Kl)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,p.$l8b)(me.verbose);we&&((0,r.$Ml)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.l(me._,me.goto);me._=we}return me}l(me,we){const _=(0,w.cwd)(),le=me.map(De=>{let Le=String(De),Oe;we&&(Oe=(0,c.$5f)(Le),Le=Oe.path),Le&&(Le=this.m(_,Le));const He=(0,c.$Zf)(Le,_),ze=(0,g.$nc)(He);return ze&&!(0,c.$Vf)(ze)?null:we&&Oe?(Oe.path=He,this.n(Oe)):He}),ge=m.$j||m.$k,Ae=(0,O.$Mb)(le,De=>De&&ge?De.toLowerCase():De||"");return(0,O.$Hb)(Ae)}m(me,we){return m.$j&&(we=(0,d.$Ke)(we,'"')),we=(0,d.$Ie)((0,d.$Ie)(we," "),"	"),m.$j&&(we=(0,g.$kc)(me,we),we=(0,d.$Ke)(we,".")),we}n(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cbd09078e6221fa1553c5a59dd25e63ad767911a/core/vs/code/electron-main/main.js.map
