/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/base/common/stopwatch","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],C=0,T=$e.length;C<T;C++)e[C]=De[$e[C]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const d=new Map,R=new Map,A=new Map,m=new Map;function E(y,k){y.has(k.detail)||y.set(k.detail,-k.timestamp)}function b(y,k){const p=y.get(k.detail);p&&(p>=0||y.set(k.detail,p+k.timestamp))}let L=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(L=$e.getStats().slice(0).sort((y,k)=>y.timestamp-k.timestamp));for(const y of L)switch(y.type){case 10:E(d,y);break;case 11:case 12:b(d,y);break;case 21:E(R,y);break;case 22:b(R,y);break;case 33:E(A,y);break;case 34:b(A,y);break;case 31:E(m,y);break;case 32:b(m,y);break}let P=0;A.forEach(y=>P+=y);function v(y){const k=[];return y.forEach((p,h)=>k.push([h,p])),k}return{amdLoad:v(d),amdInvoke:v(R),nodeRequire:v(A),nodeEval:v(m),nodeRequireTotal:P}}static toMarkdownTable(d,R){let A="";const m=[];return d.forEach((E,b)=>{m[b]=E.length}),R.forEach(E=>{E.forEach((b,L)=>{typeof b>"u"&&(b=E[L]="-");const P=b.toString().length;m[L]=Math.max(P,m[L])})}),d.forEach((E,b)=>{A+=`| ${E+" ".repeat(m[b]-E.toString().length)} `}),A+=`|
`,d.forEach((E,b)=>{A+=`| ${"-".repeat(m[b])} `}),A+=`|
`,R.forEach(E=>{E.forEach((b,L)=>{typeof b<"u"&&(A+=`| ${b+" ".repeat(m[L]-b.toString().length)} `)}),A+=`|
`}),A}}e.$U=C}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function C(p,h,s){const a=T(p,h);if(a!==-1)return p[a]}e.$fb=C;function T(p,h,s=p.length-1){for(let a=s;a>=0;a--){const o=p[a];if(h(o))return a}return-1}e.$gb=T;function d(p,h){const s=R(p,h);return s===-1?void 0:p[s]}e.$hb=d;function R(p,h,s=0,a=p.length){let o=s,f=a;for(;o<f;){const l=Math.floor((o+f)/2);h(p[l])?o=l+1:f=l}return o-1}e.$ib=R;function A(p,h){const s=m(p,h);return s===p.length?void 0:p[s]}e.$jb=A;function m(p,h,s=0,a=p.length){let o=s,f=a;for(;o<f;){const l=Math.floor((o+f)/2);h(p[l])?f=l:o=l+1}return o}e.$kb=m;function E(p,h,s=0,a=p.length){const o=m(p,h,s,a);return o===p.length?-1:o}e.$lb=E;class b{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(b.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!h(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const s=R(this.e,h,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=b;function L(p,h){if(p.length===0)return;let s=p[0];for(let a=1;a<p.length;a++){const o=p[a];h(o,s)>0&&(s=o)}return s}e.$nb=L;function P(p,h){if(p.length===0)return;let s=p[0];for(let a=1;a<p.length;a++){const o=p[a];h(o,s)>=0&&(s=o)}return s}e.$ob=P;function v(p,h){return L(p,(s,a)=>-h(s,a))}e.$pb=v;function y(p,h){if(p.length===0)return-1;let s=0;for(let a=1;a<p.length;a++){const o=p[a];h(o,p[s])>0&&(s=a)}return s}e.$qb=y;function k(p,h){for(const s of p){const a=h(s);if(a!==void 0)return a}}e.$rb=k}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(A,m){const E=Object.create(null);for(const b of A){const L=m(b);let P=E[L];P||(P=E[L]=[]),P.push(b)}return E}e.$J=C;function T(A,m){const E=[],b=[];for(const L of A)m.has(L)||E.push(L);for(const L of m)A.has(L)||b.push(L);return{removed:E,added:b}}e.$K=T;function d(A,m){const E=[],b=[];for(const[L,P]of A)m.has(L)||E.push(P);for(const[L,P]of m)A.has(L)||b.push(P);return{removed:E,added:b}}e.$L=d;function R(A,m){const E=new Set;for(const b of m)A.has(b)&&E.add(b);return E}e.$M=R}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function C(A){return(m,E,b)=>{let L=null,P=null;if(typeof b.value=="function"?(L="value",P=b.value):typeof b.get=="function"&&(L="get",P=b.get),!P)throw new Error("not supported");b[L]=A(P,E)}}function T(A,m,E){let b=null,L=null;if(typeof E.value=="function"?(b="value",L=E.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",L=E.get),!L)throw new Error("not supported");const P=`$memoize$${m}`;E[b]=function(...v){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[P]}}e.$hh=T;function d(A,m,E){return C((b,L)=>{const P=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...y){this[v]||(this[v]=E?E():void 0),clearTimeout(this[P]),m&&(this[v]=m(this[v],...y),y=[this[v]]),this[P]=setTimeout(()=>{b.apply(this,y),this[v]=E?E():void 0},A)}})}e.$ih=d;function R(A,m,E){return C((b,L)=>{const P=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,y=`$throttle$lastRun$${L}`,k=`$throttle$pending$${L}`;return function(...p){if(this[v]||(this[v]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),m&&(this[v]=m(this[v],...p)),this[k])return;const h=this[y]+A;h<=Date.now()?(this[y]=Date.now(),b.apply(this,[this[v]]),this[v]=E?E():void 0):(this[k]=!0,this[P]=setTimeout(()=>{this[k]=!1,this[y]=Date.now(),b.apply(this,[this[v]]),this[v]=E?E():void 0},h-Date.now()))}})}e.$jh=R}),define(De[9],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?o.isErrorNoTelemetry(t)?new o(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(i=>{i(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=C,e.$X=new C;function T(l){e.$X.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=T;function d(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=d;function R(l){b(l)||e.$X.onUnexpectedError(l)}e.$1=R;function A(l){b(l)||e.$X.onUnexpectedExternalError(l)}e.$2=A;function m(l){if(l instanceof Error){const{name:t,message:i}=l,c=l.stacktrace||l.stack;return{$isError:!0,name:t,message:i,stack:c,noTelemetry:o.isErrorNoTelemetry(l)}}return l}e.$3=m;const E="Canceled";function b(l){return l instanceof L?!0:l instanceof Error&&l.name===E&&l.message===E}e.$4=b;class L extends Error{constructor(){super(E),this.name=this.message}}e.$5=L;function P(){const l=new Error(E);return l.name=l.message,l}e.$6=P;function v(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.$7=v;function y(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.$8=y;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function p(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.$0=p;class h extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=h;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=a;class o extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof o)return t;const i=new o;return i.message=t.message,i.stack=t.stack,i}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=o;class f extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.$cb=f}),define(De[19],Ce([1,0,9,118]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function d(Y,_=0){return Y[Y.length-(1+_)]}e.$sb=d;function R(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.$tb=R;function A(Y,_,x=(ve,ae)=>ve===ae){if(Y===_)return!0;if(!Y||!_||Y.length!==_.length)return!1;for(let ve=0,ae=Y.length;ve<ae;ve++)if(!x(Y[ve],_[ve]))return!1;return!0}e.$ub=A;function m(Y,_){const x=Y.length-1;_<x&&(Y[_]=Y[x]),Y.pop()}e.$vb=m;function E(Y,_,x){return b(Y.length,ve=>x(Y[ve],_))}e.$wb=E;function b(Y,_){let x=0,ve=Y-1;for(;x<=ve;){const ae=(x+ve)/2|0,fe=_(ae);if(fe<0)x=ae+1;else if(fe>0)ve=ae-1;else return ae}return-(x+1)}e.$xb=b;function L(Y,_,x){if(Y=Y|0,Y>=_.length)throw new TypeError("invalid index");const ve=_[Math.floor(_.length*Math.random())],ae=[],fe=[],ee=[];for(const de of _){const be=x(de,ve);be<0?ae.push(de):be>0?fe.push(de):ee.push(de)}return Y<ae.length?L(Y,ae,x):Y<ae.length+ee.length?ee[0]:L(Y-(ae.length+ee.length),fe,x)}e.$yb=L;function P(Y,_){const x=[];let ve;for(const ae of Y.slice(0).sort(_))!ve||_(ve[0],ae)!==0?(ve=[ae],x.push(ve)):ve.push(ae);return x}e.$zb=P;function*v(Y,_){let x,ve;for(const ae of Y)ve!==void 0&&_(ve,ae)?x.push(ae):(x&&(yield x),x=[ae]),ve=ae;x&&(yield x)}e.$Ab=v;function y(Y,_){for(let x=0;x<=Y.length;x++)_(x===0?void 0:Y[x-1],x===Y.length?void 0:Y[x])}e.$Bb=y;function k(Y,_){for(let x=0;x<Y.length;x++)_(x===0?void 0:Y[x-1],Y[x],x+1===Y.length?void 0:Y[x+1])}e.$Cb=k;function p(Y,_,x){const ve=[];function ae(de,be,Pe){if(be===0&&Pe.length===0)return;const z=ve[ve.length-1];z&&z.start+z.deleteCount===de?(z.deleteCount+=be,z.toInsert.push(...Pe)):ve.push({start:de,deleteCount:be,toInsert:Pe})}let fe=0,ee=0;for(;;){if(fe===Y.length){ae(fe,0,_.slice(ee));break}if(ee===_.length){ae(fe,Y.length-fe,[]);break}const de=Y[fe],be=_[ee],Pe=x(de,be);Pe===0?(fe+=1,ee+=1):Pe<0?(ae(fe,1,[]),fe+=1):Pe>0&&(ae(fe,0,[be]),ee+=1)}return ve}e.$Db=p;function h(Y,_,x){const ve=p(Y,_,x),ae=[],fe=[];for(const ee of ve)ae.push(...Y.slice(ee.start,ee.start+ee.deleteCount)),fe.push(...ee.toInsert);return{removed:ae,added:fe}}e.$Eb=h;function s(Y,_,x){if(x===0)return[];const ve=Y.slice(0,x).sort(_);return o(Y,_,ve,x,Y.length),ve}e.top=s;function a(Y,_,x,ve,ae){return x===0?Promise.resolve([]):new Promise((fe,ee)=>{(async()=>{const de=Y.length,be=Y.slice(0,x).sort(_);for(let Pe=x,z=Math.min(x+ve,de);Pe<de;Pe=z,z=Math.min(z+ve,de)){if(Pe>x&&await new Promise(J=>setTimeout(J)),ae&&ae.isCancellationRequested)throw new C.$5;o(Y,_,be,Pe,z)}return be})().then(fe,ee)})}e.$Gb=a;function o(Y,_,x,ve,ae){for(const fe=x.length;ve<ae;ve++){const ee=Y[ve];if(_(ee,x[fe-1])<0){x.pop();const de=(0,T.$kb)(x,be=>_(ee,be)<0);x.splice(de,0,ee)}}}function f(Y){return Y.filter(_=>!!_)}e.$Hb=f;function l(Y){let _=0;for(let x=0;x<Y.length;x++)Y[x]&&(Y[_]=Y[x],_+=1);Y.length=_}e.$Ib=l;function t(Y,_,x){Y.splice(x,0,Y.splice(_,1)[0])}e.$Jb=t;function i(Y){return!Array.isArray(Y)||Y.length===0}e.$Kb=i;function c(Y){return Array.isArray(Y)&&Y.length>0}e.$Lb=c;function n(Y,_=x=>x){const x=new Set;return Y.filter(ve=>{const ae=_(ve);return x.has(ae)?!1:(x.add(ae),!0)})}e.$Mb=n;function r(Y){const _=new Set;return x=>{const ve=Y(x);return _.has(ve)?!1:(_.add(ve),!0)}}e.$Nb=r;function u(Y,_){return Y.length>0?Y[0]:_}e.$Ob=u;function I(Y,_){return Y.length>0?Y[Y.length-1]:_}e.$Pb=I;function S(Y,_,x=(ve,ae)=>ve===ae){let ve=0;for(let ae=0,fe=Math.min(Y.length,_.length);ae<fe&&x(Y[ae],_[ae]);ae++)ve++;return ve}e.$Qb=S;function $(Y){return[].concat(...Y)}e.$Rb=$;function g(Y,_){let x=typeof _=="number"?Y:0;typeof _=="number"?x=Y:(x=0,_=Y);const ve=[];if(x<=_)for(let ae=x;ae<_;ae++)ve.push(ae);else for(let ae=x;ae>_;ae--)ve.push(ae);return ve}e.$Sb=g;function w(Y,_,x){return Y.reduce((ve,ae)=>(ve[_(ae)]=x?x(ae):ae,ve),Object.create(null))}e.$Tb=w;function D(Y,_){return Y.push(_),()=>N(Y,_)}e.$Ub=D;function N(Y,_){const x=Y.indexOf(_);if(x>-1)return Y.splice(x,1),_}e.$Vb=N;function M(Y,_,x){const ve=Y.slice(0,_),ae=Y.slice(_);return ve.concat(x,ae)}e.$Wb=M;function F(Y,_){let x;if(typeof _=="number"){let ve=_;x=()=>{const ae=Math.sin(ve++)*179426549;return ae-Math.floor(ae)}}else x=Math.random;for(let ve=Y.length-1;ve>0;ve-=1){const ae=Math.floor(x()*(ve+1)),fe=Y[ve];Y[ve]=Y[ae],Y[ae]=fe}}e.$Xb=F;function U(Y,_){const x=Y.indexOf(_);x>-1&&(Y.splice(x,1),Y.unshift(_))}e.$Yb=U;function j(Y,_){const x=Y.indexOf(_);x>-1&&(Y.splice(x,1),Y.push(_))}e.$Zb=j;function O(Y,_){for(const x of _)Y.push(x)}e.$1b=O;function q(Y,_){return Array.isArray(Y)?Y.map(_):_(Y)}e.$2b=q;function K(Y){return Array.isArray(Y)?Y:[Y]}e.$3b=K;function me(Y){return Y[Math.floor(Math.random()*Y.length)]}e.$4b=me;function te(Y,_,x){const ve=Q(Y,_),ae=Y.length,fe=x.length;Y.length=ae+fe;for(let ee=ae-1;ee>=ve;ee--)Y[ee+fe]=Y[ee];for(let ee=0;ee<fe;ee++)Y[ee+ve]=x[ee]}e.$5b=te;function G(Y,_,x,ve){const ae=Q(Y,_);let fe=Y.splice(ae,x);return fe===void 0&&(fe=[]),te(Y,ae,ve),fe}e.$6b=G;function Q(Y,_){return _<0?Math.max(_+Y.length,0):Math.min(_,Y.length)}var le;(function(Y){function _(fe){return fe<0}Y.isLessThan=_;function x(fe){return fe<=0}Y.isLessThanOrEqual=x;function ve(fe){return fe>0}Y.isGreaterThan=ve;function ae(fe){return fe===0}Y.isNeitherLessOrGreaterThan=ae,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function ie(Y,_){return(x,ve)=>_(Y(x),Y(ve))}e.$7b=ie;function ce(...Y){return(_,x)=>{for(const ve of Y){const ae=ve(_,x);if(!le.isNeitherLessOrGreaterThan(ae))return ae}return le.neitherLessOrGreaterThan}}e.$8b=ce;const ye=(Y,_)=>Y-_;e.$9b=ye;const H=(Y,_)=>(0,e.$9b)(Y?1:0,_?1:0);e.$0b=H;function B(Y){return(_,x)=>-Y(_,x)}e.$$b=B;class X{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let x=this.c;for(;x<this.g.length&&_(this.g[x]);)x++;const ve=x===this.c?null:this.g.slice(this.c,x);return this.c=x,ve}takeFromEndWhile(_){let x=this.d;for(;x>=0&&_(this.g[x]);)x--;const ve=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,ve}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const x=this.g.slice(this.c,this.c+_);return this.c+=_,x}}e.$_b=X;class re{static{this.empty=new re(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(x=>(_(x),!0))}toArray(){const _=[];return this.iterate(x=>(_.push(x),!0)),_}filter(_){return new re(x=>this.iterate(ve=>_(ve)?x(ve):!0))}map(_){return new re(x=>this.iterate(ve=>x(_(ve))))}some(_){let x=!1;return this.iterate(ve=>(x=_(ve),!x)),x}findFirst(_){let x;return this.iterate(ve=>_(ve)?(x=ve,!1):!0),x}findLast(_){let x;return this.iterate(ve=>(_(ve)&&(x=ve),!0)),x}findLastMaxBy(_){let x,ve=!0;return this.iterate(ae=>((ve||le.isGreaterThan(_(ae,x)))&&(ve=!1,x=ae),!0)),x}}e.$ac=re}),define(De[58],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function T(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=T;function d(E,b="Unreachable"){throw new Error(b)}e.$4c=d;function R(E){if(!E)throw new C.$cb("Assertion Failed")}e.$5c=R;function A(E){if(!E()){debugger;E(),(0,C.$1)(new C.$cb("Assertion Failed"))}}e.$6c=A;function m(E,b){let L=0;for(;L<E.length-1;){const P=E[L],v=E[L+1];if(!b(P,v))return!1;L++}return!0}e.$7c=m}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function C(T){const d=this;let R=!1,A;return function(){return R||(R=!0,A=T.apply(d,arguments)),A}}e.$db=C}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0;class C{constructor(d){this.a=d,this.b=0}nextId(){return this.a+ ++this.b}}e.$rM=C,e.$sM=new C("id#")}),define(De[51],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(T){function d(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}T.is=d;const R=Object.freeze([]);function A(){return R}T.empty=A;function*m(l){yield l}T.single=m;function E(l){return d(l)?l:m(l)}T.wrap=E;function b(l){return l||R}T.from=b;function*L(l){for(let t=l.length-1;t>=0;t--)yield l[t]}T.reverse=L;function P(l){return!l||l[Symbol.iterator]().next().done===!0}T.isEmpty=P;function v(l){return l[Symbol.iterator]().next().value}T.first=v;function y(l,t){for(const i of l)if(t(i))return!0;return!1}T.some=y;function k(l,t){for(const i of l)if(t(i))return i}T.find=k;function*p(l,t){for(const i of l)t(i)&&(yield i)}T.filter=p;function*h(l,t){let i=0;for(const c of l)yield t(c,i++)}T.map=h;function*s(...l){for(const t of l)for(const i of t)yield i}T.concat=s;function a(l,t,i){let c=i;for(const n of l)c=t(c,n);return c}T.reduce=a;function*o(l,t,i=l.length){for(t<0&&(t+=l.length),i<0?i+=l.length:i>l.length&&(i=l.length);t<i;t++)yield l[t]}T.slice=o;function f(l,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,l];const c=l[Symbol.iterator]();for(let n=0;n<t;n++){const r=c.next();if(r.done)return[i,T.empty()];i.push(r.value)}return[i,{[Symbol.iterator](){return c}}]}T.consume=f})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function A(t,i=!1){let c=0;const n=t.length;let r="",u=0,I=16,S=0;function $(U){let j=0,O=0;for(;j<U;){const q=t.charCodeAt(c);if(q>=48&&q<=57)O=O*16+q-48;else if(q>=65&&q<=70)O=O*16+q-65+10;else if(q>=97&&q<=102)O=O*16+q-97+10;else break;c++,j++}return j<U&&(O=-1),O}function g(U){c=U,r="",u=0,I=16,S=0}function w(){const U=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&b(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&b(t.charCodeAt(c)))for(c++;c<t.length&&b(t.charCodeAt(c));)c++;else return S=3,t.substring(U,c);let j=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&b(t.charCodeAt(c))){for(c++;c<t.length&&b(t.charCodeAt(c));)c++;j=c}else S=3;return t.substring(U,j)}function D(){let U="",j=c;for(;;){if(c>=n){U+=t.substring(j,c),S=2;break}const O=t.charCodeAt(c);if(O===34){U+=t.substring(j,c),c++;break}if(O===92){if(U+=t.substring(j,c),c++,c>=n){S=2;break}switch(t.charCodeAt(c++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const K=$(4);K>=0?U+=String.fromCharCode(K):S=4;break}default:S=5}j=c;continue}if(O>=0&&O<=31)if(E(O)){U+=t.substring(j,c),S=2;break}else S=6;c++}return U}function N(){if(r="",S=0,u=c,c>=n)return u=n,I=17;let U=t.charCodeAt(c);if(m(U)){do c++,r+=String.fromCharCode(U),U=t.charCodeAt(c);while(m(U));return I=15}if(E(U))return c++,r+=String.fromCharCode(U),U===13&&t.charCodeAt(c)===10&&(c++,r+=`
`),I=14;switch(U){case 123:return c++,I=1;case 125:return c++,I=2;case 91:return c++,I=3;case 93:return c++,I=4;case 58:return c++,I=6;case 44:return c++,I=5;case 34:return c++,r=D(),I=10;case 47:{const j=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<n&&!E(t.charCodeAt(c));)c++;return r=t.substring(j,c),I=12}if(t.charCodeAt(c+1)===42){c+=2;const O=n-1;let q=!1;for(;c<O;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,q=!0;break}c++}return q||(c++,S=1),r=t.substring(j,c),I=13}return r+=String.fromCharCode(U),c++,I=16}case 45:if(r+=String.fromCharCode(U),c++,c===n||!b(t.charCodeAt(c)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=w(),I=11;default:for(;c<n&&M(U);)c++,U=t.charCodeAt(c);if(u!==c){switch(r=t.substring(u,c),r){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return r+=String.fromCharCode(U),c++,I=16}}function M(U){if(m(U)||E(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:g,getPosition:()=>c,scan:i?F:N,getToken:()=>I,getTokenValue:()=>r,getTokenOffset:()=>u,getTokenLength:()=>c-u,getTokenError:()=>S}}e.$Um=A;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function P(t,i){const c=[],n=new Object;let r;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S($,g,w,D){u.value=$,u.offset=g,u.length=w,u.type=D,u.colonOffset=void 0,r=u}try{o(t,{onObjectBegin:($,g)=>{if(i<=$)throw n;r=void 0,I=i>$,c.push("")},onObjectProperty:($,g,w)=>{if(i<g||(S($,g,w,"property"),c[c.length-1]=$,i<=g+w))throw n},onObjectEnd:($,g)=>{if(i<=$)throw n;r=void 0,c.pop()},onArrayBegin:($,g)=>{if(i<=$)throw n;r=void 0,c.push(0)},onArrayEnd:($,g)=>{if(i<=$)throw n;r=void 0,c.pop()},onLiteralValue:($,g,w)=>{if(i<g||(S($,g,w,l($)),i<=g+w))throw n},onSeparator:($,g,w)=>{if(i<=g)throw n;if($===":"&&r&&r.type==="property")r.colonOffset=g,I=!1,r=void 0;else if($===","){const D=c[c.length-1];typeof D=="number"?c[c.length-1]=D+1:(I=!0,c[c.length-1]=""),r=void 0}}})}catch($){if($!==n)throw $}return{path:c,previousNode:r,isAtPropertyKey:I,matches:$=>{let g=0;for(let w=0;g<$.length&&w<c.length;w++)if($[g]===c[w]||$[g]==="*")g++;else if($[g]!=="**")return!1;return g===$.length}}}e.$Vm=P;function v(t,i=[],c=R.DEFAULT){let n=null,r=[];const u=[];function I($){Array.isArray(r)?r.push($):n!==null&&(r[n]=$)}return o(t,{onObjectBegin:()=>{const $={};I($),u.push(r),r=$,n=null},onObjectProperty:$=>{n=$},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const $=[];I($),u.push(r),r=$,n=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:I,onError:($,g,w)=>{i.push({error:$,offset:g,length:w})}},c),r[0]}e.$Wm=v;function y(t,i=[],c=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r($){n.type==="property"&&(n.length=$-n.offset,n=n.parent)}function u($){return n.children.push($),$}o(t,{onObjectBegin:$=>{n=u({type:"object",offset:$,length:-1,parent:n,children:[]})},onObjectProperty:($,g,w)=>{n=u({type:"property",offset:g,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:$,offset:g,length:w,parent:n})},onObjectEnd:($,g)=>{n.length=$+g-n.offset,n=n.parent,r($+g)},onArrayBegin:($,g)=>{n=u({type:"array",offset:$,length:-1,parent:n,children:[]})},onArrayEnd:($,g)=>{n.length=$+g-n.offset,n=n.parent,r($+g)},onLiteralValue:($,g,w)=>{u({type:l($),offset:g,length:w,parent:n,value:$}),r(g+w)},onSeparator:($,g,w)=>{n.type==="property"&&($===":"?n.colonOffset=g:$===","&&r(g))},onError:($,g,w)=>{i.push({error:$,offset:g,length:w})}},c);const S=n.children[0];return S&&delete S.parent,S}e.$Xm=y;function k(t,i){if(!t)return;let c=t;for(const n of i)if(typeof n=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let r=!1;for(const u of c.children)if(Array.isArray(u.children)&&u.children[0].value===n){c=u.children[1],r=!0;break}if(!r)return}else{const r=n;if(c.type!=="array"||r<0||!Array.isArray(c.children)||r>=c.children.length)return;c=c.children[r]}return c}e.$Ym=k;function p(t){if(!t.parent||!t.parent.children)return[];const i=p(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;i.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&i.push(c)}return i}e.$Zm=p;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const i=Object.create(null);for(const c of t.children){const n=c.children[1];n&&(i[c.children[0].value]=h(n))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$1m=h;function s(t,i,c=!1){return i>=t.offset&&i<t.offset+t.length||c&&i===t.offset+t.length}e.$2m=s;function a(t,i,c=!1){if(s(t,i,c)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=i;r++){const u=a(n[r],i,c);if(u)return u}return t}}e.$3m=a;function o(t,i,c=R.DEFAULT){const n=A(t,!1);function r(ie){return ie?()=>ie(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(ie){return ie?ce=>ie(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const I=r(i.onObjectBegin),S=u(i.onObjectProperty),$=r(i.onObjectEnd),g=r(i.onArrayBegin),w=r(i.onArrayEnd),D=u(i.onLiteralValue),N=u(i.onSeparator),M=r(i.onComment),F=u(i.onError),U=c&&c.disallowComments,j=c&&c.allowTrailingComma;function O(){for(;;){const ie=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:U||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(ie){case 12:case 13:U?q(10):M();break;case 16:q(1);break;case 15:case 14:break;default:return ie}}}function q(ie,ce=[],ye=[]){if(F(ie),ce.length+ye.length>0){let H=n.getToken();for(;H!==17;){if(ce.indexOf(H)!==-1){O();break}else if(ye.indexOf(H)!==-1)break;H=O()}}}function K(ie){const ce=n.getTokenValue();return ie?D(ce):S(ce),O(),!0}function me(){switch(n.getToken()){case 11:{let ie=0;try{ie=JSON.parse(n.getTokenValue()),typeof ie!="number"&&(q(2),ie=0)}catch{q(2)}D(ie);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return O(),!0}function te(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(K(!1),n.getToken()===6?(N(":"),O(),le()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function G(){I(),O();let ie=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ie||q(4,[],[]),N(","),O(),n.getToken()===2&&j)break}else ie&&q(6,[],[]);te()||q(4,[],[2,5]),ie=!0}return $(),n.getToken()!==2?q(7,[2],[]):O(),!0}function Q(){g(),O();let ie=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ie||q(4,[],[]),N(","),O(),n.getToken()===4&&j)break}else ie&&q(6,[],[]);le()||q(4,[],[4,5]),ie=!0}return w(),n.getToken()!==4?q(8,[4],[]):O(),!0}function le(){switch(n.getToken()){case 3:return Q();case 1:return G();case 10:return K(!0);default:return me()}}return O(),n.getToken()===17?c.allowEmptyContent?!0:(q(4,[],[]),!1):le()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$4m=o;function f(t,i){const c=A(t),n=[];let r,u=0,I;do switch(I=c.getPosition(),r=c.scan(),r){case 12:case 13:case 17:u!==I&&n.push(t.substring(u,I)),i!==void 0&&n.push(c.getTokenValue().replace(/[^\r\n]/g,i)),u=c.getPosition();break}while(r!==17);return n.join("")}e.$5m=f;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=l}),define(De[47],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class C{constructor(d){this.d=d,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(d){this.c=d}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=C}),define(De[76],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(R){this.element=R,this.next=C.Undefined,this.prev=C.Undefined}}class T{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let R=this.a;for(;R!==C.Undefined;){const A=R.next;R.prev=C.Undefined,R.next=C.Undefined,R=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const m=new C(R);if(this.a===C.Undefined)this.a=m,this.b=m;else if(A){const b=this.b;this.b=m,m.prev=b,b.next=m}else{const b=this.a;this.a=m,m.next=b,b.prev=m}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(m))}}shift(){if(this.a!==C.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==C.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==C.Undefined&&R.next!==C.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===C.Undefined&&R.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):R.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):R.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==C.Undefined;)yield R.element,R=R.next}}e.$2c=T}),define(De[28],Ce([1,0]),function($e,e){"use strict";var C,T,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function R(a,o,f){let l=a.get(o);return l===void 0&&(l=f,a.set(o,l)),l}e.$xc=R;function A(a){const o=[];return a.forEach((f,l)=>{o.push(`${l} => ${f}`)}),`Map(${a.size}) {${o.join(", ")}}`}e.$yc=A;function m(a){const o=[];return a.forEach(f=>{o.push(f)}),`Set(${a.size}) {${o.join(", ")}}`}e.$zc=m;class E{constructor(o,f){this.uri=o,this.value=f}}function b(a){return Array.isArray(a)}class L{static{this.a=o=>o.toString()}constructor(o,f){if(this[C]="ResourceMap",o instanceof L)this.b=new Map(o.b),this.c=f??L.a;else if(b(o)){this.b=new Map,this.c=f??L.a;for(const[l,t]of o)this.set(l,t)}else this.b=new Map,this.c=o??L.a}set(o,f){return this.b.set(this.c(o),new E(o,f)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,f){typeof f<"u"&&(o=o.bind(f));for(const[l,t]of this.b)o(t.value,t.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$Ac=L;class P{constructor(o,f){this[T]="ResourceSet",!o||typeof o=="function"?this.a=new L(o):(this.a=new L(f),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,f){this.a.forEach((l,t)=>o.call(f,t,t,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=P;var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class y{constructor(){this[d]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,f=0){const l=this.a.get(o);if(l)return f!==0&&this.j(l,f),l.value}set(o,f,l=0){let t=this.a.get(o);if(t)t.value=f,l!==0&&this.j(t,l);else{switch(t={key:o,value:f,next:void 0,previous:void 0},l){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(o,t),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const f=this.a.get(o);if(f)return this.a.delete(o),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,f){const l=this.e;let t=this.b;for(;t;){if(f?o.bind(f)(t.value,t.key,this):o(t.value,t.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const o=this,f=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const i={value:l.key,done:!1};return l=l.next,i}else return{value:void 0,done:!0}}};return t}values(){const o=this,f=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const i={value:l.value,done:!1};return l=l.next,i}else return{value:void 0,done:!0}}};return t}entries(){const o=this,f=this.e;let l=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const i={value:[l.key,l.value],done:!1};return l=l.next,i}else return{value:void 0,done:!0}}};return t}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let f=this.b,l=this.size;for(;f&&l>o;)this.a.delete(f.key),f=f.next,l--;this.b=f,this.d=l,f&&(f.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const f=o.next,l=o.previous;if(!f||!l)throw new Error("Invalid list");f.previous=l,l.next=f}o.next=void 0,o.previous=void 0,this.e++}j(o,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(o===this.b)return;const l=o.next,t=o.previous;o===this.c?(t.next=void 0,this.c=t):(l.previous=t,t.next=l),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(f===2){if(o===this.c)return;const l=o.next,t=o.previous;o===this.b?(l.previous=void 0,this.b=l):(l.previous=t,t.next=l),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((f,l)=>{o.push([l,f])}),o}fromJSON(o){this.clear();for(const[f,l]of o)this.set(f,l)}}e.$Cc=y;class k extends y{constructor(o,f=1){super(),this.k=o,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,f=2){return super.get(o,f)}peek(o){return super.get(o,0)}set(o,f){return super.set(o,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class p{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let f=this.a.get(o)||0;return f===0?!1:(f--,f===0?this.a.delete(o):this.a.set(o,f),!0)}has(o){return this.a.has(o)}}e.$Ec=p;class h{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[f,l]of o)this.set(f,l)}clear(){this.a.clear(),this.b.clear()}set(o,f){this.a.set(o,f),this.b.set(f,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const f=this.a.get(o);return f===void 0?!1:(this.a.delete(o),this.b.delete(f),!0)}forEach(o,f){this.a.forEach((l,t)=>{o.call(f,l,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=h;class s{constructor(){this.a=new Map}add(o,f){let l=this.a.get(o);l||(l=new Set,this.a.set(o,l)),l.add(f)}delete(o,f){const l=this.a.get(o);l&&(l.delete(f),l.size===0&&this.a.delete(o))}forEach(o,f){const l=this.a.get(o);l&&l.forEach(f)}get(o){const f=this.a.get(o);return f||new Set}}e.$Gc=s}),define(De[3],Ce([1,0,19,74,28,75,51]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const m=!1;let E=null;class b{constructor(){this.b=new Map}static{this.a=0}c(w){let D=this.b.get(w);return D||(D={parent:null,source:null,isSingleton:!1,value:w,idx:b.a++},this.b.set(w,D)),D}trackDisposable(w){const D=this.c(w);D.source||(D.source=new Error().stack)}setParent(w,D){const N=this.c(w);N.parent=D}markAsDisposed(w){this.b.delete(w)}markAsSingleton(w){this.c(w).isSingleton=!0}f(w,D){const N=D.get(w);if(N)return N;const M=w.parent?this.f(this.c(w.parent),D):w;return D.set(w,M),M}getTrackedDisposables(){const w=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,w).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(w=10,D){let N;if(D)N=D;else{const O=new Map,q=[...this.b.values()].filter(me=>me.source!==null&&!this.f(me,O).isSingleton);if(q.length===0)return;const K=new Set(q.map(me=>me.value));if(N=q.filter(me=>!(me.parent&&K.has(me.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function M(O){function q(me,te){for(;me.length>0&&te.some(G=>typeof G=="string"?G===me[0]:me[0].match(G));)me.shift()}const K=O.source.split(`
`).map(me=>me.trim().replace("at ","")).filter(me=>me!=="");return q(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const F=new d.$Gc;for(const O of N){const q=M(O);for(let K=0;K<=q.length;K++)F.add(q.slice(0,K).join(`
`),O)}N.sort((0,C.$7b)(O=>O.idx,C.$9b));let U="",j=0;for(const O of N.slice(0,w)){j++;const q=M(O),K=[];for(let me=0;me<q.length;me++){let te=q[me];te=`(shared with ${F.get(q.slice(0,me+1).join(`
`)).size}/${N.length} leaks) at ${te}`;const Q=F.get(q.slice(0,me).join(`
`)),le=(0,T.$J)([...Q].map(ie=>M(ie)[me]),ie=>ie);delete le[q[me]];for(const[ie,ce]of Object.entries(le))K.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${ie}`);K.unshift(te)}U+=`


==================== Leaking disposable ${j}/${N.length}: ${O.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return N.length>w&&(U+=`


... and ${N.length-w} more leaking disposables

`),{leaks:N,details:U}}}e.$Hc=b;function L(g){E=g}if(e.$Ic=L,m){const g="__is_disposable_tracked__";L(new class{trackDisposable(w){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[g]||console.log(D)},3e3)}setParent(w,D){if(w&&w!==t.None)try{w[g]=!0}catch{}}markAsDisposed(w){if(w&&w!==t.None)try{w[g]=!0}catch{}}markAsSingleton(w){}})}function P(g){return E?.trackDisposable(g),g}e.$Jc=P;function v(g){E?.markAsDisposed(g)}e.$Kc=v;function y(g,w){E?.setParent(g,w)}function k(g,w){if(E)for(const D of g)E.setParent(D,w)}function p(g){return E?.markAsSingleton(g),g}e.$Lc=p;function h(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.$Mc=h;function s(g){if(A.Iterable.is(g)){const w=[];for(const D of g)if(D)try{D.dispose()}catch(N){w.push(N)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.$Nc=s;function a(g){for(const w of g)h(w)&&w.dispose();return[]}e.$Oc=a;function o(...g){const w=f(()=>s(g));return k(g,w),w}e.$Pc=o;function f(g){const w=P({dispose:(0,R.$db)(()=>{v(w),g()})});return w}e.$Qc=f;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return y(w,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(w),w}delete(w){if(w){if(w===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(w),w.dispose()}}deleteAndLeak(w){w&&this.f.has(w)&&(this.f.delete(w),y(w,null))}}e.$Rc=l;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,P(this),y(this.q,this)}dispose(){v(this),this.q.dispose()}B(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(w)}}e.$Sc=t;class i{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(w){this.b||w===this.a||(this.a?.dispose(),w&&y(w,this),this.a=w)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const w=this.a;return this.a=void 0,w&&y(w,null),w}}e.$Tc=i;class c{constructor(w){this.b=w,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=c;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(w){let D=w;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,v(this))},this}}e.$Vc=n;class r{constructor(){this.a=new Map}acquire(w,...D){let N=this.a.get(w);N||(N={counter:0,object:this.b(w,...D)},this.a.set(w,N));const{object:M}=N,F=(0,R.$db)(()=>{--N.counter===0&&(this.c(w,N.object),this.a.delete(w))});return N.counter++,{object:M,dispose:F}}}e.$Wc=r;class u{constructor(w){this.a=w}async acquire(w,...D){const N=this.a.acquire(w,...D);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(M){throw N.dispose(),M}}}e.$Xc=u;class I{constructor(w){this.object=w}dispose(){}}e.$Yc=I;function S(g){const w=new l;try{g(w)}finally{w.dispose()}}e.$Zc=S;class ${constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(w){return this.a.has(w)}get size(){return this.a.size}get(w){return this.a.get(w)}set(w,D,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(w)?.dispose(),this.a.set(w,D)}deleteAndDispose(w){this.a.get(w)?.dispose(),this.a.delete(w)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=$}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(_,x){for(var ve=0;ve<x.length;ve++){var ae=x[ve];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(_,ae.key,ae)}}function C(_,x,ve){return x&&e(_.prototype,x),ve&&e(_,ve),Object.defineProperty(_,"prototype",{writable:!1}),_}function T(_,x){if(_){if(typeof _=="string")return d(_,x);var ve=Object.prototype.toString.call(_).slice(8,-1);if(ve==="Object"&&_.constructor&&(ve=_.constructor.name),ve==="Map"||ve==="Set")return Array.from(_);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return d(_,x)}}function d(_,x){(x==null||x>_.length)&&(x=_.length);for(var ve=0,ae=new Array(x);ve<x;ve++)ae[ve]=_[ve];return ae}function R(_,x){var ve=typeof Symbol<"u"&&_[Symbol.iterator]||_["@@iterator"];if(ve)return(ve=ve.call(_)).next.bind(ve);if(Array.isArray(_)||(ve=T(_))||x&&_&&typeof _.length=="number"){ve&&(_=ve);var ae=0;return function(){return ae>=_.length?{done:!0}:{done:!1,value:_[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function m(_){$e.defaults=_}var E=/[&<>"']/,b=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(x){return v[x]};function k(_,x){if(x){if(E.test(_))return _.replace(b,y)}else if(L.test(_))return _.replace(P,y);return _}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(_){return _.replace(p,function(x,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var s=/(^|[^\[])\^/g;function a(_,x){_=typeof _=="string"?_:_.source,x=x||"";var ve={replace:function(fe,ee){return ee=ee.source||ee,ee=ee.replace(s,"$1"),_=_.replace(fe,ee),ve},getRegex:function(){return new RegExp(_,x)}};return ve}var o=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(_,x,ve){if(_){var ae;try{ae=decodeURIComponent(h(ve)).replace(o,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}x&&!f.test(ve)&&(ve=r(x,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var t={},i=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(_,x){t[" "+_]||(i.test(_)?t[" "+_]=_+"/":t[" "+_]=$(_,"/",!0)),_=t[" "+_];var ve=_.indexOf(":")===-1;return x.substring(0,2)==="//"?ve?x:_.replace(c,"$1")+x:x.charAt(0)==="/"?ve?x:_.replace(n,"$1")+x:_+x}var u={exec:function(){}};function I(_){for(var x=1,ve,ae;x<arguments.length;x++){ve=arguments[x];for(ae in ve)Object.prototype.hasOwnProperty.call(ve,ae)&&(_[ae]=ve[ae])}return _}function S(_,x){var ve=_.replace(/\|/g,function(ee,de,be){for(var Pe=!1,z=de;--z>=0&&be[z]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ae=ve.split(/ \|/),fe=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>x)ae.splice(x);else for(;ae.length<x;)ae.push("");for(;fe<ae.length;fe++)ae[fe]=ae[fe].trim().replace(/\\\|/g,"|");return ae}function $(_,x,ve){var ae=_.length;if(ae===0)return"";for(var fe=0;fe<ae;){var ee=_.charAt(ae-fe-1);if(ee===x&&!ve)fe++;else if(ee!==x&&ve)fe++;else break}return _.slice(0,ae-fe)}function g(_,x){if(_.indexOf(x[1])===-1)return-1;for(var ve=_.length,ae=0,fe=0;fe<ve;fe++)if(_[fe]==="\\")fe++;else if(_[fe]===x[0])ae++;else if(_[fe]===x[1]&&(ae--,ae<0))return fe;return-1}function w(_){_&&_.sanitize&&!_.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(_,x){if(x<1)return"";for(var ve="";x>1;)x&1&&(ve+=_),x>>=1,_+=_;return ve+_}function N(_,x,ve,ae){var fe=x.href,ee=x.title?k(x.title):null,de=_[1].replace(/\\([\[\]])/g,"$1");if(_[0].charAt(0)!=="!"){ae.state.inLink=!0;var be={type:"link",raw:ve,href:fe,title:ee,text:de,tokens:ae.inlineTokens(de)};return ae.state.inLink=!1,be}return{type:"image",raw:ve,href:fe,title:ee,text:k(de)}}function M(_,x){var ve=_.match(/^(\s+)(?:```)/);if(ve===null)return x;var ae=ve[1];return x.split(`
`).map(function(fe){var ee=fe.match(/^\s+/);if(ee===null)return fe;var de=ee[0];return de.length>=ae.length?fe.slice(ae.length):fe}).join(`
`)}var F=function(){function _(ve){this.options=ve||$e.defaults}var x=_.prototype;return x.space=function(ae){var fe=this.rules.block.newline.exec(ae);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},x.code=function(ae){var fe=this.rules.block.code.exec(ae);if(fe){var ee=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:$(ee,`
`)}}},x.fences=function(ae){var fe=this.rules.block.fences.exec(ae);if(fe){var ee=fe[0],de=M(ee,fe[3]||"");return{type:"code",raw:ee,lang:fe[2]?fe[2].trim():fe[2],text:de}}},x.heading=function(ae){var fe=this.rules.block.heading.exec(ae);if(fe){var ee=fe[2].trim();if(/#$/.test(ee)){var de=$(ee,"#");(this.options.pedantic||!de||/ $/.test(de))&&(ee=de.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ee,tokens:this.lexer.inline(ee)}}},x.hr=function(ae){var fe=this.rules.block.hr.exec(ae);if(fe)return{type:"hr",raw:fe[0]}},x.blockquote=function(ae){var fe=this.rules.block.blockquote.exec(ae);if(fe){var ee=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},x.list=function(ae){var fe=this.rules.block.list.exec(ae);if(fe){var ee,de,be,Pe,z,J,se,oe,Z,ge,Ee,je,We=fe[1].trim(),_e=We.length>1,Xe={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(je=!1,!(!(fe=it.exec(ae))||this.rules.block.hr.test(ae)));){if(ee=fe[0],ae=ae.substring(ee.length),oe=fe[2].split(`
`,1)[0],Z=ae.split(`
`,1)[0],this.options.pedantic?(Pe=2,Ee=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,Ee=oe.slice(Pe),Pe+=fe[1].length),J=!1,!oe&&/^ *$/.test(Z)&&(ee+=Z+`
`,ae=ae.substring(Z.length+1),je=!0),!je)for(var tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ae&&(ge=ae.split(`
`,1)[0],oe=ge,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(oe)||qe.test(oe)||tt.test(oe)||Ae.test(ae)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())Ee+=`
`+oe.slice(Pe);else if(!J)Ee+=`
`+oe;else break;!J&&!oe.trim()&&(J=!0),ee+=ge+`
`,ae=ae.substring(ge.length+1)}Xe.loose||(se?Xe.loose=!0:/\n *\n *$/.test(ee)&&(se=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Ee),de&&(be=de[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:ee,task:!!de,checked:be,loose:!1,text:Ee}),Xe.raw+=ee}Xe.items[Xe.items.length-1].raw=ee.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Le=Xe.items.length;for(z=0;z<Le;z++){this.lexer.state.top=!1,Xe.items[z].tokens=this.lexer.blockTokens(Xe.items[z].text,[]);var Ye=Xe.items[z].tokens.filter(function(ue){return ue.type==="space"}),he=Ye.every(function(ue){for(var Ie=ue.raw.split(""),Ke=0,Ue=R(Ie),Ze;!(Ze=Ue()).done;){var nt=Ze.value;if(nt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Xe.loose&&Ye.length&&he&&(Xe.loose=!0,Xe.items[z].loose=!0)}return Xe}},x.html=function(ae){var fe=this.rules.block.html.exec(ae);if(fe){var ee={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]);ee.type="paragraph",ee.text=de,ee.tokens=this.lexer.inline(de)}return ee}},x.def=function(ae){var fe=this.rules.block.def.exec(ae);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ee=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:fe[0],href:fe[2],title:fe[3]}}},x.table=function(ae){var fe=this.rules.block.table.exec(ae);if(fe){var ee={type:"table",header:S(fe[1]).map(function(se){return{text:se}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=fe[0];var de=ee.align.length,be,Pe,z,J;for(be=0;be<de;be++)/^ *-+: *$/.test(ee.align[be])?ee.align[be]="right":/^ *:-+: *$/.test(ee.align[be])?ee.align[be]="center":/^ *:-+ *$/.test(ee.align[be])?ee.align[be]="left":ee.align[be]=null;for(de=ee.rows.length,be=0;be<de;be++)ee.rows[be]=S(ee.rows[be],ee.header.length).map(function(se){return{text:se}});for(de=ee.header.length,Pe=0;Pe<de;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(de=ee.rows.length,Pe=0;Pe<de;Pe++)for(J=ee.rows[Pe],z=0;z<J.length;z++)J[z].tokens=this.lexer.inline(J[z].text);return ee}}},x.lheading=function(ae){var fe=this.rules.block.lheading.exec(ae);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},x.paragraph=function(ae){var fe=this.rules.block.paragraph.exec(ae);if(fe){var ee=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ee,tokens:this.lexer.inline(ee)}}},x.text=function(ae){var fe=this.rules.block.text.exec(ae);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},x.escape=function(ae){var fe=this.rules.inline.escape.exec(ae);if(fe)return{type:"escape",raw:fe[0],text:k(fe[1])}},x.tag=function(ae){var fe=this.rules.inline.tag.exec(ae);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):k(fe[0]):fe[0]}},x.link=function(ae){var fe=this.rules.inline.link.exec(ae);if(fe){var ee=fe[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var de=$(ee.slice(0,-1),"\\");if((ee.length-de.length)%2===0)return}else{var be=g(fe[2],"()");if(be>-1){var Pe=fe[0].indexOf("!")===0?5:4,z=Pe+fe[1].length+be;fe[2]=fe[2].substring(0,be),fe[0]=fe[0].substring(0,z).trim(),fe[3]=""}}var J=fe[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);oe&&(J=oe[1],se=oe[3])}else se=fe[3]?fe[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(ee)?J=J.slice(1):J=J.slice(1,-1)),N(fe,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},x.reflink=function(ae,fe){var ee;if((ee=this.rules.inline.reflink.exec(ae))||(ee=this.rules.inline.nolink.exec(ae))){var de=(ee[2]||ee[1]).replace(/\s+/g," ");if(de=fe[de.toLowerCase()],!de||!de.href){var be=ee[0].charAt(0);return{type:"text",raw:be,text:be}}return N(ee,de,ee[0],this.lexer)}},x.emStrong=function(ae,fe,ee){ee===void 0&&(ee="");var de=this.rules.inline.emStrong.lDelim.exec(ae);if(de&&!(de[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=de[1]||de[2]||"";if(!be||be&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=de[0].length-1,z,J,se=Pe,oe=0,Z=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,fe=fe.slice(-1*ae.length+Pe);(de=Z.exec(fe))!=null;)if(z=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!z){if(J=z.length,de[3]||de[4]){se+=J;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+J)%3)){oe+=J;continue}if(se-=J,!(se>0)){if(J=Math.min(J,J+se+oe),Math.min(Pe,J)%2){var ge=ae.slice(1,Pe+de.index+J);return{type:"em",raw:ae.slice(0,Pe+de.index+J+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var Ee=ae.slice(2,Pe+de.index+J-1);return{type:"strong",raw:ae.slice(0,Pe+de.index+J+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},x.codespan=function(ae){var fe=this.rules.inline.code.exec(ae);if(fe){var ee=fe[2].replace(/\n/g," "),de=/[^ ]/.test(ee),be=/^ /.test(ee)&&/ $/.test(ee);return de&&be&&(ee=ee.substring(1,ee.length-1)),ee=k(ee,!0),{type:"codespan",raw:fe[0],text:ee}}},x.br=function(ae){var fe=this.rules.inline.br.exec(ae);if(fe)return{type:"br",raw:fe[0]}},x.del=function(ae){var fe=this.rules.inline.del.exec(ae);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},x.autolink=function(ae,fe){var ee=this.rules.inline.autolink.exec(ae);if(ee){var de,be;return ee[2]==="@"?(de=k(this.options.mangle?fe(ee[1]):ee[1]),be="mailto:"+de):(de=k(ee[1]),be=de),{type:"link",raw:ee[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.url=function(ae,fe){var ee;if(ee=this.rules.inline.url.exec(ae)){var de,be;if(ee[2]==="@")de=k(this.options.mangle?fe(ee[0]):ee[0]),be="mailto:"+de;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);de=k(ee[0]),ee[1]==="www."?be="http://"+de:be=de}return{type:"link",raw:ee[0],text:de,href:be,tokens:[{type:"text",raw:de,text:de}]}}},x.inlineText=function(ae,fe){var ee=this.rules.inline.text.exec(ae);if(ee){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):k(ee[0]):ee[0]:de=k(this.options.smartypants?fe(ee[0]):ee[0]),{type:"text",raw:ee[0],text:de}}},_}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=a(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=a(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=a(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=a(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=a(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=I({},U),U.gfm=I({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=a(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=I({},U.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:a(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=a(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=a(U._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=a(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=a(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=a(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=a(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=a(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=a(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=a(j.reflink).replace("label",j._label).replace("ref",U._label).getRegex(),j.nolink=a(j.nolink).replace("ref",U._label).getRegex(),j.reflinkSearch=a(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=I({},j),j.pedantic=I({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=I({},j.normal,{escape:a(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=a(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=I({},j.gfm,{br:a(j.br).replace("{2,}","*").getRegex(),text:a(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(_){return _.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(_){var x="",ve,ae,fe=_.length;for(ve=0;ve<fe;ve++)ae=_.charCodeAt(ve),Math.random()>.5&&(ae="x"+ae.toString(16)),x+="&#"+ae+";";return x}var K=function(){function _(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||$e.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:U.normal,inline:j.normal};this.options.pedantic?(ae.block=U.pedantic,ae.inline=j.pedantic):this.options.gfm&&(ae.block=U.gfm,this.options.breaks?ae.inline=j.breaks:ae.inline=j.gfm),this.tokenizer.rules=ae}_.lex=function(ae,fe){var ee=new _(fe);return ee.lex(ae)},_.lexInline=function(ae,fe){var ee=new _(fe);return ee.inlineTokens(ae)};var x=_.prototype;return x.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},x.blockTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,oe,Z){return oe+"    ".repeat(Z.length)});for(var de,be,Pe,z;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(de=se.call({lexer:ee},ae,fe))?(ae=ae.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.space(ae)){ae=ae.substring(de.raw.length),de.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(de);continue}if(de=this.tokenizer.code(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(de=this.tokenizer.fences(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.heading(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.hr(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.blockquote(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.list(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.html(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.def(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+de.raw,be.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.lheading(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=ae.slice(1),Z=void 0;ee.options.extensions.startBlock.forEach(function(ge){Z=ge.call({lexer:this},oe),typeof Z=="number"&&Z>=0&&(se=Math.min(se,Z))}),se<1/0&&se>=0&&(Pe=ae.substring(0,se+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){be=fe[fe.length-1],z&&be.type==="paragraph"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de),z=Pe.length!==ae.length,ae=ae.substring(de.raw.length);continue}if(de=this.tokenizer.text(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=`
`+de.raw,be.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):fe.push(de);continue}if(ae){var J="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,fe},x.inline=function(ae,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ae,tokens:fe}),fe},x.inlineTokens=function(ae,fe){var ee=this;fe===void 0&&(fe=[]);var de,be,Pe,z=ae,J,se,oe;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(z))!=null;)Z.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(z=z.slice(0,J.index)+"["+D("a",J[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(z))!=null;)z=z.slice(0,J.index)+"["+D("a",J[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(z))!=null;)z=z.slice(0,J.index)+"++"+z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(de=Ee.call({lexer:ee},ae,fe))?(ae=ae.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.escape(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(ae)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(de.raw.length),be=fe[fe.length-1],be&&de.type==="text"&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(ae,z,oe)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.codespan(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.autolink(ae,q)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(ae,q))){ae=ae.substring(de.raw.length),fe.push(de);continue}if(Pe=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,je=ae.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(Ee=Math.min(Ee,We))}),Ee<1/0&&Ee>=0&&(Pe=ae.substring(0,Ee+1))}(),de=this.tokenizer.inlineText(Pe,O)){ae=ae.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(oe=de.raw.slice(-1)),se=!0,be=fe[fe.length-1],be&&be.type==="text"?(be.raw+=de.raw,be.text+=de.text):fe.push(de);continue}if(ae){var ge="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},C(_,null,[{key:"rules",get:function(){return{block:U,inline:j}}}]),_}(),me=function(){function _(ve){this.options=ve||$e.defaults}var x=_.prototype;return x.code=function(ae,fe,ee){var de=(fe||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(ae,de);be!=null&&be!==ae&&(ee=!0,ae=be)}return ae=ae.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+k(de,!0)+'">'+(ee?ae:k(ae,!0))+`</code></pre>
`:"<pre><code>"+(ee?ae:k(ae,!0))+`</code></pre>
`},x.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},x.html=function(ae){return ae},x.heading=function(ae,fe,ee,de){if(this.options.headerIds){var be=this.options.headerPrefix+de.slug(ee);return"<h"+fe+' id="'+be+'">'+ae+"</h"+fe+`>
`}return"<h"+fe+">"+ae+"</h"+fe+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(ae,fe,ee){var de=fe?"ol":"ul",be=fe&&ee!==1?' start="'+ee+'"':"";return"<"+de+be+`>
`+ae+"</"+de+`>
`},x.listitem=function(ae){return"<li>"+ae+`</li>
`},x.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(ae){return"<p>"+ae+`</p>
`},x.table=function(ae,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+fe+`</table>
`},x.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},x.tablecell=function(ae,fe){var ee=fe.header?"th":"td",de=fe.align?"<"+ee+' align="'+fe.align+'">':"<"+ee+">";return de+ae+("</"+ee+`>
`)},x.strong=function(ae){return"<strong>"+ae+"</strong>"},x.em=function(ae){return"<em>"+ae+"</em>"},x.codespan=function(ae){return"<code>"+ae+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(ae){return"<del>"+ae+"</del>"},x.link=function(ae,fe,ee){if(ae=l(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var de='<a href="'+k(ae)+'"';return fe&&(de+=' title="'+fe+'"'),de+=">"+ee+"</a>",de},x.image=function(ae,fe,ee){if(ae=l(this.options.sanitize,this.options.baseUrl,ae),ae===null)return ee;var de='<img src="'+ae+'" alt="'+ee+'"';return fe&&(de+=' title="'+fe+'"'),de+=this.options.xhtml?"/>":">",de},x.text=function(ae){return ae},_}(),te=function(){function _(){}var x=_.prototype;return x.strong=function(ae){return ae},x.em=function(ae){return ae},x.codespan=function(ae){return ae},x.del=function(ae){return ae},x.html=function(ae){return ae},x.text=function(ae){return ae},x.link=function(ae,fe,ee){return""+ee},x.image=function(ae,fe,ee){return""+ee},x.br=function(){return""},_}(),G=function(){function _(){this.seen={}}var x=_.prototype;return x.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(ae,fe){var ee=ae,de=0;if(this.seen.hasOwnProperty(ee)){de=this.seen[ae];do de++,ee=ae+"-"+de;while(this.seen.hasOwnProperty(ee))}return fe||(this.seen[ae]=de,this.seen[ee]=0),ee},x.slug=function(ae,fe){fe===void 0&&(fe={});var ee=this.serialize(ae);return this.getNextSafeSlug(ee,fe.dryrun)},_}(),Q=function(){function _(ve){this.options=ve||$e.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new G}_.parse=function(ae,fe){var ee=new _(fe);return ee.parse(ae)},_.parseInline=function(ae,fe){var ee=new _(fe);return ee.parseInline(ae)};var x=_.prototype;return x.parse=function(ae,fe){fe===void 0&&(fe=!0);var ee="",de,be,Pe,z,J,se,oe,Z,ge,Ee,je,We,_e,Xe,it,tt,Ae,Ne,qe,Le=ae.length;for(de=0;de<Le;de++){if(Ee=ae[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(qe=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){ee+=qe||"";continue}switch(Ee.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,h(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(Z="",oe="",z=Ee.header.length,be=0;be<z;be++)oe+=this.renderer.tablecell(this.parseInline(Ee.header[be].tokens),{header:!0,align:Ee.align[be]});for(Z+=this.renderer.tablerow(oe),ge="",z=Ee.rows.length,be=0;be<z;be++){for(se=Ee.rows[be],oe="",J=se.length,Pe=0;Pe<J;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:Ee.align[Pe]});ge+=this.renderer.tablerow(oe)}ee+=this.renderer.table(Z,ge);continue}case"blockquote":{ge=this.parse(Ee.tokens),ee+=this.renderer.blockquote(ge);continue}case"list":{for(je=Ee.ordered,We=Ee.start,_e=Ee.loose,z=Ee.items.length,ge="",be=0;be<z;be++)it=Ee.items[be],tt=it.checked,Ae=it.task,Xe="",it.task&&(Ne=this.renderer.checkbox(tt),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Xe+=Ne),Xe+=this.parse(it.tokens,_e),ge+=this.renderer.listitem(Xe,Ae,tt);ee+=this.renderer.list(ge,je,We);continue}case"html":{ee+=this.renderer.html(Ee.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ge=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;de+1<Le&&ae[de+1].type==="text";)Ee=ae[++de],ge+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);ee+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Ye='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return ee},x.parseInline=function(ae,fe){fe=fe||this.renderer;var ee="",de,be,Pe,z=ae.length;for(de=0;de<z;de++){if(be=ae[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){ee+=Pe||"";continue}switch(be.type){case"escape":{ee+=fe.text(be.text);break}case"html":{ee+=fe.html(be.text);break}case"link":{ee+=fe.link(be.href,be.title,this.parseInline(be.tokens,fe));break}case"image":{ee+=fe.image(be.href,be.title,be.text);break}case"strong":{ee+=fe.strong(this.parseInline(be.tokens,fe));break}case"em":{ee+=fe.em(this.parseInline(be.tokens,fe));break}case"codespan":{ee+=fe.codespan(be.text);break}case"br":{ee+=fe.br();break}case"del":{ee+=fe.del(this.parseInline(be.tokens,fe));break}case"text":{ee+=fe.text(be.text);break}default:{var J='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ee},_}();function le(_,x,ve){if(typeof _>"u"||_===null)throw new Error("marked(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");if(typeof x=="function"&&(ve=x,x=null),x=I({},le.defaults,x||{}),w(x),ve){var ae=x.highlight,fe;try{fe=K.lex(_,x)}catch(z){return ve(z)}var ee=function(J){var se;if(!J)try{x.walkTokens&&le.walkTokens(fe,x.walkTokens),se=Q.parse(fe,x)}catch(oe){J=oe}return x.highlight=ae,J?ve(J):ve(null,se)};if(!ae||ae.length<3||(delete x.highlight,!fe.length))return ee();var de=0;le.walkTokens(fe,function(z){z.type==="code"&&(de++,setTimeout(function(){ae(z.text,z.lang,function(J,se){if(J)return ee(J);se!=null&&se!==z.text&&(z.text=se,z.escaped=!0),de--,de===0&&ee()})},0))}),de===0&&ee();return}function be(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(z.message+"",!0)+"</pre>";throw z}try{var Pe=K.lex(_,x);if(x.walkTokens){if(x.async)return Promise.all(le.walkTokens(Pe,x.walkTokens)).then(function(){return Q.parse(Pe,x)}).catch(be);le.walkTokens(Pe,x.walkTokens)}return Q.parse(Pe,x)}catch(z){be(z)}}le.options=le.setOptions=function(_){return I(le.defaults,_),m(le.defaults),le},le.getDefaults=A,le.defaults=$e.defaults,le.use=function(){for(var _=arguments.length,x=new Array(_),ve=0;ve<_;ve++)x[ve]=arguments[ve];var ae=I.apply(void 0,[{}].concat(x)),fe=le.defaults.extensions||{renderers:{},childTokens:{}},ee;x.forEach(function(de){if(de.extensions&&(ee=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var z=fe.renderers?fe.renderers[Pe.name]:null;z?fe.renderers[Pe.name]=function(){for(var J=arguments.length,se=new Array(J),oe=0;oe<J;oe++)se[oe]=arguments[oe];var Z=Pe.renderer.apply(this,se);return Z===!1&&(Z=z.apply(this,se)),Z}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=le.defaults.renderer||new me,z=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),je=0;je<ge;je++)Ee[je]=arguments[je];var We=de.renderer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var J in de.renderer)z(J);ae.renderer=Pe}(),de.tokenizer&&function(){var Pe=le.defaults.tokenizer||new F,z=function(oe){var Z=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,Ee=new Array(ge),je=0;je<ge;je++)Ee[je]=arguments[je];var We=de.tokenizer[oe].apply(Pe,Ee);return We===!1&&(We=Z.apply(Pe,Ee)),We}};for(var J in de.tokenizer)z(J);ae.tokenizer=Pe}(),de.walkTokens){var be=le.defaults.walkTokens;ae.walkTokens=function(Pe){var z=[];return z.push(de.walkTokens.call(this,Pe)),be&&(z=z.concat(be.call(this,Pe))),z}}ee&&(ae.extensions=fe),le.setOptions(ae)})},le.walkTokens=function(_,x){for(var ve=[],ae=function(){var be=ee.value;switch(ve=ve.concat(x.call(le,be)),be.type){case"table":{for(var Pe=R(be.header),z;!(z=Pe()).done;){var J=z.value;ve=ve.concat(le.walkTokens(J.tokens,x))}for(var se=R(be.rows),oe;!(oe=se()).done;)for(var Z=oe.value,ge=R(Z),Ee;!(Ee=ge()).done;){var je=Ee.value;ve=ve.concat(le.walkTokens(je.tokens,x))}break}case"list":{ve=ve.concat(le.walkTokens(be.items,x));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[be.type]?le.defaults.extensions.childTokens[be.type].forEach(function(We){ve=ve.concat(le.walkTokens(be[We],x))}):be.tokens&&(ve=ve.concat(le.walkTokens(be.tokens,x)))}},fe=R(_),ee;!(ee=fe()).done;)ae();return ve},le.parseInline=function(_,x){if(typeof _>"u"||_===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof _!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(_)+", string expected");x=I({},le.defaults,x||{}),w(x);try{var ve=K.lexInline(_,x);return x.walkTokens&&le.walkTokens(ve,x.walkTokens),Q.parseInline(ve,x)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+k(ae.message+"",!0)+"</pre>";throw ae}},le.Parser=Q,le.parser=Q.parse,le.Renderer=me,le.TextRenderer=te,le.Lexer=K,le.lexer=K.lex,le.Tokenizer=F,le.Slugger=G,le.parse=le;var ie=le.options,ce=le.setOptions,ye=le.use,H=le.walkTokens,B=le.parseInline,X=le,re=Q.parse,Y=K.lex;$e.Lexer=K,$e.Parser=Q,$e.Renderer=me,$e.Slugger=G,$e.TextRenderer=te,$e.Tokenizer=F,$e.getDefaults=A,$e.lexer=Y,$e.marked=le,$e.options=ie,$e.parse=X,$e.parseInline=B,$e.parser=re,$e.setOptions=ce,$e.use=ye,$e.walkTokens=H,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[77],Ce([1,0,28]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=void 0;const T=new C.$Dc(1e4);function d(b){return E(b,"NFC",T)}e.$ol=d;const R=new C.$Dc(1e4);function A(b){return E(b,"NFD",R)}e.$pl=A;const m=/[^\u0000-\u0080]/;function E(b,L,P){if(!b)return b;const v=P.get(b);if(v)return v;let y;return m.test(b)?y=b.normalize(L):y=b,P.set(b,y),y}e.$ql=function(){const b=/[\u0300-\u036f]/g;return function(L){return A(L).replace(b,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function C(m,E,b){return Math.min(Math.max(m,E),b)}e.$Ol=C;function T(m,E){return(E+m%E)%E}e.rot=T;class d{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=d;class R{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=R;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const b=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=A}),function(){function $e(d){const R=[];typeof d=="number"&&R.push("code/timeOrigin",d);function A(E){R.push(E,Date.now())}function m(){const E=[];for(let b=0;b<R.length;b+=2)E.push({name:R[b],startTime:R[b+1]});return E}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(d+A.startTime)});return R}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function C(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=C(T))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var T in C)(typeof exports=="object"?exports:$e)[T]=C[T]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function C(T){if(e[T])return e[T].exports;var d=e[T]={i:T,l:!1,exports:{}};return $e[T].call(d.exports,d,d.exports,C),d.l=!0,d.exports}return C.m=$e,C.c=e,C.d=function(T,d,R){C.o(T,d)||Object.defineProperty(T,d,{enumerable:!0,get:R})},C.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},C.t=function(T,d){if(1&d&&(T=C(T)),8&d||4&d&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&d&&typeof T!="string")for(var A in T)C.d(R,A,function(m){return T[m]}.bind(null,A));return R},C.n=function(T){var d=T&&T.__esModule?function(){return T.default}:function(){return T};return C.d(d,"a",d),d},C.o=function(T,d){return Object.prototype.hasOwnProperty.call(T,d)},C.p="",C(C.s=0)}([function($e,e,C){(function(T){var d;e=$e.exports=ye,d=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],E=e.src=[],b=0,L=b++;E[L]="0|[1-9]\\d*";var P=b++;E[P]="[0-9]+";var v=b++;E[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=b++;E[y]="("+E[L]+")\\.("+E[L]+")\\.("+E[L]+")";var k=b++;E[k]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var p=b++;E[p]="(?:"+E[L]+"|"+E[v]+")";var h=b++;E[h]="(?:"+E[P]+"|"+E[v]+")";var s=b++;E[s]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var a=b++;E[a]="(?:-?("+E[h]+"(?:\\."+E[h]+")*))";var o=b++;E[o]="[0-9A-Za-z-]+";var f=b++;E[f]="(?:\\+("+E[o]+"(?:\\."+E[o]+")*))";var l=b++,t="v?"+E[y]+E[s]+"?"+E[f]+"?";E[l]="^"+t+"$";var i="[v=\\s]*"+E[k]+E[a]+"?"+E[f]+"?",c=b++;E[c]="^"+i+"$";var n=b++;E[n]="((?:<|>)?=?)";var r=b++;E[r]=E[P]+"|x|X|\\*";var u=b++;E[u]=E[L]+"|x|X|\\*";var I=b++;E[I]="[v=\\s]*("+E[u]+")(?:\\.("+E[u]+")(?:\\.("+E[u]+")(?:"+E[s]+")?"+E[f]+"?)?)?";var S=b++;E[S]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[a]+")?"+E[f]+"?)?)?";var $=b++;E[$]="^"+E[n]+"\\s*"+E[I]+"$";var g=b++;E[g]="^"+E[n]+"\\s*"+E[S]+"$";var w=b++;E[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=b++;E[D]="(?:~>?)";var N=b++;E[N]="(\\s*)"+E[D]+"\\s+",m[N]=new RegExp(E[N],"g");var M=b++;E[M]="^"+E[D]+E[I]+"$";var F=b++;E[F]="^"+E[D]+E[S]+"$";var U=b++;E[U]="(?:\\^)";var j=b++;E[j]="(\\s*)"+E[U]+"\\s+",m[j]=new RegExp(E[j],"g");var O=b++;E[O]="^"+E[U]+E[I]+"$";var q=b++;E[q]="^"+E[U]+E[S]+"$";var K=b++;E[K]="^"+E[n]+"\\s*("+i+")$|^$";var me=b++;E[me]="^"+E[n]+"\\s*("+t+")$|^$";var te=b++;E[te]="(\\s*)"+E[n]+"\\s*("+i+"|"+E[I]+")",m[te]=new RegExp(E[te],"g");var G=b++;E[G]="^\\s*("+E[I]+")\\s+-\\s+("+E[I]+")\\s*$";var Q=b++;E[Q]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var le=b++;E[le]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)d(ie,E[ie]),m[ie]||(m[ie]=new RegExp(E[ie]));function ce(Z,ge){if(Z instanceof ye)return Z;if(typeof Z!="string"||Z.length>R||!(ge?m[c]:m[l]).test(Z))return null;try{return new ye(Z,ge)}catch{return null}}function ye(Z,ge){if(Z instanceof ye){if(Z.loose===ge)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ye))return new ye(Z,ge);d("SemVer",Z,ge),this.loose=ge;var Ee=Z.trim().match(ge?m[c]:m[l]);if(!Ee)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<A)return We}return je}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Z,ge){var Ee=ce(Z,ge);return Ee?Ee.version:null},e.clean=function(Z,ge){var Ee=ce(Z.trim().replace(/^[=v]+/,""),ge);return Ee?Ee.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(Z){return d("SemVer.compare",this.version,this.loose,Z),Z instanceof ye||(Z=new ye(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},ye.prototype.compareMain=function(Z){return Z instanceof ye||(Z=new ye(Z,this.loose)),B(this.major,Z.major)||B(this.minor,Z.minor)||B(this.patch,Z.patch)},ye.prototype.comparePre=function(Z){if(Z instanceof ye||(Z=new ye(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ge=0;do{var Ee=this.prerelease[ge],je=Z.prerelease[ge];if(d("prerelease compare",ge,Ee,je),Ee===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==je)return B(Ee,je)}while(++ge)},ye.prototype.inc=function(Z,ge){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ge,Ee,je){typeof Ee=="string"&&(je=Ee,Ee=void 0);try{return new ye(Z,Ee).inc(ge,je).version}catch{return null}},e.diff=function(Z,ge){if(_(Z,ge))return null;var Ee=ce(Z),je=ce(ge);if(Ee.prerelease.length||je.prerelease.length){for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in Ee)if((We==="major"||We==="minor"||We==="patch")&&Ee[We]!==je[We])return We},e.compareIdentifiers=B;var H=/^[0-9]+$/;function B(Z,ge){var Ee=H.test(Z),je=H.test(ge);return Ee&&je&&(Z=+Z,ge=+ge),Ee&&!je?-1:je&&!Ee?1:Z<ge?-1:Z>ge?1:0}function X(Z,ge,Ee){return new ye(Z,Ee).compare(new ye(ge,Ee))}function re(Z,ge,Ee){return X(Z,ge,Ee)>0}function Y(Z,ge,Ee){return X(Z,ge,Ee)<0}function _(Z,ge,Ee){return X(Z,ge,Ee)===0}function x(Z,ge,Ee){return X(Z,ge,Ee)!==0}function ve(Z,ge,Ee){return X(Z,ge,Ee)>=0}function ae(Z,ge,Ee){return X(Z,ge,Ee)<=0}function fe(Z,ge,Ee,je){var We;switch(ge){case"===":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z===Ee;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof Ee=="object"&&(Ee=Ee.version),We=Z!==Ee;break;case"":case"=":case"==":We=_(Z,Ee,je);break;case"!=":We=x(Z,Ee,je);break;case">":We=re(Z,Ee,je);break;case">=":We=ve(Z,Ee,je);break;case"<":We=Y(Z,Ee,je);break;case"<=":We=ae(Z,Ee,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function ee(Z,ge){if(Z instanceof ee){if(Z.loose===ge)return Z;Z=Z.value}if(!(this instanceof ee))return new ee(Z,ge);d("comparator",Z,ge),this.loose=ge,this.parse(Z),this.semver===de?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(Z,ge){return B(ge,Z)},e.major=function(Z,ge){return new ye(Z,ge).major},e.minor=function(Z,ge){return new ye(Z,ge).minor},e.patch=function(Z,ge){return new ye(Z,ge).patch},e.compare=X,e.compareLoose=function(Z,ge){return X(Z,ge,!0)},e.rcompare=function(Z,ge,Ee){return X(ge,Z,Ee)},e.sort=function(Z,ge){return Z.sort(function(Ee,je){return e.compare(Ee,je,ge)})},e.rsort=function(Z,ge){return Z.sort(function(Ee,je){return e.rcompare(Ee,je,ge)})},e.gt=re,e.lt=Y,e.eq=_,e.neq=x,e.gte=ve,e.lte=ae,e.cmp=fe,e.Comparator=ee;var de={};function be(Z,ge){if(Z instanceof be)return Z.loose===ge?Z:new be(Z.raw,ge);if(Z instanceof ee)return new be(Z.value,ge);if(!(this instanceof be))return new be(Z,ge);if(this.loose=ge,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function Pe(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function z(Z,ge,Ee,je,We,_e,Xe,it,tt,Ae,Ne,qe,Le){return((ge=Pe(Ee)?"":Pe(je)?">="+Ee+".0.0":Pe(We)?">="+Ee+"."+je+".0":">="+ge)+" "+(it=Pe(tt)?"":Pe(Ae)?"<"+(+tt+1)+".0.0":Pe(Ne)?"<"+tt+"."+(+Ae+1)+".0":qe?"<="+tt+"."+Ae+"."+Ne+"-"+qe:"<="+it)).trim()}function J(Z,ge){for(var Ee=0;Ee<Z.length;Ee++)if(!Z[Ee].test(ge))return!1;if(ge.prerelease.length){for(Ee=0;Ee<Z.length;Ee++)if(d(Z[Ee].semver),Z[Ee].semver!==de&&Z[Ee].semver.prerelease.length>0){var je=Z[Ee].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function se(Z,ge,Ee){try{ge=new be(ge,Ee)}catch{return!1}return ge.test(Z)}function oe(Z,ge,Ee,je){var We,_e,Xe,it,tt;switch(Z=new ye(Z,je),ge=new be(ge,je),Ee){case">":We=re,_e=ae,Xe=Y,it=">",tt=">=";break;case"<":We=Y,_e=ve,Xe=re,it="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Z,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Ne=ge.set[Ae],qe=null,Le=null;if(Ne.forEach(function(Ye){Ye.semver===de&&(Ye=new ee(">=0.0.0")),qe=qe||Ye,Le=Le||Ye,We(Ye.semver,qe.semver,je)?qe=Ye:Xe(Ye.semver,Le.semver,je)&&(Le=Ye)}),qe.operator===it||qe.operator===tt||(!Le.operator||Le.operator===it)&&_e(Z,Le.semver)||Le.operator===tt&&Xe(Z,Le.semver))return!1}return!0}ee.prototype.parse=function(Z){var ge=this.loose?m[K]:m[me],Ee=Z.match(ge);if(!Ee)throw new TypeError("Invalid comparator: "+Z);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new ye(Ee[2],this.loose):this.semver=de},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Z){return d("Comparator.test",Z,this.loose),this.semver===de||(typeof Z=="string"&&(Z=new ye(Z,this.loose)),fe(Z,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Z,ge){if(!(Z instanceof ee))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new be(Z.value,ge),se(this.value,Ee,ge);if(Z.operator==="")return Ee=new be(this.value,ge),se(Z.semver,Ee,ge);var je=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),_e=this.semver.version===Z.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),it=fe(this.semver,"<",Z.semver,ge)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),tt=fe(this.semver,">",Z.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return je||We||_e&&Xe||it||tt},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Z){var ge=this.loose;Z=Z.trim(),d("range",Z,ge);var Ee=ge?m[Q]:m[G];Z=Z.replace(Ee,z),d("hyphen replace",Z),Z=Z.replace(m[te],"$1$2$3"),d("comparator trim",Z,m[te]),Z=(Z=(Z=Z.replace(m[N],"$1~")).replace(m[j],"$1^")).split(/\s+/).join(" ");var je=ge?m[K]:m[me],We=Z.split(" ").map(function(_e){return function(Xe,it){return d("comp",Xe),Xe=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Ne){return function(qe,Le){d("caret",qe,Le);var Ye=Le?m[q]:m[O];return qe.replace(Ye,function(he,ue,Ie,Ke,Ue){var Ze;return d("caret",qe,he,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":Ue?(d("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+Ue+" <"+(+ue+1)+".0.0"):(d("no pr"),Ze=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+" <"+(+ue+1)+".0.0"),d("caret return",Ze),Ze})}(Ne,Ae)}).join(" ")}(Xe,it),d("caret",Xe),Xe=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Ne){return function(qe,Le){var Ye=Le?m[F]:m[M];return qe.replace(Ye,function(he,ue,Ie,Ke,Ue){var Ze;return d("tilde",qe,he,ue,Ie,Ke,Ue),Pe(ue)?Ze="":Pe(Ie)?Ze=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?Ze=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":Ue?(d("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=">="+ue+"."+Ie+"."+Ke+Ue+" <"+ue+"."+(+Ie+1)+".0"):Ze=">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0",d("tilde return",Ze),Ze})}(Ne,Ae)}).join(" ")}(Xe,it),d("tildes",Xe),Xe=function(tt,Ae){return d("replaceXRanges",tt,Ae),tt.split(/\s+/).map(function(Ne){return function(qe,Le){qe=qe.trim();var Ye=Le?m[g]:m[$];return qe.replace(Ye,function(he,ue,Ie,Ke,Ue,Ze){d("xRange",qe,he,ue,Ie,Ke,Ue,Ze);var nt=Pe(Ie),ct=nt||Pe(Ke),bt=ct||Pe(Ue);return ue==="="&&bt&&(ue=""),nt?he=ue===">"||ue==="<"?"<0.0.0":"*":ue&&bt?(ct&&(Ke=0),bt&&(Ue=0),ue===">"?(ue=">=",ct?(Ie=+Ie+1,Ke=0,Ue=0):bt&&(Ke=+Ke+1,Ue=0)):ue==="<="&&(ue="<",ct?Ie=+Ie+1:Ke=+Ke+1),he=ue+Ie+"."+Ke+"."+Ue):ct?he=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(he=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),d("xRange return",he),he})}(Ne,Ae)}).join(" ")}(Xe,it),d("xrange",Xe),Xe=function(tt,Ae){return d("replaceStars",tt,Ae),tt.trim().replace(m[le],"")}(Xe,it),d("stars",Xe),Xe}(_e,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new ee(_e,ge)})},be.prototype.intersects=function(Z,ge){if(!(Z instanceof be))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(je){return Z.set.some(function(We){return We.every(function(_e){return je.intersects(_e,ge)})})})})},e.toComparators=function(Z,ge){return new be(Z,ge).set.map(function(Ee){return Ee.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new ye(Z,this.loose));for(var ge=0;ge<this.set.length;ge++)if(J(this.set[ge],Z))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Z,ge,Ee){var je=null,We=null;try{var _e=new be(ge,Ee)}catch{return null}return Z.forEach(function(Xe){_e.test(Xe)&&(je&&We.compare(Xe)!==-1||(We=new ye(je=Xe,Ee)))}),je},e.minSatisfying=function(Z,ge,Ee){var je=null,We=null;try{var _e=new be(ge,Ee)}catch{return null}return Z.forEach(function(Xe){_e.test(Xe)&&(je&&We.compare(Xe)!==1||(We=new ye(je=Xe,Ee)))}),je},e.validRange=function(Z,ge){try{return new be(Z,ge).range||"*"}catch{return null}},e.ltr=function(Z,ge,Ee){return oe(Z,ge,"<",Ee)},e.gtr=function(Z,ge,Ee){return oe(Z,ge,">",Ee)},e.outside=oe,e.prerelease=function(Z,ge){var Ee=ce(Z,ge);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(Z,ge,Ee){return Z=new be(Z,Ee),ge=new be(ge,Ee),Z.intersects(ge)},e.coerce=function(Z){if(Z instanceof ye)return Z;if(typeof Z!="string")return null;var ge=Z.match(m[w]);return ge==null?null:ce((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,C(1))},function($e,e){var C,T,d=$e.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(h){if(C===setTimeout)return setTimeout(h,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(h,0);try{return C(h,0)}catch{try{return C.call(null,h,0)}catch{return C.call(this,h,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var E,b=[],L=!1,P=-1;function v(){L&&E&&(L=!1,E.length?b=E.concat(b):P=-1,b.length&&y())}function y(){if(!L){var h=m(v);L=!0;for(var s=b.length;s;){for(E=b,b=[];++P<s;)E&&E[P].run();P=-1,s=b.length}E=null,L=!1,function(a){if(T===clearTimeout)return clearTimeout(a);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(a);try{T(a)}catch{try{return T.call(null,a)}catch{return T.call(this,a)}}}(h)}}function k(h,s){this.fun=h,this.array=s}function p(){}d.nextTick=function(h){var s=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)s[a-1]=arguments[a];b.push(new k(h,s)),b.length!==1||L||m(y)},k.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=p,d.addListener=p,d.once=p,d.off=p,d.removeListener=p,d.removeAllListeners=p,d.emit=p,d.prependListener=p,d.prependOnceListener=p,d.listeners=function(h){return[]},d.binding=function(h){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(h){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(De[35],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(R){return new T(R)}constructor(R){this.c=C&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=T}),define(De[4],Ce([1,0,9,75,3,76,35]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const m=!1,E=!1;var b;(function($){$.None=()=>d.$Sc.None;function g(fe){if(E){const{onDidAddListener:ee}=fe,de=k.create();let be=0;fe.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),ee?.()}}}function w(fe,ee){return me(fe,()=>{},0,void 0,!0,void 0,ee)}$.defer=w;function D(fe){return(ee,de=null,be)=>{let Pe=!1,z;return z=fe(J=>{if(!Pe)return z?z.dispose():Pe=!0,ee.call(de,J)},null,be),Pe&&z.dispose(),z}}$.once=D;function N(fe,ee,de){return q((be,Pe=null,z)=>fe(J=>be.call(Pe,ee(J)),null,z),de)}$.map=N;function M(fe,ee,de){return q((be,Pe=null,z)=>fe(J=>{ee(J),be.call(Pe,J)},null,z),de)}$.forEach=M;function F(fe,ee,de){return q((be,Pe=null,z)=>fe(J=>ee(J)&&be.call(Pe,J),null,z),de)}$.filter=F;function U(fe){return fe}$.signal=U;function j(...fe){return(ee,de=null,be)=>{const Pe=(0,d.$Pc)(...fe.map(z=>z(J=>ee.call(de,J))));return K(Pe,be)}}$.any=j;function O(fe,ee,de,be){let Pe=de;return N(fe,z=>(Pe=ee(Pe,z),Pe),be)}$.reduce=O;function q(fe,ee){let de;const be={onWillAddFirstListener(){de=fe(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};ee||g(be);const Pe=new o(be);return ee?.add(Pe),Pe.event}function K(fe,ee){return ee instanceof Array?ee.push(fe):ee&&ee.add(fe),fe}function me(fe,ee,de=100,be=!1,Pe=!1,z,J){let se,oe,Z,ge=0,Ee;const je={leakWarningThreshold:z,onWillAddFirstListener(){se=fe(_e=>{ge++,oe=ee(oe,_e),be&&!Z&&(We.fire(oe),oe=void 0),Ee=()=>{const Xe=oe;oe=void 0,Z=void 0,(!be||ge>1)&&We.fire(Xe),ge=0},typeof de=="number"?(clearTimeout(Z),Z=setTimeout(Ee,de)):Z===void 0&&(Z=0,queueMicrotask(Ee))})},onWillRemoveListener(){Pe&&ge>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,se.dispose()}};J||g(je);const We=new o(je);return J?.add(We),We.event}$.debounce=me;function te(fe,ee=0,de){return $.debounce(fe,(be,Pe)=>be?(be.push(Pe),be):[Pe],ee,void 0,!0,void 0,de)}$.accumulate=te;function G(fe,ee=(be,Pe)=>be===Pe,de){let be=!0,Pe;return F(fe,z=>{const J=be||!ee(z,Pe);return be=!1,Pe=z,J},de)}$.latch=G;function Q(fe,ee,de){return[$.filter(fe,ee,de),$.filter(fe,be=>!ee(be),de)]}$.split=Q;function le(fe,ee=!1,de=[],be){let Pe=de.slice(),z=fe(oe=>{Pe?Pe.push(oe):se.fire(oe)});be&&be.add(z);const J=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new o({onWillAddFirstListener(){z||(z=fe(oe=>se.fire(oe)),be&&be.add(z))},onDidAddFirstListener(){Pe&&(ee?setTimeout(J):J())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return be&&be.add(se),se.event}$.buffer=le;function ie(fe,ee){return(be,Pe,z)=>{const J=ee(new ye);return fe(function(se){const oe=J.evaluate(se);oe!==ce&&be.call(Pe,oe)},void 0,z)}}$.chain=ie;const ce=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(de=>(ee(de),de)),this}filter(ee){return this.f.push(de=>ee(de)?de:ce),this}reduce(ee,de){let be=de;return this.f.push(Pe=>(be=ee(be,Pe),be)),this}latch(ee=(de,be)=>de===be){let de=!0,be;return this.f.push(Pe=>{const z=de||!ee(Pe,be);return de=!1,be=Pe,z?Pe:ce}),this}evaluate(ee){for(const de of this.f)if(ee=de(ee),ee===ce)break;return ee}}function H(fe,ee,de=be=>be){const be=(...se)=>J.fire(de(...se)),Pe=()=>fe.on(ee,be),z=()=>fe.removeListener(ee,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:z});return J.event}$.fromNodeEventEmitter=H;function B(fe,ee,de=be=>be){const be=(...se)=>J.fire(de(...se)),Pe=()=>fe.addEventListener(ee,be),z=()=>fe.removeEventListener(ee,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:z});return J.event}$.fromDOMEventEmitter=B;function X(fe){return new Promise(ee=>D(fe)(ee))}$.toPromise=X;function re(fe){const ee=new o;return fe.then(de=>{ee.fire(de)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}$.fromPromise=re;function Y(fe,ee,de){return ee(de),fe(be=>ee(be))}$.runAndSubscribe=Y;function _(fe,ee){let de=null;function be(z){de?.dispose(),de=new d.$Rc,ee(z,de)}be(void 0);const Pe=fe(z=>be(z));return(0,d.$Qc)(()=>{Pe.dispose(),de?.dispose()})}$.runAndSubscribeWithStore=_;class x{constructor(ee,de){this._observable=ee,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};de||g(be),this.emitter=new o(be),de&&de.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,de){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ve(fe,ee){return new x(fe,ee).emitter.event}$.fromObservable=ve;function ae(fe){return ee=>{let de=0,be=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(fe.reportChanges(),be&&(be=!1,ee()))},handlePossibleChange(){},handleChange(){be=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}$.fromObservableLight=ae})(b||(e.Event=b={}));class L{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${L.f++}`,L.all.add(this)}start(g){this.g=new A.$Jd,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$Ld=L;let P=-1;function v($){const g=P;return P=$,{dispose(){P=g}}}e.$Md=v;class y{constructor(g,w=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=w,this.g=0}dispose(){this.f?.clear()}check(g,w){const D=this.threshold;if(D<=0||w<D)return;this.f||(this.f=new Map);const N=this.f.get(g.value)||0;if(this.f.set(g.value,N+1),this.g-=1,this.g<=0){this.g=D*.5;let M,F=0;for(const[U,j]of this.f)(!M||F<j)&&(M=U,F=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this.f.get(g.value)||0;this.f.set(g.value,M-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class h{constructor(g){this.value=g,this.id=p++}}const s=2,a=($,g)=>{if($ instanceof h)g($);else for(let w=0;w<$.length;w++){const D=$[w];D&&g(D)}};class o{constructor(g){this.w=0,this.f=g,this.g=P>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(m){const g=this.t;queueMicrotask(()=>{a(g,w=>w.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,w,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.$Sc.None;if(this.m)return d.$Sc.None;w&&(g=g.bind(w));const N=new h(g);let M,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=k.create(),M=this.g.check(N.stack,this.w+1)),m&&(N.stack=F??k.create()),this.t?this.t instanceof h?(this.u??=new l,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,d.$Qc)(()=>{M?.(),this.x(N)});return D instanceof d.$Rc?D.add(U):Array.isArray(D)&&D.push(U),U},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const w=this.t,D=w.indexOf(g);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,w[D]=void 0;const N=this.u.current===this;if(this.w*s<=w.length){let M=0;for(let F=0;F<w.length;F++)w[F]?w[M++]=w[F]:N&&(this.u.end--,M<this.u.i&&this.u.i--);w.length=M}}y(g,w){if(!g)return;const D=this.f?.onListenerError||C.$1;if(!D){g.value(w);return}try{g.value(w)}catch(N){D(N)}}z(g){const w=g.current.t;for(;g.i<g.end;)this.y(w[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,g);else{const w=this.u;w.enqueue(this,g,this.t.length),this.z(w)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=o;const f=()=>new l;e.$Od=f;class l{constructor(){this.i=-1,this.end=0}enqueue(g,w,D){this.i=0,this.end=D,this.current=g,this.value=w}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends o{async fireAsync(g,w,D){if(this.t)for(this.h||(this.h=new R.$2c),a(this.t,N=>this.h.push([N.value,g]));this.h.size>0&&!w.isCancellationRequested;){const[N,M]=this.h.shift(),F=[],U={...M,token:w,waitUntil:j=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");D&&(j=D(j,N)),F.push(j)}};try{N(U)}catch(j){(0,C.$1)(j);continue}Object.freeze(F),await Promise.allSettled(F).then(j=>{for(const O of j)O.status==="rejected"&&(0,C.$1)(O.reason)})}}}e.$Pd=t;class i extends o{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new R.$2c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$Qd=i;class c extends i{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$Rd=c;class n extends o{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(w=>super.fire(w)),this.h=[]}))}}e.$Sd=n;class r{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const w={event:g,listener:null};this.h.push(w),this.g&&this.m(w);const D=()=>{this.g&&this.o(w);const N=this.h.indexOf(w);this.h.splice(N,1)};return(0,d.$Qc)((0,T.$db)(D))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(w=>this.f.fire(w))}o(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.f.dispose()}}e.$Td=r;class u{constructor(g,w,D,N){this.f=new d.$Rc;const M=this.f.add(new r),F=this.f.add(new d.$1c);function U(j){F.set(j,M.add(N(j)))}for(const j of g)U(j);this.f.add(w(j=>{U(j)})),this.f.add(D(j=>{F.deleteAndDispose(j)})),this.event=M.event}dispose(){this.f.dispose()}}e.$Ud=u;class I{constructor(){this.f=[]}wrapEvent(g){return(w,D,N)=>g(M=>{const F=this.f[this.f.length-1];F?F.push(()=>w.call(D,M)):w.call(D,M)},void 0,N)}bufferEvents(g){const w=[];this.f.push(w);const D=g();return this.f.pop(),w.forEach(N=>N()),D}}e.$Vd=I;class S{constructor(){this.f=!1,this.g=b.None,this.h=d.$Sc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=S}),define(De[21],Ce([1,0,4]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const T=Object.freeze(function(m,E){const b=setTimeout(m.bind(E),0);return{dispose(){clearTimeout(b)}}});var d;(function(m){function E(b){return b===m.None||b===m.Cancelled||b instanceof R?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}m.isCancellationToken=E,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(d||(e.CancellationToken=d={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new C.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=d.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=d.None}}e.$Xd=A}),define(De[159],Ce([1,0,21]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class T{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new C.$Xd,E=this.b(m.token);return this.a={promise:E,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$we=T;class d{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const E=JSON.stringify(m);return this.b!==E&&(this.b=E,this.a=this.c(m)),this.a}}e.$xe=d;class R{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const E=this.b(m);return this.a.set(m,E),E}}e.$ye=R}),define(De[96],Ce([1,0,9,3]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function d(f){const l=f;return l?typeof l.read=="function":!1}e.$Yd=d;function R(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.$Zd=R;function A(f){const l=f;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$1d=A;function m(f,l){return new E(f,l)}e.$2d=m;class E{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,C.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let i;switch(l){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const c=i.indexOf(t);c>=0&&i.splice(c,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(f,l){const t=[];let i;for(;(i=f.read())!==null;)t.push(i);return l(t)}e.$3d=b;function L(f,l,t){const i=[];let c;for(;(c=f.read())!==null&&i.length<t;)i.push(c);return c===null&&i.length>0?l(i):{read:()=>{if(i.length>0)return i.shift();if(typeof c<"u"){const n=c;return c=void 0,n}return f.read()}}}e.$4d=L;function P(f,l){return new Promise((t,i)=>{const c=[];v(f,{onData:n=>{l&&c.push(n)},onError:n=>{l?i(n):t(void 0)},onEnd:()=>{t(l?l(c):void 0)}})})}e.$5d=P;function v(f,l,t){f.on("error",i=>{t?.isCancellationRequested||l.onError(i)}),f.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),f.on("data",i=>{t?.isCancellationRequested||l.onData(i)})}e.$6d=v;function y(f,l){return new Promise((t,i)=>{const c=new T.$Rc,n=[],r=S=>{if(n.push(S),n.length>l)return c.dispose(),f.pause(),t({stream:f,buffer:n,ended:!1})},u=S=>(c.dispose(),i(S)),I=()=>(c.dispose(),t({stream:f,buffer:n,ended:!0}));c.add((0,T.$Qc)(()=>f.removeListener("error",u))),f.on("error",u),c.add((0,T.$Qc)(()=>f.removeListener("end",I))),f.on("end",I),c.add((0,T.$Qc)(()=>f.removeListener("data",r))),f.on("data",r)})}e.$7d=y;function k(f,l){const t=m(l);return t.end(f),t}e.$8d=k;function p(){const f=m(()=>{throw new Error("not supported")});return f.end(),f}e.$9d=p;function h(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.$0d=h;function s(f,l,t){const i=m(t);return v(f,{onData:c=>i.write(l.data(c)),onError:c=>i.error(l.error?l.error(c):c),onEnd:()=>i.end()}),i}e.$$d=s;function a(f,l,t){let i=!1;return{read:()=>{const c=l.read();return i?c:(i=!0,c!==null?t([f,c]):f)}}}e.$_d=a;function o(f,l,t){let i=!1;const c=m(t);return v(l,{onData:n=>i?c.write(n):(i=!0,c.write(t([f,n]))),onError:n=>c.error(n),onEnd:()=>{i||(i=!0,c.write(f)),c.end()}}),c}e.$ae=o}),define(De[22],Ce([1,0,47,96]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const d=typeof Buffer<"u",R=new C.$V(()=>new Uint8Array(256));let A,m;class E{static alloc(w){return d?new E(Buffer.allocUnsafe(w)):new E(new Uint8Array(w))}static wrap(w){return d&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new E(w)}static fromString(w,D){return!(D?.dontUseNodeBuffer||!1)&&d?new E(Buffer.from(w)):(A||(A=new TextEncoder),new E(A.encode(w)))}static fromByteArray(w){const D=E.alloc(w.length);for(let N=0,M=w.length;N<M;N++)D.buffer[N]=w[N];return D}static concat(w,D){if(typeof D>"u"){D=0;for(let F=0,U=w.length;F<U;F++)D+=w[F].byteLength}const N=E.alloc(D);let M=0;for(let F=0,U=w.length;F<U;F++){const j=w[F];N.set(j,M),M+=j.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=E.alloc(this.byteLength);return w.set(this),w}toString(){return d?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,D){return new E(this.buffer.subarray(w,D))}set(w,D){if(w instanceof E)this.buffer.set(w.buffer,D);else if(w instanceof Uint8Array)this.buffer.set(w,D);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),D);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return v(this.buffer,w)}writeUInt32BE(w,D){y(this.buffer,w,D)}readUInt32LE(w){return k(this.buffer,w)}writeUInt32LE(w,D){p(this.buffer,w,D)}readUInt8(w){return h(this.buffer,w)}writeUInt8(w,D){s(this.buffer,w,D)}indexOf(w,D=0){return b(this.buffer,w instanceof E?w.buffer:w,D)}}e.$be=E;function b(g,w,D=0){const N=w.byteLength,M=g.byteLength;if(N===0)return 0;if(N===1)return g.indexOf(w[0]);if(N>M-D)return-1;const F=R.value;F.fill(w.length);for(let q=0;q<w.length;q++)F[w[q]]=w.length-q-1;let U=D+w.length-1,j=U,O=-1;for(;U<M;)if(g[U]===w[j]){if(j===0){O=U;break}U--,j--}else U+=Math.max(w.length-j,F[g[U]]),j=w.length-1;return O}e.$ce=b;function L(g,w){return g[w+0]<<0>>>0|g[w+1]<<8>>>0}e.$de=L;function P(g,w,D){g[D+0]=w&255,w=w>>>8,g[D+1]=w&255}e.$ee=P;function v(g,w){return g[w]*2**24+g[w+1]*2**16+g[w+2]*2**8+g[w+3]}e.$fe=v;function y(g,w,D){g[D+3]=w,w=w>>>8,g[D+2]=w,w=w>>>8,g[D+1]=w,w=w>>>8,g[D]=w}e.$ge=y;function k(g,w){return g[w+0]<<0>>>0|g[w+1]<<8>>>0|g[w+2]<<16>>>0|g[w+3]<<24>>>0}e.$he=k;function p(g,w,D){g[D+0]=w&255,w=w>>>8,g[D+1]=w&255,w=w>>>8,g[D+2]=w&255,w=w>>>8,g[D+3]=w&255}e.$ie=p;function h(g,w){return g[w]}e.$je=h;function s(g,w,D){g[D]=w}e.$ke=s;function a(g){return T.$3d(g,w=>E.concat(w))}e.$le=a;function o(g){return T.$0d(g)}e.$me=o;function f(g){return T.$5d(g,w=>E.concat(w))}e.$ne=f;async function l(g){return g.ended?E.concat(g.buffer):E.concat([...g.buffer,await f(g.stream)])}e.$oe=l;function t(g){return T.$8d(g,w=>E.concat(w))}e.$pe=t;function i(g){return T.$$d(g,{data:w=>typeof w=="string"?E.fromString(w):E.wrap(w)},w=>E.concat(w))}e.$qe=i;function c(g){return T.$2d(w=>E.concat(w),g)}e.$re=c;function n(g,w){return T.$_d(g,w,D=>E.concat(D))}e.$se=n;function r(g,w){return T.$ae(g,w,D=>E.concat(D))}e.$te=r;function u(g){let w=0,D=0,N=0;const M=new Uint8Array(Math.floor(g.length/4*3)),F=j=>{switch(D){case 3:M[N++]=w|j,D=0;break;case 2:M[N++]=w|j>>>2,w=j<<6,D=3;break;case 1:M[N++]=w|j>>>4,w=j<<4,D=2;break;default:w=j<<2,D=1}};for(let j=0;j<g.length;j++){const O=g.charCodeAt(j);if(O>=65&&O<=90)F(O-65);else if(O>=97&&O<=122)F(O-97+26);else if(O>=48&&O<=57)F(O-48+52);else if(O===43||O===45)F(62);else if(O===47||O===95)F(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${g[j]}`)}}const U=N;for(;D>0;)F(0);return E.wrap(M).slice(0,U)}e.$ue=u;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:g},w=!0,D=!1){const N=D?S:I;let M="";const F=g.byteLength%3;let U=0;for(;U<g.byteLength-F;U+=3){const j=g[U+0],O=g[U+1],q=g[U+2];M+=N[j>>>2],M+=N[(j<<4|O>>>4)&63],M+=N[(O<<2|q>>>6)&63],M+=N[q&63]}if(F===1){const j=g[U+0];M+=N[j>>>2],M+=N[j<<4&63],w&&(M+="==")}else if(F===2){const j=g[U+0],O=g[U+1];M+=N[j>>>2],M+=N[(j<<4|O>>>4)&63],M+=N[O<<2&63],w&&(M+="=")}return M}e.$ve=$}),define(De[15],Ce([1,0,159,47]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function d(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Be=d;const R=/{(\d+)}/g;function A(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(R,function(qe,Le){const Ye=parseInt(Le,10);return isNaN(Ye)||Ye<0||Ye>=Ne.length?qe:Ne[Ye]})}e.$Ce=A;const m=/{([^}]+)}/g;function E(Ae,Ne){return Ae.replace(m,(qe,Le)=>Ne[Le]??qe)}e.$De=E;function b(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$Ee=b;function L(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=L;function P(Ae,Ne){let qe=0;const Le=Ne.charCodeAt(0);for(let Ye=Ae.length-1;Ye>=0;Ye--)Ae.charCodeAt(Ye)===Le&&qe++;return qe}e.$Ge=P;function v(Ae,Ne,qe="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${qe}`}e.$He=v;function y(Ae,Ne=" "){const qe=k(Ae,Ne);return p(qe,Ne)}e.$Ie=y;function k(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length;if(qe===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+qe;return Ae.substring(Le)}e.$Je=k;function p(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length,Le=Ae.length;if(qe===0||Le===0)return Ae;let Ye=Le,he=-1;for(;he=Ae.lastIndexOf(Ne,Ye-1),!(he===-1||he+qe!==Ye);){if(he===0)return"";Ye=he}return Ae.substring(0,Ye)}e.$Ke=p;function h(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=h;function s(Ae){return Ae.replace(/\*/g,"")}e.$Me=s;function a(Ae,Ne,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=L(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Ne=a;function o(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Oe=o;function f(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Pe=f;function l(Ae){for(let Ne=0,qe=Ae.length;Ne<qe;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Qe=l;function t(Ae,Ne=0,qe=Ae.length){for(let Le=Ne;Le<qe;Le++){const Ye=Ae.charCodeAt(Le);if(Ye!==32&&Ye!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,qe)}e.$Re=t;function i(Ae,Ne=Ae.length-1){for(let qe=Ne;qe>=0;qe--){const Le=Ae.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}e.$Se=i;function c(Ae,Ne,qe){const Le=[];let Ye=0;for(const he of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Ye,he.index)),he.index===void 0)throw new Error("match.index should be defined");Ye=he.index+he[0].length,Le.push(qe(he[0],...he.slice(1),he.index,Ae,he.groups))}return Le.push(Ae.slice(Ye)),Promise.all(Le).then(he=>he.join(""))}e.$Te=c;function n(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Ue=n;function r(Ae,Ne,qe=0,Le=Ae.length,Ye=0,he=Ne.length){for(;qe<Le&&Ye<he;qe++,Ye++){const Ke=Ae.charCodeAt(qe),Ue=Ne.charCodeAt(Ye);if(Ke<Ue)return-1;if(Ke>Ue)return 1}const ue=Le-qe,Ie=he-Ye;return ue<Ie?-1:ue>Ie?1:0}e.$Ve=r;function u(Ae,Ne){return I(Ae,Ne,0,Ae.length,0,Ne.length)}e.$We=u;function I(Ae,Ne,qe=0,Le=Ae.length,Ye=0,he=Ne.length){for(;qe<Le&&Ye<he;qe++,Ye++){let Ke=Ae.charCodeAt(qe),Ue=Ne.charCodeAt(Ye);if(Ke===Ue)continue;if(Ke>=128||Ue>=128)return r(Ae.toLowerCase(),Ne.toLowerCase(),qe,Le,Ye,he);$(Ke)&&(Ke-=32),$(Ue)&&(Ue-=32);const Ze=Ke-Ue;if(Ze!==0)return Ze}const ue=Le-qe,Ie=he-Ye;return ue<Ie?-1:ue>Ie?1:0}e.$Xe=I;function S(Ae){return Ae>=48&&Ae<=57}e.$Ye=S;function $(Ae){return Ae>=97&&Ae<=122}e.$Ze=$;function g(Ae){return Ae>=65&&Ae<=90}e.$1e=g;function w(Ae,Ne){return Ae.length===Ne.length&&I(Ae,Ne)===0}e.$2e=w;function D(Ae,Ne){const qe=Ne.length;return Ne.length>Ae.length?!1:I(Ae,Ne,0,qe)===0}e.$3e=D;function N(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return qe}e.$4e=N;function M(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;const Ye=Ae.length-1,he=Ne.length-1;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Ye-Le)!==Ne.charCodeAt(he-Le))return Le;return qe}e.$5e=M;function F(Ae){return 55296<=Ae&&Ae<=56319}e.$6e=F;function U(Ae){return 56320<=Ae&&Ae<=57343}e.$7e=U;function j(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$8e=j;function O(Ae,Ne,qe){const Le=Ae.charCodeAt(qe);if(F(Le)&&qe+1<Ne){const Ye=Ae.charCodeAt(qe+1);if(U(Ye))return j(Le,Ye)}return Le}e.$9e=O;function q(Ae,Ne){const qe=Ae.charCodeAt(Ne-1);if(U(qe)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(F(Le))return j(Le,qe)}return qe}class K{get offset(){return this.e}constructor(Ne,qe=0){this.c=Ne,this.d=Ne.length,this.e=qe}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=q(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=O(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$0e=K;class me{get offset(){return this.c.offset}constructor(Ne,qe=0){this.c=new K(Ne,qe)}nextGraphemeLength(){const Ne=ge.getInstance(),qe=this.c,Le=qe.offset;let Ye=Ne.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const he=qe.offset,ue=Ne.getGraphemeBreakType(qe.nextCodePoint());if(oe(Ye,ue)){qe.setOffset(he);break}Ye=ue}return qe.offset-Le}prevGraphemeLength(){const Ne=ge.getInstance(),qe=this.c,Le=qe.offset;let Ye=Ne.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const he=qe.offset,ue=Ne.getGraphemeBreakType(qe.prevCodePoint());if(oe(ue,Ye)){qe.setOffset(he);break}Ye=ue}return Le-qe.offset}eol(){return this.c.eol()}}e.$$e=me;function te(Ae,Ne){return new me(Ae,Ne).nextGraphemeLength()}e.$_e=te;function G(Ae,Ne){return new me(Ae,Ne).prevGraphemeLength()}e.$af=G;function Q(Ae,Ne){Ne>0&&U(Ae.charCodeAt(Ne))&&Ne--;const qe=Ne+te(Ae,Ne);return[qe-G(Ae,qe),qe]}e.$bf=Q;function le(Ae){const Ne=new me(Ae);let qe=0;for(;!Ne.eol();)qe++,Ne.nextGraphemeLength();return qe}e.$cf=le;let ie;function ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ye(Ae){return ie||(ie=ce()),ie.test(Ae)}e.$df=ye;const H=/^[\t\n\r\x20-\x7E]*$/;function B(Ae){return H.test(Ae)}e.$ef=B,e.$ff=/[\u2028\u2029]/;function X(Ae){return e.$ff.test(Ae)}e.$gf=X;function re(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$hf=re;function Y(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$if=Y;function _(Ae,Ne){if(Ae.length<Ne)return Ae;const qe=/\b/g;let Le=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Ne);)Le=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$jf=_;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ve=/\x1b\].*?\x07/g;function ae(Ae){return Ae&&(Ae=Ae.replace(x,"").replace(ve,"")),Ae}e.$kf=ae,e.$lf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$mf=fe;function ee(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$nf=ee;function de(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const qe=Ne.length,Le=Ae.toLowerCase();let Ye=0,he=-1;for(;Ye<qe;){const ue=Le.indexOf(Ne[Ye],he+1);if(ue<0)return!1;he=ue,Ye++}return!0}e.$of=de;function be(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$pf=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$qf=Pe;function z(Ae,Ne=1){if(Ne===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Ne--;while(Ne>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$rf=z;function J(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$sf=J;function se(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$tf=se;function oe(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var Z;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Z||(e.GraphemeBreakType=Z={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=Ee()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const qe=this.d,Le=qe.length/3;let Ye=1;for(;Ye<=Le;)if(Ne<qe[3*Ye])Ye=2*Ye;else if(Ne>qe[3*Ye+1])Ye=2*Ye+1;else return qe[3*Ye+2];return 0}}function Ee(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Ne){if(Ae===0)return 0;const qe=We(Ae,Ne);if(qe!==void 0)return qe;const Le=new K(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$uf=je;function We(Ae,Ne){const qe=new K(Ne,Ae);let Le=qe.prevCodePoint();for(;_e(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!Y(Le))return;let Ye=qe.offset;return Ye>0&&qe.prevCodePoint()===8205&&(Ye=qe.offset),Ye}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Xe;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$vf="\xA0";class it{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$xe(Ne=>{function qe(Ze){const nt=new Map;for(let ct=0;ct<Ze.length;ct+=2)nt.set(Ze[ct],Ze[ct+1]);return nt}function Le(Ze,nt){const ct=new Map(Ze);for(const[bt,Et]of nt)ct.set(bt,Et);return ct}function Ye(Ze,nt){if(!Ze)return nt;const ct=new Map;for(const[bt,Et]of Ze)nt.has(bt)&&ct.set(bt,Et);return ct}const he=this.c.value;let ue=Ne.filter(Ze=>!Ze.startsWith("_")&&Ze in he);ue.length===0&&(ue=["_default"]);let Ie;for(const Ze of ue){const nt=qe(he[Ze]);Ie=Ye(Ie,nt)}const Ke=qe(he._common),Ue=Le(Ke,Ie);return new it(Ue)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new T.$V(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=it;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(Ne){return tt.e().has(Ne)}static get codePoints(){return tt.e()}}e.$xf=tt}),define(De[121],Ce([1,0,28,15]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function d(...ee){return function(de,be){for(let Pe=0,z=ee.length;Pe<z;Pe++){const J=ee[Pe](de,be);if(J)return J}return null}}e.or=d,e.$Cj=R.bind(void 0,!1),e.$Dj=R.bind(void 0,!0);function R(ee,de,be){if(!be||be.length<de.length)return null;let Pe;return ee?Pe=T.$3e(be,de):Pe=be.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function A(ee,de){const be=de.toLowerCase().indexOf(ee.toLowerCase());return be===-1?null:[{start:be,end:be+ee.length}]}e.$Ej=A;function m(ee,de){return E(ee.toLowerCase(),de.toLowerCase(),0,0)}e.$Fj=m;function E(ee,de,be,Pe){if(be===ee.length)return[];if(Pe===de.length)return null;if(ee[be]===de[Pe]){let z=null;return(z=E(ee,de,be+1,Pe+1))?s({start:Pe,end:Pe+1},z):null}return E(ee,de,be,Pe+1)}function b(ee){return 97<=ee&&ee<=122}function L(ee){return 65<=ee&&ee<=90}e.$Gj=L;function P(ee){return 48<=ee&&ee<=57}function v(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function k(ee){return v(ee)||y.has(ee)}function p(ee,de){return ee===de||k(ee)&&k(de)}function h(ee){return b(ee)||L(ee)||P(ee)}function s(ee,de){return de.length===0?de=[ee]:ee.end===de[0].start?de[0].start=ee.start:de.unshift(ee),de}function a(ee,de){for(let be=de;be<ee.length;be++){const Pe=ee.charCodeAt(be);if(L(Pe)||P(Pe)||be>0&&!h(ee.charCodeAt(be-1)))return be}return ee.length}function o(ee,de,be,Pe){if(be===ee.length)return[];if(Pe===de.length)return null;if(ee[be]!==de[Pe].toLowerCase())return null;{let z=null,J=Pe+1;for(z=o(ee,de,be+1,Pe+1);!z&&(J=a(de,J))<de.length;)z=o(ee,de,be+1,J),J++;return z===null?null:s({start:Pe,end:Pe+1},z)}}function f(ee){let de=0,be=0,Pe=0,z=0,J=0;for(let Ee=0;Ee<ee.length;Ee++)J=ee.charCodeAt(Ee),L(J)&&de++,b(J)&&be++,h(J)&&Pe++,P(J)&&z++;const se=de/ee.length,oe=be/ee.length,Z=Pe/ee.length,ge=z/ee.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:Z,numericPercent:ge}}function l(ee){const{upperPercent:de,lowerPercent:be}=ee;return be===0&&de>.6}function t(ee){const{upperPercent:de,lowerPercent:be,alphaPercent:Pe,numericPercent:z}=ee;return be>.2&&de<.8&&Pe>.6&&z<.2}function i(ee){let de=0,be=0,Pe=0,z=0;for(let J=0;J<ee.length;J++)Pe=ee.charCodeAt(J),L(Pe)&&de++,b(Pe)&&be++,v(Pe)&&z++;return(de===0||be===0)&&z===0?ee.length<=30:de<=5}function c(ee,de){if(!de||(de=de.trim(),de.length===0)||!i(ee)||de.length>60)return null;const be=f(de);if(!t(be)){if(!l(be))return null;de=de.toLowerCase()}let Pe=null,z=0;for(ee=ee.toLowerCase();z<de.length&&(Pe=o(ee,de,0,z))===null;)z=a(de,z+1);return Pe}e.$Hj=c;function n(ee,de,be=!1){if(!de||de.length===0)return null;let Pe=null,z=0;for(ee=ee.toLowerCase(),de=de.toLowerCase();z<de.length&&(Pe=r(ee,de,0,z,be))===null;)z=u(de,z+1);return Pe}e.$Ij=n;function r(ee,de,be,Pe,z){if(be===ee.length)return[];if(Pe===de.length)return null;if(p(ee.charCodeAt(be),de.charCodeAt(Pe))){let J=null,se=Pe+1;if(J=r(ee,de,be+1,Pe+1,z),!z)for(;!J&&(se=u(de,se))<de.length;)J=r(ee,de,be+1,se,z),se++;return J?ee.charCodeAt(be)!==de.charCodeAt(Pe)?J:s({start:Pe,end:Pe+1},J):null}else return null}function u(ee,de){for(let be=de;be<ee.length;be++)if(k(ee.charCodeAt(be))||be>0&&k(ee.charCodeAt(be-1)))return be;return ee.length}const I=d(e.$Dj,c,A),S=d(e.$Dj,c,m),$=new C.$Dc(1e4);function g(ee,de,be=!1){if(typeof ee!="string"||typeof de!="string")return null;let Pe=$.get(ee);Pe||(Pe=new RegExp(T.$Le(ee),"i"),$.set(ee,Pe));const z=Pe.exec(de);return z?[{start:z.index,end:z.index+z[0].length}]:be?S(ee,de):I(ee,de)}e.$Jj=g;function w(ee,de){const be=re(ee,ee.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Kj=w;function D(ee,de,be,Pe,z,J){const se=Math.min(13,ee.length);for(;be<se;be++){const oe=re(ee,de,be,Pe,z,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,J]}e.$Lj=D;function N(ee){if(typeof ee>"u")return[];const de=[],be=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const z=ee[Pe]+be,J=de[de.length-1];J&&J.end===z?J.end=z+1:de.push({start:z,end:z+1})}return de}e.$Mj=N;const M=128;function F(){const ee=[],de=[];for(let be=0;be<=M;be++)de[be]=0;for(let be=0;be<=M;be++)ee.push(de.slice(0));return ee}function U(ee){const de=[];for(let be=0;be<=ee;be++)de[be]=0;return de}const j=U(2*M),O=U(2*M),q=F(),K=F(),me=F(),te=!1;function G(ee,de,be,Pe,z){function J(oe,Z,ge=" "){for(;oe.length<Z;)oe=ge+oe;return oe}let se=` |   |${Pe.split("").map(oe=>J(oe,3)).join("|")}
`;for(let oe=0;oe<=be;oe++)oe===0?se+=" |":se+=`${de[oe-1]}|`,se+=ee[oe].slice(0,z+1).map(Z=>J(Z.toString(),3)).join("|")+`
`;return se}function Q(ee,de,be,Pe){ee=ee.substr(de),be=be.substr(Pe),console.log(G(K,ee,ee.length,be,be.length)),console.log(G(me,ee,ee.length,be,be.length)),console.log(G(q,ee,ee.length,be,be.length))}function le(ee,de){if(de<0||de>=ee.length)return!1;const be=ee.codePointAt(de);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$if(be)}}function ie(ee,de){if(de<0||de>=ee.length)return!1;switch(ee.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function ce(ee,de,be){return de[ee]!==be[ee]}function ye(ee,de,be,Pe,z,J,se=!1){for(;de<be&&z<J;)ee[de]===Pe[z]&&(se&&(j[de]=z),de+=1),z+=1;return de===be}e.$Nj=ye;var H;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(H||(H={}));var B;(function(ee){ee.Default=[-100,0];function de(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}ee.isDefault=de})(B||(e.FuzzyScore=B={}));class X{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,be){this.firstMatchCanBeWeak=de,this.boostFullMatch=be}}e.$Oj=X;function re(ee,de,be,Pe,z,J,se=X.default){const oe=ee.length>M?M:ee.length,Z=Pe.length>M?M:Pe.length;if(be>=oe||J>=Z||oe-be>Z-J||!ye(de,be,oe,z,J,Z,!0))return;Y(oe,Z,be,J,de,z);let ge=1,Ee=1,je=be,We=J;const _e=[!1];for(ge=1,je=be;je<oe;ge++,je++){const Ne=j[je],qe=O[je],Le=je+1<oe?O[je+1]:Z;for(Ee=Ne-J+1,We=Ne;We<Le;Ee++,We++){let Ye=Number.MIN_SAFE_INTEGER,he=!1;We<=qe&&(Ye=_(ee,de,je,be,Pe,z,We,Z,J,q[ge-1][Ee-1]===0,_e));let ue=0;Ye!==Number.MAX_SAFE_INTEGER&&(he=!0,ue=Ye+K[ge-1][Ee-1]);const Ie=We>Ne,Ke=Ie?K[ge][Ee-1]+(q[ge][Ee-1]>0?-5:0):0,Ue=We>Ne+1&&q[ge][Ee-1]>0,Ze=Ue?K[ge][Ee-2]+(q[ge][Ee-2]>0?-5:0):0;if(Ue&&(!Ie||Ze>=Ke)&&(!he||Ze>=ue))K[ge][Ee]=Ze,me[ge][Ee]=3,q[ge][Ee]=0;else if(Ie&&(!he||Ke>=ue))K[ge][Ee]=Ke,me[ge][Ee]=2,q[ge][Ee]=0;else if(he)K[ge][Ee]=ue,me[ge][Ee]=1,q[ge][Ee]=q[ge-1][Ee-1]+1;else throw new Error("not possible")}}if(te&&Q(ee,be,Pe,J),!_e[0]&&!se.firstMatchCanBeWeak)return;ge--,Ee--;const Xe=[K[ge][Ee],J];let it=0,tt=0;for(;ge>=1;){let Ne=Ee;do{const qe=me[ge][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&de[be+ge-1]===z[J+Ee-1]&&!ce(Ne+J-1,Pe,z)&&it+1>q[ge][Ne]&&(Ne=Ee),Ne===Ee?it++:it=1,tt||(tt=Ne),ge--,Ee=Ne-1,Xe.push(Ee)}Z===oe&&se.boostFullMatch&&(Xe[0]+=2);const Ae=tt-oe;return Xe[0]-=Ae,Xe}e.$Pj=re;function Y(ee,de,be,Pe,z,J){let se=ee-1,oe=de-1;for(;se>=be&&oe>=Pe;)z[se]===J[oe]&&(O[se]=oe,se--),oe--}function _(ee,de,be,Pe,z,J,se,oe,Z,ge,Ee){if(de[be]!==J[se])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return se===be-Pe?je=ee[be]===z[se]?7:5:ce(se,z,J)&&(se===0||!ce(se-1,z,J))?(je=ee[be]===z[se]?7:5,We=!0):le(J,se)&&(se===0||!le(J,se-1))?je=5:(le(J,se-1)||ie(J,se-1))&&(je=5,We=!0),je>1&&be===Pe&&(Ee[0]=!0),We||(We=ce(se,z,J)||le(J,se-1)||ie(J,se-1)),be===Pe?se>Z&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,se+1===oe&&(je-=We?3:5),je}function x(ee,de,be,Pe,z,J,se){return ae(ee,de,be,Pe,z,J,!0,se)}e.$Qj=x;function ve(ee,de,be,Pe,z,J,se){return ae(ee,de,be,Pe,z,J,!1,se)}e.$Rj=ve;function ae(ee,de,be,Pe,z,J,se,oe){let Z=re(ee,de,be,Pe,z,J,oe);if(Z&&!se)return Z;if(ee.length>=3){const ge=Math.min(7,ee.length-1);for(let Ee=be+1;Ee<ge;Ee++){const je=fe(ee,Ee);if(je){const We=re(je,je.toLowerCase(),be,Pe,z,J,oe);We&&(We[0]-=3,(!Z||We[0]>Z[0])&&(Z=We))}}}return Z}function fe(ee,de){if(de+1>=ee.length)return;const be=ee[de],Pe=ee[de+1];if(be!==Pe)return ee.slice(0,de)+Pe+be+ee.slice(de+2)}}),define(De[52],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=void 0;function T(s){return d(s,0)}e.$Di=T;function d(s,a){switch(typeof s){case"object":return s===null?R(349,a):Array.isArray(s)?E(s,a):b(s,a);case"string":return m(s,a);case"boolean":return A(s,a);case"number":return R(s,a);case"undefined":return R(937,a);default:return R(617,a)}}e.$Ei=d;function R(s,a){return(a<<5)-a+s|0}e.$Fi=R;function A(s,a){return R(s?433:863,a)}function m(s,a){a=R(149417,a);for(let o=0,f=s.length;o<f;o++)a=R(s.charCodeAt(o),a);return a}e.$Gi=m;function E(s,a){return a=R(104579,a),s.reduce((o,f)=>d(f,o),a)}function b(s,a){return a=R(181387,a),Object.keys(s).sort().reduce((o,f)=>(o=m(f,o),d(s[f],o)),a)}class L{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=d(a,this.g),this.g}}e.$Hi=L;var P;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function v(s,a,o=32){const f=o-a,l=~((1<<f)-1);return(s<<a|(l&s)>>>f)>>>0}function y(s,a=0,o=s.byteLength,f=0){for(let l=0;l<o;l++)s[a+l]=f}function k(s,a,o="0"){for(;s.length<a;)s=o+s;return s}function p(s,a=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(o=>o.toString(16).padStart(2,"0")).join(""):k((s>>>0).toString(16),a/4)}e.$Ii=p;class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const o=a.length;if(o===0)return;const f=this.p;let l=this.r,t=this.u,i,c;for(t!==0?(i=t,c=-1,t=0):(i=a.charCodeAt(0),c=0);;){let n=i;if(C.$6e(i))if(c+1<o){const r=a.charCodeAt(c+1);C.$7e(r)?(c++,n=C.$8e(i,r)):n=65533}else{t=i;break}else C.$7e(i)&&(n=65533);if(l=this.w(f,l,n),c++,c<o)i=a.charCodeAt(c);else break}this.r=l,this.u=t}w(a,o,f){return f<128?a[o++]=f:f<2048?(a[o++]=192|(f&1984)>>>6,a[o++]=128|(f&63)>>>0):f<65536?(a[o++]=224|(f&61440)>>>12,a[o++]=128|(f&4032)>>>6,a[o++]=128|(f&63)>>>0):(a[o++]=240|(f&1835008)>>>18,a[o++]=128|(f&258048)>>>12,a[o++]=128|(f&4032)>>>6,a[o++]=128|(f&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=h.g,o=this.q;for(let I=0;I<64;I+=4)a.setUint32(I,o.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)a.setUint32(I,v(a.getUint32(I-12,!1)^a.getUint32(I-32,!1)^a.getUint32(I-56,!1)^a.getUint32(I-64,!1),1),!1);let f=this.h,l=this.l,t=this.m,i=this.n,c=this.o,n,r,u;for(let I=0;I<80;I++)I<20?(n=l&t|~l&i,r=1518500249):I<40?(n=l^t^i,r=1859775393):I<60?(n=l&t|l&i|t&i,r=2400959708):(n=l^t^i,r=3395469782),u=v(f,5)+n+c+r+a.getUint32(I*4,!1)&4294967295,c=i,i=t,t=v(l,30),l=f,f=u;this.h=this.h+f&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+i&4294967295,this.o=this.o+c&4294967295}}e.$Ji=h}),define(De[38],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(T||(T={})),function(d){const R="error",A="warning",m="warn",E="info",b="ignore";function L(v){return v?C.$2e(R,v)?d.Error:C.$2e(A,v)||C.$2e(m,v)?d.Warning:C.$2e(E,v)?d.Info:d.Ignore:d.Ignore}d.fromValue=L;function P(v){switch(v){case d.Error:return R;case d.Warning:return A;case d.Info:return E;default:return b}}d.toString=P}(T||(T={})),e.default=T}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(De[78],Ce([1,0,19,15]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class d{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const k=y.charCodeAt(0),p=this.b.charCodeAt(this.c);return k-p}value(){return this.b[this.c]}}e.$Rh=d;class R{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,T.$Ve)(y,this.b,0,y.length,this.c,this.d):(0,T.$Xe)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=R;class A{constructor(y=!0,k=!0){this.f=y,this.g=k}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let k=y.length-1;k>=0;k--,this.c--){const p=this.b.charCodeAt(k);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,T.$Ve)(y,this.b,0,y.length,this.d,this.e):(0,T.$Xe)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=A;var m;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(m||(m={}));class E{constructor(y,k){this.f=y,this.g=k,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,T.$We)(y,this.c.scheme);if(this.d[this.e]===2)return(0,T.$We)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,T.$Ue)(y,this.c.query);if(this.d[this.e]===5)return(0,T.$Ue)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=E;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class P{static forUris(y=()=>!1,k=()=>!1){return new P(new E(y,k))}static forPaths(y=!1){return new P(new A(void 0,!y))}static forStrings(){return new P(new d)}static forConfigKeys(){return new P(new R)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,k){if(k){const p=k.slice(0);(0,C.$Xb)(p);for(const h of p)this.set(h,y)}else{const p=y.slice(0);(0,C.$Xb)(p);for(const h of p)this.set(h[0],h[1])}}set(y,k){const p=this.b.reset(y);let h;this.c||(this.c=new b,this.c.segment=p.value());const s=[];for(h=this.c;;){const o=p.cmp(h.segment);if(o>0)h.left||(h.left=new b,h.left.segment=p.value()),s.push([-1,h]),h=h.left;else if(o<0)h.right||(h.right=new b,h.right.segment=p.value()),s.push([1,h]),h=h.right;else if(p.hasNext())p.next(),h.mid||(h.mid=new b,h.mid.segment=p.value()),s.push([0,h]),h=h.mid;else break}const a=h.value;h.value=k,h.key=y;for(let o=s.length-1;o>=0;o--){const f=s[o][1];f.updateHeight();const l=f.balanceFactor();if(l<-1||l>1){const t=s[o][0],i=s[o+1][0];if(t===1&&i===1)s[o][1]=f.rotateLeft();else if(t===-1&&i===-1)s[o][1]=f.rotateRight();else if(t===1&&i===-1)f.right=s[o+1][1]=s[o+1][1].rotateRight(),s[o][1]=f.rotateLeft();else if(t===-1&&i===1)f.left=s[o+1][1]=s[o+1][1].rotateLeft(),s[o][1]=f.rotateRight();else throw new Error;if(o>0)switch(s[o-1][0]){case-1:s[o-1][1].left=s[o][1];break;case 1:s[o-1][1].right=s[o][1];break;case 0:s[o-1][1].mid=s[o][1];break}else this.c=s[0][1]}}return a}get(y){return this.d(y)?.value}d(y){const k=this.b.reset(y);let p=this.c;for(;p;){const h=k.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(k.hasNext())k.next(),p=p.mid;else break}return p}has(y){const k=this.d(y);return!(k?.value===void 0&&k?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,k){const p=this.b.reset(y),h=[];let s=this.c;for(;s;){const a=p.cmp(s.segment);if(a>0)h.push([-1,s]),s=s.left;else if(a<0)h.push([1,s]),s=s.right;else if(p.hasNext())p.next(),h.push([0,s]),s=s.mid;else break}if(s){if(k?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const a=this.f(s.right);if(a.key){const{key:o,value:f,segment:l}=a;this.e(a.key,!1),s.key=o,s.value=f,s.segment=l}}else{const a=s.left??s.right;if(h.length>0){const[o,f]=h[h.length-1];switch(o){case-1:f.left=a;break;case 0:f.mid=a;break;case 1:f.right=a;break}}else this.c=a}for(let a=h.length-1;a>=0;a--){const o=h[a][1];o.updateHeight();const f=o.balanceFactor();if(f>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),h[a][1]=o.rotateLeft()):f<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),h[a][1]=o.rotateRight()),a>0)switch(h[a-1][0]){case-1:h[a-1][1].left=h[a][1];break;case 1:h[a-1][1].right=h[a][1];break;case 0:h[a-1][1].mid=h[a][1];break}else this.c=h[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const k=this.b.reset(y);let p=this.c,h;for(;p;){const s=k.cmp(p.segment);if(s>0)p=p.left;else if(s<0)p=p.right;else if(k.hasNext())k.next(),h=p.value||h,p=p.mid;else break}return p&&p.value||h}findSuperstr(y){return this.g(y,!1)}g(y,k){const p=this.b.reset(y);let h=this.c;for(;h;){const s=p.cmp(h.segment);if(s>0)h=h.left;else if(s<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else return h.mid?this.h(h.mid):k?h.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[k,p]of this)y(p,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const k=[];return this.j(y,k),k[Symbol.iterator]()}j(y,k){y&&(y.left&&this.j(y.left,k),y.value&&k.push([y.key,y.value]),y.mid&&this.j(y.mid,k),y.right&&this.j(y.right,k))}_isBalanced(){const y=k=>{if(!k)return!0;const p=k.balanceFactor();return p<-1||p>1?!1:y(k.left)&&y(k.right)};return y(this.c)}}e.$Vh=P}),define(De[17],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function C(l){return typeof l=="string"}e.$yf=C;function T(l){return Array.isArray(l)&&l.every(t=>C(t))}e.$zf=T;function d(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$Af=d;function R(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}e.$Bf=R;function A(l){return typeof l=="number"&&!isNaN(l)}e.$Cf=A;function m(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$Df=m;function E(l){return l===!0||l===!1}e.$Ef=E;function b(l){return typeof l>"u"}e.$Ff=b;function L(l){return!P(l)}e.$Gf=L;function P(l){return b(l)||l===null}e.$Hf=P;function v(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$If=v;function y(l){if(P(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$Jf=y;function k(...l){const t=[];for(let i=0;i<l.length;i++){const c=l[i];if(P(c))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(c)}return t}e.$Kf=k;const p=Object.prototype.hasOwnProperty;function h(l){if(!d(l))return!1;for(const t in l)if(p.call(l,t))return!1;return!0}e.$Lf=h;function s(l){return typeof l=="function"}e.$Mf=s;function a(...l){return l.length>0&&l.every(s)}e.$Nf=a;function o(l,t){const i=Math.min(l.length,t.length);for(let c=0;c<i;c++)f(l[c],t[c])}e.$Of=o;function f(l,t){if(C(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(l instanceof t)return}catch{}if(!P(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=f}),define(De[79],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=e.$Sj=void 0;const T=Object.create(null);function d(m,E){if((0,C.$yf)(E)){const b=T[E];if(b===void 0)throw new Error(`${m} references an unknown codicon: ${E}`);E=b}return T[m]=E,{id:m}}function R(){return T}e.$Sj=R;function A(){return Object.values(e.$Uj)}e.$Tj=A,e.$Uj={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(De[24],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function T(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const a=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([o,f])=>{a[o]=f&&typeof f=="object"?T(f):f}),a}e.$7m=T;function d(s){if(!s||typeof s!="object")return s;const a=[s];for(;a.length>0;){const o=a.shift();Object.freeze(o);for(const f in o)if(R.call(o,f)){const l=o[f];typeof l=="object"&&!Object.isFrozen(l)&&!(0,C.$Bf)(l)&&a.push(l)}}return s}e.$8m=d;const R=Object.prototype.hasOwnProperty;function A(s,a){return m(s,a,new Set)}e.$9m=A;function m(s,a,o){if((0,C.$Hf)(s))return s;const f=a(s);if(typeof f<"u")return f;if(Array.isArray(s)){const l=[];for(const t of s)l.push(m(t,a,o));return l}if((0,C.$Af)(s)){if(o.has(s))throw new Error("Cannot clone recursive data-structure");o.add(s);const l={};for(const t in s)R.call(s,t)&&(l[t]=m(s[t],a,o));return o.delete(s),l}return s}function E(s,a,o=!0){return(0,C.$Af)(s)?((0,C.$Af)(a)&&Object.keys(a).forEach(f=>{f in s?o&&((0,C.$Af)(s[f])&&(0,C.$Af)(a[f])?E(s[f],a[f],o):s[f]=a[f]):s[f]=a[f]}),s):a}e.$0m=E;function b(s,a){if(s===a)return!0;if(s==null||a===null||a===void 0||typeof s!=typeof a||typeof s!="object"||Array.isArray(s)!==Array.isArray(a))return!1;let o,f;if(Array.isArray(s)){if(s.length!==a.length)return!1;for(o=0;o<s.length;o++)if(!b(s[o],a[o]))return!1}else{const l=[];for(f in s)l.push(f);l.sort();const t=[];for(f in a)t.push(f);if(t.sort(),!b(l,t))return!1;for(o=0;o<l.length;o++)if(!b(s[l[o]],a[l[o]]))return!1}return!0}e.$$m=b;function L(s){const a=new Set;return JSON.stringify(s,(o,f)=>{if((0,C.$Af)(f)||Array.isArray(f)){if(a.has(f))return"[Circular]";a.add(f)}return f})}e.$_m=L;function P(s,a){const o=Object.create(null);return!s||!a||Object.keys(a).forEach(l=>{const t=s[l],i=a[l];b(t,i)||(o[l]=i)}),o}e.$an=P;function v(s,a){const o=a.toLowerCase(),f=Object.keys(s).find(l=>l.toLowerCase()===o);return f?s[f]:s[a]}e.$bn=v;function y(s,a){const o=Object.create(null);for(const[f,l]of Object.entries(s))a(f,l)&&(o[f]=l);return o}e.$cn=y;function k(s){let a=[];for(;Object.prototype!==s;)a=a.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return a}e.$dn=k;function p(s){const a=[];for(const o of k(s))typeof s[o]=="function"&&a.push(o);return a}e.$en=p;function h(s,a){const o=l=>function(){const t=Array.prototype.slice.call(arguments,0);return a(l,t)},f={};for(const l of s)f[l]=o(l);return f}e.$fn=h}),define(De[59],Ce([1,0,79]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var T;(function(A){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=m})(T||(e.ThemeColor=T={}));function d(A){return{id:A}}e.$Vj=d;var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(a){const o=m.exec(a.id);if(!o)return E(C.$Uj.error);const[,f,l]=o,t=["codicon","codicon-"+f];return l&&t.push("codicon-modifier-"+l.substring(1)),t}A.asClassNameArray=E;function b(a){return E(a).join(" ")}A.asClassName=b;function L(a){return"."+E(a).join(".")}A.asCSSSelector=L;function P(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||T.isThemeColor(a.color))}A.isThemeIcon=P;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(a){const o=v.exec(a);if(!o)return;const[,f]=o;return{id:f}}A.fromString=y;function k(a){return{id:a}}A.fromId=k;function p(a,o){let f=a.id;const l=f.lastIndexOf("~");return l!==-1&&(f=f.substring(0,l)),o&&(f=`${f}~${o}`),{id:f}}A.modify=p;function h(a){const o=a.id.lastIndexOf("~");if(o!==-1)return a.id.substring(o+1)}A.getModifier=h;function s(a,o){return a.id===o.id&&a.color?.id===o.color?.id}A.isEqual=s})(R||(e.ThemeIcon=R={}))}),define(De[161],Ce([1,0,121,15,59]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const R="$(",A=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function E(s){return s.replace(m,(a,o)=>o?a:`\\${a}`)}e.$Wj=E;const b=new RegExp(`\\\\${A.source}`,"g");function L(s){return s.replace(b,a=>`\\${a}`)}e.$Xj=L;const P=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(s){return s.indexOf(R)===-1?s:s.replace(P,(a,o,f,l)=>f?a:o||l||"")}e.$Yj=v;function y(s){return s?s.replace(/\$\((.*?)\)/g,(a,o)=>` ${o} `).trim():""}e.$Zj=y;const k=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(s){k.lastIndex=0;let a="";const o=[];let f=0;for(;;){const l=k.lastIndex,t=k.exec(s),i=s.substring(l,t?.index);if(i.length>0){a+=i;for(let c=0;c<i.length;c++)o.push(f)}if(!t)break;f+=t[0].length}return{text:a,iconOffsets:o}}e.$1j=p;function h(s,a,o=!1){const{text:f,iconOffsets:l}=a;if(!l||l.length===0)return(0,C.$Jj)(s,f,o);const t=(0,T.$Je)(f," "),i=f.length-t.length,c=(0,C.$Jj)(s,t,o);if(c)for(const n of c){const r=l[n.start+i]+i;n.start+=r,n.end+=r}return c}e.$2j=h}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.Constants=void 0;var C;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function T(R){return R<0?0:R>255?255:R|0}e.$ze=T;function d(R){return R<0?0:R>4294967295?4294967295:R|0}e.$Ae=d}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(d){return C.test(d)}e.$dg=T,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function(m){for(let E=0;E<m.length;E++)m[E]=Math.floor(Math.random()*256);return m};const R=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){d(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let E=0,b="";return b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+="-",b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b+=A[R[E++]],b}}()}),define(De[162],Ce([1,0,19,51,31]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=e.$Zs=e.$Ys=void 0;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$Ys=R;function A(P,v,y){const k={id:(0,d.$eg)(),name:P,uri:v,data:y};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$Zs=A;class m{constructor(){this.a=new Map}get size(){let v=0;for(const y of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const y=[...this.a.keys()];return T.Iterable.some(this,([k,p])=>p.asFile())&&y.push("files"),L(E(v),y)}get(v){return this.a.get(this.b(v))?.[0]}append(v,y){const k=this.a.get(v);k?k.push(y):this.a.set(this.b(v),[y])}replace(v,y){this.a.set(this.b(v),[y])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,y]of this.a)for(const k of y)yield[v,k]}b(v){return E(v)}}e.$1s=m;function E(P){return P.toLowerCase()}function b(P,v){return L(E(P),v.map(E))}e.$2s=b;function L(P,v){if(P==="*/*")return v.length>0;if(v.includes(P))return!0;const y=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[k,p,h]=y;return h==="*"?v.some(s=>s.startsWith(p+"/")):!1}e.$3s=Object.freeze({create:P=>(0,C.$Mb)(P.map(v=>v.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$3s.split(P).filter(v=>!v.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function T(m,E,b,L=1){let P=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!P)return P=!0,v(0)},b);d(m,E,L,k=>{if(!P)return P=!0,clearTimeout(y),v(k)})})}e.$gg=T;function d(m,E,b,L){if(E===0)return L(0);const P=new C.Socket;P.once("connect",()=>(A(P),d(m+b,E-1,b,L))),P.once("data",()=>{}),P.once("error",v=>(A(P),v.code!=="ECONNREFUSED"?d(m+b,E-1,b,L):L(m))),P.connect(m,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(m,E,b,L="127.0.0.1"){let P=!1,v,y=1;const k=C.createServer({pauseOnConnect:!0});function p(h,s){P||(P=!0,k.removeAllListeners(),k.close(),v&&clearTimeout(v),s(h))}return new Promise(h=>{v=setTimeout(()=>{p(0,h)},b),k.on("listening",()=>{p(m,h)}),k.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&y<E?(m++,y++,k.listen(m,L)):p(0,h)}),k.on("close",()=>{p(0,h)}),k.listen(m,L)})}e.$ig=R;function A(m){try{m.removeAllListeners("connect"),m.removeAllListeners("error"),m.end(),m.destroy(),m.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=e.$Qs=void 0;class T{constructor(m){const E=(0,C.$ze)(m);this.c=E,this.a=T.d(E),this.b=new Map}static d(m){const E=new Uint8Array(256);return E.fill(m),E}set(m,E){const b=(0,C.$ze)(E);m>=0&&m<256?this.a[m]=b:this.b.set(m,b)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Qs=T;var d;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(d||(d={}));class R{constructor(){this.a=new T(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$Rs=R}),define(De[61],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0;class C{constructor(d,R){this.lineNumber=d,this.column=R}with(d=this.lineNumber,R=this.column){return d===this.lineNumber&&R===this.column?this:new C(d,R)}delta(d=0,R=0){return this.with(this.lineNumber+d,this.column+R)}equals(d){return C.equals(this,d)}static equals(d,R){return!d&&!R?!0:!!d&&!!R&&d.lineNumber===R.lineNumber&&d.column===R.column}isBefore(d){return C.isBefore(this,d)}static isBefore(d,R){return d.lineNumber<R.lineNumber?!0:R.lineNumber<d.lineNumber?!1:d.column<R.column}isBeforeOrEqual(d){return C.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,R){return d.lineNumber<R.lineNumber?!0:R.lineNumber<d.lineNumber?!1:d.column<=R.column}static compare(d,R){const A=d.lineNumber|0,m=R.lineNumber|0;if(A===m){const E=d.column|0,b=R.column|0;return E-b}return A-m}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new C(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.$ss=C}),define(De[32],Ce([1,0,61]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=void 0;class T{constructor(R,A,m,E){R>m||R===m&&A>E?(this.startLineNumber=m,this.startColumn=E,this.endLineNumber=R,this.endColumn=A):(this.startLineNumber=R,this.startColumn=A,this.endLineNumber=m,this.endColumn=E)}isEmpty(){return T.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return T.containsPosition(this,R)}static containsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<R.startColumn||A.lineNumber===R.endLineNumber&&A.column>R.endColumn)}static strictContainsPosition(R,A){return!(A.lineNumber<R.startLineNumber||A.lineNumber>R.endLineNumber||A.lineNumber===R.startLineNumber&&A.column<=R.startColumn||A.lineNumber===R.endLineNumber&&A.column>=R.endColumn)}containsRange(R){return T.containsRange(this,R)}static containsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>R.endColumn)}strictContainsRange(R){return T.strictContainsRange(this,R)}static strictContainsRange(R,A){return!(A.startLineNumber<R.startLineNumber||A.endLineNumber<R.startLineNumber||A.startLineNumber>R.endLineNumber||A.endLineNumber>R.endLineNumber||A.startLineNumber===R.startLineNumber&&A.startColumn<=R.startColumn||A.endLineNumber===R.endLineNumber&&A.endColumn>=R.endColumn)}plusRange(R){return T.plusRange(this,R)}static plusRange(R,A){let m,E,b,L;return A.startLineNumber<R.startLineNumber?(m=A.startLineNumber,E=A.startColumn):A.startLineNumber===R.startLineNumber?(m=A.startLineNumber,E=Math.min(A.startColumn,R.startColumn)):(m=R.startLineNumber,E=R.startColumn),A.endLineNumber>R.endLineNumber?(b=A.endLineNumber,L=A.endColumn):A.endLineNumber===R.endLineNumber?(b=A.endLineNumber,L=Math.max(A.endColumn,R.endColumn)):(b=R.endLineNumber,L=R.endColumn),new T(m,E,b,L)}intersectRanges(R){return T.intersectRanges(this,R)}static intersectRanges(R,A){let m=R.startLineNumber,E=R.startColumn,b=R.endLineNumber,L=R.endColumn;const P=A.startLineNumber,v=A.startColumn,y=A.endLineNumber,k=A.endColumn;return m<P?(m=P,E=v):m===P&&(E=Math.max(E,v)),b>y?(b=y,L=k):b===y&&(L=Math.min(L,k)),m>b||m===b&&E>L?null:new T(m,E,b,L)}equalsRange(R){return T.equalsRange(this,R)}static equalsRange(R,A){return!R&&!A?!0:!!R&&!!A&&R.startLineNumber===A.startLineNumber&&R.startColumn===A.startColumn&&R.endLineNumber===A.endLineNumber&&R.endColumn===A.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(R){return new C.$ss(R.endLineNumber,R.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(R){return new C.$ss(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,A){return new T(this.startLineNumber,this.startColumn,R,A)}setStartPosition(R,A){return new T(R,A,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(R){return new T(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(R){return new T(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new T(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,A=R){return new T(R.lineNumber,R.column,A.lineNumber,A.column)}static lift(R){return R?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn)}static areIntersecting(R,A){return!(R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn||A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,A){if(R&&A){const b=R.startLineNumber|0,L=A.startLineNumber|0;if(b===L){const P=R.startColumn|0,v=A.startColumn|0;if(P===v){const y=R.endLineNumber|0,k=A.endLineNumber|0;if(y===k){const p=R.endColumn|0,h=A.endColumn|0;return p-h}return y-k}return P-v}return b-L}return(R?1:0)-(A?1:0)}static compareRangesUsingEnds(R,A){return R.endLineNumber===A.endLineNumber?R.endColumn===A.endColumn?R.startLineNumber===A.startLineNumber?R.startColumn-A.startColumn:R.startLineNumber-A.startLineNumber:R.endColumn-A.endColumn:R.endLineNumber-A.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$ts=T}),define(De[164],Ce([1,0,32]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0;class T{static insert(R,A){return{range:new C.$ts(R.lineNumber,R.column,R.lineNumber,R.column),text:A,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,A){return{range:R,text:A}}static replaceMove(R,A){return{range:R,text:A,forceMoveMarkers:!0}}}e.$us=T}),define(De[165],Ce([1,0,61,32]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=e.SelectionDirection=void 0;var d;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class R extends T.$ts{constructor(m,E,b,L){super(m,E,b,L),this.selectionStartLineNumber=m,this.selectionStartColumn=E,this.positionLineNumber=b,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return R.selectionsEqual(this,m)}static selectionsEqual(m,E){return m.selectionStartLineNumber===E.selectionStartLineNumber&&m.selectionStartColumn===E.selectionStartColumn&&m.positionLineNumber===E.positionLineNumber&&m.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,E){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,m,E):new R(m,E,this.startLineNumber,this.startColumn)}getPosition(){return new C.$ss(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$ss(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,E){return this.getDirection()===0?new R(m,E,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,m,E)}static fromPositions(m,E=m){return new R(m.lineNumber,m.column,E.lineNumber,E.column)}static fromRange(m,E){return E===0?new R(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new R(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new R(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,E){if(m&&!E||!m&&E)return!1;if(!m&&!E)return!0;if(m.length!==E.length)return!1;for(let b=0,L=m.length;b<L;b++)if(!this.selectionsEqual(m[b],E[b]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,E,b,L,P){return P===0?new R(m,E,b,L):new R(b,L,m,E)}}e.$vs=R}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0,e.$3r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.WordCharacterClass=void 0;var T;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class d extends C.$Qs{constructor(m){super(0);for(let E=0,b=m.length;E<b;E++)this.set(m.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ss=d;function R(A){const m={};return E=>(m.hasOwnProperty(E)||(m[E]=A(E)),m[E])}e.$Ts=R(A=>new d(A))}),define(De[124],Ce([1,0,51,3,76]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$4r)P.indexOf(y)>=0||(v+="\\"+y);return v+="\\s]+)",new RegExp(v,"g")}e.$5r=R();function A(P){let v=e.$5r;if(P&&P instanceof RegExp)if(P.global)v=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),v=new RegExp(P.source,y)}return v.lastIndex=0,v}e.$6r=A;const m=new d.$2c;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(P){const v=m.unshift(P);return(0,T.$Qc)(v)}e.$7r=E;function b(P,v,y,k,p){if(p||(p=C.Iterable.first(m)),y.length>p.maxLen){let f=P-p.maxLen/2;return f<0?f=0:k+=f,y=y.substring(f,P+p.maxLen/2),b(P,v,y,k,p)}const h=Date.now(),s=P-1-k;let a=-1,o=null;for(let f=1;!(Date.now()-h>=p.timeBudget);f++){const l=s-p.windowSize*f;v.lastIndex=Math.max(0,l);const t=L(v,y,s,a);if(!t&&o||(o=t,l<=0))break;a=l}if(o){const f={word:o[0],startColumn:k+1+o.index,endColumn:k+1+o.index+o[0].length};return v.lastIndex=0,f}return null}e.$8r=b;function L(P,v,y,k){let p;for(;p=P.exec(v);){const h=p.index||0;if(h<=y&&P.lastIndex>=y)return p;if(k>0&&h>k)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class T{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let E=0,b=m.notIn.length;E<b;E++)switch(m.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,E){if(m.getTokenCount()===0)return!0;const b=m.findTokenIndexAtOffset(E-2),L=m.getStandardTokenType(b);return this.isOK(L)}g(m,E){for(let b=m;b<=E;b++){const L=String.fromCharCode(b);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$pt=T;class d{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of m)R(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),R(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),R(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),R(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&R(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$qt=d;function R(A,m,E){A.has(m)?A.get(m).push(E):A.set(m,[E])}}),define(De[169],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Y=e.$7Y=e.$6Y=e.State=void 0;var T;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class d{constructor(k,p,h){const s=new Uint8Array(k*p);for(let a=0,o=k*p;a<o;a++)s[a]=h;this.a=s,this.rows=k,this.cols=p}get(k,p){return this.a[k*this.cols+p]}set(k,p,h){this.a[k*this.cols+p]=h}}class R{constructor(k){let p=0,h=0;for(let a=0,o=k.length;a<o;a++){const[f,l,t]=k[a];l>p&&(p=l),f>h&&(h=f),t>h&&(h=t)}p++,h++;const s=new d(h,p,0);for(let a=0,o=k.length;a<o;a++){const[f,l,t]=k[a];s.set(f,l,t)}this.a=s,this.b=p}nextState(k,p){return p<0||p>=this.b?0:this.a.get(k,p)}}e.$6Y=R;let A=null;function m(){return A===null&&(A=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let b=null;function L(){if(b===null){b=new C.$Qs(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<y.length;p++)b.set(y.charCodeAt(p),1);const k=".,;:";for(let p=0;p<k.length;p++)b.set(k.charCodeAt(p),2)}return b}class P{static a(k,p,h,s,a){let o=a-1;do{const f=p.charCodeAt(o);if(k.get(f)!==2)break;o--}while(o>s);if(s>0){const f=p.charCodeAt(s-1),l=p.charCodeAt(o);(f===40&&l===41||f===91&&l===93||f===123&&l===125)&&o--}return{range:{startLineNumber:h,startColumn:s+1,endLineNumber:h,endColumn:o+2},url:p.substring(s,o+1)}}static computeLinks(k,p=m()){const h=L(),s=[];for(let a=1,o=k.getLineCount();a<=o;a++){const f=k.getLineContent(a),l=f.length;let t=0,i=0,c=0,n=1,r=!1,u=!1,I=!1,S=!1;for(;t<l;){let $=!1;const g=f.charCodeAt(t);if(n===13){let w;switch(g){case 40:r=!0,w=0;break;case 41:w=r?0:1;break;case 91:I=!0,u=!0,w=0;break;case 93:I=!1,w=u?0:1;break;case 123:S=!0,w=0;break;case 125:w=S?0:1;break;case 39:case 34:case 96:c===g?w=1:c===39||c===34||c===96?w=0:w=1;break;case 42:w=c===42?1:0;break;case 124:w=c===124?1:0;break;case 32:w=I?0:1;break;default:w=h.get(g)}w===1&&(s.push(P.a(h,f,a,i,t)),$=!0)}else if(n===12){let w;g===91?(u=!0,w=0):w=h.get(g),w===1?$=!0:n=13}else n=p.nextState(n,g),n===0&&($=!0);$&&(n=1,r=!1,u=!1,S=!1,i=t+1,c=g),t++}n===13&&s.push(P.a(h,f,a,i,l))}return s}}e.$7Y=P;function v(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.$8Y=v}),define(De[125],Ce([1,0,24]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pu=e.$Ou=e.$Nu=e.$Mu=e.ModelConstants=e.PositionAffinity=e.$Lu=e.TrackedRangeStickiness=e.$Ku=e.$Ju=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var d;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var R;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var A;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var m;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var E;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var b;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,C.$$m)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.$Ju=L;class P{constructor(l,t){this._findMatchBrand=void 0,this.range=l,this.matches=t}}e.$Ku=P;var v;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function y(f){return f&&typeof f.read=="function"}e.$Lu=y;var k;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var p;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class h{constructor(l,t,i,c,n,r){this.identifier=l,this.range=t,this.text=i,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=n,this._isTracked=r}}e.$Mu=h;class s{constructor(l,t,i){this.regex=l,this.wordSeparators=t,this.simpleSearch=i}}e.$Nu=s;class a{constructor(l,t,i){this.reverseEdits=l,this.changes=t,this.trimAutoWhitespaceLineNumbers=i}}e.$Ou=a;function o(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.$Pu=o}),define(De[170],Ce([1,0,19,122]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.$Su=void 0;class d{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,b){E=(0,T.$Ae)(E);const L=this.a,P=this.b,v=b.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E),E+v),this.a.set(b,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(E,b){return E=(0,T.$Ae)(E),b=(0,T.$Ae)(b),this.a[E]===b?!1:(this.a[E]=b,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,b){E=(0,T.$Ae)(E),b=(0,T.$Ae)(b);const L=this.a,P=this.b;if(E>=L.length)return!1;const v=L.length-E;return b>=v&&(b=v),b===0?!1:(this.a=new Uint32Array(L.length-b),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E+b),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,T.$Ae)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let b=this.c[0]+1;b===0&&(this.b[0]=this.a[0],b++),E>=this.a.length&&(E=this.a.length-1);for(let L=b;L<=E;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let b=0,L=this.a.length-1,P=0,v=0,y=0;for(;b<=L;)if(P=b+(L-b)/2|0,v=this.b[P],y=v-this.a[P],E<y)L=P-1;else if(E>=v)b=P+1;else break;return new A(P,E-y)}}e.$Su=d;class R{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const b=this.e[E],L=b>0?this.d[b-1]:0;return new A(b,E-L)}removeValues(E,b){this.a.splice(E,b),this.f(E)}insertValues(E,b){this.a=(0,C.$Wb)(this.a,E,b),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,b=this.a.length;E<b;E++){const L=this.a[E],P=E>0?this.d[E-1]:0;this.d[E]=P+L;for(let v=0;v<L;v++)this.e[P+v]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,b){this.a[E]!==b&&(this.a[E]=b,this.f(E))}}e.$Tu=R;class A{constructor(E,b){this.index=E,this.remainder=b,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=b}}e.$Uu=A}),define(De[171],Ce([1,0,15,61,170]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=void 0;class R{constructor(m,E,b,L){this.d=m,this.f=E,this.g=b,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const E=m.changes;for(const b of E)this.o(b.range),this.p(new T.$ss(b.range.startLineNumber,b.range.startColumn),b.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,E=this.f.length,b=new Uint32Array(E);for(let L=0;L<E;L++)b[L]=this.f[L].length+m;this.j=new d.$Su(b)}}n(m,E){this.f[m]=E,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,E){if(E.length===0)return;const b=(0,C.$Pe)(E);if(b.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]+this.f[m.lineNumber-1].substring(m.column-1));return}b[b.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]);const L=new Uint32Array(b.length-1);for(let P=1;P<b.length;P++)this.f.splice(m.lineNumber+P-1,0,b[P]),L[P-1]=b[P].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,L)}}e.$Vu=R}),define(De[172],Ce([1,0,15,167,61,32,125]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=void 0;const m=999;class E{constructor(a,o,f,l){this.searchString=a,this.isRegex=o,this.matchCase=f,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=b(this.searchString):a=this.searchString.indexOf(`
`)>=0;let o=null;try{o=C.$Ne(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch{return null}if(!o)return null;let f=!this.isRegex&&!a;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new A.$Nu(o,this.wordSeparators?(0,T.$Ts)(this.wordSeparators):null,f?this.searchString:null)}}e.$uB=E;function b(s){if(!s||s.length===0)return!1;for(let a=0,o=s.length;a<o;a++){const f=s.charCodeAt(a);if(f===10)return!0;if(f===92){if(a++,a>=o)break;const l=s.charCodeAt(a);if(l===110||l===114||l===87)return!0}}return!1}e.$vB=b;function L(s,a,o){if(!o)return new A.$Ku(s,null);const f=[];for(let l=0,t=a.length;l<t;l++)f[l]=a[l];return new A.$Ku(s,f)}e.$wB=L;class P{constructor(a){const o=[];let f=0;for(let l=0,t=a.length;l<t;l++)a.charCodeAt(l)===10&&(o[f++]=l);this.a=o}findLineFeedCountBeforeOffset(a){const o=this.a;let f=0,l=o.length-1;if(l===-1||a<=o[0])return 0;for(;f<l;){const t=f+((l-f)/2>>0);o[t]>=a?l=t-1:o[t+1]>=a?(f=t,l=t):f=t+1}return f+1}}class v{static findMatches(a,o,f,l,t){const i=o.parseSearchRequest();return i?i.regex.multiline?this.b(a,f,new h(i.wordSeparators,i.regex),l,t):this.c(a,f,i,l,t):[]}static a(a,o,f,l,t,i){let c,n=0;l?(n=l.findLineFeedCountBeforeOffset(t),c=o+t+n):c=o+t;let r;if(l){const $=l.findLineFeedCountBeforeOffset(t+i.length)-n;r=c+i.length+$}else r=c+i.length;const u=a.getPositionAt(c),I=a.getPositionAt(r);return new R.$ts(u.lineNumber,u.column,I.lineNumber,I.column)}static b(a,o,f,l,t){const i=a.getOffsetAt(o.getStartPosition()),c=a.getValueInRange(o,1),n=a.getEOL()===`\r
`?new P(c):null,r=[];let u=0,I;for(f.reset(0);I=f.next(c);)if(r[u++]=L(this.a(a,i,c,n,I.index,I[0]),I,l),u>=t)return r;return r}static c(a,o,f,l,t){const i=[];let c=0;if(o.startLineNumber===o.endLineNumber){const r=a.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return c=this.d(f,r,o.startLineNumber,o.startColumn-1,c,i,l,t),i}const n=a.getLineContent(o.startLineNumber).substring(o.startColumn-1);c=this.d(f,n,o.startLineNumber,o.startColumn-1,c,i,l,t);for(let r=o.startLineNumber+1;r<o.endLineNumber&&c<t;r++)c=this.d(f,a.getLineContent(r),r,0,c,i,l,t);if(c<t){const r=a.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);c=this.d(f,r,o.endLineNumber,0,c,i,l,t)}return i}static d(a,o,f,l,t,i,c,n){const r=a.wordSeparators;if(!c&&a.simpleSearch){const S=a.simpleSearch,$=S.length,g=o.length;let w=-$;for(;(w=o.indexOf(S,w+$))!==-1;)if((!r||p(r,o,g,w,$))&&(i[t++]=new A.$Ku(new R.$ts(f,w+1+l,f,w+1+$+l),null),t>=n))return t;return t}const u=new h(a.wordSeparators,a.regex);let I;u.reset(0);do if(I=u.next(o),I&&(i[t++]=L(new R.$ts(f,I.index+1+l,f,I.index+1+I[0].length+l),I,c),t>=n))return t;while(I);return t}static findNextMatch(a,o,f,l){const t=o.parseSearchRequest();if(!t)return null;const i=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.e(a,f,i,l):this.f(a,f,i,l)}static e(a,o,f,l){const t=new d.$ss(o.lineNumber,1),i=a.getOffsetAt(t),c=a.getLineCount(),n=a.getValueInRange(new R.$ts(t.lineNumber,t.column,c,a.getLineMaxColumn(c)),1),r=a.getEOL()===`\r
`?new P(n):null;f.reset(o.column-1);const u=f.next(n);return u?L(this.a(a,i,n,r,u.index,u[0]),u,l):o.lineNumber!==1||o.column!==1?this.e(a,new d.$ss(1,1),f,l):null}static f(a,o,f,l){const t=a.getLineCount(),i=o.lineNumber,c=a.getLineContent(i),n=this.g(f,c,i,o.column,l);if(n)return n;for(let r=1;r<=t;r++){const u=(i+r-1)%t,I=a.getLineContent(u+1),S=this.g(f,I,u+1,1,l);if(S)return S}return null}static g(a,o,f,l,t){a.reset(l-1);const i=a.next(o);return i?L(new R.$ts(f,i.index+1,f,i.index+1+i[0].length),i,t):null}static findPreviousMatch(a,o,f,l){const t=o.parseSearchRequest();if(!t)return null;const i=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.h(a,f,i,l):this.j(a,f,i,l)}static h(a,o,f,l){const t=this.b(a,new R.$ts(1,1,o.lineNumber,o.column),f,l,10*m);if(t.length>0)return t[t.length-1];const i=a.getLineCount();return o.lineNumber!==i||o.column!==a.getLineMaxColumn(i)?this.h(a,new d.$ss(i,a.getLineMaxColumn(i)),f,l):null}static j(a,o,f,l){const t=a.getLineCount(),i=o.lineNumber,c=a.getLineContent(i).substring(0,o.column-1),n=this.k(f,c,i,l);if(n)return n;for(let r=1;r<=t;r++){const u=(t+i-r-1)%t,I=a.getLineContent(u+1),S=this.k(f,I,u+1,l);if(S)return S}return null}static k(a,o,f,l){let t=null,i;for(a.reset(0);i=a.next(o);)t=L(new R.$ts(f,i.index+1,f,i.index+1+i[0].length),i,l);return t}}e.$xB=v;function y(s,a,o,f,l){if(f===0)return!0;const t=a.charCodeAt(f-1);if(s.get(t)!==0||t===13||t===10)return!0;if(l>0){const i=a.charCodeAt(f);if(s.get(i)!==0)return!0}return!1}function k(s,a,o,f,l){if(f+l===o)return!0;const t=a.charCodeAt(f+l);if(s.get(t)!==0||t===13||t===10)return!0;if(l>0){const i=a.charCodeAt(f+l-1);if(s.get(i)!==0)return!0}return!1}function p(s,a,o,f,l){return y(s,a,o,f,l)&&k(s,a,o,f,l)}e.$yB=p;class h{constructor(a,o){this._wordSeparators=a,this.a=o,this.b=-1,this.c=0}reset(a){this.a.lastIndex=a,this.b=-1,this.c=0}next(a){const o=a.length;let f;do{if(this.b+this.c===o||(f=this.a.exec(a),!f))return null;const l=f.index,t=f[0].length;if(l===this.b&&t===this.c){if(t===0){C.$9e(a,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=t,!this._wordSeparators||p(this._wordSeparators,a,o,l,t))return f}while(f);return null}}e.$zB=h}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7=e.$S7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const A=this.a.get(R);return this.a.delete(R),A}}addDragOperationTransfer(R,A){this.a.set(R,A)}}e.$S7=C;class T{constructor(R){this.identifier=R}}e.$T7=T}),define(De[174],Ce([1,0,4,3]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0;class d{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Nd,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,E){return this.a.set(m,E),this.handleChange([m]),(0,T.$Qc)(()=>{this.a.get(m)===E&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,E){this.b.get(m)?.dispose();const b=new R(this,m,E);return this.b.set(m,b),(0,T.$Qc)(()=>{const L=this.b.get(m);!L||L!==b||(this.b.delete(m),L.dispose())})}async getOrCreate(m){const E=this.get(m);if(E)return E;const b=this.b.get(m);return!b||b.isResolved?null:(await b.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const b=this.b.get(m);return!!(!b||b.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$5s=d;class R extends T.$Sc{get isResolved(){return this.c}constructor(m,E,b){super(),this.f=m,this.g=E,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(De[175],Ce([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class R extends T.$Sc{constructor(v,y="",k="",p=!0,h){super(),this.h=this.B(new C.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=y,this.u=k,this.w=p,this.C=h}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,y){this.C&&await this.C(v)}}e.$ui=R;class A extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new C.$Nd),this.onWillRun=this.f.event,this.m=this.B(new C.$Nd),this.onDidRun=this.m.event}async run(v,y){if(!v.enabled)return;this.f.fire({action:v});let k;try{await this.u(v,y)}catch(p){k=p}this.m.fire({action:v,error:k})}async u(v,y){await v.run(y)}}e.$vi=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let y=[];for(const k of v)k.length&&(y.length?y=[...y,new m,...k]:y=k);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=m;class E{get actions(){return this.a}constructor(v,y,k,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=y,this.class=p,this.a=k}async run(){}}e.$xi=E;class b extends R{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,d.localize(0,null),void 0,!1)}}e.$yi=b;function L(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...v)=>P.run(...v),tooltip:P.label}}e.$zi=L}),define(De[177],Ce([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const T=60,d=T*60,R=d*24,A=R*7,m=R*30,E=R*365;function b(P,v,y,k){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return(0,C.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(!k&&p<30)return(0,C.localize)(1,null);let h;return p<T?(h=p,v?h===1?y?(0,C.localize)(2,null,h):(0,C.localize)(3,null,h):y?(0,C.localize)(4,null,h):(0,C.localize)(5,null,h):h===1?y?(0,C.localize)(6,null,h):(0,C.localize)(7,null,h):y?(0,C.localize)(8,null,h):(0,C.localize)(9,null,h)):p<d?(h=Math.floor(p/T),v?h===1?y?(0,C.localize)(10,null,h):(0,C.localize)(11,null,h):y?(0,C.localize)(12,null,h):(0,C.localize)(13,null,h):h===1?y?(0,C.localize)(14,null,h):(0,C.localize)(15,null,h):y?(0,C.localize)(16,null,h):(0,C.localize)(17,null,h)):p<R?(h=Math.floor(p/d),v?h===1?y?(0,C.localize)(18,null,h):(0,C.localize)(19,null,h):y?(0,C.localize)(20,null,h):(0,C.localize)(21,null,h):h===1?y?(0,C.localize)(22,null,h):(0,C.localize)(23,null,h):y?(0,C.localize)(24,null,h):(0,C.localize)(25,null,h)):p<A?(h=Math.floor(p/R),v?h===1?(0,C.localize)(26,null,h):(0,C.localize)(27,null,h):h===1?(0,C.localize)(28,null,h):(0,C.localize)(29,null,h)):p<m?(h=Math.floor(p/A),v?h===1?y?(0,C.localize)(30,null,h):(0,C.localize)(31,null,h):y?(0,C.localize)(32,null,h):(0,C.localize)(33,null,h):h===1?y?(0,C.localize)(34,null,h):(0,C.localize)(35,null,h):y?(0,C.localize)(36,null,h):(0,C.localize)(37,null,h)):p<E?(h=Math.floor(p/m),v?h===1?y?(0,C.localize)(38,null,h):(0,C.localize)(39,null,h):y?(0,C.localize)(40,null,h):(0,C.localize)(41,null,h):h===1?y?(0,C.localize)(42,null,h):(0,C.localize)(43,null,h):y?(0,C.localize)(44,null,h):(0,C.localize)(45,null,h)):(h=Math.floor(p/E),v?h===1?y?(0,C.localize)(46,null,h):(0,C.localize)(47,null,h):y?(0,C.localize)(48,null,h):(0,C.localize)(49,null,h):h===1?y?(0,C.localize)(50,null,h):(0,C.localize)(51,null,h):y?(0,C.localize)(52,null,h):(0,C.localize)(53,null,h))}e.$dm=b;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=L}),define(De[179],Ce([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[41],Ce([1,0,19,17,179]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function R(P,v){return v&&(P.stack||P.stacktrace)?d.localize(0,null,m(P),A(P.stack)||A(P.stacktrace)):m(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function m(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?d.localize(1,null,P.message):P.message||d.localize(2,null)}function E(P=null,v=!1){if(!P)return d.localize(3,null);if(Array.isArray(P)){const y=C.$Hb(P),k=E(y[0],v);return y.length>1?d.localize(4,null,k,y.length):k}if(T.$yf(P))return P;if(P.detail){const y=P.detail;if(y.error)return R(y.error,v);if(y.exception)return R(y.exception,v)}return P.stack?R(P,v):P.message?P.message:d.localize(5,null)}e.$Ai=E;function b(P){const v=P;return v instanceof Error&&Array.isArray(v.actions)}e.$Bi=b;function L(P,v){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=v,y}e.$Ci=L}),define(De[180],Ce([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let T=!1,d=!1,R=!1,A=!1,m=!1,E=!1,b=!1,L=!1,P=!1,v=!1,y,k=e.$g,p=e.$g,h,s;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?a=e.$h.vscode.process:typeof process<"u"&&(a=process);const o=typeof a?.versions?.electron=="string",f=o&&a?.type==="renderer";if(typeof navigator=="object"&&!f)s=navigator.userAgent,T=s.indexOf("Windows")>=0,d=s.indexOf("Macintosh")>=0,L=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=s.indexOf("Linux")>=0,v=s?.indexOf("Mobi")>=0,E=!0,y=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,k=y,p=navigator.language;else if(typeof a=="object"){T=a.platform==="win32",d=a.platform==="darwin",R=a.platform==="linux",A=R&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,b=o,P=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,k=e.$g;const S=a.env.VSCODE_NLS_CONFIG;if(S)try{const $=JSON.parse(S),g=$.availableLanguages["*"];y=$.locale,p=$.osLocale,k=g||e.$g,h=$._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var l;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(l||(e.Platform=l={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let i=0;d?i=1:T?i=3:R&&(i=2),e.$j=T,e.$k=d,e.$l=R,e.$m=A,e.$n=m,e.$o=b,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=L,e.$s=v,e.$t=P,e.$u=i,e.$v=s,e.$w=k;var c;(function(S){function $(){return e.$w}S.value=$;function g(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=g;function w(){return e.$w==="en"}S.isDefault=w})(c||(e.Language=c={})),e.$x=y,e.$y=p,e.$z=h,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const S=[];e.$h.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let w=0,D=S.length;w<D;w++){const N=S[w];if(N.id===g.data.vscodeScheduleAsyncWork){S.splice(w,1),N.callback();return}}});let $=0;return g=>{const w=++$;S.push({id:w,callback:g}),e.$h.postMessage({vscodeScheduleAsyncWork:w},"*")}}return S=>setTimeout(S)})();var n;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=d||L?2:T?1:3;let r=!0,u=!1;function I(){if(!u){u=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,r=new Uint16Array(S.buffer)[0]===(2<<8)+1}return r}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[48],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let T;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.process<"u"){const d=C.$h.vscode.process;T={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return C.$j?"win32":C.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$dc=T.platform,e.$ec=T.arch}),define(De[16],Ce([1,0,48]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const T=65,d=97,R=90,A=122,m=46,E=47,b=92,L=58,P=63;class v extends Error{constructor(i,c,n){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const u=i.indexOf(".")!==-1?"property":"argument";let I=`The "${i}" ${u} ${r} of type ${c}`;I+=`. Received type ${typeof n}`,super(I),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,i){if(t===null||typeof t!="object")throw new v(i,"Object",t)}function k(t,i){if(typeof t!="string")throw new v(i,"string",t)}const p=C.$dc==="win32";function h(t){return t===E||t===b}function s(t){return t===E}function a(t){return t>=T&&t<=R||t>=d&&t<=A}function o(t,i,c,n){let r="",u=0,I=-1,S=0,$=0;for(let g=0;g<=t.length;++g){if(g<t.length)$=t.charCodeAt(g);else{if(n($))break;$=E}if(n($)){if(!(I===g-1||S===1))if(S===2){if(r.length<2||u!==2||r.charCodeAt(r.length-1)!==m||r.charCodeAt(r.length-2)!==m){if(r.length>2){const w=r.lastIndexOf(c);w===-1?(r="",u=0):(r=r.slice(0,w),u=r.length-1-r.lastIndexOf(c)),I=g,S=0;continue}else if(r.length!==0){r="",u=0,I=g,S=0;continue}}i&&(r+=r.length>0?`${c}..`:"..",u=2)}else r.length>0?r+=`${c}${t.slice(I+1,g)}`:r=t.slice(I+1,g),u=g-I-1;I=g,S=0}else $===m&&S!==-1?++S:S=-1}return r}function f(t,i){y(i,"pathObject");const c=i.dir||i.root,n=i.base||`${i.name||""}${i.ext||""}`;return c?c===i.root?`${c}${n}`:`${c}${t}${n}`:n}e.$fc={resolve(...t){let i="",c="",n=!1;for(let r=t.length-1;r>=-1;r--){let u;if(r>=0){if(u=t[r],k(u,"path"),u.length===0)continue}else i.length===0?u=C.cwd():(u=C.env[`=${i}`]||C.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==i.toLowerCase()&&u.charCodeAt(2)===b)&&(u=`${i}\\`));const I=u.length;let S=0,$="",g=!1;const w=u.charCodeAt(0);if(I===1)h(w)&&(S=1,g=!0);else if(h(w))if(g=!0,h(u.charCodeAt(1))){let D=2,N=D;for(;D<I&&!h(u.charCodeAt(D));)D++;if(D<I&&D!==N){const M=u.slice(N,D);for(N=D;D<I&&h(u.charCodeAt(D));)D++;if(D<I&&D!==N){for(N=D;D<I&&!h(u.charCodeAt(D));)D++;(D===I||D!==N)&&($=`\\\\${M}\\${u.slice(N,D)}`,S=D)}}}else S=1;else a(w)&&u.charCodeAt(1)===L&&($=u.slice(0,2),S=2,I>2&&h(u.charCodeAt(2))&&(g=!0,S=3));if($.length>0)if(i.length>0){if($.toLowerCase()!==i.toLowerCase())continue}else i=$;if(n){if(i.length>0)break}else if(c=`${u.slice(S)}\\${c}`,n=g,g&&i.length>0)break}return c=o(c,!n,"\\",h),n?`${i}\\${c}`:`${i}${c}`||"."},normalize(t){k(t,"path");const i=t.length;if(i===0)return".";let c=0,n,r=!1;const u=t.charCodeAt(0);if(i===1)return s(u)?"\\":t;if(h(u))if(r=!0,h(t.charCodeAt(1))){let S=2,$=S;for(;S<i&&!h(t.charCodeAt(S));)S++;if(S<i&&S!==$){const g=t.slice($,S);for($=S;S<i&&h(t.charCodeAt(S));)S++;if(S<i&&S!==$){for($=S;S<i&&!h(t.charCodeAt(S));)S++;if(S===i)return`\\\\${g}\\${t.slice($)}\\`;S!==$&&(n=`\\\\${g}\\${t.slice($,S)}`,c=S)}}}else c=1;else a(u)&&t.charCodeAt(1)===L&&(n=t.slice(0,2),c=2,i>2&&h(t.charCodeAt(2))&&(r=!0,c=3));let I=c<i?o(t.slice(c),!r,"\\",h):"";return I.length===0&&!r&&(I="."),I.length>0&&h(t.charCodeAt(i-1))&&(I+="\\"),n===void 0?r?`\\${I}`:I:r?`${n}\\${I}`:`${n}${I}`},isAbsolute(t){k(t,"path");const i=t.length;if(i===0)return!1;const c=t.charCodeAt(0);return h(c)||i>2&&a(c)&&t.charCodeAt(1)===L&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let i,c;for(let u=0;u<t.length;++u){const I=t[u];k(I,"path"),I.length>0&&(i===void 0?i=c=I:i+=`\\${I}`)}if(i===void 0)return".";let n=!0,r=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++r;const u=c.length;u>1&&h(c.charCodeAt(1))&&(++r,u>2&&(h(c.charCodeAt(2))?++r:n=!1))}if(n){for(;r<i.length&&h(i.charCodeAt(r));)r++;r>=2&&(i=`\\${i.slice(r)}`)}return e.$fc.normalize(i)},relative(t,i){if(k(t,"from"),k(i,"to"),t===i)return"";const c=e.$fc.resolve(t),n=e.$fc.resolve(i);if(c===n||(t=c.toLowerCase(),i=n.toLowerCase(),t===i))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===b;)r++;let u=t.length;for(;u-1>r&&t.charCodeAt(u-1)===b;)u--;const I=u-r;let S=0;for(;S<i.length&&i.charCodeAt(S)===b;)S++;let $=i.length;for(;$-1>S&&i.charCodeAt($-1)===b;)$--;const g=$-S,w=I<g?I:g;let D=-1,N=0;for(;N<w;N++){const F=t.charCodeAt(r+N);if(F!==i.charCodeAt(S+N))break;F===b&&(D=N)}if(N!==w){if(D===-1)return n}else{if(g>w){if(i.charCodeAt(S+N)===b)return n.slice(S+N+1);if(N===2)return n.slice(S+N)}I>w&&(t.charCodeAt(r+N)===b?D=N:N===2&&(D=3)),D===-1&&(D=0)}let M="";for(N=r+D+1;N<=u;++N)(N===u||t.charCodeAt(N)===b)&&(M+=M.length===0?"..":"\\..");return S+=D,M.length>0?`${M}${n.slice(S,$)}`:(n.charCodeAt(S)===b&&++S,n.slice(S,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const i=e.$fc.resolve(t);if(i.length<=2)return t;if(i.charCodeAt(0)===b){if(i.charCodeAt(1)===b){const c=i.charCodeAt(2);if(c!==P&&c!==m)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(a(i.charCodeAt(0))&&i.charCodeAt(1)===L&&i.charCodeAt(2)===b)return`\\\\?\\${i}`;return t},dirname(t){k(t,"path");const i=t.length;if(i===0)return".";let c=-1,n=0;const r=t.charCodeAt(0);if(i===1)return h(r)?t:".";if(h(r)){if(c=n=1,h(t.charCodeAt(1))){let S=2,$=S;for(;S<i&&!h(t.charCodeAt(S));)S++;if(S<i&&S!==$){for($=S;S<i&&h(t.charCodeAt(S));)S++;if(S<i&&S!==$){for($=S;S<i&&!h(t.charCodeAt(S));)S++;if(S===i)return t;S!==$&&(c=n=S+1)}}}}else a(r)&&t.charCodeAt(1)===L&&(c=i>2&&h(t.charCodeAt(2))?3:2,n=c);let u=-1,I=!0;for(let S=i-1;S>=n;--S)if(h(t.charCodeAt(S))){if(!I){u=S;break}}else I=!1;if(u===-1){if(c===-1)return".";u=c}return t.slice(0,u)},basename(t,i){i!==void 0&&k(i,"ext"),k(t,"path");let c=0,n=-1,r=!0,u;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(c=2),i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let I=i.length-1,S=-1;for(u=t.length-1;u>=c;--u){const $=t.charCodeAt(u);if(h($)){if(!r){c=u+1;break}}else S===-1&&(r=!1,S=u+1),I>=0&&($===i.charCodeAt(I)?--I===-1&&(n=u):(I=-1,n=S))}return c===n?n=S:n===-1&&(n=t.length),t.slice(c,n)}for(u=t.length-1;u>=c;--u)if(h(t.charCodeAt(u))){if(!r){c=u+1;break}}else n===-1&&(r=!1,n=u+1);return n===-1?"":t.slice(c,n)},extname(t){k(t,"path");let i=0,c=-1,n=0,r=-1,u=!0,I=0;t.length>=2&&t.charCodeAt(1)===L&&a(t.charCodeAt(0))&&(i=n=2);for(let S=t.length-1;S>=i;--S){const $=t.charCodeAt(S);if(h($)){if(!u){n=S+1;break}continue}r===-1&&(u=!1,r=S+1),$===m?c===-1?c=S:I!==1&&(I=1):c!==-1&&(I=-1)}return c===-1||r===-1||I===0||I===1&&c===r-1&&c===n+1?"":t.slice(c,r)},format:f.bind(null,"\\"),parse(t){k(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const c=t.length;let n=0,r=t.charCodeAt(0);if(c===1)return h(r)?(i.root=i.dir=t,i):(i.base=i.name=t,i);if(h(r)){if(n=1,h(t.charCodeAt(1))){let D=2,N=D;for(;D<c&&!h(t.charCodeAt(D));)D++;if(D<c&&D!==N){for(N=D;D<c&&h(t.charCodeAt(D));)D++;if(D<c&&D!==N){for(N=D;D<c&&!h(t.charCodeAt(D));)D++;D===c?n=D:D!==N&&(n=D+1)}}}}else if(a(r)&&t.charCodeAt(1)===L){if(c<=2)return i.root=i.dir=t,i;if(n=2,h(t.charCodeAt(2))){if(c===3)return i.root=i.dir=t,i;n=3}}n>0&&(i.root=t.slice(0,n));let u=-1,I=n,S=-1,$=!0,g=t.length-1,w=0;for(;g>=n;--g){if(r=t.charCodeAt(g),h(r)){if(!$){I=g+1;break}continue}S===-1&&($=!1,S=g+1),r===m?u===-1?u=g:w!==1&&(w=1):u!==-1&&(w=-1)}return S!==-1&&(u===-1||w===0||w===1&&u===S-1&&u===I+1?i.base=i.name=t.slice(I,S):(i.name=t.slice(I,u),i.base=t.slice(I,S),i.ext=t.slice(u,S))),I>0&&I!==n?i.dir=t.slice(0,I-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(p){const t=/\\/g;return()=>{const i=C.cwd().replace(t,"/");return i.slice(i.indexOf("/"))}}return()=>C.cwd()})();e.$gc={resolve(...t){let i="",c=!1;for(let n=t.length-1;n>=-1&&!c;n--){const r=n>=0?t[n]:l();k(r,"path"),r.length!==0&&(i=`${r}/${i}`,c=r.charCodeAt(0)===E)}return i=o(i,!c,"/",s),c?`/${i}`:i.length>0?i:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===E,c=t.charCodeAt(t.length-1)===E;return t=o(t,!i,"/",s),t.length===0?i?"/":c?"./":".":(c&&(t+="/"),i?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let i;for(let c=0;c<t.length;++c){const n=t[c];k(n,"path"),n.length>0&&(i===void 0?i=n:i+=`/${n}`)}return i===void 0?".":e.$gc.normalize(i)},relative(t,i){if(k(t,"from"),k(i,"to"),t===i||(t=e.$gc.resolve(t),i=e.$gc.resolve(i),t===i))return"";const c=1,n=t.length,r=n-c,u=1,I=i.length-u,S=r<I?r:I;let $=-1,g=0;for(;g<S;g++){const D=t.charCodeAt(c+g);if(D!==i.charCodeAt(u+g))break;D===E&&($=g)}if(g===S)if(I>S){if(i.charCodeAt(u+g)===E)return i.slice(u+g+1);if(g===0)return i.slice(u+g)}else r>S&&(t.charCodeAt(c+g)===E?$=g:g===0&&($=0));let w="";for(g=c+$+1;g<=n;++g)(g===n||t.charCodeAt(g)===E)&&(w+=w.length===0?"..":"/..");return`${w}${i.slice(u+$)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===E;let c=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===E){if(!n){c=r;break}}else n=!1;return c===-1?i?"/":".":i&&c===1?"//":t.slice(0,c)},basename(t,i){i!==void 0&&k(i,"ext"),k(t,"path");let c=0,n=-1,r=!0,u;if(i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let I=i.length-1,S=-1;for(u=t.length-1;u>=0;--u){const $=t.charCodeAt(u);if($===E){if(!r){c=u+1;break}}else S===-1&&(r=!1,S=u+1),I>=0&&($===i.charCodeAt(I)?--I===-1&&(n=u):(I=-1,n=S))}return c===n?n=S:n===-1&&(n=t.length),t.slice(c,n)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===E){if(!r){c=u+1;break}}else n===-1&&(r=!1,n=u+1);return n===-1?"":t.slice(c,n)},extname(t){k(t,"path");let i=-1,c=0,n=-1,r=!0,u=0;for(let I=t.length-1;I>=0;--I){const S=t.charCodeAt(I);if(S===E){if(!r){c=I+1;break}continue}n===-1&&(r=!1,n=I+1),S===m?i===-1?i=I:u!==1&&(u=1):i!==-1&&(u=-1)}return i===-1||n===-1||u===0||u===1&&i===n-1&&i===c+1?"":t.slice(i,n)},format:f.bind(null,"/"),parse(t){k(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const c=t.charCodeAt(0)===E;let n;c?(i.root="/",n=1):n=0;let r=-1,u=0,I=-1,S=!0,$=t.length-1,g=0;for(;$>=n;--$){const w=t.charCodeAt($);if(w===E){if(!S){u=$+1;break}continue}I===-1&&(S=!1,I=$+1),w===m?r===-1?r=$:g!==1&&(g=1):r!==-1&&(g=-1)}if(I!==-1){const w=u===0&&c?1:u;r===-1||g===0||g===1&&r===I-1&&r===u+1?i.base=i.name=t.slice(w,I):(i.name=t.slice(w,r),i.base=t.slice(w,I),i.ext=t.slice(r,I))}return u>0?i.dir=t.slice(0,u-1):c&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(De[126],Ce([1,0,47,16]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=void 0;const d=new C.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),R=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(S,$,g=!1){const w=S||"",D=$||"",N=d.value.collator.compare(w,D);return d.value.collatorIsNumeric&&N===0&&w!==D?w<D?-1:1:N}e.$hq=m;function E(S,$){const g=R.value.collator;return S=S||"",$=$||"",f(g,S,$)}e.$iq=E;function b(S,$){const g=R.value.collator;return S=S||"",$=$||"",c(S,$)||f(g,S,$)}e.$jq=b;function L(S,$){const g=R.value.collator;return S=S||"",$=$||"",i(S,$)||f(g,S,$)}e.$kq=L;function P(S,$){return S=S||"",$=$||"",S===$?0:S<$?-1:1}e.$lq=P;function v(S,$){const[g,w]=a(S),[D,N]=a($);let M=d.value.collator.compare(w,N);if(M===0){if(d.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(M=d.value.collator.compare(g,D),d.value.collatorIsNumeric&&M===0&&g!==D)return g<D?-1:1}return M}e.$mq=v;function y(S,$){S=S||"",$=$||"";const g=o(S),w=o($),D=R.value.collator,N=A.value.collator;return f(N,g,w)||f(D,S,$)}e.$nq=y;function k(S,$){S=S||"",$=$||"";const g=o(S),w=o($),D=R.value.collator,N=A.value.collator;return f(N,g,w)||c(S,$)||f(D,S,$)}e.$oq=k;function p(S,$){S=S||"",$=$||"";const g=o(S),w=o($),D=R.value.collator,N=A.value.collator;return f(N,g,w)||i(S,$)||f(D,S,$)}e.$pq=p;function h(S,$){S=S||"",$=$||"";const g=o(S).toLowerCase(),w=o($).toLowerCase();return g!==w?g<w?-1:1:S!==$?S<$?-1:1:0}e.$qq=h;const s=/^(.*?)(\.([^.]*))?$/;function a(S,$=!1){const g=S?s.exec(S):[];let w=[g&&g[1]||"",g&&g[3]||""];return $&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function o(S){const $=S?s.exec(S):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function f(S,$,g){const w=S.compare($,g);return w!==0?w:$.length!==g.length?$.length<g.length?-1:1:0}function l(S){const $=S.charAt(0);return $.toLocaleUpperCase()!==$}function t(S){const $=S.charAt(0);return $.toLocaleLowerCase()!==$}function i(S,$){return l(S)&&t($)?-1:t(S)&&l($)?1:0}function c(S,$){return t(S)&&l($)?-1:l(S)&&t($)?1:0}function n(S,$,g=!1){return g||(S=S&&S.toLowerCase(),$=$&&$.toLowerCase()),S===$?0:S<$?-1:1}function r(S,$,g=!1){const w=S.split(T.sep),D=$.split(T.sep),N=w.length-1,M=D.length-1;let F,U;for(let j=0;;j++){if(F=N===j,U=M===j,F&&U)return m(w[j],D[j],g);if(F)return-1;if(U)return 1;const O=n(w[j],D[j],g);if(O!==0)return O}}e.$rq=r;function u(S,$,g){const w=S.toLowerCase(),D=$.toLowerCase(),N=I(S,$,g);if(N)return N;const M=w.endsWith(g),F=D.endsWith(g);if(M!==F)return M?-1:1;const U=m(w,D);return U!==0?U:w.localeCompare(D)}e.$sq=u;function I(S,$,g){const w=S.toLowerCase(),D=$.toLowerCase(),N=w.startsWith(g),M=D.startsWith(g);if(N!==M)return N?-1:1;if(N&&M){if(w.length<D.length)return-1;if(w.length>D.length)return 1}return 0}e.$tq=I}),define(De[33],Ce([1,0,16,12,15,17]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(u){return u===47||u===92}e.$Qf=A;function m(u){return u.replace(/[\\/]/g,C.$gc.sep)}e.$Rf=m;function E(u){return u.indexOf("/")===-1&&(u=m(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.$Sf=E;function b(u,I=C.$gc.sep){if(!u)return"";const S=u.length,$=u.charCodeAt(0);if(A($)){if(A(u.charCodeAt(1))&&!A(u.charCodeAt(2))){let w=3;const D=w;for(;w<S&&!A(u.charCodeAt(w));w++);if(D!==w&&!A(u.charCodeAt(w+1))){for(w+=1;w<S;w++)if(A(u.charCodeAt(w)))return u.slice(0,w+1).replace(/[\\/]/g,I)}}return I}else if(s($)&&u.charCodeAt(1)===58)return A(u.charCodeAt(2))?u.slice(0,2)+I:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<S;g++)if(A(u.charCodeAt(g)))return u.slice(0,g+1)}return""}e.$Tf=b;function L(u){if(!T.$j||!u||u.length<5)return!1;let I=u.charCodeAt(0);if(I!==92||(I=u.charCodeAt(1),I!==92))return!1;let S=2;const $=S;for(;S<u.length&&(I=u.charCodeAt(S),I!==92);S++);return!($===S||(I=u.charCodeAt(S+1),isNaN(I)||I===92))}e.$Uf=L;const P=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(u,I=T.$j){const S=I?P:v;return!(!u||u.length===0||/^\s+$/.test(u)||(S.lastIndex=0,S.test(u))||I&&y.test(u)||u==="."||u===".."||I&&u[u.length-1]==="."||I&&u.length!==u.trim().length||u.length>255)}e.$Vf=k;function p(u,I,S){const $=u===I;return!S||$?$:!u||!I?!1:(0,d.$2e)(u,I)}e.$Wf=p;function h(u,I,S,$=C.sep){if(u===I)return!0;if(!u||!I||I.length>u.length)return!1;if(S){if(!(0,d.$3e)(u,I))return!1;if(I.length===u.length)return!0;let w=I.length;return I.charAt(I.length-1)===$&&w--,u.charAt(w)===$}return I.charAt(I.length-1)!==$&&(I+=$),u.indexOf(I)===0}e.$Xf=h;function s(u){return u>=65&&u<=90||u>=97&&u<=122}e.$Yf=s;function a(u,I){return T.$j&&u.endsWith(":")&&(u+=C.sep),(0,C.$ic)(u)||(u=(0,C.$jc)(I,u)),u=(0,C.$hc)(u),T.$j?(u=(0,d.$Ke)(u,C.sep),u.endsWith(":")&&(u+=C.sep)):(u=(0,d.$Ke)(u,C.sep),u||(u=C.sep)),u}e.$Zf=a;function o(u){const I=(0,C.$hc)(u);return T.$j?u.length>3?!1:f(I)&&(u.length===2||I.charCodeAt(2)===92):I===C.$gc.sep}e.$1f=o;function f(u,I=T.$j){return I?s(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.$2f=f;function l(u,I=T.$j){return f(u,I)?u[0]:void 0}e.$3f=l;function t(u,I,S){return I.length>u.length?-1:u===I?0:(S&&(u=u.toLowerCase(),I=I.toLowerCase()),u.indexOf(I))}e.$4f=t;function i(u){const I=u.split(":");let S,$,g;for(const w of I){const D=Number(w);(0,R.$Cf)(D)?$===void 0?$=D:g===void 0&&(g=D):S=S?[S,w].join(":"):w}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:$!==void 0?$:void 0,column:g!==void 0?g:$!==void 0?1:void 0}}e.$5f=i;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(u,I,S=8){let $="";for(let w=0;w<S;w++){let D;w===0&&T.$j&&!I&&(S===3||S===4)?D=n:D=c,$+=D.charAt(Math.floor(Math.random()*D.length))}let g;return I?g=`${I}-${$}`:g=$,u?(0,C.$jc)(u,g):g}e.$6f=r}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=void 0;const E=0,b=[E,[]];function L(q,K,me,te){if(!q||!K)return b;const G=q.length,Q=K.length;if(G<Q)return b;const le=q.toLowerCase();return P(K,me,Q,q,le,G,te)}e.$uq=L;function P(q,K,me,te,G,Q,le){const ie=[],ce=[];for(let X=0;X<me;X++){const re=X*Q,Y=re-Q,_=X>0,x=q[X],ve=K[X];for(let ae=0;ae<Q;ae++){const fe=ae>0,ee=re+ae,de=ee-1,be=Y+ae-1,Pe=fe?ie[de]:0,z=_&&fe?ie[be]:0,J=_&&fe?ce[be]:0;let se;!z&&_?se=0:se=v(x,ve,te,G,ae,J),se&&z+se>=Pe&&(le||_||G.startsWith(K,ae))?(ce[ee]=J+1,ie[ee]=z+se):(ce[ee]=E,ie[ee]=Pe)}}const ye=[];let H=me-1,B=Q-1;for(;H>=0&&B>=0;){const X=H*Q+B;ce[X]===E||(ye.push(B),H--),B--}return[ie[me*Q-1],ye.reverse()]}function v(q,K,me,te,G,Q){let le=0;if(!y(K,te[G]))return le;if(le+=1,Q>0&&(le+=Q*5),q===me[G]&&(le+=1),G===0)le+=8;else{const ie=k(me.charCodeAt(G-1));ie?le+=ie:(0,T.$Gj)(me.charCodeAt(G))&&Q===0&&(le+=2)}return le}function y(q,K){return q===K?!0:q==="/"||q==="\\"?K==="/"||K==="\\":!1}function k(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function h(q,K,me=0,te=0){const G=K;return G.values&&G.values.length>1?s(q,G.values,me,te):a(q,K,me,te)}e.$vq=h;function s(q,K,me,te){let G=0;const Q=[];for(const le of K){const[ie,ce]=a(q,le,me,te);if(typeof ie!="number")return p;G+=ie,Q.push(...ce)}return[G,S(Q)]}function a(q,K,me,te){const G=(0,T.$Pj)(K.original,K.originalLowercase,me,q,q.toLowerCase(),te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return G?[G[0],(0,T.$Mj)(G)]:p}const o=Object.freeze({score:0}),f=1<<18,l=1<<17,t=1<<16;function i(q,K,me,te){const G=te.values?te.values:[te];return(0,d.$Di)({[te.normalized]:{values:G.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:q,description:K,allowNonContiguousMatches:me}})}function c(q,K,me,te,G){if(!q||!K.normalized)return o;const Q=te.getItemLabel(q);if(!Q)return o;const le=te.getItemDescription(q),ie=i(Q,le,me,K),ce=G[ie];if(ce)return ce;const ye=n(Q,le,te.getItemPath(q),K,me);return G[ie]=ye,ye}e.$wq=c;function n(q,K,me,te,G){const Q=!me||!te.containsPathSeparator;return me&&(A.$l?te.pathNormalized===me:(0,m.$2e)(te.pathNormalized,me))?{score:f,labelMatch:[{start:0,end:q.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:te.values&&te.values.length>1?r(q,K,me,te.values,Q,G):u(q,K,me,te,Q,G)}function r(q,K,me,te,G,Q){let le=0;const ie=[],ce=[];for(const ye of te){const{score:H,labelMatch:B,descriptionMatch:X}=u(q,K,me,ye,G,Q);if(H===E)return o;le+=H,B&&ie.push(...B),X&&ce.push(...X)}return{score:le,labelMatch:S(ie),descriptionMatch:S(ce)}}function u(q,K,me,te,G,Q){if(G||!K){const[le,ie]=L(q,te.normalized,te.normalizedLowercase,Q&&!te.expectContiguousMatch);if(le){const ce=(0,T.$Dj)(te.normalized,q);let ye;if(ce){ye=l;const H=Math.round(te.normalized.length/q.length*100);ye+=H}else ye=t;return{score:ye+le,labelMatch:ce||I(ie)}}}if(K){let le=K;me&&(le=`${K}${R.sep}`);const ie=le.length,ce=`${le}${q}`,[ye,H]=L(ce,te.normalized,te.normalizedLowercase,Q&&!te.expectContiguousMatch);if(ye){const B=I(H),X=[],re=[];return B.forEach(Y=>{Y.start<ie&&Y.end>ie?(X.push({start:0,end:Y.end-ie}),re.push({start:Y.start,end:ie})):Y.start>=ie?X.push({start:Y.start-ie,end:Y.end-ie}):re.push(Y)}),{score:ye,labelMatch:X,descriptionMatch:re}}}return o}function I(q){const K=[];if(!q)return K;let me;for(const te of q)me&&me.end===te?me.end+=1:(me={start:te,end:te+1},K.push(me));return K}function S(q){const K=q.sort((G,Q)=>G.start-Q.start),me=[];let te;for(const G of K)!te||!$(te,G)?(te=G,me.push(G)):(te.start=Math.min(te.start,G.start),te.end=Math.max(te.end,G.end));return me}function $(q,K){return!(q.end<K.start||K.end<q.start)}function g(q,K,me,te,G,Q){const le=c(q,me,te,G,Q),ie=c(K,me,te,G,Q),ce=le.score,ye=ie.score;if((ce===f||ye===f)&&ce!==ye)return ce===f?-1:1;if(ce>t||ye>t){if(ce!==ye)return ce>ye?-1:1;if(ce<l&&ye<l){const x=D(le.labelMatch,ie.labelMatch);if(x!==0)return x}const Y=G.getItemLabel(q)||"",_=G.getItemLabel(K)||"";if(Y.length!==_.length)return Y.length-_.length}if(ce!==ye)return ce>ye?-1:1;const H=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,B=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(H&&!B)return-1;if(B&&!H)return 1;const X=w(q,le,G),re=w(K,ie,G);return X&&re&&X!==re?re>X?-1:1:N(q,K,me,G)}e.$xq=g;function w(q,K,me){let te=-1,G=-1;if(K.descriptionMatch&&K.descriptionMatch.length?te=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(te=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(G=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const Q=me.getItemDescription(q);Q&&(G+=Q.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(G=K.descriptionMatch[K.descriptionMatch.length-1].end);return G-te}function D(q,K){if(!q&&!K||(!q||!q.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!q||!q.length)return 1;const me=q[0].start,G=q[q.length-1].end-me,Q=K[0].start,ie=K[K.length-1].end-Q;return G===ie?0:ie<G?1:-1}function N(q,K,me,te){const G=te.getItemLabel(q)||"",Q=te.getItemLabel(K)||"",le=te.getItemDescription(q),ie=te.getItemDescription(K),ce=G.length+(le?le.length:0),ye=Q.length+(ie?ie.length:0);if(ce!==ye)return ce-ye;const H=te.getItemPath(q),B=te.getItemPath(K);return H&&B&&H.length!==B.length?H.length-B.length:G!==Q?(0,C.$sq)(G,Q,me.normalized):le&&ie&&le!==ie?(0,C.$sq)(le,ie,me.normalized):H&&B&&H!==B?(0,C.$sq)(H,B,me.normalized):0}function M(q){return q.startsWith('"')&&q.endsWith('"')}const F=" ";function U(q){typeof q!="string"&&(q="");const K=q.toLowerCase(),{pathNormalized:me,normalized:te,normalizedLowercase:G}=j(q),Q=me.indexOf(R.sep)>=0,le=M(q);let ie;const ce=q.split(F);if(ce.length>1)for(const ye of ce){const H=M(ye),{pathNormalized:B,normalized:X,normalizedLowercase:re}=j(ye);X&&(ie||(ie=[]),ie.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:B,normalized:X,normalizedLowercase:re,expectContiguousMatch:H}))}return{original:q,originalLowercase:K,pathNormalized:me,normalized:te,normalizedLowercase:G,values:ie,containsPathSeparator:Q,expectContiguousMatch:le}}e.$yq=U;function j(q){let K;A.$j?K=q.replace(/\//g,R.sep):K=q.replace(/\\/g,R.sep);const me=(0,m.$Me)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:me,normalizedLowercase:me.toLowerCase()}}function O(q){return Array.isArray(q)?U(q.map(K=>K.original).join(F)):U(q.original)}e.$zq=O}),define(De[97],Ce([1,0,16]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0,e.$Pr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const P=(0,C.$oc)(L),v=T[P.toLowerCase()];return v!==void 0?v:A(L)}e.$Qr=R;function A(L){const P=(0,C.$oc)(L);return d[P.toLowerCase()]}e.$Rr=A;function m(L){for(const P in d)if(d[P]===L)return P}e.$Sr=m;const E=/^(.+)\/(.+?)(;.+)?$/;function b(L,P){const v=E.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:P?void 0:L}e.$Tr=b}),define(De[98],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0;var T;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(T||(e.Source=T={}));var d;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function R(m,...E){const b=E.reduce((v,y)=>(v[y]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter(v=>!b[v]).forEach(v=>{for(let y=0;y<L.length;y++)if(v.search(L[y])!==-1){delete m[v];break}})}e.$zl=R;function A(m){m&&(delete m.DEBUG,C.$k&&delete m.DYLD_LIBRARY_PATH,C.$l&&delete m.LD_PRELOAD)}e.$Al=A}),define(De[2],Ce([1,0,16,12]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function m(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!d.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(n,r){return!n&&!r?"file":n}function b(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const L="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(r){return r instanceof y?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,u,I,S,$,g=!1){typeof r=="object"?(this.scheme=r.scheme||L,this.authority=r.authority||L,this.path=r.path||L,this.query=r.query||L,this.fragment=r.fragment||L):(this.scheme=E(r,g),this.authority=u||L,this.path=b(this.scheme,I||L),this.query=S||L,this.fragment=$||L,m(this,g))}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:u,authority:I,path:S,query:$,fragment:g}=r;return u===void 0?u=this.scheme:u===null&&(u=L),I===void 0?I=this.authority:I===null&&(I=L),S===void 0?S=this.path:S===null&&(S=L),$===void 0?$=this.query:$===null&&($=L),g===void 0?g=this.fragment:g===null&&(g=L),u===this.scheme&&I===this.authority&&S===this.path&&$===this.query&&g===this.fragment?this:new h(u,I,S,$,g)}static parse(r,u=!1){const I=v.exec(r);return I?new h(I[2]||L,c(I[4]||L),c(I[5]||L),c(I[7]||L),c(I[9]||L),u):new h(L,L,L,L,L)}static file(r){let u=L;if(T.$j&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const I=r.indexOf(P,2);I===-1?(u=r.substring(2),r=P):(u=r.substring(2,I),r=r.substring(I)||P)}return new h("file",u,r,L,L)}static from(r,u){return new h(r.scheme,r.authority,r.path,r.query,r.fragment,u)}static joinPath(r,...u){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let I;return T.$j&&r.scheme==="file"?I=y.file(C.$fc.join(f(r,!0),...u)).path:I=C.$gc.join(r.path,...u),r.with({path:I})}toString(r=!1){return l(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof y)return r;{const u=new h(r);return u._formatted=r.external??null,u._fsPath=r._sep===p?r.fsPath??null:null,u}}else return r}}e.URI=y;function k(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$vc=k;const p=T.$j?1:void 0;class h extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=p),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(n,r,u){let I,S=-1;for(let $=0;$<n.length;$++){const g=n.charCodeAt($);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||r&&g===47||u&&g===91||u&&g===93||u&&g===58)S!==-1&&(I+=encodeURIComponent(n.substring(S,$)),S=-1),I!==void 0&&(I+=n.charAt($));else{I===void 0&&(I=n.substr(0,$));const w=s[g];w!==void 0?(S!==-1&&(I+=encodeURIComponent(n.substring(S,$)),S=-1),I+=w):S===-1&&(S=$)}}return S!==-1&&(I+=encodeURIComponent(n.substring(S))),I!==void 0?I:n}function o(n){let r;for(let u=0;u<n.length;u++){const I=n.charCodeAt(u);I===35||I===63?(r===void 0&&(r=n.substr(0,u)),r+=s[I]):r!==void 0&&(r+=n[u])}return r!==void 0?r:n}function f(n,r){let u;return n.authority&&n.path.length>1&&n.scheme==="file"?u=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?u=n.path.substr(1):u=n.path[1].toLowerCase()+n.path.substr(2):u=n.path,T.$j&&(u=u.replace(/\//g,"\\")),u}e.$wc=f;function l(n,r){const u=r?o:a;let I="",{scheme:S,authority:$,path:g,query:w,fragment:D}=n;if(S&&(I+=S,I+=":"),($||S==="file")&&(I+=P,I+=P),$){let N=$.indexOf("@");if(N!==-1){const M=$.substr(0,N);$=$.substr(N+1),N=M.lastIndexOf(":"),N===-1?I+=u(M,!1,!1):(I+=u(M.substr(0,N),!1,!1),I+=":",I+=u(M.substr(N+1),!1,!0)),I+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?I+=u($,!1,!0):(I+=u($.substr(0,N),!1,!0),I+=$.substr(N))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const N=g.charCodeAt(1);N>=65&&N<=90&&(g=`/${String.fromCharCode(N+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const N=g.charCodeAt(0);N>=65&&N<=90&&(g=`${String.fromCharCode(N+32)}:${g.substr(2)}`)}I+=u(g,!0,!1)}return w&&(I+="?",I+=u(w,!1,!1)),D&&(I+="#",I+=r?D:a(D,!1,!1)),I}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(n){return n.match(i)?n.replace(i,r=>t(r)):n}}),define(De[181],Ce([1,0,2]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Zp=e.$Yp=e.$Xp=void 0;function T(b){const L=b;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$Xp=T;function d(b){const L=[];let P;try{const v=JSON.parse(b.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),P=y.__$stack),L.push(...v)}catch{L.push("Unable to log remote console arguments",b.arguments)}return{args:L,stack:P}}e.$Yp=d;function R(b){if(typeof b!="string")return R(d(b).stack);const L=b;if(L){const P=A(L),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(v&&v.length===4)return{uri:C.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Zp=R;function A(b){if(!b)return b;const L=b.indexOf(`
`);return L===-1?b:b.substring(0,L)}function m(b,L){const{args:P,stack:v}=d(b),y=typeof P[0]=="string"&&P.length===1;let k=A(v);k&&(k=`(${k.trim()})`);let p=[];if(typeof P[0]=="string"?k&&y?p=[`%c[${L}] %c${P[0]} %c${k}`,E("blue"),E(""),E("grey")]:p=[`%c[${L}] %c${P[0]}`,E("blue"),E(""),...P.slice(1)]:p=[`%c[${L}]%`,E("blue"),...P],k&&!y&&p.push(k),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=m;function E(b){return`color: ${b}`}}),define(De[62],Ce([1,0,22,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function d(E){return JSON.stringify(E,A)}e.$kh=d;function R(E){let b=JSON.parse(E);return b=m(b),b}e.$lh=R;function A(E,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:b.flags}:b}function m(E,b=0){if(!E||b>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return T.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof C.$be||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let L=0;L<E.length;++L)E[L]=m(E[L],b+1);else for(const L in E)Object.hasOwnProperty.call(E,L)&&(E[L]=m(E[L],b+1))}return E}e.$mh=m}),define(De[18],Ce([1,0,9,12,2]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var R;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,P,v){this.a[L]=P,this.b[L]=v}setConnectionToken(L,P){this.c[L]=P}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(h){return C.$1(h),L}const P=L.authority;let v=this.a[P];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const y=this.b[P],k=this.c[P];let p=`path=${encodeURIComponent(L.path)}`;return typeof k=="string"&&(p+=`&${e.$8f}=${encodeURIComponent(k)}`),d.URI.from({scheme:T.$p?this.d:R.vscodeRemoteResource,authority:`${v}:${y}`,path:this.f,query:p})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class m{static{this.a=e.$bg}asBrowserUri(L){const P=this.b(L,$e);return this.uriToBrowserUri(P)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.$9f.rewrite(L):L.scheme===R.file&&(T.$n||T.$q&&T.$h.origin===`${R.vscodeFileResource}://${m.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||m.a,query:null,fragment:null}):L}asFileUri(L){const P=this.b(L,$e);return this.uriToFileUri(P)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==m.a?L.authority:null,query:null,fragment:null}):L}b(L,P){return d.URI.isUri(L)?L:d.URI.parse(P.toUrl(L))}}e.$cg=new m;var E;(function(b){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(L.get("3"));const P="vscode-coi";function v(k){let p;typeof k=="string"?p=new URL(k).searchParams:k instanceof URL?p=k.searchParams:d.URI.isUri(k)&&(p=new URL(k.toString(!0)).searchParams);const h=p?.get(P);if(h)return L.get(h)}b.getHeadersFromQuery=v;function y(k,p,h){if(!globalThis.crossOriginIsolated)return;const s=p&&h?"3":h?"2":"1";k instanceof URLSearchParams?k.set(P,s):k[P]=s}b.addSearchParam=y})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,18,12,2]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=void 0;class A{constructor(v,y,k){this.id=v,this.dependencies=y,this.callback=k}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,y,k)=>{typeof v!="string"&&(k=y,y=v,v=null),(typeof y!="object"||!Array.isArray(y))&&(k=y,y=null),this.c.push(new A(v,y,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const y=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!y)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(v){return new Promise((y,k)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const h=()=>{p.removeEventListener("load",s),p.removeEventListener("error",a)},s=o=>{h(),y(this.c.pop())},a=o=>{h(),k(o)};p.addEventListener("load",s),p.addEventListener("error",a),this.f&&(v=this.f.createScriptURL(v)),p.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(p)})}i(v){return new Promise((y,k)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),y(this.c.pop())}catch(p){k(p)}})}async j(v){try{const y=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,h=R.URI.parse(v).fsPath,s=y.readFileSync(h).toString(),a=p.wrap(s.replace(/^#!.*/,""));return new k.Script(a).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function L(P,v,y){if(C.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[P]&&(P=b[P]);const k=`${P}/${v}`;if(E.has(k))return E.get(k);let p;if(/^\w[\w\d+.-]*:\/\//.test(k))p=k;else{const o=`${y&&!d.$p?T.$_f:T.$$f}/${k}`;p=T.$cg.asBrowserUri(o).toString(!0)}const h=m.INSTANCE.load(p);return E.set(k,h),h}else return await new Promise((k,p)=>{$e([P],k,p)})}e.$vC=L}),define(De[23],Ce([1,0,33,18,16,12,15,2]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function E(y){return(0,m.$wc)(y,!0)}e.$jg=E;class b{constructor(k){this.a=k}compare(k,p,h=!1){return k===p?0:(0,A.$Ue)(this.getComparisonKey(k,h),this.getComparisonKey(p,h))}isEqual(k,p,h=!1){return k===p?!0:!k||!p?!1:this.getComparisonKey(k,h)===this.getComparisonKey(p,h)}getComparisonKey(k,p=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,p,h=!1){if(k.scheme===p.scheme){if(k.scheme===T.Schemas.file)return C.$Xf(E(k),E(p),this.a(k))&&k.query===p.query&&(h||k.fragment===p.fragment);if((0,e.$Ag)(k.authority,p.authority))return C.$Xf(k.path,p.path,this.a(k),"/")&&k.query===p.query&&(h||k.fragment===p.fragment)}return!1}joinPath(k,...p){return m.URI.joinPath(k,...p)}basenameOrAuthority(k){return(0,e.$sg)(k)||k.authority}basename(k){return d.$gc.basename(k.path)}extname(k){return d.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let p;return k.scheme===T.Schemas.file?p=m.URI.file(d.$mc(E(k))).path:(p=d.$gc.dirname(k.path),k.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),p="/")),k.with({path:p})}normalizePath(k){if(!k.path.length)return k;let p;return k.scheme===T.Schemas.file?p=m.URI.file(d.$hc(E(k))).path:p=d.$gc.normalize(k.path),k.with({path:p})}relativePath(k,p){if(k.scheme!==p.scheme||!(0,e.$Ag)(k.authority,p.authority))return;if(k.scheme===T.Schemas.file){const a=d.$lc(E(k),E(p));return R.$j?C.$Rf(a):a}let h=k.path||"/";const s=p.path||"/";if(this.a(k)){let a=0;for(const o=Math.min(h.length,s.length);a<o&&!(h.charCodeAt(a)!==s.charCodeAt(a)&&h.charAt(a).toLowerCase()!==s.charAt(a).toLowerCase());a++);h=s.substr(0,a)+h.substr(a)}return d.$gc.relative(h,s)}resolvePath(k,p){if(k.scheme===T.Schemas.file){const h=m.URI.file(d.$kc(E(k),p));return k.with({authority:h.authority,path:h.path})}return p=C.$Sf(p),k.with({path:d.$gc.resolve(k.path,p)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,p){return k===p||k!==void 0&&p!==void 0&&(0,A.$2e)(k,p)}hasTrailingPathSeparator(k,p=d.sep){if(k.scheme===T.Schemas.file){const h=E(k);return h.length>C.$Tf(h).length&&h[h.length-1]===p}else{const h=k.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,p=d.sep){return(0,e.$Bg)(k,p)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,p=d.sep){let h=!1;if(k.scheme===T.Schemas.file){const s=E(k);h=s!==void 0&&s.length===C.$Tf(s).length&&s[s.length-1]===p}else{p="/";const s=k.path;h=s.length===1&&s.charCodeAt(s.length-1)===47}return!h&&!(0,e.$Bg)(k,p)?k.with({path:k.path+"/"}):k}}e.$kg=b,e.$lg=new b(()=>!1),e.$mg=new b(y=>y.scheme===T.Schemas.file?!R.$l:!0),e.$ng=new b(y=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function L(y,k){const p=[];for(let h=0;h<y.length;h++){const s=k(y[h]);y.some((a,o)=>o===h?!1:(0,e.$pg)(s,k(a)))||p.push(y[h])}return p}e.$Eg=L;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function k(p){const h=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(o=>{const[f,l]=o.split(":");f&&l&&h.set(f,l)});const a=p.path.substring(0,p.path.indexOf(";"));return a&&h.set(y.META_DATA_MIME,a),h}y.parseMetaData=k})(P||(e.DataUri=P={}));function v(y,k,p){if(k){let h=y.path;return h&&h[0]!==d.$gc.sep&&(h=d.$gc.sep+h),y.with({scheme:p,authority:k,path:h})}return y.with({scheme:p})}e.$Fg=v}),define(De[8],Ce([1,0,21,9,4,3,23,12,160]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function b(X){return!!X&&typeof X.then=="function"}e.$Gg=b;function L(X){const re=new C.$Xd,Y=X(re.token),_=new Promise((x,ve)=>{const ae=re.token.onCancellationRequested(()=>{ae.dispose(),re.dispose(),ve(new T.$5)});Promise.resolve(Y).then(fe=>{ae.dispose(),re.dispose(),x(fe)},fe=>{ae.dispose(),re.dispose(),ve(fe)})});return new class{cancel(){re.cancel()}then(x,ve){return _.then(x,ve)}catch(x){return this.then(void 0,x)}finally(x){return _.finally(x)}}}e.$Hg=L;function P(X,re,Y){return new Promise((_,x)=>{const ve=re.onCancellationRequested(()=>{ve.dispose(),_(Y)});X.then(_,x).finally(()=>ve.dispose())})}e.$Ig=P;function v(X,re){return new Promise((Y,_)=>{const x=re.onCancellationRequested(()=>{x.dispose(),_(new T.$5)});X.then(Y,_).finally(()=>x.dispose())})}e.$Jg=v;async function y(X){let re=-1;const Y=X.map((_,x)=>_.then(ve=>(re=x,ve)));try{return await Promise.race(Y)}finally{X.forEach((_,x)=>{x!==re&&_.cancel()})}}e.$Kg=y;function k(X,re,Y){let _;const x=setTimeout(()=>{_?.(void 0),Y?.()},re);return Promise.race([X.finally(()=>clearTimeout(x)),new Promise(ve=>_=ve)])}e.$Lg=k;function p(X){return new Promise((re,Y)=>{const _=X();b(_)?_.then(re,Y):re(_)})}e.$Mg=p;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const Y=()=>{if(this.b=null,this.f)return;const _=this.queue(this.d);return this.d=null,_};this.b=new Promise(_=>{this.a.then(Y,Y).then(_)})}return new Promise((Y,_)=>{this.b.then(Y,_)})}return this.a=re(),new Promise((Y,_)=>{this.a.then(x=>{this.a=null,Y(x)},x=>{this.a=null,_(x)})})}dispose(){this.f=!0}}e.$Ng=h;class s{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Og=s;class a{constructor(){this.a=new Map}queue(re,Y){const x=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(re)===x&&this.a.delete(re)});return this.a.set(re,x),x}}e.$Pg=a;const o=(X,re)=>{let Y=!0;const _=setTimeout(()=>{Y=!1,re()},X);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(_),Y=!1}}},f=X=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,X())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class l{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,Y=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((x,ve)=>{this.d=x,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const _=()=>{this.a=null,this.d?.(null)};return this.a=Y===E.$Kd?f(_):o(Y,_),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=l;class t{constructor(re){this.a=new l(re),this.b=new h}trigger(re,Y){return this.a.trigger(()=>this.b.queue(re),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=t;class i{constructor(){this.a=!1,this.b=new Promise((re,Y)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=i;class c extends i{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Tg=c;function n(X,re){return re?new Promise((Y,_)=>{const x=setTimeout(()=>{ve.dispose(),Y()},X),ve=re.onCancellationRequested(()=>{clearTimeout(x),ve.dispose(),_(new T.$5)})}):L(Y=>n(X,Y))}e.$Ug=n;function r(X,re=0,Y){const _=setTimeout(()=>{X(),Y&&x.dispose()},re),x=(0,R.$Qc)(()=>{clearTimeout(_),Y?.deleteAndLeak(x)});return Y?.add(x),x}e.$Vg=r;function u(X){const re=[];let Y=0;const _=X.length;function x(){return Y<_?X[Y++]():null}function ve(ae){ae!=null&&re.push(ae);const fe=x();return fe?fe.then(ve):Promise.resolve(re)}return Promise.resolve(null).then(ve)}e.$Wg=u;function I(X,re=_=>!!_,Y=null){let _=0;const x=X.length,ve=()=>{if(_>=x)return Promise.resolve(Y);const ae=X[_++];return Promise.resolve(ae()).then(ee=>re(ee)?Promise.resolve(ee):ve())};return ve()}e.$Xg=I;function S(X,re=_=>!!_,Y=null){if(X.length===0)return Promise.resolve(Y);let _=X.length;const x=()=>{_=-1;for(const ve of X)ve.cancel?.()};return new Promise((ve,ae)=>{for(const fe of X)fe.then(ee=>{--_>=0&&re(ee)?(x(),ve(ee)):_===0&&ve(Y)}).catch(ee=>{--_>=0&&(x(),ae(ee))})})}e.$Yg=S;class ${constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new d.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((Y,_)=>{this.f.push({factory:re,c:Y,e:_}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const Y=re.factory();Y.then(re.c,re.e),Y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=$;class g extends ${constructor(){super(1)}}e.$1g=g;class w{constructor(){this.a=new me,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$2g=w;class D{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new Q;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,Y=A.$lg){const _=Y.getComparisonKey(re);let x=this.a.get(_);if(!x){x=new g;const ve=this.f++,ae=d.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(_),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(ve,ae),this.a.set(_,x)}return x}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=D;class N{constructor(re,Y){this.a=-1,typeof re=="function"&&typeof Y=="number"&&this.setIfNotSet(re,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},Y)}setIfNotSet(re,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},Y))}}e.$4g=N;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(re,Y){this.cancel(),this.a=setInterval(()=>{re()},Y)}}e.$5g=M;class F{constructor(re,Y){this.b=-1,this.a=re,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=F;class U{constructor(re,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=re,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=U;class j extends F{constructor(re,Y){super(re,Y),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$8g=j;class O extends R.$Sc{constructor(re,Y){super(),this.g=re,this.h=Y,this.a=[],this.b=this.B(new R.$Tc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of re)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=X=>{(0,m.$B)(()=>{if(re)return;const Y=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$0g=(X,re)=>{const Y=requestIdleCallback(X,typeof re=="number"?{timeout:re}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(Y))}}}}();class q{constructor(re){this.d=!1,this.a=()=>{try{this.f=re()}catch(Y){this.g=Y}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=q;async function K(X,re,Y){let _;for(let x=0;x<Y;x++)try{return await X()}catch(ve){_=ve,await n(re)}throw _}e.$_g=K;class me{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,Y,_){return this.a={taskId:re,cancel:()=>_?.(),promise:Y},Y.then(()=>this.d(re),()=>this.d(re)),Y}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let Y,_;const x=new Promise((ve,ae)=>{Y=ve,_=ae});this.b={run:re,promise:x,promiseResolve:Y,promiseReject:_}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=me;class te{constructor(re,Y=()=>Date.now()){this.d=re,this.f=Y,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$bh=te;var G;(function(X){X[X.Resolved=0]="Resolved",X[X.Rejected=1]="Rejected"})(G||(G={}));class Q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,Y)=>{this.a=re,this.b=Y})}complete(re){return new Promise(Y=>{this.a(re),this.d={outcome:0,value:re},Y()})}error(re){return new Promise(Y=>{this.b(re),this.d={outcome:1,value:re},Y()})}cancel(){return this.error(new T.$5)}}e.$ch=Q;var le;(function(X){async function re(_){let x;const ve=await Promise.all(_.map(ae=>ae.then(fe=>fe,fe=>{x||(x=fe)})));if(typeof x<"u")throw x;return ve}X.settled=re;function Y(_){return new Promise(async(x,ve)=>{try{await _(x,ve)}catch(ae){ve(ae)}})}X.withAsyncBody=Y})(le||(e.Promises=le={}));var ie;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(ie||(ie={}));class ce{static fromArray(re){return new ce(Y=>{Y.emitMany(re)})}static fromPromise(re){return new ce(async Y=>{Y.emitMany(await re)})}static fromPromises(re){return new ce(async Y=>{await Promise.all(re.map(async _=>Y.emitOne(await _)))})}static merge(re){return new ce(async Y=>{await Promise.all(re.map(async _=>{for await(const x of _)Y.emitOne(x)}))})}static{this.EMPTY=ce.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new d.$Nd,queueMicrotask(async()=>{const Y={emitOne:_=>this.g(_),emitMany:_=>this.h(_),reject:_=>this.k(_)};try{await Promise.resolve(re(Y)),this.j()}catch(_){this.k(_)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await d.Event.toPromise(this.f.event)}while(!0)}}}static map(re,Y){return new ce(async _=>{for await(const x of re)_.emitOne(Y(x))})}map(re){return ce.map(this,re)}static filter(re,Y){return new ce(async _=>{for await(const x of re)Y(x)&&_.emitOne(x)})}filter(re){return ce.filter(this,re)}static coalesce(re){return ce.filter(re,Y=>!!Y)}coalesce(){return ce.coalesce(this)}static async toPromise(re){const Y=[];for await(const _ of re)Y.push(_);return Y}toPromise(){return ce.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$dh=ce;class ye extends ce{constructor(re,Y){super(Y),this.l=re}cancel(){this.l.cancel()}}e.$eh=ye;function H(X){const re=new C.$Xd,Y=X(re.token);return new ye(re,async _=>{const x=re.token.onCancellationRequested(()=>{x.dispose(),re.dispose(),_.reject(new T.$5)});try{for await(const ve of Y){if(re.token.isCancellationRequested)return;_.emitOne(ve)}x.dispose(),re.dispose()}catch(ve){x.dispose(),re.dispose(),_.reject(ve)}})}e.$fh=H;class B{constructor(){this.a=new Q,this.b=new ce(_=>{if(re){_.reject(re);return}return Y&&_.emitMany(Y),this.d=x=>_.reject(x),this.f=x=>_.emitOne(x),this.a.p});let re,Y;this.f=_=>{Y||(Y=[]),Y.push(_)},this.d=_=>{re||(re=_)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(re){this.d(re),this.a.complete()}emitOne(re){this.f(re)}}e.$gh=B}),define(De[36],Ce([1,0,19,8,33,28,16,12,15]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function b(){return Object.create(null)}e.$rj=b,e.$sj="**",e.$tj="/";const L="[/\\\\]",P="[^/\\\\]",v=/\//g;function y(me,te){switch(me){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${te?`|${L}${P}+`:""})*?`}}function k(me,te){if(!me)return[];const G=[];let Q=!1,le=!1,ie="";for(const ce of me){switch(ce){case te:if(!Q&&!le){G.push(ie),ie="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":le=!0;break;case"]":le=!1;break}ie+=ce}return ie&&G.push(ie),G}e.$uj=k;function p(me){if(!me)return"";let te="";const G=k(me,e.$tj);if(G.every(Q=>Q===e.$sj))te=".*";else{let Q=!1;G.forEach((le,ie)=>{if(le===e.$sj){if(Q)return;te+=y(2,ie===G.length-1)}else{let ce=!1,ye="",H=!1,B="";for(const X of le){if(X!=="}"&&ce){ye+=X;continue}if(H&&(X!=="]"||!B)){let re;X==="-"?re=X:(X==="^"||X==="!")&&!B?re="^":X===e.$tj?re="":re=(0,E.$Fe)(X),B+=re;continue}switch(X){case"{":ce=!0;continue;case"[":H=!0;continue;case"}":{const Y=`(?:${k(ye,",").map(_=>p(_)).join("|")})`;te+=Y,ce=!1,ye="";break}case"]":{te+="["+B+"]",H=!1,B="";break}case"?":te+=P;continue;case"*":te+=y(1);continue;default:te+=(0,E.$Fe)(X)}}ie<G.length-1&&(G[ie+1]!==e.$sj||ie+2<G.length)&&(te+=L)}Q=le===e.$sj})}return te}const h=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),i=function(){return!1},c=function(){return null};function n(me,te){if(!me)return c;let G;typeof me!="string"?G=me.pattern:G=me,G=G.trim();const Q=`${G}_${!!te.trimForExclusions}`;let le=t.get(Q);if(le)return r(le,me);let ie;return h.test(G)?le=I(G.substr(4),G):(ie=s.exec(u(G,te)))?le=S(ie[1],G):(te.trimForExclusions?o:a).test(G)?le=$(G,te):(ie=f.exec(u(G,te)))?le=g(ie[1].substr(1),G,!0):(ie=l.exec(u(G,te)))?le=g(ie[1],G,!1):le=w(G),t.set(Q,le),r(le,me)}function r(me,te){if(typeof te=="string")return me;const G=function(Q,le){return(0,d.$Xf)(Q,te.base,!m.$l)?me((0,E.$Je)(Q.substr(te.base.length),A.sep),le):null};return G.allBasenames=me.allBasenames,G.allPaths=me.allPaths,G.basenames=me.basenames,G.patterns=me.patterns,G}function u(me,te){return te.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function I(me,te){return function(G,Q){return typeof G=="string"&&G.endsWith(me)?te:null}}function S(me,te){const G=`/${me}`,Q=`\\${me}`,le=function(ce,ye){return typeof ce!="string"?null:ye?ye===me?te:null:ce===me||ce.endsWith(G)||ce.endsWith(Q)?te:null},ie=[me];return le.basenames=ie,le.patterns=[te],le.allBasenames=ie,le}function $(me,te){const G=q(me.slice(1,-1).split(",").map(ye=>n(ye,te)).filter(ye=>ye!==c),me),Q=G.length;if(!Q)return c;if(Q===1)return G[0];const le=function(ye,H){for(let B=0,X=G.length;B<X;B++)if(G[B](ye,H))return me;return null},ie=G.find(ye=>!!ye.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const ce=G.reduce((ye,H)=>H.allPaths?ye.concat(H.allPaths):ye,[]);return ce.length&&(le.allPaths=ce),le}function g(me,te,G){const Q=A.sep===A.$gc.sep,le=Q?me:me.replace(v,A.sep),ie=A.sep+le,ce=A.$gc.sep+me;let ye;return G?ye=function(H,B){return typeof H=="string"&&(H===le||H.endsWith(ie)||!Q&&(H===me||H.endsWith(ce)))?te:null}:ye=function(H,B){return typeof H=="string"&&(H===le||!Q&&H===me)?te:null},ye.allPaths=[(G?"*/":"./")+me],ye}function w(me){try{const te=new RegExp(`^${p(me)}$`);return function(G){return te.lastIndex=0,typeof G=="string"&&te.test(G)?me:null}}catch{return c}}function D(me,te,G){return!me||typeof te!="string"?!1:N(me)(te,void 0,G)}e.$vj=D;function N(me,te={}){if(!me)return i;if(typeof me=="string"||M(me)){const G=n(me,te);if(G===c)return i;const Q=function(le,ie){return!!G(le,ie)};return G.allBasenames&&(Q.allBasenames=G.allBasenames),G.allPaths&&(Q.allPaths=G.allPaths),Q}return j(me,te)}e.$wj=N;function M(me){const te=me;return te?typeof te.base=="string"&&typeof te.pattern=="string":!1}e.$xj=M;function F(me){return me.allBasenames||[]}e.$yj=F;function U(me){return me.allPaths||[]}e.$zj=U;function j(me,te){const G=q(Object.getOwnPropertyNames(me).map(ye=>O(ye,me[ye],te)).filter(ye=>ye!==c)),Q=G.length;if(!Q)return c;if(!G.some(ye=>!!ye.requiresSiblings)){if(Q===1)return G[0];const ye=function(X,re){let Y;for(let _=0,x=G.length;_<x;_++){const ve=G[_](X,re);if(typeof ve=="string")return ve;(0,T.$Gg)(ve)&&(Y||(Y=[]),Y.push(ve))}return Y?(async()=>{for(const _ of Y){const x=await _;if(typeof x=="string")return x}return null})():null},H=G.find(X=>!!X.allBasenames);H&&(ye.allBasenames=H.allBasenames);const B=G.reduce((X,re)=>re.allPaths?X.concat(re.allPaths):X,[]);return B.length&&(ye.allPaths=B),ye}const le=function(ye,H,B){let X,re;for(let Y=0,_=G.length;Y<_;Y++){const x=G[Y];x.requiresSiblings&&B&&(H||(H=(0,A.$nc)(ye)),X||(X=H.substr(0,H.length-(0,A.$oc)(ye).length)));const ve=x(ye,H,X,B);if(typeof ve=="string")return ve;(0,T.$Gg)(ve)&&(re||(re=[]),re.push(ve))}return re?(async()=>{for(const Y of re){const _=await Y;if(typeof _=="string")return _}return null})():null},ie=G.find(ye=>!!ye.allBasenames);ie&&(le.allBasenames=ie.allBasenames);const ce=G.reduce((ye,H)=>H.allPaths?ye.concat(H.allPaths):ye,[]);return ce.length&&(le.allPaths=ce),le}function O(me,te,G){if(te===!1)return c;const Q=n(me,G);if(Q===c)return c;if(typeof te=="boolean")return Q;if(te){const le=te.when;if(typeof le=="string"){const ie=(ce,ye,H,B)=>{if(!B||!Q(ce,ye))return null;const X=le.replace("$(basename)",()=>H),re=B(X);return(0,T.$Gg)(re)?re.then(Y=>Y?me:null):re?me:null};return ie.requiresSiblings=!0,ie}}return Q}function q(me,te){const G=me.filter(ye=>!!ye.basenames);if(G.length<2)return me;const Q=G.reduce((ye,H)=>{const B=H.basenames;return B?ye.concat(B):ye},[]);let le;if(te){le=[];for(let ye=0,H=Q.length;ye<H;ye++)le.push(te)}else le=G.reduce((ye,H)=>{const B=H.patterns;return B?ye.concat(B):ye},[]);const ie=function(ye,H){if(typeof ye!="string")return null;if(!H){let X;for(X=ye.length;X>0;X--){const re=ye.charCodeAt(X-1);if(re===47||re===92)break}H=ye.substr(X)}const B=Q.indexOf(H);return B!==-1?le[B]:null};ie.basenames=Q,ie.patterns=le,ie.allBasenames=Q;const ce=me.filter(ye=>!ye.basenames);return ce.push(ie),ce}function K(me,te){return(0,C.$ub)(me,te,(G,Q)=>typeof G=="string"&&typeof Q=="string"?G===Q:typeof G!="string"&&typeof Q!="string"?G.base===Q.base&&G.pattern===Q.pattern:!1)}e.$Aj=K}),define(De[80],Ce([1,0,9,161,23,15,2]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class E{constructor(s="",a=!1){if(this.value=s,typeof this.value!="string")throw(0,C.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(s,a=0){return this.value+=v(this.supportThemeIcons?(0,T.$Wj)(s):s).replace(/([ \t]+)/g,(o,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,a){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(s,a,o){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(s),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(s,a){const o=new RegExp((0,R.$Fe)(a),"g");return s.replace(o,(f,l)=>s.charAt(l-1)!=="\\"?`\\${f}`:f)}}e.$3j=E;function b(h){return L(h)?!h.value:Array.isArray(h)?h.every(b):!0}e.$4j=b;function L(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.$5j=L;function P(h,s){return h===s?!0:!h||!s?!1:h.value===s.value&&h.isTrusted===s.isTrusted&&h.supportThemeIcons===s.supportThemeIcons&&h.supportHtml===s.supportHtml&&(h.baseUri===s.baseUri||!!h.baseUri&&!!s.baseUri&&(0,d.$og)(A.URI.from(h.baseUri),A.URI.from(s.baseUri)))}e.$6j=P;function v(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=v;function y(h){return h.replace(/"/g,"&quot;")}e.$8j=y;function k(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=k;function p(h){const s=[],a=h.split("|").map(f=>f.trim());h=a[0];const o=a[1];if(o){const f=/height=(\d+)/.exec(o),l=/width=(\d+)/.exec(o),t=f?f[1]:"",i=l?l[1]:"",c=isFinite(parseInt(i)),n=isFinite(parseInt(t));c&&s.push(`width="${i}"`),n&&s.push(`height="${t}"`)}return{href:h,dimensions:s}}e.$0j=p}),define(De[99],Ce([1,0,19,33,16,12,23,15]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function E(n,r){const{os:u,tildify:I,relative:S}=r;if(S){const w=b(n,S,u);if(typeof w=="string")return w}let $=n.fsPath;if(u===1&&!R.$j?$=$.replace(/\//g,"\\"):u!==1&&R.$j&&($=$.replace(/\\/g,"/")),u!==1&&I?.userHome){const w=I.userHome.fsPath;let D;n.scheme!==I.userHome.scheme&&n.path.startsWith(d.$gc.sep)?D=I.userHome.with({path:n.path}).fsPath:D=n.fsPath,$=v(D,w,u)}return(u===1?d.$fc:d.$gc).normalize(L($,u===1))}e.$rv=E;function b(n,r,u){const I=u===1?d.$fc:d.$gc,S=u===3?A.$lg:A.$ng,$=r.getWorkspace(),g=(0,C.$Ob)($.folders);if(!g)return;n.scheme!==g.uri.scheme&&n.path.startsWith(d.$gc.sep)&&(n=g.uri.with({path:n.path}));const w=r.getWorkspaceFolder(n);if(!w)return;let D;if(S.isEqual(w.uri,n)?D="":D=S.relativePath(w.uri,n)??"",D&&(D=I.normalize(D)),$.folders.length>1&&!r.noPrefix){const N=w.name?w.name:S.basenameOrAuthority(w.uri);D=D?`${N} \u2022 ${D}`:N}return D}function L(n,r=R.$j){return(0,T.$2f)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$sv=L;let P=Object.create(null);function v(n,r,u=R.OS){if(u===1||!n||!r)return n;let I=P.original===r?P.normalized:void 0;I||(I=r,R.$j&&(I=(0,T.$Rf)(I)),I=`${(0,m.$Ke)(I,d.$gc.sep)}${d.$gc.sep}`,P={original:r,normalized:I});let S=n;return R.$j&&(S=(0,T.$Rf)(S)),(u===3?S.startsWith(I):(0,m.$3e)(S,I))?`~/${S.substr(I.length)}`:n}e.$tv=v;function y(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.$uv=y;const k="\u2026",p="\\\\",h="~";function s(n,r=d.sep){const u=new Array(n.length);let I=!1;for(let S=0;S<n.length;S++){const $=n[S];if($===""){u[S]=`.${r}`;continue}if(!$){u[S]=$;continue}I=!0;let g="",w=$;w.indexOf(p)===0?(g=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length)):w.indexOf(r)===0?(g=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length)):w.indexOf(h)===0&&(g=w.substr(0,w.indexOf(h)+h.length),w=w.substr(w.indexOf(h)+h.length));const D=w.split(r);for(let N=1;I&&N<=D.length;N++)for(let M=D.length-N;I&&M>=0;M--){I=!1;let F=D.slice(M,M+N).join(r);for(let U=0;!I&&U<n.length;U++)if(U!==S&&n[U]&&n[U].indexOf(F)>-1){const j=M+N===D.length,O=M>0&&n[U].indexOf(r)>-1?r+F:F,q=n[U].endsWith(O);I=!j||q}if(!I){let U="";(D[0].endsWith(":")||g!=="")&&(M===1&&(M=0,N++,F=D[0]+r+F),M>0&&(U=D[0]+r),U=g+U),M>0&&(U=U+k+r),U=U+F,M+N<D.length&&(U=U+r+k),u[S]=U}}I&&(u[S]=$)}return u}e.$vv=s;var a;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function o(n,r=Object.create(null)){const u=[];let I=!1,S="";for(const $ of n)if($==="$"||I&&$==="{")S&&u.push({value:S,type:a.TEXT}),S="",I=!0;else if($==="}"&&I){const g=r[S];if(typeof g=="string")g.length&&u.push({value:g,type:a.VARIABLE});else if(g){const w=u[u.length-1];(!w||w.type!==a.SEPARATOR)&&u.push({value:g.label,type:a.SEPARATOR})}S="",I=!1}else S+=$;return S&&!I&&u.push({value:S,type:a.TEXT}),u.filter(($,g)=>{if($.type===a.SEPARATOR){const w=u[g-1],D=u[g+1];return[w,D].every(N=>N&&(N.type===a.VARIABLE||N.type===a.TEXT)&&N.value.length>0)}return!0}).map($=>$.value).join("")}e.$wv=o;function f(n,r){return R.$k||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$k?"&":"&&"):n.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.$xv=f;function l(n,r){return R.$k||r?n.replace(/\(&&\w\)|&&/g,""):R.$j?n.replace(/&&|&/g,u=>u==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$yv=l;function t(n){return n.replace(/&/g,"&&")}e.$zv=t;function i(n){if(n.endsWith("]")){const r=n.lastIndexOf(" [",n.length-2);if(r!==-1){const u=c(n.substring(0,r));return{name:u.name,parentPath:u.parentPath+n.substring(r)}}}return c(n)}e.$Av=i;function c(n){const r=n.indexOf("/")!==-1?d.$gc:d.$fc,u=r.basename(n),I=r.dirname(n);return u.length?{name:u,parentPath:I}:{name:I,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function d(P){return P.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const y=this.a.transformIncoming(v);return y===v?v:d(T.URI.from(y))}transformOutgoing(v){const y=this.a.transformOutgoing(v);return y===v?v:d(T.URI.from(y))}transformOutgoingURI(v){const y=this.a.transformOutgoing(v);return y===v?v:T.URI.from(y)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Lm=R,e.$Mm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function A(P,v,y){if(!P||y>200)return null;if(typeof P=="object"){if(P instanceof T.URI)return v.transformOutgoing(P);for(const k in P)if(Object.hasOwnProperty.call(P,k)){const p=A(P[k],v,y+1);p!==null&&(P[k]=p)}}return null}function m(P,v){const y=A(P,v,0);return y===null?P:y}e.$Nm=m;function E(P,v,y,k){if(!P||k>200)return null;if(typeof P=="object"){if(P.$mid===1)return y?T.URI.revive(v.transformIncoming(P)):v.transformIncoming(P);if(P instanceof C.$be)return null;for(const p in P)if(Object.hasOwnProperty.call(P,p)){const h=E(P[p],v,y,k+1);h!==null&&(P[p]=h)}}return null}function b(P,v){const y=E(P,v,!1,0);return y===null?P:y}e.$Om=b;function L(P,v){const y=E(P,v,!0,0);return y===null?P:y}e.$Pm=L}),define(De[29],Ce([1,0,53,63,374,8,33,77,16,12,23,2]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function y(O,q=v.UNLINK,K){if((0,A.$1f)(O))throw new Error("rimraf - will refuse to recursively delete root");return q===v.UNLINK?p(O):k(O,K)}async function k(O,q=(0,A.$6f)((0,T.tmpdir)())){try{try{await C.promises.rename(O,q)}catch(K){return K.code==="ENOENT"?void 0:p(O)}p(q).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function p(O){return(0,d.promisify)(C.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function h(O){if((0,A.$1f)(O))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function s(O,q){return f(await(q?a(O):(0,d.promisify)(C.readdir)(O)))}async function a(O){try{return await(0,d.promisify)(C.readdir)(O,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const q=[],K=await s(O);for(const me of K){let te=!1,G=!1,Q=!1;try{const le=await e.Promises.lstat((0,E.$jc)(O,me));te=le.isFile(),G=le.isDirectory(),Q=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}q.push({name:me,isFile:()=>te,isDirectory:()=>G,isSymbolicLink:()=>Q})}return q}function o(O){return f(C.readdirSync(O))}e.readdirSync=o;function f(O){return O.map(q=>typeof q=="string"?b.$k?(0,m.$ol)(q):q:(q.name=b.$k?(0,m.$ol)(q.name):q.name,q))}async function l(O){const q=await s(O),K=[];for(const me of q)await i.existsDirectory((0,E.$jc)(O,me))&&K.push(me);return K}function t(O,q=1e3){return new Promise(K=>{let me=!1;const te=setInterval(()=>{me||(me=!0,C.access(O,G=>{me=!1,G&&(clearInterval(te),K(void 0))}))},q)})}e.whenDeleted=t;var i;(function(O){async function q(te){let G;try{if(G=await e.Promises.lstat(te),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(te),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(b.$j&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(te)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw le}throw Q}}O.stat=q;async function K(te){try{const{stat:G,symbolicLink:Q}=await O.stat(te);return G.isFile()&&Q?.dangling!==!0}catch{}return!1}O.existsFile=K;async function me(te){try{const{stat:G,symbolicLink:Q}=await O.stat(te);return G.isDirectory()&&Q?.dangling!==!0}catch{}return!1}O.existsDirectory=me})(i||(e.SymlinkSupport=i={}));const c=new R.$3g;function n(O,q,K){return c.queueFor(P.URI.file(O),L.$mg).queue(()=>{const me=$(K);return new Promise((te,G)=>I(O,q,me,Q=>Q?G(Q):te()))})}let r=!0;function u(O){r=O}e.configureFlushOnWrite=u;function I(O,q,K,me){if(!r)return C.writeFile(O,q,{mode:K.mode,flag:K.flag},me);C.open(O,K.flag,K.mode,(te,G)=>{if(te)return me(te);C.writeFile(G,q,Q=>{if(Q)return C.close(G,()=>me(Q));C.fdatasync(G,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),u(!1)),C.close(G,ie=>me(ie))))})})}function S(O,q,K){const me=$(K);if(!r)return C.writeFileSync(O,q,{mode:me.mode,flag:me.flag});const te=C.openSync(O,me.flag,me.mode);try{C.writeFileSync(te,q);try{C.fdatasyncSync(te)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),u(!1)}}finally{C.closeSync(te)}}e.writeFileSync=S;function $(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function g(O,q,K=6e4){if(O!==q)try{b.$j&&typeof K=="number"?await w(O,q,Date.now(),K):await(0,d.promisify)(C.rename)(O,q)}catch(me){if(O.toLowerCase()!==q.toLowerCase()&&me.code==="EXDEV"||O.endsWith("."))await D(O,q,{preserveSymlinks:!1}),await y(O,v.MOVE);else throw me}}async function w(O,q,K,me,te=0){try{return await(0,d.promisify)(C.rename)(O,q)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-K>=me)throw console.error(`[node.js fs] rename failed after ${te} retries with error: ${G}`),G;if(te===0){let Q=!1;try{const{stat:le}=await i.stat(q);le.isFile()||(Q=!0)}catch{}if(Q)throw G}return await(0,R.$Ug)(Math.min(100,te*10)),w(O,q,K,me,te+1)}}async function D(O,q,K){return M(O,q,{root:{source:O,target:q},options:K,handledSourcePaths:new Set})}const N=511;async function M(O,q,K){if(K.handledSourcePaths.has(O))return;K.handledSourcePaths.add(O);const{stat:me,symbolicLink:te}=await i.stat(O);if(te){if(K.options.preserveSymlinks)try{return await j(O,q,K)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(te.dangling)return}return me.isDirectory()?F(O,q,me.mode&N,K):U(O,q,me.mode&N)}async function F(O,q,K,me){await e.Promises.mkdir(q,{recursive:!0,mode:K});const te=await s(O);for(const G of te)await M((0,E.$jc)(O,G),(0,E.$jc)(q,G),me)}async function U(O,q,K){await e.Promises.copyFile(O,q),await e.Promises.chmod(q,K)}async function j(O,q,K){let me=await e.Promises.readlink(O);(0,A.$Xf)(me,K.root.source,!b.$l)&&(me=(0,E.$jc)(K.root.target,me.substr(K.root.source.length+1))),await e.Promises.symlink(me,q)}e.Promises=new class{get access(){return(0,d.promisify)(C.access)}get stat(){return(0,d.promisify)(C.stat)}get lstat(){return(0,d.promisify)(C.lstat)}get utimes(){return(0,d.promisify)(C.utimes)}get read(){return(O,q,K,me,te)=>new Promise((G,Q)=>{C.read(O,q,K,me,te,(le,ie,ce)=>le?Q(le):G({bytesRead:ie,buffer:ce}))})}get readFile(){return(0,d.promisify)(C.readFile)}get write(){return(O,q,K,me,te)=>new Promise((G,Q)=>{C.write(O,q,K,me,te,(le,ie,ce)=>le?Q(le):G({bytesWritten:ie,buffer:ce}))})}get appendFile(){return(0,d.promisify)(C.appendFile)}get fdatasync(){return(0,d.promisify)(C.fdatasync)}get truncate(){return(0,d.promisify)(C.truncate)}get copyFile(){return(0,d.promisify)(C.copyFile)}get open(){return(0,d.promisify)(C.open)}get close(){return(0,d.promisify)(C.close)}get symlink(){return(0,d.promisify)(C.symlink)}get readlink(){return(0,d.promisify)(C.readlink)}get chmod(){return(0,d.promisify)(C.chmod)}get mkdir(){return(0,d.promisify)(C.mkdir)}get unlink(){return(0,d.promisify)(C.unlink)}get rmdir(){return(0,d.promisify)(C.rmdir)}get realpath(){return(0,d.promisify)(C.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return l}get writeFile(){return n}get rm(){return y}get rename(){return g}get copy(){return D}}}),define(De[100],Ce([1,0,53,16,12,15,29]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=e.$6p=e.$5p=void 0;function m(v){if(d.$l)return v;const y=(0,T.$mc)(v);if(v===y)return v;const k=((0,T.$nc)(v)||v).toLowerCase();try{const h=(0,A.readdirSync)(y).filter(s=>s.toLowerCase()===k);if(h.length===1){const s=m(y);if(s)return(0,T.$jc)(s,h[0])}else if(h.length>1){const s=h.indexOf(k);if(s>=0){const a=m(y);if(a)return(0,T.$jc)(a,h[s])}}}catch{}return null}e.$5p=m;async function E(v){if(d.$l)return v;const y=(0,T.$mc)(v);if(v===y)return v;const k=((0,T.$nc)(v)||v).toLowerCase();try{const h=(await A.Promises.readdir(y)).filter(s=>s.toLowerCase()===k);if(h.length===1){const s=await E(y);if(s)return(0,T.$jc)(s,h[0])}else if(h.length>1){const s=h.indexOf(k);if(s>=0){const a=await E(y);if(a)return(0,T.$jc)(a,h[s])}}}catch{}return null}e.$6p=E;async function b(v){try{return await A.Promises.realpath(v)}catch{const k=P(v);return await A.Promises.access(k,C.constants.R_OK),k}}e.$7p=b;function L(v){try{return C.realpathSync(v)}catch{const k=P(v);return C.accessSync(k,C.constants.R_OK),k}}e.$8p=L;function P(v){return(0,R.$Ke)((0,T.$hc)(v),T.sep)}}),define(De[101],Ce([1,0,16,12,48,98,17,29]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function E(P=d.env){return P.comspec||"cmd.exe"}e.$Bl=E;function b(P){let v=[],y=!1;const k=function(p){if(y){v.push(p);return}(!P.send(p,s=>{if(s&&console.error(s),y=!1,v.length>0){const a=v.slice(0);v=[],a.forEach(o=>k(o))}})||T.$j)&&(y=!0)};return{send:k}}e.$Cl=b;var L;(function(P){async function v(y,k,p){if(C.$ic(y))return y;if(k===void 0&&(k=d.cwd()),C.$mc(y)!=="."||(p===void 0&&A.$yf(d.env.PATH)&&(p=d.env.PATH.split(C.$tc)),p===void 0||p.length===0))return C.$jc(k,y);async function s(a){if(await m.Promises.exists(a)){let o;try{o=await m.Promises.stat(a)}catch(f){f.message.startsWith("EACCES")&&(o=await m.Promises.lstat(a))}return o?!o.isDirectory():!1}return!1}for(const a of p){let o;if(C.$ic(a)?o=C.$jc(a,y):o=C.$jc(k,a,y),await s(o))return o;let f=o+".com";if(await s(f)||(f=o+".exe",await s(f)))return f}return C.$jc(k,y)}P.findExecutable=v})(L||(e.win32=L={}))});var He=this&&this.__decorate||function($e,e,C,T){var d=arguments.length,R=d<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,C):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($e,e,C,T);else for(var m=$e.length-1;m>=0;m--)(A=$e[m])&&(R=(d<3?A(R):d>3?A(e,C,R):A(e,C))||R);return d>3&&R&&Object.defineProperty(e,C,R),R};define(De[81],Ce([1,0,19,8,22,21,57,9,4,3,62,15,17]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.ProxyChannel=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.RequestInitiator=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=void 0;var y;(function(te){te[te.Promise=100]="Promise",te[te.PromiseCancel=101]="PromiseCancel",te[te.EventListen=102]="EventListen",te[te.EventDispose=103]="EventDispose"})(y||(y={}));function k(te){switch(te){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(te){te[te.Initialize=200]="Initialize",te[te.PromiseSuccess=201]="PromiseSuccess",te[te.PromiseError=202]="PromiseError",te[te.PromiseErrorObj=203]="PromiseErrorObj",te[te.EventFire=204]="EventFire"})(p||(p={}));function h(te){switch(te){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(te){te[te.Uninitialized=0]="Uninitialized",te[te.Idle=1]="Idle"})(s||(s={}));function a(te){let G=0;for(let Q=0;;Q+=7){const le=te.read(1);if(G|=(le.buffer[0]&127)<<Q,!(le.buffer[0]&128))return G}}const o=c(0);function f(te,G){if(G===0){te.write(o);return}let Q=0;for(let ie=G;ie!==0;ie=ie>>>7)Q++;const le=d.$be.alloc(Q);for(let ie=0;G!==0;ie++)le.buffer[ie]=G&127,G=G>>>7,G>0&&(le.buffer[ie]|=128);te.write(le)}class l{constructor(G){this.b=G,this.a=0}read(G){const Q=this.b.slice(this.a,this.a+G);return this.a+=Q.byteLength,Q}}e.$nh=l;class t{constructor(){this.a=[]}get buffer(){return d.$be.concat(this.a)}write(G){this.a.push(G)}}e.$oh=t;var i;(function(te){te[te.Undefined=0]="Undefined",te[te.String=1]="String",te[te.Buffer=2]="Buffer",te[te.VSBuffer=3]="VSBuffer",te[te.Array=4]="Array",te[te.Object=5]="Object",te[te.Int=6]="Int"})(i||(i={}));function c(te){const G=d.$be.alloc(1);return G.writeUInt8(te,0),G}const n={Undefined:c(i.Undefined),String:c(i.String),Buffer:c(i.Buffer),VSBuffer:c(i.VSBuffer),Array:c(i.Array),Object:c(i.Object),Uint:c(i.Int)},r=typeof Buffer<"u";function u(te,G){if(typeof G>"u")te.write(n.Undefined);else if(typeof G=="string"){const Q=d.$be.fromString(G);te.write(n.String),f(te,Q.byteLength),te.write(Q)}else if(r&&Buffer.isBuffer(G)){const Q=d.$be.wrap(G);te.write(n.Buffer),f(te,Q.byteLength),te.write(Q)}else if(G instanceof d.$be)te.write(n.VSBuffer),f(te,G.byteLength),te.write(G);else if(Array.isArray(G)){te.write(n.Array),f(te,G.length);for(const Q of G)u(te,Q)}else if(typeof G=="number"&&(G|0)===G)te.write(n.Uint),f(te,G);else{const Q=d.$be.fromString(JSON.stringify(G));te.write(n.Object),f(te,Q.byteLength),te.write(Q)}}e.$ph=u;function I(te){switch(te.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return te.read(a(te)).toString();case i.Buffer:return te.read(a(te)).buffer;case i.VSBuffer:return te.read(a(te));case i.Array:{const Q=a(te),le=[];for(let ie=0;ie<Q;ie++)le.push(I(te));return le}case i.Object:return JSON.parse(te.read(a(te)).toString());case i.Int:return a(te)}}e.$qh=I;class S{constructor(G,Q,le=null,ie=1e3){this.h=G,this.j=Q,this.k=le,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(G,Q){this.b.set(G,Q),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const Q=this.o([G.type]);this.k?.logOutgoing(Q,0,1,h(G.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([G.type,G.id],G.data);this.k?.logOutgoing(Q,G.id,1,h(G.type),G.data);return}}}o(G,Q=void 0){const le=new t;return u(le,G),u(le,Q),this.p(le.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const Q=new l(G),le=I(Q),ie=I(Q),ce=le[0];switch(ce){case 100:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}: ${le[2]}.${le[3]}`,ie),this.s({type:ce,id:le[1],channelName:le[2],name:le[3],arg:ie});case 102:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}: ${le[2]}.${le[3]}`,ie),this.t({type:ce,id:le[1],channelName:le[2],name:le[3],arg:ie});case 101:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}`),this.u({type:ce,id:le[1]});case 103:return this.k?.logIncoming(G.byteLength,le[1],1,`${k(ce)}`),this.u({type:ce,id:le[1]})}}s(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const le=new R.$Xd;let ie;try{ie=Q.call(this.j,G.name,G.arg,le.token)}catch(H){ie=Promise.reject(H)}const ce=G.id;ie.then(H=>{this.m({id:ce,data:H,type:201})},H=>{H instanceof Error?this.m({id:ce,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.m({id:ce,data:H,type:203})}).finally(()=>{ye.dispose(),this.d.delete(G.id)});const ye=(0,b.$Qc)(()=>le.cancel());this.d.set(G.id,ye)}t(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const le=G.id,ce=Q.listen(this.j,G.name,G.arg)(ye=>this.m({id:le,data:ye,type:204}));this.d.set(G.id,ce)}u(G){const Q=this.d.get(G.id);Q&&(Q.dispose(),this.d.delete(G.id))}v(G){let Q=this.g.get(G.channelName);Q||(Q=[],this.g.set(G.channelName,Q));const le=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:G,timeoutTimer:le})}w(G){const Q=this.g.get(G);if(Q){for(const le of Q)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$Nc)(this.d.values()),this.d.clear()}}e.$rh=S;var $;(function(te){te[te.LocalSide=0]="LocalSide",te[te.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class g{constructor(G,Q=null){this.l=G,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=Q}getChannel(G){const Q=this;return{call(le,ie,ce){return Q.a?Promise.reject(new m.$5):Q.m(G,le,ie,ce)},listen(le,ie){return Q.a?E.Event.None:Q.o(G,le,ie)}}}m(G,Q,le,ie=R.CancellationToken.None){const ce=this.g++,H={id:ce,type:100,channelName:G,name:Q,arg:le};if(ie.isCancellationRequested)return Promise.reject(new m.$5);let B;return new Promise((re,Y)=>{if(ie.isCancellationRequested)return Y(new m.$5);const _=()=>{const fe=ee=>{switch(ee.type){case 201:this.f.delete(ce),re(ee.data);break;case 202:{this.f.delete(ce);const de=new Error(ee.data.message);de.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,de.name=ee.data.name,Y(de);break}case 203:this.f.delete(ce),Y(ee.data);break}};this.f.set(ce,fe),this.p(H)};let x=null;this.b===s.Idle?_():(x=(0,T.$Hg)(fe=>this.u()),x.then(()=>{x=null,_()}));const ve=()=>{x?(x.cancel(),x=null):this.p({id:ce,type:101}),Y(new m.$5)},ae=ie.onCancellationRequested(ve);B=(0,b.$Pc)((0,b.$Qc)(ve),ae),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(G,Q,le){const ie=this.g++,ye={id:ie,type:102,channelName:G,name:Q,arg:le};let H=null;const B=new E.$Nd({onWillAddFirstListener:()=>{H=(0,T.$Hg)(re=>this.u()),H.then(()=>{H=null,this.d.add(B),this.p(ye)})},onDidRemoveLastListener:()=>{H?(H.cancel(),H=null):(this.d.delete(B),this.p({id:ie,type:103}))}}),X=re=>B.fire(re.data);return this.f.set(ie,X),B.event}p(G){switch(G.type){case 100:case 102:{const Q=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(Q,G.id,0,`${k(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const Q=this.q([G.type,G.id]);this.j?.logOutgoing(Q,G.id,0,k(G.type));return}}}q(G,Q=void 0){const le=new t;return u(le,G),u(le,Q),this.r(le.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const Q=new l(G),le=I(Q),ie=I(Q),ce=le[0];switch(ce){case 200:return this.j?.logIncoming(G.byteLength,0,0,h(ce)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,le[1],0,h(ce),ie),this.t({type:le[0],id:le[1],data:ie})}}t(G){if(G.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$Nc)(this.d.values()),this.d.clear()}}e.$sh=g,He([A.$hh],g.prototype,"onDidInitializePromise",null);class w{get connections(){const G=[];return this.f.forEach(Q=>G.push(Q)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new E.$Nd,this.onDidAddConnection=this.g.event,this.h=new E.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new b.$Rc,this.j.add(G(({protocol:Q,onDidClientDisconnect:le})=>{const ie=E.Event.once(Q.onMessage);this.j.add(ie(ce=>{const ye=new l(ce),H=I(ye),B=new S(Q,H),X=new g(Q);this.a.forEach((Y,_)=>B.registerChannel(_,Y));const re={channelServer:B,channelClient:X,ctx:H};this.f.add(re),this.g.fire(re),this.j.add(le(()=>{B.dispose(),X.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(G,Q){const le=this;return{call(ie,ce,ye){let H;if((0,v.$Mf)(Q)){const X=(0,C.$4b)(le.connections.filter(Q));H=X?Promise.resolve(X):E.Event.toPromise(E.Event.filter(le.onDidAddConnection,Q))}else H=Q.routeCall(le,ie,ce);const B=H.then(X=>X.channelClient.getChannel(G));return N(B).call(ie,ce,ye)},listen(ie,ce){if((0,v.$Mf)(Q))return le.k(G,Q,ie,ce);const ye=Q.routeEvent(le,ie,ce).then(H=>H.channelClient.getChannel(G));return N(ye).listen(ie,ce)}}}k(G,Q,le,ie){const ce=this;let ye;const H=new E.$Nd({onWillAddFirstListener:()=>{ye=new b.$Rc;const B=new E.$Td,X=new Map,re=_=>{const ve=_.channelClient.getChannel(G).listen(le,ie),ae=B.add(ve);X.set(_,ae)},Y=_=>{const x=X.get(_);x&&(x.dispose(),X.delete(_))};ce.connections.filter(Q).forEach(re),E.Event.filter(ce.onDidAddConnection,Q)(re,void 0,ye),ce.onDidRemoveConnection(Y,void 0,ye),B.event(H.fire,H,ye),ye.add(B)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return H.event}registerChannel(G,Q){this.a.set(G,Q);for(const le of this.f)le.channelServer.registerChannel(G,Q)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$th=w;class D{constructor(G,Q,le=null){const ie=new t;u(ie,Q),G.send(ie.buffer),this.a=new g(G,le),this.d=new S(G,Q,le)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,Q){this.d.registerChannel(G,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$uh=D;function N(te){return{call(G,Q,le){return te.then(ie=>ie.call(G,Q,le))},listen(G,Q){const le=new E.$Wd;return te.then(ie=>le.input=ie.listen(G,Q)),le.event}}}e.$vh=N;function M(te){let G=!1;return{call(Q,le,ie){return G?te.call(Q,le,ie):(0,T.$Ug)(0).then(()=>G=!0).then(()=>te.call(Q,le,ie))},listen(Q,le){if(G)return te.listen(Q,le);const ie=new E.$Wd;return(0,T.$Ug)(0).then(()=>G=!0).then(()=>ie.input=te.listen(Q,le)),ie.event}}}e.$wh=M;class F{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const Q of G.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await E.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$xh=F;var U;(function(te){function G(ce,ye,H){const B=ce,X=H&&H.disableMarshalling,re=new Map;for(const Y in B)le(Y)&&re.set(Y,E.Event.buffer(B[Y],!0,void 0,ye));return new class{listen(Y,_,x){const ve=re.get(_);if(ve)return ve;if(ie(_)){const ae=B[_];if(typeof ae=="function")return ae.call(B,x)}throw new m.$bb(`Event not found: ${_}`)}call(Y,_,x){const ve=B[_];if(typeof ve=="function"){if(!X&&Array.isArray(x))for(let fe=0;fe<x.length;fe++)x[fe]=(0,L.$mh)(x[fe]);let ae=ve.apply(B,x);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new m.$bb(`Method not found: ${_}`)}}}te.fromService=G;function Q(ce,ye){const H=ye&&ye.disableMarshalling;return new Proxy({},{get(B,X){if(typeof X=="string")return ye?.properties?.has(X)?ye.properties.get(X):ie(X)?function(re){return ce.listen(X,re)}:le(X)?ce.listen(X):async function(...re){let Y;ye&&!(0,v.$Hf)(ye.context)?Y=[ye.context,...re]:Y=re;const _=await ce.call(X,Y);return H?_:(0,L.$mh)(_)};throw new m.$bb(`Property not found: ${String(X)}`)}})}te.toService=Q;function le(ce){return ce[0]==="o"&&ce[1]==="n"&&P.$1e(ce.charCodeAt(2))}function ie(ce){return/^onDynamic/.test(ce)&&P.$1e(ce.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(te){if(Array.isArray(te))return te;if(te&&typeof te=="object"&&typeof te.toString=="function"){const G=te.toString();if(G!=="[object Object]")return G}return te}function q(te){return Array.isArray(te)?te.map(O):O(te)}function K(te,G,Q,le,ie,ce,ye){ye=q(ye);const H=j[ie],B=H[le%H.length];let X=[`%c[${te}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ce)?(X=X.concat(ye),X.push(")")):X.push(ye),console.log.apply(console,X)}class me{constructor(G,Q){this.d=G,this.f=Q,this.a=0,this.b=0}logOutgoing(G,Q,le,ie,ce){this.b+=G,K(this.d,this.b,G,Q,le,ie,ce)}logIncoming(G,Q,le,ie,ce){this.a+=G,K(this.f,this.a,G,Q,le,ie,ce)}}e.$yh=me}),define(De[82],Ce([1,0,22,4,3,81]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.ProtocolConstants=e.$zh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var m;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let u=0;function I($,g){if(!r.has($)){const w=String(++u);r.set($,w)}return r.get($)}function S($,g,w,D){if(!n.enableDiagnostics)return;const N=I($,g);if(D instanceof C.$be||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const M=C.$be.alloc(D.byteLength);M.set(D),n.records.push({timestamp:Date.now(),id:N,label:g,type:w,buff:M})}else n.records.push({timestamp:Date.now(),id:N,label:g,type:w,data:D})}n.traceSocketEvent=S})(m||(e.SocketDiagnostics=m={}));var E;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let b=null;function L(){return b||(b=C.$be.alloc(0)),b}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,u){if(r===0)return L();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const g=this.a[0];return u&&(this.a.shift(),this.b-=r),g}if(this.a[0].byteLength>r){const g=this.a[0].slice(0,r);return u&&(this.a[0]=this.a[0].slice(r),this.b-=r),g}const I=C.$be.alloc(r);let S=0,$=0;for(;r>0;){const g=this.a[$];if(g.byteLength>r){const w=g.slice(0,r);I.set(w,S),S+=r,u&&(this.a[$]=g.slice(r),this.b-=r),r-=r}else I.set(g,S),S+=g.byteLength,u?(this.a.shift(),this.b-=g.byteLength):$++,r-=g.byteLength}return I}}e.$zh=P;var v;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(v||(v={}));function y(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class p{constructor(r,u,I,S){this.type=r,this.id=u,this.ack=I,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends d.$Sc{constructor(r){super(),this.f=this.B(new T.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const I=this.g.messageType,S=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new p(I,S,$,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=C.$be.alloc(13);u.writeUInt8(r.type,0),u.writeUInt32BE(r.id,1),u.writeUInt32BE(r.ack,5),u.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(u,r.data)}g(r,u){const I=this.f===0;return this.d.push(r,u),this.f+=r.byteLength+u.byteLength,I}h(){const r=C.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,u){this.g(r,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class a extends d.$Sc{constructor(r){super(),this.f=new T.$Nd,this.onMessage=this.f.event,this.g=new T.$Nd,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new s(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new p(1,0,0,r))}}e.$Ah=a;class o extends R.$uh{static fromSocket(r,u){return new o(new a(r),u)}get onDidDispose(){return this.b.onDidDispose}constructor(r,u,I=null){super(r,u,I),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$Bh=o;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$Ch=f;class l{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,u=this.a;for(;u;)u=u.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let u=0,I=this.a;for(;I;)r[u++]=I.data,I=I.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const u=new l(r);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const r=Date.now();for(let u=0;u<i.a;u++)this.c[u]=r-1e3*u;setInterval(()=>{for(let u=i.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),u=(1+i.a)*1e3;let I=0;for(let S=0;S<i.a;S++)r-this.c[S]<=u&&I++;return 1-I/i.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new f,this.onControlMessage=this.u.event,this.v=new f,this.onMessage=this.v.event,this.w=new f,this.onDidDispose=this.w.event,this.x=new f,this.onSocketClose=this.x.event,this.y=new f,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??i.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new d.$Rc,this.o=r.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new p(5,0,0,L());this.p.write(r),this.p.flush()}sendPause(){const r=new p(7,0,0,L());this.p.write(r)}sendResume(){const r=new p(8,0,0,L());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,u){this.a=!0,this.r.dispose(),this.r=new d.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(I=>this.z(I))),this.r.add(this.o.onClose(I=>this.x.fire(I))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new p(3,0,this.h,L());this.p.write(r);const u=this.b.toArray();for(let I=0,S=u.length;I<S;I++)this.p.write(u[I]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const u=this.b.peek();if(u&&u.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new p(6,0,0,L())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let I=0,S=u.length;I<S;I++)this.p.write(u[I]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const u=++this.c;this.h=this.g;const I=new p(1,u,this.h,r);this.b.push(I),this.a||(this.p.write(I),this.B())}sendControl(r){const u=new p(2,0,0,r);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),u=Date.now()-r.writtenTime,I=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(u>=2e4&&I>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:I});return}const $=Math.max(2e4-u,2e4-I,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new p(3,0,this.h,L());this.p.write(r)}D(){this.h=this.g;const r=new p(9,0,this.h,L());this.p.write(r)}}e.$Dh=c}),define(De[183],Ce([1,0,49,8,22,21,181,9,4,3,24,101,98,81]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0;class k extends y.$rh{constructor(s){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",a=>d.$be.wrap(Buffer.from(a,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$2p=k;class p{constructor(s,a){this.i=s,this.j=a,this.c=new Set,this.g=new Map,this.h=new E.$Nd,this.onDidProcessExit=this.h.event;const o=a&&a.timeout?a.timeout:6e4;this.b=new T.$Qg(o),this.d=null,this.f=null}getChannel(s){const a=this;return{call(o,f,l){return a.k(s,o,f,l)},listen(o,f){return a.l(s,o,f)}}}k(s,a,o,f=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(m.$6());this.b.cancel();const l=this.n(s),t=(0,T.$Hg)(n=>l.call(a,o,n)),i=f.onCancellationRequested(()=>t.cancel()),c=(0,b.$Qc)(()=>t.cancel());return this.c.add(c),t.finally(()=>{i.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,a,o){if(!this.b)return E.Event.None;this.b.cancel();let f;const l=new E.$Nd({onWillAddFirstListener:()=>{f=this.n(s).listen(a,o)(l.fire,l),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,L.$7m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,v.$Al)(a.env),this.d=(0,C.fork)(this.i,s,a);const o=new E.$Nd;E.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.$Xp)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}o.fire(d.$be.wrap(Buffer.from(r,"base64")))});const l=this.j.useQueue?(0,P.$Cl)(this.d):this.d,t=r=>this.d&&this.d.connected&&l.send(r.buffer.toString("base64")),i=o.event,c={send:t,onMessage:i};this.f=new y.$sh(c);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,u)=>{process.removeListener("exit",n),this.c.forEach(I=>(0,b.$Nc)(I)),this.c.clear(),r!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:u})})}return this.f}n(s){let a=this.g.get(s);return a||(a=this.m.getChannel(s),this.g.set(s,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$3p=p}),define(De[184],Ce([1,0,8,4,3,62,17]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.StorageState=e.$1o=e.StorageHint=void 0;var m;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(m||(e.StorageHint=m={}));function E(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$1o=E;var b;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(b||(e.StorageState=b={}));class L extends d.$Sc{static{this.a=100}constructor(y,k=Object.create(null)){super(),this.r=y,this.s=k,this.b=this.B(new T.$Qd),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=this.B(new C.$Rg(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((k,p)=>this.w(p,k)),y.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(y,k){if(this.c===b.Closed)return;let p=!1;(0,A.$Hf)(k)?p=this.f.delete(y):this.f.get(y)!==k&&(this.f.set(y,k),p=!0),p&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.s.hint!==m.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,k){const p=this.f.get(y);return(0,A.$Hf)(p)?k:p}getBoolean(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:p==="true"}getNumber(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:parseInt(p,10)}getObject(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:(0,R.$lh)(p)}async set(y,k,p=!1){if(this.c===b.Closed)return;if((0,A.$Hf)(k))return this.delete(y,p);const h=(0,A.$Af)(k)||Array.isArray(k)?(0,R.$kh)(k):String(k);if(this.f.get(y)!==h)return this.f.set(y,h),this.j.set(y,h),this.h.delete(y),this.b.fire({key:y,external:p}),this.D()}async delete(y,k=!1){if(!(this.c===b.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:k}),this.D()}async optimize(){if(this.c!==b.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=b.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===m.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===m.STORAGE_IN_MEMORY}}e.$2o=L;class P{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((k,p)=>this.a.set(p,k)),y.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$3o=P}),define(De[185],Ce([1,0,36,16]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tE=void 0;function d(R,A,m,E,b,L){if(Array.isArray(R)){let P=0;for(const v of R){const y=d(v,A,m,E,b,L);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof R=="string")return E?R==="*"?5:R===m?10:0:0;if(R){const{language:P,pattern:v,scheme:y,hasAccessToAllModels:k,notebookType:p}=R;if(!E&&!k)return 0;p&&b&&(A=b);let h=0;if(y)if(y===A.scheme)h=10;else if(y==="*")h=5;else return 0;if(P)if(P===m)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(p)if(p===L)h=10;else if(p==="*"&&L!==void 0)h=Math.max(h,5);else return 0;if(v){let s;if(typeof v=="string"?s=v:s={...v,base:(0,T.$hc)(v.base)},s===A.fsPath||(0,C.$vj)(s,A.fsPath))h=10;else return 0}return h}else return 0}}e.$tE=d}),define(De[129],Ce([1,0,22,12]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30=e.$20=void 0;var d;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(d||(d={}));function R(P){for(let v=0,y=P.length;v<y;v+=4){const k=P[v+0],p=P[v+1],h=P[v+2],s=P[v+3];P[v+0]=s,P[v+1]=h,P[v+2]=p,P[v+3]=k}}function A(P){const v=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return T.$D()||R(v),C.$be.wrap(v)}function m(P){const v=P.buffer;if(T.$D()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const y=new Uint8Array(v.byteLength);return y.set(v),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(P){const v=new Uint32Array(b(P));let y=0;if(v[y++]=P.id,P.type==="full")v[y++]=1,v[y++]=P.data.length,v.set(P.data,y),y+=P.data.length;else{v[y++]=2,v[y++]=P.deltas.length;for(const k of P.deltas)v[y++]=k.start,v[y++]=k.deleteCount,k.data?(v[y++]=k.data.length,v.set(k.data,y),y+=k.data.length):v[y++]=0}return A(v)}e.$20=E;function b(P){let v=0;if(v+=1+1,P.type==="full")v+=1+P.data.length;else{v+=1,v+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(v+=y.data.length)}return v}function L(P){const v=m(P);let y=0;const k=v[y++];if(v[y++]===1){const a=v[y++],o=v.subarray(y,y+a);return y+=a,{id:k,type:"full",data:o}}const h=v[y++],s=[];for(let a=0;a<h;a++){const o=v[y++],f=v[y++],l=v[y++];let t;l>0&&(t=v.subarray(y,y+l),y+=l),s[a]={start:o,deleteCount:f,data:t}}return{id:k,type:"delta",deltas:s}}e.$30=L}),define(De[186],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,24,12,166,124,186]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=b;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class v{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=v;function y(he,ue){if(typeof he!="object"||typeof ue!="object"||!he||!ue)return new v(ue,he!==ue);if(Array.isArray(he)||Array.isArray(ue)){const Ke=Array.isArray(he)&&Array.isArray(ue)&&C.$ub(he,ue);return new v(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Ue=y(he[Ke],ue[Ke]);Ue.didChange&&(he[Ke]=Ue.newValue,Ie=!0)}return new v(he,Ie)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return this.defaultValue}}class p{constructor(ue,Ie,Ke,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function h(he,ue){return typeof he>"u"?ue:he==="false"?!1:!!he}e.boolean=h;class s extends p{constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return h(ue,this.defaultValue)}}function a(he,ue,Ie,Ke){if(typeof he>"u")return ue;let Ue=parseInt(he,10);return isNaN(Ue)?ue:(Ue=Math.max(Ie,Ue),Ue=Math.min(Ke,Ue),Ue|0)}e.clampedInt=a;class o extends p{static clampedInt(ue,Ie,Ke,Ue){return a(ue,Ie,Ke,Ue)}constructor(ue,Ie,Ke,Ue,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ke,nt.minimum=Ue,nt.maximum=Ze),super(ue,Ie,Ke,nt),this.minimum=Ue,this.maximum=Ze}validate(ue){return o.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function f(he,ue,Ie,Ke){if(typeof he>"u")return ue;const Ue=l.float(he,ue);return l.clamp(Ue,Ie,Ke)}e.clampedFloat=f;class l extends p{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Ue,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ke),super(ue,Ie,Ke,Ze),this.validationFn=Ue}validate(ue){return this.validationFn(l.float(ue,this.defaultValue))}}class t extends p{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ke),super(ue,Ie,Ke,Ue)}validate(ue){return t.string(ue,this.defaultValue)}}function i(he,ue,Ie,Ke){return typeof he!="string"?ue:Ke&&he in Ke?Ke[he]:Ie.indexOf(he)===-1?ue:he}e.stringSet=i;class c extends p{constructor(ue,Ie,Ke,Ue,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ue,Ze.default=Ke),super(ue,Ie,Ke,Ze),this.c=Ue}validate(ue){return i(ue,this.defaultValue,this.c)}}class n extends P{constructor(ue,Ie,Ke,Ue,Ze,nt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Ze,ct.default=Ue),super(ue,Ie,Ke,ct),this.c=Ze,this.d=nt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function r(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class I extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:h(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function $(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function w(he){switch(he){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function D(he){switch(he){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class N extends k{constructor(){super(140)}compute(ue,Ie,Ke){const Ue=["monaco-editor"];return Ie.get(39)&&Ue.push(Ie.get(39)),ue.extraEditorClassName&&Ue.push(ue.extraEditorClassName),Ie.get(73)==="default"?Ue.push("mouse-default"):Ie.get(73)==="copy"&&Ue.push("mouse-copy"),Ie.get(110)&&Ue.push("showUnused"),Ie.get(138)&&Ue.push("showDeprecated"),Ue.join(" ")}}class M extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class F extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:m.localize(16,null),included:d.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:m.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:h(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":i(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":i(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(Ie.loop,this.defaultValue.loop)}}}class U extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?U.OFF:ue==="true"?U.ON:ue:ue?U.ON:U.OFF}}e.EditorFontLigatures=U;class j extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.TRANSLATE:ue:ue?j.TRANSLATE:j.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class O extends k{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class q extends p{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(ue){const Ie=l.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class K extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(o.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class me extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:m.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:i(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??i(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??i(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??i(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??i(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??i(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class te extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:m.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),delay:o.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:h(Ie.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:h(Ie.above,this.defaultValue.above)}}}var G;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(G||(e.RenderMinimap=G={}));class Q extends k{constructor(){super(143)}compute(ue,Ie,Ke){return Q.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Ue=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const Ze=(Ke+ue.viewLineCount+Ue)/(ue.pixelRatio*ue.height),nt=Math.floor(ue.viewLineCount/Ze);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ue,desiredRatio:Ze,minimapLineCount:nt}}static c(ue,Ie){const Ke=ue.outerWidth,Ue=ue.outerHeight,Ze=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const nt=Ie.stableMinimapLayoutInput,ct=nt&&ue.outerHeight===nt.outerHeight&&ue.lineHeight===nt.lineHeight&&ue.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===nt.pixelRatio&&ue.scrollBeyondLastLine===nt.scrollBeyondLastLine&&ue.paddingTop===nt.paddingTop&&ue.paddingBottom===nt.paddingBottom&&ue.minimap.enabled===nt.minimap.enabled&&ue.minimap.side===nt.minimap.side&&ue.minimap.size===nt.minimap.size&&ue.minimap.showSlider===nt.minimap.showSlider&&ue.minimap.renderCharacters===nt.minimap.renderCharacters&&ue.minimap.maxColumn===nt.minimap.maxColumn&&ue.minimap.scale===nt.minimap.scale&&ue.verticalScrollbarWidth===nt.verticalScrollbarWidth&&ue.isViewportWrapping===nt.isViewportWrapping,bt=ue.lineHeight,Et=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,Ht=ue.minimap.renderCharacters;let vt=Ze>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Ut=ue.minimap.maxColumn,Nt=ue.minimap.size,Gt=ue.minimap.side,zt=ue.verticalScrollbarWidth,Dt=ue.viewLineCount,Ft=ue.remainingWidth,Bt=ue.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Ze*Ue);const qt=Wt/Ze;let Ot=!1,ut=!1,ft=Jt*vt,At=vt/Ze,Vt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Te,desiredRatio:Se,minimapLineCount:ne}=Q.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Ue,lineHeight:bt,pixelRatio:Ze});if(Dt/ne>1)Ot=!0,ut=!0,vt=1,ft=1,At=vt/Ze;else{let Ve=!1,xe=vt+1;if(Nt==="fit"){const Je=Math.ceil((Me+Dt+Te)*ft);Bt&&ct&&Ft<=Ie.stableFitRemainingWidth?(Ve=!0,xe=Ie.stableFitMaxMinimapScale):Ve=Je>Wt}if(Nt==="fill"||Ve){Ot=!0;const Je=vt;ft=Math.min(bt*Ze,Math.max(1,Math.floor(1/Se))),Bt&&ct&&Ft<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),vt=Math.min(xe,Math.max(1,Math.floor(ft/Jt))),vt>Je&&(Vt=Math.min(2,vt/Je)),At=vt/Ze/Vt,Wt=Math.ceil(Math.max(Qt,Me+Dt+Te)*ft),Bt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Ft,Ie.stableFitMaxMinimapScale=vt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Rt=Math.floor(Ut*At),at=Math.min(Rt,Math.max(0,Math.floor((Ft-zt-2)*At/(Et+At)))+e.MINIMAP_GUTTER_WIDTH);let pt=Math.floor(Ze*at);const Tt=pt/Ze;pt=Math.floor(pt*Vt);const Pt=Ht?1:2,Ge=Gt==="left"?0:Ke-at-zt;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:at,minimapHeightIsEditorHeight:Ot,minimapIsSampling:ut,minimapScale:vt,minimapLineHeight:ft,minimapCanvasInnerWidth:pt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:qt}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Ue=Ie.outerHeight|0,Ze=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ct=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ue.get(135),vt=Ht==="inherit"?ue.get(134):Ht,Ut=vt==="inherit"?ue.get(130):vt,Nt=ue.get(133),Gt=Ie.isDominatedByLongLines,zt=ue.get(57),Dt=ue.get(67).renderType!==0,Ft=ue.get(68),Bt=ue.get(104),Jt=ue.get(83),Wt=ue.get(72),qt=ue.get(102),Ot=qt.verticalScrollbarSize,ut=qt.verticalHasArrows,ft=qt.arrowSize,At=qt.horizontalScrollbarSize,Vt=ue.get(43),Rt=ue.get(109)!=="never";let at=ue.get(65);Vt&&Rt&&(at+=16);let pt=0;if(Dt){const kt=Math.max(nt,Ft);pt=Math.round(kt*bt)}let Tt=0;zt&&(Tt=Ze*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Tt,Qt=Ge+pt,Me=Qt+at;const Te=Ke-Tt-pt-at;let Se=!1,ne=!1,Fe=-1;vt==="inherit"&&Gt?(Se=!0,ne=!0):Ut==="on"||Ut==="bounded"?ne=!0:Ut==="wordWrapColumn"&&(Fe=Nt);const Ve=Q.c({outerWidth:Ke,outerHeight:Ue,lineHeight:Ze,typicalHalfwidthCharacterWidth:ct,pixelRatio:Et,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Ot,viewLineCount:Kt,remainingWidth:Te,isViewportWrapping:ne},Ie.memory||new L);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Pt+=Ve.minimapWidth,Ge+=Ve.minimapWidth,Qt+=Ve.minimapWidth,Me+=Ve.minimapWidth);const xe=Te-Ve.minimapWidth,Je=Math.max(1,Math.floor((xe-Ot-2)/ct)),rt=ut?ft:0;return ne&&(Fe=Math.max(1,Je),Ut==="bounded"&&(Fe=Math.min(Fe,Nt))),{width:Ke,height:Ue,glyphMarginLeft:Pt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:pt,decorationsLeft:Qt,decorationsWidth:at,contentLeft:Me,contentWidth:xe,minimap:Ve,viewportColumn:Je,isWordWrapMinified:Se,isViewportWrapping:ne,wrappingColumn:Fe,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:At,overviewRuler:{top:rt,width:Ot,height:Ue-2*rt,right:0}}}}e.EditorLayoutInfoComputer=Q;class le extends P{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(ue){return i(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class ie extends P{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:m.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:h(ue.enabled,this.defaultValue.enabled)}}}class ce extends P{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:m.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:i(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:h(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ye extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:m.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:i(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:h(Ie.padding,this.defaultValue.padding)}}}class H extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):o.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?o.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class B extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>l.clamp(ue,0,150),{markdownDescription:m.localize(63,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class X extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:ue.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:m.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),autohide:h(Ie.autohide,this.defaultValue.autohide),size:i(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(Ie.side,this.defaultValue.side,["right","left"]),showSlider:i(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(Ie.scale,1,1,3),maxColumn:o.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(he){return he==="ctrlCmd"?d.$k?"metaKey":"ctrlKey":"altKey"}class Y extends P{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:o.clampedInt(Ie.top,0,0,1e3),bottom:o.clampedInt(Ie.bottom,0,0,1e3)}}}class _ extends P{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:m.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),cycle:h(Ie.cycle,this.defaultValue.cycle)}}}class x extends k{constructor(){super(141)}compute(ue,Ie,Ke){return ue.pixelRatio}}class ve extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:m.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:m.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:m.localize(84,null)}},default:ue,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Et=ue?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ue}=ue,Ze=["on","inline","off"];let nt,ct,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=i(Ie,this.defaultValue.other,Ze),typeof Ke=="boolean"?ct=Ke?"on":"off":ct=i(Ke,this.defaultValue.comments,Ze),typeof Ue=="boolean"?bt=Ue?"on":"off":bt=i(Ue,this.defaultValue.strings,Ze),{other:nt,comments:ct,strings:bt}}}var ae;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(ae||(e.RenderLineNumbersType=ae={}));class fe extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function ee(he){const ue=he.get(97);return ue==="editable"?he.get(90):ue!=="on"}e.filterValidationDecorations=ee;class de extends P{constructor(){const ue=[],Ie={type:"number",description:m.localize(91,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:ue,description:m.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:o.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ue=Ke;Ie.push({column:o.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((Ke,Ue)=>Ke.column-Ue.column),Ie}return this.defaultValue}}class be extends P{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(he,ue){if(typeof he!="string")return ue;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:m.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:m.localize(105,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=o.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=o.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:h(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:o.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:o.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:h(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:h(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:m.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:m.localize(112,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(T.$$m(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(T.$$m(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Ue=super.applyUpdate(ue,Ie);return Ke?new v(Ue.newValue,!0):Ue}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Ue,Ze]of Object.entries(ue))Ze===!0&&(Ke[Ue]=!0);return Ke}}class se extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:m.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(114,null),m.localize(115,null)],description:m.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:m.localize(117,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),mode:i(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:h(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:h(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const ue={enabled:R.$3r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$3r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:m.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:m.localize(119,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(120,null),m.localize(121,null),m.localize(122,null)],default:ue.bracketPairs,description:m.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],default:ue.bracketPairsHorizontal,description:m.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:m.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:m.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(130,null),m.localize(131,null),m.localize(132,null)],default:ue.highlightActiveIndentation,description:m.localize(133,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(he,ue,Ie){const Ke=Ie.indexOf(he);return Ke===-1?ue:Ie[Ke]}class Ee extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(134,null),m.localize(135,null)],default:ue.insertMode,description:m.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:m.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:m.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:m.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(140,null),m.localize(141,null),m.localize(142,null),m.localize(143,null)],default:ue.selectionMode,markdownDescription:m.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:m.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:m.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:m.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:m.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:m.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:i(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:h(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:h(Ie.preview,this.defaultValue.preview),previewMode:i(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(Ie.showMethods,this.defaultValue.showMethods),showFunctions:h(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:h(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(Ie.showFields,this.defaultValue.showFields),showVariables:h(Ie.showVariables,this.defaultValue.showVariables),showClasses:h(Ie.showClasses,this.defaultValue.showClasses),showStructs:h(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:h(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:h(Ie.showModules,this.defaultValue.showModules),showProperties:h(Ie.showProperties,this.defaultValue.showProperties),showEvents:h(Ie.showEvents,this.defaultValue.showEvents),showOperators:h(Ie.showOperators,this.defaultValue.showOperators),showUnits:h(Ie.showUnits,this.defaultValue.showUnits),showValues:h(Ie.showValues,this.defaultValue.showValues),showConstants:h(Ie.showConstants,this.defaultValue.showConstants),showEnums:h(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:h(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(Ie.showKeywords,this.defaultValue.showKeywords),showWords:h(Ie.showWords,this.defaultValue.showWords),showColors:h(Ie.showColors,this.defaultValue.showColors),showFiles:h(Ie.showFiles,this.defaultValue.showFiles),showReferences:h(Ie.showReferences,this.defaultValue.showReferences),showFolders:h(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:h(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:h(Ie.showUsers,this.defaultValue.showUsers),showIssues:h(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends P{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(183,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:h(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends P{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(184,null),m.localize(185,null),m.localize(186,null),m.localize(187,null)],description:m.localize(188,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Xe extends k{constructor(){super(144)}compute(ue,Ie,Ke){const Ue=Ie.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:m.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(191,null),m.localize(192,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),showDropSelector:i(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:m.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(195,null),m.localize(196,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:h(Ie.enabled,this.defaultValue.enabled),showPasteSelector:i(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.$k?Ne:d.$l?qe:Ae,fontWeight:"normal",fontSize:d.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(he){return e.editorOptionsRegistry[he.id]=he,he}var Ye;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.occurrencesHighlight=80]="occurrencesHighlight",he[he.overviewRulerBorder=81]="overviewRulerBorder",he[he.overviewRulerLanes=82]="overviewRulerLanes",he[he.padding=83]="padding",he[he.pasteAs=84]="pasteAs",he[he.parameterHints=85]="parameterHints",he[he.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",he[he.quickSuggestions=88]="quickSuggestions",he[he.quickSuggestionsDelay=89]="quickSuggestionsDelay",he[he.readOnly=90]="readOnly",he[he.readOnlyMessage=91]="readOnlyMessage",he[he.renameOnType=92]="renameOnType",he[he.renderControlCharacters=93]="renderControlCharacters",he[he.renderFinalNewline=94]="renderFinalNewline",he[he.renderLineHighlight=95]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=97]="renderValidationDecorations",he[he.renderWhitespace=98]="renderWhitespace",he[he.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",he[he.roundedSelection=100]="roundedSelection",he[he.rulers=101]="rulers",he[he.scrollbar=102]="scrollbar",he[he.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=104]="scrollBeyondLastLine",he[he.scrollPredominantAxis=105]="scrollPredominantAxis",he[he.selectionClipboard=106]="selectionClipboard",he[he.selectionHighlight=107]="selectionHighlight",he[he.selectOnLineNumbers=108]="selectOnLineNumbers",he[he.showFoldingControls=109]="showFoldingControls",he[he.showUnused=110]="showUnused",he[he.snippetSuggestions=111]="snippetSuggestions",he[he.smartSelect=112]="smartSelect",he[he.smoothScrolling=113]="smoothScrolling",he[he.stickyScroll=114]="stickyScroll",he[he.stickyTabStops=115]="stickyTabStops",he[he.stopRenderingLineAfter=116]="stopRenderingLineAfter",he[he.suggest=117]="suggest",he[he.suggestFontSize=118]="suggestFontSize",he[he.suggestLineHeight=119]="suggestLineHeight",he[he.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",he[he.suggestSelection=121]="suggestSelection",he[he.tabCompletion=122]="tabCompletion",he[he.tabIndex=123]="tabIndex",he[he.unicodeHighlighting=124]="unicodeHighlighting",he[he.unusualLineTerminators=125]="unusualLineTerminators",he[he.useShadowDOM=126]="useShadowDOM",he[he.useTabStops=127]="useTabStops",he[he.wordBreak=128]="wordBreak",he[he.wordSeparators=129]="wordSeparators",he[he.wordWrap=130]="wordWrap",he[he.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=133]="wordWrapColumn",he[he.wordWrapOverride1=134]="wordWrapOverride1",he[he.wordWrapOverride2=135]="wordWrapOverride2",he[he.wrappingIndent=136]="wrappingIndent",he[he.wrappingStrategy=137]="wrappingStrategy",he[he.showDeprecated=138]="showDeprecated",he[he.inlayHints=139]="inlayHints",he[he.editorClassName=140]="editorClassName",he[he.pixelRatio=141]="pixelRatio",he[he.tabFocusMode=142]="tabFocusMode",he[he.layoutInfo=143]="layoutInfo",he[he.wrappingInfo=144]="wrappingInfo",he[he.defaultColorDecorators=145]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(197,null)})),acceptSuggestionOnEnter:Le(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(198,null),""],markdownDescription:m.localize(199,null)})),accessibilitySupport:Le(new u),accessibilityPageSize:Le(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(200,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",m.localize(201,null))),ariaRequired:Le(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Le(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(203,null),m.localize(204,null),""],description:m.localize(205,null)})),autoClosingComments:Le(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(206,null),m.localize(207,null),""],description:m.localize(208,null)})),autoClosingDelete:Le(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(209,null),""],description:m.localize(210,null)})),autoClosingOvertype:Le(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(211,null),""],description:m.localize(212,null)})),autoClosingQuotes:Le(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(213,null),m.localize(214,null),""],description:m.localize(215,null)})),autoIndent:Le(new n(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[m.localize(216,null),m.localize(217,null),m.localize(218,null),m.localize(219,null),m.localize(220,null)],description:m.localize(221,null)})),automaticLayout:Le(new s(13,"automaticLayout",!1)),autoSurround:Le(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(222,null),m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),bracketPairColorization:Le(new oe),bracketPairGuides:Le(new Z),stickyTabStops:Le(new s(115,"stickyTabStops",!1,{description:m.localize(226,null)})),codeLens:Le(new s(17,"codeLens",!0,{description:m.localize(227,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:m.localize(228,null)})),codeLensFontSize:Le(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(229,null)})),colorDecorators:Le(new s(20,"colorDecorators",!0,{description:m.localize(230,null)})),colorDecoratorActivatedOn:Le(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(231,null),m.localize(232,null),m.localize(233,null)],description:m.localize(234,null)})),colorDecoratorsLimit:Le(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(235,null)})),columnSelection:Le(new s(22,"columnSelection",!1,{description:m.localize(236,null)})),comments:Le(new I),contextmenu:Le(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(237,null)})),cursorBlinking:Le(new n(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:m.localize(238,null)})),cursorSmoothCaretAnimation:Le(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null)],description:m.localize(242,null)})),cursorStyle:Le(new n(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:m.localize(243,null)})),cursorSurroundingLines:Le(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(244,null)})),cursorSurroundingLinesStyle:Le(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(245,null),m.localize(246,null)],markdownDescription:m.localize(247,null)})),cursorWidth:Le(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(248,null)})),disableLayerHinting:Le(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new s(34,"domReadOnly",!1)),dragAndDrop:Le(new s(35,"dragAndDrop",!0,{description:m.localize(249,null)})),emptySelectionClipboard:Le(new M),dropIntoEditor:Le(new it),stickyScroll:Le(new ce),experimentalWhitespaceRendering:Le(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(250,null),m.localize(251,null),m.localize(252,null)],description:m.localize(253,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new l(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:m.localize(254,null)})),find:Le(new F),fixedOverflowWidgets:Le(new s(42,"fixedOverflowWidgets",!1)),folding:Le(new s(43,"folding",!0,{description:m.localize(255,null)})),foldingStrategy:Le(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),foldingHighlight:Le(new s(45,"foldingHighlight",!0,{description:m.localize(259,null)})),foldingImportsByDefault:Le(new s(46,"foldingImportsByDefault",!1,{description:m.localize(260,null)})),foldingMaximumRegions:Le(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(261,null)})),unfoldOnClickAfterEndOfLine:Le(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(262,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(263,null)})),fontInfo:Le(new O),fontLigatures2:Le(new U),fontSize:Le(new q),fontWeight:Le(new K),fontVariations:Le(new j),formatOnPaste:Le(new s(55,"formatOnPaste",!1,{description:m.localize(264,null)})),formatOnType:Le(new s(56,"formatOnType",!1,{description:m.localize(265,null)})),glyphMargin:Le(new s(57,"glyphMargin",!0,{description:m.localize(266,null)})),gotoLocation:Le(new me),hideCursorInOverviewRuler:Le(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(267,null)})),hover:Le(new te),inDiffEditor:Le(new s(61,"inDiffEditor",!1)),letterSpacing:Le(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>l.clamp(he,-5,20),{description:m.localize(268,null)})),lightbulb:Le(new ie),lineDecorationsWidth:Le(new H),lineHeight:Le(new B),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new s(69,"linkedEditing",!1,{description:m.localize(269,null)})),links:Le(new s(70,"links",!0,{description:m.localize(270,null)})),matchBrackets:Le(new c(71,"matchBrackets","always",["always","near","never"],{description:m.localize(271,null)})),minimap:Le(new X),mouseStyle:Le(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new l(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:m.localize(272,null)})),mouseWheelZoom:Le(new s(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(273,null)})),multiCursorMergeOverlapping:Le(new s(76,"multiCursorMergeOverlapping",!0,{description:m.localize(274,null)})),multiCursorModifier:Le(new n(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[m.localize(275,null),m.localize(276,null)],markdownDescription:m.localize(277,null)})),multiCursorPaste:Le(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(278,null),m.localize(279,null)],markdownDescription:m.localize(280,null)})),multiCursorLimit:Le(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(281,null)})),occurrencesHighlight:Le(new s(80,"occurrencesHighlight",!0,{description:m.localize(282,null)})),overviewRulerBorder:Le(new s(81,"overviewRulerBorder",!0,{description:m.localize(283,null)})),overviewRulerLanes:Le(new o(82,"overviewRulerLanes",3,0,3)),padding:Le(new Y),pasteAs:Le(new tt),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(284,null),m.localize(285,null)],description:m.localize(286,null)})),definitionLinkOpensInPeek:Le(new s(87,"definitionLinkOpensInPeek",!1,{description:m.localize(287,null)})),quickSuggestions:Le(new ve),quickSuggestionsDelay:Le(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(288,null)})),readOnly:Le(new s(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new s(92,"renameOnType",!1,{description:m.localize(289,null),markdownDeprecationMessage:m.localize(290,null)})),renderControlCharacters:Le(new s(93,"renderControlCharacters",!0,{description:m.localize(291,null),restricted:!0})),renderFinalNewline:Le(new c(94,"renderFinalNewline",d.$l?"dimmed":"on",["off","on","dimmed"],{description:m.localize(292,null)})),renderLineHighlight:Le(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(293,null)],description:m.localize(294,null)})),renderLineHighlightOnlyWhenFocus:Le(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(295,null)})),renderValidationDecorations:Le(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(296,null),m.localize(297,null),m.localize(298,null),""],description:m.localize(299,null)})),revealHorizontalRightPadding:Le(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new s(100,"roundedSelection",!0,{description:m.localize(300,null)})),rulers:Le(new de),scrollbar:Le(new z),scrollBeyondLastColumn:Le(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(301,null)})),scrollBeyondLastLine:Le(new s(104,"scrollBeyondLastLine",!0,{description:m.localize(302,null)})),scrollPredominantAxis:Le(new s(105,"scrollPredominantAxis",!0,{description:m.localize(303,null)})),selectionClipboard:Le(new s(106,"selectionClipboard",!0,{description:m.localize(304,null),included:d.$l})),selectionHighlight:Le(new s(107,"selectionHighlight",!0,{description:m.localize(305,null)})),selectOnLineNumbers:Le(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(306,null),m.localize(307,null),m.localize(308,null)],description:m.localize(309,null)})),showUnused:Le(new s(110,"showUnused",!0,{description:m.localize(310,null)})),showDeprecated:Le(new s(138,"showDeprecated",!0,{description:m.localize(311,null)})),inlayHints:Le(new ye),snippetSuggestions:Le(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(312,null),m.localize(313,null),m.localize(314,null),m.localize(315,null)],description:m.localize(316,null)})),smartSelect:Le(new je),smoothScrolling:Le(new s(113,"smoothScrolling",!1,{description:m.localize(317,null)})),stopRenderingLineAfter:Le(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ee),inlineSuggest:Le(new se),inlineCompletionsAccessibilityVerbose:Le(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(318,null)})),suggestFontSize:Le(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(319,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(320,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new s(120,"suggestOnTriggerCharacters",!0,{description:m.localize(321,null)})),suggestSelection:Le(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),tabCompletion:Le(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(326,null),m.localize(327,null),m.localize(328,null)],description:m.localize(329,null)})),tabIndex:Le(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new J),unusualLineTerminators:Le(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),useShadowDOM:Le(new s(126,"useShadowDOM",!0)),useTabStops:Le(new s(127,"useTabStops",!0,{description:m.localize(334,null)})),wordBreak:Le(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$4r,{description:m.localize(338,null)})),wordWrap:Le(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(339,null),m.localize(340,null),m.localize(341,null),m.localize(342,null)],description:m.localize(343,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(344,null)})),wordWrapOverride1:Le(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new s(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(345,null)})),pixelRatio:Le(new x),tabFocusMode:Le(new s(142,"tabFocusMode",!1,{markdownDescription:m.localize(346,null)})),layoutInfo:Le(new Q),wrappingInfo:Le(new Xe),wrappingIndent:Le(new _e),wrappingStrategy:Le(new le)}}),define(De[187],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[83],Ce([1,0,79,2,164,32,174,187]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$kt=e.$jt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$it=e.$ht=e.SymbolKinds=e.SymbolTag=e.$gt=e.$ft=e.SymbolKind=e.$et=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$dt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ct=e.$bt=e.$at=void 0;class E{constructor(U,j,O){this.offset=U,this.type=j,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$at=E;class b{constructor(U,j){this.tokens=U,this.endState=j,this._tokenizationResultBrand=void 0}}e.$bt=b;class L{constructor(U,j){this.tokens=U,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$ct=L;var P;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var v;(function(F){const U=new Map;U.set(0,C.$Uj.symbolMethod),U.set(1,C.$Uj.symbolFunction),U.set(2,C.$Uj.symbolConstructor),U.set(3,C.$Uj.symbolField),U.set(4,C.$Uj.symbolVariable),U.set(5,C.$Uj.symbolClass),U.set(6,C.$Uj.symbolStruct),U.set(7,C.$Uj.symbolInterface),U.set(8,C.$Uj.symbolModule),U.set(9,C.$Uj.symbolProperty),U.set(10,C.$Uj.symbolEvent),U.set(11,C.$Uj.symbolOperator),U.set(12,C.$Uj.symbolUnit),U.set(13,C.$Uj.symbolValue),U.set(15,C.$Uj.symbolEnum),U.set(14,C.$Uj.symbolConstant),U.set(15,C.$Uj.symbolEnum),U.set(16,C.$Uj.symbolEnumMember),U.set(17,C.$Uj.symbolKeyword),U.set(27,C.$Uj.symbolSnippet),U.set(18,C.$Uj.symbolText),U.set(19,C.$Uj.symbolColor),U.set(20,C.$Uj.symbolFile),U.set(21,C.$Uj.symbolReference),U.set(22,C.$Uj.symbolCustomColor),U.set(23,C.$Uj.symbolFolder),U.set(24,C.$Uj.symbolTypeParameter),U.set(25,C.$Uj.account),U.set(26,C.$Uj.issues);function j(K){let me=U.get(K);return me||(console.info("No codicon found for CompletionItemKind "+K),me=C.$Uj.symbolProperty),me}F.toIcon=j;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function q(K,me){let te=O.get(K);return typeof te>"u"&&!me&&(te=9),te}F.fromString=q})(v||(e.CompletionItemKinds=v={}));var y;(function(F){F[F.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var k;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var p;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var h;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(h||(e.InlineCompletionTriggerKind=h={}));class s{constructor(U,j,O,q){this.range=U,this.text=j,this.completionKind=O,this.isSnippetText=q}equals(U){return R.$ts.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}e.$dt=s;var a;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var o;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var f;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(f||(e.DocumentHighlightKind=f={}));function l(F){return F&&T.URI.isUri(F.uri)&&R.$ts.isIRange(F.range)&&(R.$ts.isIRange(F.originSelectionRange)||R.$ts.isIRange(F.targetSelectionRange))}e.$et=l;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$ft={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function i(F,U){return(0,m.localize)(26,null,F,e.$ft[U])}e.$gt=i;var c;(function(F){F[F.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var n;(function(F){const U=new Map;U.set(0,C.$Uj.symbolFile),U.set(1,C.$Uj.symbolModule),U.set(2,C.$Uj.symbolNamespace),U.set(3,C.$Uj.symbolPackage),U.set(4,C.$Uj.symbolClass),U.set(5,C.$Uj.symbolMethod),U.set(6,C.$Uj.symbolProperty),U.set(7,C.$Uj.symbolField),U.set(8,C.$Uj.symbolConstructor),U.set(9,C.$Uj.symbolEnum),U.set(10,C.$Uj.symbolInterface),U.set(11,C.$Uj.symbolFunction),U.set(12,C.$Uj.symbolVariable),U.set(13,C.$Uj.symbolConstant),U.set(14,C.$Uj.symbolString),U.set(15,C.$Uj.symbolNumber),U.set(16,C.$Uj.symbolBoolean),U.set(17,C.$Uj.symbolArray),U.set(18,C.$Uj.symbolObject),U.set(19,C.$Uj.symbolKey),U.set(20,C.$Uj.symbolNull),U.set(21,C.$Uj.symbolEnumMember),U.set(22,C.$Uj.symbolStruct),U.set(23,C.$Uj.symbolEvent),U.set(24,C.$Uj.symbolOperator),U.set(25,C.$Uj.symbolTypeParameter);function j(O){let q=U.get(O);return q||(console.info("No codicon found for SymbolKind "+O),q=C.$Uj.symbolProperty),q}F.toIcon=j})(n||(e.SymbolKinds=n={}));class r{static asEditOperation(U){return d.$us.replace(R.$ts.lift(U.range),U.text)}}e.$ht=r;class u{static{this.Comment=new u("comment")}static{this.Imports=new u("imports")}static{this.Region=new u("region")}static fromValue(U){switch(U){case"comment":return u.Comment;case"imports":return u.Imports;case"region":return u.Region}return new u(U)}constructor(U){this.value=U}}e.$it=u;var I;(function(F){function U(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}F.is=U})(I||(e.Command=I={}));var S;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var $;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var g;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(g||(e.CommentMode=g={}));var w;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(w||(e.CommentState=w={}));var D;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(D||(e.InlayHintKind=D={}));class N{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$jt=N,e.$kt=new A.$5s;var M;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(M||(e.ExternalUriOpenerPriority=M={}))}),define(De[188],Ce([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(De[204],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[205],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[206],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[207],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[208],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[209],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[210],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[211],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[212],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[213],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[214],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[215],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[216],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[217],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[218],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[219],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[220],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[221],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[222],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[223],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[224],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[225],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[226],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[227],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[228],Ce([1,0,9,190]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var d;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(d||(e.TokenType=d={}));function R(...b){switch(b.length){case 1:return(0,T.localize)(0,null,b[0]);case 2:return(0,T.localize)(1,null,b[0],b[1]);case 3:return(0,T.localize)(2,null,b[0],b[1],b[2]);default:return}}const A=(0,T.localize)(3,null),m=(0,T.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const P=this.d,v=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:v};this.g.push({offset:P,lexeme:v,additionalInfo:L}),this.f.push(y)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const P=this.c.substring(this.d,this.e),v=E.b.get(P);v?this.k(v):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,P=!1,v=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(m);return}const k=this.c.charCodeAt(L);if(P)P=!1;else if(k===47&&!v){L++;break}else k===91?v=!0:k===92?P=!0:k===93&&(v=!1);L++}for(;L<this.c.length&&E.a.has(this.c.charCodeAt(L));)L++;this.e=L;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=E}),define(De[229],Ce([1,0,23,38,193,375]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||A.test(s)}e.$Lo=E;function b(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=s.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Mo=b;function L(s){if(!s)return null;const a=s.majorBase,o=s.majorMustEqual,f=s.minorBase;let l=s.minorMustEqual;const t=s.patchBase;let i=s.patchMustEqual;s.hasCaret&&(a===0||(l=!1),i=!1);let c=0;if(s.preRelease){const n=m.exec(s.preRelease);if(n){const[,r,u,I]=n;c=Date.UTC(Number(r),Number(u)-1,Number(I))}}return{majorBase:a,majorMustEqual:o,minorBase:f,minorMustEqual:l,patchBase:t,patchMustEqual:i,isMinimum:s.hasGreaterEquals,notBefore:c}}e.$No=L;function P(s,a,o){let f;typeof s=="string"?f=L(b(s)):f=s;let l;a instanceof Date?l=a.getTime():typeof a=="string"&&(l=new Date(a).getTime());let t;if(typeof o=="string"?t=L(b(o)):t=o,!f||!t)return!1;const i=f.majorBase,c=f.minorBase,n=f.patchBase;let r=t.majorBase,u=t.minorBase,I=t.patchBase;const S=t.notBefore;let $=t.majorMustEqual,g=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?i>r?!0:i<r?!1:c>u?!0:c<u||l&&l<S?!1:n>=I:(i===1&&r===0&&(!$||!g||!w)&&(r=1,u=0,I=0,$=!0,g=!1,w=!1),i<r?!1:i>r?!$:c<u?!1:c>u?!g:n<I?!1:n>I?!w:!(l&&l<S))}e.$Oo=P;function v(s,a,o,f,l){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([T.default.Error,d.localize(0,null)]),t;if(typeof f.name!="string")return t.push([T.default.Error,d.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([T.default.Error,d.localize(2,null,"version")]),t;if(!f.engines)return t.push([T.default.Error,d.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([T.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!h(f.extensionDependencies))return t.push([T.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!h(f.activationEvents))return t.push([T.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([T.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([T.default.Warning,d.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([T.default.Error,d.localize(9,null,"main")]),t;{const n=(0,C.$vg)(o,f.main);(0,C.$pg)(n,o)||t.push([T.default.Warning,d.localize(10,null,n.path,o.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([T.default.Error,d.localize(11,null,"browser")]),t;{const n=(0,C.$vg)(o,f.browser);(0,C.$pg)(n,o)||t.push([T.default.Warning,d.localize(12,null,n.path,o.path)])}}if(!R.valid(f.version))return t.push([T.default.Error,d.localize(13,null)]),t;const i=[];if(!y(s,a,f,l,i))for(const n of i)t.push([T.default.Error,n]);return t}e.$Po=v;function y(s,a,o,f,l){return f||typeof o.main>"u"&&typeof o.browser>"u"?!0:p(s,a,o.engines.vscode,l)}e.$Qo=y;function k(s,a,o){return s==="*"||p(a,o,s)}e.$Ro=k;function p(s,a,o,f=[]){const l=L(b(o));if(!l)return f.push(d.localize(14,null,o)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return f.push(d.localize(15,null,o)),!1}else if(!l.majorMustEqual)return f.push(d.localize(16,null,o)),!1;return P(s,a,l)?!0:(f.push(d.localize(17,null,s,o)),!1)}function h(s){if(!Array.isArray(s))return!1;for(let a=0,o=s.length;a<o;a++)if(typeof s[a]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class C{constructor(d,R=[],A=!1){this.ctor=d,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.$Mh=C}),define(De[103],Ce([1,0,102]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.InstantiationType=void 0;const T=[];var d;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function R(m,E,b){E instanceof C.$Mh||(E=new C.$Mh(E,[],!!b)),T.push([m,E])}e.$wr=R;function A(){return T}e.$xr=A}),define(De[230],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class C{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$bq=C;class T{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const m=this.lookupOrInsertNode(R),E=this.lookupOrInsertNode(A);m.outgoing.set(E.key,E),E.incoming.set(m.key,m)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let m=this.a.get(A);return m||(m=new C(A,R),this.a.set(A,m)),m}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,m]of this.a)R.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const m=new Set([R]),E=this.c(A,m);if(E)return E}}c(R,A){for(const[m,E]of R.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const b=this.c(E,A);if(b)return b;A.delete(m)}}}e.$cq=T}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(C||(e._util=C={})),e.$Oh=d("instantiationService");function T(A,m,E){m[C.DI_TARGET]===m?m[C.DI_DEPENDENCIES].push({id:A,index:E}):(m[C.DI_DEPENDENCIES]=[{id:A,index:E}],m[C.DI_TARGET]=m)}function d(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const m=function(E,b,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,E,L)};return m.toString=()=>A,C.serviceIds.set(A,m),m}e.$Ph=d;function R(A){return A}e.$Qh=R}),define(De[50],Ce([1,0,17,2,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,d.$Ph)("configurationService");function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof T.URI)}e.$ki=R;function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof T.URI)}e.$li=A;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=E;function b(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$ni=b;function L(s,a){const o=Object.create(null);for(const f in s)P(o,f,s[f],a);return o}e.$oi=L;function P(s,a,o,f){const l=a.split("."),t=l.pop();let i=s;for(let c=0;c<l.length;c++){const n=l[c];let r=i[n];switch(typeof r){case"undefined":r=i[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${a} as ${l.slice(0,c+1).join(".")} is ${JSON.stringify(r)}`);return}i=r}if(typeof i=="object"&&i!==null)try{i[t]=o}catch{f(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(i)}`)}else f(`Ignoring ${a} as ${l.join(".")} is ${JSON.stringify(i)}`)}e.$pi=P;function v(s,a){const o=a.split(".");y(s,o)}e.$qi=v;function y(s,a){const o=a.shift();if(a.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const f=s[o];typeof f=="object"&&!Array.isArray(f)&&(y(f,a),Object.keys(f).length===0&&delete s[o])}}function k(s,a,o){function f(i,c){let n=i;for(const r of c){if(typeof n!="object"||n===null)return;n=n[r]}return n}const l=a.split("."),t=f(s,l);return typeof t>"u"?o:t}e.$ri=k;function p(s,a,o){Object.keys(a).forEach(f=>{f!=="__proto__"&&(f in s?C.$Af(s[f])&&C.$Af(a[f])?p(s[f],a[f],o):o&&(s[f]=a[f]):s[f]=a[f])})}e.$si=p;function h(s){return s.replace(/[\[\]]/g,"")}e.$ti=h}),define(De[42],Ce([1,0,12,15,228,5,189,9]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.$k),E.set("isLinux",C.$l),E.set("isWindows",C.$j),E.set("isWeb",C.$p),E.set("isMacNative",C.$k&&!C.$p),E.set("isEdge",C.$H),E.set("isFirefox",C.$F),E.set("isChrome",C.$E),E.set("isSafari",C.$G);function b(H,B){if(E.get(H)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(H,B)}e.$Li=b;const L=Object.prototype.hasOwnProperty;var P;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const v={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),k=(0,A.localize)(1,null),p=(0,A.localize)(2,null),h=(0,A.localize)(3,null),s=(0,A.localize)(4,null),a=(0,A.localize)(5,null),o=(0,A.localize)(6,null),f=(0,A.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=v){this.k=B,this.d=new d.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const X=this.l();if(!this.E()){const re=this.D(),Y=re.type===17?a:void 0;throw this.h.push({message:s,offset:re.offset,lexeme:d.$Ki.getLexeme(re),additionalInfo:Y}),l.c}return X}catch(X){if(X!==l.c)throw X;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const X=this.o();B.push(X)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const X=this.s();B.push(X)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const X=this.l();return this.A(1,h),X?.negate()}case 17:return this.z(),D.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const X=this.l();return this.A(1,h),X}case 17:{const X=B.lexeme;if(this.z(),this.y(9)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==10)throw this.B("REGEX",Y);const _=Y.lexeme,x=_.lastIndexOf("/"),ve=x===_.length-1?void 0:this.w(_.substring(x+1));let ae;try{ae=new RegExp(_.substring(1,x),ve)}catch{throw this.B("REGEX",Y)}return O.create(X,ae)}switch(Y.type){case 10:case 19:{const _=[Y.lexeme];this.z();let x=this.D(),ve=0;for(let be=0;be<Y.lexeme.length;be++)Y.lexeme.charCodeAt(be)===40?ve++:Y.lexeme.charCodeAt(be)===41&&ve--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:ve++;break;case 1:ve--;break;case 10:case 18:for(let be=0;be<x.lexeme.length;be++)x.lexeme.charCodeAt(be)===40?ve++:Y.lexeme.charCodeAt(be)===41&&ve--}if(ve<0)break;_.push(d.$Ki.getLexeme(x)),this.z(),x=this.D()}const ae=_.join(""),fe=ae.lastIndexOf("/"),ee=fe===ae.length-1?void 0:this.w(ae.substring(fe+1));let de;try{de=new RegExp(ae.substring(1,fe),ee)}catch{throw this.B("REGEX",Y)}return t.regex(X,de)}case 18:{const _=Y.lexeme;this.z();let x=null;if(!(0,T.$Be)(_)){const ve=_.indexOf("/"),ae=_.lastIndexOf("/");if(ve!==ae&&ve>=0){const fe=_.slice(ve+1,ae),ee=_[ae+1]==="i"?"i":"";try{x=new RegExp(fe,ee)}catch{throw this.B("REGEX",Y)}}}if(x===null)throw this.B("REGEX",Y);return O.create(X,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const Y=this.u();return t.notIn(X,Y)}switch(this.D().type){case 3:{this.z();const Y=this.u();if(this.x().type===18)return t.equals(X,Y);switch(Y){case"true":return t.has(X);case"false":return t.not(X);default:return t.equals(X,Y)}}case 4:{this.z();const Y=this.u();if(this.x().type===18)return t.notEquals(X,Y);switch(Y){case"true":return t.not(X);case"false":return t.has(X);default:return t.notEquals(X,Y)}}case 5:return this.z(),U.create(X,this.u());case 6:return this.z(),j.create(X,this.u());case 7:return this.z(),M.create(X,this.u());case 8:return this.z(),F.create(X,this.u());case 13:return this.z(),t.in(X,this.u());default:return t.has(X)}}case 20:throw this.h.push({message:o,offset:B.offset,lexeme:"",additionalInfo:f}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,X){if(this.C(B))return this.z();throw this.B(X,this.D())}B(B,X,re){const Y=(0,A.localize)(8,null,B,d.$Ki.getLexeme(X)),_=X.offset,x=d.$Ki.getLexeme(X);return this.h.push({message:Y,offset:_,lexeme:x,additionalInfo:re}),l.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=l;class t{static false(){return r.INSTANCE}static true(){return u.INSTANCE}static has(B){return I.create(B)}static equals(B,X){return S.create(B,X)}static notEquals(B,X){return w.create(B,X)}static regex(B,X){return O.create(B,X)}static in(B,X){return $.create(B,X)}static notIn(B,X){return g.create(B,X)}static not(B){return D.create(B)}static and(...B){return me.create(B,null,!0)}static or(...B){return te.create(B,null,!0)}static greater(B,X){return M.create(B,X)}static greaterEquals(B,X){return F.create(B,X)}static smaller(B,X){return U.create(B,X)}static smallerEquals(B,X){return j.create(B,X)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ni=t;function i(H){const B=new l({regexParsingWithErrorRecovery:!1});return H.map(X=>(B.parse(X),B.lexingErrors.length>0?B.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,A.localize)(9,null,re.additionalInfo):(0,A.localize)(10,null),offset:re.offset,length:re.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.$Oi=i;function c(H,B){const X=H?H.substituteConstants():void 0,re=B?B.substituteConstants():void 0;return!X&&!re?!0:!X||!re?!1:X.equals(re)}e.$Pi=c;function n(H,B){return H.cmp(B)}class r{static{this.INSTANCE=new r}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return u.INSTANCE}}e.$Qi=r;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return r.INSTANCE}}e.$Ri=u;class I{static create(B,X=null){const re=E.get(B);return typeof re=="boolean"?re?u.INSTANCE:r.INSTANCE:new I(B,X)}constructor(B,X){this.key=B,this.c=X,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?u.INSTANCE:r.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Si=I;class S{static create(B,X,re=null){if(typeof X=="boolean")return X?I.create(B,re):D.create(B,re);const Y=E.get(B);return typeof Y=="boolean"?X===(Y?"true":"false")?u.INSTANCE:r.INSTANCE:new S(B,X,re)}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const X=B?"true":"false";return this.d===X?u.INSTANCE:r.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Ti=S;class ${static create(B,X){return new $(B,X)}constructor(B,X){this.d=B,this.f=X,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:le(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const X=B.getValue(this.f),re=B.getValue(this.d);return Array.isArray(X)?X.includes(re):typeof re=="string"&&typeof X=="object"&&X!==null?L.call(X,re):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Ui=$;class g{static create(B,X){return new g(B,X)}constructor(B,X){this.d=B,this.f=X,this.type=11,this.c=$.create(B,X)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=g;class w{static create(B,X,re=null){if(typeof X=="boolean")return X?D.create(B,re):I.create(B,re);const Y=E.get(B);return typeof Y=="boolean"?X===(Y?"true":"false")?r.INSTANCE:u.INSTANCE:new w(B,X,re)}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const X=B?"true":"false";return this.d===X?r.INSTANCE:u.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Wi=w;class D{static create(B,X=null){const re=E.get(B);return typeof re=="boolean"?re?r.INSTANCE:u.INSTANCE:new D(B,X)}constructor(B,X){this.c=B,this.d=X,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Q(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?r.INSTANCE:u.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Xi=D;function N(H,B){if(typeof H=="string"){const X=parseFloat(H);isNaN(X)||(H=X)}return typeof H=="string"||typeof H=="number"?B(H):r.INSTANCE}class M{static create(B,X,re=null){return N(X,Y=>new M(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Yi=M;class F{static create(B,X,re=null){return N(X,Y=>new F(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Zi=F;class U{static create(B,X,re=null){return N(X,Y=>new U(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$1i=U;class j{static create(B,X,re=null){return N(X,Y=>new j(B,Y,re))}constructor(B,X,re){this.c=B,this.d=X,this.f=re,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:le(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$2i=j;class O{static create(B,X){return new O(B,X)}constructor(B,X){this.d=B,this.f=X,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const X=this.f?this.f.source:"",re=B.f?B.f.source:"";return X<re?-1:X>re?1:0}equals(B){if(B.type===this.type){const X=this.f?this.f.source:"",re=B.f?B.f.source:"";return this.d===B.d&&X===re}return!1}substituteConstants(){return this}evaluate(B){const X=B.getValue(this.d);return this.f?this.f.test(X):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$3i=O;class q{static create(B){return new q(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new q(this.c.map(B))}negate(){return this.c}}e.$4i=q;function K(H){let B=null;for(let X=0,re=H.length;X<re;X++){const Y=H[X].substituteConstants();if(H[X]!==Y&&B===null){B=[];for(let _=0;_<X;_++)B[_]=H[_]}B!==null&&(B[X]=Y)}return B===null?H:B}class me{static create(B,X,re){return me.d(B,X,re)}constructor(B,X){this.expr=B,this.c=X,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Y=n(this.expr[X],B.expr[X]);if(Y!==0)return Y}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals(B.expr[X]))return!1;return!0}return!1}substituteConstants(){const B=K(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].evaluate(B))return!1;return!0}static d(B,X,re){const Y=[];let _=!1;for(const x of B)if(x){if(x.type===1){_=!0;continue}if(x.type===0)return r.INSTANCE;if(x.type===6){Y.push(...x.expr);continue}Y.push(x)}if(Y.length===0&&_)return u.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(n);for(let x=1;x<Y.length;x++)Y[x-1].equals(Y[x])&&(Y.splice(x,1),x--);if(Y.length===1)return Y[0];for(;Y.length>1;){const x=Y[Y.length-1];if(x.type!==9)break;Y.pop();const ve=Y.pop(),ae=Y.length===0,fe=te.create(x.expr.map(ee=>me.create([ee,ve],null,re)),null,ae);fe&&(Y.push(fe),Y.sort(n))}if(Y.length===1)return Y[0];if(re){for(let x=0;x<Y.length;x++)for(let ve=x+1;ve<Y.length;ve++)if(Y[x].negate().equals(Y[ve]))return r.INSTANCE;if(Y.length===1)return Y[0]}return new me(Y,X)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const X of this.expr)B.push(...X.keys());return B}map(B){return new me(this.expr.map(X=>X.map(B)),null)}negate(){if(!this.c){const B=[];for(const X of this.expr)B.push(X.negate());this.c=te.create(B,this,!0)}return this.c}}e.$5i=me;class te{static create(B,X,re){return te.d(B,X,re)}constructor(B,X){this.expr=B,this.c=X,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let X=0,re=this.expr.length;X<re;X++){const Y=n(this.expr[X],B.expr[X]);if(Y!==0)return Y}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let X=0,re=this.expr.length;X<re;X++)if(!this.expr[X].equals(B.expr[X]))return!1;return!0}return!1}substituteConstants(){const B=K(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let X=0,re=this.expr.length;X<re;X++)if(this.expr[X].evaluate(B))return!0;return!1}static d(B,X,re){let Y=[],_=!1;if(B){for(let x=0,ve=B.length;x<ve;x++){const ae=B[x];if(ae){if(ae.type===0){_=!0;continue}if(ae.type===1)return u.INSTANCE;if(ae.type===9){Y=Y.concat(ae.expr);continue}Y.push(ae)}}if(Y.length===0&&_)return r.INSTANCE;Y.sort(n)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let x=1;x<Y.length;x++)Y[x-1].equals(Y[x])&&(Y.splice(x,1),x--);if(Y.length===1)return Y[0];if(re){for(let x=0;x<Y.length;x++)for(let ve=x+1;ve<Y.length;ve++)if(Y[x].negate().equals(Y[ve]))return u.INSTANCE;if(Y.length===1)return Y[0]}return new te(Y,X)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const X of this.expr)B.push(...X.keys());return B}map(B){return new te(this.expr.map(X=>X.map(B)),null)}negate(){if(!this.c){const B=[];for(const X of this.expr)B.push(X.negate());for(;B.length>1;){const X=B.shift(),re=B.shift(),Y=[];for(const _ of ye(X))for(const x of ye(re))Y.push(me.create([_,x],null,!1));B.unshift(te.create(Y,null,!1))}this.c=te.create(B,this,!0)}return this.c}}e.$6i=te;class G extends I{static{this.d=[]}static all(){return G.d.values()}constructor(B,X,re){super(B,null),this.f=X,typeof re=="object"?G.d.push({...re,key:B}):re!==!0&&G.d.push({key:B,description:re,type:X!=null?typeof X:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return w.create(this.key,B)}}e.$7i=G,e.$8i=(0,R.$Ph)("contextKeyService");function Q(H,B){return H<B?-1:H>B?1:0}function le(H,B,X,re){return H<X?-1:H>X?1:B<re?-1:B>re?1:0}function ie(H,B){if(H.type===0||B.type===1)return!0;if(H.type===9)return B.type===9?ce(H.expr,B.expr):!1;if(B.type===9){for(const X of B.expr)if(ie(H,X))return!0;return!1}if(H.type===6){if(B.type===6)return ce(B.expr,H.expr);for(const X of H.expr)if(ie(X,B))return!0;return!1}return H.equals(B)}e.$9i=ie;function ce(H,B){let X=0,re=0;for(;X<H.length&&re<B.length;){const Y=H[X].cmp(B[re]);if(Y<0)return!1;Y===0&&X++,re++}return X===H.length}function ye(H){return H.type===9?H.expr:[H]}}),define(De[231],Ce([1,0,23,38,191,5,99,12,24]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.ConfirmResult=e.$Dv=e.$Cv=e.$Bv=void 0,e.$Bv=(0,R.$Ph)("dialogService");var b;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(b||(b={}));class L{a(h){return this.d(h,b.Confirmation)}b(h){return this.d(h,b.Prompt)}c(h){return this.d(h,b.Input)}d(h,s){const a=[];switch(s){case b.Confirmation:{const o=h;o.primaryButton?a.push(o.primaryButton):a.push((0,d.localize)(0,null)),o.cancelButton?a.push(o.cancelButton):a.push((0,d.localize)(1,null));break}case b.Prompt:{const o=h;Array.isArray(o.buttons)&&o.buttons.length>0&&a.push(...o.buttons.map(f=>f.label)),o.cancelButton&&(o.cancelButton===!0?a.push((0,d.localize)(2,null)):typeof o.cancelButton=="string"?a.push(o.cancelButton):o.cancelButton.label?a.push(o.cancelButton.label):a.push((0,d.localize)(3,null))),a.length===0&&a.push((0,d.localize)(4,null));break}case b.Input:{const o=h;o.primaryButton?a.push(o.primaryButton):a.push((0,d.localize)(5,null)),o.cancelButton?a.push(o.cancelButton):a.push((0,d.localize)(6,null));break}}return a}e(h){if(typeof h=="string")return h;if(typeof h=="number")return h===T.default.Info?"info":h===T.default.Error?"error":h===T.default.Warning?"warning":"none"}f(h,s,a){const o=[...h.buttons??[]];h.cancelButton&&typeof h.cancelButton!="string"&&typeof h.cancelButton!="boolean"&&o.push(h.cancelButton);let f=o[s]?.run({checkboxChecked:a});return f instanceof Promise||(f=Promise.resolve(f)),{result:f,checkboxChecked:a}}}e.$Cv=L,e.$Dv=(0,R.$Ph)("fileDialogService");var P;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const v=10;function y(p){const h=[];return h.push(...p.slice(0,v).map(s=>typeof s=="string"?s:(0,C.$sg)(s))),p.length>v&&(p.length-v===1?h.push((0,d.localize)(7,null)):h.push((0,d.localize)(8,null,p.length-v))),h.push(""),h.join(`
`)}e.$Ev=y;function k(p,h){const s=(0,E.$7m)(p);let a=(s.buttons??[]).map(t=>(0,A.$yv)(t)),o=(p.buttons||[]).map((t,i)=>i),f=0,l=s.cancelId??a.length-1;if(a.length>1){const t=typeof l=="number"?a[l]:void 0;if(m.$l||m.$k){if(typeof t=="string"&&a.length>1&&l!==1){a.splice(l,1),a.splice(1,0,t);const i=o[l];o.splice(l,1),o.splice(1,0,i),l=1}m.$l&&a.length>1&&(a=a.reverse(),o=o.reverse(),f=a.length-1,typeof t=="string"&&(l=f-1))}else if(m.$j&&typeof t=="string"&&a.length>1&&l!==a.length-1){a.splice(l,1),a.push(t);const i=o[l];o.splice(l,1),o.push(i),l=a.length-1}}return s.buttons=a,s.defaultId=f,s.cancelId=l,s.noLink=!0,s.title=s.title||h.nameLong,{options:s,buttonIndeces:o}}e.$Fv=k}),define(De[131],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,C.$Ph)("environmentService"),e.$Xh=(0,C.$Qh)(e.$Wh)}),define(De[132],Ce([1,0,192,5]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$0n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function d(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=d;function R(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=R;function A(s,a){switch(s){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=A;function m(s,a){return a==="web"&&!s.includes("web")}e.$7n=m;function E(s,a,o){return m(a,o)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===o}e.$8n=E;function b(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$9n=b;var L;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var P;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var v;(function(s){s.Install="install",s.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var y;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$0n=(0,T.$Ph)("extensionGalleryService");var k;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var p;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class h extends Error{constructor(a,o){super(a),this.code=o,this.name=o}}e.$$n=h,e.$_n=(0,T.$Ph)("extensionManagementService"),e.$ao="extensionsIdentifiers/disabled",e.$bo="extensionsIdentifiers/enabled",e.$co=(0,T.$Ph)("IGlobalExtensionEnablementService"),e.$do=(0,T.$Ph)("IExtensionTipsService"),e.$eo=(0,C.localize)(0,null),e.$fo={value:e.$eo,original:"Extensions"},e.$go={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[232],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kYb=e.$jYb=void 0,e.$jYb=(0,C.$Ph)("externalTerminal"),e.$kYb="Terminal.app"}),define(De[233],Ce([1,0,49,18,16,12,98,29,101,194,232]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=e.$f7b=e.$e7b=void 0;const P=b.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends v{static{this.b="cmd.exe"}openTerminal(f,l){return this.spawnTerminal(C,f,E.$Bl(),l)}spawnTerminal(f,l,t,i){const c=l.windowsExec||y.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=d.$nc(c,".exe").toLowerCase();if(n==="cmder")return f.spawn(c,i?[i]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return c.indexOf(" ")>=0&&r.push('""'),r.push(c),n==="wt"&&r.push("-d ."),new Promise((u,I)=>{const S=h(process),$=f.spawn(t,r,{cwd:i,env:S});$.on("error",I),$.on("exit",()=>u())})}runInTerminal(f,l,t,i,c){const n="windowsExec"in c&&c.windowsExec?c.windowsExec:y.getDefaultTerminalWindows();return new Promise((r,u)=>{const I=`"${l} - ${P}"`,S=`""${t.join('" "')}" & pause"`,$=Object.assign({},h(process),i);Object.keys($).filter(M=>$[M]===null).forEach(M=>delete $[M]);const g={cwd:l,env:$,windowsVerbatimArguments:!0};let w,D;d.$nc(n,".exe")==="wt"?(w=n,D=["-d",".",y.b,"/c",S]):(w=y.b,D=["/c","start",I,"/wait",n,"/c",S]),C.spawn(w,D,g).on("error",M=>{u(s(M))}),r(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$e7b=y;class k extends v{static{this.b="/usr/bin/osascript"}openTerminal(f,l){return this.spawnTerminal(C,f,l)}runInTerminal(f,l,t,i,c){const n=c.osxExec||L.$kYb;return new Promise((r,u)=>{if(n===L.$kYb||n==="iTerm.app"){const I=n===L.$kYb?"TerminalHelper":"iTermHelper",$=[T.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",f||P,"-w",l];for(const D of t)$.push("-a"),$.push(D);if(i){const D=Object.assign({},h(process),i);for(const N in D){const M=D[N];M===null?($.push("-u"),$.push(N)):($.push("-e"),$.push(`${N}=${M}`))}}let g="";const w=C.spawn(k.b,$);w.on("error",D=>{u(s(D))}),w.stderr.on("data",D=>{g+=D.toString()}),w.on("exit",D=>{if(D===0)r(void 0);else if(g){const N=g.split(`
`,1);u(new Error(N[0]))}else u(new Error(b.localize(1,null,I,D)))})}else u(new Error(b.localize(2,null,n)))})}spawnTerminal(f,l,t){const i=l.osxExec||L.$kYb;return new Promise((c,n)=>{const r=["-a",i];t&&r.push(t);const u=h(process),I=f.spawn("/usr/bin/open",r,{cwd:t,env:u});I.on("error",n),I.on("exit",()=>c())})}}e.$f7b=k;class p extends v{static{this.b=b.localize(3,null)}openTerminal(f,l){return this.spawnTerminal(C,f,l)}runInTerminal(f,l,t,i,c){const n=c.linuxExec?Promise.resolve(c.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,u)=>{const I=[];n.then(S=>{S.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const $=`${a(t)}; echo; read -p "${p.b}" -n1;`;I.push(`''${$}''`);const g=Object.assign({},h(process),i);Object.keys(g).filter(M=>g[M]===null).forEach(M=>delete g[M]);const w={cwd:l,env:g};let D="";const N=C.spawn(S,I,w);N.on("error",M=>{u(s(M))}),N.stderr.on("data",M=>{D+=M.toString()}),N.on("exit",M=>{if(M===0)r(void 0);else if(D){const F=D.split(`
`,1);u(new Error(F[0]))}else u(new Error(b.localize(4,null,S,M)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!R.$l)p.d=Promise.resolve("xterm");else{const f=await m.Promises.exists("/etc/debian_version");p.d=new Promise(l=>{f?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return p.d}spawnTerminal(f,l,t){const i=l.linuxExec?Promise.resolve(l.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((c,n)=>{i.then(r=>{const u=h(process),I=f.spawn(r,[],{cwd:t,env:u});I.on("error",n),I.on("exit",()=>c())})})}}e.$g7b=p;function h(o){const f={...o.env};return(0,A.$zl)(f),f}function s(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(b.localize(5,null,o.path)):o}function a(o){let f="";for(const l of o)l.indexOf(" ")>=0?f+='"'+l+'"':f+=l,f+=" ";return f}}),define(De[30],Ce([1,0,78,16,15,17,2,195,5,12,18,47]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,E.$Ph)("fileService");function v(ie){return ie.create===!0}e.$_j=v;var y;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var k;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function p(ie){const ce=ie;return!!ce&&typeof ce.onDidChange=="function"}e.$ak=p;var h;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function s(ie){return!!(ie.capabilities&2)}e.$bk=s;function a(ie){return!!(ie.capabilities&8)}e.$ck=a;function o(ie){return!!(ie.capabilities&131072)}e.$dk=o;function f(ie){return!!(ie.capabilities&4)}e.$ek=f;function l(ie){return!!(ie.capabilities&16)}e.$fk=l;function t(ie){return s(ie)?!!(ie.capabilities&16384):!1}e.$gk=t;function i(ie){return s(ie)?!!(ie.capabilities&32768):!1}e.$hk=i;function c(ie){return!!(ie.capabilities&65536)}e.$ik=c;function n(ie){return!!(ie.capabilities&2048)}e.$jk=n;var r;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class u extends Error{static create(ce,ye){const H=new u(ce.toString(),ye);return $(H,ye),H}constructor(ce,ye){super(ce),this.code=ye}}e.$kk=u;function I(ie,ce){return u.create(ie,ce)}e.$lk=I;function S(ie){return ie||I((0,m.localize)(0,null),r.Unknown)}e.$mk=S;function $(ie,ce){return ie.name=ce?`${ce} (FileSystemError)`:"FileSystemError",ie}e.$nk=$;function g(ie){if(!ie)return r.Unknown;if(ie instanceof u)return ie.code;const ce=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ce)return r.Unknown;switch(ce[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$ok=g;function w(ie){if(ie instanceof j)return ie.fileOperationResult;switch(g(ie)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$pk=w;var D;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class N{constructor(ce,ye,H){this.resource=ce,this.operation=ye,this.target=H}isOperation(ce){return this.operation===ce}}e.$qk=N;var M;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class F{static{this.a=null}constructor(ce,ye){this.c=ye,this.b=void 0,this.d=new P.$V(()=>{const H=C.$Vh.forUris(()=>this.c);return H.fill(this.rawAdded.map(B=>[B,!0])),H}),this.f=new P.$V(()=>{const H=C.$Vh.forUris(()=>this.c);return H.fill(this.rawUpdated.map(B=>[B,!0])),H}),this.g=new P.$V(()=>{const H=C.$Vh.forUris(()=>this.c);return H.fill(this.rawDeleted.map(B=>[B,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ce){switch(H.type){case 1:this.rawAdded.push(H.resource);break;case 0:this.rawUpdated.push(H.resource);break;case 2:this.rawDeleted.push(H.resource);break}this.b!==F.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ce,...ye){return this.h(ce,{includeChildren:!1},...ye)}affects(ce,...ye){return this.h(ce,{includeChildren:!0},...ye)}h(ce,ye,...H){if(!ce)return!1;const B=H.length>0;return!!((!B||H.includes(1))&&(this.d.value.get(ce)||ye.includeChildren&&this.d.value.findSuperstr(ce))||(!B||H.includes(0))&&(this.f.value.get(ce)||ye.includeChildren&&this.f.value.findSuperstr(ce))||(!B||H.includes(2))&&(this.g.value.findSubstr(ce)||ye.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$rk=F;function U(ie,ce,ye){return!ie||!ce||ie===ce||ce.length>ie.length?!1:(ce.charAt(ce.length-1)!==T.sep&&(ce+=T.sep),ye?(0,d.$3e)(ie,ce):ie.indexOf(ce)===0)}e.$sk=U;class j extends Error{constructor(ce,ye,H){super(ce),this.fileOperationResult=ye,this.options=H}}e.$tk=j;class O extends j{constructor(ce,ye,H,B){super(ce,ye,B),this.fileOperationResult=ye,this.size=H}}e.$uk=O;class q extends j{constructor(ce,ye,H){super(ce,2,H),this.stat=ye}}e.$vk=q;var K;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var me;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Dk="";function te(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Ek=te;async function G(ie,ce){if(!ce.hasProvider(A.URI.from({scheme:ie.scheme})))return new Promise(ye=>{const H=ce.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ie.scheme&&B.added&&(H.dispose(),ye())})})}e.$Fk=G;class Q{static{this.KB=1024}static{this.MB=Q.KB*Q.KB}static{this.GB=Q.MB*Q.KB}static{this.TB=Q.GB*Q.KB}static formatSize(ce){return(0,R.$Cf)(ce)||(ce=0),ce<Q.KB?(0,m.localize)(1,null,ce.toFixed(0)):ce<Q.MB?(0,m.localize)(2,null,(ce/Q.KB).toFixed(2)):ce<Q.GB?(0,m.localize)(3,null,(ce/Q.MB).toFixed(2)):ce<Q.TB?(0,m.localize)(4,null,(ce/Q.GB).toFixed(2)):(0,m.localize)(5,null,(ce/Q.TB).toFixed(2))}}e.$Gk=Q;function le(ie){const ce=typeof ie=="string"||ie?.scheme===L.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===L.Schemas.file?1024*Q.MB:ce?10*Q.MB:b.$p?50*Q.MB:1024*Q.MB}e.$Hk=le}),define(De[234],Ce([1,0,22,9,196,30]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;async function A(L,P,v,y,k,p){let h;try{await m(L,P,v,y,k,p)}catch(s){h=s}finally{h&&k.errorTransformer&&(h=k.errorTransformer(h)),typeof h<"u"&&v.error(h),v.end()}}e.$Mp=A;async function m(L,P,v,y,k,p){E(p);const h=await L.open(P,{create:!1});try{E(p);let s=0,a=0,o=k&&typeof k.length=="number"?k.length:void 0,f=C.$be.alloc(Math.min(k.bufferSize,typeof o=="number"?o:k.bufferSize)),l=k&&typeof k.position=="number"?k.position:0,t=0;do a=await L.read(h,l,f.buffer,t,f.byteLength-t),l+=a,t+=a,s+=a,typeof o=="number"&&(o-=a),t===f.byteLength&&(await v.write(y(f)),f=C.$be.alloc(Math.min(k.bufferSize,typeof o=="number"?o:k.bufferSize)),t=0);while(a>0&&(typeof o!="number"||o>0)&&E(p)&&b(s,k));if(t>0){let i=t;typeof o=="number"&&(i=Math.min(t,o)),v.write(y(f.slice(0,i)))}}catch(s){throw(0,R.$mk)(s)}finally{await L.close(h)}}function E(L){if(L.isCancellationRequested)throw(0,T.$6)();return!0}function b(L,P){if(typeof P?.limits?.size=="number"&&L>P.limits.size)throw(0,R.$lk)((0,d.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[84],Ce([1,0,36,3,16,12,2,30]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=void 0;function E(s){return s.recursive===!0}e.$Op=E;class b extends T.$Sc{static{this.a=5}constructor(a,o,f,l){super(),this.h=a,this.j=o,this.m=f,this.n=l,this.c=this.B(new T.$Tc),this.f=void 0,this.g=0}s(){const a=new T.$Rc;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(o=>this.h(o))),a.add(this.b.onDidLogMessage(o=>this.j(o))),a.add(this.b.onDidError(o=>this.t(o)))}t(a){this.n.restartOnError?this.g<b.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Pp=b;class L extends b{constructor(a,o,f){super(a,o,f,{type:"node.js",restartOnError:!1})}}e.$Qp=L;class P extends b{constructor(a,o,f){super(a,o,f,{type:"universal",restartOnError:!0})}}e.$Rp=P;function v(s){return s.map(a=>({type:a.type,resource:A.URI.revive(a.resource),cId:a.cId}))}e.$Sp=v;function y(s){const a=new h;for(const o of s)a.processEvent(o);return a.coalesce()}e.$Tp=y;function k(s,a){return typeof a=="string"&&!a.startsWith(C.$sj)&&!(0,d.$ic)(a)?{base:s,pattern:a}:a}e.$Up=k;function p(s,a){const o=[];for(const f of a)o.push((0,C.$wj)(k(s,f)));return o}e.$Vp=p;class h{constructor(){this.a=new Set,this.b=new Map}c(a){return R.$l?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const o=this.b.get(this.c(a));let f=!1;if(o){const l=o.type,t=a.type;o.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?f=!0:l===1&&t===2?(this.b.delete(this.c(a)),this.a.delete(o)):l===2&&t===1?o.type=0:l===1&&t===0||(o.type=t)}else f=!0;f&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],o=[];return Array.from(this.a).filter(f=>f.type!==2?(a.push(f),!1):!0).sort((f,l)=>f.resource.fsPath.length-l.resource.fsPath.length).filter(f=>o.some(l=>(0,m.$sk)(f.resource.fsPath,l,!R.$l))?!1:(o.push(f.resource.fsPath),!0)).concat(a)}}}),define(De[235],Ce([1,0,53,8,21,33,3,77,16,12,23,2,100,29,84]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=e.$9p=void 0;class p extends A.$Sc{static{this.a=100}static{this.b=75}constructor(a,o,f,l){super(),this.m=a,this.n=o,this.r=f,this.s=l,this.c=this.B(new T.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$8g(t=>this.z(t),p.b)),this.g=(0,k.$Vp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Vp)(this.m.path,this.m.includes):void 0,this.j=new d.$Xd,this.ready=this.t()}async t(){try{const a=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const o=await y.Promises.stat(a);this.B(await this.w(a,o.isDirectory()))}catch(a){a.code!=="ENOENT"?this.D(a):this.G(a)}}async u(a){let o=a.path;try{o=await y.Promises.realpath(a.path),a.path===o&&(o=await(0,v.$6p)(a.path)??a.path),a.path!==o&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${o})`)}catch{}return o}async w(a,o){if(b.$k&&(0,R.$Xf)(a,"/Volumes/",!0))return this.D(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Sc.None;const f=new d.$Xd(this.j.token),l=new A.$Rc;try{const t=P.URI.file(this.m.path),i=(0,E.$nc)(a),c=(0,C.watch)(a);l.add((0,A.$Qc)(()=>{c.removeAllListeners(),c.close()})),this.G(`Started watching: '${a}'`);const n=new Set;if(o)try{for(const u of await y.Promises.readdir(a))n.add(u)}catch(u){this.D(u)}const r=new Map;l.add((0,A.$Qc)(()=>{for(const[,u]of r)u.dispose();r.clear()})),c.on("error",(u,I)=>{this.D(`Failed to watch ${a} for changes using fs.watch() (${u}, ${I})`),this.dispose()}),c.on("change",(u,I)=>{if(f.token.isCancellationRequested)return;this.G(`[raw] ["${u}"] ${I}`);let S="";if(I&&(S=I.toString(),b.$k&&(S=(0,m.$ol)(S))),!(!S||u!=="change"&&u!=="rename"))if(o)if(u==="rename"){r.get(S)?.dispose();const $=setTimeout(async()=>{if(r.delete(S),S===i&&!await y.Promises.exists(a)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.C((0,E.$jc)(a,S));if(f.token.isCancellationRequested)return;let w;g?n.has(S)?w=0:(w=1,n.add(S)):(n.delete(S),w=2),this.y({resource:(0,L.$vg)(t,S),type:w,cId:this.m.correlationId})},p.a);r.set(S,(0,A.$Qc)(()=>clearTimeout($)))}else{let $;n.has(S)?$=0:($=1,n.add(S)),this.y({resource:(0,L.$vg)(t,S),type:$,cId:this.m.correlationId})}else if(u==="rename"||S!==i){const $=setTimeout(async()=>{const g=await y.Promises.exists(a);f.token.isCancellationRequested||(g?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),l.add(await this.w(a,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);l.clear(),l.add((0,A.$Qc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(a)&&!f.token.isCancellationRequested&&this.D(`Failed to watch ${a} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Qc)(()=>{f.dispose(!0),l.dispose()})}y(a,o=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`),!o&&this.g.some(f=>f(a.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${a.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(f=>f(a.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${a.resource.fsPath}`):this.f.work(a))}z(a){const o=(0,k.$Tp)(a);if(o.length>0){if(this.s)for(const l of o)this.G(` >> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(a){if(b.$l)return y.Promises.exists(a);try{const o=(0,E.$nc)(a);return(await y.Promises.readdir((0,E.$mc)(a))).some(l=>l===o)}catch(o){return this.G(o),!1}}setVerboseLogging(a){this.s=a}D(a){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}F(a){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}G(a){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$9p=p;async function h(s,a,o,f,l=512){const t=await y.Promises.open(s,"r"),i=Buffer.allocUnsafe(l),c=new d.$Xd(f);let n,r=!1;const u={path:s,excludes:[],recursive:!1},I=new p(u,S=>{(async()=>{for(const{type:$}of S)if($===0){if(r)return;r=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:g}=await y.Promises.read(t,i,0,l,null);if(!g||c.token.isCancellationRequested)break;a(i.slice(0,g))}}catch(g){n=new Error(g),c.dispose(!0)}finally{r=!1}}})()});return await I.ready,o(),new Promise((S,$)=>{c.token.onCancellationRequested(async()=>{I.dispose();try{await y.Promises.close(t)}catch(g){n=new Error(g)}n?$(n):S()})})}e.$0p=h}),define(De[236],Ce([1,0,4,36,3,12,235]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class m extends d.$Sc{constructor(){super(...arguments),this.a=this.B(new C.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(b){const L=this.j(b),P=L.filter(y=>{const k=this.c.get(y.path);return k?!(0,T.$Aj)(k.request.excludes,y.excludes)||!(0,T.$Aj)(k.request.includes,y.includes):!0}),v=Array.from(this.c.values()).filter(({request:y})=>!L.find(k=>k.path===y.path&&(0,T.$Aj)(k.excludes,y.excludes)&&(0,T.$Aj)(k.includes,y.includes))).map(({request:y})=>y.path);P.length&&this.m(`Request to start watching: ${P.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.h(y);for(const y of P)this.g(y)}g(b){const L=new A.$9p(b,v=>this.a.fire(v),v=>this.b.fire(v),this.f),P={request:b,instance:L};this.c.set(b.path,P)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const L=this.c.get(b);L&&(this.c.delete(b),L.instance.dispose())}j(b){const L=new Map;for(const P of b){const v=R.$l?P.path:P.path.toLowerCase();let y=L.get(P.correlationId);y||(y=new Map,L.set(P.correlationId,y)),y.set(v,P)}return Array.from(L.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(b){this.f=b;for(const[,L]of this.c)L.instance.setVerboseLogging(b)}m(b){this.f&&this.b.fire({type:"trace",message:this.n(b)})}n(b,L){return L?`[File Watcher (node.js)] ${b} (path: ${L.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$$p=m}),define(De[237],Ce([1,0,84,236]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=void 0;class d extends C.$Qp{constructor(A,m,E){super(A,m,E),this.s()}r(A){return A.add(new T.$$p)}}e.$_p=d}),define(De[238],Ce([1,0,18,81,183,84]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;class A extends R.$Rp{constructor(E,b,L){super(E,b,L),this.s()}r(E){const b=E.add(new d.$3p(C.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:L,signal:P})=>this.t(`terminated by itself with code ${L}, signal: ${P}`))),T.ProxyChannel.toService((0,T.$wh)(b.getChannel("watcher")))}}e.$4p=A}),define(De[104],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class C{constructor(...d){this.a=new Map;for(const[R,A]of d)this.set(R,A)}set(d,R){const A=this.a.get(d);return this.a.set(d,R),A}has(d){return this.a.has(d)}get(d){return this.a.get(d)}}e.$Nh=C}),define(De[239],Ce([1,0,8,9,3,102,230,5,104,76]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;const L=!1;class P extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class v{constructor(h=new E.$Nh,s=!1,a,o=L){this.f=h,this.g=s,this.h=a,this.i=o,this.o=new Set,this.f.set(m.$Oh,this),this._globalGraph=o?a?._globalGraph??new A.$cq(f=>f):void 0}createChild(h){return new v(h,this.g,this,this.i)}invokeFunction(h,...s){const a=k.traceInvocation(this.i,h);let o=!1;try{return h({get:l=>{if(o)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(l,a);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...s)}finally{o=!0,a.stop()}}createInstance(h,...s){let a,o;return h instanceof R.$Mh?(a=k.traceCreation(this.i,h.ctor),o=this.j(h.ctor,h.staticArguments.concat(s),a)):(a=k.traceCreation(this.i,h),o=this.j(h,s,a)),a.stop(),o}j(h,s=[],a){const o=m._util.getServiceDependencies(h).sort((t,i)=>t.index-i.index),f=[];for(const t of o){const i=this.m(t.id,a);i||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(i)}const l=o.length>0?o[0].index:s.length;if(s.length!==l){console.trace(`[createInstance] First service dependency of ${h.name} at position ${l+1} conflicts with ${s.length} static arguments`);const t=l-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,l)}return Reflect.construct(h,s.concat(f))}k(h,s){if(this.f.get(h)instanceof R.$Mh)this.f.set(h,s);else if(this.h)this.h.k(h,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const s=this.f.get(h);return!s&&this.h?this.h.l(h):s}m(h,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const a=this.l(h);return a instanceof R.$Mh?this.q(h,a,s.branch(h,!0)):(s.branch(h,!1),a)}q(h,s,a){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,s,a)}finally{this.o.delete(h)}}r(h,s,a){const o=new A.$cq(t=>t.id.toString());let f=0;const l=[{id:h,desc:s,_trace:a}];for(;l.length;){const t=l.pop();if(o.lookupOrInsertNode(t),f++>1e3)throw new P(o);for(const i of m._util.getServiceDependencies(t.desc.ctor)){const c=this.l(i.id);if(c||this.u(`[createInstance] ${h} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(i.id)),c instanceof R.$Mh){const n={id:i.id,desc:c,_trace:t._trace.branch(i.id,!0)};o.insertEdge(t,n),l.push(n)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new P(o);break}for(const{data:i}of t){if(this.l(i.id)instanceof R.$Mh){const n=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,n)}o.removeNode(i)}}return this.l(h)}s(h,s,a=[],o,f){if(this.f.get(h)instanceof R.$Mh)return this.t(h,s,a,o,f);if(this.h)return this.h.s(h,s,a,o,f);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(h,s,a=[],o,f){if(o){const l=new v(void 0,this.g,this,this.i);l.c=String(h);const t=new Map,i=new C.$$g(()=>{const c=l.j(s,a,f);for(const[n,r]of t){const u=c[n];if(typeof u=="function")for(const I of r)u.apply(c,I)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,n){if(!i.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let I=t.get(n);return I||(I=new b.$2c,t.set(n,I)),($,g,w)=>{const D=I.push([$,g,w]);return(0,d.$Qc)(D)}}if(n in c)return c[n];const r=i.value;let u=r[n];return typeof u!="function"||(u=u.bind(r),c[n]=u),u},set(c,n,r){return i.value[n]=r,!0},getPrototypeOf(c){return s.prototype}})}else return this.j(s,a,f)}u(h,s){if(s&&console.warn(h),this.g)throw new Error(h)}}e.$dq=v;var y;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(y||(y={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(h,s){return h?new k(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(h,s){return h?new k(1,s.name):k.c}static{this.f=0}constructor(h,s){this.type=h,this.name=s,this.g=Date.now(),this.h=[]}branch(h,s){const a=new k(3,h.toString());return this.h.push([h,s,a]),a}stop(){const h=Date.now()-this.g;k.f+=h;let s=!1;function a(f,l){const t=[],i=new Array(f+1).join("	");for(const[c,n,r]of l.h)if(n&&r){s=!0,t.push(`${i}CREATES -> ${c}`);const u=a(f+1,r);u&&t.push(u)}else t.push(`${i}uses -> ${c}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(h>2||s)&&k.all.add(o.join(`
`))}}e.$eq=k}),define(De[14],Ce([1,0,41,4,52,3,28,12,23,17,2,42,5]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,v.$Ph)("logService"),e.$$i=(0,v.$Ph)("loggerService");function y(){return new Date().toISOString()}function k($){return(0,b.$Cf)($)}e.$_i=k;var p;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$aj=p.Info;function h($,g,w){switch(g){case p.Trace:$.trace(w);break;case p.Debug:$.debug(w);break;case p.Info:$.info(w);break;case p.Warning:$.warn(w);break;case p.Error:$.error(w);break;case p.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=h;function s($,g=!1){let w="";for(let D=0;D<$.length;D++){let N=$[D];if(N instanceof Error&&(N=(0,C.$Ai)(N,g)),typeof N=="object")try{N=JSON.stringify(N)}catch{}w+=(D>0?" ":"")+N}return w}class a extends R.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new T.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==p.Off&&this.b<=g}}e.$cj=a;class o extends a{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...w){this.f(p.Trace)&&this.g(p.Trace,s([g,...w],!0))}debug(g,...w){this.f(p.Debug)&&this.g(p.Debug,s([g,...w]))}info(g,...w){this.f(p.Info)&&this.g(p.Info,s([g,...w]))}warn(g,...w){this.f(p.Warning)&&this.g(p.Warning,s([g,...w]))}error(g,...w){if(this.f(p.Error))if(g instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=g.stack,this.g(p.Error,s(D))}else this.g(p.Error,s([g,...w]))}flush(){}}e.$dj=o;class f extends a{constructor(g=e.$aj){super(),this.setLevel(g),this.g=!m.$j}trace(g,...w){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...w):console.log(`[main ${y()}]`,g,...w))}debug(g,...w){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...w):console.log(`[main ${y()}]`,g,...w))}info(g,...w){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,g,...w):console.log(`[main ${y()}]`,g,...w))}warn(g,...w){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,g,...w):console.warn(`[main ${y()}]`,g,...w))}error(g,...w){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,g,...w):console.error(`[main ${y()}]`,g,...w))}dispose(){}flush(){}}e.$ej=f;class l extends a{constructor(g=e.$aj,w=!0){super(),this.g=w,this.setLevel(g)}trace(g,...w){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...w):console.log(g,...w))}debug(g,...w){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...w):console.log(g,...w))}info(g,...w){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...w):console.log(g,...w))}warn(g,...w){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...w):console.log(g,...w))}error(g,...w){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...w):console.error(g,...w))}dispose(){}flush(){}}e.$fj=l;class t extends a{constructor(g,w=e.$aj){super(),this.g=g,this.setLevel(w)}trace(g,...w){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(g),...w])}debug(g,...w){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(g),...w])}info(g,...w){this.f(p.Info)&&this.g.log(p.Info,[this.h(g),...w])}warn(g,...w){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(g),...w])}error(g,...w){this.f(p.Error)&&this.g.log(p.Error,[this.h(g),...w])}h(g){return typeof g=="string"?g:(0,C.$Ai)(g,this.f(p.Trace))}dispose(){}flush(){}}e.$gj=t;class i extends a{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const w of this.g)w.setLevel(g);super.setLevel(g)}trace(g,...w){for(const D of this.g)D.trace(g,...w)}debug(g,...w){for(const D of this.g)D.debug(g,...w)}info(g,...w){for(const D of this.g)D.info(g,...w)}warn(g,...w){for(const D of this.g)D.warn(g,...w)}error(g,...w){for(const D of this.g)D.error(g,...w)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.$hj=i;class c extends R.$Sc{constructor(g,w,D){if(super(),this.h=g,this.j=w,this.b=new A.$Ac,this.c=this.B(new T.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Nd),this.onDidChangeVisibility=this.g.event,D)for(const N of D)this.b.set(N.resource,{logger:void 0,info:N})}m(g){return(0,b.$yf)(g)?[...this.b.values()].find(w=>w.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,w){const D=this.n(g),N=(0,b.$yf)(g)?g:w?.id??(0,d.$Di)(D.toString()).toString(16);let M=this.b.get(D)?.logger;const F=w?.logLevel==="always"?p.Trace:w?.logLevel;M||(M=this.s(D,F??this.getLogLevel(D)??this.h,{...w,id:N}));const U={logger:M,info:{resource:D,id:N,logLevel:F,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(U.info),this.b.set(D,U),M}n(g){return(0,b.$yf)(g)?(0,E.$vg)(this.j,`${g}.log`):g}setLogLevel(g,w){if(L.URI.isUri(g)){const D=g,N=w,M=this.b.get(D);M&&N!==M.info.logLevel&&(M.info.logLevel=N===this.h?void 0:N,M.logger?.setLevel(N),this.b.set(M.info.resource,M),this.f.fire([D,N]))}else{this.h=g;for(const[D,N]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,w){const D=this.m(g);D&&w!==!D.info.hidden&&(D.info.hidden=!w,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,w]))}getLogLevel(g){let w;return g&&(w=this.b.get(g)?.info.logLevel),w??this.h}registerLogger(g){const w=this.b.get(g.resource);w?w.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const w=this.b.get(g);w&&(w.logger&&w.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=c;class n{constructor(){this.onDidChangeLogLevel=new T.$Nd().event}setLevel(g){}getLevel(){return p.Info}trace(g,...w){}debug(g,...w){}info(g,...w){}warn(g,...w){}error(g,...w){}critical(g,...w){}dispose(){}flush(){}}e.$jj=n;class r extends n{}e.$kj=r;function u($){if($.verbose)return p.Trace;if(typeof $.logLevel=="string"){const g=S($.logLevel.toLowerCase());if(g!==void 0)return g}return e.$aj}e.$lj=u;function I($){switch($){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$mj=I;function S($){switch($){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$nj=S,e.$oj=new P.$7i("logLevel",I(p.Info))}),define(De[240],Ce([1,0,19,8,9,4,3,16,84,14]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class L extends A.$Sc{constructor(v,y){super(),this.a=v,this.b=y,this.c=this.B(new R.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Rg(0)),this.w=[],this.y=this.B(new T.$Rg(0))}watch(v,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(v,y):this.z(v,y)}n(v,y){const k={path:this.H(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},p=(0,C.$Ub)(this.j,k);return this.r(),(0,A.$Qc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,d.$1)(v))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Sp)(y)),y=>this.G(y),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.j)(0,E.$Op)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.j)(0,E.$Op)(y)&&v.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,y){const k={path:this.H(v),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},p=(0,C.$Ub)(this.w,k);return this.C(),(0,A.$Qc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,d.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,E.$Sp)(v)),v=>this.G(v),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,m.$hc)(v.fsPath)}}e.$Wp=L}),define(De[241],Ce([1,0,53,376,8,28,22,4,33,3,16,12,23,96,29,197,30,234,240,41,238,237]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0,(()=>{try{(0,T.gracefulify)(C)}catch(i){console.error(`Error enabling graceful-fs: ${(0,o.$Ai)(i)}`)}})();class t extends a.$Wp{static{this.I=!1}constructor(c,n){super(c,n),this.onDidChangeCapabilities=m.Event.None,this.N=new R.$Ac(r=>v.$mg.getComparisonKey(r)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$l&&(this.J|=1024)),this.J}async stat(c){try{const{stat:n,symbolicLink:r}=await k.SymlinkSupport.stat(this.H(c));return{type:this.M(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:h.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const n=await k.Promises.readdir(this.H(c),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async u=>{try{let I;u.isSymbolicLink()?I=(await this.stat((0,v.$vg)(c,u.name))).type:I=this.M(u),r.push([u.name,I])}catch(I){this.a.trace(I)}})),r}catch(n){throw this.fb(n)}}M(c,n){let r;return n?.dangling?r=h.FileType.Unknown:c.isFile()?r=h.FileType.File:c.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,n&&(r|=h.FileType.SymbolicLink),r}async O(c){const n=this.H(c);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.N.get(c);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const u=new d.$Sg;return this.N.set(c,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(c)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(c)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(c,n){let r;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(c)})`),r=await this.O(c));const u=this.H(c);return await k.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{r?.dispose()}}P(c){t.I&&this.a.trace(c)}readFileStream(c,n,r){const u=(0,y.$2d)(I=>A.$be.concat(I.map(S=>A.$be.wrap(S))).buffer);return(0,s.$Mp)(this,c,u,I=>I.buffer,{...n,bufferSize:256*1024},r),u}async writeFile(c,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.Q(c)?this.R(c,(0,v.$vg)((0,v.$ug)(c),`${(0,v.$sg)(c)}${r.atomic.postfix}`),n,r):this.S(c,n,r)}async Q(c){try{const n=this.H(c),{symbolicLink:r}=await k.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async R(c,n,r,u){const I=new b.$Rc;try{I.add(await this.O(c)),I.add(await this.O(n)),await this.S(n,r,u,!0);try{await this.rename(n,c,{overwrite:!0})}catch(S){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{I.dispose()}}async S(c,n,r,u){let I;try{const S=this.H(c);if(!r.create||!r.overwrite){if(await k.Promises.exists(S)){if(!r.overwrite)throw(0,h.$lk)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.$lk)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}I=await this.open(c,{create:!0,unlock:r.unlock},u),await this.write(I,0,n,0,n.byteLength)}catch(S){throw await this.gb(c,S)}finally{typeof I=="number"&&await this.close(I)}}static{this.Y=!0}static configureFlushOnWrite(c){t.Y=c}async open(c,n,r){const u=this.H(c);let I;(0,h.$_j)(n)&&!r&&(I=await this.O(c));let S;try{if((0,h.$_j)(n)&&n.unlock)try{const{stat:g}=await k.SymlinkSupport.stat(u);g.mode&128||await k.Promises.chmod(u,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let $;if((0,h.$_j)(n)){if(P.$j)try{await k.Promises.truncate(u,0),$="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}$||($="w")}else $="r";S=await k.Promises.open(u,$)}catch($){throw I?.dispose(),(0,h.$_j)(n)?await this.gb(c,$):this.fb($)}if(this.U.set(S,0),(0,h.$_j)(n)&&this.X.set(S,c),I){const $=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${u})`),this.W.set(S,I),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${u})`),$.dispose())}return S}async close(c){const n=this.W.get(c);try{if(this.U.delete(c),this.X.delete(c)&&t.Y)try{await k.Promises.fdatasync(c)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await k.Promises.close(c)}catch(r){throw this.fb(r)}finally{n&&(this.W.get(c)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.W.delete(c)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),n.dispose())}}async read(c,n,r,u,I){const S=this.Z(c,n);let $=null;try{$=(await k.Promises.read(c,r,u,I,S)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(c,S,$)}return $}Z(c,n){return n===this.U.get(c)?null:n}$(c,n,r){const u=this.U.get(c);typeof u=="number"&&(typeof n=="number"||(typeof r=="number"?this.U.set(c,u+r):this.U.delete(c)))}async write(c,n,r,u,I){return(0,d.$_g)(()=>this.ab(c,n,r,u,I),100,3)}async ab(c,n,r,u,I){const S=this.Z(c,n);let $=null;try{$=(await k.Promises.write(c,r,u,I,S)).bytesWritten}catch(g){throw await this.gb(this.X.get(c),g)}finally{this.$(c,S,$)}return $}async mkdir(c){try{await k.Promises.mkdir(this.H(c))}catch(n){throw this.fb(n)}}async delete(c,n){try{const r=this.H(c);if(n.recursive){let u;n?.atomic!==!1&&n.atomic.postfix&&(u=(0,L.$jc)((0,L.$mc)(r),`${(0,L.$nc)(r)}${n.atomic.postfix}`)),await k.Promises.rm(r,k.RimRafMode.MOVE,u)}else try{await k.Promises.unlink(r)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let I=!1;try{const{stat:S,symbolicLink:$}=await k.SymlinkSupport.stat(r);I=S.isDirectory()&&!$}catch{}if(I)await k.Promises.rmdir(r);else throw u}else throw u}}catch(r){throw this.fb(r)}}async rename(c,n,r){const u=this.H(c),I=this.H(n);if(u!==I)try{await this.bb(c,n,"move",r.overwrite),await k.Promises.rename(u,I)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(2,null,(0,L.$nc)(u),(0,L.$nc)((0,L.$mc)(I)),S.toString()))),this.fb(S)}}async copy(c,n,r){const u=this.H(c),I=this.H(n);if(u!==I)try{await this.bb(c,n,"copy",r.overwrite),await k.Promises.copy(u,I,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(3,null,(0,L.$nc)(u),(0,L.$nc)((0,L.$mc)(I)),S.toString()))),this.fb(S)}}async bb(c,n,r,u){const I=this.H(c),S=this.H(n);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Wf)(I,S,!0)),$){if(r==="copy")throw(0,h.$lk)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const w=await this.L(c);if(!w)throw(0,h.$lk)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(n);if(D){if(!u)throw(0,h.$lk)((0,p.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);w.type&h.FileType.File&&D.type&h.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,n){return this.cb(c,n,!1)}async cb(c,n,r){const u=this.H(c),I=this.H(n),S=!!(this.capabilities&1024);if((0,E.$Wf)(u,I,!S))return;const $=new b.$Rc;try{$.add(await this.O(c)),$.add(await this.O(n)),r&&await k.Promises.mkdir((0,L.$mc)(I),{recursive:!0}),await k.Promises.copyFile(u,I)}catch(g){if(g.code==="ENOENT"&&!r)return this.cb(c,n,!0);throw this.fb(g)}finally{$.dispose()}}t(c,n,r){return new f.$4p(u=>c(u),u=>n(u),r)}F(c,n,r){return new l.$_p(u=>c(u),u=>n(u),r)}fb(c){if(c instanceof h.$kk)return c;let n=c,r;switch(c.code){case"ENOENT":r=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=h.FileSystemProviderErrorCode.Unknown;break;default:r=h.FileSystemProviderErrorCode.Unknown}return(0,h.$lk)(n,r)}async gb(c,n){let r=this.fb(n);if(c&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await k.SymlinkSupport.stat(this.H(c));u.mode&128||(r=(0,h.$lk)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return r}}e.$aq=t}),define(De[242],Ce([1,0,3,14]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;class d extends C.$Sc{constructor(A,m=[]){super(),this.a=new T.$hj([A,...m]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$JN=d}),define(De[243],Ce([1,0,30,14]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;var d;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(d||(d={}));async function R(b,L,P,v,y){try{const k=await new Promise((h,s)=>{$e(["@vscode/spdlog"],h,s)});k.setFlushOn(d.Trace);const p=await k.createAsyncRotatingLogger(b,L,P,v);return y?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(k){console.error(k)}return null}function A(b,L,P){switch(L){case T.LogLevel.Trace:b.trace(P);break;case T.LogLevel.Debug:b.debug(P);break;case T.LogLevel.Info:b.info(P);break;case T.LogLevel.Warning:b.warn(P);break;case T.LogLevel.Error:b.error(P);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function m(b,L){switch(L){case T.LogLevel.Trace:b.setLevel(d.Trace);break;case T.LogLevel.Debug:b.setLevel(d.Debug);break;case T.LogLevel.Info:b.setLevel(d.Info);break;case T.LogLevel.Warning:b.setLevel(d.Warning);break;case T.LogLevel.Error:b.setLevel(d.Error);break;case T.LogLevel.Off:b.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class E extends T.$dj{constructor(L,P,v,y,k){super(),this.m=[],this.setLevel(k),this.n=this.s(L,P,v,y),this.B(this.onDidChangeLogLevel(p=>{this.r&&m(this.r,p)}))}async s(L,P,v,y){const k=v?6:1,p=30/k*C.$Gk.MB,h=await R(L,P,p,k,y);if(h){this.r=h,m(this.r,this.getLevel());for(const{level:s,message:a}of this.m)A(this.r,s,a);this.m=[]}}g(L,P){this.r?A(this.r,L,P):this.getLevel()<=L&&this.m.push({level:L,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$yN=E}),define(De[133],Ce([1,0,38,198,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function b(k,p){return p-k}E.compare=b;const L=Object.create(null);L[E.Error]=(0,T.localize)(0,null),L[E.Warning]=(0,T.localize)(1,null),L[E.Info]=(0,T.localize)(2,null);function P(k){return L[k]||""}E.toString=P;function v(k){switch(k){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=v;function y(k){switch(k){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var m;(function(E){const b="";function L(v){return P(v,!0)}E.makeKey=L;function P(v,y){const k=[b];return v.source?k.push(v.source.replace("\xA6","\\\xA6")):k.push(b),v.code?typeof v.code=="string"?k.push(v.code.replace("\xA6","\\\xA6")):k.push(v.code.value.replace("\xA6","\\\xA6")):k.push(b),v.severity!==void 0&&v.severity!==null?k.push(A.toString(v.severity)):k.push(b),v.message&&y?k.push(v.message.replace("\xA6","\\\xA6")):k.push(b),v.startLineNumber!==void 0&&v.startLineNumber!==null?k.push(v.startLineNumber.toString()):k.push(b),v.startColumn!==void 0&&v.startColumn!==null?k.push(v.startColumn.toString()):k.push(b),v.endLineNumber!==void 0&&v.endLineNumber!==null?k.push(v.endLineNumber.toString()):k.push(b),v.endColumn!==void 0&&v.endColumn!==null?k.push(v.endColumn.toString()):k.push(b),k.push(b),k.join("\xA6")}E.makeKeyOptionalMessage=P})(m||(e.IMarkerData=m={})),e.$_s=(0,d.$Ph)("markerService")}),define(De[244],Ce([1,0,4,38,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Zu=e.Severity=void 0,e.Severity=T.default,e.$Zu=(0,d.$Ph)("notificationService");var R;(function(L){L[L.DEFAULT=0]="DEFAULT",L[L.SILENT=1]="SILENT",L[L.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var A;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.PROFILE=1]="PROFILE",L[L.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new b,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$1u=E;class b{infinite(){}done(){}total(P){}worked(P){}}e.$2u=b}),define(De[134],Ce([1,0,15,2,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nU=e.$mU=e.$lU=e.$kU=e.$jU=void 0,e.$jU=(0,d.$Ph)("openerService");function R(b,L){return T.URI.isUri(b)?(0,C.$2e)(b.scheme,L):(0,C.$3e)(b,L+":")}e.$kU=R;function A(b,...L){return L.some(P=>R(b,P))}e.$lU=A;function m(b,L){return b.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.$mU=m;function E(b){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(b.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},b=b.with({fragment:""})),{selection:L,uri:b}}e.$nU=E}),define(De[245],Ce([1,0,12,48]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.context<"u"){const R=C.$h.vscode.context.configuration();if(R)d=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(d=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:R.version})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(De[135],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,C.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(C,T){e(C,T,$e)}};define(De[64],Ce([1,0,8,21,3,5]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProgressLocation=e.$3u=void 0,e.$3u=(0,R.$Ph)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$4u=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(v){this.b=v}report(v){this.a=v,this.b(this.a)}}e.$5u=m;class E{get value(){return this.a}constructor(v){this.e=v}report(v){this.b?this.b.push(v):this.b=[v],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const v=this.b.shift();this.a=v,await this.e(this.a)}}finally{this.c=!1;const v=this.d;this.d=void 0,v?.()}}drain(){return this.c?new Promise(v=>{const y=this.d;this.d=()=>{y?.(),v()}}):Promise.resolve()}}e.$6u=E;let b=class extends d.$Sc{constructor(v,y){super(),this.a=new C.$ch,y.withProgress(v,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,d.$Qc)(()=>this.a.complete()))}report(v){this.b?this.b.report(v):this.c=v}};e.$7u=b,e.$7u=b=He([Be(1,e.$3u)],b);class L extends d.$Sc{constructor(v){super(),this.g=v,this.a=0,this.b=this.B(new d.$Rc)}start(v){this.stop();const y=++this.a,k=new T.$Xd;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},v),this.b.add((0,d.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,d.$Qc)(()=>k.cancel())),this.b.add((0,d.$Qc)(()=>this.c?this.c.done():void 0)),{id:y,token:k.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(v){this.a===v&&this.b.clear()}}e.$8u=L,e.$9u=(0,R.$Ph)("editorProgressService")}),define(De[43],Ce([1,0,58,17]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class d{constructor(){this.a=new Map}add(A,m){C.ok(T.$yf(A)),C.ok(T.$Af(m)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$gn=new d}),define(De[105],Ce([1,0,4,43]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function d(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new C.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,b){this.a[d(E)]=b,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;T.$gn.add(e.$hn.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,17,188,50,105,43]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var b;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$ln={Configuration:"base.contributions.configuration"};var L;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const P=E.$gn.as(m.$hn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new T.$Nd,this.onDidSchemaChange=this.i.event,this.j=new T.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(t,i=!0){this.registerConfigurations([t],i)}registerConfigurations(t,i=!0){const c=new Set;this.n(t,i,c),P.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const i=new Set;this.o(t,i),P.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:t,remove:i}){const c=new Set;this.o(i,c),this.n(t,!1,c),P.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const i=new Set;this.k(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(t,i){const c=[];for(const{overrides:n,source:r}of t)for(const u in n)if(i.add(u),e.$vn.test(u)){const I=this.a.get(u),S=I?.valuesSources??new Map;if(r)for(const D of Object.keys(n[u]))S.set(D,r);const $={...I?.value||{},...n[u]};this.a.set(u,{source:r,value:$,valuesSources:S});const g=(0,A.$ti)(u),w={type:"object",default:$,description:R.localize(1,null,g),$ref:e.$sn,defaultDefaultValue:$,source:d.$yf(r)?void 0:r,defaultValueSource:r};c.push(...p(u)),this.d[u]=w,this.b.properties[u]=w}else{this.a.set(u,{value:n[u],source:r});const I=this.d[u];I&&(this.w(u,I),this.r(u,I))}this.m(c)}deregisterDefaultConfigurations(t){const i=new Set;this.l(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(t,i){for(const{overrides:c,source:n}of t)for(const r in c){const u=this.a.get(r),I=d.$yf(n)?n:n?.id,S=d.$yf(u?.source)?u?.source:u?.source?.id;if(I===S)if(i.add(r),this.a.delete(r),e.$vn.test(r))delete this.d[r],delete this.b.properties[r];else{const $=this.d[r];$&&(this.w(r,$),this.r(r,$))}}this.u()}deltaConfiguration(t){let i=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),i=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),i=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const i of t)this.h.add(i);this.u()}n(t,i,c){t.forEach(n=>{this.p(n,i,n.extensionInfo,n.restrictedProperties,void 0,c),this.c.push(n),this.q(n)})}o(t,i){const c=n=>{if(n.properties)for(const r in n.properties){i.add(r);const u=this.d[r];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>c(r))};for(const n of t){c(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,i=!0,c,n,r=3,u){r=d.$Hf(t.scope)?r:t.scope;const I=t.properties;if(I)for(const $ in I){const g=I[$];if(i&&o($,g)){delete I[$];continue}if(g.source=c,g.defaultDefaultValue=I[$].default,this.w($,g),e.$vn.test($)?g.scope=void 0:(g.scope=d.$Hf(g.scope)?r:g.scope,g.restricted=d.$Hf(g.restricted)?!!n?.includes($):g.restricted),I[$].hasOwnProperty("included")&&!I[$].included){this.f[$]=I[$],delete I[$];continue}else this.d[$]=I[$],I[$].policy?.name&&this.e.set(I[$].policy.name,$);!I[$].deprecationMessage&&I[$].markdownDeprecationMessage&&(I[$].deprecationMessage=I[$].markdownDeprecationMessage),u.add($)}const S=t.allOf;if(S)for(const $ of S)this.p($,i,c,n,r,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const i=c=>{const n=c.properties;if(n)for(const u in n)this.r(u,n[u]);c.allOf?.forEach(i)};i(t)}r(t,i){switch(e.$mn.properties[t]=i,i.scope){case 1:e.$nn.properties[t]=i;break;case 2:e.$on.properties[t]=i;break;case 6:e.$pn.properties[t]=i;break;case 3:e.$qn.properties[t]=i;break;case 4:e.$rn.properties[t]=i;break;case 5:e.$rn.properties[t]=i,this.g.properties[t]=i;break}}s(t,i){switch(delete e.$mn.properties[t],i.scope){case 1:delete e.$nn.properties[t];break;case 2:delete e.$on.properties[t];break;case 6:delete e.$pn.properties[t];break;case 3:delete e.$qn.properties[t];break;case 4:case 5:delete e.$rn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const i=`[${t}]`,c={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$sn};this.w(i,c),e.$mn.properties[i]=c,e.$nn.properties[i]=c,e.$on.properties[i]=c,e.$pn.properties[i]=c,e.$qn.properties[i]=c,e.$rn.properties[i]=c}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=t,e.$nn.patternProperties[e.$un]=t,e.$on.patternProperties[e.$un]=t,e.$pn.patternProperties[e.$un]=t,e.$qn.patternProperties[e.$un]=t,e.$rn.patternProperties[e.$un]=t,this.i.fire()}w(t,i){const c=this.a.get(t);let n=c?.value,r=c?.source;d.$Ff(n)&&(n=i.defaultDefaultValue,r=void 0),d.$Ff(n)&&(n=s(i.type)),i.default=n,i.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",k=new RegExp(y,"g");e.$un=`^(${y})+$`,e.$vn=new RegExp(e.$un);function p(l){const t=[];if(e.$vn.test(l)){let i=k.exec(l);for(;i?.length;){const c=i[1].trim();c&&t.push(c),i=k.exec(l)}}return(0,C.$Mb)(t)}e.$wn=p;function h(l){return l.reduce((t,i)=>`${t}[${i}]`,"")}e.$xn=h;function s(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=s;const a=new v;E.$gn.add(e.$ln.Configuration,a);function o(l,t){return l.trim()?e.$vn.test(l)?R.localize(7,null,l):a.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,l,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$zn=o;function f(){const l=[],t=a.getConfigurationProperties();for(const i of Object.keys(t))l.push([i,t[i].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$An=f}),define(De[246],Ce([1,0,19,4,157,3,28,24,17,2,50,136,43]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function y(i){return Object.isFrozen(i)?i:m.$8m(i)}class k{constructor(c={},n=[],r=[],u){this.b=c,this.c=n,this.d=r,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(n=>{if(n instanceof k)return n;const r=new p("");return r.parseRaw(n),r.configurationModel});this.f=c.reduce((n,r)=>r===n?r:n.merge(r),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,L.$ri)(this.contents,c):this.contents}inspect(c,n){const r=this.rawConfiguration.getValue(c),u=n?this.rawConfiguration.getOverrideValue(c,n):void 0,I=n?this.rawConfiguration.override(n).getValue(c):r;return{value:r,override:u,merged:I}}getOverrideValue(c,n){const r=this.i(n);return r?c?(0,L.$ri)(r,c):r:void 0}getKeysForOverrideIdentifier(c){const n=[];for(const r of this.overrides)r.identifiers.includes(c)&&n.push(...r.keys);return C.$Mb(n)}getAllOverrideIdentifiers(){const c=[];for(const n of this.overrides)c.push(...n.identifiers);return C.$Mb(c)}override(c){let n=this.a.get(c);return n||(n=this.g(c),this.a.set(c,n)),n}merge(...c){const n=m.$7m(this.contents),r=m.$7m(this.overrides),u=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of c)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(n,S.contents);for(const $ of S.overrides){const[g]=r.filter(w=>C.$ub(w.identifiers,$.identifiers));g?(this.h(g.contents,$.contents),g.keys.push(...$.keys),g.keys=C.$Mb(g.keys)):r.push(m.$7m($))}for(const $ of S.keys)u.indexOf($)===-1&&u.push($)}return new k(n,u,r,I.every(S=>S instanceof k)?void 0:I)}g(c){const n=this.i(c);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const u of C.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let I=this.contents[u];const S=n[u];S&&(typeof I=="object"&&typeof S=="object"?(I=m.$7m(I),this.h(I,S)):I=S),r[u]=I}return new k(r,this.keys,this.overrides)}h(c,n){for(const r of Object.keys(n)){if(r in c&&E.$Af(c[r])&&E.$Af(n[r])){this.h(c[r],n[r]);continue}c[r]=m.$7m(n[r])}}i(c){let n=null,r=null;const u=I=>{I&&(r?this.h(r,I):r=m.$7m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===c?n=I.contents:I.identifiers.includes(c)&&u(I.contents);return u(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,n){this.j(c,n,!0)}setValue(c,n){this.j(c,n,!1)}removeValue(c){const n=this.keys.indexOf(c);n!==-1&&(this.keys.splice(n,1),(0,L.$qi)(this.contents,c),P.$vn.test(c)&&this.overrides.splice(this.overrides.findIndex(r=>C.$ub(r.identifiers,(0,P.$wn)(c))),1))}j(c,n,r){(0,L.$pi)(this.contents,c,n,u=>console.error(u)),r=r||this.keys.indexOf(c)===-1,r&&this.keys.push(c),P.$vn.test(c)&&this.overrides.push({identifiers:(0,P.$wn)(c),keys:Object.keys(this.contents[c]),contents:(0,L.$oi)(this.contents[c],u=>console.error(u))})}}e.$Bn=k;class p{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,n){if(!E.$Hf(c)){const r=this.g(c);this.parseRaw(r,n)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,n){this.a=c;const{contents:r,keys:u,overrides:I,restricted:S,hasExcludedProperties:$}=this.h(c,n);this.b=new k(r,u,I,$?[c]:void 0),this.c=S||[]}g(c){let n={},r=null,u=[];const I=[],S=[];function $(w){Array.isArray(u)?u.push(w):r!==null&&(u[r]=w)}const g={onObjectBegin:()=>{const w={};$(w),I.push(u),u=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{u=I.pop()},onArrayBegin:()=>{const w=[];$(w),I.push(u),u=w,r=null},onArrayEnd:()=>{u=I.pop()},onLiteralValue:$,onError:(w,D,N)=>{S.push({error:w,offset:D,length:N})}};if(c)try{d.$4m(c,g),n=u[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return n}h(c,n){const r=v.$gn.as(P.$ln.Configuration).getConfigurationProperties(),u=this.i(c,r,!0,n);c=u.raw;const I=(0,L.$oi)(c,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(c),$=this.j(c,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:I,keys:S,overrides:$,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(c,n,r,u){let I=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:I};const S={},$=[];for(const g in c)if(P.$vn.test(g)&&r){const w=this.i(c[g],n,!1,u);S[g]=w.raw,I=I||w.hasExcludedProperties,$.push(...w.restricted)}else{const w=n[g],D=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&$.push(g),!u.exclude?.includes(g)&&(u.include?.includes(g)||(D===void 0||u.scopes===void 0||u.scopes.includes(D))&&!(u.skipRestricted&&w?.restricted))?S[g]=c[g]:I=!0}return{raw:S,restricted:$,hasExcludedProperties:I}}j(c,n){const r=[];for(const u of Object.keys(c))if(P.$vn.test(u)){const I={};for(const S in c[u])I[S]=c[u][S];r.push({identifiers:(0,P.$wn)(u),keys:Object.keys(I),contents:(0,L.$oi)(I,n)})}return r}}e.$Cn=p;class h extends R.$Sc{constructor(c,n,r,u){super(),this.c=c,this.f=n,this.g=u,this.b=this.B(new T.$Nd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&r.isEqual(I.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=h;class s{constructor(c,n,r,u,I,S,$,g,w,D,N,M,F){this.a=c,this.b=n,this.c=r,this.overrideIdentifiers=u,this.d=I,this.f=S,this.g=$,this.h=g,this.i=w,this.j=D,this.k=N,this.l=M,this.m=F}get value(){return y(this.c)}n(c,n,r){const u=c.inspect(n,r);return{get value(){return y(u.value)},get override(){return y(u.override)},get merged(){return y(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(c,n,r,u,I=new k,S=new k,$=new A.$Ac,g=new k,w=new A.$Ac){this.c=c,this.d=n,this.f=r,this.g=u,this.h=I,this.i=S,this.j=$,this.l=g,this.m=w,this.a=null,this.b=new A.$Ac,this.n=null}getValue(c,n,r){return this.q(c,n,r).getValue(c)}updateValue(c,n,r={}){let u;r.resource?(u=this.m.get(r.resource),u||(u=new k,this.m.set(r.resource,u))):u=this.l,n===void 0?u.removeValue(c):u.setValue(c,n),r.resource||(this.a=null)}inspect(c,n,r){const u=this.q(c,n,r),I=this.u(n.resource,r),S=n.resource?this.m.get(n.resource)||this.l:this.l,$=new Set;for(const g of u.overrides)for(const w of g.identifiers)u.getOverrideValue(c,w)!==void 0&&$.add(w);return new s(c,n,u.getValue(c),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,I||void 0,S)}keys(c){const n=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,n){this.j.set(c,n),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,n){const r=[];if(!n){const{added:u,updated:I,removed:S}=l(this.c,c);n=[...u,...I,...S]}for(const u of n)for(const I of(0,P.$wn)(u)){const S=this.c.getKeysForOverrideIdentifier(I),$=c.getKeysForOverrideIdentifier(I),g=[...$.filter(w=>S.indexOf(w)===-1),...S.filter(w=>$.indexOf(w)===-1),...S.filter(w=>!m.$$m(this.c.override(I).getValue(w),c.override(I).getValue(w)))];r.push([I,g])}return this.updateDefaultConfiguration(c),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(c){const{added:n,updated:r,removed:u}=l(this.d,c),I=[...n,...r,...u];return I.length&&this.updatePolicyConfiguration(c),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:n,updated:r,removed:u,overrides:I}=l(this.applicationConfiguration,c),S=[...n,...r,...u];return S.length&&this.updateApplicationConfiguration(c),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(c){const{added:n,updated:r,removed:u,overrides:I}=l(this.localUserConfiguration,c),S=[...n,...r,...u];return S.length&&this.updateLocalUserConfiguration(c),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(c){const{added:n,updated:r,removed:u,overrides:I}=l(this.remoteUserConfiguration,c),S=[...n,...r,...u];return S.length&&this.updateRemoteUserConfiguration(c),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(c){const{added:n,updated:r,removed:u,overrides:I}=l(this.workspaceConfiguration,c),S=[...n,...r,...u];return S.length&&this.updateWorkspaceConfiguration(c),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(c,n){const r=this.p.get(c),{added:u,updated:I,removed:S,overrides:$}=l(r,n),g=[...u,...I,...S];return(g.length||!r)&&this.updateFolderConfiguration(c,n),{keys:g,overrides:$}}compareAndDeleteFolderConfiguration(c){const n=this.p.get(c);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:r,updated:u,removed:I,overrides:S}=l(n,void 0);return{keys:[...r,...u,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,n,r){let u=this.r(n,r);return n.overrideIdentifier&&(u=u.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(u=u.merge(this.d)),u}r({resource:c},n){let r=this.s();if(n&&c){const u=n.getFolder(c);u&&(r=this.t(u.uri)||r);const I=this.m.get(c);I&&(r=r.merge(I))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let n=this.b.get(c);if(!n){const r=this.s(),u=this.j.get(c);u?(n=r.merge(u),this.b.set(c,n)):n=r}return n}u(c,n){if(n&&c){const r=n.getFolder(c);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,n)=>{const{contents:r,overrides:u,keys:I}=this.j.get(n);return c.push([n,{contents:r,overrides:u,keys:I}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(n=>c.add(n)),this.userConfiguration.keys.forEach(n=>c.add(n)),this.i.keys.forEach(n=>c.add(n)),this.j.forEach(n=>n.keys.forEach(r=>c.add(r))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>c.add(r))),[...c.values()]}w(c){const n=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(c).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(c).forEach(u=>n.add(u))),[...n.values()]}static parse(c){const n=this.x(c.defaults),r=this.x(c.policy),u=this.x(c.application),I=this.x(c.user),S=this.x(c.workspace),$=c.folders.reduce((g,w)=>(g.set(b.URI.revive(w[0]),this.x(w[1])),g),new A.$Ac);return new a(n,r,u,I,new k,S,$,new k,new A.$Ac)}static x(c){return new k(c.contents,c.keys,c.overrides)}}e.$En=a;function o(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const c=new Set,n=new Map;for(const u of i)u.keys.forEach(I=>c.add(I)),u.overrides.forEach(([I,S])=>{const $=(0,A.$xc)(n,I,new Set);S.forEach(g=>$.add(g))});const r=[];return n.forEach((u,I)=>r.push([I,[...u.values()]])),{keys:[...c.values()],overrides:r}}e.$Fn=o;class f{constructor(c,n,r,u){this.change=c,this.f=n,this.g=r,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of c.keys)this.affectedKeys.add(I);for(const[,I]of c.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(c,n){const r=this.a+c,u=this.d.indexOf(r);if(u<0)return!1;const I=u+r.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(n){const $=this.previousConfiguration?this.previousConfiguration.getValue(c,n,this.f?.workspace):void 0,g=this.g.getValue(c,n,this.h);return!m.$$m($,g)}return!0}}e.$Gn=f;function l(i,c){const{added:n,removed:r,updated:u}=t(c?.rawConfiguration,i?.rawConfiguration),I=[],S=i?.getAllOverrideIdentifiers()||[],$=c?.getAllOverrideIdentifiers()||[];if(c){const g=$.filter(w=>!S.includes(w));for(const w of g)I.push([w,c.getKeysForOverrideIdentifier(w)])}if(i){const g=S.filter(w=>!$.includes(w));for(const w of g)I.push([w,i.getKeysForOverrideIdentifier(w)])}if(c&&i){for(const g of S)if($.includes(g)){const w=t({contents:i.getOverrideValue(void 0,g)||{},keys:i.getKeysForOverrideIdentifier(g)},{contents:c.getOverrideValue(void 0,g)||{},keys:c.getKeysForOverrideIdentifier(g)});I.push([g,[...w.added,...w.removed,...w.updated]])}}return{added:n,removed:r,updated:u,overrides:I}}function t(i,c){const n=i?c?i.keys.filter(I=>c.keys.indexOf(I)===-1):[...i.keys]:[],r=c?i?c.keys.filter(I=>i.keys.indexOf(I)===-1):[...c.keys]:[],u=[];if(i&&c){for(const I of c.keys)if(i.keys.indexOf(I)!==-1){const S=(0,L.$ri)(c.contents,I),$=(0,L.$ri)(i.contents,I);m.$$m(S,$)||u.push(I)}}return{added:n,removed:r,updated:u}}}),define(De[247],Ce([1,0,22,4,3,82]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikb=e.$Hkb=e.$Gkb=e.$Fkb=void 0;const A=(b,L,P)=>{const v=new Uint8Array(16);for(let p=0;p<16;p++)v[p]=Math.round(Math.random()*256);const y=(0,C.$ve)(C.$be.wrap(v));return[`GET ws://localhost${b}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$Fkb=A,e.$Gkb=C.$be.fromString(`\r
\r
`);async function m(b,L,P,v,y){b.write(C.$be.fromString((0,e.$Fkb)(L,P,v)));const k=new d.$Rc;try{return await new Promise((p,h)=>{let s;k.add(b.onData(a=>{s?s=C.$be.concat([s,a],s.byteLength+a.byteLength):s=a;const o=s.indexOf(e.$Gkb);if(o===-1)return;p(b),b.pauseData();const f=s.slice(o+e.$Gkb.byteLength);f.byteLength&&y.onData.fire(f)})),k.add(b.onClose(a=>h(a??new Error("socket closed")))),k.add(b.onEnd(()=>h(new Error("socket ended"))))})}catch(p){throw b.dispose(),p}finally{k.dispose()}}e.$Hkb=m;class E extends d.$Sc{constructor(L,P){super(),this.g=L,this.a=this.B(new T.$Qd),this.onData=(...v)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...v)),this.b=this.B(new T.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(v=>this.a.fire(v))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,L,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Ikb=E}),define(De[65],Ce([1,0,9,5]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,T.$Ph)("remoteAuthorityResolverService");var d;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=R;class A{constructor(P,v){this.host=P,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=A;var m;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class E extends C.$bb{static isNotAvailable(P){return P instanceof E&&P._code===m.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof E&&P._code===m.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof E&&P._code===m.NoResolverFound}static isInvalidAuthority(P){return P instanceof E&&P._code===m.InvalidAuthority}static isHandled(P){return P instanceof E&&P.isHandled}constructor(P,v=m.Unknown,y){super(P),this._message=P,this._code=v,this._detail=y,this.isHandled=v===m.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Sk=E;function b(L){const P=L.indexOf("+");return P===-1?L:L.substring(0,P)}e.$Tk=b}),define(De[66],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function T(b){return b.scheme===C.Schemas.vscodeRemote?b.authority:void 0}e.$Uk=T;function d(b){if(!b)return;const L=b.indexOf("+");return L<0?b:b.substr(0,L)}e.$Vk=d;function R(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Wk=R;function A(b){const{host:L,port:P}=E(b);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.$Xk=A;function m(b,L){let{host:P,port:v}=E(b);return typeof v>"u"&&(v=L),{host:P,port:v}}e.$Yk=m;function E(b){const L=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=b.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const v=b.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:b,port:void 0}}}),define(De[25],Ce([1,0,15,5,66]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function R(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$4l=R,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class E{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,s){if(typeof h>"u"||h===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof h=="string"||typeof s=="string"){const a=typeof h=="string"?h:h.value,o=typeof s=="string"?s:s.value;return C.$2e(a,o)}return h._lower===s._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$6l=E;class b{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const s of h)this.add(s)}add(h){this.c.add(E.toKey(h))}delete(h){return this.c.delete(E.toKey(h))}has(h){return this.c.has(E.toKey(h))}}e.$7l=b;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(E.toKey(h))}get(h){return this.c.get(E.toKey(h))}has(h){return this.c.has(E.toKey(h))}set(h,s){this.c.set(E.toKey(h),s)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=L;function P(p){return v(p)}e.$9l=P;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$0l=v;function y(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$$l=y;function k(p,h){if(h){const s=`onResolveRemoteAuthority:${(0,d.$Vk)(h)}`;return!!p.activationEvents?.includes(s)}return!1}e.$_l=k,e.$am=(0,T.$Ph)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,9,25]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.$XE=void 0;class d{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const E of A){const b=this.readActivationEvents(E);b.length>0&&(m[T.$6l.toKey(E.identifier)]=b)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return m;for(const E in A.contributes){const b=this.a.get(E);if(!b)continue;const L=A.contributes[E],P=Array.isArray(L)?L:[L];try{b(P,m)}catch(v){(0,C.$1)(v)}}return m}}e.$XE=d,e.$YE=new d}),define(De[248],Ce([1,0,8,22,21,9,4,3,54,35,31,82,65,66]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.PersistentConnectionEventType=e.$6k=e.$5k=e.$4k=e.ConnectionType=void 0;const k=30*1e3;var p;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function h(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(H){const B=new d.$Xd;return setTimeout(()=>B.cancel(),H),B.token}function a(H,B){if(H.isCancellationRequested||B.isCancellationRequested)return d.CancellationToken.Cancelled;const X=new d.$Xd;return H.onCancellationRequested(()=>X.cancel()),B.onCancellationRequested(()=>X.cancel()),X.token}class o{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new m.$Rc,this.promise=new Promise((X,re)=>{this.f=X,this.g=re}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function f(H,B){const X=new o(B);return X.registerDisposable(H.onControlMessage(re=>{const Y=JSON.parse(re.toString()),_=G(Y);_?X.reject(_):X.resolve(Y)})),X.promise}function l(H,B,X,re,Y,_,x,ve){const ae=new o(ve),fe=b.$Jd.create(!1);return H.info(`Creating a socket (${x})...`),E.mark(`code/willCreateSocket/${_}`),B.connect(X,re,Y,x).then(ee=>{ae.didTimeout?(E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(E.mark(`code/didCreateSocketOK/${_}`),H.info(`Creating a socket (${x}) was successful after ${fe.elapsed()} ms.`),ae.resolve(ee))},ee=>{E.mark(`code/didCreateSocketError/${_}`),H.info(`Creating a socket (${x}) returned an error after ${fe.elapsed()} ms.`),H.error(ee),ae.reject(ee)}),ae.promise}function t(H,B){const X=new o(B);return H.then(re=>{X.didTimeout||X.resolve(re)},re=>{X.didTimeout||X.reject(re)}),X.promise}async function i(H,B,X,re){const Y=ce(H,B);H.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let _;try{_=await l(H.logService,H.remoteSocketFactoryService,H.connectTo,(0,y.$Wk)(H),`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,h(B),`renderer-${h(B)}-${H.reconnectionToken}`,re)}catch(ee){throw H.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ee),ee}H.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let x,ve;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(_,null),x=H.reconnectionProtocol,ve=!1):(x=new P.$Dh({socket:_}),ve=!0),H.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const ae=await t(H.signService.createNewMessage((0,L.$eg)()),re),fe={type:"auth",auth:H.connectionToken||"00000000000000000000",data:ae.data};x.sendControl(T.$be.fromString(JSON.stringify(fe)));try{const ee=await f(x,a(re,s(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const z=new Error("Unexpected handshake message");throw z.code="VSCODE_CONNECTION_ERROR",z}if(H.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await t(H.signService.validate(ae,ee.signedData),re)){const z=new Error("Refused to connect to unsupported server");throw z.code="VSCODE_CONNECTION_ERROR",z}const be=await t(H.signService.sign(ee.data),re),Pe={type:"connectionType",commit:H.commit,signedData:be,desiredConnectionType:B};return X&&(Pe.args=X),H.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(T.$be.fromString(JSON.stringify(Pe))),{protocol:x,ownsProtocol:ve}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(H.logService.error(`${Y} the handshake timed out. Error:`),H.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${Y} received error control message when negotiating connection. Error:`),H.logService.error(ee)),ve&&te(x),ee}}async function c(H,B,X,re){const Y=Date.now(),_=ce(H,B),{protocol:x,ownsProtocol:ve}=await i(H,B,X,re),ae=new o(re);return ae.registerDisposable(x.onControlMessage(fe=>{const ee=JSON.parse(fe.toString()),de=G(ee);de?(H.logService.error(`${_} received error control message when negotiating connection. Error:`),H.logService.error(de),ve&&te(x),ae.reject(de)):(H.reconnectionProtocol?.endAcceptReconnection(),H.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${ye(Y)}!`),ae.resolve({protocol:x,firstMessage:ee}))})),ae.promise}async function n(H,B){const{protocol:X}=await c(H,1,void 0,B);return{protocol:X}}async function r(H,B,X){const{protocol:re,firstMessage:Y}=await c(H,2,B,X),_=Y&&Y.debugPort;return{protocol:re,debugPort:_}}async function u(H,B,X){const re=Date.now(),Y=ce(H,3),{protocol:_}=await i(H,3,B,X);return H.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${ye(re)}!`),_}async function I(H,B,X){const{connectTo:re,connectionToken:Y}=await H.addressProvider.getAddress();return{commit:H.commit,quality:H.quality,connectTo:re,connectionToken:Y,reconnectionToken:B,reconnectionProtocol:X,remoteSocketFactoryService:H.remoteSocketFactoryService,signService:H.signService,logService:H.logService}}async function S(H,B,X){return g(H,async re=>{const{protocol:Y}=await n(re,d.CancellationToken.None);return new K(H,B,X,re.reconnectionToken,Y)})}e.$4k=S;async function $(H,B){return g(H,async X=>{const{protocol:re,debugPort:Y}=await r(X,B,d.CancellationToken.None);return new me(H,B,X.reconnectionToken,re,Y)})}e.$5k=$;async function g(H,B){for(let re=1;;re++)try{const Y=(0,L.$eg)(),_=await I(H,Y,null);return await B(_)}catch(Y){if(re<5)H.logService.error(`[remote-connection][attempt ${re}] An error occurred in initial connection! Will retry... Error:`),H.logService.error(Y);else throw H.logService.error(`[remote-connection][attempt ${re}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),H.logService.error(Y),q.triggerPermanentFailure(0,0,v.$Sk.isHandled(Y)),Y}}async function w(H,B,X){const re=await I(H,(0,L.$eg)(),null);return await u(re,{host:B,port:X},d.CancellationToken.None)}e.$6k=w;function D(H){return(0,C.$Hg)(B=>new Promise((X,re)=>{const Y=setTimeout(X,H*1e3);B.onCancellationRequested(()=>{clearTimeout(Y),X()})}))}var N;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class M{constructor(B,X){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.type=0}}e.$7k=M;class F{constructor(B,X,re,Y){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.durationSeconds=re,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.$8k=F;class U{constructor(B,X,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=2}}e.$9k=U;class j{constructor(B,X,re){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.attempt=re,this.type=4}}e.$0k=j;class O{constructor(B,X,re,Y){this.reconnectionToken=B,this.millisSinceLastIncomingData=X,this.attempt=re,this.handled=Y,this.type=3}}e.$$k=O;class q extends m.$Sc{static triggerPermanentFailure(B,X,re){this._permanentFailure=!0,this.f=B,this.g=X,this.h=re,this.j.forEach(Y=>Y.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||q._permanentFailure}constructor(B,X,re,Y,_){super(),this.t=B,this.u=X,this.reconnectionToken=re,this.protocol=Y,this.w=_,this.m=this.B(new A.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(x=>{const ve=ie(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${ve} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${ve} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${ve} received socket close event.`),this.y()})),this.B(Y.onSocketTimeout(x=>{const ve=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ve} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),q.j.push(this),this.B((0,m.$Qc)(()=>{const x=q.j.indexOf(this);x>=0&&q.j.splice(x,1)})),this.n&&this.D(q.f,q.g,q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const X=[0,5,5,10,10,10,10,10,30];let re=-1;do{re++;const Y=re<X.length?X[re]:X[X.length-1];try{if(Y>0){const x=D(Y);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,x)),this.u.logService.info(`${B} waiting for ${Y} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1)),this.u.logService.info(`${B} resolving connection...`);const _=await I(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${_.connectTo}...`),await this.G(_,s(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),re+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(re>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}if(v.$Sk.isTemporarilyNotAvailable(_)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,R.$4)(_)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof v.$Sk){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,v.$Sk.isHandled(_));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),re+1,!1);break}}while(!this.n&&!this.s)}C(B,X,re){this.w?q.triggerPermanentFailure(B,X,re):this.D(B,X,re)}D(B,X,re){this.m.fire(new O(this.reconnectionToken,B,X,re)),te(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$_k=q;class K extends q{constructor(B,X,re,Y,_){super(1,B,Y,_,!0),this.client=this.B(new P.$Bh(_,{remoteAuthority:X,clientId:re},B.ipcLogger))}async G(B,X){await n(B,X)}}e.$al=K;class me extends q{constructor(B,X,re,Y,_){super(2,B,re,Y,!1),this.H=X,this.debugPort=_}async G(B,X){await r(B,this.H,X)}}e.$bl=me;function te(H){try{H.acceptDisconnect();const B=H.getSocket();H.dispose(),B.dispose()}catch(B){(0,R.$1)(B)}}function G(H){if(H&&H.type==="error"){const B=new Error(`Connection error: ${H.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Q(H,B){for(;H.length<B;)H+=" ";return H}function le(H,B){return`[remote-connection][${Q(h(H),13)}][${B.substr(0,5)}\u2026]`}function ie(H,B,X){return`${le(H,B)}[${X?"reconnect":"initial"}]`}function ce(H,B){return`${ie(B,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.connectTo}]`}function ye(H){return`${Date.now()-H} ms`}}),define(De[249],Ce([1,0,3,5]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=e.$Zk=void 0,e.$Zk=(0,T.$Ph)("remoteSocketFactoryService");class d{constructor(){this.a={}}register(A,m){return this.a[A]??=[],this.a[A].push(m),(0,C.$Qc)(()=>{const E=this.a[A]?.indexOf(m);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,m,E,b){const L=this.b(A);if(!L)throw new Error(`No socket factory found for ${A}`);return L.connect(A,m,E,b)}}e.$1k=d}),define(De[250],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y3b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(d){try{const R=await this.c();if(R){const A=String(C.a++);return this.b.set(A,R),{id:A,data:R.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,R){if(!d.id)return!0;const A=this.b.get(d.id);if(!A)return!1;this.b.delete(d.id);try{return A.validate(R)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(d){try{return await this.d(d)}catch{}return d}}e.$y3b=C}),define(De[106],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.$2k=void 0,e.$2k="signService",e.$3k=(0,C.$Ph)(e.$2k)}),define(De[138],Ce([1,0,250]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=void 0;class T extends C.$y3b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(A=>new A.signer().sign(R))}h(){return new Promise((R,A)=>$e(["vsda"],R,A))}}e.$s8b=T}),define(De[251],Ce([1,0,12,48,31]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=void 0;function R(E){if(C.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,b,L,P,v,y,k,p,h){const s=Object.create(null);s["common.machineId"]=y,s["common.sqmId"]=k,s.sessionID=(0,d.$eg)()+Date.now(),s.commitHash=P,s.version=v,s["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,C.$i)(C.$u),s["common.nodePlatform"]=T.$dc,s["common.nodeArch"]=L,s["common.product"]=h||"desktop",p&&(s["common.msftInternal"]=p);let a=0;const o=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),C.$m&&(s["common.snap"]="true");const f=R(b);return f&&(s["common.platformDetail"]=f),s}e.$ho=A;function m(E){const b=T.env.USERDNSDOMAIN;if(!b)return!1;const L=b.toLowerCase();return E.some(P=>L===P)}e.$io=m}),define(De[252],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,C.$Ph)("telemetryService"),e.$dl=(0,C.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var d;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(De[85],Ce([1,0,24,17,4,50,66,251,252]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=void 0;class b{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$jo=b;class L{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ko=L,e.$lo=new L;class P{async publicLog(r,u,I){}async publicLogError(r,u,I){}}e.$mo=P,e.$no="telemetry",e.$oo="extensionTelemetryLog",e.$po={log:()=>null,flush:()=>Promise.resolve(null)};function v(n,r){return d.Event.debounce(r.onDidChangeConfiguration,(I,S)=>{const $=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:$}},1e3,!0)(I=>{I.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,R.$mi)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$qo=v;function y(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}e.$ro=y;function k(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$so=k;function p(n){const r=n.getValue(E.$kl),u=n.getValue(E.$ll);if(n.getValue(E.$ml)===!1||u===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$to=p;function h(n){const r={},u={},I={};o(n,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const $=I[S];typeof $=="number"?u[S]=$:typeof $=="boolean"?u[S]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${$.length}`),r[S]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(r[S]=$)}return{properties:r,measurements:u}}e.$uo=h;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(n){if(!n)return"none";const r=(0,A.$Vk)(n);return s.has(r)?r:"other"}e.$vo=a;function o(n,r,u=0,I){if(n)for(const S of Object.getOwnPropertyNames(n)){const $=n[S],g=I?I+S:S;Array.isArray($)?r[g]=(0,C.$_m)($):$ instanceof Date?r[g]=$.toISOString():(0,T.$Af)($)?u<2?o($,r,u+1,g+"."):r[g]=(0,C.$_m)($):r[g]=$}}function f(n,r){const u=n.msftInternalDomains||[],I=r.getValue("telemetry.internalTesting");return(0,m.$io)(u)||I}e.$wo=f;function l(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$xo=l;function t(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let u=n;const I=[];for(const w of r)for(;;){const D=w.exec(n);if(!D)break;I.push([D.index,w.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(u="";;){const w=$.exec(n);if(!w)break;const D=I.some(([N,M])=>w.index<M&&N<$.lastIndex);!S.test(w[0])&&!D&&(u+=n.substring(g,w.index)+"<REDACTED: user-file-path>",g=$.lastIndex)}return g<n.length&&(u+=n.substr(g)),u}function i(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of r)if(u.regex.test(n))return`<REDACTED: ${u.label}>`;return n}function c(n,r){return(0,C.$9m)(n,u=>{if(u instanceof b||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let I=u.replaceAll("%20"," ");I=t(I,r);for(const S of r)I=I.replace(S,"");return I=i(I),I}})}e.$yo=c}),define(De[253],Ce([1,0,15,132,25,12,2,9,48,85]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;function L(c,n){return c.uuid&&n.uuid?c.uuid===n.uuid:c.id===n.id?!0:(0,C.$We)(c.id,n.id)===0}e.$zo=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(n){const r=n.manifest?n.manifest.version:n.version,u=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new v(n.identifier,r,u)}static parse(n){const r=P.exec(n);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,u="undefined"){this.version=r,this.targetPlatform=u,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof v?L(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Ao=v;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(c){const n=y.exec(c);return n&&n[1]?[h(n[1]),n[2]]:[h(c),void 0]}e.$Bo=k;function p(c,n){return`${c}.${n}`}e.$Co=p;function h(c){return c.toLowerCase()}e.$Do=h;function s(c,n){return h(p(c??d.$2l,n))}e.$Eo=s;function a(c,n){const r=[],u=I=>{for(const S of r)if(S.some($=>L(n($),n(I))))return S;return null};for(const I of c){const S=u(I);S?S.push(I):r.push([I])}return r}e.$Fo=a;function o(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Go=o;function f(c){return{id:new b.$jo(c.identifier.id),name:new b.$jo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Ho=f,e.$Io=new d.$6l("pprice.better-merge");function l(c,n){const r=[],u=n.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const I=u.shift();if(I&&r.every(S=>!L(S.identifier,{id:I}))){const S=c.filter($=>L($.identifier,{id:I}));S.length===1&&(r.push(S[0]),u.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.$Jo=l;async function t(c,n){if(!R.$l)return!1;let r;try{r=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){n.debug("Error while getting the os-release file.",(0,m.$0)(I))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(c,n){const r=await t(c,n),u=(0,T.$6n)(r?"alpine":R.$u,E.$ec);return n.debug("ComputeTargetPlatform:",u),u}e.$Ko=i}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=e.$mr=e.$lr=e.$kr=void 0;function C(E){return[...E.entries()]}e.$kr=C;function T(E){return E?[...E.entries()]:[]}e.$lr=T;function d(E){return new Map(E)}e.$mr=d;function R(E){return new Map(E??[])}e.$nr=R;function A(E){return Array.from(E.entries()).map(b=>[b[0],C(b[1].map),T(b[1].descriptionMap)])}e.$or=A;function m(E){return new Map(E.map(b=>[b[0],{map:d(b[1]),descriptionMap:R(b[2])}]))}e.$pr=m}),define(De[255],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkb=void 0;class C{constructor(d){this.b=d,this.a=new Map}dispose(){for(const d of this.a.values())d.dispose()}startBuffering(d,R,A=5){const m=R(E=>{const b=typeof E=="string"?E:E.data;let L=this.a.get(d);if(L){L.data.push(b);return}const P=setTimeout(()=>this.flushBuffer(d),A);L={data:[b],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(d),m.dispose()}},this.a.set(d,L)});return m}stopBuffering(d){this.a.get(d)?.dispose()}flushBuffer(d){const R=this.a.get(d);R&&(this.a.delete(d),this.b(d,R.data.join("")))}}e.$Zkb=C}),define(De[256],Ce([1,0,8,79,59,4,17,2,199,105,43]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.IconFontDefinition=e.IconContribution=e.$5v=void 0,e.$5v={IconContribution:"base.contributions.icons"};var P;(function(f){function l(t,i){let c=t.defaults;for(;d.ThemeIcon.isThemeIcon(c);){const n=k.getIcon(c.id);if(!n)return;c=n.defaults}return c}f.getDefinition=l})(P||(e.IconContribution=P={}));var v;(function(f){function l(i){return{weight:i.weight,style:i.style,src:i.src.map(c=>({format:c.format,location:c.location.toString()}))}}f.toJSONObject=l;function t(i){const c=n=>(0,A.$yf)(n)?n:void 0;if(i&&Array.isArray(i.src)&&i.src.every(n=>(0,A.$yf)(n.format)&&(0,A.$yf)(n.location)))return{weight:c(i.weight),style:c(i.style),src:i.src.map(n=>({format:n.format,location:m.URI.parse(n.location)}))}}f.fromJSONObject=t})(v||(e.IconFontDefinition=v={}));class y{constructor(){this.a=new R.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,t,i,c){const n=this.b[l];if(n){if(i&&!n.description){n.description=i,this.d.properties[l].markdownDescription=`${i} $(${l})`;const I=this.e.enum.indexOf(l);I!==-1&&(this.e.enumDescriptions[I]=i),this.a.fire()}return n}const r={id:l,description:i,defaults:t,deprecationMessage:c};this.b[l]=r;const u={$ref:"#/definitions/icons"};return c&&(u.deprecationMessage=c),i&&(u.markdownDescription=`${i}: $(${l})`),this.d.properties[l]=u,this.e.enum.push(l),this.e.enumDescriptions.push(i||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const t=this.e.enum.indexOf(l);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,t){const i=this.f[l];return i||(this.f[l]=t,this.a.fire(),t)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(n,r)=>n.id.localeCompare(r.id),t=n=>{for(;d.ThemeIcon.isThemeIcon(n.defaults);)n=this.b[n.defaults.id];return`codicon codicon-${n?n.id:""}`},i=[];i.push("| preview     | identifier                        | default codicon ID                | description"),i.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(n=>this.b[n]);for(const n of c.filter(r=>!!r.description).sort(l))i.push(`|<i class="${t(n)}"></i>|${n.id}|${d.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);i.push("| preview     | identifier                        "),i.push("| ----------- | --------------------------------- |");for(const n of c.filter(r=>!d.ThemeIcon.isThemeIcon(r.defaults)).sort(l))i.push(`|<i class="${t(n)}"></i>|${n.id}|`);return i.join(`
`)}}const k=new y;L.$gn.add(e.$5v.IconContribution,k);function p(f,l,t,i){return k.registerIcon(f,l,t,i)}e.$6v=p;function h(){return k}e.$7v=h;function s(){const f=(0,T.$Sj)();for(const l in f){const t="\\"+f[l].toString(16);k.registerIcon(l,{fontCharacter:t})}}s(),e.$8v="vscode://schemas/icons";const a=L.$gn.as(b.$hn.JSONContribution);a.registerSchema(e.$8v,k.getIconSchema());const o=new C.$6g(()=>a.notifySchemaChanged(e.$8v),200);k.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$9v=p("widget-close",T.$Uj.close,(0,E.localize)(2,null)),e.$0v=p("goto-previous-location",T.$Uj.arrowUp,(0,E.localize)(3,null)),e.$$v=p("goto-next-location",T.$Uj.arrowDown,(0,E.localize)(4,null)),e.$_v=d.ThemeIcon.modify(T.$Uj.sync,"spin"),e.$aw=d.ThemeIcon.modify(T.$Uj.loading,"spin")}),define(De[86],Ce([1,0,4,50,5,14]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,d.$Ph)("tunnelService"),e.$$u=(0,d.$Ph)("sharedTunnelsService");var A;(function(h){h.Http="http",h.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(h){return!!h.forwardPort}e.$_u=E;var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function L(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(s)return{address:s[1],port:+s[2]}}e.$av=L,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.$bv.indexOf(h)>=0}e.$cv=P,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(h){return e.$dv.indexOf(h)>=0}e.$ev=v;function y(h,s,a,o){if(a===1)return!1;if(a===2&&v(s)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(f?.length===4&&parseInt(f[1])>=18)return!1}return h<1024}e.$fv=y;class k{constructor(s,a,o){this.remoteAddress=s,this.localAddress=a,this.b=o,this.a=new C.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=k;let p=class{constructor(s,a){this.j=s,this.k=a,this.a=new C.$Nd,this.onTunnelOpened=this.a.event,this.b=new C.$Nd,this.onTunnelClosed=this.b.event,this.c=new C.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],a=Array.from(this.e.values());for(const o of a){const f=Array.from(o.values());for(const l of f){const t=await l.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:a}of s.values())await a.then(o=>typeof o!="string"?o?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,a,o,f,l){this.p(s,a,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:a,localAddress:o,privacy:f,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,a){(v(s)||P(s))&&(s=e.$bv[0]);const o=this.r(s,a);if(o)return++o.refcount,o.value}openTunnel(s,a,o,f,l,t=!1,i,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${o} on local port ${l}.`);const n=this.f??s;if(!n)return;if(a||(a="localhost"),f||(f=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.s(n,a,o,f,l,t,i,c);return r?r.then(u=>{if(u){if(typeof u=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,o),u}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(u);return(u.tunnelRemoteHost!==a||u.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&u.privacy!==i&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const a=this.e.get(s.tunnelRemoteHost);if(a){const o=a.get(s.tunnelRemotePort);o&&(o.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,o))}}}}async o(s,a,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${a}.`);const f=o.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(a),f}}async closeTunnel(s,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${a} `);const o=this.e.get(s);if(o&&o.has(a)){const f=o.get(a);f.refcount=0,await this.o(s,a,f)}}p(s,a,o){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(a,{refcount:1,value:o})}async q(s,a){const o=this.e.get(s);if(o){const f=o.get(a),l=f?await f.value:void 0;(!l||typeof l=="string")&&o.delete(a),o.size===0&&this.e.delete(s)}}r(s,a){const o=[s];P(s)?(o.push(...e.$bv),o.push(...e.$dv)):v(s)&&o.push(...e.$dv);const f=o.map(l=>this.e.get(l));for(const l of f){const t=l?.get(a);if(t)return t}}canTunnel(s){return!!L(s)}t(s,a,o,f,l,t,i){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${o} on local port ${f}.`);const c=o;this.i.add(c);const n=f===void 0?o:f,r={elevationRequired:l?this.isPortPrivileged(n):!1},u={remoteAddress:{host:a,port:o},localAddressPort:f,privacy:t,public:t?t!==m.Private:void 0,protocol:i},I=s.forwardPort(u,r);return I?(this.p(a,o,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),I}};e.$hv=p,e.$hv=p=He([Be(0,R.$0i),Be(1,T.$ji)],p)}),define(De[257],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=void 0,e.$Ik=(0,C.$Ph)("IUriIdentityService")}),define(De[258],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$iv=void 0,e.$iv=(0,C.$Ph)("editSessionIdentityService");var T;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(De[259],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=void 0;function T(E){return E.scheme!==C.Schemas.file&&E.scheme!==C.Schemas.vscodeRemote}e.$UJ=T;function d(E){if(E.folders.length)return E.folders.every(b=>T(b.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.$VJ=d;function R(E){return d(E)?.scheme}e.$WJ=R;function A(E){return d(E)?.authority}e.$XJ=A;function m(E){return d(E)!==void 0}e.$YJ=m}),define(De[44],Ce([1,0,201,16,78,23,2,5,18]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,m.$Ph)("contextService");function b(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.uri)}e.$Zh=b;function L(n){return typeof n?.id=="string"&&!b(n)&&!v(n)}e.$1h=L,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function P(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,T.$nc)(n)}:r?e.$2h:e.$3h;const u=n;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.$4h=P;function v(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.configPath)}e.$5h=v;function y(n){const r=n;if(r?.uri)return{id:r.id,uri:A.URI.revive(r.uri)};const u=n;if(u?.configPath)return{id:u.id,configPath:A.URI.revive(u.configPath)};if(n?.id)return{id:n.id}}e.$6h=y;var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function p(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.$7h=p;function h(n){const r=n;return!!(r&&typeof r=="object"&&A.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.$8h=h;class s{constructor(r,u,I,S,$){this.h=r,this.j=I,this.k=S,this.l=$,this.c=d.$Vh.forUris(this.l,()=>!0),this.folders=u}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=d.$Vh.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=s;class a{constructor(r,u){this.raw=u,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.$vg)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=a;function o(n){return new a({uri:n,index:0,name:(0,R.$rg)(n)},{uri:n.toString()})}e.$$h=o,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,C.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function f(n,r){return R.$mg.isEqualOrParent(n,r.untitledWorkspacesHome)}e.$di=f;function l(n){let r;return A.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===E.Schemas.tmp}e.$ei=l,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$fi}e.$gi=t;function i(n,r){return!f(n,r)&&!l(n)}e.$hi=i;function c(n){return(typeof n=="string"?(0,T.$oc)(n):(0,R.$tg)(n))===e.$ai}e.$ii=c}),define(De[260],Ce([1,0,52,4,3,23,2,200,131,30,5,14,44,28,257,8,31,15,17]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.ProfileResourceType=void 0;var o;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(o||(e.ProfileResourceType=o={}));function f(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&A.URI.isUri(r.location)&&A.URI.isUri(r.globalStorageHome)&&A.URI.isUri(r.settingsResource)&&A.URI.isUri(r.keybindingsResource)&&A.URI.isUri(r.tasksResource)&&A.URI.isUri(r.snippetsHome)&&A.URI.isUri(r.extensionsResource))}e.$Jk=f,e.$Kk=(0,L.$Ph)("IUserDataProfilesService");function l(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:r}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Lk=l;function t(n,r,u,I,S,$){return{id:n,name:r,location:u,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:$&&S?.useDefaultFlags?.globalState?$.globalStorageHome:(0,R.$vg)(u,"globalStorage"),settingsResource:$&&S?.useDefaultFlags?.settings?$.settingsResource:(0,R.$vg)(u,"settings.json"),keybindingsResource:$&&S?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,R.$vg)(u,"keybindings.json"),tasksResource:$&&S?.useDefaultFlags?.tasks?$.tasksResource:(0,R.$vg)(u,"tasks.json"),snippetsHome:$&&S?.useDefaultFlags?.snippets?$.snippetsHome:(0,R.$vg)(u,"snippets"),extensionsResource:$&&S?.useDefaultFlags?.extensions?$.extensionsResource:(0,R.$vg)(u,"extensions.json"),cacheHome:(0,R.$vg)(I,n),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Mk=t;let i=class extends d.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,u,I,S){super(),this.t=r,this.u=u,this.w=I,this.y=S,this.f=!0,this.h=this.B(new T.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),u=[r];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,a.$yf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}u.push(t((0,R.$sg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},r))}}catch($){this.y.error($)}const I=new y.$Ac,S=new Map;if(u.length)try{const $=this.Q();if($.workspaces)for(const[g,w]of Object.entries($.workspaces)){const D=A.URI.parse(g),N=u.find(M=>M.id===w);N&&I.set(D,N)}if($.emptyWindows)for(const[g,w]of Object.entries($.emptyWindows)){const D=u.find(N=>N.id===w);D&&S.set(g,D)}}catch($){this.y.error($)}this.z={profiles:u,workspaces:I,emptyWindows:S}}return this.z}D(){const r=t("__default__profile__",(0,m.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const u="Temp",I=new RegExp(`${(0,s.$Fe)(u)}\\s(\\d+)`);let S=0;for(const g of this.profiles){const w=I.exec(g.name),D=w?parseInt(w[1]):0;S=D>S?D:S}const $=`${u} ${S+1}`;return this.createProfile((0,C.$Di)((0,h.$eg)()).toString(16),$,{transient:!0},r)}async createNamedProfile(r,u,I){return this.createProfile((0,C.$Di)((0,h.$eg)()).toString(16),r,u,I)}async createProfile(r,u,I,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(r,u,I);return S&&await this.setProfileForWorkspace(S,$),$}async F(r,u,I){if(!(0,a.$yf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(u);return S||(S=(async()=>{try{const $=this.profiles.find(D=>D.name===u||D.id===r);if($)return $;const g=t(r,u,(0,R.$vg)(this.profilesHome,r),this.g,I,this.defaultProfile);await this.u.createFolder(g.location);const w=[];return this.j.fire({profile:g,join(D){w.push(D)}}),await p.Promises.settled(w),this.I([g],[],[]),g}finally{this.r.delete(u)}})(),this.r.set(u,S)),S}async updateProfile(r,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let I=this.profiles.find(S=>S.id===r.id);if(!I)throw new Error(`Profile '${r.name}' does not exist`);return I=t(I.id,u.name??I.name,I.location,this.g,{shortName:u.shortName??I.shortName,icon:u.icon===null?void 0:u.icon??I.icon,transient:u.transient??I.isTransient,useDefaultFlags:u.useDefaultFlags??I.useDefaultFlags},this.defaultProfile),this.I([],[],[I]),I}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(S=>S.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);const I=[];this.m.fire({profile:u,join(S){I.push(S)}});try{await Promise.allSettled(I)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(S){(0,b.$pk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(r,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=this.profiles.find(S=>S.id===u.id);if(!I)throw new Error(`Profile '${u.name}' does not exist`);this.L(r,I)}unsetWorkspace(r,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(u=>u.isDirectory&&this.profiles.every(I=>!this.w.extUri.isEqual(I.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(r.map(u=>this.removeProfile(u)))}getProfileForWorkspace(r){const u=this.G(r);return A.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(r){return(0,v.$Zh)(r)?r.uri:(0,v.$5h)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,r.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,r.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,r.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,r.location)))}I(r,u,I){const S=[...this.profiles,...r],$=[];this.s.profiles=[];for(let g of S)g.isDefault||u.some(w=>g.id===w.id)||(g=I.find(w=>g.id===w.id)??g,g.isTransient?this.s.profiles.push(g):$.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P($),this.z=void 0,this.J(r,u,I)}J(r,u,I){this.h.fire({added:r,removed:u,updated:I,all:this.profiles})}L(r,u,I){I=u?.isTransient?!0:I,I||this.L(r,void 0,!0);const S=this.G(r),$=I?this.s:this.C;A.URI.isUri(S)?($.workspaces.delete(S),u&&$.workspaces.set(S,u)):($.emptyWindows.delete(S),u&&$.emptyWindows.set(S,u)),I||this.M()}M(){const r={};for(const[I,S]of this.C.workspaces.entries())r[I.toString()]=S.id;const u={};for(const[I,S]of this.C.emptyWindows.entries())u[I.toString()]=S.id;this.R({workspaces:r,emptyWindows:u}),this.z=void 0}N(r){const u={},I=this.D();if(r.workspaces)for(const[$,g]of Object.entries(r.workspaces)){const w=A.URI.parse(g);u[$]=this.w.extUri.isEqual(w,I.location)?I.id:this.w.extUri.basename(w)}const S={};if(r.emptyWindows)for(const[$,g]of Object.entries(r.emptyWindows)){const w=A.URI.parse(g);S[$]=this.w.extUri.isEqual(w,I.location)?I.id:this.w.extUri.basename(w)}return{workspaces:u,emptyWindows:S}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$Nk=i,e.$Nk=i=He([Be(0,E.$Wh),Be(1,b.$$j),Be(2,k.$Ik),Be(3,P.$0i)],i);class c extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Ok=c}),define(De[261],Ce([1,0,8,4,3,54,17,184,5,260]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$6o=e.$5o=e.$4o=void 0,e.$4o="__$__isNewStorageMarker",e.$5o="__$__targetStorageMarker",e.$6o=(0,E.$Ph)("storageService");var L;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var P;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var v;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function y(a){const o=a.get(e.$5o);if(o)try{return JSON.parse(o)}catch{}return Object.create(null)}e.$7o=y;class k extends d.$Sc{static{this.a=60*1e3}constructor(o={flushInterval:k.a}){super(),this.m=o,this.b=this.B(new T.$Qd),this.c=this.B(new T.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new d.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(o,f,l){return T.Event.filter(this.b.event,t=>t.scope===o&&(f===void 0||t.key===f),l)}n(){this.j.value=(0,C.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,d.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(o,f){const{key:l,external:t}=f;if(l===e.$5o){switch(o){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:o})}else this.b.fire({scope:o,key:l,target:this.J(o)[l],external:t})}w(o){this.f.fire({reason:o})}get(o,f,l){return this.P(f)?.get(o,l)}getBoolean(o,f,l){return this.P(f)?.getBoolean(o,l)}getNumber(o,f,l){return this.P(f)?.getNumber(o,l)}getObject(o,f,l){return this.P(f)?.getObject(o,l)}storeAll(o,f){this.y(()=>{for(const l of o)this.store(l.key,l.value,l.scope,l.target,f)})}store(o,f,l,t,i=!1){if((0,A.$Hf)(f)){this.remove(o,l,i);return}this.y(()=>{this.z(o,l,t),this.P(l)?.set(o,f,i)})}remove(o,f,l=!1){this.y(()=>{this.z(o,f,void 0),this.P(f)?.delete(o,l)})}y(o){this.b.pause(),this.c.pause();try{o()}finally{this.b.resume(),this.c.resume()}}keys(o,f){const l=[],t=this.J(o);for(const i of Object.keys(t))t[i]===f&&l.push(i);return l}z(o,f,l,t=!1){const i=this.J(f);typeof l=="number"?i[o]!==l&&(i[o]=l,this.P(f)?.set(e.$5o,JSON.stringify(i),t)):typeof i[o]=="number"&&(delete i[o],this.P(f)?.set(e.$5o,JSON.stringify(i),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(o){switch(o){case-1:return this.I;case 0:return this.G;default:return this.D}}L(o){const f=this.P(o);return f?y(f):Object.create(null)}isNew(o){return this.getBoolean(e.$4o,o)===!0}async flush(o=L.NONE){this.f.fire({reason:o});const f=this.P(-1),l=this.P(0),t=this.P(1);switch(o){case L.NONE:await C.Promises.settled([f?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await C.Promises.settled([f?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const o=this.P(-1)?.items??new Map,f=this.P(0)?.items??new Map,l=this.P(1)?.items??new Map;return s(o,f,l,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(o){return await this.flush(),this.P(o)?.optimize()}async switch(o,f){return this.w(L.NONE),(0,b.$Jk)(o)?this.R(o,f):this.S(o,f)}M(o,f){return!(o.id===f.id||p(f)&&p(o))}N(o,f,l){this.y(()=>{const t=new Set;for(const[i,c]of o)t.add(i),f.get(i)!==c&&this.u(l,{key:i,external:!0});for(const[i]of f.items)t.has(i)||this.u(l,{key:i,external:!0})})}}e.$8o=k;function p(a){return a.isDefault||!!a.useDefaultFlags?.globalState}e.$9o=p;class h extends k{constructor(){super(),this.U=this.B(new m.$2o(new m.$3o,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new m.$2o(new m.$3o,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new m.$2o(new m.$3o,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(o=>this.u(1,o))),this.B(this.W.onDidChangeStorage(o=>this.u(0,o))),this.B(this.U.onDidChangeStorage(o=>this.u(-1,o)))}P(o){switch(o){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(o){switch(o){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(o){return!1}}e.$0o=h;async function s(a,o,f,l,t,i){const c=D=>{try{return JSON.parse(D)}catch{return D}},n=new Map,r=new Map;a.forEach((D,N)=>{n.set(N,D),r.set(N,c(D))});const u=new Map,I=new Map;o.forEach((D,N)=>{u.set(N,D),I.set(N,c(D))});const S=new Map,$=new Map;f.forEach((D,N)=>{S.set(N,D),$.set(N,c(D))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const g=[];if(n.forEach((D,N)=>{g.push({key:N,value:D})}),console.table(g),console.groupEnd(),console.log(r),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];u.forEach((N,M)=>{D.push({key:M,value:N})}),console.table(D),console.groupEnd(),console.log(I)}console.group(`Storage: Workspace (path: ${i})`);const w=[];S.forEach((D,N)=>{w.push({key:N,value:D})}),console.table(w),console.groupEnd(),console.log($)}e.$$o=s}),define(De[107],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class C{static{this.a=!1}constructor(d){this.d=d,this.b=new Map,this.c=1}add(d){const R=this.c++;return this.b.set(R,d),this.e(),R}get(d,R){return this.b.has(d)?this.b.get(d)[R]:void 0}delete(d){this.b.delete(d),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$icc=C}),define(De[55],Ce([1,0,18,23,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=void 0;class R{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new T.$kg(m=>{const E=this.b.get(m.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(m,E){E===null?this.b.delete(m.scheme):this.b.set(m.scheme,E)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$kcc=R,e.$lcc=(0,d.$Ph)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=void 0,e.$CM=(0,C.$Ph)("IExtHostInitDataService")}),define(De[262],Ce([1,0,207,14,242,27]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;let A=class extends d.$JN{constructor(E,b,L){const P=L.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",v=L.remote.isRemote?(0,C.localize)(0,null):E?(0,C.localize)(1,null):(0,C.localize)(2,null);super(b.createLogger(P,{name:v}))}};e.$tec=A,e.$tec=A=He([Be(1,T.$$i),Be(2,R.$CM)],A)}),define(De[263],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;class T{constructor(A,m,E){this.h=new Map,this.a=A,this.b=m,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new C.$6g(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of b.values())L.complete()}catch(L){for(const P of b.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let E=this.f[A];return typeof E>"u"&&(E=m),E}update(A,m){this.f[A]=m;const E=this.h.get(A);if(E!==void 0)return E.p;const b=new C.$ch;return this.h.set(A,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$Ncc=T;class d extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$Occ=d}),define(De[264],Ce([1,0,4,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class d{constructor(A){this.c=A,this.a=new C.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,E,b){const P=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(m.value,E,b);this.b.fire(P)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$aec=d}),define(De[20],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0,e.$mM=(0,C.$Ph)("IExtHostRpcService");class T{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$nM=T}),define(De[265],Ce([1,0,25,4]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class d{#e;constructor(A,m){this.b=new T.$Nd,this.onDidChange=this.b.event,this.a=C.$6l.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$Zcc=d}),define(De[67],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=void 0,e.$vcc=(0,C.$Ph)("IURITransformerService");class T{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$wcc=T}),define(De[266],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcb=e.$Ecb=void 0;class T{constructor(){this.buffers=[]}add(E){let b=this.buffers.indexOf(E);return b<0&&(b=this.buffers.length,this.buffers.push(E)),b}}function d(m,E){if(E.serializeBuffersForPostMessage){const b=new T,P=JSON.stringify(m,(y,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(k)};if(ArrayBuffer.isView(k)){const p=R(k);if(p)return{$$vscode_array_buffer_reference$$:!0,index:b.add(k.buffer),view:{type:p,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),v=b.buffers.map(y=>{const k=new Uint8Array(y);return C.$be.wrap(k)});return{message:P,buffers:v}}else return{message:JSON.stringify(m),buffers:[]}}e.$Ecb=d;function R(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,E){const b=E.map(v=>{const y=new ArrayBuffer(v.byteLength);return new Uint8Array(y).set(v.buffer),y}),L=E.length?(v,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const k=y,{index:p}=k,h=b[p];if(k.view)switch(k.view.type){case 1:return new Int8Array(h,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return y}:void 0;return{message:JSON.parse(m,L),arrayBuffers:b}}e.$Fcb=A}),define(De[267],Ce([1,0,268,377,378,60,2,14,379]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;const b=!1;function L(o,f,l,t,i,c){const n=c.environment.useHostProxy,r=typeof n=="boolean"?n:!c.remote.isRemote,u={resolveProxy:$=>o.resolveProxy($),lookupProxyAuthorization:h.bind(void 0,t,i,f,{},c.remote.isRemote),getProxyURL:()=>f.getConfiguration("http").get("proxy"),getProxySupport:()=>f.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>v(f),getSystemCertificatesV2:()=>y(f),log:($,g,...w)=>{switch($){case E.LogLevel.Trace:t.trace(g,...w);break;case E.LogLevel.Debug:t.debug(g,...w);break;case E.LogLevel.Info:t.info(g,...w);break;case E.LogLevel.Warning:t.warn(g,...w);break;case E.LogLevel.Error:t.error(g,...w);break;case E.LogLevel.Critical:t.error(g,...w);break;case E.LogLevel.Off:break;default:D($,g,w);break}function D(N,M,...F){t.error("Unknown log level",N),t.error(M,...F)}},getLogLevel:()=>{const $=t.getLevel();switch($){case m.LogLevel.Trace:return E.LogLevel.Trace;case m.LogLevel.Debug:return E.LogLevel.Debug;case m.LogLevel.Info:return E.LogLevel.Info;case m.LogLevel.Warning:return E.LogLevel.Warning;case m.LogLevel.Error:return E.LogLevel.Error;case m.LogLevel.Off:return E.LogLevel.Off;default:return g($)}function g(w){return t.error("Unknown log level",w),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:r,addCertificates:[],env:process.env},I=(0,E.createProxyResolver)(u),S=P(u,I);return p(l,S)}e.$2ec=L;function P(o,f){return{http:Object.assign(C,(0,E.createHttpPatch)(o,C,f)),https:Object.assign(T,(0,E.createHttpPatch)(o,T,f)),net:Object.assign(R,(0,E.createNetPatch)(o,R)),tls:Object.assign(d,(0,E.createTlsPatch)(o,d))}}function v(o){const f=o.getConfiguration("http");return!f.get("experimental.systemCertificatesV2",b)&&!!f.get("systemCertificates")}function y(o){const f=o.getConfiguration("http");return!!f.get("experimental.systemCertificatesV2",b)&&!!f.get("systemCertificates")}const k=new Map;function p(o,f){return o.getExtensionPathIndex().then(l=>{const t=globalThis._VSCODE_NODE_MODULES.module,i=t._load;t._load=function(n,r,u){if(n==="net")return f.net;if(n==="tls")return f.tls;if(n!=="http"&&n!=="https")return i.apply(this,arguments);const I=l.findSubstr(A.URI.file(r.filename));let S=k.get(I);if(S||k.set(I,S={}),!S[n]){const $=f[n];S[n]={...$}}return S[n]}})}async function h(o,f,l,t,i,c,n,r){const u=t[c];n&&(t[c]=n),o.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${c}`,`proxyAuthenticate:${n}`,`proxyAuthenticateCache:${u}`);const I=n||u,S=Array.isArray(I)?I:typeof I=="string"?[I]:[];if(a(f,S,i),S.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!r.kerberosRequested)try{r.kerberosRequested=!0;const $=await new Promise((M,F)=>{$e(["kerberos"],M,F)}),g=new URL(c),w=l.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${c}`,`spn:${w}`),"Negotiate "+await(await $.initializeClient(w)).step("")}catch($){o.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let s=!1;function a(o,f,l){s||!f.length||(s=!0,o.$publicLog2("proxyAuthenticationRequest",{authenticationType:f.map(t=>t.split(" ")[0]).join(","),extensionHostType:l?"remote":"local"}))}}),define(De[269],Ce([1,0,128]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;function T(R){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:R,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function d(R){return new C.$Lm(T(R))}e.$Ar=d}),define(De[139],Ce([1,0,217,17,2,3,5,43,30,18,41,176,38]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=e.$gE=e.$fE=e.EditorsOrder=e.$eE=e.CloseDirection=e.$dE=e.$cE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.EditorInputCapabilities=e.$6D=e.SaveReason=e.Verbosity=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=void 0,e.$TD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$UD={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$VD="workbench.editor.sidebysideEditor",e.$WD="workbench.editors.textDiffEditor",e.$XD="workbench.editors.binaryResourceDiffEditor";var y;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var k;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function p(ce){const ye=ce;return!!ye&&typeof ye.getSelection=="function"&&!!ye.onDidChangeSelection}e.$YD=p;function h(ce,ye,H){for(const B of H.visibleEditorPanes)if(B.group.id===ye&&ce.matches(B.input))return B.getViewState()}e.$ZD=h;function s(ce){if(u(ce))return!1;const ye=ce;return d.URI.isUri(ye?.resource)}e.$1D=s;function a(ce){if(u(ce))return!1;const ye=ce;return ye?.original!==void 0&&ye.modified!==void 0}e.$2D=a;function o(ce){if(u(ce)||a(ce))return!1;const ye=ce;return ye?.primary!==void 0&&ye.secondary!==void 0}e.$3D=o;function f(ce){if(u(ce))return!1;const ye=ce;return ye?ye.resource===void 0||ye.resource.scheme===b.Schemas.untitled||ye.forceUntitled===!0:!1}e.$4D=f;function l(ce){if(u(ce))return!1;const ye=ce;return d.URI.isUri(ye?.base?.resource)&&d.URI.isUri(ye?.input1?.resource)&&d.URI.isUri(ye?.input2?.resource)&&d.URI.isUri(ye?.result?.resource)}e.$5D=l;var t;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var i;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class c{constructor(){this.a=new Map}registerSource(ye,H){let B=this.a.get(ye);return B||(B={source:ye,label:H},this.a.set(ye,B)),B.source}getSourceLabel(ye){return this.a.get(ye)?.label??ye}}e.$6D=new c;var n;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(n||(e.EditorInputCapabilities=n={}));class r extends R.$Sc{}e.$7D=r;function u(ce){return ce instanceof r}e.$8D=u;function I(ce){const ye=ce;return d.URI.isUri(ye?.preferredResource)}function S(ce){const ye=ce;return u(ye?.primary)&&u(ye?.secondary)}e.$9D=S;function $(ce){const ye=ce;return u(ye?.modified)&&u(ye?.original)}e.$0D=$;function g(ce,ye,H,B,X){return ie(B,[(0,P.$zi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const re={...H,limits:{size:Number.MAX_VALUE}};ce.openEditor(ye,re)}}),(0,P.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>X.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$$D=g;function w(ce){return u(ce?.editor)}e.$_D=w;function D(ce){const ye=ce;return w(ce)&&ye?.group!==void 0}e.$aE=D;function N(ce){const ye=ce;return typeof ye?.groupId=="number"&&u(ye.editor)}e.$bE=N;var M;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var F;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var U;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class j{getOriginalUri(ye,H){if(!ye)return;if(l(ye))return e.$dE.getOriginalUri(ye.result,H);if(H?.supportSideBySide){const{primary:X,secondary:re}=this.a(ye);if(X&&re){if(H?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getOriginalUri(X,{filterByScheme:H.filterByScheme})??this.getOriginalUri(re,{filterByScheme:H.filterByScheme});ye=H.supportSideBySide===U.PRIMARY?X:re}}if(a(ye)||o(ye)||l(ye))return;const B=I(ye)?ye.preferredResource:ye.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}a(ye){return S(ye)||o(ye)?{primary:ye.primary,secondary:ye.secondary}:$(ye)||a(ye)?{primary:ye.modified,secondary:ye.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ye,H){if(!ye)return;if(l(ye))return e.$dE.getCanonicalUri(ye.result,H);if(H?.supportSideBySide){const{primary:X,secondary:re}=this.a(ye);if(X&&re){if(H?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(X,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===U.ANY)return this.getCanonicalUri(X,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:H.filterByScheme});ye=H.supportSideBySide===U.PRIMARY?X:re}}if(a(ye)||o(ye)||l(ye))return;const B=ye.resource;return!B||!H||!H.filterByScheme?B:this.b(B,H.filterByScheme)}b(ye,H){if(Array.isArray(H)){if(H.some(B=>ye.scheme===B))return ye}else if(H===ye.scheme)return ye}}var O;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function q(ce,ye,H,B){if(!ce.isSticky(ye))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return H===O.MOUSE||H===O.KEYBOARD;case"mouse":return H===O.MOUSE;case"keyboard":return H===O.KEYBOARD}return!1}e.$cE=q,e.$dE=new j;var K;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class me{constructor(){this.c=new Map,this.d=new Map}start(ye){const H=this.a=ye.get(A.$Oh);for(const[B,X]of this.c)this.e(B,X,H);this.c.clear()}e(ye,H,B){const X=B.createInstance(H);this.d.set(ye,X)}registerFileEditorFactory(ye){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ye}getFileEditorFactory(){return(0,T.$Jf)(this.b)}registerEditorSerializer(ye,H){if(this.c.has(ye)||this.d.has(ye))throw new Error(`A editor serializer with type ID '${ye}' was already registered.`);return this.a?this.e(ye,H,this.a):this.c.set(ye,H),(0,R.$Qc)(()=>{this.c.delete(ye),this.d.delete(ye)})}getEditorSerializer(ye){return this.d.get(typeof ye=="string"?ye:ye.typeId)}}m.$gn.add(e.$TD.EditorFactory,new me);async function te(ce,ye,H){return!ce||!ce.length?[]:await Promise.all(ce.map(async B=>{const X=d.URI.revive(B.fileUri);if(!X){H.info("Cannot resolve the path because it is not valid.",B);return}if(!await ye.canHandleResource(X)){H.info("Cannot resolve the path because it cannot be handled",B);return}let Y=B.exists,_=B.type;if(typeof Y!="boolean"||typeof _!="number")try{_=(await ye.stat(X)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Y=!0}catch(ve){H.error(ve),Y=!1}if(!Y&&B.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",B);return}if(_===E.FileType.Directory){H.info("Cannot resolve the path because it is a directory",B);return}const x={...B.options,pinned:!0};return Y?{resource:X,options:x}:{resource:X,options:x,forceUntitled:!0}}))}e.$eE=te;var G;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(G||(e.EditorsOrder=G={}));function Q(ce){const ye=ce;if(!ye)return!1;const H=ye;if(H.modified)return Q(H.modified);const B=ye;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.$fE=Q;function le(ce){return(0,L.$Bi)(ce)}e.$gE=le;function ie(ce,ye,H){const B=(0,L.$Ci)(ce,ye);return B.forceMessage=H?.forceMessage,B.forceSeverity=H?.forceSeverity,B.allowDialog=H?.allowDialog,B}e.$hE=ie}),define(De[270],Ce([1,0,4,218,5,3,28,43,19,24,79,256]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=e.$rE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$qE=e.$pE=e.ViewContentGroups=e.$oE=e.$nE=e.ViewContainerLocation=e.Extensions=e.$mE=e.$lE=e.$kE=void 0,e.$kE="views",e.$lE=(0,T.localize)(0,null),e.$mE=(0,P.$6v)("default-view-icon",L.$Uj.window,(0,T.localize)(1,null));var v;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var y;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$nE=[0,1,2];function k(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$oE=k;class p extends R.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new C.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Rb)([...this.g.values()])}registerViewContainer(c,n,r){const u=this.get(c.id);if(u)return u;const I=c;return I.openCommandActionDescriptor=r?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,n,[]).push(I),r?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:n}),I}deregisterViewContainer(c){for(const n of this.g.keys()){const r=this.g.get(n),u=r?.indexOf(c);if(u!==-1){r?.splice(u,1),r.length===0&&this.g.delete(n),this.f.fire({viewContainer:c,viewContainerLocation:n});return}}}get(c){return this.all.filter(n=>n.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(n=>this.getViewContainers(n).filter(r=>r?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(n=>this.getViewContainerLocation(n)===c)}}m.$gn.add(v.ViewContainersRegistry,new p);var h;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(h||(e.ViewContentGroups=h={}));function s(i,c){const n=i.group??h.More,r=c.group??h.More;return n!==r?n.localeCompare(r):(i.order??5)-(c.order??5)}class a extends R.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(c,n){this.registerViews2([{views:c,viewContainer:n}])}registerViews2(c){c.forEach(({views:n,viewContainer:r})=>this.r(n,r)),this.c.fire(c)}deregisterViews(c,n){const r=this.s(c,n);r.length&&this.f.fire({views:r,viewContainer:n})}moveViews(c,n){for(const r of this.m.keys())if(r!==n){const u=this.s(c,r);u.length&&(this.r(u,n),this.g.fire({views:u,from:r,to:n}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const n of this.j){const r=(this.m.get(n)||[]).filter(u=>u.id===c)[0];if(r)return r}return null}getViewContainer(c){for(const n of this.j)if((this.m.get(n)||[]).filter(u=>u.id===c)[0])return n;return null}registerViewWelcomeContent(c,n){return this.n.add(c,n),this.h.fire(c),(0,R.$Qc)(()=>{this.n.delete(c,n),this.h.fire(c)})}registerViewWelcomeContent2(c,n){const r=new Map;for(const[u,I]of n)this.n.add(c,I),r.set(u,(0,R.$Qc)(()=>{this.n.delete(c,I),this.h.fire(c)}));return this.h.fire(c),r}getViewWelcomeContent(c){const n=[];return this.n.forEach(c,r=>n.push(r)),n.sort(s)}r(c,n){let r=this.m.get(n);r||(r=[],this.m.set(n,r),this.j.push(n));for(const u of c){if(this.getView(u.id)!==null)throw new Error((0,T.localize)(2,null,u.id));r.push(u)}}s(c,n){const r=this.m.get(n);if(!r)return[];const u=[],I=[];for(const S of r)c.includes(S)?u.push(S):I.push(S);return u.length&&(I.length?this.m.set(n,I):(this.m.delete(n),this.j.splice(this.j.indexOf(n),1))),u}}m.$gn.add(v.ViewsRegistry,new a),e.$pE=(0,d.$Ph)("viewsService"),e.$qE=(0,d.$Ph)("viewDescriptorService");var o;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var f;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(f||(e.TreeItemCollapsibleState=f={}));class l{constructor(c,n){this.c=!1,this.d=!1,(0,b.$0m)(this,c),this.d=!!n,this.resolve=async r=>{if(n&&!this.c){const u=await n(r);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}r.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$rE=l;class t extends Error{constructor(c){super((0,T.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$sE=t}),define(De[271],Ce([1,0,2,32,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$TE=e.$SE=void 0;function R(b){return!!b&&typeof b=="object"&&"uri"in b&&b.uri instanceof C.URI&&"version"in b&&typeof b.version=="number"&&"ranges"in b&&Array.isArray(b.ranges)&&b.ranges.every(T.$ts.isIRange)}e.$SE=R;function A(b){return!!b&&typeof b=="object"&&"documents"in b&&Array.isArray(b.documents)&&b.documents.every(R)}e.$TE=A;var m;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var E;(function(b){b[b.Action=1]="Action",b[b.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$UE=(0,d.$Ph)("IChatService")}),define(De[140],Ce([1,0,4,8,219]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new C.$Nd,this.n=new C.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,E,b,L){const P={command:m};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.s("request",P),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const k={type:"response",seq:0,request_seq:P.seq,success:!1,command:m,message:(0,d.localize)(0,null,L,m)};y(k)}},L)}return b&&this.f.set(P.seq,b),P.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,E){return m.type!=="event"||E.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,T.$Ug)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const E=m,b=this.f.get(E.request_seq);b&&(this.f.delete(E.request_seq),b(E));break}}}}s(m,E){E.type=m,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((E,b)=>m.set(b,E)),await(0,T.$Ug)(500),m.forEach((E,b)=>{E({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$$cb=R}),define(De[272],Ce([1,0,220,42,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$7G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$6G=e.MemoryRangeType=e.$5G=e.State=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0,e.$3F="workbench.view.debug",e.$4F="workbench.debug.variablesView",e.$5F="workbench.debug.watchExpressionsView",e.$6F="workbench.debug.callStackView",e.$7F="workbench.debug.loadedScriptsView",e.$8F="workbench.debug.breakPointsView",e.$9F="workbench.debug.disassemblyView",e.$0F="workbench.panel.repl",e.$$F="workbench.panel.repl.view",e.$_F=new T.$7i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$aG=new T.$7i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$bG=new T.$7i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$cG="debugUx",e.$dG=new T.$7i(e.$cG,"default",{type:"string",description:C.localize(3,null)}),e.$eG=new T.$7i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$fG=new T.$7i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$gG=new T.$7i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$hG=new T.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$iG=new T.$7i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$jG=new T.$7i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$kG=new T.$7i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$lG=new T.$7i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$mG=new T.$7i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$nG=new T.$7i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$oG=new T.$7i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$pG=new T.$7i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$qG=new T.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$rG=new T.$7i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$sG=new T.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$tG=new T.$7i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$uG=new T.$7i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$vG=new T.$7i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$wG=new T.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$xG=new T.$7i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$yG=new T.$7i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$zG=new T.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$AG=new T.$7i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$BG=new T.$7i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$CG=new T.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$DG=new T.$7i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$EG=new T.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$FG=new T.$7i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$GG=new T.$7i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$HG=new T.$7i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$IG=new T.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$JG=new T.$7i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$KG=new T.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$LG=new T.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$MG=new T.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$NG=new T.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$OG=new T.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$PG=new T.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$QG=new T.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$RG=new T.$7i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$SG=new T.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$TG=new T.$7i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$UG=new T.$7i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$VG=new T.$7i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$WG=new T.$7i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$XG=new T.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$YG=new T.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const R=v=>C.localize(51,null,v);e.$ZG=R,e.$1G="editor.contrib.debug",e.$2G="editor.contrib.breakpoint",e.$3G="debug",e.$4G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var A;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(A||(e.State=A={}));function m(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$5G=m;var E;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$6G="vscode-debug-memory";var b;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L||(e.DebuggerString=L={})),e.$7G=(0,d.$Ph)("debugService");var P;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(De[273],Ce([1,0,15,2,16,24,18,32,21,19]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=void 0;const L=/{([^}]+)}/g;function P(S,$,g){return S.replace(L,function(w,D){return $&&D.length>0&&D[0]!=="_"?w:g&&g.hasOwnProperty(D)?g[D]:w})}e.$rF=P;function v(S){const $={};for(const g of Object.keys(S))g.startsWith("!")||($[g]=S[g]);return $}e.$sF=v;function y(S){return S.configuration.request==="attach"&&!k(S)&&(!S.parentSession||y(S.parentSession))}e.$tF=y;function k(S){let $=S.configuration.type;if($)return $==="vslsShare"&&($=S.configuration.adapterProxy.configuration.type),(0,C.$2e)($,"extensionhost")||(0,C.$2e)($,"pwa-extensionhost")?S:S.parentSession?k(S.parentSession):void 0}e.$uF=k;function p(S){return S.type&&(S.label||S.program||S.runtime)}e.$vF=p;function h(S,$,g){let w,D=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=N.exec(S);){const F=M.index+1,U=F+M[0].length;if(F<=$&&U>=g){w=M[0],D=F;break}}if(w){const F=/\w+/g;let U=null;for(;(U=F.exec(w))&&!(U.index+1+D+U[0].length>=g););U&&(w=w.substring(0,F.lastIndex))}return w?{start:D,end:D+w.length-1}:{start:0,end:0}}e.$wF=h;async function s(S,$,g,w){if(S.evaluatableExpressionProvider.has($)){const D=S.evaluatableExpressionProvider.ordered($),N=(0,b.$Hb)(await Promise.all(D.map(async M=>{try{return await M.provideEvaluatableExpression($,g,w??E.CancellationToken.None)}catch{return}})));if(N.length>0){let M=N[0].expression;const F=N[0].range;return M||(M=$.getLineContent(g.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:M}}}else{const D=$.getLineContent(g.lineNumber),{start:N,end:M}=h(D,g.column,g.column),F=D.substring(N-1,M);return{matchingExpression:F,range:new m.$ts(g.lineNumber,N,g.lineNumber,N+F.length)}}return null}e.$xF=s;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(S){return!!(S&&S.match(a))}e.$yF=o;function f(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(o(S.path))return T.URI.parse(S.path);if((0,d.$ic)(S.path))return T.URI.file(S.path)}return S.path}function l(S){if(typeof S.path=="object"){const $=T.URI.revive(S.path);if($)return $.scheme===A.Schemas.file?$.fsPath:$.toString()}return S.path}function t(S,$){const g=$?f:l,w=(0,R.$7m)(S);return c(w,(D,N)=>{D&&N&&(N.path=g(N))}),w}e.$zF=t;function i(S,$){const g=$?f:l,w=(0,R.$7m)(S);return c(w,(D,N)=>{!D&&N&&(N.path=g(N))}),w}e.$AF=i;function c(S,$){switch(S.type){case"event":{const g=S;switch(g.event){case"output":$(!1,g.body.source);break;case"loadedSource":$(!1,g.body.source);break;case"breakpoint":$(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=S;switch(g.command){case"setBreakpoints":$(!0,g.arguments.source);break;case"breakpointLocations":$(!0,g.arguments.source);break;case"source":$(!0,g.arguments.source);break;case"gotoTargets":$(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(w=>$(!1,w));break;default:break}break}case"response":{const g=S;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(w=>$(!1,w.source));break;case"loadedSources":g.body.sources.forEach(w=>$(!1,w));break;case"scopes":g.body.scopes.forEach(w=>$(!1,w.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(w=>$(!1,w.source));break;case"setBreakpoints":g.body.breakpoints.forEach(w=>$(!1,w.source));break;case"disassemble":g.body?.instructions.forEach(D=>$(!1,D.location));break;default:break}break}}}function n(S){return S.filter($=>!$.presentation?.hidden).sort(($,g)=>$.presentation?g.presentation?$.presentation.group?g.presentation.group?$.presentation.group!==g.presentation.group?$.presentation.group.localeCompare(g.presentation.group):r($.presentation.order,g.presentation.order):-1:g.presentation.group?1:r($.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$BF=n;function r(S,$){return typeof S!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:S-$}async function u(S,$){const g=S.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(g!=="none"&&(await $.saveAll(),g==="allEditorsInActiveGroup")){const w=$.activeEditorPane;w&&w.input.resource?.scheme===A.Schemas.untitled&&await $.save({editor:w.input,groupId:w.group.id})}await S.reloadConfiguration()}e.$CF=u;const I=(S,$)=>!S||!$?S===$:S.name===$.name&&S.path===$.path&&S.sourceReference===$.sourceReference;e.$DF=I}),define(De[274],Ce([1,0,49,60,24,16,12,15,29,221,140]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=e.$Bec=e.$Aec=e.$zec=void 0;class P extends L.$$cb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,a){this.p=a,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",o=>this.w(o))}sendMessage(s){if(this.p){const a=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${P.a}${a}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const a=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(o){this.m.fire(new Error((o.message||o)+`
`+a))}continue}}else{const a=this.r.indexOf(P.a);if(a!==-1){const f=this.r.toString("utf8",0,a).split(P.b);for(const l of f){const t=l.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(a+P.a.length);continue}}break}}}e.$zec=P;class v extends P{startSession(){return new Promise((s,a)=>{let o=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),o=!0}),this.x.on("close",()=>{o?this.m.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.x.on("error",f=>{o?this.m.fire(f):a(f)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Aec=v;class y extends v{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$Bec=y;class k extends v{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.path,s)}}e.$Cec=k;class p extends P{constructor(s,a){super(),this.y=s,this.z=a}async startSession(){const s=this.y.command,a=this.y.args,o=this.y.options||{};try{if(s)if(R.$ic(s)){if(!await E.Promises.exists(s))throw new Error(b.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(b.localize(1,null,this.z));let f=process.env;if(o.env&&Object.keys(o.env).length>0&&(f=d.$0m(d.$7m(process.env),o.env)),s==="node")if(Array.isArray(a)&&a.length>0){const l=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:f,execArgv:l?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(t.cwd=o.cwd);const i=C.fork(a[0],a.slice(1),t);if(!i.pid)throw new Error(b.localize(2,null,a[0]));this.x=i}else throw new Error(b.localize(3,null));else{const l={env:f};o.cwd&&(l.cwd=o.cwd),this.x=C.spawn(s,a,l)}this.x.on("error",l=>{this.m.fire(l)}),this.x.on("exit",(l,t)=>{this.n.fire(l)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",l=>{this.m.fire(l)}),this.x.stdin.on("error",l=>{this.m.fire(l)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(f){this.m.fire(f)}}async stopSession(){return this.x?(await this.u(),A.$j?new Promise((s,a)=>{const o=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(f,l,t){if(f)return a(f)});o.on("exit",s),o.on("error",a)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,a){if(!s)return;const o=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?o.runtime=R.$jc(a,s.runtime):o.runtime=s.runtime),s.runtimeArgs&&(o.runtimeArgs=s.runtimeArgs),s.program&&(R.$ic(s.program)?o.program=s.program:o.program=R.$jc(a,s.program)),s.args&&(o.args=s.args);const f=s;return f.win&&(o.win=p.A(f.win,a)),f.winx86&&(o.winx86=p.A(f.winx86,a)),f.windows&&(o.windows=p.A(f.windows,a)),f.osx&&(o.osx=p.A(f.osx,a)),f.linux&&(o.linux=p.A(f.linux,a)),o}static platformAdapterExecutable(s,a){let o=Object.create(null);a=a.toLowerCase();for(const n of s)if(n.contributes){const r=n.contributes.debuggers;r&&r.length>0&&r.filter(u=>typeof u.type=="string"&&m.$2e(u.type,a)).forEach(u=>{const I=p.A(u,n.extensionLocation.fsPath);o=d.$0m(o,I,n.isBuiltin)})}let f;A.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=o.winx86||o.win||o.windows:A.$j?f=o.win||o.windows:A.$k?f=o.osx:A.$l&&(f=o.linux),f=f||o;const l=f.program||o.program,t=f.args||o.args,i=f.runtime||o.runtime,c=f.runtimeArgs||o.runtimeArgs;if(i)return{type:"executable",command:i,args:(c||[]).concat(typeof l=="string"?[l]:[]).concat(t||[])};if(l)return{type:"executable",command:l,args:t||[]}}}e.$Dec=p}),define(De[275],Ce([1,0,49,33,12]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=e.$Eec=void 0;function R(b,L){return new Promise((P,v)=>{let y="";const k=C.spawn(b,L);k.pid&&k.stdout.on("data",p=>{y+=p.toString()}),k.on("error",p=>{v(p)}),k.on("close",p=>{P(y)})})}async function A(b){if(b)if(d.$j){const L=await new Promise((P,v)=>{$e(["@vscode/windows-process-tree"],P,v)});return new Promise(P=>{L.getProcessTree(b,v=>{P(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(b)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$Eec=A;var m;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(m||(m={}));function E(b,L,P,v,y){b=b.trim().toLowerCase();let k;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?k=1:b.indexOf("cmd.exe")>=0?k=0:b.indexOf("bash")>=0?k=2:d.$j?k=0:k=2;let p,h=" ";switch(k){case 1:if(p=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),v){const s=(0,T.$3f)(v);s&&(h+=`${s}:; `),h+=`cd ${p(v)}; `}if(y)for(const s in y){const a=y[s];a===null?h+=`Remove-Item env:${s}; `:h+=`\${env:${s}}='${a}'; `}if(L.length>0){const s=L.shift(),a=P?s:p(s);h+=a[0]==="'"?`& ${a} `:`${a} `;for(const o of L)h+=o==="<"||o===">"||P?o:p(o),h+=" "}break;case 0:if(p=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(a=>s.includes(a))||s.length===0?`"${s}"`:s),v){const s=(0,T.$3f)(v);s&&(h+=`${s}: && `),h+=`cd ${p(v)} && `}if(y){h+='cmd /C "';for(const s in y){let a=y[s];a===null?h+=`set "${s}=" && `:(a=a.replace(/[&^|<>]/g,o=>`^${o}`),h+=`set "${s}=${a}" && `)}}for(const s of L)h+=s==="<"||s===">"||P?s:p(s),h+=" ";y&&(h+='"');break;case 2:{p=a=>(a=a.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),a.length===0?'""':a);const s=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(v&&(h+=`cd ${p(v)} ; `),y){h+="/usr/bin/env";for(const a in y){const o=y[a];o===null?h+=` -u ${s(a)}`:h+=` ${s(`${a}=${o}`)}`}h+=" "}for(const a of L)h+=a==="<"||a===">"||P?a:p(a),h+=" ";break}}return h}e.$Fec=E}),define(De[108],Ce([1,0,22,36,51,97,18,16,12,42]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wI=e.$vI=e.$uI=e.$tI=e.CellStatusbarAlignment=e.$sI=e.$rI=e.$qI=e.NotebookEditorPriority=e.$pI=e.$oI=e.$nI=e.$mI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$lI=e.$kI=e.$jI=e.$iI=e.CellKind=e.$hI=e.$gI=e.$fI=void 0,e.$fI="workbench.editor.notebook",e.$gI="workbench.editor.notebookTextDiffEditor",e.$hI="workbench.editor.interactive";var L;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(L||(e.CellKind=L={})),e.$iI=["application/json","application/javascript","text/html","image/svg+xml",R.$Pr.latex,R.$Pr.markdown,"image/png","image/jpeg",R.$Pr.text],e.$jI=[R.$Pr.latex,R.$Pr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Pr.text],e.$kI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$lI="_notAvailable";var P;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var v;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var k;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var p;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var h;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var s;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var a;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var o;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;const q=["W","X","Y","Z","a","b","c","d","e","f"],K=new RegExp(`^[${q.join("")}]+`),me=7;function te(ye,H){const B=H.toString(me),re=`${B.length<q.length?q[B.length-1]:"z"}${B}s${(0,C.$ve)(C.$be.fromString(ye.scheme),!0,!0)}`;return ye.with({scheme:O.scheme,fragment:re})}O.generate=te;function G(ye){if(ye.scheme!==O.scheme)return;const H=ye.fragment.indexOf("s");if(H<0)return;const B=parseInt(ye.fragment.substring(0,H).replace(K,""),me),X=(0,C.$ue)(ye.fragment.substring(H+1)).toString();if(!isNaN(B))return{handle:B,notebook:ye.with({scheme:X,fragment:null})}}O.parse=G;function Q(ye,H){return ye.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${ye.scheme!==A.Schemas.file?ye.scheme:""}`})}O.generateCellOutputUri=Q;function le(ye){if(ye.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ye.fragment);if(!H)return;const B=H[1]&&H[1]!==""?H[1]:void 0,X=H[2];return{outputId:B,notebook:ye.with({scheme:X||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=le;function ie(ye,H,B){return O.generate(ye,H).with({scheme:B})}O.generateCellPropertyUri=ie;function ce(ye,H){if(ye.scheme===H)return O.parse(ye.with({scheme:O.scheme}))}O.parseCellPropertyUri=ce})(o||(e.CellUri=o={}));const f=O=>E.$j?O.replace(/\//g,"\\"):O;class l{constructor(q=[],K=e.$iI){this.e=K,this.d=[...new Set(q)].map(me=>({pattern:me,matches:T.$wj(f(me))}))}sort(q){const K=new Map(d.Iterable.map(q,te=>[te,f(te)]));let me=[];for(const{matches:te}of this.d)for(const[G,Q]of K)if(te(Q)){me.push(G),K.delete(G);break}return K.size&&(me=me.concat([...K.keys()].sort((te,G)=>this.e.indexOf(te)-this.e.indexOf(G)))),me}prioritize(q,K){const me=this.f(q);if(me===-1){this.d.unshift({pattern:q,matches:T.$wj(f(q))});return}const te=new Set(K.map(Q=>this.f(Q,me)));te.delete(-1);const G=Array.from(te).sort();this.d.splice(me+1,0,...G.map(Q=>this.d[Q]));for(let Q=G.length-1;Q>=0;Q--)this.d.splice(G[Q],1)}toArray(){return this.d.map(q=>q.pattern)}f(q,K=this.d.length){const me=f(q);for(let te=0;te<K;te++)if(this.d[te].matches(me))return te;return-1}}e.$mI=l;function t(O,q,K,me=(te,G)=>te===G){const te=[];function G(ie,ce,ye){if(ce===0&&ye.length===0)return;const H=te[te.length-1];H&&H.start+H.deleteCount===ie?(H.deleteCount+=ce,H.toInsert.push(...ye)):te.push({start:ie,deleteCount:ce,toInsert:ye})}let Q=0,le=0;for(;;){if(Q===O.length){G(Q,0,q.slice(le));break}if(le===q.length){G(Q,O.length-Q,[]);break}const ie=O[Q],ce=q[le];if(me(ie,ce)){Q+=1,le+=1;continue}K(ce)?(G(Q,1,[]),Q+=1):(G(Q,0,[ce]),le+=1)}return te}e.$nI=t,e.$oI=new b.$7i("notebookEditorCursorAtBoundary","none"),e.$pI=new b.$7i("notebookEditorCursorAtLineBoundary","none");var i;(function(O){O.default="default",O.option="option"})(i||(e.NotebookEditorPriority=i={}));function c(O){const q=O;return!!((typeof q.include=="string"||T.$xj(q.include))&&(typeof q.exclude=="string"||T.$xj(q.exclude)))}e.$qI=c;function n(O,q,K){if(Array.isArray(O.viewType)&&O.viewType.indexOf(q)>=0||O.viewType===q)return!0;if(O.filenamePattern){const me=c(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,te=c(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$vj(me,(0,m.$nc)(K.fsPath).toLowerCase()))return!(te&&T.$vj(te,(0,m.$nc)(K.fsPath).toLowerCase()))}return!1}e.$rI=n,e.$sI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var r;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(r||(e.CellStatusbarAlignment=r={}));class u{static{this.d="notebook/"}static create(q){return`${u.d}${q}`}static parse(q){if(q.startsWith(u.d))return q.substring(u.d.length)}}e.$tI=u;function I(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$uI=I;const S=new TextDecoder;function $(O){const q=[];let K=!1;for(const Q of O)(q.length===0||K)&&(q.push(Q),K=!0);let me=D(q);const te=C.$be.concat(q.map(Q=>C.$be.wrap(Q))),G=j(te);return me=me||G.byteLength!==te.byteLength,{data:G,didCompression:me}}e.$vI=$,e.$wI=`${String.fromCharCode(27)}[A`;const g=e.$wI.split("").map(O=>O.charCodeAt(0)),w=10;function D(O){let q=!1;return O.forEach((K,me)=>{if(me===0||K.length<e.$wI.length)return;const te=O[me-1],G=K.subarray(0,e.$wI.length);if(G[0]===g[0]&&G[1]===g[1]&&G[2]===g[2]){const Q=te.lastIndexOf(w);if(Q===-1)return;q=!0,O[me-1]=te.subarray(0,Q),O[me]=K.subarray(e.$wI.length)}}),q}function N(O){let q=O;do O=q,q=O.replace(/[^\n]\x08/gm,"");while(q.length<O.length);return O}function M(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const q=O.match(/^(.*)\r+/m)[1];let K=O.match(/\r+(.*)$/m)[1];K=K+q.slice(K.length,q.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,K)}return O}const F="\b".charCodeAt(0),U="\r".charCodeAt(0);function j(O){return!O.buffer.includes(F)&&!O.buffer.includes(U)?O:C.$be.fromString(M(N(S.decode(O.buffer))))}}),define(De[7],Ce([1,0,19,9,80,28,97,15,17,2,31,25,30,65,108]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k){"use strict";var p,h,s,a,o,f,l,t,i,c,n,r,u,I,S,$,g,w;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$bM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.TestRunProfileKind=e.TestResultState=e.$UL=e.$TL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$SL=e.$RL=e.$QL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$PL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.ColorThemeKind=e.$JL=e.$IL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$HL=e.DebugConsoleMode=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$BL=e.$AL=e.FileChangeType=e.$zL=e.$yL=e.$xL=e.$wL=e.InlineCompletionTriggerKind=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.ConfigurationTarget=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$_K=e.ViewBadge=e.ProgressLocation=e.$$K=e.$0K=e.TaskScope=e.ShellQuoting=e.$9K=e.$8K=e.$7K=e.TaskPanelKind=e.TaskRevealKind=e.$6K=e.TerminalLocation=e.$5K=e.$4K=e.$3K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$2K=e.$1K=e.$ZK=e.$YK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$XK=e.StatusBarAlignment=e.ViewColumn=e.$WK=e.$VK=e.$UK=e.$TK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$SK=e.$RK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.LanguageStatusSeverity=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.CodeActionTriggerKind=e.$FK=e.$EK=e.SymbolTag=e.SymbolKind=e.$DK=e.DocumentHighlightKind=e.$CK=e.$BK=e.$AK=e.$zK=e.DiagnosticSeverity=e.DiagnosticTag=e.$yK=e.$xK=e.FileEditType=e.$wK=e.$vK=e.$uK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(V){return Object.assign(V,{apply:function(...pe){if(pe.length===0)return Reflect.construct(V,[]);{const Re=pe.length===1?[]:pe[1];return Reflect.construct(V,Re,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(V,[]);{const[Re,...Qe]=pe;return Reflect.construct(V,Qe,Re.constructor)}}})}var N;(function(V){V[V.Top=0]="Top",V[V.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var M;(function(V){V[V.TerminalCommand=0]="TerminalCommand",V[V.Opener=1]="Opener",V[V.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let F=p=class{static from(...W){let pe=W;return new p(function(){if(pe){for(const Re of pe)Re&&typeof Re.dispose=="function"&&Re.dispose();pe=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$nK=F,e.$nK=F=p=He([D],F);let U=h=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(pe)&&(pe=Qe)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(pe)&&(pe=Qe)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof h)return!0;const{line:pe,character:Re}=W;return typeof pe=="number"&&typeof Re=="number"}static of(W){if(W instanceof h)return W;if(this.isPosition(W))return new h(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,T.$7)("line must be non-negative");if(pe<0)throw(0,T.$7)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,T.$7)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&pe===0?this:new h(this.line+Re,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,T.$7)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Re===this.line&&pe===this.character?this:new h(Re,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$oK=U,e.$oK=U=h=He([D],U);let j=s=class{static isRange(W){return W instanceof s?!0:W?U.isPosition(W.start)&&U.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Re,Qe){let et,ot;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(et=new U(W,pe),ot=new U(Re,Qe)):U.isPosition(W)&&U.isPosition(pe)&&(et=U.of(W),ot=U.of(pe)),!et||!ot)throw new Error("Invalid arguments");et.isBefore(ot)?(this.c=et,this.e=ot):(this.c=ot,this.e=et)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):U.isPosition(W)?!(U.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=U.Max(W.start,this.c),Re=U.Min(W.end,this.e);if(!pe.isAfter(Re))return new s(pe,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=U.Min(W.start,this.c),Re=U.Max(W.end,this.end);return new s(pe,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,T.$7)();let Re;return W?U.isPosition(W)?Re=W:(Re=W.start||this.start,pe=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&pe.isEqual(this.end)?this:new s(Re,pe)}toJSON(){return[this.start,this.end]}};e.$pK=j,e.$pK=j=s=He([D],j);let O=a=class extends j{static isSelection(W){return W instanceof a?!0:W?j.isRange(W)&&U.isPosition(W.anchor)&&U.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Re,Qe){let et,ot;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(et=new U(W,pe),ot=new U(Re,Qe)):U.isPosition(W)&&U.isPosition(pe)&&(et=U.of(W),ot=U.of(pe)),!et||!ot)throw new Error("Invalid arguments");super(et,ot),this.f=et,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$qK=O,e.$qK=O=a=He([D],O);const q=V=>{if(typeof V!="string"||V.length===0||!/^[0-9A-Za-z_\-]+$/.test(V))throw(0,T.$7)("connectionToken")};class K{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Re){if(typeof W!="string"||W.length===0)throw(0,T.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,T.$7)("port");typeof Re<"u"&&q(Re),this.host=W,this.port=Math.round(pe),this.connectionToken=Re}}e.$rK=K;class me{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&q(pe)}}e.$sK=me;class te extends Error{static NotAvailable(W,pe){return new te(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new te(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=pe,this._detail=Re,Object.setPrototypeOf(this,te.prototype)}}e.$tK=te;var G;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(G||(e.EndOfLine=G={}));var Q;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let le=o=class{static isTextEdit(W){return W instanceof o?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new o(W,pe)}static insert(W,pe){return o.replace(new j(W,W),pe)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const pe=new o(new j(new U(0,0),new U(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,T.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$7)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$uK=le,e.$uK=le=o=He([D],le);let ie=f=class{static isNotebookCellEdit(W){return W instanceof f?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new f(W,pe)}static insertCells(W,pe){return new f(new xt(W,W),pe)}static deleteCells(W){return new f(W,[])}static updateCellMetadata(W,pe){const Re=new f(new xt(W,W),[]);return Re.newCellMetadata=pe,Re}static updateNotebookMetadata(W){const pe=new f(new xt(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$vK=ie,e.$vK=ie=f=He([D],ie);class ce{static isSnippetTextEdit(W){return W instanceof ce?!0:W?j.isRange(W.range)&&B.isSnippetString(W.snippet):!1}static replace(W,pe){return new ce(W,pe)}static insert(W,pe){return ce.replace(new j(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$wK=ce;var ye;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace",V[V.Snippet=6]="Snippet"})(ye||(e.FileEditType=ye={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Re,Qe){this.c.push({_type:1,from:W,to:pe,options:Re,metadata:Qe})}createFile(W,pe,Re){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Re})}deleteFile(W,pe,Re){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Re})}e(W,pe,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Re,Qe){const et=pe.start,ot=pe.end;(et!==ot||Re.length>0)&&this.c.push({_type:5,uri:W,index:et,count:ot-et,cells:Re,metadata:Qe})}g(W,pe,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:pe,metadata:Re}})}replace(W,pe,Re,Qe){this.c.push({_type:2,uri:W,edit:new le(pe,Re),metadata:Qe})}insert(W,pe,Re,Qe){this.replace(W,new j(pe,pe),Re,Qe)}delete(W,pe,Re){this.replace(W,pe,"",Re)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Re of pe){if(!Re)continue;let Qe,et;Array.isArray(Re)?(Qe=Re[0],et=Re[1]):Qe=Re,ie.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,et):this.f(W,Qe.range,Qe.newCells,et):ce.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:2,uri:W,edit:Qe,metadata:et})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Ib)(this.c)}}get(W){const pe=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&pe.push(Re.edit);return pe}entries(){const W=new R.$Ac;for(const pe of this.c)if(pe._type===2){let Re=W.get(pe.uri);Re||(Re=[pe.uri,[]],W.set(pe.uri,Re)),Re[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$xK=H,e.$xK=H=He([D],H);let B=l=class{static isSnippetString(W){return W instanceof l?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=l.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Re=new l;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=l.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Re=new l;Re.e=this.e,pe(Re),this.e=Re.e,pe=Re.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$yK=B,e.$yK=B=l=He([D],B);var X;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(X||(e.DiagnosticTag=X={}));var re;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let Y=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&b.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(j.isRange(pe))this.range=j.of(pe);else if(U.isPosition(pe))this.range=new j(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$zK=Y,e.$zK=Y=t=He([D],Y);let _=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&b.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$AK=_,e.$AK=_=He([D],_);let x=class{constructor(W,pe,Re=re.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Re}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,C.$ub)(W.tags,pe.tags)&&(0,C.$ub)(W.relatedInformation,pe.relatedInformation,_.isEqual)}};e.$BK=x,e.$BK=x=He([D],x);let ve=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$CK=ve,e.$CK=ve=He([D],ve);var ae;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let fe=class{constructor(W,pe=ae.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$DK=fe,e.$DK=fe=He([D],fe);var ee;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var de;(function(V){V[V.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let be=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Re,Qe,et){this.name=W,this.kind=pe,this.containerName=et,typeof Re=="string"&&(this.containerName=Re),Qe instanceof Y?this.location=Qe:Re instanceof j&&(this.location=new Y(Qe,Re)),i.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$EK=be,e.$EK=be=i=He([D],be);let Pe=c=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(c.validate)}constructor(W,pe,Re,Qe,et){this.name=W,this.detail=pe,this.kind=Re,this.range=Qe,this.selectionRange=et,this.children=[],c.validate(this)}};e.$FK=Pe,e.$FK=Pe=c=He([D],Pe);var z;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let J=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$GK=J,e.$GK=J=He([D],J);let se=class{static{n=this}static{this.c="."}constructor(W){this.value=W}append(W){return new n(this.value?this.value+n.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+n.c)}};e.$HK=se,e.$HK=se=n=He([D],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$IK=oe,e.$IK=oe=He([D],oe);class Z{constructor(W,pe,Re,Qe,et,ot){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$JK=Z;class ge{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$KK=ge;class Ee{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$LK=Ee;var je;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$MK=We,e.$MK=We=He([D],We);let _e=r=class{#e;static isMarkdownString(W){return W instanceof r?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){this.#e=new d.$3j(W,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,pe){return this.#e.appendCodeblock(pe??"",W),this}};e.$NK=_e,e.$NK=_e=r=He([D],_e);let Xe=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$OK=Xe,e.$OK=Xe=He([D],Xe);let it=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$PK=it,e.$PK=it=He([D],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$QK=tt,e.$QK=tt=He([D],tt);var Ae;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let qe=class{constructor(W){this.value=W}};e.$RK=qe,e.$RK=qe=He([D],qe);let Le=class{constructor(W,pe,Re){this.position=W,this.label=pe,this.kind=Re}};e.$SK=Le,e.$SK=Le=He([D],Le);var Ye;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye||(e.CompletionTriggerKind=Ye={}));var he;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var ue;(function(V){V[V.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$TK=Ie,e.$TK=Ie=He([D],Ie);let Ke=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$UK=Ke,e.$UK=Ke=He([D],Ke);let Ue=class{constructor(W,pe,Re){this.insertText=W,this.range=pe,this.command=Re}};e.$VK=Ue,e.$VK=Ue=He([D],Ue);let Ze=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$WK=Ze,e.$WK=Ze=He([D],Ze);var nt;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ct;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function bt(V,W){return`${P.$6l.toKey(V)}.${W}`}e.$XK=bt;var Et;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Kt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var vt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(V){function W(pe){switch(pe){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=W}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(V){function W(pe){switch(pe){case V.Other:return"other";case V.Comment:return"comment";case V.String:return"string";case V.RegEx:return"regex"}return"other"}V.toString=W}(Gt||(e.SyntaxTokenType=Gt={}));let zt=class{constructor(W,pe){if(pe&&!b.URI.isUri(pe))throw(0,T.$7)("target");if(!j.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.target=pe}};e.$YK=zt,e.$YK=zt=He([D],zt);let Dt=class{constructor(W,pe,Re,Qe){this.red=W,this.green=pe,this.blue=Re,this.alpha=Qe}};e.$ZK=Dt,e.$ZK=Dt=He([D],Dt);let Ft=class{constructor(W,pe){if(pe&&!(pe instanceof Dt))throw(0,T.$7)("color");if(!j.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.color=pe}};e.$1K=Ft,e.$1K=Ft=He([D],Ft);let Bt=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$7)("label");this.label=W}};e.$2K=Bt,e.$2K=Bt=He([D],Bt);var Jt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(V){V[V.Unknown=0]="Unknown",V[V.Shutdown=1]="Shutdown",V[V.Process=2]="Process",V[V.User=3]="User",V[V.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class Ot{constructor(W,pe,Re){if(this.startIndex=W,this.length=pe,this.tooltip=Re,typeof W!="number"||W<0)throw(0,T.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,T.$7)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$7)("tooltip")}}e.$3K=Ot;class ut{constructor(W){this.uri=W}}e.$4K=ut;class ft{constructor(W){this.terminalCommand=W}}e.$5K=ft;var At;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class Vt{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$7)("options")}}e.$6K=Vt;var Rt;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var at;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(at||(e.TaskPanelKind=at={}));let pt=class{static{u=this}static{this.Clean=new u("clean","Clean")}static{this.Build=new u("build","Build")}static{this.Rebuild=new u("rebuild","Rebuild")}static{this.Test=new u("test","Test")}static from(W){switch(W){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,T.$7)("name");this.c=W}get id(){return this.c}};e.$7K=pt,e.$7K=pt=u=He([D],pt);function Tt(V){let W="";for(let pe=0;pe<V.length;pe++)W+=V[pe].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,pe,Re){if(typeof W!="string")throw(0,T.$7)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Re):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Tt(W)}};e.$8K=Pt,e.$8K=Pt=He([D],Pt);let Ge=class{constructor(W,pe,Re){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,T.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W,this.f=pe,this.g=Re}else{if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Tt(W)}};e.$9K=Ge,e.$9K=Ge=He([D],Ge);var Qt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Me;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Te{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.$eg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$0K=Te;let Se=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,pe,Re,Qe,et,ot){this.j=!1,this.k=this.definition=W;let ht;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Re,this.execution=Qe,ht=et,this.j=!0):pe===Me.Global||pe===Me.Workspace?(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=et,ht=ot):(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=et,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Te?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,L.$eg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,T.$7)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,T.$7)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const pe=this.k.type;(I.g===pe||I.e===pe||I.f===pe||I.c===pe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$7)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$$K=Se,e.$$K=Se=I=He([D],Se);var ne;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(ne||(e.ProgressLocation=ne={}));var Fe;(function(V){function W(pe){const Re=pe;return(0,E.$Cf)(Re.value)?Re.tooltip&&!(0,E.$yf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}V.isViewBadge=W})(Fe||(e.ViewBadge=Fe={}));let Ve=S=class{static isTreeItem(W,pe){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,E.$Cf)(Re.checkboxState)?Re.checkboxState:(0,E.$Af)(Re.checkboxState)&&(0,E.$Cf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,et=!(0,E.$Cf)(Re.checkboxState)&&(0,E.$Af)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Je.Checked&&Qe!==Je.Unchecked||et!==void 0&&!(0,E.$yf)(et))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof S)return!0;if(Re.label!==void 0&&!(0,E.$yf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$yf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$yf)(Re.iconPath)&&!b.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$yf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,E.$yf)(Qe.light)&&!b.URI.isUri(Qe.light)&&!(0,E.$yf)(Qe.dark)&&!b.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$yf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!b.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$yf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<xe.None&&Re.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$yf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,pe=xe.None){this.collapsibleState=pe,b.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$_K=Ve,e.$_K=Ve=S=He([D],Ve);var xe;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Je;(function(V){V[V.Unchecked=0]="Unchecked",V[V.Checked=1]="Checked"})(Je||(e.TreeItemCheckboxState=Je={}));let rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$aL=rt,e.$aL=rt=He([D],rt);class kt extends rt{}e.$bL=kt;class St extends kt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$cL=St;class mt{constructor(W,pe,Re,Qe){this.name=W,this.uri=pe,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$dL=mt;let dt=class{#e=new Map;constructor(W){for(const[pe,Re]of W??[]){const Qe=this.#e.get(this.#t(pe));Qe?Qe.push(Re):this.#e.set(this.#t(pe),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,pe){this.#e.set(this.#t(W),[pe])}forEach(W,pe){for(const[Re,Qe]of this.#e)for(const et of Qe)W.call(pe,et,Re,this)}*[Symbol.iterator](){for(const[W,pe]of this.#e)for(const Re of pe)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$eL=dt,e.$eL=dt=He([D],dt);let gt=class{constructor(W){this.insertText=W}};e.$fL=gt,e.$fL=gt=He([D],gt);let mi=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$gL=mi,e.$gL=mi=He([D],mi);let Ct=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$hL=Ct,e.$hL=Ct=He([D],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$iL=Di,e.$iL=Di=He([D],Di);var ui;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=b.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!b.URI.isUri(W)&&!b.URI.isUri(W.uri)))throw(0,T.$7)("base");if(typeof pe!="string")throw(0,T.$7)("pattern");typeof W=="string"?this.baseUri=b.URI.file(W):b.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$jL=$i,e.$jL=$i=He([D],$i);const It=new WeakMap;function fn(V,W){It.set(V,W)}e.$kL=fn;let ri=class{constructor(W,pe,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=It.get(this)??(0,L.$eg)()),this.c}};e.$lL=ri,e.$lL=ri=He([D],ri);let yt=class extends ri{constructor(W,pe,Re,Qe,et){if(super(pe,Re,Qe,et),W===null)throw(0,T.$7)("location");this.location=W}};e.$mL=yt,e.$mL=yt=He([D],yt);let bi=class extends ri{constructor(W,pe,Re,Qe,et){super(pe,Re,Qe,et),this.functionName=W}};e.$nL=bi,e.$nL=bi=He([D],bi);let wi=class extends ri{constructor(W,pe,Re,Qe,et,ot,ht){if(super(Qe,et,ot,ht),!pe)throw(0,T.$7)("dataId");this.label=W,this.dataId=pe,this.canPersist=Re}};e.$oL=wi,e.$oL=wi=He([D],wi);let si=class{constructor(W,pe,Re){this.command=W,this.args=pe||[],this.options=Re}};e.$pL=si,e.$pL=si=He([D],si);let Ci=class{constructor(W,pe){this.port=W,this.host=pe}};e.$qL=Ci,e.$qL=Ci=He([D],Ci);let Ii=class{constructor(W){this.path=W}};e.$rL=Ii,e.$rL=Ii=He([D],Ii);let Lt=class{constructor(W){this.implementation=W}};e.$sL=Lt,e.$sL=Lt=He([D],Lt);let vi=class{constructor(W,pe,Re){this.session=W,this.threadId=pe,this.frameId=Re}};e.$tL=vi,e.$tL=vi=He([D],vi);let Pi=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$uL=Pi,e.$uL=Pi=He([D],Pi);let oi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$vL=oi,e.$vL=oi=He([D],oi);var li;(function(V){V[V.Invoke=0]="Invoke",V[V.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let lt=class{constructor(W,pe){this.range=W,this.text=pe}};e.$wL=lt,e.$wL=lt=He([D],lt);let Ai=class{constructor(W,pe,Re=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Re}};e.$xL=Ai,e.$xL=Ai=He([D],Ai);let Zt=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$yL=Zt,e.$yL=Zt=He([D],Zt);let ii=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$zL=ii,e.$zL=ii=He([D],ii);var Ri;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Li=$=class extends Error{static FileExists(W){return new $(W,v.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(W){return new $(W,v.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(W){return new $(W,v.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(W){return new $(W,v.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(W){return new $(W,v.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(W){return new $(W,v.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(W,pe=v.FileSystemProviderErrorCode.Unknown,Re){super(b.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,v.$nk)(this,pe),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$AL=Li,e.$AL=Li=$=He([D],Li);let Mi=class{constructor(W,pe,Re){this.start=W,this.end=pe,this.kind=Re}};e.$BL=Mi,e.$BL=Mi=He([D],Mi);var Xi;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Fi;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Yi;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Ti;(function(V){V[V.Published=0]="Published",V[V.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$CL=gn;function Ni(V){return typeof V>"u"||(0,E.$zf)(V)}class hi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let pe=0,Re=W.tokenTypes.length;pe<Re;pe++)this.j.set(W.tokenTypes[pe],pe);for(let pe=0,Re=W.tokenModifiers.length;pe<Re;pe++)this.k.set(W.tokenModifiers[pe],pe)}}push(W,pe,Re,Qe,et){if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.n(W,pe,Re,Qe,et);if(j.isRange(W)&&typeof pe=="string"&&Ni(Re))return this.m(W,pe,Re);throw(0,T.$7)()}m(W,pe,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,et=W.start.character,ot=W.end.character-W.start.character,ht=this.j.get(pe);let jt=0;if(Re)for(const Yt of Re){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);jt|=1<<ei>>>0}this.n(Qe,et,ot,ht,jt)}n(W,pe,Re,Qe,et){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const jt=this.g.length/5|0;let Yt=0,ei=0;for(let ti=0;ti<jt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Yt,Ji+=ei):ni+=Yt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Yt=ni,ei=Ji}}let ot=W,ht=pe;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=et,this.c=W,this.e=pe}static o(W){const pe=[],Re=W.length/5|0;for(let ht=0;ht<Re;ht++)pe[ht]=ht;pe.sort((ht,jt)=>{const Yt=W[5*ht],ei=W[5*jt];if(Yt===ei){const ti=W[5*ht+1],ni=W[5*jt+1];return ti-ni}return Yt-ei});const Qe=new Uint32Array(W.length);let et=0,ot=0;for(let ht=0;ht<Re;ht++){const jt=5*pe[ht],Yt=W[jt+0],ei=W[jt+1],ti=W[jt+2],ni=W[jt+3],Ji=W[jt+4],In=Yt-et,Fn=In===0?ei-ot:ei,Qi=5*ht;Qe[Qi+0]=In,Qe[Qi+1]=Fn,Qe[Qi+2]=ti,Qe[Qi+3]=ni,Qe[Qi+4]=Ji,et=Yt,ot=ei}return Qe}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(hi.o(this.g),W)}}e.$DL=hi;class Oi{constructor(W,pe){this.resultId=pe,this.data=W}}e.$EL=Oi;class mn{constructor(W,pe,Re){this.start=W,this.deleteCount=pe,this.data=Re}}e.$FL=mn;class di{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$GL=di;var Zi;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let ji=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$HL=ji,e.$HL=ji=He([D],ji);var xi;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(V){V[V.Info=1]="Info",V[V.Warning=2]="Warning",V[V.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(W){if(typeof W.badge=="string"){let pe=(0,m.$_e)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,m.$_e)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Re){this.badge=W,this.tooltip=pe,this.color=Re}}e.$IL=$n;let Ui=class{constructor(W){this.kind=W}};e.$JL=Ui,e.$JL=Ui=He([D],Ui);var gi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast",V[V.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,T.$7)("start must be positive");if(pe<0)throw(0,T.$7)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Re=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Re=W.end),pe===this.c&&Re===this.e?this:new xt(pe,Re)}}e.$KL=xt;class pi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>pi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Re,Qe,et,ot,ht){this.kind=W,this.value=pe,this.languageId=Re,this.mime=Qe,this.outputs=et??[],this.metadata=ot,this.executionSummary=ht,pi.validate(this)}}e.$LL=pi;class bn{constructor(W){this.cells=W}}e.$ML=bn;class Xt{static isNotebookCellOutputItem(W){return W instanceof Xt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return Xt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return Xt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Xt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new Xt(W,pe)}static#e=new TextEncoder;static text(W,pe=A.$Pr.text){const Re=Xt.#e.encode(String(W));return new Xt(Re,pe)}static json(W,pe="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Xt.text(Re,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Re=(0,A.$Tr)(pe,!0);if(!Re)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$NL=Xt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Re=new Set,Qe=new Set;for(let et=0;et<W.length;et++){const ot=W[et],ht=(0,A.$Tr)(ot.mime);if(!Re.has(ht)||(0,k.$uI)(ht)){Re.add(ht);continue}Qe.add(et),pe&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Qe.size===0?W:W.filter((et,ot)=>!Qe.has(ot))}constructor(W,pe,Re){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Re):(this.id=(0,L.$eg)(),this.metadata=pe??Re)}}e.$OL=yi;var en;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(W,pe){this.text=W,this.alignment=pe}}e.$PL=rn;var ze;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(ze||(e.NotebookControllerAffinity=ze={}));var _t;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred",V[V.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(W,pe=[]){this.uri=W,this.provides=(0,C.$3b)(pe)}}e.$QL=sn;class $t{constructor(W){this.label=W}}e.$RL=$t;let zi=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$SL=zi,e.$SL=zi=He([D],zi);var on;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class ki{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$TL=ki;class wn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$UL=wn;var cn;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Si=class{constructor(W=void 0,pe=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=pe,this.profile=Re,this.continuous=Qe}};e.$VL=Si,e.$VL=Si=He([D],Si);let Wi=g=class{static diff(W,pe,Re){const Qe=new g(W);return Qe.expectedOutput=pe,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$WL=Wi,e.$WL=Wi=g=He([D],Wi);let qi=class{constructor(W){this.id=W}};e.$XL=qi,e.$XL=qi=He([D],qi);let ci=class{constructor(W,pe){this.covered=W,this.total=pe}};e.$YL=ci,e.$YL=ci=He([D],ci);let Vi=w=class{static fromDetails(W,pe){const Re=new ci(0,0),Qe=new ci(0,0),et=new ci(0,0);for(const ht of pe)if("branches"in ht){Re.total+=1,Re.covered+=ht.executionCount>0?1:0;for(const jt of ht.branches)Qe.total+=1,Qe.covered+=jt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ot=new w(W,Re,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return ot.detailedCoverage=pe,ot}constructor(W,pe,Re,Qe){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$ZL=Vi,e.$ZL=Vi=w=He([D],Vi);let Ki=class{constructor(W,pe,Re=[]){this.executionCount=W,this.location=pe,this.branches=Re}};e.$1L=Ki,e.$1L=Ki=He([D],Ki);let Hi=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$2L=Hi,e.$2L=Hi=He([D],Hi);let Gi=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$3L=Gi,e.$3L=Gi=He([D],Gi);var ln;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var hn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var dn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn||(e.PortAutoForwardAction=dn={}));class we{constructor(W,pe,Re,Qe,et,ot){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=et,this.selectionRange=ot}}e.$4L=we;class ke{constructor(W){this.uri=W}}e.$5L=ke;class Oe{constructor(W,pe){this.original=W,this.modified=pe}}e.$6L=Oe;class st{constructor(W,pe,Re,Qe){this.base=W,this.input1=pe,this.input2=Re,this.result=Qe}}e.$7L=st;class wt{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$8L=wt;class Mt{constructor(W){this.viewType=W}}e.$9L=Mt;class Pn{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$0L=Pn;class An{constructor(W,pe,Re){this.original=W,this.modified=pe,this.notebookType=Re}}e.$$L=An;class Rn{constructor(){}}e.$_L=Rn;class Ln{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$aM=Ln;var vn;(function(V){V[V.Down=0]="Down",V[V.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var pn;(function(V){V[V.Action=1]="Action",V[V.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var yn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful",V[V.Undone=2]="Undone",V[V.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(V){V[V.System=0]="System",V[V.User=1]="User",V[V.Assistant=2]="Assistant",V[V.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(V){V[V.Short=1]="Short",V[V.Medium=2]="Medium",V[V.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Mn{constructor(W,pe){this.role=W,this.content=pe}}e.$bM=Mn;var Sn;(function(V){V[V.Unhelpful=0]="Unhelpful",V[V.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(V){V[V.SymbolInformation=1]="SymbolInformation",V[V.CommandInformation=2]="CommandInformation",V[V.SearchInformation=3]="SearchInformation",V[V.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(V){V[V.Started=1]="Started",V[V.Recognizing=2]="Recognizing",V[V.Recognized=3]="Recognized",V[V.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(De[141],Ce([1,0,58,18,15,171,124,7,19]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=void 0;const b=new Map;function L(k,p){p?b.set(k,p):b.delete(k)}e.$oM=L;function P(k){return b.get(k)}class v extends R.$Vu{constructor(p,h,s,a,o,f,l,t){super(h,s,a,o),this.c=p,this.m=f,this.q=l,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$ub)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===T.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(h){return h?p.s(h):p.getText()},get eol(){return p.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(h){return p.t(h)},offsetAt(h){return p.u(h)},positionAt(h){return p.v(h)},validateRange(h){return p.w(h)},validatePosition(h){return p.x(h)},getWordRangeAtPosition(h,s){return p.y(h,s)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,C.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,C.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const h=this.w(p);if(h.isEmpty)return"";if(h.isSingleLine)return this.f[h.start.line].substring(h.start.character,h.end.character);const s=this.g,a=h.start.line,o=h.end.line,f=[];f.push(this.f[a].substring(h.start.character));for(let l=a+1;l<o;l++)f.push(this.f[l]);return f.push(this.f[o].substring(0,h.end.character)),f.join(s)}t(p){let h;if(p instanceof m.$oK?h=p.line:typeof p=="number"&&(h=p),typeof h!="number"||h<0||h>=this.f.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new y(h,this.f[h],h===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const h=this.j.getIndexOf(p),s=this.f[h.index].length;return new m.$oK(h.index,Math.min(h.remainder,s))}w(p){if(!(p instanceof m.$pK))throw new Error("Invalid argument");const h=this.x(p.start),s=this.x(p.end);return h===p.start&&s===p.end?p:new m.$pK(h.line,h.character,s.line,s.character)}x(p){if(!(p instanceof m.$oK))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:h,character:s}=p,a=!1;if(h<0)h=0,s=0,a=!0;else if(h>=this.f.length)h=this.f.length-1,s=this.f[h].length,a=!0;else{const o=this.f[h].length;s<0?(s=0,a=!0):s>o&&(s=o,a=!0)}return a?new m.$oK(h,s):p}y(p,h){const s=this.x(p);if(!h)h=P(this.m);else if((0,d.$Oe)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const a=(0,A.$8r)(s.character+1,(0,A.$6r)(h),this.f[s.line],0);if(a)return new m.$pK(s.line,a.startColumn-1,s.line,a.endColumn-1)}}e.$pM=v;class y{constructor(p,h,s){this.a=p,this.b=h,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$pK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$pK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$qM=y}),define(De[276],Ce([1,0,7,20,4]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;let R=class{constructor(m){this.a=new C.$JL(C.ColorThemeKind.Dark),this.b=new d.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let E;switch(m){case"light":E=C.ColorThemeKind.Light;break;case"hcDark":E=C.ColorThemeKind.HighContrast;break;case"hcLight":E=C.ColorThemeKind.HighContrastLight;break;default:E=C.ColorThemeKind.Dark}this.a=new C.$JL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Vdc=R,e.$Vdc=R=He([Be(0,T.$mM)],R)}),define(De[277],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yI=e.CellExecutionUpdateType=void 0;var T;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$yI=(0,C.$Ph)("INotebookExecutionService")}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(R){R.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var T;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class d{static fromExtHostTestItem(A,m,E=A.parent){if(A._isRoot)return new d([m]);const b=[A.id];for(let L=E;L&&L.id!==m;L=L.parent)b.push(L.id);return b.push(m),new d(b.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new d(A.split("\0"))}static join(A,m){return new d([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:d.isChild(A,m)?2:d.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.d>1?new d(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new d(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new d(this.path,A)}compare(A){if(typeof A=="string")return d.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$eJ=d}),define(De[87],Ce([1,0,2,32,68]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$kJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$jJ=e.$iJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$hJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$gJ=e.$fJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var m;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$fJ=[2,4,8,16,32,64];const E=S=>"runId"in S;e.$gJ=E;var b;(function(S){S.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),S.deserialize=$=>({range:T.$ts.lift($.range),uri:C.URI.revive($.uri)})})(b||(e.IRichLocation=b={}));var L;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(L||(e.TestMessageType=L={}));var P;(function(S){S.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&b.serialize($.location)}),S.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&b.deserialize($.location)})})(P||(e.ITestErrorMessage=P={}));const v=(S,$)=>`${$?"s":"e"}${S}`;e.$hJ=v;var y;(function(S){S.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&b.serialize($.location)}),S.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&b.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var k;(function(S){S.serialize=$=>$.type===0?P.serialize($):y.serialize($),S.deserialize=$=>$.type===0?P.deserialize($):y.deserialize($)})(k||(e.ITestMessage=k={}));var p;(function(S){S.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),S.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(k.serialize)}),S.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(k.deserialize)})})(p||(e.ITestTaskState=p={}));const h="\0",s=(S,$)=>S+h+$;e.$iJ=s;const a=S=>{const $=S.indexOf(h);return{ctrlId:S.slice(0,$),tagId:S.slice($+1)}};e.$jJ=a;var o;(function(S){S.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),S.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?C.URI.revive($.uri):void 0,range:$.range?T.$ts.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(o||(e.ITestItem=o={}));var f;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(f||(e.TestItemExpandState=f={}));var l;(function(S){S.serialize=$=>({expand:$.expand,item:o.serialize($.item)}),S.deserialize=$=>({controllerId:d.$eJ.root($.item.extId),expand:$.expand,item:o.deserialize($.item)})})(l||(e.InternalTestItem=l={}));var t;(function(S){S.serialize=$=>{let g;return $.item&&(g={},$.item.label!==void 0&&(g.label=$.item.label),$.item.tags!==void 0&&(g.tags=$.item.tags),$.item.busy!==void 0&&(g.busy=$.item.busy),$.item.uri!==void 0&&(g.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(g.range=$.item.range?.toJSON()),$.item.description!==void 0&&(g.description=$.item.description),$.item.error!==void 0&&(g.error=$.item.error),$.item.sortText!==void 0&&(g.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:g}},S.deserialize=$=>{let g;return $.item&&(g={},$.item.label!==void 0&&(g.label=$.item.label),$.item.tags!==void 0&&(g.tags=$.item.tags),$.item.busy!==void 0&&(g.busy=$.item.busy),$.item.range!==void 0&&(g.range=$.item.range?T.$ts.lift($.item.range):null),$.item.description!==void 0&&(g.description=$.item.description),$.item.error!==void 0&&(g.error=$.item.error),$.item.sortText!==void 0&&(g.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:g}}})(t||(e.ITestItemUpdate=t={}));const i=(S,$)=>{$.expand!==void 0&&(S.expand=$.expand),$.item!==void 0&&(S.item=S.item?Object.assign(S.item,$.item):$.item)};e.$kJ=i;var c;(function(S){S.serializeWithoutMessages=$=>({...l.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serializeWithoutMessages)}),S.serialize=$=>({...l.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.serialize)}),S.deserialize=$=>({...l.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(p.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var n;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(n||(e.DetailType=n={}));var r;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(r||(e.TestDiffOpType=r={}));var u;(function(S){S.deserialize=$=>$.op===0?{op:$.op,item:l.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:C.URI.revive($.uri),docv:$.docv}:$,S.serialize=$=>$.op===0?{op:$.op,item:l.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(u||(e.TestsDiffOp=u={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply($){const g=this.o();for(const w of $)switch(w.op){case 0:this.j(l.deserialize(w.item),g);break;case 1:this.k(t.deserialize(w.item),g);break;case 3:this.l(w.itemId,g);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}g.complete?.()}j($,g){const w=d.$eJ.parentId($.item.extId)?.toString();let D;if(!w)D=this.p($),this.f.add(D),this.d.set($.item.extId,D);else if(this.d.has(w)){const N=this.d.get(w);N.children.add($.item.extId),D=this.p($,N),this.d.set($.item.extId,D)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return g.add?.(D),$.expand===2&&this.g++,D}k($,g){const w=this.d.get($.extId);if(w)return $.expand!==void 0&&(w.expand===2&&this.g--,$.expand===2&&this.g++),(0,e.$kJ)(w,$),g.update?.(w),w}l($,g){const w=this.d.get($);if(!w)return;const D=d.$eJ.parentId(w.item.extId)?.toString();D?this.d.get(D).children.delete(w.item.extId):this.f.delete(w);const N=[[$]];for(;N.length;)for(const M of N.pop()){const F=this.d.get(M);F&&(N.push(F.children),this.d.delete(M),g.remove?.(F,F!==w),F.expand===2&&this.g--)}}m($){}updatePendingRoots($){this.h+=$}o(){return{}}}e.$lJ=I}),define(De[109],Ce([1,0,8,4,3,58,87,68]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.TestItemEventOp=void 0;var E;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const b=(a,o)=>a===o,P=Object.entries({range:(a,o)=>a===o?!0:!a||!o?!1:a.equalsRange(o),busy:b,label:b,description:b,error:b,sortText:b,tags:(a,o)=>!(a.length!==o.length||a.some(f=>!o.includes(f)))}),v=(a,o)=>{let f;for(const[l,t]of P)t(a[l],o[l])||(f?f[l]=o[l]:f={[l]:o[l]});return f};class y extends d.$Sc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new C.$6g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const f of this.tree.values())this.I(f)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const f of this.m)if(f.op===2&&f.uri===o.uri){f.docv=o.docv;return}break}case 1:{const f=this.m[this.m.length-1];if(f){if(f.op===1&&f.item.extId===o.item.extId){(0,A.$kJ)(f.item,o.item);return}if(f.op===0&&f.item.item.extId===o.item.extId){(0,A.$kJ)(f.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,f){const l=this.tree.get(o);if(l){if((l.expandLevels===void 0||f>l.expandLevels)&&(l.expandLevels=f),l.expand===1){const t=this.L(l);return t.isOpen()?this.J(l,f-1):t.wait().then(()=>this.J(l,f-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,f-1)):this.J(l,f-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,f){switch(f.op){case 3:this.N(m.$eJ.joinToString(o.fullId,f.id));break;case 0:this.y(f.item,o);break;case 5:for(const l of f.ops)this.u(o,l);break;case 1:this.z(f.new,f.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:f.update}});break;case 6:this.w(o.actual.uri);break;default:(0,R.$4c)(f)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,f){const l=m.$eJ.fromExtHostTestItem(o,this.root.id,f?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==f?.actual&&this.s.getChildren(t.parent).delete(o.id);let i=this.tree.get(l.toString());if(!i){i={fullId:l,actual:o,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(i.fullId.toString(),i),this.F(o,f),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(o)}}),this.H(o,i,f);return}if(i.actual===o){this.G(o,i,f);return}if(i.actual.uri?.toString()!==o.uri?.toString())return this.N(l.toString()),this.y(o,f);const c=this.s.getChildren(i.actual),n=i.actual,r=v(this.s.toITestItem(n),this.s.toITestItem(o));this.s.getApiFor(n).listener=void 0,i.actual=o,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.z(o.tags,n.tags,l.toString()),delete r.tags),this.u(i,{op:4,update:r})),this.H(o,i,f);for(const[u,I]of c)this.s.getChildren(o).get(I.id)||this.N(m.$eJ.joinToString(l,I.id));this.w(i.actual.uri)}z(o,f,l){const t=new Set(f.map(i=>i.id));for(const i of o)t.delete(i.id)||this.C(i);this.pushDiff({op:1,item:{extId:l,item:{tags:o.map(i=>(0,A.$iJ)(this.s.controllerId,i.id))}}}),t.forEach(this.D,this)}C(o){const f=this.j.get(o.id);f?f.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$iJ)(this.s.controllerId,o.id)}}))}D(o){const f=this.j.get(o);f&&!--f.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,A.$iJ)(this.s.controllerId,o)}))}F(o,f){this.s.getApiFor(o).parent=f&&f.actual!==this.root?f.actual:void 0}G(o,f,l){this.F(o,l);const t=this.s.getApiFor(o);t.parent=l?.actual,t.listener=i=>this.u(f,i),this.I(f)}H(o,f,l){this.G(o,f,l);for(const[t,i]of this.s.getChildren(o))this.y(i,f)}I(o){let f;this.h?o.resolveBarrier?f=o.resolveBarrier.isOpen()?3:2:f=o.actual.canResolveChildren?1:0:f=0,f!==o.expand&&(o.expand=f,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:f}}),f===1&&o.expandLevels!==void 0&&this.L(o))}J(o,f){if(f<0)return;const l=[];for(const[t,i]of this.s.getChildren(o.actual)){const c=this.expand(m.$eJ.joinToString(o.fullId,i.id),f);(0,C.$Gg)(c)&&l.push(c)}if(l.length)return Promise.all(l).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const i=new C.$Sg;return i.open(),i}o.expand=2,this.M(o);const f=o.resolveBarrier=new C.$Sg,l=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(i){l(i)}return(0,C.$Gg)(t)?t.catch(l).then(()=>{f.open(),this.I(o)}):(f.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const f=this.tree.get(o);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const l=[f];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const i of t.actual.tags)this.D(i.id);this.tree.delete(t.fullId.toString());for(const[i,c]of this.s.getChildren(t.actual))l.push(this.tree.get(m.$eJ.joinToString(t.fullId,c.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$cM=y;class k extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$dM=k;class p extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$eM=p;class h extends Error{constructor(o,f,l){super(`TestItem with ID "${o}" is from controller "${f}" and cannot be added as a child of an item from controller "${l}".`)}}e.$fM=h;const s=(a,o,f)=>{let l=new Map;return{get size(){return l.size},forEach(t,i){for(const c of l.values())t.call(i,c,this)},[Symbol.iterator](){return l.entries()},replace(t){const i=new Map,c=new Set(l.keys()),n={op:5,ops:[]};for(const r of t){if(!(r instanceof f))throw new p(r.id);const u=o(r).controllerId;if(u!==a.controllerId)throw new h(r.id,u,a.controllerId);if(i.has(r.id))throw new k(r.id);i.set(r.id,r),c.delete(r.id),n.ops.push({op:0,item:r})}for(const r of c.keys())n.ops.push({op:3,id:r});a.listener?.(n),l=i},add(t){if(!(t instanceof f))throw new p(t.id);l.set(t.id,t),a.listener?.({op:0,item:t})},delete(t){l.delete(t)&&a.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$gM=s}),define(De[142],Ce([1,0,109]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0;const T=new WeakMap,d=(A,m)=>{const E={controllerId:m};return T.set(A,E),E};e.$hM=d;const R=A=>{const m=T.get(A);if(!m)throw new C.$eM(A?.id||"<unknown>");return m};e.$iM=R}),define(De[110],Ce([1,0,18,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epb=e.$dpb=e.$cpb=e.$bpb=e.$apb=void 0,e.$apb="vscode-cdn.net",e.$bpb=`vscode-resource.${e.$apb}`,e.$cpb=`'self' https://*.${e.$apb}`;function d(m,E){return m.scheme===C.Schemas.http||m.scheme===C.Schemas.https?m:(E&&E.authority&&E.isRemote&&m.scheme===C.Schemas.file&&(m=T.URI.from({scheme:C.Schemas.vscodeRemote,authority:E.authority,path:m.path})),T.URI.from({scheme:C.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$bpb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$dpb=d;function R(m){return m.replace(/./g,E=>{const b=E.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?E:"-"+b.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(E,b)=>String.fromCharCode(parseInt(b,16)))}e.$epb=A}),define(De[278],Ce([1,0,4,3,110]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class R{constructor(m,E,b){this.d=m,this.e=E,this.f=b,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const L=E.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,E,b,L,P){let v;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){v=o;break}if(!v)throw new Error("not a visible editor");const y=this,k=this.a++,p=new C.$Nd,h=new C.$Nd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,d.$dpb)(o,y.f)}get cspSource(){return d.$cpb}set options(o){this.b=o,y.d.$setOptions(k,o)}get options(){return this.b}set html(o){this.a=o,y.d.$setHtml(k,o)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(o){return y.d.$postMessage(k,o)}},a=new class{constructor(){this.editor=m,this.line=E,this.height=b,this.webview=s,this.onDidDispose=h.event}dispose(){y.c.has(k)&&(y.c.delete(k),y.d.$disposeEditorInset(k),h.fire(),h.dispose(),p.dispose())}};return this.d.$createEditorInset(k,v.id,v.value.document.uri,E+1,b,L||{},P.identifier,P.extensionLocation),this.c.set(k,{editor:m,inset:a,onDidReceiveMessage:p}),a}$onDidDispose(m){const E=this.c.get(m);E&&E.inset.dispose()}$onDidReceiveMessage(m,E){this.c.get(m)?.onDidReceiveMessage.fire(E)}}e.$tdc=R}),define(De[279],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.VariableKind=e.$$M=void 0,e.$$M=(0,C.$Ph)("configurationResolverService");var T;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class d extends Error{constructor(A,m){super(m),this.variable=A}}e.$_M=d}),define(De[280],Ce([1,0,16,48,17,24,12,99,224,279,15]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,k,p,h){this.h=new Map,this.a=y,this.b=k,this.g=p,h&&(this.c=h.then(s=>this.i(s)))}i(y){if(A.$j){const k=Object.create(null);return Object.keys(y).forEach(p=>{k[p.toLowerCase()]=y[p]}),k}return y}resolveWithEnvironment(y,k,p){return this.l({env:this.i(y),userHome:void 0},k?k.uri:void 0,p)}async resolveAsync(y,k){const p={env:await this.c,userHome:await this.g};return this.l(p,y?y.uri:void 0,k)}async j(y,k,p,h){const s=R.$7m(k);A.$j&&s.windows?Object.keys(s.windows).forEach(o=>s[o]=s.windows[o]):A.$k&&s.osx?Object.keys(s.osx).forEach(o=>s[o]=s.osx[o]):A.$l&&s.linux&&Object.keys(s.linux).forEach(o=>s[o]=s.linux[o]),delete s.windows,delete s.osx,delete s.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,y?y.uri:void 0,s,p,h)}async resolveAnyAsync(y,k,p){return this.j(y,k,p)}async resolveAnyMap(y,k,p){const h=new Map;return{newConfig:await this.j(y,k,p,h),resolvedVariables:h}}resolveWithInteractionReplace(y,k,p,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,k,p,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,k){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,k)}async l(y,k,p,h,s){if(d.$yf(p))return this.m(y,k,p,h,s);if(Array.isArray(p))return Promise.all(p.map(a=>this.l(y,k,a,h,s)));if(d.$Af(p)){const a=Object.create(null),o=await Promise.all(Object.keys(p).map(async f=>[await this.m(y,k,f,h,s),await this.l(y,k,p[f],h,s)]));for(const[f,l]of o)a[f]=l;return a}return p}m(y,k,p,h,s){return(0,L.$Te)(p,P.VARIABLE_REGEXP,async(a,o)=>{if(o.includes(P.VARIABLE_LHS))return a;let f=await this.o(y,a,o,k,h);return s?.set(o,f),f!==a&&d.$yf(f)&&f.match(P.VARIABLE_REGEXP)&&(f=await this.m(y,k,f,h,s)),f})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,k,p,h,s){let a;const o=p.split(":");o.length>1&&(p=o[0],a=o[1]);const f=i=>{const c=this.a.getFilePath();if(c)return(0,m.$sv)(c);throw new b.$_M(i,(0,E.localize)(0,null,k))},l=i=>{const c=f(i);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,m.$sv)(n)}throw new b.$_M(i,(0,E.localize)(1,null,k,C.$nc(c)))},t=i=>{if(a){const c=this.a.getFolderUri(a);if(c)return c;throw new b.$_M(i,(0,E.localize)(2,null,k,a))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new b.$_M(i,(0,E.localize)(3,null,k)):new b.$_M(i,(0,E.localize)(4,null,k))};switch(p){case"env":if(a){if(y.env){const i=y.env[A.$j?a.toLowerCase():a];if(d.$yf(i))return i}return""}throw new b.$_M(b.VariableKind.Env,(0,E.localize)(5,null,k));case"config":if(a){const i=this.a.getConfigurationValue(h,a);if(d.$Hf(i))throw new b.$_M(b.VariableKind.Config,(0,E.localize)(6,null,k,a));if(d.$Af(i))throw new b.$_M(b.VariableKind.Config,(0,E.localize)(7,null,k,a));return i}throw new b.$_M(b.VariableKind.Config,(0,E.localize)(8,null,k));case"command":return this.p(b.VariableKind.Command,k,a,s,"command");case"input":return this.p(b.VariableKind.Input,k,a,s,"input");case"extensionInstallFolder":if(a){const i=await this.a.getExtension(a);if(!i)throw new b.$_M(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,k,a));return this.n(i.extensionLocation)}throw new b.$_M(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,k));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,m.$sv)(this.n(t(b.VariableKind.WorkspaceFolder)));case"cwd":return h||a?(0,m.$sv)(this.n(t(b.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$sv)(C.$nc(this.n(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new b.$_M(b.VariableKind.UserHome,(0,E.localize)(11,null,k))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new b.$_M(b.VariableKind.LineNumber,(0,E.localize)(12,null,k))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new b.$_M(b.VariableKind.SelectedText,(0,E.localize)(13,null,k))}case"file":return f(b.VariableKind.File);case"fileWorkspaceFolder":return l(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||a?C.$lc(this.n(t(b.VariableKind.RelativeFile)),f(b.VariableKind.RelativeFile)):f(b.VariableKind.RelativeFile);case"relativeFileDirname":{const i=C.$mc(f(b.VariableKind.RelativeFileDirname));if(h||a){const c=C.$lc(this.n(t(b.VariableKind.RelativeFileDirname)),i);return c.length===0?".":c}return i}case"fileDirname":return C.$mc(f(b.VariableKind.FileDirname));case"fileExtname":return C.$oc(f(b.VariableKind.FileExtname));case"fileBasename":return C.$nc(f(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=C.$nc(f(b.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-C.$oc(i).length)}case"fileDirnameBasename":return C.$nc(C.$mc(f(b.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||k}case"execInstallFolder":{const i=this.a.getAppRoot();return i||k}case"pathSeparator":return C.sep;default:try{const i=a?`${p}:${a}`:p;return this.p(b.VariableKind.Unknown,k,i,s,void 0)}catch{return k}}}}p(y,k,p,h,s){if(p&&h){const a=s===void 0?h[p]:h[s+":"+p];if(typeof a=="string")return a;throw new b.$_M(y,(0,E.localize)(14,null,k))}return k}}e.$nN=P}),define(De[143],Ce([1,0,5,139]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.OpenEditorContext=e.GroupsOrder=e.$oC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$nC=void 0,e.$nC=(0,C.$Ph)("editorGroupsService");var d;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var R;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var A;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EVEN=1]="EVEN",k[k.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var E;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function b(k){const p=k;return(0,T.$8D)(p?.editor)&&(0,T.$8D)(p?.replacement)}e.$oC=b;var L;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var P;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function v(k){const p=k;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$pC=v;function y(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$qC=y}),define(De[281],Ce([1,0,5,143]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.$sC=e.$rC=void 0,e.$rC=(0,C.$Ph)("editorService"),e.$sC=-1,e.$tC=-2;function d(R){const A=R;return typeof R=="number"||(0,T.$pC)(A)}e.$uC=d}),define(De[144],Ce([1,0,5,131]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IJ=void 0,e.$IJ=(0,C.$Qh)(T.$Wh)}),define(De[145],Ce([1,0,25,4,16,3]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4b=e.$C4b=e.$B4b=e.$A4b=e.$z4b=e.$y4b=void 0;class A{constructor(s,a){this.versionId=s,this.removedDueToLooping=a}}e.$y4b=A;class m{static isHostExtension(s,a,o){if(a.getExtensionDescription(s))return!1;const f=o.getExtensionDescription(s);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(s,a){this.j=s,this.c=new T.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=a,this.k()}k(){this.e.sort(k),this.f=new C.$8l,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const a=this.j.readActivationEvents(s);if(Array.isArray(a))for(let o of a)o==="onUri"&&(o=`onUri:${C.$6l.toKey(s.identifier)}`),this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,a){this.e=p(this.e,a),this.e=this.e.concat(s);const o=m.l(this.e);return this.e=p(this.e,o.map(f=>f.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,o)}static l(s){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,c){this.addNode(i),this.addNode(c),this.c.has(i)?this.c.get(i).push(c):this.c.set(i,[c])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,c){const n=a.getArcs(i);for(let r=0;r<n.length;r++)if(!c.has(n[r]))return!1;return!0}getNodes(){return this.e}},o=new C.$8l;for(const i of s)if(o.set(i.identifier,i),i.extensionDependencies)for(const c of i.extensionDependencies)a.addArc(C.$6l.toKey(i.identifier),C.$6l.toKey(c));const f=new Set;a.getNodes().filter(i=>a.getArcs(i).length===0).forEach(i=>f.add(i));const l=a.getNodes().filter(i=>!f.has(i));let t;do{t=!1;for(let i=0;i<l.length;i++){const c=l[i];a.hasOnlyGoodArcs(c,f)&&(l.splice(i,1),i--,f.add(c),t=!0)}}while(t);return l.map(i=>o.get(i))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const a=this.h.get(s);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const a=this.f.get(s);return a||void 0}getExtensionDescriptionByUUID(s){for(const a of this.g)if(a.uuid===s)return a}getExtensionDescriptionByIdOrUUID(s,a){return this.getExtensionDescription(s)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.$z4b=m;class E{constructor(s,a){this.versionId=s,this.extensions=a}}e.$A4b=E,e.$B4b={readActivationEvents:h=>h.activationEvents};class b{constructor(s){this.d=new v,this.c=new m(s,[])}async acquireLock(s){const a=await this.d.acquire(s);return new L(this,a)}deltaExtensions(s,a,o){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,o)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,a){return this.c.getExtensionDescriptionByIdOrUUID(s,a)}}e.$C4b=b;class L extends R.$Sc{constructor(s,a){super(),this.f=s,this.c=!1,this.B(a)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$D4b=L;class P{constructor(s){this.name=s,this.promise=new Promise((a,o)=>{this.c=a})}resolve(s){this.c(s)}}class v{constructor(){this.c=[],this.d=!1}async acquire(s){const a=new P(s);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let a=!0;const o=setTimeout(()=>{a&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),f=()=>{a&&(clearTimeout(o),a=!1,this.d=!1,this.e())};s.resolve((0,R.$Qc)(f))}}var y;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(y||(y={}));function k(h,s){const a=h.isBuiltin?0:h.isUnderDevelopment?2:1,o=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(a!==o)return a-o;const f=d.$gc.basename(h.extensionLocation.path),l=d.$gc.basename(s.extensionLocation.path);return f<l?-1:f>l?1:0}function p(h,s){const a=new C.$7l(s);return h.filter(o=>!a.has(o.identifier))}}),define(De[282],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.ExtHostConnectionType=void 0;var C;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[T.ENV_KEY]=this.pipeName}}e.$xm=T;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[d.ENV_KEY]="1"}}e.$ym=d;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[R.ENV_KEY]="1"}}e.$zm=R;function A(L){delete L[T.ENV_KEY],delete L[d.ENV_KEY],delete L[R.ENV_KEY]}function m(L,P){A(P),L.serialize(P)}e.$Am=m;function E(L){if(L[T.ENV_KEY])return b(L,new T(L[T.ENV_KEY]));if(L[d.ENV_KEY])return b(L,new d);if(L[R.ENV_KEY])return b(L,new R);throw new Error("No connection information defined in environment!")}e.$Bm=E;function b(L,P){return A(L),P}}),define(De[111],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(T||(e.UIKind=T={}));var d;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var R;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function A(b){const L=C.$be.alloc(1);switch(b){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$bm=A;function m(b,L){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$cm=m;var E;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,5,4,14,27,111,66,85,24,2,3,211]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=e.$DM=void 0;let y=class extends P.$Sc{constructor(s,a){super(),this.s=s,this.t=a,this.a=this.B(new T.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=a.createLogger(this.m,{id:E.$oo,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(o=>{(0,d.$_i)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,a,o){const f=this.getTelemetryDetails(),l=new k(a,o,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(s,a,o){this.f=s,this.g=a,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const a=Object.create(null);switch(a["common.extname"]=`${s.publisher}.${s.name}`,a["common.extversion"]=s.version,a["common.vscodemachineid"]=this.s.telemetryInfo.machineId,a["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,a["common.vscodeversion"]=this.s.version,a["common.isnewappinstall"]=p(this.s.telemetryInfo.firstSessionDate),a["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:a["common.uikind"]="web";break;case A.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,m.$Vk)((0,E.$vo)(this.s.remote.authority)),a}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const a=this.getTelemetryDetails();this.r.forEach((o,f)=>{const l=o.filter(t=>!t.isDisposed);l.length===0?this.r.delete(f):this.r.set(f,l)}),this.r.forEach(o=>{for(const f of o)f.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,a){const f=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!f)return this.r.delete(s.value),!1;let l=!1;for(const t of f)t.ignoreUnhandledExtHostErrors||(t.logError(a),l=!0);return l}};e.$DM=y,e.$DM=y=He([Be(0,R.$CM),Be(1,d.$$i)],y);class k{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,a,o,f,l,t,i){this.g=o,this.h=f,this.i=l,this.j=t,this.a=new T.$Nd,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(s,a){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let a="properties"in s?s.properties??{}:s;return a=(0,E.$yo)(a,[]),this.c&&(a=(0,b.$0m)(a,this.c)),this.b||(a=(0,b.$0m)(a,this.j)),"properties"in s?s.properties=a:s=a,s}k(s,a){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(s,a),this.h.trace(s,a))}logUsage(s,a){this.d.isUsageEnabled&&this.k(s,a)}logError(s,a){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,a);else{const o={name:s.name,message:s.message,stack:s.stack,cause:s.cause},f=(0,E.$yo)(o,[]),l=new Error(f.message,{cause:f.cause});l.stack=f.stack,l.name=f.name,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f.sendErrorData(l,a),this.h.trace("exception",a)}}get apiTelemetryLogger(){if(!this.e){const s=this,a={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$EM=k;function p(h){const s=Date.now()-new Date(h).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$FM=p,e.$GM=(0,C.$Ph)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,253,137,25,5]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mF=e.$lF=e.$kF=e.ActivationKind=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.ExtensionHostStartup=e.$eF=e.$dF=e.$cF=e.$bF=void 0,e.$bF=Object.freeze({identifier:new A.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$cF="extensions.webWorker",e.$dF=(0,m.$Ph)("extensionService");class E{constructor(l){this.dependency=l}}e.$eF=E;var b;(function(f){f[f.EagerAutoStart=1]="EagerAutoStart",f[f.EagerManualStart=2]="EagerManualStart",f[f.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,i){this.c=l,this.d=t.slice(0),this.e=i.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$YE.createActivationEventsMap(this.d)}}set(l,t,i){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const c=[],n=[],r=[],u=[],I=P(this.d),S=P(t),$=(M,F)=>M.extensionLocation.toString()===F.extensionLocation.toString()||M.isBuiltin===F.isBuiltin||M.isUserBuiltin===F.isUserBuiltin||M.isUnderDevelopment===F.isUnderDevelopment;for(const M of this.d){const F=S.get(M.identifier);if(!F){c.push(M.identifier),I.delete(M.identifier);continue}if(!$(M,F)){c.push(M.identifier),I.delete(M.identifier);continue}}for(const M of t){const F=I.get(M.identifier);if(!F){n.push(M);continue}if(!$(F,M)){c.push(F.identifier),I.delete(F.identifier);continue}}const g=new A.$7l(this.e),w=new A.$7l(i);for(const M of this.e)w.has(M)||r.push(M);for(const M of i)g.has(M)||u.push(M);const D=R.$YE.createActivationEventsMap(n),N={versionId:l,toRemove:c,toAdd:n,addActivationEvents:D,myToRemove:r,myToAdd:u};return this.delta(N),N}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:i,myToRemove:c,myToAdd:n}=l,r=new A.$7l(t),u=new A.$7l(c);for(let I=0;I<this.d.length;I++)r.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)u.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of i)this.d.push(I);for(const I of n)this.e.push(I);return l}containsExtension(l){for(const t of this.e)if(A.$6l.equals(t,l))return!0;return!1}}e.$fF=L;function P(f){const l=new A.$8l;for(const t of f)l.set(t.identifier,t);return l}function v(f,l){return f.enabledApiProposals?f.enabledApiProposals.includes(l):!1}e.$gF=v;function y(f,l){if(!v(f,l))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.$hF=y;class k{constructor(l,t,i,c){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=i,this.activationReason=c}}e.$iF=k;class p{constructor(l,t){this.description=l,this.value=t}}e.$jF=p;var h;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(h||(e.ActivationKind=h={}));function s(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,d.$Eo)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation,targetPlatform:f.targetPlatform,validations:[],isValid:!0}}e.$kF=s;function a(f,l){return{identifier:new A.$6l((0,d.$Co)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!l,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid,targetPlatform:f.targetPlatform}}e.$lF=a;class o{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$mF=o}),define(De[283],Ce([1,0,9,145,25,26,14,8]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=e.$Hcc=e.$Gcc=e.$Fcc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,a,o,f){this.startup=s,this.codeLoadingTime=a,this.activateCallTime=o,this.activateResolvedTime=f}}e.$Fcc=E;class b{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,a){return s===-1||a===-1?-1:a-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Gcc=b;class L{constructor(s,a,o,f,l,t){this.activationFailed=s,this.activationFailedError=a,this.activationTimes=o,this.module=f,this.exports=l,this.subscriptions=t}}e.$Hcc=L;class P extends L{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Icc=P;class v extends L{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jcc=v;class y extends L{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(s,a,o,f){this.g=f,this.a=s,this.b=a,this.c=o,this.d=new d.$8l,this.f=Object.create(null)}dispose(){for(const[s,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const s=[];for(const[a,o]of this.d)s.push(o.wait());await Promise.all(s)}isActivated(s){const a=this.d.get(s);return!!(a&&a.value)}getActivatedExtension(s){const a=this.d.get(s);if(!a||!a.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return a.value}async activateByEvent(s,a){if(this.f[s])return;const o=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(o.map(f=>({id:f.identifier,reason:{startup:a,extensionId:f.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,a){const o=this.a.getExtensionDescription(s);if(!o)throw new Error(`Extension '${s}' is not known`);return this.h([{id:o.identifier,reason:a}])}async h(s){const a=s.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(a.map(o=>o.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const a=this.a.getExtensionDescription(s.id);if(!a){const l=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new y(l));return this.c.onExtensionActivationError(s.id,l,new R.$eF(s.id.value)),t}const o=[],f=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const l of f){if(this.m(l))continue;const t=this.d.get(l);if(t){o.push(t);continue}if(this.l(l)){o.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:s.reason}));continue}const i=this.a.getExtensionDescription(l);if(i){if(!i.main&&!i.browser)continue;o.push(this.j({id:i.identifier,reason:s.reason}));continue}const c=a.displayName||a.identifier.value,n=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${l}'`),r=this.k(s,a.displayName,[],new y(n));return this.c.onExtensionActivationError(a.identifier,n,new R.$eF(l)),r}return this.k(s,a.displayName,o,null)}k(s,a,o,f){const l=new p(s.id,a,s.reason,o,f,this.c,this.g);return this.d.set(s.id,l),l}l(s){return T.$z4b.isHostExtension(s,this.a,this.b)}m(s){const a=this.b.getExtensionDescription(s);return a?!a.main&&!a.browser:!1}};e.$Kcc=k,e.$Kcc=k=He([Be(3,A.$0i)],k);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,a,o,f,l,t,i){this.c=s,this.d=a,this.f=o,this.g=f,this.h=l,this.j=t,this.k=i,this.a=new m.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const a=this.g[s];if(a.value&&!a.value.activationFailed){this.g.splice(s,1),s--;continue}if(a.value&&a.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);o.detail=a.value.activationFailedError,this.h=new y(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const a=new Error;if(s&&s.name&&(a.name=s.name),s&&s.message?a.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(a.stack=s.stack),this.h=new y(a),this.b&&C.$4(s))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};p=He([Be(6,A.$0i)],p)}),define(De[13],Ce([1,0,19,22,162,75,80,28,158,62,97,24,17,2,32,83,133,142,139,108,68,87,281,7,26]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$lM=e.$kM=e.MarkdownString=e.$jM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Me){function Te(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:xe,positionColumn:Je}=ne,rt=new i.$oK(Fe-1,Ve-1),kt=new i.$oK(xe-1,Je-1);return new i.$qK(rt,kt)}Me.to=Te;function Se(ne){const{anchor:Fe,active:Ve}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Se})(n||(e.Selection=n={}));var r;(function(Me){function Te(ne){if(!ne)return;const{start:Fe,end:Ve}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Te;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:xe,endColumn:Je}=ne;return new i.$pK(Fe-1,Ve-1,xe-1,Je-1)}Me.to=Se})(r||(e.Range=r={}));var u;(function(Me){function Te(Se){switch(Se){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Me.to=Te})(u||(e.TokenType=u={}));var I;(function(Me){function Te(ne){return new i.$oK(ne.lineNumber-1,ne.column-1)}Me.to=Te;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Se})(I||(e.Position=I={}));var S;(function(Me){function Te(Fe,Ve,xe){return(0,C.$Hb)((0,C.$3b)(Fe).map(Je=>Se(Je,Ve,xe)))}Me.from=Te;function Se(Fe,Ve,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,Ve),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ne(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(S||(e.DocumentSelector=S={}));var $;(function(Me){function Te(ne){switch(ne){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(ne){switch(ne){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Me.to=Se})($||(e.DiagnosticTag=$={}));var g;(function(Me){function Te(ne){let Fe;return ne.code&&((0,v.$yf)(ne.code)||(0,v.$Cf)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...r.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:D.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(w.from),tags:Array.isArray(ne.tags)?(0,C.$Hb)(ne.tags.map($.from)):void 0}}Me.from=Te;function Se(ne){const Fe=new i.$BK(r.to(ne),ne.message,D.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,v.$yf)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(w.to),Fe.tags=ne.tags&&(0,C.$Hb)(ne.tags.map($.to)),Fe}Me.to=Se})(g||(e.Diagnostic=g={}));var w;(function(Me){function Te(ne){return{...r.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=Te;function Se(ne){return new i.$AK(new i.$zK(ne.resource,r.to(ne)),ne.message)}Me.to=Se})(w||(e.DiagnosticRelatedInformation=w={}));var D;(function(Me){function Te(ne){switch(ne){case i.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}Me.from=Te;function Se(ne){switch(ne){case h.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Me.to=Se})(D||(e.DiagnosticSeverity=D={}));var N;(function(Me){function Te(ne){return typeof ne=="number"&&ne>=i.ViewColumn.One?ne-1:ne===i.ViewColumn.Beside?t.$tC:t.$sC}Me.from=Te;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(N||(e.ViewColumn=N={}));function M(Me){return typeof Me.range<"u"}function F(Me){return Me.length===0?!0:!!M(Me[0])}e.$jM=F;var U;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ne(Je){let rt;if(Se(Je)){const{language:dt,value:gt}=Je;rt={value:"```"+dt+`
`+gt+"\n```\n"}}else i.$NK.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const kt=Object.create(null);rt.uris=kt;const St=dt=>{try{let gt=y.URI.parse(dt,!0);gt=gt.with({query:Fe(gt.query,kt)}),kt[dt]=gt}catch{}return""},mt=new E.marked.Renderer;return mt.link=St,mt.image=dt=>typeof dt=="string"?St(A.$0j(dt).href):"",(0,E.marked)(rt.value,{renderer:mt}),rt}Me.from=ne;function Fe(Je,rt){if(!Je)return Je;let kt;try{kt=(0,b.$lh)(Je)}catch{}if(!kt)return Je;let St=!1;return kt=(0,P.$9m)(kt,mt=>{if(y.URI.isUri(mt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=mt,St=!0,dt}else return}),St?JSON.stringify(kt):Je}function Ve(Je){const rt=new i.$NK(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,rt}Me.to=Ve;function xe(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=xe})(U||(e.MarkdownString=U={}));function j(Me){return F(Me)?Me.map(Te=>({range:r.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?U.fromMany(Te.hoverMessage):Te.hoverMessage?U.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:r.from(Te)}))}e.$kM=j;function O(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$lM=O;var q;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var K;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?q.from(Se.before):void 0,after:Se.after?q.from(Se.after):void 0}}Me.from=Te})(K||(e.ThemableDecorationRenderOptions=K={}));var me;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(me||(e.DecorationRangeBehavior=me={}));var te;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?me.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?q.from(Se.before):void 0,after:Se.after?q.from(Se.after):void 0}}Me.from=Te})(te||(e.DecorationRenderOptions=te={}));var G;(function(Me){function Te(ne){return{text:ne.newText,eol:ne.newEol&&Ae.from(ne.newEol),range:r.from(ne.range)}}Me.from=Te;function Se(ne){const Fe=new i.$uK(r.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:Ae.to(ne.eol),Fe}Me.to=Se})(G||(e.TextEdit=G={}));var Q;(function(Me){function Te(ne,Fe){const Ve={edits:[]};if(ne instanceof i.$xK){const xe=new m.$Bc;for(const Je of ne._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ne._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,T.$ve)(T.$be.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ve.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?Ve.edits.push({resource:Je.uri,textEdit:G.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ve.edits.push({resource:Je.uri,textEdit:{range:r.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ve.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ve.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(bt.from)}})}return Ve}Me.from=Te;function Se(ne){const Fe=new i.$xK,Ve=new m.$Ac;for(const xe of ne.edits)if(xe.textEdit){const Je=xe,rt=y.URI.revive(Je.resource),kt=r.to(Je.textEdit.range),St=Je.textEdit.text,mt=Je.textEdit.insertAsSnippet;let dt;mt?dt=i.$wK.replace(kt,new i.$yK(St)):dt=i.$uK.replace(kt,St);const gt=Ve.get(rt);gt?gt.push(dt):Ve.set(rt,[dt])}else Fe.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of Ve)Fe.set(xe,Je);return Fe}Me.to=Se})(Q||(e.WorkspaceEdit=Q={}));var le;(function(Me){const Te=Object.create(null);Te[i.SymbolKind.File]=0,Te[i.SymbolKind.Module]=1,Te[i.SymbolKind.Namespace]=2,Te[i.SymbolKind.Package]=3,Te[i.SymbolKind.Class]=4,Te[i.SymbolKind.Method]=5,Te[i.SymbolKind.Property]=6,Te[i.SymbolKind.Field]=7,Te[i.SymbolKind.Constructor]=8,Te[i.SymbolKind.Enum]=9,Te[i.SymbolKind.Interface]=10,Te[i.SymbolKind.Function]=11,Te[i.SymbolKind.Variable]=12,Te[i.SymbolKind.Constant]=13,Te[i.SymbolKind.String]=14,Te[i.SymbolKind.Number]=15,Te[i.SymbolKind.Boolean]=16,Te[i.SymbolKind.Array]=17,Te[i.SymbolKind.Object]=18,Te[i.SymbolKind.Key]=19,Te[i.SymbolKind.Null]=20,Te[i.SymbolKind.EnumMember]=21,Te[i.SymbolKind.Struct]=22,Te[i.SymbolKind.Event]=23,Te[i.SymbolKind.Operator]=24,Te[i.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Se;function ne(Fe){for(const Ve in Te)if(Te[Ve]===Fe)return Number(Ve);return i.SymbolKind.Property}Me.to=ne})(le||(e.SymbolKind=le={}));var ie;(function(Me){function Te(ne){switch(ne){case i.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return i.SymbolTag.Deprecated}}Me.to=Se})(ie||(e.SymbolTag=ie={}));var ce;(function(Me){function Te(ne){return{name:ne.name,kind:le.from(ne.kind),tags:ne.tags&&ne.tags.map(ie.from),containerName:ne.containerName,location:re.from(ne.location)}}Me.from=Te;function Se(ne){const Fe=new i.$EK(ne.name,le.to(ne.kind),ne.containerName,re.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(ie.to),Fe}Me.to=Se})(ce||(e.WorkspaceSymbol=ce={}));var ye;(function(Me){function Te(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),kind:le.from(ne.kind),tags:ne.tags?.map(ie.from)??[]};return ne.children&&(Fe.children=ne.children.map(Te)),Fe}Me.from=Te;function Se(ne){const Fe=new i.$FK(ne.name,ne.detail,le.to(ne.kind),r.to(ne.range),r.to(ne.selectionRange));return(0,C.$Lb)(ne.tags)&&(Fe.tags=ne.tags.map(ie.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Me.to=Se})(ye||(e.DocumentSymbol=ye={}));var H;(function(Me){function Te(ne){const Fe=new i.$JK(le.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ne.name,detail:ne.detail,kind:le.from(ne.kind),uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Me.from=Se})(H||(e.CallHierarchyItem=H={}));var B;(function(Me){function Te(Se){return new i.$KK(H.to(Se.from),Se.fromRanges.map(ne=>r.to(ne)))}Me.to=Te})(B||(e.CallHierarchyIncomingCall=B={}));var X;(function(Me){function Te(Se){return new i.$LK(H.to(Se.to),Se.fromRanges.map(ne=>r.to(ne)))}Me.to=Te})(X||(e.CallHierarchyOutgoingCall=X={}));var re;(function(Me){function Te(ne){return{range:ne.range&&r.from(ne.range),uri:ne.uri}}Me.from=Te;function Se(ne){return new i.$zK(y.URI.revive(ne.uri),r.to(ne.range))}Me.to=Se})(re||(e.location=re={}));var Y;(function(Me){function Te(ne){const Fe=ne,Ve=ne;return{originSelectionRange:Fe.originSelectionRange?r.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:r.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?r.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Se(ne){return{targetUri:y.URI.revive(ne.uri),targetRange:r.to(ne.range),targetSelectionRange:ne.targetSelectionRange?r.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?r.to(ne.originSelectionRange):void 0}}Me.to=Se})(Y||(e.DefinitionLink=Y={}));var _;(function(Me){function Te(ne){return{range:r.from(ne.range),contents:U.fromMany(ne.contents)}}Me.from=Te;function Se(ne){return new i.$CK(ne.contents.map(U.to),r.to(ne.range))}Me.to=Se})(_||(e.Hover=_={}));var x;(function(Me){function Te(ne){return{range:r.from(ne.range),expression:ne.expression}}Me.from=Te;function Se(ne){return new i.$vL(r.to(ne.range),ne.expression)}Me.to=Se})(x||(e.EvaluatableExpression=x={}));var ve;(function(Me){function Te(ne){if(ne instanceof i.$wL)return{type:"text",range:r.from(ne.range),text:ne.text};if(ne instanceof i.$xL)return{type:"variable",range:r.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof i.$yL)return{type:"expression",range:r.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(ne){switch(ne.type){case"text":return{range:r.to(ne.range),text:ne.text};case"variable":return{range:r.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:r.to(ne.range),expression:ne.expression}}}Me.to=Se})(ve||(e.InlineValue=ve={}));var ae;(function(Me){function Te(ne){return{frameId:ne.frameId,stoppedLocation:r.from(ne.stoppedLocation)}}Me.from=Te;function Se(ne){return new i.$zL(ne.frameId,r.to(ne.stoppedLocation))}Me.to=Se})(ae||(e.InlineValueContext=ae={}));var fe;(function(Me){function Te(ne){return{range:r.from(ne.range),kind:ne.kind}}Me.from=Te;function Se(ne){return new i.$DK(r.to(ne.range),ne.kind)}Me.to=Se})(fe||(e.DocumentHighlight=fe={}));var ee;(function(Me){function Te(Se){switch(Se){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Me.to=Te})(ee||(e.CompletionTriggerKind=ee={}));var de;(function(Me){function Te(Se){return{triggerKind:ee.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(de||(e.CompletionContext=de={}));var be;(function(Me){function Te(ne){switch(ne){case i.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return i.CompletionItemTag.Deprecated}}Me.to=Se})(be||(e.CompletionItemTag=be={}));var Pe;(function(Me){const Te=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function Se(Ve){return Te.get(Ve)??9}Me.from=Se;const ne=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Fe(Ve){return ne.get(Ve)??i.CompletionItemKind.Property}Me.to=Fe})(Pe||(e.CompletionItemKind=Pe={}));var z;(function(Me){function Te(Se,ne){const Fe=new i.$TK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=Pe.to(Se.kind),Fe.tags=Se.tags?.map(be.to),Fe.detail=Se.detail,Fe.documentation=A.$5j(Se.documentation)?U.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,k.$ts.isIRange(Se.range)?Fe.range=r.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:r.to(Se.range.insert),replacing:r.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new i.$yK(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof i.$pK?new i.$uK(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(Ve=>G.to(Ve))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Me.to=Te})(z||(e.CompletionItem=z={}));var J;(function(Me){function Te(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:U.fromStrict(ne.documentation)}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$5j(ne.documentation)?U.to(ne.documentation):ne.documentation}}Me.to=Se})(J||(e.ParameterInformation=J={}));var se;(function(Me){function Te(ne){return{label:ne.label,documentation:U.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.from):[],activeParameter:ne.activeParameter}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$5j(ne.documentation)?U.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.to):[],activeParameter:ne.activeParameter}}Me.to=Se})(se||(e.SignatureInformation=se={}));var oe;(function(Me){function Te(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.from):[]}}Me.from=Te;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(se.to):[]}}Me.to=Se})(oe||(e.SignatureHelp=oe={}));var Z;(function(Me){function Te(Se,ne){const Fe=new i.$SK(I.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(ge.to.bind(void 0,Se)),ne.kind&&Ee.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(G.to),Fe.tooltip=A.$5j(ne.tooltip)?U.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Me.to=Te})(Z||(e.InlayHint=Z={}));var ge;(function(Me){function Te(Se,ne){const Fe=new i.$RK(ne.label);return Fe.tooltip=A.$5j(ne.tooltip)?U.to(ne.tooltip):ne.tooltip,p.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=re.to(ne.location)),Fe}Me.to=Te})(ge||(e.InlayHintLabelPart=ge={}));var Ee;(function(Me){function Te(ne){return ne}Me.from=Te;function Se(ne){return ne}Me.to=Se})(Ee||(e.InlayHintKind=Ee={}));var je;(function(Me){function Te(ne){return{range:r.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=Te;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?y.URI.parse(ne.url,!0):y.URI.revive(ne.url)}catch{}return new i.$YK(r.to(ne.range),Fe)}Me.to=Se})(je||(e.DocumentLink=je={}));var We;(function(Me){function Te(ne){const Fe=new i.$2K(ne.label);return ne.textEdit&&(Fe.textEdit=G.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(Ve=>G.to(Ve))),Fe}Me.to=Te;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?G.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>G.from(Fe)):void 0}}Me.from=Se})(We||(e.ColorPresentation=We={}));var _e;(function(Me){function Te(ne){return new i.$ZK(ne[0],ne[1],ne[2],ne[3])}Me.to=Te;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Se})(_e||(e.Color=_e={}));var Xe;(function(Me){function Te(ne){return{range:r.from(ne.range)}}Me.from=Te;function Se(ne){return new i.$IK(r.to(ne.range))}Me.to=Se})(Xe||(e.SelectionRange=Xe={}));var it;(function(Me){function Te(Se){switch(Se){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Me.to=Te})(it||(e.TextDocumentSaveReason=it={}));var tt;(function(Me){function Te(ne){switch(ne){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(ne){switch(ne){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Me.to=Se})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Ae;(function(Me){function Te(ne){if(ne===i.EndOfLine.CRLF)return 1;if(ne===i.EndOfLine.LF)return 0}Me.from=Te;function Se(ne){if(ne===1)return i.EndOfLine.CRLF;if(ne===0)return i.EndOfLine.LF}Me.to=Se})(Ae||(e.EndOfLine=Ae={}));var Ne;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ne||(e.ProgressLocation=Ne={}));var qe;(function(Me){function Te(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=Le.from(ne.kind)),Fe}Me.from=Te;function Se(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=Le.to(ne.kind)),Fe}Me.to=Se})(qe||(e.FoldingRange=qe={}));var Le;(function(Me){function Te(ne){if(ne)switch(ne){case i.FoldingRangeKind.Comment:return p.$it.Comment;case i.FoldingRangeKind.Imports:return p.$it.Imports;case i.FoldingRangeKind.Region:return p.$it.Region}}Me.from=Te;function Se(ne){if(ne)switch(ne.value){case p.$it.Comment.value:return i.FoldingRangeKind.Comment;case p.$it.Imports.value:return i.FoldingRangeKind.Imports;case p.$it.Region.value:return i.FoldingRangeKind.Region}}Me.to=Se})(Le||(e.FoldingRangeKind=Le={}));var Ye;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?r.from(Se.selection):void 0,override:typeof Se.override=="boolean"?a.$UD.id:void 0}}Me.from=Te})(Ye||(e.TextEditorOpenOptions=Ye={}));var he;(function(Me){function Te(Ve){return Ve instanceof i.$jL?Ve.toJSON():typeof Ve=="string"?Ve:Se(Ve)||ne(Ve)?new i.$jL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Te;function Se(Ve){const xe=Ve;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ne(Ve){const xe=Ve;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new i.$jL(y.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Fe})(he||(e.GlobPattern=he={}));var ue;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:he.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=Te})(ue||(e.LanguageSelector=ue={}));var Ie;(function(Me){function Te(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&y.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(xe=>xe instanceof i.$pK)))}Me.is=Te;function Se(ne){return{documents:ne.documents.map(Fe=>Fe.map(Ve=>({uri:y.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(xe=>r.from(xe))})))}}Me.from=Se})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Te(ne){return{start:ne.start,end:ne.end}}Me.from=Te;function Se(ne){return new i.$KL(ne.start,ne.end)}Me.to=Se})(Ke||(e.NotebookRange=Ke={}));var Ue;(function(Me){function Te(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=Te;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Se})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ze;(function(Me){function Te(Se){if(Se===o.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(Se===o.NotebookCellExecutionState.Pending)return;if(Se===o.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(Ze||(e.NotebookCellExecutionState=Ze={}));var nt;(function(Me){function Te(ne){switch(ne){case i.NotebookCellKind.Markup:return o.CellKind.Markup;case i.NotebookCellKind.Code:default:return o.CellKind.Code}}Me.from=Te;function Se(ne){switch(ne){case o.CellKind.Markup:return i.NotebookCellKind.Markup;case o.CellKind.Code:default:return i.NotebookCellKind.Code}}Me.to=Se})(nt||(e.NotebookCellKind=nt={}));var ct;(function(Me){function Te(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ve of ne.cells)i.$LL.validate(Ve),Fe.cells.push(bt.from(Ve));return Fe}Me.from=Te;function Se(ne){const Fe=new i.$ML(ne.cells.map(bt.to));return(0,v.$Lf)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Me.to=Se})(ct||(e.NotebookData=ct={}));var bt;(function(Me){function Te(ne){return{cellKind:nt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ue.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Kt.from):[]}}Me.from=Te;function Se(ne){return new i.$LL(nt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Kt.to):void 0,ne.metadata,ne.internalMetadata?Ue.to(ne.internalMetadata):void 0)}Me.to=Se})(bt||(e.NotebookCellData=bt={}));var Et;(function(Me){function Te(ne){return{mime:ne.mime,valueBytes:T.$be.wrap(ne.data)}}Me.from=Te;function Se(ne){return new i.$NL(ne.valueBytes.buffer,ne.mime)}Me.to=Se})(Et||(e.NotebookCellOutputItem=Et={}));var Kt;(function(Me){function Te(ne){return{outputId:ne.id,items:ne.items.map(Et.from),metadata:ne.metadata}}Me.from=Te;function Se(ne){const Fe=ne.items.map(Et.to);return new i.$OL(Fe,ne.outputId,ne.metadata)}Me.to=Se})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Te(Fe){return ne(Fe)?{include:he.from(Fe.include)??void 0,exclude:he.from(Fe.exclude)??void 0}:he.from(Fe)??void 0}Me.from=Te;function Se(Fe){return ne(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Me.to=Se;function ne(Fe){const Ve=Fe;return Ve?!(0,v.$Hf)(Ve.include)&&!(0,v.$Hf)(Ve.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var vt;(function(Me){function Te(Se,ne,Fe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ve,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(vt||(e.NotebookStatusBarItem=vt={}));var Ut;(function(Me){function Te(Se,ne,Fe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ne.toInternal(Ve,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Nt;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Me){function Te(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=Te;function Se(ne){return new i.$QL(y.URI.revive(ne.uri),ne.provides)}Me.to=Se})(Gt||(e.NotebookRendererScript=Gt={}));var zt;(function(Me){function Te(ne){return{message:U.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:r.from(ne.location.range),uri:ne.location.uri}}}Me.from=Te;function Se(ne){const Fe=new i.$WL(typeof ne.message=="string"?ne.message:U.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?re.to(ne.location):void 0,Fe}Me.to=Se})(zt||(e.TestMessage=zt={}));var Dt;(function(Me){Me.namespace=l.$iJ,Me.denamespace=l.$jJ})(Dt||(e.TestTag=Dt={}));var Ft;(function(Me){function Te(ne){const Fe=(0,s.$iM)(ne).controllerId;return{extId:f.$eJ.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:y.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ve=>Dt.namespace(Fe,Ve.id)),range:k.$ts.lift(r.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&U.fromStrict(ne.error)||null}}Me.from=Te;function Se(ne){return{parent:void 0,error:void 0,id:f.$eJ.fromString(ne.extId).localId,label:ne.label,uri:y.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:Ve}=Dt.denamespace(Fe);return new i.$XL(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:r.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Se})(Ft||(e.TestItem=Ft={})),function(Me){function Te(ne){return{id:ne.id}}Me.from=Te;function Se(ne){return new i.$XL(ne.id)}Me.to=Se}(Dt||(e.TestTag=Dt={}));var Bt;(function(Me){const Te=(ne,Fe)=>{const Ve=[];for(const[Je,rt]of Fe)f.$eJ.compare(rt.item.extId,Je)===2&&(Fe.delete(Je),Ve.push(rt));const xe={...Ft.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(zt.to)})),children:Ve.map(Je=>Te(Je,Fe))};for(const Je of xe.children)Je.parent=xe;return xe};function Se(ne){const Fe=[],Ve=new Map;for(const xe of ne.items){Ve.set(xe.item.extId,xe);const Je=f.$eJ.root(xe.item.extId);ne.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ne.completedAt,results:Fe.map(xe=>Te(xe,Ve))}}Me.to=Se})(Bt||(e.TestResults=Bt={}));var Jt;(function(Me){function Te(Ve){return{covered:Ve.covered,total:Ve.covered}}function Se(Ve){return"line"in Ve?I.from(Ve):r.from(Ve)}function ne(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Se(xe.location)})):void 0}:{type:0,count:Ve.executionCount,location:Se(Ve.location)}}Me.fromDetailed=ne;function Fe(Ve){return{uri:Ve.uri,statement:Te(Ve.statementCoverage),branch:Ve.branchCoverage&&Te(Ve.branchCoverage),function:Ve.functionCoverage&&Te(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ne)}}Me.fromFile=Fe})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Me){function Te(Se){switch(Se){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Me.to=Te})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Me){function Te(ne){const Fe=new i.$4L(le.to(ne.kind),ne.name,ne.detail||"",y.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:le.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(ie.from)}}Me.from=Se})(qt||(e.TypeHierarchyItem=qt={}));var Ot;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(Ot||(e.ViewBadge=Ot={}));var ut;(function(Me){function Te(Ve,xe,Je){const rt=xe.fileData;return rt?new i.$cL(new i.$dL(rt.name,y.URI.revive(rt.uri),rt.id,(0,R.$db)(()=>Je(rt.id)))):Ve===L.$Pr.uriList&&xe.uriListData?new i.$bL(Fe(xe.uriListData)):new i.$bL(xe.asString)}Me.to=Te;async function Se(Ve,xe){const Je=await xe.asString();if(Ve===L.$Pr.uriList)return{asString:Je,fileData:void 0,uriListData:ne(Je)};const rt=xe.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Se;function ne(Ve){return d.$3s.split(Ve).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Fe(Ve){return d.$3s.create(Ve.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(ut||(e.DataTransferItem=ut={}));var ft;(function(Me){function Te(ne,Fe){const Ve=ne.items.map(([xe,Je])=>[xe,ut.to(xe,Je,Fe)]);return new i.$eL(Ve)}Me.toDataTransfer=Te;async function Se(ne){const Fe={items:[]},Ve=[];for(const[xe,Je]of ne)Ve.push((async()=>{Fe.items.push([xe,await ut.from(xe,Je)])})());return await Promise.all(Ve),Fe}Me.from=Se})(ft||(e.DataTransfer=ft={}));var At;(function(Me){function Te(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.to=Te;function Se(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.from=Se})(At||(e.ChatReplyFollowup=At={}));var Vt;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:At.from(Se)}Me.from=Te})(Vt||(e.ChatFollowup=Vt={}));var Rt;(function(Me){function Te(ne){const Fe=new i.$bM(at.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Me.to=Te;function Se(ne){return{role:at.from(ne.role),content:ne.content,name:ne.name}}Me.from=Se})(Rt||(e.ChatMessage=Rt={}));var at;(function(Me){function Te(ne){switch(ne){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}Me.to=Te;function Se(ne){switch(ne){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}Me.from=Se})(at||(e.ChatMessageRole=at={}));var pt;(function(Me){function Te(Fe){const Ve={};for(const xe of Object.keys(Fe))Ve[xe]=Fe[xe].map(Me.to);return Ve}Me.objectTo=Te;function Se(Fe){return{level:Tt.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Se;function ne(Fe){return{level:Tt.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ne})(pt||(e.ChatVariable=pt={}));var Tt;(function(Me){function Te(ne){switch(ne){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}Me.to=Te;function Se(ne){switch(ne){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(Tt||(e.ChatVariableLevel=Tt={}));var Pt;(function(Me){function Te(Se){switch(Se){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Pt||(e.InteractiveEditorResponseFeedbackKind=Pt={}));var Ge;(function(Me){function Te(Se,ne){return"placeholder"in ne&&"resolvedContent"in ne?{placeholder:ne.placeholder}:"responseId"in ne?{requestId:ne.responseId}:"markdownContent"in ne?((0,c.$hF)(Se,"chatAgents2Additions"),{content:U.from(ne.markdownContent)}):"content"in ne?typeof ne.content=="string"?ne:((0,c.$hF)(Se,"chatAgents2Additions"),{content:U.from(ne.content)}):"documents"in ne?{documents:ne.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ve=>r.from(Ve))}))}:"reference"in ne?{reference:"uri"in ne.reference?{uri:ne.reference.uri,range:r.from(ne.reference.range)}:ne.reference}:"inlineReference"in ne?{inlineReference:"uri"in ne.inlineReference?{uri:ne.inlineReference.uri,range:r.from(ne.inlineReference.range)}:ne.inlineReference,title:ne.title}:("agentName"in ne&&(0,c.$hF)(Se,"chatAgents2Additions"),ne)}Me.from=Te})(Ge||(e.ChatResponseProgress=Ge={}));var Qt;(function(Me){function Te(Se,ne,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ne.toInternal(Se,Fe)}Me.from=Te})(Qt||(e.TerminalQuickFix=Qt={}))}),define(De[284],Ce([1,0,2,9,7,13,76]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class m{constructor(b,L,P,v={timeout:1500,errors:3}){this.c=b,this.d=L,this.f=P,this.g=v,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(L,P,v)=>{const k={dispose:this.a.push([L,P,b])};return Array.isArray(v)&&v.push(k),k}}async $participateInSave(b,L){const P=C.URI.revive(b);let v=!1;const y=setTimeout(()=>v=!0,this.g.timeout),k=[];try{for(const p of[...this.a]){if(v)break;const h=this.d.getDocument(P),s=await this.h(p,{document:h,reason:R.TextDocumentSaveReason.to(L)});k.push(s)}}finally{clearTimeout(y)}return k}h([b,L,P],v){const y=this.b.get(b);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,b,L,v).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const p=this.b.get(b);this.b.set(b,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,L,P,v){const y=[],k=Date.now(),{document:p,reason:h}=v,{version:s}=p,a=Object.freeze({document:p,reason:h,waitUntil(o){if(Object.isFrozen(y))throw(0,T.$8)("waitUntil can not be called async");y.push(Promise.resolve(o))}});try{L.apply(P,[a])}catch(o){return Promise.reject(o)}return Object.freeze(y),new Promise((o,f)=>{const l=setTimeout(()=>f(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(l),o(t)}).catch(t=>{clearTimeout(l),f(t)})}).then(o=>{const f={edits:[]};for(const l of o)if(Array.isArray(l)&&l.every(t=>t instanceof d.$uK))for(const{newText:t,newEol:i,range:c}of l)f.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:c&&R.Range.from(c),text:t,eol:i&&R.EndOfLine.from(i)}});if(f.edits.length!==0)return s===p.version?this.f.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.$Ecc=m}),define(De[285],Ce([1,0,18,2,13,7,108]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=void 0;class m{constructor(P,v,y,k){this.start=P,this.deletedCount=v,this.deletedItems=y,this.items=k}asApiEvent(){return{range:new R.$KL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(P,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,v,y){this.notebook=P,this.h=v,this.j=y,this.handle=y.handle,this.uri=T.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(d.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(d.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:d.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return P.g},set mime(k){P.g=k},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(d.NotebookCellOutput.to)}setOutputItems(P,v,y){const k=y.map(d.NotebookCellOutputItem.to),p=this.a.find(h=>h.id===P);if(p&&(v||(p.items.length=0),p.items.push(...k),p.items.length>1&&p.items.every(h=>A.$uI(h.mime)))){const h=new Map,s=[];p.items.forEach(a=>{let o;h.has(a.mime)?o=h.get(a.mime):(o=[],h.set(a.mime,o),s.push(a.mime)),o.push(a.data)}),p.items.length=0,s.forEach(a=>{const o=A.$vI(h.get(a));p.items.push({mime:a,data:o.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(d.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$Rdc=E;class b{static{this.a=0}constructor(P,v,y,k,p){this.k=P,this.l=v,this.m=y,this.uri=k,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,v={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===C.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(p=>p.apiCell)},save(){return P.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,v,y){this.g=P.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:y});const k={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},p=[];for(const s of P.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,k.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,k.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),p.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),p.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const h=new Map;for(let s=0;s<p.length;s++){const a=p[s],o=h.get(a.cell);if(o===void 0){const f=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});h.set(a.cell,f-1)}else k.cellChanges[o]={...k.cellChanges[o],...a}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let v=P.start|0,y=P.end|0;return v<0&&(v=0),y>this.b.length&&(y=this.b.length),P.with({start:v,end:y})}p(P){P=this.o(P);const v=[];for(let y=P.start;y<P.end;y++)v.push(this.b[y]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,v,y){if(this.j)return;const k=[],p=[],h=[];if(P.reverse().forEach(s=>{const o=s[2].map(t=>{const i=new E(this,this.l,t);return v||p.push(E.asModelAddData(this.apiNotebook,t)),i}),f=new m(s[0],s[1],[],o),l=this.b.splice(s[0],s[1],...o);for(const t of l)h.push(t.uri),f.deletedItems.push(t.apiCell);k.push(f)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:h}),y)for(const s of k)y.push(s.asApiEvent())}s(P,v,y,k){const p=this.b.splice(P,v);this.b.splice(y,0,...p);const h=[new m(P,v,p.map(s=>s.apiCell),[]),new m(y,0,[],p)];for(const s of h)k.push(s.asApiEvent())}t(P,v){this.b[P].setOutputs(v)}u(P,v,y,k){this.b[P].setOutputItems(v,y,k)}v(P,v){const y=this.b[P];y.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(y.uri,v)}w(P,v){const y=this.b[P];y.apiCell.mime=v}x(P,v){this.b[P].setMetadata(v)}y(P,v){this.b[P].setInternalMetadata(v)}getCellFromApiCell(P){return this.b.find(v=>v.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(v=>v.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$Sdc=b}),define(De[286],Ce([1,0,4,2,13,7]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class A{constructor(E,b,L,P={timeout:1500,errors:3}){this.b=E,this.c=b,this.d=L,this.f=P,this.a=new C.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(b,L,P)=>{const v=function(k){b.call(L,k)};return v.extension=E,this.a.event(v,void 0,P)}}async $participateInSave(E,b,L){const P=T.URI.revive(E),v=this.c.getNotebookDocument(P);if(!v)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:d.TextDocumentSaveReason.to(b)},L,async(p,h)=>{const s=Date.now(),a=await await Promise.resolve(p);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier),!L.isCancellationRequested&&a&&(a instanceof R.$xK?y.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(y.length===0)return!0;const k={edits:[]};for(const p of y){const{edits:h}=d.WorkspaceEdit.from(p);k.edits=k.edits.concat(h)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$gec=A}),define(De[146],Ce([1,0,9,13,7]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,E,b,L,P,v){this.id=m,this.f=E,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=v}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(E){this.selections=[E]},get selections(){return m.a},set selections(E){if(!Array.isArray(E)||!E.every(d.$KL.isNotebookRange))throw(0,C.$7)("selections");m.a=E,m.g(E)},get visibleRanges(){return m.b},revealRange(E,b){m.f.$tryRevealRange(m.id,T.NotebookRange.from(E),b??d.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(T.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Tdc=R}),define(De[287],Ce([1,0,9,4,14,13]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;let A=class{constructor(E,b){this.c=E,this.d=b,this.a=new T.$Nd({onListenerError:C.$2}),this.b=new T.$Nd({onListenerError:C.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,b);const L=this.d.getEditorById(E);b.visibleRanges&&L._acceptVisibleRanges(b.visibleRanges.ranges.map(R.NotebookRange.to)),b.selections&&L._acceptSelections(b.selections.selections.map(R.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:L.apiEditor,visibleRanges:L.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:L.apiEditor,selections:L.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const b in E)this.d.getEditorById(b)._acceptViewColumn(R.ViewColumn.to(E[b]))}};e.$_dc=A,e.$_dc=A=He([Be(0,d.$0i)],A)}),define(De[288],Ce([1,0,13,64,209,21,57,9]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class E{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,y,k){const p=this.b++,{title:h,location:s,cancellable:a}=y,o={label:(0,d.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(p,{location:C.ProgressLocation.from(s),title:h,source:o,cancellable:a},v.isUnderDevelopment?void 0:v.identifier.value).catch(m.$2),this.d(p,k,!!a)}d(v,y,k){let p;k&&(p=new R.$Xd,this.c.set(v,p));const h=a=>{this.a.$progressEnd(a),this.c.delete(a),p?.dispose()};let s;try{s=y(new L(this.a,v),k&&p?p.token:R.CancellationToken.None)}catch(a){throw h(v),a}return s.then(a=>h(v),a=>h(v)),s}$acceptProgressCanceled(v){const y=this.c.get(v);y&&(y.cancel(),this.c.delete(v))}}e.$ddc=E;function b(P,v){return P.message=v.message,typeof v.increment=="number"&&(typeof P.increment=="number"?P.increment+=v.increment:P.increment=v.increment),P}class L extends T.$5u{constructor(v,y){super(k=>this.throttledReport(k)),this.c=v,this.d=y}throttledReport(v){this.c.$progressReport(this.d,v)}}He([(0,A.$jh)(100,(P,v)=>b(P,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[147],Ce([1,0,32,142,68,109,87,13,2]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=void 0;const b=(o,f,l,t)=>{let i=f;return{enumerable:!0,configurable:!1,get(){return i},set(c){if(!l(i,c)){const n=i;i=c,o.listener?.(t(c,n))}}}},L=(o,f)=>o===f,P={range:(o,f)=>o===f?!0:!o||!f?!1:o.isEqual(f),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(o,f)=>!(o.length!==f.length||o.some(l=>!f.find(t=>l.id===t.id)))},v=o=>f=>({op:4,update:o(f)}),y=(o,f)=>({range:(()=>{let l;const t=v(i=>({range:C.$ts.lift(m.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return l},set(i){o.listener?.({op:6}),P.range(l,i)||(l=i,o.listener?.(t(i)))}}})(),label:b(o,f,P.label,v(l=>({label:l}))),description:b(o,void 0,P.description,v(l=>({description:l}))),sortText:b(o,void 0,P.sortText,v(l=>({sortText:l}))),canResolveChildren:b(o,!1,P.canResolveChildren,l=>({op:2,state:l})),busy:b(o,!1,P.busy,v(l=>({busy:l}))),error:b(o,void 0,P.error,v(l=>({error:m.MarkdownString.fromStrict(l)||null}))),tags:b(o,[],P.tags,(l,t)=>({op:1,new:l.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),k=o=>{const f=d.$eJ.fromString(o.extId),l=new h(f.controllerId,f.localId,o.label,E.URI.revive(o.uri)||void 0);return l.range=m.Range.to(o.range||void 0),l.description=o.description||void 0,l.sortText=o.sortText||void 0,l.tags=o.tags.map(t=>m.TestTag.to({id:(0,A.$jJ)(t).tagId})),l},p=o=>{let f;for(const l of o.tests){const t=k(l.item);(0,T.$iM)(t).parent=f,f=t}return f};e.$yM=p;class h{constructor(f,l,t,i){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const c=(0,T.$hM)(this,f);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,R.$gM)(c,T.$iM,h),enumerable:!0,writable:!1},...y(c,t)})}}e.$zM=h;class s extends h{constructor(f,l){super(f,f,l,void 0),this._isRoot=!0}}e.$AM=s;class a extends R.$cM{constructor(f,l,t){super({controllerId:f,getDocumentVersion:i=>i&&t.getDocument(i)?.version,getApiFor:T.$iM,getChildren:i=>i.children,root:new s(f,l),toITestItem:m.TestItem.from})}}e.$BM=a}),define(De[148],Ce([1,0,58,9,119,13,7]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=void 0;class m{static{this.c=new d.$rM("TextEditorDecorationType")}constructor(v,y,k){const p=m.c.nextId();v.$registerTextEditorDecorationType(y.identifier,p,R.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:p,dispose(){v.$removeTextEditorDecorationType(p)}})}}e.$tM=m;class E{constructor(v,y){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,y){this.k();let k=null;if(v instanceof A.$oK)k=new A.$pK(v,v);else if(v instanceof A.$pK)k=v;else throw new Error("Unrecognized location");this.l(k,y,!1)}insert(v,y){this.k(),this.l(new A.$pK(v,v),y,!0)}delete(v){this.k();let y=null;if(v instanceof A.$pK)y=v;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(v,y,k){const p=this.c.validateRange(v);this.g.push({range:p,text:y,forceMoveMarkers:k})}setEndOfLine(v){if(this.k(),v!==A.EndOfLine.LF&&v!==A.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=v}}class b{constructor(v,y,k,p){this.c=v,this.d=y,this._accept(k),this.e=p;const h=this;this.value={get tabSize(){return h.f},set tabSize(s){h.m(s)},get indentSize(){return h.g},set indentSize(s){h.o(s)},get insertSpaces(){return h.h},set insertSpaces(s){h.q(s)},get cursorStyle(){return h.j},set cursorStyle(s){h.s(s)},get lineNumbers(){return h.k},set lineNumbers(s){h.t(s)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}m(v){const y=this.l(v);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const y=Math.floor(v);return y>0?y:null}if(typeof v=="string"){const y=parseInt(v,10);return isNaN(y)?null:y>0?y:null}return null}o(v){const y=this.n(v);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(v){return v==="auto"?"auto":v==="false"?!1:!!v}q(v){const y=this.p(v);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const y={};let k=!1;if(typeof v.tabSize<"u"){const p=this.l(v.tabSize);p==="auto"?(k=!0,y.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,k=!0,y.tabSize=p)}if(typeof v.indentSize<"u"){const p=this.n(v.indentSize);p==="tabSize"?(k=!0,y.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,k=!0,y.indentSize=p)}if(typeof v.insertSpaces<"u"){const p=this.p(v.insertSpaces);p==="auto"?(k=!0,y.insertSpaces=p):this.h!==p&&(this.h=p,k=!0,y.insertSpaces=p)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,k=!0,y.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,k=!0,y.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(v,y){y.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(k)})}}e.$uM=b;class L{constructor(v,y,k,p,h,s,a,o){this.id=v,this.j=y,this.k=k,this.g=!1,this.h=new Set,this.c=h,this.d=new b(this.j,this.id,s,k),this.e=a,this.f=o;const f=this;this.value=Object.freeze({get document(){return p.value},set document(l){throw new T.$9("document")},get selection(){return f.c&&f.c[0]},set selection(l){if(!(l instanceof A.$qK))throw(0,T.$7)("selection");f.c=[l],f.l()},get selections(){return f.c},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof A.$qK)))throw(0,T.$7)("selections");f.c=l,f.l()},get visibleRanges(){return f.e},set visibleRanges(l){throw new T.$9("visibleRanges")},get options(){return f.d.value},set options(l){f.g||f.d.assign(l)},get viewColumn(){return f.f},set viewColumn(l){throw new T.$9("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new E(p.value,t);return l(i),f.m(i)},insertSnippet(l,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=f.c.map(n=>R.Range.from(n));else if(t instanceof A.$oK){const{lineNumber:n,column:r}=R.Position.from(t);c=[{startLineNumber:n,startColumn:r,endLineNumber:n,endColumn:r}]}else if(t instanceof A.$pK)c=[R.Range.from(t)];else{c=[];for(const n of t)if(n instanceof A.$pK)c.push(R.Range.from(n));else{const{lineNumber:r,column:u}=R.Position.from(n);c.push({startLineNumber:r,startColumn:u,endLineNumber:r,endColumn:u})}}return y.$tryInsertSnippet(v,p.value.version,l.value,c,i)},setDecorations(l,t){const i=t.length===0;i&&!f.h.has(l.key)||(i?f.h.delete(l.key):f.h.add(l.key),f.n(()=>{if(R.$jM(t))return y.$trySetDecorations(v,l.key,R.$kM(t));{const c=new Array(4*t.length);for(let n=0,r=t.length;n<r;n++){const u=t[n];c[4*n]=u.start.line+1,c[4*n+1]=u.start.character+1,c[4*n+2]=u.end.line+1,c[4*n+3]=u.end.character+1}return y.$trySetDecorationsFast(v,l.key,c)}}))},revealRange(l,t){f.n(()=>y.$tryRevealRange(v,R.Range.from(l),t||A.TextEditorRevealType.Default))},show(l){y.$tryShowEditor(v,R.ViewColumn.from(l))},hide(){y.$tryHideEditor(v)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,C.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,C.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,C.ok)(!this.g),this.f=v}_acceptSelections(v){(0,C.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const y=v.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const k=y.edits.map(h=>h.range);k.sort((h,s)=>h.end.line===s.end.line?h.end.character===s.end.character?h.start.line===s.start.line?h.start.character-s.start.character:h.start.line-s.start.line:h.end.character-s.end.character:h.end.line-s.end.line);for(let h=0,s=k.length-1;h<s;h++){const a=k[h].end;if(k[h+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=y.edits.map(h=>({range:R.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,p,{setEndOfLine:typeof y.setEndOfLine=="number"?R.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$vM=L}),define(De[289],Ce([1,0,213,23,2,4,3,270,8,7,17,19,13,80,21,173,26]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;function s(f,l){if((0,L.$yf)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let t;return Array.isArray(f.highlights)&&(t=f.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),t=t.length?t:void 0),{label:f.label,highlights:t}}}class a extends A.$Sc{constructor(l,t,i){super(),this.f=l,this.g=t,this.h=i,this.a=new Map,this.b=new p.$S7;function c(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:n=>c(n)?this.r(n):Array.isArray(n)&&n.length>0?n.map(r=>c(r)?this.r(r):r):n})}registerTreeDataProvider(l,t,i){const c=this.createTreeView(l,{treeDataProvider:t},i);return{dispose:()=>c.dispose()}}createTreeView(l,t,i){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],n=t.dragAndDropController?.dragMimeTypes??[],r=!!t.dragAndDropController?.handleDrag,u=!!t.dragAndDropController?.handleDrop,I=this.m(l,t,i),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:n,hasHandleDrag:r,hasHandleDrop:u,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(l,S),g={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,h.$hF)(i,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,h.$hF)(i,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(w){(0,y.$5j)(w)&&(0,h.$hF)(i,"treeViewMarkdownMessage"),I.message=w},get title(){return I.title},set title(w){I.title=w},get description(){return I.description},set description(w){I.description=w},get badge(){return I.badge},set badge(w){w!==void 0&&b.ViewBadge.isViewBadge(w)?I.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(I.badge=void 0)},reveal:(w,D)=>I.reveal(w,D),dispose:async()=>{await $,this.a.delete(l),I.dispose()}};return this.B(g),g}$getChildren(l,t){const i=this.a.get(l);return i?i.getChildren(t):Promise.reject(new m.$sE(l))}async $handleDrop(l,t,i,c,n,r,u,I){const S=this.a.get(l);if(!S)return Promise.reject(new m.$sE(l));const $=v.DataTransfer.toDataTransfer(i,async g=>(await this.f.$resolveDropFileData(l,t,g)).buffer);return u===l&&I&&await this.j($,S,I,n,r),S.onDrop($,c,n)}async j(l,t,i,c,n){const r=this.b.removeDragOperationTransfer(n);if(r)(await r)?.forEach((u,I)=>{u&&l.set(I,u)});else if(n&&t.handleDrag){const u=t.handleDrag(i,l,c);this.b.addDragOperationTransfer(n,u),await u}return l}async $handleDrag(l,t,i,c){const n=this.a.get(l);if(!n)return Promise.reject(new m.$sE(l));const r=await this.j(new b.$eL,n,t,c,i);if(!(!r||c.isCancellationRequested))return v.DataTransfer.from(r)}async $hasResolve(l){const t=this.a.get(l);if(!t)throw new m.$sE(l);return t.hasResolve}$resolve(l,t,i){const c=this.a.get(l);if(!c)throw new m.$sE(l);return c.resolveTreeItem(t,i)}$setExpanded(l,t,i){const c=this.a.get(l);if(!c)throw new m.$sE(l);c.setExpanded(t,i)}$setSelectionAndFocus(l,t,i){const c=this.a.get(l);if(!c)throw new m.$sE(l);c.setSelectionAndFocus(t,i)}$setVisible(l,t){const i=this.a.get(l);if(!i){if(!t)return;throw new m.$sE(l)}i.setVisible(t)}$changeCheckboxState(l,t){const i=this.a.get(l);if(!i)throw new m.$sE(l);i.setCheckboxState(t)}m(l,t,i){const c=this.B(new o(l,t,this.f,this.g.converter,this.h,i));return this.a.set(l,c),c}r(l){const t=this.a.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.$kdc=a;class o extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,L.$Hf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,t,i,c,n,r){if(super(),this.I=l,this.J=i,this.L=c,this.M=n,this.N=r,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$Xd,r.contributes&&r.contributes.views)for(const $ in r.contributes.views)for(const g of r.contributes.views[$])g.id===l&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let u,I;const S=R.Event.debounce(this.F.event,($,g)=>($||($={message:!1,elements:[]}),g.element!==!1&&(u||(u=new Promise(w=>I=w),this.G=this.G.then(()=>u)),Array.isArray(g.element)?$.elements.push(...g.element):$.elements.push(g.element)),g.message&&($.message=!0),$),200,!0);this.B(S(({message:$,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const w=I;return u=null,this.$(g).then(()=>w())})),$&&this.J.$setMessage(this.I,v.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let i=this.X(l);return i||(i=await this.Y(t)),i?i.map(c=>c.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const i=(0,L.$Hf)(t.select)?!0:t.select,c=(0,L.$Hf)(t.focus)?!1:t.focus,n=(0,L.$Hf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(r=>this.W(l,r[r.length-1]).then(u=>this.J.$reveal(this.I,{item:u.item,parentChain:r.map(I=>I.item)},{select:i,focus:c,expand:n})),r=>this.M.error(r)):this.J.$reveal(this.I,void 0,{select:i,focus:c,expand:n})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=v.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,t){const i=this.getExtensionElement(l);i&&(t?this.u.fire(Object.freeze({element:i})):this.w.fire(Object.freeze({element:i})))}setSelectionAndFocus(l,t){const i=!(0,P.$ub)(this.s,l);this.s=l;const c=this.t!==t;this.t=t,i&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async i=>{const c=this.getExtensionElement(i.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:i.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);t.forEach(i=>{i.treeItem.checkboxState=i.newState?b.TreeItemCheckboxState.Checked:b.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(i=>[i.extensionItem,i.newState])})}async handleDrag(l,t,i){const c=[];for(const n of l){const r=this.getExtensionElement(n);r&&c.push(r)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,i),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,t,i){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,E.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(c,l,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,t){if(!this.f.resolveTreeItem)return;const i=this.j.get(l);if(i){const c=this.m.get(i);if(c){const n=await this.f.resolveTreeItem(c.extensionItem,i,t)??c.extensionItem;return this.hb(n),c.item.tooltip=this.eb(n.tooltip),c.item.command=this.fb(c.disposableStore,n.command),c.item}}}S(l){return this.U(l).then(t=>t?this.S(t).then(i=>this.W(t,i[i.length-1]).then(c=>(i.push(c),i))):Promise.resolve([]))}U(l){const t=this.m.get(l);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Mg)(()=>this.f.getParent(l))}W(l,t){const i=this.m.get(l);return i?Promise.resolve(i):(0,E.$Mg)(()=>this.f.getTreeItem(l)).then(c=>this.kb(l,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const n=this.getExtensionElement(c);if(n){const r=this.m.get(n);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let t;if(typeof l=="string"){const i=this.getExtensionElement(l);t=i?this.m.get(i):void 0}else t=l;return t&&t.children||void 0}return this.h}async Y(l){this.rb(l);const t=new k.$Xd(this.Z.token);try{const i=l?this.m.get(l):void 0,c=await this.f.getChildren(l);if(t.token.isCancellationRequested)return;const n=await Promise.all((0,P.$Hb)(c||[]).map(async r=>{const u=await this.f.getTreeItem(r);return u&&!t.token.isCancellationRequested?this.db(r,u,i):null}));return t.token.isCancellationRequested?void 0:(0,P.$Hb)(n)}finally{t.dispose()}}$(l){if(l.some(i=>!i))return this.Z.dispose(!0),this.Z=new k.$Xd,this.tb(),this.J.$refresh(this.I);{const i=this.ab(l);if(i.length)return this.bb(i)}return Promise.resolve(void 0)}ab(l){const t=new Set,i=l.map(n=>this.m.get(n));for(const n of i)if(n&&!t.has(n.item.handle)){let r=n;for(;r&&r.parent&&i.findIndex(u=>r&&r.parent&&u&&u.item.handle===r.parent.item.handle)===-1;){const u=this.j.get(r.parent.item.handle);r=u?this.m.get(u):void 0}r&&!r.parent&&t.add(n.item.handle)}const c=[];return t.forEach(n=>{const r=this.j.get(n);if(r){const u=this.m.get(r);u&&(!u.parent||!t.has(u.parent.item.handle))&&c.push(n)}}),c}bb(l){const t={};return Promise.all(l.map(i=>this.cb(i).then(c=>{c&&(t[i]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(l){const t=this.getExtensionElement(l);if(t){const i=this.m.get(t);if(i)return this.rb(t),(0,E.$Mg)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const n=this.ib(t,c,i.parent);return this.pb(t,n,i,i.parent),i.dispose(),n}return null})}return Promise.resolve(null)}db(l,t,i){const c=this.ib(l,t,i);if(t.id&&this.j.has(c.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(l,c),this.qb(c,i),c}eb(l){return b.$NK.isMarkdownString(l)?v.MarkdownString.from(l):l}fb(l,t){return t?{...this.L.toInternal(t,l),originalId:t.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let t,i,c;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,i=l.checkboxState.tooltip,c=l.checkboxState.accessibilityInformation),{isChecked:t===b.TreeItemCheckboxState.Checked,tooltip:i,accessibilityInformation:c}}hb(l){if(!b.$_K.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,t,i){this.hb(t);const c=this.B(new A.$Rc),n=this.kb(l,t,i),r=this.lb(t);return{item:{handle:n,parentHandle:i?i.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:r,iconDark:this.mb(t)||r,themeIcon:this.jb(t),collapsibleState:(0,L.$Hf)(t.collapsibleState)?b.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:i,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(l){return l.iconPath instanceof b.$hL?l.iconPath:void 0}kb(l,{id:t,label:i,resourceUri:c},n,r){if(t)return`${o.b}/${t}`;const u=s(i,this.N),I=n?n.item.handle:o.a;let S=u?u.label:c?(0,T.$sg)(c):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const $=this.m.has(l)?this.m.get(l).item.handle:void 0,g=this.X(n)||[];let w,D=0;do{if(w=`${I}/${D}:${S}`,r||!this.j.has(w)||$===w)break;D++}while(D<=g.length);return w}lb(l){if(l.iconPath&&!(l.iconPath instanceof b.$hL))return typeof l.iconPath=="string"||d.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof b.$hL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return d.URI.isUri(l)?l:d.URI.file(l)}ob(l,t){this.j.set(t.item.handle,l),this.m.set(l,t)}pb(l,t,i,c){this.j.delete(t.item.handle),this.m.delete(l),t.item.handle!==i.item.handle&&this.j.delete(i.item.handle),this.ob(l,t);const n=this.X(c)||[],r=n.filter(u=>u.item.handle===i.item.handle)[0];r&&n.splice(n.indexOf(r),1,t)}qb(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const t=this.m.get(l);if(t){if(t.children)for(const i of t.children){const c=this.j.get(i.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(l){const t=this.m.get(l);if(t){if(t.children)for(const i of t.children){const c=this.j.get(i.item.handle);c&&this.sb(c)}this.m.delete(l),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[290],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[291],Ce([1,0,225,9,38,132,105,43,25,290,135,137]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=void 0;const v=m.$gn.as(A.$hn.JSONContribution);class y{constructor(l,t,i){this.a=l,this.b=t,this.c=i}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(d.default.Error,l)}warn(l){this.d(d.default.Warning,l)}info(l){this.d(d.default.Info,l)}}e.$8E=y;class k{static a(l){const t=new E.$7l;for(let i=0,c=l.length;i<c;i++)t.add(l[i].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new k(t,[]);if(!t||!t.length)return new k([],l);const i=this.a(l),c=this.a(t),n=t.filter(u=>!i.has(u.description.identifier)),r=l.filter(u=>!c.has(u.description.identifier));return new k(n,r)}constructor(l,t){this.added=l,this.removed=t}}e.$9E=k;class p{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=k.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,T.$1)(l)}}}e.$0E=p;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$$E={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$5l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Xn}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$Xn}},extensionKind:{description:C.localize(51,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new p(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&P.$YE.register(l.extensionPoint,l.activationEventsGenerator),e.$$E.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,v.registerSchema(s,e.$$E),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$_E=a;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$gn.add(o.ExtensionsRegistry,new a),e.$aF=m.$gn.as(o.ExtensionsRegistry),v.registerSchema(s,e.$$E),v.registerSchema(L.$qj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(De[292],Ce([1,0,222,17,24,291,42,4]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var b;(function(v){function y(k,p,h){if(!k)return;const s=T.$yf(k.type)?k.type:void 0;if(!s||s.length===0){h.error(C.localize(3,null));return}const a=[];if(Array.isArray(k.required))for(const o of k.required)T.$yf(o)&&a.push(o);return{extensionId:p.value,taskType:s,required:a,properties:k.properties?d.$7m(k.properties):{},when:k.when?A.$Ni.deserialize(k.when):void 0}}v.from=y})(b||(b={}));const L=R.$aF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,y)=>{for(const k of v)k.type&&y.push(`onTaskType:${k.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:E}});class P{constructor(){this.d=new m.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,k)=>{L.setHandler((p,h)=>{this.c=void 0;try{for(const s of h.removed){const a=s.value;for(const o of a)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const s of h.added){const a=s.value;for(const o of a){const f=b.from(o,s.description.identifier,s.collector);f&&(this.a[f.taskType]=f)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const k of this.all()){const p={type:"object",additionalProperties:!1};k.required.length>0&&(p.required=k.required.slice(0)),k.properties!==void 0?p.properties=d.$7m(k.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[k.taskType]},y.push(p)}this.c={oneOf:y}}return this.c}}e.$RF=new P}),define(De[293],Ce([1,0,223,17,23,24,42,292]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$2F=e.JsonSchemaVersion=e.ExecutionEngine=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$VF=e.ShellQuoting=e.$UF=e.$TF=e.$SF=void 0,e.$SF="settings",e.$TF=new A.$7i("taskRunning",!1,C.localize(0,null)),e.$UF={value:C.localize(1,null),original:"Tasks"};var E;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$VF="$customized",function(j){function O(q){if(!q)return j.Strong;switch(q.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=O}(E||(e.ShellQuoting=E={}));var b;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var L;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(L||(e.RevealKind=L={})),function(j){function O(q){switch(q.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=O}(L||(e.RevealKind=L={}));var P;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(j){function O(q){switch(q.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=O}(P||(e.RevealProblemKind=P={}));var v;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(v||(e.PanelKind=v={})),function(j){function O(q){switch(q.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=O}(v||(e.PanelKind=v={}));var y;(function(j){j.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var k;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(j){function O(K){switch(K.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=O;function q(K){switch(K){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=q}(k||(e.RuntimeType=k={}));var p;(function(j){function O(q){return T.$yf(q)?q:q.value}j.value=O})(p||(e.CommandString=p={}));var h;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function O(K){return K===j.Clean._id||K===j.Build._id||K===j.Rebuild._id||K===j.Test._id}j.is=O;function q(K){if(K!==void 0)return T.$yf(K)?O(K)?{_id:K,isDefault:!1}:void 0:K}j.from=q})(h||(e.TaskGroup=h={}));var s;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var a;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function O(q){switch(q){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=O})(a||(e.TaskSourceKind=a={}));var o;(function(j){j.parallel="parallel",j.sequence="sequence"})(o||(e.DependsOrder=o={}));var f;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(f||(e.RunOnOptions=f={}));var l;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:f.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(O,q,K,me,te,G){this._label="",this._id=O,q&&(this._label=q),K&&(this.type=K),this.runOptions=me,this.configurationProperties=te,this._source=G}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,q=!1){if(O===void 0)return!1;if(T.$yf(O))return O===this._label||O===this.configurationProperties.identifier||q&&O===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$WF=t;class i extends t{constructor(O,q,K,me,te,G,Q,le){super(O,K,void 0,Q,le,q),this.command={},this._source=q,this.hasDefinedMatchers=G,te&&(this.command=te)}clone(){return new i(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case k.Shell:q="shell";break;case k.Process:q="process";break;case k.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(O){return O instanceof i}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$SF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(q+=this._source.kind);const K={type:e.$VF,folder:O,id:q};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new i(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$XF=i;class c extends t{constructor(O,q,K,me,te,G,Q){super(O,K,me,G,Q,q),this._source=q,this.configures=te}static is(O){return O instanceof c}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$SF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(q+=this._source.kind);const K={type:e.$VF,folder:O,id:q};return JSON.stringify(K)}}e.$YF=c;class n extends t{constructor(O,q,K,me,te,G,Q,le,ie){super(O,K,me,le,ie,q),this.defines=te,this.hasDefinedMatchers=Q,this.command=G,this.icon=ie.icon,this.hide=ie.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof n}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new n(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$ZF=n;class r extends t{constructor(O,q,K,me,te,G){super(O,K,me,te,G,q),this._source=q}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new r(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$1F=r;var u;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(u||(e.ExecutionEngine=u={})),function(j){j._default=j.Terminal}(u||(e.ExecutionEngine=u={}));var I;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(O){this.c=new Map;for(let q=0;q<O.length;q++)this.c.set(O[q].uri.toString(),q)}compare(O,q){const K=O.getWorkspaceFolder(),me=q.getWorkspaceFolder();if(K&&me){let te=this.c.get(K.uri.toString());te=te===void 0?0:te+1;let G=this.c.get(me.uri.toString());return G=G===void 0?0:G+1,te===G?O._label.localeCompare(q._label):te-G}else return!K&&me?-1:K&&!me?1:0}}e.$2F=S;var $;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})($||(e.TaskEventKind=$={}));var g;(function(j){j.SingleRun="singleRun",j.Background="background"})(g||(e.TaskRunType=g={}));var w;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var D;(function(j){function O(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function q(le,ie,ce){return{...O(le),kind:"start",terminalId:ie,resolvedVariables:ce}}j.start=q;function K(le,ie,ce){return{...O(le),kind:"processStarted",terminalId:ie,processId:ce}}j.processStarted=K;function me(le,ie,ce){return{...O(le),kind:"processEnded",terminalId:ie,exitCode:ce}}j.processEnded=me;function te(le,ie,ce){return{...O(le),kind:"terminated",exitReason:ce,terminalId:ie}}j.terminated=te;function G(le,ie,ce){return{...O(ie),kind:le,terminalId:ce}}j.general=G;function Q(){return{kind:"changed"}}j.changed=Q})(D||(e.TaskEvent=D={}));var N;(function(j){function O(K){const me=Object.keys(K).sort();let te="";for(const G of me){let Q=K[G];Q instanceof Object?Q=O(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),te+=G+","+Q+","}return te}function q(K){const te={_key:O(K),type:K.taskType};return Object.assign(te,K),te}j.create=q})(N||(e.KeyedTaskIdentifier=N={}));var M;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection"})(M||(e.TaskSettingId=M={}));var F;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var U;(function(j){function O(q,K){const me=m.$RF.get(q.type);if(me===void 0){const le=R.$7m(q);return delete le._key,N.create(le)}const te=Object.create(null);te.type=me.taskType;const G=new Set;me.required.forEach(le=>G.add(le));const Q=me.properties;for(const le of Object.keys(Q)){const ie=q[le];if(ie!=null)te[le]=ie;else if(G.has(le)){const ce=Q[le];if(ce.default!==void 0)te[le]=R.$7m(ce.default);else switch(ce.type){case"boolean":te[le]=!1;break;case"number":case"integer":te[le]=0;break;case"string":te[le]="";break;default:K.error(C.localize(2,null,JSON.stringify(q,void 0,0),le));return}}}return N.create(te)}j.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(De[294],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F4b=e.$E4b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$E4b=T;class d extends T{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$F4b=d}),define(De[69],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=void 0;class C{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++C.count}}e.$nv=C;const T=[];function d(m){const E=new C(m);return T[E.nid]=E,E}e.$ov=d;function R(m){return T[m].sid}e.$pv=R;class A{constructor(E){this.value=E}}e.$qv=A}),define(De[6],Ce([1,0,69]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mK=e.$lK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$kK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var d;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var R;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var A;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var b;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var L;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class P{static{this.a=0}static mixin(h){return h._id=P.a++,h}}e.$kK=P;var v;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var y;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var k;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$lK={MainThreadAuthentication:(0,C.$ov)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$ov)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$ov)("MainThreadChatProvider"),MainThreadChatAgents:(0,C.$ov)("MainThreadChatAgents"),MainThreadChatAgents2:(0,C.$ov)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$ov)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$ov)("MainThreadClipboard"),MainThreadCommands:(0,C.$ov)("MainThreadCommands"),MainThreadComments:(0,C.$ov)("MainThreadComments"),MainThreadConfiguration:(0,C.$ov)("MainThreadConfiguration"),MainThreadConsole:(0,C.$ov)("MainThreadConsole"),MainThreadDebugService:(0,C.$ov)("MainThreadDebugService"),MainThreadDecorations:(0,C.$ov)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$ov)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$ov)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$ov)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$ov)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$ov)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$ov)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$ov)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$ov)("MainThreadErrors"),MainThreadTreeViews:(0,C.$ov)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$ov)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$ov)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$ov)("MainThreadLanguages"),MainThreadLogger:(0,C.$ov)("MainThreadLogger"),MainThreadMessageService:(0,C.$ov)("MainThreadMessageService"),MainThreadOutputService:(0,C.$ov)("MainThreadOutputService"),MainThreadProgress:(0,C.$ov)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$ov)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$ov)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$ov)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$ov)("MainThreadSecretState"),MainThreadStorage:(0,C.$ov)("MainThreadStorage"),MainThreadSpeech:(0,C.$ov)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$ov)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$ov)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$ov)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$ov)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$ov)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$ov)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$ov)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$ov)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$ov)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$ov)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$ov)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$ov)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$ov)("MainThreadExtensionService"),MainThreadSCM:(0,C.$ov)("MainThreadSCM"),MainThreadSearch:(0,C.$ov)("MainThreadSearch"),MainThreadShare:(0,C.$ov)("MainThreadShare"),MainThreadTask:(0,C.$ov)("MainThreadTask"),MainThreadWindow:(0,C.$ov)("MainThreadWindow"),MainThreadLabelService:(0,C.$ov)("MainThreadLabelService"),MainThreadNotebook:(0,C.$ov)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$ov)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$ov)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$ov)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$ov)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$ov)("MainThreadInteractive"),MainThreadChat:(0,C.$ov)("MainThreadChat"),MainThreadInlineChat:(0,C.$ov)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$ov)("MainThreadTheming"),MainThreadTunnelService:(0,C.$ov)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$ov)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$ov)("MainThreadTimeline"),MainThreadTesting:(0,C.$ov)("MainThreadTesting"),MainThreadLocalization:(0,C.$ov)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$ov)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$ov)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$ov)("MainThreadIssueReporter")},e.$mK={ExtHostCommands:(0,C.$ov)("ExtHostCommands"),ExtHostConfiguration:(0,C.$ov)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$ov)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$ov)("ExtHostDebugService"),ExtHostDecorations:(0,C.$ov)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$ov)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$ov)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$ov)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$ov)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$ov)("ExtHostEditors"),ExtHostTreeViews:(0,C.$ov)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$ov)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$ov)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$ov)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$ov)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$ov)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$ov)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$ov)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$ov)("ExtHostStatusBar"),ExtHostShare:(0,C.$ov)("ExtHostShare"),ExtHostExtensionService:(0,C.$ov)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$ov)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$ov)("ExtHostTerminalService"),ExtHostSCM:(0,C.$ov)("ExtHostSCM"),ExtHostSearch:(0,C.$ov)("ExtHostSearch"),ExtHostTask:(0,C.$ov)("ExtHostTask"),ExtHostWorkspace:(0,C.$ov)("ExtHostWorkspace"),ExtHostWindow:(0,C.$ov)("ExtHostWindow"),ExtHostWebviews:(0,C.$ov)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$ov)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$ov)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$ov)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$ov)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$ov)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$ov)("ExtHostProgress"),ExtHostComments:(0,C.$ov)("ExtHostComments"),ExtHostSecretState:(0,C.$ov)("ExtHostSecretState"),ExtHostStorage:(0,C.$ov)("ExtHostStorage"),ExtHostUrls:(0,C.$ov)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$ov)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$ov)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$ov)("ExtHostOutputService"),ExtHosLabelService:(0,C.$ov)("ExtHostLabelService"),ExtHostNotebook:(0,C.$ov)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$ov)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$ov)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$ov)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$ov)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$ov)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$ov)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$ov)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$ov)("ExtHostChat"),ExtHostChatAgents:(0,C.$ov)("ExtHostChatAgents"),ExtHostChatAgents2:(0,C.$ov)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$ov)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$ov)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$ov)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$ov)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$ov)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$ov)("ExtHostTheming"),ExtHostTunnelService:(0,C.$ov)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$ov)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$ov)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$ov)("ExtHostTimeline"),ExtHostTesting:(0,C.$ov)("ExtHostTesting"),ExtHostTelemetry:(0,C.$ov)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$ov)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$ov)("ExtHostIssueReporter")}}),define(De[295],Ce([1,0,6,7]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$lK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,E){if(this.a.size===0)throw new Error("No related information providers registered");const b=this.a.get(A);if(!b)throw new Error("related information provider not found");return await b.provideRelatedInformation(m,E)??[]}getRelatedInformation(A,m,E){return this.c.$getAiRelatedInformation(m,E)}registerRelatedInformationProvider(A,m,E){const b=this.b;return this.b++,this.a.set(b,E),this.c.$registerAiRelatedInformationProvider(b,m),new T.$nK(()=>{this.c.$unregisterAiRelatedInformationProvider(b),this.a.delete(b)})}}e.$mec=d}),define(De[89],Ce([1,0,5,14,6,20]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=e.$occ=void 0,e.$occ=(0,C.$Ph)("IExtHostApiDeprecationService");let A=class{constructor(E,b){this.c=b,this.a=new Set,this.b=E.getProxy(d.$lK.MainThreadTelemetry)}report(E,b,L){const P=this.d(E,b);this.a.has(P)||(this.a.add(P),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:E}))}d(E,b){return`${E}-${b.identifier.value}`}};e.$pcc=A,e.$pcc=A=He([Be(0,R.$mM),Be(1,T.$0i)],A),e.$qcc=Object.freeze(new class{report(m,E,b){}})}),define(De[296],Ce([1,0,4,6,7,25]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class A{constructor(b){this.b=new Map,this.c=[],this.d=new C.$Nd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=b.getProxy(T.$lK.MainThreadAuthentication)}$setProviders(b){return this.c=b,Promise.resolve()}async getSession(b,L,P,v={}){const y=R.$6l.toKey(b.identifier),k=[...P].sort().join(" ");return await this.f.getOrCreate(`${y} ${L} ${k}`,async()=>{await this.a.$ensureProvider(L);const p=b.displayName||b.name;return this.a.$getSession(L,P,y,p,v)})}async getSessions(b,L,P){const v=R.$6l.toKey(b.identifier),y=[...P].sort().join(" ");return await this.g.getOrCreate(`${v} ${y}`,async()=>{await this.a.$ensureProvider(L);const k=b.displayName||b.name;return this.a.$getSessions(L,P,v,k)})}async removeSession(b,L){const P=this.b.get(b);return P?P.provider.removeSession(L):this.a.$removeSession(b,L)}registerAuthenticationProvider(b,L,P,v){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:L,provider:P,options:v??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===b)||this.c.push({id:b,label:L});const y=P.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(b,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(b,L,v?.supportsMultipleAccounts??!1),new d.$nK(()=>{y.dispose(),this.b.delete(b);const k=this.c.findIndex(p=>p.id===b);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,L,P){const v=this.b.get(b);if(v)return Promise.resolve(v.provider.createSession(L,P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,L){const P=this.b.get(b);if(P)return Promise.resolve(P.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,L){const P=this.b.get(b);if(P)return Promise.resolve(P.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,L){return this.d.fire({provider:{id:b,label:L}}),Promise.resolve()}}e.$Wdc=A;class m{constructor(){this.a=new Map}getOrCreate(b,L){const P=this.a.get(b);if(P)return P;const v=L().finally(()=>this.a.delete(b));return this.a.set(b,v),v}}}),define(De[297],Ce([1,0,6,20,13]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let R=class{constructor(m,E){this.a=m.getProxy(C.$lK.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>E.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,b){const L=d.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,b?.isRefactoring??!1)}};e.$3dc=R,e.$3dc=R=He([Be(0,T.$mM)],R)}),define(De[298],Ce([1,0,8,4,51,3,35,202,6,13]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class L{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=L.a++}}class P{static{this.a=0}constructor(y,k){this.h=k,this.b=new Map,this.d=new Map,this.e=new T.$Nd,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$lK.MainThreadChat)}registerChatProvider(y,k,p){const h=new L(y,p);return this.b.set(h.handle,h),this.g.$registerChatProvider(h.handle,k),(0,R.$Qc)(()=>{this.g.$unregisterChatProvider(h.handle),this.b.delete(h.handle)})}transferChatSession(y,k){const p=d.Iterable.find(this.d.keys(),h=>this.d.get(h)===y)??0;typeof p=="number"&&this.g.$transferChatSession(p,k)}sendInteractiveRequestToProvider(y,k){this.g.$sendRequestToProvider(y,k)}async $prepareChat(y,k,p){const h=this.b.get(y);if(!h)return;const s=await h.provider.prepareSession(k,p);if(!s)return;const a=P.a++;return this.d.set(a,s),{id:a,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $provideWelcomeMessage(y,k){const p=this.b.get(y);if(!p||!p.provider.provideWelcomeMessage)return;const h=await p.provider.provideWelcomeMessage(k);if(h)return h.map(s=>typeof s=="string"?s:Array.isArray(s)?s.map(a=>b.ChatReplyFollowup.from(a)):b.MarkdownString.from(s))}async $provideFollowups(y,k,p){const h=this.b.get(y);if(!h)return;const s=this.d.get(k);return!s||!h.provider.provideFollowups?void 0:(await h.provider.provideFollowups(s,p))?.map(o=>b.ChatFollowup.from(o))}async $provideSampleQuestions(y,k){const p=this.b.get(y);if(!p||!p.provider.provideSampleQuestions)return;const h=await p.provider.provideSampleQuestions(k);if(h)return h?.map(s=>b.ChatReplyFollowup.from(s))}$removeRequest(y,k,p){const h=this.b.get(y);if(!h)return;const s=this.d.get(k);s&&h.provider.removeRequest&&h.provider.removeRequest(s,p)}async $provideReply(y,k,p,h){const s=this.b.get(y);if(!s)return;const a=this.d.get(k);if(!a)return;const o={session:a,message:p.message,variables:{}};if(p.variables)for(const n of Object.keys(p.variables))o.variables[n]=p.variables[n].map(b.ChatVariable.to);const f=A.$Jd.create(!1);let l;const t={report:n=>{if(h.isCancellationRequested)return;typeof l>"u"&&(l=f.elapsed());const r=b.ChatResponseProgress.from(s.extension,n);if("placeholder"in n&&"resolvedContent"in n){const u=Promise.all([this.g.$acceptResponseProgress(y,k,r),n.resolvedContent]);(0,C.$Ig)(u,h).then(I=>{if(!I)return;const[S,$]=I;this.g.$acceptResponseProgress(y,k,$,S??void 0)})}else this.g.$acceptResponseProgress(y,k,r)}};let i;try{i=await s.provider.provideResponseWithProgress(o,t,h),i||(i={errorDetails:{message:(0,m.localize)(0,null)}})}catch(n){i={errorDetails:{message:(0,m.localize)(1,null,n.message),responseIsIncomplete:!0}},this.h.error(n)}try{if(a.saveState&&this.d.has(k)){const n=a.saveState();this.g.$acceptChatState(k,n)}}catch(n){this.h.warn(n)}const c={firstProgress:l??0,totalElapsed:f.elapsed()};return{errorDetails:i.errorDetails,timings:c}}async $provideSlashCommands(y,k,p){const h=this.b.get(y);if(!h)return;const s=this.d.get(k);return!s||!h.provider.provideSlashCommands?void 0:(await h.provider.provideSlashCommands(s,p))?.map(o=>({...o,kind:b.CompletionItemKind.from(o.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$eec=P}),define(De[299],Ce([1,0,8,3,64,6,13,7]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class E{static{this.a=0}constructor(P,v,y){this.d=v,this.e=y,this.b=new Map,this.c=P.getProxy(R.$lK.MainThreadChatAgents)}registerAgent(P,v,y,k){const p=E.a++;return this.b.set(p,{extension:P,agent:y}),this.c.$registerAgent(p,v,k),(0,T.$Qc)(()=>{this.c.$unregisterAgent(p),this.b.delete(p)})}async $invokeAgent(P,v,y,k,p){const h=this.b.get(P);if(!h){this.e.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function a(){if(s)throw new Error("Only valid while executing the command")}const o=new C.$ch;p.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),10*1e3),this.d.allowListExtensionWhile(h.extension,o.p);const f=h.agent({role:m.ChatMessageRole.User,content:y},{history:k.history.map(A.ChatMessage.to)},new d.$5u(l=>{a(),this.c.$handleProgressChunk(v,{content:b(l.message)?l.message:l.message.value})}),p);try{return await(0,C.$Ig)(Promise.resolve(f).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(i=>A.ChatFollowup.from(i))}}),p)}finally{s=!0,o.complete()}}}e.$oec=E;function b(L){return!!L&&typeof L=="object"&&"treeData"in L}}),define(De[300],Ce([1,0,8,21,41,4,35,17,2,203,64,6,13,7,271,26]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class h{static{this.a=0}constructor(o,f,l){this.i=f,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(P.$lK.MainThreadChatAgents2)}createChatAgent(o,f,l){const t=h.a++,i=new s(o,f,this.d,t,l);return this.b.set(t,i),this.d.$registerAgent(t,f,{}),i.apiAgent}async $invokeAgent(o,f,l,t,i,c){this.g.delete(f);const n=this.b.get(o);if(!n)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let r=!1;function u(){if(r)throw new Error("Only valid while executing the command")}const I=new C.$ch;c.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(n.extension.identifier,I.p);const S=t.command?await n.validateSlashCommand(t.command):void 0,$=A.$Jd.create(!1);let g;try{const w=n.invoke({prompt:t.message,variables:v.ChatVariable.objectTo(t.variables),slashCommand:S},{history:i.history.map(v.ChatMessage.to)},new L.$5u(D=>{u(),typeof g>"u"&&"content"in D&&(g=$.elapsed());const N=v.ChatResponseProgress.from(n.extension,D);if("placeholder"in D&&"resolvedContent"in D){const M=Promise.all([this.d.$handleProgressChunk(l,N),D.resolvedContent]);(0,C.$Ig)(M,c).then(F=>{if(!F)return;const[U,j]=F;this.d.$handleProgressChunk(l,j,U??void 0)})}else this.d.$handleProgressChunk(l,N)}),c);return await(0,C.$Ig)(Promise.resolve(w).then(D=>{if(D){this.g.set(f,D);let N=this.h.get(f);N||(N=new Map,this.h.set(f,N)),N.set(l,D);const M={firstProgress:g,totalElapsed:$.elapsed()};return{errorDetails:D.errorDetails,timings:M}}else this.g.delete(f)}),c)}catch(w){return this.j.error(w,n.extension),{errorDetails:{message:(0,b.localize)(0,null,(0,d.$Ai)(w)),responseIsIncomplete:!0}}}finally{r=!0,I.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,f){const l=this.b.get(o);return l?l.provideSlashCommand(f):[]}$provideFollowups(o,f,l){const t=this.b.get(o);if(!t)return Promise.resolve([]);const i=this.g.get(f);return i?t.provideFollowups(i,l):Promise.resolve([])}$acceptFeedback(o,f,l,t){const i=this.b.get(o);if(!i)return;const c=this.h.get(f)?.get(l);if(!c)return;let n;switch(t){case k.InteractiveSessionVoteDirection.Down:n=y.ChatAgentResultFeedbackKind.Unhelpful;break;case k.InteractiveSessionVoteDirection.Up:n=y.ChatAgentResultFeedbackKind.Helpful;break}i.acceptFeedback(Object.freeze({result:c,kind:n}))}$acceptAction(o,f,l,t){const i=this.b.get(o);if(!i)return;const c=this.h.get(f)?.get(l);c&&t.action.kind!=="vote"&&i.acceptAction(Object.freeze({action:t.action,result:c}))}}e.$pec=h;class s{constructor(o,f,l,t,i){this.extension=o,this.n=f,this.o=l,this.q=t,this.r=i,this.l=new R.$Nd,this.m=new R.$Nd}acceptFeedback(o){this.l.fire(o)}acceptAction(o){this.m.fire(o)}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,m.$If)(this.b));const f=this.b.find(l=>l.name===o);if(!f)throw new Error(`Unknown slashCommand: ${o}`);return f}async provideSlashCommand(o){if(!this.a)return[];const f=await this.a.provideSlashCommands(o);return f?(this.b=f,f.map(l=>({name:l.name,description:l.description}))):[]}async provideFollowups(o,f){if(!this.d)return[];const l=await this.d.provideFollowups(o,f);return l?l.map(t=>v.ChatFollowup.from(t)):[]}get apiAgent(){let o=!1,f=!1;const l=()=>{o||f||(f=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$hL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),f=!1}))},t=this;return{get name(){return t.n},get description(){return t.g??""},set description(i){t.g=i,l()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(i){t.h=i,l()},get iconPath(){return t.i},set iconPath(i){t.i=i,l()},get slashCommandProvider(){return t.a},set slashCommandProvider(i){t.a=i,l()},get followupProvider(){return t.d},set followupProvider(i){t.d=i,l()},get isDefault(){return(0,p.$hF)(t.extension,"defaultChatAgent"),t.j},set isDefault(i){(0,p.$hF)(t.extension,"defaultChatAgent"),t.j=i,l()},get isSecondary(){return(0,p.$hF)(t.extension,"defaultChatAgent"),t.k},set isSecondary(i){(0,p.$hF)(t.extension,"defaultChatAgent"),t.k=i,l()},get onDidReceiveFeedback(){return t.l.event},onDidPerformAction:(0,p.$gF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){o=!0,t.a=void 0,t.d=void 0,t.l.dispose(),t.o.$unregisterAgent(t.q)}}}invoke(o,f,l,t){return this.r(o,f,l,t)}}}),define(De[301],Ce([1,0,21,3,6,13,64,25,8,4]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class L{constructor(k,p){this.stream=new E.$gh,this.stream=p??new E.$gh;const h=this;this.apiObj={option:k,response:h.stream.asyncIterable}}}class P{constructor(k,p){this.a=new b.$Nd,this.b=new Map,this.c=new E.$gh,this.d=!1;const h=this;this.apiObject={result:k,response:h.c.asyncIterable,onDidStartResponseStream:h.a.event,cancel(){p.cancel()}},k.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(k){if(this.d)return;let p=this.b.get(k.index);p||(this.b.size===0?p=new L(k.index,this.c):p=new L(k.index),this.b.set(k.index,p),this.a.fire(p.apiObj)),p.stream.emitOne(k.part)}}class v{static{this.a=1}constructor(k,p){this.d=p,this.c=new Map,this.e=new Map,this.f=new m.$8l,this.b=k.getProxy(d.$lK.MainThreadChatProvider)}registerProvider(k,p,h,s){const a=v.a++;return this.c.set(a,{extension:k,provider:h}),this.b.$registerProvider(a,p,{extension:k,displayName:s.name??k.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(a),this.c.delete(a)})}async $provideChatResponse(k,p,h,s,a){const o=this.c.get(k);if(!o)return;const f=new A.$6u(async l=>{if(a.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(p,{index:l.index,part:l.part})});return o.provider.provideChatResponse(h.map(R.ChatMessage.to),s,f,a)}allowListExtensionWhile(k,p){this.f.set(k,p),p.finally(()=>this.f.delete(k))}async requestChatResponseProvider(k,p){if(!this.f.has(k))throw new Error("Extension is NOT allowed to make chat requests");const h=this;return{get isRevoked(){return!h.f.has(k)},makeRequest(s,a,o){if(!h.f.has(k))throw new Error("Access to chat has been revoked");const f=new C.$Xd(o),l=Math.random()*1e6|0,t=h.b.$fetchResponse(k,p,l,s.map(R.ChatMessage.from),a??{},f.token),i=new P(t,f);return h.e.set(l,{res:i}),t.finally(()=>{h.e.delete(l)}),i.apiObject}}}async $handleResponseFragment(k,p){const h=this.e.get(k);h&&h.res.handleFragment(p)}}e.$jec=v}),define(De[302],Ce([1,0,3,6,9,13]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(T.$lK.MainThreadChatVariables)}async $resolveVariable(E,b,L){const P=this.b.get(E);if(P)try{const v=await P.resolver.resolve(P.data.name,{message:b},L);if(v)return v.map(R.ChatVariable.from)}catch(v){(0,d.$2)(v)}}registerVariableResolver(E,b,L,P){const v=A.a++;return this.b.set(v,{extension:E.identifier,data:{name:b,description:L},resolver:P}),this.c.$registerVariable(v,{name:b,description:L}),(0,C.$Qc)(()=>{this.b.delete(v),this.c.$unregisterVariable(v)})}}e.$lec=A}),define(De[303],Ce([1,0,6]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class T{constructor(R){const A=R.getProxy(C.$lK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$tcc=T}),define(De[34],Ce([1,0,17,7,13,24,6,19,14,62,32,61,2,3,5,20,147,22,69,41,35,85,88]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=void 0;let i=class{#e;#t;#i;constructor(S,$,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$lK.MainThreadCommands),this.d=$,this.#i=g,this.#t=S.getProxy(A.$lK.MainThreadTelemetry),this.converter=new c(this,w=>{const D=this.c.get(w);return D?.result===r.Void?D:void 0},$),this.f=[{processArgument(w){return(0,b.$mh)(w)}},{processArgument(w){return(0,R.$9m)(w,function(D){if(L.$ts.isIRange(D))return d.Range.to(D);if(P.$ss.isIPosition(D))return d.Position.to(D);if(L.$ts.isIRange(D.range)&&v.URI.isUri(D.uri))return d.location.to(D);if(D instanceof s.$be)return D.buffer.buffer;if(!Array.isArray(D))return D})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const $=this.registerCommand(!1,S.id,async(...g)=>{const w=S.args.map((N,M)=>{if(!N.validate(g[M]))throw new Error(`Invalid argument '${N.name}' when running '${S.id}', received: ${typeof g[M]=="object"?JSON.stringify(g[M],null,"	"):g[M]} `);return N.convert(g[M])}),D=await this.executeCommand(S.internalId,...w);return S.result.convert(D,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new T.$nK(()=>{$.dispose(),this.c.delete(S.id)})}registerCommand(S,$,g,w,D,N){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:g,thisArg:w,metadata:D,extension:N}),S&&this.#e.$registerCommand($),new T.$nK(()=>{this.b.delete($)&&S&&this.#e.$unregisterCommand($)})}executeCommand(S,...$){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,$,!0)}async g(S,$,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,$,!1);{let w=!1;const D=(0,R.$9m)($,function(N){if(N instanceof T.$oK)return d.Position.from(N);if(N instanceof T.$pK)return d.Range.from(N);if(N instanceof T.$zK)return d.location.from(N);if(T.$KL.isNotebookRange(N))return d.NotebookRange.from(N);if(N instanceof ArrayBuffer)return w=!0,s.$be.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return w=!0,s.$be.wrap(N);if(N instanceof s.$be)return w=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(S,w?new a.$qv(D):D,g);return(0,b.$mh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(S,$,!1);throw N}}}async h(S,$,g){const w=this.b.get(S);if(!w)throw new Error("Unknown command");const{callback:D,thisArg:N,metadata:M}=w;if(M?.args)for(let U=0;U<M.args.length;U++)try{(0,C.$Pf)($[U],M.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${M.args[U].name}' - ${M.args[U].description}`)}const F=f.$Jd.create();try{return await D.apply(N,$)}catch(U){if(S===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...$);j&&(S=j.command)}if(this.d.error(U,S,w.extension?.identifier),!g)throw U;if(w.extension?.identifier){const j=this.#i.onExtensionError(w.extension.identifier,U);this.d.trace("forwarded error to extension?",j,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Ai)(U)),this.id=S,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,S,F.elapsed())}}j(S,$,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new l.$jo($),duration:g})}$executeContributedCommand(S,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?($=$.map(w=>this.f.reduce((D,N)=>N.processArgument(D,g.extension?.identifier),w)),this.h(S,$,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then($=>(S&&($=$.filter(g=>g[0]!=="_")),$))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[$,g]of this.b){const{metadata:w}=g;w&&(S[$]=w)}return Promise.resolve(S)}};e.$HM=i,e.$HM=i=He([Be(0,p.$mM),Be(1,E.$0i),Be(2,t.$GM)],i),e.$IM=(0,k.$Ph)("IExtHostCommands");class c{constructor(S,$,g){this.d=S,this.f=$,this.g=g,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,$){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const w=this.f(S.command);if(w)g.id=w.internalId,g.arguments=w.args.map((D,N)=>D.convert(S.arguments&&S.arguments[N]));else if((0,m.$Lb)(S.arguments)){const D=`${S.command} /${++this.c}`;this.b.set(D,S),$.add((0,y.$Qc)(()=>{this.b.delete(D),this.g.trace("CommandsConverter#DISPOSE",D)})),g.$ident=D,g.id=this.delegatingCommandId,g.arguments=[D],this.g.trace("CommandsConverter#CREATE",S.command,D)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const $=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$JM=c;class n{static{this.Uri=new n("uri","Uri of a text document",S=>v.URI.isUri(S),S=>S)}static{this.Position=new n("position","A position in a text document",S=>T.$oK.isPosition(S),d.Position.from)}static{this.Range=new n("range","A range in a text document",S=>T.$pK.isRange(S),d.Range.from)}static{this.Selection=new n("selection","A selection in a text document",S=>T.$qK.isSelection(S),d.Selection.from)}static{this.Number=new n("number","",S=>typeof S=="number",S=>S)}static{this.String=new n("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=n.Arr(n.String)}static Arr(S){return new n(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,$=>Array.isArray($)&&$.every(g=>S.validate(g)),$=>$.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new n("item","A call hierarchy item",S=>S instanceof T.$JK,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new n("item","A type hierarchy item",S=>S instanceof T.$4L,d.TypeHierarchyItem.from)}static{this.TestItem=new n("testItem","A VS Code TestItem",S=>S instanceof h.$zM,d.TestItem.from)}constructor(S,$,g,w){this.name=S,this.description=$,this.validate=g,this.convert=w}optional(){return new n(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,$){return new n(S??this.name,$??this.description,this.validate,this.convert)}}e.$KM=n;class r{static{this.Void=new r("no result",S=>S)}constructor(S,$){this.description=S,this.convert=$}}e.$LM=r;class u{constructor(S,$,g,w,D){this.id=S,this.internalId=$,this.description=g,this.args=w,this.result=D}}e.$MM=u}),define(De[304],Ce([1,0,19,18,2,83,129,42,134,34,13,7]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;const v=[new b.$MM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of DocumentHighlight-instances.",k(L.DocumentHighlight.to))),new b.$MM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$KM.Uri],new b.$LM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,s)=>{if((0,C.$Kb)(h))return;class a extends P.$EK{static to(f){const l=new a(f.name,L.SymbolKind.to(f.kind),f.containerName||"",new P.$zK(s[0],L.Range.to(f.range)));return l.detail=f.detail,l.range=l.location.range,l.selectionRange=L.Range.to(f.selectionRange),l.children=f.children?f.children.map(a.to):[],l}}return h.map(a.to)})),new b.$MM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$KM.Uri,new b.$KM("options","Formatting options",h=>!0,h=>h)],new b.$LM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new b.$MM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$KM.Uri,b.$KM.Range,new b.$KM("options","Formatting options",h=>!0,h=>h)],new b.$LM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new b.$MM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$KM.Uri,b.$KM.Position,new b.$KM("ch","Trigger character",h=>typeof h=="string",h=>h),new b.$KM("options","Formatting options",h=>!0,h=>h)],new b.$LM("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new b.$MM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$MM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$MM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$MM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$MM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of Location-instances.",k(L.location.to))),new b.$MM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of Hover-instances.",k(L.Hover.to))),new b.$MM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$KM.Uri,new b.$KM("position","A position in a text document",h=>Array.isArray(h)&&h.every(s=>P.$oK.isPosition(s)),h=>h.map(L.Position.from))],new b.$LM("A promise that resolves to an array of ranges.",h=>h.map(s=>{let a;for(const o of s.reverse())a=new P.$IK(L.Range.to(o),a);return a}))),new b.$MM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$KM.String.with("query","Search string")],new b.$LM("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(L.WorkspaceSymbol.to))),new b.$MM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(L.CallHierarchyItem.to))),new b.$MM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$KM.CallHierarchyItem],new b.$LM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(L.CallHierarchyIncomingCall.to))),new b.$MM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$KM.CallHierarchyItem],new b.$LM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(L.CallHierarchyOutgoingCall.to))),new b.$MM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:L.Range.to(h.range),placeholder:h.text}})),new b.$MM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$KM.Uri,b.$KM.Position,b.$KM.String.with("newName","The new symbol name")],new b.$LM("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return L.WorkspaceEdit.to(h)}})),new b.$MM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$KM.Uri,b.$KM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$LM("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(L.DocumentLink.to))),new b.$MM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$KM.Uri],new b.$LM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new P.$CL(h.tokenTypes,h.tokenModifiers)})),new b.$MM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$KM.Uri],new b.$LM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const s=(0,A.$30)(h);if(s.type==="full")return new P.$EL(s.data,void 0)})),new b.$MM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$KM.Uri,b.$KM.Range.optional()],new b.$LM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new P.$CL(h.tokenTypes,h.tokenModifiers)})),new b.$MM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$KM.Uri,b.$KM.Range],new b.$LM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const s=(0,A.$30)(h);if(s.type==="full")return new P.$EL(s.data,void 0)})),new b.$MM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$KM.Uri,b.$KM.Position,b.$KM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$KM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$LM("A promise that resolves to a CompletionList-instance.",(h,s,a)=>{if(!h)return new P.$UK([]);const o=h.suggestions.map(f=>L.CompletionItem.to(f,a));return new P.$UK(o,h.incomplete)})),new b.$MM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$KM.Uri,b.$KM.Position,b.$KM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$LM("A promise that resolves to SignatureHelp.",h=>{if(h)return L.SignatureHelp.to(h)})),new b.$MM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$KM.Uri,b.$KM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$LM("A promise that resolves to an array of CodeLens-instances.",(h,s,a)=>k(o=>new P.$MK(L.Range.to(o.range),o.command&&a.fromInternal(o.command)))(h))),new b.$MM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$KM.Uri,new b.$KM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>P.$pK.isRange(h),h=>P.$qK.isSelection(h)?L.Selection.from(h):L.Range.from(h)),b.$KM.String.with("kind","Code action kind to return code actions for").optional(),b.$KM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$LM("A promise that resolves to an array of Command-instances.",(h,s,a)=>k(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(o.command)}else{const f=new P.$GK(o.title,o.kind?new P.$HK(o.kind):void 0);return o.edit&&(f.edit=L.WorkspaceEdit.to(o.edit)),o.command&&(f.command=a.fromInternal(o.command)),f.isPreferred=o.isPreferred,f}})(h))),new b.$MM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$KM.Uri],new b.$LM("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(s=>new P.$1K(L.Range.to(s.range),L.Color.to(s.color))):[])),new b.$MM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$KM("color","The color to show and insert",h=>h instanceof P.$ZK,L.Color.from),new b.$KM("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:L.Range.from(h.range)}))],new b.$LM("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(L.ColorPresentation.to):[])),new b.$MM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$KM.Uri,b.$KM.Range],new b.$LM("A promise that resolves to an array of Inlay objects",(h,s,a)=>h.map(L.InlayHint.to.bind(void 0,a)))),new b.$MM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$KM.Uri],new b.$LM("A promise that resolves to an array of FoldingRange objects",(h,s)=>{if(h)return h.map(L.FoldingRange.to)})),new b.$MM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$LM("A promise that resolves to an array of NotebookContentProvider static info objects.",k(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(s=>L.NotebookExclusiveDocumentPattern.to(s))})))),new b.$MM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$KM.Uri,b.$KM.Range,new b.$KM("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof P.$pK,h=>L.InlineValueContext.from(h))],new b.$LM("A promise that resolves to an array of InlineValue objects",h=>h.map(L.InlineValue.to))),new b.$MM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$KM("uriOrString","Uri-instance or string (only http/https)",h=>d.URI.isUri(h)||typeof h=="string"&&(0,E.$lU)(h,T.Schemas.http,T.Schemas.https),h=>h),new b.$KM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[L.ViewColumn.from(h),void 0]:[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)])).optional(),b.$KM.String.with("label","").optional()],b.$LM.Void),new b.$MM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$KM.Uri.with("resource","Resource to open"),b.$KM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$KM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[L.ViewColumn.from(h),void 0]:[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)])).optional()],b.$LM.Void),new b.$MM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$KM.Uri.with("left","Left-hand side resource of the diff editor"),b.$KM.Uri.with("right","Right-hand side resource of the diff editor"),b.$KM.String.with("title","Human readable title for the diff editor").optional(),new b.$KM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[L.ViewColumn.from(h.viewColumn),L.TextEditorOpenOptions.from(h)]).optional()],b.$LM.Void),new b.$MM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$KM.Uri,b.$KM.Position],new b.$LM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new b.$MM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$KM.TypeHierarchyItem],new b.$LM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new b.$MM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$KM.TypeHierarchyItem],new b.$LM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(L.TypeHierarchyItem.to))),new b.$MM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$KM.TestItem],b.$LM.Void),new b.$MM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$KM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$LM.Void),new b.$MM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$KM.String.with("name","The context key name"),new b.$KM("value","The context key value",()=>!0,h=>h)],b.$LM.Void),new b.$MM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$KM.Uri,b.$KM.StringArray,new b.$KM("MappedEditsContext","Mapped Edits Context",h=>L.MappedEditsContext.is(h),h=>L.MappedEditsContext.from(h))],new b.$LM("A promise that resolves to a workspace edit or null",h=>h?L.WorkspaceEdit.to(h):null))];class y{static register(s){v.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",m.$Oi)}}e.$scc=y;function k(h){return s=>{if(Array.isArray(s))return s.map(h)}}function p(h){if(!Array.isArray(h))return;const s=[];for(const a of h)R.$et(a)?s.push(L.DefinitionLink.to(a)):s.push(L.location.to(a));return s}}),define(De[305],Ce([1,0,8,57,4,3,2,83,25,13,7,6,26]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;function y(k,p,h){const s=k.getProxy(P.$lK.MainThreadComments);class a{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$8l,p.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const I=this.b.get(u.handle);return I?I.value:u}else if(u&&u.$mid===7){const I=this.b.get(u.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.commentThreadHandle);return S?S.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const I=this.b.get(u.thread.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.thread.commentThreadHandle);return S?u.$mid===8?S.value:{thread:S.value,text:u.text}:u}else if(u&&u.$mid===10){const I=this.b.get(u.thread.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const $=u.commentUniqueId,g=S.getCommentByUniqueId($);return g||u}else if(u&&u.$mid===11){const I=this.b.get(u.thread.commentControlHandle);if(!I)return u;const S=I.getCommentThread(u.thread.commentThreadHandle);if(!S)return u;const $=u.text,g=u.commentUniqueId,w=S.getCommentByUniqueId(g);return w?(typeof w.body=="string"?w.body=$:w.body=new L.$NK($),w):u}return u}})}createCommentController(u,I,S){const $=a.a++,g=new f(u,$,I,S);this.b.set(g.handle,g);const w=this.c.get(u.identifier)||[];return w.push(g),this.c.set(u.identifier,w),g.value}async $createCommentThreadTemplate(u,I,S){const $=this.b.get(u);$&&$.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(u,I,S){const $=this.b.get(u);$&&$.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(u,I){this.b.get(u)?.$deleteCommentThread(I)}$provideCommentingRanges(u,I,S){const $=this.b.get(u);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const g=h.getDocument(A.URI.revive(I));return(0,C.$Mg)(async()=>{const w=await $.commentingRangeProvider.provideCommentingRanges(g,S);let D;return Array.isArray(w)?D={ranges:w,fileComments:!1}:w?D={ranges:w.ranges||[],fileComments:w.fileComments||!1}:D=w??void 0,D}).then(w=>{let D;return w&&(D={ranges:w.ranges.map(N=>b.Range.from(N)),fileComments:w.fileComments}),D})}$toggleReaction(u,I,S,$,g){const w=this.b.get(u);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,C.$Mg)(()=>{const D=w.getCommentThread(I);if(D){const N=D.getCommentByUniqueId($.uniqueIdInThread);if(w!==void 0&&N&&w.reactionHandler)return w.reactionHandler(N,i(g))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,I,S,$,g,w,D,N){this.m=I,this.n=S,this.o=$,this.p=g,this.q=w,this.extensionDescription=D,this.r=N,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new d.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Tc,this.l.value=new R.$Rc,this.n===void 0&&(this.n=`${u}.${this.handle}`),s.$createCommentThread(I,this.handle,this.n,this.o,b.Range.from(this.p),D.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{s.$deleteCommentThread(I,this.handle)}});const M=this;this.value={get uri(){return M.uri},get range(){return M.range},set range(F){M.range=F},get comments(){return M.comments},set comments(F){M.comments=F},get collapsibleState(){return M.collapsibleState},set collapsibleState(F){M.collapsibleState=F},get canReply(){return M.canReply},set canReply(F){M.canReply=F},get contextValue(){return M.contextValue},set contextValue(F){M.contextValue=F},get label(){return M.label},set label(F){M.label=F},get state(){return M.state},set state(F){M.state=F},dispose:()=>{M.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Rc);const u=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};u("range")&&(I.range=b.Range.from(this.p)),u("label")&&(I.label=this.label),u("contextValue")&&(I.contextValue=this.contextValue??null),u("comments")&&(I.comments=this.q.map(S=>l(this,S,this.k,this.extensionDescription))),u("collapsibleState")&&(I.collapseState=c(this.g)),u("canReply")&&(I.canReply=this.canReply),u("state")&&(I.state=n(this.h)),u("isTemplate")&&(I.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(u){for(const I of this.k){const S=I[0],$=I[1];if(u===$)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}He([(0,T.$ih)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class f{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,I,S,$){this.f=u,this.g=I,this.h=S,this.i=$,this.a=new Map,s.$registerCommentController(this.handle,S,$,this.f.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(w){g.options=w},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(w){g.commentingRangeProvider=w},get reactionHandler(){return g.reactionHandler},set reactionHandler(w){g.reactionHandler=w},createCommentThread(w,D,N){return g.createCommentThread(w,D,N).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(u,I,S){I===void 0&&(0,v.$hF)(this.f,"fileComments");const $=new o(this.id,this.handle,void 0,u,I,S,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(u,I){const S=new o(this.id,this.handle,void 0,A.URI.revive(u),b.Range.to(I),[],this.f,!0);return S.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(u,I){const S=this.a.get(u);S&&(S.range=b.Range.to(I))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function l(r,u,I,S){let $=I.get(u);return $||($=++r.commentHandle,I.set(u,$)),u.state!==void 0&&(0,v.$hF)(S,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:$,body:typeof u.body=="string"?u.body:b.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(g=>t(g)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function t(r){return{label:r.label,iconPath:r.iconPath?b.$lM(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function c(r){if(r!==void 0)switch(r){case L.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function n(r){if(r!==void 0)switch(r){case L.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new a}e.$ucc=y}),define(De[306],Ce([1,0,24,6,27,20]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;let A=class{constructor(L,P){this.a=L.getProxy(T.$lK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const v=this,y=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,P,y,arguments)}})}e(L,P,v,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:E(y,this.b)}),this.c&&this.f(L,v,y)}};e.$sec=A,e.$sec=A=He([Be(0,R.$mM),Be(1,d.$CM)],A);const m=1e5;function E(b,L){const P=[];if(b.length)for(let v=0;v<b.length;v++){let y=b[v];if(typeof y>"u")y="undefined";else if(y instanceof Error){const k=y;k.stack?y=k.stack:y=k.toString()}P.push(y)}if(L){const v=new Error().stack;v&&P.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,C.$_m)(P);return v.length>m?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,14,19,15,16,26]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0;let y=class{static{v=this}static{this.c=0}static{this.d=250}constructor(p,h){this.h=h,this.f=new Map,this.g=p.getProxy(T.$lK.MainThreadDecorations)}registerFileDecorationProvider(p,h){const s=v.c++;this.f.set(s,{provider:p,extensionDescription:h}),this.g.$registerDecorationProvider(s,h.identifier.value);const a=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(s,null);return}const f=(0,E.$3b)(o);if(f.length<=v.d){this.g.$onDidChange(s,f);return}this.h.warn("[Decorations] CAPPING events from decorations provider",h.identifier.value,f.length);const l=f.map(c=>({uri:c,rank:(0,b.$Ge)(c.path,"/")})),t=(0,E.$zb)(l,(c,n)=>c.rank-n.rank||(0,b.$Ue)(c.uri.path,n.uri.path)),i=[];e:for(const c of t){let n;for(const r of c){const u=(0,L.$mc)(r.uri.path);if(n!==u&&(n=u,i.push(r.uri)>=v.d))break e}}this.g.$onDidChange(s,i)});return new d.$nK(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(p,h,s){if(!this.f.has(p))return Object.create(null);const a=Object.create(null),{provider:o,extensionDescription:f}=this.f.get(p);return await Promise.all(h.map(async l=>{try{const{uri:t,id:i}=l,c=await Promise.resolve(o.provideFileDecoration(C.URI.revive(t),s));if(!c)return;try{d.$IL.validate(c),c.badge&&typeof c.badge!="string"&&(0,P.$hF)(f,"codiconDecoration"),a[i]=[c.propagate,c.tooltip,c.badge,c.color]}catch(n){this.h.warn(`INVALID decoration from extension '${f.identifier.value}': ${n}`)}}catch(t){this.h.error(t)}})),a}};e.$vdc=y,e.$vdc=y=v=He([Be(0,A.$mM),Be(1,m.$0i)],y),e.$wdc=(0,R.$Ph)("IExtHostDecorations")}),define(De[307],Ce([1,0,204,133,2,6,7,13,4,14,28,55]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class y{#e;#t;#i;constructor(h,s,a,o,f,l,t,i){this.d=h,this.e=s,this.f=a,this.g=o,this.h=f,this.c=!1,this.f=Math.max(o,a),this.#i=new L.$Ac(c=>l.getComparisonKey(c)),this.#e=t,this.#t=i}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(h,s){if(!h){this.clear();return}this.j();let a=[];if(d.URI.isUri(h)){if(!s){this.delete(h);return}this.#i.set(h,s.slice()),a=[h]}else if(Array.isArray(h)){a=[];let l;h=[...h].sort(y.k);for(const t of h){const[i,c]=t;if((!l||i.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=i,a.push(i),this.#i.set(i,[])),c)this.#i.get(i)?.push(...c);else{const n=this.#i.get(i);n&&(n.length=0)}}}if(this.#t.fire(a),!this.#e)return;const o=[];let f=0;for(const l of a){let t=[];const i=this.#i.get(l);if(i)if(i.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const r of i)if(r.severity===c[n]&&t.push({...m.Diagnostic.from(r),modelVersionId:this.h(l)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,C.localize)(0,null,i.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=i.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(l)}));if(o.push([l,t]),f+=t.length,f>this.f)break}this.#e.$changeMany(this.e,o)}delete(h){this.j(),this.#t.fire([h]),this.#i.delete(h),this.#e?.$changeMany(this.e,[[h,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(h,s){this.j();for(const[a,o]of this)h.call(s,a,o,this)}*[Symbol.iterator](){this.j();for(const h of this.#i.keys())yield[h,this.get(h)]}get(h){this.j();const s=this.#i.get(h);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(h){return this.j(),Array.isArray(this.#i.get(h))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(h,s){return h[0].toString()<s[0].toString()?-1:h[0].toString()>s[0].toString()?1:0}}e.$mcc=y;let k=class{static{v=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*v.d}static _mapper(h){const s=new L.$Ac;for(const a of h)s.set(a,a);return{uris:Object.freeze(Array.from(s.values()))}}constructor(h,s,a,o){this.j=s,this.k=a,this.l=o,this.g=new Map,this.h=new E.$Rd({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,v._mapper),this.f=h.getProxy(R.$lK.MainThreadDiagnostics)}createDiagnosticCollection(h,s){const{g:a,f:o,h:f,j:l,k:t,l:i}=this,c=new class{$changeMany(u,I){o.$changeMany(u,I),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,u,I.length===0?"CLEARING":I)}$clear(u){o.$clear(u),l.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,u)}dispose(){o.dispose()}};let n;if(!s)s="_generated_diagnostic_collection_name_#"+v.c++,n=s;else if(!a.has(s))n=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do n=s+v.c++;while(a.has(n))}return new class extends y{constructor(){super(s,n,v.e,v.d,u=>i.getDocument(u)?.version,t.extUri,c,f),a.set(n,this)}dispose(){super.dispose(),a.delete(n)}}}getDiagnostics(h){if(h)return this.m(h);{const s=new Map,a=[];for(const o of this.g.values())o.forEach((f,l)=>{let t=s.get(f.toString());typeof t>"u"&&(t=a.length,s.set(f.toString(),t),a.push([f,[]])),a[t][1]=a[t][1].concat(...l)});return a}}m(h){let s=[];for(const a of this.g.values())a.has(h)&&(s=s.concat(a.get(h)));return s}$acceptMarkersChange(h){if(!this.n){const s="_generated_mirror",a=new y(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(s,a),this.n=a}for(const[s,a]of h)this.n.set(d.URI.revive(s),a.map(m.Diagnostic.to))}};e.$ncc=k,e.$ncc=k=v=He([Be(1,b.$0i),Be(2,P.$lcc)],k)}),define(De[308],Ce([1,0,2,6,26]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class R{constructor(m){this.a=m.getProxy(T.$lK.MainThreadDialogs)}showOpenDialog(m,E){return E?.allowUIResources&&(0,d.$hF)(m,"showLocal"),this.a.$showOpenDialog(E).then(b=>b?b.map(L=>C.URI.revive(L)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(E=>E?C.URI.revive(E):void 0)}}e.$Ccc=R}),define(De[309],Ce([1,0,9,2,7,6,18,21,15]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class b{static{this.a=0}constructor(P,v,y){this.d=v,this.e=y,this.b=new Map,this.c=P.getProxy(R.$lK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,v){if(Object.keys(A.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=b.a++;this.b.set(y,v),this.c.$registerTextContentProvider(y,P);let k;return typeof v.onDidChange=="function"&&(k=v.onDidChange(p=>{if(p.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(y,p).then(h=>{if(!h&&typeof h!="string")return;const s=this.d.getDocument(p);if(!s)return;const a=(0,E.$Pe)(h);if(!s.equalLines(a))return this.c.$onVirtualDocumentChange(p,h)},C.$1)})),new d.$nK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(P,v){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(T.URI.revive(v),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.$Dcc=b}),define(De[310],Ce([1,0,4,3,2,6,141,13,17,24,7,9]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class v{constructor(k,p){this.a=new C.$Nd({onListenerError:P.$2}),this.b=new C.$Nd({onListenerError:P.$2}),this.c=new C.$Nd({onListenerError:P.$2}),this.d=new C.$Nd({onListenerError:P.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=k.getProxy(R.$lK.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(h=>{for(const s of h)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const s of h)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const p=this.g.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this.g.getDocument(k);if(p)return Promise.resolve(p);let h=this.h.get(k.toString());return h||(h=this.f.$tryOpenDocument(k).then(s=>{this.h.delete(k.toString());const a=d.URI.revive(s);return(0,E.$Jf)(this.g.getDocument(a))},s=>(this.h.delete(k.toString()),Promise.reject(s))),this.h.set(k.toString(),h)),h}createDocumentData(k){return this.f.$tryCreateDocument(k).then(p=>d.URI.revive(p))}$acceptModelLanguageChanged(k,p){const h=d.URI.revive(k),s=this.g.getDocument(h);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(p),this.a.fire(s.document)}$acceptModelSaved(k){const p=d.URI.revive(k),h=this.g.getDocument(p);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(k,p){const h=d.URI.revive(k),s=this.g.getDocument(h);if(!s)throw new Error("unknown document");s._acceptIsDirty(p),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,h){const s=d.URI.revive(k),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),a.onEvents(p);let o;p.isUndoing?o=L.TextDocumentChangeReason.Undo:p.isRedoing&&(o=L.TextDocumentChangeReason.Redo),this.c.fire((0,b.$8m)({document:a.document,contentChanges:p.changes.map(f=>({range:m.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:o}))}setWordDefinitionFor(k,p){(0,A.$oM)(k,p)}}e.$jcc=v}),define(De[70],Ce([1,0,58,4,3,2,5,6,141,20,148,13,14,28,18,51,47]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;class s{constructor(f){this.value=f,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(f,l){this.h=f,this.i=l,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new T.$Nd,this.e=new T.$Nd,this.f=new T.$Nd,this.g=new T.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const l=[],t=[],i=[];if(f.removedDocuments)for(const c of f.removedDocuments){const n=R.URI.revive(c),r=this.c.get(n);r?.unref()&&(this.c.delete(n),l.push(r.value))}if(f.addedDocuments)for(const c of f.addedDocuments){const n=R.URI.revive(c.uri);let r=this.c.get(n);if(r&&n.scheme!==k.Schemas.vscodeNotebookCell&&n.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);r||(r=new s(new E.$pM(this.h.getProxy(m.$lK.MainThreadDocuments),n,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(n,r),t.push(r.value)),r.ref()}if(f.removedEditors)for(const c of f.removedEditors){const n=this.b.get(c);this.b.delete(c),n&&i.push(n)}if(f.addedEditors)for(const c of f.addedEditors){const n=R.URI.revive(c.documentUri);C.ok(this.c.has(n),`document '${n}' does not exist`),C.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const r=this.c.get(n).value,u=new L.$vM(c.id,this.h.getProxy(m.$lK.MainThreadTextEditors),this.i,new h.$V(()=>r.document),c.selections.map(P.Selection.to),c.options,c.visibleRanges.map(I=>P.Range.to(I)),typeof c.editorPosition=="number"?P.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,u)}f.newActiveEditor!==void 0&&(C.ok(f.newActiveEditor===null||this.b.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this.a=f.newActiveEditor),(0,d.$Nc)(l),(0,d.$Nc)(i),f.removedDocuments&&this.e.fire(l),f.addedDocuments&&this.d.fire(t),(f.removedEditors||f.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),f.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(f){return this.c.get(f)?.value}allDocuments(){return p.Iterable.map(this.c.values(),f=>f.value)}getEditor(f){return this.b.get(f)}activeEditor(f){if(!this.a)return;const l=this.b.get(this.a);return f?l:l?.value}allEditors(){return[...this.b.values()]}};e.$wM=a,e.$wM=a=He([Be(0,b.$mM),Be(1,v.$0i)],a),e.$xM=(0,A.$Ph)("IExtHostDocumentsAndEditors")}),define(De[71],Ce([1,0,13,6,2,4,5,7,20,17,74]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0,e.$Adc=(0,A.$Ph)("IExtHostEditorTabs");class P{constructor(h,s,a){this.e=a,this.d=s,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,s={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$5L(d.URI.revive(this.b.input.uri));case 2:return new m.$6L(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified));case 3:return new m.$7L(d.URI.revive(this.b.input.base),d.URI.revive(this.b.input.input1),d.URI.revive(this.b.input.input2),d.URI.revive(this.b.input.result));case 6:return new m.$8L(d.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$9L(this.b.input.viewType);case 4:return new m.$0L(d.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$$L(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$_L;case 9:return new m.$aM(d.URI.revive(this.b.input.uri),d.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(h,s){this.c=[],this.d="",this.b=h,this.e=s;for(const a of h.tabs)a.isActive&&(this.d=a.id),this.c.push(new P(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,s={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return C.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(a=>a.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(a=>a.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const a=new P(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,a),h.tabDto.isActive&&(this.d=a.tabId),a}else if(h.kind===1){const a=this.c.splice(h.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(h.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,a),a}const s=this.c.find(a=>a.tabId===h.tabDto.id);if(!s)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(h.tabDto),s}activeTabId(){return this.d}}let y=class{constructor(h){this.b=new R.$Nd,this.c=new R.$Nd,this.e=[],this.a=h.getProxy(T.$lK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,s={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(a=>a.apiObject))},get activeTabGroup(){const a=h.d;return(0,b.$Jf)(h.e.find(f=>f.groupId===a)?.apiObject)},close:async(a,o)=>{const f=Array.isArray(a)?a:[a];return f.length?k(f[0])?this.j(f,o):this.i(f,o):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(h){const s=new Set(this.e.map(c=>c.groupId)),a=new Set(h.map(c=>c.groupId)),o=(0,L.$K)(s,a),f=this.e.filter(c=>o.removed.includes(c.groupId)).map(c=>c.apiObject),l=[],t=[];this.e=h.map(c=>{const n=new v(c,()=>this.d);return o.added.includes(n.groupId)?l.push(n.apiObject):t.push(n.apiObject),n});const i=(0,b.$Jf)(h.find(c=>c.isActive===!0)?.groupId);i!==void 0&&this.d!==i&&(this.d=i),this.c.fire(Object.freeze({opened:l,closed:f,changed:t}))}$acceptTabGroupUpdate(h){const s=this.e.find(a=>a.groupId===h.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const s=this.e.find(o=>o.groupId===h.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const a=s.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(h){for(const s of this.e)for(const a of s.tabs)if(a.apiObject===h)return a}h(h){return this.e.find(s=>s.apiObject===h)}async i(h,s){const a=[];for(const o of h){const f=this.g(o);if(!f)throw new Error("Tab close: Invalid tab not found!");a.push(f.tabId)}return this.a.$closeTab(a,s)}async j(h,s){const a=[];for(const o of h){const f=this.h(o);if(!f)throw new Error("Group close: Invalid group not found!");a.push(f.groupId)}return this.a.$closeGroup(a,s)}};e.$Bdc=y,e.$Bdc=y=He([Be(0,E.$mM)],y);function k(p){return p.tabs!==void 0}}),define(De[311],Ce([1,0,6,7]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$lK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const b=this.a.get(A);if(!b)throw new Error("Embedding vector provider not found");const L=await b.provideEmbeddingVector(m,E);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(A,m,E){const b=this.b;return this.b++,this.a.set(b,E),this.c.$registerAiEmbeddingVectorProvider(m,b),new T.$nK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(b),this.a.delete(b)})}}e.$nec=d}),define(De[312],Ce([1,0,2,6,3,7,13,169,15,22,26,80]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class v{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const h=this.a.indexOf(p);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),h=[];let s,a,o=14,f=14;for(const l of p){let t=s?(0,E.$4e)(s,l):0;for(t===0?a=1:a=f;t<l.length;t++)t+1===l.length?(o=f,f=9):f+=1,h.push([a,l.toUpperCase().charCodeAt(t),f]),h.push([a,l.toLowerCase().charCodeAt(t),f]),a=f;s=l,f=o}h.push([9,58,10]),h.push([10,47,12]),this.b=new m.$6Y(h)}}provideDocumentLinks(p){this.c();const h=[],s=m.$7Y.computeLinks({getLineContent(a){return p.lineAt(a-1).text},getLineCount(){return p.lineCount}},this.b);for(const a of s){const o=A.DocumentLink.to(a);o.target&&h.push(o)}return h}}class y{constructor(p,h){this.i=h,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(T.$lK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,h,s,a={}){if(y.j(s),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const o=this.h++;this.b.add(h),this.d.add(h),this.c.set(o,s);let f=2;a.isCaseSensitive&&(f+=1024),a.isReadonly&&(f+=2048),typeof s.copy=="function"&&(f+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,L.$hF)(p,"fsChunks"),f+=4);let l;a.isReadonly&&(0,P.$5j)(a.isReadonly)&&((0,L.$hF)(p,"readonlyMessage"),l={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(o,h,f,l).catch(i=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${h}`),console.error(i)});const t=s.onDidChangeFile(i=>{const c=[];for(const n of i){const{uri:r,type:u}=n;if(r.scheme!==h)continue;let I;switch(u){case R.FileChangeType.Changed:I=0;break;case R.FileChangeType.Created:I=1;break;case R.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:r,type:I})}this.a.$onFileSystemChange(o,c)});return(0,d.$Qc)(()=>{t.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:h,ctime:s,mtime:a,size:o,permissions:f}=p;return{type:h,ctime:s,mtime:a,size:o,permissions:f}}$stat(p,h){return Promise.resolve(this.l(p).stat(C.URI.revive(h))).then(s=>y.k(s))}$readdir(p,h){return Promise.resolve(this.l(p).readDirectory(C.URI.revive(h)))}$readFile(p,h){return Promise.resolve(this.l(p).readFile(C.URI.revive(h))).then(s=>b.$be.wrap(s))}$writeFile(p,h,s,a){return Promise.resolve(this.l(p).writeFile(C.URI.revive(h),s.buffer,a))}$delete(p,h,s){return Promise.resolve(this.l(p).delete(C.URI.revive(h),s))}$rename(p,h,s,a){return Promise.resolve(this.l(p).rename(C.URI.revive(h),C.URI.revive(s),a))}$copy(p,h,s,a){const o=this.l(p);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(C.URI.revive(h),C.URI.revive(s),a))}$mkdir(p,h){return Promise.resolve(this.l(p).createDirectory(C.URI.revive(h)))}$watch(p,h,s,a){const o=this.l(p).watch(C.URI.revive(s),a);this.f.set(h,o)}$unwatch(p,h){const s=this.f.get(h);s&&(s.dispose(),this.f.delete(h))}$open(p,h,s){const a=this.l(p);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(C.URI.revive(h),s))}$close(p,h){const s=this.l(p);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(h))}$read(p,h,s,a){const o=this.l(p);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const f=b.$be.alloc(a);return Promise.resolve(o.read(h,s,f.buffer,0,a)).then(l=>f.slice(0,l))}$write(p,h,s,a){const o=this.l(p);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(h,s,a.buffer,0,a.byteLength))}l(p){const h=this.c.get(p);if(!h){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return h}}e.$0cc=y}),define(De[72],Ce([1,0,6,30,7,22,5,20,55,3,8,23,18]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0;let k=y=class{constructor(h,s){this.b=new Map,this.c=new L.$3g,this.a=h.getProxy(C.$lK.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(o){try{let f;const l=a.b.get(o.scheme);return l?(await a.a.$ensureActivation(o.scheme),f=await l.impl.stat(o)):f=await a.a.$stat(o),{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===T.FilePermission.Readonly?1:void 0}}catch(f){y.e(f)}},async readDirectory(o){try{const f=a.b.get(o.scheme);return f?(await a.a.$ensureActivation(o.scheme),(await f.impl.readDirectory(o)).slice()):await a.a.$readdir(o)}catch(f){return y.e(f)}},async createDirectory(o){try{const f=a.b.get(o.scheme);return f&&!f.isReadonly?(await a.a.$ensureActivation(o.scheme),await a.d(f.impl,f.extUri,o)):await a.a.$mkdir(o)}catch(f){return y.e(f)}},async readFile(o){try{const f=a.b.get(o.scheme);return f?(await a.a.$ensureActivation(o.scheme),(await f.impl.readFile(o)).slice()):(await a.a.$readFile(o)).buffer}catch(f){return y.e(f)}},async writeFile(o,f){try{const l=a.b.get(o.scheme);return l&&!l.isReadonly?(await a.a.$ensureActivation(o.scheme),await a.d(l.impl,l.extUri,l.extUri.dirname(o)),await a.c.queueFor(o).queue(()=>Promise.resolve(l.impl.writeFile(o,f,{create:!0,overwrite:!0})))):await a.a.$writeFile(o,R.$be.wrap(f))}catch(l){return y.e(l)}},async delete(o,f){try{const l=a.b.get(o.scheme);return l&&!l.isReadonly?(await a.a.$ensureActivation(o.scheme),await l.impl.delete(o,{recursive:!1,...f})):await a.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...f})}catch(l){return y.e(l)}},async rename(o,f,l){try{return await a.a.$rename(o,f,{overwrite:!1,...l})}catch(t){return y.e(t)}},async copy(o,f,l){try{return await a.a.$copy(o,f,{overwrite:!1,...l})}catch(t){return y.e(t)}},isWritableFileSystem(o){const f=s.getCapabilities(o);if(typeof f=="number")return!(f&2048)}})}async d(h,s,a){const o=[];for(;!s.isEqual(a,s.dirname(a));)try{if(!((await h.stat(a)).type&T.FileType.Directory))throw d.$AL.FileExists(`Unable to create folder '${a.scheme===v.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(f){if(T.$ok(f)!==T.FileSystemProviderErrorCode.FileNotFound)throw f;o.push(s.basename(a)),a=s.dirname(a)}for(let f=o.length-1;f>=0;f--){a=s.joinPath(a,o[f]);try{await h.createDirectory(a)}catch(l){if(T.$ok(l)!==T.FileSystemProviderErrorCode.FileExists)throw l}}}static e(h){if(h instanceof d.$AL)throw h;if(h instanceof T.$kk)switch(h.code){case T.FileSystemProviderErrorCode.FileExists:throw d.$AL.FileExists(h.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.$AL.FileNotFound(h.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.$AL.FileNotADirectory(h.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.$AL.FileIsADirectory(h.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.$AL.NoPermissions(h.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.$AL.Unavailable(h.message);default:throw new d.$AL(h.message,h.name)}if(!(h instanceof Error))throw new d.$AL(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw d.$AL.Unavailable(h.message);switch(h.name){case T.FileSystemProviderErrorCode.FileExists:throw d.$AL.FileExists(h.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.$AL.FileNotFound(h.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.$AL.FileNotADirectory(h.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.$AL.FileIsADirectory(h.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.$AL.NoPermissions(h.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.$AL.Unavailable(h.message);default:throw new d.$AL(h.message,h.name)}}addFileSystemProvider(h,s,a){return this.b.set(h,{impl:s,extUri:a?.isCaseSensitive?P.$lg:P.$ng,isReadonly:!!a?.isReadonly}),(0,b.$Qc)(()=>this.b.delete(h))}getFileSystemProviderExtUri(h){return this.b.get(h)?.extUri??P.$lg}};e.$Pcc=k,e.$Pcc=k=y=He([Be(0,m.$mM),Be(1,E.$lcc)],k),e.$Qcc=(0,A.$Ph)("IExtHostConsumerFileSystem")}),define(De[313],Ce([1,0,4,36,2,6,13,7,47]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class b{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,k,p,h,s,a){this.a=Math.random(),this.b=new C.$Nd,this.c=new C.$Nd,this.d=new C.$Nd,this.h=0,a?.ignoreCreateEvents&&(this.h+=1),a?.ignoreChangeEvents&&(this.h+=2),a?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$wj)(s),f=typeof s=="string",l=h(t=>{if(!(typeof t.session=="number"&&t.session!==this.a)){if(!a?.ignoreCreateEvents)for(const i of t.created){const c=d.URI.revive(i);o(c.fsPath)&&(!f||k.getWorkspaceFolder(c))&&this.b.fire(c)}if(!a?.ignoreChangeEvents)for(const i of t.changed){const c=d.URI.revive(i);o(c.fsPath)&&(!f||k.getWorkspaceFolder(c))&&this.c.fire(c)}if(!a?.ignoreDeleteEvents)for(const i of t.deleted){const c=d.URI.revive(i);o(c.fsPath)&&(!f||k.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=m.$nK.from(this.i(y,p,s,a),this.b,this.c,this.d,l)}i(y,k,p,h){const s=m.$nK.from();if(typeof p=="string")return s;const a=y.getProxy(R.$lK.MainThreadFileSystemEventService);let o=!1;return(p.pattern.includes(T.$sj)||p.pattern.includes(T.$tj))&&(o=!0),a.$watch(k.identifier.value,this.a,p.baseUri,{recursive:o,excludes:h?.excludes??[]}),m.$nK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$V(()=>this.a.created.map(d.URI.revive)),this.c=new E.$V(()=>this.a.changed.map(d.URI.revive)),this.d=new E.$V(()=>this.a.deleted.map(d.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(y,k,p){this.j=y,this.k=k,this.l=p,this.a=new C.$Nd,this.b=new C.$Nd,this.c=new C.$Nd,this.d=new C.$Nd,this.g=new C.$Pd,this.h=new C.$Pd,this.i=new C.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,k,p,h){return new b(this.j,y,k,this.a.event,A.GlobPattern.from(p),h)}$onFileEvent(y){this.a.fire(new L(y))}$onDidRunFileOperation(y,k){switch(y){case 2:this.b.fire(Object.freeze({files:k.map(p=>({oldUri:d.URI.revive(p.source),newUri:d.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(p=>d.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(p=>d.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,k){return(p,h,s)=>{const a=function(f){p.call(h,f)};return a.extension=y,k.event(a,void 0,s)}}async $onWillRunFileOperation(y,k,p,h){switch(y){case 2:return await this.n(this.g,{files:k.map(s=>({oldUri:d.URI.revive(s.source),newUri:d.URI.revive(s.target)}))},p,h);case 1:return await this.n(this.i,{files:k.map(s=>d.URI.revive(s.target))},p,h);case 0:case 3:return await this.n(this.h,{files:k.map(s=>d.URI.revive(s.target))},p,h)}}async n(y,k,p,h){const s=new Set,a=[];if(await y.fireAsync(k,h,async(f,l)=>{const t=Date.now(),i=await Promise.resolve(f);i instanceof m.$xK&&(a.push([l.extension,i]),s.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-t>p&&this.k.warn("SLOW file-participant",l.extension.identifier)}),h.isCancellationRequested||a.length===0)return;const o={edits:[]};for(const[,f]of a){const{edits:l}=A.WorkspaceEdit.from(f,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(l)}return{edit:o,extensionNames:Array.from(s)}}}e.$$cc=P}),define(De[314],Ce([1,0,3,2,6,13,7,34,8]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;class b{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=b.a++}}class L{constructor(y){this.session=y,this.responses=[]}}class P{static{this.a=0}constructor(y,k,p,h){this.f=p,this.g=h,this.b=new Map,this.d=new Map,this.e=y.getProxy(d.$lK.MainThreadInlineChat),k.registerApiCommand(new m.$MM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$KM("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?R.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?R.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?R.Position.from(s.position):void 0}})],m.$LM.Void))}registerProvider(y,k,p){const h=new b(y,k);return this.b.set(h.handle,h),this.e.$registerInteractiveEditorProvider(h.handle,p.label,y.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(h.handle),this.b.delete(h.handle)})}async $prepareSession(y,k,p,h){const s=this.b.get(y);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const a=this.f.getDocument(T.URI.revive(k)),o=R.Selection.to(p),f=await s.provider.prepareInteractiveEditorSession({document:a,selection:o},h);if(!f)return;if(f.wholeRange&&!f.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=P.a++;return this.d.set(l,new L(f)),{id:l,placeholder:f.placeholder,input:f.input,slashCommands:f.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(f.wholeRange),message:f.message}}async $provideResponse(y,k,p,h){const s=this.b.get(y);if(!s)return;const a=this.d.get(k.id);if(!a)return;const o={prompt:p.prompt,selection:R.Selection.to(p.selection),wholeRange:R.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let f=!1;const l={report:async u=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");f||h.isCancellationRequested||await this.e.$handleProgressChunk(p.requestId,{message:u.message,edits:u.edits?.map(R.TextEdit.from),slashCommand:u.slashCommand?.command,markdownFragment:A.$NK.isMarkdownString(u.content)?u.content.value:u.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(a.session,o,l,h));let i;try{i=await(0,E.$Ig)(t,h)}finally{f=!0}if(!i)return;const c=a.responses.push(i)-1,n={wholeRange:R.Range.from(i.wholeRange),placeholder:i.placeholder};if(P.h(i))return{...n,id:c,type:"message",message:R.MarkdownString.from(i.contents)};const{edits:r}=i;return r instanceof A.$xK?{...n,id:c,type:"bulkEdit",edits:R.WorkspaceEdit.from(r)}:{...n,id:c,type:"editorEdit",edits:r.map(R.TextEdit.from)}}$handleFeedback(y,k,p,h){const s=this.b.get(y),a=this.d.get(k),o=a?.responses[p];if(s&&o){const f=R.InteractiveEditorResponseFeedbackKind.to(h);s.provider.handleInteractiveEditorResponseFeedback?.(a.session,o,f)}}$releaseSession(y,k){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$fec=P}),define(De[315],Ce([1,0,2,34]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class d{constructor(A,m,E,b,L){this.a=m,this.b=E,this.c=b;const P=new T.$MM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$KM("showOptions","Show Options",v=>!0,v=>v),new T.$KM("resource","Interactive resource Uri",v=>!0,v=>v),new T.$KM("controllerId","Notebook controller Id",v=>!0,v=>v),new T.$KM("title","Interactive editor title",v=>!0,v=>v)],new T.$LM("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const y=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:C.URI.revive(v.notebookUri),inputUri:C.URI.revive(v.inputUri),notebookEditor:y.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:C.URI.revive(v.notebookUri),inputUri:C.URI.revive(v.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(A,m,E,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$bec=d}),define(De[316],Ce([1,0,6,7]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class d{constructor(A){this.a=new Map,this.b=A.getProxy(C.$lK.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const b=await E.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}registerIssueUriRequestHandler(A,m){const E=A.identifier.value;return this.a.set(E,m),this.b.$registerIssueUriRequestHandler(E),new T.$nK(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$hec=d}),define(De[317],Ce([1,0,3,6]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class d{constructor(A){this.b=0,this.a=A.getProxy(T.$lK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,C.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$udc=d}),define(De[318],Ce([1,0,2,24,13,7,83,6,15,32,19,17,165,21,25,3,129,119,107,35,9,8,26,206]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class c{constructor(z,J){this.d=z,this.e=J}async provideDocumentSymbols(z,J){const se=this.d.getDocument(z),oe=await this.e.provideDocumentSymbols(se,J);if(!(0,L.$Kb)(oe))return oe[0]instanceof R.$FK?oe.map(d.DocumentSymbol.from):c.f(oe)}static f(z){z=z.slice(0).sort((oe,Z)=>{let ge=oe.location.range.start.compareTo(Z.location.range.start);return ge===0&&(ge=Z.location.range.end.compareTo(oe.location.range.end)),ge});const J=[],se=[];for(const oe of z){const Z={name:oe.name||"!!MISSING: name!!",kind:d.SymbolKind.from(oe.kind),tags:oe.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:d.Range.from(oe.location.range),selectionRange:d.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(Z),J.push(Z);break}const ge=se[se.length-1];if(b.$ts.containsRange(ge.range,Z.range)&&!b.$ts.equalsRange(ge.range,Z.range)){ge.children?.push(Z),se.push(Z);break}se.pop()}}return J}}class n{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,J,se){this.g=z,this.h=J,this.j=se,this.e=new a.$icc("CodeLens"),this.f=new Map}async provideCodeLenses(z,J){const se=this.g.getDocument(z),oe=await this.j.provideCodeLenses(se,J);if(!oe||J.isCancellationRequested)return;const Z=this.e.add(oe),ge=new p.$Rc;this.f.set(Z,ge);const Ee={cacheId:Z,lenses:[]};for(let je=0;je<oe.length;je++)Ee.lenses.push({cacheId:[Z,je],range:d.Range.from(oe[je].range),command:this.h.toInternal(oe[je].command,ge)});return Ee}async resolveCodeLens(z,J){const se=z.cacheId&&this.e.get(...z.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,J),oe||(oe=se),J.isCancellationRequested)return;const Z=z.cacheId&&this.f.get(z.cacheId[0]);if(Z)return z.command=this.h.toInternal(oe.command??n.d,Z),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function r(Pe){return Array.isArray(Pe)?Pe.map(d.DefinitionLink.from):Pe?[d.DefinitionLink.from(Pe)]:[]}class u{constructor(z,J){this.d=z,this.e=J}async provideDefinition(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideDefinition(oe,Z,se);return r(ge)}}class I{constructor(z,J){this.d=z,this.e=J}async provideDeclaration(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideDeclaration(oe,Z,se);return r(ge)}}class S{constructor(z,J){this.d=z,this.e=J}async provideImplementation(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideImplementation(oe,Z,se);return r(ge)}}class ${constructor(z,J){this.d=z,this.e=J}async provideTypeDefinition(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideTypeDefinition(oe,Z,se);return r(ge)}}class g{constructor(z,J){this.d=z,this.e=J}async provideHover(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideHover(oe,Z,se);if(!(!ge||(0,L.$Kb)(ge.contents)))return ge.range||(ge.range=oe.getWordRangeAtPosition(Z)),ge.range||(ge.range=new R.$pK(Z,Z)),d.Hover.from(ge)}}class w{constructor(z,J){this.d=z,this.e=J}async provideEvaluatableExpression(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideEvaluatableExpression(oe,Z,se);if(ge)return d.EvaluatableExpression.from(ge)}}class D{constructor(z,J){this.d=z,this.e=J}async provideInlineValues(z,J,se,oe){const Z=this.d.getDocument(z),ge=await this.e.provideInlineValues(Z,d.Range.to(J),d.InlineValueContext.to(se),oe);if(Array.isArray(ge))return ge.map(Ee=>d.InlineValue.from(Ee))}}class N{constructor(z,J){this.d=z,this.e=J}async provideDocumentHighlights(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideDocumentHighlights(oe,Z,se);if(Array.isArray(ge))return ge.map(d.DocumentHighlight.from)}}class M{constructor(z,J){this.d=z,this.e=J}async provideLinkedEditingRanges(z,J,se){const oe=this.d.getDocument(z),Z=d.Position.to(J),ge=await this.e.provideLinkedEditingRanges(oe,Z,se);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,L.$Hb)(ge.ranges.map(d.Range.from)),wordPattern:ge.wordPattern}}}class F{constructor(z,J){this.d=z,this.e=J}async provideReferences(z,J,se,oe){const Z=this.d.getDocument(z),ge=d.Position.to(J),Ee=await this.e.provideReferences(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(d.location.from)}}class U{static{this.d=1e3}constructor(z,J,se,oe,Z,ge,Ee){this.g=z,this.h=J,this.j=se,this.k=oe,this.l=Z,this.m=ge,this.n=Ee,this.e=new a.$icc("CodeAction"),this.f=new Map}async provideCodeActions(z,J,se,oe){const Z=this.g.getDocument(z),ge=v.$vs.isISelection(J)?d.Selection.to(J):d.Range.to(J),Ee=[];for(const tt of this.j.getDiagnostics(z))if(ge.intersection(tt.range)&&Ee.push(tt)>U.d)break;const je={diagnostics:Ee,only:se.only?new R.$HK(se.only):void 0,triggerKind:d.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(Z,ge,je,oe);if(!(0,L.$Lb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Xe=new p.$Rc;this.f.set(_e,Xe);const it=[];for(let tt=0;tt<We.length;tt++){const Ae=We[tt];Ae&&(U.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Xe)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,tt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Xe),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(d.Diagnostic.from),edit:Ae.edit&&d.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$gF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(z,J){const[se,oe]=z,Z=this.e.get(se,oe);if(!Z||U.o(Z))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(Z,J)??Z;let Ee;ge.edit&&(Ee=d.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(se);We&&(je=this.h.toInternal(ge.command,We))}return{edit:Ee,command:je}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class j{static toInternalProviderId(z,J){return z+"."+J}constructor(z,J,se,oe,Z){this.d=z,this.e=J,this.f=se,this.g=oe,this.h=Z}async prepareDocumentPaste(z,J,se,oe){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(z),ge=J.map(We=>d.Range.to(We)),Ee=d.DataTransfer.toDataTransfer(se,()=>{throw new f.$$});if(await this.f.prepareDocumentPaste(Z,ge,Ee,oe),oe.isCancellationRequested)return;const je=Array.from(Ee).filter(([,We])=>!(We instanceof R.$bL));return d.DataTransfer.from(je)}async providePasteEdits(z,J,se,oe,Z){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(J),Ee=se.map(_e=>d.Range.to(_e)),je=d.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,z,_e)).buffer),We=await this.f.provideDocumentPasteEdits(ge,Ee,je,Z);if(We)return{label:We.label??(0,i.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:j.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(z,J){this.d=z,this.e=J}async provideDocumentFormattingEdits(z,J,se){const oe=this.d.getDocument(z),Z=await this.e.provideDocumentFormattingEdits(oe,J,se);if(Array.isArray(Z))return Z.map(d.TextEdit.from)}}class q{constructor(z,J){this.d=z,this.e=J}async provideDocumentRangeFormattingEdits(z,J,se,oe){const Z=this.d.getDocument(z),ge=d.Range.to(J),Ee=await this.e.provideDocumentRangeFormattingEdits(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,J,se,oe){(0,P.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(z),ge=J.map(d.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Z,ge,se,oe);if(Array.isArray(Ee))return Ee.map(d.TextEdit.from)}}class K{constructor(z,J){this.d=z,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,J,se,oe,Z){const ge=this.d.getDocument(z),Ee=d.Position.to(J),je=await this.e.provideOnTypeFormattingEdits(ge,Ee,se,oe,Z);if(Array.isArray(je))return je.map(d.TextEdit.from)}}class me{constructor(z,J){this.e=z,this.f=J,this.d=new a.$icc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,J){const se=await this.e.provideWorkspaceSymbols(z,J);if(!(0,L.$Lb)(se))return{symbols:[]};const oe=this.d.add(se),Z={cacheId:oe,symbols:[]};for(let ge=0;ge<se.length;ge++){const Ee=se[ge];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Z.symbols.push({...d.WorkspaceSymbol.from(Ee),cacheId:[oe,ge]})}return Z}async resolveWorkspaceSymbol(z,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const se=this.d.get(...z.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,J);return oe&&(0,T.$0m)(z,d.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class te{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,J,se){this.d=z,this.e=J,this.f=se}async provideRenameEdits(z,J,se,oe){const Z=this.d.getDocument(z),ge=d.Position.to(J);try{const Ee=await this.e.provideRenameEdits(Z,ge,se,oe);return Ee?d.WorkspaceEdit.from(Ee):void 0}catch(Ee){const je=te.g(Ee);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(z,J,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(z),Z=d.Position.to(J);try{const ge=await this.e.prepareRename(oe,Z,se);let Ee,je;if(R.$pK.isRange(ge)?(Ee=ge,je=oe.getText(ge)):(0,P.$Af)(ge)&&(Ee=ge.range,je=ge.placeholder),!Ee||!je)return;if(Ee.start.line>Z.line||Ee.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(Ee),text:je}}catch(ge){const Ee=te.g(ge);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class G{constructor(z,J){this.resultId=z,this.tokens=J}}class Q{constructor(z,J){this.f=z,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,J,se){const oe=this.f.getDocument(z),Z=J!==0?this.d.get(J):null;let ge=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,Z.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return Z&&this.d.delete(J),ge?(ge=Q.h(ge),this.o(Q.n(Z,ge),ge)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return Q.j(z)?Q.k(z)?z:new R.$EL(new Uint32Array(z.data),z.resultId):Q.l(z)?Q.m(z)?z:new R.$GL(z.edits.map(J=>new R.$FL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const J of z.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(z,J){if(!Q.j(J)||!z||!z.tokens)return J;const se=z.tokens,oe=se.length,Z=J.data,ge=Z.length;let Ee=0;const je=Math.min(oe,ge);for(;Ee<je&&se[Ee]===Z[Ee];)Ee++;if(Ee===oe&&Ee===ge)return new R.$GL([],J.resultId);let We=0;const _e=je-Ee;for(;We<_e&&se[oe-We-1]===Z[ge-We-1];)We++;return new R.$GL([{start:Ee,deleteCount:oe-Ee-We,data:Z.subarray(Ee,ge-We)}],J.resultId)}o(z,J){if(Q.j(z)){const se=this.e++;return this.d.set(se,new G(z.resultId,z.data)),(0,h.$20)({id:se,type:"full",data:z.data})}if(Q.l(z)){const se=this.e++;return Q.j(J)?this.d.set(se,new G(J.resultId,J.data)):this.d.set(se,new G(z.resultId)),(0,h.$20)({id:se,type:"delta",deltas:(z.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class le{constructor(z,J){this.d=z,this.e=J}async provideDocumentRangeSemanticTokens(z,J,se){const oe=this.d.getDocument(z),Z=await this.e.provideDocumentRangeSemanticTokens(oe,d.Range.to(J),se);return Z?this.f(Z):null}f(z){return(0,h.$20)({id:0,type:"full",data:z.data})}}class ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,J,se,oe,Z){this.f=z,this.g=J,this.h=se,this.j=oe,this.k=Z,this.d=new a.$icc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,J,se,oe){const Z=this.f.getDocument(z),ge=d.Position.to(J),Ee=Z.getWordRangeAtPosition(ge)||new R.$pK(ge,ge),je=Ee.with({end:ge}),We=new o.$Jd,_e=await this.h.provideCompletionItems(Z,ge,oe,d.CompletionContext.to(se));if(!_e||oe.isCancellationRequested)return;const Xe=Array.isArray(_e)?new R.$UK(_e):_e,it=ie.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),tt=new p.$Rc;this.e.set(it,tt);const Ae=[],Ne={x:it,b:Ae,a:{replace:d.Range.from(Ee),insert:d.Range.from(je)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Xe.items.length;qe++){const Le=Xe.items[qe],Ye=this.l(Le,[it,qe],je,Ee);Ae.push(Ye)}return Ne}async resolveCompletionItem(z,J){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...z);if(!se)return;const oe=this.l(se,z),Z=await this.h.resolveCompletionItem(se,J);if(!Z)return;const ge=this.l(Z,z);return(oe.h!==ge.h||oe.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ge.n||oe.o!==ge.o||!(0,T.$$m)(oe.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,J,se,oe){const Z=this.e.get(J[0]);if(!Z)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(z.command,Z),Ee={x:J,a:z.label,b:z.kind!==void 0?d.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(d.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:d.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(d.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=z.textEdit.newText):typeof z.insertText=="string"?Ee.h=z.insertText:z.insertText instanceof R.$yK&&(Ee.h=z.insertText.value,Ee.i|=4);let je;return z.textEdit?je=z.textEdit.range:z.range&&(je=z.range),R.$pK.isRange(je)?Ee.j=d.Range.from(je):je&&(!se?.isEqual(je.inserting)||!oe?.isEqual(je.replacing))&&(Ee.j={insert:d.Range.from(je.inserting),replace:d.Range.from(je.replacing)}),Ee}}class ce{async provideInlineCompletions(z,J,se,oe){}disposeCompletions(z){}handleDidShowCompletionItem(z,J,se){}handlePartialAccept(z,J,se){}}class ye extends ce{constructor(z,J,se,oe){super(),this.f=z,this.g=J,this.h=se,this.j=oe,this.d=new H,this.e=(0,t.$gF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$gF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,J,se,oe){const Z=this.g.getDocument(z),ge=d.Position.to(J),Ee=await this.h.provideInlineCompletionItems(Z,ge,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:d.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!Ee||oe.isCancellationRequested)return;const je=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],_e=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:je}),items:je.map((tt,Ae)=>{let Ne;tt.command&&(Xe||(Xe=new p.$Rc),Ne=this.j.toInternal(tt.command,Xe));const qe=tt.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:tt.filterText,range:tt.range?d.Range.from(tt.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Xe||(Xe=new p.$Rc),this.j.toInternal(tt,Xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,J,se){const oe=this.d.get(z)?.items[J];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(z,J,se){const oe=this.d.get(z)?.items[J];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class H{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const J=this.e++;return this.d.set(J,z),J}disposeReferenceId(z){const J=this.d.get(z);return this.d.delete(z),J}get(z){return this.d.get(z)}}class B{constructor(z,J){this.e=z,this.f=J,this.d=new a.$icc("SignatureHelp")}async provideSignatureHelp(z,J,se,oe){const Z=this.e.getDocument(z),ge=d.Position.to(J),Ee=this.g(se),je=await this.f.provideSignatureHelp(Z,ge,oe,Ee);if(je){const We=this.d.add([je]);return{...d.SignatureHelp.from(je),id:We}}}g(z){let J;if(z.activeSignatureHelp){const se=d.SignatureHelp.to(z.activeSignatureHelp),oe=this.d.get(z.activeSignatureHelp.id,0);oe?(J=oe,J.activeSignature=se.activeSignature,J.activeParameter=se.activeParameter):J=se}return{...z,activeSignatureHelp:J}}releaseSignatureHelp(z){this.d.delete(z)}}class X{constructor(z,J,se,oe,Z){this.f=z,this.g=J,this.h=se,this.j=oe,this.k=Z,this.d=new a.$icc("InlayHints"),this.e=new Map}async provideInlayHints(z,J,se){const oe=this.f.getDocument(z),Z=d.Range.to(J),ge=await this.h.provideInlayHints(oe,Z,se);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(se.isCancellationRequested)return;const Ee=this.d.add(ge);this.e.set(Ee,new p.$Rc);const je={hints:[],cacheId:Ee};for(let We=0;We<ge.length;We++)this.l(ge[We],Z)&&je.hints.push(this.m(ge[We],[Ee,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),je}async resolveInlayHint(z,J){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...z);if(!se)return;const oe=await this.h.resolveInlayHint(se,J);if(oe&&this.l(oe))return this.m(oe,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,J){return z.label.length===0||Array.isArray(z.label)&&z.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(J&&!J.contains(z.position))}m(z,J){const se=this.e.get(J[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:J,tooltip:d.MarkdownString.fromStrict(z.tooltip),position:d.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(d.TextEdit.from),kind:z.kind&&d.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?oe.label=z.label:oe.label=z.label.map(Z=>{const ge={label:Z.value};return ge.tooltip=d.MarkdownString.fromStrict(Z.tooltip),R.$zK.isLocation(Z.location)&&(ge.location=d.location.from(Z.location)),Z.command&&(ge.command=this.g.toInternal(Z.command,se)),ge}),oe}}class re{constructor(z,J){this.e=z,this.f=J,this.d=new a.$icc("DocumentLink")}async provideLinks(z,J){const se=this.e.getDocument(z),oe=await this.f.provideDocumentLinks(se,J);if(!(!Array.isArray(oe)||oe.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(re.g).map(d.DocumentLink.from)};{const Z=this.d.add(oe),ge={links:[],cacheId:Z};for(let Ee=0;Ee<oe.length;Ee++){if(!re.g(oe[Ee]))continue;const je=d.DocumentLink.from(oe[Ee]);je.cacheId=[Z,Ee],ge.links.push(je)}return ge}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,J){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...z);if(!se)return;const oe=await this.f.resolveDocumentLink(se,J);if(!(!oe||!re.g(oe)))return d.DocumentLink.from(oe)}releaseLinks(z){this.d.delete(z)}}class Y{constructor(z,J){this.d=z,this.e=J}async provideColors(z,J){const se=this.d.getDocument(z),oe=await this.e.provideDocumentColors(se,J);return Array.isArray(oe)?oe.map(ge=>({color:d.Color.from(ge.color),range:d.Range.from(ge.range)})):[]}async provideColorPresentations(z,J,se){const oe=this.d.getDocument(z),Z=d.Range.to(J.range),ge=d.Color.to(J.color),Ee=await this.e.provideColorPresentations(ge,{document:oe,range:Z},se);if(Array.isArray(Ee))return Ee.map(d.ColorPresentation.from)}}class _{constructor(z,J){this.d=z,this.e=J}async provideFoldingRanges(z,J,se){const oe=this.d.getDocument(z),Z=await this.e.provideFoldingRanges(oe,J,se);if(Array.isArray(Z))return Z.map(d.FoldingRange.from)}}class x{constructor(z,J,se){this.d=z,this.e=J,this.f=se}async provideSelectionRanges(z,J,se){const oe=this.d.getDocument(z),Z=J.map(d.Position.to),ge=await this.e.provideSelectionRanges(oe,Z,se);if(!(0,L.$Lb)(ge))return[];if(ge.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let je=0;je<Z.length;je++){const We=[];Ee.push(We);let _e=Z[je],Xe=ge[je];for(;;){if(!Xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(d.SelectionRange.from(Xe)),!Xe.parent)break;_e=Xe.range,Xe=Xe.parent}}return Ee}}class ve{constructor(z,J){this.f=z,this.g=J,this.d=new s.$rM(""),this.e=new Map}async prepareSession(z,J,se){const oe=this.f.getDocument(z),Z=d.Position.to(J),ge=await this.g.prepareCallHierarchy(oe,Z,se);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(je=>this.h(Ee,je)):[this.h(Ee,ge)]}async provideCallsTo(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(Z)return Z.map(ge=>({from:this.h(z,ge.from),fromRanges:ge.fromRanges.map(Ee=>d.Range.from(Ee))}))}async provideCallsFrom(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(Z)return Z.map(ge=>({to:this.h(z,ge.to),fromRanges:ge.fromRanges.map(Ee=>d.Range.from(Ee))}))}releaseSession(z){this.e.delete(z)}h(z,J){const se=this.e.get(z),oe=d.CallHierarchyItem.from(J,z,se.size.toString(36));return se.set(oe._itemId,J),oe}j(z,J){return this.e.get(z)?.get(J)}}class ae{constructor(z,J){this.f=z,this.g=J,this.d=new s.$rM(""),this.e=new Map}async prepareSession(z,J,se){const oe=this.f.getDocument(z),Z=d.Position.to(J),ge=await this.g.prepareTypeHierarchy(oe,Z,se);if(!ge)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ge)?ge.map(je=>this.h(Ee,je)):[this.h(Ee,ge)]}async provideSupertypes(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(oe,se);if(Z)return Z.map(ge=>this.h(z,ge))}async provideSubtypes(z,J,se){const oe=this.j(z,J);if(!oe)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(oe,se);if(Z)return Z.map(ge=>this.h(z,ge))}releaseSession(z){this.e.delete(z)}h(z,J){const se=this.e.get(z),oe=d.TypeHierarchyItem.from(J,z,se.size.toString(36));return se.set(oe._itemId,J),oe}j(z,J){return this.e.get(z)?.get(J)}}class fe{static toInternalProviderId(z,J){return z+"."+J}constructor(z,J,se,oe,Z){this.d=z,this.e=J,this.f=se,this.g=oe,this.h=Z}async provideDocumentOnDropEdits(z,J,se,oe,Z){const ge=this.e.getDocument(J),Ee=d.Position.to(se),je=d.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,_e)).buffer),We=await this.f.provideDocumentDropEdits(ge,Ee,je,Z);if(We)return{label:We.label??(0,i.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:fe.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(z,J){this.d=z,this.e=J}async provideMappedEdits(z,J,se,oe){const Z=C.URI.revive(z),ge=this.d.getDocument(Z),Ee=se.documents.map(_e=>_e.map(Xe=>({uri:C.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(it=>d.Range.to(it))}))),je={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,J,je,oe);return We?d.WorkspaceEdit.from(We):null}}class de{constructor(z,J){this.adapter=z,this.extension=J}}class be{static{this.d=0}constructor(z,J,se,oe,Z,ge,Ee,je){this.g=J,this.h=se,this.j=oe,this.k=Z,this.l=ge,this.m=Ee,this.n=je,this.f=new Map,this.e=z.getProxy(m.$lK.MainThreadLanguageFeatures)}o(z,J){return d.DocumentSelector.from(z,this.g,J)}p(z){return new R.$nK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return be.d++}async s(z,J,se,oe,Z,ge=!1){const Ee=this.f.get(z);if(!Ee||!(Ee.adapter instanceof J))return oe;const je=Date.now();ge||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(_e=>{(0,f.$4)(_e)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ee.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(Z)?(0,l.$Jg)(We,Z):We}t(z,J){const se=this.q();return this.f.set(se,new de(z,J)),se}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,J,se,oe){const Z=this.t(new c(this.h,se),z),ge=oe&&oe.label||be.u(z);return this.e.$registerDocumentSymbolProvider(Z,this.o(J,z),ge),this.p(Z)}$provideDocumentSymbols(z,J,se){return this.s(z,c,oe=>oe.provideDocumentSymbols(C.URI.revive(J),se),void 0,se)}registerCodeLensProvider(z,J,se){const oe=this.q(),Z=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new de(new n(this.h,this.j.converter,se),z)),this.e.$registerCodeLensSupport(oe,this.o(J,z),Z);let ge=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Z));ge=R.$nK.from(ge,Ee)}return ge}$provideCodeLenses(z,J,se){return this.s(z,n,oe=>oe.provideCodeLenses(C.URI.revive(J),se),void 0,se)}$resolveCodeLens(z,J,se){return this.s(z,n,oe=>oe.resolveCodeLens(J,se),void 0,void 0)}$releaseCodeLenses(z,J){this.s(z,n,se=>Promise.resolve(se.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(z,J,se){const oe=this.t(new u(this.h,se),z);return this.e.$registerDefinitionSupport(oe,this.o(J,z)),this.p(oe)}$provideDefinition(z,J,se,oe){return this.s(z,u,Z=>Z.provideDefinition(C.URI.revive(J),se,oe),[],oe)}registerDeclarationProvider(z,J,se){const oe=this.t(new I(this.h,se),z);return this.e.$registerDeclarationSupport(oe,this.o(J,z)),this.p(oe)}$provideDeclaration(z,J,se,oe){return this.s(z,I,Z=>Z.provideDeclaration(C.URI.revive(J),se,oe),[],oe)}registerImplementationProvider(z,J,se){const oe=this.t(new S(this.h,se),z);return this.e.$registerImplementationSupport(oe,this.o(J,z)),this.p(oe)}$provideImplementation(z,J,se,oe){return this.s(z,S,Z=>Z.provideImplementation(C.URI.revive(J),se,oe),[],oe)}registerTypeDefinitionProvider(z,J,se){const oe=this.t(new $(this.h,se),z);return this.e.$registerTypeDefinitionSupport(oe,this.o(J,z)),this.p(oe)}$provideTypeDefinition(z,J,se,oe){return this.s(z,$,Z=>Z.provideTypeDefinition(C.URI.revive(J),se,oe),[],oe)}registerHoverProvider(z,J,se,oe){const Z=this.t(new g(this.h,se),z);return this.e.$registerHoverProvider(Z,this.o(J,z)),this.p(Z)}$provideHover(z,J,se,oe){return this.s(z,g,Z=>Z.provideHover(C.URI.revive(J),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(z,J,se,oe){const Z=this.t(new w(this.h,se),z);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(J,z)),this.p(Z)}$provideEvaluatableExpression(z,J,se,oe){return this.s(z,w,Z=>Z.provideEvaluatableExpression(C.URI.revive(J),se,oe),void 0,oe)}registerInlineValuesProvider(z,J,se,oe){const Z=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new D(this.h,se),z);this.e.$registerInlineValuesProvider(ge,this.o(J,z),Z);let Ee=this.p(ge);if(Z!==void 0){const je=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));Ee=R.$nK.from(Ee,je)}return Ee}$provideInlineValues(z,J,se,oe,Z){return this.s(z,D,ge=>ge.provideInlineValues(C.URI.revive(J),se,oe,Z),void 0,Z)}registerDocumentHighlightProvider(z,J,se){const oe=this.t(new N(this.h,se),z);return this.e.$registerDocumentHighlightProvider(oe,this.o(J,z)),this.p(oe)}$provideDocumentHighlights(z,J,se,oe){return this.s(z,N,Z=>Z.provideDocumentHighlights(C.URI.revive(J),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(z,J,se){const oe=this.t(new M(this.h,se),z);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(J,z)),this.p(oe)}$provideLinkedEditingRanges(z,J,se,oe){return this.s(z,M,async Z=>{const ge=await Z.provideLinkedEditingRanges(C.URI.revive(J),se,oe);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?be.w(ge.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(z,J,se){const oe=this.t(new F(this.h,se),z);return this.e.$registerReferenceSupport(oe,this.o(J,z)),this.p(oe)}$provideReferences(z,J,se,oe,Z){return this.s(z,F,ge=>ge.provideReferences(C.URI.revive(J),se,oe,Z),void 0,Z)}registerCodeActionProvider(z,J,se,oe){const Z=new p.$Rc,ge=this.t(new U(this.h,this.j.converter,this.k,se,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(ge,this.o(J,z),{providedKinds:oe?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:oe?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Z)}))},be.u(z),!!se.resolveCodeAction),Z.add(this.p(ge)),Z}$provideCodeActions(z,J,se,oe,Z){return this.s(z,U,ge=>ge.provideCodeActions(C.URI.revive(J),se,oe,Z),void 0,Z)}$resolveCodeAction(z,J,se){return this.s(z,U,oe=>oe.resolveCodeAction(J,se),{},void 0)}$releaseCodeActions(z,J){this.s(z,U,se=>Promise.resolve(se.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(z,J,se){const oe=this.t(new O(this.h,se),z);return this.e.$registerDocumentFormattingSupport(oe,this.o(J,z),z.identifier,z.displayName||z.name),this.p(oe)}$provideDocumentFormattingEdits(z,J,se,oe){return this.s(z,O,Z=>Z.provideDocumentFormattingEdits(C.URI.revive(J),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(z,J,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",Z=this.t(new q(this.h,se),z);return this.e.$registerRangeFormattingSupport(Z,this.o(J,z),z.identifier,z.displayName||z.name,oe),this.p(Z)}$provideDocumentRangeFormattingEdits(z,J,se,oe,Z){return this.s(z,q,ge=>ge.provideDocumentRangeFormattingEdits(C.URI.revive(J),se,oe,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(z,J,se,oe,Z){return this.s(z,q,ge=>ge.provideDocumentRangesFormattingEdits(C.URI.revive(J),se,oe,Z),void 0,Z)}registerOnTypeFormattingEditProvider(z,J,se,oe){const Z=this.t(new K(this.h,se),z);return this.e.$registerOnTypeFormattingSupport(Z,this.o(J,z),oe,z.identifier),this.p(Z)}$provideOnTypeFormattingEdits(z,J,se,oe,Z,ge){return this.s(z,K,Ee=>Ee.provideOnTypeFormattingEdits(C.URI.revive(J),se,oe,Z,ge),void 0,ge)}registerWorkspaceSymbolProvider(z,J){const se=this.t(new me(J,this.l),z);return this.e.$registerNavigateTypeSupport(se,typeof J.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(z,J,se){return this.s(z,me,oe=>oe.provideWorkspaceSymbols(J,se),{symbols:[]},se)}$resolveWorkspaceSymbol(z,J,se){return this.s(z,me,oe=>oe.resolveWorkspaceSymbol(J,se),void 0,void 0)}$releaseWorkspaceSymbols(z,J){this.s(z,me,se=>se.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(z,J,se){const oe=this.t(new te(this.h,se,this.l),z);return this.e.$registerRenameSupport(oe,this.o(J,z),te.supportsResolving(se)),this.p(oe)}$provideRenameEdits(z,J,se,oe,Z){return this.s(z,te,ge=>ge.provideRenameEdits(C.URI.revive(J),se,oe,Z),void 0,Z)}$resolveRenameLocation(z,J,se,oe){return this.s(z,te,Z=>Z.resolveRenameLocation(C.URI.revive(J),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(z,J,se,oe){const Z=this.t(new Q(this.h,se),z),ge=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(J,z),oe,ge);let Ee=this.p(Z);if(ge){const je=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));Ee=R.$nK.from(Ee,je)}return Ee}$provideDocumentSemanticTokens(z,J,se,oe){return this.s(z,Q,Z=>Z.provideDocumentSemanticTokens(C.URI.revive(J),se,oe),null,oe)}$releaseDocumentSemanticTokens(z,J){this.s(z,Q,se=>se.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,J,se,oe){const Z=this.t(new le(this.h,se),z);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(J,z),oe),this.p(Z)}$provideDocumentRangeSemanticTokens(z,J,se,oe){return this.s(z,le,Z=>Z.provideDocumentRangeSemanticTokens(C.URI.revive(J),se,oe),null,oe)}registerCompletionItemProvider(z,J,se,oe){const Z=this.t(new ie(this.h,this.j.converter,se,this.m,z),z);return this.e.$registerCompletionsProvider(Z,this.o(J,z),oe,ie.supportsResolving(se),z.identifier),this.p(Z)}$provideCompletionItems(z,J,se,oe,Z){return this.s(z,ie,ge=>ge.provideCompletionItems(C.URI.revive(J),se,oe,Z),void 0,Z)}$resolveCompletionItem(z,J,se){return this.s(z,ie,oe=>oe.resolveCompletionItem(J,se),void 0,se)}$releaseCompletionItems(z,J){this.s(z,ie,se=>se.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(z,J,se,oe){const Z=new ye(z,this.h,se,this.j.converter),ge=this.t(Z,z);return this.e.$registerInlineCompletionsSupport(ge,this.o(J,z),Z.supportsHandleEvents,k.$6l.toKey(z.identifier.value),oe?.yieldTo?.map(Ee=>k.$6l.toKey(Ee))||[]),this.p(ge)}$provideInlineCompletions(z,J,se,oe,Z){return this.s(z,ce,ge=>ge.provideInlineCompletions(C.URI.revive(J),se,oe,Z),void 0,Z)}$handleInlineCompletionDidShow(z,J,se,oe){this.s(z,ce,async Z=>{Z.handleDidShowCompletionItem(J,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,J,se,oe){this.s(z,ce,async Z=>{Z.handlePartialAccept(J,se,oe)},void 0,void 0)}$freeInlineCompletionsList(z,J){this.s(z,ce,async se=>{se.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(z,J,se,oe){const Z=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ge=this.t(new B(this.h,se),z);return this.e.$registerSignatureHelpProvider(ge,this.o(J,z),Z),this.p(ge)}$provideSignatureHelp(z,J,se,oe,Z){return this.s(z,B,ge=>ge.provideSignatureHelp(C.URI.revive(J),se,oe,Z),void 0,Z)}$releaseSignatureHelp(z,J){this.s(z,B,se=>se.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(z,J,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new X(this.h,this.j.converter,se,this.l,z),z);this.e.$registerInlayHintsProvider(Z,this.o(J,z),typeof se.resolveInlayHint=="function",oe,be.u(z));let ge=this.p(Z);if(oe!==void 0){const Ee=se.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(oe));ge=R.$nK.from(ge,Ee)}return ge}$provideInlayHints(z,J,se,oe){return this.s(z,X,Z=>Z.provideInlayHints(C.URI.revive(J),se,oe),void 0,oe)}$resolveInlayHint(z,J,se){return this.s(z,X,oe=>oe.resolveInlayHint(J,se),void 0,se)}$releaseInlayHints(z,J){this.s(z,X,se=>se.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(z,J,se){const oe=this.t(new re(this.h,se),z);return this.e.$registerDocumentLinkProvider(oe,this.o(J,z),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(z,J,se){return this.s(z,re,oe=>oe.provideLinks(C.URI.revive(J),se),void 0,se,J.scheme==="output")}$resolveDocumentLink(z,J,se){return this.s(z,re,oe=>oe.resolveLink(J,se),void 0,void 0,!0)}$releaseDocumentLinks(z,J){this.s(z,re,se=>se.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(z,J,se){const oe=this.t(new Y(this.h,se),z);return this.e.$registerDocumentColorProvider(oe,this.o(J,z)),this.p(oe)}$provideDocumentColors(z,J,se){return this.s(z,Y,oe=>oe.provideColors(C.URI.revive(J),se),[],se)}$provideColorPresentations(z,J,se,oe){return this.s(z,Y,Z=>Z.provideColorPresentations(C.URI.revive(J),se,oe),void 0,oe)}registerFoldingRangeProvider(z,J,se){const oe=this.q(),Z=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new de(new _(this.h,se),z)),this.e.$registerFoldingRangeProvider(oe,this.o(J,z),z.identifier,Z);let ge=this.p(oe);if(Z!==void 0){const Ee=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));ge=R.$nK.from(ge,Ee)}return ge}$provideFoldingRanges(z,J,se,oe){return this.s(z,_,Z=>Z.provideFoldingRanges(C.URI.revive(J),se,oe),void 0,oe)}registerSelectionRangeProvider(z,J,se){const oe=this.t(new x(this.h,se,this.l),z);return this.e.$registerSelectionRangeProvider(oe,this.o(J,z)),this.p(oe)}$provideSelectionRanges(z,J,se,oe){return this.s(z,x,Z=>Z.provideSelectionRanges(C.URI.revive(J),se,oe),[],oe)}registerCallHierarchyProvider(z,J,se){const oe=this.t(new ve(this.h,se),z);return this.e.$registerCallHierarchyProvider(oe,this.o(J,z)),this.p(oe)}$prepareCallHierarchy(z,J,se,oe){return this.s(z,ve,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(J),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(z,J,se,oe){return this.s(z,ve,Z=>Z.provideCallsTo(J,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(z,J,se,oe){return this.s(z,ve,Z=>Z.provideCallsFrom(J,se,oe),void 0,oe)}$releaseCallHierarchy(z,J){this.s(z,ve,se=>Promise.resolve(se.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(z,J,se){const oe=this.t(new ae(this.h,se),z);return this.e.$registerTypeHierarchyProvider(oe,this.o(J,z)),this.p(oe)}$prepareTypeHierarchy(z,J,se,oe){return this.s(z,ae,Z=>Promise.resolve(Z.prepareSession(C.URI.revive(J),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(z,J,se,oe){return this.s(z,ae,Z=>Z.provideSupertypes(J,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(z,J,se,oe){return this.s(z,ae,Z=>Z.provideSubtypes(J,se,oe),void 0,oe)}$releaseTypeHierarchy(z,J){this.s(z,ae,se=>Promise.resolve(se.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(z,J,se,oe){const Z=this.q();this.f.set(Z,new de(new fe(this.e,this.h,se,Z,z),z));const ge=(0,t.$gF)(z,"dropMetadata")&&oe?fe.toInternalProviderId(z.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(J,z),ge,(0,t.$gF)(z,"dropMetadata")?oe:void 0),this.p(Z)}$provideDocumentOnDropEdits(z,J,se,oe,Z,ge){return this.s(z,fe,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(J,C.URI.revive(se),oe,Z,ge)),void 0,void 0)}registerMappedEditsProvider(z,J,se){const oe=this.t(new ee(this.h,se),z);return this.e.$registerMappedEditsProvider(oe,this.o(J,z)),this.p(oe)}$provideMappedEdits(z,J,se,oe,Z){return this.s(z,ee,ge=>Promise.resolve(ge.provideMappedEdits(J,se,oe,Z)),null,Z)}registerDocumentPasteEditProvider(z,J,se,oe){const Z=this.q();this.f.set(Z,new de(new j(this.e,this.h,se,Z,z),z));const ge=j.toInternalProviderId(z.identifier.value,oe.id);return this.e.$registerPasteEditProvider(Z,this.o(J,z),ge,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(z,J,se,oe,Z){return this.s(z,j,ge=>ge.prepareDocumentPaste(C.URI.revive(J),se,oe,Z),void 0,Z)}$providePasteEdits(z,J,se,oe,Z,ge){return this.s(z,j,Ee=>Ee.providePasteEdits(J,C.URI.revive(se),oe,Z,ge),void 0,ge)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:be.w(z.decreaseIndentPattern),increaseIndentPattern:be.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?be.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?be.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:be.w(z.beforeText),afterText:z.afterText?be.w(z.afterText):void 0,previousLineText:z.previousLineText?be.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(be.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(J=>R.SyntaxTokenType.toString(J)):void 0}}static D(z){return z.map(be.C)}setLanguageConfiguration(z,J,se){const{wordPattern:oe}=se;if(oe&&(0,E.$Oe)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(J,oe):this.h.setWordDefinitionFor(J,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const Z=this.q(),ge={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?be.w(se.wordPattern):void 0,indentationRules:se.indentationRules?be.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?be.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?be.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,J,ge),this.p(Z)}$setWordDefinitions(z){for(const J of z)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$rcc=be}),define(De[319],Ce([1,0,6,13,7,38,8,3,26]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class b{constructor(P,v,y,k){this.c=v,this.d=y,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(C.$lK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,v){await this.a.$changeLanguage(P,v);const y=this.c.getDocumentData(P);if(!y)throw new Error(`document '${P.toString()}' NOT found`);return y.document}async tokenAtPosition(P,v){const y=P.version,k=T.Position.from(v),p=await this.a.$tokensAtPosition(P.uri,k),h={type:d.StandardTokenType.Other,range:P.getWordRangeAtPosition(v)??new d.$pK(v.line,v.character,v.line,v.character)};if(!p)return h;const s={range:T.Range.to(p.range),type:T.TokenType.to(p.type)};return!s.range.contains(v)||y!==P.version?h:s}createLanguageStatusItem(P,v,y){const k=this.f++,p=this.a,h=this.g,s=`${P.identifier.value}/${v}`;if(h.has(s))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);h.add(s);const a={selector:y,id:v,name:P.displayName??P.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const f=new m.$Rc,l=()=>{if(o?.dispose(),!h.has(s)){console.warn(`LanguageStatusItem (${v}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,A.$Vg)(()=>{f.clear(),this.a.$setLanguageStatus(k,{id:s,name:a.name??P.displayName??P.name,source:P.displayName??P.name,selector:T.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===d.LanguageStatusSeverity.Error?R.default.Error:a.severity===d.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:a.command&&this.d.toInternal(a.command,f),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},t={dispose(){f.dispose(),o?.dispose(),p.$removeLanguageStatus(k),h.delete(s)},get id(){return a.id},get name(){return a.name},set name(i){a.name=i,l()},get selector(){return a.selector},set selector(i){a.selector=i,l()},get text(){return a.text},set text(i){a.text=i,l()},set text2(i){(0,E.$hF)(P,"languageStatusText"),a.text=i,l()},get text2(){return(0,E.$hF)(P,"languageStatusText"),a.text},get detail(){return a.detail},set detail(i){a.detail=i,l()},get severity(){return a.severity},set severity(i){a.severity=i,l()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i,l()},get command(){return a.command},set command(i){a.command=i,l()},get busy(){return a.busy},set busy(i){a.busy=i,l()}};return l(),t}}e.$_cc=b}),define(De[112],Ce([1,0,12,15,2,5,14,6,27,20]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=void 0;let L=class{constructor(v,y,k){this.f=k,this.d=new Map,this.a=y.getProxy(m.$lK.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===C.$g}getMessage(v,y){const{message:k,args:p,comment:h}=y;if(this.c)return(0,T.$De)(k,p??{});let s=k;h&&h.length>0&&(s+=`/${Array.isArray(h)?h.join(""):h}`);const a=this.d.get(v)?.contents[s];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,T.$De)(a??k,p??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let y;const k=await this.g(v);if(!k){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(k),h=JSON.parse(p);y=v.isBuiltin?h.contents?.bundle:h}catch(p){this.f.error(`Failed to load translations for ${v.identifier.value} from ${k}: ${p.message}`);return}y&&this.d.set(v.identifier.value,{contents:y,uri:k})}async g(v){if(v.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return d.URI.revive(y)}return v.l10n?d.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$1cc=L,e.$1cc=L=He([Be(0,E.$CM),Be(1,b.$mM),Be(2,A.$0i)],L),e.$2cc=(0,R.$Ph)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,14,6,27,20,2,62]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let E=class extends C.$ij{constructor(P,v){super(v.logLevel,v.logsLocation,v.loggers.map(y=>(0,m.$mh)(y))),this.r=P.getProxy(T.$lK.MainThreadLogger)}$setLogLevel(P,v){v?this.setLogLevel(A.URI.revive(v),P):this.setLogLevel(P)}setVisibility(P,v){super.setVisibility(P,v),this.r.$setVisibility(P,v)}s(P,v,y){return new b(this.r,P,v,y)}};e.$rec=E,e.$rec=E=He([Be(0,R.$mM),Be(1,d.$CM)],E);class b extends C.$dj{constructor(P,v,y,k){super(k?.logLevel==="always"),this.r=P,this.s=v,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(v,k).then(()=>{this.u(this.n),this.m=!0})}g(P,v){const y=[[P,v]];this.m?this.u(y):this.n.push(...y)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=void 0,e.$3cc=(0,T.$Ph)("IExtHostManagedSockets");let m=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(C.$lK.MainThreadManagedSockets)}setFactory(P,v){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(P,v),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const v=++this.b,y=await this.c.makeConnection(),k=new d.$Rc;return this.d.set(v,new b(v,y,k)),k.add((0,d.$Qc)(()=>this.d.delete(v))),k.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(v),k.dispose()})),k.add(y.onDidClose(p=>{this.a.$onDidManagedSocketClose(v,p?.stack??p?.message),k.dispose()})),k.add(y.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(v,A.$be.wrap(p)))),v}$remoteSocketWrite(P,v){this.d.get(P)?.actual.send(v.buffer)}$remoteSocketEnd(P){const v=this.d.get(P);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$4cc=m,e.$4cc=m=He([Be(0,R.$mM)],m);class E{constructor(P,v){this.socketFactoryId=P,this.makeConnection=v}}class b extends d.$Sc{constructor(P,v,y){super(),this.socketId=P,this.actual=v,this.B(y)}}}),define(De[320],Ce([1,0,6,14,26]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;function R(m){return m&&m.title}let A=class{constructor(E,b){this.b=b,this.a=E.getProxy(C.$lK.MainThreadMessageService)}showMessage(E,b,L,P,v){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let k;typeof P=="string"||R(P)?k=[P,...v]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,k=v),y.useCustom&&(0,d.$hF)(E,"resolvers");const p=[];for(let h=0;h<k.length;h++){const s=k[h];if(typeof s=="string")p.push({title:s,handle:h,isCloseAffordance:!1});else if(typeof s=="object"){const{title:a,isCloseAffordance:o}=s;p.push({title:a,isCloseAffordance:!!o,handle:h})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(b,L,y,p).then(h=>{if(typeof h=="number")return k[h]})}};e.$adc=A,e.$adc=A=He([Be(1,T.$0i)],A)}),define(De[321],Ce([1,0,208,22,4,3,28,15,17,2,30,107,6,34,13,7,69,285,146,9,24,18]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,n,r,u,I){this.q=r,this.r=u,this.s=I,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new d.$Nd({onListenerError:o.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new d.$Nd({onListenerError:o.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new d.$Nd({onListenerError:o.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new d.$Nd({onListenerError:o.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$icc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=c.getProxy(v.$lK.MainThreadNotebook),this.c=c.getProxy(v.$lK.MainThreadNotebookDocuments),this.d=c.getProxy(v.$lK.MainThreadNotebookEditors),this.i=n.converter,n.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const $=S.notebookEditor?.notebookUri,g=S.cell.handle,D=this.g.get($)?.getCell(g);if(D)return D.apiCell}if(S&&S.$mid===14){const $=S.uri,g=this.g.get($);if(g)return g.apiNotebook}return S}}),t.A(n)}getEditorById(c){const n=this.h.get(c);if(!n)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return n}getIdByEditor(c){for(const[n,r]of this.h)if(r.apiEditor===c)return n}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,n){const r=this.g.get(c);if(!r&&!n)throw new Error(`NO notebook document for '${c}'`);return r}static t(c,n){if(!n)return;const r=n.filenamePattern.map(u=>k.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(n.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:n.displayName,filenamePattern:r,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,n,r){const u=t.a++,I=typeof r.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(u,r),this.b.$registerNotebookCellStatusBarItemProvider(u,I,n);let S;return I!==void 0&&(S=r.onDidChangeCellStatusBarItems($=>this.b.$emitCellStatusBarEvent(I))),new p.$nK(()=>{this.f.delete(u),this.b.$unregisterNotebookCellStatusBarItemProvider(u,I),S?.dispose()})}async createNotebookDocument(c){const n=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&k.NotebookData.from(c.content)});return b.URI.revive(n)}async openNotebookDocument(c){const n=this.g.get(c);if(n)return n.apiNotebook;const r=await this.c.$tryOpenNotebook(c),u=this.g.get(b.URI.revive(r));return(0,E.$Jf)(u?.apiNotebook)}async showNotebookDocument(c,n){b.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let r;typeof n=="object"?r={position:k.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(k.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:r={preserveFocus:!1};const u=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,r),I=u&&this.h.get(u)?.apiEditor;if(I)return I;throw u?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,n,r,u){const I=this.f.get(c),S=b.URI.revive(n),$=this.g.get(S);if(!$||!I)return;const g=$.getCellFromIndex(r);if(!g)return;const w=await I.provideCellStatusBarItems(g.apiCell,u);if(!w)return;const D=new R.$Rc,N=this.p.add([D]),F=(Array.isArray(w)?w:[w]).map(U=>k.NotebookStatusBarItem.from(U,this.i,D));return{cacheId:N,items:F}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,n,r,u,I){if((0,m.$Be)(n))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:n,serializer:r,options:u}),this.b.$registerNotebookSerializer(S,{id:c.identifier,location:c.extensionLocation},n,k.NotebookDocumentContentOptions.from(u),t.t(c,I)),(0,R.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(c,n,r){const u=this.w.get(c);if(!u)throw new Error("NO serializer found");const I=await u.serializer.deserializeNotebook(n.buffer,r);return new h.$qv(k.NotebookData.from(I))}async $notebookToData(c,n,r){const u=this.w.get(c);if(!u)throw new Error("NO serializer found");const I=await u.serializer.serializeNotebook(k.NotebookData.to(n.value),r);return T.$be.wrap(I)}async $saveNotebook(c,n,r,u,I){const S=b.URI.revive(n),$=this.w.get(c);if(!$)throw new Error("NO serializer found");const g=this.g.get(S);if(!g)throw new Error("Document NOT found");if(g.versionId!==r)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new L.$tk((0,C.localize)(0,null,this.y(S)),6);await this.x(S,u);const w={metadata:(0,f.$cn)(g.apiNotebook.metadata,U=>!($.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of g.apiNotebook.getCells()){const j=new p.$LL(U.kind,U.document.getText(),U.document.languageId,U.mime,$.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);j.metadata=(0,f.$cn)(U.metadata,O=>!($.options?.transientCellMetadata??{})[O]),w.cells.push(j)}const D=await $.serializer.serializeNotebook(w,I);await this.s.value.writeFile(S,D);const N=this.s.getFileSystemProviderExtUri(S.scheme),M=await this.s.value.stat(S);return{name:N.basename(S),isFile:(M.type&L.FileType.File)!==0,isDirectory:(M.type&L.FileType.Directory)!==0,isSymbolicLink:(M.type&L.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((M.permissions??0)&L.FilePermission.Locked),etag:L.$Ek({mtime:M.mtime,size:M.size}),children:void 0}}async x(c,n){const r=await this.s.value.stat(c);if(typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==L.$Dk&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==L.$Ek({mtime:n.mtime,size:r.size}))throw new L.$tk((0,C.localize)(1,null),3,n)}y(c){return c.scheme===l.Schemas.file?c.fsPath:c.toString()}z(c,n,r){if(this.h.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const u=new a.$Tdc(n,this.d,c,r.visibleRanges.map(k.NotebookRange.to),r.selections.map(k.NotebookRange.to),typeof r.viewColumn=="number"?k.ViewColumn.to(r.viewColumn):void 0);this.h.set(n,u)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const r of c.value.removedDocuments){const u=b.URI.revive(r),I=this.g.get(u);I&&(I.dispose(),this.g.delete(u),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===u.toString()&&this.h.delete(S.id)}if(c.value.addedDocuments){const r=[];for(const u of c.value.addedDocuments){const I=b.URI.revive(u.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new s.$Sdc(this.c,this.q,this.r,I,u);r.push(...u.cells.map($=>s.$Rdc.asModelAddData(S.apiNotebook,$))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this.m.fire(S.apiNotebook)}}if(c.value.addedEditors)for(const r of c.value.addedEditors){if(this.h.has(r.id))return;const u=b.URI.revive(r.documentUri),I=this.g.get(u);I&&this.z(I,r.id,r)}const n=[];if(c.value.removedEditors)for(const r of c.value.removedEditors){const u=this.h.get(r);u&&(this.h.delete(r),this.k?.id===u.id&&(this.k=void 0),n.push(u))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(u=>this.h.get(u)).filter(u=>!!u);const r=new Set;this.l.forEach(u=>r.add(u.id));for(const u of this.h.values()){const I=r.has(u.id);u._acceptVisibility(I)}this.l=[...this.h.values()].map(u=>u).filter(u=>u.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(c){const n=y.$KM.String.with("notebookType","A notebook type"),r=new y.$MM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new y.$KM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>T.$be.wrap(I))],new y.$LM("Notebook Data",I=>k.NotebookData.to(I.value))),u=new y.$MM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new y.$KM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new h.$qv(k.NotebookData.from(I)))],new y.$LM("Bytes",I=>I.buffer));c.registerApiCommand(r),c.registerApiCommand(u)}}e.$Udc=t}),define(De[322],Ce([1,0,19,8,21,4,3,28,2,25,14,6,34,13,7,110,277,26,69]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;let o=class{constructor(u,I,S,$,g){this.l=I,this.m=S,this.n=$,this.o=g,this.b=new m.$Ac,this.c=new m.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new R.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=u.getProxy(P.$lK.MainThreadNotebookKernels);const w=new v.$MM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.$KM("options","Select kernel options",D=>!0,D=>{if(D&&"notebookEditor"in D&&"id"in D){const N=this.m.getIdByEditor(D.notebookEditor);return{id:D.id,extension:D.extension,notebookEditorId:N}}else if(D&&"notebookEditor"in D){const N=this.m.getIdByEditor(D.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${D.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return D})],v.$LM.Void);this.n.registerApiCommand(w)}createNotebookController(u,I,S,$,g,w){for(const le of this.i.values())if(le.controller.id===I&&b.$6l.equals(u.identifier,le.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const D=this.j++,N=this;this.o.trace(`NotebookController[${D}], CREATED by ${u.identifier.value}, ${I}`);const M=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${u.identifier}'`);let F=!1;const U=new R.$Nd,j=new R.$Nd,O={id:n(u.identifier,I),notebookType:S,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:$||u.identifier.value,preloads:w?w.map(y.NotebookRendererScript.from):[]};let q=g??M,K;this.a.$addKernel(D,O).catch(le=>{console.log(le),F=!0});let me=0;const te=()=>{if(F)return;const le=++me;Promise.resolve().then(()=>{le===me&&this.a.$updateKernel(D,O)})},G=new m.$Ac,Q={get id(){return I},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return O.label},set label(le){O.label=le??u.displayName??u.name,te()},get detail(){return O.detail??""},set detail(le){O.detail=le,te()},get description(){return O.description??""},set description(le){O.description=le,te()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(le){O.supportedLanguages=le,te()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(le){O.supportsExecutionOrder=le,te()},get rendererScripts(){return O.preloads?O.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(le){q=le??M},get interruptHandler(){return K},set interruptHandler(le){K=le,O.supportsInterrupt=!!le,te()},createNotebookCellExecution(le){if(F)throw new Error("notebook controller is DISPOSED");if(!G.has(le.notebook.uri))throw N.o.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return N._createNotebookCellExecution(le,n(u.identifier,this.id))},createNotebookExecution(le){if((0,s.$hF)(u,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!G.has(le.uri))throw N.o.trace(`NotebookController[${D}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.uri.toString()}`);return N._createNotebookExecution(le,n(u.identifier,this.id))},dispose:()=>{F||(this.o.trace(`NotebookController[${D}], DISPOSED`),F=!0,this.i.delete(D),U.dispose(),j.dispose(),this.a.$removeKernel(D))},updateNotebookAffinity(le,ie){ie===k.NotebookControllerAffinity2.Hidden&&(0,s.$hF)(u,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(D,le.uri,ie)},onDidReceiveMessage:j.event,postMessage(le,ie){return(0,s.$hF)(u,"notebookMessaging"),N.a.$postMessage(D,ie&&N.m.getIdByEditor(ie),le)},asWebviewUri(le){return(0,s.$hF)(u,"notebookMessaging"),(0,p.$dpb)(le,N.l.remote)}};return this.i.set(D,{extensionId:u.identifier,controller:Q,onDidReceiveMessage:j,onDidChangeSelection:U,associatedNotebooks:G}),Q}getIdByController(u){for(const[I,S]of this.i)if(S.controller===u)return n(S.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,I){const S=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const g={dispose:()=>{this.e.delete(S),$.a.$removeKernelDetectionTask(S)}};return this.e.set(S,g),g}registerKernelSourceActionProvider(u,I,S){const $=this.h++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,w=this;this.g.set($,S),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,I);let D;return g!==void 0&&(D=S.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.g.delete($),w.a.$removeKernelSourceActionProvider($,$),D?.dispose()}}}async $provideKernelSourceActions(u,I){const S=this.g.get(u);if(S){const $=new A.$Rc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(w=>y.NotebookKernelSourceAction.from(w,this.n.converter,$))}return[]}$acceptNotebookAssociation(u,I,S){const $=this.i.get(u);if($){const g=this.m.getNotebookDocument(E.URI.revive(I));S?$.associatedNotebooks.set(g.uri,!0):$.associatedNotebooks.delete(g.uri),this.o.trace(`NotebookController[${u}] ASSOCIATE notebook`,g.uri.toString(),S),$.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(u,I,S){const $=this.i.get(u);if(!$)return;const g=this.m.getNotebookDocument(E.URI.revive(I)),w=[];for(const D of S){const N=g.getCell(D);N&&w.push(N.apiCell)}try{this.o.trace(`NotebookController[${u}] EXECUTE cells`,g.uri.toString(),w.length),await $.controller.executeHandler.call($.controller,w,g.apiNotebook,$.controller)}catch(D){this.o.error(`NotebookController[${u}] execute cells FAILED`,D),console.error(D)}}async $cancelCells(u,I,S){const $=this.i.get(u);if(!$)return;const g=this.m.getNotebookDocument(E.URI.revive(I));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,g.apiNotebook);else for(const w of S){const D=g.getCell(w);D&&this.b.get(D.uri)?.cancel()}if($.controller.interruptHandler){const w=this.c.get(g.uri);S.length&&Array.isArray(w)&&w.length&&w.forEach(D=>D.dispose())}}$acceptKernelMessageFromRenderer(u,I,S){const $=this.i.get(u);if(!$)return;const g=this.m.getEditorById(I);$.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(u,I,S){const g=this.m.getNotebookDocument(E.URI.revive(u)).getCell(I);if(g){const w=S?y.NotebookCellExecutionState.to(S):k.NotebookCellExecutionState.Idle;w!==void 0&&this.k.fire({cell:g.apiCell,state:w})}}_createNotebookCellExecution(u,I){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const g=new l(I,$,this.a);this.b.set($.uri,g);const w=g.onDidChangeState(()=>{g.state===f.Resolved&&(g.dispose(),w.dispose(),this.b.delete($.uri))});return g.asApiObject()}_createNotebookExecution(u,I){const S=this.m.getNotebookDocument(u.uri),$=u.getCells().find(D=>{const N=S.getCellFromApiCell(D);return N&&this.b.has(N.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new i(I,S,this.a),w=g.onDidChangeState(()=>{g.state===t.Resolved&&(g.dispose(),w.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,w]),g.asApiObject()}};e.$9dc=o,e.$9dc=o=He([Be(4,L.$0i)],o);var f;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(f||(f={}));class l extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(u,I,S){super(),this.m=I,this.n=S,this.b=l.a++,this.c=new R.$Nd,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new d.$Xd),this.h=new c(10,$=>this.s($)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,u,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(u){await this.h.addItem(u)}async s(u){const I=Array.isArray(u)?u:[u];return this.n.$updateExecution(this.b,new a.$qv(I))}t(){if(this.f===f.Init)throw new Error("Must call start before modifying cell output");if(this.f===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(u){let I=this.m;if(u&&(I=this.m.notebook.getCellFromApiCell(u)),!I)throw new Error("INVALID cell");return I.handle}y(u){return u.map(I=>{const S=k.$OL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?y.NotebookCellOutput.from(I):y.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(u,I,S){const $=this.w(I),g=this.y((0,C.$3b)(u));return this.r({editType:h.CellExecutionUpdateType.Output,cellHandle:$,append:S,outputs:g})}async C(u,I,S){return u=k.$OL.ensureUniqueMimeTypes((0,C.$3b)(u),!0),this.r({editType:h.CellExecutionUpdateType.OutputItems,items:u.map(y.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.m.apiCell},get executionOrder(){return u.j},set executionOrder(S){u.j=S,u.s([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:u.j}])},start(S){if(u.f===f.Resolved||u.f===f.Started)throw new Error("Cannot call start again");u.f=f.Started,u.c.fire(),u.s({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,$){if(u.f===f.Resolved)throw new Error("Cannot call resolve twice");u.f=f.Resolved,u.c.fire(),u.h.flush(),u.n.$completeExecution(u.b,new a.$qv({runEndTime:$,lastRunSuccess:S}))},clearOutput(S){return u.t(),u.z([],S,!1)},appendOutput(S,$){return u.t(),u.z(S,$,!0)},replaceOutput(S,$){return u.t(),u.z(S,$,!1)},appendOutputItems(S,$){return u.t(),u.C(S,$,!0)},replaceOutputItems(S,$){return u.t(),u.C(S,$,!1)}})}}var t;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(t||(t={}));class i extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(u,I,S){super(),this.h=I,this.j=S,this.b=i.a++,this.c=new R.$Nd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new d.$Xd),this.j.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(u,I){this.e=u,this.f=I,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new T.$ch,this.b=Date.now(),(0,T.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>u.complete())}}function n(r,u){return`${r.value}/${u}`}e.$0dc=n}),define(De[323],Ce([1,0,4,6,146]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class R{constructor(m,E){this.c=E,this.a=new Map,this.b=m.getProxy(T.$lK.MainThreadNotebookRenderers)}$postRendererMessage(m,E,b){const L=this.c.getEditorById(m);this.a.get(E)?.fire({editor:L.apiEditor,message:b})}createRendererMessaging(m,E){if(!m.contributes?.notebookRenderer?.some(L=>L.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(L,P,v)=>this.d(E).event(L,P,v),postMessage:(L,P)=>{d.$Tdc.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const v=P&&d.$Tdc.apiEditorsToExtHost.get(P);return this.b.$postMessage(v?.id,E,L)}}}d(m){let E=this.a.get(m);return E||(E=new C.$Nd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(m)}}),this.a.set(m,E),E)}}e.$$dc=R}),define(De[324],Ce([1,0,3,17,2,26,6]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class m{constructor(b){this.b=new Map,this.a=b.getProxy(A.$lK.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,L,P){if((0,R.$hF)(b,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,P),this.a.$registerProfileContentHandler(L,P.name,P.description,b.identifier.value),(0,C.$Qc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(b,L,P,v){const y=this.b.get(b);if(!y)throw new Error(`Unknown handler with id: ${b}`);return y.saveProfile(L,P,v)}async $readProfile(b,L,P){const v=this.b.get(b);if(!v)throw new Error(`Unknown handler with id: ${b}`);return v.readProfile((0,T.$yf)(L)?L:d.URI.revive(L),P)}}e.$cec=m}),define(De[325],Ce([1,0,2,6,8,13]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class A{static{this.a=0}constructor(E,b){this.d=b,this.c=new Map,this.b=E.getProxy(T.$lK.MainThreadQuickDiff)}$provideOriginalResource(E,b,L){const P=C.URI.revive(b),v=this.c.get(E);return v?(0,d.$Mg)(()=>v.provideOriginalResource(P,L)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,b,L,P){const v=A.a++;return this.c.set(v,b),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(E,this.d),L,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}e.$dec=A}),define(De[326],Ce([1,0,21,4,3,6,2,7,9,19,38,59,26,13]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;function k(p,h,s){const a=p.getProxy(R.$lK.MainThreadQuickOpen);class o{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,$,g=C.CancellationToken.None){this.c=void 0;const w=Promise.resolve(S),D=++this.f,N=a.$show(D,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},g),M={},F=N.then(()=>M);return Promise.race([F,w]).then(U=>{if(U===M)return;const j=(0,v.$gF)(I,"quickPickItemTooltip");return w.then(O=>{const q=[];for(let K=0;K<O.length;K++){const me=O[K];if(typeof me=="string")q.push({label:me,handle:K});else if(me.kind===m.QuickPickItemKind.Separator)q.push({type:"separator",label:me.label});else{me.tooltip&&!j&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const te=me.iconPath?c(me.iconPath):void 0;q.push({label:me.label,iconPath:te?.iconPath,iconClass:te?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:j?y.MarkdownString.fromStrict(me.tooltip):void 0,handle:K})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=K=>{$.onDidSelectItem(O[K])}),a.$setItems(D,q),N.then(K=>{if(typeof K=="number")return O[K];if(Array.isArray(K))return K.map(me=>O[me])})})}).then(void 0,U=>{if(!(0,E.$4)(U))return a.$setError(D,U),Promise.reject(U)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=C.CancellationToken.None){return this.d=I?.validateInput,a.$input(I,typeof this.d=="function",S).then(void 0,$=>{if(!(0,E.$4)($))return Promise.reject($)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let $;switch(S.severity){case m.InputBoxValidationSeverity.Info:$=L.default.Info;break;case m.InputBoxValidationSeverity.Warning:$=L.default.Warning;break;case m.InputBoxValidationSeverity.Error:$=L.default.Error;break;default:$=S.message?L.default.Error:L.default.Ignore;break}return{content:S.message,severity:$}}async showWorkspaceFolderPick(I,S=C.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!$)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(w=>w.uri.toString()===$.uri.toString())}createQuickPick(I){const S=new n(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new r(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const $=this.e.get(I);$ instanceof n&&$._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const $=this.e.get(I);$ instanceof n&&$._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,$){const g=this.e.get(I);g instanceof n&&g._fireDidTriggerItemButton(S,$)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class f{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=n.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Nd,this.q=new T.$Nd,this.r=new T.$Nd,this.s=new T.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,$)=>{const g=S===m.$HL.Back?-1:$;this.o.set(g,S)}),this.z({buttons:I.map((S,$)=>({...c(S.iconPath),tooltip:S.tooltip,handle:S===m.$HL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,d.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const $=I[S];this.u[S]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function l(u){if(u instanceof m.$hL)return{id:u.id};const I=i(u),S=t(u);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function t(u){return typeof u=="object"&&"light"in u?u.light:u}function i(u){return typeof u=="object"&&"dark"in u?u.dark:u}function c(u){const I=l(u);let S,$;return"id"in I?$=P.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:$}}class n extends f{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Nd,this.L=[],this.M=new T.$Nd,this.N=new T.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((g,w)=>{this.C.set(w,g),this.D.set(g,w)});const S=(0,v.$gF)(this.O,"quickPickItemTooltip"),$=[];for(let g=0;g<I.length;g++){const w=I[g];if(w.kind===m.QuickPickItemKind.Separator)$.push({type:"separator",label:w.label});else{w.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const D=w.iconPath?c(w.iconPath):void 0;$.push({handle:g,label:w.label,iconPath:D?.iconPath,iconClass:D?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,M)=>({...c(N.iconPath),tooltip:N.tooltip,handle:M}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,b.$Hb)(I.map($=>this.C.get($)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,b.$Hb)(I.map($=>this.C.get($)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const $=this.C.get(I);if(!$||!$.buttons||!$.buttons.length)return;const g=$.buttons[S];g&&this.N.fire({button:g,item:$})}}class r extends f{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:L.default.Error}):this.z({validationMessage:I.message,severity:I.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new o(h,s)}e.$edc=k}),define(De[327],Ce([1,0,2,4,57,3,8,6,19,126,14,25,59,13,26,18]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=void 0;function s(w){if(w)return typeof w.iconPath=="string"?C.URI.file(w.iconPath):C.URI.isUri(w.iconPath)||v.ThemeIcon.isThemeIcon(w.iconPath)?w.iconPath:void 0}function a(w){if(w?.icon){if(C.URI.isUri(w.icon))return w.icon;if(v.ThemeIcon.isThemeIcon(w.icon))return w.icon;{const D=w.icon;return{light:D.light,dark:D.dark}}}else return}function o(w){if(w.icon){if(C.URI.isUri(w.icon))return w.icon;if(v.ThemeIcon.isThemeIcon(w.icon))return w.icon;{const D=w.icon;return{light:D.light,dark:D.dark}}}else return}function f(w,D){if(!w.iconPath&&!D.iconPath)return 0;if(w.iconPath){if(!D.iconPath)return 1}else return-1;const N=typeof w.iconPath=="string"?w.iconPath:C.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id,M=typeof D.iconPath=="string"?D.iconPath:C.URI.isUri(D.iconPath)?D.iconPath.fsPath:D.iconPath.id;return(0,b.$rq)(N,M)}function l(w,D){let N=0;if(w.strikeThrough!==D.strikeThrough)return w.strikeThrough?1:-1;if(w.faded!==D.faded)return w.faded?1:-1;if(w.tooltip!==D.tooltip)return(w.tooltip||"").localeCompare(D.tooltip||"");if(N=f(w,D),N!==0)return N;if(w.light&&D.light)N=f(w.light,D.light);else{if(w.light)return 1;if(D.light)return-1}if(N!==0)return N;if(w.dark&&D.dark)N=f(w.dark,D.dark);else{if(w.dark)return 1;if(D.dark)return-1}return N}function t(w,D){if(w.command!==D.command)return w.command<D.command?-1:1;if(w.title!==D.title)return w.title<D.title?-1:1;if(w.tooltip!==D.tooltip){if(w.tooltip!==void 0&&D.tooltip!==void 0)return w.tooltip<D.tooltip?-1:1;if(w.tooltip!==void 0)return 1;if(D.tooltip!==void 0)return-1}if(w.arguments===D.arguments)return 0;if(w.arguments)if(D.arguments){if(w.arguments.length!==D.arguments.length)return w.arguments.length-D.arguments.length}else return 1;else return-1;for(let N=0;N<w.arguments.length;N++){const M=w.arguments[N],F=D.arguments[N];if(M!==F)return M<F?-1:1}return 0}function i(w,D){let N=(0,b.$rq)(w.resourceUri.fsPath,D.resourceUri.fsPath,!0);if(N!==0)return N;if(w.command&&D.command)N=t(w.command,D.command);else{if(w.command)return 1;if(D.command)return-1}if(N!==0)return N;if(w.decorations&&D.decorations)N=l(w.decorations,D.decorations);else{if(w.decorations)return 1;if(D.decorations)return-1}return N}function c(w,D){for(let N=0;N<w.length;N++)if(w[N]!==D[N])return!1;return!0}function n(w,D){return w.command===D.command&&w.title===D.title&&w.tooltip===D.tooltip&&(w.arguments&&D.arguments?c(w.arguments,D.arguments):w.arguments===D.arguments)}function r(w,D){return(0,E.$ub)(w,D,n)}function u(w,D){return w===D?!0:!w||!D?!1:w.id===D.id&&w.label===D.label&&w.upstream?.id===D.upstream?.id&&w.upstream?.label===D.upstream?.label}class I{#e;#t;get value(){return this.d}set value(D){D=D??"",this.#e.$setInputBoxValue(this.o,D),this.q(D)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(D){this.#e.$setInputBoxPlaceholder(this.o,D),this.f=D}get validateInput(){return(0,k.$hF)(this.m,"scmValidation"),this.g}set validateInput(D){if((0,k.$hF)(this.m,"scmValidation"),D&&typeof D!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=D,this.#e.$setValidationProviderIsEnabled(this.o,!!D)}get enabled(){return this.h}set enabled(D){D=!!D,this.h!==D&&(this.h=D,this.#e.$setInputBoxEnablement(this.o,D))}get visible(){return this.j}set visible(D){D=!!D,this.j!==D&&(this.j=D,this.#e.$setInputBoxVisibility(this.o,D))}get actionButton(){return(0,k.$hF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(D){(0,k.$hF)(this.m,"scmInputBoxActionButton"),this.l.value=new R.$Rc,this.k=D;const N=D!==void 0?{command:this.n.converter.toInternal(D.command,this.l.value),icon:a(D),enabled:D.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,k.$hF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(D,N,M,F,U,j){this.m=D,this.n=N,this.o=U,this.p=j,this.d="",this.e=new T.$Nd,this.f="",this.h=!0,this.j=!0,this.l=new R.$Tc,this.#t=M,this.#e=F}showValidationMessage(D,N){(0,k.$hF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,D,N)}$onInputBoxValueChange(D){this.q(D)}q(D){this.d=D,this.e.fire(D)}}e.$fdc=I;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(D){this.v=D,this.q.$updateGroupLabel(this.t,this.handle,D)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(D){this.p=D,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(D){this.f=[...D],this.k.fire()}constructor(D,N,M,F,U){this.q=D,this.s=N,this.t=M,this.u=F,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(D){return this.g.get(D)}$executeResourceCommand(D,N){const M=this.h.get(D);return M?(0,A.$Mg)(()=>this.s.executeCommand(M.command,...M.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const D=[...this.f].sort(i),M=(0,E.$Db)(this.o,D,i).map(j=>{const O=j.toInsert.map(q=>{const K=this.e++;this.g.set(K,q);const me=q.resourceUri;let te;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const re=new R.$Rc;te=this.s.converter.toInternal(q.command,re),this.j.set(K,re)}else this.h.set(K,q.command);const G=s(q.decorations),Q=q.decorations&&s(q.decorations.light)||G,le=q.decorations&&s(q.decorations.dark)||G,ie=[Q,le],ce=q.decorations&&q.decorations.tooltip||"",ye=q.decorations&&!!q.decorations.strikeThrough,H=q.decorations&&!!q.decorations.faded,B=q.contextValue||"";return{rawResource:[K,me,ie,ce,ye,H,B,te],handle:K}});return{start:j.start,deleteCount:j.deleteCount,toInsert:O}}),F=M.map(({start:j,deleteCount:O,toInsert:q})=>[j,O,q.map(K=>K.rawResource)]),U=M.reverse();for(const{start:j,deleteCount:O,toInsert:q}of U){const K=q.map(te=>te.handle),me=this.n.splice(j,O,...K);for(const te of me)this.g.delete(te),this.h.delete(te),this.j.get(te)?.dispose(),this.j.delete(te)}return this.o=D,F}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(D){this.g!==D&&(this.g=D,this.#e.$updateSourceControl(this.x,{count:D}))}get quickDiffProvider(){return this.h}set quickDiffProvider(D){this.h=D;let N;(0,k.$gF)(this.y,"quickDiffProvider")&&(N=D?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!D,quickDiffLabel:N})}get historyProvider(){return(0,k.$hF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(D){(0,k.$hF)(this.y,"scmHistoryProvider"),this.j=D,this.k.value=new R.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!D}),D&&(this.k.value.add(D.onDidChangeCurrentHistoryItemGroup(()=>{u(this.l,D?.currentHistoryItemGroup)||(this.l=D?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(D.onDidChangeActionButton(()=>{(0,k.$hF)(this.y,"scmActionButton"),this.m.value=new R.$Rc;const N=D.actionButton!==void 0?{command:this.z.converter.toInternal(D.actionButton.command,this.m.value),description:D.actionButton.description,enabled:D.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(D){D!==this.n&&(this.n=D,this.#e.$updateSourceControl(this.x,{commitTemplate:D}))}get acceptInputCommand(){return this.p}set acceptInputCommand(D){this.o.value=new R.$Rc,this.p=D;const N=this.z.converter.toInternal(D,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,k.$hF)(this.y,"scmActionButton"),this.s}set actionButton(D){(0,k.$hF)(this.y,"scmActionButton"),this.q.value=new R.$Rc,this.s=D;const N=D!==void 0?{command:this.z.converter.toInternal(D.command,this.q.value),secondaryCommands:D.secondaryCommands?.map(M=>M.map(F=>this.z.converter.toInternal(F,this.q.value))),description:D.description,enabled:D.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(D){if(this.u&&D&&r(this.u,D))return;this.t.value=new R.$Rc,this.u=D;const N=(D||[]).map(M=>this.z.converter.toInternal(M,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(D,N,M,F,U,j,O){this.y=D,this.z=F,this.A=U,this.B=j,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Tc,this.m=new R.$Tc,this.n=void 0,this.o=new R.$Tc,this.p=void 0,this.q=new R.$Tc,this.t=new R.$Tc,this.u=void 0,this.v=!1,this.w=new T.$Nd,this.onDidChangeSelection=this.w.event,this.x=$.d++,this.D=new Map,this.E=new Set,this.#e=M;const q=C.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new I(D,F,N,this.#e,this.x,q),this.#e.$registerSourceControl(this.x,U,j,O,q)}createResourceGroup(D,N){const M=new S(this.#e,this.z,this.x,D,N),F=T.Event.once(M.onDidDispose)(()=>this.D.delete(M));return this.D.set(M,F),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const D=[],N=[];for(const[M,F]of this.D){F.dispose();const U=M.onDidUpdateResourceStates(()=>{this.E.add(M),this.eventuallyUpdateResourceStates()});T.Event.once(M.onDidDispose)(()=>{this.E.delete(M),U.dispose(),this.e.delete(M.handle),this.#e.$unregisterGroup(this.x,M.handle)}),D.push([M.handle,M.id,M.label,M.features]);const j=M._takeResourceStateSnapshot();j.length>0&&N.push([M.handle,j]),this.e.set(M.handle,M)}this.#e.$registerGroups(this.x,D,N),this.D.clear()}eventuallyUpdateResourceStates(){const D=[];this.E.forEach(N=>{const M=N._takeResourceStateSnapshot();M.length!==0&&D.push([N.handle,M])}),D.length>0&&this.#e.$spliceResourceStates(this.x,D),this.E.clear()}getResourceGroup(D){return this.e.get(D)}setSelectionState(D){this.v=D,this.w.fire(D)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(D=>D.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,d.$ih)(100)],$.prototype,"eventuallyAddResourceGroups",null),He([(0,d.$ih)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let g=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(D,N,M,F){this.l=N,this.m=M,this.n=F,this.g=new Map,this.h=new P.$8l,this.j=new T.$Nd,this.e=D.getProxy(m.$lK.MainThreadSCM),this.f=D.getProxy(m.$lK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const j=this.g.get(U.sourceControlHandle);if(!j)return U;const O=j.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const j=this.g.get(U.sourceControlHandle);return j?j.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const j=this.g.get(U.handle);return j||U}return U}})}createSourceControl(D,N,M,F){this.n.trace("ExtHostSCM#createSourceControl",D.identifier.value,N,M,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:D.identifier.value});const U=h.d++,j=new $(D,this.m,this.e,this.l,N,M,F);this.g.set(U,j);const O=this.h.get(D.identifier)||[];return O.push(j),this.h.set(D.identifier,O),j}getLastInputBox(D){this.n.trace("ExtHostSCM#getLastInputBox",D.identifier.value);const N=this.h.get(D.identifier),M=N&&N[N.length-1];return M&&M.inputBox}$provideOriginalResource(D,N,M){const F=C.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",D,F.toString());const U=this.g.get(D);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>U.quickDiffProvider.provideOriginalResource(F,M)).then(j=>j||null)}$onInputBoxValueChange(D,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",D);const M=this.g.get(D);return M&&M.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(D,N,M,F){this.n.trace("ExtHostSCM#$executeResourceCommand",D,N,M);const U=this.g.get(D);if(!U)return Promise.resolve(void 0);const j=U.getResourceGroup(N);return j?j.$executeResourceCommand(M,F):Promise.resolve(void 0)}$validateInput(D,N,M){this.n.trace("ExtHostSCM#$validateInput",D);const F=this.g.get(D);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>F.inputBox.validateInput(N,M)).then(U=>{if(!U)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(U.message);return j?Promise.resolve([j,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(D){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",D),D!==void 0&&this.g.get(D)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=D,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(D,N,M){return await this.g.get(D)?.historyProvider?.resolveHistoryItemGroupBase(N,M)??void 0}async $resolveHistoryItemGroupCommonAncestor(D,N,M,F){return await this.g.get(D)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,M,F)??void 0}async $provideHistoryItems(D,N,M,F){return(await this.g.get(D)?.historyProvider?.provideHistoryItems(N,M,F))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:o(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(D,N,M){return await this.g.get(D)?.historyProvider?.provideHistoryItemChanges(N,M)??void 0}};e.$gdc=g,e.$gdc=g=h=He([Be(3,L.$0i)],g)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=void 0;class R{constructor(m){this.b=new T.$Nd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(C.$lK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,E){return this.a.$getPassword(m,E)}store(m,E,b){return this.a.$setPassword(m,E,b)}delete(m,E){return this.a.$deletePassword(m,E)}}e.$Xcc=R,e.$Ycc=(0,d.$Ph)("IExtHostSecretState")}),define(De[328],Ce([1,0,6,13,2]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class R{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(C.$lK.MainThreadShare)}async $provideShare(m,E,b){return await this.c.get(m)?.provideShare({selection:T.Range.to(E.selection),resourceUri:d.URI.revive(E.resourceUri)},b)??void 0}registerShareProvider(m,E){const b=R.a++;return this.c.set(b,E),this.b.$registerShareProvider(b,T.DocumentSelector.from(m,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$iec=R}),define(De[329],Ce([1,0,21,3,6]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class R{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(d.$lK.MainThreadSpeech)}async $createSpeechToTextSession(m,E){const b=this.c.get(m);if(!b)return;const L=new T.$Rc,P=new C.$Xd;this.d.set(E,P);const v=L.add(b.provideSpeechToTextSession(P.token));L.add(v.onDidChange(y=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),L.add(P.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,E,b){const L=R.a++;return this.c.set(L,b),this.b.$registerProvider(L,E,{extension:m,displayName:m.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$kec=R}),define(De[330],Ce([1,0,7,6,210,3,13,17]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$iL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$iL("statusBarItem.warningForeground")]])}#e;#t;constructor(v,y,k,p,h,s=C.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new R.$Rc,this.#e=v,this.#t=y,h&&p){this.c=(0,C.$XK)(p.identifier,h);const o=k.get(this.c);o&&(s=o.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,a=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=h,this.g=s,this.h=this.u(a)}u(v){if((0,m.$Cf)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!E.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new R.$Rc,typeof v=="string"?this.r={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:this.#t.toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let y;this.m?y=this.m:y=(0,d.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=E.b.get(this.o.id));const p=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,v,this.e?.identifier.value,y,this.k,p,this.r?.internal,k,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$hdc=E;class b{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,d.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const y={message:v};return this.b.unshift(y),this.c(),new C.$nK(()=>{const k=this.b.indexOf(y);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(v,y){this.e=new Map,this.a=v.getProxy(T.$lK.MainThreadStatusBar),this.b=y,this.c=new b(this)}$acceptStaticEntries(v){for(const y of v)this.e.set(y.entryId,y)}createStatusBarEntry(v,y,k,p){return new E(this.a,this.b,this.e,v,y,k,p)}setStatusBarMessage(v,y){const k=this.c.setMessage(v);let p;return typeof y=="number"?p=setTimeout(()=>k.dispose(),y):typeof y<"u"&&y.then(()=>k.dispose(),()=>k.dispose()),new C.$nK(()=>{k.dispose(),clearTimeout(p)})}}e.$idc=L}),define(De[115],Ce([1,0,6,4,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0;class R{constructor(m,E){this.c=E,this.b=new T.$Nd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(C.$lK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,E){this.a.$registerExtensionStorageKeysToSync(m,E)}async initializeExtensionStorage(m,E,b){const L=await this.a.$initializeExtensionStorage(m,E);let P;return L&&(P=this.d(m,E,L)),P||b}setValue(m,E,b){return this.a.$setValue(m,E,b)}$acceptValue(m,E,b){const L=this.d(m,E,b);L&&this.b.fire({shared:m,key:E,value:L})}d(m,E,b){try{return JSON.parse(b)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${m}): ${L}`)}}}e.$Lcc=R,e.$Mcc=(0,d.$Ph)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,14,72,2]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0,e.$Rcc=(0,C.$Ph)("IExtensionStoragePaths");let m=class{constructor(b,L,P){this.d=L,this.f=P,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(b){return A.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,L=await this.g(b);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(A.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(b){if(this.c)return A.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return A.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Scc=m,e.$Scc=m=He([Be(0,T.$CM),Be(1,d.$0i),Be(2,R.$Qcc)],m)}),define(De[45],Ce([1,0,4,6,5,2,20,3,7,212,9,254,21,31,255,59,8,13,34]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=void 0,e.$Tcc=(0,d.$Ph)("IExtHostTerminalService");class o{constructor($,g,w,D){this.l=$,this._id=g,this.m=w,this.n=D,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(M=>this.f=M);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(M,F=!0){N.q(),N.l.$sendText(N._id,M,F)},show(M){N.q(),N.l.$show(N._id,M)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create($,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??void 0,env:$.env??void 0,icon:r($.iconPath)??void 0,color:p.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o($.location,g?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,g,w,D){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:w,color:p.ThemeColor.isThemeColor(D)?D.id:void 0,location:this.o($,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,g){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in $?{viewColumn:s.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,g){this.h=Object.freeze({code:$,reason:g})}setDimensions($,g){return $===this.d&&g===this.g||$===0||g===0?!1:(this.d=$,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(g=>{g!==$&&(this.b=Promise.resolve($))})}}e.$Ucc=o;class f{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new C.$Nd,this.onProcessData=this.a.event,this.b=new C.$Nd,this.d=new C.$Nd,this.onDidChangeProperty=this.d.event,this.f=new C.$Nd,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,g){this.g.setDimensions?.({columns:$,rows:g})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends m.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,g,w){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new C.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new C.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Nd,this.onDidChangeShell=this.N.event,this.O=new C.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(T.$lK.MainThreadTerminalService),this.y=new k.$Zkb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:D=>{const N=M=>{const F=M;return this.W(F.instanceId)?.value};switch(D?.$mid){case 15:return N(D);default:{if(Array.isArray(D))for(let M=0;M<D.length&&D[M].$mid===15;M++)D[M]=N(D[M]);return D}}}}),this.B({dispose:()=>{for(const[D,N]of this.g)N.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,g){const w=new o(this.a,(0,y.$eg)(),$,$.name),D=new f($.pty);return w.createExtensionTerminal($.location,this.R($,g).resolvedExtHostIdentifier,r($.iconPath),u($.color)).then(N=>{const M=this.S(N,D);this.h[N]=M}),this.f.push(w),w.value}R($,g){if(g=g||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const w=$.location.parentTerminal;if(w){const D=this.f.find(N=>N.value===w);D&&(g.resolvedExtHostIdentifier=D._id)}}else $.location&&typeof $.location!="object"?g.location=$.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal($,g){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const D=new f(g),N=this.S($,D);this.h[$]=N}async $acceptActiveTerminalChanged($){const g=this.b;if($===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const w=this.W($);w&&(this.b=w,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,g){const w=this.W($);w&&this.O.fire({terminal:w.value,data:g})}async $acceptTerminalDimensions($,g,w){const D=this.W($);D&&D.setDimensions(g,w)&&this.L.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptDidExecuteCommand($,g){const w=this.W($);w&&this.P.fire({terminal:w.value,...g})}async $acceptTerminalMaximumDimensions($,g,w){this.g.get($)?.resize(g,w)}async $acceptTerminalTitleChange($,g){const w=this.W($);w&&(w.name=g)}async $acceptTerminalClosed($,g,w){const D=this.Y(this.f,$);if(D!==null){const N=this.f.splice(D,1)[0];N.setExitStatus(g,w),this.H.fire(N.value)}}$acceptTerminalOpened($,g,w,D){if(g){const F=this.Y(this.f,g);if(F!==null){this.f[F]._id=$,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const N={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:R.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},M=new o(this.a,$,N,w);this.f.push(M),this.I.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId($,g){this.W($)?._setProcessId(g)}async $startExtensionTerminal($,g){const w=this.W($);if(!w)return{message:(0,b.localize)(0,null,$)};w.isOpen||await new Promise(N=>{const M=this.onDidOpenTerminal(async F=>{F===w.value&&(M.dispose(),N())})});const D=this.g.get($);D?D.startSendingEvents(g):this.j[$]={initialDimensions:g}}S($,g){const w=new m.$Rc;w.add(g.onProcessReady(N=>this.a.$sendProcessReady($,N.pid,N.cwd,N.windowsPty))),w.add(g.onDidChangeProperty(N=>this.a.$sendProcessProperty($,N))),this.y.startBuffering($,g.onProcessData),w.add(g.onProcessExit(N=>this.U($,N))),this.g.set($,g);const D=this.j[$];return D&&g instanceof f&&(g.startSendingEvents(D.initialDimensions),delete this.j[$]),w}$acceptProcessAckDataEvent($,g){this.g.get($)?.acknowledgeDataEvent(g)}$acceptProcessInput($,g){this.g.get($)?.input(g)}$acceptTerminalInteraction($){const g=this.W($);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection($,g){this.W($)?.setSelection(g)}$acceptProcessResize($,g,w){try{this.g.get($)?.resize(g,w)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown($,g){this.g.get($)?.shutdown(g)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(g=>this.a.$sendProcessProperty($,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(g=>this.a.$sendProcessProperty($,{type:"cwd",value:g}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$nK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,g,w){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,w),this.a.$registerProfileProvider(g,$.identifier.value),new E.$nK(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider($,g,w){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,w),this.a.$registerQuickFixProvider($,g),new E.$nK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,g){const w=new v.$Xd().token;if(w.isCancellationRequested)return;const D=this.D.get($);if(!D)return;const N=await D.provideTerminalQuickFixes(g,w);if(N===null||Array.isArray(N)&&N.length===0)return;const M=new m.$Rc;if(this.w.value=M,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,M):void 0;const F=[];for(const U of N){const j=s.TerminalQuickFix.from(U,this.Q.converter,M);j&&F.push(j)}return F}async $createContributedProfileTerminal($,g){const w=new v.$Xd().token;let D=await this.C.get($)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,g);return}this.createTerminalFromOptions(D.options,g)}}async $provideLinks($,g){const w=this.W($);if(!w)return[];this.F.delete($),this.G.get($)?.dispose(!0);const N=new v.$Xd;this.G.set($,N);const M=[],F={terminal:w.value,line:g},U=[];for(const q of this.z)U.push(h.Promises.withAsyncBody(async K=>{N.token.onCancellationRequested(()=>K({provider:q,links:[]}));const me=await q.provideTerminalLinks(F,N.token)||[];N.token.isCancellationRequested||K({provider:q,links:me})}));const j=await Promise.all(U);if(N.token.isCancellationRequested)return[];const O=new Map;for(const q of j)q&&q.links.length>0&&M.push(...q.links.map(K=>{const me={id:l++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return O.set(me.id,{provider:q.provider,link:K}),me}));return this.F.set($,O),M}$activateLink($,g){const w=this.F.get($)?.get(g);w&&w.provider.handleTerminalLink(w.link)}U($,g){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const w=this.h[$];w&&(w.dispose(),delete this.h[$]),this.a.$sendProcessExit($,g)}W($){return this.X(this.f,$)}X($,g){const w=this.Y($,g);return w!==null?$[w]:null}Y($,g){const w=$.findIndex(D=>D._id===g);return w===-1?null:w}getEnvironmentVariableCollection($){let g=this.n.get($.identifier.value);return g||(g=new i,this.$($.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z($,g){const w=(0,P.$kr)(g.map),D=(0,P.$lr)(g.descriptionMap);this.a.$setEnvironmentVariableCollection($,g.persistent,w.length===0?void 0:w,D)}$initEnvironmentVariableCollections($){$.forEach(g=>{const w=g[0],D=new i(g[1]);this.$(w,D)})}$acceptDefaultProfile($,g){const w=this.s;this.s=$,this.u=g,w?.path!==$.path&&this.N.fire($.path)}$($,g){this.n.set($,g),g.onDidChangeCollection(()=>{this.Z($,g)})}};e.$Vcc=t,e.$Vcc=t=He([Be(1,a.$IM),Be(2,A.$mM)],t);class i{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Nd,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const g=this.h($);let w=this.a.get(g);return w||(w=new c(this,$),this.a.set(g,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace($,g,w,D){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:D})}append($,g,w,D){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:D})}prepend($,g,w,D){this.f($,{value:g,type:E.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:D})}f($,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g($,g.scope),D=this.map.get(w),N=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!D||D.value!==g.value||D.type!==g.type||D.options?.applyAtProcessCreation!==N.applyAtProcessCreation||D.options?.applyAtShellIntegration!==N.applyAtShellIntegration||D.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const M=this.g($,g.scope),F={variable:$,...g,options:N};this.map.set(M,F),this.d.fire()}}get($,g){const w=this.g($,g),D=this.map.get(w);return D?I(D):void 0}g($,g){const w=this.h(g);return w.length?`${$}:::${w}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const g=new Map;for(const[w,D]of this.map)this.h(D.scope)===this.h($)&&g.set(D.variable,I(D));return g}delete($,g){const w=this.g($,g);this.map.delete(w),this.d.fire()}clear($){if($?.workspaceFolder){for(const[g,w]of this.map)w.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(g);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,g){const w=this.h(g),D=this.descriptionMap.get(w);if(!D||D.description!==$){let N;typeof $=="string"?N=$:N=$?.value.split(`

`)[0];const M={description:N,scope:g};this.descriptionMap.set(w,M),this.d.fire()}}getDescription($){const g=this.h($);return this.descriptionMap.get(g)?.description}k($){const g=this.h($);this.descriptionMap.delete(g)}}class c{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,g){this.b=$,this.d=g,this.a=new C.$Nd}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,g,w){this.b.replace($,g,w,this.d)}append($,g,w){this.b.append($,g,w,this.d)}prepend($,g,w){this.b.prepend($,g,w,this.d)}get($){return this.b.get($,this.d)}forEach($,g){this.b.getVariableMap(this.d).forEach((w,D)=>$.call(g,D,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let n=class extends t{constructor($,g){super(!1,$,g)}createTerminal($,g,w){throw new L.$_}createTerminalFromOptions($,g){throw new L.$_}};e.$Wcc=n,e.$Wcc=n=He([Be(0,a.$IM),Be(1,A.$mM)],n);function r(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function u(S){return p.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const $={...S};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(De[331],Ce([1,0,118,8,22,21,4,75,52,3,24,17,31,6,20,147,13,7,68,109,87]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=e.$5dc=e.$4dc=void 0;let l=class{constructor(M,F,U){this.j=U,this.c=new A.$Nd,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(y.$lK.MainThreadTesting),this.h=new g(this.f),this.g=new n(this.f),F.registerArgumentProcessor({processArgument:j=>{switch(j?.$mid){case 16:{const O=j,q=O.tests[O.tests.length-1].item.extId;return this.d.get(a.$eJ.root(q))?.collection.tree.get(q)?.actual??(0,p.$yM)(j)}case 18:{const{extId:O,message:q}=j;return{test:this.d.get(a.$eJ.root(O))?.collection.tree.get(O)?.actual,message:h.TestMessage.to(q)}}default:return j}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await F.executeCommand("_testing.getExplorerSelection"),O=q=>{const K=this.d.get(a.$eJ.root(q));if(K)return a.$eJ.isRoot(q)?K.controller:K.collection.tree.get(q)?.actual};return{include:j?.include.map(O).filter(P.$Gf)||[],exclude:j?.exclude.map(O).filter(P.$Gf)||[]}})}createTestController(M,F,U,j){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const O=new b.$Rc,q=O.add(new p.$BM(F,U,this.j));q.root.label=U;const K=new Map,me=this.f,te={items:q.root.children,get label(){return U},set label(Q){U=Q,q.root.label=Q,me.$updateController(F,{label:U})},get refreshHandler(){return j},set refreshHandler(Q){j=Q,me.$updateController(F,{canRefresh:!!Q})},get id(){return F},createRunProfile:(Q,le,ie,ce,ye,H)=>{let B=(0,E.$Di)(Q);for(;K.has(B);)B++;return new w(this.f,K,F,B,Q,le,ie,ce,ye,H)},createTestItem(Q,le,ie){return new p.$zM(F,Q,le,ie)},createTestRun:(Q,le,ie=!0)=>this.g.createTestRun(M,F,q,Q,le,ie),invalidateTestResults:Q=>{if(Q===void 0)this.f.$markTestRetired(void 0);else{const le=Q instanceof Array?Q:[Q];this.f.$markTestRetired(le.map(ie=>a.$eJ.fromExtHostTestItem(ie,F).toString()))}},set resolveHandler(Q){q.resolveHandler=Q},get resolveHandler(){return q.resolveHandler},dispose:()=>{O.dispose()}};me.$registerTestController(F,U,!!j),O.add((0,b.$Qc)(()=>me.$unregisterTestController(F)));const G={controller:te,collection:q,profiles:K,extension:M};return this.d.set(F,G),O.add((0,b.$Qc)(()=>this.d.delete(F))),O.add(q.onDidGenerateDiff(Q=>me.$publishDiff(F,Q.map(f.TestsDiffOp.serialize)))),te}createTestObserver(){return this.h.checkout()}async runTests(M,F=R.CancellationToken.None){const U=r(M);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(U.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(O=>a.$eJ.fromExtHostTestItem(O,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:D[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:M.exclude?.map(O=>O.id)},F)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,F,U){return(0,C.$rb)(this.g.trackers,O=>O.id===M?O.getCoverage(F):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(M,F,U,j){return(0,C.$rb)(this.g.trackers,q=>q.id===M?q.getCoverage(F):void 0)?.resolveFileCoverage(U,j)??Promise.resolve([])}$configureRunProfile(M,F){this.d.get(M)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(M,F){await this.d.get(M)?.controller.refreshHandler?.(F)}$publishTestResults(M){this.results=Object.freeze(M.map(F=>(0,L.$8m)(h.TestResults.to(F))).concat(this.results).sort((F,U)=>U.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,F){const U=this.d.get(a.$eJ.fromString(M).controllerId)?.collection;U&&(await U.expand(M,F<0?1/0:F),U.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(f.TestsDiffOp.deserialize))}async $runControllerTests(M,F){return Promise.all(M.map(U=>this.k(U,!1,F)))}async $startContinuousRun(M,F){const U=new R.$Xd(F),j=await Promise.all(M.map(O=>this.k(O,!0,U.token)));return!F.isCancellationRequested&&!j.some(O=>O.error)&&await new Promise(O=>F.onCancellationRequested(O)),U.dispose(!0),j}async k(M,F,U){const j=this.d.get(M.controllerId);if(!j)return{};const{collection:O,profiles:q,extension:K}=j,me=q.get(M.profileId);if(!me)return{};const te=M.testIds.map(ie=>O.tree.get(ie)).filter(P.$Gf),G=M.excludeExtIds.map(ie=>j.collection.tree.get(ie)).filter(P.$Gf).filter(ie=>te.some(ce=>ce.fullId.compare(ie.fullId)===2));if(!te.length)return{};const Q=new s.$VL(te.some(ie=>ie.actual instanceof p.$AM)?void 0:te.map(ie=>ie.actual),G.map(ie=>ie.actual),me,F),le=(0,f.$gJ)(M)&&this.g.prepareForMainThreadTestRun(Q,u.fromInternal(M,j.collection),K,U);try{return await me.runHandler(Q,U),{}}catch(ie){return{error:String(ie)}}finally{le&&(le.hasRunningTasks&&!U.isCancellationRequested&&await A.Event.toPromise(le.onEnd),le.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};e.$4dc=l,e.$4dc=l=He([Be(0,k.$mM)],l);const t=1e4;var i;(function(N){N[N.Running=0]="Running",N[N.Cancelling=1]="Cancelling",N[N.Ended=2]="Ended"})(i||(i={}));class c extends b.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,F,U){super(),this.m=M,this.s=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Nd),this.onEnd=this.j.event,this.h=this.B(new R.$Xd(U));const j=this.B(new T.$6g(()=>this.u(),t));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const F=this.m.id,U=this.m.controllerId,j=(0,v.$eg)(),O=new I(this.s,F,j),q=G=>(Q,...le)=>{if(me){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}this.m.isIncluded(Q)&&(this.y(Q),G(Q,...le))},K=(G,Q)=>{const le=Q instanceof Array?Q.map(h.TestMessage.from):[h.TestMessage.from(Q)];if(G.uri&&G.range){const ie={range:h.Range.from(G.range),uri:G.uri};for(const ce of le)ce.location=ce.location||ie}this.s.$appendTestMessagesInRun(F,j,a.$eJ.fromExtHostTestItem(G,U).toString(),le)};let me=!1;const te={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return O.coverageProvider},set coverageProvider(G){O.coverageProvider=G},enqueued:q(G=>{this.s.$updateTestStateInRun(F,j,a.$eJ.fromExtHostTestItem(G,U).toString(),1)}),skipped:q(G=>{this.s.$updateTestStateInRun(F,j,a.$eJ.fromExtHostTestItem(G,U).toString(),5)}),started:q(G=>{this.s.$updateTestStateInRun(F,j,a.$eJ.fromExtHostTestItem(G,U).toString(),2)}),errored:q((G,Q,le)=>{K(G,Q),this.s.$updateTestStateInRun(F,j,a.$eJ.fromExtHostTestItem(G,U).toString(),6,le)}),failed:q((G,Q,le)=>{K(G,Q),this.s.$updateTestStateInRun(F,j,a.$eJ.fromExtHostTestItem(G,U).toString(),4,le)}),passed:q((G,Q)=>{this.s.$updateTestStateInRun(F,j,a.$eJ.fromExtHostTestItem(G,this.m.controllerId).toString(),3,Q)}),appendOutput:(G,Q,le)=>{me||(le&&(this.m.isIncluded(le)?this.y(le):le=void 0),this.s.$appendOutputToRun(F,j,d.$be.fromString(G),Q&&h.location.from(Q),le&&a.$eJ.fromExtHostTestItem(le,U).toString()))},end:()=>{me||(me=!0,this.s.$finishedTestRunTask(F,j),this.f.delete(j),this.f.size||this.w())}};return this.f.set(j,{run:te,coverage:O}),this.s.$startedTestRunTask(F,{id:j,name:M,running:!0}),te}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof p.$zM))throw new o.$eM(M.id);if(this.g.has(a.$eJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const F=[],U=this.m.colllection.root;for(;;){const j=h.TestItem.from(M);if(F.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),M===U))break;M=M.parent||U}this.s.$addTestsToRun(this.m.controllerId,this.m.id,F)}dispose(){this.w(),super.dispose()}}class n{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,F,U,j){return this.f(M,F,U,j)}cancelRunById(M){for(const F of this.c.values())if(F.id===M){F.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,F,U,j,O,q){const K=this.c.get(j);if(K)return K.createRun(O);const me=u.fromPublic(F,U,j,q),te=r(j);this.d.$startedExtensionTestRun({controllerId:F,continuous:!!j.continuous,profile:te&&{group:D[te.kind],id:te.profileId},exclude:j.exclude?.map(Q=>a.$eJ.fromExtHostTestItem(Q,U.root.id).toString())??[],id:me.id,include:j.include?.map(Q=>a.$eJ.fromExtHostTestItem(Q,U.root.id).toString())??[U.root.id],persist:q});const G=this.f(j,me,M);return A.Event.once(G.onEnd)(()=>{this.d.$finishedExtensionTestRun(me.id),G.dispose()}),G.createRun(O)}f(M,F,U,j){const O=new c(F,this.d,j);return this.c.set(M,O),A.Event.once(O.onEnd)(()=>this.c.delete(M)),O}}e.$5dc=n;const r=N=>{if(N.profile){if(!(N.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class u{static fromPublic(M,F,U,j){return new u(M,(0,v.$eg)(),U.include?.map(O=>a.$eJ.fromExtHostTestItem(O,M).toString())??[M],U.exclude?.map(O=>a.$eJ.fromExtHostTestItem(O,M).toString())??[],j,F)}static fromInternal(M,F){return new u(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,F)}constructor(M,F,U,j,O,q){this.controllerId=M,this.id=F,this.isPersisted=O,this.colllection=q,this.c=U.map(K=>K+"\0"),this.d=j.map(K=>K+"\0")}isIncluded(M){const F=a.$eJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const U of this.d)if(F===U||F.startsWith(U))return!1;for(const U of this.c)if(F===U||F.startsWith(U))return!0;return!1}}e.$6dc=u;class I{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,F,U){this.f=M,this.g=F,this.h=U}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(h.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(M,F){const U=await this.d;let j=U?.[M];return!this.c||!U||!j?[]:(j.detailedCoverage||(j=U[M]=await this.c.resolveFileCoverage?.(j,F)??j),j.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class S{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,h.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const F=a.$eJ.parentId(M.item.extId);if(F&&this.g.has(F.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:F,f:U}=this;return{get added(){return[...M].map(j=>j.revived)},get updated(){return[...F].map(j=>j.revived)},get removed(){return[...U].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class $ extends f.$lJ{constructor(){super(...arguments),this.q=new A.$Nd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,F){return{...M,revived:h.TestItem.toPlain(M.item),depth:F?F.depth+1:0,children:new Set}}o(){return new S(this.q)}}class g{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(F=>F.revived)},dispose:(0,m.$db)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new $;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class w{#e;#t;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?h.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,F,U,j,O,q,K,me=!1,te=void 0,G=!1){this.controllerId=U,this.profileId=j,this.d=O,this.kind=q,this.runHandler=K,this.f=me,this._tag=te,this.g=G,this.#e=M,this.#t=F,F.set(j,this);const Q=D[q];if(typeof Q!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);this.#e.$publishTestRunProfile({profileId:j,controllerId:U,tag:te?h.TestTag.namespace(this.controllerId,te.id):null,label:O,group:Q,isDefault:me,hasConfigurationHandler:!1,supportsContinuousRun:G})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$7dc=w;const D={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(De[332],Ce([1,0,19,9,4,6,148,13,7]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class b{constructor(P,v){this.i=v,this.a=new d.$Nd({onListenerError:T.$2}),this.b=new d.$Nd({onListenerError:T.$2}),this.c=new d.$Nd({onListenerError:T.$2}),this.d=new d.$Nd({onListenerError:T.$2}),this.f=new d.$Nd({onListenerError:T.$2}),this.g=new d.$Nd({onListenerError:T.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(R.$lK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const v=this.i.allEditors();return P?v:v.map(y=>y.value)}async showTextDocument(P,v,y){let k;typeof v=="number"?k={position:m.ViewColumn.from(v),preserveFocus:y}:typeof v=="object"?k={position:m.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?m.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:k={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(P.uri,k),h=p&&this.i.getEditor(p);if(h)return h.value;throw p?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,v){return new A.$tM(this.h,P,v).value}$acceptEditorPropertiesChanged(P,v){const y=this.i.getEditor(P);if(!y)throw new Error("unknown text editor");if(v.options&&y._acceptOptions(v.options),v.selections){const k=v.selections.selections.map(m.Selection.to);y._acceptSelections(k)}if(v.visibleRanges){const k=C.$Hb(v.visibleRanges.map(m.Range.to));y._acceptVisibleRanges(k)}if(v.options&&this.b.fire({textEditor:y.value,options:{...v.options,lineNumbers:m.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const k=E.TextEditorSelectionChangeKind.fromValue(v.selections.source),p=v.selections.selections.map(m.Selection.to);this.a.fire({textEditor:y.value,selections:p,kind:k})}if(v.visibleRanges){const k=C.$Hb(v.visibleRanges.map(m.Range.to));this.c.fire({textEditor:y.value,visibleRanges:k})}}$acceptEditorPositionData(P){for(const v in P){const y=this.i.getEditor(v);if(!y)throw new Error("Unknown text editor");const k=m.ViewColumn.to(P[v]);y.value.viewColumn!==k&&(y._acceptViewColumn(k),this.d.fire({textEditor:y.value,viewColumn:k}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$jdc=b}),define(De[333],Ce([1,0,2,5,6,3,7,13,25,17]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=void 0,e.$Xdc=(0,T.$Ph)("IExtHostTimeline");class L{constructor(y,k){this.b=new Map,this.c=new Map,this.a=y.getProxy(d.$lK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(p,h)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$6l.equals(h,this.b.get(p.source)?.extension)){const s=p.uri===void 0?void 0:C.URI.revive(p.uri);return this.c.get(p.source)?.get(P(s))?.get(p.handle)}else return;return p}})}async $getTimeline(y,k,p,h){return this.b.get(y)?.provider.provideTimeline(C.URI.revive(k),p,h)}registerTimelineProvider(y,k,p,h){const s=new R.$Rc,a=this.d(k.id,h,s).bind(this);let o;k.onDidChange&&(o=k.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:k.id}),this));const f=this.c;return this.f({...k,scheme:y,onDidChange:void 0,async provideTimeline(l,t,i){t?.resetCache&&(s.clear(),f.get(k.id)?.clear());const c=await k.provideTimeline(l,t,i);if(c==null)return;const n=a(l,t);return{...c,source:k.id,items:c.items.map(n)}},dispose(){for(const l of f.values())l.get(k.id)?.clear();o?.dispose(),s.dispose()}},p)}d(y,k,p){return(h,s)=>{let a;if(s?.cacheResults){let o=this.c.get(y);o===void 0&&(o=new Map,this.c.set(y,o));const f=P(h);a=o.get(f),a===void 0&&(a=new Map,o.set(f,a))}return o=>{const{iconPath:f,...l}=o,t=`${y}|${o.id??o.timestamp}`;a?.set(t,o);let i,c,n;o.iconPath&&(f instanceof A.$hL?n={id:f.id,color:f.color}:C.URI.isUri(f)?(i=f,c=f):{light:i,dark:c}=f);let r;return A.$NK.isMarkdownString(l.tooltip)?r=m.MarkdownString.from(l.tooltip):(0,b.$yf)(l.tooltip)?r=l.tooltip:A.$NK.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=m.MarkdownString.from(l.detail)):(0,b.$yf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=l.detail),{...l,id:l.id??void 0,handle:t,source:y,command:o.command?k.toInternal(o.command,p):void 0,icon:i,iconDark:c,themeIcon:n,tooltip:r,accessibilityInformation:o.accessibilityInformation}}}}f(y,k){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:k}),(0,R.$Qc)(()=>{for(const h of this.c.values())h.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$Ydc=L;function P(v){return v?.toString()}}),define(De[73],Ce([1,0,21,4,3,214,5,14,86,6,27,20,7]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dwb=e.$cwb=e.TunnelDtoConverter=void 0;class y extends E.$gv{}var k;(function(h){function s(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:o.protocol}}h.fromApiTunnel=s;function a(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==E.TunnelPrivacyId.ConstantPrivate&&o.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}h.fromServiceTunnel=a})(k||(e.TunnelDtoConverter=k={})),e.$cwb=(0,A.$Ph)("IExtHostTunnelService");let p=class extends d.$Sc{constructor(s,a,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(b.$lK.MainThreadTunnelService)}async openTunnel(s,a){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const o=await this.a.$openTunnel(a,s.displayName);if(o){const f=new y(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(f),f}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,a){const o=this.u();return this.r.set(o,{selector:s,provider:a}),this.a.$registerPortsAttributesProvider(s,o),new v.$nK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(s,a,o,f,l){const t=[];for(const c of s){const n=this.r.get(c);if(!n)return[];t.push(...await Promise.all(a.map(async r=>{let u;try{u=await n.provider.providePortAttributes({port:r,pid:o,commandLine:f},l)}catch{u=await n.provider.providePortAttributes(r,o,f,l)}return{providedAttributes:u,port:r}})))}const i=t.filter(c=>!!c.providedAttributes);return i.length>0?i.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(f,l)=>await s.provideTunnel(f,l,new C.$Xd().token)??void 0;const o=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,d.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,a){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const o=s.tunnelFactory??(a?this.w(a):void 0);if(o){this.b=o;let f=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const l=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:f}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,d.$Qc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,a){if(this.g.has(s.host)){const o=this.g.get(s.host);o.has(s.port)&&(a&&o.get(s.port).disposeListener.dispose(),await o.get(s.port).tunnel.dispose(),o.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,a){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(s,a);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const f=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),f===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const l=this.B(f.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(f.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:f,disposeListener:l}),k.fromApiTunnel(f)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(s){const a=await Promise.all(s.map(f=>this.f(f.host,f.port,f.detail??""))),o=s.filter((f,l)=>a[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(f=>f.port).join(", ")} to ${o.map(f=>f.port).join(", ")}`),o}};e.$dwb=p,e.$dwb=p=He([Be(0,P.$mM),Be(1,L.$CM),Be(2,m.$0i)],p)}),define(De[334],Ce([1,0,3,18,2,6]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(R.$lK.MainThreadUriOpeners)}registerExternalUriOpener(E,b,L,P){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const v=P.schemes.find(y=>!A.a.has(y));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(b,L),this.b.$registerUriOpener(b,P.schemes,E,P.label),(0,C.$Qc)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(E,b,L){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const v=d.URI.revive(b);return P.canOpenExternalUri(v,L)}async $openUri(E,b,L){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(d.URI.revive(b.resolvedUri),{sourceUri:d.URI.revive(b.sourceUri)},L)}}e.$8dc=A}),define(De[335],Ce([1,0,6,2,3,9,25]),function($e,e,C,T,d,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class m{static{this.a=0}constructor(b){this.c=new A.$7l,this.d=new Map,this.b=b.getProxy(C.$lK.MainThreadUrls)}registerUriHandler(b,L){const P=b.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const v=m.a++;return this.c.add(P),this.d.set(v,L),this.b.$registerUriHandler(v,P,b.displayName||b.name),(0,d.$Qc)(()=>{this.c.delete(P),this.d.delete(v),this.b.$unregisterUriHandler(v)})}$handleExternalUri(b,L){const P=this.d.get(b);if(!P)return Promise.resolve(void 0);try{P.handleUri(T.URI.revive(L))}catch(v){(0,R.$1)(v)}return Promise.resolve(void 0)}async createAppUri(b){return T.URI.revive(await this.b.$createAppUri(b))}}e.$ldc=m}),define(De[91],Ce([1,0,4,3,18,24,2,229,266,110,6]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.$odc=e.$ndc=e.$mdc=void 0;class P{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(f,l,t,i,c,n,r){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Nd,this._onDidDispose=this.#h.event,this.#e=f,this.#t=l,this.#r=t,this.#l=i,this.#u=c,this.#n=n,this.#c=v(n),this.#d=y(n),this.#i=r}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return this.#a=!0,(0,b.$dpb)(f,this.#l)}get cspSource(){const f=this.#n.extensionLocation;if(f.scheme===d.Schemas.https||f.scheme===d.Schemas.http){let l=f.toString();return l.endsWith("/")||(l+="/"),l+" "+b.$cpb}return b.$cpb}get html(){return this.a(),this.#s}set html(f){this.a(),this.#s!==f&&(this.#s=f,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(f)))}get options(){return this.a(),this.#r}set options(f){this.a(),R.$$m(this.#r,f)||this.#t.$setOptions(this.#e,h(this.#n,this.#u,f)),this.#r=f}async postMessage(f){if(this.#o)return!1;const l=(0,E.$Ecb)(f,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(f){if(!this.#d)return f;const l=this.#n.extensionLocation?.scheme===d.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===d.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,c,n,r,u,I)=>{const S=A.URI.from({scheme:r||"file",path:decodeURIComponent(u)}),$=(0,b.$dpb)(S,{isRemote:l,authority:t}).toString();return`${c}${$}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,c,n,r,u,I)=>{const S=A.URI.from({scheme:r||"file",path:decodeURIComponent(u)}),$=(0,b.$dpb)(S,{isRemote:l,authority:t}).toString();return`${c}${$}${I}`})}}e.$mdc=P;function v(o){try{const f=(0,m.$No)((0,m.$Mo)(o.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.$ndc=v;function y(o){try{const f=(0,m.$No)((0,m.$Mo)(o.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class k extends T.$Sc{constructor(f,l,t,i,c){super(),this.c=l,this.f=t,this.g=i,this.h=c,this.b=new Map,this.a=f.getProxy(L.$lK.MainThreadWebviews)}dispose(){super.dispose();for(const f of this.b.values())f.dispose();this.b.clear()}$onMessage(f,l,t){const i=this.j(f);if(i){const{message:c}=(0,E.$Fcb)(l,t.value);i._onMessageEmitter.fire(c)}}$onMissingCsp(f,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,l,t){const i=new P(f,this.a,s(l),this.c,this.f,t,this.h);this.b.set(f,i);const c=i._onDidDispose(()=>{c.dispose(),this.deleteWebview(f)});return i}deleteWebview(f){this.b.delete(f)}j(f){return this.b.get(f)}}e.$odc=k;function p(o){return{id:o.identifier,location:o.extensionLocation}}e.$pdc=p;function h(o,f,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||a(o,f)}}e.$qdc=h;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(f=>A.URI.from(f))}}function a(o,f){return[...(f?.getWorkspaceFolders()||[]).map(l=>l.uri),o.extensionLocation]}}),define(De[336],Ce([1,0,21,52,3,18,23,2,13,91,107,6,7]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class y{constructor(i,c){this.document=i,this.b=c,this.a=1,this.c=new L.$icc("custom documents")}addEdit(i){return this.c.add([i])}async undo(i,c){await this.f(i).undo(),c||this.disposeBackup()}async redo(i,c){await this.f(i).redo(),c||this.disposeBackup()}disposeEdits(i){for(const c of i)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const i=l(this.document.uri)+this.a++;return(0,A.$vg)(this.b,i)}updateBackup(i){this.d?.delete(),this.d=i}disposeBackup(){this.d?.delete(),this.d=void 0}f(i){const c=this.c.get(i,0);if(!c)throw new Error("No edit found");return c}}class k{constructor(){this.a=new Map}get(i,c){return this.a.get(this.b(i,c))}add(i,c,n){const r=this.b(i,c.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${i} resource:${c.uri}`);const u=new y(c,n);return this.a.set(r,u),u}delete(i,c){const n=this.b(i,c.uri);this.a.delete(n)}b(i,c){return`${i}@@@${c}`}}var p;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(p||(p={}));class h{constructor(){this.a=new Map}addTextProvider(i,c,n){return this.b(0,i,c,n)}addCustomProvider(i,c,n){return this.b(1,i,c,n)}get(i){return this.a.get(i)}b(i,c,n,r){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:i,extension:n,provider:r}),new v.$nK(()=>this.a.delete(c))}}class s{constructor(i,c,n,r,u){this.d=c,this.f=n,this.g=r,this.h=u,this.b=new h,this.c=new k,this.a=i.getProxy(P.$lK.MainThreadCustomEditors)}registerCustomEditorProvider(i,c,n,r){const u=new d.$Rc;return o(n)?(u.add(this.b.addTextProvider(c,i,n)),this.a.$registerTextEditorProvider((0,b.$pdc)(i),c,r.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,b.$ndc)(i))):(u.add(this.b.addCustomProvider(c,i,n)),a(n)&&u.add(n.onDidChangeCustomDocument(I=>{const S=this.i(c,I.document.uri);if(f(I)){const $=S.addEdit(I);this.a.$onDidEdit(I.document.uri,c,$,I.label)}else this.a.$onContentChange(I.document.uri,c)})),this.a.$registerCustomEditorProvider((0,b.$pdc)(i),c,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,b.$ndc)(i))),v.$nK.from(u,new v.$nK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(i,c,n,r,u){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${c}'`);const S=m.URI.revive(i),$=await I.provider.openCustomDocument(S,{backupId:n,untitledDocumentData:r?.buffer},u);let g;return a(I.provider)&&this.f&&(g=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(c,$,g),{editable:a(I.provider)}}async $disposeCustomDocument(i,c){const n=this.b.get(c);if(!n)throw new Error(`No provider found for '${c}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${c}'`);const r=m.URI.revive(i),{document:u}=this.i(c,r);this.c.delete(c,u),u.dispose()}async $resolveCustomEditor(i,c,n,r,u,I){const S=this.b.get(n);if(!S)throw new Error(`No provider found for '${n}'`);const $=E.ViewColumn.to(u),g=this.g.createNewWebview(c,r.contentOptions,S.extension),w=this.h.createNewWebviewPanel(c,n,r.title,$,r.options,g,r.active),D=m.URI.revive(i);switch(S.type){case 1:{const{document:N}=this.i(n,D);return S.provider.resolveCustomEditor(N,w,I)}case 0:{const N=this.d.getDocument(D);return S.provider.resolveCustomTextEditor(N,w,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,c,n){this.i(c,i).disposeEdits(n)}async $onMoveCustomEditor(i,c,n){const r=this.b.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const u=this.h.getWebviewPanel(i);if(!u)throw new Error("No webview found");const I=m.URI.revive(c),S=this.d.getDocument(I);await r.provider.moveCustomTextEditor(S,u,C.CancellationToken.None)}async $undo(i,c,n,r){return this.i(c,i).undo(n,r)}async $redo(i,c,n,r){return this.i(c,i).redo(n,r)}async $revert(i,c,n){const r=this.i(c,i);await this.j(c).revertCustomDocument(r.document,n),r.disposeBackup()}async $onSave(i,c,n){const r=this.i(c,i);await this.j(c).saveCustomDocument(r.document,n),r.disposeBackup()}async $onSaveAs(i,c,n,r){const u=this.i(c,i);return this.j(c).saveCustomDocumentAs(u.document,m.URI.revive(n),r)}async $backup(i,c,n){const r=this.i(c,i),I=await this.j(c).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},n);return r.updateBackup(I),I.id}i(i,c){const n=this.c.get(i,m.URI.revive(c));if(!n)throw new Error("No custom document found");return n}j(i){const n=this.b.get(i)?.provider;if(!n||!a(n))throw new Error("Custom document is not editable");return n}}e.$2dc=s;function a(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function f(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const i=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Di)(i)+""}}),define(De[337],Ce([1,0,4,3,2,31,13,91,6,7]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class L extends T.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(k,p,h,s){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=p,this.#l=h,this.#i=s.viewType,this.#u=s.panelOptions,this.#r=s.viewColumn,this.#n=s.title,this.#a=s.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#s}set iconPath(k){this.c(),this.#s!==k&&(this.#s=k,this.#t.$setIconPath(this.#e,d.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(k){this.#c||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#a=k.active,this.#o=k.visible,this.#r=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:A.ViewColumn.from(k),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class P extends T.$Sc{static c(){return(0,R.$eg)()}constructor(k,p,h){super(),this.j=p,this.m=h,this.g=new Map,this.h=new Map,this.f=k.getProxy(E.$lK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,p,h,s,a={}){const o=typeof s=="object"?s.viewColumn:s,f={viewColumn:A.ViewColumn.from(o),preserveFocus:typeof s=="object"&&!!s.preserveFocus},l=(0,m.$ndc)(k),t=P.c();this.f.$createWebviewPanel((0,m.$pdc)(k),t,p,{title:h,panelOptions:v(a),webviewOptions:(0,m.$qdc)(k,this.m,a),serializeBuffersForPostMessage:l},f);const i=this.j.createNewWebview(t,a,k);return this.createNewWebviewPanel(t,p,h,o,a,i,!0)}$onDidChangeWebviewPanelViewStates(k){const p=Object.keys(k);p.sort((h,s)=>{const a=k[h],o=k[s];return a.active?1:o.active?-1:+a.visible-+o.visible});for(const h of p){const s=this.getWebviewPanel(h);if(!s)continue;const a=k[h];s._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,p,h){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:h,extension:k}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,m.$ndc)(k)}),new b.$nK(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(k,p,h,s){const a=this.h.get(p);if(!a)throw new Error(`No serializer found for '${p}'`);const{serializer:o,extension:f}=a,l=this.j.createNewWebview(k,h.webviewOptions,f),t=this.createNewWebviewPanel(k,p,h.title,s,h.panelOptions,l,h.active);await o.deserializeWebviewPanel(t,h.state)}createNewWebviewPanel(k,p,h,s,a,o,f){const l=new L(k,this.f,o,{viewType:p,title:h,viewColumn:s,panelOptions:a,active:f});return this.g.set(k,l),l}getWebviewPanel(k){return this.g.get(k)}}e.$1dc=P;function v(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(De[338],Ce([1,0,4,3,91,13,6,7]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class E extends T.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(P,v,y,k,p,h){super(),this.#u=!1,this.#a=this.B(new C.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$Nd),this.onDidDispose=this.#c.event,this.#i=y,this.#s=k,this.#e=P,this.#t=v,this.#l=p,this.#n=h}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#r}set description(P){this.a(),this.#r!==P&&(this.#r=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#u||(this.#n=P,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(P){this.a(),!(P?.value===this.#o?.value&&P?.tooltip===this.#o?.tooltip)&&(this.#o=R.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#u)throw new Error("Webview is disposed")}}class b{constructor(P,v){this.d=v,this.b=new Map,this.c=new Map,this.a=P.getProxy(A.$lK.MainThreadWebviewViews)}registerWebviewViewProvider(P,v,y,k){if(this.b.has(v))throw new Error(`View provider for '${v}' already registered`);return this.b.set(v,{provider:y,extension:P}),this.a.$registerWebviewViewProvider((0,d.$pdc)(P),v,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.$ndc)(P)}),new m.$nK(()=>{this.b.delete(v),this.a.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(P,v,y,k,p){const h=this.b.get(v);if(!h)throw new Error(`No view provider found for '${v}'`);const{provider:s,extension:a}=h,o=this.d.createNewWebview(P,{},a),f=new E(P,this.a,v,y,o,!0);this.c.set(P,f),await s.resolveWebviewView(f,{state:k},p)}async $onDidChangeWebviewViewVisibility(P,v){this.e(P)._setVisible(v)}async $disposeWebviewView(P){const v=this.e(P);this.c.delete(P),v.dispose(),this.d.deleteWebview(P)}e(P){const v=this.c.get(P);if(!v)throw new Error("No webview found");return v}}e.$Zdc=b}),define(De[151],Ce([1,0,4,6,2,18,15,5,20,26]),function($e,e,C,T,d,R,A,m,E,b){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=void 0;let P=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(y){const k=this.d;return{get focused(){return k.focused},get active(){return(0,b.$hF)(y,"windowActivity"),k.active}}}constructor(y){this.c=new C.$Nd,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=y.getProxy(T.$lK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:p})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,k){k!==this.d[y]&&(this.d={...this.d,[y]:k},this.c.fire(this.d))}openUri(y,k){let p;if(typeof y=="string"){p=y;try{y=d.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.$Be)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,p,k)}async asExternalUri(y,k){if((0,A.$Be)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(y,k);return d.URI.from(p)}};e.$rdc=P,e.$rdc=P=L=He([Be(0,E.$mM)],P),e.$sdc=(0,m.$Ph)("IExtHostWindow")}),define(De[339],Ce([1,0,306,27,20]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;const R=1024*1024;let A=class extends C.$sec{constructor(E,b){super(E,b),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,b,L){const P=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),b.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,b){const L=process[E],P=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(y,k,p)=>{if(!this.g){v+=y.toString(k);const h=v.length>R?v.length:v.lastIndexOf(`
`);h!==-1&&(console[b](v.slice(0,h)),v=v.slice(h+1))}P.call(L,y,k,p)}})}};e.$4ec=A,e.$4ec=A=He([Be(0,d.$mM),Be(1,T.$CM)],A)}),define(De[340],Ce([1,0,72,18,14,241,30,12]),function($e,e,C,T,d,R,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;let E=class{constructor(P,v){P.addFileSystemProvider(T.Schemas.file,new b(v),{isCaseSensitive:m.$l})}};e.$5ec=E,e.$5ec=E=He([Be(0,C.$Qcc),Be(1,d.$0i)],E);class b{constructor(P){this.b=P,this.a=new R.$aq(this.b)}async stat(P){const v=await this.a.stat(P);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,v,y){return this.a.writeFile(P,v,{...y,unlock:!1,atomic:!1})}delete(P,v){return this.a.delete(P,{...v,useTrash:!1,atomic:!1})}rename(P,v,y){return this.a.rename(P,v,y)}copy(P,v,y){return this.a.copy(P,v,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,v){throw new Error("Method not implemented.")}}}),define(De[341],Ce([1,0,16,63,31,34,3,6,2,20]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;let L=class extends A.$Sc{constructor(v,y){super();const k=v.getProxy(m.$lK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async p=>{const h=E.URI.file((0,C.$jc)((0,T.tmpdir)(),(0,d.$eg)()));return await k.$download(p,h),h})}};e.$3ec=L,e.$3ec=L=He([Be(0,b.$mM),Be(1,R.$IM)],L)}),define(De[342],Ce([1,0,150,18,243,31]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class A extends C.$rec{s(E,b,L){return E.scheme===T.Schemas.file?new d.$yN(L?.name||(0,R.$eg)(),E.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,b):super.s(E,b,L)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$dfc=A}),define(De[343],Ce([1,0,53,16,2,90,3,18,8,29]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class L extends R.$Scc{constructor(){super(...arguments),this.i=null}async g(t){const i=await super.g(t);if(i.scheme!==m.Schemas.file)return i;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${i.fsPath}.`),i;const c=i.fsPath;let n=0;do{let r;n===0?r=c:r=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${n}`:`${c}-${n}`,await P(r);const u=T.$jc(r,"vscode.lock"),I=await p(this.d,u,!1);if(I)return this.i=I,process.on("exit",()=>{I.dispose()}),d.URI.file(r);n++}while(n<10);return i}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$cfc=L;async function P(l){try{await b.Promises.stat(l);return}catch{}try{await b.Promises.mkdir(l,{recursive:!0})}catch{}}const v=1e3,y=10*60*1e3;class k extends A.$Sc{constructor(t,i){super(),this.b=t,this.c=i,this.a=this.B(new E.$5g),this.a.cancelAndSet(async()=>{const c=await h(t,i);(!c||c.pid!==process.pid)&&(t.info(`Lock '${i}': The lock was lost unexpectedly.`),this.a.cancel());try{await b.Promises.utimes(i,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${i}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const i={pid:process.pid,willReleaseAt:Date.now()+t};await b.Promises.writeFile(this.c,JSON.stringify(i),{flag:"w"})}catch(i){this.b.error(i)}}}async function p(l,t,i){try{const n={pid:process.pid,willReleaseAt:0};await b.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){l.error(n)}const c=await h(l,t);return!c||c.pid!==process.pid?i?(l.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(l.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),o(l,t)):(l.info(`Lock '${t}': Lock acquired.`),new k(l,t))}async function h(l,t){let i;try{i=await b.Promises.readFile(t)}catch(c){return l.error(c),null}try{return JSON.parse(String(i))}catch(c){return l.error(c),null}}async function s(l,t){let i;try{i=await b.Promises.stat(t)}catch(c){return l.error(c),0}return i.mtime.getTime()}function a(l){try{return process.kill(l,0),!0}catch{return!1}}async function o(l,t){const i=await h(l,t);if(!i)return l.info(`Lock '${t}': Could not read pid of lock holder.`),f(l,t);if(i.willReleaseAt){let I=i.willReleaseAt-Date.now();if(I<5e3){for(I>0?l.info(`Lock '${t}': The lockfile is scheduled to be released in ${I} ms.`):l.info(`Lock '${t}': The lockfile is scheduled to have been released.`);I>0;){if(await(0,E.$Ug)(Math.min(100,I)),await s(l,t)===0)return f(l,t);I=i.willReleaseAt-Date.now()}return f(l,t)}}if(!a(i.pid))return l.info(`Lock '${t}': The pid ${i.pid} appears to be gone.`),f(l,t);const c=await s(l,t),n=Date.now()-c;if(n<=y)return l.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;l.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Ug)(2e3);const r=await s(l,t),u=Date.now()-r;return u<=y?(l.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(l.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),f(l,t))}async function f(l,t){l.info(`Lock '${t}': Deleting a stale lock.`);try{await b.Promises.unlink(t)}catch{}return p(l,t,!0)}}),define(De[344],Ce([1,0,31,20,45,34]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;let A=class extends d.$Vcc{constructor(E,b){super(!0,E,b)}createTerminal(E,b,L){return this.createTerminalFromOptions({name:E,shellPath:b,shellArgs:L})}createTerminalFromOptions(E,b){const L=new d.$Ucc(this.a,(0,C.$eg)(),E,E.name);return this.f.push(L),L.create(E,this.R(E,b)),L.value}};e.$xec=A,e.$xec=A=He([Be(0,R.$IM),Be(1,T.$mM)],A)}),define(De[345],Ce([1,0,8,22,21,9,4,3,128,294,69]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$I4b=e.ResponsiveState=e.RequestInitiator=e.$H4b=e.$G4b=void 0;function v(w,D){try{return JSON.stringify(w,D)}catch{return"null"}}const y="$$ref$$",k={[y]:-1};class p{constructor(D,N){this.jsonString=D,this.referencedBuffers=N}}function h(w,D=null,N=!1){const M=[];return{jsonString:(N?v:JSON.stringify)(w,(U,j)=>{if(typeof j>"u")return k;if(typeof j=="object"){if(j instanceof T.$be){const O=M.push(j)-1;return{[y]:O}}if(D)return D(U,j)}return j}),referencedBuffers:M}}e.$G4b=h;function s(w,D,N){return JSON.parse(w,(M,F)=>{if(F){const U=F[y];if(typeof U=="number")return D[U];if(N&&F.$mid===1)return N.transformIncoming(F)}return F})}e.$H4b=s;function a(w,D){return JSON.stringify(w,D)}function o(w){return w?(D,N)=>N&&N.$mid===1?w.transformOutgoing(N):N:null}var f;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(f||(e.RequestInitiator=f={}));var l;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},i=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class n extends m.$Sc{static{P=i}static{this.a=3*1e3}constructor(D,N=null,M=null){super(),this[P]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=N,this.g=M,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,U=L.$nv.count;F<U;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$6g(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(D=>{const N=this.w[D];delete this.w[D],N.resolveErr(R.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(D){this.z===0&&(this.C=Date.now()+n.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(D){this.C=Date.now()+n.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(D){this.y!==D&&(this.y=D,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(D){return this.g?(0,E.$Om)(D,this.g):D}getProxy(D){const{nid:N,sid:M}=D;return this.s[N]||(this.s[N]=this.J(N,M)),this.s[N]}J(D,N){const M={get:(F,U)=>(typeof U=="string"&&!F[U]&&U.charCodeAt(0)===36&&(F[U]=(...j)=>this.U(D,U,j)),U===c?N:F[U])};return new Proxy(Object.create(null),M)}set(D,N){return this.m[D.nid]=N,N}assertRegistered(D){for(let N=0,M=D.length;N<M;N++){const F=D[N];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(D){if(this.j)return;const N=D.byteLength,M=u.read(D,0),F=M.readUInt8(),U=M.readUInt32();switch(F){case 1:case 2:{let{rpcId:j,method:O,args:q}=S.deserializeRequestJSONArgs(M);this.g&&(q=(0,E.$Om)(q,this.g)),this.M(N,U,j,O,q,F===2);break}case 3:case 4:{let{rpcId:j,method:O,args:q}=S.deserializeRequestMixedArgs(M);this.g&&(q=(0,E.$Om)(q,this.g)),this.M(N,U,j,O,q,F===4);break}case 5:{this.f?.logIncoming(N,U,0,"ack"),this.G(U);break}case 6:{this.N(N,U);break}case 7:{this.O(N,U,void 0);break}case 9:{let j=S.deserializeReplyOKJSON(M);this.g&&(j=(0,E.$Om)(j,this.g)),this.O(N,U,j);break}case 10:{const j=S.deserializeReplyOKJSONWithBuffers(M,this.g);this.O(N,U,j);break}case 8:{const j=S.deserializeReplyOKVSBuffer(M);this.O(N,U,j);break}case 11:{let j=S.deserializeReplyErrError(M);this.g&&(j=(0,E.$Om)(j,this.g)),this.P(N,U,j);break}case 12:{this.P(N,U,void 0);break}default:console.error("received unexpected message"),console.error(D)}}M(D,N,M,F,U,j){this.f?.logIncoming(D,N,1,`receiveRequest ${(0,L.$pv)(M)}.${F}(`,U);const O=String(N);let q,K;if(j){const te=new d.$Xd;U.push(te.token),q=this.Q(M,F,U),K=()=>te.cancel()}else q=this.Q(M,F,U),K=t;this.u[O]=K;const me=S.serializeAcknowledged(N);this.f?.logOutgoing(me.byteLength,N,1,"ack"),this.c.send(me),q.then(te=>{delete this.u[O];const G=S.serializeReplyOK(N,te,this.h);this.f?.logOutgoing(G.byteLength,N,1,"reply:",te),this.c.send(G)},te=>{delete this.u[O];const G=S.serializeReplyErr(N,te);this.f?.logOutgoing(G.byteLength,N,1,"replyErr:",te),this.c.send(G)})}N(D,N){this.f?.logIncoming(D,N,1,"receiveCancel");const M=String(N);this.u[M]?.()}O(D,N,M){this.f?.logIncoming(D,N,0,"receiveReply:",M);const F=String(N);if(!this.w.hasOwnProperty(F))return;const U=this.w[F];delete this.w[F],U.resolveOk(M)}P(D,N,M){this.f?.logIncoming(D,N,0,"receiveReplyErr:",M);const F=String(N);if(!this.w.hasOwnProperty(F))return;const U=this.w[F];delete this.w[F];let j;M&&(M.$isError?(j=new Error,j.name=M.name,j.message=M.message,j.stack=M.stack):j=M),U.resolveErr(j)}Q(D,N,M){try{return Promise.resolve(this.S(D,N,M))}catch(F){return Promise.reject(F)}}S(D,N,M){const F=this.m[D];if(!F)throw new Error("Unknown actor "+(0,L.$pv)(D));const U=F[N];if(typeof U!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.$pv)(D));return U.apply(F,M)}U(D,N,M){if(this.j)return new b.$F4b;let F=null;if(M.length>0&&d.CancellationToken.isCancellationToken(M[M.length-1])&&(F=M.pop()),F&&F.isCancellationRequested)return Promise.reject(R.$6());const U=S.serializeRequestArguments(M,this.h),j=++this.t,O=String(j),q=new b.$E4b,K=new m.$Rc;F&&K.add(F.onCancellationRequested(()=>{const te=S.serializeCancel(j);this.f?.logOutgoing(te.byteLength,j,0,"cancel"),this.c.send(S.serializeCancel(j))})),this.w[O]=new r(q,K),this.F(j);const me=S.serializeRequest(j,D,N,U,!!F);return this.f?.logOutgoing(me.byteLength,j,0,`request: ${(0,L.$pv)(D)}.${N}(`,M),this.c.send(me),q}}e.$I4b=n;class r{constructor(D,N){this.a=D,this.b=N}resolveOk(D){this.a.resolveOk(D),this.b.dispose()}resolveErr(D){this.a.resolveErr(D),this.b.dispose()}}class u{static alloc(D,N,M){const F=new u(T.$be.alloc(M+1+4),0);return F.writeUInt8(D),F.writeUInt32(N),F}static read(D,N){return new u(D,N)}get buffer(){return this.a}constructor(D,N){this.a=D,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const M=this.a.slice(this.b,this.b+D).toString();return this.b+=D,M}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+D).toString();return this.b+=D,M}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+D);return this.b+=D,N}static sizeMixedArray(D){let N=0;N+=1;for(let M=0,F=D.length;M<F;M++){const U=D[M];switch(N+=1,U.type){case 1:N+=this.sizeLongString(U.value);break;case 2:N+=this.sizeVSBuffer(U.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(U.value);for(let j=0;j<U.buffers.length;++j)N+=this.sizeVSBuffer(U.buffers[j]);break;case 4:break}}return N}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let N=0,M=D.length;N<M;N++){const F=D[N];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let U=0;U<F.buffers.length;++U)this.writeBuffer(F.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const N=new Array(D);for(let M=0;M<D;M++)switch(this.readUInt8()){case 1:N[M]=this.readLongString();break;case 2:N[M]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),j=this.readLongString(),O=[];for(let q=0;q<U;++q)O.push(this.readVSBuffer());N[M]=new L.$qv(s(j,O,null));break}case 4:N[M]=void 0;break}return N}}var I;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(I||(I={}));class S{static a(D){for(let N=0,M=D.length;N<M;N++)if(D[N]instanceof T.$be||D[N]instanceof L.$qv||typeof D[N]>"u")return!0;return!1}static serializeRequestArguments(D,N){if(this.a(D)){const M=[];for(let F=0,U=D.length;F<U;F++){const j=D[F];if(j instanceof T.$be)M[F]={type:2,value:j};else if(typeof j>"u")M[F]={type:4};else if(j instanceof L.$qv){const{jsonString:O,referencedBuffers:q}=h(j.value,N);M[F]={type:3,value:T.$be.fromString(O),buffers:q}}else M[F]={type:1,value:T.$be.fromString(a(j,N))}}return{type:1,args:M}}return{type:0,args:a(D,N)}}static serializeRequest(D,N,M,F,U){switch(F.type){case 0:return this.b(D,N,M,F.args,U);case 1:return this.c(D,N,M,F.args,U)}}static b(D,N,M,F,U){const j=T.$be.fromString(M),O=T.$be.fromString(F);let q=0;q+=u.sizeUInt8(),q+=u.sizeShortString(j),q+=u.sizeLongString(O);const K=u.alloc(U?2:1,D,q);return K.writeUInt8(N),K.writeShortString(j),K.writeLongString(O),K.buffer}static deserializeRequestJSONArgs(D){const N=D.readUInt8(),M=D.readShortString(),F=D.readLongString();return{rpcId:N,method:M,args:JSON.parse(F)}}static c(D,N,M,F,U){const j=T.$be.fromString(M);let O=0;O+=u.sizeUInt8(),O+=u.sizeShortString(j),O+=u.sizeMixedArray(F);const q=u.alloc(U?4:3,D,O);return q.writeUInt8(N),q.writeShortString(j),q.writeMixedArray(F),q.buffer}static deserializeRequestMixedArgs(D){const N=D.readUInt8(),M=D.readShortString(),F=D.readMixedArray(),U=new Array(F.length);for(let j=0,O=F.length;j<O;j++){const q=F[j];typeof q=="string"?U[j]=JSON.parse(q):U[j]=q}return{rpcId:N,method:M,args:U}}static serializeAcknowledged(D){return u.alloc(5,D,0).buffer}static serializeCancel(D){return u.alloc(6,D,0).buffer}static serializeReplyOK(D,N,M){if(typeof N>"u")return this.d(D);if(N instanceof T.$be)return this.e(D,N);if(N instanceof L.$qv){const{jsonString:F,referencedBuffers:U}=h(N.value,M,!0);return this.g(D,F,U)}else return this.f(D,v(N,M))}static d(D){return u.alloc(7,D,0).buffer}static e(D,N){let M=0;M+=u.sizeVSBuffer(N);const F=u.alloc(8,D,M);return F.writeVSBuffer(N),F.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,N){const M=T.$be.fromString(N);let F=0;F+=u.sizeLongString(M);const U=u.alloc(9,D,F);return U.writeLongString(M),U.buffer}static g(D,N,M){const F=T.$be.fromString(N);let U=0;U+=u.sizeUInt32,U+=u.sizeLongString(F);for(const O of M)U+=u.sizeVSBuffer(O);const j=u.alloc(10,D,U);j.writeUInt32(M.length),j.writeLongString(F);for(const O of M)j.writeBuffer(O);return j.buffer}static deserializeReplyOKJSON(D){const N=D.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(D,N){const M=D.readUInt32(),F=D.readLongString(),U=[];for(let j=0;j<M;++j)U.push(D.readVSBuffer());return new L.$qv(s(F,U,N))}static serializeReplyErr(D,N){const M=N?v(R.$3(N),null):void 0;if(typeof M!="string")return this.h(D);const F=T.$be.fromString(M);let U=0;U+=u.sizeLongString(F);const j=u.alloc(11,D,U);return j.writeLongString(F),j.buffer}static deserializeReplyErrError(D){const N=D.readLongString();return JSON.parse(N)}static h(D){return u.alloc(12,D,0).buffer}}var $;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var g;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(g||(g={}))}),define(De[346],Ce([1,0,4,43,42,5]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.OutputChannelUpdateMode=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=void 0,e.$wJ="text/x-code-output",e.$xJ="output",e.$yJ="Log",e.$zJ="text/x-code-log-output",e.$AJ="log",e.$BJ="workbench.panel.output",e.$CJ=new d.$7i("inOutput",!1),e.$DJ=new d.$7i("activeLogOutput",!1),e.$EJ=new d.$7i("outputView.scrollLock",!1),e.$FJ=(0,R.$Ph)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$GJ={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new C.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new C.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(L=>b.push(L)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}T.$gn.add(e.$GJ.OutputChannels,new m),e.$HJ=new d.$7i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,14,346,72,27,55,178,22,17,30,4,3]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=void 0;class s extends A.$dj{get disposed(){return this.n}constructor(l,t,i,c,n){super(),this.id=l,this.name=t,this.r=i,this.s=c,this.extension=n,this.m=0,this.n=!1,this.visible=!1,this.setLevel(i.getLevel()),this.B(i.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.m;this.info(l),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(l,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.s.$close(this.id)}g(l,t){this.m+=v.$be.fromString(t).byteLength,(0,A.log)(this.r,l,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class a extends s{appendLine(l){this.append(l)}}let o=class{constructor(l,t,i,c,n,r){this.i=t,this.j=i,this.k=c,this.l=n,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(C.$lK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[t,i]of this.g)i.visible=t===this.h}createOutputChannel(l,t,i){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,n=(0,y.$yf)(t)?t:void 0;if((0,y.$yf)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const u=this.i.environment.extensionLogLevel?.find(([S])=>R.$6l.equals(i.identifier,S))?.[1];u&&(r=(0,A.$nj)(u));const I=c?this.o(l,r,i):this.n(l,n,i);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),c?this.r(l,r??this.m.getLevel(),I):this.q(l,I)}async n(l,t,i){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,n=this.k.extUri.joinPath(c,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(n,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),u=await this.a.$register(l,n,t,i.identifier.value);return new s(u,l,r,this.a,i)}async o(l,t,i){const c=await this.p(i),n=l.replace(/[\\/:\*\?"<>\|]/g,""),r=this.k.extUri.joinPath(c,`${n}.log`),u=`${i.identifier.value}.${n}`,I=this.l.createLogger(r,{id:u,name:l,logLevel:t,extensionId:i.identifier.value});return new a(u,l,I,this.a,i)}p(l){let t=this.d.get(l.identifier.value);if(!t){const i=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(i)}catch(c){if((0,k.$ok)(c)!==k.FileSystemProviderErrorCode.FileExists)throw c}return i})())}return t}q(l,t){let i=!1;const c=()=>{if(i)throw new Error("Channel has been closed")};return{get name(){return l},append(n){c(),t.then(r=>r.append(n))},appendLine(n){c(),t.then(r=>r.appendLine(n))},clear(){c(),t.then(n=>n.clear())},replace(n){c(),t.then(r=>r.replace(n))},show(n,r){c(),t.then(u=>u.show(n,r))},hide(){c(),t.then(n=>n.hide())},dispose(){i=!0,t.then(n=>n.dispose())}}}r(l,t,i){const c=new h.$Rc,n=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},r=c.add(new p.$Nd);function u(I){t=I,r.fire(I)}return i.then(I=>{c.add(I),I.logLevel!==t&&u(I.logLevel),c.add(I.onDidChangeLogLevel(S=>u(S)))}),{...this.q(l,i),get logLevel(){return t},onDidChangeLogLevel:r.event,trace(I,...S){n(),i.then($=>$.trace(I,...S))},debug(I,...S){n(),i.then($=>$.debug(I,...S))},info(I,...S){n(),i.then($=>$.info(I,...S))},warn(I,...S){n(),i.then($=>$.warn(I,...S))},error(I,...S){n(),i.then($=>$.error(I,...S))},dispose(){c.dispose()}}}};e.$bdc=o,e.$bdc=o=He([Be(0,d.$mM),Be(1,b.$CM),Be(2,E.$Qcc),Be(3,L.$lcc),Be(4,A.$$i),Be(5,A.$0i)],o),e.$cdc=(0,T.$Ph)("IExtHostOutputService")}),define(De[347],Ce([1,0,5,8]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,C.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let R=1/0;for(let m=0;m<this.maxSampleCount;m++){const E=await d.getRoundTripTime();if(E===void 0)return;R=Math.min(R,E/2),await(0,T.$Ug)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(R):A=this.initial.reduce((m,E)=>m+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:R,average:this.average.reduce((m,E)=>m+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[348],Ce([1,0,33,18,16,12,23,2,5,259,44,144,347]),function($e,e,C,T,d,R,A,m,E,b,L,P,v){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=void 0,e.$ZJ=(0,E.$Ph)("pathService");let k=y=class{constructor(h,s,a,o){this.d=h,this.e=s,this.f=a,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const f=await this.e.getEnvironment();return this.c=f?.userHome??h})()}hasValidBasename(h,s,a){return typeof s=="string"||typeof s>"u"?this.a.then(o=>this.h(h,o,s)):this.h(h,s,a)}h(h,s,a){return h.scheme===T.Schemas.file||h.scheme===T.Schemas.vscodeRemote?(0,C.$Vf)(a??(0,A.$sg)(h),s===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(h,s){if(h.remoteAuthority)return T.Schemas.vscodeRemote;const a=(0,b.$WJ)(s.getWorkspace());if(a)return a;const o=s.getWorkspace().folders[0];if(o)return o.uri.scheme;const f=s.getWorkspace().configuration;return f?f.scheme:T.Schemas.file}userHome(h){return h?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(h=>h===1?d.$fc:d.$gc)}async fileURI(h){let s="";if(await this.a===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const o=h.indexOf("/",2);o===-1?(s=h.substring(2),h="/"):(s=h.substring(2,o),h=h.substring(o)||"/")}return m.URI.from({scheme:T.Schemas.file,authority:s,path:h,query:"",fragment:""})}};e.$1J=k,e.$1J=k=y=He([Be(1,v.$tm),Be(2,P.$IJ),Be(3,L.$Yh)],k)}),define(De[349],Ce([1,0,226,19,57,4,52,3,2,50,231,14,65,261,86,44,144,26,21,17,24,42]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=e.$RJ=e.OnPortForward=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.TunnelSource=e.TunnelCloseReason=e.$LJ=e.$KJ=e.$JJ=void 0;const t=10*1e3,i="remote.tunnels.toRestore";e.$JJ="onTunnel",e.$KJ=new l.$7i("forwardedPortsViewEnabled",!1,C.localize(0,null));function c(N){const M=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}e.$LJ=c;var n;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(n||(e.TunnelCloseReason=n={}));var r;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(r||(e.TunnelSource=r={})),e.$MJ={source:r.User,description:C.localize(1,null)},e.$NJ={source:r.Auto,description:C.localize(2,null)};function u(N,M,F){const U=N.get(S(M,F));if(U)return U;if((0,k.$cv)(M))for(const j of k.$bv){const O=S(j,F);if(N.has(O))return N.get(O)}else if((0,k.$ev)(M))for(const j of k.$dv){const O=S(j,F);if(N.has(O))return N.get(O)}}e.$OJ=u;function I(N,M,F){const U=u(N,M,F);if(U)return U;const j=(0,k.$ev)(M)?"localhost":(0,k.$cv)(M)?"0.0.0.0":void 0;if(j)return u(N,j,F)}e.$PJ=I;function S(N,M){return N+":"+M}e.$QJ=S;var $;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})($||(e.OnPortForward=$={}));function g(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$RJ=g;class w extends m.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.r=M,this.j=[],this.n=new R.$Nd,this.onDidChangeAttributes=this.n.event,this.B(M.onDidChangeConfiguration(F=>{(F.affectsConfiguration(w.c)||F.affectsConfiguration(w.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(M,F,U){let j=this.w(M,F,U,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const q=this.j[j];q.key===M?(O.onAutoForward=q.onAutoForward??O.onAutoForward,O.elevateIfNeeded=q.elevateIfNeeded!==void 0?q.elevateIfNeeded:O.elevateIfNeeded,O.label=q.label??O.label,O.requireLocalPort=q.requireLocalPort,O.protocol=q.protocol):(O.onAutoForward=O.onAutoForward??q.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:q.elevateIfNeeded,O.label=O.label??q.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??q.protocol),j=this.w(M,F,U,this.j,j+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(M){return M.start!==void 0&&M.end!==void 0}u(M){return M.host!==void 0&&M.port!==void 0&&(0,o.$yf)(M.host)&&(0,o.$Cf)(M.port)}w(M,F,U,j,O){if(O>=j.length)return-1;const q=!(0,k.$cv)(F)&&!(0,k.$ev)(F),me=j.slice(O).findIndex(te=>(0,o.$Cf)(te.key)?q?!1:te.key===M:this.t(te.key)?q?!1:M>=te.key.start&&M<=te.key.end:this.u(te.key)?M===te.key.port&&F===te.key.host:U?te.key.test(U):!1);return me>=0?me+O:-1}y(){const M=this.r.getValue(w.c);if(!M||!(0,o.$Af)(M))return[];const F=[];for(const j in M){if(j===void 0)continue;const O=M[j];let q;if(Number(j))q=Number(j);else if((0,o.$yf)(j))if(w.g.test(j)){const K=j.match(w.g);q={start:Number(K[1]),end:Number(K[2])}}else if(w.h.test(j)){const K=j.match(w.h);q={host:K[1],port:Number(K[2])}}else{let K;try{K=RegExp(j)}catch{}K&&(q=K)}q&&F.push({key:q,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const U=this.r.getValue(w.f);return U&&(this.m={elevateIfNeeded:U.elevateIfNeeded,label:U.label,onAutoForward:U.onAutoForward,requireLocalPort:U.requireLocalPort,protocol:U.protocol}),this.z(F)}z(M){function F(U,j){return(0,o.$Cf)(U.key)?U.key:j.t(U.key)?U.key.start:j.u(U.key)?U.key.port:Number.MAX_VALUE}return M.sort((U,j)=>F(U,this)-F(j,this))}C(){return this.m}static providedActionToAction(M){switch(M){case k.ProvidedOnAutoForward.Notify:return $.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case k.ProvidedOnAutoForward.Silent:return $.Silent;case k.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(M,F,U){const O=this.r.inspect(w.c).userRemoteValue;let q;!O||!(0,o.$Af)(O)?q={}:q=(0,f.$7m)(O),q[`${M}`]||(q[`${M}`]={});for(const K in F)q[`${M}`][K]=F[K];return this.r.updateValue(w.c,q,U)}}e.$SJ=w;let D=class extends m.$Sc{constructor(M,F,U,j,O,q,K,me,te,G){super(),this.H=M,this.I=F,this.J=U,this.L=j,this.M=O,this.N=q,this.O=K,this.P=me,this.Q=te,this.R=G,this.c=new Map,this.g=new R.$Nd,this.onForwardPort=this.g.event,this.h=new R.$Nd,this.onClosePort=this.h.event,this.j=new R.$Nd,this.onPortName=this.j.event,this.n=new R.$Nd,this.onCandidatesChanged=this.n.event,this.t=new R.$Nd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Nd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new w(U),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Q=>{const le=await this.getAttributes(Q.map(ie=>({port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost})));for(const ie of Q)if(ie.localAddress){const ce=S(ie.tunnelRemoteHost,ie.tunnelRemotePort),ye=I(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort);this.forwarded.set(ce,{remotePort:ie.tunnelRemotePort,remoteHost:ie.tunnelRemoteHost,localAddress:ie.localAddress,protocol:le?.get(ie.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,le?.get(ie.tunnelRemotePort)),localPort:ie.tunnelLocalPort,runningProcess:ye?.detail,hasRunningProcess:!!ye,pid:ye?.pid,privacy:ie.privacy,source:e.$MJ}),this.f.set(ce,ie)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Q=>{const le=S(Q.tunnelRemoteHost,Q.tunnelRemotePort);if(!I(this.forwarded,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!I(this.detected,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&!I(this.c,Q.tunnelRemoteHost,Q.tunnelRemotePort)&&Q.localAddress){const ie=I(this.m??new Map,Q.tunnelRemoteHost,Q.tunnelRemotePort),ce=(await this.getAttributes([{port:Q.tunnelRemotePort,host:Q.tunnelRemoteHost}]))?.get(Q.tunnelRemotePort);this.forwarded.set(le,{remoteHost:Q.tunnelRemoteHost,remotePort:Q.tunnelRemotePort,localAddress:Q.localAddress,protocol:ce?.protocol??k.TunnelProtocol.Http,localUri:await this.X(Q.localAddress,ce),localPort:Q.tunnelLocalPort,closeable:!0,runningProcess:ie?.detail,hasRunningProcess:!!ie,pid:ie?.pid,privacy:Q.privacy,source:e.$MJ})}await this.$(),this.f.set(le,Q),this.g.fire(this.forwarded.get(le))})),this.B(this.H.onTunnelClosed(Q=>this.W(Q,n.Other))),this.U()}S(){return this.Q.extensions.find(M=>M.activationEvents?.includes(e.$JJ))?(this.R.createKey(e.$KJ.key,!0),!0):!1}U(){if(this.S())return;const M=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&M.dispose()}))}async W(M,F){const U=S(M.host,M.port);this.forwarded.has(U)&&(this.forwarded.delete(U),await this.$(),this.h.fire(M))}X(M,F){if(M.startsWith("http"))return E.URI.parse(M);const U=F?.protocol??"http";return E.URI.parse(`${U}://${M}`)}async Y(){const M=this.N.getWorkspace(),F=M.configuration?(0,A.$Di)(M.configuration.path):M.folders.length>0?(0,A.$Di)(M.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${i}.${this.L.remoteAuthority}.${F}`}async Z(){const M=this.I.get(i,1);if(M)return this.I.remove(i,1),await this.$(),M;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=await this.s;if(M&&M!==this.y){const F=JSON.parse(M)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(U=>U.remotePort).join(", ")}`);for(const U of F){const j=I(this.detected,U.remoteHost,U.remotePort);U.source.source!==r.Extension&&!j||U.source.source===r.Extension&&j?await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,privacy:U.privacy,elevateIfNeeded:!0,source:U.source}):U.source.source===r.Extension&&!j&&this.D.set(S(U.remoteHost,U.remotePort),U)}}}if(this.z=!0,this.C.fire(),!this.w){const M=await this.Y();this.w=this.B(new m.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===M&&(this.s=Promise.resolve(this.I.get(M,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=JSON.stringify(Array.from(this.forwarded.values()));if(M!==this.y){this.y=M;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(M,F,U){if(!M.tunnelLocalPort||!U?.requireLocalPort||M.tunnelLocalPort===F)return;const j=new Date;if(this.ab.getTime()+t>j.getTime())return;this.ab=j;const O=C.localize(3,null,F,M.tunnelRemotePort,M.tunnelLocalPort);return this.P.info(O)}async forward(M,F){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(M,F)}async cb(M,F){await this.Q.activateByEvent(e.$JJ);const U=I(this.forwarded,M.remote.host,M.remote.port);F=F??(F!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const j=M.local!==void 0?M.local:M.remote.port;let O;if(U)return this.eb(U,M,F);{const q=this.L.remoteAuthority,K=q?{getAddress:async()=>(await this.M.resolveAuthority(q)).authority}:void 0,me=S(M.remote.host,M.remote.port);this.c.set(me,!0),M=this.db(me,M);const te=await this.H.openTunnel(K,M.remote.host,M.remote.port,void 0,j,M.elevateIfNeeded?M.elevateIfNeeded:F?.elevateIfNeeded,M.privacy,F?.protocol);if(typeof te=="string")O=te;else if(te&&te.localAddress){const G=I(this.m??new Map,M.remote.host,M.remote.port),Q=te.protocol?te.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:F?.protocol??k.TunnelProtocol.Http,le={remoteHost:te.tunnelRemoteHost,remotePort:te.tunnelRemotePort,localPort:te.tunnelLocalPort,name:F?.label??M.name,closeable:!0,localAddress:te.localAddress,protocol:Q,localUri:await this.X(te.localAddress,F),runningProcess:G?.detail,hasRunningProcess:!!G,pid:G?.pid,source:M.source??e.$MJ,privacy:te.privacy};return this.forwarded.set(me,le),this.f.set(me,te),this.c.delete(me),await this.$(),await this.bb(te,j,F),this.g.fire(le),te}this.c.delete(me)}return O}db(M,F){const U=this.D.has(M)?this.D:this.F.has(M)?this.F:void 0;if(U){const j=U.get(M);U.delete(M),j&&(F.name=j.name??F.name,F.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??F.local,F.privacy=j.privacy??F.privacy)}return F}async eb(M,F,U){const j=U?.label??F.name;let O;(function(K){K[K.None=0]="None",K[K.Fire=1]="Fire",K[K.Reopen=2]="Reopen"})(O||(O={}));let q=O.None;switch(j!==M.name&&(M.name=j,q=O.Fire),(U?.protocol||M.protocol!==k.TunnelProtocol.Http)&&U?.protocol!==M.protocol&&(F.source=M.source,q=O.Reopen),F.privacy&&M.privacy!==F.privacy&&(q=O.Reopen),q){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(M.remoteHost,M.remotePort,n.User),await this.cb(F,U)}return I(this.f,F.remote.host,F.remote.port)}async name(M,F,U){const j=I(this.forwarded,M,F),O=S(M,F);if(j){j.name=U,await this.$(),this.j.fire({host:M,port:F});return}else this.detected.has(O)&&(this.detected.get(O).name=U,this.j.fire({host:M,port:F}))}async close(M,F,U){const j=S(M,F),O=this.forwarded.get(j);return U===n.AutoForwardEnd&&O&&O.source.source===r.Auto&&this.F.set(j,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(M,F),this.W({host:M,port:F},U)}address(M,F){const U=S(M,F);return(this.forwarded.get(U)||this.detected.get(U))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(M){if(M)for(const F of M){const U=I(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),j=typeof F.localAddress=="string"?F.localAddress:S(F.localAddress.host,F.localAddress.port);this.detected.set(S(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:j,protocol:k.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:r.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,j,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(M){this.r=M}async setCandidates(M){let F=M;this.r&&(F=await this.r(M));const U=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(U.values()).map(j=>j.port).join(", ")}`),this.n.fire(U)}fb(M){const F=this.m??new Map,U=new Map;return this.m=U,M.forEach(j=>{const O=S(j.host,j.port);U.set(O,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),F.has(O)&&F.delete(O);const q=I(this.forwarded,j.host,j.port);q&&(q.runningProcess=j.detail,q.hasRunningProcess=!0,q.pid=j.pid)}),F.forEach((j,O)=>{const q=c(O);if(!q)return;const K=I(this.forwarded,q.host,q.port);K&&(K.runningProcess=void 0,K.hasRunningProcess=!1,K.pid=void 0);const me=I(this.detected,q.host,q.port);me&&(me.runningProcess=void 0,me.hasRunningProcess=!1,me.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const M=Array.from(this.forwarded.values()),F=await this.getAttributes(M.map(U=>({port:U.remotePort,host:U.remoteHost})),!1);if(F)for(const U of M){const j=F.get(U.remotePort);(j?.protocol||U.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==U.protocol&&await this.cb({remote:{host:U.remoteHost,port:U.remotePort},local:U.localPort,name:U.name,source:U.source},j),j&&j.label&&j.label!==U.name&&await this.name(U.remoteHost,U.remotePort,j.label)}}async getAttributes(M,F=!0){const U=new Map,j=new Map;M.forEach(te=>{const G=I(this.m??new Map,k.$bv[0],te.port)??te;if(G){U.set(te.port,G);const Q=g(G)?G.pid:void 0;j.has(Q)||j.set(Q,[]),j.get(Q)?.push(te.port)}});const O=new Map;if(M.forEach(te=>{const G=this.configPortsAttributes.getAttributes(te.port,te.host,U.get(te.port)?.detail);G&&O.set(te.port,G)}),this.G.length===0||!F)return O.size>0?O:void 0;const q=await Promise.all((0,T.$Rb)(this.G.map(te=>Array.from(j.entries()).map(G=>{const Q=G[1],le=U.get(Q[0]);return te.providePortAttributes(Q,le?.pid,le?.detail,new a.$Xd().token)})))),K=new Map;if(q.forEach(te=>te.forEach(G=>{G&&K.set(G.port,G)})),!O&&!K)return;const me=new Map;return M.forEach(te=>{const G=O.get(te.port),Q=K.get(te.port);me.set(te.port,{elevateIfNeeded:G?.elevateIfNeeded,label:G?.label,onAutoForward:G?.onAutoForward??w.providedActionToAction(Q?.autoForwardAction),requireLocalPort:G?.requireLocalPort,protocol:G?.protocol})}),me}addAttributesProvider(M){this.G.push(M)}};e.$TJ=D,He([(0,d.$ih)(1e3)],D.prototype,"$",null),e.$TJ=D=He([Be(0,k.$0u),Be(1,y.$6o),Be(2,b.$ji),Be(3,h.$IJ),Be(4,v.$Pk),Be(5,p.$Yh),Be(6,P.$0i),Be(7,L.$Bv),Be(8,s.$dF),Be(9,l.$8i)],D)}),define(De[92],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GI=e.$FI=void 0;class C{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new C(0,0)}with(A){return new C(0,0)}}e.$FI=C;class T{constructor(A,m,E,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,m),this.end=new C(E,b)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$GI=T;var d;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(De[37],Ce([1,0,19,36,24,33,15,5,16,9,92,8]),function($e,e,C,T,d,R,A,m,E,b,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.SearchErrorCode=e.$VI=e.$UI=e.SearchSortOrder=e.ViewMode=e.$TI=e.$SI=e.$RI=e.$QI=e.SearchCompletionExitCode=e.$PI=e.$OI=e.$NI=e.QueryType=e.SearchProviderType=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$HI="workbench.view.search",e.$II="workbench.panel.search",e.$JI="workbench.view.search",e.$KI="search-result",e.$LI="search.exclude";const v="\u27EA ",y=" characters skipped \u27EB",k=(v.length+y.length+5)*2;e.$MI=(0,m.$Ph)("searchService");var p;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(p||(e.SearchProviderType=p={}));var h;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(h||(e.QueryType=h={}));function s(Q){return!!Q.preview}e.$NI=s;function a(Q){return!!Q.resource}e.$OI=a;function o(Q){return!!Q.message}e.$PI=o;var f;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(f||(e.SearchCompletionExitCode=f={}));class l{constructor(le){this.resource=le,this.results=[]}}e.$QI=l;class t{constructor(le,ie,ce,ye){this.ranges=ie,this.webviewIndex=ye;const H=Array.isArray(ie)?ie:[ie];if(ce&&ce.matchLines===1&&i(H)){le=(0,A.$rf)(le,ce.matchLines);let B="",X=0,re=0;const Y=Math.floor(ce.charsPerLine/5),_=[];for(const x of H){const ve=Math.max(x.startColumn-Y,0),ae=x.startColumn+ce.charsPerLine;if(ve>re+Y+k){const fe=v+(ve-re)+y;B+=fe+le.slice(ve,ae),X+=ve-(re+fe.length)}else B+=le.slice(re,ae);_.push(new n(0,x.startColumn-X,x.endColumn-X)),re=ae}this.preview={text:B,matches:Array.isArray(this.ranges)?_:_[0]}}else{const B=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:le,matches:(0,C.$2b)(ie,X=>new c(X.startLineNumber-B,X.startColumn,X.endLineNumber-B,X.endColumn))}}}}e.$RI=t;function i(Q){const le=Q[0].startLineNumber;for(const ie of Q)if(ie.startLineNumber!==le||ie.endLineNumber!==le)return!1;return!0}class c{constructor(le,ie,ce,ye){this.startLineNumber=le,this.startColumn=ie,this.endLineNumber=ce,this.endColumn=ye}}e.$SI=c;class n extends c{constructor(le,ie,ce){super(le,ie,le,ce)}}e.$TI=n;var r;(function(Q){Q.List="list",Q.Tree="tree"})(r||(e.ViewMode=r={}));var u;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(u||(e.SearchSortOrder=u={}));function I(Q,le=!0){const ie=Q&&Q.files&&Q.files.exclude,ce=le&&Q&&Q.search&&Q.search.exclude;if(!ie&&!ce)return;if(!ie||!ce)return ie||ce;let ye=Object.create(null);return ye=d.$0m(ye,d.$7m(ie)),ye=d.$0m(ye,d.$7m(ce),!0),ye}e.$UI=I;function S(Q,le){return Q.excludePattern&&T.$vj(Q.excludePattern,le)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&T.$vj(Q.includePattern,le)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ie=>{const ce=ie.folder.fsPath;if(R.$Xf(le,ce)){const ye=E.$lc(ce,le);return!ie.includePattern||!!T.$vj(ie.includePattern,ye)}else return!1}):!1:!0}e.$VI=S;var $;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class g extends Error{constructor(le,ie){super(le),this.code=ie}}e.$WI=g;function w(Q){const le=Q.message;if((0,b.$4)(Q))return new g(le,$.canceled);try{const ie=JSON.parse(le);return new g(ie.message,ie.code)}catch{return new g(le,$.other)}}e.$XI=w;function D(Q){const le={message:Q.message,code:Q.code};return new Error(JSON.stringify(le))}e.$YI=D;function N(Q){return Q.type==="error"?!0:Q.type==="success"}e.$ZI=N;function M(Q){return Q.type==="success"}e.$1I=M;function F(Q){return!!Q.path}e.$2I=F;function U(Q,le){const ie=Q.searchPath?Q.searchPath:Q.relativePath;return(0,A.$of)(ie,le)}e.$3I=U;class j{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$4I=j;function O(Q,le){const ie={...Q||{},...le||{}};return Object.keys(ie).filter(ce=>{const ye=ie[ce];return typeof ye=="boolean"&&ye})}e.$5I=O;class q{constructor(le,ie){this.c=null,this.a={...le.excludePattern||{},...ie.excludePattern||{}},this.b=T.$wj(this.a);let ce=le.includePattern;ie.includePattern&&(ce?ce={...ce,...ie.includePattern}:ce=ie.includePattern),ce&&(this.c=T.$wj(ce))}matchesExcludesSync(le,ie,ce){return!!(this.b&&this.b(le,ie,ce))}includedInQuerySync(le,ie,ce){return!(this.b&&this.b(le,ie,ce)||this.c&&!this.c(le,ie,ce))}includedInQuery(le,ie,ce){const ye=this.b(le,ie,ce),H=()=>this.c?!!this.c(le,ie,ce):!0;return(0,P.$Gg)(ye)?ye.then(B=>B?!1:H()):H()}hasSiblingExcludeClauses(){return K(this.a)}}e.$6I=q;function K(Q){for(const le in Q)if(typeof Q[le]!="boolean")return!0;return!1}function me(Q){if(!Q)return;let le;return ie=>(le||(le=(Q()||Promise.resolve([])).then(ce=>ce?G(ce):{})),le.then(ce=>!!ce[ie]))}e.$7I=me;function te(Q){if(!Q)return;let le;return ie=>{if(!le){const ce=Q();le=ce?G(ce):{}}return!!le[ie]}}e.$8I=te;function G(Q){const le={};for(const ie of Q)le[ie]=!0;return le}}),define(De[39],Ce([1,0,19,8,21,4,3,78,18,120,23,15,2,215,5,14,244,44,55,27,20,13,7,67,37,6]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t,i,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;function r(N,M,F){return new L.$kg(U=>$(U,F)).isEqual(N,M)}function u(N,M,F){return r(N.uri,M.uri,F)?0:(0,P.$Ue)(N.uri.toString(),M.uri.toString())}function I(N,M,F){return N.index!==M.index?N.index<M.index?-1:1:r(N.uri,M.uri,F)?(0,P.$Ue)(N.name,M.name):(0,P.$Ue)(N.uri.toString(),M.uri.toString())}function S(N,M,F,U){const j=N.slice(0).sort((q,K)=>F(q,K,U)),O=M.slice(0).sort((q,K)=>F(q,K,U));return(0,C.$Eb)(j,O,(q,K)=>F(q,K,U))}function $(N,M){const F=M.getCapabilities(N.scheme);return!(F&&F&1024)}class g extends s.$9h{static toExtHostWorkspace(M,F,U,j){if(!M)return{workspace:null,added:[],removed:[]};const{id:O,name:q,folders:K,configuration:me,transient:te,isUntitled:G}=M,Q=[],le=F;F?K.forEach((H,B)=>{const X=v.URI.revive(H.uri),re=g.o(U||F,X,j);re?(re.name=H.name,re.index=H.index,Q.push(re)):Q.push({uri:X,name:H.name,index:B})}):Q.push(...K.map(({uri:H,name:B,index:X})=>({uri:v.URI.revive(H),name:B,index:X}))),Q.sort((H,B)=>H.index<B.index?-1:1);const ie=new g(O,q,Q,!!te,me?v.URI.revive(me):null,!!G,H=>$(H,j)),{added:ce,removed:ye}=S(le?le.workspaceFolders:[],ie.workspaceFolders,u,j);return{workspace:ie,added:ce,removed:ye}}static o(M,F,U){for(let j=0;j<M.folders.length;j++){const O=M.workspaceFolders[j];if(r(O.uri,F,U))return O}}constructor(M,F,U,j,O,q,K){super(M,U.map(me=>new s.$0h(me)),j,O,K),this.t=F,this.u=q,this.q=[],this.s=m.$Vh.forUris(K),U.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,F){return F&&this.s.get(M)&&(M=(0,L.$ug)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let w=class{constructor(M,F,U,j,O){this.c=new R.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Pd,this.B=new Map,this.h=j,this.s=U,this.t=O,this.j=new b.$Ql,this.k=new T.$Sg,this.o=M.getProxy(n.$lK.MainThreadWorkspace),this.q=M.getProxy(n.$lK.MainThreadMessageService);const q=F.workspace;this.l=q?new g(q.id,q.name,[],!!q.transient,q.configuration?v.URI.revive(q.configuration):null,!!q.isUntitled,K=>$(K,U)):void 0}$initializeWorkspace(M,F){this.v=F,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:E.Schemas.untitled,path:(0,L.$sg)((0,L.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,F,U,...j){const O=[];if(Array.isArray(j)&&j.forEach(G=>{v.URI.isUri(G.uri)&&!O.some(Q=>r(Q.uri,G.uri,this.s))&&O.push({uri:G.uri,name:G.name||(0,L.$rg)(G.uri)})}),this.n||[F,U].some(G=>typeof G!="number"||G<0)||U===0&&O.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(F+U>q.length)return!1;const K=q.slice(0);K.splice(F,U,...O.map(G=>({uri:G.uri,name:G.name||(0,L.$rg)(G.uri),index:void 0})));for(let G=0;G<K.length;G++){const Q=K[G];if(K.some((le,ie)=>ie!==G&&r(Q.uri,le.uri,this.s)))return!1}K.forEach((G,Q)=>G.index=Q);const{added:me,removed:te}=S(q,K,I,this.s);if(me.length===0&&te.length===0)return!1;if(this.o){const G=M.displayName||M.name;this.o.$updateWorkspaceFolders(G,F,U,O).then(void 0,Q=>{this.n=void 0;const le={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(h.Severity.Error,(0,y.localize)(0,null,G,Q.toString()),le,[])})}return this.y(K),!0}getWorkspaceFolder(M,F){if(this.x)return this.x.getWorkspaceFolder(M,F)}async getWorkspaceFolder2(M,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,F)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,F){let U,j="";if(typeof M=="string"?(U=v.URI.file(M),j=M):typeof M<"u"&&(U=M,j=M.fsPath),!U)return j;const O=this.getWorkspaceFolder(U,!0);if(!O)return j;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let q=(0,L.$xg)(O.uri,U);return F&&O.name&&(q=`${O.name}/${q}`),q}y(M){this.x&&(this.n=g.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:F,added:U,removed:j}=g.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:j}))}findFiles(M,F,U,j,O=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let q;if(F===null?q=!1:F&&(typeof F=="string"?q=F:q=F.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:me}=D(l.GlobPattern.from(M));return this.o.$startFileSearch(K??null,me??null,q??null,U??null,O).then(te=>Array.isArray(te)?te.map(G=>v.URI.revive(G)):[])}async findTextInFiles(M,F,U,j,O=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),K=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:me,folder:te}=D(l.GlobPattern.from(F.include)),G=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,Q={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:K,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:me,excludePattern:G},le=!1;if(this.u[q]=ie=>{if(le)return;const ce=v.URI.revive(ie.resource);ie.results.forEach(ye=>{(0,c.$NI)(ye)?U({uri:ce,preview:{text:ye.preview.text,matches:(0,C.$2b)(ye.preview.matches,H=>new t.$pK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))},ranges:(0,C.$2b)(ye.ranges,H=>new t.$pK(H.startLineNumber,H.startColumn,H.endLineNumber,H.endColumn))}):U({uri:ce,text:ye.text,lineNumber:ye.lineNumber})})},O.isCancellationRequested)return{};try{const ie=await this.o.$startTextSearch(M,te??null,Q,q,O);return delete this.u[q],ie||{}}catch(ie){throw delete this.u[q],ie}}$handleTextSearchResult(M,F){this.u[F]?.(M)}async save(M){const F=await this.o.$save(M,{saveAs:!1});return v.URI.revive(F)}async saveAs(M){const F=await this.o.$save(M,{saveAs:!0});return v.URI.revive(F)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,F){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,F);const U=this.t.transformOutgoingScheme(M),j=this.z++;return this.o.$registerEditSessionIdentityProvider(j,U),(0,A.$Qc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(M,F){this.h.info("Getting edit session identifier for workspaceFolder",M);const U=await this.resolveWorkspaceFolder(v.URI.revive(M));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const j=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!j),!j)return;const O=await j.provideEditSessionIdentity(U,F);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(M,F,U,j){this.h.info("Getting edit session identifier for workspaceFolder",M);const O=await this.resolveWorkspaceFolder(v.URI.revive(M));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const q=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!q),!q)return;const K=await q.provideEditSessionIdentityMatch?.(F,U,j);if(this.h.info("Provider returned edit session identifier match result: ",K),!!K)return K}getOnWillCreateEditSessionIdentityEvent(M){return(F,U,j)=>{const O=function(K){F.call(U,K)};return O.extension=M,this.A.event(O,void 0,j)}}async $onWillCreateEditSessionIdentity(M,F,U){const j=await this.resolveWorkspaceFolder(v.URI.revive(M));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:j},F,async(O,q)=>{const K=Date.now();await Promise.resolve(O),Date.now()-K>U&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(M,F){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,F);const U=this.t.transformOutgoingScheme(M),j=this.z++;return this.o.$registerCanonicalUriProvider(j,U),(0,A.$Qc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(M,F,U){const j=this.B.get(M.scheme);if(!j)return;const O=await j.provideCanonicalUri?.(v.URI.revive(M),F,U);if(O)return O}async $provideCanonicalUri(M,F,U){return this.provideCanonicalUri(v.URI.revive(M),{targetScheme:F},U)}};e.$xcc=w,e.$xcc=w=He([Be(0,f.$mM),Be(1,o.$CM),Be(2,a.$lcc),Be(3,p.$0i),Be(4,i.$vcc)],w),e.$ycc=(0,k.$Ph)("IExtHostWorkspace");function D(N){let M,F;return N&&(typeof N=="string"?M=N:(M=N.pattern,F=v.URI.revive(N.baseUri))),{includePattern:M,folder:F}}}),define(De[40],Ce([1,0,24,4,39,6,7,246,136,17,8,5,20,14,2]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=e.$Acc=e.$zcc=void 0;function p(i,c){if(c){const n=c.split(".");let r=i;for(let u=0;r&&u<n.length;u++)r=r[n[u]];return r}}function h(i){return i instanceof k.URI}function s(i){return i&&i.uri instanceof k.URI&&i.languageId&&typeof i.languageId=="string"}function a(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function o(i){return i&&i.uri instanceof k.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function f(i){if(h(i))return{resource:i};if(s(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(a(i))return{overrideIdentifier:i.languageId};if(o(i))return{resource:i.uri};if(i===null)return{resource:null}}let l=class{constructor(c,n,r){this.a=c.getProxy(R.$lK.MainThreadConfiguration),this.c=n,this.b=r,this.d=new L.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,n){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(c,n))}};e.$zcc=l,e.$zcc=l=He([Be(0,v.$mM),Be(1,d.$ycc),Be(2,y.$0i)],l);class t{constructor(c,n,r,u){this.a=new T.$Nd,this.b=c,this.f=u,this.c=n,this.e=m.$En.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,n){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$En.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(n,r))}getConfiguration(c,n,r){const u=f(n)||{},I=this.g(c?p(this.e.getValue(void 0,u,this.c.workspace),c):this.e.getValue(void 0,u,this.c.workspace));c&&this.h(c,u,r?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(g){return typeof p(I,g)<"u"},get:(g,w)=>{this.h(c?`${c}.${g}`:g,u,r?.identifier);let D=p(I,g);if(typeof D>"u")D=w;else{let N;const M=(F,U)=>{if((0,b.$Af)(F)){let j;const O=()=>{N=N||(0,C.$7m)(I),j=j||p(N,U)};return new Proxy(F,{get:(q,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return O(),()=>j;if(N)return j=j||p(N,U),j[K];const me=q[K];return typeof K=="string"?M(me,`${U}.${K}`):me},set:(q,K,me)=>(O(),j&&(j[K]=me),!0),deleteProperty:(q,K)=>(O(),j&&delete j[K],!0),defineProperty:(q,K,me)=>(O(),j&&Object.defineProperty(j,K,me),!0)})}return Array.isArray(F)?(0,C.$7m)(F):F};D=M(D,g)}return D},update:(g,w,D,N)=>{g=c?`${c}.${g}`:g;const M=S(D);return w!==void 0?this.b.$updateConfigurationOption(M,g,w,u,N):this.b.$removeConfigurationOption(M,g,u,N)},inspect:g=>{g=c?`${c}.${g}`:g;const w=this.e.inspect(g,u,this.c.workspace);if(w)return{key:g,defaultValue:(0,C.$7m)(w.policy?.value??w.default?.value),globalValue:(0,C.$7m)(w.user?.value??w.application?.value),workspaceValue:(0,C.$7m)(w.workspace?.value),workspaceFolderValue:(0,C.$7m)(w.workspaceFolder?.value),defaultLanguageValue:(0,C.$7m)(w.default?.override),globalLanguageValue:(0,C.$7m)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,C.$7m)(w.workspace?.override),workspaceFolderLanguageValue:(0,C.$7m)(w.workspaceFolder?.override),languageIds:(0,C.$7m)(w.overrideIdentifiers)}}};return typeof I=="object"&&(0,C.$0m)($,I,!1),Object.freeze($)}g(c){const n=r=>(0,b.$Af)(r)?new Proxy(r,{get:(u,I)=>n(u[I]),set:(u,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(u,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(u,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return n(c)}h(c,n,r){const u=E.$vn.test(c)?4:this.d.get(c),I=r?`[${r.value}] `:"";if(u===4){typeof n?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){n?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,n){const r=new m.$Gn(c,n,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,I)=>r.affectsConfiguration(u,f(I))})}k(c){return c.reduce((n,r)=>(n.set(r[0],r[1]),n),new Map)}}e.$Acc=t,e.$Bcc=(0,P.$Ph)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,8,4,6,7,39,70,40,21,45,20,27,5,18,12,14,89,293,9]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=e.$xdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(M){function F(j){if(j!=null)return j}M.from=F;function U(j){if(j!=null)return j}M.to=U})(l||(l={}));var t;(function(M){function F(j){if(j!=null)return j}M.from=F;function U(j){if(j!=null)return j}M.to=U})(t||(t={}));var i;(function(M){function F(j){if(j!=null)return j}M.from=F;function U(j){if(j!=null)return j}M.to=U})(i||(i={}));var c;(function(M){function F(O){if(O){const q=O;return q&&!!q.process}else return!1}M.is=F;function U(O){if(O==null)return;const q={process:O.process,args:O.args};return O.options&&(q.options=i.from(O.options)),q}M.from=U;function j(O){if(O!=null)return new A.$8K(O.process,O.args,O.options)}M.to=j})(c||(c={}));var n;(function(M){function F(j){if(j!=null)return j}M.from=F;function U(j){if(j!=null)return j}M.to=U})(n||(n={}));var r;(function(M){function F(O){if(O){const q=O;return q&&(!!q.commandLine||!!q.command)}else return!1}M.is=F;function U(O){if(O==null)return;const q={};return O.commandLine!==void 0?q.commandLine=O.commandLine:(q.command=O.command,q.args=O.args),O.options&&(q.options=n.from(O.options)),q}M.from=U;function j(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$9K(O.commandLine,O.options):new A.$9K(O.command,O.args?O.args:[],O.options)}M.to=j})(r||(r={}));var u;(function(M){function F(O){if(O){const q=O;return q&&q.customExecution==="customExecution"}else return!1}M.is=F;function U(O){return{customExecution:"customExecution"}}M.from=U;function j(O,q){return q.get(O)}M.to=j})(u||(e.CustomExecutionDTO=u={}));var I;(function(M){function F(U,j){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?O=j.workspaceFile:O=o.$SF),{id:U._id,workspaceFolder:O}}M.from=F})(I||(e.TaskHandleDTO=I={}));var S;(function(M){function F(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}M.from=F})(S||(S={}));var $;(function(M){function F(O,q){if(O==null)return[];const K=[];for(const me of O){const te=U(me,q);te&&K.push(te)}return K}M.fromMany=F;function U(O,q){if(O==null)return;let K;O.execution instanceof A.$8K?K=c.from(O.execution):O.execution instanceof A.$9K?K=r.from(O.execution):O.execution&&O.execution instanceof A.$0K&&(K=u.from(O.execution));const me=l.from(O.definition);let te;return O.scope?typeof O.scope=="number"?te=O.scope:te=O.scope.uri:te=A.TaskScope.Workspace,!me||!te?void 0:{_id:O._id,definition:me,name:O.name,source:{extensionId:q.identifier.value,label:O.source,scope:te},execution:K,isBackground:O.isBackground,group:S.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}M.from=U;async function j(O,q,K){if(O==null)return;let me;c.is(O.execution)?me=c.to(O.execution):r.is(O.execution)?me=r.to(O.execution):u.is(O.execution)&&(me=u.to(O._id,K));const te=l.to(O.definition);let G;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?G=O.source.scope:G=await q.resolveWorkspaceFolder(C.URI.revive(O.source.scope)):G=A.TaskScope.Workspace),!te||!G)return;const Q=new A.$$K(te,G,O.name,O.source.label,me,O.problemMatchers);return O.isBackground!==void 0&&(Q.isBackground=O.isBackground),O.group!==void 0&&(Q.group=A.$7K.from(O.group._id),Q.group&&O.group.isDefault&&(Q.group=new A.$7K(Q.group.id,Q.group.label),O.group.isDefault===!0&&(Q.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Q.presentationOptions=t.to(O.presentationOptions)),O._id&&(Q._id=O._id),O.detail&&(Q.detail=O.detail),Q}M.to=j})($||(e.TaskDTO=$={}));var g;(function(M){function F(j){return j}M.from=F;function U(j){if(j)return Object.assign(Object.create(null),j)}M.to=U})(g||(g={}));class w{#e;constructor(F,U,j){this._id=U,this.a=j,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let D=class{constructor(F,U,j,O,q,K,me,te){this.q=new d.$Nd,this.r=new d.$Nd,this.s=new d.$Nd,this.t=new d.$Nd,this.a=F.getProxy(R.$lK.MainThreadTask),this.b=j,this.c=O,this.d=q,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=te,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,U,j){if(!j)return new A.$nK(()=>{});const O=this.w();return this.j.set(O,{type:U,provider:j,extension:F}),this.a.$registerTaskProvider(O,U),new A.$nK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(F,U){this.a.$registerTaskSystem(F,U)}fetchTasks(F){return this.a.$fetchTasks(g.from(F)).then(async U=>{const j=[];for(const O of U){const q=await $.to(O,this.b,this.m);q&&j.push(q)}return j})}get taskExecutions(){const F=[];return this.k.forEach(U=>F.push(U)),F}terminateTask(F){if(!(F instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,U,j){const O=this.m.get(F.id);O&&(this.o.set(F.id,O),this.e.attachPtyToTerminal(U,await O.callback(j))),this.p=F.id,this.q.fire({execution:await this.y(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){const U=await this.y(F);this.l.delete(F.id),this.k.delete(F.id),this.A(F),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const U=await this.y(F.id);this.s.fire({execution:U,processId:F.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(F){const U=await this.y(F.id);this.t.fire({execution:U,exitCode:F.exitCode})}$provideTasks(F,U){const j=this.j.get(F);if(!j)return Promise.reject(new Error("no handler found"));const O=[],q=(0,T.$Mg)(()=>j.provider.provideTasks(L.CancellationToken.None)).then(K=>this.u(U,O,j,K));return new Promise(K=>{q.then(me=>{Promise.all(O).then(()=>{K(me)})})})}async $resolveTask(F,U){const j=this.j.get(F);if(!j)return Promise.reject(new Error("no handler found"));if(U.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${j.type}].`);const O=await $.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const q=await j.provider.resolveTask(O,L.CancellationToken.None);if(!q)return;this.z(q,j);const K=$.from(q,j.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(K.execution)&&await this.x(K,q,!0),await this.v(K)}w(){return this.h++}async x(F,U,j){const O=await this.a.$createTaskId(F);!j&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async y(F,U){if(typeof F=="string"){const q=this.l.get(F);if(!q)throw new f.$bb("Unexpected: The specified task is missing an execution");return q}const j=this.l.get(F.id);if(j)return j;const O=new Promise((q,K)=>{function me(te,G,Q){Q?q(new w(te,G.id,Q)):K("Unexpected: Task does not exist.")}U?me(this,F,U):$.to(F.task,this.b,this.m).then(te=>me(this,F,te))});return this.l.set(F.id,O),O.then(q=>(this.k.set(F.id,q),q),q=>Promise.reject(q))}z(F,U){F._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const j=this.n.values();let O=j.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=j.next()}};e.$xdc=D,e.$xdc=D=He([Be(0,v.$mM),Be(1,y.$CM),Be(2,m.$ycc),Be(3,E.$xM),Be(4,b.$Bcc),Be(5,P.$Tcc),Be(6,s.$0i),Be(7,a.$occ)],D);let N=class extends D{constructor(F,U,j,O,q,K,me,te){super(F,U,j,O,q,K,me,te),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:h.$i(0)})}async executeTask(F,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const j=$.from(U,F);if(j===void 0)throw new Error("Task is not valid");if(u.is(j.execution))await this.x(j,U,!1);else throw new f.$_;const O=await this.y(await this.a.$getTaskExecution(j),U);return this.a.$executeTask(j).catch(q=>{throw new Error(q)}),O}u(F,U,j,O){const q=[];if(O)for(const K of O){this.z(K,j),(!K.definition||!F[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const me=$.from(K,j.extension);me&&u.is(me.execution)?(q.push(me),U.push(this.x(me,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:j.extension}}async v(F){if(u.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,U,j){}};e.$ydc=N,e.$ydc=N=He([Be(0,v.$mM),Be(1,y.$CM),Be(2,m.$ycc),Be(3,E.$xM),Be(4,b.$Bcc),Be(5,P.$Tcc),Be(6,s.$0i),Be(7,a.$occ)],N),e.$zdc=(0,k.$Ph)("IExtHostTask")}),define(De[350],Ce([1,0,16,21,41,36,23,35,37]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class b{constructor(v,y,k){this.k=v,this.l=y,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.$wj(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.$wj(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const y=this.k.folderQueries||[];return new Promise((k,p)=>{const h=s=>{this.f++,v(s)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const a=s.toString(),o=C.$nc(a);this.j&&this.j(a,o)||this.v(h,{base:s,basename:o})}),Promise.all(y.map(s=>this.p(s,h))).then(s=>{k({limitHit:this.e,stats:s[0]||void 0})},s=>{p(new Error((0,d.$Ai)(s)))})})}async p(v,y){const k=new T.$Xd,p=this.q(v),h=this.r(),s=new E.$6I(this.k,v),a=!s.hasSiblingExcludeClauses();let o;try{this.h.add(k),o=m.$Jd.create();const f=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,k.token),l=o.elapsed(),t=m.$Jd.create();return this.g&&!this.e||(f&&f.forEach(i=>{const c=C.$gc.relative(v.folder.path,i.path);if(a){const n=C.$nc(i.path);this.v(y,{base:v.folder,relativePath:c,basename:n});return}this.s(h,v.folder,c,y)}),this.g&&!this.e)?null:(this.u(h,s,y),{providerTime:l,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(v){const y=(0,E.$5I)(this.k.includePattern,v.includePattern),k=(0,E.$5I)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:k,includes:y,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},y,k,p){if(k===this.a){const s=C.$nc(this.a);this.v(p,{base:y,relativePath:this.a,basename:s})}function h(s){const a=C.$nc(s),o=C.$mc(s);let f=v[o];f||(f=v[o]=[],h(o)),f.push({base:y,relativePath:s,basename:a})}h(k)}u({rootEntries:v,pathToEntries:y},k,p){const h=this,s=this.a;function a(o){const f=(0,E.$8I)(()=>o.map(l=>l.basename));for(let l=0,t=o.length;l<t;l++){const i=o[l],{relativePath:c,basename:n}=i;if(k.matchesExcludesSync(c,n,s!==n?f:void 0))continue;const r=y[c];if(r)a(r);else{if(c===s)continue;h.v(p,i)}if(h.e)break}}a(v)}v(v,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(y))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(v,y,k,p){const h=this.c(v.cacheKey),s=new b(v,y,h&&h.token);let a=0;const o=f=>{a+=f.length,k(f.map(l=>this.d(l)))};return this.e(s,L.a,o,p).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:f.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(v)return this.b.has(v)||this.b.set(v,new T.$Xd),this.b.get(v)}d(v){return v.relativePath?{resource:A.$vg(v.base,v.relativePath)}:{resource:v.base}}e(v,y,k,p){const h=p.onCancellationRequested(()=>{v.cancel()}),s=o=>{o&&(a.push(o),y>0&&a.length>=y&&(k(a),a=[]))};let a=[];return v.search(s).then(o=>(a.length&&k(a),h.dispose(),o),o=>(a.length&&k(a),h.dispose(),Promise.reject(o)))}}e.$Jdc=L}),define(De[351],Ce([1,0,19,74,36,99,28,18,16,23,15,17,2,172,227,50,14,44,143,348,37]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.$2J=void 0;let l=class{constructor(g,w,D,N,M){this.a=g,this.b=w,this.c=D,this.d=N,this.e=M}text(g,w,D={}){g=this.f(g,D);const N=this.a.getValue(),M=w&&w.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(w?.map(s.$$h),D),type:2,contentPattern:g,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:N.search.usePCRE2||M||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(g,w){const D=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const N={...g,wordSeparators:D.editor.wordSeparators};return this.j(g,w)&&(N.isCaseSensitive=!0),this.k(g)&&(N.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),N}file(g,w={}){return{...this.h(g,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(g,w){return g?(g=Array.isArray(g)?g.map(r):r(g),w?this.parseSearchPaths(g):{pattern:i(...Array.isArray(g)?g:[g])}):{}}h(g=[],w={}){const D=this.g(w.includePattern,w.expandPatterns),N=this.g(w.excludePattern,w.expandPatterns),M=g.length>1,F=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(O=>this.q(O,w,N)):g.map(O=>this.r(O,w,N,M))).filter(O=>!!O),U={_reason:w._reason,folderQueries:F,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:N.pattern,includePattern:D.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=C.$Hb(C.$Rb(this.c.groups.map(me=>me.editors.map(te=>te.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const q=O.filter(me=>(0,f.$VI)(U,me.fsPath)),K=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...U,...K}}const j=w.extraFileResources&&w.extraFileResources.filter(O=>(0,f.$VI)(U,O.fsPath));return U.extraFileResources=j&&j.length?j:void 0,U}i(g){const w=[],D=new A.$Ac,N={};let M=!1;return g.forEach(F=>{if(F.scheme===m.Schemas.walkThrough)return;if((0,b.$zg)(F)){const j=this.b.getWorkspaceFolder(F)?.uri??F.with({path:E.$mc(F.fsPath)});let O=D.get(j);O||(M=!0,O={folder:j,includePattern:{}},w.push(O),D.set(j,O));const q=E.$lc(j.fsPath,F.fsPath);(0,P.$Jf)(O.includePattern)[q.replace(/\\/g,"/")]=!0}else F.fsPath&&(M=!0,N[F.fsPath]=!0)}),{folderQueries:w,includePattern:N,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}j(g,w){if(w.isSmartCase){if(g.isRegExp){if(L.$pf(g.pattern,!0))return!0}else if(L.$pf(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,y.$vB)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const w=K=>E.$ic(K)||/^\.\.?([\/\\]|$)/.test(K),N=(Array.isArray(g)?g:c(g)).map(K=>{const me=this.e.resolvedUserHome;return me?(0,R.$uv)(K,me.scheme===m.Schemas.file?me.fsPath:me.path):K}),M=T.$J(N,K=>w(K)?"searchPaths":"exprSegments"),F=(M.exprSegments||[]).map(K=>L.$Ke(K,"/")).map(K=>L.$Ke(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),n(K))),U={},j=this.m(M.searchPaths||[]);j&&j.length&&(U.searchPaths=j);const O=C.$Rb(F),q=i(...O);return q&&(U.pattern=q),U}l(g,w){return w.disregardExcludeSettings?void 0:(0,f.$UI)(g,!w.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const w=g.flatMap(N=>{let{pathPortion:M,globPortion:F}=t(N);return F&&(F=u(F)),this.n(M).flatMap(j=>this.o(j,F))}),D=new Map;return w.forEach(N=>{const M=N.searchPath.toString(),F=D.get(M);F?N.pattern&&(F.pattern=F.pattern||{},F.pattern[N.pattern]=!0):D.set(M,{searchPath:N.searchPath,pattern:N.pattern?i(N.pattern):void 0})}),Array.from(D.values())}n(g){if(E.$ic(g)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:g})}]:[{searchPath:v.URI.file(E.$hc(g))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(g=r(g),g.startsWith("../")||g===".."){const N=E.$gc.resolve(w.path,g);return[{searchPath:w.with({path:N})}]}const D=u(g);return[{searchPath:w,pattern:D}]}else{if(g==="./"||g===".\\")return[];{const w=g.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(M=>{const F=w.match(new RegExp(`^${L.$Fe(M.name)}(?:/(.*)|$)`));return F?{match:F,folder:M}:null}).filter(P.$Gf);if(N.length)return N.map(M=>{const F=M.match[1];return{searchPath:M.folder.uri,pattern:F&&u(F)}});{const M=g.match(/\.[\/\\](.+)[\/\\]?/),F=M?M[1]:g,U=k.localize(0,null,F);throw new Error(U)}}}}o(g,w){const D=g.pattern&&w?`${g.pattern}/${w}`:g.pattern||w,N=[{searchPath:g.searchPath,pattern:D}];return D&&!D.endsWith("**")&&N.push({searchPath:g.searchPath,pattern:D+"/**"}),N}q(g,w,D){const N=this.r((0,s.$$h)(g.searchPath),w,D,!1);return N?{...N,includePattern:g.pattern}:null}r(g,w,D,N){let M;const F=v.URI.isUri(g)?g:g.uri;if(D.searchPaths){const K=D.searchPaths.filter(me=>(0,b.$og)(me.searchPath,F))[0];if(K&&!K.pattern)return null;K&&(M=K.pattern)}const U=this.a.getValue({resource:F}),O={...this.l(U,w)||{},...M||{}},q=v.URI.isUri(g)?(0,b.$sg)(g):g.name;return{folder:F,folderName:N?q:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!U.search.followSymlinks}}};e.$2J=l,e.$2J=l=He([Be(0,p.$ji),Be(1,s.$Yh),Be(2,a.$nC),Be(3,h.$0i),Be(4,o.$ZJ)],l);function t($){const g=$.match(/[\*\{\}\(\)\[\]\?]/);if(g){const w=g.index,D=$.substr(0,w).match(/[/|\\][^/\\]*$/);if(D){let N=$.substr(0,D.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:$.substr((D.index||0)+1)}}}return{pathPortion:$}}function i(...$){return $.length?$.reduce((g,w)=>(g[w]=!0,g),Object.create(null)):void 0}function c($){return d.$uj($,",").map(g=>g.trim()).filter(g=>!!g.length)}function n($){return[`**/${$}/**`,`**/${$}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function r($){return $.replace(/\\/g,"/")}function u($){return r($).replace(/^\.\//,"").replace(/\/+$/g,"")}function I($){return $.replace(/([?*[\]])/g,"[$1]")}function S($,g){$=C.$Mb($,N=>N.toString());const w=[],D=g.getWorkspace();return $&&$.forEach(N=>{let M;if(g.getWorkbenchState()===2)M=(0,b.$xg)(D.folders[0].uri,N),M&&M!=="."&&(M="./"+M);else{const F=g.getWorkspaceFolder(N);if(F){const U=F.name;if(D.folders.filter(O=>O.name===U).length===1){const O=(0,b.$xg)(F.uri,N);O===""?M=`./${F.name}`:M=`./${F.name}/${O}`}else M=N.fsPath}}M&&w.push(I(M))}),w}e.$3J=S}),define(De[352],Ce([1,0,23,2,21,9,5,351,37,44]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glb=e.$Flb=void 0;const L=7e3;function P(p,h){const s=h.activationEvents;if(!s)return Promise.resolve(void 0);const a=[],o=[];for(const n of s)if(/^workspaceContains:/.test(n)){const r=n.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||p.forceUsingSearch?o.push(r):a.push(r)}if(a.length===0&&o.length===0)return Promise.resolve(void 0);let f;const l=new Promise((n,r)=>{f=n}),t=n=>f({activationEvent:n}),i=Promise.all(a.map(n=>v(p,n,t))).then(()=>{}),c=y(p,h.identifier,o,t);return Promise.all([i,c]).then(()=>{f(void 0)}),l}e.$Flb=P;async function v(p,h,s){for(const a of p.folders)if(await p.exists(C.$vg(T.URI.revive(a),h))){s(`workspaceContains:${h}`);return}}async function y(p,h,s,a){if(s.length===0)return Promise.resolve(void 0);const o=new d.$Xd,f=p.checkExists(p.folders,s,o.token),l=setTimeout(async()=>{o.cancel(),p.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},L);let t=!1;try{t=await f}catch(i){R.$4(i)||R.$1(i)}o.dispose(),clearTimeout(l),t&&a(`workspaceContains:${s.join(",")}`)}function k(p,h,s,a){const o=p.get(A.$Oh),f=p.get(E.$MI),t=o.createInstance(m.$2J).file(h.map(i=>(0,b.$$h)(T.URI.revive(i))),{_reason:"checkExists",includePattern:s,exists:!0});return f.fileSearch(t,a).then(i=>!!i.limitHit,i=>R.$4(i)?!1:Promise.reject(i))}e.$Glb=k}),define(De[46],Ce([1,0,205,16,54,23,8,3,78,2,14,6,40,283,115,39,26,145,9,25,22,263,7,65,5,27,90,20,104,73,45,4,352,114,265,18,112,35,12,113]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t,i,c,n,r,u,I,S,$,g,w,D,N,M,F,U,j,O){"use strict";var q;Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0,e.$5cc=(0,c.$Ph)("IHostUtils");let K=q=class extends m.$Sc{constructor(H,B,X,re,Y,_,x,ve,ae,fe,ee,de){super(),this.X=de,this.a=this.B(new g.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=X,this.f=x,this.j=re,this.m=Y,this.s=_,this.t=ae,this.u=fe,this.w=ee,this.y=this.g.getProxy(P.$lK.MainThreadWorkspace),this.z=this.g.getProxy(P.$lK.MainThreadTelemetry),this.C=this.g.getProxy(P.$lK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new ce(this.f.extensions.activationEvents),this.L=new s.$z4b(this.I,this.f.extensions.allExtensions);const be=new o.$7l(this.f.extensions.myExtensions);this.J=new s.$z4b(this.I,le(this.L,be)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${G(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${G(this.J)}`)),this.M=new k.$Lcc(this.g,this.s),this.N=new D.$Xcc(this.g),this.O=ve,this.h=H.createChild(new I.$Nh([k.$Mcc,this.M],[D.$Ycc,this.N])),this.P=this.B(new y.$Kcc(this.J,this.L,{onExtensionActivationError:(Pe,z,J)=>{this.C.$onExtensionActivationError(Pe,a.$3(z),J)},actualActivateExtension:async(Pe,z)=>{if(s.$z4b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,z),new y.$Jcc;const J=this.J.getExtensionDescription(Pe);return this.db(J,z)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),d.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){a.$1(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this.cb(Y))}catch{}await Promise.all(H)}terminate(H,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),a.setUnexpectedErrorHandler(re=>{this.s.error(re)}),this.g.dispose();const X=this.Y();Promise.race([(0,A.$Ug)(5e3),X]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const B=await this.C.$getExtension(H);return B&&{...B,identifier:new o.$6l(B.identifier.value),extensionLocation:b.URI.revive(B.extensionLocation)}}Z(H,B){return this.P.activateByEvent(H,B)}$(H,B){return this.P.activateById(H,B)}activateByIdWithErrors(H,B){return this.$(H,B).then(()=>{const X=this.P.getActivatedExtension(H);if(X.activationFailed)return Promise.reject(X.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===M.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(H.fsPath);return b.URI.file(B)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new ie(H))),this.Q}async bb(H){const B=E.$Vh.forUris(X=>R.$mg.ignorePathCasing(X));return await Promise.all(H.map(async X=>{if(this.ub(X)){const re=await this.ab(X.extensionLocation);B.set(re,X)}})),B}cb(H){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return B;const X=this.P.getActivatedExtension(H);if(!X)return B;try{typeof X.module.deactivate=="function"&&(B=Promise.resolve(X.module.deactivate()).then(void 0,re=>(this.s.error(re),Promise.resolve(void 0))))}catch(re){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(re)}try{(0,m.$Nc)(X.subscriptions)}catch(re){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(re)}return B}async db(H,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,B).then(X=>{const re=X.activationTimes;return this.C.$onDidActivateExtension(H.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,B),this.eb(H,B,"success",re),X},X=>{throw this.eb(H,B,"failure"),X})}eb(H,B,X,re){const Y=te(H,B);this.z.$publicLog2("extensionActivationTimes",{...Y,...re||{},outcome:X})}fb(H,B){const X=te(H,B);this.z.$publicLog2("activatePlugin",X);const re=this.ub(H);if(!re)return Promise.resolve(new y.$Icc(y.$Fcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${H.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const Y=new y.$Gcc(B.startup);return Promise.all([this.vb(H,(0,R.$vg)(H.extensionLocation,re),Y),this.gb(H)]).then(_=>(d.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),q.hb(this.s,H.identifier,_[0],_[1],Y))).then(_=>(d.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),_))}gb(H){const B=new l.$Occ(H,this.M),X=new l.$Ncc(H.identifier.value,!1,this.M),re=new N.$Zcc(H,this.N),Y=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,_=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([B.whenReady,X.whenReady,this.O.whenReady]).then(()=>{const x=this;let ve,ae;const fe=(0,h.$gF)(H,"ipc")?this.f.messagePorts?.get(o.$6l.toKey(H.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:X,secrets:re,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(ee){return T.$jc(H.extensionLocation.fsPath,ee)},get storagePath(){return x.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return x.O.globalValue(H).fsPath},get logPath(){return T.$jc(x.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return b.URI.joinPath(x.f.logsLocation,H.identifier.value)},get storageUri(){return x.O.workspaceValue(H)},get globalStorageUri(){return x.O.globalValue(H)},get extensionMode(){return Y},get extension(){return ve===void 0&&(ve=new Q(x,H.identifier,H,_,!1)),ve},get extensionRuntime(){return(0,h.$hF)(H,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!ae){if(!fe)return;const ee=g.Event.buffer(g.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),ae={onDidReceiveMessage:ee,postMessage:fe.postMessage.bind(fe)}}return ae}})})}static hb(H,B,X,re,Y){return X=X||{activate:void 0,deactivate:void 0},this.ib(H,B,X,re,Y).then(_=>new y.$Hcc(!1,null,Y.build(),X,_,re.subscriptions))}static ib(H,B,X,re,Y){if(typeof X.activate=="function")try{Y.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${B.value}`);const _=typeof global=="object"?global:self,x=X.activate.apply(_,[re]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(x).then(ve=>(Y.activateResolveStop(),ve))}catch(_){return Promise.reject(_)}else return Promise.resolve(X)}jb(H,B){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:B}).then(void 0,X=>{this.s.error(X)})}kb(H,B=0){const re=Date.now();(0,j.$B)(()=>{for(let Y=B;Y<H.length;Y+=1){const _=H[Y];for(const x of _.activationEvents??[])if(x==="onStartupFinished")if(Date.now()-re>50){this.kb(H,Y);break}else this.jb(_,x)}})}lb(){this.C.$setPerformanceMarks(d.getMarks()),this.m.getConfigProvider().then(H=>{const B=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),X=this.J.getAllExtensionDescriptions();if(B)this.kb(X);else for(const re of X)if(re.activationEvents)for(const Y of re.activationEvents)Y==="onStartupFinished"&&this.jb(re,Y)})}mb(){const H=this.Z("*",!0).then(void 0,_=>{this.s.error(_)});this.B(this.j.onDidChangeWorkspace(_=>this.nb(_.added)));const B=this.j.workspace?this.j.workspace.folders:[],X=this.nb(B),re=this.pb(),Y=Promise.all([re,H,X]).then(()=>{});return Promise.race([Y,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),Y}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(H,B))).then(()=>{})}async ob(H,B){if(this.isActivated(B.identifier))return;const X=!this.f.remote.isRemote&&!!this.f.remote.authority,re={logService:this.s,folders:H.map(_=>_.uri),forceUsingSearch:X||!this.c.fsExists,exists:_=>this.c.fsExists(_.fsPath),checkExists:(_,x,ve)=>this.y.$checkExists(_,x,ve)},Y=await(0,w.$Flb)(re,B);if(Y)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Y.activationEvent}).then(void 0,_=>this.s.error(_))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:B}=this.f.environment;if(!H||!B)throw new Error(C.localize(0,null));const X=await this.vb(null,B,new y.$Gcc(!1));if(!X||typeof X.run!="function")throw new Error(C.localize(1,null,B.toString()));return new Promise((re,Y)=>{const _=(ae,fe)=>{ae?(j.$t&&this.s.error("Test runner called back with error",ae),Y(ae)):(j.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),re(typeof fe=="number"&&fe>0?1:0))},x=(0,R.$jg)(B),ve=X.run(x,_);ve&&ve.then&&ve.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),re(0)}).catch(ae=>{j.$t&&this.s.error("Test runner finished with error",ae),Y(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,B){return this.R[H]=B,(0,m.$Qc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:B}=await this.sb(H);return B?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const B=H.indexOf("+");if(B===-1)throw new t.$tK("Not an authority that can be resolved!",i.RemoteAuthorityResolverErrorCode.InvalidAuthority);const X=H.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${X}`,!1),{authorityPrefix:X,resolver:this.R[X]}}async $resolveAuthority(H,B){const X=U.$Jd.create(!1),re=()=>`[resolveAuthority(${(0,i.$Tk)(H)},${B})][${X.elapsed()}ms] `,Y=oe=>this.s.info(`${re()}${oe}`),_=oe=>this.s.warn(`${re()}${oe}`),x=(oe,Z=void 0)=>this.s.error(`${re()}${oe}`,Z),ve=oe=>{if(oe instanceof t.$tK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},ae=async oe=>{Y(`activating resolver for ${oe}...`);const{resolver:Z,authorityPrefix:ge}=await this.sb(oe);if(!Z)throw x(`no resolver for ${ge}`),new t.$tK(`No remote extension installed to resolve ${ge}.`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Z,authorityPrefix:ge,remoteAuthority:oe}},fe=H.split(/@|%40/g).reverse();Y(`activating remote resolvers ${fe.join(" -> ")}`);let ee;try{ee=await Promise.all(fe.map(ae)).catch(async oe=>{if(!(oe instanceof t.$tK)||oe._code!==i.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return _(`resolving nested authorities failed: ${oe.message}`),[await ae(H)]})}catch(oe){return ve(oe)}const de=new A.$5g;de.cancelAndSet(()=>Y("waiting..."),1e3);let be,Pe;for(const[oe,{authorityPrefix:Z,resolver:ge,remoteAuthority:Ee}]of ee.entries())try{if(oe===ee.length-1)Y("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${Z}`),be=await ge.resolve(Ee,{resolveAttempt:B,execServer:Pe}),d.mark(`code/extHost/didResolveAuthorityOK/${Z}`),Y("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$sK.isManagedResolvedAuthority(be)?be:void 0));else{if(Y(`invoking resolveExecServer() for ${Ee}`),d.mark(`code/extHost/willResolveExecServer/${Z}`),Pe=await ge.resolveExecServer?.(Ee,{resolveAttempt:B,execServer:Pe}),!Pe)throw new t.$tK(`Exec server was not available for ${Ee}`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${Z}`)}}catch(je){return d.mark(`code/extHost/didResolveAuthorityError/${Z}`),x("returned an error",je),de.dispose(),ve(je)}de.dispose();const z={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},J={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};Y(`returned ${t.$sK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let se;if(t.$sK.isManagedResolvedAuthority(be)){const oe=B;this.X.setFactory(oe,be.makeConnection),se={authority:H,connectTo:new i.$Qk(oe),connectionToken:be.connectionToken}}else se={authority:H,connectTo:new i.$Rk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:se,options:J,tunnelInformation:z}}}async $getCanonicalURI(H,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,i.$Tk)(H)})`);const{resolver:X}=await this.sb(H);if(!X)return null;const re=b.URI.revive(B);if(typeof X.getCanonicalURI>"u")return re;const Y=await(0,A.$Mg)(()=>X.getCanonicalURI(re));return Y||re}$startExtensionHost(H){H.toAdd.forEach(re=>re.extensionLocation=b.URI.revive(re.extensionLocation));const{globalRegistry:B,myExtensions:X}=me(this.I,this.L,this.J,H);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(X),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${G(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${G(this.J)}`)),this.rb()}$activateByEvent(H,B){return B===1?this.D.wait().then(X=>this.Z(H,!1)):this.G.wait().then(X=>this.Z(H,!1))}async $activate(H,B){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,B),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(_=>_.extensionLocation=b.URI.revive(_.extensionLocation));const{globalRegistry:B,myExtensions:X}=me(this.I,this.L,this.J,H),re=await this.bb(X);return(await this.getExtensionPathIndex()).setSearchTree(re),this.L.set(B.getAllExtensionDescriptions()),this.J.set(X),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${G(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${G(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const B=f.$be.alloc(H),X=Math.random()%256;for(let re=0;re<H;re++)B.writeUInt8(X,re);return B}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$6cc=K,e.$6cc=K=q=He([Be(0,c.$Oh),Be(1,e.$5cc),Be(2,u.$mM),Be(3,p.$ycc),Be(4,v.$Bcc),Be(5,L.$0i),Be(6,n.$CM),Be(7,r.$Rcc),Be(8,S.$cwb),Be(9,$.$Tcc),Be(10,F.$2cc),Be(11,O.$3cc)],K);function me(ye,H,B,X){ye.addActivationEvents(X.addActivationEvents);const re=new s.$z4b(ye,H.getAllExtensionDescriptions());re.deltaExtensions(X.toAdd,X.toRemove);const Y=new o.$7l(B.getAllExtensionDescriptions().map(x=>x.identifier));for(const x of X.myToRemove)Y.delete(x);for(const x of X.myToAdd)Y.add(x);const _=le(re,Y);return{globalRegistry:re,myExtensions:_}}function te(ye,H){return{id:ye.identifier.value,name:ye.name,extensionVersion:ye.version,publisherDisplayName:ye.publisher,activationEvents:ye.activationEvents?ye.activationEvents.join(","):null,isBuiltin:ye.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function G(ye){return ye.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$7cc=(0,c.$Ph)("IExtHostExtensionService");class Q{#e;#t;#i;constructor(H,B,X,re,Y){this.#e=H,this.#t=B,this.#i=X.identifier,this.id=X.identifier.value,this.extensionUri=X.extensionLocation,this.extensionPath=T.$hc((0,R.$jg)(X.extensionLocation)),this.packageJSON=X,this.extensionKind=re,this.isFromDifferentExtensionHost=Y}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$8cc=Q;function le(ye,H){return ye.getAllExtensionDescriptions().filter(B=>H.has(B.identifier))}class ie{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$9cc=ie;class ce{constructor(H){this.a=new o.$8l,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const B of Object.keys(H))this.a.set(B,H[B])}}}),define(De[353],Ce([1,0,54,2,6,40,26,25,20,27,5,46,14,15]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;let p=class{constructor(f,l,t,i,c,n,r){this.c=f,this.d=l,this.e=t,this.f=i,this.g=c,this.h=n,this.i=r,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const f=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new s(this.c,l,this.d,f,this.i)),this.register(this.e.createInstance(h)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,l,this.h.environment.appUriScheme))}register(f){if("nodeModuleName"in f)if(Array.isArray(f.nodeModuleName))for(const l of f.nodeModuleName)this.a.set(l,f);else this.a.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this.b.push(l=>f.alternativeModuleName(l))}};e.$uec=p,e.$uec=p=He([Be(2,L.$Oh),Be(3,R.$Bcc),Be(4,P.$7cc),Be(5,b.$CM),Be(6,v.$0i)],p);let h=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(f){if(f.environment.appRoot&&k.a.size){const l=(0,y.$Fe)(this.c(f.environment.appRoot.fsPath)),t="[a-z0-9_.-]",i=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${c}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(f){if(!this.b)return;const l=this.b.exec(this.c(f));if(!l)return;const[,t,i,c]=l,n=k.a.get(i);if(n!==void 0)return console.warn(`${i} as been renamed to ${n}, please update your imports`),t+n+c}c(f){return f.replace(/\\/g,"/")}};h=k=He([Be(0,b.$CM)],h);class s{constructor(f,l,t,i,c){this.c=f,this.d=l,this.e=t,this.f=i,this.g=c,this.nodeModuleName="vscode",this.a=new m.$8l}load(f,l){const t=this.d.findSubstr(l);if(t){let i=this.a.get(t.identifier);return i||(i=this.c(t,this.e,this.f),this.a.set(t.identifier,i)),i}if(!this.b){let i="";this.d.forEach((c,n)=>i+=`	${n} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${i}`),this.b=this.c(A.$bF,this.e,this.f)}return this.b}}let a=class{constructor(f,l,t){this.e=f,this.f=l,this.nodeModuleName=["open","opn"],this.d=t.getProxy(d.$lK.MainThreadTelemetry);const i=t.getProxy(d.$lK.MainThreadWindow);this.c=(c,n)=>{const r=T.URI.parse(c);return n?this.g(c,n):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,c,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this.f?i.$openUri(r,c,{}):this.g(c,n)}}load(f,l,t){const i=this.e.findSubstr(l);return i&&(this.a=i.identifier.value,this.h()),this.b=t(f),this.c}g(f,l){return this.i(),this.b(f,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=He([Be(2,E.$mM)],a)}),define(De[56],Ce([1,0,47,3,16,48,5,70,71,46,7,39,280,40]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,A.$Ph)("IExtHostVariableResolverProvider");class k extends v.$nN{constructor(s,a,o,f,l,t,i){function c(){if(o){const n=o.activeEditor();if(n)return n.document.uri;const r=f.tabGroups.all.find(u=>u.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof L.$6L||r.input instanceof L.$$L)return r.input.modified;if(r.input instanceof L.$5L||r.input instanceof L.$0L||r.input instanceof L.$8L)return r.input.uri}}}super({getFolderUri:n=>{const r=t.folders.filter(u=>u.name===n);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,r)=>l.getConfiguration(void 0,n).get(r),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=c();if(n)return d.$hc(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const n=c();if(n){const r=a.getWorkspaceFolder(n);if(r)return d.$hc(r.uri.fsPath)}}},getSelectedText:()=>{if(o){const n=o.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(o){const n=o.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>s.getExtension(n)},void 0,i?Promise.resolve(i):void 0,Promise.resolve(R.env))}}let p=class extends T.$Sc{constructor(s,a,o,f,l){super(),this.b=s,this.c=a,this.g=o,this.h=f,this.j=l,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async n=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$Ddc=p,e.$Ddc=p=He([Be(0,b.$7cc),Be(1,P.$ycc),Be(2,m.$xM),Be(3,y.$Bcc),Be(4,E.$Adc)],p)}),define(De[94],Ce([1,0,8,4,2,5,6,71,46,20,7,39,140,273,40,56]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=e.$Gdc=e.$Fdc=e.$Edc=void 0,e.$Edc=(0,R.$Ph)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(i,c,n,r,u,I){this.E=c,this.F=n,this.G=r,this.H=u,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Nd,this.n=new T.$Nd,this.o=new T.$Nd,this.u=new T.$Nd,this.k=i.getProxy(A.$lK.MainThreadDebugService),this.y=new T.$Nd,this.A=new T.$Nd,this.v=new a(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange($=>{this.J(S)}),this.J(S)})}asDebugSourceUri(i,c){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let r=`debug:${encodeURIComponent(n.path||"")}`,u="?";return c&&(r+=`${u}session=${encodeURIComponent(c.id)}`,u="&"),r+=`${u}ref=${n.sourceReference}`,d.URI.parse(r)}else{if(n.path)return d.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(i){const c=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const r=n.contributes.debuggers;if(r&&r.length>0)for(const u of r)(0,y.$vF)(u)&&c.push(u.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const i=[];return this.w.forEach(c=>i.push(c)),i}addBreakpoints(i){const c=i.filter(u=>{const I=u.id;return this.w.has(I)?!1:(this.w.set(I,u),!0)});this.U(c,[],[]);const n=[],r=new Map;for(const u of c)if(u instanceof L.$mL){let I=r.get(u.location.uri.toString());I||(I={type:"sourceMulti",uri:u.location.uri,lines:[]},r.set(u.location.uri.toString(),I),n.push(I)),I.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof L.$nL&&n.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(i){const c=i.filter(I=>this.w.delete(I.id));this.U([],c,[]);const n=c.filter(I=>I instanceof L.$mL).map(I=>I.id),r=c.filter(I=>I instanceof L.$nL).map(I=>I.id),u=c.filter(I=>I instanceof L.$oL).map(I=>I.id);return this.k.$unregisterBreakpoints(n,r,u)}startDebugging(i,c,n){return this.k.$startDebugging(i?i.uri:void 0,c,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===L.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(i){return this.k.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,c,n){if(!c)return new L.$nK(()=>{});const r=this.d++;return this.f.push({type:i,handle:r,provider:c}),this.k.$registerDebugConfigurationProvider(i,n,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,r),new L.$nK(()=>{this.f=this.f.filter(u=>u.provider!==c),this.k.$unregisterDebugConfigurationProvider(r)})}registerDebugAdapterDescriptorFactory(i,c,n){if(!n)return new L.$nK(()=>{});if(!this.Q(i,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const r=this.g++;return this.h.push({type:c,handle:r,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(c,r),new L.$nK(()=>{this.h=this.h.filter(u=>u.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(r)})}registerDebugAdapterTrackerFactory(i,c){if(!c)return new L.$nK(()=>{});const n=this.i++;return this.j.push({type:i,handle:n,factory:c}),new L.$nK(()=>{this.j=this.j.filter(r=>r.factory!==c)})}async $runInTerminal(i,c){return Promise.resolve(void 0)}async $substituteVariables(i,c){let n;const r=await this.W(i);return r&&(n={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(n,c)}K(i,c){if(i.type==="implementation")return new f(i.implementation)}L(){}async $startDASession(i,c){const n=this,r=await this.V(c);return this.S(this.N(r.type),r).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}' (extension might have failed to activate)`);const I=this.M(u),S=this.K(I,r);if(!S)throw new Error(`Couldn't create a debug adapter for type '${r.type}'.`);const $=S;return this.B.set(i,$),this.R(r).then(g=>(g&&this.C.set(i,g),$.onMessage(async w=>{if(w.type==="request"&&w.command==="handshake"){const D=w,N={type:"response",seq:0,command:D.command,request_seq:D.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const M=await this.D.sign(D.arguments.value);N.body={signature:M},$.sendResponse(N)}else throw new Error("no signer")}catch(M){N.success=!1,N.message=M.message,$.sendResponse(N)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(w),w=(0,y.$AF)(w,!0),n.k.$acceptDAMessage(i,w)}),$.onError(w=>{g&&g.onError&&g.onError(w),this.k.$acceptDAError(i,w.name,w.message,w.stack)}),$.onExit(w=>{g&&g.onExit&&g.onExit(w??void 0,void 0),this.k.$acceptDAExit(i,w??void 0,void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),$.startSession()))})}$sendDAMessage(i,c){c=(0,y.$zF)(c,!1);const n=this.C.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(c),this.B.get(i)?.sendMessage(c)}$stopDASession(i){const c=this.C.get(i);this.C.delete(i),c&&c.onWillStopSession&&c.onWillStopSession();const n=this.B.get(i);return this.B.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const c=[],n=[],r=[];if(i.added)for(const u of i.added){const I=u.id;if(I&&!this.w.has(I)){let S;if(u.type==="function")S=new L.$nL(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")S=new L.$oL(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const $=d.URI.revive(u.uri);S=new L.$mL(new L.$zK($,new L.$oK(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,L.$kL)(S,I),this.w.set(I,S),c.push(S)}}if(i.removed)for(const u of i.removed){const I=this.w.get(u);I&&(this.w.delete(u),n.push(I))}if(i.changed){for(const u of i.changed)if(u.id){const I=this.w.get(u.id);if(I){if(I instanceof L.$nL&&u.type==="function"){const S=I;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.functionName=u.functionName}else if(I instanceof L.$mL&&u.type==="source"){const S=I;S.enabled=u.enabled,S.condition=u.condition,S.hitCondition=u.hitCondition,S.logMessage=u.logMessage,S.location=new L.$zK(d.URI.revive(u.uri),new L.$oK(u.line,u.character))}r.push(I)}}}this.U(c,n,r)}async $acceptStackFrameFocus(i){let c;const n=i.sessionId?await this.V(i.sessionId):void 0;if(!n)throw new Error("no DebugSession found for debug focus context");i.kind==="thread"?c=new L.$uL(n,i.threadId):c=new L.$tL(n,i.threadId,i.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(i,c,n){return(0,C.$Mg)(async()=>{const r=this.P(i);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.W(c);return r.provideDebugConfigurations(u,n)}).then(r=>{if(!r)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return r})}$resolveDebugConfiguration(i,c,n,r){return(0,C.$Mg)(async()=>{const u=this.P(i);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(c);return u.resolveDebugConfiguration(I,n,r)})}$resolveDebugConfigurationWithSubstitutedVariables(i,c,n,r){return(0,C.$Mg)(async()=>{const u=this.P(i);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(c);return u.resolveDebugConfigurationWithSubstitutedVariables(I,n,r)})}async $provideDebugAdapter(i,c){const n=this.O(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const r=await this.V(c);return this.S(n,r).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}'`);return this.M(u)})}async $acceptDebugSessionStarted(i){const c=await this.V(i);this.m.fire(c)}async $acceptDebugSessionTerminated(i){const c=await this.V(i);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(i){this.q=i?await this.V(i):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(i,c){(await this.V(i))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(i,c){const r={session:await this.V(i),event:c.event,body:c.body};this.u.fire(r)}M(i){if(i instanceof L.$pL)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof L.$qL)return{type:"server",port:i.port,host:i.host};if(i instanceof L.$rL)return{type:"pipeServer",path:i.path};if(i instanceof L.$sL)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}N(i){const c=this.h.filter(n=>n.type===i);if(c.length>0)return c[0].factory}O(i){const c=this.h.filter(n=>n.handle===i);if(c.length>0)return c[0].factory}P(i){const c=this.f.filter(n=>n.handle===i);if(c.length>0)return c[0].provider}Q(i,c){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const r of n)if(r.label&&r.type&&r.type===c)return!0}}return!1}R(i){const n=i.configuration.type,r=this.j.filter(u=>u.type===n||u.type==="*").map(u=>(0,C.$Mg)(()=>u.factory.createDebugAdapterTracker(i)).then(I=>I,I=>null));return Promise.race([Promise.all(r).then(u=>{const I=u.filter(S=>!!S);if(I.length>0)return new o(I)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async S(i,c){const n=c.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new L.$qL(n));if(i){const u=await this.F.getExtensionRegistry();return(0,C.$Mg)(()=>i.createDebugAdapterDescriptor(c,this.T(c,u))).then(I=>{if(I)return I})}const r=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,r))}T(i,c){}U(i,c,n){(i.length>0||c.length>0||n.length>0)&&this.y.fire(Object.freeze({added:i,removed:c,changed:n}))}async V(i){if(i)if(typeof i=="string"){const c=this.l.get(i);if(c)return c}else{let c=this.l.get(i.id);if(!c){const n=await this.W(i.folderUri),r=i.parent?this.l.get(i.parent):void 0;c=new s(this.k,i.id,i.type,i.name,n,i.configuration,r),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(i){if(i){const c=d.URI.revive(i);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$Fdc=h,e.$Fdc=h=He([Be(0,b.$mM),Be(1,P.$ycc),Be(2,E.$7cc),Be(3,k.$Bcc),Be(4,m.$Adc),Be(5,p.$Cdc)],h);class s{constructor(i,c,n,r,u,I,S){this.d=i,this.f=c,this.g=n,this.h=r,this.i=u,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(i){this.h=i,this.d.$setDebugSessionName(this.f,i)}get parentSession(){return this.k}_acceptNameChanged(i){this.h=i}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(i,c){return this.d.$customDebugAdapterRequest(this.f,i,c)}getDebugProtocolBreakpoint(i){return this.d.$getDebugProtocolBreakpoint(this.f,i.id)}}e.$Gdc=s;class a{constructor(i){this.value=Object.freeze({append(c){i.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$Hdc=a;class o{constructor(i){this.d=i}onWillStartSession(){this.d.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(i):void 0)}onWillStopSession(){this.d.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.d.forEach(c=>c.onError?c.onError(i):void 0)}onExit(i,c){this.d.forEach(n=>n.onExit?n.onExit(i,c):void 0)}}class f extends v.$$cb{constructor(i){super(),this.h=i,i.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.h.handleMessage(i)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends h{constructor(i,c,n,r,u,I){super(i,c,n,r,u,I)}};e.$Idc=l,e.$Idc=l=He([Be(0,b.$mM),Be(1,P.$ycc),Be(2,E.$7cc),Be(3,k.$Bcc),Be(4,m.$Adc),Be(5,p.$Cdc)],l)}),define(De[354],Ce([1,0,9,54,2,6,345,14,103,104,27,239,20,67,46,88]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;class h{static async installEarlyHandler(o){Error.stackTraceLimit=100;const f=o.get(m.$0i),t=o.get(v.$mM).getProxy(R.$lK.MainThreadErrors);C.setUnexpectedErrorHandler(i=>{f.error(i);const c=C.$3(i);t.$onUnexpectedError(c)})}static async installFullHandler(o){const f=o.get(m.$0i),l=o.get(v.$mM),t=o.get(k.$7cc),i=o.get(p.$GM),c=l.getProxy(R.$lK.MainThreadExtensionService),n=l.getProxy(R.$lK.MainThreadErrors),r=await t.getExtensionPathIndex(),u=new WeakMap;function I(g,w){if(u.has(g))return u.get(g).stack;let D="",N,M;for(const U of w)D+=`
	at ${U.toString()}`,M=U.getFileName(),!N&&M&&(N=r.findSubstr(d.URI.file(M)));const F=`${g.name||"Error"}: ${g.message||""}${D}`;return u.set(g,{extensionIdentifier:N?.identifier,stack:F}),F}const S=Symbol("prepareStackTrace wrapped");let $=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(g){if(g===I||!g||g[S]){$=g||I;return}$=function(w,D){return I(w,D),g.call(Error,w,D)},Object.assign($,{[S]:!0})}}),C.setUnexpectedErrorHandler(g=>{f.error(g);const w=C.$3(g),D=u.get(g);if(!D?.extensionIdentifier){n.$onUnexpectedError(w);return}c.$onExtensionRuntimeError(D.extensionIdentifier,w);const N=i.onExtensionError(D.extensionIdentifier,g);f.trace("forwarded error to extension?",N,D)})}}e.$vec=h;class s{constructor(o,f,l,t,i){this.a=l,this.b=new A.$I4b(o,null,t),f=s.e(f,this.b);const c=new b.$Nh(...(0,E.$xr)());c.set(L.$CM,{_serviceBrand:void 0,...f,messagePorts:i}),c.set(v.$mM,new v.$nM(this.b)),c.set(y.$vcc,new y.$wcc(t)),c.set(k.$5cc,l);const n=new P.$dq(c,!0);n.invokeFunction(h.installEarlyHandler),this.d=n.invokeFunction(r=>r.get(m.$0i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",f),this.c=n.invokeFunction(r=>r.get(k.$7cc)),this.c.initialize(),n.invokeFunction(h.installFullHandler)}async asBrowserUri(o){const f=this.b.getProxy(R.$lK.MainThreadExtensionService);return d.URI.revive(await f.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,f){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(f.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=d.URI.revive(f.transformIncomingURIs(o.environment.appRoot));const l=o.environment.extensionDevelopmentLocationURI;return l&&(o.environment.extensionDevelopmentLocationURI=l.map(t=>d.URI.revive(f.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=d.URI.revive(f.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=d.URI.revive(f.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=d.URI.revive(f.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=d.URI.revive(f.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=d.URI.revive(f.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=d.URI.revive(f.transformIncomingURIs(o.logsLocation)),o.workspace=f.transformIncomingURIs(o.workspace),o}}e.$wec=s}),define(De[355],Ce([1,0,8,12,216,233,138,94,71,46,20,45,7,56,39,274,275,40]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;let a=class extends m.$Fdc{constructor(i,c,n,r,u,I,S){super(i,c,n,r,I,S),this.Z=u,this.X=new l}K(i,c){switch(i.type){case"server":return new p.$Bec(i);case"pipeServer":return new p.$Cec(i);case"executable":return new p.$Dec(i,c.type)}return super.K(i,c)}T(i,c){const n=p.$Dec.platformAdapterExecutable(c.getAllExtensionDescriptions(),i.type);if(n)return new v.$pL(n.command,n.args,n.options)}L(){return new A.$s8b}async $runInTerminal(i,c){if(i.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const n=await this.G.getConfigProvider(),r=this.Z.getDefaultShell(!0),u=this.Z.getDefaultShellArgs(!0),I=i.title||d.localize(0,null),S=JSON.stringify({shell:r,shellArgs:u});let $=await this.X.checkout(S,I),g,w=!1;if($)g=i.cwd;else{const F={shellPath:r,shellArgs:u,cwd:i.cwd,name:I,iconPath:new v.$hL("debug")};w=!0,$=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,S)}$.show(!0);const D=await $.processId;w?await new Promise(F=>setTimeout(F,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?$.sendText("cls"):r.indexOf("bash")>=0?$.sendText("clear"):T.$j?$.sendText("cls"):$.sendText("clear"));const N=(0,h.$Fec)(r,i.args,!!i.argsCanBeInterpretedByShell,g,i.env);$.sendText(N);const M=this.onDidTerminateDebugSession(F=>{F.id===c&&(this.X.free($),M.dispose())});return D}else if(i.kind==="external")return f(i,await this.G.getConfigProvider());return super.$runInTerminal(i,c)}};e.$Gec=a,e.$Gec=a=He([Be(0,L.$mM),Be(1,k.$ycc),Be(2,b.$7cc),Be(3,s.$Bcc),Be(4,P.$Tcc),Be(5,E.$Adc),Be(6,y.$Cdc)],a);let o;function f(t,i){if(!o)if(T.$j)o=new R.$e7b;else if(T.$k)o=new R.$f7b;else if(T.$l)o=new R.$g7b;else throw new Error("external terminals not supported on this platform");const c=i.getConfiguration("terminal");return o.runInTerminal(t.title,t.cwd,t.args,t.env||{},c.external||{})}class l{constructor(){this.b=new Map}static{this.a=1e3}async checkout(i,c){const r=[...this.b.entries()].map(([u,I])=>(0,C.$Hg)(async S=>{if(u.name!==c||I.lastUsedAt!==-1&&await(0,h.$Eec)(await u.processId))return null;const $=Date.now();return I.lastUsedAt+l.a>$||S.isCancellationRequested||I.config!==i?null:(I.lastUsedAt=$,u)}));return await(0,C.$Yg)(r,u=>!!u)}insert(i,c){this.b.set(i,{lastUsedAt:Date.now(),config:c})}free(i){const c=this.b.get(i);c&&(c.lastUsedAt=-1)}onTerminalClosed(i){this.b.delete(i)}}}),define(De[356],Ce([1,0,16,2,101,39,70,40,44,45,20,27,93,18,14,89,23,63,56]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;let o=class extends v.$xdc{constructor(l,t,i,c,n,r,u,I,S){super(l,t,i,c,n,r,u,I),this.B=i,this.C=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(l,t){const i=t;if(!t.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const c=v.TaskHandleDTO.from(i,this.B),n=await this.a.$getTaskExecution(c);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(n,t);return this.a.$executeTask(c).catch(()=>{}),r}else{const c=v.TaskDTO.from(t,l);if(c===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(c.execution)&&await this.x(c,t,!1);const n=await this.y(await this.a.$getTaskExecution(c),t);return this.a.$executeTask(c).catch(()=>{}),n}}u(l,t,i,c){const n=[];if(c)for(const r of c){this.z(r,i),(!r.definition||!l[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const u=v.TaskDTO.from(r,i.extension);u&&(n.push(u),v.CustomExecutionDTO.is(u.execution)&&t.push(this.x(u,r,!0)))}return{tasks:n,extension:i.extension}}async v(l){return l}async F(l){let t=l&&l.length>0?l[0]:void 0;if(!t){const i=T.URI.file((0,s.homedir)());t=new E.$0h({uri:i,name:h.$sg(i),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(l,t){const i=T.URI.revive(l),c={process:void 0,variables:Object.create(null)},n=await this.b.resolveWorkspaceFolder(i),r=await this.b.getWorkspaceFolders2()??[],u=await this.C.getResolver(),I=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(r);for(const S of t.variables)c.variables[S]=await u.resolveAsync(I,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(C.$tc);for(let $=0;$<S.length;$++)S[$]=await u.resolveAsync(I,S[$])}c.process=await d.win32.findExecutable(await u.resolveAsync(I,t.process.name),t.process.cwd!==void 0?await u.resolveAsync(I,t.process.cwd):void 0,S)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(l,t,i){return d.win32.findExecutable(l,t,i)}};e.$yec=o,e.$yec=o=He([Be(0,L.$mM),Be(1,P.$CM),Be(2,R.$ycc),Be(3,A.$xM),Be(4,m.$Bcc),Be(5,b.$Tcc),Be(6,k.$0i),Be(7,p.$occ),Be(8,a.$Cdc)],o)}),define(De[357],Ce([1,0,63,56]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class d extends T.$Ddc{m(){return(0,C.homedir)()}}e.$efc=d}),define(De[153],Ce([1,0,19,8,21,41,18,16,23,2,37]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=e.$Ldc=e.$Kdc=void 0;class P{constructor(a,o,f,l){this.d=a,this.e=o,this.f=f,this.g=l,this.a=null,this.b=!1,this.c=0}search(a,o){const f=this.d.folderQueries||[],l=new d.$Xd(o);return new Promise((t,i)=>{this.a=new y(a);let c=!1;const n=(r,u)=>{if(!c&&!this.b){const I=this.h(r);p(r)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,c=!0,l.cancel(),r=this.j(r,this.d.maxResults-this.c));const S=this.h(r);this.c+=S,(S>0||!p(r))&&this.a.add(r,u)}};Promise.all(f.map((r,u)=>this.k(r,I=>n(I,u),l.token))).then(r=>{l.dispose(),this.a.flush();const u=r.some(I=>!!I&&!!I.limitHit);t({limitHit:this.b||u,messages:(0,C.$Rb)(r.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},r=>{l.dispose();const u=(0,R.$Ai)(r);i(new Error(u))})})}h(a){return p(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,o){const f=Array.isArray(a.ranges)?a.ranges:[a.ranges],l=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:f.slice(0,o),preview:{matches:l.slice(0,o),text:a.preview.text},uri:a.uri}}async k(a,o,f){const l=new L.$6I(this.d,a),t=[],i={report:r=>{if(!this.l(r))return;const u=a.folder.scheme===A.Schemas.file?(0,L.$7I)(()=>this.f.readdir(E.$ug(r.uri))):void 0,I=E.$xg(a.folder,r.uri);if(I){const S=l.includedInQuery(I,m.$nc(I),u);(0,T.$Gg)(S)?t.push(S.then($=>{$&&o(r)})):S&&o(r)}}},c=this.n(a),n=await this.e.provideTextSearchResults(v(this.d.contentPattern),c,i,f);return t.length&&await Promise.all(t),n}l(a){if(p(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const o=(0,L.$5I)(this.d.includePattern,a.includePattern),f=(0,L.$5I)(this.d.excludePattern,a.excludePattern),l={folder:b.URI.from(a.folder),excludes:f,includes:o,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$Kdc=P;function v(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class y{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new h(512,o=>this.g(o))}add(a,o){this.d&&(this.b!==o||!E.$og(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:a.uri,results:[]}),this.d.results.push(k(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$Ldc=y;function k(s){return p(s)?{preview:{matches:(0,C.$2b)(s.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:s.preview.text},ranges:(0,C.$2b)(s.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function p(s){return!!s.preview}e.$Mdc=p;class h{static{this.a=4e3}static{this.b=50}constructor(a,o){this.g=a,this.h=o,this.c=0,this.d=[],this.e=0}addItem(a,o){a&&this.j(a,o)}addItems(a,o){a&&this.k(a,o)}j(a,o){this.d.push(a),this.e+=o,this.l()}k(a,o){this.d=this.d.concat(a),this.e+=o,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Ndc=h}),define(De[95],Ce([1,0,3,6,5,350,20,67,14,2,153]),function($e,e,C,T,d,R,A,m,E,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=e.$Odc=void 0,e.$Odc=(0,d.$Ph)("IExtHostSearch");let P=class{constructor(p,h,s){this.k=p,this.l=h,this.n=s,this.c=this.k.getProxy(T.$lK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Jdc}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,h){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const s=this.d++;return this.e.set(s,h),this.c.$registerTextSearchProvider(s,this.o(p)),(0,C.$Qc)(()=>{this.g.delete(p),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(p,h){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const s=this.d++;return this.h.set(s,h),this.c.$registerFileSearchProvider(s,this.o(p)),(0,C.$Qc)(()=>{this.i.delete(p),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(p,h,s,a){const o=v(s),f=this.h.get(p);if(f)return this.j.fileSearch(o,f,l=>{this.c.$handleFileMatch(p,h,l.map(t=>t.resource))},a);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,h,s,a){const o=this.e.get(p);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const f=v(s);return this.q(f,o).search(t=>this.c.$handleTextMatch(p,h,t),a)}$enableExtensionHostSearch(){}q(p,h){return new L.$Kdc(p,h,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Pdc=P,e.$Pdc=P=He([Be(0,A.$mM),Be(1,m.$vcc),Be(2,E.$0i)],P);function v(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(y),extraFileResources:k.extraFileResources&&k.extraFileResources.map(p=>b.URI.revive(p))}}e.$Qdc=v;function y(k){return{...k,folder:b.URI.revive(k.folder)}}}),define(De[358],Ce([1,0,21,9,4,38,2,130,125,168,185,30,6,111,304,303,34,305,40,307,308,309,284,310,70,46,312,313,318,319,320,152,288,326,327,330,115,45,332,289,13,7,85,335,91,151,39,25,278,317,66,149,93,94,95,14,67,20,27,321,276,73,89,296,333,90,72,338,336,337,297,55,331,334,114,71,88,322,92,323,18,134,287,264,315,3,26,272,112,258,324,325,298,314,286,316,113,328,301,329,302,295,311,299,300]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t,i,c,n,r,u,I,S,$,g,w,D,N,M,F,U,j,O,q,K,me,te,G,Q,le,ie,ce,ye,H,B,X,re,Y,_,x,ve,ae,fe,ee,de,be,Pe,z,J,se,oe,Z,ge,Ee,je,We,_e,Xe,it,tt,Ae,Ne,qe,Le,Ye,he,ue,Ie,Ke,Ue,Ze,nt,ct,bt,Et,Kt,Ht,vt,Ut,Nt,Gt,zt,Dt,Ft,Bt,Jt,Wt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;function Ot(ut){const ft=ut.get(ae.$CM),At=ut.get(je.$lcc),Vt=ut.get(se.$Qcc),Rt=ut.get(n.$7cc),at=ut.get(le.$ycc),pt=ut.get(tt.$GM),Tt=ut.get(a.$Bcc),Pt=ut.get(x.$vcc),Ge=ut.get(ve.$mM),Qt=ut.get(F.$Mcc),Me=ut.get(J.$Rcc),Te=ut.get(_.$$i),Se=ut.get(_.$0i),ne=ut.get(de.$cwb),Fe=ut.get(be.$occ),Ve=ut.get(Q.$sdc),xe=ut.get(Xe.$Ycc),Je=ut.get(it.$Adc),rt=ut.get(Nt.$3cc);Ge.set(v.$mK.ExtHostFileSystemInfo,At),Ge.set(v.$mK.ExtHostLogLevelServiceShape,Te),Ge.set(v.$mK.ExtHostWorkspace,at),Ge.set(v.$mK.ExtHostConfiguration,Tt),Ge.set(v.$mK.ExtHostExtensionService,Rt),Ge.set(v.$mK.ExtHostStorage,Qt),Ge.set(v.$mK.ExtHostTunnelService,ne),Ge.set(v.$mK.ExtHostWindow,Ve),Ge.set(v.$mK.ExtHostSecretState,xe),Ge.set(v.$mK.ExtHostTelemetry,pt),Ge.set(v.$mK.ExtHostEditorTabs,Je),Ge.set(v.$mK.ExtHostManagedSockets,rt);const kt=Ge.set(v.$mK.ExtHostDecorations,ut.get(B.$wdc)),St=Ge.set(v.$mK.ExtHostDocumentsAndEditors,ut.get(c.$xM)),mt=Ge.set(v.$mK.ExtHostCommands,ut.get(h.$IM)),dt=Ge.set(v.$mK.ExtHostTerminalService,ut.get(U.$Tcc)),gt=Ge.set(v.$mK.ExtHostDebugService,ut.get(re.$Edc)),mi=Ge.set(v.$mK.ExtHostSearch,ut.get(Y.$Odc)),Ct=Ge.set(v.$mK.ExtHostTask,ut.get(X.$zdc)),Di=Ge.set(v.$mK.ExtHostOutputService,ut.get(g.$cdc)),ui=Ge.set(v.$mK.ExtHostLocalization,ut.get(nt.$2cc)),$i=Ge.set(v.$mK.ExtHostUrls,new te.$ldc(Ge)),It=Ge.set(v.$mK.ExtHostDocuments,new i.$jcc(Ge,St)),fn=Ge.set(v.$mK.ExtHostDocumentContentProviders,new l.$Dcc(Ge,St,Se)),ri=Ge.set(v.$mK.ExtHostDocumentSaveParticipant,new t.$Ecc(Se,It,Ge.getProxy(v.$lK.MainThreadBulkEdits))),yt=Ge.set(v.$mK.ExtHostNotebook,new fe.$Udc(Ge,mt,St,It,Vt)),bi=Ge.set(v.$mK.ExtHostNotebookDocuments,new ue.$aec(yt)),wi=Ge.set(v.$mK.ExtHostNotebookEditors,new he.$_dc(Se,yt)),si=Ge.set(v.$mK.ExtHostNotebookKernels,new Ae.$9dc(Ge,ft,yt,mt,Se)),Ci=Ge.set(v.$mK.ExtHostNotebookRenderers,new qe.$$dc(Ge,yt)),Ii=Ge.set(v.$mK.ExtHostNotebookDocumentSaveParticipant,new vt.$gec(Se,yt,Ge.getProxy(v.$lK.MainThreadBulkEdits))),Lt=Ge.set(v.$mK.ExtHostEditors,new j.$jdc(Ge,St)),vi=Ge.set(v.$mK.ExtHostTreeViews,new O.$kdc(Ge.getProxy(v.$lK.MainThreadTreeViews),mt,Se)),Pi=Ge.set(v.$mK.ExtHostEditorInsets,new ce.$tdc(Ge.getProxy(v.$lK.MainThreadEditorInsets),Lt,ft.remote)),oi=Ge.set(v.$mK.ExtHostDiagnostics,new o.$ncc(Ge,Se,At,St)),li=Ge.set(v.$mK.ExtHostLanguages,new S.$_cc(Ge,It,mt.converter,Pt)),lt=Ge.set(v.$mK.ExtHostLanguageFeatures,new I.$rcc(Ge,Pt,It,mt,oi,Se,Fe,pt)),Ai=Ge.set(v.$mK.ExtHostFileSystem,new r.$0cc(Ge,lt)),Zt=Ge.set(v.$mK.ExtHostFileSystemEventService,new u.$$cc(Ge,Se,St)),ii=Ge.set(v.$mK.ExtHostQuickOpen,(0,D.$edc)(Ge,at,mt)),Ri=Ge.set(v.$mK.ExtHostSCM,new N.$gdc(Ge,mt,It,Se)),Li=Ge.set(v.$mK.ExtHostQuickDiff,new Et.$dec(Ge,Pt)),Mi=Ge.set(v.$mK.ExtHostShare,new Gt.$iec(Ge,Pt)),Xi=Ge.set(v.$mK.ExtHostComments,(0,s.$ucc)(Ge,mt,It)),Fi=Ge.set(v.$mK.ExtHostProgress,new w.$ddc(Ge.getProxy(v.$lK.MainThreadProgress))),Yi=Ge.set(v.$mK.ExtHosLabelService,new ye.$udc(Ge)),Ti=Ge.set(v.$mK.ExtHostTheming,new ee.$Vdc(Ge)),ai=Ge.set(v.$mK.ExtHostAuthentication,new Pe.$Wdc(Ge)),gn=Ge.set(v.$mK.ExtHostTimeline,new z.$Ydc(Ge,mt)),Ni=Ge.set(v.$mK.ExtHostWebviews,new G.$odc(Ge,ft.remote,at,Se,Fe)),hi=Ge.set(v.$mK.ExtHostWebviewPanels,new ge.$1dc(Ge,Ni,at)),Oi=Ge.set(v.$mK.ExtHostCustomEditors,new Z.$2dc(Ge,It,Me,Ni,hi)),mn=Ge.set(v.$mK.ExtHostWebviewViews,new oe.$Zdc(Ge,Ni)),di=Ge.set(v.$mK.ExtHostTesting,new We.$4dc(Ge,mt,St)),Zi=Ge.set(v.$mK.ExtHostUriOpeners,new _e.$8dc(Ge)),ji=Ge.set(v.$mK.ExtHostProfileContentHandlers,new bt.$cec(Ge));Ge.set(v.$mK.ExtHostInteractive,new Ie.$bec(Ge,yt,St,mt,Se));const xi=Ge.set(v.$mK.ExtHostInlineChat,new Ht.$fec(Ge,mt,It,Se)),fi=Ge.set(v.$mK.ExtHostChatProvider,new zt.$jec(Ge,Se)),_i=Ge.set(v.$mK.ExtHostChatAgents,new Wt.$oec(Ge,fi,Se)),$n=Ge.set(v.$mK.ExtHostChatAgents2,new qt.$pec(Ge,fi,Se)),Ui=Ge.set(v.$mK.ExtHostChatVariables,new Ft.$lec(Ge)),gi=Ge.set(v.$mK.ExtHostChat,new Kt.$eec(Ge,Se)),xt=Ge.set(v.$mK.ExtHostAiRelatedInformation,new Bt.$mec(Ge)),pi=Ge.set(v.$mK.ExtHostAiEmbeddingVector,new Jt.$nec(Ge)),bn=Ge.set(v.$mK.ExtHostIssueReporter,new Ut.$hec(Ge)),Xt=Ge.set(v.$mK.ExtHostStatusBar,new M.$idc(Ge,mt.converter)),yi=Ge.set(v.$mK.ExtHostSpeech,new Dt.$kec(Ge)),en=Object.values(v.$mK);Ge.assertRegistered(en);const tn=new Ee.$3dc(Ge,St),nn=new p.$tcc(Ge),Ei=new $.$adc(Ge,Se),rn=new f.$Ccc(Ge);return k.$scc.register(mt),function(ze,_t,sn){const $t=function(){let we=!ze.isUnderDevelopment;function ke(){we||(Se.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const wt=st;typeof wt.scheme>"u"&&ke(),typeof wt.exclusive=="boolean"&&(0,Ue.$hF)(ze,"documentFiltersExclusive")}return st}}(),zi={getSession(we,ke,Oe){return ai.getSession(ze,we,ke,Oe)},getSessions(we,ke){return(0,Ue.$hF)(ze,"authGetSessions"),ai.getSessions(ze,we,ke)},async hasSession(we,ke){return(0,Ue.$hF)(ze,"authSession"),!!await ai.getSession(ze,we,ke,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(we,ke,Oe,st){return ai.registerAuthenticationProvider(we,ke,Oe,st)}},on={registerCommand(we,ke,Oe){return mt.registerCommand(!0,we,ke,Oe,void 0,ze)},registerTextEditorCommand(we,ke,Oe){return mt.registerCommand(!0,we,(...st)=>{const wt=Lt.getActiveTextEditor();if(!wt){Se.warn("Cannot execute "+we+" because there is no active text editor.");return}return wt.edit(Mt=>{ke.apply(Oe,[wt,Mt,...st])}).then(Mt=>{Mt||Se.warn("Edits from command "+we+" were not applied.")},Mt=>{Se.warn("An error occurred while running command "+we,Mt)})},void 0,void 0,ze)},registerDiffInformationCommand:(we,ke,Oe)=>((0,Ue.$hF)(ze,"diffCommand"),mt.registerCommand(!0,we,async(...st)=>{const wt=St.activeEditor(!0);if(!wt){Se.warn("Cannot execute "+we+" because there is no active text editor.");return}const Mt=await Lt.getDiffInformation(wt.id);ke.apply(Oe,[Mt,...st])},void 0,void 0,ze)),executeCommand(we,...ke){return mt.executeCommand(we,...ke)},getCommands(we=!1){return mt.getCommands(we)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return dt.onDidChangeShell},get isTelemetryEnabled(){return pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$hF)(ze,"telemetry"),pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$hF)(ze,"telemetry"),pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.$FM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,ke){return tt.$EM.validateSender(we),pt.instantiateLogger(ze,we,ke)},openExternal(we,ke){return Ve.openUri(we,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===ft.environment.appUriScheme)return $i.createAppUri(we);try{return await Ve.asExternalUri(we,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Ye.$kU)(we,Le.Schemas.http)||(0,Ye.$kU)(we,Le.Schemas.https))return we;throw ke}},get remoteName(){return(0,H.$Vk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$hF)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,Ue.$hF)(ze,"handleIssueUri"),bn.registerIssueUriRequestHandler(ze,we)},get appQuality(){return(0,Ue.$hF)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$hF)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(we,ke,Oe){return di.createTestController(ze,we,ke,Oe)},createTestObserver(){return(0,Ue.$hF)(ze,"testObserver"),di.createTestObserver()},runTests(we){return(0,Ue.$hF)(ze,"testObserver"),di.runTests(we)},get onDidChangeTestResults(){return(0,Ue.$hF)(ze,"testObserver"),di.onResultsChanged},get testResults(){return(0,Ue.$hF)(ze,"testObserver"),di.results}},ki=ft.remote.isRemote?K.ExtensionKind.Workspace:K.ExtensionKind.UI,wn={getExtension(we,ke){(0,Ue.$gF)(ze,"extensionsAny")||(ke=!1);const Oe=_t.mine.getExtensionDescription(we);if(Oe)return new n.$8cc(Rt,ze.identifier,Oe,ki,!1);if(ke){const st=_t.all.getExtensionDescription(we);if(st)return new n.$8cc(Rt,ze.identifier,st,ki,!0)}},get all(){const we=[];for(const ke of _t.mine.getAllExtensionDescriptions())we.push(new n.$8cc(Rt,ze.identifier,ke,ki,!1));return we},get allAcrossExtensionHosts(){(0,Ue.$hF)(ze,"extensionsAny");const we=new ie.$7l(_t.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of _t.all.getAllExtensionDescriptions()){const st=!we.has(Oe.identifier);ke.push(new n.$8cc(Rt,ze.identifier,Oe,ki,st))}return ke},get onDidChange(){return(0,Ue.$gF)(ze,"extensionsAny")?d.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(we){return oi.createDiagnosticCollection(ze.identifier,we)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:we=>oi.getDiagnostics(we),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(we,ke){return li.changeLanguage(we.uri,ke)},match(we,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,L.$tE)(q.LanguageSelector.from(we),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(we,ke,Oe){return lt.registerCodeActionProvider(ze,$t(we),ke,Oe)},registerDocumentPasteEditProvider(we,ke,Oe){return(0,Ue.$hF)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,$t(we),ke,Oe)},registerCodeLensProvider(we,ke){return lt.registerCodeLensProvider(ze,$t(we),ke)},registerDefinitionProvider(we,ke){return lt.registerDefinitionProvider(ze,$t(we),ke)},registerDeclarationProvider(we,ke){return lt.registerDeclarationProvider(ze,$t(we),ke)},registerImplementationProvider(we,ke){return lt.registerImplementationProvider(ze,$t(we),ke)},registerTypeDefinitionProvider(we,ke){return lt.registerTypeDefinitionProvider(ze,$t(we),ke)},registerHoverProvider(we,ke){return lt.registerHoverProvider(ze,$t(we),ke,ze.identifier)},registerEvaluatableExpressionProvider(we,ke){return lt.registerEvaluatableExpressionProvider(ze,$t(we),ke,ze.identifier)},registerInlineValuesProvider(we,ke){return lt.registerInlineValuesProvider(ze,$t(we),ke,ze.identifier)},registerDocumentHighlightProvider(we,ke){return lt.registerDocumentHighlightProvider(ze,$t(we),ke)},registerLinkedEditingRangeProvider(we,ke){return lt.registerLinkedEditingRangeProvider(ze,$t(we),ke)},registerReferenceProvider(we,ke){return lt.registerReferenceProvider(ze,$t(we),ke)},registerRenameProvider(we,ke){return lt.registerRenameProvider(ze,$t(we),ke)},registerDocumentSymbolProvider(we,ke,Oe){return lt.registerDocumentSymbolProvider(ze,$t(we),ke,Oe)},registerWorkspaceSymbolProvider(we){return lt.registerWorkspaceSymbolProvider(ze,we)},registerDocumentFormattingEditProvider(we,ke){return lt.registerDocumentFormattingEditProvider(ze,$t(we),ke)},registerDocumentRangeFormattingEditProvider(we,ke){return lt.registerDocumentRangeFormattingEditProvider(ze,$t(we),ke)},registerOnTypeFormattingEditProvider(we,ke,Oe,...st){return lt.registerOnTypeFormattingEditProvider(ze,$t(we),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(we,ke,Oe){return lt.registerDocumentSemanticTokensProvider(ze,$t(we),ke,Oe)},registerDocumentRangeSemanticTokensProvider(we,ke,Oe){return lt.registerDocumentRangeSemanticTokensProvider(ze,$t(we),ke,Oe)},registerSignatureHelpProvider(we,ke,Oe,...st){return typeof Oe=="object"?lt.registerSignatureHelpProvider(ze,$t(we),ke,Oe):lt.registerSignatureHelpProvider(ze,$t(we),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(we,ke,...Oe){return lt.registerCompletionItemProvider(ze,$t(we),ke,Oe)},registerInlineCompletionItemProvider(we,ke,Oe){return ke.handleDidShowCompletionItem&&(0,Ue.$hF)(ze,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$hF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Ue.$hF)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,$t(we),ke,Oe)},registerDocumentLinkProvider(we,ke){return lt.registerDocumentLinkProvider(ze,$t(we),ke)},registerColorProvider(we,ke){return lt.registerColorProvider(ze,$t(we),ke)},registerFoldingRangeProvider(we,ke){return lt.registerFoldingRangeProvider(ze,$t(we),ke)},registerSelectionRangeProvider(we,ke){return lt.registerSelectionRangeProvider(ze,we,ke)},registerCallHierarchyProvider(we,ke){return lt.registerCallHierarchyProvider(ze,we,ke)},registerTypeHierarchyProvider(we,ke){return lt.registerTypeHierarchyProvider(ze,we,ke)},setLanguageConfiguration:(we,ke)=>lt.setLanguageConfiguration(ze,we,ke),getTokenInformationAtPosition(we,ke){return(0,Ue.$hF)(ze,"tokenInformation"),li.tokenAtPosition(we,ke)},registerInlayHintsProvider(we,ke){return lt.registerInlayHintsProvider(ze,we,ke)},createLanguageStatusItem(we,ke){return li.createLanguageStatusItem(ze,we,ke)},registerDocumentDropEditProvider(we,ke,Oe){return lt.registerDocumentOnDropEditProvider(ze,we,ke,(0,Ue.$gF)(ze,"dropMetadata")?Oe:void 0)}},un={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(we,ke,Oe){const st=await(A.URI.isUri(we)?Promise.resolve(Si.openTextDocument(we)):Promise.resolve(we));return Lt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(we){return Lt.createTextEditorDecorationType(ze,we)},onDidChangeActiveTextEditor(we,ke,Oe){return Lt.onDidChangeActiveTextEditor(we,ke,Oe)},onDidChangeVisibleTextEditors(we,ke,Oe){return Lt.onDidChangeVisibleTextEditors(we,ke,Oe)},onDidChangeTextEditorSelection(we,ke,Oe){return Lt.onDidChangeTextEditorSelection(we,ke,Oe)},onDidChangeTextEditorOptions(we,ke,Oe){return Lt.onDidChangeTextEditorOptions(we,ke,Oe)},onDidChangeTextEditorVisibleRanges(we,ke,Oe){return Lt.onDidChangeTextEditorVisibleRanges(we,ke,Oe)},onDidChangeTextEditorViewColumn(we,ke,Oe){return Lt.onDidChangeTextEditorViewColumn(we,ke,Oe)},onDidCloseTerminal(we,ke,Oe){return dt.onDidCloseTerminal(we,ke,Oe)},onDidOpenTerminal(we,ke,Oe){return dt.onDidOpenTerminal(we,ke,Oe)},onDidChangeActiveTerminal(we,ke,Oe){return dt.onDidChangeActiveTerminal(we,ke,Oe)},onDidChangeTerminalDimensions(we,ke,Oe){return(0,Ue.$hF)(ze,"terminalDimensions"),dt.onDidChangeTerminalDimensions(we,ke,Oe)},onDidChangeTerminalState(we,ke,Oe){return dt.onDidChangeTerminalState(we,ke,Oe)},onDidWriteTerminalData(we,ke,Oe){return(0,Ue.$hF)(ze,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(we,ke,Oe)},onDidExecuteTerminalCommand(we,ke,Oe){return(0,Ue.$hF)(ze,"terminalExecuteCommandEvent"),dt.onDidExecuteTerminalCommand(we,ke,Oe)},get state(){return Ve.getState(ze)},onDidChangeWindowState(we,ke,Oe){return Ve.onDidChangeWindowState(we,ke,Oe)},showInformationMessage(we,...ke){return Ei.showMessage(ze,R.default.Info,we,ke[0],ke.slice(1))},showWarningMessage(we,...ke){return Ei.showMessage(ze,R.default.Warning,we,ke[0],ke.slice(1))},showErrorMessage(we,...ke){return Ei.showMessage(ze,R.default.Error,we,ke[0],ke.slice(1))},showQuickPick(we,ke,Oe){return ii.showQuickPick(ze,we,ke,Oe)},showWorkspaceFolderPick(we){return ii.showWorkspaceFolderPick(we)},showInputBox(we,ke){return ii.showInput(we,ke)},showOpenDialog(we){return rn.showOpenDialog(ze,we)},showSaveDialog(we){return rn.showSaveDialog(we)},createStatusBarItem(we,ke,Oe){let st,wt,Mt;return typeof we=="string"?(st=we,wt=ke,Mt=Oe):(wt=we,Mt=ke),Xt.createStatusBarEntry(ze,st,wt,Mt)},setStatusBarMessage(we,ke){return Xt.setStatusBarMessage(we,ke)},withScmProgress(we){return Fe.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Fi.withProgress(ze,{location:K.ProgressLocation.SourceControl},(ke,Oe)=>we({report(st){}}))},withProgress(we,ke){return Fi.withProgress(ze,we,ke)},createOutputChannel(we,ke){return Di.createOutputChannel(we,ke,ze)},createWebviewPanel(we,ke,Oe,st){return hi.createWebviewPanel(ze,we,ke,Oe,st)},createWebviewTextEditorInset(we,ke,Oe,st){return(0,Ue.$hF)(ze,"editorInsets"),Pi.createWebviewEditorInset(we,ke,Oe,st,ze)},createTerminal(we,ke,Oe){return typeof we=="object"?"pty"in we?dt.createExtensionTerminal(we):dt.createTerminalFromOptions(we):dt.createTerminal(we,ke,Oe)},registerTerminalLinkProvider(we){return dt.registerLinkProvider(we)},registerTerminalProfileProvider(we,ke){return dt.registerProfileProvider(ze,we,ke)},registerTerminalQuickFixProvider(we,ke){return(0,Ue.$hF)(ze,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(we,ze.identifier.value,ke)},registerTreeDataProvider(we,ke){return vi.registerTreeDataProvider(we,ke,ze)},createTreeView(we,ke){return vi.createTreeView(we,ke,ze)},registerWebviewPanelSerializer:(we,ke)=>hi.registerWebviewPanelSerializer(ze,we,ke),registerCustomEditorProvider:(we,ke,Oe={})=>Oi.registerCustomEditorProvider(ze,we,ke,Oe),registerFileDecorationProvider(we){return kt.registerFileDecorationProvider(we,ze)},registerUriHandler(we){return $i.registerUriHandler(ze,we)},createQuickPick(){return ii.createQuickPick(ze)},createInputBox(){return ii.createInputBox(ze)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(we,ke,Oe){return Ti.onDidChangeActiveColorTheme(we,ke,Oe)},registerWebviewViewProvider(we,ke,Oe){return mn.registerWebviewViewProvider(ze,we,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,ke,Oe){return yt.onDidChangeActiveNotebookEditor(we,ke,Oe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,ke,Oe){return wi.onDidChangeNotebookEditorSelection(we,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(we,ke,Oe){return wi.onDidChangeNotebookEditorVisibleRanges(we,ke,Oe)},showNotebookDocument(we,ke){return yt.showNotebookDocument(we,ke)},registerExternalUriOpener(we,ke,Oe){return(0,Ue.$hF)(ze,"externalUriOpener"),Zi.registerExternalUriOpener(ze.identifier,we,ke,Oe)},registerProfileContentHandler(we,ke){return(0,Ue.$hF)(ze,"profileContentHandlers"),ji.registrProfileContentHandler(ze,we,ke)},registerQuickDiffProvider(we,ke,Oe,st){return(0,Ue.$hF)(ze,"quickDiffProvider"),Li.registerQuickDiffProvider($t(we),ke,Oe,st)},get tabGroups(){return Je.tabGroups},registerShareProvider(we,ke){return(0,Ue.$hF)(ze,"shareProvider"),Mi.registerShareProvider($t(we),ke)}},Si={get rootPath(){return Fe.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(we){throw new T.$9("rootPath")},getWorkspaceFolder(we){return at.getWorkspaceFolder(we)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(we){throw new T.$9("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(we){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(we,ke,...Oe)=>at.updateWorkspaceFolders(ze,we,ke||0,...Oe),onDidChangeWorkspaceFolders:function(we,ke,Oe){return at.onDidChangeWorkspace(we,ke,Oe)},asRelativePath:(we,ke)=>at.getRelativePath(we,ke),findFiles:(we,ke,Oe,st)=>at.findFiles(we,ke,Oe,ze.identifier,st),findTextInFiles:(we,ke,Oe,st)=>{(0,Ue.$hF)(ze,"findTextInFiles");let wt,Mt;return typeof ke=="object"?(wt=ke,Mt=Oe):(wt={},Mt=ke,st=Oe),at.findTextInFiles(we,wt||{},Mt,ze.identifier,st)},save:we=>((0,Ue.$hF)(ze,"saveEditor"),at.save(we)),saveAs:we=>((0,Ue.$hF)(ze,"saveEditor"),at.saveAs(we)),saveAll:we=>at.saveAll(we),applyEdit(we,ke){return tn.applyWorkspaceEdit(we,ze,ke)},createFileSystemWatcher:(we,ke,Oe,st)=>{let wt;return typeof ke=="boolean"?wt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st}:ke&&((0,Ue.$hF)(ze,"createFileSystemWatcher"),wt=ke),Zt.createFileSystemWatcher(at,ze,we,wt)},get textDocuments(){return It.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$9("textDocuments")},openTextDocument(we){let ke;const Oe=we;if(typeof we=="string")ke=Promise.resolve(A.URI.file(we));else if(A.URI.isUri(we))ke=Promise.resolve(we);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(we,ke,Oe)=>It.onDidAddDocument(we,ke,Oe),onDidCloseTextDocument:(we,ke,Oe)=>It.onDidRemoveDocument(we,ke,Oe),onDidChangeTextDocument:(we,ke,Oe)=>It.onDidChangeDocument(we,ke,Oe),onDidSaveTextDocument:(we,ke,Oe)=>It.onDidSaveDocument(we,ke,Oe),onWillSaveTextDocument:(we,ke,Oe)=>ri.getOnWillSaveTextDocumentEvent(ze)(we,ke,Oe),get notebookDocuments(){return yt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,ke){let Oe;if(A.URI.isUri(we))Oe=we,await yt.openNotebookDocument(we);else if(typeof we=="string")Oe=A.URI.revive(await yt.createNotebookDocument({viewType:we,content:ke}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(we,ke,Oe){return bi.onDidSaveNotebookDocument(we,ke,Oe)},onDidChangeNotebookDocument(we,ke,Oe){return bi.onDidChangeNotebookDocument(we,ke,Oe)},onWillSaveNotebookDocument(we,ke,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(ze)(we,ke,Oe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(we,ke,Oe,st){return yt.registerNotebookSerializer(ze,we,ke,Oe,(0,Ue.$gF)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,ke,Oe)=>sn.onDidChangeConfiguration(we,ke,Oe),getConfiguration(we,ke){return ke=arguments.length===1?void 0:ke,sn.getConfiguration(we,ke,ze)},registerTextDocumentContentProvider(we,ke){return fn.registerTextDocumentContentProvider(we,ke)},registerTaskProvider:(we,ke)=>(Fe.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(ze,we,ke)),registerFileSystemProvider(we,ke,Oe){return(0,Ke.$Pc)(Ai.registerFileSystemProvider(ze,we,ke,Oe),Vt.addFileSystemProvider(we,ke,Oe))},get fs(){return Vt.value},registerFileSearchProvider:(we,ke)=>((0,Ue.$hF)(ze,"fileSearchProvider"),mi.registerFileSearchProvider(we,ke)),registerTextSearchProvider:(we,ke)=>((0,Ue.$hF)(ze,"textSearchProvider"),mi.registerTextSearchProvider(we,ke)),registerRemoteAuthorityResolver:(we,ke)=>((0,Ue.$hF)(ze,"resolvers"),Rt.registerRemoteAuthorityResolver(we,ke)),registerResourceLabelFormatter:we=>((0,Ue.$hF)(ze,"resolvers"),Yi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,Ue.$hF)(ze,"resolvers"),Rt.getRemoteExecServer(we)),onDidCreateFiles:(we,ke,Oe)=>Zt.onDidCreateFile(we,ke,Oe),onDidDeleteFiles:(we,ke,Oe)=>Zt.onDidDeleteFile(we,ke,Oe),onDidRenameFiles:(we,ke,Oe)=>Zt.onDidRenameFile(we,ke,Oe),onWillCreateFiles:(we,ke,Oe)=>Zt.getOnWillCreateFileEvent(ze)(we,ke,Oe),onWillDeleteFiles:(we,ke,Oe)=>Zt.getOnWillDeleteFileEvent(ze)(we,ke,Oe),onWillRenameFiles:(we,ke,Oe)=>Zt.getOnWillRenameFileEvent(ze)(we,ke,Oe),openTunnel:we=>((0,Ue.$hF)(ze,"tunnels"),ne.openTunnel(ze,we).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Ue.$hF)(ze,"tunnels"),ne.getTunnels()},onDidChangeTunnels:(we,ke,Oe)=>((0,Ue.$hF)(ze,"tunnels"),ne.onDidChangeTunnels(we,ke,Oe)),registerPortAttributesProvider:(we,ke)=>((0,Ue.$hF)(ze,"portsAttributes"),ne.registerPortsAttributesProvider(we,ke)),registerTunnelProvider:(we,ke)=>((0,Ue.$hF)(ze,"tunnelFactory"),ne.registerTunnelProvider(we,ke)),registerTimelineProvider:(we,ke)=>((0,Ue.$hF)(ze,"timeline"),gn.registerTimelineProvider(we,ke,ze.identifier,mt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:we=>((0,Ue.$hF)(ze,"workspaceTrust"),at.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,ke,Oe)=>at.onDidGrantWorkspaceTrust(we,ke,Oe),registerEditSessionIdentityProvider:(we,ke)=>((0,Ue.$hF)(ze,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(we,ke)),onWillCreateEditSessionIdentity:(we,ke,Oe)=>((0,Ue.$hF)(ze,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(ze)(we,ke,Oe)),registerCanonicalUriProvider:(we,ke)=>((0,Ue.$hF)(ze,"canonicalUriProvider"),at.registerCanonicalUriProvider(we,ke)),getCanonicalUri:(we,ke,Oe)=>((0,Ue.$hF)(ze,"canonicalUriProvider"),at.provideCanonicalUri(we,ke,Oe))},Wi={get inputBox(){return Fe.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(ze)},createSourceControl(we,ke,Oe){return Ri.createSourceControl(ze,we,ke,Oe)}},qi={createCommentController(we,ke){return Xi.createCommentController(ze,we,ke)}},ci={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(we,ke,Oe){return gt.onDidStartDebugSession(we,ke,Oe)},onDidTerminateDebugSession(we,ke,Oe){return gt.onDidTerminateDebugSession(we,ke,Oe)},onDidChangeActiveDebugSession(we,ke,Oe){return gt.onDidChangeActiveDebugSession(we,ke,Oe)},onDidReceiveDebugSessionCustomEvent(we,ke,Oe){return gt.onDidReceiveDebugSessionCustomEvent(we,ke,Oe)},onDidChangeBreakpoints(we,ke,Oe){return gt.onDidChangeBreakpoints(we,ke,Oe)},onDidChangeStackFrameFocus(we,ke,Oe){return(0,Ue.$hF)(ze,"debugFocus"),gt.onDidChangeStackFrameFocus(we,ke,Oe)},registerDebugConfigurationProvider(we,ke,Oe){return gt.registerDebugConfigurationProvider(we,ke,Oe||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,ke){return gt.registerDebugAdapterDescriptorFactory(ze,we,ke)},registerDebugAdapterTrackerFactory(we,ke){return gt.registerDebugAdapterTrackerFactory(we,ke)},startDebugging(we,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?gt.startDebugging(we,ke,{parentSession:Oe}):gt.startDebugging(we,ke,Oe||{})},stopDebugging(we){return gt.stopDebugging(we)},addBreakpoints(we){return gt.addBreakpoints(we)},removeBreakpoints(we){return gt.removeBreakpoints(we)},asDebugSourceUri(we,ke){return gt.asDebugSourceUri(we,ke)}},Vi={registerTaskProvider:(we,ke)=>Ct.registerTaskProvider(ze,we,ke),fetchTasks:we=>Ct.fetchTasks(we),executeTask:we=>Ct.executeTask(ze,we),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(we,ke,Oe)=>Ct.onDidStartTask(we,ke,Oe),onDidEndTask:(we,ke,Oe)=>Ct.onDidEndTask(we,ke,Oe),onDidStartTaskProcess:(we,ke,Oe)=>Ct.onDidStartTaskProcess(we,ke,Oe),onDidEndTaskProcess:(we,ke,Oe)=>Ct.onDidEndTaskProcess(we,ke,Oe)},Ki={createNotebookController(we,ke,Oe,st,wt){return si.createNotebookController(ze,we,ke,Oe,st,(0,Ue.$gF)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(we,ke)=>yt.registerNotebookCellStatusBarItemProvider(ze,we,ke),createRendererMessaging(we){return Ci.createRendererMessaging(ze,we)},createNotebookControllerDetectionTask(we){return(0,Ue.$hF)(ze,"notebookKernelSource"),si.createNotebookControllerDetectionTask(ze,we)},registerKernelSourceActionProvider(we,ke){return(0,Ue.$hF)(ze,"notebookKernelSource"),si.registerKernelSourceActionProvider(ze,we,ke)},onDidChangeNotebookCellExecutionState(we,ke,Oe){return(0,Ue.$hF)(ze,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(we,ke,Oe)}},Hi={t(...we){if(typeof we[0]=="string"){const ke=we.shift(),Oe=!we||typeof we[0]!="object"?we:we[0];return ui.getMessage(ze.identifier.value,{message:ke,args:Oe})}return ui.getMessage(ze.identifier.value,we[0])},get bundle(){return ui.getBundle(ze.identifier.value)},get uri(){return ui.getBundleUri(ze.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(we,ke){return(0,Ue.$hF)(ze,"interactive"),xi.registerProvider(ze,we,ke={label:ke?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(we,ke){return(0,Ue.$hF)(ze,"interactive"),gi.registerChatProvider(ze,we,ke)},sendInteractiveRequestToProvider(we,ke){return(0,Ue.$hF)(ze,"interactive"),gi.sendInteractiveRequestToProvider(we,ke)},get onDidPerformUserAction(){return(0,Ue.$hF)(ze,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(we,ke){return(0,Ue.$hF)(ze,"interactive"),gi.transferChatSession(we,ke)}},ln={getRelatedInformation(we,ke){return(0,Ue.$hF)(ze,"aiRelatedInformation"),xt.getRelatedInformation(ze,we,ke)},registerRelatedInformationProvider(we,ke){return(0,Ue.$hF)(ze,"aiRelatedInformation"),xt.registerRelatedInformationProvider(ze,we,ke)},registerEmbeddingVectorProvider(we,ke){return(0,Ue.$hF)(ze,"aiRelatedInformation"),pi.registerEmbeddingVectorProvider(ze,we,ke)}},hn={registerChatResponseProvider(we,ke,Oe){return(0,Ue.$hF)(ze,"chatProvider"),fi.registerProvider(ze.identifier,we,ke,Oe)},requestChatAccess(we){return(0,Ue.$hF)(ze,"chatRequestAccess"),fi.requestChatResponseProvider(ze.identifier,we)},registerVariable(we,ke,Oe){return(0,Ue.$hF)(ze,"chatVariables"),Ui.registerVariableResolver(ze,we,ke,Oe)},registerMappedEditsProvider(we,ke){return(0,Ue.$hF)(ze,"mappedEditsProvider"),lt.registerMappedEditsProvider(ze,we,ke)},createChatAgent(we,ke){return(0,Ue.$hF)(ze,"chatAgents2"),$n.createChatAgent(ze,we,ke)},registerAgent(we,ke,Oe){return(0,Ue.$hF)(ze,"chatAgents"),_i.registerAgent(ze.identifier,we,ke,Oe)}},dn={registerSpeechProvider(we,ke){return(0,Ue.$hF)(ze,"speech"),yi.registerProvider(ze.identifier,we,ke)}};return{version:ft.version,ai:ln,authentication:zi,commands:on,comments:qi,chat:hn,debug:ci,env:Bi,extensions:wn,interactive:Gi,l10n:Hi,languages:cn,notebooks:Ki,scm:Wi,speech:dn,tasks:Vi,tests:an,window:un,workspace:Si,Breakpoint:K.$lL,TerminalOutputAnchor:K.TerminalOutputAnchor,ChatAgentResultFeedbackKind:K.ChatAgentResultFeedbackKind,ChatMessage:K.$bM,ChatMessageRole:K.ChatMessageRole,ChatVariableLevel:K.ChatVariableLevel,CallHierarchyIncomingCall:K.$KK,CallHierarchyItem:K.$JK,CallHierarchyOutgoingCall:K.$LK,CancellationError:T.$5,CancellationTokenSource:C.$Xd,CandidatePortSource:v.CandidatePortSource,CodeAction:K.$GK,CodeActionKind:K.$HK,CodeActionTriggerKind:K.CodeActionTriggerKind,CodeLens:K.$MK,Color:K.$ZK,ColorInformation:K.$1K,ColorPresentation:K.$2K,ColorThemeKind:K.ColorThemeKind,CommentMode:K.CommentMode,CommentState:K.CommentState,CommentThreadCollapsibleState:K.CommentThreadCollapsibleState,CommentThreadState:K.CommentThreadState,CompletionItem:K.$TK,CompletionItemKind:K.CompletionItemKind,CompletionItemTag:K.CompletionItemTag,CompletionList:K.$UK,CompletionTriggerKind:K.CompletionTriggerKind,ConfigurationTarget:K.ConfigurationTarget,CustomExecution:K.$0K,DebugAdapterExecutable:K.$pL,DebugAdapterInlineImplementation:K.$sL,DebugAdapterNamedPipeServer:K.$rL,DebugAdapterServer:K.$qL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:K.DebugConsoleMode,DecorationRangeBehavior:K.DecorationRangeBehavior,Diagnostic:K.$BK,DiagnosticRelatedInformation:K.$AK,DiagnosticSeverity:K.DiagnosticSeverity,DiagnosticTag:K.DiagnosticTag,Disposable:K.$nK,DocumentHighlight:K.$DK,DocumentHighlightKind:K.DocumentHighlightKind,DocumentLink:K.$YK,DocumentSymbol:K.$FK,EndOfLine:K.EndOfLine,EnvironmentVariableMutatorType:K.EnvironmentVariableMutatorType,EvaluatableExpression:K.$vL,InlineValueText:K.$wL,InlineValueVariableLookup:K.$xL,InlineValueEvaluatableExpression:K.$yL,InlineCompletionTriggerKind:K.InlineCompletionTriggerKind,EventEmitter:d.$Nd,ExtensionKind:K.ExtensionKind,ExtensionMode:K.ExtensionMode,ExternalUriOpenerPriority:K.ExternalUriOpenerPriority,FileChangeType:K.FileChangeType,FileDecoration:K.$IL,FileDecoration2:K.$IL,FileSystemError:K.$AL,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:K.$BL,FoldingRangeKind:K.FoldingRangeKind,FunctionBreakpoint:K.$nL,InlineCompletionItem:K.$VK,InlineCompletionList:K.$WK,Hover:K.$CK,IndentAction:b.IndentAction,Location:K.$zK,MarkdownString:K.$NK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:K.$OK,PortAutoForwardAction:K.PortAutoForwardAction,Position:K.$oK,ProcessExecution:K.$8K,ProgressLocation:K.ProgressLocation,QuickInputButtons:K.$HL,Range:K.$pK,RelativePattern:K.$jL,Selection:K.$qK,SelectionRange:K.$IK,SemanticTokens:K.$EL,SemanticTokensBuilder:K.$DL,SemanticTokensEdit:K.$FL,SemanticTokensEdits:K.$GL,SemanticTokensLegend:K.$CL,ShellExecution:K.$9K,ShellQuoting:K.ShellQuoting,SignatureHelp:K.$QK,SignatureHelpTriggerKind:K.SignatureHelpTriggerKind,SignatureInformation:K.$PK,SnippetString:K.$yK,SourceBreakpoint:K.$mL,StandardTokenType:K.StandardTokenType,StatusBarAlignment:K.StatusBarAlignment,SymbolInformation:K.$EK,SymbolKind:K.SymbolKind,SymbolTag:K.SymbolTag,Task:K.$$K,TaskGroup:K.$7K,TaskPanelKind:K.TaskPanelKind,TaskRevealKind:K.TaskRevealKind,TaskScope:K.TaskScope,TerminalLink:K.$3K,TerminalQuickFixExecuteTerminalCommand:K.$5K,TerminalQuickFixOpener:K.$4K,TerminalLocation:K.TerminalLocation,TerminalProfile:K.$6K,TerminalExitReason:K.TerminalExitReason,TextDocumentSaveReason:K.TextDocumentSaveReason,TextEdit:K.$uK,SnippetTextEdit:K.$wK,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:K.TextEditorLineNumbersStyle,TextEditorRevealType:K.TextEditorRevealType,TextEditorSelectionChangeKind:K.TextEditorSelectionChangeKind,SyntaxTokenType:K.SyntaxTokenType,TextDocumentChangeReason:K.TextDocumentChangeReason,ThemeColor:K.$iL,ThemeIcon:K.$hL,TreeItem:K.$_K,TreeItemCheckboxState:K.TreeItemCheckboxState,TreeItemCollapsibleState:K.TreeItemCollapsibleState,TypeHierarchyItem:K.$4L,UIKind:y.UIKind,Uri:A.URI,ViewColumn:K.ViewColumn,WorkspaceEdit:K.$xK,DocumentDropEdit:K.$fL,DocumentPasteEdit:K.$gL,InlayHint:K.$SK,InlayHintLabelPart:K.$RK,InlayHintKind:K.InlayHintKind,RemoteAuthorityResolverError:K.$tK,ResolvedAuthority:K.$rK,ManagedResolvedAuthority:K.$sK,SourceControlInputBoxValidationType:K.SourceControlInputBoxValidationType,ExtensionRuntime:K.ExtensionRuntime,TimelineItem:K.$SL,NotebookRange:K.$KL,NotebookCellKind:K.NotebookCellKind,NotebookCellExecutionState:K.NotebookCellExecutionState,NotebookCellData:K.$LL,NotebookData:K.$ML,NotebookRendererScript:K.$QL,NotebookCellStatusBarAlignment:K.NotebookCellStatusBarAlignment,NotebookEditorRevealType:K.NotebookEditorRevealType,NotebookCellOutput:K.$OL,NotebookCellOutputItem:K.$NL,NotebookCellStatusBarItem:K.$PL,NotebookControllerAffinity:K.NotebookControllerAffinity,NotebookControllerAffinity2:K.NotebookControllerAffinity2,NotebookEdit:K.$vK,NotebookKernelSourceAction:K.$RL,PortAttributes:K.$UL,LinkedEditingRanges:K.$TL,TestResultState:K.TestResultState,TestRunRequest:K.$VL,TestMessage:K.$WL,TestMessage2:K.$WL,TestTag:K.$XL,TestRunProfileKind:K.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:K.$eL,DataTransferItem:K.$aL,CoveredCount:K.$YL,FileCoverage:K.$ZL,StatementCoverage:K.$1L,BranchCoverage:K.$2L,FunctionCoverage:K.$3L,WorkspaceTrustState:K.WorkspaceTrustState,LanguageStatusSeverity:K.LanguageStatusSeverity,QuickPickItemKind:K.QuickPickItemKind,InputBoxValidationSeverity:K.InputBoxValidationSeverity,TabInputText:K.$5L,TabInputTextDiff:K.$6L,TabInputTextMerge:K.$7L,TabInputCustom:K.$8L,TabInputNotebook:K.$0L,TabInputNotebookDiff:K.$$L,TabInputWebview:K.$9L,TabInputTerminal:K.$_L,TabInputInteractiveWindow:K.$aM,TelemetryTrustedValue:me.$jo,LogLevel:_.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch,InteractiveSessionVoteDirection:K.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:K.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:K.InteractiveEditorResponseFeedbackKind,StackFrameFocus:K.$tL,ThreadFocus:K.$uL,RelatedInformationType:K.RelatedInformationType,SpeechToTextStatus:K.SpeechToTextStatus}}}e.$qec=Ot}),define(De[359],Ce([1,0,103,152,39,149,40,34,70,45,93,94,95,115,73,89,151,72,55,114,88,71,150,14,56,112,113]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t,i,c,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$wr)(n.$2cc,n.$1cc,1),(0,C.$wr)(i.$$i,t.$rec,1),(0,C.$wr)(p.$occ,p.$pcc,1),(0,C.$wr)(m.$IM,m.$HM,0),(0,C.$wr)(A.$Bcc,A.$zcc,0),(0,C.$wr)(s.$Qcc,s.$Pcc,0),(0,C.$wr)(P.$Edc,P.$Idc,0),(0,C.$wr)(R.$wdc,R.$vdc,0),(0,C.$wr)(E.$xM,E.$wM,0),(0,C.$wr)(r.$3cc,r.$4cc,0),(0,C.$wr)(a.$lcc,a.$kcc,0),(0,C.$wr)(T.$cdc,T.$bdc,1),(0,C.$wr)(v.$Odc,v.$Pdc,0),(0,C.$wr)(y.$Mcc,y.$Lcc,0),(0,C.$wr)(L.$zdc,L.$ydc,0),(0,C.$wr)(b.$Tcc,b.$Wcc,0),(0,C.$wr)(k.$cwb,k.$dwb,0),(0,C.$wr)(h.$sdc,h.$rdc,0),(0,C.$wr)(d.$ycc,d.$xcc,0),(0,C.$wr)(o.$Ycc,o.$Xcc,0),(0,C.$wr)(f.$GM,f.$DM,0),(0,C.$wr)(l.$Adc,l.$Bdc,0),(0,C.$wr)(c.$Cdc,c.$Ddc,0)}),define(De[116],Ce([1,0,19,14,37,92]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=e.$Iec=e.$Hec=void 0;function A(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$Hec=A;function m(P,v,y,k){const p=(0,C.$2b)(y,E),h=new d.$RI(v,p,k),s=h.preview.matches;return{ranges:(0,C.$2b)(p,b),uri:P,preview:{text:h.preview.text,matches:(0,C.$2b)(s,b)}}}e.$Iec=m;function E(P){return new d.$SI(P.start.line,P.start.character,P.end.line,P.end.character)}function b(P){return new R.$GI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(v,y){this.a=v,this.b=y}appendLine(v){this.b.debug(`${this.a}#search`,v)}};e.$Jec=L,e.$Jec=L=He([Be(1,T.$0i)],L)}),define(De[360],Ce([1,0,49,16,77,33,12,15,116,361]),function($e,e,C,T,d,R,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=e.$Lec=e.$Kec=void 0;const L=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(o,f,l,t){const i=v(o,f,l,t),c=f.folder.fsPath;return{cmd:C.spawn(L,i.args,{cwd:c}),rgDiskPath:L,siblingClauses:i.siblingClauses,rgArgs:i,cwd:c}}e.$Kec=P;function v(o,f,l,t){const i=["--files","--hidden","--case-sensitive","--no-require-git"];k([f],l,!1).forEach(n=>{const r=(0,E.$Hec)(n);if(i.push("-g",r),A.$k){const u=(0,d.$pl)(r);u!==r&&i.push("-g",u)}});const c=y([f],t,void 0,!1);return c.globArgs.forEach(n=>{const r=`!${(0,E.$Hec)(n)}`;if(i.push("-g",r),A.$k){const u=(0,d.$pl)(r);u!==r&&i.push("-g",u)}}),f.disregardIgnoreFiles!==!1?i.push("--no-ignore"):f.disregardParentIgnoreFiles!==!1&&i.push("--no-ignore-parent"),f.ignoreSymlinks||i.push("--follow"),o.exists&&i.push("--quiet"),i.push("--no-config"),f.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:c.siblingClauses}}function y(o,f,l,t=!0){const i=[];let c={};return o.forEach(n=>{const r=Object.assign({},n.excludePattern||{},f||{}),u=p(r,t?n.folder.fsPath:void 0,l);i.push(...u.globArgs),u.siblingClauses&&(c=Object.assign(c,u.siblingClauses))}),{globArgs:i,siblingClauses:c}}function k(o,f,l=!0){const t=[];return o.forEach(i=>{const c=Object.assign({},f||{},i.includePattern||{}),n=p(c,l?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}function p(o,f,l){const t=[],i={};return Object.keys(o).forEach(c=>{if(l&&l.has(c)||!c)return;const n=o[c];c=s(f?h(f,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof n=="boolean"&&n?(c.startsWith("\\\\")&&(c+="**"),t.push(a(c))):n&&n.when&&(i[c]=n)}),{globArgs:t,siblingClauses:i}}function h(o,f){return T.$ic(f)?f:T.$jc(o,f)}e.$Lec=h;function s(o){return o=m.$Ke(o,"\\"),m.$Ke(o,"/")}function a(o){return R.$Tf(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.$Mec=a}),define(De[362],Ce([1,0,49,53,16,363,19,41,36,77,33,12,35,15,17,29,37,360,127]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.$Nec=void 0;const o=new Set;process.on("exit",()=>{o.forEach(c=>c())});class f{constructor(n){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=n,this.b=n.filePattern||"",this.d=n.includePattern&&E.$wj(n.includePattern),this.f=n.maxResults||null,this.g=!!n.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,a.$yq)(this.b).normalizedLowercase),this.u=n.excludePattern&&E.$wj(n.excludePattern),this.t=new Map,n.folderQueries.forEach(r=>{const u=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),I=r.folder.fsPath;n.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==I).forEach(S=>{(0,L.$Xf)(S,I)&&(u[d.$lc(I,S)]=!0)}),this.t.set(I,new t(u,I))})}cancel(){this.l=!0,o.forEach(n=>n())}walk(n,r,u,I,S){if(this.m=v.$Jd.create(!1),this.l)return S(null,this.j);r.forEach($=>{const g=d.$nc($.fsPath);this.u&&this.u($.fsPath,g)||this.J(u,{relativePath:$.fsPath,searchPath:void 0})}),this.r=v.$Jd.create(!1),this.w(n,($,g)=>{this.x(this.y,this,$,u,I,w=>{if(w){const D=(0,m.$Ai)(w);console.error(D),this.q.push(D),g(w,void 0)}else g(null,void 0)})},($,g)=>{this.m.stop();const w=$?A.$Hb($)[0]:null;S(w,this.j)})}w(n,r,u){const I=new Array(n.length),S=new Array(n.length);let $=!1,g=0;if(n.length===0)return u(null,[]);n.forEach((w,D)=>{r(w,(N,M)=>{if(N?($=!0,I[D]=null,S[D]=N):(I[D]=M,S[D]=null),++g===n.length)return u($?S:null,I)})})}x(n,r,...u){try{n.apply(r,u)}catch(I){u[u.length-1](I)}}y(n,r,u,I){const S=n.folder.fsPath,$=P.$k,g=()=>F&&F.kill();o.add(g);let w=q=>{o.delete(g),w=()=>{},I(q)},D="";const N=this.D(),M=(0,s.$Kec)(this.a,n,this.a.includePattern,this.t.get(n.folder.fsPath).expression),F=M.cmd,U=!Object.keys(M.siblingClauses).length,j=M.rgArgs.args.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");let O=`${M.rgDiskPath} ${j}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),u({message:O}),this.s=0,this.z(F,"utf8",u,(q,K,me)=>{if(q){w(q);return}if(this.j){w();return}const G=(D+($?b.$ol(K||""):K)).split(`
`);if(me){const Q=G.length;G[Q-1]=G[Q-1].trim(),G[Q-1]||G.pop()}else D=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=G.length,U){for(const Q of G)if(this.J(r,{base:S,relativePath:Q,searchPath:this.N(n,Q)}),this.j){g();break}(me||this.j)&&w();return}this.G(n,N,S,G,r),me&&(this.H(N,S,r),w())})}spawnFindCmd(n){const r=this.t.get(n.folder.fsPath),u=r.getBasenameTerms(),I=r.getPathTerms(),S=["-L","."];if(u.length||I.length){S.push("-not","(","(");for(const $ of u)S.push("-name",$),S.push("-o");for(const $ of I)S.push("-path",$),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),C.spawn("find",S,{cwd:n.folder.fsPath})}readStdout(n,r,u){let I="";this.z(n,r,()=>{},(S,$,g)=>{if(S){u(S);return}I+=$,g&&u(null,I)})}z(n,r,u,I){let S=(w,D,N)=>{(w||N)&&(S=()=>{},this.r?.stop()),I(w,D,N)},$=!1;n.stdout?(this.A(n.stdout,r,S),n.stdout.once("data",()=>$=!0)):u({message:"stdout is null"});let g;n.stderr?g=this.B(n.stderr):u({message:"stderr is null"}),n.on("error",w=>{S(w)}),n.on("close",w=>{let D;!$&&(D=this.C(g,r))&&i(D)?S(new Error(`command failed with error code ${w}: ${this.C(g,r)}`)):(this.g&&w===0&&(this.j=!0),S(null,"",!0))})}A(n,r,u){const I=new R.StringDecoder(r);return n.on("data",S=>{u(null,I.write(S))}),I}B(n){const r=[];return n.on("data",u=>{r.push(u)}),r}C(n,r){const u=new R.StringDecoder(r);return n.map(I=>u.write(I)).join("")}D(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}G(n,{pathToEntries:r},u,I,S){I.indexOf(this.b)!==-1&&this.J(S,{base:u,relativePath:this.b,searchPath:this.N(n,this.b)});const $=g=>{const w=d.$nc(g),D=d.$mc(g);let N=r[D];N||(N=r[D]=[],$(D)),N.push({base:u,relativePath:g,basename:w,searchPath:this.N(n,g)})};I.forEach($)}H({rootEntries:n,pathToEntries:r},u,I){const S=this,$=this.t.get(u),g=this.b;function w(D){S.o++;const N=(0,h.$8I)(()=>D.map(M=>M.basename));for(let M=0,F=D.length;M<F;M++){const U=D[M],{relativePath:j,basename:O}=U;if($.test(j,O,g!==O?N:void 0))continue;const q=r[j];if(q)w(q);else{if(S.p++,j===g)continue;S.J(I,U)}if(S.j)break}}w(n)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(n,r,u,I,S){const $=n.folder,g=(0,h.$8I)(()=>u);this.w(u,(w,D)=>{if(this.l||this.j)return D(null);const N=r?[r,w].join(d.sep):w;if(this.t.get(n.folder.fsPath).test(N,w,this.a.filePattern!==w?g:void 0))return D(null);const M=[$.fsPath,N].join(d.sep);T.lstat(M,(F,U)=>{if(F||this.l||this.j)return D(null);this.L(M,U,(j,O)=>j||this.l||this.j?D(null):O.isDirectory()?(this.o++,this.M(M,U,(q,K)=>q||this.l||this.j||(K=K||"",this.v[K])?D(null):(this.v[K]=!0,p.Promises.readdir(M).then(me=>{if(this.l||this.j)return D(null);this.I(n,N,me,I,te=>D(te||null))},me=>{D(null)})))):(this.p++,N===this.b||this.h&&k.$Cf(O.size)&&O.size>this.h||this.J(I,{base:$.fsPath,relativePath:N,searchPath:this.N(n,N)}),D(null,void 0)))})},w=>{const D=w&&A.$Hb(w);return S(D&&D.length>0?D[0]:void 0)})}J(n,r){this.K(r)&&(!this.d||this.d(r.relativePath,d.$nc(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||n(r))}K(n){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.$3I)(n,this.c)}return!0}L(n,r,u){return r.isSymbolicLink()?T.stat(n,u):u(null,r)}M(n,r,u){return r.isSymbolicLink()?T.realpath(n,(I,S)=>I?u(I):u(null,S)):u(null,n)}N(n,r){return n.folderName?d.$jc(n.folderName,r):r}}e.$Nec=f;class l{constructor(n){this.a=n.folderQueries,this.b=n.extraFileResources||[],this.c=new f(n)}search(n,r,u){this.c.walk(this.a,this.b,n,r,(I,S)=>{u(I,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Oec=l;class t{constructor(n,r){this.expression=n,this.c=r,this.d(n)}d(n){let r,u;Object.keys(n).filter(I=>n[I]).forEach(I=>{d.$ic(I)?(r=r||E.$rj(),r[I]=n[I]):(u=u||E.$rj(),u[I]=n[I])}),this.a=r&&E.$wj(r,{trimForExclusions:!0}),this.b=u&&E.$wj(u,{trimForExclusions:!0})}test(n,r,u){return this.b&&this.b(n,r,u)||this.a&&this.a(d.$jc(this.c,n),r,u)}getBasenameTerms(){const n=[];return this.a&&n.push(...E.$yj(this.a)),this.b&&n.push(...E.$yj(this.b)),n}getPathTerms(){const n=[];return this.a&&n.push(...E.$zj(this.a)),this.b&&n.push(...E.$zj(this.b)),n}}function i(c){const n=c.trim().split(`
`),r=n[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return y.$qf(n[n.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(De[364],Ce([1,0,96,22,182,21]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=e.$JC=e.$IC=e.$HC=e.$GC=e.$FC=e.$EC=e.DecodeStreamErrorKind=e.$DC=e.$CC=e.$BC=e.$AC=e.$zC=e.$yC=e.$xC=e.$wC=void 0,e.$wC="utf8",e.$xC="utf8bom",e.$yC="utf16be",e.$zC="utf16le";function A(r){return[e.$wC,e.$xC,e.$yC,e.$zC].some(u=>u===r)}e.$AC=A,e.$BC=[254,255],e.$CC=[255,254],e.$DC=[239,187,191];const m=512,E=512,b=512*8,L=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class v extends Error{constructor(u,I){super(u),this.decodeStreamErrorKind=I}}e.$EC=v;class y{static async create(u){let I;if(u!==e.$wC)I=(await(0,d.$vC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(u));else{const S=new TextDecoder;I={write($){return S.decode($,{stream:!0})},end(){return S.decode()}}}return new y(I)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function k(r,u){const I=u.minBytesRequiredForDetection??u.guessEncoding?b:E;return new Promise((S,$)=>{const g=(0,C.$2d)(U=>U.join("")),w=[];let D=0,N;const M=new R.$Xd,F=async()=>{try{const U=await n({buffer:T.$be.concat(w),bytesRead:D},u.guessEncoding);if(U.seemsBinary&&u.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);U.encoding=await u.overwriteEncoding(U.encoding),N=await y.create(U.encoding);const j=N.write(T.$be.concat(w).buffer);g.write(j),w.length=0,D=0,S({stream:g,detected:U})}catch(U){M.cancel(),g.destroy(),$(U)}};(0,C.$6d)(r,{onData:async U=>{N?g.write(N.write(U.buffer)):(w.push(U),D+=U.byteLength,D>=I&&(r.pause(),await F(),setTimeout(()=>r.resume())))},onError:U=>g.error(U),onEnd:async()=>{N||await F(),g.end(N?.end())}},M.token)})}e.$FC=k;async function p(r,u,I){const $=(await(0,d.$vC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(u),I);let g=!1,w=!1;return{read(){if(w)return null;const D=r.read();if(typeof D!="string"){if(w=!0,!g&&I?.addBOM)switch(u){case e.$wC:case e.$xC:return T.$be.wrap(Uint8Array.from(e.$DC));case e.$yC:return T.$be.wrap(Uint8Array.from(e.$BC));case e.$zC:return T.$be.wrap(Uint8Array.from(e.$CC))}const N=$.end();return N&&N.length>0?(g=!0,T.$be.wrap(N)):null}return g=!0,T.$be.wrap($.write(D))}}}e.$GC=p;async function h(r){return(await(0,d.$vC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(r))}e.$HC=h;function s(r){return r===e.$xC||r===null?e.$wC:r}e.$IC=s;function a(r,u){if(!r||u<e.$BC.length)return null;const I=r.readUInt8(0),S=r.readUInt8(1);if(I===e.$BC[0]&&S===e.$BC[1])return e.$yC;if(I===e.$CC[0]&&S===e.$CC[1])return e.$zC;if(u<e.$DC.length)return null;const $=r.readUInt8(2);return I===e.$DC[0]&&S===e.$DC[1]&&$===e.$DC[2]?e.$xC:null}e.$JC=a;const o=["ascii","utf-16","utf-32"];async function f(r){const u=await(0,d.$vC)("jschardet","dist/jschardet.min.js"),I=r.slice(0,L),S=i(I.buffer),$=u.detect(S);if(!$||!$.encoding)return null;const g=$.encoding.toLowerCase();return 0<=o.indexOf(g)?null:t($.encoding)}const l={ibm866:"cp866",big5:"cp950"};function t(r){const u=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return l[u]||u}function i(r){let u="";for(let I=0;I<r.length;I++)u+=String.fromCharCode(r[I]);return u}function c(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=r.match(/windows(\d+)/);return u?"windows-"+u[1]:r}}}e.$KC=c;function n({buffer:r,bytesRead:u},I){let S=a(r,u),$=!1;if(S!==e.$yC&&S!==e.$zC&&r){let g=!0,w=!0,D=!1;for(let N=0;N<u&&N<m;N++){const M=N%2===1,F=r.readUInt8(N)===0;if(F&&(D=!0),g&&(M&&!F||!M&&F)&&(g=!1),w&&(M&&F||!M&&!F)&&(w=!1),F&&!g&&!w)break}D&&(g?S=e.$zC:w?S=e.$yC:$=!0)}return I&&!$&&!S&&r?f(r.slice(0,u)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:$,encoding:S}}e.$LC=n,e.$MC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,364,29,153]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class R extends d.$Kdc{constructor(m,E,b=T,L="searchProcess"){super(m,E,{readdir:P=>b.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,C.$KC)(P)},L)}}e.$Wec=R}),define(De[155],Ce([1,0,49,380,363,19,74,36,16,15,2,37,92,381,361,116]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=e.$Tec=e.$Sec=e.$Rec=e.$Qec=e.$Pec=void 0;const h=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(w){this.a=w}provideTextSearchResults(w,D,N,M){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((F,U)=>{M.onCancellationRequested(()=>Q());const j=i(w,D),O=D.folder.fsPath,q=j.map(H=>H.match(/^-/)?H:`'${H}'`).join(" ");this.a.appendLine(`${h} ${q}
 - cwd: ${O}`);let K=C.spawn(h,j,{cwd:O});K.on("error",H=>{console.error(H),this.a.appendLine("Error: "+(H&&H.message)),U((0,P.$YI)(new P.$WI(H&&H.message,P.SearchErrorCode.rgProcessError)))});let me=!1;const te=new f(D.maxResults,O,D.previewOptions);te.on("result",H=>{me=!0,ie="",N.report(H)});let G=!1;const Q=()=>{G=!0,K?.kill(),te?.cancel()};let le=!1;te.on("hitLimit",()=>{le=!0,Q()});let ie="";K.stdout.on("data",H=>{te.handleData(H),me||(ie+=H)});let ce=!1;K.stdout.once("data",()=>ce=!0);let ye="";K.stderr.on("data",H=>{const B=H.toString();this.a.appendLine(B),ye.length+B.length<1e6&&(ye+=B)}),K.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(me?"Got result from parser":"No result from parser"),ie&&this.a.appendLine(`Got data without result: ${ie}`),this.a.appendLine(""),G)F({limitHit:le});else{te.flush(),K=null;let H;ye&&!ce&&(H=a(ye))?U((0,P.$YI)(new P.$WI(H.message,H.code))):F({limitHit:le})}})})}}e.$Pec=s;function a(g){const w=g.split(`
`),D=w[0].trim();if(w.some(M=>M.startsWith("regex parse error")))return new P.$WI(o(w),P.SearchErrorCode.regexParseError);const N=D.match(/grep config error: unknown encoding: (.*)/);if(N)return new P.$WI(`Unknown encoding: ${N[1]}`,P.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new P.$WI(D.charAt(0).toUpperCase()+D.substr(1),P.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new P.$WI(D.charAt(0).toUpperCase()+D.substr(1),P.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new P.$WI(D,P.SearchErrorCode.regexParseError)}function o(g){const w=["Regex parse error"],D=g.filter(N=>N.startsWith("PCRE2:"));if(D.length>=1){const N=D[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const M=N.split(":")[1];w.push(":"+M)}}return w.join("")}class f extends T.EventEmitter{constructor(w,D,N){super(),this.g=w,this.h=D,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new d.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,D){return super.on(w,D),this}handleData(w){if(this.b)return;const D=typeof w=="string"?w:this.d.write(w);this.k(D)}k(w){let D=w.indexOf(`
`);const N=this.a+w;if(D>=0)D+=this.a.length;else{this.a=N;return}let M=0;for(;D>=0;)this.m(N.substring(M,D).trim()),M=D+1,D=N.indexOf(`
`,M);this.a=N.substring(M)}m(w){if(this.b||!w)return;let D;try{D=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(D.type==="match"){const N=l(D.data.path),M=L.URI.file(E.$jc(this.h,N)),F=this.n(D.data,M);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const N=l(D.data.path),M=L.URI.file(E.$jc(this.h,N));this.o(D.data,M).forEach(U=>this.p(U))}}n(w,D){const N=w.line_number-1,M=l(w.lines),F=Buffer.from(M);let U=0,j=0,O=N;w.submatches.length===0&&w.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const q=(0,R.$Hb)(w.submatches.map((K,me)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=l(K.match),G=F.slice(U,K.start).toString(),Q=t(G),le=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+j,ie=t(te),ce=Q.numLines+O,ye=ie.numLines+ce,H=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+le;return U=K.end,j=H,O=ye,new v.$GI(ce,le,ye,H)}));return(0,p.$Iec)(D,M,q,this.j)}o(w,D){const N=l(w.lines),M=w.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((F,U)=>({text:F,uri:D,lineNumber:M+U}))}p(w){this.emit("result",w)}}e.$Qec=f;function l(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function t(g){const w=/\n/g;let D=0,N=-1,M;for(;M=w.exec(g);)D++,N=M.index;const F=N>=0?g.length-N-1:g.length;return{numLines:D,lastLineLength:F}}function i(g,w){const D=["--hidden","--no-require-git"];D.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:M}=(0,A.$J)(w.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const U=new Set;M.forEach(j=>{U.add(j)}),D.push("-g","!*"),U.forEach(j=>{c(j).map(p.$Hec).forEach(O=>{D.push("-g",O)})})}N&&N.length&&N.forEach(U=>{D.push("-g",U)}),w.excludes.map(p.$Hec).forEach(U=>D.push("-g",`!${U}`)),w.maxFileSize&&D.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),w.followSymlinks&&D.push("--follow"),w.encoding&&w.encoding!=="utf8"&&D.push("--encoding",w.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,b.$Fe)(g.pattern),g.isRegExp=!0),w.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),g.isRegExp&&(g.pattern=n(g.pattern),D.push("--engine","auto"));let F;if(g.isWordMatch){const j=(0,b.$Ne)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",j)}else if(g.isRegExp){let U=u(g.pattern);U=I(U),D.push("--regexp",U)}else F=g.pattern,D.push("--fixed-strings");return D.push("--no-config"),w.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),g.isMultiline&&D.push("--multiline"),w.beforeContext&&D.push("--before-context",w.beforeContext+""),w.afterContext&&D.push("--after-context",w.afterContext+""),D.push("--"),F&&D.push(F),D.push("."),D}e.$Rec=i;function c(g){return $(g).flatMap(D=>{const N=(0,m.$uj)(D,"/");return N.map((M,F)=>N.slice(0,F+1).join("/"))})}function n(g){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(w);)g=g.replace(w,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(D);)g=g.replace(D,"$1\\x{$2}");return g}e.$Sec=n;const r=g=>g.type==="Assertion"&&g.kind==="lookbehind";function u(g){let w;try{w=new y.RegExpParser().parsePattern(g)}catch{return g}let D="",N=0;const M=(j,O,q)=>{D+=g.slice(N,j)+q,N=O},F=[];return new y.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const O=F[0];if(!O)M(j.start,j.end,"\\r?\\n");else if(!F.some(r))if(O.type==="CharacterClass")if(O.negate){const q=g.slice(O.start+2,j.start)+g.slice(j.end,O.end-1);O.parent?.type==="Quantifier"?M(O.start,O.end,q?`[^${q}]`:"."):M(O.start,O.end,"(?!\\r?\\n"+(q?`|[${q}]`:"")+")")}else{const q=g.slice(O.start+1,j.start)+g.slice(j.end,O.end-1);M(O.start,O.end,q===""?"\\r?\\n":`(?:[${q}]|\\r?\\n)`)}else O.type==="Quantifier"&&M(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){F.unshift(j)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(j){F.unshift(j)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(j){F.unshift(j)},onCharacterClassLeave(){F.shift()},onAssertionEnter(j){r(j)&&F.push(j)},onAssertionLeave(j){F[0]===j&&F.shift()}}).visit(w),D+=g.slice(N),D}e.$Tec=u;function I(g){return g.replace(/\n/g,"\\r?\\n")}e.$Uec=I;function S(g){let w=!1,D=!1,N="",M="";for(let F=0;F<g.length;F++){const U=g[F];switch(U){case"\\":D?(w?M+="\\"+U:N+="\\"+U,D=!1):D=!0;break;case"{":if(D)w?M+=U:N+=U,D=!1;else{if(w)return{strInBraces:N+"{"+M+"{"+g.substring(F+1)};w=!0}break;case"}":if(D)w?M+=U:N+=U,D=!1;else{if(w)return{fixedStart:N,strInBraces:M,fixedEnd:g.substring(F+1)};N+=U}break;default:w?M+=(D?"\\":"")+U:N+=(D?"\\":"")+U,D=!1;break}}return{strInBraces:N+(w?"{"+M:"")}}function $(g){const{fixedStart:w,strInBraces:D,fixedEnd:N}=S(g);if(w===void 0||N===void 0)return[D];let M=(0,m.$uj)(D,",");M.length||(M=[""]);const F=$(N);return M.flatMap(U=>{const j=w+U;return F.map(O=>j+O)})}e.$Vec=$}),define(De[365],Ce([1,0,21,155,64,18]),function($e,e,C,T,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class A{constructor(b){this.b=b,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(b,L,P,v){const y=new T.$Pec(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const k={...L,folder:L.folder.with({scheme:R.Schemas.file})},p=new d.$5u(h=>P.report({...h,uri:h.uri.with({scheme:L.folder.scheme})}));return this.c(v,h=>y.provideTextSearchResults(b,k,p,h))}else return this.c(v,k=>y.provideTextSearchResults(b,L,P,k))}async c(b,L){const P=m(b);this.a.add(P);const v=await L(P.token);return this.a.delete(P),v}d(){this.a.forEach(b=>b.cancel())}}e.$Zec=A;function m(E){const b=new C.$Xd;return E.onCancellationRequested(()=>b.cancel()),b}}),define(De[366],Ce([1,0,29,155,154]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class R{constructor(E){this.a=E}search(E,b,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){L({message:y})}},v=new d.$Wec(this.a,new T.$Pec(P),C);return new Promise((y,k)=>v.search(p=>{b(p.map(A))},E).then(p=>y({limitHit:p.limitHit,type:"success",stats:p.stats}),k))}}e.$Xec=R;function A(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((E,b)=>{if(b.ranges){const L=b;return E+(Array.isArray(L.ranges)?L.ranges.length:1)}else return E+1},0)}}}),define(De[367],Ce([1,0,19,8,9,4,127,16,35,2,30,37,362,366]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class k{static{this.a=512}constructor(f="searchProcess"){this.d=f,this.b=Object.create(null)}fileSearch(f){let l;const t=s(f),i=new R.$Nd({onDidAddFirstListener:()=>{l=(0,T.$Hg)(c=>this.doFileSearchWithEngine(v.$Oec,t,n=>i.fire(n),c)),l.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{l.cancel()}});return i.event}textSearch(f){let l;const t=s(f),i=new R.$Nd({onDidAddFirstListener:()=>{l=(0,T.$Hg)(c=>this.f(t,n=>i.fire(n),c)),l.then(c=>i.fire(c),c=>i.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{l.cancel()}});return i.event}f(f,l,t){return f.maxFileSize=this.g().maxFileSize,new y.$Xec(f).search(t,l,l)}g(){return{maxFileSize:16*L.$Gk.GB}}doFileSearch(f,l,t){return this.doFileSearchWithEngine(v.$Oec,f,l,t)}doFileSearchWithEngine(f,l,t,i,c=k.a){let n=0;const r=I=>{Array.isArray(I)?(n+=I.length,t(I.map(S=>this.h(S)))):I.relativePath?(n++,t(this.h(I))):t(I)};if(l.sortByScore){let I=this.l(l,r,i);if(!I){const S=l.maxResults?Object.assign({},l,{maxResults:null}):l,$=new f(S);I=this.j($,l,t,r,i)}return new Promise((S,$)=>{I.then(([g,w])=>{const D=w.map(N=>this.h(N));this.o(D,t,c),S(g)},$)})}const u=new f(l);return this.r(u,r,c,i).then(I=>({limitHit:I.limitHit,type:"success",stats:{detailStats:I.stats,type:this.d,fromCache:!1,resultCount:n,sortingTime:void 0}}))}h(f){return{path:f.base?(0,m.$jc)(f.base,f.relativePath):f.relativePath}}j(f,l,t,i,c){const n=new R.$Nd;let r=(0,T.$Hg)(I=>{let S=[];const $=g=>{Array.isArray(g)?S=g:(i(g),n.fire(g))};return this.r(f,$,-1,I).then(g=>[g,S])}),u;if(l.cacheKey){u=this.k(l.cacheKey);const I={promise:r,event:n.event,resolved:!1};u.resultsToSearchCache[l.filePattern||""]=I,r.then(()=>{I.resolved=!0},S=>{delete u.resultsToSearchCache[l.filePattern||""]}),r=this.s(r)}return r.then(([I,S])=>{const $=u?u.scorerCache:Object.create(null),g=(typeof l.maxResults!="number"||l.maxResults>0)&&E.$Jd.create(!1);return this.n(l,S,$,c).then(w=>{const D=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:I.stats,sortingTime:D,fromCache:!1,type:this.d,workspaceFolderCount:l.folderQueries.length,resultCount:w.length},messages:I.messages,limitHit:I.limitHit||typeof l.maxResults=="number"&&S.length>l.maxResults},w]})})}k(f){const l=this.b[f];return l||(this.b[f]=new p)}l(f,l,t){const i=f.cacheKey&&this.b[f.cacheKey];if(!i)return;const c=this.q(i,f.filePattern||"",l,t);if(c)return c.then(([n,r,u])=>{const I=E.$Jd.create(!1);return this.n(f,r,i.scorerCache,t).then(S=>{const $=I.elapsed(),g={fromCache:!0,detailStats:u,type:this.d,resultCount:r.length,sortingTime:$};return[{type:"success",limitHit:n.limitHit||typeof f.maxResults=="number"&&r.length>f.maxResults,stats:g},S]})})}n(f,l,t,i){const c=(0,A.$yq)(f.filePattern||""),n=(u,I)=>(0,A.$xq)(u,I,c,!0,h,t),r=typeof f.maxResults=="number"?f.maxResults:Number.MAX_VALUE;return C.$Gb(l,n,r,1e4,i)}o(f,l,t){if(t&&t>0)for(let i=0;i<f.length;i+=t)l(f.slice(i,i+t));else l(f)}q(f,l,t,i){const c=E.$Jd.create(!1),n=l.indexOf(m.sep)>=0;let r;for(const $ in f.resultsToSearchCache)if(l.startsWith($)){if(n&&$.indexOf(m.sep)<0&&$!=="")continue;const g=f.resultsToSearchCache[$];r={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!r)return null;const u=c.elapsed(),I=E.$Jd.create(!1),S=r.event(t);return i&&i.onCancellationRequested(()=>{S.dispose()}),r.promise.then(([$,g])=>{if(i&&i.isCancellationRequested)throw(0,d.$6)();const w=[],D=(0,A.$yq)(l).normalizedLowercase;for(const N of g)(0,P.$3I)(N,D)&&w.push(N);return[$,w,{cacheWasResolved:r.resolved,cacheLookupTime:u,cacheFilterTime:I.elapsed(),cacheEntryCount:g.length}]})}r(f,l,t,i){return new Promise((c,n)=>{let r=[];i?.onCancellationRequested(()=>f.cancel()),f.search(u=>{u&&(t?(r.push(u),t>0&&r.length>=t&&(l(r),r=[])):l(u))},u=>{l(u)},(u,I)=>{r.length&&l(r),u?n(u):c(I)})})}clearCache(f){return delete this.b[f],Promise.resolve(void 0)}s(f){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(l,t){return f.then(l,t)}catch(l){return this.then(void 0,l)}finally(l){return f.finally(l)}}}}e.$Yec=k;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(o){return(0,m.$nc)(o.relativePath)}getItemDescription(o){return(0,m.$mc)(o.relativePath)}getItemPath(o){return o.relativePath}};function s(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(a),extraFileResources:o.extraFileResources&&o.extraFileResources.map(f=>b.URI.revive(f))}}function a(o){return{...o,folder:b.URI.revive(o.folder)}}}),define(De[368],Ce([1,0,3,18,2,29,14,27,20,95,67,37,367,365,116,154]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let h=class extends b.$Pdc{constructor(a,o,f,l){super(a,f,l),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Rc;const t=new k.$Jec("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new y.$Zec(t))),o.remote.isRemote&&o.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const a=new k.$Jec("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new y.$Zec(a))),this.x.add(this.z(T.Schemas.file,new v.$Yec("fileSearchProvider")))}z(a,o){const f=this.d++;return this.v=o,this.t=f,this.c.$registerFileSearchProvider(f,this.o(a)),(0,C.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(f)})}$provideFileSearchResults(a,o,f,l){const t=(0,b.$Qdc)(f);return a===this.t?this.A(a,o,t,l):super.$provideFileSearchResults(a,o,f,l)}A(a,o,f,l){const t=i=>{if((0,P.$2I)(i)&&(i=[i]),Array.isArray(i)){this.c.$handleFileMatch(a,o,i.map(c=>d.URI.file(c.path)));return}i.message&&this.n.debug("ExtHostSearch",i.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(f,t,l)}$clearCache(a){return this.v?.clearCache(a),super.$clearCache(a)}q(a,o){return new p.$Wec(a,o,void 0,"textSearchProvider")}};e.$1ec=h,e.$1ec=h=He([Be(0,E.$mM),Be(1,m.$CM),Be(2,L.$vcc),Be(3,A.$0i)],h)}),define(De[117],Ce([1,0,382,60,63,383,22,9,4,3,16,12,31,81,82]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=void 0;class p{traceSocketEvent(g,w){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,w)}constructor(g,w=""){this.f=!0,this.debugLabel=w,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,m.$1)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const w=D=>{this.traceSocketEvent("read",D),g(A.$be.wrap(D))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(g){const w=D=>{g({type:0,hadError:D,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(g){const w=()=>{g()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.$1)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.$1)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$Eh=p;var h;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var s;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(s||(s={}));class a extends b.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,w){this.socket.traceSocketEvent(g,w)}constructor(g,w,D,N){super(),this.f=this.B(new E.$Nd),this.g=this.B(new E.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:D?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new o(this,w,D,N,this.f,(M,F)=>this.m(M,F))),this.B(this.a.onError(M=>{console.error(M),(0,m.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new k.$zh,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let w=0;for(;w<g.byteLength;)this.a.writeMessage(g.slice(w,Math.min(w+262144,g.byteLength)),{compressed:!0,opcode:2}),w+=262144}m(g,{compressed:w,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let N=2;g.byteLength<126?N+=0:g.byteLength<2**16?N+=2:N+=8;const M=A.$be.alloc(N),F=w?64:0,U=D&15;if(M.writeUInt8(128|F|U,0),g.byteLength<126)M.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){M.writeUInt8(126,1);let j=1;M.writeUInt8(g.byteLength>>>8&255,++j),M.writeUInt8(g.byteLength>>>0&255,++j)}else{M.writeUInt8(127,1);let j=1;M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(g.byteLength>>>24&255,++j),M.writeUInt8(g.byteLength>>>16&255,++j),M.writeUInt8(g.byteLength>>>8&255,++j),M.writeUInt8(g.byteLength>>>0&255,++j)}this.socket.write(A.$be.concat([M,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),D=w.readUInt8(0),N=(D&128)>>>7,M=(D&64)>>>6,F=D&15,U=w.readUInt8(1),j=(U&128)>>>7,O=U&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),D=w.readUInt8(1),N=(D&128)>>>7;let M=D&127,F=1;M===126?M=w.readUInt8(++F)*2**8+w.readUInt8(++F):M===127&&(M=w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*0+w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F));let U=0;N&&(U=w.readUInt8(++F)*2**24+w.readUInt8(++F)*2**16+w.readUInt8(++F)*2**8+w.readUInt8(++F)),this.j.state=3,this.j.readLen=M,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),t(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(w,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(w,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Fh=a;class o extends b.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$be.alloc(0)}constructor(g,w,D,N,M,F){super(),this.n=g,this.r=M,this.s=F,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,w?(this.b=this.B(new f(this.n,N,D,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(g,w){this.g.push({data:g,options:w}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:w}=this.g.shift();if(this.f&&w.compressed){const D=await this.w(this.f,g);this.s(D,w)}else this.s(g,{...w,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,w){return new Promise((D,N)=>{g.write(w),g.flush(M=>D(M))})}acceptFrame(g,w,D){this.h.push({data:g,isCompressed:w,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const w=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(w)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,w,D){return new Promise((N,M)=>{g.write(w),D&&g.write(A.$be.fromByteArray([0,0,255,255])),g.flush(F=>N(F))})}}class f extends b.$Sc{get recordedInflateBytes(){return this.j?A.$be.concat(this.f):A.$be.alloc(0)}constructor(g,w,D,N){super(),this.h=g,this.j=w,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(A.$be.wrap(M))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=A.$be.concat(this.g);this.g.length=0,g(w)})}}class l extends b.$Sc{constructor(g,w){super(),this.g=g,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(A.$be.wrap(D))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=A.$be.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),g(w)})}}function t($,g){if(g===0)return;const w=$.byteLength>>>2;for(let j=0;j<w;j++){const O=$.readUInt32BE(j*4);$.writeUInt32BE(O^g,j*4)}const D=w*4,N=$.byteLength-D,M=g>>>24&255,F=g>>>16&255,U=g>>>8&255;N>=1&&$.writeUInt8($.readUInt8(D)^M,D),N>=2&&$.writeUInt8($.readUInt8(D+1)^F,D+1),N>=3&&$.writeUInt8($.readUInt8(D+2)^U,D+2)}e.$Gh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function c(){const $=(0,v.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const g=process.platform!=="darwin"&&e.$Gh?e.$Gh:(0,d.tmpdir)(),w=(0,L.$jc)(g,`vscode-ipc-${$}.sock`);return r(w),w}e.$Hh=c;function n($,g,w){const D=(0,C.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${w}-${g}-sock`;const N=w.substr(0,4),M=g.substr(0,6),F=D.substr(0,8);let U;return process.platform!=="darwin"&&e.$Gh&&!process.env.VSCODE_PORTABLE?U=(0,L.$jc)(e.$Gh,`vscode-${F}-${N}-${M}.sock`):U=(0,L.$jc)($,`${N}-${M}.sock`),r(U),U}e.$Ih=n;function r($){const g=i[P.$u];typeof g=="number"&&$.length>=g&&console.warn(`WARNING: IPC handle "${$}" is longer than ${g} chars, try a shorter --user-data-dir`)}class u extends y.$th{static b(g){const w=E.Event.fromNodeEventEmitter(g,"connection");return E.Event.map(w,D=>({protocol:new k.$Ah(new p(D,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(D,"close"))}))}constructor(g){super(u.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Jh=u;function I($){return new Promise((g,w)=>{const D=(0,T.createServer)();D.on("error",w),D.listen($,()=>{D.removeListener("error",w),g(new u(D))})})}e.$Kh=I;function S($,g){return new Promise((w,D)=>{const N=(0,T.createConnection)($,()=>{N.removeListener("error",D),w(k.$Bh.fromSocket(new p(N,`ipc-client${g}`),g))});N.once("error",D)})}e.$Lh=S}),define(De[369],Ce([1,0,60,63,163,117,8,3,12,50,14,135,248,249,106,86,22]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q8b=e.$p8b=e.$o8b=e.$n8b=void 0;async function s(t,i,c,n,r){let u;for(let I=3;I&&(u?.dispose(),u=await new a(t,i,c,n,r).waitForReady(),!(r&&d.$hg[r]||!d.$hg[u.tunnelLocalPort]));I--);return u}class a extends m.$Sc{constructor(i,c,n,r,u){super(),this.m=c,this.n=u,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=C.createServer(),this.c=new A.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=I=>this.r(I),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,c=(0,p.$ev)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,d.$ig)(i,2,1e3,c),r=null;return this.b.listen(n,this.m),await this.c.wait(),r=this.b.address(),r||(n=0,this.b.listen(n,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(i){i.pause();const c=(0,p.$cv)(this.tunnelRemoteHost)||(0,p.$ev)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,v.$6k)(this.a,c,this.tunnelRemotePort),r=n.getSocket(),u=n.readEntireBuffer();n.dispose(),u.byteLength>0&&i.write(u.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),r.end()}),i.on("close",()=>r.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),r instanceof R.$Eh?r.socket.destroy():r.end()}),r instanceof R.$Eh?this.t(i,r):this.s(i,r),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),r.end()})}s(i,c){c.onClose(()=>i.destroy()),c.onEnd(()=>i.end()),c.onData(n=>i.write(n.buffer)),i.on("data",n=>c.write(h.$be.wrap(n))),i.resume()}t(i,c){const n=c.socket;n.on("end",()=>i.end()),n.on("close",()=>i.end()),n.on("error",()=>{i.destroy()}),n.pipe(i),i.pipe(n)}}e.$n8b=a;let o=class extends p.$hv{constructor(i,c,n,r,u){super(c,u),this.u=i,this.v=n,this.w=r}isPortPrivileged(i){return(0,p.$fv)(i,this.l,E.OS,T.release())}s(i,c,n,r,u,I,S,$){const g=this.r(c,n);if(g)return++g.refcount,g.value;if((0,p.$_u)(i))return this.t(i,c,n,u,I,S,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${n} on local port ${u}.`);const w={commit:this.w.commit,quality:this.w.quality,addressProvider:i,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=s(w,r,c,n,u);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(c,n,D),D}}};e.$o8b=o,e.$o8b=o=He([Be(0,y.$Zk),Be(1,L.$0i),Be(2,k.$3k),Be(3,P.$pj),Be(4,b.$ji)],o);let f=class extends o{constructor(i,c,n,r,u){super(i,c,n,r,u)}};e.$p8b=f,e.$p8b=f=He([Be(0,y.$Zk),Be(1,L.$0i),Be(2,k.$3k),Be(3,P.$pj),Be(4,b.$ji)],f);let l=class extends m.$Sc{constructor(i,c,n,r,u){super(),this.b=i,this.c=c,this.f=n,this.g=r,this.h=u,this.a=new Map}async openTunnel(i,c,n,r,u,I,S,$,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${r} on local port ${I}.`),!this.a.has(i)){const w=new f(this.b,this.c,this.g,this.f,this.h);this.B(w),this.a.set(i,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(c,n,r,u,I,S,$,g)}};e.$q8b=l,e.$q8b=l=He([Be(0,y.$Zk),Be(1,L.$0i),Be(2,P.$pj),Be(3,k.$3k),Be(4,b.$ji)],l)}),define(De[370],Ce([1,0,117,268,53,34,2,14,44]),function($e,e,C,T,d,R,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=void 0;class b{constructor(v,y,k){this.b=v,this.c=y,this.f=k,this.a=T.createServer((p,h)=>this.h(p,h)),this.g().catch(p=>(y.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,y){const k=(h,s)=>{y.writeHead(h,{"content-type":"application/json"}),y.end(JSON.stringify(s||null),a=>a&&this.c.error(a))},p=[];v.setEncoding("utf8"),v.on("data",h=>p.push(h)),v.on("end",async()=>{try{const h=JSON.parse(p.join(""));let s;switch(h.type){case"open":s=await this.i(h);break;case"openExternal":s=await this.j(h);break;case"status":s=await this.l(h);break;case"extensionManagement":s=await this.k(h);break;default:k(404,`Unknown message type: ${h.type}`);break}k(200,s)}catch(h){const s=h instanceof Error?h.message:JSON.stringify(h);k(500,s),this.c.error("Error while processing pipe request",h)}})}async i(v){const{fileURIs:y,folderURIs:k,forceNewWindow:p,diffMode:h,mergeMode:s,addMode:a,forceReuseWindow:o,gotoLineMode:f,waitMarkerFilePath:l,remoteAuthority:t}=v,i=[];if(Array.isArray(k))for(const u of k)try{i.push({folderUri:A.URI.parse(u)})}catch{}if(Array.isArray(y))for(const u of y)try{(0,E.$ii)(u)?i.push({workspaceUri:A.URI.parse(u)}):i.push({fileUri:A.URI.parse(u)})}catch{}const c=l?A.URI.file(l):void 0,r={forceNewWindow:p,diffMode:h,mergeMode:s,addMode:a,gotoLineMode:f,forceReuseWindow:o,preferNewWindow:!o&&!c&&!a,waitMarkerFileURI:c,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",i,r)}async j(v){for(const y of v.uris){const k=A.URI.parse(y),p=k.scheme==="file"?k:y;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(v){const y=p=>p?.map(h=>/\.vsix$/i.test(h)?A.URI.parse(h):h),k={list:v.list,install:y(v.install),uninstall:y(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&d.existsSync(this.f)&&d.unlinkSync(this.f)}}e.$NM=b;let L=class extends b{constructor(v,y){super(v,y,(0,C.$Hh)())}};e.$OM=L,e.$OM=L=He([Be(0,R.$IM),Be(1,m.$0i)],L)}),define(De[371],Ce([1,0,54,358,353,267,46,341,2,18,7,370,100,339,340]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class p extends d.$uec{j(){const a=this,o=globalThis._VSCODE_NODE_MODULES.module,f=o._load;o._load=function(c,n,r){return c=t(c),a.a.has(c)?a.a.get(c).load(c,E.URI.file((0,v.$8p)(n.filename)),u=>f.apply(this,[u,n,r])):f.apply(this,arguments)};const l=o._resolveLookupPaths;o._resolveLookupPaths=(i,c)=>l.call(this,t(i),c);const t=i=>{for(const c of a.b){const n=c(i);if(n){i=n;break}}return i}}}class h extends A.$6cc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$4ec);const a=this.h.invokeFunction(T.$qec);if(this.h.createInstance(m.$3ec),this.f.remote.isRemote&&this.f.remote.authority){const l=this.h.createInstance(P.$OM);process.env.VSCODE_IPC_HOOK_CLI=l.ipcHandlePath}this.h.createInstance(k.$5ec),await this.h.createInstance(p,a,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const f=await this.m.getConfigProvider();await(0,R.$2ec)(this.j,f,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(a){return a.main}async vb(a,o,f){if(o.scheme!==b.Schemas.file)throw new Error(`Cannot load URI: '${o}', must be of file-scheme`);let l=null;f.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${o.toString(!0)}`),this.s.flush();const t=a?.identifier.value;a&&await this.w.initializeLocalizedMessages(a);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),l=$e.__$__nodeRequire(o.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}return l}async $setRemoteEnvironment(a){if(this.f.remote.isRemote)for(const o in a){const f=a[o];f===null?delete process.env[o]:process.env[o]=f}}}e.$6ec=h}),define(De[372],Ce([1,0,49,22,4,3,120,12,23,2,29,14,247,65,106,86,369,27,20,73,349]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=e.$_ec=e.$$ec=e.$0ec=e.$9ec=e.$8ec=e.$7ec=void 0;function l(g){const w=g.trim().split(`
`),D=[];return w.forEach(M=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);F&&F.length>=3&&D.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),D.reduce((M,F)=>(M[F.socket]=F,M),{})}e.$7ec=l;function t(...g){const w=[].concat(...g.map(c));return[...new Map(w.filter(D=>D.st==="0A").map(D=>{const N=D.local_address.split(":");return{socket:parseInt(D.inode,10),ip:i(N[0]),port:parseInt(N[1],16)}}).map(D=>[D.ip+":"+D.port,D])).values()]}e.$8ec=t;function i(g){let w="";if(g.length===8)for(let D=g.length-2;D>=0;D-=2)w+=parseInt(g.substr(D,2),16),D!==0&&(w+=".");else for(let D=0;D<g.length;D+=8){const N=g.substring(D,D+8);let M="";for(let F=8;F>=2;F-=2)M+=N.substring(F-2,F),(F===6||F===2)&&(M=parseInt(M,16).toString(16),w+=`${M}`,M="",D+F!==g.length-6&&(w+=":"))}return w}e.$9ec=i;function c(g){const w=g.trim().split(`
`),D=w.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return w.map(M=>M.trim().split(/\s+/).reduce((F,U,j)=>(F[D[j]||j]=U,F),{}))}e.$0ec=c;function n(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function r(g){const w=g.trim().split(`
`),D=[];return w.forEach(N=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);M&&M.length>=4&&D.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),D}e.$$ec=r;async function u(g,w,D){const N=D.reduce((F,U)=>(F[U.pid]=U,F),{}),M=[];return g.forEach(({socket:F,ip:U,port:j})=>{const O=w[F]?w[F].pid:void 0,q=O?N[O]?.cmd:void 0;O&&q&&!n(q)&&M.push({host:U,port:j,detail:q,pid:O})}),M}e.$_ec=u;function I(g,w,D){const N=new Map,M=r(w);for(const F of g){const U=D.get(F.port);if(U){N.set(F.port,U);continue}const j=M.find(O=>O.cmd.includes(`${F.port}`));if(j){let O=j,q;do q=M.find(K=>K.ppid===O.pid),q&&(O=q);while(q);N.set(F.port,{host:F.ip,port:F.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return N}e.$afc=I;let S=class extends o.$dwb{constructor(w,D,N,M){super(w,D,N),this.D=D,this.F=M,this.y=void 0,this.z=new Map,this.C=!1,m.$l&&D.remote.isRemote&&D.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(w){if(w&&this.C)return;this.C=w;let D;this.y&&(D=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new A.$Rl;let M=0;for(;this.C;){const F=new Date().getTime(),U=(await this.I()).filter(q=>(0,p.$cv)(q.host)||(0,p.$ev)(q.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${U.map(q=>q.port).join(", ")}`);const j=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),M++>3&&N.update(j),(!D||JSON.stringify(D)!==JSON.stringify(U))&&(D=U,await this.a.$onFoundNewCandidates(D));const O=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(q=>setTimeout(()=>q(),O))}}G(w){return Math.max(w*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(w=>w.port).join(", ")}`)}async I(){let w="",D="";try{w=await L.Promises.readFile("/proc/net/tcp","utf8"),D=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(w,D),M=await new Promise(te=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(G,Q,le)=>{te(Q)})}),F=l(M),U=await L.Promises.readdir("/proc"),j=[];for(const te of U)try{const G=Number(te),Q=E.$vg(b.URI.file("/proc"),te);if((await L.Promises.stat(Q.fsPath)).isDirectory()&&!isNaN(G)){const ie=await L.Promises.readlink(E.$vg(Q,"cwd").fsPath),ce=await L.Promises.readFile(E.$vg(Q,"cmdline").fsPath,"utf8");j.push({pid:G,cwd:ie,cmd:ce})}}catch{}const O=[],q=N.filter(te=>{const G=F[te.socket];return G||O.push(te),G}),K=u(q,F,j);let me;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const te=await new Promise(G=>{(0,C.exec)("ps -F -A -l | grep root",(Q,le,ie)=>{G(le)})});this.z=I(O,te,this.z),me=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${me.map(G=>G.port).join(", ")}`)}return K.then(te=>me?te.concat(me):te)}w(w){return async D=>{const N=new h.$n8b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,U,j,O){const q=await w.makeConnection();return $.connect(q,U,j,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Qk(0),connectionToken:w.connectionToken})}},signService:this.F},"localhost",D.remoteAddress.host||"localhost",D.remoteAddress.port,D.localAddressPort);await N.waitForReady();const M=new d.$Nd;return{localAddress:(0,f.$LJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{N.dispose(),M.fire(),M.dispose()}}}}};e.$bfc=S,e.$bfc=S=He([Be(0,a.$mM),Be(1,s.$CM),Be(2,P.$0i),Be(3,k.$3k)],S);class $ extends v.$Ikb{static connect(w,D,N,M){const F=new R.$Rc,U={onClose:F.add(new d.$Nd),onData:F.add(new d.$Nd),onEnd:F.add(new d.$Nd)};F.add(w.onDidReceiveMessage(O=>U.onData.fire(T.$be.wrap(O)))),F.add(w.onDidEnd(()=>U.onEnd.fire())),F.add(w.onDidClose(O=>U.onClose.fire({type:0,error:O,hadError:!!O})));const j=new $(w,M,U);return j.B(F),(0,v.$Hkb)(j,D,N,M,U)}constructor(w,D,N){super(D,N),this.n=w}write(w){this.n.send(w.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[373],Ce([1,0,103,344,356,355,368,371,372,94,46,95,93,45,73,90,343,342,14,357,56,262,102,106,138]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s,a,o,f,l,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$wr)(L.$7cc,m.$6ec,0),(0,C.$wr)(a.$$i,s.$dfc,1),(0,C.$wr)(a.$0i,new t.$Mh(l.$tec,[!1],!0)),(0,C.$wr)(i.$3k,c.$s8b,1),(0,C.$wr)(p.$Rcc,h.$cfc,0),(0,C.$wr)(b.$Edc,R.$Gec,0),(0,C.$wr)(P.$Odc,A.$1ec,0),(0,C.$wr)(v.$zdc,d.$yec,0),(0,C.$wr)(y.$Tcc,T.$xec,0),(0,C.$wr)(k.$cwb,E.$bfc,0),(0,C.$wr)(f.$Cdc,o.$efc,0)}),define(De[384],Ce([1,0,60,385,54,9,82,117,245,111,354,22,29,100,8,130,269,282,359,373]),function($e,e,C,T,d,R,A,m,E,b,L,P,v,y,k,p,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const a=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,u=r._load;r._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const o=process.exit.bind(process);function f(r){process.exit=function(u){if(r)o(u);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let l=function(r){o()};function t(){const r=(0,s.$Bm)(process.env);if(r.type===3)return new Promise((u,I)=>{const S=$=>{const g=$[0],w=new A.$Ch;g.on("message",D=>w.fire(P.$be.wrap(D.data))),g.on("close",()=>{l("renderer closed the MessagePort")}),g.start(),u({onMessage:w.event,send:D=>g.postMessage(D.buffer)})};process.parentPort.on("message",$=>S($.ports))});if(r.type===2)return new Promise((u,I)=>{let S=null;const $=setTimeout(()=>{l("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),g=108e5,w=3e5,D=new k.$7g(()=>l("renderer disconnected for too long (1)"),g),N=new k.$7g(()=>l("renderer disconnected for too long (2)"),w);process.on("message",(F,U)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const j=P.$be.wrap(Buffer.from(F.initialDataChunk,"base64"));let O;if(F.skipWebSocketFrames)O=new m.$Eh(U,"extHost-socket");else{const q=P.$be.wrap(Buffer.from(F.inflateBytes,"base64"));O=new m.$Fh(new m.$Eh(U,"extHost-socket"),F.permessageDeflate,q,!1)}S?(D.cancel(),N.cancel(),S.beginAcceptReconnection(O,j),S.endAcceptReconnection(),S.sendResume()):(clearTimeout($),S=new A.$Dh({socket:O,initialChunk:j}),S.sendResume(),S.onDidDispose(()=>l("renderer disconnected")),u(S),S.onSocketClose(()=>{D.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;D.isScheduled()&&N.schedule()}});const M={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(M)});{const u=r.pipeName;return new Promise((I,S)=>{const $=C.createConnection(u,()=>{$.removeListener("error",S);const g=new A.$Dh({socket:new m.$Eh($,"extHost-renderer")});g.sendResume(),I(g)});$.once("error",S),$.on("close",()=>{l("renderer closed the socket")})})}}async function i(){const r=await t();return new class{constructor(){this.a=new A.$Ch,this.onMessage=this.a.event,this.b=!1,r.onMessage(u=>{(0,b.$cm)(u,2)?(this.b=!0,l("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||r.send(u)}async drain(){if(r.drain)return r.drain()}}}function c(r){return new Promise(u=>{const I=r.onMessage(S=>{I.dispose();const $=JSON.parse(S.toString()),g=$.commit,w=E.default.commit;if(g&&w&&g!==w&&o(55),$.parentPid){let D=0;setInterval(function(){try{process.kill($.parentPid,0),D=0}catch(M){M&&M.code==="EPERM"?(D++,D>=3&&l(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):l(`parent process ${$.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start($.parentPid)}catch(M){(0,R.$1)(M)}}r.send((0,b.$bm)(0)),u({protocol:r,initData:$})});r.send((0,b.$bm)(1))})}async function n(){const r=[];process.on("unhandledRejection",(D,N)=>{r.push(N),setTimeout(()=>{const M=r.indexOf(N);M>=0&&N.catch(F=>{r.splice(M,1),(0,R.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),D&&(0,R.$1)(D))})},1e3)}),process.on("rejectionHandled",D=>{const N=r.indexOf(D);N>=0&&r.splice(N,1)}),process.on("uncaughtException",function(D){(0,R.$Z)(D)||(0,R.$1)(D)}),d.mark("code/extHost/willConnectToRenderer");const u=await i();d.mark("code/extHost/didConnectToRenderer");const I=await c(u);d.mark("code/extHost/didWaitForInitData");const{initData:S}=I;f(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=a.useHostProxy!==void 0?a.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,p.boolean)(a.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(N){o(N)}fsExists(N){return v.Promises.exists(N)}fsRealpath(N){return(0,y.$7p)(N)}};let g=null;S.remote.authority&&a.transformURIs&&(g=(0,h.$Ar)(S.remote.authority));const w=new L.$wec(I.protocol,S,$,g);l=D=>w.terminate(D)}n().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cbd09078e6221fa1553c5a59dd25e63ad767911a/core/vs/workbench/api/node/extensionHostProcess.js.map
