/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/core/range","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,M=be.length;w<M;w++)e[w]=Ae[be[w]];return e};define(Ae[65],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=void 0;function w(A){return(u,D,f)=>{let R=null,k=null;if(typeof f.value=="function"?(R="value",k=f.value):typeof f.get=="function"&&(R="get",k=f.get),!k)throw new Error("not supported");f[R]=A(k,D)}}function M(A,u,D){let f=null,R=null;if(typeof D.value=="function"?(f="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(f="get",R=D.get),!R)throw new Error("not supported");const k=`$memoize$${u}`;D[f]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,a)}),this[k]}}e.$hh=M;function P(A,u,D){return w((f,R)=>{const k=`$debounce$${R}`,a=`$debounce$result$${R}`;return function(...v){this[a]||(this[a]=D?D():void 0),clearTimeout(this[k]),u&&(this[a]=u(this[a],...v),v=[this[a]]),this[k]=setTimeout(()=>{f.apply(this,v),this[a]=D?D():void 0},A)}})}e.$ih=P;function L(A,u,D){return w((f,R)=>{const k=`$throttle$timer$${R}`,a=`$throttle$result$${R}`,v=`$throttle$lastRun$${R}`,$=`$throttle$pending$${R}`;return function(...d){if(this[a]||(this[a]=D?D():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),u&&(this[a]=u(this[a],...d)),this[$])return;const t=this[v]+A;t<=Date.now()?(this[v]=Date.now(),f.apply(this,[this[a]]),this[a]=D?D():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[v]=Date.now(),f.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$jh=L}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0;class w{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$rM=w,e.$sM=new w("id#")}),define(Ae[115],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var M;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(n,r=!1){let s=0;const o=n.length;let g="",h=0,C=16,I=0;function c(B){let T=0,z=0;for(;T<B;){const ie=n.charCodeAt(s);if(ie>=48&&ie<=57)z=z*16+ie-48;else if(ie>=65&&ie<=70)z=z*16+ie-65+10;else if(ie>=97&&ie<=102)z=z*16+ie-97+10;else break;s++,T++}return T<B&&(z=-1),z}function y(B){s=B,g="",h=0,C=16,I=0}function b(){const B=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&f(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&f(n.charCodeAt(s)))for(s++;s<n.length&&f(n.charCodeAt(s));)s++;else return I=3,n.substring(B,s);let T=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&f(n.charCodeAt(s))){for(s++;s<n.length&&f(n.charCodeAt(s));)s++;T=s}else I=3;return n.substring(B,T)}function S(){let B="",T=s;for(;;){if(s>=o){B+=n.substring(T,s),I=2;break}const z=n.charCodeAt(s);if(z===34){B+=n.substring(T,s),s++;break}if(z===92){if(B+=n.substring(T,s),s++,s>=o){I=2;break}switch(n.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const X=c(4);X>=0?B+=String.fromCharCode(X):I=4;break}default:I=5}T=s;continue}if(z>=0&&z<=31)if(D(z)){B+=n.substring(T,s),I=2;break}else I=6;s++}return B}function j(){if(g="",I=0,h=s,s>=o)return h=o,C=17;let B=n.charCodeAt(s);if(u(B)){do s++,g+=String.fromCharCode(B),B=n.charCodeAt(s);while(u(B));return C=15}if(D(B))return s++,g+=String.fromCharCode(B),B===13&&n.charCodeAt(s)===10&&(s++,g+=`
`),C=14;switch(B){case 123:return s++,C=1;case 125:return s++,C=2;case 91:return s++,C=3;case 93:return s++,C=4;case 58:return s++,C=6;case 44:return s++,C=5;case 34:return s++,g=S(),C=10;case 47:{const T=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!D(n.charCodeAt(s));)s++;return g=n.substring(T,s),C=12}if(n.charCodeAt(s+1)===42){s+=2;const z=o-1;let ie=!1;for(;s<z;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,ie=!0;break}s++}return ie||(s++,I=1),g=n.substring(T,s),C=13}return g+=String.fromCharCode(B),s++,C=16}case 45:if(g+=String.fromCharCode(B),s++,s===o||!f(n.charCodeAt(s)))return C=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=b(),C=11;default:for(;s<o&&O(B);)s++,B=n.charCodeAt(s);if(h!==s){switch(g=n.substring(h,s),g){case"true":return C=8;case"false":return C=9;case"null":return C=7}return C=16}return g+=String.fromCharCode(B),s++,C=16}}function O(B){if(u(B)||D(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let B;do B=j();while(B>=12&&B<=15);return B}return{setPosition:y,getPosition:()=>s,scan:r?K:j,getToken:()=>C,getTokenValue:()=>g,getTokenOffset:()=>h,getTokenLength:()=>s-h,getTokenError:()=>I}}e.$Um=A;function u(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function k(n,r){const s=[],o=new Object;let g;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let C=!1;function I(c,y,b,S){h.value=c,h.offset=y,h.length=b,h.type=S,h.colonOffset=void 0,g=h}try{p(n,{onObjectBegin:(c,y)=>{if(r<=c)throw o;g=void 0,C=r>c,s.push("")},onObjectProperty:(c,y,b)=>{if(r<y||(I(c,y,b,"property"),s[s.length-1]=c,r<=y+b))throw o},onObjectEnd:(c,y)=>{if(r<=c)throw o;g=void 0,s.pop()},onArrayBegin:(c,y)=>{if(r<=c)throw o;g=void 0,s.push(0)},onArrayEnd:(c,y)=>{if(r<=c)throw o;g=void 0,s.pop()},onLiteralValue:(c,y,b)=>{if(r<y||(I(c,y,b,m(c)),r<=y+b))throw o},onSeparator:(c,y,b)=>{if(r<=y)throw o;if(c===":"&&g&&g.type==="property")g.colonOffset=y,C=!1,g=void 0;else if(c===","){const S=s[s.length-1];typeof S=="number"?s[s.length-1]=S+1:(C=!0,s[s.length-1]=""),g=void 0}}})}catch(c){if(c!==o)throw c}return{path:s,previousNode:g,isAtPropertyKey:C,matches:c=>{let y=0;for(let b=0;y<c.length&&b<s.length;b++)if(c[y]===s[b]||c[y]==="*")y++;else if(c[y]!=="**")return!1;return y===c.length}}}e.$Vm=k;function a(n,r=[],s=L.DEFAULT){let o=null,g=[];const h=[];function C(c){Array.isArray(g)?g.push(c):o!==null&&(g[o]=c)}return p(n,{onObjectBegin:()=>{const c={};C(c),h.push(g),g=c,o=null},onObjectProperty:c=>{o=c},onObjectEnd:()=>{g=h.pop()},onArrayBegin:()=>{const c=[];C(c),h.push(g),g=c,o=null},onArrayEnd:()=>{g=h.pop()},onLiteralValue:C,onError:(c,y,b)=>{r.push({error:c,offset:y,length:b})}},s),g[0]}e.$Wm=a;function v(n,r=[],s=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(c){o.type==="property"&&(o.length=c-o.offset,o=o.parent)}function h(c){return o.children.push(c),c}p(n,{onObjectBegin:c=>{o=h({type:"object",offset:c,length:-1,parent:o,children:[]})},onObjectProperty:(c,y,b)=>{o=h({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:c,offset:y,length:b,parent:o})},onObjectEnd:(c,y)=>{o.length=c+y-o.offset,o=o.parent,g(c+y)},onArrayBegin:(c,y)=>{o=h({type:"array",offset:c,length:-1,parent:o,children:[]})},onArrayEnd:(c,y)=>{o.length=c+y-o.offset,o=o.parent,g(c+y)},onLiteralValue:(c,y,b)=>{h({type:m(c),offset:y,length:b,parent:o,value:c}),g(y+b)},onSeparator:(c,y,b)=>{o.type==="property"&&(c===":"?o.colonOffset=y:c===","&&g(y))},onError:(c,y,b)=>{r.push({error:c,offset:y,length:b})}},s);const I=o.children[0];return I&&delete I.parent,I}e.$Xm=v;function $(n,r){if(!n)return;let s=n;for(const o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let g=!1;for(const h of s.children)if(Array.isArray(h.children)&&h.children[0].value===o){s=h.children[1],g=!0;break}if(!g)return}else{const g=o;if(s.type!=="array"||g<0||!Array.isArray(s.children)||g>=s.children.length)return;s=s.children[g]}return s}e.$Ym=$;function d(n){if(!n.parent||!n.parent.children)return[];const r=d(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;r.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&r.push(s)}return r}e.$Zm=d;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const r=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(r[s.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$1m=t;function i(n,r,s=!1){return r>=n.offset&&r<n.offset+n.length||s&&r===n.offset+n.length}e.$2m=i;function l(n,r,s=!1){if(i(n,r,s)){const o=n.children;if(Array.isArray(o))for(let g=0;g<o.length&&o[g].offset<=r;g++){const h=l(o[g],r,s);if(h)return h}return n}}e.$3m=l;function p(n,r,s=L.DEFAULT){const o=A(n,!1);function g(ue){return ue?()=>ue(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(ue){return ue?ae=>ue(ae,o.getTokenOffset(),o.getTokenLength()):()=>!0}const C=g(r.onObjectBegin),I=h(r.onObjectProperty),c=g(r.onObjectEnd),y=g(r.onArrayBegin),b=g(r.onArrayEnd),S=h(r.onLiteralValue),j=h(r.onSeparator),O=g(r.onComment),K=h(r.onError),B=s&&s.disallowComments,T=s&&s.allowTrailingComma;function z(){for(;;){const ue=o.scan();switch(o.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:B||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(ue){case 12:case 13:B?ie(10):O();break;case 16:ie(1);break;case 15:case 14:break;default:return ue}}}function ie(ue,ae=[],we=[]){if(K(ue),ae.length+we.length>0){let _=o.getToken();for(;_!==17;){if(ae.indexOf(_)!==-1){z();break}else if(we.indexOf(_)!==-1)break;_=z()}}}function X(ue){const ae=o.getTokenValue();return ue?S(ae):I(ae),z(),!0}function De(){switch(o.getToken()){case 11:{let ue=0;try{ue=JSON.parse(o.getTokenValue()),typeof ue!="number"&&(ie(2),ue=0)}catch{ie(2)}S(ue);break}case 7:S(null);break;case 8:S(!0);break;case 9:S(!1);break;default:return!1}return z(),!0}function Pe(){return o.getToken()!==10?(ie(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(j(":"),z(),ye()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function ke(){C(),z();let ue=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ue||ie(4,[],[]),j(","),z(),o.getToken()===2&&T)break}else ue&&ie(6,[],[]);Pe()||ie(4,[],[2,5]),ue=!0}return c(),o.getToken()!==2?ie(7,[2],[]):z(),!0}function $e(){y(),z();let ue=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ue||ie(4,[],[]),j(","),z(),o.getToken()===4&&T)break}else ue&&ie(6,[],[]);ye()||ie(4,[],[4,5]),ue=!0}return b(),o.getToken()!==4?ie(8,[4],[]):z(),!0}function ye(){switch(o.getToken()){case 3:return $e();case 1:return ke();case 10:return X(!0);default:return De()}}return z(),o.getToken()===17?s.allowEmptyContent?!0:(ie(4,[],[]),!1):ye()?(o.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$4m=p;function E(n,r){const s=A(n),o=[];let g,h=0,C;do switch(C=s.getPosition(),g=s.scan(),g){case 12:case 13:case 17:h!==C&&o.push(n.substring(h,C)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),h=s.getPosition();break}while(g!==17);return o.join("")}e.$5m=E;function m(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$6m=m}),function(be,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(me,he){for(var Ee=0;Ee<he.length;Ee++){var re=he[Ee];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(me,re.key,re)}}function w(me,he,Ee){return he&&e(me.prototype,he),Ee&&e(me,Ee),Object.defineProperty(me,"prototype",{writable:!1}),me}function M(me,he){if(me){if(typeof me=="string")return P(me,he);var Ee=Object.prototype.toString.call(me).slice(8,-1);if(Ee==="Object"&&me.constructor&&(Ee=me.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(me);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return P(me,he)}}function P(me,he){(he==null||he>me.length)&&(he=me.length);for(var Ee=0,re=new Array(he);Ee<he;Ee++)re[Ee]=me[Ee];return re}function L(me,he){var Ee=typeof Symbol<"u"&&me[Symbol.iterator]||me["@@iterator"];if(Ee)return(Ee=Ee.call(me)).next.bind(Ee);if(Array.isArray(me)||(Ee=M(me))||he&&me&&typeof me.length=="number"){Ee&&(me=Ee);var re=0;return function(){return re>=me.length?{done:!0}:{done:!1,value:me[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function u(me){be.defaults=me}var D=/[&<>"']/,f=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(he){return a[he]};function $(me,he){if(he){if(D.test(me))return me.replace(f,v)}else if(R.test(me))return me.replace(k,v);return me}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(me){return me.replace(d,function(he,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var i=/(^|[^\[])\^/g;function l(me,he){me=typeof me=="string"?me:me.source,he=he||"";var Ee={replace:function(le,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),me=me.replace(le,ne),Ee},getRegex:function(){return new RegExp(me,he)}};return Ee}var p=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(me,he,Ee){if(me){var re;try{re=decodeURIComponent(t(Ee)).replace(p,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}he&&!E.test(Ee)&&(Ee=g(he,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var n={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(me,he){n[" "+me]||(r.test(me)?n[" "+me]=me+"/":n[" "+me]=c(me,"/",!0)),me=n[" "+me];var Ee=me.indexOf(":")===-1;return he.substring(0,2)==="//"?Ee?he:me.replace(s,"$1")+he:he.charAt(0)==="/"?Ee?he:me.replace(o,"$1")+he:me+he}var h={exec:function(){}};function C(me){for(var he=1,Ee,re;he<arguments.length;he++){Ee=arguments[he];for(re in Ee)Object.prototype.hasOwnProperty.call(Ee,re)&&(me[re]=Ee[re])}return me}function I(me,he){var Ee=me.replace(/\|/g,function(ne,oe,fe){for(var Ce=!1,F=oe;--F>=0&&fe[F]==="\\";)Ce=!Ce;return Ce?"|":" |"}),re=Ee.split(/ \|/),le=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>he)re.splice(he);else for(;re.length<he;)re.push("");for(;le<re.length;le++)re[le]=re[le].trim().replace(/\\\|/g,"|");return re}function c(me,he,Ee){var re=me.length;if(re===0)return"";for(var le=0;le<re;){var ne=me.charAt(re-le-1);if(ne===he&&!Ee)le++;else if(ne!==he&&Ee)le++;else break}return me.slice(0,re-le)}function y(me,he){if(me.indexOf(he[1])===-1)return-1;for(var Ee=me.length,re=0,le=0;le<Ee;le++)if(me[le]==="\\")le++;else if(me[le]===he[0])re++;else if(me[le]===he[1]&&(re--,re<0))return le;return-1}function b(me){me&&me.sanitize&&!me.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function S(me,he){if(he<1)return"";for(var Ee="";he>1;)he&1&&(Ee+=me),he>>=1,me+=me;return Ee+me}function j(me,he,Ee,re){var le=he.href,ne=he.title?$(he.title):null,oe=me[1].replace(/\\([\[\]])/g,"$1");if(me[0].charAt(0)!=="!"){re.state.inLink=!0;var fe={type:"link",raw:Ee,href:le,title:ne,text:oe,tokens:re.inlineTokens(oe)};return re.state.inLink=!1,fe}return{type:"image",raw:Ee,href:le,title:ne,text:$(oe)}}function O(me,he){var Ee=me.match(/^(\s+)(?:```)/);if(Ee===null)return he;var re=Ee[1];return he.split(`
`).map(function(le){var ne=le.match(/^\s+/);if(ne===null)return le;var oe=ne[0];return oe.length>=re.length?le.slice(re.length):le}).join(`
`)}var K=function(){function me(Ee){this.options=Ee||be.defaults}var he=me.prototype;return he.space=function(re){var le=this.rules.block.newline.exec(re);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},he.code=function(re){var le=this.rules.block.code.exec(re);if(le){var ne=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:c(ne,`
`)}}},he.fences=function(re){var le=this.rules.block.fences.exec(re);if(le){var ne=le[0],oe=O(ne,le[3]||"");return{type:"code",raw:ne,lang:le[2]?le[2].trim():le[2],text:oe}}},he.heading=function(re){var le=this.rules.block.heading.exec(re);if(le){var ne=le[2].trim();if(/#$/.test(ne)){var oe=c(ne,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(ne=oe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:ne,tokens:this.lexer.inline(ne)}}},he.hr=function(re){var le=this.rules.block.hr.exec(re);if(le)return{type:"hr",raw:le[0]}},he.blockquote=function(re){var le=this.rules.block.blockquote.exec(re);if(le){var ne=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},he.list=function(re){var le=this.rules.block.list.exec(re);if(le){var ne,oe,fe,Ce,F,V,G,J,q,x,ce,Ne,je=le[1].trim(),Qe=je.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(Ne=!1,!(!(le=_e.exec(re))||this.rules.block.hr.test(re)));){if(ne=le[0],re=re.substring(ne.length),J=le[2].split(`
`,1)[0],q=re.split(`
`,1)[0],this.options.pedantic?(Ce=2,ce=J.trimLeft()):(Ce=le[2].search(/[^ ]/),Ce=Ce>4?1:Ce,ce=J.slice(Ce),Ce+=le[1].length),V=!1,!J&&/^ *$/.test(q)&&(ne+=q+`
`,re=re.substring(q.length+1),Ne=!0),!Ne)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");re&&(x=re.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(J)||tt.test(J)||Ze.test(J)||xe.test(re)));){if(J.search(/[^ ]/)>=Ce||!J.trim())ce+=`
`+J.slice(Ce);else if(!V)ce+=`
`+J;else break;!V&&!J.trim()&&(V=!0),ne+=x+`
`,re=re.substring(x.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ne)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ce),oe&&(fe=oe[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ne,task:!!oe,checked:fe,loose:!1,text:ce}),Ge.raw+=ne}Ge.items[Ge.items.length-1].raw=ne.trimRight(),Ge.items[Ge.items.length-1].text=ce.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(F=0;F<ze;F++){this.lexer.state.top=!1,Ge.items[F].tokens=this.lexer.blockTokens(Ge.items[F].text,[]);var ut=Ge.items[F].tokens.filter(function(Q){return Q.type==="space"}),Y=ut.every(function(Q){for(var ve=Q.raw.split(""),Be=0,Oe=L(ve),Xe;!(Xe=Oe()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&ut.length&&Y&&(Ge.loose=!0,Ge.items[F].loose=!0)}return Ge}},he.html=function(re){var le=this.rules.block.html.exec(re);if(le){var ne={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]);ne.type="paragraph",ne.text=oe,ne.tokens=this.lexer.inline(oe)}return ne}},he.def=function(re){var le=this.rules.block.def.exec(re);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ne=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:le[0],href:le[2],title:le[3]}}},he.table=function(re){var le=this.rules.block.table.exec(re);if(le){var ne={type:"table",header:I(le[1]).map(function(G){return{text:G}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=le[0];var oe=ne.align.length,fe,Ce,F,V;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(ne.align[fe])?ne.align[fe]="right":/^ *:-+: *$/.test(ne.align[fe])?ne.align[fe]="center":/^ *:-+ *$/.test(ne.align[fe])?ne.align[fe]="left":ne.align[fe]=null;for(oe=ne.rows.length,fe=0;fe<oe;fe++)ne.rows[fe]=I(ne.rows[fe],ne.header.length).map(function(G){return{text:G}});for(oe=ne.header.length,Ce=0;Ce<oe;Ce++)ne.header[Ce].tokens=this.lexer.inline(ne.header[Ce].text);for(oe=ne.rows.length,Ce=0;Ce<oe;Ce++)for(V=ne.rows[Ce],F=0;F<V.length;F++)V[F].tokens=this.lexer.inline(V[F].text);return ne}}},he.lheading=function(re){var le=this.rules.block.lheading.exec(re);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},he.paragraph=function(re){var le=this.rules.block.paragraph.exec(re);if(le){var ne=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:ne,tokens:this.lexer.inline(ne)}}},he.text=function(re){var le=this.rules.block.text.exec(re);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},he.escape=function(re){var le=this.rules.inline.escape.exec(re);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},he.tag=function(re){var le=this.rules.inline.tag.exec(re);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},he.link=function(re){var le=this.rules.inline.link.exec(re);if(le){var ne=le[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var oe=c(ne.slice(0,-1),"\\");if((ne.length-oe.length)%2===0)return}else{var fe=y(le[2],"()");if(fe>-1){var Ce=le[0].indexOf("!")===0?5:4,F=Ce+le[1].length+fe;le[2]=le[2].substring(0,fe),le[0]=le[0].substring(0,F).trim(),le[3]=""}}var V=le[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);J&&(V=J[1],G=J[3])}else G=le[3]?le[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ne)?V=V.slice(1):V=V.slice(1,-1)),j(le,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},he.reflink=function(re,le){var ne;if((ne=this.rules.inline.reflink.exec(re))||(ne=this.rules.inline.nolink.exec(re))){var oe=(ne[2]||ne[1]).replace(/\s+/g," ");if(oe=le[oe.toLowerCase()],!oe||!oe.href){var fe=ne[0].charAt(0);return{type:"text",raw:fe,text:fe}}return j(ne,oe,ne[0],this.lexer)}},he.emStrong=function(re,le,ne){ne===void 0&&(ne="");var oe=this.rules.inline.emStrong.lDelim.exec(re);if(oe&&!(oe[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Ce=oe[0].length-1,F,V,G=Ce,J=0,q=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,le=le.slice(-1*re.length+Ce);(oe=q.exec(le))!=null;)if(F=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!F){if(V=F.length,oe[3]||oe[4]){G+=V;continue}else if((oe[5]||oe[6])&&Ce%3&&!((Ce+V)%3)){J+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+J),Math.min(Ce,V)%2){var x=re.slice(1,Ce+oe.index+V);return{type:"em",raw:re.slice(0,Ce+oe.index+V+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ce=re.slice(2,Ce+oe.index+V-1);return{type:"strong",raw:re.slice(0,Ce+oe.index+V+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},he.codespan=function(re){var le=this.rules.inline.code.exec(re);if(le){var ne=le[2].replace(/\n/g," "),oe=/[^ ]/.test(ne),fe=/^ /.test(ne)&&/ $/.test(ne);return oe&&fe&&(ne=ne.substring(1,ne.length-1)),ne=$(ne,!0),{type:"codespan",raw:le[0],text:ne}}},he.br=function(re){var le=this.rules.inline.br.exec(re);if(le)return{type:"br",raw:le[0]}},he.del=function(re){var le=this.rules.inline.del.exec(re);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},he.autolink=function(re,le){var ne=this.rules.inline.autolink.exec(re);if(ne){var oe,fe;return ne[2]==="@"?(oe=$(this.options.mangle?le(ne[1]):ne[1]),fe="mailto:"+oe):(oe=$(ne[1]),fe=oe),{type:"link",raw:ne[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},he.url=function(re,le){var ne;if(ne=this.rules.inline.url.exec(re)){var oe,fe;if(ne[2]==="@")oe=$(this.options.mangle?le(ne[0]):ne[0]),fe="mailto:"+oe;else{var Ce;do Ce=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Ce!==ne[0]);oe=$(ne[0]),ne[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:ne[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},he.inlineText=function(re,le){var ne=this.rules.inline.text.exec(re);if(ne){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):$(ne[0]):ne[0]:oe=$(this.options.smartypants?le(ne[0]):ne[0]),{type:"text",raw:ne[0],text:oe}}},me}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=l(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=l(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=l(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=l(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=l(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=l(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=C({},B),B.gfm=C({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=l(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=l(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=C({},B.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:l(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=l(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=l(B._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=l(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=l(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=l(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=l(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=l(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=l(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=l(T.reflink).replace("label",T._label).replace("ref",B._label).getRegex(),T.nolink=l(T.nolink).replace("ref",B._label).getRegex(),T.reflinkSearch=l(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=C({},T),T.pedantic=C({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=C({},T.normal,{escape:l(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=l(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=C({},T.gfm,{br:l(T.br).replace("{2,}","*").getRegex(),text:l(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(me){return me.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ie(me){var he="",Ee,re,le=me.length;for(Ee=0;Ee<le;Ee++)re=me.charCodeAt(Ee),Math.random()>.5&&(re="x"+re.toString(16)),he+="&#"+re+";";return he}var X=function(){function me(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||be.defaults,this.options.tokenizer=this.options.tokenizer||new K,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:B.normal,inline:T.normal};this.options.pedantic?(re.block=B.pedantic,re.inline=T.pedantic):this.options.gfm&&(re.block=B.gfm,this.options.breaks?re.inline=T.breaks:re.inline=T.gfm),this.tokenizer.rules=re}me.lex=function(re,le){var ne=new me(le);return ne.lex(re)},me.lexInline=function(re,le){var ne=new me(le);return ne.inlineTokens(re)};var he=me.prototype;return he.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},he.blockTokens=function(re,le){var ne=this;le===void 0&&(le=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var oe,fe,Ce,F;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:ne},re,le))?(re=re.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.space(re)){re=re.substring(oe.raw.length),oe.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(oe);continue}if(oe=this.tokenizer.code(re)){re=re.substring(oe.raw.length),fe=le[le.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(oe);continue}if(oe=this.tokenizer.fences(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.heading(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.hr(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.blockquote(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.list(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.html(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.def(re)){re=re.substring(oe.raw.length),fe=le[le.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.lheading(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(Ce=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=re.slice(1),q=void 0;ne.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ce=re.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ce))){fe=le[le.length-1],F&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(oe),F=Ce.length!==re.length,re=re.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(re)){re=re.substring(oe.raw.length),fe=le[le.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):le.push(oe);continue}if(re){var V="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,le},he.inline=function(re,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:re,tokens:le}),le},he.inlineTokens=function(re,le){var ne=this;le===void 0&&(le=[]);var oe,fe,Ce,F=re,V,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,V.index)+"["+S("a",V[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,V.index)+"["+S("a",V[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,V.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(oe=ce.call({lexer:ne},re,le))?(re=re.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.tag(re)){re=re.substring(oe.raw.length),fe=le[le.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.link(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(oe.raw.length),fe=le[le.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.emStrong(re,F,J)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.codespan(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.br(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.del(re)){re=re.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.autolink(re,ie)){re=re.substring(oe.raw.length),le.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(re,ie))){re=re.substring(oe.raw.length),le.push(oe);continue}if(Ce=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,Ne=re.slice(1),je=void 0;ne.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Ne),typeof je=="number"&&je>=0&&(ce=Math.min(ce,je))}),ce<1/0&&ce>=0&&(Ce=re.substring(0,ce+1))}(),oe=this.tokenizer.inlineText(Ce,z)){re=re.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(J=oe.raw.slice(-1)),G=!0,fe=le[le.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):le.push(oe);continue}if(re){var x="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return le},w(me,null,[{key:"rules",get:function(){return{block:B,inline:T}}}]),me}(),De=function(){function me(Ee){this.options=Ee||be.defaults}var he=me.prototype;return he.code=function(re,le,ne){var oe=(le||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(re,oe);fe!=null&&fe!==re&&(ne=!0,re=fe)}return re=re.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(ne?re:$(re,!0))+`</code></pre>
`:"<pre><code>"+(ne?re:$(re,!0))+`</code></pre>
`},he.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},he.html=function(re){return re},he.heading=function(re,le,ne,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(ne);return"<h"+le+' id="'+fe+'">'+re+"</h"+le+`>
`}return"<h"+le+">"+re+"</h"+le+`>
`},he.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},he.list=function(re,le,ne){var oe=le?"ol":"ul",fe=le&&ne!==1?' start="'+ne+'"':"";return"<"+oe+fe+`>
`+re+"</"+oe+`>
`},he.listitem=function(re){return"<li>"+re+`</li>
`},he.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},he.paragraph=function(re){return"<p>"+re+`</p>
`},he.table=function(re,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+le+`</table>
`},he.tablerow=function(re){return`<tr>
`+re+`</tr>
`},he.tablecell=function(re,le){var ne=le.header?"th":"td",oe=le.align?"<"+ne+' align="'+le.align+'">':"<"+ne+">";return oe+re+("</"+ne+`>
`)},he.strong=function(re){return"<strong>"+re+"</strong>"},he.em=function(re){return"<em>"+re+"</em>"},he.codespan=function(re){return"<code>"+re+"</code>"},he.br=function(){return this.options.xhtml?"<br/>":"<br>"},he.del=function(re){return"<del>"+re+"</del>"},he.link=function(re,le,ne){if(re=m(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var oe='<a href="'+$(re)+'"';return le&&(oe+=' title="'+le+'"'),oe+=">"+ne+"</a>",oe},he.image=function(re,le,ne){if(re=m(this.options.sanitize,this.options.baseUrl,re),re===null)return ne;var oe='<img src="'+re+'" alt="'+ne+'"';return le&&(oe+=' title="'+le+'"'),oe+=this.options.xhtml?"/>":">",oe},he.text=function(re){return re},me}(),Pe=function(){function me(){}var he=me.prototype;return he.strong=function(re){return re},he.em=function(re){return re},he.codespan=function(re){return re},he.del=function(re){return re},he.html=function(re){return re},he.text=function(re){return re},he.link=function(re,le,ne){return""+ne},he.image=function(re,le,ne){return""+ne},he.br=function(){return""},me}(),ke=function(){function me(){this.seen={}}var he=me.prototype;return he.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},he.getNextSafeSlug=function(re,le){var ne=re,oe=0;if(this.seen.hasOwnProperty(ne)){oe=this.seen[re];do oe++,ne=re+"-"+oe;while(this.seen.hasOwnProperty(ne))}return le||(this.seen[re]=oe,this.seen[ne]=0),ne},he.slug=function(re,le){le===void 0&&(le={});var ne=this.serialize(re);return this.getNextSafeSlug(ne,le.dryrun)},me}(),$e=function(){function me(Ee){this.options=Ee||be.defaults,this.options.renderer=this.options.renderer||new De,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Pe,this.slugger=new ke}me.parse=function(re,le){var ne=new me(le);return ne.parse(re)},me.parseInline=function(re,le){var ne=new me(le);return ne.parseInline(re)};var he=me.prototype;return he.parse=function(re,le){le===void 0&&(le=!0);var ne="",oe,fe,Ce,F,V,G,J,q,x,ce,Ne,je,Qe,Ge,_e,Ze,xe,it,tt,ze=re.length;for(oe=0;oe<ze;oe++){if(ce=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){ne+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(q="",J="",F=ce.header.length,fe=0;fe<F;fe++)J+=this.renderer.tablecell(this.parseInline(ce.header[fe].tokens),{header:!0,align:ce.align[fe]});for(q+=this.renderer.tablerow(J),x="",F=ce.rows.length,fe=0;fe<F;fe++){for(G=ce.rows[fe],J="",V=G.length,Ce=0;Ce<V;Ce++)J+=this.renderer.tablecell(this.parseInline(G[Ce].tokens),{header:!1,align:ce.align[Ce]});x+=this.renderer.tablerow(J)}ne+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ce.tokens),ne+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ce.ordered,je=ce.start,Qe=ce.loose,F=ce.items.length,x="",fe=0;fe<F;fe++)_e=ce.items[fe],Ze=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Ze),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Qe),x+=this.renderer.listitem(Ge,xe,Ze);ne+=this.renderer.list(x,Ne,je);continue}case"html":{ne+=this.renderer.html(ce.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(x=ce.tokens?this.parseInline(ce.tokens):ce.text;oe+1<ze&&re[oe+1].type==="text";)ce=re[++oe],x+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);ne+=le?this.renderer.paragraph(x):x;continue}default:{var ut='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}}return ne},he.parseInline=function(re,le){le=le||this.renderer;var ne="",oe,fe,Ce,F=re.length;for(oe=0;oe<F;oe++){if(fe=re[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ce=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){ne+=Ce||"";continue}switch(fe.type){case"escape":{ne+=le.text(fe.text);break}case"html":{ne+=le.html(fe.text);break}case"link":{ne+=le.link(fe.href,fe.title,this.parseInline(fe.tokens,le));break}case"image":{ne+=le.image(fe.href,fe.title,fe.text);break}case"strong":{ne+=le.strong(this.parseInline(fe.tokens,le));break}case"em":{ne+=le.em(this.parseInline(fe.tokens,le));break}case"codespan":{ne+=le.codespan(fe.text);break}case"br":{ne+=le.br();break}case"del":{ne+=le.del(this.parseInline(fe.tokens,le));break}case"text":{ne+=le.text(fe.text);break}default:{var V='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ne},me}();function ye(me,he,Ee){if(typeof me>"u"||me===null)throw new Error("marked(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");if(typeof he=="function"&&(Ee=he,he=null),he=C({},ye.defaults,he||{}),b(he),Ee){var re=he.highlight,le;try{le=X.lex(me,he)}catch(F){return Ee(F)}var ne=function(V){var G;if(!V)try{he.walkTokens&&ye.walkTokens(le,he.walkTokens),G=$e.parse(le,he)}catch(J){V=J}return he.highlight=re,V?Ee(V):Ee(null,G)};if(!re||re.length<3||(delete he.highlight,!le.length))return ne();var oe=0;ye.walkTokens(le,function(F){F.type==="code"&&(oe++,setTimeout(function(){re(F.text,F.lang,function(V,G){if(V)return ne(V);G!=null&&G!==F.text&&(F.text=G,F.escaped=!0),oe--,oe===0&&ne()})},0))}),oe===0&&ne();return}function fe(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+$(F.message+"",!0)+"</pre>";throw F}try{var Ce=X.lex(me,he);if(he.walkTokens){if(he.async)return Promise.all(ye.walkTokens(Ce,he.walkTokens)).then(function(){return $e.parse(Ce,he)}).catch(fe);ye.walkTokens(Ce,he.walkTokens)}return $e.parse(Ce,he)}catch(F){fe(F)}}ye.options=ye.setOptions=function(me){return C(ye.defaults,me),u(ye.defaults),ye},ye.getDefaults=A,ye.defaults=be.defaults,ye.use=function(){for(var me=arguments.length,he=new Array(me),Ee=0;Ee<me;Ee++)he[Ee]=arguments[Ee];var re=C.apply(void 0,[{}].concat(he)),le=ye.defaults.extensions||{renderers:{},childTokens:{}},ne;he.forEach(function(oe){if(oe.extensions&&(ne=!0,oe.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var F=le.renderers?le.renderers[Ce.name]:null;F?le.renderers[Ce.name]=function(){for(var V=arguments.length,G=new Array(V),J=0;J<V;J++)G[J]=arguments[J];var q=Ce.renderer.apply(this,G);return q===!1&&(q=F.apply(this,G)),q}:le.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ce.level]?le[Ce.level].unshift(Ce.tokenizer):le[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?le.startBlock?le.startBlock.push(Ce.start):le.startBlock=[Ce.start]:Ce.level==="inline"&&(le.startInline?le.startInline.push(Ce.start):le.startInline=[Ce.start]))}Ce.childTokens&&(le.childTokens[Ce.name]=Ce.childTokens)})),oe.renderer&&function(){var Ce=ye.defaults.renderer||new De,F=function(J){var q=Ce[J];Ce[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var je=oe.renderer[J].apply(Ce,ce);return je===!1&&(je=q.apply(Ce,ce)),je}};for(var V in oe.renderer)F(V);re.renderer=Ce}(),oe.tokenizer&&function(){var Ce=ye.defaults.tokenizer||new K,F=function(J){var q=Ce[J];Ce[J]=function(){for(var x=arguments.length,ce=new Array(x),Ne=0;Ne<x;Ne++)ce[Ne]=arguments[Ne];var je=oe.tokenizer[J].apply(Ce,ce);return je===!1&&(je=q.apply(Ce,ce)),je}};for(var V in oe.tokenizer)F(V);re.tokenizer=Ce}(),oe.walkTokens){var fe=ye.defaults.walkTokens;re.walkTokens=function(Ce){var F=[];return F.push(oe.walkTokens.call(this,Ce)),fe&&(F=F.concat(fe.call(this,Ce))),F}}ne&&(re.extensions=le),ye.setOptions(re)})},ye.walkTokens=function(me,he){for(var Ee=[],re=function(){var fe=ne.value;switch(Ee=Ee.concat(he.call(ye,fe)),fe.type){case"table":{for(var Ce=L(fe.header),F;!(F=Ce()).done;){var V=F.value;Ee=Ee.concat(ye.walkTokens(V.tokens,he))}for(var G=L(fe.rows),J;!(J=G()).done;)for(var q=J.value,x=L(q),ce;!(ce=x()).done;){var Ne=ce.value;Ee=Ee.concat(ye.walkTokens(Ne.tokens,he))}break}case"list":{Ee=Ee.concat(ye.walkTokens(fe.items,he));break}default:ye.defaults.extensions&&ye.defaults.extensions.childTokens&&ye.defaults.extensions.childTokens[fe.type]?ye.defaults.extensions.childTokens[fe.type].forEach(function(je){Ee=Ee.concat(ye.walkTokens(fe[je],he))}):fe.tokens&&(Ee=Ee.concat(ye.walkTokens(fe.tokens,he)))}},le=L(me),ne;!(ne=le()).done;)re();return Ee},ye.parseInline=function(me,he){if(typeof me>"u"||me===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");he=C({},ye.defaults,he||{}),b(he);try{var Ee=X.lexInline(me,he);return he.walkTokens&&ye.walkTokens(Ee,he.walkTokens),$e.parseInline(Ee,he)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+$(re.message+"",!0)+"</pre>";throw re}},ye.Parser=$e,ye.parser=$e.parse,ye.Renderer=De,ye.TextRenderer=Pe,ye.Lexer=X,ye.lexer=X.lex,ye.Tokenizer=K,ye.Slugger=ke,ye.parse=ye;var ue=ye.options,ae=ye.setOptions,we=ye.use,_=ye.walkTokens,W=ye.parseInline,Z=ye,ee=$e.parse,pe=X.lex;be.Lexer=X,be.Parser=$e,be.Renderer=De,be.Slugger=ke,be.TextRenderer=Pe,be.Tokenizer=K,be.getDefaults=A,be.lexer=pe,be.marked=ye,be.options=ue,be.parse=Z,be.parseInline=W,be.parser=ee,be.setOptions=ae,be.use=we,be.walkTokens=_,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.rot=e.$Ol=void 0;function w(u,D,f){return Math.min(Math.max(u,D),f)}e.$Ol=w;function M(u,D){return(D+u%D)%D}e.rot=M;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Ql=P;class L{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Rl=L;class A{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const f=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Sl=A}),function(){function be(P){const L=[];typeof P=="number"&&L.push("code/timeOrigin",P);function A(D){L.push(D,Date.now())}function u(){const D=[];for(let f=0;f<L.length;f+=2)D.push({name:L[f],startTime:L[f+1]});return D}return{mark:A,getMarks:u}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(P+A.startTime)});return L}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=w(M))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var M in w)(typeof exports=="object"?exports:be)[M]=w[M]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(M){if(e[M])return e[M].exports;var P=e[M]={i:M,l:!1,exports:{}};return be[M].call(P.exports,P,P.exports,w),P.l=!0,P.exports}return w.m=be,w.c=e,w.d=function(M,P,L){w.o(M,P)||Object.defineProperty(M,P,{enumerable:!0,get:L})},w.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},w.t=function(M,P){if(1&P&&(M=w(M)),8&P||4&P&&typeof M=="object"&&M&&M.__esModule)return M;var L=Object.create(null);if(w.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:M}),2&P&&typeof M!="string")for(var A in M)w.d(L,A,function(u){return M[u]}.bind(null,A));return L},w.n=function(M){var P=M&&M.__esModule?function(){return M.default}:function(){return M};return w.d(P,"a",P),P},w.o=function(M,P){return Object.prototype.hasOwnProperty.call(M,P)},w.p="",w(w.s=0)}([function(be,e,w){(function(M){var P;e=be.exports=we,P=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,u=e.re=[],D=e.src=[],f=0,R=f++;D[R]="0|[1-9]\\d*";var k=f++;D[k]="[0-9]+";var a=f++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=f++;D[v]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var $=f++;D[$]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var d=f++;D[d]="(?:"+D[R]+"|"+D[a]+")";var t=f++;D[t]="(?:"+D[k]+"|"+D[a]+")";var i=f++;D[i]="(?:-("+D[d]+"(?:\\."+D[d]+")*))";var l=f++;D[l]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var p=f++;D[p]="[0-9A-Za-z-]+";var E=f++;D[E]="(?:\\+("+D[p]+"(?:\\."+D[p]+")*))";var m=f++,n="v?"+D[v]+D[i]+"?"+D[E]+"?";D[m]="^"+n+"$";var r="[v=\\s]*"+D[$]+D[l]+"?"+D[E]+"?",s=f++;D[s]="^"+r+"$";var o=f++;D[o]="((?:<|>)?=?)";var g=f++;D[g]=D[k]+"|x|X|\\*";var h=f++;D[h]=D[R]+"|x|X|\\*";var C=f++;D[C]="[v=\\s]*("+D[h]+")(?:\\.("+D[h]+")(?:\\.("+D[h]+")(?:"+D[i]+")?"+D[E]+"?)?)?";var I=f++;D[I]="[v=\\s]*("+D[g]+")(?:\\.("+D[g]+")(?:\\.("+D[g]+")(?:"+D[l]+")?"+D[E]+"?)?)?";var c=f++;D[c]="^"+D[o]+"\\s*"+D[C]+"$";var y=f++;D[y]="^"+D[o]+"\\s*"+D[I]+"$";var b=f++;D[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var S=f++;D[S]="(?:~>?)";var j=f++;D[j]="(\\s*)"+D[S]+"\\s+",u[j]=new RegExp(D[j],"g");var O=f++;D[O]="^"+D[S]+D[C]+"$";var K=f++;D[K]="^"+D[S]+D[I]+"$";var B=f++;D[B]="(?:\\^)";var T=f++;D[T]="(\\s*)"+D[B]+"\\s+",u[T]=new RegExp(D[T],"g");var z=f++;D[z]="^"+D[B]+D[C]+"$";var ie=f++;D[ie]="^"+D[B]+D[I]+"$";var X=f++;D[X]="^"+D[o]+"\\s*("+r+")$|^$";var De=f++;D[De]="^"+D[o]+"\\s*("+n+")$|^$";var Pe=f++;D[Pe]="(\\s*)"+D[o]+"\\s*("+r+"|"+D[C]+")",u[Pe]=new RegExp(D[Pe],"g");var ke=f++;D[ke]="^\\s*("+D[C]+")\\s+-\\s+("+D[C]+")\\s*$";var $e=f++;D[$e]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var ye=f++;D[ye]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)P(ue,D[ue]),u[ue]||(u[ue]=new RegExp(D[ue]));function ae(q,x){if(q instanceof we)return q;if(typeof q!="string"||q.length>L||!(x?u[s]:u[m]).test(q))return null;try{return new we(q,x)}catch{return null}}function we(q,x){if(q instanceof we){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof we))return new we(q,x);P("SemVer",q,x),this.loose=x;var ce=q.trim().match(x?u[s]:u[m]);if(!ce)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var je=+Ne;if(je>=0&&je<A)return je}return Ne}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ae,e.valid=function(q,x){var ce=ae(q,x);return ce?ce.version:null},e.clean=function(q,x){var ce=ae(q.trim().replace(/^[=v]+/,""),x);return ce?ce.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof we||(q=new we(q,this.loose)),this.compareMain(q)||this.comparePre(q)},we.prototype.compareMain=function(q){return q instanceof we||(q=new we(q,this.loose)),W(this.major,q.major)||W(this.minor,q.minor)||W(this.patch,q.patch)},we.prototype.comparePre=function(q){if(q instanceof we||(q=new we(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ce=this.prerelease[x],Ne=q.prerelease[x];if(P("prerelease compare",x,ce,Ne),ce===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ce===void 0)return-1;if(ce!==Ne)return W(ce,Ne)}while(++x)},we.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ce,Ne){typeof ce=="string"&&(Ne=ce,ce=void 0);try{return new we(q,ce).inc(x,Ne).version}catch{return null}},e.diff=function(q,x){if(me(q,x))return null;var ce=ae(q),Ne=ae(x);if(ce.prerelease.length||Ne.prerelease.length){for(var je in ce)if((je==="major"||je==="minor"||je==="patch")&&ce[je]!==Ne[je])return"pre"+je;return"prerelease"}for(var je in ce)if((je==="major"||je==="minor"||je==="patch")&&ce[je]!==Ne[je])return je},e.compareIdentifiers=W;var _=/^[0-9]+$/;function W(q,x){var ce=_.test(q),Ne=_.test(x);return ce&&Ne&&(q=+q,x=+x),ce&&!Ne?-1:Ne&&!ce?1:q<x?-1:q>x?1:0}function Z(q,x,ce){return new we(q,ce).compare(new we(x,ce))}function ee(q,x,ce){return Z(q,x,ce)>0}function pe(q,x,ce){return Z(q,x,ce)<0}function me(q,x,ce){return Z(q,x,ce)===0}function he(q,x,ce){return Z(q,x,ce)!==0}function Ee(q,x,ce){return Z(q,x,ce)>=0}function re(q,x,ce){return Z(q,x,ce)<=0}function le(q,x,ce,Ne){var je;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),je=q===ce;break;case"!==":typeof q=="object"&&(q=q.version),typeof ce=="object"&&(ce=ce.version),je=q!==ce;break;case"":case"=":case"==":je=me(q,ce,Ne);break;case"!=":je=he(q,ce,Ne);break;case">":je=ee(q,ce,Ne);break;case">=":je=Ee(q,ce,Ne);break;case"<":je=pe(q,ce,Ne);break;case"<=":je=re(q,ce,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return je}function ne(q,x){if(q instanceof ne){if(q.loose===x)return q;q=q.value}if(!(this instanceof ne))return new ne(q,x);P("comparator",q,x),this.loose=x,this.parse(q),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,x){return W(x,q)},e.major=function(q,x){return new we(q,x).major},e.minor=function(q,x){return new we(q,x).minor},e.patch=function(q,x){return new we(q,x).patch},e.compare=Z,e.compareLoose=function(q,x){return Z(q,x,!0)},e.rcompare=function(q,x,ce){return Z(x,q,ce)},e.sort=function(q,x){return q.sort(function(ce,Ne){return e.compare(ce,Ne,x)})},e.rsort=function(q,x){return q.sort(function(ce,Ne){return e.rcompare(ce,Ne,x)})},e.gt=ee,e.lt=pe,e.eq=me,e.neq=he,e.gte=Ee,e.lte=re,e.cmp=le,e.Comparator=ne;var oe={};function fe(q,x){if(q instanceof fe)return q.loose===x?q:new fe(q.raw,x);if(q instanceof ne)return new fe(q.value,x);if(!(this instanceof fe))return new fe(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ce(q){return!q||q.toLowerCase()==="x"||q==="*"}function F(q,x,ce,Ne,je,Qe,Ge,_e,Ze,xe,it,tt,ze){return((x=Ce(ce)?"":Ce(Ne)?">="+ce+".0.0":Ce(je)?">="+ce+"."+Ne+".0":">="+x)+" "+(_e=Ce(Ze)?"":Ce(xe)?"<"+(+Ze+1)+".0.0":Ce(it)?"<"+Ze+"."+(+xe+1)+".0":tt?"<="+Ze+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function V(q,x){for(var ce=0;ce<q.length;ce++)if(!q[ce].test(x))return!1;if(x.prerelease.length){for(ce=0;ce<q.length;ce++)if(P(q[ce].semver),q[ce].semver!==oe&&q[ce].semver.prerelease.length>0){var Ne=q[ce].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function G(q,x,ce){try{x=new fe(x,ce)}catch{return!1}return x.test(q)}function J(q,x,ce,Ne){var je,Qe,Ge,_e,Ze;switch(q=new we(q,Ne),x=new fe(x,Ne),ce){case">":je=ee,Qe=re,Ge=pe,_e=">",Ze=">=";break;case"<":je=pe,Qe=Ee,Ge=ee,_e="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,x,Ne))return!1;for(var xe=0;xe<x.set.length;++xe){var it=x.set[xe],tt=null,ze=null;if(it.forEach(function(ut){ut.semver===oe&&(ut=new ne(">=0.0.0")),tt=tt||ut,ze=ze||ut,je(ut.semver,tt.semver,Ne)?tt=ut:Ge(ut.semver,ze.semver,Ne)&&(ze=ut)}),tt.operator===_e||tt.operator===Ze||(!ze.operator||ze.operator===_e)&&Qe(q,ze.semver)||ze.operator===Ze&&Ge(q,ze.semver))return!1}return!0}ne.prototype.parse=function(q){var x=this.loose?u[X]:u[De],ce=q.match(x);if(!ce)throw new TypeError("Invalid comparator: "+q);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new we(ce[2],this.loose):this.semver=oe},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===oe||(typeof q=="string"&&(q=new we(q,this.loose)),le(q,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(q,x){if(!(q instanceof ne))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new fe(q.value,x),G(this.value,ce,x);if(q.operator==="")return ce=new fe(this.value,x),G(q.semver,ce,x);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Qe=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=le(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ze=le(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||je||Qe&&Ge||_e||Ze},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),P("range",q,x);var ce=x?u[$e]:u[ke];q=q.replace(ce,F),P("hyphen replace",q),q=q.replace(u[Pe],"$1$2$3"),P("comparator trim",q,u[Pe]),q=(q=(q=q.replace(u[j],"$1~")).replace(u[T],"$1^")).split(/\s+/).join(" ");var Ne=x?u[X]:u[De],je=q.split(" ").map(function(Qe){return function(Ge,_e){return P("comp",Ge),Ge=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(it){return function(tt,ze){P("caret",tt,ze);var ut=ze?u[ie]:u[z];return tt.replace(ut,function(Y,Q,ve,Be,Oe){var Xe;return P("caret",tt,Y,Q,ve,Be,Oe),Ce(Q)?Xe="":Ce(ve)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ce(Be)?Xe=Q==="0"?">="+Q+"."+ve+".0 <"+Q+"."+(+ve+1)+".0":">="+Q+"."+ve+".0 <"+(+Q+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=Q==="0"?ve==="0"?">="+Q+"."+ve+"."+Be+Oe+" <"+Q+"."+ve+"."+(+Be+1):">="+Q+"."+ve+"."+Be+Oe+" <"+Q+"."+(+ve+1)+".0":">="+Q+"."+ve+"."+Be+Oe+" <"+(+Q+1)+".0.0"):(P("no pr"),Xe=Q==="0"?ve==="0"?">="+Q+"."+ve+"."+Be+" <"+Q+"."+ve+"."+(+Be+1):">="+Q+"."+ve+"."+Be+" <"+Q+"."+(+ve+1)+".0":">="+Q+"."+ve+"."+Be+" <"+(+Q+1)+".0.0"),P("caret return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),P("caret",Ge),Ge=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(it){return function(tt,ze){var ut=ze?u[K]:u[O];return tt.replace(ut,function(Y,Q,ve,Be,Oe){var Xe;return P("tilde",tt,Y,Q,ve,Be,Oe),Ce(Q)?Xe="":Ce(ve)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ce(Be)?Xe=">="+Q+"."+ve+".0 <"+Q+"."+(+ve+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+Q+"."+ve+"."+Be+Oe+" <"+Q+"."+(+ve+1)+".0"):Xe=">="+Q+"."+ve+"."+Be+" <"+Q+"."+(+ve+1)+".0",P("tilde return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),P("tildes",Ge),Ge=function(Ze,xe){return P("replaceXRanges",Ze,xe),Ze.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var ut=ze?u[y]:u[c];return tt.replace(ut,function(Y,Q,ve,Be,Oe,Xe){P("xRange",tt,Y,Q,ve,Be,Oe,Xe);var nt=Ce(ve),$t=nt||Ce(Be),bt=$t||Ce(Oe);return Q==="="&&bt&&(Q=""),nt?Y=Q===">"||Q==="<"?"<0.0.0":"*":Q&&bt?($t&&(Be=0),bt&&(Oe=0),Q===">"?(Q=">=",$t?(ve=+ve+1,Be=0,Oe=0):bt&&(Be=+Be+1,Oe=0)):Q==="<="&&(Q="<",$t?ve=+ve+1:Be=+Be+1),Y=Q+ve+"."+Be+"."+Oe):$t?Y=">="+ve+".0.0 <"+(+ve+1)+".0.0":bt&&(Y=">="+ve+"."+Be+".0 <"+ve+"."+(+Be+1)+".0"),P("xRange return",Y),Y})}(it,xe)}).join(" ")}(Ge,_e),P("xrange",Ge),Ge=function(Ze,xe){return P("replaceStars",Ze,xe),Ze.trim().replace(u[ye],"")}(Ge,_e),P("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Ne)})),je=je.map(function(Qe){return new ne(Qe,x)})},fe.prototype.intersects=function(q,x){if(!(q instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(Ne){return q.set.some(function(je){return je.every(function(Qe){return Ne.intersects(Qe,x)})})})})},e.toComparators=function(q,x){return new fe(q,x).set.map(function(ce){return ce.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new we(q,this.loose));for(var x=0;x<this.set.length;x++)if(V(this.set[x],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,x,ce){var Ne=null,je=null;try{var Qe=new fe(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&je.compare(Ge)!==-1||(je=new we(Ne=Ge,ce)))}),Ne},e.minSatisfying=function(q,x,ce){var Ne=null,je=null;try{var Qe=new fe(x,ce)}catch{return null}return q.forEach(function(Ge){Qe.test(Ge)&&(Ne&&je.compare(Ge)!==1||(je=new we(Ne=Ge,ce)))}),Ne},e.validRange=function(q,x){try{return new fe(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ce){return J(q,x,"<",ce)},e.gtr=function(q,x,ce){return J(q,x,">",ce)},e.outside=J,e.prerelease=function(q,x){var ce=ae(q,x);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(q,x,ce){return q=new fe(q,ce),x=new fe(x,ce),q.intersects(x)},e.coerce=function(q){if(q instanceof we)return q;if(typeof q!="string")return null;var x=q.match(u[b]);return x==null?null:ae((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(be,e){var w,M,P=be.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function u(t){if(w===setTimeout)return setTimeout(t,0);if((w===L||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:L}catch{w=L}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var D,f=[],R=!1,k=-1;function a(){R&&D&&(R=!1,D.length?f=D.concat(f):k=-1,f.length&&v())}function v(){if(!R){var t=u(a);R=!0;for(var i=f.length;i;){for(D=f,f=[];++k<i;)D&&D[k].run();k=-1,i=f.length}D=null,R=!1,function(l){if(M===clearTimeout)return clearTimeout(l);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(l);try{M(l)}catch{try{return M.call(null,l)}catch{return M.call(this,l)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function d(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)i[l-1]=arguments[l];f.push(new $(t,i)),f.length!==1||R||u(v)},$.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=d,P.addListener=d,P.once=d,P.off=d,P.removeListener=d,P.removeAllListeners=d,P.emit=d,P.prependListener=d,P.prependOnceListener=d,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,11,6]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function P(E){const m=E;return m?typeof m.read=="function":!1}e.$Yd=P;function L(E){const m=E;return m?[m.on,m.pause,m.resume,m.destroy].every(n=>typeof n=="function"):!1}e.$Zd=L;function A(E){const m=E;return m?L(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.$1d=A;function u(E,m){return new D(E,m)}e.$2d=u;class D{constructor(m,n){this.e=m,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(n=>n(m))}h(m){this.c.error.length===0?(0,w.$1)(m):this.c.error.slice(0).forEach(n=>n(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,n){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(m,n){if(this.a.destroyed)return;let r;switch(m){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(n);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(E,m){const n=[];let r;for(;(r=E.read())!==null;)n.push(r);return m(n)}e.$3d=f;function R(E,m,n){const r=[];let s;for(;(s=E.read())!==null&&r.length<n;)r.push(s);return s===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return E.read()}}}e.$4d=R;function k(E,m){return new Promise((n,r)=>{const s=[];a(E,{onData:o=>{m&&s.push(o)},onError:o=>{m?r(o):n(void 0)},onEnd:()=>{n(m?m(s):void 0)}})})}e.$5d=k;function a(E,m,n){E.on("error",r=>{n?.isCancellationRequested||m.onError(r)}),E.on("end",()=>{n?.isCancellationRequested||m.onEnd()}),E.on("data",r=>{n?.isCancellationRequested||m.onData(r)})}e.$6d=a;function v(E,m){return new Promise((n,r)=>{const s=new M.$Rc,o=[],g=I=>{if(o.push(I),o.length>m)return s.dispose(),E.pause(),n({stream:E,buffer:o,ended:!1})},h=I=>(s.dispose(),r(I)),C=()=>(s.dispose(),n({stream:E,buffer:o,ended:!0}));s.add((0,M.$Qc)(()=>E.removeListener("error",h))),E.on("error",h),s.add((0,M.$Qc)(()=>E.removeListener("end",C))),E.on("end",C),s.add((0,M.$Qc)(()=>E.removeListener("data",g))),E.on("data",g)})}e.$7d=v;function $(E,m){const n=u(m);return n.end(E),n}e.$8d=$;function d(){const E=u(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=d;function t(E){let m=!1;return{read:()=>m?null:(m=!0,E)}}e.$0d=t;function i(E,m,n){const r=u(n);return a(E,{onData:s=>r.write(m.data(s)),onError:s=>r.error(m.error?m.error(s):s),onEnd:()=>r.end()}),r}e.$$d=i;function l(E,m,n){let r=!1;return{read:()=>{const s=m.read();return r?s:(r=!0,s!==null?n([E,s]):E)}}}e.$_d=l;function p(E,m,n){let r=!1;const s=u(n);return a(m,{onData:o=>r?s.write(o):(r=!0,s.write(n([E,o]))),onError:o=>s.error(o),onEnd:()=>{r||(r=!0,s.write(E)),s.end()}}),s}e.$ae=p}),define(Ae[26],Re([1,0,42,118]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const P=typeof Buffer<"u",L=new w.$V(()=>new Uint8Array(256));let A,u;class D{static alloc(b){return P?new D(Buffer.allocUnsafe(b)):new D(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new D(b)}static fromString(b,S){return!(S?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(b)):(A||(A=new TextEncoder),new D(A.encode(b)))}static fromByteArray(b){const S=D.alloc(b.length);for(let j=0,O=b.length;j<O;j++)S.buffer[j]=b[j];return S}static concat(b,S){if(typeof S>"u"){S=0;for(let K=0,B=b.length;K<B;K++)S+=b[K].byteLength}const j=D.alloc(S);let O=0;for(let K=0,B=b.length;K<B;K++){const T=b[K];j.set(T,O),O+=T.byteLength}return j}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=D.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(b,S){return new D(this.buffer.subarray(b,S))}set(b,S){if(b instanceof D)this.buffer.set(b.buffer,S);else if(b instanceof Uint8Array)this.buffer.set(b,S);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),S);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return a(this.buffer,b)}writeUInt32BE(b,S){v(this.buffer,b,S)}readUInt32LE(b){return $(this.buffer,b)}writeUInt32LE(b,S){d(this.buffer,b,S)}readUInt8(b){return t(this.buffer,b)}writeUInt8(b,S){i(this.buffer,b,S)}indexOf(b,S=0){return f(this.buffer,b instanceof D?b.buffer:b,S)}}e.$be=D;function f(y,b,S=0){const j=b.byteLength,O=y.byteLength;if(j===0)return 0;if(j===1)return y.indexOf(b[0]);if(j>O-S)return-1;const K=L.value;K.fill(b.length);for(let ie=0;ie<b.length;ie++)K[b[ie]]=b.length-ie-1;let B=S+b.length-1,T=B,z=-1;for(;B<O;)if(y[B]===b[T]){if(T===0){z=B;break}B--,T--}else B+=Math.max(b.length-T,K[y[B]]),T=b.length-1;return z}e.$ce=f;function R(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0}e.$de=R;function k(y,b,S){y[S+0]=b&255,b=b>>>8,y[S+1]=b&255}e.$ee=k;function a(y,b){return y[b]*2**24+y[b+1]*2**16+y[b+2]*2**8+y[b+3]}e.$fe=a;function v(y,b,S){y[S+3]=b,b=b>>>8,y[S+2]=b,b=b>>>8,y[S+1]=b,b=b>>>8,y[S]=b}e.$ge=v;function $(y,b){return y[b+0]<<0>>>0|y[b+1]<<8>>>0|y[b+2]<<16>>>0|y[b+3]<<24>>>0}e.$he=$;function d(y,b,S){y[S+0]=b&255,b=b>>>8,y[S+1]=b&255,b=b>>>8,y[S+2]=b&255,b=b>>>8,y[S+3]=b&255}e.$ie=d;function t(y,b){return y[b]}e.$je=t;function i(y,b,S){y[S]=b}e.$ke=i;function l(y){return M.$3d(y,b=>D.concat(b))}e.$le=l;function p(y){return M.$0d(y)}e.$me=p;function E(y){return M.$5d(y,b=>D.concat(b))}e.$ne=E;async function m(y){return y.ended?D.concat(y.buffer):D.concat([...y.buffer,await E(y.stream)])}e.$oe=m;function n(y){return M.$8d(y,b=>D.concat(b))}e.$pe=n;function r(y){return M.$$d(y,{data:b=>typeof b=="string"?D.fromString(b):D.wrap(b)},b=>D.concat(b))}e.$qe=r;function s(y){return M.$2d(b=>D.concat(b),y)}e.$re=s;function o(y,b){return M.$_d(y,b,S=>D.concat(S))}e.$se=o;function g(y,b){return M.$ae(y,b,S=>D.concat(S))}e.$te=g;function h(y){let b=0,S=0,j=0;const O=new Uint8Array(Math.floor(y.length/4*3)),K=T=>{switch(S){case 3:O[j++]=b|T,S=0;break;case 2:O[j++]=b|T>>>2,b=T<<6,S=3;break;case 1:O[j++]=b|T>>>4,b=T<<4,S=2;break;default:b=T<<2,S=1}};for(let T=0;T<y.length;T++){const z=y.charCodeAt(T);if(z>=65&&z<=90)K(z-65);else if(z>=97&&z<=122)K(z-97+26);else if(z>=48&&z<=57)K(z-48+52);else if(z===43||z===45)K(62);else if(z===47||z===95)K(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${y[T]}`)}}const B=j;for(;S>0;)K(0);return D.wrap(O).slice(0,B)}e.$ue=h;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:y},b=!0,S=!1){const j=S?I:C;let O="";const K=y.byteLength%3;let B=0;for(;B<y.byteLength-K;B+=3){const T=y[B+0],z=y[B+1],ie=y[B+2];O+=j[T>>>2],O+=j[(T<<4|z>>>4)&63],O+=j[(z<<2|ie>>>6)&63],O+=j[ie&63]}if(K===1){const T=y[B+0];O+=j[T>>>2],O+=j[T<<4&63],b&&(O+="==")}else if(K===2){const T=y[B+0],z=y[B+1];O+=j[T>>>2],O+=j[(T<<4|z>>>4)&63],O+=j[z<<2&63],b&&(O+="=")}return O}e.$ve=c}),define(Ae[119],Re([1,0,28,16]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.FuzzyScore=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.or=void 0;function P(...ne){return function(oe,fe){for(let Ce=0,F=ne.length;Ce<F;Ce++){const V=ne[Ce](oe,fe);if(V)return V}return null}}e.or=P,e.$Cj=L.bind(void 0,!1),e.$Dj=L.bind(void 0,!0);function L(ne,oe,fe){if(!fe||fe.length<oe.length)return null;let Ce;return ne?Ce=M.$3e(fe,oe):Ce=fe.indexOf(oe)===0,Ce?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(ne,oe){const fe=oe.toLowerCase().indexOf(ne.toLowerCase());return fe===-1?null:[{start:fe,end:fe+ne.length}]}e.$Ej=A;function u(ne,oe){return D(ne.toLowerCase(),oe.toLowerCase(),0,0)}e.$Fj=u;function D(ne,oe,fe,Ce){if(fe===ne.length)return[];if(Ce===oe.length)return null;if(ne[fe]===oe[Ce]){let F=null;return(F=D(ne,oe,fe+1,Ce+1))?i({start:Ce,end:Ce+1},F):null}return D(ne,oe,fe,Ce+1)}function f(ne){return 97<=ne&&ne<=122}function R(ne){return 65<=ne&&ne<=90}e.$Gj=R;function k(ne){return 48<=ne&&ne<=57}function a(ne){return ne===32||ne===9||ne===10||ne===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>v.add(ne.charCodeAt(0)));function $(ne){return a(ne)||v.has(ne)}function d(ne,oe){return ne===oe||$(ne)&&$(oe)}function t(ne){return f(ne)||R(ne)||k(ne)}function i(ne,oe){return oe.length===0?oe=[ne]:ne.end===oe[0].start?oe[0].start=ne.start:oe.unshift(ne),oe}function l(ne,oe){for(let fe=oe;fe<ne.length;fe++){const Ce=ne.charCodeAt(fe);if(R(Ce)||k(Ce)||fe>0&&!t(ne.charCodeAt(fe-1)))return fe}return ne.length}function p(ne,oe,fe,Ce){if(fe===ne.length)return[];if(Ce===oe.length)return null;if(ne[fe]!==oe[Ce].toLowerCase())return null;{let F=null,V=Ce+1;for(F=p(ne,oe,fe+1,Ce+1);!F&&(V=l(oe,V))<oe.length;)F=p(ne,oe,fe+1,V),V++;return F===null?null:i({start:Ce,end:Ce+1},F)}}function E(ne){let oe=0,fe=0,Ce=0,F=0,V=0;for(let ce=0;ce<ne.length;ce++)V=ne.charCodeAt(ce),R(V)&&oe++,f(V)&&fe++,t(V)&&Ce++,k(V)&&F++;const G=oe/ne.length,J=fe/ne.length,q=Ce/ne.length,x=F/ne.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:x}}function m(ne){const{upperPercent:oe,lowerPercent:fe}=ne;return fe===0&&oe>.6}function n(ne){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ce,numericPercent:F}=ne;return fe>.2&&oe<.8&&Ce>.6&&F<.2}function r(ne){let oe=0,fe=0,Ce=0,F=0;for(let V=0;V<ne.length;V++)Ce=ne.charCodeAt(V),R(Ce)&&oe++,f(Ce)&&fe++,a(Ce)&&F++;return(oe===0||fe===0)&&F===0?ne.length<=30:oe<=5}function s(ne,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(ne)||oe.length>60)return null;const fe=E(oe);if(!n(fe)){if(!m(fe))return null;oe=oe.toLowerCase()}let Ce=null,F=0;for(ne=ne.toLowerCase();F<oe.length&&(Ce=p(ne,oe,0,F))===null;)F=l(oe,F+1);return Ce}e.$Hj=s;function o(ne,oe,fe=!1){if(!oe||oe.length===0)return null;let Ce=null,F=0;for(ne=ne.toLowerCase(),oe=oe.toLowerCase();F<oe.length&&(Ce=g(ne,oe,0,F,fe))===null;)F=h(oe,F+1);return Ce}e.$Ij=o;function g(ne,oe,fe,Ce,F){if(fe===ne.length)return[];if(Ce===oe.length)return null;if(d(ne.charCodeAt(fe),oe.charCodeAt(Ce))){let V=null,G=Ce+1;if(V=g(ne,oe,fe+1,Ce+1,F),!F)for(;!V&&(G=h(oe,G))<oe.length;)V=g(ne,oe,fe+1,G,F),G++;return V?ne.charCodeAt(fe)!==oe.charCodeAt(Ce)?V:i({start:Ce,end:Ce+1},V):null}else return null}function h(ne,oe){for(let fe=oe;fe<ne.length;fe++)if($(ne.charCodeAt(fe))||fe>0&&$(ne.charCodeAt(fe-1)))return fe;return ne.length}const C=P(e.$Dj,s,A),I=P(e.$Dj,s,u),c=new w.$Dc(1e4);function y(ne,oe,fe=!1){if(typeof ne!="string"||typeof oe!="string")return null;let Ce=c.get(ne);Ce||(Ce=new RegExp(M.$Le(ne),"i"),c.set(ne,Ce));const F=Ce.exec(oe);return F?[{start:F.index,end:F.index+F[0].length}]:fe?I(ne,oe):C(ne,oe)}e.$Jj=y;function b(ne,oe){const fe=ee(ne,ne.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?j(fe):null}e.$Kj=b;function S(ne,oe,fe,Ce,F,V){const G=Math.min(13,ne.length);for(;fe<G;fe++){const J=ee(ne,oe,fe,Ce,F,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}e.$Lj=S;function j(ne){if(typeof ne>"u")return[];const oe=[],fe=ne[1];for(let Ce=ne.length-1;Ce>1;Ce--){const F=ne[Ce]+fe,V=oe[oe.length-1];V&&V.end===F?V.end=F+1:oe.push({start:F,end:F+1})}return oe}e.$Mj=j;const O=128;function K(){const ne=[],oe=[];for(let fe=0;fe<=O;fe++)oe[fe]=0;for(let fe=0;fe<=O;fe++)ne.push(oe.slice(0));return ne}function B(ne){const oe=[];for(let fe=0;fe<=ne;fe++)oe[fe]=0;return oe}const T=B(2*O),z=B(2*O),ie=K(),X=K(),De=K(),Pe=!1;function ke(ne,oe,fe,Ce,F){function V(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let G=` |   |${Ce.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=fe;J++)J===0?G+=" |":G+=`${oe[J-1]}|`,G+=ne[J].slice(0,F+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function $e(ne,oe,fe,Ce){ne=ne.substr(oe),fe=fe.substr(Ce),console.log(ke(X,ne,ne.length,fe,fe.length)),console.log(ke(De,ne,ne.length,fe,fe.length)),console.log(ke(ie,ne,ne.length,fe,fe.length))}function ye(ne,oe){if(oe<0||oe>=ne.length)return!1;const fe=ne.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$if(fe)}}function ue(ne,oe){if(oe<0||oe>=ne.length)return!1;switch(ne.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ae(ne,oe,fe){return oe[ne]!==fe[ne]}function we(ne,oe,fe,Ce,F,V,G=!1){for(;oe<fe&&F<V;)ne[oe]===Ce[F]&&(G&&(T[oe]=F),oe+=1),F+=1;return oe===fe}e.$Nj=we;var _;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(_||(_={}));var W;(function(ne){ne.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}ne.isDefault=oe})(W||(e.FuzzyScore=W={}));class Z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.$Oj=Z;function ee(ne,oe,fe,Ce,F,V,G=Z.default){const J=ne.length>O?O:ne.length,q=Ce.length>O?O:Ce.length;if(fe>=J||V>=q||J-fe>q-V||!we(oe,fe,J,F,V,q,!0))return;pe(J,q,fe,V,oe,F);let x=1,ce=1,Ne=fe,je=V;const Qe=[!1];for(x=1,Ne=fe;Ne<J;x++,Ne++){const it=T[Ne],tt=z[Ne],ze=Ne+1<J?z[Ne+1]:q;for(ce=it-V+1,je=it;je<ze;ce++,je++){let ut=Number.MIN_SAFE_INTEGER,Y=!1;je<=tt&&(ut=me(ne,oe,Ne,fe,Ce,F,je,q,V,ie[x-1][ce-1]===0,Qe));let Q=0;ut!==Number.MAX_SAFE_INTEGER&&(Y=!0,Q=ut+X[x-1][ce-1]);const ve=je>it,Be=ve?X[x][ce-1]+(ie[x][ce-1]>0?-5:0):0,Oe=je>it+1&&ie[x][ce-1]>0,Xe=Oe?X[x][ce-2]+(ie[x][ce-2]>0?-5:0):0;if(Oe&&(!ve||Xe>=Be)&&(!Y||Xe>=Q))X[x][ce]=Xe,De[x][ce]=3,ie[x][ce]=0;else if(ve&&(!Y||Be>=Q))X[x][ce]=Be,De[x][ce]=2,ie[x][ce]=0;else if(Y)X[x][ce]=Q,De[x][ce]=1,ie[x][ce]=ie[x-1][ce-1]+1;else throw new Error("not possible")}}if(Pe&&$e(ne,fe,Ce,V),!Qe[0]&&!G.firstMatchCanBeWeak)return;x--,ce--;const Ge=[X[x][ce],V];let _e=0,Ze=0;for(;x>=1;){let it=ce;do{const tt=De[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&oe[fe+x-1]===F[V+ce-1]&&!ae(it+V-1,Ce,F)&&_e+1>ie[x][it]&&(it=ce),it===ce?_e++:_e=1,Ze||(Ze=it),x--,ce=it-1,Ge.push(ce)}q===J&&G.boostFullMatch&&(Ge[0]+=2);const xe=Ze-J;return Ge[0]-=xe,Ge}e.$Pj=ee;function pe(ne,oe,fe,Ce,F,V){let G=ne-1,J=oe-1;for(;G>=fe&&J>=Ce;)F[G]===V[J]&&(z[G]=J,G--),J--}function me(ne,oe,fe,Ce,F,V,G,J,q,x,ce){if(oe[fe]!==V[G])return Number.MIN_SAFE_INTEGER;let Ne=1,je=!1;return G===fe-Ce?Ne=ne[fe]===F[G]?7:5:ae(G,F,V)&&(G===0||!ae(G-1,F,V))?(Ne=ne[fe]===F[G]?7:5,je=!0):ye(V,G)&&(G===0||!ye(V,G-1))?Ne=5:(ye(V,G-1)||ue(V,G-1))&&(Ne=5,je=!0),Ne>1&&fe===Ce&&(ce[0]=!0),je||(je=ae(G,F,V)||ye(V,G-1)||ue(V,G-1)),fe===Ce?G>q&&(Ne-=je?3:5):x?Ne+=je?2:0:Ne+=je?0:1,G+1===J&&(Ne-=je?3:5),Ne}function he(ne,oe,fe,Ce,F,V,G){return re(ne,oe,fe,Ce,F,V,!0,G)}e.$Qj=he;function Ee(ne,oe,fe,Ce,F,V,G){return re(ne,oe,fe,Ce,F,V,!1,G)}e.$Rj=Ee;function re(ne,oe,fe,Ce,F,V,G,J){let q=ee(ne,oe,fe,Ce,F,V,J);if(q&&!G)return q;if(ne.length>=3){const x=Math.min(7,ne.length-1);for(let ce=fe+1;ce<x;ce++){const Ne=le(ne,ce);if(Ne){const je=ee(Ne,Ne.toLowerCase(),fe,Ce,F,V,J);je&&(je[0]-=3,(!q||je[0]>q[0])&&(q=je))}}}return q}function le(ne,oe){if(oe+1>=ne.length)return;const fe=ne[oe],Ce=ne[oe+1];if(fe!==Ce)return ne.slice(0,oe)+Ce+fe+ne.slice(oe+2)}}),define(Ae[29],Re([1,0,16]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(M||(M={})),function(P){const L="error",A="warning",u="warn",D="info",f="ignore";function R(a){return a?w.$2e(L,a)?P.Error:w.$2e(A,a)||w.$2e(u,a)?P.Warning:w.$2e(D,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=R;function k(a){switch(a){case P.Error:return L;case P.Warning:return A;case P.Info:return D;default:return f}}P.toString=k}(M||(M={})),e.default=M}),define(Ae[120],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Ae[50],Re([1,0,18,16]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const $=v.charCodeAt(0),d=this.b.charCodeAt(this.c);return $-d}value(){return this.b[this.c]}}e.$Rh=P;class L{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,M.$Ve)(v,this.b,0,v.length,this.c,this.d):(0,M.$Xe)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Sh=L;class A{constructor(v=!0,$=!0){this.f=v,this.g=$}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let $=v.length-1;$>=0;$--,this.c--){const d=this.b.charCodeAt($);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,M.$Ve)(v,this.b,0,v.length,this.d,this.e):(0,M.$Xe)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Th=A;var u;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(u||(u={}));class D{constructor(v,$){this.f=v,this.g=$,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,M.$We)(v,this.c.scheme);if(this.d[this.e]===2)return(0,M.$We)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,M.$Ue)(v,this.c.query);if(this.d[this.e]===5)return(0,M.$Ue)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Uh=D;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(R||(R={}));class k{static forUris(v=()=>!1,$=()=>!1){return new k(new D(v,$))}static forPaths(v=!1){return new k(new A(void 0,!v))}static forStrings(){return new k(new P)}static forConfigKeys(){return new k(new L)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,$){if($){const d=$.slice(0);(0,w.$Xb)(d);for(const t of d)this.set(t,v)}else{const d=v.slice(0);(0,w.$Xb)(d);for(const t of d)this.set(t[0],t[1])}}set(v,$){const d=this.b.reset(v);let t;this.c||(this.c=new f,this.c.segment=d.value());const i=[];for(t=this.c;;){const p=d.cmp(t.segment);if(p>0)t.left||(t.left=new f,t.left.segment=d.value()),i.push([-1,t]),t=t.left;else if(p<0)t.right||(t.right=new f,t.right.segment=d.value()),i.push([1,t]),t=t.right;else if(d.hasNext())d.next(),t.mid||(t.mid=new f,t.mid.segment=d.value()),i.push([0,t]),t=t.mid;else break}const l=t.value;t.value=$,t.key=v;for(let p=i.length-1;p>=0;p--){const E=i[p][1];E.updateHeight();const m=E.balanceFactor();if(m<-1||m>1){const n=i[p][0],r=i[p+1][0];if(n===1&&r===1)i[p][1]=E.rotateLeft();else if(n===-1&&r===-1)i[p][1]=E.rotateRight();else if(n===1&&r===-1)E.right=i[p+1][1]=i[p+1][1].rotateRight(),i[p][1]=E.rotateLeft();else if(n===-1&&r===1)E.left=i[p+1][1]=i[p+1][1].rotateLeft(),i[p][1]=E.rotateRight();else throw new Error;if(p>0)switch(i[p-1][0]){case-1:i[p-1][1].left=i[p][1];break;case 1:i[p-1][1].right=i[p][1];break;case 0:i[p-1][1].mid=i[p][1];break}else this.c=i[0][1]}}return l}get(v){return this.d(v)?.value}d(v){const $=this.b.reset(v);let d=this.c;for(;d;){const t=$.cmp(d.segment);if(t>0)d=d.left;else if(t<0)d=d.right;else if($.hasNext())$.next(),d=d.mid;else break}return d}has(v){const $=this.d(v);return!($?.value===void 0&&$?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,$){const d=this.b.reset(v),t=[];let i=this.c;for(;i;){const l=d.cmp(i.segment);if(l>0)t.push([-1,i]),i=i.left;else if(l<0)t.push([1,i]),i=i.right;else if(d.hasNext())d.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const l=this.f(i.right);if(l.key){const{key:p,value:E,segment:m}=l;this.e(l.key,!1),i.key=p,i.value=E,i.segment=m}}else{const l=i.left??i.right;if(t.length>0){const[p,E]=t[t.length-1];switch(p){case-1:E.left=l;break;case 0:E.mid=l;break;case 1:E.right=l;break}}else this.c=l}for(let l=t.length-1;l>=0;l--){const p=t[l][1];p.updateHeight();const E=p.balanceFactor();if(E>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),t[l][1]=p.rotateLeft()):E<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),t[l][1]=p.rotateRight()),l>0)switch(t[l-1][0]){case-1:t[l-1][1].left=t[l][1];break;case 1:t[l-1][1].right=t[l][1];break;case 0:t[l-1][1].mid=t[l][1];break}else this.c=t[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const $=this.b.reset(v);let d=this.c,t;for(;d;){const i=$.cmp(d.segment);if(i>0)d=d.left;else if(i<0)d=d.right;else if($.hasNext())$.next(),t=d.value||t,d=d.mid;else break}return d&&d.value||t}findSuperstr(v){return this.g(v,!1)}g(v,$){const d=this.b.reset(v);let t=this.c;for(;t;){const i=d.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(d.hasNext())d.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[$,d]of this)v(d,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const $=[];return this.j(v,$),$[Symbol.iterator]()}j(v,$){v&&(v.left&&this.j(v.left,$),v.value&&$.push([v.key,v.value]),v.mid&&this.j(v.mid,$),v.right&&this.j(v.right,$))}_isBalanced(){const v=$=>{if(!$)return!0;const d=$.balanceFactor();return d<-1||d>1?!1:v($.left)&&v($.right)};return v(this.c)}}e.$Vh=k}),define(Ae[43],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Vj=e.ThemeColor=void 0;var M;(function(A){function u(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=u})(M||(e.ThemeColor=M={}));function P(A){return{id:A}}e.$Vj=P;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const u=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(l){const p=u.exec(l.id);if(!p)return D(w.$Uj.error);const[,E,m]=p,n=["codicon","codicon-"+E];return m&&n.push("codicon-modifier-"+m.substring(1)),n}A.asClassNameArray=D;function f(l){return D(l).join(" ")}A.asClassName=f;function R(l){return"."+D(l).join(".")}A.asCSSSelector=R;function k(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||M.isThemeColor(l.color))}A.isThemeIcon=k;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function v(l){const p=a.exec(l);if(!p)return;const[,E]=p;return{id:E}}A.fromString=v;function $(l){return{id:l}}A.fromId=$;function d(l,p){let E=l.id;const m=E.lastIndexOf("~");return m!==-1&&(E=E.substring(0,m)),p&&(E=`${E}~${p}`),{id:E}}A.modify=d;function t(l){const p=l.id.lastIndexOf("~");if(p!==-1)return l.id.substring(p+1)}A.getModifier=t;function i(l,p){return l.id===p.id&&l.color?.id===p.color?.id}A.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Ae[121],Re([1,0,119,16,43]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=void 0;const L="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),u=new RegExp(`(\\\\)?${A.source}`,"g");function D(i){return i.replace(u,(l,p)=>p?l:`\\${l}`)}e.$Wj=D;const f=new RegExp(`\\\\${A.source}`,"g");function R(i){return i.replace(f,l=>`\\${l}`)}e.$Xj=R;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(i){return i.indexOf(L)===-1?i:i.replace(k,(l,p,E,m)=>E?l:p||m||"")}e.$Yj=a;function v(i){return i?i.replace(/\$\((.*?)\)/g,(l,p)=>` ${p} `).trim():""}e.$Zj=v;const $=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(i){$.lastIndex=0;let l="";const p=[];let E=0;for(;;){const m=$.lastIndex,n=$.exec(i),r=i.substring(m,n?.index);if(r.length>0){l+=r;for(let s=0;s<r.length;s++)p.push(E)}if(!n)break;E+=n[0].length}return{text:l,iconOffsets:p}}e.$1j=d;function t(i,l,p=!1){const{text:E,iconOffsets:m}=l;if(!m||m.length===0)return(0,w.$Jj)(i,E,p);const n=(0,M.$Je)(E," "),r=E.length-n.length,s=(0,w.$Jj)(i,n,p);if(s)for(const o of s){const g=m[o.start+r]+r;o.start+=g,o.end+=g}return s}e.$2j=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(P){return w.test(P)}e.$dg=M,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(u){for(let D=0;D<u.length;D++)u[D]=Math.floor(Math.random()*256);return u};const L=new Uint8Array(16),A=[];for(let u=0;u<256;u++)A.push(u.toString(16).padStart(2,"0"));return function(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let D=0,f="";return f+=A[L[D++]],f+=A[L[D++]],f+=A[L[D++]],f+=A[L[D++]],f+="-",f+=A[L[D++]],f+=A[L[D++]],f+="-",f+=A[L[D++]],f+=A[L[D++]],f+="-",f+=A[L[D++]],f+=A[L[D++]],f+="-",f+=A[L[D++]],f+=A[L[D++]],f+=A[L[D++]],f+=A[L[D++]],f+=A[L[D++]],f+=A[L[D++]],f}}()}),define(Ae[122],Re([1,0,18,66,36]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=e.$1s=e.$Zs=e.$Ys=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Ys=L;function A(k,a,v){const $={id:(0,P.$eg)(),name:k,uri:a,data:v};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Zs=A;class u{constructor(){this.a=new Map}get size(){let a=0;for(const v of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const v=[...this.a.keys()];return M.Iterable.some(this,([$,d])=>d.asFile())&&v.push("files"),R(D(a),v)}get(a){return this.a.get(this.b(a))?.[0]}append(a,v){const $=this.a.get(a);$?$.push(v):this.a.set(this.b(a),[v])}replace(a,v){this.a.set(this.b(a),[v])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,v]of this.a)for(const $ of v)yield[a,$]}b(a){return D(a)}}e.$1s=u;function D(k){return k.toLowerCase()}function f(k,a){return R(D(k),a.map(D))}e.$2s=f;function R(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const v=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[$,d,t]=v;return t==="*"?a.some(i=>i.startsWith(d+"/")):!1}e.$3s=Object.freeze({create:k=>(0,w.$Mb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$3s.split(k).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0,e.$3r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.$pt=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class M{constructor(u){if(this.e=null,this.f=!1,this.open=u.open,this.close=u.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(u.notIn))for(let D=0,f=u.notIn.length;D<f;D++)switch(u.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(u){switch(u){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(u,D){if(u.getTokenCount()===0)return!0;const f=u.findTokenIndexAtOffset(D-2),R=u.getStandardTokenType(f);return this.isOK(R)}g(u,D){for(let f=u;f<=D;f++){const R=String.fromCharCode(f);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$pt=M;class P{constructor(u){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of u)L(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),L(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),L(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),L(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&L(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$qt=P;function L(A,u,D){A.has(u)?A.get(u).push(D):A.set(u,[D])}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7=e.$S7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$S7=w;class M{constructor(L){this.identifier=L}}e.$T7=M}),define(Ae[126],Re([9,10]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=void 0;class L extends M.$Sc{constructor(a,v="",$="",d=!0,t){super(),this.h=this.B(new w.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=v,this.u=$,this.w=d,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,v){this.C&&await this.C(a)}}e.$ui=L;class A extends M.$Sc{constructor(){super(...arguments),this.f=this.B(new w.$Nd),this.onWillRun=this.f.event,this.m=this.B(new w.$Nd),this.onDidRun=this.m.event}async run(a,v){if(!a.enabled)return;this.f.fire({action:a});let $;try{await this.u(a,v)}catch(d){$=d}this.m.fire({action:a,error:$})}async u(a,v){await a.run(v)}}e.$vi=A;class u{constructor(){this.id=u.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let v=[];for(const $ of a)$.length&&(v.length?v=[...v,new u,...$]:v=$);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$wi=u;class D{get actions(){return this.a}constructor(a,v,$,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=v,this.class=d,this.a=$}async run(){}}e.$xi=D;class f extends L{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,P.localize(0,null),void 0,!1)}}e.$yi=f;function R(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$zi=R}),define(Ae[128],Re([9,10]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0;const M=60,P=M*60,L=P*24,A=L*7,u=L*30,D=L*365;function f(k,a,v,$){typeof k!="number"&&(k=k.getTime());const d=Math.round((new Date().getTime()-k)/1e3);if(d<-30)return(0,w.localize)(0,null,f(new Date().getTime()+d*1e3,!1));if(!$&&d<30)return(0,w.localize)(1,null);let t;return d<M?(t=d,a?t===1?v?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):v?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?v?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):v?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):d<P?(t=Math.floor(d/M),a?t===1?v?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):v?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?v?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):v?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):d<L?(t=Math.floor(d/P),a?t===1?v?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):v?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?v?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):v?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):d<A?(t=Math.floor(d/L),a?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):d<u?(t=Math.floor(d/A),a?t===1?v?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):v?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?v?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):v?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):d<D?(t=Math.floor(d/u),a?t===1?v?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):v?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?v?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):v?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(d/D),a?t===1?v?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):v?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?v?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):v?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$dm=f;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$em=R}),define(Ae[130],Re([9,10]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[37],Re([1,0,18,15,130]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=void 0;function L(k,a){return a&&(k.stack||k.stacktrace)?P.localize(0,null,u(k),A(k.stack)||A(k.stacktrace)):u(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function u(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?P.localize(1,null,k.message):k.message||P.localize(2,null)}function D(k=null,a=!1){if(!k)return P.localize(3,null);if(Array.isArray(k)){const v=w.$Hb(k),$=D(v[0],a);return v.length>1?P.localize(4,null,$,v.length):$}if(M.$yf(k))return k;if(k.detail){const v=k.detail;if(v.error)return L(v.error,a);if(v.exception)return L(v.exception,a)}return k.stack?L(k,a):k.message?k.message:P.localize(5,null)}e.$Ai=D;function f(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$Bi=f;function R(k,a){let v;return typeof k=="string"?v=new Error(k):v=k,v.actions=a,v}e.$Ci=R}),define(Ae[131],Re([1,0,42,20]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=void 0;const P=new w.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),L=new w.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function u(I,c,y=!1){const b=I||"",S=c||"",j=P.value.collator.compare(b,S);return P.value.collatorIsNumeric&&j===0&&b!==S?b<S?-1:1:j}e.$hq=u;function D(I,c){const y=L.value.collator;return I=I||"",c=c||"",E(y,I,c)}e.$iq=D;function f(I,c){const y=L.value.collator;return I=I||"",c=c||"",s(I,c)||E(y,I,c)}e.$jq=f;function R(I,c){const y=L.value.collator;return I=I||"",c=c||"",r(I,c)||E(y,I,c)}e.$kq=R;function k(I,c){return I=I||"",c=c||"",I===c?0:I<c?-1:1}e.$lq=k;function a(I,c){const[y,b]=l(I),[S,j]=l(c);let O=P.value.collator.compare(b,j);if(O===0){if(P.value.collatorIsNumeric&&b!==j)return b<j?-1:1;if(O=P.value.collator.compare(y,S),P.value.collatorIsNumeric&&O===0&&y!==S)return y<S?-1:1}return O}e.$mq=a;function v(I,c){I=I||"",c=c||"";const y=p(I),b=p(c),S=L.value.collator,j=A.value.collator;return E(j,y,b)||E(S,I,c)}e.$nq=v;function $(I,c){I=I||"",c=c||"";const y=p(I),b=p(c),S=L.value.collator,j=A.value.collator;return E(j,y,b)||s(I,c)||E(S,I,c)}e.$oq=$;function d(I,c){I=I||"",c=c||"";const y=p(I),b=p(c),S=L.value.collator,j=A.value.collator;return E(j,y,b)||r(I,c)||E(S,I,c)}e.$pq=d;function t(I,c){I=I||"",c=c||"";const y=p(I).toLowerCase(),b=p(c).toLowerCase();return y!==b?y<b?-1:1:I!==c?I<c?-1:1:0}e.$qq=t;const i=/^(.*?)(\.([^.]*))?$/;function l(I,c=!1){const y=I?i.exec(I):[];let b=[y&&y[1]||"",y&&y[3]||""];return c&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function p(I){const c=I?i.exec(I):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function E(I,c,y){const b=I.compare(c,y);return b!==0?b:c.length!==y.length?c.length<y.length?-1:1:0}function m(I){const c=I.charAt(0);return c.toLocaleUpperCase()!==c}function n(I){const c=I.charAt(0);return c.toLocaleLowerCase()!==c}function r(I,c){return m(I)&&n(c)?-1:n(I)&&m(c)?1:0}function s(I,c){return n(I)&&m(c)?-1:m(I)&&n(c)?1:0}function o(I,c,y=!1){return y||(I=I&&I.toLowerCase(),c=c&&c.toLowerCase()),I===c?0:I<c?-1:1}function g(I,c,y=!1){const b=I.split(M.sep),S=c.split(M.sep),j=b.length-1,O=S.length-1;let K,B;for(let T=0;;T++){if(K=j===T,B=O===T,K&&B)return u(b[T],S[T],y);if(K)return-1;if(B)return 1;const z=o(b[T],S[T],y);if(z!==0)return z}}e.$rq=g;function h(I,c,y){const b=I.toLowerCase(),S=c.toLowerCase(),j=C(I,c,y);if(j)return j;const O=b.endsWith(y),K=S.endsWith(y);if(O!==K)return O?-1:1;const B=u(b,S);return B!==0?B:b.localeCompare(S)}e.$sq=h;function C(I,c,y){const b=I.toLowerCase(),S=c.toLowerCase(),j=b.startsWith(y),O=S.startsWith(y);if(j!==O)return j?-1:1;if(j&&O){if(b.length<S.length)return-1;if(b.length>S.length)return 1}return 0}e.$tq=C}),define(Ae[44],Re([1,0,20,23,16,15]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(h){return h===47||h===92}e.$Qf=A;function u(h){return h.replace(/[\\/]/g,w.$gc.sep)}e.$Rf=u;function D(h){return h.indexOf("/")===-1&&(h=u(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Sf=D;function f(h,C=w.$gc.sep){if(!h)return"";const I=h.length,c=h.charCodeAt(0);if(A(c)){if(A(h.charCodeAt(1))&&!A(h.charCodeAt(2))){let b=3;const S=b;for(;b<I&&!A(h.charCodeAt(b));b++);if(S!==b&&!A(h.charCodeAt(b+1))){for(b+=1;b<I;b++)if(A(h.charCodeAt(b)))return h.slice(0,b+1).replace(/[\\/]/g,C)}}return C}else if(i(c)&&h.charCodeAt(1)===58)return A(h.charCodeAt(2))?h.slice(0,2)+C:h.slice(0,2);let y=h.indexOf("://");if(y!==-1){for(y+=3;y<I;y++)if(A(h.charCodeAt(y)))return h.slice(0,y+1)}return""}e.$Tf=f;function R(h){if(!M.$j||!h||h.length<5)return!1;let C=h.charCodeAt(0);if(C!==92||(C=h.charCodeAt(1),C!==92))return!1;let I=2;const c=I;for(;I<h.length&&(C=h.charCodeAt(I),C!==92);I++);return!(c===I||(C=h.charCodeAt(I+1),isNaN(C)||C===92))}e.$Uf=R;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(h,C=M.$j){const I=C?k:a;return!(!h||h.length===0||/^\s+$/.test(h)||(I.lastIndex=0,I.test(h))||C&&v.test(h)||h==="."||h===".."||C&&h[h.length-1]==="."||C&&h.length!==h.trim().length||h.length>255)}e.$Vf=$;function d(h,C,I){const c=h===C;return!I||c?c:!h||!C?!1:(0,P.$2e)(h,C)}e.$Wf=d;function t(h,C,I,c=w.sep){if(h===C)return!0;if(!h||!C||C.length>h.length)return!1;if(I){if(!(0,P.$3e)(h,C))return!1;if(C.length===h.length)return!0;let b=C.length;return C.charAt(C.length-1)===c&&b--,h.charAt(b)===c}return C.charAt(C.length-1)!==c&&(C+=c),h.indexOf(C)===0}e.$Xf=t;function i(h){return h>=65&&h<=90||h>=97&&h<=122}e.$Yf=i;function l(h,C){return M.$j&&h.endsWith(":")&&(h+=w.sep),(0,w.$ic)(h)||(h=(0,w.$jc)(C,h)),h=(0,w.$hc)(h),M.$j?(h=(0,P.$Ke)(h,w.sep),h.endsWith(":")&&(h+=w.sep)):(h=(0,P.$Ke)(h,w.sep),h||(h=w.sep)),h}e.$Zf=l;function p(h){const C=(0,w.$hc)(h);return M.$j?h.length>3?!1:E(C)&&(h.length===2||C.charCodeAt(2)===92):C===w.$gc.sep}e.$1f=p;function E(h,C=M.$j){return C?i(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$2f=E;function m(h,C=M.$j){return E(h,C)?h[0]:void 0}e.$3f=m;function n(h,C,I){return C.length>h.length?-1:h===C?0:(I&&(h=h.toLowerCase(),C=C.toLowerCase()),h.indexOf(C))}e.$4f=n;function r(h){const C=h.split(":");let I,c,y;for(const b of C){const S=Number(b);(0,L.$Cf)(S)?c===void 0?c=S:y===void 0&&(y=S):I=I?[I,b].join(":"):b}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:c!==void 0?c:void 0,column:y!==void 0?y:c!==void 0?1:void 0}}e.$5f=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(h,C,I=8){let c="";for(let b=0;b<I;b++){let S;b===0&&M.$j&&!C&&(I===3||I===4)?S=o:S=s,c+=S.charAt(Math.floor(Math.random()*S.length))}let y;return C?y=`${C}-${c}`:y=c,h?(0,w.$jc)(h,y):y}e.$6f=g}),define(Ae[67],Re([1,0,20]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=void 0,e.$Pr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const k=(0,w.$oc)(R),a=M[k.toLowerCase()];return a!==void 0?a:A(R)}e.$Qr=L;function A(R){const k=(0,w.$oc)(R);return P[k.toLowerCase()]}e.$Rr=A;function u(R){for(const k in P)if(P[k]===R)return k}e.$Sr=u;const D=/^(.+)\/(.+?)(;.+)?$/;function f(R,k){const a=D.exec(R);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:R}e.$Tr=f}),define(Ae[68],Re([1,0,26,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=void 0;function P(D){return JSON.stringify(D,A)}e.$kh=P;function L(D){let f=JSON.parse(D);return f=u(f),f}e.$lh=L;function A(D,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function u(D,f=0){if(!D||f>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return M.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof w.$be||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=u(D[R],f+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=u(D[R],f+1))}return D}e.$mh=u}),define(Ae[13],Re([1,0,11,23,2]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var L;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${L.vscodeRemoteResource}`}set(R,k,a){this.a[R]=k,this.b[R]=a}setConnectionToken(R,k){this.c[R]=k}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return w.$1(t),R}const k=R.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const v=this.b[k],$=this.c[k];let d=`path=${encodeURIComponent(R.path)}`;return typeof $=="string"&&(d+=`&${e.$8f}=${encodeURIComponent($)}`),P.URI.from({scheme:M.$p?this.d:L.vscodeRemoteResource,authority:`${a}:${v}`,path:this.f,query:d})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class u{static{this.a=e.$bg}asBrowserUri(R){const k=this.b(R,be);return this.uriToBrowserUri(k)}uriToBrowserUri(R){return R.scheme===L.vscodeRemote?e.$9f.rewrite(R):R.scheme===L.file&&(M.$n||M.$q&&M.$h.origin===`${L.vscodeFileResource}://${u.a}`)?R.with({scheme:L.vscodeFileResource,authority:R.authority||u.a,query:null,fragment:null}):R}asFileUri(R){const k=this.b(R,be);return this.uriToFileUri(k)}uriToFileUri(R){return R.scheme===L.vscodeFileResource?R.with({scheme:L.file,authority:R.authority!==u.a?R.authority:null,query:null,fragment:null}):R}b(R,k){return P.URI.isUri(R)?R:P.URI.parse(k.toUrl(R))}}e.$cg=new u;var D;(function(f){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(R.get("3"));const k="vscode-coi";function a($){let d;typeof $=="string"?d=new URL($).searchParams:$ instanceof URL?d=$.searchParams:P.URI.isUri($)&&(d=new URL($.toString(!0)).searchParams);const t=d?.get(k);if(t)return R.get(t)}f.getHeadersFromQuery=a;function v($,d,t){if(!globalThis.crossOriginIsolated)return;const i=d&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(k,i):$[k]=i}f.addSearchParam=v})(D||(e.COI=D={}))}),define(Ae[24],Re([1,0,44,13,20,23,16,2]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function D(v){return(0,u.$wc)(v,!0)}e.$jg=D;class f{constructor($){this.a=$}compare($,d,t=!1){return $===d?0:(0,A.$Ue)(this.getComparisonKey($,t),this.getComparisonKey(d,t))}isEqual($,d,t=!1){return $===d?!0:!$||!d?!1:this.getComparisonKey($,t)===this.getComparisonKey(d,t)}getComparisonKey($,d=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,d,t=!1){if($.scheme===d.scheme){if($.scheme===M.Schemas.file)return w.$Xf(D($),D(d),this.a($))&&$.query===d.query&&(t||$.fragment===d.fragment);if((0,e.$Ag)($.authority,d.authority))return w.$Xf($.path,d.path,this.a($),"/")&&$.query===d.query&&(t||$.fragment===d.fragment)}return!1}joinPath($,...d){return u.URI.joinPath($,...d)}basenameOrAuthority($){return(0,e.$sg)($)||$.authority}basename($){return P.$gc.basename($.path)}extname($){return P.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let d;return $.scheme===M.Schemas.file?d=u.URI.file(P.$mc(D($))).path:(d=P.$gc.dirname($.path),$.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),d="/")),$.with({path:d})}normalizePath($){if(!$.path.length)return $;let d;return $.scheme===M.Schemas.file?d=u.URI.file(P.$hc(D($))).path:d=P.$gc.normalize($.path),$.with({path:d})}relativePath($,d){if($.scheme!==d.scheme||!(0,e.$Ag)($.authority,d.authority))return;if($.scheme===M.Schemas.file){const l=P.$lc(D($),D(d));return L.$j?w.$Rf(l):l}let t=$.path||"/";const i=d.path||"/";if(this.a($)){let l=0;for(const p=Math.min(t.length,i.length);l<p&&!(t.charCodeAt(l)!==i.charCodeAt(l)&&t.charAt(l).toLowerCase()!==i.charAt(l).toLowerCase());l++);t=i.substr(0,l)+t.substr(l)}return P.$gc.relative(t,i)}resolvePath($,d){if($.scheme===M.Schemas.file){const t=u.URI.file(P.$kc(D($),d));return $.with({authority:t.authority,path:t.path})}return d=w.$Sf(d),$.with({path:P.$gc.resolve($.path,d)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,d){return $===d||$!==void 0&&d!==void 0&&(0,A.$2e)($,d)}hasTrailingPathSeparator($,d=P.sep){if($.scheme===M.Schemas.file){const t=D($);return t.length>w.$Tf(t).length&&t[t.length-1]===d}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,d=P.sep){return(0,e.$Bg)($,d)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,d=P.sep){let t=!1;if($.scheme===M.Schemas.file){const i=D($);t=i!==void 0&&i.length===w.$Tf(i).length&&i[i.length-1]===d}else{d="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Bg)($,d)?$.with({path:$.path+"/"}):$}}e.$kg=f,e.$lg=new f(()=>!1),e.$mg=new f(v=>v.scheme===M.Schemas.file?!L.$l:!0),e.$ng=new f(v=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function R(v,$){const d=[];for(let t=0;t<v.length;t++){const i=$(v[t]);v.some((l,p)=>p===t?!1:(0,e.$pg)(i,$(l)))||d.push(v[t])}return d}e.$Eg=R;var k;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function $(d){const t=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(p=>{const[E,m]=p.split(":");E&&m&&t.set(E,m)});const l=d.path.substring(0,d.path.indexOf(";"));return l&&t.set(v.META_DATA_MIME,l),t}v.parseMetaData=$})(k||(e.DataUri=k={}));function a(v,$,d){if($){let t=v.path;return t&&t[0]!==P.$gc.sep&&(t=P.$gc.sep+t),v.with({scheme:d,authority:$,path:t})}return v.with({scheme:d})}e.$Fg=a}),define(Ae[12],Re([1,0,19,11,5,6,24,23,120]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function f(Z){return!!Z&&typeof Z.then=="function"}e.$Gg=f;function R(Z){const ee=new w.$Xd,pe=Z(ee.token),me=new Promise((he,Ee)=>{const re=ee.token.onCancellationRequested(()=>{re.dispose(),ee.dispose(),Ee(new M.$5)});Promise.resolve(pe).then(le=>{re.dispose(),ee.dispose(),he(le)},le=>{re.dispose(),ee.dispose(),Ee(le)})});return new class{cancel(){ee.cancel()}then(he,Ee){return me.then(he,Ee)}catch(he){return this.then(void 0,he)}finally(he){return me.finally(he)}}}e.$Hg=R;function k(Z,ee,pe){return new Promise((me,he)=>{const Ee=ee.onCancellationRequested(()=>{Ee.dispose(),me(pe)});Z.then(me,he).finally(()=>Ee.dispose())})}e.$Ig=k;function a(Z,ee){return new Promise((pe,me)=>{const he=ee.onCancellationRequested(()=>{he.dispose(),me(new M.$5)});Z.then(pe,me).finally(()=>he.dispose())})}e.$Jg=a;async function v(Z){let ee=-1;const pe=Z.map((me,he)=>me.then(Ee=>(ee=he,Ee)));try{return await Promise.race(pe)}finally{Z.forEach((me,he)=>{he!==ee&&me.cancel()})}}e.$Kg=v;function $(Z,ee,pe){let me;const he=setTimeout(()=>{me?.(void 0),pe?.()},ee);return Promise.race([Z.finally(()=>clearTimeout(he)),new Promise(Ee=>me=Ee)])}e.$Lg=$;function d(Z){return new Promise((ee,pe)=>{const me=Z();f(me)?me.then(ee,pe):ee(me)})}e.$Mg=d;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ee,!this.b){const pe=()=>{if(this.b=null,this.f)return;const me=this.queue(this.d);return this.d=null,me};this.b=new Promise(me=>{this.a.then(pe,pe).then(me)})}return new Promise((pe,me)=>{this.b.then(pe,me)})}return this.a=ee(),new Promise((pe,me)=>{this.a.then(he=>{this.a=null,pe(he)},he=>{this.a=null,me(he)})})}dispose(){this.f=!0}}e.$Ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.$Og=i;class l{constructor(){this.a=new Map}queue(ee,pe){const he=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(ee)===he&&this.a.delete(ee)});return this.a.set(ee,he),he}}e.$Pg=l;const p=(Z,ee)=>{let pe=!0;const me=setTimeout(()=>{pe=!1,ee()},Z);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(me),pe=!1}}},E=Z=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,Z())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class m{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,pe=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((he,Ee)=>{this.d=he,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const he=this.g;return this.g=null,he()}}));const me=()=>{this.a=null,this.d?.(null)};return this.a=pe===D.$Kd?E(me):p(pe,me),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=m;class n{constructor(ee){this.a=new m(ee),this.b=new t}trigger(ee,pe){return this.a.trigger(()=>this.b.queue(ee),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=n;class r{constructor(){this.a=!1,this.b=new Promise((ee,pe)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=r;class s extends r{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.$Tg=s;function o(Z,ee){return ee?new Promise((pe,me)=>{const he=setTimeout(()=>{Ee.dispose(),pe()},Z),Ee=ee.onCancellationRequested(()=>{clearTimeout(he),Ee.dispose(),me(new M.$5)})}):R(pe=>o(Z,pe))}e.$Ug=o;function g(Z,ee=0,pe){const me=setTimeout(()=>{Z(),pe&&he.dispose()},ee),he=(0,L.$Qc)(()=>{clearTimeout(me),pe?.deleteAndLeak(he)});return pe?.add(he),he}e.$Vg=g;function h(Z){const ee=[];let pe=0;const me=Z.length;function he(){return pe<me?Z[pe++]():null}function Ee(re){re!=null&&ee.push(re);const le=he();return le?le.then(Ee):Promise.resolve(ee)}return Promise.resolve(null).then(Ee)}e.$Wg=h;function C(Z,ee=me=>!!me,pe=null){let me=0;const he=Z.length,Ee=()=>{if(me>=he)return Promise.resolve(pe);const re=Z[me++];return Promise.resolve(re()).then(ne=>ee(ne)?Promise.resolve(ne):Ee())};return Ee()}e.$Xg=C;function I(Z,ee=me=>!!me,pe=null){if(Z.length===0)return Promise.resolve(pe);let me=Z.length;const he=()=>{me=-1;for(const Ee of Z)Ee.cancel?.()};return new Promise((Ee,re)=>{for(const le of Z)le.then(ne=>{--me>=0&&ee(ne)?(he(),Ee(ne)):me===0&&Ee(pe)}).catch(ne=>{--me>=0&&(he(),re(ne))})})}e.$Yg=I;class c{constructor(ee){this.a=0,this.d=ee,this.f=[],this.b=0,this.g=new P.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(ee){return this.a++,new Promise((pe,me)=>{this.f.push({factory:ee,c:pe,e:me}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ee=this.f.shift();this.b++;const pe=ee.factory();pe.then(ee.c,ee.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=c;class y extends c{constructor(){super(1)}}e.$1g=y;class b{constructor(){this.a=new De,this.b=0}queue(ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ee())):this.a.run(this.b++,ee())}}e.$2g=b;class S{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ee=new $e;return this.b.add(ee),ee.p}g(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueFor(ee,pe=A.$lg){const me=pe.getComparisonKey(ee);let he=this.a.get(me);if(!he){he=new y;const Ee=this.f++,re=P.Event.once(he.onDrained)(()=>{he?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$1c),this.d.set(Ee,re),this.a.set(me,he)}return he}h(){this.g()&&this.j()}j(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=S;class j{constructor(ee,pe){this.a=-1,typeof ee=="function"&&typeof pe=="number"&&this.setIfNotSet(ee,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},pe)}setIfNotSet(ee,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},pe))}}e.$4g=j;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ee,pe){this.cancel(),this.a=setInterval(()=>{ee()},pe)}}e.$5g=O;class K{constructor(ee,pe){this.b=-1,this.a=ee,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=K;class B{constructor(ee,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=ee,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=B;class T extends K{constructor(ee,pe){super(ee,pe),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.$8g=T;class z extends L.$Sc{constructor(ee,pe){super(),this.g=ee,this.h=pe,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const pe of ee)this.a.push(pe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=Z=>{(0,u.$B)(()=>{if(ee)return;const pe=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$0g=(Z,ee)=>{const pe=requestIdleCallback(Z,typeof ee=="number"?{timeout:ee}:void 0);let me=!1;return{dispose(){me||(me=!0,cancelIdleCallback(pe))}}}}();class ie{constructor(ee){this.d=!1,this.a=()=>{try{this.f=ee()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=ie;async function X(Z,ee,pe){let me;for(let he=0;he<pe;he++)try{return await Z()}catch(Ee){me=Ee,await o(ee)}throw me}e.$_g=X;class De{isRunning(ee){return typeof ee=="number"?this.a?.taskId===ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ee,pe,me){return this.a={taskId:ee,cancel:()=>me?.(),promise:pe},pe.then(()=>this.d(ee),()=>this.d(ee)),pe}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this.b)this.b.run=ee;else{let pe,me;const he=new Promise((Ee,re)=>{pe=Ee,me=re});this.b={run:ee,promise:he,promiseResolve:pe,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=De;class Pe{constructor(ee,pe=()=>Date.now()){this.d=ee,this.f=pe,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.$bh=Pe;var ke;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(ke||(ke={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ee,pe)=>{this.a=ee,this.b=pe})}complete(ee){return new Promise(pe=>{this.a(ee),this.d={outcome:0,value:ee},pe()})}error(ee){return new Promise(pe=>{this.b(ee),this.d={outcome:1,value:ee},pe()})}cancel(){return this.error(new M.$5)}}e.$ch=$e;var ye;(function(Z){async function ee(me){let he;const Ee=await Promise.all(me.map(re=>re.then(le=>le,le=>{he||(he=le)})));if(typeof he<"u")throw he;return Ee}Z.settled=ee;function pe(me){return new Promise(async(he,Ee)=>{try{await me(he,Ee)}catch(re){Ee(re)}})}Z.withAsyncBody=pe})(ye||(e.Promises=ye={}));var ue;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(ue||(ue={}));class ae{static fromArray(ee){return new ae(pe=>{pe.emitMany(ee)})}static fromPromise(ee){return new ae(async pe=>{pe.emitMany(await ee)})}static fromPromises(ee){return new ae(async pe=>{await Promise.all(ee.map(async me=>pe.emitOne(await me)))})}static merge(ee){return new ae(async pe=>{await Promise.all(ee.map(async me=>{for await(const he of me)pe.emitOne(he)}))})}static{this.EMPTY=ae.fromArray([])}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new P.$Nd,queueMicrotask(async()=>{const pe={emitOne:me=>this.g(me),emitMany:me=>this.h(me),reject:me=>this.k(me)};try{await Promise.resolve(ee(pe)),this.j()}catch(me){this.k(me)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,pe){return new ae(async me=>{for await(const he of ee)me.emitOne(pe(he))})}map(ee){return ae.map(this,ee)}static filter(ee,pe){return new ae(async me=>{for await(const he of ee)pe(he)&&me.emitOne(he)})}filter(ee){return ae.filter(this,ee)}static coalesce(ee){return ae.filter(ee,pe=>!!pe)}coalesce(){return ae.coalesce(this)}static async toPromise(ee){const pe=[];for await(const me of ee)pe.push(me);return pe}toPromise(){return ae.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}e.$dh=ae;class we extends ae{constructor(ee,pe){super(pe),this.l=ee}cancel(){this.l.cancel()}}e.$eh=we;function _(Z){const ee=new w.$Xd,pe=Z(ee.token);return new we(ee,async me=>{const he=ee.token.onCancellationRequested(()=>{he.dispose(),ee.dispose(),me.reject(new M.$5)});try{for await(const Ee of pe){if(ee.token.isCancellationRequested)return;me.emitOne(Ee)}he.dispose(),ee.dispose()}catch(Ee){he.dispose(),ee.dispose(),me.reject(Ee)}})}e.$fh=_;class W{constructor(){this.a=new $e,this.b=new ae(me=>{if(ee){me.reject(ee);return}return pe&&me.emitMany(pe),this.d=he=>me.reject(he),this.f=he=>me.emitOne(he),this.a.p});let ee,pe;this.f=me=>{pe||(pe=[]),pe.push(me)},this.d=me=>{ee||(ee=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ee){this.d(ee),this.a.complete()}emitOne(ee){this.f(ee)}}e.$gh=W}),define(Ae[38],Re([1,0,18,12,44,28,20,23,16]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=void 0;function f(){return Object.create(null)}e.$rj=f,e.$sj="**",e.$tj="/";const R="[/\\\\]",k="[^/\\\\]",a=/\//g;function v(De,Pe){switch(De){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${Pe?`|${R}${k}+`:""})*?`}}function $(De,Pe){if(!De)return[];const ke=[];let $e=!1,ye=!1,ue="";for(const ae of De){switch(ae){case Pe:if(!$e&&!ye){ke.push(ue),ue="";continue}break;case"{":$e=!0;break;case"}":$e=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}ue+=ae}return ue&&ke.push(ue),ke}e.$uj=$;function d(De){if(!De)return"";let Pe="";const ke=$(De,e.$tj);if(ke.every($e=>$e===e.$sj))Pe=".*";else{let $e=!1;ke.forEach((ye,ue)=>{if(ye===e.$sj){if($e)return;Pe+=v(2,ue===ke.length-1)}else{let ae=!1,we="",_=!1,W="";for(const Z of ye){if(Z!=="}"&&ae){we+=Z;continue}if(_&&(Z!=="]"||!W)){let ee;Z==="-"?ee=Z:(Z==="^"||Z==="!")&&!W?ee="^":Z===e.$tj?ee="":ee=(0,D.$Fe)(Z),W+=ee;continue}switch(Z){case"{":ae=!0;continue;case"[":_=!0;continue;case"}":{const pe=`(?:${$(we,",").map(me=>d(me)).join("|")})`;Pe+=pe,ae=!1,we="";break}case"]":{Pe+="["+W+"]",_=!1,W="";break}case"?":Pe+=k;continue;case"*":Pe+=v(1);continue;default:Pe+=(0,D.$Fe)(Z)}}ue<ke.length-1&&(ke[ue+1]!==e.$sj||ue+2<ke.length)&&(Pe+=R)}$e=ye===e.$sj})}return Pe}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Dc(1e4),r=function(){return!1},s=function(){return null};function o(De,Pe){if(!De)return s;let ke;typeof De!="string"?ke=De.pattern:ke=De,ke=ke.trim();const $e=`${ke}_${!!Pe.trimForExclusions}`;let ye=n.get($e);if(ye)return g(ye,De);let ue;return t.test(ke)?ye=C(ke.substr(4),ke):(ue=i.exec(h(ke,Pe)))?ye=I(ue[1],ke):(Pe.trimForExclusions?p:l).test(ke)?ye=c(ke,Pe):(ue=E.exec(h(ke,Pe)))?ye=y(ue[1].substr(1),ke,!0):(ue=m.exec(h(ke,Pe)))?ye=y(ue[1],ke,!1):ye=b(ke),n.set($e,ye),g(ye,De)}function g(De,Pe){if(typeof Pe=="string")return De;const ke=function($e,ye){return(0,P.$Xf)($e,Pe.base,!u.$l)?De((0,D.$Je)($e.substr(Pe.base.length),A.sep),ye):null};return ke.allBasenames=De.allBasenames,ke.allPaths=De.allPaths,ke.basenames=De.basenames,ke.patterns=De.patterns,ke}function h(De,Pe){return Pe.trimForExclusions&&De.endsWith("/**")?De.substr(0,De.length-2):De}function C(De,Pe){return function(ke,$e){return typeof ke=="string"&&ke.endsWith(De)?Pe:null}}function I(De,Pe){const ke=`/${De}`,$e=`\\${De}`,ye=function(ae,we){return typeof ae!="string"?null:we?we===De?Pe:null:ae===De||ae.endsWith(ke)||ae.endsWith($e)?Pe:null},ue=[De];return ye.basenames=ue,ye.patterns=[Pe],ye.allBasenames=ue,ye}function c(De,Pe){const ke=ie(De.slice(1,-1).split(",").map(we=>o(we,Pe)).filter(we=>we!==s),De),$e=ke.length;if(!$e)return s;if($e===1)return ke[0];const ye=function(we,_){for(let W=0,Z=ke.length;W<Z;W++)if(ke[W](we,_))return De;return null},ue=ke.find(we=>!!we.allBasenames);ue&&(ye.allBasenames=ue.allBasenames);const ae=ke.reduce((we,_)=>_.allPaths?we.concat(_.allPaths):we,[]);return ae.length&&(ye.allPaths=ae),ye}function y(De,Pe,ke){const $e=A.sep===A.$gc.sep,ye=$e?De:De.replace(a,A.sep),ue=A.sep+ye,ae=A.$gc.sep+De;let we;return ke?we=function(_,W){return typeof _=="string"&&(_===ye||_.endsWith(ue)||!$e&&(_===De||_.endsWith(ae)))?Pe:null}:we=function(_,W){return typeof _=="string"&&(_===ye||!$e&&_===De)?Pe:null},we.allPaths=[(ke?"*/":"./")+De],we}function b(De){try{const Pe=new RegExp(`^${d(De)}$`);return function(ke){return Pe.lastIndex=0,typeof ke=="string"&&Pe.test(ke)?De:null}}catch{return s}}function S(De,Pe,ke){return!De||typeof Pe!="string"?!1:j(De)(Pe,void 0,ke)}e.$vj=S;function j(De,Pe={}){if(!De)return r;if(typeof De=="string"||O(De)){const ke=o(De,Pe);if(ke===s)return r;const $e=function(ye,ue){return!!ke(ye,ue)};return ke.allBasenames&&($e.allBasenames=ke.allBasenames),ke.allPaths&&($e.allPaths=ke.allPaths),$e}return T(De,Pe)}e.$wj=j;function O(De){const Pe=De;return Pe?typeof Pe.base=="string"&&typeof Pe.pattern=="string":!1}e.$xj=O;function K(De){return De.allBasenames||[]}e.$yj=K;function B(De){return De.allPaths||[]}e.$zj=B;function T(De,Pe){const ke=ie(Object.getOwnPropertyNames(De).map(we=>z(we,De[we],Pe)).filter(we=>we!==s)),$e=ke.length;if(!$e)return s;if(!ke.some(we=>!!we.requiresSiblings)){if($e===1)return ke[0];const we=function(Z,ee){let pe;for(let me=0,he=ke.length;me<he;me++){const Ee=ke[me](Z,ee);if(typeof Ee=="string")return Ee;(0,M.$Gg)(Ee)&&(pe||(pe=[]),pe.push(Ee))}return pe?(async()=>{for(const me of pe){const he=await me;if(typeof he=="string")return he}return null})():null},_=ke.find(Z=>!!Z.allBasenames);_&&(we.allBasenames=_.allBasenames);const W=ke.reduce((Z,ee)=>ee.allPaths?Z.concat(ee.allPaths):Z,[]);return W.length&&(we.allPaths=W),we}const ye=function(we,_,W){let Z,ee;for(let pe=0,me=ke.length;pe<me;pe++){const he=ke[pe];he.requiresSiblings&&W&&(_||(_=(0,A.$nc)(we)),Z||(Z=_.substr(0,_.length-(0,A.$oc)(we).length)));const Ee=he(we,_,Z,W);if(typeof Ee=="string")return Ee;(0,M.$Gg)(Ee)&&(ee||(ee=[]),ee.push(Ee))}return ee?(async()=>{for(const pe of ee){const me=await pe;if(typeof me=="string")return me}return null})():null},ue=ke.find(we=>!!we.allBasenames);ue&&(ye.allBasenames=ue.allBasenames);const ae=ke.reduce((we,_)=>_.allPaths?we.concat(_.allPaths):we,[]);return ae.length&&(ye.allPaths=ae),ye}function z(De,Pe,ke){if(Pe===!1)return s;const $e=o(De,ke);if($e===s)return s;if(typeof Pe=="boolean")return $e;if(Pe){const ye=Pe.when;if(typeof ye=="string"){const ue=(ae,we,_,W)=>{if(!W||!$e(ae,we))return null;const Z=ye.replace("$(basename)",()=>_),ee=W(Z);return(0,M.$Gg)(ee)?ee.then(pe=>pe?De:null):ee?De:null};return ue.requiresSiblings=!0,ue}}return $e}function ie(De,Pe){const ke=De.filter(we=>!!we.basenames);if(ke.length<2)return De;const $e=ke.reduce((we,_)=>{const W=_.basenames;return W?we.concat(W):we},[]);let ye;if(Pe){ye=[];for(let we=0,_=$e.length;we<_;we++)ye.push(Pe)}else ye=ke.reduce((we,_)=>{const W=_.patterns;return W?we.concat(W):we},[]);const ue=function(we,_){if(typeof we!="string")return null;if(!_){let Z;for(Z=we.length;Z>0;Z--){const ee=we.charCodeAt(Z-1);if(ee===47||ee===92)break}_=we.substr(Z)}const W=$e.indexOf(_);return W!==-1?ye[W]:null};ue.basenames=$e,ue.patterns=ye,ue.allBasenames=$e;const ae=De.filter(we=>!we.basenames);return ae.push(ue),ae}function X(De,Pe){return(0,w.$ub)(De,Pe,(ke,$e)=>typeof ke=="string"&&typeof $e=="string"?ke===$e:typeof ke!="string"&&typeof $e!="string"?ke.base===$e.base&&ke.pattern===$e.pattern:!1)}e.$Aj=X}),define(Ae[51],Re([1,0,11,121,24,16,2]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.MarkdownStringTextNewlineStyle=void 0;var u;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(u||(e.MarkdownStringTextNewlineStyle=u={}));class D{constructor(i="",l=!1){if(this.value=i,typeof this.value!="string")throw(0,w.$7)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(i,l=0){return this.value+=a(this.supportThemeIcons?(0,M.$Wj)(i):i).replace(/([ \t]+)/g,(p,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,l){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}appendLink(i,l,p){return this.value+="[",this.value+=this.c(l,"]"),this.value+="](",this.value+=this.c(String(i),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(i,l){const p=new RegExp((0,L.$Fe)(l),"g");return i.replace(p,(E,m)=>i.charAt(m-1)!=="\\"?`\\${E}`:E)}}e.$3j=D;function f(t){return R(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$4j=f;function R(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$5j=R;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$og)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$6j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$7j=a;function v(t){return t.replace(/"/g,"&quot;")}e.$8j=v;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$9j=$;function d(t){const i=[],l=t.split("|").map(E=>E.trim());t=l[0];const p=l[1];if(p){const E=/height=(\d+)/.exec(p),m=/width=(\d+)/.exec(p),n=E?E[1]:"",r=m?m[1]:"",s=isFinite(parseInt(r)),o=isFinite(parseInt(n));s&&i.push(`width="${r}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$0j=d}),define(Ae[90],Re([1,0,18,44,20,23,24,16]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=void 0;function D(o,g){const{os:h,tildify:C,relative:I}=g;if(I){const b=f(o,I,h);if(typeof b=="string")return b}let c=o.fsPath;if(h===1&&!L.$j?c=c.replace(/\//g,"\\"):h!==1&&L.$j&&(c=c.replace(/\\/g,"/")),h!==1&&C?.userHome){const b=C.userHome.fsPath;let S;o.scheme!==C.userHome.scheme&&o.path.startsWith(P.$gc.sep)?S=C.userHome.with({path:o.path}).fsPath:S=o.fsPath,c=a(S,b,h)}return(h===1?P.$fc:P.$gc).normalize(R(c,h===1))}e.$rv=D;function f(o,g,h){const C=h===1?P.$fc:P.$gc,I=h===3?A.$lg:A.$ng,c=g.getWorkspace(),y=(0,w.$Ob)(c.folders);if(!y)return;o.scheme!==y.uri.scheme&&o.path.startsWith(P.$gc.sep)&&(o=y.uri.with({path:o.path}));const b=g.getWorkspaceFolder(o);if(!b)return;let S;if(I.isEqual(b.uri,o)?S="":S=I.relativePath(b.uri,o)??"",S&&(S=C.normalize(S)),c.folders.length>1&&!g.noPrefix){const j=b.name?b.name:I.basenameOrAuthority(b.uri);S=S?`${j} \u2022 ${S}`:j}return S}function R(o,g=L.$j){return(0,M.$2f)(o,g)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$sv=R;let k=Object.create(null);function a(o,g,h=L.OS){if(h===1||!o||!g)return o;let C=k.original===g?k.normalized:void 0;C||(C=g,L.$j&&(C=(0,M.$Rf)(C)),C=`${(0,u.$Ke)(C,P.$gc.sep)}${P.$gc.sep}`,k={original:g,normalized:C});let I=o;return L.$j&&(I=(0,M.$Rf)(I)),(h===3?I.startsWith(C):(0,u.$3e)(I,C))?`~/${I.substr(C.length)}`:o}e.$tv=a;function v(o,g){return o.replace(/^~($|\/|\\)/,`${g}$1`)}e.$uv=v;const $="\u2026",d="\\\\",t="~";function i(o,g=P.sep){const h=new Array(o.length);let C=!1;for(let I=0;I<o.length;I++){const c=o[I];if(c===""){h[I]=`.${g}`;continue}if(!c){h[I]=c;continue}C=!0;let y="",b=c;b.indexOf(d)===0?(y=b.substr(0,b.indexOf(d)+d.length),b=b.substr(b.indexOf(d)+d.length)):b.indexOf(g)===0?(y=b.substr(0,b.indexOf(g)+g.length),b=b.substr(b.indexOf(g)+g.length)):b.indexOf(t)===0&&(y=b.substr(0,b.indexOf(t)+t.length),b=b.substr(b.indexOf(t)+t.length));const S=b.split(g);for(let j=1;C&&j<=S.length;j++)for(let O=S.length-j;C&&O>=0;O--){C=!1;let K=S.slice(O,O+j).join(g);for(let B=0;!C&&B<o.length;B++)if(B!==I&&o[B]&&o[B].indexOf(K)>-1){const T=O+j===S.length,z=O>0&&o[B].indexOf(g)>-1?g+K:K,ie=o[B].endsWith(z);C=!T||ie}if(!C){let B="";(S[0].endsWith(":")||y!=="")&&(O===1&&(O=0,j++,K=S[0]+g+K),O>0&&(B=S[0]+g),B=y+B),O>0&&(B=B+$+g),B=B+K,O+j<S.length&&(B=B+g+$),h[I]=B}}C&&(h[I]=c)}return h}e.$vv=i;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function p(o,g=Object.create(null)){const h=[];let C=!1,I="";for(const c of o)if(c==="$"||C&&c==="{")I&&h.push({value:I,type:l.TEXT}),I="",C=!0;else if(c==="}"&&C){const y=g[I];if(typeof y=="string")y.length&&h.push({value:y,type:l.VARIABLE});else if(y){const b=h[h.length-1];(!b||b.type!==l.SEPARATOR)&&h.push({value:y.label,type:l.SEPARATOR})}I="",C=!1}else I+=c;return I&&!C&&h.push({value:I,type:l.TEXT}),h.filter((c,y)=>{if(c.type===l.SEPARATOR){const b=h[y-1],S=h[y+1];return[b,S].every(j=>j&&(j.type===l.VARIABLE||j.type===l.TEXT)&&j.value.length>0)}return!0}).map(c=>c.value).join("")}e.$wv=p;function E(o,g){return L.$k||g?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$k?"&":"&&"):o.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$xv=E;function m(o,g){return L.$k||g?o.replace(/\(&&\w\)|&&/g,""):L.$j?o.replace(/&&|&/g,h=>h==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$yv=m;function n(o){return o.replace(/&/g,"&&")}e.$zv=n;function r(o){if(o.endsWith("]")){const g=o.lastIndexOf(" [",o.length-2);if(g!==-1){const h=s(o.substring(0,g));return{name:h.name,parentPath:h.parentPath+o.substring(g)}}}return s(o)}e.$Av=r;function s(o){const g=o.indexOf("/")!==-1?P.$gc:P.$fc,h=g.basename(o),C=g.dirname(o);return h.length?{name:h,parentPath:C}:{name:C,parentPath:""}}}),define(Ae[132],Re([1,0,26,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0;function P(k){return k.toJSON()}class L{constructor(a){this.a=a}transformIncoming(a){const v=this.a.transformIncoming(a);return v===a?a:P(M.URI.from(v))}transformOutgoing(a){const v=this.a.transformOutgoing(a);return v===a?a:P(M.URI.from(v))}transformOutgoingURI(a){const v=this.a.transformOutgoing(a);return v===a?a:M.URI.from(v)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Lm=L,e.$Mm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,a,v){if(!k||v>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return a.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const d=A(k[$],a,v+1);d!==null&&(k[$]=d)}}return null}function u(k,a){const v=A(k,a,0);return v===null?k:v}e.$Nm=u;function D(k,a,v,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return v?M.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof w.$be)return null;for(const d in k)if(Object.hasOwnProperty.call(k,d)){const t=D(k[d],a,v,$+1);t!==null&&(k[d]=t)}}return null}function f(k,a){const v=D(k,a,!1,0);return v===null?k:v}e.$Om=f;function R(k,a){const v=D(k,a,!0,0);return v===null?k:v}e.$Pm=R}),define(Ae[133],Re([1,0,38,20]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tE=void 0;function P(L,A,u,D,f,R){if(Array.isArray(L)){let k=0;for(const a of L){const v=P(a,A,u,D,f,R);if(v===10)return v;v>k&&(k=v)}return k}else{if(typeof L=="string")return D?L==="*"?5:L===u?10:0:0;if(L){const{language:k,pattern:a,scheme:v,hasAccessToAllModels:$,notebookType:d}=L;if(!D&&!$)return 0;d&&f&&(A=f);let t=0;if(v)if(v===A.scheme)t=10;else if(v==="*")t=5;else return 0;if(k)if(k===u)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(d)if(d===R)t=10;else if(d==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,M.$hc)(a.base)},i===A.fsPath||(0,w.$vj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$tE=P}),define(Ae[91],Re([1,0,26,23]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30=e.$20=void 0;var P;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(P||(P={}));function L(k){for(let a=0,v=k.length;a<v;a+=4){const $=k[a+0],d=k[a+1],t=k[a+2],i=k[a+3];k[a+0]=i,k[a+1]=t,k[a+2]=d,k[a+3]=$}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||L(a),w.$be.wrap(a)}function u(k){const a=k.buffer;if(M.$D()||L(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const v=new Uint8Array(a.byteLength);return v.set(a),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function D(k){const a=new Uint32Array(f(k));let v=0;if(a[v++]=k.id,k.type==="full")a[v++]=1,a[v++]=k.data.length,a.set(k.data,v),v+=k.data.length;else{a[v++]=2,a[v++]=k.deltas.length;for(const $ of k.deltas)a[v++]=$.start,a[v++]=$.deleteCount,$.data?(a[v++]=$.data.length,a.set($.data,v),v+=$.data.length):a[v++]=0}return A(a)}e.$20=D;function f(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const v of k.deltas)v.data&&(a+=v.data.length)}return a}function R(k){const a=u(k);let v=0;const $=a[v++];if(a[v++]===1){const l=a[v++],p=a.subarray(v,v+l);return v+=l,{id:$,type:"full",data:p}}const t=a[v++],i=[];for(let l=0;l<t;l++){const p=a[v++],E=a[v++],m=a[v++];let n;m>0&&(n=a.subarray(v,v+m),v+=m),i[l]={start:p,deleteCount:E,data:n}}return{id:$,type:"delta",deltas:i}}e.$30=R}),define(Ae[134],Re([9,10]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,25,23,123,136,134]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=f;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(Q,ve,Be,Oe){this.id=Q,this.name=ve,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,ve){return v(Q,ve)}compute(Q,ve,Be){return Be}}class a{constructor(Q,ve){this.newValue=Q,this.didChange=ve}}e.ApplyUpdateResult=a;function v(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new a(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Be=Array.isArray(Y)&&Array.isArray(Q)&&w.$ub(Y,Q);return new a(Q,!Be)}let ve=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const Oe=v(Y[Be],Q[Be]);Oe.didChange&&(Y[Be]=Oe.newValue,ve=!0)}return new a(Y,ve)}class ${constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ve){return v(Q,ve)}validate(Q){return this.defaultValue}}class d{constructor(Q,ve,Be,Oe){this.id=Q,this.name=ve,this.defaultValue=Be,this.schema=Oe}applyUpdate(Q,ve){return v(Q,ve)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ve,Be){return Be}}function t(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:!!Y}e.boolean=t;class i extends d{constructor(Q,ve,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Be),super(Q,ve,Be,Oe)}validate(Q){return t(Q,this.defaultValue)}}function l(Y,Q,ve,Be){if(typeof Y>"u")return Q;let Oe=parseInt(Y,10);return isNaN(Oe)?Q:(Oe=Math.max(ve,Oe),Oe=Math.min(Be,Oe),Oe|0)}e.clampedInt=l;class p extends d{static clampedInt(Q,ve,Be,Oe){return l(Q,ve,Be,Oe)}constructor(Q,ve,Be,Oe,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Oe,nt.maximum=Xe),super(Q,ve,Be,nt),this.minimum=Oe,this.maximum=Xe}validate(Q){return p.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function E(Y,Q,ve,Be){if(typeof Y>"u")return Q;const Oe=m.float(Y,Q);return m.clamp(Oe,ve,Be)}e.clampedFloat=E;class m extends d{static clamp(Q,ve,Be){return Q<ve?ve:Q>Be?Be:Q}static float(Q,ve){if(typeof Q=="number")return Q;if(typeof Q>"u")return ve;const Be=parseFloat(Q);return isNaN(Be)?ve:Be}constructor(Q,ve,Be,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,ve,Be,Xe),this.validationFn=Oe}validate(Q){return this.validationFn(m.float(Q,this.defaultValue))}}class n extends d{static string(Q,ve){return typeof Q!="string"?ve:Q}constructor(Q,ve,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Be),super(Q,ve,Be,Oe)}validate(Q){return n.string(Q,this.defaultValue)}}function r(Y,Q,ve,Be){return typeof Y!="string"?Q:Be&&Y in Be?Be[Y]:ve.indexOf(Y)===-1?Q:Y}e.stringSet=r;class s extends d{constructor(Q,ve,Be,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=Be),super(Q,ve,Be,Xe),this.c=Oe}validate(Q){return r(Q,this.defaultValue,this.c)}}class o extends k{constructor(Q,ve,Be,Oe,Xe,nt,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=Xe,$t.default=Oe),super(Q,ve,Be,$t),this.c=Xe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function g(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",tags:["accessibility"],description:u.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ve,Be){return Be===0?Q.accessibilitySupport:Be}}class C extends k{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:u.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{insertSpace:t(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function c(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function b(Y){switch(Y){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function S(Y){switch(Y){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class j extends ${constructor(){super(140)}compute(Q,ve,Be){const Oe=["monaco-editor"];return ve.get(39)&&Oe.push(ve.get(39)),Q.extraEditorClassName&&Oe.push(Q.extraEditorClassName),ve.get(73)==="default"?Oe.push("mouse-default"):ve.get(73)==="copy"&&Oe.push("mouse-copy"),ve.get(110)&&Oe.push("showUnused"),ve.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class O extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(Q,ve,Be){return Be&&Q.emptySelectionClipboard}}class K extends k{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:u.localize(16,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:u.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{cursorMoveOnType:t(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ve.loop,this.defaultValue.loop)}}}class B extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.ON:Q:Q?B.ON:B.OFF}}e.EditorFontLigatures=B;class T extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",T.OFF,{anyOf:[{type:"boolean",description:u.localize(22,null)},{type:"string",description:u.localize(23,null)}],description:u.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?T.OFF:Q==="true"?T.TRANSLATE:Q:Q?T.TRANSLATE:T.OFF}compute(Q,ve,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=T;class z extends ${constructor(){super(50)}compute(Q,ve,Be){return Q.fontInfo}}class ie extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(25,null)})}validate(Q){const ve=m.float(Q,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(ve,6,100)}compute(Q,ve,Be){return Q.fontInfo.fontSize}}class X extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:u.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(p.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class De extends k{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[u.localize(28,null),u.localize(29,null),u.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:u.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:u.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:u.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:u.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:u.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:u.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:u.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:u.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{multiple:r(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??r(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??r(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??r(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??r(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??r(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Pe extends k{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:u.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:u.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:u.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:u.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:u.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),delay:p.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:t(ve.sticky,this.defaultValue.sticky),hidingDelay:p.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ve.above,this.defaultValue.above)}}}var ke;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class $e extends ${constructor(){super(143)}compute(Q,ve,Be){return $e.computeLayout(ve,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const ve=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let Oe=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Oe=Math.max(Oe,ve-1));const Xe=(Be+Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:nt}}static c(Q,ve){const Be=Q.outerWidth,Oe=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=ve.stableMinimapLayoutInput,$t=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,bt=Q.lineHeight,Pt=Q.typicalHalfwidthCharacterWidth,qt=Q.scrollBeyondLastLine,Ht=Q.minimap.renderCharacters;let vt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Ut=Q.minimap.maxColumn,Nt=Q.minimap.size,Gt=Q.minimap.side,jt=Q.verticalScrollbarWidth,kt=Q.viewLineCount,Lt=Q.remainingWidth,Bt=Q.isViewportWrapping,Jt=Ht?2:3;let Wt=Math.floor(Xe*Oe);const Kt=Wt/Xe;let Ot=!1,at=!1,dt=Jt*vt,At=vt/Xe,Vt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Fe,desiredRatio:ge,minimapLineCount:H}=$e.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:qt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Oe,lineHeight:bt,pixelRatio:Xe});if(kt/H>1)Ot=!0,at=!0,vt=1,dt=1,At=vt/Xe;else{let Ue=!1,Je=vt+1;if(Nt==="fit"){const Ve=Math.ceil((Ie+kt+Fe)*dt);Bt&&$t&&Lt<=ve.stableFitRemainingWidth?(Ue=!0,Je=ve.stableFitMaxMinimapScale):Ue=Ve>Wt}if(Nt==="fill"||Ue){Ot=!0;const Ve=vt;dt=Math.min(bt*Xe,Math.max(1,Math.floor(1/ge))),Bt&&$t&&Lt<=ve.stableFitRemainingWidth&&(Je=ve.stableFitMaxMinimapScale),vt=Math.min(Je,Math.max(1,Math.floor(dt/Jt))),vt>Ve&&(Vt=Math.min(2,vt/Ve)),At=vt/Xe/Vt,Wt=Math.ceil(Math.max(Qt,Ie+kt+Fe)*dt),Bt?(ve.stableMinimapLayoutInput=Q,ve.stableFitRemainingWidth=Lt,ve.stableFitMaxMinimapScale=vt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Rt=Math.floor(Ut*At),ot=Math.min(Rt,Math.max(0,Math.floor((Lt-jt-2)*At/(Pt+At)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Xe*ot);const Tt=wt/Xe;wt=Math.floor(wt*Vt);const Ct=Ht?1:2,We=Gt==="left"?0:Be-ot-jt;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:ot,minimapHeightIsEditorHeight:Ot,minimapIsSampling:at,minimapScale:vt,minimapLineHeight:dt,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:Kt}}static computeLayout(Q,ve){const Be=ve.outerWidth|0,Oe=ve.outerHeight|0,Xe=ve.lineHeight|0,nt=ve.lineNumbersDigitCount|0,$t=ve.typicalHalfwidthCharacterWidth,bt=ve.maxDigitWidth,Pt=ve.pixelRatio,qt=ve.viewLineCount,Ht=Q.get(135),vt=Ht==="inherit"?Q.get(134):Ht,Ut=vt==="inherit"?Q.get(130):vt,Nt=Q.get(133),Gt=ve.isDominatedByLongLines,jt=Q.get(57),kt=Q.get(67).renderType!==0,Lt=Q.get(68),Bt=Q.get(104),Jt=Q.get(83),Wt=Q.get(72),Kt=Q.get(102),Ot=Kt.verticalScrollbarSize,at=Kt.verticalHasArrows,dt=Kt.arrowSize,At=Kt.horizontalScrollbarSize,Vt=Q.get(43),Rt=Q.get(109)!=="never";let ot=Q.get(65);Vt&&Rt&&(ot+=16);let wt=0;if(kt){const Et=Math.max(nt,Lt);wt=Math.round(Et*bt)}let Tt=0;jt&&(Tt=Xe*ve.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Tt,Qt=We+wt,Ie=Qt+ot;const Fe=Be-Tt-wt-ot;let ge=!1,H=!1,Me=-1;vt==="inherit"&&Gt?(ge=!0,H=!0):Ut==="on"||Ut==="bounded"?H=!0:Ut==="wordWrapColumn"&&(Me=Nt);const Ue=$e.c({outerWidth:Be,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:Bt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Wt,verticalScrollbarWidth:Ot,viewLineCount:qt,remainingWidth:Fe,isViewportWrapping:H},ve.memory||new R);Ue.renderMinimap!==0&&Ue.minimapLeft===0&&(Ct+=Ue.minimapWidth,We+=Ue.minimapWidth,Qt+=Ue.minimapWidth,Ie+=Ue.minimapWidth);const Je=Fe-Ue.minimapWidth,Ve=Math.max(1,Math.floor((Je-Ot-2)/$t)),et=at?dt:0;return H&&(Me=Math.max(1,Ve),Ut==="bounded"&&(Me=Math.min(Me,Nt))),{width:Be,height:Oe,glyphMarginLeft:Ct,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:wt,decorationsLeft:Qt,decorationsWidth:ot,contentLeft:Ie,contentWidth:Je,minimap:Ue,viewportColumn:Ve,isWordWrapMinified:ge,isViewportWrapping:H,wrappingColumn:Me,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:At,overviewRuler:{top:et,width:Ot,height:Oe-2*et,right:0}}}}e.EditorLayoutInfoComputer=$e;class ye extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[u.localize(47,null),u.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:u.localize(49,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,ve,Be){return ve.get(2)===2?"advanced":Be}}class ue extends k{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:u.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class ae extends k{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:u.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:u.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:u.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:u.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends k{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:u.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[u.localize(56,null),u.localize(57,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),u.localize(58,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),u.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:u.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:u.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:u.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:r(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(ve.fontFamily,this.defaultValue.fontFamily),padding:t(ve.padding,this.defaultValue.padding)}}}class _ extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):p.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ve,Be){return Be<0?p.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class W extends m{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>m.clamp(Q,0,150),{markdownDescription:u.localize(63,null)})}compute(Q,ve,Be){return Q.fontInfo.lineHeight}}class Z extends k{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:u.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:u.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(66,null),u.localize(67,null),u.localize(68,null)],default:Q.size,description:u.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:u.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:u.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:u.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:u.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),autohide:t(ve.autohide,this.defaultValue.autohide),size:r(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ve.side,this.defaultValue.side,["right","left"]),showSlider:r(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ve.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(ve.scale,1,1,3),maxColumn:p.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(Y){return Y==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class pe extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{top:p.clampedInt(ve.top,0,0,1e3),bottom:p.clampedInt(ve.bottom,0,0,1e3)}}}class me extends k{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:u.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:u.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),cycle:t(ve.cycle,this.defaultValue.cycle)}}}class he extends ${constructor(){super(141)}compute(Q,ve,Be){return Q.pixelRatio}}class Ee extends k{constructor(){const Q={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[u.localize(79,null),u.localize(80,null),u.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:Q.strings,description:u.localize(82,null)},comments:{anyOf:ve,default:Q.comments,description:u.localize(83,null)},other:{anyOf:ve,default:Q.other,description:u.localize(84,null)}},default:Q,markdownDescription:u.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Pt=Q?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Oe}=Q,Xe=["on","inline","off"];let nt,$t,bt;return typeof ve=="boolean"?nt=ve?"on":"off":nt=r(ve,this.defaultValue.other,Xe),typeof Be=="boolean"?$t=Be?"on":"off":$t=r(Be,this.defaultValue.comments,Xe),typeof Oe=="boolean"?bt=Oe?"on":"off":bt=r(Oe,this.defaultValue.strings,Xe),{other:nt,comments:$t,strings:bt}}}var re;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(86,null),u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:"on",description:u.localize(90,null)})}validate(Q){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ve=4,Be=Q):Q==="interval"?ve=3:Q==="relative"?ve=2:Q==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function ne(Y){const Q=Y.get(97);return Q==="editable"?Y.get(90):Q!=="on"}e.filterValidationDecorations=ne;class oe extends k{constructor(){const Q=[],ve={type:"number",description:u.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:u.localize(92,null),format:"color-hex"}}}]},default:Q,description:u.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const ve=[];for(const Be of Q)if(typeof Be=="number")ve.push({column:p.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Oe=Be;ve.push({column:p.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return ve.sort((Be,Oe)=>Be.column-Oe.column),ve}return this.defaultValue}}class fe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ce(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(94,null),u.localize(95,null),u.localize(96,null)],default:"auto",description:u.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(98,null),u.localize(99,null),u.localize(100,null)],default:"auto",description:u.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:u.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:u.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:u.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:u.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q,Be=p.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=p.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(ve.vertical,this.defaultValue.vertical),horizontal:Ce(ve.horizontal,this.defaultValue.horizontal),useShadows:t(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:p.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:p.clampedInt(ve.verticalSliderSize,Oe,0,1e3),scrollByPage:t(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends k{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:u.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:u.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:u.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:u.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:u.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:u.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:u.localize(112,null)}})}applyUpdate(Q,ve){let Be=!1;ve.allowedCharacters&&Q&&(M.$$m(Q.allowedCharacters,ve.allowedCharacters)||(Q={...Q,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&Q&&(M.$$m(Q.allowedLocales,ve.allowedLocales)||(Q={...Q,allowedLocales:ve.allowedLocales},Be=!0));const Oe=super.applyUpdate(Q,ve);return Be?new a(Oe.newValue,!0):Oe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{nonBasicASCII:x(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ve){if(typeof Q!="object"||!Q)return ve;const Be={};for(const[Oe,Xe]of Object.entries(Q))Xe===!0&&(Be[Oe]=!0);return Be}}class G extends k{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:u.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[u.localize(114,null),u.localize(115,null)],description:u.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:u.localize(117,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),mode:r(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends k{constructor(){const Q={enabled:L.$3r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$3r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:u.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:u.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends k{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(120,null),u.localize(121,null),u.localize(122,null)],default:Q.bracketPairs,description:u.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(124,null),u.localize(125,null),u.localize(126,null)],default:Q.bracketPairsHorizontal,description:u.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:u.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:u.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[u.localize(130,null),u.localize(131,null),u.localize(132,null)],default:Q.highlightActiveIndentation,description:u.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{bracketPairs:x(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Y,Q,ve){const Be=ve.indexOf(Y);return Be===-1?Q:ve[Be]}class ce extends k{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(134,null),u.localize(135,null)],default:Q.insertMode,description:u.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:u.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:u.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:u.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[u.localize(140,null),u.localize(141,null),u.localize(142,null),u.localize(143,null)],default:Q.selectionMode,markdownDescription:u.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:u.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:u.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:u.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:u.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:u.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:u.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(181,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{insertMode:r(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ve.showIcons,this.defaultValue.showIcons),showStatusBar:t(ve.showStatusBar,this.defaultValue.showStatusBar),preview:t(ve.preview,this.defaultValue.preview),previewMode:r(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ve.showMethods,this.defaultValue.showMethods),showFunctions:t(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ve.showFields,this.defaultValue.showFields),showVariables:t(ve.showVariables,this.defaultValue.showVariables),showClasses:t(ve.showClasses,this.defaultValue.showClasses),showStructs:t(ve.showStructs,this.defaultValue.showStructs),showInterfaces:t(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ve.showModules,this.defaultValue.showModules),showProperties:t(ve.showProperties,this.defaultValue.showProperties),showEvents:t(ve.showEvents,this.defaultValue.showEvents),showOperators:t(ve.showOperators,this.defaultValue.showOperators),showUnits:t(ve.showUnits,this.defaultValue.showUnits),showValues:t(ve.showValues,this.defaultValue.showValues),showConstants:t(ve.showConstants,this.defaultValue.showConstants),showEnums:t(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ve.showKeywords,this.defaultValue.showKeywords),showWords:t(ve.showWords,this.defaultValue.showWords),showColors:t(ve.showColors,this.defaultValue.showColors),showFiles:t(ve.showFiles,this.defaultValue.showFiles),showReferences:t(ve.showReferences,this.defaultValue.showReferences),showFolders:t(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ve.showSnippets,this.defaultValue.showSnippets),showUsers:t(ve.showUsers,this.defaultValue.showUsers),showIssues:t(ve.showIssues,this.defaultValue.showIssues)}}}class Ne extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:u.localize(183,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[u.localize(184,null),u.localize(185,null),u.localize(186,null),u.localize(187,null)],description:u.localize(188,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ve,Be){return ve.get(2)===2?0:Be}}class Ge extends ${constructor(){super(144)}compute(Q,ve,Be){const Oe=ve.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class _e extends k{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:u.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:u.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[u.localize(191,null),u.localize(192,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),showDropSelector:r(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ze extends k{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:u.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:u.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[u.localize(195,null),u.localize(196,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ve=Q;return{enabled:t(ve.enabled,this.defaultValue.enabled),showPasteSelector:r(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?it:P.$l?tt:xe,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ut;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(ut||(e.EditorOption=ut={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(197,null)})),acceptSuggestionOnEnter:ze(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(198,null),""],markdownDescription:u.localize(199,null)})),accessibilitySupport:ze(new h),accessibilityPageSize:ze(new p(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(200,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",u.localize(201,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:u.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:ze(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(203,null),u.localize(204,null),""],description:u.localize(205,null)})),autoClosingComments:ze(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(206,null),u.localize(207,null),""],description:u.localize(208,null)})),autoClosingDelete:ze(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(209,null),""],description:u.localize(210,null)})),autoClosingOvertype:ze(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(211,null),""],description:u.localize(212,null)})),autoClosingQuotes:ze(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(213,null),u.localize(214,null),""],description:u.localize(215,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[u.localize(216,null),u.localize(217,null),u.localize(218,null),u.localize(219,null),u.localize(220,null)],description:u.localize(221,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(222,null),u.localize(223,null),u.localize(224,null),""],description:u.localize(225,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:u.localize(226,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:u.localize(227,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:u.localize(228,null)})),codeLensFontSize:ze(new p(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(229,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:u.localize(230,null)})),colorDecoratorActivatedOn:ze(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[u.localize(231,null),u.localize(232,null),u.localize(233,null)],description:u.localize(234,null)})),colorDecoratorsLimit:ze(new p(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:u.localize(235,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:u.localize(236,null)})),comments:ze(new C),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:u.localize(237,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:u.localize(238,null)})),cursorSmoothCaretAnimation:ze(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[u.localize(239,null),u.localize(240,null),u.localize(241,null)],description:u.localize(242,null)})),cursorStyle:ze(new o(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],S,{description:u.localize(243,null)})),cursorSurroundingLines:ze(new p(29,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(244,null)})),cursorSurroundingLinesStyle:ze(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(245,null),u.localize(246,null)],markdownDescription:u.localize(247,null)})),cursorWidth:ze(new p(31,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(248,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:u.localize(249,null)})),emptySelectionClipboard:ze(new O),dropIntoEditor:ze(new _e),stickyScroll:ze(new ae),experimentalWhitespaceRendering:ze(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[u.localize(250,null),u.localize(251,null),u.localize(252,null)],description:u.localize(253,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new m(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:u.localize(254,null)})),find:ze(new K),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:u.localize(255,null)})),foldingStrategy:ze(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(256,null),u.localize(257,null)],description:u.localize(258,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:u.localize(259,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:u.localize(260,null)})),foldingMaximumRegions:ze(new p(47,"foldingMaximumRegions",5e3,10,65e3,{description:u.localize(261,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(262,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(263,null)})),fontInfo:ze(new z),fontLigatures2:ze(new B),fontSize:ze(new ie),fontWeight:ze(new X),fontVariations:ze(new T),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:u.localize(264,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:u.localize(265,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:u.localize(266,null)})),gotoLocation:ze(new De),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:u.localize(267,null)})),hover:ze(new Pe),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new m(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>m.clamp(Y,-5,20),{description:u.localize(268,null)})),lightbulb:ze(new ue),lineDecorationsWidth:ze(new _),lineHeight:ze(new W),lineNumbers:ze(new le),lineNumbersMinChars:ze(new p(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:u.localize(269,null)})),links:ze(new i(70,"links",!0,{description:u.localize(270,null)})),matchBrackets:ze(new s(71,"matchBrackets","always",["always","near","never"],{description:u.localize(271,null)})),minimap:ze(new Z),mouseStyle:ze(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new m(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:u.localize(272,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:u.localize(273,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:u.localize(274,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[u.localize(275,null),u.localize(276,null)],markdownDescription:u.localize(277,null)})),multiCursorPaste:ze(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(278,null),u.localize(279,null)],markdownDescription:u.localize(280,null)})),multiCursorLimit:ze(new p(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:u.localize(281,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:u.localize(282,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:u.localize(283,null)})),overviewRulerLanes:ze(new p(82,"overviewRulerLanes",3,0,3)),padding:ze(new pe),pasteAs:ze(new Ze),parameterHints:ze(new me),peekWidgetDefaultFocus:ze(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(284,null),u.localize(285,null)],description:u.localize(286,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:u.localize(287,null)})),quickSuggestions:ze(new Ee),quickSuggestionsDelay:ze(new p(89,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(288,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new fe),renameOnType:ze(new i(92,"renameOnType",!1,{description:u.localize(289,null),markdownDeprecationMessage:u.localize(290,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:u.localize(291,null),restricted:!0})),renderFinalNewline:ze(new s(94,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:u.localize(292,null)})),renderLineHighlight:ze(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(293,null)],description:u.localize(294,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(295,null)})),renderValidationDecorations:ze(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(296,null),u.localize(297,null),u.localize(298,null),""],description:u.localize(299,null)})),revealHorizontalRightPadding:ze(new p(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:u.localize(300,null)})),rulers:ze(new oe),scrollbar:ze(new F),scrollBeyondLastColumn:ze(new p(103,"scrollBeyondLastColumn",4,0,1073741824,{description:u.localize(301,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:u.localize(302,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:u.localize(303,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:u.localize(304,null),included:P.$l})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:u.localize(305,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[u.localize(306,null),u.localize(307,null),u.localize(308,null)],description:u.localize(309,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:u.localize(310,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:u.localize(311,null)})),inlayHints:ze(new we),snippetSuggestions:ze(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(312,null),u.localize(313,null),u.localize(314,null),u.localize(315,null)],description:u.localize(316,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:u.localize(317,null)})),stopRenderingLineAfter:ze(new p(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ce),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:u.localize(318,null)})),suggestFontSize:ze(new p(118,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(319,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new p(119,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(320,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:u.localize(321,null)})),suggestSelection:ze(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(322,null),u.localize(323,null),u.localize(324,null)],description:u.localize(325,null)})),tabCompletion:ze(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(326,null),u.localize(327,null),u.localize(328,null)],description:u.localize(329,null)})),tabIndex:ze(new p(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(330,null),u.localize(331,null),u.localize(332,null)],description:u.localize(333,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:u.localize(334,null)})),wordBreak:ze(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[u.localize(335,null),u.localize(336,null)],description:u.localize(337,null)})),wordSeparators:ze(new n(129,"wordSeparators",A.$4r,{description:u.localize(338,null)})),wordWrap:ze(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(339,null),u.localize(340,null),u.localize(341,null),u.localize(342,null)],description:u.localize(343,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new p(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(344,null)})),wordWrapOverride1:ze(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new j),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:u.localize(345,null)})),pixelRatio:ze(new he),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:u.localize(346,null)})),layoutInfo:ze(new $e),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new ye)}}),define(Ae[137],Re([9,10]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([9,10]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([9,10]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([9,10]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([9,10]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([9,10]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([9,10]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[148],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([9,10]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([9,10]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[162],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([9,10]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([9,10]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([9,10]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,11,139]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.TokenType=void 0;var P;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(P||(e.TokenType=P={}));function L(...f){switch(f.length){case 1:return(0,M.localize)(0,null,f[0]);case 2:return(0,M.localize)(1,null,f[0],f[1]);case 3:return(0,M.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,M.localize)(3,null),u=(0,M.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,w.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,a=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:R}),this.f.push(v)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),a=D.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,a=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(u);return}const $=this.c.charCodeAt(R);if(k)k=!1;else if($===47&&!a){R++;break}else $===91?a=!0:$===92?k=!0:$===93&&(a=!1);R++}for(;R<this.c.length&&D.a.has(this.c.charCodeAt(R));)R++;this.e=R;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ki=D}),define(Ae[170],Re([1,0,24,29,141,280]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,u=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||A.test(i)}e.$Lo=D;function f(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=i.match(A);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$Mo=f;function R(i){if(!i)return null;const l=i.majorBase,p=i.majorMustEqual,E=i.minorBase;let m=i.minorMustEqual;const n=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(l===0||(m=!1),r=!1);let s=0;if(i.preRelease){const o=u.exec(i.preRelease);if(o){const[,g,h,C]=o;s=Date.UTC(Number(g),Number(h)-1,Number(C))}}return{majorBase:l,majorMustEqual:p,minorBase:E,minorMustEqual:m,patchBase:n,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$No=R;function k(i,l,p){let E;typeof i=="string"?E=R(f(i)):E=i;let m;l instanceof Date?m=l.getTime():typeof l=="string"&&(m=new Date(l).getTime());let n;if(typeof p=="string"?n=R(f(p)):n=p,!E||!n)return!1;const r=E.majorBase,s=E.minorBase,o=E.patchBase;let g=n.majorBase,h=n.minorBase,C=n.patchBase;const I=n.notBefore;let c=n.majorMustEqual,y=n.minorMustEqual,b=n.patchMustEqual;return n.isMinimum?r>g?!0:r<g?!1:s>h?!0:s<h||m&&m<I?!1:o>=C:(r===1&&g===0&&(!c||!y||!b)&&(g=1,h=0,C=0,c=!0,y=!1,b=!1),r<g?!1:r>g?!c:s<h?!1:s>h?!y:o<C?!1:o>C?!b:!(m&&m<I))}e.$Oo=k;function a(i,l,p,E,m){const n=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return n.push([M.default.Error,P.localize(0,null)]),n;if(typeof E.name!="string")return n.push([M.default.Error,P.localize(1,null,"name")]),n;if(typeof E.version!="string")return n.push([M.default.Error,P.localize(2,null,"version")]),n;if(!E.engines)return n.push([M.default.Error,P.localize(3,null,"engines")]),n;if(typeof E.engines.vscode!="string")return n.push([M.default.Error,P.localize(4,null,"engines.vscode")]),n;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return n.push([M.default.Error,P.localize(5,null,"extensionDependencies")]),n;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return n.push([M.default.Error,P.localize(6,null,"activationEvents")]),n;if(typeof E.main>"u"&&typeof E.browser>"u")return n.push([M.default.Error,P.localize(7,null,"activationEvents","main","browser")]),n}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&n.push([M.default.Warning,P.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return n.push([M.default.Error,P.localize(9,null,"main")]),n;{const o=(0,w.$vg)(p,E.main);(0,w.$pg)(o,p)||n.push([M.default.Warning,P.localize(10,null,o.path,p.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return n.push([M.default.Error,P.localize(11,null,"browser")]),n;{const o=(0,w.$vg)(p,E.browser);(0,w.$pg)(o,p)||n.push([M.default.Warning,P.localize(12,null,o.path,p.path)])}}if(!L.valid(E.version))return n.push([M.default.Error,P.localize(13,null)]),n;const r=[];if(!v(i,l,E,m,r))for(const o of r)n.push([M.default.Error,o]);return n}e.$Po=a;function v(i,l,p,E,m){return E||typeof p.main>"u"&&typeof p.browser>"u"?!0:d(i,l,p.engines.vscode,m)}e.$Qo=v;function $(i,l,p){return i==="*"||d(l,p,i)}e.$Ro=$;function d(i,l,p,E=[]){const m=R(f(p));if(!m)return E.push(P.localize(14,null,p)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return E.push(P.localize(15,null,p)),!1}else if(!m.majorMustEqual)return E.push(P.localize(16,null,p)),!1;return k(i,l,m)?!0:(E.push(P.localize(17,null,i,p)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let l=0,p=i.length;l<p;l++)if(typeof i[l]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class w{constructor(P,L=[],A=!1){this.ctor=P,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$Mh=w}),define(Ae[70],Re([1,0,69]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.InstantiationType=void 0;const M=[];var P;(function(u){u[u.Eager=0]="Eager",u[u.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function L(u,D,f){D instanceof w.$Mh||(D=new w.$Mh(D,[],!!f)),M.push([u,D])}e.$wr=L;function A(){return M}e.$xr=A}),define(Ae[171],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class w{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$bq=w;class M{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const u=this.lookupOrInsertNode(L),D=this.lookupOrInsertNode(A);u.outgoing.set(D.key,D),D.incoming.set(u.key,u)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const u of this.a.values())u.outgoing.delete(A),u.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let u=this.a.get(A);return u||(u=new w(A,L),this.a.set(A,u)),u}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,u]of this.a)L.push(`${A}
	(-> incoming)[${[...u.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...u.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const u=new Set([L]),D=this.c(A,u);if(D)return D}}c(L,A){for(const[u,D]of L.outgoing){if(A.has(u))return[...A,u].join(" -> ");A.add(u);const f=this.c(D,A);if(f)return f;A.delete(u)}}}e.$cq=M}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function u(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=u})(w||(e._util=w={})),e.$Oh=P("instantiationService");function M(A,u,D){u[w.DI_TARGET]===u?u[w.DI_DEPENDENCIES].push({id:A,index:D}):(u[w.DI_DEPENDENCIES]=[{id:A,index:D}],u[w.DI_TARGET]=u)}function P(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const u=function(D,f,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(u,D,R)};return u.toString=()=>A,w.serviceIds.set(A,u),u}e.$Ph=P;function L(A){return A}e.$Qh=L}),define(Ae[45],Re([1,0,15,2,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.ConfigurationTarget=e.$li=e.$ki=e.$ji=void 0,e.$ji=(0,P.$Ph)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$ki=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$li=A;var u;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(u||(e.ConfigurationTarget=u={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$mi=D;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ni=f;function R(i,l){const p=Object.create(null);for(const E in i)k(p,E,i[E],l);return p}e.$oi=R;function k(i,l,p,E){const m=l.split("."),n=m.pop();let r=i;for(let s=0;s<m.length;s++){const o=m[s];let g=r[o];switch(typeof g){case"undefined":g=r[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${l} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify(g)}`);return}r=g}if(typeof r=="object"&&r!==null)try{r[n]=p}catch{E(`Ignoring ${l} as ${m.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${l} as ${m.join(".")} is ${JSON.stringify(r)}`)}e.$pi=k;function a(i,l){const p=l.split(".");v(i,p)}e.$qi=a;function v(i,l){const p=l.shift();if(l.length===0){delete i[p];return}if(Object.keys(i).indexOf(p)!==-1){const E=i[p];typeof E=="object"&&!Array.isArray(E)&&(v(E,l),Object.keys(E).length===0&&delete i[p])}}function $(i,l,p){function E(r,s){let o=r;for(const g of s){if(typeof o!="object"||o===null)return;o=o[g]}return o}const m=l.split("."),n=E(i,m);return typeof n>"u"?p:n}e.$ri=$;function d(i,l,p){Object.keys(l).forEach(E=>{E!=="__proto__"&&(E in i?w.$Af(i[E])&&w.$Af(l[E])?d(i[E],l[E],p):p&&(i[E]=l[E]):i[E]=l[E])})}e.$si=d;function t(i){return i.replace(/[\[\]]/g,"")}e.$ti=t}),define(Ae[32],Re([1,0,23,16,169,4,138,11]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.ContextKeyExprType=e.$Li=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",w.$k),D.set("isLinux",w.$l),D.set("isWindows",w.$j),D.set("isWeb",w.$p),D.set("isMacNative",w.$k&&!w.$p),D.set("isEdge",w.$H),D.set("isFirefox",w.$F),D.set("isChrome",w.$E),D.set("isSafari",w.$G);function f(_,W){if(D.get(_)!==void 0)throw(0,u.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(_,W)}e.$Li=f;const R=Object.prototype.hasOwnProperty;var k;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},v=(0,A.localize)(0,null),$=(0,A.localize)(1,null),d=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),l=(0,A.localize)(5,null),p=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=a){this.k=W,this.d=new P.$Ki,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const ee=this.D(),pe=ee.type===17?l:void 0;throw this.h.push({message:i,offset:ee.offset,lexeme:P.$Ki.getLexeme(ee),additionalInfo:pe}),m.c}return Z}catch(Z){if(Z!==m.c)throw Z;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const Z=this.o();W.push(Z)}return W.length===1?W[0]:n.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const Z=this.s();W.push(Z)}return W.length===1?W[0]:n.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),g.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const Z=this.l();return this.A(1,t),Z?.negate()}case 17:return this.z(),S.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const Z=this.l();return this.A(1,t),Z}case 17:{const Z=W.lexeme;if(this.z(),this.y(9)){const pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),pe.type!==10)throw this.B("REGEX",pe);const me=pe.lexeme,he=me.lastIndexOf("/"),Ee=he===me.length-1?void 0:this.w(me.substring(he+1));let re;try{re=new RegExp(me.substring(1,he),Ee)}catch{throw this.B("REGEX",pe)}return z.create(Z,re)}switch(pe.type){case 10:case 19:{const me=[pe.lexeme];this.z();let he=this.D(),Ee=0;for(let fe=0;fe<pe.lexeme.length;fe++)pe.lexeme.charCodeAt(fe)===40?Ee++:pe.lexeme.charCodeAt(fe)===41&&Ee--;for(;!this.E()&&he.type!==15&&he.type!==16;){switch(he.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let fe=0;fe<he.lexeme.length;fe++)he.lexeme.charCodeAt(fe)===40?Ee++:pe.lexeme.charCodeAt(fe)===41&&Ee--}if(Ee<0)break;me.push(P.$Ki.getLexeme(he)),this.z(),he=this.D()}const re=me.join(""),le=re.lastIndexOf("/"),ne=le===re.length-1?void 0:this.w(re.substring(le+1));let oe;try{oe=new RegExp(re.substring(1,le),ne)}catch{throw this.B("REGEX",pe)}return n.regex(Z,oe)}case 18:{const me=pe.lexeme;this.z();let he=null;if(!(0,M.$Be)(me)){const Ee=me.indexOf("/"),re=me.lastIndexOf("/");if(Ee!==re&&Ee>=0){const le=me.slice(Ee+1,re),ne=me[re+1]==="i"?"i":"";try{he=new RegExp(le,ne)}catch{throw this.B("REGEX",pe)}}}if(he===null)throw this.B("REGEX",pe);return z.create(Z,he)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const pe=this.u();return n.notIn(Z,pe)}switch(this.D().type){case 3:{this.z();const pe=this.u();if(this.x().type===18)return n.equals(Z,pe);switch(pe){case"true":return n.has(Z);case"false":return n.not(Z);default:return n.equals(Z,pe)}}case 4:{this.z();const pe=this.u();if(this.x().type===18)return n.notEquals(Z,pe);switch(pe){case"true":return n.not(Z);case"false":return n.has(Z);default:return n.notEquals(Z,pe)}}case 5:return this.z(),B.create(Z,this.u());case 6:return this.z(),T.create(Z,this.u());case 7:return this.z(),O.create(Z,this.u());case 8:return this.z(),K.create(Z,this.u());case 13:return this.z(),n.in(Z,this.u());default:return n.has(Z)}}case 20:throw this.h.push({message:p,offset:W.offset,lexeme:"",additionalInfo:E}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,Z){if(this.C(W))return this.z();throw this.B(Z,this.D())}B(W,Z,ee){const pe=(0,A.localize)(8,null,W,P.$Ki.getLexeme(Z)),me=Z.offset,he=P.$Ki.getLexeme(Z);return this.h.push({message:pe,offset:me,lexeme:he,additionalInfo:ee}),m.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Mi=m;class n{static false(){return g.INSTANCE}static true(){return h.INSTANCE}static has(W){return C.create(W)}static equals(W,Z){return I.create(W,Z)}static notEquals(W,Z){return b.create(W,Z)}static regex(W,Z){return z.create(W,Z)}static in(W,Z){return c.create(W,Z)}static notIn(W,Z){return y.create(W,Z)}static not(W){return S.create(W)}static and(...W){return De.create(W,null,!0)}static or(...W){return Pe.create(W,null,!0)}static greater(W,Z){return O.create(W,Z)}static greaterEquals(W,Z){return K.create(W,Z)}static smaller(W,Z){return B.create(W,Z)}static smallerEquals(W,Z){return T.create(W,Z)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Ni=n;function r(_){const W=new m({regexParsingWithErrorRecovery:!1});return _.map(Z=>(W.parse(Z),W.lexingErrors.length>0?W.lexingErrors.map(ee=>({errorMessage:ee.additionalInfo?(0,A.localize)(9,null,ee.additionalInfo):(0,A.localize)(10,null),offset:ee.offset,length:ee.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ee=>({errorMessage:ee.additionalInfo?`${ee.message}. ${ee.additionalInfo}`:ee.message,offset:ee.offset,length:ee.lexeme.length})):[]))}e.$Oi=r;function s(_,W){const Z=_?_.substituteConstants():void 0,ee=W?W.substituteConstants():void 0;return!Z&&!ee?!0:!Z||!ee?!1:Z.equals(ee)}e.$Pi=s;function o(_,W){return _.cmp(W)}class g{static{this.INSTANCE=new g}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return h.INSTANCE}}e.$Qi=g;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return g.INSTANCE}}e.$Ri=h;class C{static create(W,Z=null){const ee=D.get(W);return typeof ee=="boolean"?ee?h.INSTANCE:g.INSTANCE:new C(W,Z)}constructor(W,Z){this.key=W,this.c=Z,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=D.get(this.key);return typeof W=="boolean"?W?h.INSTANCE:g.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=S.create(this.key,this)),this.c}}e.$Si=C;class I{static create(W,Z,ee=null){if(typeof Z=="boolean")return Z?C.create(W,ee):S.create(W,ee);const pe=D.get(W);return typeof pe=="boolean"?Z===(pe?"true":"false")?h.INSTANCE:g.INSTANCE:new I(W,Z,ee)}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const Z=W?"true":"false";return this.d===Z?h.INSTANCE:g.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ti=I;class c{static create(W,Z){return new c(W,Z)}constructor(W,Z){this.d=W,this.f=Z,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const Z=W.getValue(this.f),ee=W.getValue(this.d);return Array.isArray(Z)?Z.includes(ee):typeof ee=="string"&&typeof Z=="object"&&Z!==null?R.call(Z,ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$Ui=c;class y{static create(W,Z){return new y(W,Z)}constructor(W,Z){this.d=W,this.f=Z,this.type=11,this.c=c.create(W,Z)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Vi=y;class b{static create(W,Z,ee=null){if(typeof Z=="boolean")return Z?S.create(W,ee):C.create(W,ee);const pe=D.get(W);return typeof pe=="boolean"?Z===(pe?"true":"false")?g.INSTANCE:h.INSTANCE:new b(W,Z,ee)}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=D.get(this.c);if(typeof W=="boolean"){const Z=W?"true":"false";return this.d===Z?g.INSTANCE:h.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Wi=b;class S{static create(W,Z=null){const ee=D.get(W);return typeof ee=="boolean"?ee?g.INSTANCE:h.INSTANCE:new S(W,Z)}constructor(W,Z){this.c=W,this.d=Z,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:$e(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=D.get(this.c);return typeof W=="boolean"?W?g.INSTANCE:h.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=C.create(this.c,this)),this.d}}e.$Xi=S;function j(_,W){if(typeof _=="string"){const Z=parseFloat(_);isNaN(Z)||(_=Z)}return typeof _=="string"||typeof _=="number"?W(_):g.INSTANCE}class O{static create(W,Z,ee=null){return j(Z,pe=>new O(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Yi=O;class K{static create(W,Z,ee=null){return j(Z,pe=>new K(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Zi=K;class B{static create(W,Z,ee=null){return j(Z,pe=>new B(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$1i=B;class T{static create(W,Z,ee=null){return j(Z,pe=>new T(W,pe,ee))}constructor(W,Z,ee){this.c=W,this.d=Z,this.f=ee,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ye(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$2i=T;class z{static create(W,Z){return new z(W,Z)}constructor(W,Z){this.d=W,this.f=Z,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const Z=this.f?this.f.source:"",ee=W.f?W.f.source:"";return Z<ee?-1:Z>ee?1:0}equals(W){if(W.type===this.type){const Z=this.f?this.f.source:"",ee=W.f?W.f.source:"";return this.d===W.d&&Z===ee}return!1}substituteConstants(){return this}evaluate(W){const Z=W.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$3i=z;class ie{static create(W){return new ie(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new ie(this.c.map(W))}negate(){return this.c}}e.$4i=ie;function X(_){let W=null;for(let Z=0,ee=_.length;Z<ee;Z++){const pe=_[Z].substituteConstants();if(_[Z]!==pe&&W===null){W=[];for(let me=0;me<Z;me++)W[me]=_[me]}W!==null&&(W[Z]=pe)}return W===null?_:W}class De{static create(W,Z,ee){return De.d(W,Z,ee)}constructor(W,Z){this.expr=W,this.c=Z,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const pe=o(this.expr[Z],W.expr[Z]);if(pe!==0)return pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(W.expr[Z]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:De.create(W,this.c,!1)}evaluate(W){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].evaluate(W))return!1;return!0}static d(W,Z,ee){const pe=[];let me=!1;for(const he of W)if(he){if(he.type===1){me=!0;continue}if(he.type===0)return g.INSTANCE;if(he.type===6){pe.push(...he.expr);continue}pe.push(he)}if(pe.length===0&&me)return h.INSTANCE;if(pe.length!==0){if(pe.length===1)return pe[0];pe.sort(o);for(let he=1;he<pe.length;he++)pe[he-1].equals(pe[he])&&(pe.splice(he,1),he--);if(pe.length===1)return pe[0];for(;pe.length>1;){const he=pe[pe.length-1];if(he.type!==9)break;pe.pop();const Ee=pe.pop(),re=pe.length===0,le=Pe.create(he.expr.map(ne=>De.create([ne,Ee],null,ee)),null,re);le&&(pe.push(le),pe.sort(o))}if(pe.length===1)return pe[0];if(ee){for(let he=0;he<pe.length;he++)for(let Ee=he+1;Ee<pe.length;Ee++)if(pe[he].negate().equals(pe[Ee]))return g.INSTANCE;if(pe.length===1)return pe[0]}return new De(pe,Z)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const Z of this.expr)W.push(...Z.keys());return W}map(W){return new De(this.expr.map(Z=>Z.map(W)),null)}negate(){if(!this.c){const W=[];for(const Z of this.expr)W.push(Z.negate());this.c=Pe.create(W,this,!0)}return this.c}}e.$5i=De;class Pe{static create(W,Z,ee){return Pe.d(W,Z,ee)}constructor(W,Z){this.expr=W,this.c=Z,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let Z=0,ee=this.expr.length;Z<ee;Z++){const pe=o(this.expr[Z],W.expr[Z]);if(pe!==0)return pe}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(!this.expr[Z].equals(W.expr[Z]))return!1;return!0}return!1}substituteConstants(){const W=X(this.expr);return W===this.expr?this:Pe.create(W,this.c,!1)}evaluate(W){for(let Z=0,ee=this.expr.length;Z<ee;Z++)if(this.expr[Z].evaluate(W))return!0;return!1}static d(W,Z,ee){let pe=[],me=!1;if(W){for(let he=0,Ee=W.length;he<Ee;he++){const re=W[he];if(re){if(re.type===0){me=!0;continue}if(re.type===1)return h.INSTANCE;if(re.type===9){pe=pe.concat(re.expr);continue}pe.push(re)}}if(pe.length===0&&me)return g.INSTANCE;pe.sort(o)}if(pe.length!==0){if(pe.length===1)return pe[0];for(let he=1;he<pe.length;he++)pe[he-1].equals(pe[he])&&(pe.splice(he,1),he--);if(pe.length===1)return pe[0];if(ee){for(let he=0;he<pe.length;he++)for(let Ee=he+1;Ee<pe.length;Ee++)if(pe[he].negate().equals(pe[Ee]))return h.INSTANCE;if(pe.length===1)return pe[0]}return new Pe(pe,Z)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const Z of this.expr)W.push(...Z.keys());return W}map(W){return new Pe(this.expr.map(Z=>Z.map(W)),null)}negate(){if(!this.c){const W=[];for(const Z of this.expr)W.push(Z.negate());for(;W.length>1;){const Z=W.shift(),ee=W.shift(),pe=[];for(const me of we(Z))for(const he of we(ee))pe.push(De.create([me,he],null,!1));W.unshift(Pe.create(pe,null,!1))}this.c=Pe.create(W,this,!0)}return this.c}}e.$6i=Pe;class ke extends C{static{this.d=[]}static all(){return ke.d.values()}constructor(W,Z,ee){super(W,null),this.f=Z,typeof ee=="object"?ke.d.push({...ee,key:W}):ee!==!0&&ke.d.push({key:W,description:ee,type:Z!=null?typeof Z:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return I.create(this.key,W)}notEqualsTo(W){return b.create(this.key,W)}}e.$7i=ke,e.$8i=(0,L.$Ph)("contextKeyService");function $e(_,W){return _<W?-1:_>W?1:0}function ye(_,W,Z,ee){return _<Z?-1:_>Z?1:W<ee?-1:W>ee?1:0}function ue(_,W){if(_.type===0||W.type===1)return!0;if(_.type===9)return W.type===9?ae(_.expr,W.expr):!1;if(W.type===9){for(const Z of W.expr)if(ue(_,Z))return!0;return!1}if(_.type===6){if(W.type===6)return ae(W.expr,_.expr);for(const Z of _.expr)if(ue(Z,W))return!0;return!1}return _.equals(W)}e.$9i=ue;function ae(_,W){let Z=0,ee=0;for(;Z<_.length&&ee<W.length;){const pe=_[Z].cmp(W[ee]);if(pe<0)return!1;pe===0&&Z++,ee++}return Z===_.length}function we(_){return _.type===9?_.expr:[_]}}),define(Ae[172],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=void 0,e.$Wh=(0,w.$Ph)("environmentService"),e.$Xh=(0,w.$Qh)(e.$Wh)}),define(Ae[92],Re([1,0,140,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$0n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=void 0,e.$Xn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Yn=new RegExp(e.$Xn),e.$Zn="__web_extension",e.$1n="skipWalkthrough",e.$2n="extensionsSync",e.$3n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$4n=P;function L(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$5n=L;function A(i,l){switch(i){case 3:return l==="x64"?"win32-x64":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$6n=A;function u(i,l){return l==="web"&&!i.includes("web")}e.$7n=u;function D(i,l,p){return u(l,p)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===p}e.$8n=D;function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$9n=f;var R;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var k;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var a;(function(i){i.Install="install",i.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$0n=(0,M.$Ph)("extensionGalleryService");var $;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var d;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class t extends Error{constructor(l,p){super(l),this.code=p,this.name=p}}e.$$n=t,e.$_n=(0,M.$Ph)("extensionManagementService"),e.$ao="extensionsIdentifiers/disabled",e.$bo="extensionsIdentifiers/enabled",e.$co=(0,M.$Ph)("IGlobalExtensionEnablementService"),e.$do=(0,M.$Ph)("IExtensionTipsService"),e.$eo=(0,w.localize)(0,null),e.$fo={value:e.$eo,original:"Extensions"},e.$go={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[39],Re([1,0,50,20,16,15,2,142,4,23,13,42]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.FileKind=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileOperationResult=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileChangeType=e.$qk=e.FileOperation=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileSystemProviderErrorCode=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileSystemProviderCapabilities=e.$ak=e.FilePermission=e.FileType=e.$_j=e.$$j=void 0,e.$$j=(0,D.$Ph)("fileService");function a(ue){return ue.create===!0}e.$_j=a;var v;(function(ue){ue[ue.Unknown=0]="Unknown",ue[ue.File=1]="File",ue[ue.Directory=2]="Directory",ue[ue.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var $;(function(ue){ue[ue.Readonly=1]="Readonly",ue[ue.Locked=2]="Locked"})($||(e.FilePermission=$={}));function d(ue){const ae=ue;return!!ae&&typeof ae.onDidChange=="function"}e.$ak=d;var t;(function(ue){ue[ue.None=0]="None",ue[ue.FileReadWrite=2]="FileReadWrite",ue[ue.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ue[ue.FileReadStream=16]="FileReadStream",ue[ue.FileFolderCopy=8]="FileFolderCopy",ue[ue.PathCaseSensitive=1024]="PathCaseSensitive",ue[ue.Readonly=2048]="Readonly",ue[ue.Trash=4096]="Trash",ue[ue.FileWriteUnlock=8192]="FileWriteUnlock",ue[ue.FileAtomicRead=16384]="FileAtomicRead",ue[ue.FileAtomicWrite=32768]="FileAtomicWrite",ue[ue.FileAtomicDelete=65536]="FileAtomicDelete",ue[ue.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ue){return!!(ue.capabilities&2)}e.$bk=i;function l(ue){return!!(ue.capabilities&8)}e.$ck=l;function p(ue){return!!(ue.capabilities&131072)}e.$dk=p;function E(ue){return!!(ue.capabilities&4)}e.$ek=E;function m(ue){return!!(ue.capabilities&16)}e.$fk=m;function n(ue){return i(ue)?!!(ue.capabilities&16384):!1}e.$gk=n;function r(ue){return i(ue)?!!(ue.capabilities&32768):!1}e.$hk=r;function s(ue){return!!(ue.capabilities&65536)}e.$ik=s;function o(ue){return!!(ue.capabilities&2048)}e.$jk=o;var g;(function(ue){ue.FileExists="EntryExists",ue.FileNotFound="EntryNotFound",ue.FileNotADirectory="EntryNotADirectory",ue.FileIsADirectory="EntryIsADirectory",ue.FileExceedsStorageQuota="EntryExceedsStorageQuota",ue.FileTooLarge="EntryTooLarge",ue.FileWriteLocked="EntryWriteLocked",ue.NoPermissions="NoPermissions",ue.Unavailable="Unavailable",ue.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class h extends Error{static create(ae,we){const _=new h(ae.toString(),we);return c(_,we),_}constructor(ae,we){super(ae),this.code=we}}e.$kk=h;function C(ue,ae){return h.create(ue,ae)}e.$lk=C;function I(ue){return ue||C((0,u.localize)(0,null),g.Unknown)}e.$mk=I;function c(ue,ae){return ue.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ue}e.$nk=c;function y(ue){if(!ue)return g.Unknown;if(ue instanceof h)return ue.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ue.name);if(!ae)return g.Unknown;switch(ae[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.$ok=y;function b(ue){if(ue instanceof T)return ue.fileOperationResult;switch(y(ue)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}e.$pk=b;var S;(function(ue){ue[ue.CREATE=0]="CREATE",ue[ue.DELETE=1]="DELETE",ue[ue.MOVE=2]="MOVE",ue[ue.COPY=3]="COPY",ue[ue.WRITE=4]="WRITE"})(S||(e.FileOperation=S={}));class j{constructor(ae,we,_){this.resource=ae,this.operation=we,this.target=_}isOperation(ae){return this.operation===ae}}e.$qk=j;var O;(function(ue){ue[ue.UPDATED=0]="UPDATED",ue[ue.ADDED=1]="ADDED",ue[ue.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class K{static{this.a=null}constructor(ae,we){this.c=we,this.b=void 0,this.d=new k.$V(()=>{const _=w.$Vh.forUris(()=>this.c);return _.fill(this.rawAdded.map(W=>[W,!0])),_}),this.f=new k.$V(()=>{const _=w.$Vh.forUris(()=>this.c);return _.fill(this.rawUpdated.map(W=>[W,!0])),_}),this.g=new k.$V(()=>{const _=w.$Vh.forUris(()=>this.c);return _.fill(this.rawDeleted.map(W=>[W,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of ae){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==K.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains(ae,...we){return this.h(ae,{includeChildren:!1},...we)}affects(ae,...we){return this.h(ae,{includeChildren:!0},...we)}h(ae,we,..._){if(!ae)return!1;const W=_.length>0;return!!((!W||_.includes(1))&&(this.d.value.get(ae)||we.includeChildren&&this.d.value.findSuperstr(ae))||(!W||_.includes(0))&&(this.f.value.get(ae)||we.includeChildren&&this.f.value.findSuperstr(ae))||(!W||_.includes(2))&&(this.g.value.findSubstr(ae)||we.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$rk=K;function B(ue,ae,we){return!ue||!ae||ue===ae||ae.length>ue.length?!1:(ae.charAt(ae.length-1)!==M.sep&&(ae+=M.sep),we?(0,P.$3e)(ue,ae):ue.indexOf(ae)===0)}e.$sk=B;class T extends Error{constructor(ae,we,_){super(ae),this.fileOperationResult=we,this.options=_}}e.$tk=T;class z extends T{constructor(ae,we,_,W){super(ae,we,W),this.fileOperationResult=we,this.size=_}}e.$uk=z;class ie extends T{constructor(ae,we,_){super(ae,2,_),this.stat=we}}e.$vk=ie;var X;(function(ue){ue[ue.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ue[ue.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ue[ue.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ue[ue.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ue[ue.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ue[ue.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ue[ue.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ue[ue.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ue[ue.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ue[ue.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ue[ue.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$wk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$xk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$yk="files.associations",e.$zk="files.exclude",e.$Ak="files.readonlyInclude",e.$Bk="files.readonlyExclude",e.$Ck="files.readonlyFromPermissions";var De;(function(ue){ue[ue.FILE=0]="FILE",ue[ue.FOLDER=1]="FOLDER",ue[ue.ROOT_FOLDER=2]="ROOT_FOLDER"})(De||(e.FileKind=De={})),e.$Dk="";function Pe(ue){if(!(typeof ue.size!="number"||typeof ue.mtime!="number"))return ue.mtime.toString(29)+ue.size.toString(31)}e.$Ek=Pe;async function ke(ue,ae){if(!ae.hasProvider(A.URI.from({scheme:ue.scheme})))return new Promise(we=>{const _=ae.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ue.scheme&&W.added&&(_.dispose(),we())})})}e.$Fk=ke;class $e{static{this.KB=1024}static{this.MB=$e.KB*$e.KB}static{this.GB=$e.MB*$e.KB}static{this.TB=$e.GB*$e.KB}static formatSize(ae){return(0,L.$Cf)(ae)||(ae=0),ae<$e.KB?(0,u.localize)(1,null,ae.toFixed(0)):ae<$e.MB?(0,u.localize)(2,null,(ae/$e.KB).toFixed(2)):ae<$e.GB?(0,u.localize)(3,null,(ae/$e.MB).toFixed(2)):ae<$e.TB?(0,u.localize)(4,null,(ae/$e.GB).toFixed(2)):(0,u.localize)(5,null,(ae/$e.TB).toFixed(2))}}e.$Gk=$e;function ye(ue){const ae=typeof ue=="string"||ue?.scheme===R.Schemas.vscodeRemote;return typeof ue!="string"&&ue?.scheme===R.Schemas.file?1024*$e.MB:ae?10*$e.MB:f.$p?50*$e.MB:1024*$e.MB}e.$Hk=ye}),define(Ae[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class w{constructor(...P){this.a=new Map;for(const[L,A]of P)this.set(L,A)}set(P,L){const A=this.a.get(P);return this.a.set(P,L),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Nh=w}),define(Ae[173],Re([1,0,12,11,6,69,171,4,71,174]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0;const R=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Nh,i=!1,l,p=R){this.f=t,this.g=i,this.h=l,this.i=p,this.o=new Set,this.f.set(u.$Oh,this),this._globalGraph=p?l?._globalGraph??new A.$cq(E=>E):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...i){const l=$.traceInvocation(this.i,t);let p=!1;try{return t({get:m=>{if(p)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(m,l);if(!n)throw new Error(`[invokeFunction] unknown service '${m}'`);return n}},...i)}finally{p=!0,l.stop()}}createInstance(t,...i){let l,p;return t instanceof L.$Mh?(l=$.traceCreation(this.i,t.ctor),p=this.j(t.ctor,t.staticArguments.concat(i),l)):(l=$.traceCreation(this.i,t),p=this.j(t,i,l)),l.stop(),p}j(t,i=[],l){const p=u._util.getServiceDependencies(t).sort((n,r)=>n.index-r.index),E=[];for(const n of p){const r=this.m(n.id,l);r||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),E.push(r)}const m=p.length>0?p[0].index:i.length;if(i.length!==m){console.trace(`[createInstance] First service dependency of ${t.name} at position ${m+1} conflicts with ${i.length} static arguments`);const n=m-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,m)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof L.$Mh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const l=this.l(t);return l instanceof L.$Mh?this.q(t,l,i.branch(t,!0)):(i.branch(t,!1),l)}q(t,i,l){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,l)}finally{this.o.delete(t)}}r(t,i,l){const p=new A.$cq(n=>n.id.toString());let E=0;const m=[{id:t,desc:i,_trace:l}];for(;m.length;){const n=m.pop();if(p.lookupOrInsertNode(n),E++>1e3)throw new k(p);for(const r of u._util.getServiceDependencies(n.desc.ctor)){const s=this.l(r.id);if(s||this.u(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),s instanceof L.$Mh){const o={id:r.id,desc:s,_trace:n._trace.branch(r.id,!0)};p.insertEdge(n,o),m.push(o)}}}for(;;){const n=p.roots();if(n.length===0){if(!p.isEmpty())throw new k(p);break}for(const{data:r}of n){if(this.l(r.id)instanceof L.$Mh){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}p.removeNode(r)}}return this.l(t)}s(t,i,l=[],p,E){if(this.f.get(t)instanceof L.$Mh)return this.t(t,i,l,p,E);if(this.h)return this.h.s(t,i,l,p,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,l=[],p,E){if(p){const m=new a(void 0,this.g,this,this.i);m.c=String(t);const n=new Map,r=new w.$$g(()=>{const s=m.j(i,l,E);for(const[o,g]of n){const h=s[o];if(typeof h=="function")for(const C of g)h.apply(s,C)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let C=n.get(o);return C||(C=new f.$2c,n.set(o,C)),(c,y,b)=>{const S=C.push([c,y,b]);return(0,P.$Qc)(S)}}if(o in s)return s[o];const g=r.value;let h=g[o];return typeof h!="function"||(h=h.bind(g),s[o]=h),h},set(s,o,g){return r.value[o]=g,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,l,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$dq=a;var v;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(v||(v={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const l=new $(3,t.toString());return this.h.push([t,i,l]),l}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function l(E,m){const n=[],r=new Array(E+1).join("	");for(const[s,o,g]of m.h)if(o&&g){i=!0,n.push(`${r}CREATES -> ${s}`);const h=l(E+1,g);h&&n.push(h)}else n.push(`${r}uses -> ${s}`);return n.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(p.join(`
`))}}e.$eq=$}),define(Ae[14],Re([1,0,37,5,93,6,28,23,24,15,2,32,4]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.log=e.$aj=e.LogLevel=e.$_i=e.$$i=e.$0i=void 0,e.$0i=(0,a.$Ph)("logService"),e.$$i=(0,a.$Ph)("loggerService");function v(){return new Date().toISOString()}function $(c){return(0,f.$Cf)(c)}e.$_i=$;var d;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$aj=d.Info;function t(c,y,b){switch(y){case d.Trace:c.trace(b);break;case d.Debug:c.debug(b);break;case d.Info:c.info(b);break;case d.Warning:c.warn(b);break;case d.Error:c.error(b);break;case d.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=t;function i(c,y=!1){let b="";for(let S=0;S<c.length;S++){let j=c[S];if(j instanceof Error&&(j=(0,w.$Ai)(j,y)),typeof j=="object")try{j=JSON.stringify(j)}catch{}b+=(S>0?" ":"")+j}return b}class l extends L.$Sc{constructor(){super(...arguments),this.b=e.$aj,this.c=this.B(new M.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==d.Off&&this.b<=y}}e.$cj=l;class p extends l{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...b){this.f(d.Trace)&&this.g(d.Trace,i([y,...b],!0))}debug(y,...b){this.f(d.Debug)&&this.g(d.Debug,i([y,...b]))}info(y,...b){this.f(d.Info)&&this.g(d.Info,i([y,...b]))}warn(y,...b){this.f(d.Warning)&&this.g(d.Warning,i([y,...b]))}error(y,...b){if(this.f(d.Error))if(y instanceof Error){const S=Array.prototype.slice.call(arguments);S[0]=y.stack,this.g(d.Error,i(S))}else this.g(d.Error,i([y,...b]))}flush(){}}e.$dj=p;class E extends l{constructor(y=e.$aj){super(),this.setLevel(y),this.g=!u.$j}trace(y,...b){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,y,...b):console.log(`[main ${v()}]`,y,...b))}debug(y,...b){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,y,...b):console.log(`[main ${v()}]`,y,...b))}info(y,...b){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,y,...b):console.log(`[main ${v()}]`,y,...b))}warn(y,...b){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,y,...b):console.warn(`[main ${v()}]`,y,...b))}error(y,...b){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,y,...b):console.error(`[main ${v()}]`,y,...b))}dispose(){}flush(){}}e.$ej=E;class m extends l{constructor(y=e.$aj,b=!0){super(),this.g=b,this.setLevel(y)}trace(y,...b){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...b):console.log(y,...b))}debug(y,...b){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...b):console.log(y,...b))}info(y,...b){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...b):console.log(y,...b))}warn(y,...b){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...b):console.log(y,...b))}error(y,...b){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...b):console.error(y,...b))}dispose(){}flush(){}}e.$fj=m;class n extends l{constructor(y,b=e.$aj){super(),this.g=y,this.setLevel(b)}trace(y,...b){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(y),...b])}debug(y,...b){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(y),...b])}info(y,...b){this.f(d.Info)&&this.g.log(d.Info,[this.h(y),...b])}warn(y,...b){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(y),...b])}error(y,...b){this.f(d.Error)&&this.g.log(d.Error,[this.h(y),...b])}h(y){return typeof y=="string"?y:(0,w.$Ai)(y,this.f(d.Trace))}dispose(){}flush(){}}e.$gj=n;class r extends l{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const b of this.g)b.setLevel(y);super.setLevel(y)}trace(y,...b){for(const S of this.g)S.trace(y,...b)}debug(y,...b){for(const S of this.g)S.debug(y,...b)}info(y,...b){for(const S of this.g)S.info(y,...b)}warn(y,...b){for(const S of this.g)S.warn(y,...b)}error(y,...b){for(const S of this.g)S.error(y,...b)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$hj=r;class s extends L.$Sc{constructor(y,b,S){if(super(),this.h=y,this.j=b,this.b=new A.$Ac,this.c=this.B(new M.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Nd),this.onDidChangeVisibility=this.g.event,S)for(const j of S)this.b.set(j.resource,{logger:void 0,info:j})}m(y){return(0,f.$yf)(y)?[...this.b.values()].find(b=>b.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,b){const S=this.n(y),j=(0,f.$yf)(y)?y:b?.id??(0,P.$Di)(S.toString()).toString(16);let O=this.b.get(S)?.logger;const K=b?.logLevel==="always"?d.Trace:b?.logLevel;O||(O=this.s(S,K??this.getLogLevel(S)??this.h,{...b,id:j}));const B={logger:O,info:{resource:S,id:j,logLevel:K,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(B.info),this.b.set(S,B),O}n(y){return(0,f.$yf)(y)?(0,D.$vg)(this.j,`${y}.log`):y}setLogLevel(y,b){if(R.URI.isUri(y)){const S=y,j=b,O=this.b.get(S);O&&j!==O.info.logLevel&&(O.info.logLevel=j===this.h?void 0:j,O.logger?.setLevel(j),this.b.set(O.info.resource,O),this.f.fire([S,j]))}else{this.h=y;for(const[S,j]of this.b.entries())this.b.get(S)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,b){const S=this.m(y);S&&b!==!S.info.hidden&&(S.info.hidden=!b,this.b.set(S.info.resource,S),this.g.fire([S.info.resource,b]))}getLogLevel(y){let b;return y&&(b=this.b.get(y)?.info.logLevel),b??this.h}registerLogger(y){const b=this.b.get(y.resource);b?b.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const b=this.b.get(y);b&&(b.logger&&b.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ij=s;class o{constructor(){this.onDidChangeLogLevel=new M.$Nd().event}setLevel(y){}getLevel(){return d.Info}trace(y,...b){}debug(y,...b){}info(y,...b){}warn(y,...b){}error(y,...b){}critical(y,...b){}dispose(){}flush(){}}e.$jj=o;class g extends o{}e.$kj=g;function h(c){if(c.verbose)return d.Trace;if(typeof c.logLevel=="string"){const y=I(c.logLevel.toLowerCase());if(y!==void 0)return y}return e.$aj}e.$lj=h;function C(c){switch(c){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.$mj=C;function I(c){switch(c){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$nj=I,e.$oj=new k.$7i("logLevel",C(d.Info))}),define(Ae[175],Re([1,0,6,14]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JN=void 0;class P extends w.$Sc{constructor(A,u=[]){super(),this.a=new M.$hj([A,...u]),this.B(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...u){this.a.trace(A,...u)}debug(A,...u){this.a.debug(A,...u)}info(A,...u){this.a.info(A,...u)}warn(A,...u){this.a.warn(A,...u)}error(A,...u){this.a.error(A,...u)}flush(){this.a.flush()}}e.$JN=P}),define(Ae[94],Re([1,0,29,143,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(D){function f($,d){return d-$}D.compare=f;const R=Object.create(null);R[D.Error]=(0,M.localize)(0,null),R[D.Warning]=(0,M.localize)(1,null),R[D.Info]=(0,M.localize)(2,null);function k($){return R[$]||""}D.toString=k;function a($){switch($){case w.default.Error:return D.Error;case w.default.Warning:return D.Warning;case w.default.Info:return D.Info;case w.default.Ignore:return D.Hint}}D.fromSeverity=a;function v($){switch($){case D.Error:return w.default.Error;case D.Warning:return w.default.Warning;case D.Info:return w.default.Info;case D.Hint:return w.default.Ignore}}D.toSeverity=v}(A||(e.MarkerSeverity=A={}));var u;(function(D){const f="";function R(a){return k(a,!0)}D.makeKey=R;function k(a,v){const $=[f];return a.source?$.push(a.source.replace("\xA6","\\\xA6")):$.push(f),a.code?typeof a.code=="string"?$.push(a.code.replace("\xA6","\\\xA6")):$.push(a.code.value.replace("\xA6","\\\xA6")):$.push(f),a.severity!==void 0&&a.severity!==null?$.push(A.toString(a.severity)):$.push(f),a.message&&v?$.push(a.message.replace("\xA6","\\\xA6")):$.push(f),a.startLineNumber!==void 0&&a.startLineNumber!==null?$.push(a.startLineNumber.toString()):$.push(f),a.startColumn!==void 0&&a.startColumn!==null?$.push(a.startColumn.toString()):$.push(f),a.endLineNumber!==void 0&&a.endLineNumber!==null?$.push(a.endLineNumber.toString()):$.push(f),a.endColumn!==void 0&&a.endColumn!==null?$.push(a.endColumn.toString()):$.push(f),$.push(f),$.join("\xA6")}D.makeKeyOptionalMessage=k})(u||(e.IMarkerData=u={})),e.$_s=(0,P.$Ph)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Zu=e.Severity=void 0,e.Severity=M.default,e.$Zu=(0,P.$Ph)("notificationService");var L;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var u;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(u||(e.NotificationsFilter=u={}));class D{constructor(){this.progress=new f,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$1u=D;class f{infinite(){}done(){}total(k){}worked(k){}}e.$2u=f}),define(Ae[95],Re([1,0,16,2,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nU=e.$mU=e.$lU=e.$kU=e.$jU=void 0,e.$jU=(0,P.$Ph)("openerService");function L(f,R){return M.URI.isUri(f)?(0,w.$2e)(f.scheme,R):(0,w.$3e)(f,R+":")}e.$kU=L;function A(f,...R){return R.some(k=>L(f,k))}e.$lU=A;function u(f,R){return f.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$mU=u;function D(f){let R;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return k&&(R={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},f=f.with({fragment:""})),{selection:R,uri:f}}e.$nU=D}),define(Ae[177],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$pj=void 0,e.$pj=(0,w.$Ph)("productService"),e.$qj="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(be,e,w,M){var P=arguments.length,L=P<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,w):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(be,e,w,M);else for(var u=be.length-1;u>=0;u--)(A=be[u])&&(L=(P<3?A(L):P>3?A(e,w,L):A(e,w))||L);return P>3&&L&&Object.defineProperty(e,w,L),L},Ke=this&&this.__param||function(be,e){return function(w,M){e(w,M,be)}};define(Ae[52],Re([1,0,12,19,6,4]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.ProgressLocation=e.$3u=void 0,e.$3u=(0,L.$Ph)("progressService");var A;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$4u=Object.freeze({total(){},worked(){},done(){}});class u{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$5u=u;class D{get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const v=this.d;this.d=()=>{v?.(),a()}}):Promise.resolve()}}e.$6u=D;let f=class extends P.$Sc{constructor(a,v){super(),this.a=new w.$ch,v.withProgress(a,$=>(this.b=$,this.c&&$.report(this.c),this.a.p)),this.B((0,P.$Qc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$7u=f,e.$7u=f=qe([Ke(1,e.$3u)],f);class R extends P.$Sc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new P.$Rc)}start(a){this.stop();const v=++this.a,$=new M.$Xd;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,P.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Qc)(()=>$.cancel())),this.b.add((0,P.$Qc)(()=>this.c?this.c.done():void 0)),{id:v,token:$.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$8u=R,e.$9u=(0,L.$Ph)("editorProgressService")}),define(Ae[30],Re([1,0,53,15]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;class P{constructor(){this.a=new Map}add(A,u){w.ok(M.$yf(A)),w.ok(M.$Af(u)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,u)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$gn=new P}),define(Ae[72],Re([1,0,5,30]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=void 0,e.$hn={JSONContribution:"base.contributions.json"};function P(u){return u.length>0&&u.charAt(u.length-1)==="#"?u.substring(0,u.length-1):u}class L{constructor(){this.b=new w.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,f){this.a[P(D)]=f,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;M.$gn.add(e.$hn.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,15,137,45,72,30]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.ConfigurationScope=e.$ln=e.EditPresentationTypes=void 0;var f;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$ln={Configuration:"base.contributions.configuration"};var R;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn={properties:{},patternProperties:{}},e.$qn={properties:{},patternProperties:{}},e.$rn={properties:{},patternProperties:{}},e.$sn="vscode://schemas/settings/resourceLanguage",e.$tn="vscode://schemas/settings/configurationDefaults";const k=D.$gn.as(u.$hn.JSONContribution);class a{constructor(){this.h=new Set,this.i=new M.$Nd,this.onDidSchemaChange=this.i.event,this.j=new M.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$sn,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const s=new Set;this.n(n,r,s),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const r=new Set;this.o(n,r),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const s=new Set;this.o(r,s),this.n(n,!1,s),k.registerSchema(e.$sn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const s=[];for(const{overrides:o,source:g}of n)for(const h in o)if(r.add(h),e.$vn.test(h)){const C=this.a.get(h),I=C?.valuesSources??new Map;if(g)for(const S of Object.keys(o[h]))I.set(S,g);const c={...C?.value||{},...o[h]};this.a.set(h,{source:g,value:c,valuesSources:I});const y=(0,A.$ti)(h),b={type:"object",default:c,description:L.localize(1,null,y),$ref:e.$sn,defaultDefaultValue:c,source:P.$yf(g)?void 0:g,defaultValueSource:g};s.push(...d(h)),this.d[h]=b,this.b.properties[h]=b}else{this.a.set(h,{value:o[h],source:g});const C=this.d[h];C&&(this.w(h,C),this.r(h,C))}this.m(s)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:s,source:o}of n)for(const g in s){const h=this.a.get(g),C=P.$yf(o)?o:o?.id,I=P.$yf(h?.source)?h?.source:h?.source?.id;if(C===I)if(r.add(g),this.a.delete(g),e.$vn.test(g))delete this.d[g],delete this.b.properties[g];else{const c=this.d[g];c&&(this.w(g,c),this.r(g,c))}}this.u()}deltaConfiguration(n){let r=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,s){n.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,r){const s=o=>{if(o.properties)for(const g in o.properties){r.add(g);const h=this.d[g];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[g],this.s(g,o.properties[g])}o.allOf?.forEach(g=>s(g))};for(const o of n){s(o);const g=this.c.indexOf(o);g!==-1&&this.c.splice(g,1)}}p(n,r=!0,s,o,g=3,h){g=P.$Hf(n.scope)?g:n.scope;const C=n.properties;if(C)for(const c in C){const y=C[c];if(r&&p(c,y)){delete C[c];continue}if(y.source=s,y.defaultDefaultValue=C[c].default,this.w(c,y),e.$vn.test(c)?y.scope=void 0:(y.scope=P.$Hf(y.scope)?g:y.scope,y.restricted=P.$Hf(y.restricted)?!!o?.includes(c):y.restricted),C[c].hasOwnProperty("included")&&!C[c].included){this.f[c]=C[c],delete C[c];continue}else this.d[c]=C[c],C[c].policy?.name&&this.e.set(C[c].policy.name,c);!C[c].deprecationMessage&&C[c].markdownDeprecationMessage&&(C[c].deprecationMessage=C[c].markdownDeprecationMessage),h.add(c)}const I=n.allOf;if(I)for(const c of I)this.p(c,r,s,o,g,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=s=>{const o=s.properties;if(o)for(const h in o)this.r(h,o[h]);s.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$mn.properties[n]=r,r.scope){case 1:e.$nn.properties[n]=r;break;case 2:e.$on.properties[n]=r;break;case 6:e.$pn.properties[n]=r;break;case 3:e.$qn.properties[n]=r;break;case 4:e.$rn.properties[n]=r;break;case 5:e.$rn.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$mn.properties[n],r.scope){case 1:delete e.$nn.properties[n];break;case 2:delete e.$on.properties[n];break;case 6:delete e.$pn.properties[n];break;case 3:delete e.$qn.properties[n];break;case 4:case 5:delete e.$rn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$sn};this.w(r,s),e.$mn.properties[r]=s,e.$nn.properties[r]=s,e.$on.properties[r]=s,e.$pn.properties[r]=s,e.$qn.properties[r]=s,e.$rn.properties[r]=s}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$sn};e.$mn.patternProperties[e.$un]=n,e.$nn.patternProperties[e.$un]=n,e.$on.patternProperties[e.$un]=n,e.$pn.patternProperties[e.$un]=n,e.$qn.patternProperties[e.$un]=n,e.$rn.patternProperties[e.$un]=n,this.i.fire()}w(n,r){const s=this.a.get(n);let o=s?.value,g=s?.source;P.$Ff(o)&&(o=r.defaultDefaultValue,g=void 0),P.$Ff(o)&&(o=i(r.type)),r.default=o,r.defaultValueSource=g}}const v="\\[([^\\]]+)\\]",$=new RegExp(v,"g");e.$un=`^(${v})+$`,e.$vn=new RegExp(e.$un);function d(m){const n=[];if(e.$vn.test(m)){let r=$.exec(m);for(;r?.length;){const s=r[1].trim();s&&n.push(s),r=$.exec(m)}}return(0,w.$Mb)(n)}e.$wn=d;function t(m){return m.reduce((n,r)=>`${n}[${r}]`,"")}e.$xn=t;function i(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$yn=i;const l=new a;D.$gn.add(e.$ln.Configuration,l);function p(m,n){return m.trim()?e.$vn.test(m)?L.localize(7,null,m):l.getConfigurationProperties()[m]!==void 0?L.localize(8,null,m):n.policy?.name&&l.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,m,n.policy?.name,l.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.$zn=p;function E(){const m=[],n=l.getConfigurationProperties();for(const r of Object.keys(n))m.push([r,n[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.$An=E}),define(Ae[178],Re([1,0,18,5,115,6,28,25,15,2,45,96,30]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function v(r){return Object.isFrozen(r)?r:u.$8m(r)}class ${constructor(s={},o=[],g=[],h){this.b=s,this.c=o,this.d=g,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof $)return o;const g=new d("");return g.parseRaw(o),g.configurationModel});this.f=s.reduce((o,g)=>g===o?g:o.merge(g),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$ri)(this.contents,s):this.contents}inspect(s,o){const g=this.rawConfiguration.getValue(s),h=o?this.rawConfiguration.getOverrideValue(s,o):void 0,C=o?this.rawConfiguration.override(o).getValue(s):g;return{value:g,override:h,merged:C}}getOverrideValue(s,o){const g=this.i(o);return g?s?(0,R.$ri)(g,s):g:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const g of this.overrides)g.identifiers.includes(s)&&o.push(...g.keys);return w.$Mb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return w.$Mb(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=u.$7m(this.contents),g=u.$7m(this.overrides),h=[...this.keys],C=this.raw?.length?[...this.raw]:[this];for(const I of s)if(C.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const c of I.overrides){const[y]=g.filter(b=>w.$ub(b.identifiers,c.identifiers));y?(this.h(y.contents,c.contents),y.keys.push(...c.keys),y.keys=w.$Mb(y.keys)):g.push(u.$7m(c))}for(const c of I.keys)h.indexOf(c)===-1&&h.push(c)}return new $(o,h,g,C.every(I=>I instanceof $)?void 0:C)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const g={};for(const h of w.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let C=this.contents[h];const I=o[h];I&&(typeof C=="object"&&typeof I=="object"?(C=u.$7m(C),this.h(C,I)):C=I),g[h]=C}return new $(g,this.keys,this.overrides)}h(s,o){for(const g of Object.keys(o)){if(g in s&&D.$Af(s[g])&&D.$Af(o[g])){this.h(s[g],o[g]);continue}s[g]=u.$7m(o[g])}}i(s){let o=null,g=null;const h=C=>{C&&(g?this.h(g,C):g=u.$7m(C))};for(const C of this.overrides)C.identifiers.length===1&&C.identifiers[0]===s?o=C.contents:C.identifiers.includes(s)&&h(C.contents);return h(o),g}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,R.$qi)(this.contents,s),k.$vn.test(s)&&this.overrides.splice(this.overrides.findIndex(g=>w.$ub(g.identifiers,(0,k.$wn)(s))),1))}j(s,o,g){(0,R.$pi)(this.contents,s,o,h=>console.error(h)),g=g||this.keys.indexOf(s)===-1,g&&this.keys.push(s),k.$vn.test(s)&&this.overrides.push({identifiers:(0,k.$wn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$oi)(this.contents[s],h=>console.error(h))})}}e.$Bn=$;class d{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!D.$Hf(s)){const g=this.g(s);this.parseRaw(g,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:g,keys:h,overrides:C,restricted:I,hasExcludedProperties:c}=this.h(s,o);this.b=new $(g,h,C,c?[s]:void 0),this.c=I||[]}g(s){let o={},g=null,h=[];const C=[],I=[];function c(b){Array.isArray(h)?h.push(b):g!==null&&(h[g]=b)}const y={onObjectBegin:()=>{const b={};c(b),C.push(h),h=b,g=null},onObjectProperty:b=>{g=b},onObjectEnd:()=>{h=C.pop()},onArrayBegin:()=>{const b=[];c(b),C.push(h),h=b,g=null},onArrayEnd:()=>{h=C.pop()},onLiteralValue:c,onError:(b,S,j)=>{I.push({error:b,offset:S,length:j})}};if(s)try{P.$4m(s,y),o=h[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return o}h(s,o){const g=a.$gn.as(k.$ln.Configuration).getConfigurationProperties(),h=this.i(s,g,!0,o);s=h.raw;const C=(0,R.$oi)(s,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),I=Object.keys(s),c=this.j(s,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:C,keys:I,overrides:c,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(s,o,g,h){let C=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:C};const I={},c=[];for(const y in s)if(k.$vn.test(y)&&g){const b=this.i(s[y],o,!1,h);I[y]=b.raw,C=C||b.hasExcludedProperties,c.push(...b.restricted)}else{const b=o[y],S=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&c.push(y),!h.exclude?.includes(y)&&(h.include?.includes(y)||(S===void 0||h.scopes===void 0||h.scopes.includes(S))&&!(h.skipRestricted&&b?.restricted))?I[y]=s[y]:C=!0}return{raw:I,restricted:c,hasExcludedProperties:C}}j(s,o){const g=[];for(const h of Object.keys(s))if(k.$vn.test(h)){const C={};for(const I in s[h])C[I]=s[h][I];g.push({identifiers:(0,k.$wn)(h),keys:Object.keys(C),contents:(0,R.$oi)(C,o)})}return g}}e.$Cn=d;class t extends L.$Sc{constructor(s,o,g,h){super(),this.c=s,this.f=o,this.g=h,this.b=this.B(new M.$Nd),this.onDidChange=this.b.event,this.a=new d(this.c.toString()),this.B(this.g.watch(g.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(0)||C.isOperation(3)||C.isOperation(1)||C.isOperation(4))&&g.isEqual(C.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Dn=t;class i{constructor(s,o,g,h,C,I,c,y,b,S,j,O,K){this.a=s,this.b=o,this.c=g,this.overrideIdentifiers=h,this.d=C,this.f=I,this.g=c,this.h=y,this.i=b,this.j=S,this.k=j,this.l=O,this.m=K}get value(){return v(this.c)}n(s,o,g){const h=s.inspect(o,g);return{get value(){return v(h.value)},get override(){return v(h.override)},get merged(){return v(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(s,o,g,h,C=new $,I=new $,c=new A.$Ac,y=new $,b=new A.$Ac){this.c=s,this.d=o,this.f=g,this.g=h,this.h=C,this.i=I,this.j=c,this.l=y,this.m=b,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,o,g){return this.q(s,o,g).getValue(s)}updateValue(s,o,g={}){let h;g.resource?(h=this.m.get(g.resource),h||(h=new $,this.m.set(g.resource,h))):h=this.l,o===void 0?h.removeValue(s):h.setValue(s,o),g.resource||(this.a=null)}inspect(s,o,g){const h=this.q(s,o,g),C=this.u(o.resource,g),I=o.resource?this.m.get(o.resource)||this.l:this.l,c=new Set;for(const y of h.overrides)for(const b of y.identifiers)h.getOverrideValue(s,b)!==void 0&&c.add(b);return new i(s,o,h.getValue(s),c.size?[...c]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,g?this.i:void 0,C||void 0,I)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const g=[];if(!o){const{added:h,updated:C,removed:I}=m(this.c,s);o=[...h,...C,...I]}for(const h of o)for(const C of(0,k.$wn)(h)){const I=this.c.getKeysForOverrideIdentifier(C),c=s.getKeysForOverrideIdentifier(C),y=[...c.filter(b=>I.indexOf(b)===-1),...I.filter(b=>c.indexOf(b)===-1),...I.filter(b=>!u.$$m(this.c.override(C).getValue(b),s.override(C).getValue(b)))];g.push([C,y])}return this.updateDefaultConfiguration(s),{keys:o,overrides:g}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:g,removed:h}=m(this.d,s),C=[...o,...g,...h];return C.length&&this.updatePolicyConfiguration(s),{keys:C,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:g,removed:h,overrides:C}=m(this.applicationConfiguration,s),I=[...o,...g,...h];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:C}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:g,removed:h,overrides:C}=m(this.localUserConfiguration,s),I=[...o,...g,...h];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:C}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:g,removed:h,overrides:C}=m(this.remoteUserConfiguration,s),I=[...o,...g,...h];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:C}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:g,removed:h,overrides:C}=m(this.workspaceConfiguration,s),I=[...o,...g,...h];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:C}}compareAndUpdateFolderConfiguration(s,o){const g=this.p.get(s),{added:h,updated:C,removed:I,overrides:c}=m(g,o),y=[...h,...C,...I];return(y.length||!g)&&this.updateFolderConfiguration(s,o),{keys:y,overrides:c}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:g,updated:h,removed:C,overrides:I}=m(o,void 0);return{keys:[...g,...h,...C],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,g){let h=this.r(o,g);return o.overrideIdentifier&&(h=h.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(h=h.merge(this.d)),h}r({resource:s},o){let g=this.s();if(o&&s){const h=o.getFolder(s);h&&(g=this.t(h.uri)||g);const C=this.m.get(s);C&&(g=g.merge(C))}return g}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const g=this.s(),h=this.j.get(s);h?(o=g.merge(h),this.b.set(s,o)):o=g}return o}u(s,o){if(o&&s){const g=o.getFolder(s);if(g)return this.j.get(g.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:g,overrides:h,keys:C}=this.j.get(o);return s.push([o,{contents:g,overrides:h,keys:C}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(g=>s.add(g))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(g=>s.add(g))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(g=>o.add(g)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(g=>o.add(g)),this.i.getKeysForOverrideIdentifier(s).forEach(g=>o.add(g)),this.j.forEach(g=>g.getKeysForOverrideIdentifier(s).forEach(h=>o.add(h))),[...o.values()]}static parse(s){const o=this.x(s.defaults),g=this.x(s.policy),h=this.x(s.application),C=this.x(s.user),I=this.x(s.workspace),c=s.folders.reduce((y,b)=>(y.set(f.URI.revive(b[0]),this.x(b[1])),y),new A.$Ac);return new l(o,g,h,C,new $,I,c,new $,new A.$Ac)}static x(s){return new $(s.contents,s.keys,s.overrides)}}e.$En=l;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,o=new Map;for(const h of r)h.keys.forEach(C=>s.add(C)),h.overrides.forEach(([C,I])=>{const c=(0,A.$xc)(o,C,new Set);I.forEach(y=>c.add(y))});const g=[];return o.forEach((h,C)=>g.push([C,[...h.values()]])),{keys:[...s.values()],overrides:g}}e.$Fn=p;class E{constructor(s,o,g,h){this.change=s,this.f=o,this.g=g,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const C of s.keys)this.affectedKeys.add(C);for(const[,C]of s.overrides)for(const I of C)this.affectedKeys.add(I);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(s,o){const g=this.a+s,h=this.d.indexOf(g);if(h<0)return!1;const C=h+g.length;if(C>=this.d.length)return!1;const I=this.d.charCodeAt(C);if(I!==this.b&&I!==this.c)return!1;if(o){const c=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,y=this.g.getValue(s,o,this.h);return!u.$$m(c,y)}return!0}}e.$Gn=E;function m(r,s){const{added:o,removed:g,updated:h}=n(s?.rawConfiguration,r?.rawConfiguration),C=[],I=r?.getAllOverrideIdentifiers()||[],c=s?.getAllOverrideIdentifiers()||[];if(s){const y=c.filter(b=>!I.includes(b));for(const b of y)C.push([b,s.getKeysForOverrideIdentifier(b)])}if(r){const y=I.filter(b=>!c.includes(b));for(const b of y)C.push([b,r.getKeysForOverrideIdentifier(b)])}if(s&&r){for(const y of I)if(c.includes(y)){const b=n({contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)},{contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)});C.push([y,[...b.added,...b.removed,...b.updated]])}}return{added:o,removed:g,updated:h,overrides:C}}function n(r,s){const o=r?s?r.keys.filter(C=>s.keys.indexOf(C)===-1):[...r.keys]:[],g=s?r?s.keys.filter(C=>r.keys.indexOf(C)===-1):[...s.keys]:[],h=[];if(r&&s){for(const C of s.keys)if(r.keys.indexOf(C)!==-1){const I=(0,R.$ri)(s.contents,C),c=(0,R.$ri)(r.contents,C);u.$$m(I,c)||h.push(C)}}return{added:o,removed:g,updated:h}}}),define(Ae[97],Re([1,0,11,4]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.RemoteAuthorityResolverErrorCode=e.$Rk=e.$Qk=e.RemoteConnectionType=e.$Pk=void 0,e.$Pk=(0,M.$Ph)("remoteAuthorityResolverService");var P;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Qk=L;class A{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Rk=A;var u;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(u||(e.RemoteAuthorityResolverErrorCode=u={}));class D extends w.$bb{static isNotAvailable(k){return k instanceof D&&k._code===u.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===u.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===u.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===u.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,a=u.Unknown,v){super(k),this._message=k,this._code=a,this._detail=v,this.isHandled=a===u.NotAvailable&&v===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Sk=D;function f(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$Tk=f}),define(Ae[54],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=void 0;function M(f){return f.scheme===w.Schemas.vscodeRemote?f.authority:void 0}e.$Uk=M;function P(f){if(!f)return;const R=f.indexOf("+");return R<0?f:f.substr(0,R)}e.$Vk=P;function L(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Wk=L;function A(f){const{host:R,port:k}=D(f);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.$Xk=A;function u(f,R){let{host:k,port:a}=D(f);return typeof a>"u"&&(a=R),{host:k,port:a}}e.$Yk=u;function D(f){const R=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=f.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=f.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:f,port:void 0}}}),define(Ae[21],Re([1,0,16,4,54]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.TargetPlatform=e.ExtensionType=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=void 0,e.$Zl="extensions.user.cache",e.$1l="extensions.builtin.cache",e.$2l="undefined_publisher",e.$3l=["ui","workspace","web"];function L(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$4l=L,e.$5l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(A||(e.ExtensionType=A={}));var u;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(u||(e.TargetPlatform=u={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const l=typeof t=="string"?t:t.value,p=typeof i=="string"?i:i.value;return w.$2e(l,p)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$6l=D;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$7l=f;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$8l=R;function k(d){return a(d)}e.$9l=k;function a(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.$0l=a;function v(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.$$l=v;function $(d,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$Vk)(t)}`;return!!d.activationEvents?.includes(i)}return!1}e.$_l=$,e.$am=(0,M.$Ph)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,11,21]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YE=e.$XE=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,u){this.a.set(A,u)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const u=Object.create(null);for(const D of A){const f=this.readActivationEvents(D);f.length>0&&(u[M.$6l.toKey(D.identifier)]=f)}return u}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const u=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return u;for(const D in A.contributes){const f=this.a.get(D);if(!f)continue;const R=A.contributes[D],k=Array.isArray(R)?R:[R];try{f(k,u)}catch(a){(0,w.$1)(a)}}return u}}e.$XE=P,e.$YE=new P}),define(Ae[179],Re([1,0,23,73,36]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=void 0;function L(D){if(w.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,f,R,k,a,v,$,d,t){const i=Object.create(null);i["common.machineId"]=v,i["common.sqmId"]=$,i.sessionID=(0,P.$eg)()+Date.now(),i.commitHash=k,i.version=a,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,w.$i)(w.$u),i["common.nodePlatform"]=M.$dc,i["common.nodeArch"]=R,i["common.product"]=t||"desktop",d&&(i["common.msftInternal"]=d);let l=0;const p=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),w.$m&&(i["common.snap"]="true");const E=L(f);return E&&(i["common.platformDetail"]=E),i}e.$ho=A;function u(D){const f=M.env.USERDNSDOMAIN;if(!f)return!1;const R=f.toLowerCase();return D.some(k=>R===k)}e.$io=u}),define(Ae[180],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0,e.$cl=(0,w.$Ph)("telemetryService"),e.$dl=(0,w.$Ph)("customEndpointTelemetryService"),e.$el="telemetry.currentSessionDate",e.$fl="telemetry.firstSessionDate",e.$gl="telemetry.lastSessionDate",e.$hl="telemetry.machineId",e.$il="telemetry.sqmId",e.$jl="telemetry",e.$kl="telemetry.telemetryLevel",e.$ll="telemetry.enableCrashReporter",e.$ml="telemetry.enableTelemetry";var M;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var P;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ae[55],Re([1,0,25,15,5,45,54,179,180]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=void 0;class f{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$jo=f;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ko=R,e.$lo=new R;class k{async publicLog(g,h,C){}async publicLogError(g,h,C){}}e.$mo=k,e.$no="telemetry",e.$oo="extensionTelemetryLog",e.$po={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,g){return P.Event.debounce(g.onDidChangeConfiguration,(C,I)=>{const c=C?new Set([...C.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:c}},1e3,!0)(C=>{C.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.$mi)(C.source),configurationKeys:Array.from(C.affectedKeys)})})}e.$qo=a;function v(o,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!o.enableTelemetry)}e.$ro=v;function $(o,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$so=$;function d(o){const g=o.getValue(D.$kl),h=o.getValue(D.$ll);if(o.getValue(D.$ml)===!1||h===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$to=d;function t(o){const g={},h={},C={};p(o,C);for(let I in C){I=I.length>150?I.substr(I.length-149):I;const c=C[I];typeof c=="number"?h[I]=c:typeof c=="boolean"?h[I]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${c.length}`),g[I]=c.substring(0,8191)):typeof c<"u"&&c!==null&&(g[I]=c)}return{properties:g,measurements:h}}e.$uo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(o){if(!o)return"none";const g=(0,A.$Vk)(o);return i.has(g)?g:"other"}e.$vo=l;function p(o,g,h=0,C){if(o)for(const I of Object.getOwnPropertyNames(o)){const c=o[I],y=C?C+I:I;Array.isArray(c)?g[y]=(0,w.$_m)(c):c instanceof Date?g[y]=c.toISOString():(0,M.$Af)(c)?h<2?p(c,g,h+1,y+"."):g[y]=(0,w.$_m)(c):g[y]=c}}function E(o,g){const h=o.msftInternalDomains||[],C=g.getValue("telemetry.internalTesting");return(0,u.$io)(h)||C}e.$wo=E;function m(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$xo=m;function n(o,g){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let h=o;const C=[];for(const b of g)for(;;){const S=b.exec(o);if(!S)break;C.push([S.index,b.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(h="";;){const b=c.exec(o);if(!b)break;const S=C.some(([j,O])=>b.index<O&&j<c.lastIndex);!I.test(b[0])&&!S&&(h+=o.substring(y,b.index)+"<REDACTED: user-file-path>",y=c.lastIndex)}return y<o.length&&(h+=o.substr(y)),h}function r(o){if(!o)return o;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of g)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return o}function s(o,g){return(0,w.$9m)(o,h=>{if(h instanceof f||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let C=h.replaceAll("%20"," ");C=n(C,g);for(const I of g)C=C.replace(I,"");return C=r(C),C}})}e.$yo=s}),define(Ae[181],Re([1,0,16,92,21,23,2,11,73,55]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;function R(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,w.$We)(s.id,o.id)===0}e.$zo=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const g=o.manifest?o.manifest.version:o.version,h=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,g,h)}static parse(o){const g=k.exec(o);return g&&g[1]&&g[2]?new a({id:g[1]},g[2],g[4]||void 0):null}constructor(o,g,h="undefined"){this.version=g,this.targetPlatform=h,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$Ao=a;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(s){const o=v.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$Bo=$;function d(s,o){return`${s}.${o}`}e.$Co=d;function t(s){return s.toLowerCase()}e.$Do=t;function i(s,o){return t(d(s??P.$2l,o))}e.$Eo=i;function l(s,o){const g=[],h=C=>{for(const I of g)if(I.some(c=>R(o(c),o(C))))return I;return null};for(const C of s){const I=h(C);I?I.push(C):g.push([C])}return g}e.$Fo=l;function p(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Go=p;function E(s){return{id:new f.$jo(s.identifier.id),name:new f.$jo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Ho=E,e.$Io=new P.$6l("pprice.better-merge");function m(s,o){const g=[],h=o.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const C=h.shift();if(C&&g.every(I=>!R(I.identifier,{id:C}))){const I=s.filter(c=>R(c.identifier,{id:C}));I.length===1&&(g.push(I[0]),h.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.$Jo=m;async function n(s,o){if(!L.$l)return!1;let g;try{g=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(C){o.debug("Error while getting the os-release file.",(0,u.$0)(C))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,o){const g=await n(s,o),h=(0,M.$6n)(g?"alpine":L.$u,D.$ec);return o.debug("ComputeTargetPlatform:",h),h}e.$Ko=r}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=e.$mr=e.$lr=e.$kr=void 0;function w(D){return[...D.entries()]}e.$kr=w;function M(D){return D?[...D.entries()]:[]}e.$lr=M;function P(D){return new Map(D)}e.$mr=P;function L(D){return new Map(D??[])}e.$nr=L;function A(D){return Array.from(D.entries()).map(f=>[f[0],w(f[1].map),M(f[1].descriptionMap)])}e.$or=A;function u(D){return new Map(D.map(f=>[f[0],{map:P(f[1]),descriptionMap:L(f[2])}]))}e.$pr=u}),define(Ae[183],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkb=void 0;class w{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,L,A=5){const u=L(D=>{const f=typeof D=="string"?D:D.data;let R=this.a.get(P);if(R){R.data.push(f);return}const k=setTimeout(()=>this.flushBuffer(P),A);R={data:[f],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(P),u.dispose()}},this.a.set(P,R)});return u}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const L=this.a.get(P);L&&(this.a.delete(P),this.b(P,L.data.join("")))}}e.$Zkb=w}),define(Ae[184],Re([1,0,12,89,43,5,15,2,144,72,30]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.IconFontDefinition=e.IconContribution=e.$5v=void 0,e.$5v={IconContribution:"base.contributions.icons"};var k;(function(E){function m(n,r){let s=n.defaults;for(;P.ThemeIcon.isThemeIcon(s);){const o=$.getIcon(s.id);if(!o)return;s=o.defaults}return s}E.getDefinition=m})(k||(e.IconContribution=k={}));var a;(function(E){function m(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}E.toJSONObject=m;function n(r){const s=o=>(0,A.$yf)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,A.$yf)(o.format)&&(0,A.$yf)(o.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(o=>({format:o.format,location:u.URI.parse(o.location)}))}}E.fromJSONObject=n})(a||(e.IconFontDefinition=a={}));class v{constructor(){this.a=new L.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(m,n,r,s){const o=this.b[m];if(o){if(r&&!o.description){o.description=r,this.d.properties[m].markdownDescription=`${r} $(${m})`;const C=this.e.enum.indexOf(m);C!==-1&&(this.e.enumDescriptions[C]=r),this.a.fire()}return o}const g={id:m,description:r,defaults:n,deprecationMessage:s};this.b[m]=g;const h={$ref:"#/definitions/icons"};return s&&(h.deprecationMessage=s),r&&(h.markdownDescription=`${r}: $(${m})`),this.d.properties[m]=h,this.e.enum.push(m),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:m}}deregisterIcon(m){delete this.b[m],delete this.d.properties[m];const n=this.e.enum.indexOf(m);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(m=>this.b[m])}getIcon(m){return this.b[m]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(m,n){const r=this.f[m];return r||(this.f[m]=n,this.a.fire(),n)}deregisterIconFont(m){delete this.f[m]}getIconFont(m){return this.f[m]}toString(){const m=(o,g)=>o.id.localeCompare(g.id),n=o=>{for(;P.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(g=>!!g.description).sort(m))r.push(`|<i class="${n(o)}"></i>|${o.id}|${P.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of s.filter(g=>!P.ThemeIcon.isThemeIcon(g.defaults)).sort(m))r.push(`|<i class="${n(o)}"></i>|${o.id}|`);return r.join(`
`)}}const $=new v;R.$gn.add(e.$5v.IconContribution,$);function d(E,m,n,r){return $.registerIcon(E,m,n,r)}e.$6v=d;function t(){return $}e.$7v=t;function i(){const E=(0,M.$Sj)();for(const m in E){const n="\\"+E[m].toString(16);$.registerIcon(m,{fontCharacter:n})}}i(),e.$8v="vscode://schemas/icons";const l=R.$gn.as(f.$hn.JSONContribution);l.registerSchema(e.$8v,$.getIconSchema());const p=new w.$6g(()=>l.notifySchemaChanged(e.$8v),200);$.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.$9v=d("widget-close",M.$Uj.close,(0,D.localize)(2,null)),e.$0v=d("goto-previous-location",M.$Uj.arrowUp,(0,D.localize)(3,null)),e.$$v=d("goto-next-location",M.$Uj.arrowDown,(0,D.localize)(4,null)),e.$_v=P.ThemeIcon.modify(M.$Uj.sync,"spin"),e.$aw=P.ThemeIcon.modify(M.$Uj.loading,"spin")}),define(Ae[185],Re([1,0,5,45,4,14]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.$bv=e.$av=e.ProvidedOnAutoForward=e.$_u=e.TunnelPrivacyId=e.TunnelProtocol=e.$$u=e.$0u=void 0,e.$0u=(0,P.$Ph)("tunnelService"),e.$$u=(0,P.$Ph)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var u;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(u||(e.TunnelPrivacyId=u={}));function D(t){return!!t.forwardPort}e.$_u=D;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$av=R,e.$bv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$bv.indexOf(t)>=0}e.$cv=k,e.$dv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$dv.indexOf(t)>=0}e.$ev=a;function v(t,i,l,p){if(l===1)return!1;if(l===2&&a(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$fv=v;class ${constructor(i,l,p){this.remoteAddress=i,this.localAddress=l,this.b=p,this.a=new w.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$gv=$;let d=class{constructor(i,l){this.j=i,this.k=l,this.a=new w.$Nd,this.onTunnelOpened=this.a.event,this.b=new w.$Nd,this.onTunnelClosed=this.b.event,this.c=new w.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],l=Array.from(this.e.values());for(const p of l){const E=Array.from(p.values());for(const m of E){const n=await m.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:l}of i.values())await l.then(p=>typeof p!="string"?p?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,l,p,E,m){this.p(i,l,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:l,localAddress:p,privacy:E,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,l){(a(i)||k(i))&&(i=e.$bv[0]);const p=this.r(i,l);if(p)return++p.refcount,p.value}openTunnel(i,l,p,E,m,n=!1,r,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${p} on local port ${m}.`);const o=this.f??i;if(!o)return;if(l||(l="localhost"),E||(E=this.l),this.f&&this.i.has(p)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.s(o,l,p,E,m,n,r,s);return g?g.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,p),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,p);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.n(h);return(h.tunnelRemoteHost!==l||h.tunnelRemotePort!==p)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(C),C}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const l=this.e.get(i.tunnelRemoteHost);if(l){const p=l.get(i.tunnelRemotePort);p&&(p.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,p))}}}}async o(i,l,p){if(p.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${l}.`);const E=p.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(l),E}}async closeTunnel(i,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${l} `);const p=this.e.get(i);if(p&&p.has(l)){const E=p.get(l);E.refcount=0,await this.o(i,l,E)}}p(i,l,p){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(l,{refcount:1,value:p})}async q(i,l){const p=this.e.get(i);if(p){const E=p.get(l),m=E?await E.value:void 0;(!m||typeof m=="string")&&p.delete(l),p.size===0&&this.e.delete(i)}}r(i,l){const p=[i];k(i)?(p.push(...e.$bv),p.push(...e.$dv)):a(i)&&p.push(...e.$dv);const E=p.map(m=>this.e.get(m));for(const m of E){const n=m?.get(l);if(n)return n}}canTunnel(i){return!!R(i)}t(i,l,p,E,m,n,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${p} on local port ${E}.`);const s=p;this.i.add(s);const o=E===void 0?p:E,g={elevationRequired:m?this.isPortPrivileged(o):!1},h={remoteAddress:{host:l,port:p},localAddressPort:E,privacy:n,public:n?n!==u.Private:void 0,protocol:r},C=i.forwardPort(h,g);return C?(this.p(l,p,C),C.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),C}};e.$hv=d,e.$hv=d=qe([Ke(0,L.$0i),Ke(1,M.$ji)],d)}),define(Ae[186],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$iv=void 0,e.$iv=(0,w.$Ph)("editSessionIdentityService");var M;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[187],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=void 0;function M(D){return D.scheme!==w.Schemas.file&&D.scheme!==w.Schemas.vscodeRemote}e.$UJ=M;function P(D){if(D.folders.length)return D.folders.every(f=>M(f.uri))?D.folders[0].uri:void 0;if(D.configuration&&M(D.configuration))return D.configuration}e.$VJ=P;function L(D){return P(D)?.scheme}e.$WJ=L;function A(D){return P(D)?.authority}e.$XJ=A;function u(D){return P(D)!==void 0}e.$YJ=u}),define(Ae[56],Re([1,0,145,20,50,24,2,4,13]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.WorkbenchState=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=void 0,e.$Yh=(0,u.$Ph)("contextService");function f(o){const g=o;return typeof g?.id=="string"&&A.URI.isUri(g.uri)}e.$Zh=f;function R(o){return typeof o?.id=="string"&&!f(o)&&!a(o)}e.$1h=R,e.$2h={id:"ext-dev"},e.$3h={id:"empty-window"};function k(o,g){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$nc)(o)}:g?e.$2h:e.$3h;const h=o;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$4h=k;function a(o){const g=o;return typeof g?.id=="string"&&A.URI.isUri(g.configPath)}e.$5h=a;function v(o){const g=o;if(g?.uri)return{id:g.id,uri:A.URI.revive(g.uri)};const h=o;if(h?.configPath)return{id:h.id,configPath:A.URI.revive(h.configPath)};if(o?.id)return{id:o.id}}e.$6h=v;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function d(o){const g=o;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.$7h=d;function t(o){const g=o;return!!(g&&typeof g=="object"&&A.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.$8h=t;class i{constructor(g,h,C,I,c){this.h=g,this.j=C,this.k=I,this.l=c,this.c=P.$Vh.forUris(this.l,()=>!0),this.folders=h}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=P.$Vh.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$9h=i;class l{constructor(g,h){this.raw=h,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,L.$vg)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$0h=l;function p(o){return new l({uri:o,index:0,name:(0,L.$rg)(o)},{uri:o.toString()})}e.$$h=p,e.$_h="code-workspace",e.$ai=`.${e.$_h}`,e.$bi=[{name:(0,w.localize)(0,null),extensions:[e.$_h]}],e.$ci="workspace.json";function E(o,g){return L.$mg.isEqualOrParent(o,g.untitledWorkspacesHome)}e.$di=E;function m(o){let g;return A.URI.isUri(o)?g=o:g=o.configuration,g?.scheme===D.Schemas.tmp}e.$ei=m,e.$fi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$fi}e.$gi=n;function r(o,g){return!E(o,g)&&!m(o)}e.$hi=r;function s(o){return(typeof o=="string"?(0,M.$oc)(o):(0,L.$tg)(o))===e.$ai}e.$ii=s}),define(Ae[74],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class w{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const L=this.c++;return this.b.set(L,P),this.e(),L}get(P,L){return this.b.has(P)?this.b.get(P)[L]:void 0}delete(P){this.b.delete(P),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$icc=w}),define(Ae[40],Re([1,0,13,24,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=void 0;class L{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new M.$kg(u=>{const D=this.b.get(u.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(u,D){D===null?this.b.delete(u.scheme):this.b.set(u.scheme,D)}isFreeScheme(u){return!this.b.has(u)&&!this.a.has(u)}getCapabilities(u){return this.b.get(u)}}e.$kcc=L,e.$lcc=(0,P.$Ph)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=void 0,e.$CM=(0,w.$Ph)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;let A=class extends P.$JN{constructor(D,f,R){const k=R.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=R.remote.isRemote?(0,w.localize)(0,null):D?(0,w.localize)(1,null):(0,w.localize)(2,null);super(f.createLogger(k,{name:a}))}};e.$tec=A,e.$tec=A=qe([Ke(1,M.$$i),Ke(2,L.$CM)],A)}),define(Ae[189],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0;class M{constructor(A,u,D){this.h=new Map,this.a=A,this.b=u,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new w.$6g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of f.values())R.complete()}catch(R){for(const k of f.values())k.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,u){let D=this.f[A];return typeof D>"u"&&(D=u),D}update(A,u){this.f[A]=u;const D=this.h.get(A);if(D!==void 0)return D.p;const f=new w.$ch;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$Ncc=M;class P extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,u){super(A.identifier.value,!0,u),this.j=A}}e.$Occ=P}),define(Ae[190],Re([1,0,5,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class P{constructor(A){this.c=A,this.a=new w.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,u,D,f){const k=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(u.value,D,f);this.b.fire(k)}$acceptDirtyStateChanged(A,u){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(u)}$acceptModelSaved(A){const u=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(u.apiNotebook)}}e.$aec=P}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0,e.$mM=(0,w.$Ph)("IExtHostRpcService");class M{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$nM=M}),define(Ae[191],Re([1,0,21,5]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class P{#e;constructor(A,u){this.b=new M.$Nd,this.onDidChange=this.b.event,this.a=w.$6l.toKey(A.identifier),this.#e=u,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return this.#e.get(this.a,A)}store(A,u){return this.#e.store(this.a,A,u)}delete(A){return this.#e.delete(this.a,A)}}e.$Zcc=P}),define(Ae[57],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=void 0,e.$vcc=(0,w.$Ph)("IURITransformerService");class M{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$wcc=M}),define(Ae[192],Re([1,0,26]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcb=e.$Ecb=void 0;class M{constructor(){this.buffers=[]}add(D){let f=this.buffers.indexOf(D);return f<0&&(f=this.buffers.length,this.buffers.push(D)),f}}function P(u,D){if(D.serializeBuffersForPostMessage){const f=new M,k=JSON.stringify(u,(v,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add($)};if(ArrayBuffer.isView($)){const d=L($);if(d)return{$$vscode_array_buffer_reference$$:!0,index:f.add($.buffer),view:{type:d,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),a=f.buffers.map(v=>{const $=new Uint8Array(v);return w.$be.wrap($)});return{message:k,buffers:a}}else return{message:JSON.stringify(u),buffers:[]}}e.$Ecb=P;function L(u){switch(u.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(u,D){const f=D.map(a=>{const v=new ArrayBuffer(a.byteLength);return new Uint8Array(v).set(a.buffer),v}),R=D.length?(a,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const $=v,{index:d}=$,t=f[d];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse(u,R),arrayBuffers:f}}e.$Fcb=A}),define(Ae[99],Re([1,0,160,15,2,6,4,30,39,13,37,127,29]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=e.$gE=e.$fE=e.EditorsOrder=e.$eE=e.CloseDirection=e.$dE=e.$cE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$bE=e.$aE=e.$_D=e.$$D=e.$0D=e.$9D=e.$8D=e.$7D=e.EditorInputCapabilities=e.$6D=e.SaveReason=e.Verbosity=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=void 0,e.$TD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$UD={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$VD="workbench.editor.sidebysideEditor",e.$WD="workbench.editors.textDiffEditor",e.$XD="workbench.editors.binaryResourceDiffEditor";var v;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var $;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function d(ae){const we=ae;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.$YD=d;function t(ae,we,_){for(const W of _.visibleEditorPanes)if(W.group.id===we&&ae.matches(W.input))return W.getViewState()}e.$ZD=t;function i(ae){if(h(ae))return!1;const we=ae;return P.URI.isUri(we?.resource)}e.$1D=i;function l(ae){if(h(ae))return!1;const we=ae;return we?.original!==void 0&&we.modified!==void 0}e.$2D=l;function p(ae){if(h(ae)||l(ae))return!1;const we=ae;return we?.primary!==void 0&&we.secondary!==void 0}e.$3D=p;function E(ae){if(h(ae))return!1;const we=ae;return we?we.resource===void 0||we.resource.scheme===f.Schemas.untitled||we.forceUntitled===!0:!1}e.$4D=E;function m(ae){if(h(ae))return!1;const we=ae;return P.URI.isUri(we?.base?.resource)&&P.URI.isUri(we?.input1?.resource)&&P.URI.isUri(we?.input2?.resource)&&P.URI.isUri(we?.result?.resource)}e.$5D=m;var n;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var r;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource(we,_){let W=this.a.get(we);return W||(W={source:we,label:_},this.a.set(we,W)),W.source}getSourceLabel(we){return this.a.get(we)?.label??we}}e.$6D=new s;var o;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad",ae[ae.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(o||(e.EditorInputCapabilities=o={}));class g extends L.$Sc{}e.$7D=g;function h(ae){return ae instanceof g}e.$8D=h;function C(ae){const we=ae;return P.URI.isUri(we?.preferredResource)}function I(ae){const we=ae;return h(we?.primary)&&h(we?.secondary)}e.$9D=I;function c(ae){const we=ae;return h(we?.modified)&&h(we?.original)}e.$0D=c;function y(ae,we,_,W,Z){return ue(W,[(0,k.$zi)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const ee={..._,limits:{size:Number.MAX_VALUE}};ae.openEditor(we,ee)}}),(0,k.$zi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>Z.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$$D=y;function b(ae){return h(ae?.editor)}e.$_D=b;function S(ae){const we=ae;return b(ae)&&we?.group!==void 0}e.$aE=S;function j(ae){const we=ae;return typeof we?.groupId=="number"&&h(we.editor)}e.$bE=j;var O;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var K;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(K||(e.GroupModelChangeKind=K={}));var B;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class T{getOriginalUri(we,_){if(!we)return;if(m(we))return e.$dE.getOriginalUri(we.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(we);if(Z&&ee){if(_?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===B.ANY)return this.getOriginalUri(Z,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:_.filterByScheme});we=_.supportSideBySide===B.PRIMARY?Z:ee}}if(l(we)||p(we)||m(we))return;const W=C(we)?we.preferredResource:we.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}a(we){return I(we)||p(we)?{primary:we.primary,secondary:we.secondary}:c(we)||l(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,_){if(!we)return;if(m(we))return e.$dE.getCanonicalUri(we.result,_);if(_?.supportSideBySide){const{primary:Z,secondary:ee}=this.a(we);if(Z&&ee){if(_?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===B.ANY)return this.getCanonicalUri(Z,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:_.filterByScheme});we=_.supportSideBySide===B.PRIMARY?Z:ee}}if(l(we)||p(we)||m(we))return;const W=we.resource;return!W||!_||!_.filterByScheme?W:this.b(W,_.filterByScheme)}b(we,_){if(Array.isArray(_)){if(_.some(W=>we.scheme===W))return we}else if(_===we.scheme)return we}}var z;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function ie(ae,we,_,W){if(!ae.isSticky(we))return!1;switch(W.preventPinnedEditorClose){case"keyboardAndMouse":return _===z.MOUSE||_===z.KEYBOARD;case"mouse":return _===z.MOUSE;case"keyboard":return _===z.KEYBOARD}return!1}e.$cE=ie,e.$dE=new T;var X;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(X||(e.CloseDirection=X={}));class De{constructor(){this.c=new Map,this.d=new Map}start(we){const _=this.a=we.get(A.$Oh);for(const[W,Z]of this.c)this.e(W,Z,_);this.c.clear()}e(we,_,W){const Z=W.createInstance(_);this.d.set(we,Z)}registerFileEditorFactory(we){if(this.b)throw new Error("Can only register one file editor factory.");this.b=we}getFileEditorFactory(){return(0,M.$Jf)(this.b)}registerEditorSerializer(we,_){if(this.c.has(we)||this.d.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.a?this.e(we,_,this.a):this.c.set(we,_),(0,L.$Qc)(()=>{this.c.delete(we),this.d.delete(we)})}getEditorSerializer(we){return this.d.get(typeof we=="string"?we:we.typeId)}}u.$gn.add(e.$TD.EditorFactory,new De);async function Pe(ae,we,_){return!ae||!ae.length?[]:await Promise.all(ae.map(async W=>{const Z=P.URI.revive(W.fileUri);if(!Z){_.info("Cannot resolve the path because it is not valid.",W);return}if(!await we.canHandleResource(Z)){_.info("Cannot resolve the path because it cannot be handled",W);return}let pe=W.exists,me=W.type;if(typeof pe!="boolean"||typeof me!="number")try{me=(await we.stat(Z)).isDirectory?D.FileType.Directory:D.FileType.Unknown,pe=!0}catch(Ee){_.error(Ee),pe=!1}if(!pe&&W.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",W);return}if(me===D.FileType.Directory){_.info("Cannot resolve the path because it is a directory",W);return}const he={...W.options,pinned:!0};return pe?{resource:Z,options:he}:{resource:Z,options:he,forceUntitled:!0}}))}e.$eE=Pe;var ke;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(ke||(e.EditorsOrder=ke={}));function $e(ae){const we=ae;if(!we)return!1;const _=we;if(_.modified)return $e(_.modified);const W=we;return!!(W.contributionsState&&W.viewState&&Array.isArray(W.cursorState))}e.$fE=$e;function ye(ae){return(0,R.$Bi)(ae)}e.$gE=ye;function ue(ae,we,_){const W=(0,R.$Ci)(ae,we);return W.forceMessage=_?.forceMessage,W.forceSeverity=_?.forceSeverity,W.allowDialog=_?.allowDialog,W}e.$hE=ue}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,25,89,184]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=e.$rE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$qE=e.$pE=e.ViewContentGroups=e.$oE=e.$nE=e.ViewContainerLocation=e.Extensions=e.$mE=e.$lE=e.$kE=void 0,e.$kE="views",e.$lE=(0,M.localize)(0,null),e.$mE=(0,k.$6v)("default-view-icon",R.$Uj.window,(0,M.localize)(1,null));var a;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var v;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$nE=[0,1,2];function $(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$oE=$;class d extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new w.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new w.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Rb)([...this.g.values()])}registerViewContainer(s,o,g){const h=this.get(s.id);if(h)return h;const C=s;return C.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,A.$xc)(this.g,o,[]).push(C),g?.isDefault&&this.h.push(C),this.c.fire({viewContainer:C,viewContainerLocation:o}),C}deregisterViewContainer(s){for(const o of this.g.keys()){const g=this.g.get(o),h=g?.indexOf(s);if(h!==-1){g?.splice(h,1),g.length===0&&this.g.delete(o),this.f.fire({viewContainer:s,viewContainerLocation:o});return}}}get(s){return this.all.filter(o=>o.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(g=>g?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(o=>this.getViewContainerLocation(o)===s)}}u.$gn.add(a.ViewContainersRegistry,new d);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(r,s){const o=r.group??t.More,g=s.group??t.More;return o!==g?o.localeCompare(g):(r.order??5)-(s.order??5)}class l extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new w.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,o){this.registerViews2([{views:s,viewContainer:o}])}registerViews2(s){s.forEach(({views:o,viewContainer:g})=>this.r(o,g)),this.c.fire(s)}deregisterViews(s,o){const g=this.s(s,o);g.length&&this.f.fire({views:g,viewContainer:o})}moveViews(s,o){for(const g of this.m.keys())if(g!==o){const h=this.s(s,g);h.length&&(this.r(h,o),this.g.fire({views:h,from:g,to:o}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const o of this.j){const g=(this.m.get(o)||[]).filter(h=>h.id===s)[0];if(g)return g}return null}getViewContainer(s){for(const o of this.j)if((this.m.get(o)||[]).filter(h=>h.id===s)[0])return o;return null}registerViewWelcomeContent(s,o){return this.n.add(s,o),this.h.fire(s),(0,L.$Qc)(()=>{this.n.delete(s,o),this.h.fire(s)})}registerViewWelcomeContent2(s,o){const g=new Map;for(const[h,C]of o)this.n.add(s,C),g.set(h,(0,L.$Qc)(()=>{this.n.delete(s,C),this.h.fire(s)}));return this.h.fire(s),g}getViewWelcomeContent(s){const o=[];return this.n.forEach(s,g=>o.push(g)),o.sort(i)}r(s,o){let g=this.m.get(o);g||(g=[],this.m.set(o,g),this.j.push(o));for(const h of s){if(this.getView(h.id)!==null)throw new Error((0,M.localize)(2,null,h.id));g.push(h)}}s(s,o){const g=this.m.get(o);if(!g)return[];const h=[],C=[];for(const I of g)s.includes(I)?h.push(I):C.push(I);return h.length&&(C.length?this.m.set(o,C):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),h}}u.$gn.add(a.ViewsRegistry,new l),e.$pE=(0,P.$Ph)("viewsService"),e.$qE=(0,P.$Ph)("viewDescriptorService");var p;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(p||(e.ViewVisibilityState=p={}));var E;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class m{constructor(s,o){this.c=!1,this.d=!1,(0,f.$0m)(this,s),this.d=!!o,this.resolve=async g=>{if(o&&!this.c){const h=await o(g);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$rE=m;class n extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$sE=n}),define(Ae[194],Re([1,0,2,41,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$TE=e.$SE=void 0;function L(f){return!!f&&typeof f=="object"&&"uri"in f&&f.uri instanceof w.URI&&"version"in f&&typeof f.version=="number"&&"ranges"in f&&Array.isArray(f.ranges)&&f.ranges.every(M.$ts.isIRange)}e.$SE=L;function A(f){return!!f&&typeof f=="object"&&"documents"in f&&Array.isArray(f.documents)&&f.documents.every(L)}e.$TE=A;var u;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(u||(e.InteractiveSessionVoteDirection=u={}));var D;(function(f){f[f.Action=1]="Action",f[f.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$UE=(0,P.$Ph)("IChatService")}),define(Ae[195],Re([1,0,5,12,162]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new w.$Nd,this.n=new w.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(u){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=u}onEvent(u){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=u}onRequest(u){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=u}sendResponse(u){u.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${u.command}`)):this.s("response",u)}sendRequest(u,D,f,R){const k={command:u};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof R=="number"){const a=setTimeout(()=>{clearTimeout(a);const v=this.f.get(k.seq);if(v){this.f.delete(k.seq);const $={type:"response",seq:0,request_seq:k.seq,success:!1,command:u,message:(0,P.localize)(0,null,R,u)};v($)}},R)}return f&&this.f.set(k.seq,f),k.seq}acceptMessage(u){this.j?this.j(u):(this.k.push(u),this.k.length===1&&this.q())}o(u,D){return u.type!=="event"||D.type!=="event"}async q(){let u;for(;this.k.length;){if((!u||this.o(this.k[0],u))&&await(0,M.$Ug)(0),u=this.k.shift(),!u)return;switch(u.type){case"event":this.i?.(u);break;case"request":this.g?.(u);break;case"response":{const D=u,f=this.f.get(D.request_seq);f&&(this.f.delete(D.request_seq),f(D));break}}}}s(u,D){D.type=u,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const u=new Map;this.f.forEach((D,f)=>u.set(f,D)),await(0,M.$Ug)(500),u.forEach((D,f)=>{D({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$$cb=L}),define(Ae[196],Re([1,0,163,32,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$7G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$6G=e.MemoryRangeType=e.$5G=e.State=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0,e.$3F="workbench.view.debug",e.$4F="workbench.debug.variablesView",e.$5F="workbench.debug.watchExpressionsView",e.$6F="workbench.debug.callStackView",e.$7F="workbench.debug.loadedScriptsView",e.$8F="workbench.debug.breakPointsView",e.$9F="workbench.debug.disassemblyView",e.$0F="workbench.panel.repl",e.$$F="workbench.panel.repl.view",e.$_F=new M.$7i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$aG=new M.$7i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$bG=new M.$7i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$cG="debugUx",e.$dG=new M.$7i(e.$cG,"default",{type:"string",description:w.localize(3,null)}),e.$eG=new M.$7i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$fG=new M.$7i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$gG=new M.$7i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$hG=new M.$7i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$iG=new M.$7i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$jG=new M.$7i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$kG=new M.$7i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$lG=new M.$7i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$mG=new M.$7i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$nG=new M.$7i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$oG=new M.$7i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$pG=new M.$7i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$qG=new M.$7i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$rG=new M.$7i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$sG=new M.$7i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$tG=new M.$7i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$uG=new M.$7i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$vG=new M.$7i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$wG=new M.$7i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$xG=new M.$7i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$yG=new M.$7i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$zG=new M.$7i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$AG=new M.$7i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$BG=new M.$7i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$CG=new M.$7i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$DG=new M.$7i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$EG=new M.$7i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$FG=new M.$7i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$GG=new M.$7i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$HG=new M.$7i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$IG=new M.$7i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$JG=new M.$7i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$KG=new M.$7i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$LG=new M.$7i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$MG=new M.$7i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$NG=new M.$7i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$OG=new M.$7i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$PG=new M.$7i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$QG=new M.$7i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$RG=new M.$7i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$SG=new M.$7i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$TG=new M.$7i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$UG=new M.$7i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$VG=new M.$7i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$WG=new M.$7i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$XG=new M.$7i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$YG=new M.$7i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const L=a=>w.localize(51,null,a);e.$ZG=L,e.$1G="editor.contrib.debug",e.$2G="editor.contrib.breakpoint",e.$3G="debug",e.$4G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function u(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$5G=u;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$6G="vscode-debug-memory";var f;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var R;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$7G=(0,P.$Ph)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[197],Re([1,0,16,2,20,25,13,41,19,18]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=void 0;const R=/{([^}]+)}/g;function k(I,c,y){return I.replace(R,function(b,S){return c&&S.length>0&&S[0]!=="_"?b:y&&y.hasOwnProperty(S)?y[S]:b})}e.$rF=k;function a(I){const c={};for(const y of Object.keys(I))y.startsWith("!")||(c[y]=I[y]);return c}e.$sF=a;function v(I){return I.configuration.request==="attach"&&!$(I)&&(!I.parentSession||v(I.parentSession))}e.$tF=v;function $(I){let c=I.configuration.type;if(c)return c==="vslsShare"&&(c=I.configuration.adapterProxy.configuration.type),(0,w.$2e)(c,"extensionhost")||(0,w.$2e)(c,"pwa-extensionhost")?I:I.parentSession?$(I.parentSession):void 0}e.$uF=$;function d(I){return I.type&&(I.label||I.program||I.runtime)}e.$vF=d;function t(I,c,y){let b,S=0;const j=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=j.exec(I);){const K=O.index+1,B=K+O[0].length;if(K<=c&&B>=y){b=O[0],S=K;break}}if(b){const K=/\w+/g;let B=null;for(;(B=K.exec(b))&&!(B.index+1+S+B[0].length>=y););B&&(b=b.substring(0,K.lastIndex))}return b?{start:S,end:S+b.length-1}:{start:0,end:0}}e.$wF=t;async function i(I,c,y,b){if(I.evaluatableExpressionProvider.has(c)){const S=I.evaluatableExpressionProvider.ordered(c),j=(0,f.$Hb)(await Promise.all(S.map(async O=>{try{return await O.provideEvaluatableExpression(c,y,b??D.CancellationToken.None)}catch{return}})));if(j.length>0){let O=j[0].expression;const K=j[0].range;return O||(O=c.getLineContent(y.lineNumber).substring(K.startColumn-1,K.endColumn-1)),{range:K,matchingExpression:O}}}else{const S=c.getLineContent(y.lineNumber),{start:j,end:O}=t(S,y.column,y.column),K=S.substring(j-1,O);return{matchingExpression:K,range:new u.$ts(y.lineNumber,j,y.lineNumber,j+K.length)}}return null}e.$xF=i;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(I){return!!(I&&I.match(l))}e.$yF=p;function E(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(p(I.path))return M.URI.parse(I.path);if((0,P.$ic)(I.path))return M.URI.file(I.path)}return I.path}function m(I){if(typeof I.path=="object"){const c=M.URI.revive(I.path);if(c)return c.scheme===A.Schemas.file?c.fsPath:c.toString()}return I.path}function n(I,c){const y=c?E:m,b=(0,L.$7m)(I);return s(b,(S,j)=>{S&&j&&(j.path=y(j))}),b}e.$zF=n;function r(I,c){const y=c?E:m,b=(0,L.$7m)(I);return s(b,(S,j)=>{!S&&j&&(j.path=y(j))}),b}e.$AF=r;function s(I,c){switch(I.type){case"event":{const y=I;switch(y.event){case"output":c(!1,y.body.source);break;case"loadedSource":c(!1,y.body.source);break;case"breakpoint":c(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=I;switch(y.command){case"setBreakpoints":c(!0,y.arguments.source);break;case"breakpointLocations":c(!0,y.arguments.source);break;case"source":c(!0,y.arguments.source);break;case"gotoTargets":c(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(b=>c(!1,b));break;default:break}break}case"response":{const y=I;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(b=>c(!1,b.source));break;case"loadedSources":y.body.sources.forEach(b=>c(!1,b));break;case"scopes":y.body.scopes.forEach(b=>c(!1,b.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(b=>c(!1,b.source));break;case"setBreakpoints":y.body.breakpoints.forEach(b=>c(!1,b.source));break;case"disassemble":y.body?.instructions.forEach(S=>c(!1,S.location));break;default:break}break}}}function o(I){return I.filter(c=>!c.presentation?.hidden).sort((c,y)=>c.presentation?y.presentation?c.presentation.group?y.presentation.group?c.presentation.group!==y.presentation.group?c.presentation.group.localeCompare(y.presentation.group):g(c.presentation.order,y.presentation.order):-1:y.presentation.group?1:g(c.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$BF=o;function g(I,c){return typeof I!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:I-c}async function h(I,c){const y=I.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(y!=="none"&&(await c.saveAll(),y==="allEditorsInActiveGroup")){const b=c.activeEditorPane;b&&b.input.resource?.scheme===A.Schemas.untitled&&await c.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}e.$CF=h;const C=(I,c)=>!I||!c?I===c:I.name===c.name&&I.path===c.path&&I.sourceReference===c.sourceReference;e.$DF=C}),define(Ae[75],Re([1,0,26,38,66,67,13,20,23,32]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wI=e.$vI=e.$uI=e.$tI=e.CellStatusbarAlignment=e.$sI=e.$rI=e.$qI=e.NotebookEditorPriority=e.$pI=e.$oI=e.$nI=e.$mI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$lI=e.$kI=e.$jI=e.$iI=e.CellKind=e.$hI=e.$gI=e.$fI=void 0,e.$fI="workbench.editor.notebook",e.$gI="workbench.editor.notebookTextDiffEditor",e.$hI="workbench.editor.interactive";var R;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(R||(e.CellKind=R={})),e.$iI=["application/json","application/javascript","text/html","image/svg+xml",L.$Pr.latex,L.$Pr.markdown,"image/png","image/jpeg",L.$Pr.text],e.$jI=[L.$Pr.latex,L.$Pr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Pr.text],e.$kI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$lI="_notAvailable";var k;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var v;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var $;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var d;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var l;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(l||(e.CellEditType=l={}));var p;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;const ie=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${ie.join("")}]+`),De=7;function Pe(we,_){const W=_.toString(De),ee=`${W.length<ie.length?ie[W.length-1]:"z"}${W}s${(0,w.$ve)(w.$be.fromString(we.scheme),!0,!0)}`;return we.with({scheme:z.scheme,fragment:ee})}z.generate=Pe;function ke(we){if(we.scheme!==z.scheme)return;const _=we.fragment.indexOf("s");if(_<0)return;const W=parseInt(we.fragment.substring(0,_).replace(X,""),De),Z=(0,w.$ue)(we.fragment.substring(_+1)).toString();if(!isNaN(W))return{handle:W,notebook:we.with({scheme:Z,fragment:null})}}z.parse=ke;function $e(we,_){return we.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${we.scheme!==A.Schemas.file?we.scheme:""}`})}z.generateCellOutputUri=$e;function ye(we){if(we.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!_)return;const W=_[1]&&_[1]!==""?_[1]:void 0,Z=_[2];return{outputId:W,notebook:we.with({scheme:Z||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=ye;function ue(we,_,W){return z.generate(we,_).with({scheme:W})}z.generateCellPropertyUri=ue;function ae(we,_){if(we.scheme===_)return z.parse(we.with({scheme:z.scheme}))}z.parseCellPropertyUri=ae})(p||(e.CellUri=p={}));const E=z=>D.$j?z.replace(/\//g,"\\"):z;class m{constructor(ie=[],X=e.$iI){this.e=X,this.d=[...new Set(ie)].map(De=>({pattern:De,matches:M.$wj(E(De))}))}sort(ie){const X=new Map(P.Iterable.map(ie,Pe=>[Pe,E(Pe)]));let De=[];for(const{matches:Pe}of this.d)for(const[ke,$e]of X)if(Pe($e)){De.push(ke),X.delete(ke);break}return X.size&&(De=De.concat([...X.keys()].sort((Pe,ke)=>this.e.indexOf(Pe)-this.e.indexOf(ke)))),De}prioritize(ie,X){const De=this.f(ie);if(De===-1){this.d.unshift({pattern:ie,matches:M.$wj(E(ie))});return}const Pe=new Set(X.map($e=>this.f($e,De)));Pe.delete(-1);const ke=Array.from(Pe).sort();this.d.splice(De+1,0,...ke.map($e=>this.d[$e]));for(let $e=ke.length-1;$e>=0;$e--)this.d.splice(ke[$e],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,X=this.d.length){const De=E(ie);for(let Pe=0;Pe<X;Pe++)if(this.d[Pe].matches(De))return Pe;return-1}}e.$mI=m;function n(z,ie,X,De=(Pe,ke)=>Pe===ke){const Pe=[];function ke(ue,ae,we){if(ae===0&&we.length===0)return;const _=Pe[Pe.length-1];_&&_.start+_.deleteCount===ue?(_.deleteCount+=ae,_.toInsert.push(...we)):Pe.push({start:ue,deleteCount:ae,toInsert:we})}let $e=0,ye=0;for(;;){if($e===z.length){ke($e,0,ie.slice(ye));break}if(ye===ie.length){ke($e,z.length-$e,[]);break}const ue=z[$e],ae=ie[ye];if(De(ue,ae)){$e+=1,ye+=1;continue}X(ae)?(ke($e,1,[]),$e+=1):(ke($e,0,[ae]),ye+=1)}return Pe}e.$nI=n,e.$oI=new f.$7i("notebookEditorCursorAtBoundary","none"),e.$pI=new f.$7i("notebookEditorCursorAtLineBoundary","none");var r;(function(z){z.default="default",z.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(z){const ie=z;return!!((typeof ie.include=="string"||M.$xj(ie.include))&&(typeof ie.exclude=="string"||M.$xj(ie.exclude)))}e.$qI=s;function o(z,ie,X){if(Array.isArray(z.viewType)&&z.viewType.indexOf(ie)>=0||z.viewType===ie)return!0;if(z.filenamePattern){const De=s(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,Pe=s(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(M.$vj(De,(0,u.$nc)(X.fsPath).toLowerCase()))return!(Pe&&M.$vj(Pe,(0,u.$nc)(X.fsPath).toLowerCase()))}return!1}e.$rI=o,e.$sI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var g;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class h{static{this.d="notebook/"}static create(ie){return`${h.d}${ie}`}static parse(ie){if(ie.startsWith(h.d))return ie.substring(h.d.length)}}e.$tI=h;function C(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$uI=C;const I=new TextDecoder;function c(z){const ie=[];let X=!1;for(const $e of z)(ie.length===0||X)&&(ie.push($e),X=!0);let De=S(ie);const Pe=w.$be.concat(ie.map($e=>w.$be.wrap($e))),ke=T(Pe);return De=De||ke.byteLength!==Pe.byteLength,{data:ke,didCompression:De}}e.$vI=c,e.$wI=`${String.fromCharCode(27)}[A`;const y=e.$wI.split("").map(z=>z.charCodeAt(0)),b=10;function S(z){let ie=!1;return z.forEach((X,De)=>{if(De===0||X.length<e.$wI.length)return;const Pe=z[De-1],ke=X.subarray(0,e.$wI.length);if(ke[0]===y[0]&&ke[1]===y[1]&&ke[2]===y[2]){const $e=Pe.lastIndexOf(b);if($e===-1)return;ie=!0,z[De-1]=Pe.subarray(0,$e),z[De]=X.subarray(e.$wI.length)}}),ie}function j(z){let ie=z;do z=ie,ie=z.replace(/[^\n]\x08/gm,"");while(ie.length<z.length);return z}function O(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const ie=z.match(/^(.*)\r+/m)[1];let X=z.match(/\r+(.*)$/m)[1];X=X+ie.slice(X.length,ie.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return z}const K="\b".charCodeAt(0),B="\r".charCodeAt(0);function T(z){return!z.buffer.includes(K)&&!z.buffer.includes(B)?z:w.$be.fromString(O(j(I.decode(z.buffer))))}}),define(Ae[7],Re([1,0,18,11,51,28,67,16,15,2,36,21,39,97,75]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$){"use strict";var d,t,i,l,p,E,m,n,r,s,o,g,h,C,I,c,y,b;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$bM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.TestRunProfileKind=e.TestResultState=e.$UL=e.$TL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$SL=e.$RL=e.$QL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$PL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.ColorThemeKind=e.$JL=e.$IL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$HL=e.DebugConsoleMode=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$BL=e.$AL=e.FileChangeType=e.$zL=e.$yL=e.$xL=e.$wL=e.InlineCompletionTriggerKind=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.ConfigurationTarget=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$_K=e.ViewBadge=e.ProgressLocation=e.$$K=e.$0K=e.TaskScope=e.ShellQuoting=e.$9K=e.$8K=e.$7K=e.TaskPanelKind=e.TaskRevealKind=e.$6K=e.TerminalLocation=e.$5K=e.$4K=e.$3K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$2K=e.$1K=e.$ZK=e.$YK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$XK=e.StatusBarAlignment=e.ViewColumn=e.$WK=e.$VK=e.$UK=e.$TK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$SK=e.$RK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.LanguageStatusSeverity=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.CodeActionTriggerKind=e.$FK=e.$EK=e.SymbolTag=e.SymbolKind=e.$DK=e.DocumentHighlightKind=e.$CK=e.$BK=e.$AK=e.$zK=e.DiagnosticSeverity=e.DiagnosticTag=e.$yK=e.$xK=e.FileEditType=e.$wK=e.$vK=e.$uK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function S(U){return Object.assign(U,{apply:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const Se=se.length===1?[]:se[1];return Reflect.construct(U,Se,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const[Se,...He]=se;return Reflect.construct(U,He,Se.constructor)}}})}var j;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(j||(e.TerminalOutputAnchor=j={}));var O;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let K=d=class{static from(...N){let se=N;return new d(function(){if(se){for(const Se of se)Se&&typeof Se.dispose=="function"&&Se.dispose();se=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$nK=K,e.$nK=K=d=qe([S],K);let B=t=class{static Min(...N){if(N.length===0)throw new TypeError;let se=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isBefore(se)&&(se=He)}return se}static Max(...N){if(N.length===0)throw new TypeError;let se=N[0];for(let Se=1;Se<N.length;Se++){const He=N[Se];He.isAfter(se)&&(se=He)}return se}static isPosition(N){if(!N)return!1;if(N instanceof t)return!0;const{line:se,character:Se}=N;return typeof se=="number"&&typeof Se=="number"}static of(N){if(N instanceof t)return N;if(this.isPosition(N))return new t(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,se){if(N<0)throw(0,M.$7)("line must be non-negative");if(se<0)throw(0,M.$7)("character must be non-negative");this.c=N,this.e=se}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,se=0){if(N===null||se===null)throw(0,M.$7)();let Se;return typeof N>"u"?Se=0:typeof N=="number"?Se=N:(Se=typeof N.lineDelta=="number"?N.lineDelta:0,se=typeof N.characterDelta=="number"?N.characterDelta:0),Se===0&&se===0?this:new t(this.line+Se,this.character+se)}with(N,se=this.character){if(N===null||se===null)throw(0,M.$7)();let Se;return typeof N>"u"?Se=this.line:typeof N=="number"?Se=N:(Se=typeof N.line=="number"?N.line:this.line,se=typeof N.character=="number"?N.character:this.character),Se===this.line&&se===this.character?this:new t(Se,se)}toJSON(){return{line:this.line,character:this.character}}};e.$oK=B,e.$oK=B=t=qe([S],B);let T=i=class{static isRange(N){return N instanceof i?!0:N?B.isPosition(N.start)&&B.isPosition(N.end):!1}static of(N){if(N instanceof i)return N;if(this.isRange(N))return new i(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,se,Se,He){let Ye,st;if(typeof N=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"?(Ye=new B(N,se),st=new B(Se,He)):B.isPosition(N)&&B.isPosition(se)&&(Ye=B.of(N),st=B.of(se)),!Ye||!st)throw new Error("Invalid arguments");Ye.isBefore(st)?(this.c=Ye,this.e=st):(this.c=st,this.e=Ye)}contains(N){return i.isRange(N)?this.contains(N.start)&&this.contains(N.end):B.isPosition(N)?!(B.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const se=B.Max(N.start,this.c),Se=B.Min(N.end,this.e);if(!se.isAfter(Se))return new i(se,Se)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const se=B.Min(N.start,this.c),Se=B.Max(N.end,this.end);return new i(se,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,se=this.end){if(N===null||se===null)throw(0,M.$7)();let Se;return N?B.isPosition(N)?Se=N:(Se=N.start||this.start,se=N.end||this.end):Se=this.start,Se.isEqual(this.c)&&se.isEqual(this.end)?this:new i(Se,se)}toJSON(){return[this.start,this.end]}};e.$pK=T,e.$pK=T=i=qe([S],T);let z=l=class extends T{static isSelection(N){return N instanceof l?!0:N?T.isRange(N)&&B.isPosition(N.anchor)&&B.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,se,Se,He){let Ye,st;if(typeof N=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"?(Ye=new B(N,se),st=new B(Se,He)):B.isPosition(N)&&B.isPosition(se)&&(Ye=B.of(N),st=B.of(se)),!Ye||!st)throw new Error("Invalid arguments");super(Ye,st),this.f=Ye,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$qK=z,e.$qK=z=l=qe([S],z);const ie=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,M.$7)("connectionToken")};class X{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,se,Se){if(typeof N!="string"||N.length===0)throw(0,M.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,M.$7)("port");typeof Se<"u"&&ie(Se),this.host=N,this.port=Math.round(se),this.connectionToken=Se}}e.$rK=X;class De{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,se){this.makeConnection=N,this.connectionToken=se,typeof se<"u"&&ie(se)}}e.$sK=De;class Pe extends Error{static NotAvailable(N,se){return new Pe(N,v.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(N){return new Pe(N,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,se=v.RemoteAuthorityResolverErrorCode.Unknown,Se){super(N),this._message=N,this._code=se,this._detail=Se,Object.setPrototypeOf(this,Pe.prototype)}}e.$tK=Pe;var ke;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(ke||(e.EndOfLine=ke={}));var $e;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})($e||(e.EnvironmentVariableMutatorType=$e={}));let ye=p=class{static isTextEdit(N){return N instanceof p?!0:N?T.isRange(N)&&typeof N.newText=="string":!1}static replace(N,se){return new p(N,se)}static insert(N,se){return p.replace(new T(N,N),se)}static delete(N){return p.replace(N,"")}static setEndOfLine(N){const se=new p(new T(new B(0,0),new B(0,0)),"");return se.newEol=N,se}get range(){return this.c}set range(N){if(N&&!T.isRange(N))throw(0,M.$7)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,M.$7)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,M.$7)("newEol");this.f=N}constructor(N,se){this.c=N,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$uK=ye,e.$uK=ye=p=qe([S],ye);let ue=E=class{static isNotebookCellEdit(N){return N instanceof E?!0:N?xt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,se){return new E(N,se)}static insertCells(N,se){return new E(new xt(N,N),se)}static deleteCells(N){return new E(N,[])}static updateCellMetadata(N,se){const Se=new E(new xt(N,N),[]);return Se.newCellMetadata=se,Se}static updateNotebookMetadata(N){const se=new E(new xt(0,0),[]);return se.newNotebookMetadata=N,se}constructor(N,se){this.range=N,this.newCells=se}};e.$vK=ue,e.$vK=ue=E=qe([S],ue);class ae{static isSnippetTextEdit(N){return N instanceof ae?!0:N?T.isRange(N.range)&&W.isSnippetString(N.snippet):!1}static replace(N,se){return new ae(N,se)}static insert(N,se){return ae.replace(new T(N,N),se)}constructor(N,se){this.range=N,this.snippet=se}}e.$wK=ae;var we;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,se,Se,He){this.c.push({_type:1,from:N,to:se,options:Se,metadata:He})}createFile(N,se,Se){this.c.push({_type:1,from:void 0,to:N,options:se,metadata:Se})}deleteFile(N,se,Se){this.c.push({_type:1,from:N,to:void 0,options:se,metadata:Se})}e(N,se,Se){this.c.push({_type:3,metadata:Se,uri:N,edit:{editType:5,metadata:se},notebookMetadata:se})}f(N,se,Se,He){const Ye=se.start,st=se.end;(Ye!==st||Se.length>0)&&this.c.push({_type:5,uri:N,index:Ye,count:st-Ye,cells:Se,metadata:He})}g(N,se,Se,He){this.c.push({_type:3,metadata:He,uri:N,edit:{editType:3,index:se,metadata:Se}})}replace(N,se,Se,He){this.c.push({_type:2,uri:N,edit:new ye(se,Se),metadata:He})}insert(N,se,Se,He){this.replace(N,new T(se,se),Se,He)}delete(N,se,Se){this.replace(N,se,"",Se)}has(N){return this.c.some(se=>se._type===2&&se.uri.toString()===N.toString())}set(N,se){if(se)for(const Se of se){if(!Se)continue;let He,Ye;Array.isArray(Se)?(He=Se[0],Ye=Se[1]):He=Se,ue.isNotebookCellEdit(He)?He.newCellMetadata?this.g(N,He.range.start,He.newCellMetadata,Ye):He.newNotebookMetadata?this.e(N,He.newNotebookMetadata,Ye):this.f(N,He.range,He.newCells,Ye):ae.isSnippetTextEdit(He)?this.c.push({_type:6,uri:N,range:He.range,edit:He.snippet,metadata:Ye}):this.c.push({_type:2,uri:N,edit:He,metadata:Ye})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===N.toString()&&(this.c[Se]=void 0);break}}(0,w.$Ib)(this.c)}}get(N){const se=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===N.toString()&&se.push(Se.edit);return se}entries(){const N=new L.$Ac;for(const se of this.c)if(se._type===2){let Se=N.get(se.uri);Se||(Se=[se.uri,[]],N.set(se.uri,Se)),Se[1].push(se.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$xK=_,e.$xK=_=qe([S],_);let W=m=class{static isSnippetString(N){return N instanceof m?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=m.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,se=this.e++){if(typeof N=="function"){const Se=new m;Se.e=this.e,N(Se),this.e=Se.e,N=Se.value}else N=m.c(N);return this.value+="${",this.value+=se,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,se=this.e++){const Se=N.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(N,se){if(typeof se=="function"){const Se=new m;Se.e=this.e,se(Se),this.e=Se.e,se=Se.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$yK=W,e.$yK=W=m=qe([S],W);var Z;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(Z||(e.DiagnosticTag=Z={}));var ee;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let pe=n=class{static isLocation(N){return N instanceof n?!0:N?T.isRange(N.range)&&f.URI.isUri(N.uri):!1}constructor(N,se){if(this.uri=N,se)if(T.isRange(se))this.range=T.of(se);else if(B.isPosition(se))this.range=new T(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$zK=pe,e.$zK=pe=n=qe([S],pe);let me=class{static is(N){return N?typeof N.message=="string"&&N.location&&T.isRange(N.location.range)&&f.URI.isUri(N.location.uri):!1}constructor(N,se){this.location=N,this.message=se}static isEqual(N,se){return N===se?!0:!N||!se?!1:N.message===se.message&&N.location.range.isEqual(se.location.range)&&N.location.uri.toString()===se.location.uri.toString()}};e.$AK=me,e.$AK=me=qe([S],me);let he=class{constructor(N,se,Se=ee.Error){if(!T.isRange(N))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=N,this.message=se,this.severity=Se}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,se){return N===se?!0:!N||!se?!1:N.message===se.message&&N.severity===se.severity&&N.code===se.code&&N.severity===se.severity&&N.source===se.source&&N.range.isEqual(se.range)&&(0,w.$ub)(N.tags,se.tags)&&(0,w.$ub)(N.relatedInformation,se.relatedInformation,me.isEqual)}};e.$BK=he,e.$BK=he=qe([S],he);let Ee=class{constructor(N,se){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=se}};e.$CK=Ee,e.$CK=Ee=qe([S],Ee);var re;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let le=class{constructor(N,se=re.Text){this.range=N,this.kind=se}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$DK=le,e.$DK=le=qe([S],le);var ne;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(ne||(e.SymbolKind=ne={}));var oe;(function(U){U[U.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=r=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,se,Se,He,Ye){this.name=N,this.kind=se,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),He instanceof pe?this.location=He:Se instanceof T&&(this.location=new pe(He,Se)),r.validate(this)}toJSON(){return{name:this.name,kind:ne[this.kind],location:this.location,containerName:this.containerName}}};e.$EK=fe,e.$EK=fe=r=qe([S],fe);let Ce=s=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(s.validate)}constructor(N,se,Se,He,Ye){this.name=N,this.detail=se,this.kind=Se,this.range=He,this.selectionRange=Ye,this.children=[],s.validate(this)}};e.$FK=Ce,e.$FK=Ce=s=qe([S],Ce);var F;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let V=class{constructor(N,se){this.title=N,this.kind=se}};e.$GK=V,e.$GK=V=qe([S],V);let G=class{static{o=this}static{this.c="."}constructor(N){this.value=N}append(N){return new o(this.value?this.value+o.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+o.c)}};e.$HK=G,e.$HK=G=o=qe([S],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(N,se){if(this.range=N,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$IK=J,e.$IK=J=qe([S],J);class q{constructor(N,se,Se,He,Ye,st){this.kind=N,this.name=se,this.detail=Se,this.uri=He,this.range=Ye,this.selectionRange=st}}e.$JK=q;class x{constructor(N,se){this.fromRanges=se,this.from=N}}e.$KK=x;class ce{constructor(N,se){this.fromRanges=se,this.to=N}}e.$LK=ce;var Ne;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let je=class{constructor(N,se){this.range=N,this.command=se}get isResolved(){return!!this.command}};e.$MK=je,e.$MK=je=qe([S],je);let Qe=g=class{#e;static isMarkdownString(N){return N instanceof g?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,se=!1){this.#e=new P.$3j(N,{supportThemeIcons:se})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,se){return this.#e.appendCodeblock(se??"",N),this}};e.$NK=Qe,e.$NK=Qe=g=qe([S],Qe);let Ge=class{constructor(N,se){this.label=N,this.documentation=se}};e.$OK=Ge,e.$OK=Ge=qe([S],Ge);let _e=class{constructor(N,se){this.label=N,this.documentation=se,this.parameters=[]}};e.$PK=_e,e.$PK=_e=qe([S],_e);let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$QK=Ze,e.$QK=Ze=qe([S],Ze);var xe;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(N){this.value=N}};e.$RK=tt,e.$RK=tt=qe([S],tt);let ze=class{constructor(N,se,Se){this.position=N,this.label=se,this.kind=Se}};e.$SK=ze,e.$SK=ze=qe([S],ze);var ut;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut||(e.CompletionTriggerKind=ut={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var Q;(function(U){U[U.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let ve=class{constructor(N,se){this.label=N,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$TK=ve,e.$TK=ve=qe([S],ve);let Be=class{constructor(N=[],se=!1){this.items=N,this.isIncomplete=se}};e.$UK=Be,e.$UK=Be=qe([S],Be);let Oe=class{constructor(N,se,Se){this.insertText=N,this.range=se,this.command=Se}};e.$VK=Oe,e.$VK=Oe=qe([S],Oe);let Xe=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$WK=Xe,e.$WK=Xe=qe([S],Xe);var nt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var $t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function bt(U,N){return`${k.$6l.toKey(U)}.${N}`}e.$XK=bt;var Pt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var qt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(qt||(e.TextDocumentSaveReason=qt={}));var Ht;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var vt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(U){function N(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=N}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(U){function N(se){switch(se){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=N}(Gt||(e.SyntaxTokenType=Gt={}));let jt=class{constructor(N,se){if(se&&!f.URI.isUri(se))throw(0,M.$7)("target");if(!T.isRange(N)||N.isEmpty)throw(0,M.$7)("range");this.range=N,this.target=se}};e.$YK=jt,e.$YK=jt=qe([S],jt);let kt=class{constructor(N,se,Se,He){this.red=N,this.green=se,this.blue=Se,this.alpha=He}};e.$ZK=kt,e.$ZK=kt=qe([S],kt);let Lt=class{constructor(N,se){if(se&&!(se instanceof kt))throw(0,M.$7)("color");if(!T.isRange(N)||N.isEmpty)throw(0,M.$7)("range");this.range=N,this.color=se}};e.$1K=Lt,e.$1K=Lt=qe([S],Lt);let Bt=class{constructor(N){if(!N||typeof N!="string")throw(0,M.$7)("label");this.label=N}};e.$2K=Bt,e.$2K=Bt=qe([S],Bt);var Jt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Wt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Kt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Kt||(e.TerminalExitReason=Kt={}));class Ot{constructor(N,se,Se){if(this.startIndex=N,this.length=se,this.tooltip=Se,typeof N!="number"||N<0)throw(0,M.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$3K=Ot;class at{constructor(N){this.uri=N}}e.$4K=at;class dt{constructor(N){this.terminalCommand=N}}e.$5K=dt;var At;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class Vt{constructor(N){if(this.options=N,typeof N!="object")throw(0,M.$7)("options")}}e.$6K=Vt;var Rt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ot;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(ot||(e.TaskPanelKind=ot={}));let wt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(N){switch(N){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(N,se){if(this.label=se,typeof N!="string"||typeof se!="string")throw(0,M.$7)("name");this.c=N}get id(){return this.c}};e.$7K=wt,e.$7K=wt=h=qe([S],wt);function Tt(U){let N="";for(let se=0;se<U.length;se++)N+=U[se].replace(/,/g,",,")+",";return N}let Ct=class{constructor(N,se,Se){if(typeof N!="string")throw(0,M.$7)("process");this.e=[],this.c=N,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Se):this.f=se)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,M.$7)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const se of this.e)N.push(se);return Tt(N)}};e.$8K=Ct,e.$8K=Ct=qe([S],Ct);let We=class{constructor(N,se,Se){if(this.f=[],Array.isArray(se)){if(!N)throw(0,M.$7)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,M.$7)("command");this.e=N,this.f=se,this.g=Se}else{if(typeof N!="string")throw(0,M.$7)("commandLine");this.c=N,this.g=se}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,M.$7)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,M.$7)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)N.push(typeof se=="string"?se:se.value);return Tt(N)}};e.$9K=We,e.$9K=We=qe([S],We);var Qt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var Ie;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Ie||(e.TaskScope=Ie={}));class Fe{constructor(N){this.c=N}computeId(){return"customExecution"+(0,R.$eg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$0K=Fe;let ge=class{static{C=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,se,Se,He,Ye,st){this.j=!1,this.k=this.definition=N;let lt;typeof se=="string"?(this.m=this.name=se,this.t=this.source=Se,this.execution=He,lt=Ye,this.j=!0):se===Ie.Global||se===Ie.Workspace?(this.target=se,this.m=this.name=Se,this.t=this.source=He,this.execution=Ye,lt=st):(this.target=se,this.m=this.name=Se,this.t=this.source=He,this.execution=Ye,lt=st),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:C.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:C.f,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:C.c,id:this.n.computeId()}:this.k={type:C.g,id:(0,R.$eg)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,M.$7)("Kind can't be undefined or null");this.z(),this.k=N}get scope(){return this.l}set target(N){this.z(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,M.$7)("name");this.z(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.z(),this.n=N;const se=this.k.type;(C.g===se||C.e===se||C.f===se||C.c===se)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.z(),this.o=N,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.z(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,M.$7)("source must be a string of length > 0");this.z(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.z(),this.u=N}get detail(){return this.y}set detail(N){N===null&&(N=void 0),this.y=N}get presentationOptions(){return this.w}set presentationOptions(N){N==null&&(N=Object.create(null)),this.z(),this.w=N}get runOptions(){return this.x}set runOptions(N){N==null&&(N=Object.create(null)),this.z(),this.x=N}};e.$$K=ge,e.$$K=ge=C=qe([S],ge);var H;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(H||(e.ProgressLocation=H={}));var Me;(function(U){function N(se){const Se=se;return(0,D.$Cf)(Se.value)?Se.tooltip&&!(0,D.$yf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=N})(Me||(e.ViewBadge=Me={}));let Ue=I=class{static isTreeItem(N,se){const Se=N;if(Se.checkboxState!==void 0){const He=(0,D.$Cf)(Se.checkboxState)?Se.checkboxState:(0,D.$Af)(Se.checkboxState)&&(0,D.$Cf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ye=!(0,D.$Cf)(Se.checkboxState)&&(0,D.$Af)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==Ve.Checked&&He!==Ve.Unchecked||Ye!==void 0&&!(0,D.$yf)(Ye))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(N instanceof I)return!0;if(Se.label!==void 0&&!(0,D.$yf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,D.$yf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,D.$yf)(Se.iconPath)&&!f.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,D.$yf)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,D.$yf)(He.light)&&!f.URI.isUri(He.light)&&!(0,D.$yf)(He.dark)&&!f.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,D.$yf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!f.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,D.$yf)(Se.tooltip)&&!(Se.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Je.None&&Se.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,D.$yf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(N,se=Je.None){this.collapsibleState=se,f.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$_K=Ue,e.$_K=Ue=I=qe([S],Ue);var Je;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var Ve;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Ve||(e.TreeItemCheckboxState=Ve={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$aL=et,e.$aL=et=qe([S],et);class Et extends et{}e.$bL=Et;class Dt extends Et{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$cL=Dt;class gt{constructor(N,se,Se,He){this.name=N,this.uri=se,this._itemId=Se,this.c=He}data(){return this.c()}}e.$dL=gt;let ht=class{#e=new Map;constructor(N){for(const[se,Se]of N??[]){const He=this.#e.get(this.#t(se));He?He.push(Se):this.#e.set(this.#t(se),[Se])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,se){this.#e.set(this.#t(N),[se])}forEach(N,se){for(const[Se,He]of this.#e)for(const Ye of He)N.call(se,Ye,Se,this)}*[Symbol.iterator](){for(const[N,se]of this.#e)for(const Se of se)yield[N,Se]}#t(N){return N.toLowerCase()}};e.$eL=ht,e.$eL=ht=qe([S],ht);let ft=class{constructor(N){this.insertText=N}};e.$fL=ft,e.$fL=ft=qe([S],ft);let mi=class{constructor(N,se){this.label=se,this.insertText=N}};e.$gL=mi,e.$gL=mi=qe([S],mi);let St=class{constructor(N,se){this.id=N,this.color=se}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$hL=St,e.$hL=St=qe([S],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(N){this.id=N}};e.$iL=Si,e.$iL=Si=qe([S],Si);var ui;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(N){this.c=N,this.e=f.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,se){if(typeof N!="string"&&(!N||!f.URI.isUri(N)&&!f.URI.isUri(N.uri)))throw(0,M.$7)("base");if(typeof se!="string")throw(0,M.$7)("pattern");typeof N=="string"?this.baseUri=f.URI.file(N):f.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$jL=$i,e.$jL=$i=qe([S],$i);const It=new WeakMap;function fn(U,N){It.set(U,N)}e.$kL=fn;let ri=class{constructor(N,se,Se,He){this.enabled=typeof N=="boolean"?N:!0,typeof se=="string"&&(this.condition=se),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,R.$eg)()),this.c}};e.$lL=ri,e.$lL=ri=qe([S],ri);let yt=class extends ri{constructor(N,se,Se,He,Ye){if(super(se,Se,He,Ye),N===null)throw(0,M.$7)("location");this.location=N}};e.$mL=yt,e.$mL=yt=qe([S],yt);let pi=class extends ri{constructor(N,se,Se,He,Ye){super(se,Se,He,Ye),this.functionName=N}};e.$nL=pi,e.$nL=pi=qe([S],pi);let vi=class extends ri{constructor(N,se,Se,He,Ye,st,lt){if(super(He,Ye,st,lt),!se)throw(0,M.$7)("dataId");this.label=N,this.dataId=se,this.canPersist=Se}};e.$oL=vi,e.$oL=vi=qe([S],vi);let si=class{constructor(N,se,Se){this.command=N,this.args=se||[],this.options=Se}};e.$pL=si,e.$pL=si=qe([S],si);let Ii=class{constructor(N,se){this.port=N,this.host=se}};e.$qL=Ii,e.$qL=Ii=qe([S],Ii);let Ci=class{constructor(N){this.path=N}};e.$rL=Ci,e.$rL=Ci=qe([S],Ci);let Mt=class{constructor(N){this.implementation=N}};e.$sL=Mt,e.$sL=Mt=qe([S],Mt);let bi=class{constructor(N,se,Se){this.session=N,this.threadId=se,this.frameId=Se}};e.$tL=bi,e.$tL=bi=qe([S],bi);let Pi=class{constructor(N,se){this.session=N,this.threadId=se}};e.$uL=Pi,e.$uL=Pi=qe([S],Pi);let oi=class{constructor(N,se){this.range=N,this.expression=se}};e.$vL=oi,e.$vL=oi=qe([S],oi);var li;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ct=class{constructor(N,se){this.range=N,this.text=se}};e.$wL=ct,e.$wL=ct=qe([S],ct);let Ai=class{constructor(N,se,Se=!0){this.range=N,this.variableName=se,this.caseSensitiveLookup=Se}};e.$xL=Ai,e.$xL=Ai=qe([S],Ai);let Zt=class{constructor(N,se){this.range=N,this.expression=se}};e.$yL=Zt,e.$yL=Zt=qe([S],Zt);let ii=class{constructor(N,se){this.frameId=N,this.stoppedLocation=se}};e.$zL=ii,e.$zL=ii=qe([S],ii);var Ri;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=c=class extends Error{static FileExists(N){return new c(N,a.FileSystemProviderErrorCode.FileExists,c.FileExists)}static FileNotFound(N){return new c(N,a.FileSystemProviderErrorCode.FileNotFound,c.FileNotFound)}static FileNotADirectory(N){return new c(N,a.FileSystemProviderErrorCode.FileNotADirectory,c.FileNotADirectory)}static FileIsADirectory(N){return new c(N,a.FileSystemProviderErrorCode.FileIsADirectory,c.FileIsADirectory)}static NoPermissions(N){return new c(N,a.FileSystemProviderErrorCode.NoPermissions,c.NoPermissions)}static Unavailable(N){return new c(N,a.FileSystemProviderErrorCode.Unavailable,c.Unavailable)}constructor(N,se=a.FileSystemProviderErrorCode.Unknown,Se){super(f.URI.isUri(N)?N.toString(!0):N),this.code=Se?.name??"Unknown",(0,a.$nk)(this,se),Object.setPrototypeOf(this,c.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$AL=Mi,e.$AL=Mi=c=qe([S],Mi);let Fi=class{constructor(N,se,Se){this.start=N,this.end=se,this.kind=Se}};e.$BL=Fi,e.$BL=Fi=qe([S],Fi);var Xi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Li;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var Yi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Ti;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(N,se=[]){this.tokenTypes=N,this.tokenModifiers=se}}e.$CL=gn;function Ni(U){return typeof U>"u"||(0,D.$zf)(U)}class hi{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let se=0,Se=N.tokenTypes.length;se<Se;se++)this.j.set(N.tokenTypes[se],se);for(let se=0,Se=N.tokenModifiers.length;se<Se;se++)this.k.set(N.tokenModifiers[se],se)}}push(N,se,Se,He,Ye){if(typeof N=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(N,se,Se,He,Ye);if(T.isRange(N)&&typeof se=="string"&&Ni(Se))return this.m(N,se,Se);throw(0,M.$7)()}m(N,se,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const He=N.start.line,Ye=N.start.character,st=N.end.character-N.start.character,lt=this.j.get(se);let zt=0;if(Se)for(const Yt of Se){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);zt|=1<<ei>>>0}this.n(He,Ye,st,lt,zt)}n(N,se,Se,He,Ye){if(this.f&&(N<this.c||N===this.c&&se<this.e)){this.f=!1;const zt=this.g.length/5|0;let Yt=0,ei=0;for(let ti=0;ti<zt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Yt,Ji+=ei):ni+=Yt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Yt=ni,ei=Ji}}let st=N,lt=se;this.f&&this.h>0&&(st-=this.c,st===0&&(lt-=this.e)),this.g[this.h++]=st,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=He,this.g[this.h++]=Ye,this.c=N,this.e=se}static o(N){const se=[],Se=N.length/5|0;for(let lt=0;lt<Se;lt++)se[lt]=lt;se.sort((lt,zt)=>{const Yt=N[5*lt],ei=N[5*zt];if(Yt===ei){const ti=N[5*lt+1],ni=N[5*zt+1];return ti-ni}return Yt-ei});const He=new Uint32Array(N.length);let Ye=0,st=0;for(let lt=0;lt<Se;lt++){const zt=5*se[lt],Yt=N[zt+0],ei=N[zt+1],ti=N[zt+2],ni=N[zt+3],Ji=N[zt+4],Cn=Yt-Ye,Ln=Cn===0?ei-st:ei,Qi=5*lt;He[Qi+0]=Cn,He[Qi+1]=Ln,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ye=Yt,st=ei}return He}build(N){return this.f?new Oi(new Uint32Array(this.g),N):new Oi(hi.o(this.g),N)}}e.$DL=hi;class Oi{constructor(N,se){this.resultId=se,this.data=N}}e.$EL=Oi;class mn{constructor(N,se,Se){this.start=N,this.deleteCount=se,this.data=Se}}e.$FL=mn;class di{constructor(N,se){this.resultId=se,this.edits=N}}e.$GL=di;var Zi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$HL=zi,e.$HL=zi=qe([S],zi);var xi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(N){if(typeof N.badge=="string"){let se=(0,u.$_e)(N.badge,0);if(se<N.badge.length&&(se+=(0,u.$_e)(N.badge,se)),N.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!St.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,se,Se){this.badge=N,this.tooltip=se,this.color=Se}}e.$IL=$n;let Ui=class{constructor(N){this.kind=N}};e.$JL=Ui,e.$JL=Ui=qe([S],Ui);var gi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(N){return N instanceof xt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,se){if(N<0)throw(0,M.$7)("start must be positive");if(se<0)throw(0,M.$7)("end must be positive");N<=se?(this.c=N,this.e=se):(this.c=se,this.e=N)}with(N){let se=this.c,Se=this.e;return N.start!==void 0&&(se=N.start),N.end!==void 0&&(Se=N.end),se===this.c&&Se===this.e?this:new xt(se,Se)}}e.$KL=xt;class wi{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(N){return!0}constructor(N,se,Se,He,Ye,st,lt){this.kind=N,this.value=se,this.languageId=Se,this.mime=He,this.outputs=Ye??[],this.metadata=st,this.executionSummary=lt,wi.validate(this)}}e.$LL=wi;class pn{constructor(N){this.cells=N}}e.$ML=pn;class Xt{static isNotebookCellOutputItem(N){return N instanceof Xt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const se={name:N.name,message:N.message,stack:N.stack};return Xt.json(se,"application/vnd.code.notebook.error")}static stdout(N){return Xt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Xt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,se="application/octet-stream"){return new Xt(N,se)}static#e=new TextEncoder;static text(N,se=A.$Pr.text){const Se=Xt.#e.encode(String(N));return new Xt(Se,se)}static json(N,se="text/x-json"){const Se=JSON.stringify(N,void 0,"	");return Xt.text(Se,se)}constructor(N,se){this.data=N,this.mime=se;const Se=(0,A.$Tr)(se,!0);if(!Se)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$NL=Xt;class yi{static isNotebookCellOutput(N){return N instanceof yi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,se=!1){const Se=new Set,He=new Set;for(let Ye=0;Ye<N.length;Ye++){const st=N[Ye],lt=(0,A.$Tr)(st.mime);if(!Se.has(lt)||(0,$.$uI)(lt)){Se.add(lt);continue}He.add(Ye),se&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return He.size===0?N:N.filter((Ye,st)=>!He.has(st))}constructor(N,se,Se){this.items=yi.ensureUniqueMimeTypes(N,!0),typeof se=="string"?(this.id=se,this.metadata=Se):(this.id=(0,R.$eg)(),this.metadata=se??Se)}}e.$OL=yi;var en;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(N,se){this.text=N,this.alignment=se}}e.$PL=rn;var Te;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Te||(e.NotebookControllerAffinity=Te={}));var _t;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(N,se=[]){this.uri=N,this.provides=(0,w.$3b)(se)}}e.$QL=sn;class mt{constructor(N){this.label=N}}e.$RL=mt;let ji=class{constructor(N,se){this.label=N,this.timestamp=se}};e.$SL=ji,e.$SL=ji=qe([S],ji);var on;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class Di{constructor(N,se){this.ranges=N,this.wordPattern=se}}e.$TL=Di;class vn{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$UL=vn;var cn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let ki=class{constructor(N=void 0,se=void 0,Se=void 0,He=!1){this.include=N,this.exclude=se,this.profile=Se,this.continuous=He}};e.$VL=ki,e.$VL=ki=qe([S],ki);let Wi=y=class{static diff(N,se,Se){const He=new y(N);return He.expectedOutput=se,He.actualOutput=Se,He}constructor(N){this.message=N}};e.$WL=Wi,e.$WL=Wi=y=qe([S],Wi);let Ki=class{constructor(N){this.id=N}};e.$XL=Ki,e.$XL=Ki=qe([S],Ki);let ci=class{constructor(N,se){this.covered=N,this.total=se}};e.$YL=ci,e.$YL=ci=qe([S],ci);let Vi=b=class{static fromDetails(N,se){const Se=new ci(0,0),He=new ci(0,0),Ye=new ci(0,0);for(const lt of se)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const zt of lt.branches)He.total+=1,He.covered+=zt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const st=new b(N,Se,He.total>0?He:void 0,Ye.total>0?Ye:void 0);return st.detailedCoverage=se,st}constructor(N,se,Se,He){this.uri=N,this.statementCoverage=se,this.branchCoverage=Se,this.functionCoverage=He}};e.$ZL=Vi,e.$ZL=Vi=b=qe([S],Vi);let qi=class{constructor(N,se,Se=[]){this.executionCount=N,this.location=se,this.branches=Se}};e.$1L=qi,e.$1L=qi=qe([S],qi);let Hi=class{constructor(N,se){this.executionCount=N,this.location=se}};e.$2L=Hi,e.$2L=Hi=qe([S],Hi);let Gi=class{constructor(N,se){this.executionCount=N,this.location=se}};e.$3L=Gi,e.$3L=Gi=qe([S],Gi);var ln;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var hn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var dn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn||(e.PortAutoForwardAction=dn={}));class te{constructor(N,se,Se,He,Ye,st){this.kind=N,this.name=se,this.detail=Se,this.uri=He,this.range=Ye,this.selectionRange=st}}e.$4L=te;class de{constructor(N){this.uri=N}}e.$5L=de;class Le{constructor(N,se){this.original=N,this.modified=se}}e.$6L=Le;class rt{constructor(N,se,Se,He){this.base=N,this.input1=se,this.input2=Se,this.result=He}}e.$7L=rt;class pt{constructor(N,se){this.uri=N,this.viewType=se}}e.$8L=pt;class Ft{constructor(N){this.viewType=N}}e.$9L=Ft;class Pn{constructor(N,se){this.uri=N,this.notebookType=se}}e.$0L=Pn;class An{constructor(N,se,Se){this.original=N,this.modified=se,this.notebookType=Se}}e.$$L=An;class Rn{constructor(){}}e.$_L=Rn;class Mn{constructor(N,se){this.uri=N,this.inputBoxUri=se}}e.$aM=Mn;var bn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Fn{constructor(N,se){this.role=N,this.content=se}}e.$bM=Fn;var kn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Ae[100],Re([1,0,53,13,16,281,136,7,18]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=void 0;const f=new Map;function R($,d){d?f.set($,d):f.delete($)}e.$oM=R;function k($){return f.get($)}class a extends L.$Vu{constructor(d,t,i,l,p,E,m,n){super(t,i,l,p),this.c=d,this.m=E,this.q=m,this.notebook=n,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,D.$ub)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===M.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(t){return t?d.s(t):d.getText()},get eol(){return d.g===`
`?u.EndOfLine.LF:u.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(t){return d.t(t)},offsetAt(t){return d.u(t)},positionAt(t){return d.v(t)},validateRange(t){return d.w(t)},validatePosition(t){return d.x(t)},getWordRangeAtPosition(t,i){return d.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,w.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,w.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const t=this.w(d);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,l=t.start.line,p=t.end.line,E=[];E.push(this.f[l].substring(t.start.character));for(let m=l+1;m<p;m++)E.push(this.f[m]);return E.push(this.f[p].substring(0,t.end.character)),E.join(i)}t(d){let t;if(d instanceof u.$oK?t=d.line:typeof d=="number"&&(t=d),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this.f[t],t===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const t=this.j.getIndexOf(d),i=this.f[t.index].length;return new u.$oK(t.index,Math.min(t.remainder,i))}w(d){if(!(d instanceof u.$pK))throw new Error("Invalid argument");const t=this.x(d.start),i=this.x(d.end);return t===d.start&&i===d.end?d:new u.$pK(t.line,t.character,i.line,i.character)}x(d){if(!(d instanceof u.$oK))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:t,character:i}=d,l=!1;if(t<0)t=0,i=0,l=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,l=!0;else{const p=this.f[t].length;i<0?(i=0,l=!0):i>p&&(i=p,l=!0)}return l?new u.$oK(t,i):d}y(d,t){const i=this.x(d);if(!t)t=k(this.m);else if((0,P.$Oe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const l=(0,A.$8r)(i.character+1,(0,A.$6r)(t),this.f[i.line],0);if(l)return new u.$pK(i.line,l.startColumn-1,i.line,l.endColumn-1)}}e.$pM=a;class v{constructor(d,t,i){this.a=d,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new u.$pK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new u.$pK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$qM=v}),define(Ae[198],Re([1,0,7,17,5]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;let L=class{constructor(u){this.a=new w.$JL(w.ColorThemeKind.Dark),this.b=new P.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange(u){let D;switch(u){case"light":D=w.ColorThemeKind.Light;break;case"hcDark":D=w.ColorThemeKind.HighContrast;break;case"hcLight":D=w.ColorThemeKind.HighContrastLight;break;default:D=w.ColorThemeKind.Dark}this.a=new w.$JL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Vdc=L,e.$Vdc=L=qe([Ke(0,M.$mM)],L)}),define(Ae[199],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yI=e.CellExecutionUpdateType=void 0;var M;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$yI=(0,w.$Ph)("INotebookExecutionService")}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(L){L.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var M;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class P{static fromExtHostTestItem(A,u,D=A.parent){if(A._isRoot)return new P([u]);const f=[A.id];for(let R=D;R&&R.id!==u;R=R.parent)f.push(R.id);return f.push(u),new P(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const u=A.indexOf("\0");return u===-1?A:A.slice(0,u)}static fromString(A){return new P(A.split("\0"))}static join(A,u){return new P([...A.path,u])}static joinToString(A,u){return A.toString()+"\0"+u}static parentId(A){const u=A.lastIndexOf("\0");return u===-1?void 0:A.slice(0,u)}static localId(A){const u=A.lastIndexOf("\0");return u===-1?A:A.slice(u+1)}static isChild(A,u){return u.startsWith(A)&&u[A.length]==="\0"}static compare(A,u){return A===u?0:P.isChild(A,u)?2:P.isChild(u,A)?3:1}constructor(A,u=A.length){if(this.path=A,this.d=u,A.length===0||u<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let u=0;u<A.d&&u<this.d;u++)if(A.path[u]!==this.path[u])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$eJ=P}),define(Ae[58],Re([1,0,2,41,46]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$kJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$jJ=e.$iJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$hJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$gJ=e.$fJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var u;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(u||(e.TestRunProfileBitset=u={})),e.$fJ=[2,4,8,16,32,64];const D=I=>"runId"in I;e.$gJ=D;var f;(function(I){I.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),I.deserialize=c=>({range:M.$ts.lift(c.range),uri:w.URI.revive(c.uri)})})(f||(e.IRichLocation=f={}));var R;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(R||(e.TestMessageType=R={}));var k;(function(I){I.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&f.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,contextValue:c.contextValue,location:c.location&&f.deserialize(c.location)})})(k||(e.ITestErrorMessage=k={}));const a=(I,c)=>`${c?"s":"e"}${I}`;e.$hJ=a;var v;(function(I){I.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&f.serialize(c.location)}),I.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&f.deserialize(c.location)})})(v||(e.ITestOutputMessage=v={}));var $;(function(I){I.serialize=c=>c.type===0?k.serialize(c):v.serialize(c),I.deserialize=c=>c.type===0?k.deserialize(c):v.deserialize(c)})($||(e.ITestMessage=$={}));var d;(function(I){I.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),I.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map($.serialize)}),I.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map($.deserialize)})})(d||(e.ITestTaskState=d={}));const t="\0",i=(I,c)=>I+t+c;e.$iJ=i;const l=I=>{const c=I.indexOf(t);return{ctrlId:I.slice(0,c),tagId:I.slice(c+1)}};e.$jJ=l;var p;(function(I){I.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),I.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?w.URI.revive(c.uri):void 0,range:c.range?M.$ts.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(p||(e.ITestItem=p={}));var E;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var m;(function(I){I.serialize=c=>({expand:c.expand,item:p.serialize(c.item)}),I.deserialize=c=>({controllerId:P.$eJ.root(c.item.extId),expand:c.expand,item:p.deserialize(c.item)})})(m||(e.InternalTestItem=m={}));var n;(function(I){I.serialize=c=>{let y;return c.item&&(y={},c.item.label!==void 0&&(y.label=c.item.label),c.item.tags!==void 0&&(y.tags=c.item.tags),c.item.busy!==void 0&&(y.busy=c.item.busy),c.item.uri!==void 0&&(y.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(y.range=c.item.range?.toJSON()),c.item.description!==void 0&&(y.description=c.item.description),c.item.error!==void 0&&(y.error=c.item.error),c.item.sortText!==void 0&&(y.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:y}},I.deserialize=c=>{let y;return c.item&&(y={},c.item.label!==void 0&&(y.label=c.item.label),c.item.tags!==void 0&&(y.tags=c.item.tags),c.item.busy!==void 0&&(y.busy=c.item.busy),c.item.range!==void 0&&(y.range=c.item.range?M.$ts.lift(c.item.range):null),c.item.description!==void 0&&(y.description=c.item.description),c.item.error!==void 0&&(y.error=c.item.error),c.item.sortText!==void 0&&(y.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:y}}})(n||(e.ITestItemUpdate=n={}));const r=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.$kJ=r;var s;(function(I){I.serializeWithoutMessages=c=>({...m.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(d.serializeWithoutMessages)}),I.serialize=c=>({...m.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(d.serialize)}),I.deserialize=c=>({...m.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(d.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(o||(e.DetailType=o={}));var g;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(g||(e.TestDiffOpType=g={}));var h;(function(I){I.deserialize=c=>c.op===0?{op:c.op,item:m.deserialize(c.item)}:c.op===1?{op:c.op,item:n.deserialize(c.item)}:c.op===2?{op:c.op,uri:w.URI.revive(c.uri),docv:c.docv}:c,I.serialize=c=>c.op===0?{op:c.op,item:m.serialize(c.item)}:c.op===1?{op:c.op,item:n.serialize(c.item)}:c})(h||(e.TestsDiffOp=h={}));class C{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(c){const y=this.o();for(const b of c)switch(b.op){case 0:this.j(m.deserialize(b.item),y);break;case 1:this.k(n.deserialize(b.item),y);break;case 3:this.l(b.itemId,y);break;case 5:this.m(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this.c.set(b.tag.id,b.tag);break;case 7:this.c.delete(b.id);break}y.complete?.()}j(c,y){const b=P.$eJ.parentId(c.item.extId)?.toString();let S;if(!b)S=this.p(c),this.f.add(S),this.d.set(c.item.extId,S);else if(this.d.has(b)){const j=this.d.get(b);j.children.add(c.item.extId),S=this.p(c,j),this.d.set(c.item.extId,S)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return y.add?.(S),c.expand===2&&this.g++,S}k(c,y){const b=this.d.get(c.extId);if(b)return c.expand!==void 0&&(b.expand===2&&this.g--,c.expand===2&&this.g++),(0,e.$kJ)(b,c),y.update?.(b),b}l(c,y){const b=this.d.get(c);if(!b)return;const S=P.$eJ.parentId(b.item.extId)?.toString();S?this.d.get(S).children.delete(b.item.extId):this.f.delete(b);const j=[[c]];for(;j.length;)for(const O of j.pop()){const K=this.d.get(O);K&&(j.push(K.children),this.d.delete(O),y.remove?.(K,K!==b),K.expand===2&&this.g--)}}m(c){}updatePendingRoots(c){this.h+=c}o(){return{}}}e.$lJ=C}),define(Ae[76],Re([1,0,12,5,6,53,58,46]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.TestItemEventOp=void 0;var D;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const f=(l,p)=>l===p,k=Object.entries({range:(l,p)=>l===p?!0:!l||!p?!1:l.equalsRange(p),busy:f,label:f,description:f,error:f,sortText:f,tags:(l,p)=>!(l.length!==p.length||l.some(E=>!p.includes(E)))}),a=(l,p)=>{let E;for(const[m,n]of k)n(l[m],p[m])||(E?E[m]=p[m]:E={[m]:p[m]});return E};class v extends P.$Sc{get root(){return this.s.root}constructor(p){super(),this.s=p,this.f=this.B(new w.$6g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(p){this.h=p;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const p=this.m;return this.m=[],p}pushDiff(p){switch(p.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===p.uri){E.docv=p.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===p.item.extId){(0,A.$kJ)(E.item,p.item);return}if(E.op===0&&E.item.item.extId===p.item.extId){(0,A.$kJ)(E.item,p.item);return}}break}}this.m.push(p),this.f.isScheduled()||this.f.schedule()}expand(p,E){const m=this.tree.get(p);if(m){if((m.expandLevels===void 0||E>m.expandLevels)&&(m.expandLevels=E),m.expand===1){const n=this.L(m);return n.isOpen()?this.J(m,E-1):n.wait().then(()=>this.J(m,E-1))}else if(m.expand===3)return m.resolveBarrier?.isOpen()===!1?m.resolveBarrier.wait().then(()=>this.J(m,E-1)):this.J(m,E-1)}}dispose(){for(const p of this.tree.values())this.s.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(p,E){switch(E.op){case 3:this.N(u.$eJ.joinToString(p.fullId,E.id));break;case 0:this.y(E.item,p);break;case 5:for(const m of E.ops)this.u(p,m);break;case 1:this.z(E.new,E.old,p.fullId.toString());break;case 2:this.I(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:E.update}});break;case 6:this.w(p.actual.uri);break;default:(0,L.$4c)(E)}}w(p){p&&this.pushDiff({op:2,uri:p,docv:this.s.getDocumentVersion(p)})}y(p,E){const m=u.$eJ.fromExtHostTestItem(p,this.root.id,E?.actual),n=this.s.getApiFor(p);n.parent&&n.parent!==E?.actual&&this.s.getChildren(n.parent).delete(p.id);let r=this.tree.get(m.toString());if(!r){r={fullId:m,actual:p,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},p.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(p,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(p)}}),this.H(p,r,E);return}if(r.actual===p){this.G(p,r,E);return}if(r.actual.uri?.toString()!==p.uri?.toString())return this.N(m.toString()),this.y(p,E);const s=this.s.getChildren(r.actual),o=r.actual,g=a(this.s.toITestItem(o),this.s.toITestItem(p));this.s.getApiFor(o).listener=void 0,r.actual=p,r.expand=0,g&&(g.hasOwnProperty("tags")&&(this.z(p.tags,o.tags,m.toString()),delete g.tags),this.u(r,{op:4,update:g})),this.H(p,r,E);for(const[h,C]of s)this.s.getChildren(p).get(C.id)||this.N(u.$eJ.joinToString(m,C.id));this.w(r.actual.uri)}z(p,E,m){const n=new Set(E.map(r=>r.id));for(const r of p)n.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:m,item:{tags:p.map(r=>(0,A.$iJ)(this.s.controllerId,r.id))}}}),n.forEach(this.D,this)}C(p){const E=this.j.get(p.id);E?E.refCount++:(this.j.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$iJ)(this.s.controllerId,p.id)}}))}D(p){const E=this.j.get(p);E&&!--E.refCount&&(this.j.delete(p),this.pushDiff({op:7,id:(0,A.$iJ)(this.s.controllerId,p)}))}F(p,E){this.s.getApiFor(p).parent=E&&E.actual!==this.root?E.actual:void 0}G(p,E,m){this.F(p,m);const n=this.s.getApiFor(p);n.parent=m?.actual,n.listener=r=>this.u(E,r),this.I(E)}H(p,E,m){this.G(p,E,m);for(const[n,r]of this.s.getChildren(p))this.y(r,E)}I(p){let E;this.h?p.resolveBarrier?E=p.resolveBarrier.isOpen()?3:2:E=p.actual.canResolveChildren?1:0:E=0,E!==p.expand&&(p.expand=E,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:E}}),E===1&&p.expandLevels!==void 0&&this.L(p))}J(p,E){if(E<0)return;const m=[];for(const[n,r]of this.s.getChildren(p.actual)){const s=this.expand(u.$eJ.joinToString(p.fullId,r.id),E);(0,w.$Gg)(s)&&m.push(s)}if(m.length)return Promise.all(m).then(()=>{})}L(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this.h){const r=new w.$Sg;return r.open(),r}p.expand=2,this.M(p);const E=p.resolveBarrier=new w.$Sg,m=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let n;try{n=this.h(p.actual===this.root?void 0:p.actual)}catch(r){m(r)}return(0,w.$Gg)(n)?n.catch(m).then(()=>{E.open(),this.I(p)}):(E.open(),this.I(p)),p.resolveBarrier}M(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}N(p){const E=this.tree.get(p);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const m=[E];for(;m.length;){const n=m.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.D(r.id);this.tree.delete(n.fullId.toString());for(const[r,s]of this.s.getChildren(n.actual))m.push(this.tree.get(u.$eJ.joinToString(n.fullId,s.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.g.fire(p)}}e.$cM=v;class $ extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.$dM=$;class d extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$eM=d;class t extends Error{constructor(p,E,m){super(`TestItem with ID "${p}" is from controller "${E}" and cannot be added as a child of an item from controller "${m}".`)}}e.$fM=t;const i=(l,p,E)=>{let m=new Map;return{get size(){return m.size},forEach(n,r){for(const s of m.values())n.call(r,s,this)},[Symbol.iterator](){return m.entries()},replace(n){const r=new Map,s=new Set(m.keys()),o={op:5,ops:[]};for(const g of n){if(!(g instanceof E))throw new d(g.id);const h=p(g).controllerId;if(h!==l.controllerId)throw new t(g.id,h,l.controllerId);if(r.has(g.id))throw new $(g.id);r.set(g.id,g),s.delete(g.id),o.ops.push({op:0,item:g})}for(const g of s.keys())o.ops.push({op:3,id:g});l.listener?.(o),m=r},add(n){if(!(n instanceof E))throw new d(n.id);m.set(n.id,n),l.listener?.({op:0,item:n})},delete(n){m.delete(n)&&l.listener?.({op:3,id:n})},get(n){return m.get(n)},toJSON(){return Array.from(m.values())}}};e.$gM=i}),define(Ae[101],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=void 0;const M=new WeakMap,P=(A,u)=>{const D={controllerId:u};return M.set(A,D),D};e.$hM=P;const L=A=>{const u=M.get(A);if(!u)throw new w.$eM(A?.id||"<unknown>");return u};e.$iM=L}),define(Ae[77],Re([1,0,13,2]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epb=e.$dpb=e.$cpb=e.$bpb=e.$apb=void 0,e.$apb="vscode-cdn.net",e.$bpb=`vscode-resource.${e.$apb}`,e.$cpb=`'self' https://*.${e.$apb}`;function P(u,D){return u.scheme===w.Schemas.http||u.scheme===w.Schemas.https?u:(D&&D.authority&&D.isRemote&&u.scheme===w.Schemas.file&&(u=M.URI.from({scheme:w.Schemas.vscodeRemote,authority:D.authority,path:u.path})),M.URI.from({scheme:w.Schemas.https,authority:`${u.scheme}+${L(u.authority)}.${e.$bpb}`,path:u.path,fragment:u.fragment,query:u.query}))}e.$dpb=P;function L(u){return u.replace(/./g,D=>{const f=D.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?D:"-"+f.toString(16).padStart(4,"0")})}function A(u){return u.replace(/-([0-9a-f]{4})/g,(D,f)=>String.fromCharCode(parseInt(f,16)))}e.$epb=A}),define(Ae[200],Re([1,0,5,6,77]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class L{constructor(u,D,f){this.d=u,this.e=D,this.f=f,this.a=0,this.b=new M.$Rc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const k of this.c.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(u=>u.inset.dispose()),this.b.dispose()}createWebviewEditorInset(u,D,f,R,k){let a;for(const p of this.e.getVisibleTextEditors(!0))if(p.value===u){a=p;break}if(!a)throw new Error("not a visible editor");const v=this,$=this.a++,d=new w.$Nd,t=new w.$Nd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(p){return(0,P.$dpb)(p,v.f)}get cspSource(){return P.$cpb}set options(p){this.b=p,v.d.$setOptions($,p)}get options(){return this.b}set html(p){this.a=p,v.d.$setHtml($,p)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(p){return v.d.$postMessage($,p)}},l=new class{constructor(){this.editor=u,this.line=D,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){v.c.has($)&&(v.c.delete($),v.d.$disposeEditorInset($),t.fire(),t.dispose(),d.dispose())}};return this.d.$createEditorInset($,a.id,a.value.document.uri,D+1,f,R||{},k.identifier,k.extensionLocation),this.c.set($,{editor:u,inset:l,onDidReceiveMessage:d}),l}$onDidDispose(u){const D=this.c.get(u);D&&D.inset.dispose()}$onDidReceiveMessage(u,D){this.c.get(u)?.onDidReceiveMessage.fire(D)}}e.$tdc=L}),define(Ae[201],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.VariableKind=e.$$M=void 0,e.$$M=(0,w.$Ph)("configurationResolverService");var M;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class P extends Error{constructor(A,u){super(u),this.variable=A}}e.$_M=P}),define(Ae[202],Re([1,0,20,73,15,25,23,90,166,201,16]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,$,d,t){this.h=new Map,this.a=v,this.b=$,this.g=d,t&&(this.c=t.then(i=>this.i(i)))}i(v){if(A.$j){const $=Object.create(null);return Object.keys(v).forEach(d=>{$[d.toLowerCase()]=v[d]}),$}return v}resolveWithEnvironment(v,$,d){return this.l({env:this.i(v),userHome:void 0},$?$.uri:void 0,d)}async resolveAsync(v,$){const d={env:await this.c,userHome:await this.g};return this.l(d,v?v.uri:void 0,$)}async j(v,$,d,t){const i=L.$7m($);A.$j&&i.windows?Object.keys(i.windows).forEach(p=>i[p]=i.windows[p]):A.$k&&i.osx?Object.keys(i.osx).forEach(p=>i[p]=i.osx[p]):A.$l&&i.linux&&Object.keys(i.linux).forEach(p=>i[p]=i.linux[p]),delete i.windows,delete i.osx,delete i.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,v?v.uri:void 0,i,d,t)}async resolveAnyAsync(v,$,d){return this.j(v,$,d)}async resolveAnyMap(v,$,d){const t=new Map;return{newConfig:await this.j(v,$,d,t),resolvedVariables:t}}resolveWithInteractionReplace(v,$,d,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,$,d,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,$){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,$)}async l(v,$,d,t,i){if(P.$yf(d))return this.m(v,$,d,t,i);if(Array.isArray(d))return Promise.all(d.map(l=>this.l(v,$,l,t,i)));if(P.$Af(d)){const l=Object.create(null),p=await Promise.all(Object.keys(d).map(async E=>[await this.m(v,$,E,t,i),await this.l(v,$,d[E],t,i)]));for(const[E,m]of p)l[E]=m;return l}return d}m(v,$,d,t,i){return(0,R.$Te)(d,k.VARIABLE_REGEXP,async(l,p)=>{if(p.includes(k.VARIABLE_LHS))return l;let E=await this.o(v,l,p,$,t);return i?.set(p,E),E!==l&&P.$yf(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.m(v,$,E,t,i)),E})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,$,d,t,i){let l;const p=d.split(":");p.length>1&&(d=p[0],l=p[1]);const E=r=>{const s=this.a.getFilePath();if(s)return(0,u.$sv)(s);throw new f.$_M(r,(0,D.localize)(0,null,$))},m=r=>{const s=E(r);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,u.$sv)(o)}throw new f.$_M(r,(0,D.localize)(1,null,$,w.$nc(s)))},n=r=>{if(l){const s=this.a.getFolderUri(l);if(s)return s;throw new f.$_M(r,(0,D.localize)(2,null,$,l))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$_M(r,(0,D.localize)(3,null,$)):new f.$_M(r,(0,D.localize)(4,null,$))};switch(d){case"env":if(l){if(v.env){const r=v.env[A.$j?l.toLowerCase():l];if(P.$yf(r))return r}return""}throw new f.$_M(f.VariableKind.Env,(0,D.localize)(5,null,$));case"config":if(l){const r=this.a.getConfigurationValue(t,l);if(P.$Hf(r))throw new f.$_M(f.VariableKind.Config,(0,D.localize)(6,null,$,l));if(P.$Af(r))throw new f.$_M(f.VariableKind.Config,(0,D.localize)(7,null,$,l));return r}throw new f.$_M(f.VariableKind.Config,(0,D.localize)(8,null,$));case"command":return this.p(f.VariableKind.Command,$,l,i,"command");case"input":return this.p(f.VariableKind.Input,$,l,i,"input");case"extensionInstallFolder":if(l){const r=await this.a.getExtension(l);if(!r)throw new f.$_M(f.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,$,l));return this.n(r.extensionLocation)}throw new f.$_M(f.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,$));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,u.$sv)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||l?(0,u.$sv)(this.n(n(f.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,u.$sv)(w.$nc(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new f.$_M(f.VariableKind.UserHome,(0,D.localize)(11,null,$))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new f.$_M(f.VariableKind.LineNumber,(0,D.localize)(12,null,$))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new f.$_M(f.VariableKind.SelectedText,(0,D.localize)(13,null,$))}case"file":return E(f.VariableKind.File);case"fileWorkspaceFolder":return m(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||l?w.$lc(this.n(n(f.VariableKind.RelativeFile)),E(f.VariableKind.RelativeFile)):E(f.VariableKind.RelativeFile);case"relativeFileDirname":{const r=w.$mc(E(f.VariableKind.RelativeFileDirname));if(t||l){const s=w.$lc(this.n(n(f.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return w.$mc(E(f.VariableKind.FileDirname));case"fileExtname":return w.$oc(E(f.VariableKind.FileExtname));case"fileBasename":return w.$nc(E(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=w.$nc(E(f.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-w.$oc(r).length)}case"fileDirnameBasename":return w.$nc(w.$mc(E(f.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||$}case"execInstallFolder":{const r=this.a.getAppRoot();return r||$}case"pathSeparator":return w.sep;default:try{const r=l?`${d}:${l}`:d;return this.p(f.VariableKind.Unknown,$,r,i,void 0)}catch{return $}}}}p(v,$,d,t,i){if(d&&t){const l=i===void 0?t[d]:t[i+":"+d];if(typeof l=="string")return l;throw new f.$_M(v,(0,D.localize)(14,null,$))}return $}}e.$nN=k}),define(Ae[102],Re([1,0,4,99]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.OpenEditorContext=e.GroupsOrder=e.$oC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$nC=void 0,e.$nC=(0,w.$Ph)("editorGroupsService");var P;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var u;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(u||(e.GroupsArrangement=u={}));var D;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function f($){const d=$;return(0,M.$8D)(d?.editor)&&(0,M.$8D)(d?.replacement)}e.$oC=f;var R;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a($){const d=$;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.$pC=a;function v($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$qC=v}),define(Ae[203],Re([1,0,4,102]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uC=e.$tC=e.$sC=e.$rC=void 0,e.$rC=(0,w.$Ph)("editorService"),e.$sC=-1,e.$tC=-2;function P(L){const A=L;return typeof L=="number"||(0,M.$pC)(A)}e.$uC=P}),define(Ae[204],Re([1,0,4,172]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IJ=void 0,e.$IJ=(0,w.$Qh)(M.$Wh)}),define(Ae[103],Re([1,0,21,5,20,6]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4b=e.$C4b=e.$B4b=e.$A4b=e.$z4b=e.$y4b=void 0;class A{constructor(i,l){this.versionId=i,this.removedDueToLooping=l}}e.$y4b=A;class u{static isHostExtension(i,l,p){if(l.getExtensionDescription(i))return!1;const E=p.getExtensionDescription(i);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(i,l){this.j=i,this.c=new M.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=l,this.k()}k(){this.e.sort($),this.f=new w.$8l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const l=this.j.readActivationEvents(i);if(Array.isArray(l))for(let p of l)p==="onUri"&&(p=`onUri:${w.$6l.toKey(i.identifier)}`),this.h.has(p)||this.h.set(p,[]),this.h.get(p).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,l){this.e=d(this.e,l),this.e=this.e.concat(i);const p=u.l(this.e);return this.e=d(this.e,p.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,p)}static l(i){const l=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,s){this.addNode(r),this.addNode(s),this.c.has(r)?this.c.get(r).push(s):this.c.set(r,[s])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,s){const o=l.getArcs(r);for(let g=0;g<o.length;g++)if(!s.has(o[g]))return!1;return!0}getNodes(){return this.e}},p=new w.$8l;for(const r of i)if(p.set(r.identifier,r),r.extensionDependencies)for(const s of r.extensionDependencies)l.addArc(w.$6l.toKey(r.identifier),w.$6l.toKey(s));const E=new Set;l.getNodes().filter(r=>l.getArcs(r).length===0).forEach(r=>E.add(r));const m=l.getNodes().filter(r=>!E.has(r));let n;do{n=!1;for(let r=0;r<m.length;r++){const s=m[r];l.hasOnlyGoodArcs(s,E)&&(m.splice(r,1),r--,E.add(s),n=!0)}}while(n);return m.map(r=>p.get(r))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const l=this.h.get(i);return l?l.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const l=this.f.get(i);return l||void 0}getExtensionDescriptionByUUID(i){for(const l of this.g)if(l.uuid===i)return l}getExtensionDescriptionByIdOrUUID(i,l){return this.getExtensionDescription(i)??(l?this.getExtensionDescriptionByUUID(l):void 0)}}e.$z4b=u;class D{constructor(i,l){this.versionId=i,this.extensions=l}}e.$A4b=D,e.$B4b={readActivationEvents:t=>t.activationEvents};class f{constructor(i){this.d=new a,this.c=new u(i,[])}async acquireLock(i){const l=await this.d.acquire(i);return new R(this,l)}deltaExtensions(i,l,p){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(l,p)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,l){return this.c.getExtensionDescriptionByIdOrUUID(i,l)}}e.$C4b=f;class R extends L.$Sc{constructor(i,l){super(),this.f=i,this.c=!1,this.B(l)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$D4b=R;class k{constructor(i){this.name=i,this.promise=new Promise((l,p)=>{this.c=l})}resolve(i){this.c(i)}}class a{constructor(){this.c=[],this.d=!1}async acquire(i){const l=new k(i);return this.c.push(l),this.e(),l.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let l=!0;const p=setTimeout(()=>{l&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{l&&(clearTimeout(p),l=!1,this.d=!1,this.e())};i.resolve((0,L.$Qc)(E))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function $(t,i){const l=t.isBuiltin?0:t.isUnderDevelopment?2:1,p=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(l!==p)return l-p;const E=P.$gc.basename(t.extensionLocation.path),m=P.$gc.basename(i.extensionLocation.path);return E<m?-1:E>m?1:0}function d(t,i){const l=new w.$7l(i);return t.filter(p=>!l.has(p.identifier))}}),define(Ae[78],Re([1,0,26]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$cm=e.$bm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(M||(e.UIKind=M={}));var P;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var L;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(f){const R=w.$be.alloc(1);switch(f){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$bm=A;function u(f,R){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$cm=u;var D;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[59],Re([1,0,4,5,14,27,78,54,55,25,2,6,155]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=e.$DM=void 0;let v=class extends k.$Sc{constructor(i,l){super(),this.s=i,this.t=l,this.a=this.B(new M.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=l.createLogger(this.m,{id:D.$oo,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(l.onDidChangeLogLevel(p=>{(0,P.$_i)(p)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,l,p){const E=this.getTelemetryDetails(),m=new $(l,p,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,m]),m.apiTelemetryLogger}$initializeTelemetryLevel(i,l,p){this.f=i,this.g=l,this.c=p??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const l=Object.create(null);switch(l["common.extname"]=`${i.publisher}.${i.name}`,l["common.extversion"]=i.version,l["common.vscodemachineid"]=this.s.telemetryInfo.machineId,l["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,l["common.vscodeversion"]=this.s.version,l["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),l["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:l["common.uikind"]="web";break;case A.UIKind.Desktop:l["common.uikind"]="desktop";break;default:l["common.uikind"]="unknown"}return l["common.remotename"]=(0,u.$Vk)((0,D.$vo)(this.s.remote.authority)),l}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const l=this.getTelemetryDetails();this.r.forEach((p,E)=>{const m=p.filter(n=>!n.isDisposed);m.length===0?this.r.delete(E):this.r.set(E,m)}),this.r.forEach(p=>{for(const E of p)E.updateTelemetryEnablements(l.isUsageEnabled,l.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,l){const E=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!E)return this.r.delete(i.value),!1;let m=!1;for(const n of E)n.ignoreUnhandledExtHostErrors||(n.logError(l),m=!0);return m}};e.$DM=v,e.$DM=v=qe([Ke(0,L.$CM),Ke(1,P.$$i)],v);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,l,p,E,m,n,r){this.g=p,this.h=E,this.i=m,this.j=n,this.a=new M.$Nd,this.ignoreUnhandledExtHostErrors=l?.ignoreUnhandledErrors??!1,this.b=l?.ignoreBuiltInCommonProperties??!1,this.c=l?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,l){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:l},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let l="properties"in i?i.properties??{}:i;return l=(0,D.$yo)(l,[]),this.c&&(l=(0,f.$0m)(l,this.c)),this.b||(l=(0,f.$0m)(l,this.j)),"properties"in i?i.properties=l:i=l,i}k(i,l){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,l=this.mixInCommonPropsAndCleanData(l||{}),this.i||this.f?.sendEventData(i,l),this.h.trace(i,l))}logUsage(i,l){this.d.isUsageEnabled&&this.k(i,l)}logError(i,l){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,l);else{const p={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,D.$yo)(p,[]),m=new Error(E.message,{cause:E.cause});m.stack=E.stack,m.name=E.name,l=this.mixInCommonPropsAndCleanData(l||{}),this.i||this.f.sendErrorData(m,l),this.h.trace("exception",l)}}get apiTelemetryLogger(){if(!this.e){const i=this,l={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(l)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$EM=$;function d(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$FM=d,e.$GM=(0,w.$Ph)("IExtHostTelemetry")}),define(Ae[22],Re([1,0,5,2,181,98,21,4]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mF=e.$lF=e.$kF=e.ActivationKind=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.ExtensionHostStartup=e.$eF=e.$dF=e.$cF=e.$bF=void 0,e.$bF=Object.freeze({identifier:new A.$6l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$cF="extensions.webWorker",e.$dF=(0,u.$Ph)("extensionService");class D{constructor(m){this.dependency=m}}e.$eF=D;var f;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(m,n,r){this.c=m,this.d=n.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$YE.createActivationEventsMap(this.d)}}set(m,n,r){if(this.c>m)throw new Error(`ExtensionHostExtensions: invalid versionId ${m} (current: ${this.c})`);const s=[],o=[],g=[],h=[],C=k(this.d),I=k(n),c=(O,K)=>O.extensionLocation.toString()===K.extensionLocation.toString()||O.isBuiltin===K.isBuiltin||O.isUserBuiltin===K.isUserBuiltin||O.isUnderDevelopment===K.isUnderDevelopment;for(const O of this.d){const K=I.get(O.identifier);if(!K){s.push(O.identifier),C.delete(O.identifier);continue}if(!c(O,K)){s.push(O.identifier),C.delete(O.identifier);continue}}for(const O of n){const K=C.get(O.identifier);if(!K){o.push(O);continue}if(!c(K,O)){s.push(K.identifier),C.delete(K.identifier);continue}}const y=new A.$7l(this.e),b=new A.$7l(r);for(const O of this.e)b.has(O)||g.push(O);for(const O of r)y.has(O)||h.push(O);const S=L.$YE.createActivationEventsMap(o),j={versionId:m,toRemove:s,toAdd:o,addActivationEvents:S,myToRemove:g,myToAdd:h};return this.delta(j),j}delta(m){if(this.c>=m.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:s,myToAdd:o}=m,g=new A.$7l(n),h=new A.$7l(s);for(let C=0;C<this.d.length;C++)g.has(this.d[C].identifier)&&(this.d.splice(C,1),C--);for(let C=0;C<this.e.length;C++)h.has(this.e[C])&&(this.e.splice(C,1),C--);for(const C of r)this.d.push(C);for(const C of o)this.e.push(C);return m}containsExtension(m){for(const n of this.e)if(A.$6l.equals(n,m))return!0;return!1}}e.$fF=R;function k(E){const m=new A.$8l;for(const n of E)m.set(n.identifier,n);return m}function a(E,m){return E.enabledApiProposals?E.enabledApiProposals.includes(m):!1}e.$gF=a;function v(E,m){if(!a(E,m))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$hF=v;class ${constructor(m,n,r,s){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=s}}e.$iF=$;class d{constructor(m,n){this.description=m,this.value=n}}e.$jF=d;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,P.$Eo)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$kF=i;function l(E,m){return{identifier:new A.$6l((0,P.$Co)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!m,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$lF=l;class p{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$mF=p}),define(Ae[205],Re([1,0,11,103,21,22,14,12]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=e.$Hcc=e.$Gcc=e.$Fcc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,l,p,E){this.startup=i,this.codeLoadingTime=l,this.activateCallTime=p,this.activateResolvedTime=E}}e.$Fcc=D;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,l){return i===-1||l===-1?-1:l-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Gcc=f;class R{constructor(i,l,p,E,m,n){this.activationFailed=i,this.activationFailedError=l,this.activationTimes=p,this.module=E,this.exports=m,this.subscriptions=n}}e.$Hcc=R;class k extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Icc=k;class a extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jcc=a;class v extends R{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,l,p,E){this.g=E,this.a=i,this.b=l,this.c=p,this.d=new P.$8l,this.f=Object.create(null)}dispose(){for(const[i,l]of this.d)l.dispose()}async waitForActivatingExtensions(){const i=[];for(const[l,p]of this.d)i.push(p.wait());await Promise.all(i)}isActivated(i){const l=this.d.get(i);return!!(l&&l.value)}getActivatedExtension(i){const l=this.d.get(i);if(!l||!l.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return l.value}async activateByEvent(i,l){if(this.f[i])return;const p=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(p.map(E=>({id:E.identifier,reason:{startup:l,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,l){const p=this.a.getExtensionDescription(i);if(!p)throw new Error(`Extension '${i}' is not known`);return this.h([{id:p.identifier,reason:l}])}async h(i){const l=i.filter(p=>!this.isActivated(p.id)).map(p=>this.j(p));await Promise.all(l.map(p=>p.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const l=this.a.getExtensionDescription(i.id);if(!l){const m=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new v(m));return this.c.onExtensionActivationError(i.id,m,new L.$eF(i.id.value)),n}const p=[],E=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const m of E){if(this.m(m))continue;const n=this.d.get(m);if(n){p.push(n);continue}if(this.l(m)){p.push(this.j({id:this.b.getExtensionDescription(m).identifier,reason:i.reason}));continue}const r=this.a.getExtensionDescription(m);if(r){if(!r.main&&!r.browser)continue;p.push(this.j({id:r.identifier,reason:i.reason}));continue}const s=l.displayName||l.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${m}'`),g=this.k(i,l.displayName,[],new v(o));return this.c.onExtensionActivationError(l.identifier,o,new L.$eF(m)),g}return this.k(i,l.displayName,p,null)}k(i,l,p,E){const m=new d(i.id,l,i.reason,p,E,this.c,this.g);return this.d.set(i.id,m),m}l(i){return M.$z4b.isHostExtension(i,this.a,this.b)}m(i){const l=this.b.getExtensionDescription(i);return l?!l.main&&!l.browser:!1}};e.$Kcc=$,e.$Kcc=$=qe([Ke(3,A.$0i)],$);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,l,p,E,m,n,r){this.c=i,this.d=l,this.f=p,this.g=E,this.h=m,this.j=n,this.k=r,this.a=new u.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const l=this.g[i];if(l.value&&!l.value.activationFailed){this.g.splice(i,1),i--;continue}if(l.value&&l.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);p.detail=l.value.activationFailedError,this.h=new v(p),this.j.onExtensionActivationError(this.c,p,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const l=new Error;if(i&&i.name&&(l.name=i.name),i&&i.message?l.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(l.stack=i.stack),this.h=new v(l),this.b&&w.$4(i))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};d=qe([Ke(6,A.$0i)],d)}),define(Ae[8],Re([1,0,18,26,122,206,51,28,116,68,67,25,15,2,41,79,94,101,99,75,46,58,203,7,22]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$lM=e.$kM=e.MarkdownString=e.$jM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Ie){function Fe(H){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Je,positionColumn:Ve}=H,et=new r.$oK(Me-1,Ue-1),Et=new r.$oK(Je-1,Ve-1);return new r.$qK(et,Et)}Ie.to=Fe;function ge(H){const{anchor:Me,active:Ue}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ie.from=ge})(o||(e.Selection=o={}));var g;(function(Ie){function Fe(H){if(!H)return;const{start:Me,end:Ue}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ie.from=Fe;function ge(H){if(!H)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Je,endColumn:Ve}=H;return new r.$pK(Me-1,Ue-1,Je-1,Ve-1)}Ie.to=ge})(g||(e.Range=g={}));var h;(function(Ie){function Fe(ge){switch(ge){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ie.to=Fe})(h||(e.TokenType=h={}));var C;(function(Ie){function Fe(H){return new r.$oK(H.lineNumber-1,H.column-1)}Ie.to=Fe;function ge(H){return{lineNumber:H.line+1,column:H.character+1}}Ie.from=ge})(C||(e.Position=C={}));var I;(function(Ie){function Fe(Me,Ue,Je){return(0,w.$Hb)((0,w.$3b)(Me).map(Ve=>ge(Ve,Ue,Je)))}Ie.from=Fe;function ge(Me,Ue,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,Ue),pattern:Y.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function H(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var c;(function(Ie){function Fe(H){switch(H){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ie.from=Fe;function ge(H){switch(H){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ie.to=ge})(c||(e.DiagnosticTag=c={}));var y;(function(Ie){function Fe(H){let Me;return H.code&&((0,a.$yf)(H.code)||(0,a.$Cf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...g.from(H.range),message:H.message,source:H.source,code:Me,severity:S.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(b.from),tags:Array.isArray(H.tags)?(0,w.$Hb)(H.tags.map(c.from)):void 0}}Ie.from=Fe;function ge(H){const Me=new r.$BK(g.to(H),H.message,S.to(H.severity));return Me.source=H.source,Me.code=(0,a.$yf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(b.to),Me.tags=H.tags&&(0,w.$Hb)(H.tags.map(c.to)),Me}Ie.to=ge})(y||(e.Diagnostic=y={}));var b;(function(Ie){function Fe(H){return{...g.from(H.location.range),message:H.message,resource:H.location.uri}}Ie.from=Fe;function ge(H){return new r.$AK(new r.$zK(H.resource,g.to(H)),H.message)}Ie.to=ge})(b||(e.DiagnosticRelatedInformation=b={}));var S;(function(Ie){function Fe(H){switch(H){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Fe;function ge(H){switch(H){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ie.to=ge})(S||(e.DiagnosticSeverity=S={}));var j;(function(Ie){function Fe(H){return typeof H=="number"&&H>=r.ViewColumn.One?H-1:H===r.ViewColumn.Beside?n.$tC:n.$sC}Ie.from=Fe;function ge(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=ge})(j||(e.ViewColumn=j={}));function O(Ie){return typeof Ie.range<"u"}function K(Ie){return Ie.length===0?!0:!!O(Ie[0])}e.$jM=K;var B;(function(Ie){function Fe(Ve){return Ve.map(Ie.from)}Ie.fromMany=Fe;function ge(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function H(Ve){let et;if(ge(Ve)){const{language:ht,value:ft}=Ve;et={value:"```"+ht+`
`+ft+"\n```\n"}}else r.$NK.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const Et=Object.create(null);et.uris=Et;const Dt=ht=>{try{let ft=v.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,Et)}),Et[ht]=ft}catch{}return""},gt=new D.marked.Renderer;return gt.link=Dt,gt.image=ht=>typeof ht=="string"?Dt(A.$0j(ht).href):"",(0,D.marked)(et.value,{renderer:gt}),et}Ie.from=H;function Me(Ve,et){if(!Ve)return Ve;let Et;try{Et=(0,f.$lh)(Ve)}catch{}if(!Et)return Ve;let Dt=!1;return Et=(0,k.$9m)(Et,gt=>{if(v.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=gt,Dt=!0,ht}else return}),Dt?JSON.stringify(Et):Ve}function Ue(Ve){const et=new r.$NK(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?v.URI.from(Ve.baseUri):void 0,et}Ie.to=Ue;function Je(Ve){if(Ve)return typeof Ve=="string"?Ve:Ie.from(Ve)}Ie.fromStrict=Je})(B||(e.MarkdownString=B={}));function T(Ie){return K(Ie)?Ie.map(Fe=>({range:g.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?B.fromMany(Fe.hoverMessage):Fe.hoverMessage?B.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ie.map(Fe=>({range:g.from(Fe)}))}e.$kM=T;function z(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?v.URI.file(Ie):Ie}e.$lM=z;var ie;(function(Ie){function Fe(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?z(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ie.from=Fe})(ie||(e.ThemableDecorationAttachmentRenderOptions=ie={}));var X;(function(Ie){function Fe(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?z(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?ie.from(ge.before):void 0,after:ge.after?ie.from(ge.after):void 0}}Ie.from=Fe})(X||(e.ThemableDecorationRenderOptions=X={}));var De;(function(Ie){function Fe(ge){if(typeof ge>"u")return ge;switch(ge){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Fe})(De||(e.DecorationRangeBehavior=De={}));var Pe;(function(Ie){function Fe(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?De.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?X.from(ge.light):void 0,dark:ge.dark?X.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?z(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?ie.from(ge.before):void 0,after:ge.after?ie.from(ge.after):void 0}}Ie.from=Fe})(Pe||(e.DecorationRenderOptions=Pe={}));var ke;(function(Ie){function Fe(H){return{text:H.newText,eol:H.newEol&&xe.from(H.newEol),range:g.from(H.range)}}Ie.from=Fe;function ge(H){const Me=new r.$uK(g.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:xe.to(H.eol),Me}Ie.to=ge})(ke||(e.TextEdit=ke={}));var $e;(function(Ie){function Fe(H,Me){const Ue={edits:[]};if(H instanceof r.$xK){const Je=new u.$Bc;for(const Ve of H._allEntries())Ve._type===1&&v.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of H._allEntries())if(Ve._type===1){let et;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?et={type:"base64",value:(0,M.$ve)(M.$be.wrap(Ve.options.contents))}:et={type:"dataTransferItem",id:Ve.options.contents._itemId}),Ue.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:et},metadata:Ve.metadata})}else Ve._type===2?Ue.edits.push({resource:Ve.uri,textEdit:ke.from(Ve.edit),versionId:Je.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Ue.edits.push({resource:Ve.uri,textEdit:{range:g.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Je.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(bt.from)}})}return Ue}Ie.from=Fe;function ge(H){const Me=new r.$xK,Ue=new u.$Ac;for(const Je of H.edits)if(Je.textEdit){const Ve=Je,et=v.URI.revive(Ve.resource),Et=g.to(Ve.textEdit.range),Dt=Ve.textEdit.text,gt=Ve.textEdit.insertAsSnippet;let ht;gt?ht=r.$wK.replace(Et,new r.$yK(Dt)):ht=r.$uK.replace(Et,Dt);const ft=Ue.get(et);ft?ft.push(ht):Ue.set(et,[ht])}else Me.renameFile(v.URI.revive(Je.oldResource),v.URI.revive(Je.newResource),Je.options);for(const[Je,Ve]of Ue)Me.set(Je,Ve);return Me}Ie.to=ge})($e||(e.WorkspaceEdit=$e={}));var ye;(function(Ie){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function ge(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Ie.from=ge;function H(Me){for(const Ue in Fe)if(Fe[Ue]===Me)return Number(Ue);return r.SymbolKind.Property}Ie.to=H})(ye||(e.SymbolKind=ye={}));var ue;(function(Ie){function Fe(H){switch(H){case r.SymbolTag.Deprecated:return 1}}Ie.from=Fe;function ge(H){switch(H){case 1:return r.SymbolTag.Deprecated}}Ie.to=ge})(ue||(e.SymbolTag=ue={}));var ae;(function(Ie){function Fe(H){return{name:H.name,kind:ye.from(H.kind),tags:H.tags&&H.tags.map(ue.from),containerName:H.containerName,location:ee.from(H.location)}}Ie.from=Fe;function ge(H){const Me=new r.$EK(H.name,ye.to(H.kind),H.containerName,ee.to(H.location));return Me.tags=H.tags&&H.tags.map(ue.to),Me}Ie.to=ge})(ae||(e.WorkspaceSymbol=ae={}));var we;(function(Ie){function Fe(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:g.from(H.range),selectionRange:g.from(H.selectionRange),kind:ye.from(H.kind),tags:H.tags?.map(ue.from)??[]};return H.children&&(Me.children=H.children.map(Fe)),Me}Ie.from=Fe;function ge(H){const Me=new r.$FK(H.name,H.detail,ye.to(H.kind),g.to(H.range),g.to(H.selectionRange));return(0,w.$Lb)(H.tags)&&(Me.tags=H.tags.map(ue.to)),H.children&&(Me.children=H.children.map(ge)),Me}Ie.to=ge})(we||(e.DocumentSymbol=we={}));var _;(function(Ie){function Fe(H){const Me=new r.$JK(ye.to(H.kind),H.name,H.detail||"",v.URI.revive(H.uri),g.to(H.range),g.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ie.to=Fe;function ge(H,Me,Ue){if(Me=Me??H._sessionId,Ue=Ue??H._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:H.name,detail:H.detail,kind:ye.from(H.kind),uri:H.uri,range:g.from(H.range),selectionRange:g.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ie.from=ge})(_||(e.CallHierarchyItem=_={}));var W;(function(Ie){function Fe(ge){return new r.$KK(_.to(ge.from),ge.fromRanges.map(H=>g.to(H)))}Ie.to=Fe})(W||(e.CallHierarchyIncomingCall=W={}));var Z;(function(Ie){function Fe(ge){return new r.$LK(_.to(ge.to),ge.fromRanges.map(H=>g.to(H)))}Ie.to=Fe})(Z||(e.CallHierarchyOutgoingCall=Z={}));var ee;(function(Ie){function Fe(H){return{range:H.range&&g.from(H.range),uri:H.uri}}Ie.from=Fe;function ge(H){return new r.$zK(v.URI.revive(H.uri),g.to(H.range))}Ie.to=ge})(ee||(e.location=ee={}));var pe;(function(Ie){function Fe(H){const Me=H,Ue=H;return{originSelectionRange:Me.originSelectionRange?g.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:g.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?g.from(Me.targetSelectionRange):void 0}}Ie.from=Fe;function ge(H){return{targetUri:v.URI.revive(H.uri),targetRange:g.to(H.range),targetSelectionRange:H.targetSelectionRange?g.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?g.to(H.originSelectionRange):void 0}}Ie.to=ge})(pe||(e.DefinitionLink=pe={}));var me;(function(Ie){function Fe(H){return{range:g.from(H.range),contents:B.fromMany(H.contents)}}Ie.from=Fe;function ge(H){return new r.$CK(H.contents.map(B.to),g.to(H.range))}Ie.to=ge})(me||(e.Hover=me={}));var he;(function(Ie){function Fe(H){return{range:g.from(H.range),expression:H.expression}}Ie.from=Fe;function ge(H){return new r.$vL(g.to(H.range),H.expression)}Ie.to=ge})(he||(e.EvaluatableExpression=he={}));var Ee;(function(Ie){function Fe(H){if(H instanceof r.$wL)return{type:"text",range:g.from(H.range),text:H.text};if(H instanceof r.$xL)return{type:"variable",range:g.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof r.$yL)return{type:"expression",range:g.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Fe;function ge(H){switch(H.type){case"text":return{range:g.to(H.range),text:H.text};case"variable":return{range:g.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:g.to(H.range),expression:H.expression}}}Ie.to=ge})(Ee||(e.InlineValue=Ee={}));var re;(function(Ie){function Fe(H){return{frameId:H.frameId,stoppedLocation:g.from(H.stoppedLocation)}}Ie.from=Fe;function ge(H){return new r.$zL(H.frameId,g.to(H.stoppedLocation))}Ie.to=ge})(re||(e.InlineValueContext=re={}));var le;(function(Ie){function Fe(H){return{range:g.from(H.range),kind:H.kind}}Ie.from=Fe;function ge(H){return new r.$DK(g.to(H.range),H.kind)}Ie.to=ge})(le||(e.DocumentHighlight=le={}));var ne;(function(Ie){function Fe(ge){switch(ge){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ie.to=Fe})(ne||(e.CompletionTriggerKind=ne={}));var oe;(function(Ie){function Fe(ge){return{triggerKind:ne.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ie.to=Fe})(oe||(e.CompletionContext=oe={}));var fe;(function(Ie){function Fe(H){switch(H){case r.CompletionItemTag.Deprecated:return 1}}Ie.from=Fe;function ge(H){switch(H){case 1:return r.CompletionItemTag.Deprecated}}Ie.to=ge})(fe||(e.CompletionItemTag=fe={}));var Ce;(function(Ie){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function ge(Ue){return Fe.get(Ue)??9}Ie.from=ge;const H=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(Ue){return H.get(Ue)??r.CompletionItemKind.Property}Ie.to=Me})(Ce||(e.CompletionItemKind=Ce={}));var F;(function(Ie){function Fe(ge,H){const Me=new r.$TK(ge.label);return Me.insertText=ge.insertText,Me.kind=Ce.to(ge.kind),Me.tags=ge.tags?.map(fe.to),Me.detail=ge.detail,Me.documentation=A.$5j(ge.documentation)?B.to(ge.documentation):ge.documentation,Me.sortText=ge.sortText,Me.filterText=ge.filterText,Me.preselect=ge.preselect,Me.commitCharacters=ge.commitCharacters,$.$ts.isIRange(ge.range)?Me.range=g.to(ge.range):typeof ge.range=="object"&&(Me.range={inserting:g.to(ge.range.insert),replacing:g.to(ge.range.replace)}),Me.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Me.insertText=new r.$yK(ge.insertText):(Me.insertText=ge.insertText,Me.textEdit=Me.range instanceof r.$pK?new r.$uK(Me.range,Me.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Me.additionalTextEdits=ge.additionalTextEdits.map(Ue=>ke.to(Ue))),Me.command=H&&ge.command?H.fromInternal(ge.command):void 0,Me}Ie.to=Fe})(F||(e.CompletionItem=F={}));var V;(function(Ie){function Fe(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:B.fromStrict(H.documentation)}}Ie.from=Fe;function ge(H){return{label:H.label,documentation:A.$5j(H.documentation)?B.to(H.documentation):H.documentation}}Ie.to=ge})(V||(e.ParameterInformation=V={}));var G;(function(Ie){function Fe(H){return{label:H.label,documentation:B.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(V.from):[],activeParameter:H.activeParameter}}Ie.from=Fe;function ge(H){return{label:H.label,documentation:A.$5j(H.documentation)?B.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(V.to):[],activeParameter:H.activeParameter}}Ie.to=ge})(G||(e.SignatureInformation=G={}));var J;(function(Ie){function Fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.from):[]}}Ie.from=Fe;function ge(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.to):[]}}Ie.to=ge})(J||(e.SignatureHelp=J={}));var q;(function(Ie){function Fe(ge,H){const Me=new r.$SK(C.to(H.position),typeof H.label=="string"?H.label:H.label.map(x.to.bind(void 0,ge)),H.kind&&ce.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(ke.to),Me.tooltip=A.$5j(H.tooltip)?B.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ie.to=Fe})(q||(e.InlayHint=q={}));var x;(function(Ie){function Fe(ge,H){const Me=new r.$RK(H.label);return Me.tooltip=A.$5j(H.tooltip)?B.to(H.tooltip):H.tooltip,d.Command.is(H.command)&&(Me.command=ge.fromInternal(H.command)),H.location&&(Me.location=ee.to(H.location)),Me}Ie.to=Fe})(x||(e.InlayHintLabelPart=x={}));var ce;(function(Ie){function Fe(H){return H}Ie.from=Fe;function ge(H){return H}Ie.to=ge})(ce||(e.InlayHintKind=ce={}));var Ne;(function(Ie){function Fe(H){return{range:g.from(H.range),url:H.target,tooltip:H.tooltip}}Ie.from=Fe;function ge(H){let Me;if(H.url)try{Me=typeof H.url=="string"?v.URI.parse(H.url,!0):v.URI.revive(H.url)}catch{}return new r.$YK(g.to(H.range),Me)}Ie.to=ge})(Ne||(e.DocumentLink=Ne={}));var je;(function(Ie){function Fe(H){const Me=new r.$2K(H.label);return H.textEdit&&(Me.textEdit=ke.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(Ue=>ke.to(Ue))),Me}Ie.to=Fe;function ge(H){return{label:H.label,textEdit:H.textEdit?ke.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>ke.from(Me)):void 0}}Ie.from=ge})(je||(e.ColorPresentation=je={}));var Qe;(function(Ie){function Fe(H){return new r.$ZK(H[0],H[1],H[2],H[3])}Ie.to=Fe;function ge(H){return[H.red,H.green,H.blue,H.alpha]}Ie.from=ge})(Qe||(e.Color=Qe={}));var Ge;(function(Ie){function Fe(H){return{range:g.from(H.range)}}Ie.from=Fe;function ge(H){return new r.$IK(g.to(H.range))}Ie.to=ge})(Ge||(e.SelectionRange=Ge={}));var _e;(function(Ie){function Fe(ge){switch(ge){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ie.to=Fe})(_e||(e.TextDocumentSaveReason=_e={}));var Ze;(function(Ie){function Fe(H){switch(H){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Fe;function ge(H){switch(H){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ie.to=ge})(Ze||(e.TextEditorLineNumbersStyle=Ze={}));var xe;(function(Ie){function Fe(H){if(H===r.EndOfLine.CRLF)return 1;if(H===r.EndOfLine.LF)return 0}Ie.from=Fe;function ge(H){if(H===1)return r.EndOfLine.CRLF;if(H===0)return r.EndOfLine.LF}Ie.to=ge})(xe||(e.EndOfLine=xe={}));var it;(function(Ie){function Fe(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Fe})(it||(e.ProgressLocation=it={}));var tt;(function(Ie){function Fe(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=ze.from(H.kind)),Me}Ie.from=Fe;function ge(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=ze.to(H.kind)),Me}Ie.to=ge})(tt||(e.FoldingRange=tt={}));var ze;(function(Ie){function Fe(H){if(H)switch(H){case r.FoldingRangeKind.Comment:return d.$it.Comment;case r.FoldingRangeKind.Imports:return d.$it.Imports;case r.FoldingRangeKind.Region:return d.$it.Region}}Ie.from=Fe;function ge(H){if(H)switch(H.value){case d.$it.Comment.value:return r.FoldingRangeKind.Comment;case d.$it.Imports.value:return r.FoldingRangeKind.Imports;case d.$it.Region.value:return r.FoldingRangeKind.Region}}Ie.to=ge})(ze||(e.FoldingRangeKind=ze={}));var ut;(function(Ie){function Fe(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?g.from(ge.selection):void 0,override:typeof ge.override=="boolean"?l.$UD.id:void 0}}Ie.from=Fe})(ut||(e.TextEditorOpenOptions=ut={}));var Y;(function(Ie){function Fe(Ue){return Ue instanceof r.$jL?Ue.toJSON():typeof Ue=="string"?Ue:ge(Ue)||H(Ue)?new r.$jL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ie.from=Fe;function ge(Ue){const Je=Ue;return Je?v.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function H(Ue){const Je=Ue;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new r.$jL(v.URI.revive(Ue.baseUri),Ue.pattern)}Ie.to=Me})(Y||(e.GlobPattern=Y={}));var Q;(function(Ie){function Fe(ge){if(ge){if(Array.isArray(ge))return ge.map(Fe);if(typeof ge=="string")return ge;{const H=ge;return{language:H.language,scheme:H.scheme,pattern:Y.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ie.from=Fe})(Q||(e.LanguageSelector=Q={}));var ve;(function(Ie){function Fe(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&v.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Je=>Je instanceof r.$pK)))}Ie.is=Fe;function ge(H){return{documents:H.documents.map(Me=>Me.map(Ue=>({uri:v.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Je=>g.from(Je))})))}}Ie.from=ge})(ve||(e.MappedEditsContext=ve={}));var Be;(function(Ie){function Fe(H){return{start:H.start,end:H.end}}Ie.from=Fe;function ge(H){return new r.$KL(H.start,H.end)}Ie.to=ge})(Be||(e.NotebookRange=Be={}));var Oe;(function(Ie){function Fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ie.to=Fe;function ge(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ie.from=ge})(Oe||(e.NotebookCellExecutionSummary=Oe={}));var Xe;(function(Ie){function Fe(ge){if(ge===p.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(ge===p.NotebookCellExecutionState.Pending)return;if(ge===p.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ie.to=Fe})(Xe||(e.NotebookCellExecutionState=Xe={}));var nt;(function(Ie){function Fe(H){switch(H){case r.NotebookCellKind.Markup:return p.CellKind.Markup;case r.NotebookCellKind.Code:default:return p.CellKind.Code}}Ie.from=Fe;function ge(H){switch(H){case p.CellKind.Markup:return r.NotebookCellKind.Markup;case p.CellKind.Code:default:return r.NotebookCellKind.Code}}Ie.to=ge})(nt||(e.NotebookCellKind=nt={}));var $t;(function(Ie){function Fe(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const Ue of H.cells)r.$LL.validate(Ue),Me.cells.push(bt.from(Ue));return Me}Ie.from=Fe;function ge(H){const Me=new r.$ML(H.cells.map(bt.to));return(0,a.$Lf)(H.metadata)||(Me.metadata=H.metadata),Me}Ie.to=ge})($t||(e.NotebookData=$t={}));var bt;(function(Ie){function Fe(H){return{cellKind:nt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Oe.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(qt.from):[]}}Ie.from=Fe;function ge(H){return new r.$LL(nt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(qt.to):void 0,H.metadata,H.internalMetadata?Oe.to(H.internalMetadata):void 0)}Ie.to=ge})(bt||(e.NotebookCellData=bt={}));var Pt;(function(Ie){function Fe(H){return{mime:H.mime,valueBytes:M.$be.wrap(H.data)}}Ie.from=Fe;function ge(H){return new r.$NL(H.valueBytes.buffer,H.mime)}Ie.to=ge})(Pt||(e.NotebookCellOutputItem=Pt={}));var qt;(function(Ie){function Fe(H){return{outputId:H.id,items:H.items.map(Pt.from),metadata:H.metadata}}Ie.from=Fe;function ge(H){const Me=H.items.map(Pt.to);return new r.$OL(Me,H.outputId,H.metadata)}Ie.to=ge})(qt||(e.NotebookCellOutput=qt={}));var Ht;(function(Ie){function Fe(Me){return H(Me)?{include:Y.from(Me.include)??void 0,exclude:Y.from(Me.exclude)??void 0}:Y.from(Me)??void 0}Ie.from=Fe;function ge(Me){return H(Me)?{include:Y.to(Me.include),exclude:Y.to(Me.exclude)}:Y.to(Me)}Ie.to=ge;function H(Me){const Ue=Me;return Ue?!(0,a.$Hf)(Ue.include)&&!(0,a.$Hf)(Ue.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var vt;(function(Ie){function Fe(ge,H,Me){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Ue,Me),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ie.from=Fe})(vt||(e.NotebookStatusBarItem=vt={}));var Ut;(function(Ie){function Fe(ge,H,Me){const Ue=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:H.toInternal(Ue,Me),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ie.from=Fe})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Nt;(function(Ie){function Fe(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ie.from=Fe})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Ie){function Fe(H){return{uri:H.uri,provides:H.provides}}Ie.from=Fe;function ge(H){return new r.$QL(v.URI.revive(H.uri),H.provides)}Ie.to=ge})(Gt||(e.NotebookRendererScript=Gt={}));var jt;(function(Ie){function Fe(H){return{message:B.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:g.from(H.location.range),uri:H.location.uri}}}Ie.from=Fe;function ge(H){const Me=new r.$WL(typeof H.message=="string"?H.message:B.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?ee.to(H.location):void 0,Me}Ie.to=ge})(jt||(e.TestMessage=jt={}));var kt;(function(Ie){Ie.namespace=m.$iJ,Ie.denamespace=m.$jJ})(kt||(e.TestTag=kt={}));var Lt;(function(Ie){function Fe(H){const Me=(0,i.$iM)(H).controllerId;return{extId:E.$eJ.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:v.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Ue=>kt.namespace(Me,Ue.id)),range:$.$ts.lift(g.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&B.fromStrict(H.error)||null}}Ie.from=Fe;function ge(H){return{parent:void 0,error:void 0,id:E.$eJ.fromString(H.extId).localId,label:H.label,uri:v.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:Ue}=kt.denamespace(Me);return new r.$XL(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:g.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ie.toPlain=ge})(Lt||(e.TestItem=Lt={})),function(Ie){function Fe(H){return{id:H.id}}Ie.from=Fe;function ge(H){return new r.$XL(H.id)}Ie.to=ge}(kt||(e.TestTag=kt={}));var Bt;(function(Ie){const Fe=(H,Me)=>{const Ue=[];for(const[Ve,et]of Me)E.$eJ.compare(et.item.extId,Ve)===2&&(Me.delete(Ve),Ue.push(et));const Je={...Lt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(jt.to)})),children:Ue.map(Ve=>Fe(Ve,Me))};for(const Ve of Je.children)Ve.parent=Je;return Je};function ge(H){const Me=[],Ue=new Map;for(const Je of H.items){Ue.set(Je.item.extId,Je);const Ve=E.$eJ.root(Je.item.extId);H.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:H.completedAt,results:Me.map(Je=>Fe(Je,Ue))}}Ie.to=ge})(Bt||(e.TestResults=Bt={}));var Jt;(function(Ie){function Fe(Ue){return{covered:Ue.covered,total:Ue.covered}}function ge(Ue){return"line"in Ue?C.from(Ue):g.from(Ue)}function H(Ue){return"branches"in Ue?{count:Ue.executionCount,location:ge(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Je=>({count:Je.executionCount,location:Je.location&&ge(Je.location)})):void 0}:{type:0,count:Ue.executionCount,location:ge(Ue.location)}}Ie.fromDetailed=H;function Me(Ue){return{uri:Ue.uri,statement:Fe(Ue.statementCoverage),branch:Ue.branchCoverage&&Fe(Ue.branchCoverage),function:Ue.functionCoverage&&Fe(Ue.functionCoverage),details:Ue.detailedCoverage?.map(H)}}Ie.fromFile=Me})(Jt||(e.TestCoverage=Jt={}));var Wt;(function(Ie){function Fe(ge){switch(ge){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ie.to=Fe})(Wt||(e.CodeActionTriggerKind=Wt={}));var Kt;(function(Ie){function Fe(H){const Me=new r.$4L(ye.to(H.kind),H.name,H.detail||"",v.URI.revive(H.uri),g.to(H.range),g.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ie.to=Fe;function ge(H,Me,Ue){if(Me=Me??H._sessionId,Ue=Ue??H._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:ye.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:g.from(H.range),selectionRange:g.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ie.from=ge})(Kt||(e.TypeHierarchyItem=Kt={}));var Ot;(function(Ie){function Fe(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ie.from=Fe})(Ot||(e.ViewBadge=Ot={}));var at;(function(Ie){function Fe(Ue,Je,Ve){const et=Je.fileData;return et?new r.$cL(new r.$dL(et.name,v.URI.revive(et.uri),et.id,(0,L.$db)(()=>Ve(et.id)))):Ue===R.$Pr.uriList&&Je.uriListData?new r.$bL(Me(Je.uriListData)):new r.$bL(Je.asString)}Ie.to=Fe;async function ge(Ue,Je){const Ve=await Je.asString();if(Ue===R.$Pr.uriList)return{asString:Ve,fileData:void 0,uriListData:H(Ve)};const et=Je.asFile();return{asString:Ve,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ie.from=ge;function H(Ue){return P.$3s.split(Ue).map(Je=>{if(Je.startsWith("#"))return Je;try{return v.URI.parse(Je)}catch{}return Je})}function Me(Ue){return P.$3s.create(Ue.map(Je=>typeof Je=="string"?Je:v.URI.revive(Je)))}})(at||(e.DataTransferItem=at={}));var dt;(function(Ie){function Fe(H,Me){const Ue=H.items.map(([Je,Ve])=>[Je,at.to(Je,Ve,Me)]);return new r.$eL(Ue)}Ie.toDataTransfer=Fe;async function ge(H){const Me={items:[]},Ue=[];for(const[Je,Ve]of H)Ue.push((async()=>{Me.items.push([Je,await at.from(Je,Ve)])})());return await Promise.all(Ue),Me}Ie.from=ge})(dt||(e.DataTransfer=dt={}));var At;(function(Ie){function Fe(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ie.to=Fe;function ge(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ie.from=ge})(At||(e.ChatReplyFollowup=At={}));var Vt;(function(Ie){function Fe(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:At.from(ge)}Ie.from=Fe})(Vt||(e.ChatFollowup=Vt={}));var Rt;(function(Ie){function Fe(H){const Me=new r.$bM(ot.to(H.role),H.content);return Me.name=H.name,Me}Ie.to=Fe;function ge(H){return{role:ot.from(H.role),content:H.content,name:H.name}}Ie.from=ge})(Rt||(e.ChatMessage=Rt={}));var ot;(function(Ie){function Fe(H){switch(H){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ie.to=Fe;function ge(H){switch(H){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ie.from=ge})(ot||(e.ChatMessageRole=ot={}));var wt;(function(Ie){function Fe(Me){const Ue={};for(const Je of Object.keys(Me))Ue[Je]=Me[Je].map(Ie.to);return Ue}Ie.objectTo=Fe;function ge(Me){return{level:Tt.to(Me.level),value:Me.value,description:Me.description}}Ie.to=ge;function H(Me){return{level:Tt.from(Me.level),value:Me.value,description:Me.description}}Ie.from=H})(wt||(e.ChatVariable=wt={}));var Tt;(function(Ie){function Fe(H){switch(H){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ie.to=Fe;function ge(H){switch(H){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ie.from=ge})(Tt||(e.ChatVariableLevel=Tt={}));var Ct;(function(Ie){function Fe(ge){switch(ge){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Ie.to=Fe})(Ct||(e.InteractiveEditorResponseFeedbackKind=Ct={}));var We;(function(Ie){function Fe(ge,H){return"placeholder"in H&&"resolvedContent"in H?{placeholder:H.placeholder}:"responseId"in H?{requestId:H.responseId}:"markdownContent"in H?((0,s.$hF)(ge,"chatAgents2Additions"),{content:B.from(H.markdownContent)}):"content"in H?typeof H.content=="string"?H:((0,s.$hF)(ge,"chatAgents2Additions"),{content:B.from(H.content)}):"documents"in H?{documents:H.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Ue=>g.from(Ue))}))}:"reference"in H?{reference:"uri"in H.reference?{uri:H.reference.uri,range:g.from(H.reference.range)}:H.reference}:"inlineReference"in H?{inlineReference:"uri"in H.inlineReference?{uri:H.inlineReference.uri,range:g.from(H.inlineReference.range)}:H.inlineReference,title:H.title}:("agentName"in H&&(0,s.$hF)(ge,"chatAgents2Additions"),H)}Ie.from=Fe})(We||(e.ChatResponseProgress=We={}));var Qt;(function(Ie){function Fe(ge,H,Me){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:H.toInternal(ge,Me)}Ie.from=Fe})(Qt||(e.TerminalQuickFix=Qt={}))}),define(Ae[207],Re([1,0,2,11,7,8,174]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class u{constructor(f,R,k,a={timeout:1500,errors:3}){this.c=f,this.d=R,this.f=k,this.g=a,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(R,k,a)=>{const $={dispose:this.a.push([R,k,f])};return Array.isArray(a)&&a.push($),$}}async $participateInSave(f,R){const k=w.URI.revive(f);let a=!1;const v=setTimeout(()=>a=!0,this.g.timeout),$=[];try{for(const d of[...this.a]){if(a)break;const t=this.d.getDocument(k),i=await this.h(d,{document:t,reason:L.TextDocumentSaveReason.to(R)});$.push(i)}}finally{clearTimeout(v)}return $}h([f,R,k],a){const v=this.b.get(f);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(k,f,R,a).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const d=this.b.get(f);this.b.set(f,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,R,k,a){const v=[],$=Date.now(),{document:d,reason:t}=a,{version:i}=d,l=Object.freeze({document:d,reason:t,waitUntil(p){if(Object.isFrozen(v))throw(0,M.$8)("waitUntil can not be called async");v.push(Promise.resolve(p))}});try{R.apply(k,[l])}catch(p){return Promise.reject(p)}return Object.freeze(v),new Promise((p,E)=>{const m=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(v).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(m),p(n)}).catch(n=>{clearTimeout(m),E(n)})}).then(p=>{const E={edits:[]};for(const m of p)if(Array.isArray(m)&&m.every(n=>n instanceof P.$uK))for(const{newText:n,newEol:r,range:s}of m)E.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:n,eol:r&&L.EndOfLine.from(r)}});if(E.edits.length!==0)return i===d.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$Ecc=u}),define(Ae[208],Re([1,0,13,2,8,7,75]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=e.$Rdc=void 0;class u{constructor(k,a,v,$){this.start=k,this.deletedCount=a,this.deletedItems=v,this.items=$}asApiEvent(){return{range:new L.$KL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,v){this.notebook=k,this.h=a,this.j=v,this.handle=v.handle,this.uri=M.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime($){k.g=$},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(v)}return this.f}setOutputs(k){this.a=k.map(P.NotebookCellOutput.to)}setOutputItems(k,a,v){const $=v.map(P.NotebookCellOutputItem.to),d=this.a.find(t=>t.id===k);if(d&&(a||(d.items.length=0),d.items.push(...$),d.items.length>1&&d.items.every(t=>A.$uI(t.mime)))){const t=new Map,i=[];d.items.forEach(l=>{let p;t.has(l.mime)?p=t.get(l.mime):(p=[],t.set(l.mime,p),i.push(l.mime)),p.push(l.data)}),d.items.length=0,i.forEach(l=>{const p=A.$vI(t.get(l));d.items.push({mime:l,data:p.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Rdc=D;class f{static{this.a=0}constructor(k,a,v,$,d){this.k=k,this.l=a,this.m=v,this.uri=$,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===w.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(v){return v=k.n(v),k.b[v].apiCell},getCells(v){return(v?k.p(v):k.b).map(d=>d.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,v){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:v});const $={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},d=[];for(const i of k.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),d.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),d.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),d.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<d.length;i++){const l=d[i],p=t.get(l.cell);if(p===void 0){const E=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});t.set(l.cell,E-1)}else $.cellChanges[p]={...$.cellChanges[p],...l}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,v=k.end|0;return a<0&&(a=0),v>this.b.length&&(v=this.b.length),k.with({start:a,end:v})}p(k){k=this.o(k);const a=[];for(let v=k.start;v<k.end;v++)a.push(this.b[v]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,v){if(this.j)return;const $=[],d=[],t=[];if(k.reverse().forEach(i=>{const p=i[2].map(n=>{const r=new D(this,this.l,n);return a||d.push(D.asModelAddData(this.apiNotebook,n)),r}),E=new u(i[0],i[1],[],p),m=this.b.splice(i[0],i[1],...p);for(const n of m)t.push(n.uri),E.deletedItems.push(n.apiCell);$.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:t}),v)for(const i of $)v.push(i.asApiEvent())}s(k,a,v,$){const d=this.b.splice(k,a);this.b.splice(v,0,...d);const t=[new u(k,a,d.map(i=>i.apiCell),[]),new u(v,0,[],d)];for(const i of t)$.push(i.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,v,$){this.b[k].setOutputItems(a,v,$)}v(k,a){const v=this.b[k];v.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(v.uri,a)}w(k,a){const v=this.b[k];v.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Sdc=f}),define(Ae[209],Re([1,0,5,2,8,7]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class A{constructor(D,f,R,k={timeout:1500,errors:3}){this.b=D,this.c=f,this.d=R,this.f=k,this.a=new w.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(f,R,k)=>{const a=function($){f.call(R,$)};return a.extension=D,this.a.event(a,void 0,k)}}async $participateInSave(D,f,R){const k=M.URI.revive(D),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:P.TextDocumentSaveReason.to(f)},R,async(d,t)=>{const i=Date.now(),l=await await Promise.resolve(d);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&l&&(l instanceof L.$xK?v.push(l):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(v.length===0)return!0;const $={edits:[]};for(const d of v){const{edits:t}=P.WorkspaceEdit.from(d);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$gec=A}),define(Ae[104],Re([1,0,11,8,7]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(u,D,f,R,k,a){this.id=u,this.f=D,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=R,this.c=a}get apiEditor(){if(!this.e){const u=this;this.e={get notebook(){return u.notebookData.apiNotebook},get selection(){return u.a[0]},set selection(D){this.selections=[D]},get selections(){return u.a},set selections(D){if(!Array.isArray(D)||!D.every(P.$KL.isNotebookRange))throw(0,w.$7)("selections");u.a=D,u.g(D)},get visibleRanges(){return u.b},revealRange(D,f){u.f.$tryRevealRange(u.id,M.NotebookRange.from(D),f??P.NotebookEditorRevealType.Default)},get viewColumn(){return u.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(u){this.d=u}_acceptVisibleRanges(u){this.b=u}_acceptSelections(u){this.a=u}g(u){this.f.$trySetSelections(this.id,u.map(M.NotebookRange.from))}_acceptViewColumn(u){this.c=u}}e.$Tdc=L}),define(Ae[210],Re([1,0,11,5,14,8]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;let A=class{constructor(D,f){this.c=D,this.d=f,this.a=new M.$Nd({onListenerError:w.$2}),this.b=new M.$Nd({onListenerError:w.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,f);const R=this.d.getEditorById(D);f.visibleRanges&&R._acceptVisibleRanges(f.visibleRanges.ranges.map(L.NotebookRange.to)),f.selections&&R._acceptSelections(f.selections.selections.map(L.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const f in D)this.d.getEditorById(f)._acceptViewColumn(L.ViewColumn.to(D[f]))}};e.$_dc=A,e.$_dc=A=qe([Ke(0,P.$0i)],A)}),define(Ae[211],Re([1,0,8,52,153,19,65,11]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,v,$){const d=this.b++,{title:t,location:i,cancellable:l}=v,p={label:(0,P.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(d,{location:w.ProgressLocation.from(i),title:t,source:p,cancellable:l},a.isUnderDevelopment?void 0:a.identifier.value).catch(u.$2),this.d(d,$,!!l)}d(a,v,$){let d;$&&(d=new L.$Xd,this.c.set(a,d));const t=l=>{this.a.$progressEnd(l),this.c.delete(l),d?.dispose()};let i;try{i=v(new R(this.a,a),$&&d?d.token:L.CancellationToken.None)}catch(l){throw t(a),l}return i.then(l=>t(a),l=>t(a)),i}$acceptProgressCanceled(a){const v=this.c.get(a);v&&(v.cancel(),this.c.delete(a))}}e.$ddc=D;function f(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class R extends M.$5u{constructor(a,v){super($=>this.throttledReport($)),this.c=a,this.d=v}throttledReport(a){this.c.$progressReport(this.d,a)}}qe([(0,A.$jh)(100,(k,a)=>f(k,a),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,41,101,46,76,58,8,2]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=void 0;const f=(p,E,m,n)=>{let r=E;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!m(r,s)){const o=r;r=s,p.listener?.(n(s,o))}}}},R=(p,E)=>p===E,k={range:(p,E)=>p===E?!0:!p||!E?!1:p.isEqual(E),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(p,E)=>!(p.length!==E.length||p.some(m=>!E.find(n=>m.id===n.id)))},a=p=>E=>({op:4,update:p(E)}),v=(p,E)=>({range:(()=>{let m;const n=a(r=>({range:w.$ts.lift(u.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return m},set(r){p.listener?.({op:6}),k.range(m,r)||(m=r,p.listener?.(n(r)))}}})(),label:f(p,E,k.label,a(m=>({label:m}))),description:f(p,void 0,k.description,a(m=>({description:m}))),sortText:f(p,void 0,k.sortText,a(m=>({sortText:m}))),canResolveChildren:f(p,!1,k.canResolveChildren,m=>({op:2,state:m})),busy:f(p,!1,k.busy,a(m=>({busy:m}))),error:f(p,void 0,k.error,a(m=>({error:u.MarkdownString.fromStrict(m)||null}))),tags:f(p,[],k.tags,(m,n)=>({op:1,new:m.map(u.TestTag.from),old:n.map(u.TestTag.from)}))}),$=p=>{const E=P.$eJ.fromString(p.extId),m=new t(E.controllerId,E.localId,p.label,D.URI.revive(p.uri)||void 0);return m.range=u.Range.to(p.range||void 0),m.description=p.description||void 0,m.sortText=p.sortText||void 0,m.tags=p.tags.map(n=>u.TestTag.to({id:(0,A.$jJ)(n).tagId})),m},d=p=>{let E;for(const m of p.tests){const n=$(m.item);(0,M.$iM)(n).parent=E,E=n}return E};e.$yM=d;class t{constructor(E,m,n,r){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const s=(0,M.$hM)(this,E);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,L.$gM)(s,M.$iM,t),enumerable:!0,writable:!1},...v(s,n)})}}e.$zM=t;class i extends t{constructor(E,m){super(E,E,m,void 0),this._isRoot=!0}}e.$AM=i;class l extends L.$cM{constructor(E,m,n){super({controllerId:E,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:M.$iM,getChildren:r=>r.children,root:new i(E,m),toITestItem:u.TestItem.from})}}e.$BM=l}),define(Ae[106],Re([1,0,53,11,88,8,7]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=void 0;class u{static{this.c=new P.$rM("TextEditorDecorationType")}constructor(a,v,$){const d=u.c.nextId();a.$registerTextEditorDecorationType(v.identifier,d,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:d,dispose(){a.$removeTextEditorDecorationType(d)}})}}e.$tM=u;class D{constructor(a,v){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,v){this.k();let $=null;if(a instanceof A.$oK)$=new A.$pK(a,a);else if(a instanceof A.$pK)$=a;else throw new Error("Unrecognized location");this.l($,v,!1)}insert(a,v){this.k(),this.l(new A.$pK(a,a),v,!0)}delete(a){this.k();let v=null;if(a instanceof A.$pK)v=a;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(a,v,$){const d=this.c.validateRange(a);this.g.push({range:d,text:v,forceMoveMarkers:$})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=a}}class f{constructor(a,v,$,d){this.c=a,this.d=v,this._accept($),this.e=d;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}m(a){const v=this.l(a);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}o(a){const v=this.n(a);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const v=this.p(a);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(a)})))}assign(a){const v={};let $=!1;if(typeof a.tabSize<"u"){const d=this.l(a.tabSize);d==="auto"?($=!0,v.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,$=!0,v.tabSize=d)}if(typeof a.indentSize<"u"){const d=this.n(a.indentSize);d==="tabSize"?($=!0,v.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,$=!0,v.indentSize=d)}if(typeof a.insertSpaces<"u"){const d=this.p(a.insertSpaces);d==="auto"?($=!0,v.insertSpaces=d):this.h!==d&&(this.h=d,$=!0,v.insertSpaces=d)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,$=!0,v.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,$=!0,v.lineNumbers=L.TextEditorLineNumbersStyle.from(a.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(a,v){v.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn($)})}}e.$uM=f;class R{constructor(a,v,$,d,t,i,l,p){this.id=a,this.j=v,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,$),this.e=l,this.f=p;const E=this;this.value=Object.freeze({get document(){return d.value},set document(m){throw new M.$9("document")},get selection(){return E.c&&E.c[0]},set selection(m){if(!(m instanceof A.$qK))throw(0,M.$7)("selection");E.c=[m],E.l()},get selections(){return E.c},set selections(m){if(!Array.isArray(m)||m.some(n=>!(n instanceof A.$qK)))throw(0,M.$7)("selections");E.c=m,E.l()},get visibleRanges(){return E.e},set visibleRanges(m){throw new M.$9("visibleRanges")},get options(){return E.d.value},set options(m){E.g||E.d.assign(m)},get viewColumn(){return E.f},set viewColumn(m){throw new M.$9("viewColumn")},edit(m,n={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(d.value,n);return m(r),E.m(r)},insertSnippet(m,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=E.c.map(o=>L.Range.from(o));else if(n instanceof A.$oK){const{lineNumber:o,column:g}=L.Position.from(n);s=[{startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g}]}else if(n instanceof A.$pK)s=[L.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$pK)s.push(L.Range.from(o));else{const{lineNumber:g,column:h}=L.Position.from(o);s.push({startLineNumber:g,startColumn:h,endLineNumber:g,endColumn:h})}}return v.$tryInsertSnippet(a,d.value.version,m.value,s,r)},setDecorations(m,n){const r=n.length===0;r&&!E.h.has(m.key)||(r?E.h.delete(m.key):E.h.add(m.key),E.n(()=>{if(L.$jM(n))return v.$trySetDecorations(a,m.key,L.$kM(n));{const s=new Array(4*n.length);for(let o=0,g=n.length;o<g;o++){const h=n[o];s[4*o]=h.start.line+1,s[4*o+1]=h.start.character+1,s[4*o+2]=h.end.line+1,s[4*o+3]=h.end.character+1}return v.$trySetDecorationsFast(a,m.key,s)}}))},revealRange(m,n){E.n(()=>v.$tryRevealRange(a,L.Range.from(m),n||A.TextEditorRevealType.Default))},show(m){v.$tryShowEditor(a,L.ViewColumn.from(m))},hide(){v.$tryHideEditor(a)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,w.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,w.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,w.ok)(!this.g),this.f=a}_acceptSelections(a){(0,w.ok)(!this.g),this.c=a}async l(){const a=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const v=a.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const $=v.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const l=$[t].end;if($[t+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=v.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,d,{setEndOfLine:typeof v.setEndOfLine=="number"?L.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$vM=R}),define(Ae[212],Re([1,0,157,24,2,5,6,193,12,7,15,18,8,51,19,125,22]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;function i(E,m){if((0,R.$yf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let n;return Array.isArray(E.highlights)&&(n=E.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:E.label,highlights:n}}}class l extends A.$Sc{constructor(m,n,r){super(),this.f=m,this.g=n,this.h=r,this.a=new Map,this.b=new d.$S7;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(g=>s(g)?this.r(g):g):o})}registerTreeDataProvider(m,n,r){const s=this.createTreeView(m,{treeDataProvider:n},r);return{dispose:()=>s.dispose()}}createTreeView(m,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],g=!!n.dragAndDropController?.handleDrag,h=!!n.dragAndDropController?.handleDrop,C=this.m(m,n,r),I={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:g,hasHandleDrop:h,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},c=this.f.$registerTreeViewDataProvider(m,I),y={get onDidCollapseElement(){return C.onDidCollapseElement},get onDidExpandElement(){return C.onDidExpandElement},get selection(){return C.selectedElements},get onDidChangeSelection(){return C.onDidChangeSelection},get activeItem(){return(0,t.$hF)(r,"treeViewActiveItem"),C.focusedElement},get onDidChangeActiveItem(){return(0,t.$hF)(r,"treeViewActiveItem"),C.onDidChangeActiveItem},get visible(){return C.visible},get onDidChangeVisibility(){return C.onDidChangeVisibility},get onDidChangeCheckboxState(){return C.onDidChangeCheckboxState},get message(){return C.message},set message(b){(0,v.$5j)(b)&&(0,t.$hF)(r,"treeViewMarkdownMessage"),C.message=b},get title(){return C.title},set title(b){C.title=b},get description(){return C.description},set description(b){C.description=b},get badge(){return C.badge},set badge(b){b!==void 0&&f.ViewBadge.isViewBadge(b)?C.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(C.badge=void 0)},reveal:(b,S)=>C.reveal(b,S),dispose:async()=>{await c,this.a.delete(m),C.dispose()}};return this.B(y),y}$getChildren(m,n){const r=this.a.get(m);return r?r.getChildren(n):Promise.reject(new u.$sE(m))}async $handleDrop(m,n,r,s,o,g,h,C){const I=this.a.get(m);if(!I)return Promise.reject(new u.$sE(m));const c=a.DataTransfer.toDataTransfer(r,async y=>(await this.f.$resolveDropFileData(m,n,y)).buffer);return h===m&&C&&await this.j(c,I,C,o,g),I.onDrop(c,s,o)}async j(m,n,r,s,o){const g=this.b.removeDragOperationTransfer(o);if(g)(await g)?.forEach((h,C)=>{h&&m.set(C,h)});else if(o&&n.handleDrag){const h=n.handleDrag(r,m,s);this.b.addDragOperationTransfer(o,h),await h}return m}async $handleDrag(m,n,r,s){const o=this.a.get(m);if(!o)return Promise.reject(new u.$sE(m));const g=await this.j(new f.$eL,o,n,s,r);if(!(!g||s.isCancellationRequested))return a.DataTransfer.from(g)}async $hasResolve(m){const n=this.a.get(m);if(!n)throw new u.$sE(m);return n.hasResolve}$resolve(m,n,r){const s=this.a.get(m);if(!s)throw new u.$sE(m);return s.resolveTreeItem(n,r)}$setExpanded(m,n,r){const s=this.a.get(m);if(!s)throw new u.$sE(m);s.setExpanded(n,r)}$setSelectionAndFocus(m,n,r){const s=this.a.get(m);if(!s)throw new u.$sE(m);s.setSelectionAndFocus(n,r)}$setVisible(m,n){const r=this.a.get(m);if(!r){if(!n)return;throw new u.$sE(m)}r.setVisible(n)}$changeCheckboxState(m,n){const r=this.a.get(m);if(!r)throw new u.$sE(m);r.setCheckboxState(n)}m(m,n,r){const s=this.B(new p(m,n,this.f,this.g.converter,this.h,r));return this.a.set(m,s),s}r(m){const n=this.a.get(m.$treeViewId);return n&&"$treeItemHandle"in m?n.getExtensionElement(m.$treeItemHandle):n&&"$focusedTreeItem"in m&&m.$focusedTreeItem?n.focusedElement:null}}e.$kdc=l;class p extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(m=>this.getExtensionElement(m)).filter(m=>!(0,R.$Hf)(m))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(m,n,r,s,o,g){if(super(),this.I=m,this.J=r,this.L=s,this.M=o,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Xd,g.contributes&&g.contributes.views)for(const c in g.contributes.views)for(const y of g.contributes.views[c])y.id===m&&(this.P=y.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(c=>this.F.fire({message:!1,element:c})));let h,C;const I=L.Event.debounce(this.F.event,(c,y)=>(c||(c={message:!1,elements:[]}),y.element!==!1&&(h||(h=new Promise(b=>C=b),this.G=this.G.then(()=>h)),Array.isArray(y.element)?c.elements.push(...y.element):c.elements.push(y.element)),y.message&&(c.message=!0),c),200,!0);this.B(I(({message:c,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const b=C;return h=null,this.$(y).then(()=>b())})),c&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(m){const n=m?this.getExtensionElement(m):void 0;if(m&&!n)return this.M.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let r=this.X(m);return r||(r=await this.Y(n)),r?r.map(s=>s.item):void 0}getExtensionElement(m){return this.j.get(m)}reveal(m,n){n=n||{select:!0,focus:!1};const r=(0,R.$Hf)(n.select)?!0:n.select,s=(0,R.$Hf)(n.focus)?!1:n.focus,o=(0,R.$Hf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.G.then(()=>this.S(m)).then(g=>this.W(m,g[g.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:g.map(C=>C.item)},{select:r,focus:s,expand:o})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:r,focus:s,expand:o})}get message(){return this.O}set message(m){this.O=m,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(m){this.P=m,this.J.$setTitle(this.I,m,this.Q)}get description(){return this.Q}set description(m){this.Q=m,this.J.$setTitle(this.I,this.P,m)}get badge(){return this.R}set badge(m){this.R?.value===m?.value&&this.R?.tooltip===m?.tooltip||(this.R=a.ViewBadge.from(m),this.J.$setBadge(this.I,m))}setExpanded(m,n){const r=this.getExtensionElement(m);r&&(n?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(m,n){const r=!(0,k.$ub)(this.s,m);this.s=m;const s=this.t!==n;this.t=n,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(m){m!==this.r&&(this.r=m,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(m){const n=(await Promise.all(m.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:r.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(m,n,r){const s=[];for(const o of m){const g=this.getExtensionElement(o);g&&s.push(g)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,r),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(m,n,r){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,D.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(s,m,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(m,n){if(!this.f.resolveTreeItem)return;const r=this.j.get(m);if(r){const s=this.m.get(r);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,r,n)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(m){return this.U(m).then(n=>n?this.S(n).then(r=>this.W(n,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}U(m){const n=this.m.get(m);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,D.$Mg)(()=>this.f.getParent(m))}W(m,n){const r=this.m.get(m);return r?Promise.resolve(r):(0,D.$Mg)(()=>this.f.getTreeItem(m)).then(s=>this.kb(m,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const g=this.m.get(o);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(m){if(m){let n;if(typeof m=="string"){const r=this.getExtensionElement(m);n=r?this.m.get(r):void 0}else n=m;return n&&n.children||void 0}return this.h}async Y(m){this.rb(m);const n=new $.$Xd(this.Z.token);try{const r=m?this.m.get(m):void 0,s=await this.f.getChildren(m);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Hb)(s||[]).map(async g=>{const h=await this.f.getTreeItem(g);return h&&!n.token.isCancellationRequested?this.db(g,h,r):null}));return n.token.isCancellationRequested?void 0:(0,k.$Hb)(o)}finally{n.dispose()}}$(m){if(m.some(r=>!r))return this.Z.dispose(!0),this.Z=new $.$Xd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(m);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(m){const n=new Set,r=m.map(o=>this.m.get(o));for(const o of r)if(o&&!n.has(o.item.handle)){let g=o;for(;g&&g.parent&&r.findIndex(h=>g&&g.parent&&h&&h.item.handle===g.parent.item.handle)===-1;){const h=this.j.get(g.parent.item.handle);g=h?this.m.get(h):void 0}g&&!g.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const g=this.j.get(o);if(g){const h=this.m.get(g);h&&(!h.parent||!n.has(h.parent.item.handle))&&s.push(o)}}),s}bb(m){const n={};return Promise.all(m.map(r=>this.cb(r).then(s=>{s&&(n[r]=s.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(m){const n=this.getExtensionElement(m);if(n){const r=this.m.get(n);if(r)return this.rb(n),(0,D.$Mg)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.ib(n,s,r.parent);return this.pb(n,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}db(m,n,r){const s=this.ib(m,n,r);if(n.id&&this.j.has(s.item.handle))throw new Error((0,w.localize)(0,null,n.id));return this.ob(m,s),this.qb(s,r),s}eb(m){return f.$NK.isMarkdownString(m)?a.MarkdownString.from(m):m}fb(m,n){return n?{...this.L.toInternal(n,m),originalId:n.command}:void 0}gb(m){if(m.checkboxState===void 0)return;let n,r,s;return typeof m.checkboxState=="number"?n=m.checkboxState:(n=m.checkboxState.state,r=m.checkboxState.tooltip,s=m.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}hb(m){if(!f.$_K.isTreeItem(m,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(m,n,r){this.hb(n);const s=this.B(new A.$Rc),o=this.kb(m,n,r),g=this.lb(n);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(s,n.command),contextValue:n.contextValue,icon:g,iconDark:this.mb(n)||g,themeIcon:this.jb(n),collapsibleState:(0,R.$Hf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(m){return m.iconPath instanceof f.$hL?m.iconPath:void 0}kb(m,{id:n,label:r,resourceUri:s},o,g){if(n)return`${p.b}/${n}`;const h=i(r,this.N),C=o?o.item.handle:p.a;let I=h?h.label:s?(0,M.$sg)(s):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const c=this.m.has(m)?this.m.get(m).item.handle:void 0,y=this.X(o)||[];let b,S=0;do{if(b=`${C}/${S}:${I}`,g||!this.j.has(b)||c===b)break;S++}while(S<=y.length);return b}lb(m){if(m.iconPath&&!(m.iconPath instanceof f.$hL))return typeof m.iconPath=="string"||P.URI.isUri(m.iconPath)?this.nb(m.iconPath):this.nb(m.iconPath.light)}mb(m){if(m.iconPath&&!(m.iconPath instanceof f.$hL)&&m.iconPath.dark)return this.nb(m.iconPath.dark)}nb(m){return P.URI.isUri(m)?m:P.URI.file(m)}ob(m,n){this.j.set(n.item.handle,m),this.m.set(m,n)}pb(m,n,r,s){this.j.delete(n.item.handle),this.m.delete(m),n.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(m,n);const o=this.X(s)||[],g=o.filter(h=>h.item.handle===r.item.handle)[0];g&&o.splice(o.indexOf(g),1,n)}qb(m,n){n?(n.children||(n.children=[]),n.children.push(m)):(this.h||(this.h=[]),this.h.push(m))}rb(m){if(m){const n=this.m.get(m);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}n.children=void 0}}else this.tb()}sb(m){const n=this.m.get(m);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}this.m.delete(m),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(m=>m.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[213],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[214],Re([1,0,167,11,29,92,72,30,21,213,177,98]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=void 0;const a=u.$gn.as(A.$hn.JSONContribution);class v{constructor(m,n,r){this.a=m,this.b=n,this.c=r}d(m,n){this.a({type:m,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(m){this.d(P.default.Error,m)}warn(m){this.d(P.default.Warning,m)}info(m){this.d(P.default.Info,m)}}e.$8E=v;class ${static a(m){const n=new D.$7l;for(let r=0,s=m.length;r<s;r++)n.add(m[r].description.identifier);return n}static compute(m,n){if(!m||!m.length)return new $(n,[]);if(!n||!n.length)return new $([],m);const r=this.a(m),s=this.a(n),o=n.filter(h=>!r.has(h.description.identifier)),g=m.filter(h=>!s.has(h.description.identifier));return new $(o,g)}constructor(m,n){this.added=m,this.removed=n}}e.$9E=$;class d{constructor(m,n){this.name=m,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(m){if(this.a!==null)throw new Error("Handler already set!");this.a=m,this.d()}acceptUsers(m){this.c=$.compute(this.b,m),this.b=m,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(m){(0,M.$1)(m)}}}e.$0E=d;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$$E={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$5l},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Xn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Xn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(m){if(this.a.has(m.extensionPoint))throw new Error("Duplicate extension point: "+m.extensionPoint);const n=new d(m.extensionPoint,m.defaultExtensionKind);return this.a.set(m.extensionPoint,n),m.activationEventsGenerator&&k.$YE.register(m.extensionPoint,m.activationEventsGenerator),e.$$E.properties.contributes.properties[m.extensionPoint]=m.jsonSchema,a.registerSchema(i,e.$$E),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$_E=l;const p={ExtensionsRegistry:"ExtensionsRegistry"};u.$gn.add(p.ExtensionsRegistry,new l),e.$aF=u.$gn.as(p.ExtensionsRegistry),a.registerSchema(i,e.$$E),a.registerSchema(R.$qj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Ae[215],Re([1,0,164,15,25,214,32,5]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var f;(function(a){function v($,d,t){if(!$)return;const i=M.$yf($.type)?$.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const l=[];if(Array.isArray($.required))for(const p of $.required)M.$yf(p)&&l.push(p);return{extensionId:d.value,taskType:i,required:l,properties:$.properties?P.$7m($.properties):{},when:$.when?A.$Ni.deserialize($.when):void 0}}a.from=v})(f||(f={}));const R=L.$aF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,v)=>{for(const $ of a)$.type&&v.push(`onTaskType:${$.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new u.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,$)=>{R.setHandler((d,t)=>{this.c=void 0;try{for(const i of t.removed){const l=i.value;for(const p of l)this.a&&p.type&&this.a[p.type]&&delete this.a[p.type]}for(const i of t.added){const l=i.value;for(const p of l){const E=f.from(p,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const $ of this.all()){const d={type:"object",additionalProperties:!1};$.required.length>0&&(d.required=$.required.slice(0)),$.properties!==void 0?d.properties=P.$7m($.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[$.taskType]},v.push(d)}this.c={oneOf:v}}return this.c}}e.$RF=new k}),define(Ae[216],Re([1,0,165,15,24,25,32,215]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$2F=e.JsonSchemaVersion=e.ExecutionEngine=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$VF=e.ShellQuoting=e.$UF=e.$TF=e.$SF=void 0,e.$SF="settings",e.$TF=new A.$7i("taskRunning",!1,w.localize(0,null)),e.$UF={value:w.localize(1,null),original:"Tasks"};var D;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$VF="$customized",function(T){function z(ie){if(!ie)return T.Strong;switch(ie.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=z}(D||(e.ShellQuoting=D={}));var f;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var R;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(R||(e.RevealKind=R={})),function(T){function z(ie){switch(ie.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=z}(R||(e.RevealKind=R={}));var k;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(T){function z(ie){switch(ie.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=z}(k||(e.RevealProblemKind=k={}));var a;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(a||(e.PanelKind=a={})),function(T){function z(ie){switch(ie.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=z}(a||(e.PanelKind=a={}));var v;(function(T){T.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var $;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(T){function z(X){switch(X.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=z;function ie(X){switch(X){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=ie}($||(e.RuntimeType=$={}));var d;(function(T){function z(ie){return M.$yf(ie)?ie:ie.value}T.value=z})(d||(e.CommandString=d={}));var t;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function z(X){return X===T.Clean._id||X===T.Build._id||X===T.Rebuild._id||X===T.Test._id}T.is=z;function ie(X){if(X!==void 0)return M.$yf(X)?z(X)?{_id:X,isDefault:!1}:void 0:X}T.from=ie})(t||(e.TaskGroup=t={}));var i;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var l;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function z(ie){switch(ie){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=z})(l||(e.TaskSourceKind=l={}));var p;(function(T){T.parallel="parallel",T.sequence="sequence"})(p||(e.DependsOrder=p={}));var E;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var m;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(m||(e.RunOptions=m={}));class n{constructor(z,ie,X,De,Pe,ke){this._label="",this._id=z,ie&&(this._label=ie),X&&(this.type=X),this.runOptions=De,this.configurationProperties=Pe,this._source=ke}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,ie=!1){if(z===void 0)return!1;if(M.$yf(z))return z===this._label||z===this.configurationProperties.identifier||ie&&z===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$WF=n;class r extends n{constructor(z,ie,X,De,Pe,ke,$e,ye){super(z,X,void 0,$e,ye,ie),this.command={},this._source=ie,this.hasDefinedMatchers=ke,Pe&&(this.command=Pe)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case $.Shell:ie="shell";break;case $.Process:ie="process";break;case $.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(z){return z instanceof r}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===l.User?e.$SF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ie=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(ie+=this._source.kind);const X={type:e.$VF,folder:z,id:ie};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new r(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$XF=r;class s extends n{constructor(z,ie,X,De,Pe,ke,$e){super(z,X,De,ke,$e,ie),this._source=ie,this.configures=Pe}static is(z){return z instanceof s}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===l.User?e.$SF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ie=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(ie+=this._source.kind);const X={type:e.$VF,folder:z,id:ie};return JSON.stringify(X)}}e.$YF=s;class o extends n{constructor(z,ie,X,De,Pe,ke,$e,ye,ue){super(z,X,De,ye,ue,ie),this.defines=Pe,this.hasDefinedMatchers=$e,this.command=ke,this.icon=ue.icon,this.hide=ue.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof o}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new o(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$ZF=o;class g extends n{constructor(z,ie,X,De,Pe,ke){super(z,X,De,Pe,ke,ie),this._source=ie}clone(){return new g(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof g}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new g(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$1F=g;var h;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(T){T._default=T.Terminal}(h||(e.ExecutionEngine=h={}));var C;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(C||(e.JsonSchemaVersion=C={}));class I{constructor(z){this.c=new Map;for(let ie=0;ie<z.length;ie++)this.c.set(z[ie].uri.toString(),ie)}compare(z,ie){const X=z.getWorkspaceFolder(),De=ie.getWorkspaceFolder();if(X&&De){let Pe=this.c.get(X.uri.toString());Pe=Pe===void 0?0:Pe+1;let ke=this.c.get(De.uri.toString());return ke=ke===void 0?0:ke+1,Pe===ke?z._label.localeCompare(ie._label):Pe-ke}else return!X&&De?-1:X&&!De?1:0}}e.$2F=I;var c;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(c||(e.TaskEventKind=c={}));var y;(function(T){T.SingleRun="singleRun",T.Background="background"})(y||(e.TaskRunType=y={}));var b;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var S;(function(T){function z(ye){return{taskId:ye._id,taskName:ye.configurationProperties.name,runType:ye.configurationProperties.isBackground?"background":"singleRun",group:ye.configurationProperties.group,__task:ye}}function ie(ye,ue,ae){return{...z(ye),kind:"start",terminalId:ue,resolvedVariables:ae}}T.start=ie;function X(ye,ue,ae){return{...z(ye),kind:"processStarted",terminalId:ue,processId:ae}}T.processStarted=X;function De(ye,ue,ae){return{...z(ye),kind:"processEnded",terminalId:ue,exitCode:ae}}T.processEnded=De;function Pe(ye,ue,ae){return{...z(ye),kind:"terminated",exitReason:ae,terminalId:ue}}T.terminated=Pe;function ke(ye,ue,ae){return{...z(ue),kind:ye,terminalId:ae}}T.general=ke;function $e(){return{kind:"changed"}}T.changed=$e})(S||(e.TaskEvent=S={}));var j;(function(T){function z(X){const De=Object.keys(X).sort();let Pe="";for(const ke of De){let $e=X[ke];$e instanceof Object?$e=z($e):typeof $e=="string"&&($e=$e.replace(/,/g,",,")),Pe+=ke+","+$e+","}return Pe}function ie(X){const Pe={_key:z(X),type:X.taskType};return Object.assign(Pe,X),Pe}T.create=ie})(j||(e.KeyedTaskIdentifier=j={}));var O;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection"})(O||(e.TaskSettingId=O={}));var K;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(K||(e.TasksSchemaProperties=K={}));var B;(function(T){function z(ie,X){const De=u.$RF.get(ie.type);if(De===void 0){const ye=L.$7m(ie);return delete ye._key,j.create(ye)}const Pe=Object.create(null);Pe.type=De.taskType;const ke=new Set;De.required.forEach(ye=>ke.add(ye));const $e=De.properties;for(const ye of Object.keys($e)){const ue=ie[ye];if(ue!=null)Pe[ye]=ue;else if(ke.has(ye)){const ae=$e[ye];if(ae.default!==void 0)Pe[ye]=L.$7m(ae.default);else switch(ae.type){case"boolean":Pe[ye]=!1;break;case"number":case"integer":Pe[ye]=0;break;case"string":Pe[ye]="";break;default:X.error(w.localize(2,null,JSON.stringify(ie,void 0,0),ye));return}}}return j.create(Pe)}T.createTaskIdentifier=z})(B||(e.TaskDefinition=B={}))}),define(Ae[217],Re([1,0,11]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F4b=e.$E4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,u)=>{this.b=A,this.d=u,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$1)(A))}then(A,u){return this.j().then(A,u)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$E4b=M;class P extends M{constructor(){super(),this.h=!0,this.i=new w.$5}}e.$F4b=P}),define(Ae[47],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=void 0;class w{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++w.count}}e.$nv=w;const M=[];function P(u){const D=new w(u);return M[D.nid]=D,D}e.$ov=P;function L(u){return M[u].sid}e.$pv=L;class A{constructor(D){this.value=D}}e.$qv=A}),define(Ae[3],Re([1,0,47]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mK=e.$lK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$kK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var P;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(P||(e.TabInputKind=P={}));var L;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var u;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(u||(e.WebviewMessageArrayBufferViewType=u={}));var D;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var f;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$kK=k;var a;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var v;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var $;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$lK={MainThreadAuthentication:(0,w.$ov)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$ov)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$ov)("MainThreadChatProvider"),MainThreadChatAgents:(0,w.$ov)("MainThreadChatAgents"),MainThreadChatAgents2:(0,w.$ov)("MainThreadChatAgents2"),MainThreadChatVariables:(0,w.$ov)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$ov)("MainThreadClipboard"),MainThreadCommands:(0,w.$ov)("MainThreadCommands"),MainThreadComments:(0,w.$ov)("MainThreadComments"),MainThreadConfiguration:(0,w.$ov)("MainThreadConfiguration"),MainThreadConsole:(0,w.$ov)("MainThreadConsole"),MainThreadDebugService:(0,w.$ov)("MainThreadDebugService"),MainThreadDecorations:(0,w.$ov)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$ov)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$ov)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$ov)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$ov)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$ov)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$ov)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$ov)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$ov)("MainThreadErrors"),MainThreadTreeViews:(0,w.$ov)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$ov)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$ov)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$ov)("MainThreadLanguages"),MainThreadLogger:(0,w.$ov)("MainThreadLogger"),MainThreadMessageService:(0,w.$ov)("MainThreadMessageService"),MainThreadOutputService:(0,w.$ov)("MainThreadOutputService"),MainThreadProgress:(0,w.$ov)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$ov)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$ov)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$ov)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$ov)("MainThreadSecretState"),MainThreadStorage:(0,w.$ov)("MainThreadStorage"),MainThreadSpeech:(0,w.$ov)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,w.$ov)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$ov)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$ov)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$ov)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$ov)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$ov)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$ov)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$ov)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$ov)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$ov)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$ov)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,w.$ov)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,w.$ov)("MainThreadExtensionService"),MainThreadSCM:(0,w.$ov)("MainThreadSCM"),MainThreadSearch:(0,w.$ov)("MainThreadSearch"),MainThreadShare:(0,w.$ov)("MainThreadShare"),MainThreadTask:(0,w.$ov)("MainThreadTask"),MainThreadWindow:(0,w.$ov)("MainThreadWindow"),MainThreadLabelService:(0,w.$ov)("MainThreadLabelService"),MainThreadNotebook:(0,w.$ov)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$ov)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$ov)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$ov)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$ov)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$ov)("MainThreadInteractive"),MainThreadChat:(0,w.$ov)("MainThreadChat"),MainThreadInlineChat:(0,w.$ov)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$ov)("MainThreadTheming"),MainThreadTunnelService:(0,w.$ov)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$ov)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$ov)("MainThreadTimeline"),MainThreadTesting:(0,w.$ov)("MainThreadTesting"),MainThreadLocalization:(0,w.$ov)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$ov)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$ov)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$ov)("MainThreadIssueReporter")},e.$mK={ExtHostCommands:(0,w.$ov)("ExtHostCommands"),ExtHostConfiguration:(0,w.$ov)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$ov)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$ov)("ExtHostDebugService"),ExtHostDecorations:(0,w.$ov)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$ov)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$ov)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$ov)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$ov)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$ov)("ExtHostEditors"),ExtHostTreeViews:(0,w.$ov)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$ov)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$ov)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$ov)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$ov)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$ov)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$ov)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$ov)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$ov)("ExtHostStatusBar"),ExtHostShare:(0,w.$ov)("ExtHostShare"),ExtHostExtensionService:(0,w.$ov)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$ov)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$ov)("ExtHostTerminalService"),ExtHostSCM:(0,w.$ov)("ExtHostSCM"),ExtHostSearch:(0,w.$ov)("ExtHostSearch"),ExtHostTask:(0,w.$ov)("ExtHostTask"),ExtHostWorkspace:(0,w.$ov)("ExtHostWorkspace"),ExtHostWindow:(0,w.$ov)("ExtHostWindow"),ExtHostWebviews:(0,w.$ov)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$ov)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$ov)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$ov)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$ov)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$ov)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$ov)("ExtHostProgress"),ExtHostComments:(0,w.$ov)("ExtHostComments"),ExtHostSecretState:(0,w.$ov)("ExtHostSecretState"),ExtHostStorage:(0,w.$ov)("ExtHostStorage"),ExtHostUrls:(0,w.$ov)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$ov)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$ov)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$ov)("ExtHostOutputService"),ExtHosLabelService:(0,w.$ov)("ExtHostLabelService"),ExtHostNotebook:(0,w.$ov)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$ov)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$ov)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$ov)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$ov)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$ov)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$ov)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$ov)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$ov)("ExtHostChat"),ExtHostChatAgents:(0,w.$ov)("ExtHostChatAgents"),ExtHostChatAgents2:(0,w.$ov)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$ov)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$ov)("ExtHostChatProvider"),ExtHostSpeech:(0,w.$ov)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,w.$ov)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$ov)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$ov)("ExtHostTheming"),ExtHostTunnelService:(0,w.$ov)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$ov)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$ov)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$ov)("ExtHostTimeline"),ExtHostTesting:(0,w.$ov)("ExtHostTesting"),ExtHostTelemetry:(0,w.$ov)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$ov)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$ov)("ExtHostIssueReporter")}}),define(Ae[218],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$lK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,u,D){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(u,D)??[]}getRelatedInformation(A,u,D){return this.c.$getAiRelatedInformation(u,D)}registerRelatedInformationProvider(A,u,D){const f=this.b;return this.b++,this.a.set(f,D),this.c.$registerAiRelatedInformationProvider(f,u),new M.$nK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$mec=P}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=e.$occ=void 0,e.$occ=(0,w.$Ph)("IExtHostApiDeprecationService");let A=class{constructor(D,f){this.c=f,this.a=new Set,this.b=D.getProxy(P.$lK.MainThreadTelemetry)}report(D,f,R){const k=this.d(D,f);this.a.has(k)||(this.a.add(k),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:D}))}d(D,f){return`${D}-${f.identifier.value}`}};e.$pcc=A,e.$pcc=A=qe([Ke(0,L.$mM),Ke(1,M.$0i)],A),e.$qcc=Object.freeze(new class{report(u,D,f){}})}),define(Ae[219],Re([1,0,5,3,7,21]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new w.$Nd,this.onDidChangeSessions=this.d.event,this.f=new u,this.g=new u,this.a=f.getProxy(M.$lK.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,R,k,a={}){const v=L.$6l.toKey(f.identifier),$=[...k].sort().join(" ");return await this.f.getOrCreate(`${v} ${R} ${$}`,async()=>{await this.a.$ensureProvider(R);const d=f.displayName||f.name;return this.a.$getSession(R,k,v,d,a)})}async getSessions(f,R,k){const a=L.$6l.toKey(f.identifier),v=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${v}`,async()=>{await this.a.$ensureProvider(R);const $=f.displayName||f.name;return this.a.$getSessions(R,k,a,$)})}async removeSession(f,R){const k=this.b.get(f);return k?k.provider.removeSession(R):this.a.$removeSession(f,R)}registerAuthenticationProvider(f,R,k,a){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:R,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===f)||this.c.push({id:f,label:R});const v=k.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(f,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(f,R,a?.supportsMultipleAccounts??!1),new P.$nK(()=>{v.dispose(),this.b.delete(f);const $=this.c.findIndex(d=>d.id===f);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,R,k){const a=this.b.get(f);if(a)return Promise.resolve(a.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,R){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,R){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,R){return this.d.fire({provider:{id:f,label:R}}),Promise.resolve()}}e.$Wdc=A;class u{constructor(){this.a=new Map}getOrCreate(f,R){const k=this.a.get(f);if(k)return k;const a=R().finally(()=>this.a.delete(f));return this.a.set(f,a),a}}}),define(Ae[220],Re([1,0,3,17,8]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let L=class{constructor(u,D){this.a=u.getProxy(w.$lK.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>D.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(u,D,f){const R=P.WorkspaceEdit.from(u,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,f?.isRefactoring??!1)}};e.$3dc=L,e.$3dc=L=qe([Ke(0,M.$mM)],L)}),define(Ae[221],Re([1,0,12,5,66,6,48,146,3,8]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class R{static{this.a=0}constructor(v,$){this.extension=v,this.provider=$,this.handle=R.a++}}class k{static{this.a=0}constructor(v,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new M.$Nd,this.onDidPerformUserAction=this.e.event,this.g=v.getProxy(D.$lK.MainThreadChat)}registerChatProvider(v,$,d){const t=new R(v,d);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,L.$Qc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(v,$){const d=P.Iterable.find(this.d.keys(),t=>this.d.get(t)===v)??0;typeof d=="number"&&this.g.$transferChatSession(d,$)}sendInteractiveRequestToProvider(v,$){this.g.$sendRequestToProvider(v,$)}async $prepareChat(v,$,d){const t=this.b.get(v);if(!t)return;const i=await t.provider.prepareSession($,d);if(!i)return;const l=k.a++;return this.d.set(l,i),{id:l,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(v,$){const d=this.b.get(v);if(!d||!d.provider.provideWelcomeMessage)return;const t=await d.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(l=>f.ChatReplyFollowup.from(l)):f.MarkdownString.from(i))}async $provideFollowups(v,$,d){const t=this.b.get(v);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,d))?.map(p=>f.ChatFollowup.from(p))}async $provideSampleQuestions(v,$){const d=this.b.get(v);if(!d||!d.provider.provideSampleQuestions)return;const t=await d.provider.provideSampleQuestions($);if(t)return t?.map(i=>f.ChatReplyFollowup.from(i))}$removeRequest(v,$,d){const t=this.b.get(v);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,d)}async $provideReply(v,$,d,t){const i=this.b.get(v);if(!i)return;const l=this.d.get($);if(!l)return;const p={session:l,message:d.message,variables:{}};if(d.variables)for(const o of Object.keys(d.variables))p.variables[o]=d.variables[o].map(f.ChatVariable.to);const E=A.$Jd.create(!1);let m;const n={report:o=>{if(t.isCancellationRequested)return;typeof m>"u"&&(m=E.elapsed());const g=f.ChatResponseProgress.from(i.extension,o);if("placeholder"in o&&"resolvedContent"in o){const h=Promise.all([this.g.$acceptResponseProgress(v,$,g),o.resolvedContent]);(0,w.$Ig)(h,t).then(C=>{if(!C)return;const[I,c]=C;this.g.$acceptResponseProgress(v,$,c,I??void 0)})}else this.g.$acceptResponseProgress(v,$,g)}};let r;try{r=await i.provider.provideResponseWithProgress(p,n,t),r||(r={errorDetails:{message:(0,u.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,u.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(l.saveState&&this.d.has($)){const o=l.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const s={firstProgress:m??0,totalElapsed:E.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(v,$,d){const t=this.b.get(v);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,d))?.map(p=>({...p,kind:f.CompletionItemKind.from(p.kind)}))}$releaseSession(v){this.d.delete(v)}async $onDidPerformUserAction(v){this.e.fire(v)}}e.$eec=k}),define(Ae[222],Re([1,0,12,6,52,3,8,7]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;class D{static{this.a=0}constructor(k,a,v){this.d=a,this.e=v,this.b=new Map,this.c=k.getProxy(L.$lK.MainThreadChatAgents)}registerAgent(k,a,v,$){const d=D.a++;return this.b.set(d,{extension:k,agent:v}),this.c.$registerAgent(d,a,$),(0,M.$Qc)(()=>{this.c.$unregisterAgent(d),this.b.delete(d)})}async $invokeAgent(k,a,v,$,d){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function l(){if(i)throw new Error("Only valid while executing the command")}const p=new w.$ch;d.onCancellationRequested(()=>p.complete()),setTimeout(()=>p.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,p.p);const E=t.agent({role:u.ChatMessageRole.User,content:v},{history:$.history.map(A.ChatMessage.to)},new P.$5u(m=>{l(),this.c.$handleProgressChunk(a,{content:f(m.message)?m.message:m.message.value})}),d);try{return await(0,w.$Ig)(Promise.resolve(E).then(m=>{if(m&&"followUp"in m)return{followUp:m?.followUp?.map(r=>A.ChatFollowup.from(r))}}),d)}finally{i=!0,p.complete()}}}e.$oec=D;function f(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Ae[223],Re([1,0,12,19,37,5,48,15,2,147,52,3,8,7,194,22]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class t{static{this.a=0}constructor(p,E,m){this.i=E,this.j=m,this.b=new Map,this.g=new Map,this.h=new Map,this.d=p.getProxy(k.$lK.MainThreadChatAgents2)}createChatAgent(p,E,m){const n=t.a++,r=new i(p,E,this.d,n,m);return this.b.set(n,r),this.d.$registerAgent(n,E,{}),r.apiAgent}async $invokeAgent(p,E,m,n,r,s){this.g.delete(E);const o=this.b.get(p);if(!o)throw new Error(`[CHAT](${p}) CANNOT invoke agent because the agent is not registered`);let g=!1;function h(){if(g)throw new Error("Only valid while executing the command")}const C=new w.$ch;s.onCancellationRequested(()=>C.complete()),setTimeout(()=>C.complete(),10*1e3),this.i.allowListExtensionWhile(o.extension.identifier,C.p);const I=n.command?await o.validateSlashCommand(n.command):void 0,c=A.$Jd.create(!1);let y;try{const b=o.invoke({prompt:n.message,variables:a.ChatVariable.objectTo(n.variables),slashCommand:I},{history:r.history.map(a.ChatMessage.to)},new R.$5u(S=>{h(),typeof y>"u"&&"content"in S&&(y=c.elapsed());const j=a.ChatResponseProgress.from(o.extension,S);if("placeholder"in S&&"resolvedContent"in S){const O=Promise.all([this.d.$handleProgressChunk(m,j),S.resolvedContent]);(0,w.$Ig)(O,s).then(K=>{if(!K)return;const[B,T]=K;this.d.$handleProgressChunk(m,T,B??void 0)})}else this.d.$handleProgressChunk(m,j)}),s);return await(0,w.$Ig)(Promise.resolve(b).then(S=>{if(S){this.g.set(E,S);let j=this.h.get(E);j||(j=new Map,this.h.set(E,j)),j.set(m,S);const O={firstProgress:y,totalElapsed:c.elapsed()};return{errorDetails:S.errorDetails,timings:O}}else this.g.delete(E)}),s)}catch(b){return this.j.error(b,o.extension),{errorDetails:{message:(0,f.localize)(0,null,(0,P.$Ai)(b)),responseIsIncomplete:!0}}}finally{g=!0,C.complete()}}$releaseSession(p){this.g.delete(p),this.h.delete(p)}async $provideSlashCommands(p,E){const m=this.b.get(p);return m?m.provideSlashCommand(E):[]}$provideFollowups(p,E,m){const n=this.b.get(p);if(!n)return Promise.resolve([]);const r=this.g.get(E);return r?n.provideFollowups(r,m):Promise.resolve([])}$acceptFeedback(p,E,m,n){const r=this.b.get(p);if(!r)return;const s=this.h.get(E)?.get(m);if(!s)return;let o;switch(n){case $.InteractiveSessionVoteDirection.Down:o=v.ChatAgentResultFeedbackKind.Unhelpful;break;case $.InteractiveSessionVoteDirection.Up:o=v.ChatAgentResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze({result:s,kind:o}))}$acceptAction(p,E,m,n){const r=this.b.get(p);if(!r)return;const s=this.h.get(E)?.get(m);s&&n.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:n.action,result:s}))}}e.$pec=t;class i{constructor(p,E,m,n,r){this.extension=p,this.n=E,this.o=m,this.q=n,this.r=r,this.l=new L.$Nd,this.m=new L.$Nd}acceptFeedback(p){this.l.fire(p)}acceptAction(p){this.m.fire(p)}async validateSlashCommand(p){this.b||(await this.provideSlashCommand(M.CancellationToken.None),(0,u.$If)(this.b));const E=this.b.find(m=>m.name===p);if(!E)throw new Error(`Unknown slashCommand: ${p}`);return E}async provideSlashCommand(p){if(!this.a)return[];const E=await this.a.provideSlashCommands(p);return E?(this.b=E,E.map(m=>({name:m.name,description:m.description}))):[]}async provideFollowups(p,E){if(!this.d)return[];const m=await this.d.provideFollowups(p,E);return m?m.map(n=>a.ChatFollowup.from(n)):[]}get apiAgent(){let p=!1,E=!1;const m=()=>{p||E||(E=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$hL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),E=!1}))},n=this;return{get name(){return n.n},get description(){return n.g??""},set description(r){n.g=r,m()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(r){n.h=r,m()},get iconPath(){return n.i},set iconPath(r){n.i=r,m()},get slashCommandProvider(){return n.a},set slashCommandProvider(r){n.a=r,m()},get followupProvider(){return n.d},set followupProvider(r){n.d=r,m()},get isDefault(){return(0,d.$hF)(n.extension,"defaultChatAgent"),n.j},set isDefault(r){(0,d.$hF)(n.extension,"defaultChatAgent"),n.j=r,m()},get isSecondary(){return(0,d.$hF)(n.extension,"defaultChatAgent"),n.k},set isSecondary(r){(0,d.$hF)(n.extension,"defaultChatAgent"),n.k=r,m()},get onDidReceiveFeedback(){return n.l.event},onDidPerformAction:(0,d.$gF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){p=!0,n.a=void 0,n.d=void 0,n.l.dispose(),n.o.$unregisterAgent(n.q)}}}invoke(p,E,m,n){return this.r(p,E,m,n)}}}),define(Ae[224],Re([1,0,19,6,3,8,52,21,12,5]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class R{constructor($,d){this.stream=new D.$gh,this.stream=d??new D.$gh;const t=this;this.apiObj={option:$,response:t.stream.asyncIterable}}}class k{constructor($,d){this.a=new f.$Nd,this.b=new Map,this.c=new D.$gh,this.d=!1;const t=this;this.apiObject={result:$,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){d.cancel()}},$.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment($){if(this.d)return;let d=this.b.get($.index);d||(this.b.size===0?d=new R($.index,this.c):d=new R($.index),this.b.set($.index,d),this.a.fire(d.apiObj)),d.stream.emitOne($.part)}}class a{static{this.a=1}constructor($,d){this.d=d,this.c=new Map,this.e=new Map,this.f=new u.$8l,this.b=$.getProxy(P.$lK.MainThreadChatProvider)}registerProvider($,d,t,i){const l=a.a++;return this.c.set(l,{extension:$,provider:t}),this.b.$registerProvider(l,d,{extension:$,displayName:i.name??$.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(l),this.c.delete(l)})}async $provideChatResponse($,d,t,i,l){const p=this.c.get($);if(!p)return;const E=new A.$6u(async m=>{if(l.isCancellationRequested){this.d.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(d,{index:m.index,part:m.part})});return p.provider.provideChatResponse(t.map(L.ChatMessage.to),i,E,l)}allowListExtensionWhile($,d){this.f.set($,d),d.finally(()=>this.f.delete($))}async requestChatResponseProvider($,d){if(!this.f.has($))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has($)},makeRequest(i,l,p){if(!t.f.has($))throw new Error("Access to chat has been revoked");const E=new w.$Xd(p),m=Math.random()*1e6|0,n=t.b.$fetchResponse($,d,m,i.map(L.ChatMessage.from),l??{},E.token),r=new k(n,E);return t.e.set(m,{res:r}),n.finally(()=>{t.e.delete(m)}),r.apiObject}}}async $handleResponseFragment($,d){const t=this.e.get($);t&&t.res.handleFragment(d)}}e.$jec=a}),define(Ae[225],Re([1,0,6,3,11,8]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class A{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(M.$lK.MainThreadChatVariables)}async $resolveVariable(D,f,R){const k=this.b.get(D);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:f},R);if(a)return a.map(L.ChatVariable.from)}catch(a){(0,P.$2)(a)}}registerVariableResolver(D,f,R,k){const a=A.a++;return this.b.set(a,{extension:D.identifier,data:{name:f,description:R},resolver:k}),this.c.$registerVariable(a,{name:f,description:R}),(0,w.$Qc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$lec=A}),define(Ae[226],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class M{constructor(L){const A=L.getProxy(w.$lK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(u){return A.$writeText(u)}})}}e.$tcc=M}),define(Ae[31],Re([1,0,15,7,8,25,3,18,14,68,41,282,2,6,4,17,105,26,47,37,48,55,59]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=void 0;let r=class{#e;#t;#i;constructor(I,c,y){this.b=new Map,this.c=new Map,this.#e=I.getProxy(A.$lK.MainThreadCommands),this.d=c,this.#i=y,this.#t=I.getProxy(A.$lK.MainThreadTelemetry),this.converter=new s(this,b=>{const S=this.c.get(b);return S?.result===g.Void?S:void 0},c),this.f=[{processArgument(b){return(0,f.$mh)(b)}},{processArgument(b){return(0,L.$9m)(b,function(S){if(R.$ts.isIRange(S))return P.Range.to(S);if(k.$ss.isIPosition(S))return P.Position.to(S);if(R.$ts.isIRange(S.range)&&a.URI.isUri(S.uri))return P.location.to(S);if(S instanceof i.$be)return S.buffer.buffer;if(!Array.isArray(S))return S})}}]}registerArgumentProcessor(I){this.f.push(I)}registerApiCommand(I){const c=this.registerCommand(!1,I.id,async(...y)=>{const b=I.args.map((j,O)=>{if(!j.validate(y[O]))throw new Error(`Invalid argument '${j.name}' when running '${I.id}', received: ${typeof y[O]=="object"?JSON.stringify(y[O],null,"	"):y[O]} `);return j.convert(y[O])}),S=await this.executeCommand(I.internalId,...b);return I.result.convert(S,y,this.converter)},void 0,{description:I.description,args:I.args,returns:I.result.description});return this.c.set(I.id,I),new M.$nK(()=>{c.dispose(),this.c.delete(I.id)})}registerCommand(I,c,y,b,S,j){if(this.d.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this.b.has(c))throw new Error(`command '${c}' already exists`);return this.b.set(c,{callback:y,thisArg:b,metadata:S,extension:j}),I&&this.#e.$registerCommand(c),new M.$nK(()=>{this.b.delete(c)&&I&&this.#e.$unregisterCommand(c)})}executeCommand(I,...c){return this.d.trace("ExtHostCommands#executeCommand",I),this.g(I,c,!0)}async g(I,c,y){if(this.b.has(I))return this.#e.$fireCommandActivationEvent(I),this.h(I,c,!1);{let b=!1;const S=(0,L.$9m)(c,function(j){if(j instanceof M.$oK)return P.Position.from(j);if(j instanceof M.$pK)return P.Range.from(j);if(j instanceof M.$zK)return P.location.from(j);if(M.$KL.isNotebookRange(j))return P.NotebookRange.from(j);if(j instanceof ArrayBuffer)return b=!0,i.$be.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return b=!0,i.$be.wrap(j);if(j instanceof i.$be)return b=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(I,b?new l.$qv(S):S,y);return(0,f.$mh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(I,c,!1);throw j}}}async h(I,c,y){const b=this.b.get(I);if(!b)throw new Error("Unknown command");const{callback:S,thisArg:j,metadata:O}=b;if(O?.args)for(let B=0;B<O.args.length;B++)try{(0,w.$Pf)(c[B],O.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${I}' failed. Illegal argument '${O.args[B].name}' - ${O.args[B].description}`)}const K=E.$Jd.create();try{return await S.apply(j,c)}catch(B){if(I===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...c);T&&(I=T.command)}if(this.d.error(B,I,b.extension?.identifier),!y)throw B;if(b.extension?.identifier){const T=this.#i.onExtensionError(b.extension.identifier,B);this.d.trace("forwarded error to extension?",T,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,p.$Ai)(B)),this.id=I,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,I,K.elapsed())}}j(I,c,y){I.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:I.extension.identifier.value,id:new m.$jo(c),duration:y})}$executeContributedCommand(I,...c){this.d.trace("ExtHostCommands#$executeContributedCommand",I);const y=this.b.get(I);return y?(c=c.map(b=>this.f.reduce((S,j)=>j.processArgument(S,y.extension?.identifier),b)),this.h(I,c,!0)):Promise.reject(new Error(`Contributed command '${I}' does not exist.`))}getCommands(I=!1){return this.d.trace("ExtHostCommands#getCommands",I),this.#e.$getCommands().then(c=>(I&&(c=c.filter(y=>y[0]!=="_")),c))}$getContributedCommandMetadata(){const I=Object.create(null);for(const[c,y]of this.b){const{metadata:b}=y;b&&(I[c]=b)}return Promise.resolve(I)}};e.$HM=r,e.$HM=r=qe([Ke(0,d.$mM),Ke(1,D.$0i),Ke(2,n.$GM)],r),e.$IM=(0,$.$Ph)("IExtHostCommands");class s{constructor(I,c,y){this.d=I,this.f=c,this.g=y,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(I,c){if(!I)return;const y={$ident:void 0,id:I.command,title:I.title,tooltip:I.tooltip};if(!I.command)return y;const b=this.f(I.command);if(b)y.id=b.internalId,y.arguments=b.args.map((S,j)=>S.convert(I.arguments&&I.arguments[j]));else if((0,u.$Lb)(I.arguments)){const S=`${I.command} /${++this.c}`;this.b.set(S,I),c.add((0,v.$Qc)(()=>{this.b.delete(S),this.g.trace("CommandsConverter#DISPOSE",S)})),y.$ident=S,y.id=this.delegatingCommandId,y.arguments=[S],this.g.trace("CommandsConverter#CREATE",I.command,S)}return y}fromInternal(I){return typeof I.$ident=="string"?this.b.get(I.$ident):{command:I.id,title:I.title,arguments:I.arguments}}getActualCommand(...I){return this.b.get(I[0])}h(...I){const c=this.getActualCommand(...I);return this.g.trace("CommandsConverter#EXECUTE",I[0],c?c.command:"MISSING"),c?this.d.executeCommand(c.command,...c.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${I[0]}`)}}e.$JM=s;class o{static{this.Uri=new o("uri","Uri of a text document",I=>a.URI.isUri(I),I=>I)}static{this.Position=new o("position","A position in a text document",I=>M.$oK.isPosition(I),P.Position.from)}static{this.Range=new o("range","A range in a text document",I=>M.$pK.isRange(I),P.Range.from)}static{this.Selection=new o("selection","A selection in a text document",I=>M.$qK.isSelection(I),P.Selection.from)}static{this.Number=new o("number","",I=>typeof I=="number",I=>I)}static{this.String=new o("string","",I=>typeof I=="string",I=>I)}static{this.StringArray=o.Arr(o.String)}static Arr(I){return new o(`${I.name}_array`,`Array of ${I.name}, ${I.description}`,c=>Array.isArray(c)&&c.every(y=>I.validate(y)),c=>c.map(y=>I.convert(y)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",I=>I instanceof M.$JK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",I=>I instanceof M.$4L,P.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",I=>I instanceof t.$zM,P.TestItem.from)}constructor(I,c,y,b){this.name=I,this.description=c,this.validate=y,this.convert=b}optional(){return new o(this.name,`(optional) ${this.description}`,I=>I==null||this.validate(I),I=>I===void 0?void 0:I===null?null:this.convert(I))}with(I,c){return new o(I??this.name,c??this.description,this.validate,this.convert)}}e.$KM=o;class g{static{this.Void=new g("no result",I=>I)}constructor(I,c){this.description=I,this.convert=c}}e.$LM=g;class h{constructor(I,c,y,b,S){this.id=I,this.internalId=c,this.description=y,this.args=b,this.result=S}}e.$MM=h}),define(Ae[227],Re([1,0,18,13,2,79,91,32,95,31,8,7]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;const a=[new f.$MM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of DocumentHighlight-instances.",$(R.DocumentHighlight.to))),new f.$MM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$KM.Uri],new f.$LM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.$Kb)(t))return;class l extends k.$EK{static to(E){const m=new l(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new k.$zK(i[0],R.Range.to(E.range)));return m.detail=E.detail,m.range=m.location.range,m.selectionRange=R.Range.to(E.selectionRange),m.children=E.children?E.children.map(l.to):[],m}}return t.map(l.to)})),new f.$MM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$KM.Uri,new f.$KM("options","Formatting options",t=>!0,t=>t)],new f.$LM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$MM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$KM.Uri,f.$KM.Range,new f.$KM("options","Formatting options",t=>!0,t=>t)],new f.$LM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$MM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$KM.Uri,f.$KM.Position,new f.$KM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$KM("options","Formatting options",t=>!0,t=>t)],new f.$LM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$MM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$MM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$MM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$MM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of Location or LocationLink instances.",d)),new f.$MM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of Location-instances.",$(R.location.to))),new f.$MM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of Hover-instances.",$(R.Hover.to))),new f.$MM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$KM.Uri,new f.$KM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$oK.isPosition(i)),t=>t.map(R.Position.from))],new f.$LM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let l;for(const p of i.reverse())l=new k.$IK(R.Range.to(p),l);return l}))),new f.$MM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$KM.String.with("query","Search string")],new f.$LM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new f.$MM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new f.$MM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$KM.CallHierarchyItem],new f.$LM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new f.$MM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$KM.CallHierarchyItem],new f.$LM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new f.$MM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new f.$MM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$KM.Uri,f.$KM.Position,f.$KM.String.with("newName","The new symbol name")],new f.$LM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new f.$MM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$KM.Uri,f.$KM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$LM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new f.$MM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$KM.Uri],new f.$LM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$CL(t.tokenTypes,t.tokenModifiers)})),new f.$MM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$KM.Uri],new f.$LM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$30)(t);if(i.type==="full")return new k.$EL(i.data,void 0)})),new f.$MM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$KM.Uri,f.$KM.Range.optional()],new f.$LM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$CL(t.tokenTypes,t.tokenModifiers)})),new f.$MM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$KM.Uri,f.$KM.Range],new f.$LM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$30)(t);if(i.type==="full")return new k.$EL(i.data,void 0)})),new f.$MM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$KM.Uri,f.$KM.Position,f.$KM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$KM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$LM("A promise that resolves to a CompletionList-instance.",(t,i,l)=>{if(!t)return new k.$UK([]);const p=t.suggestions.map(E=>R.CompletionItem.to(E,l));return new k.$UK(p,t.incomplete)})),new f.$MM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$KM.Uri,f.$KM.Position,f.$KM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$LM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new f.$MM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$KM.Uri,f.$KM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$LM("A promise that resolves to an array of CodeLens-instances.",(t,i,l)=>$(p=>new k.$MK(R.Range.to(p.range),p.command&&l.fromInternal(p.command)))(t))),new f.$MM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$KM.Uri,new f.$KM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$pK.isRange(t),t=>k.$qK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),f.$KM.String.with("kind","Code action kind to return code actions for").optional(),f.$KM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$LM("A promise that resolves to an array of Command-instances.",(t,i,l)=>$(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(p.command)}else{const E=new k.$GK(p.title,p.kind?new k.$HK(p.kind):void 0);return p.edit&&(E.edit=R.WorkspaceEdit.to(p.edit)),p.command&&(E.command=l.fromInternal(p.command)),E.isPreferred=p.isPreferred,E}})(t))),new f.$MM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$KM.Uri],new f.$LM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$1K(R.Range.to(i.range),R.Color.to(i.color))):[])),new f.$MM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$KM("color","The color to show and insert",t=>t instanceof k.$ZK,R.Color.from),new f.$KM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new f.$LM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new f.$MM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$KM.Uri,f.$KM.Range],new f.$LM("A promise that resolves to an array of Inlay objects",(t,i,l)=>t.map(R.InlayHint.to.bind(void 0,l)))),new f.$MM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$KM.Uri],new f.$LM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new f.$MM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$LM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new f.$MM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$KM.Uri,f.$KM.Range,new f.$KM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$pK,t=>R.InlineValueContext.from(t))],new f.$LM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new f.$MM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$KM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,D.$lU)(t,M.Schemas.http,M.Schemas.https),t=>t),new f.$KM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),f.$KM.String.with("label","").optional()],f.$LM.Void),new f.$MM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$KM.Uri.with("resource","Resource to open"),f.$KM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$KM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],f.$LM.Void),new f.$MM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$KM.Uri.with("left","Left-hand side resource of the diff editor"),f.$KM.Uri.with("right","Right-hand side resource of the diff editor"),f.$KM.String.with("title","Human readable title for the diff editor").optional(),new f.$KM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],f.$LM.Void),new f.$MM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$KM.Uri,f.$KM.Position],new f.$LM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$MM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$KM.TypeHierarchyItem],new f.$LM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$MM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$KM.TypeHierarchyItem],new f.$LM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$MM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$KM.TestItem],f.$LM.Void),new f.$MM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$KM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$LM.Void),new f.$MM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$KM.String.with("name","The context key name"),new f.$KM("value","The context key value",()=>!0,t=>t)],f.$LM.Void),new f.$MM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$KM.Uri,f.$KM.StringArray,new f.$KM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new f.$LM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class v{static register(i){a.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",u.$Oi)}}e.$scc=v;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function d(t){if(!Array.isArray(t))return;const i=[];for(const l of t)L.$et(l)?i.push(R.DefinitionLink.to(l)):i.push(R.location.to(l));return i}}),define(Ae[228],Re([1,0,12,65,5,6,2,79,21,8,7,3,22]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;function v($,d,t){const i=$.getProxy(k.$lK.MainThreadComments);class l{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$8l,d.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const C=this.b.get(h.handle);return C?C.value:h}else if(h&&h.$mid===7){const C=this.b.get(h.commentControlHandle);if(!C)return h;const I=C.getCommentThread(h.commentThreadHandle);return I?I.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const C=this.b.get(h.thread.commentControlHandle);if(!C)return h;const I=C.getCommentThread(h.thread.commentThreadHandle);return I?h.$mid===8?I.value:{thread:I.value,text:h.text}:h}else if(h&&h.$mid===10){const C=this.b.get(h.thread.commentControlHandle);if(!C)return h;const I=C.getCommentThread(h.thread.commentThreadHandle);if(!I)return h;const c=h.commentUniqueId,y=I.getCommentByUniqueId(c);return y||h}else if(h&&h.$mid===11){const C=this.b.get(h.thread.commentControlHandle);if(!C)return h;const I=C.getCommentThread(h.thread.commentThreadHandle);if(!I)return h;const c=h.text,y=h.commentUniqueId,b=I.getCommentByUniqueId(y);return b?(typeof b.body=="string"?b.body=c:b.body=new R.$NK(c),b):h}return h}})}createCommentController(h,C,I){const c=l.a++,y=new E(h,c,C,I);this.b.set(y.handle,y);const b=this.c.get(h.identifier)||[];return b.push(y),this.c.set(h.identifier,b),y.value}async $createCommentThreadTemplate(h,C,I){const c=this.b.get(h);c&&c.$createCommentThreadTemplate(C,I)}async $updateCommentThreadTemplate(h,C,I){const c=this.b.get(h);c&&c.$updateCommentThreadTemplate(C,I)}$deleteCommentThread(h,C){this.b.get(h)?.$deleteCommentThread(C)}$provideCommentingRanges(h,C,I){const c=this.b.get(h);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const y=t.getDocument(A.URI.revive(C));return(0,w.$Mg)(async()=>{const b=await c.commentingRangeProvider.provideCommentingRanges(y,I);let S;return Array.isArray(b)?S={ranges:b,fileComments:!1}:b?S={ranges:b.ranges||[],fileComments:b.fileComments||!1}:S=b??void 0,S}).then(b=>{let S;return b&&(S={ranges:b.ranges.map(j=>f.Range.from(j)),fileComments:b.fileComments}),S})}$toggleReaction(h,C,I,c,y){const b=this.b.get(h);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,w.$Mg)(()=>{const S=b.getCommentThread(C);if(S){const j=S.getCommentByUniqueId(c.uniqueIdInThread);if(b!==void 0&&j&&b.reactionHandler)return b.reactionHandler(j,r(y))}return Promise.resolve(void 0)})}}class p{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,C,I,c,y,b,S,j){this.m=C,this.n=I,this.o=c,this.p=y,this.q=b,this.extensionDescription=S,this.r=j,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Tc,this.l.value=new L.$Rc,this.n===void 0&&(this.n=`${h}.${this.handle}`),i.$createCommentThread(C,this.handle,this.n,this.o,f.Range.from(this.p),S.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{i.$deleteCommentThread(C,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(K){O.range=K},get comments(){return O.comments},set comments(K){O.comments=K},get collapsibleState(){return O.collapsibleState},set collapsibleState(K){O.collapsibleState=K},get canReply(){return O.canReply},set canReply(K){O.canReply=K},get contextValue(){return O.contextValue},set contextValue(K){O.contextValue=K},get label(){return O.label},set label(K){O.label=K},get state(){return O.state},set state(K){O.state=K},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Rc);const h=I=>Object.prototype.hasOwnProperty.call(this.b,I),C={};h("range")&&(C.range=f.Range.from(this.p)),h("label")&&(C.label=this.label),h("contextValue")&&(C.contextValue=this.contextValue??null),h("comments")&&(C.comments=this.q.map(I=>m(this,I,this.k,this.extensionDescription))),h("collapsibleState")&&(C.collapseState=s(this.g)),h("canReply")&&(C.canReply=this.canReply),h("state")&&(C.state=o(this.h)),h("isTemplate")&&(C.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(h){for(const C of this.k){const I=C[0],c=C[1];if(h===c)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}qe([(0,M.$ih)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,C,I,c){this.f=h,this.g=C,this.h=I,this.i=c,this.a=new Map,i.$registerCommentController(this.handle,I,c,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(b){y.options=b},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(b){y.commentingRangeProvider=b},get reactionHandler(){return y.reactionHandler},set reactionHandler(b){y.reactionHandler=b},createCommentThread(b,S,j){return y.createCommentThread(b,S,j).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(h,C,I){C===void 0&&(0,a.$hF)(this.f,"fileComments");const c=new p(this.id,this.handle,void 0,h,C,I,this.f,!1);return this.a.set(c.handle,c),c}$createCommentThreadTemplate(h,C){const I=new p(this.id,this.handle,void 0,A.URI.revive(h),f.Range.to(C),[],this.f,!0);return I.collapsibleState=u.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(h,C){const I=this.a.get(h);I&&(I.range=f.Range.to(C))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function m(g,h,C,I){let c=C.get(h);return c||(c=++g.commentHandle,C.set(h,c)),h.state!==void 0&&(0,a.$hF)(I,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:c,body:typeof h.body=="string"?h.body:f.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(y=>n(y)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function n(g){return{label:g.label,iconPath:g.iconPath?f.$lM(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function r(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?A.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function s(g){if(g!==void 0)switch(g){case R.CommentThreadCollapsibleState.Expanded:return u.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return u.CommentThreadCollapsibleState.Collapsed}return u.CommentThreadCollapsibleState.Collapsed}function o(g){if(g!==void 0)switch(g){case R.CommentThreadState.Unresolved:return u.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return u.CommentThreadState.Resolved}return u.CommentThreadState.Unresolved}return new l}e.$ucc=v}),define(Ae[229],Re([1,0,25,3,27,17]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;let A=class{constructor(R,k){this.a=R.getProxy(M.$lK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,k){const a=this,v=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){a.e(R,k,v,arguments)}})}e(R,k,a,v){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(v,this.b)}),this.c&&this.f(R,a,v)}};e.$sec=A,e.$sec=A=qe([Ke(0,L.$mM),Ke(1,P.$CM)],A);const u=1e5;function D(f,R){const k=[];if(f.length)for(let a=0;a<f.length;a++){let v=f[a];if(typeof v>"u")v="undefined";else if(v instanceof Error){const $=v;$.stack?v=$.stack:v=$.toString()}k.push(v)}if(R){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,w.$_m)(k);return a.length>u?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,16,20,22]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0;let v=class{static{a=this}static{this.c=0}static{this.d=250}constructor(d,t){this.h=t,this.f=new Map,this.g=d.getProxy(M.$lK.MainThreadDecorations)}registerFileDecorationProvider(d,t){const i=a.c++;this.f.set(i,{provider:d,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const l=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(i,null);return}const E=(0,D.$3b)(p);if(E.length<=a.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const m=E.map(s=>({uri:s,rank:(0,f.$Ge)(s.path,"/")})),n=(0,D.$zb)(m,(s,o)=>s.rank-o.rank||(0,f.$Ue)(s.uri.path,o.uri.path)),r=[];e:for(const s of n){let o;for(const g of s){const h=(0,R.$mc)(g.uri.path);if(o!==h&&(o=h,r.push(g.uri)>=a.d))break e}}this.g.$onDidChange(i,r)});return new P.$nK(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(d,t,i){if(!this.f.has(d))return Object.create(null);const l=Object.create(null),{provider:p,extensionDescription:E}=this.f.get(d);return await Promise.all(t.map(async m=>{try{const{uri:n,id:r}=m,s=await Promise.resolve(p.provideFileDecoration(w.URI.revive(n),i));if(!s)return;try{P.$IL.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.$hF)(E,"codiconDecoration"),l[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),l}};e.$vdc=v,e.$vdc=v=a=qe([Ke(0,A.$mM),Ke(1,u.$0i)],v),e.$wdc=(0,L.$Ph)("IExtHostDecorations")}),define(Ae[230],Re([1,0,148,94,2,3,7,8,5,14,28,40]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class v{#e;#t;#i;constructor(t,i,l,p,E,m,n,r){this.d=t,this.e=i,this.f=l,this.g=p,this.h=E,this.c=!1,this.f=Math.max(p,l),this.#i=new R.$Ac(s=>m.getComparisonKey(s)),this.#e=n,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let l=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),l=[t]}else if(Array.isArray(t)){l=[];let m;t=[...t].sort(v.k);for(const n of t){const[r,s]=n;if((!m||r.toString()!==m.toString())&&(m&&this.#i.get(m).length===0&&this.#i.delete(m),m=r,l.push(r),this.#i.set(r,[])),s)this.#i.get(r)?.push(...s);else{const o=this.#i.get(r);o&&(o.length=0)}}}if(this.#t.fire(l),!this.#e)return;const p=[];let E=0;for(const m of l){let n=[];const r=this.#i.get(m);if(r)if(r.length>this.g){n=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const g of r)if(g.severity===s[o]&&n.push({...u.Diagnostic.from(g),modelVersionId:this.h(m)})===this.g)break e;n.push({severity:M.MarkerSeverity.Info,message:(0,w.localize)(0,null,r.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(s=>({...u.Diagnostic.from(s),modelVersionId:this.h(m)}));if(p.push([m,n]),E+=n.length,E>this.f)break}this.#e.$changeMany(this.e,p)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[l,p]of this)t.call(i,l,p,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$mcc=v;let $=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const i=new R.$Ac;for(const l of t)i.set(l,l);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,l,p){this.j=i,this.k=l,this.l=p,this.g=new Map,this.h=new D.$Rd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,a._mapper),this.f=t.getProxy(L.$lK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:l,f:p,h:E,j:m,k:n,l:r}=this,s=new class{$changeMany(h,C){p.$changeMany(h,C),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,h,C.length===0?"CLEARING":C)}$clear(h){p.$clear(h),m.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,h)}dispose(){p.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+a.c++,o=i;else if(!l.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+a.c++;while(l.has(o))}return new class extends v{constructor(){super(i,o,a.e,a.d,h=>r.getDocument(h)?.version,n.extUri,s,E),l.set(o,this)}dispose(){super.dispose(),l.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,l=[];for(const p of this.g.values())p.forEach((E,m)=>{let n=i.get(E.toString());typeof n>"u"&&(n=l.length,i.set(E.toString(),n),l.push([E,[]])),l[n][1]=l[n][1].concat(...m)});return l}}m(t){let i=[];for(const l of this.g.values())l.has(t)&&(i=i.concat(l.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",l=new v(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,p=>{},this.k.extUri,void 0,this.h);this.g.set(i,l),this.n=l}for(const[i,l]of t)this.n.set(P.URI.revive(i),l.map(u.Diagnostic.to))}};e.$ncc=$,e.$ncc=$=a=qe([Ke(1,f.$0i),Ke(2,k.$lcc)],$)}),define(Ae[231],Re([1,0,2,3,22]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class L{constructor(u){this.a=u.getProxy(M.$lK.MainThreadDialogs)}showOpenDialog(u,D){return D?.allowUIResources&&(0,P.$hF)(u,"showLocal"),this.a.$showOpenDialog(D).then(f=>f?f.map(R=>w.URI.revive(R)):void 0)}showSaveDialog(u){return this.a.$showSaveDialog(u).then(D=>D?w.URI.revive(D):void 0)}}e.$Ccc=L}),define(Ae[232],Re([1,0,11,2,7,3,13,19,16]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class f{static{this.a=0}constructor(k,a,v){this.d=a,this.e=v,this.b=new Map,this.c=k.getProxy(L.$lK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const v=f.a++;this.b.set(v,a),this.c.$registerTextContentProvider(v,k);let $;return typeof a.onDidChange=="function"&&($=a.onDidChange(d=>{if(d.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(v,d).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(d);if(!i)return;const l=(0,D.$Pe)(t);if(!i.equalLines(l))return this.c.$onVirtualDocumentChange(d,t)},w.$1)})),new P.$nK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(k,a){const v=this.b.get(k);return v?Promise.resolve(v.provideTextDocumentContent(M.URI.revive(a),u.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Dcc=f}),define(Ae[233],Re([1,0,5,6,2,3,100,8,15,25,7,11]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class a{constructor($,d){this.a=new w.$Nd({onListenerError:k.$2}),this.b=new w.$Nd({onListenerError:k.$2}),this.c=new w.$Nd({onListenerError:k.$2}),this.d=new w.$Nd({onListenerError:k.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Rc,this.h=new Map,this.f=$.getProxy(L.$lK.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const d=this.g.getDocument($);if(d)return d}getDocument($){const d=this.getDocumentData($);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return d.document}ensureDocumentData($){const d=this.g.getDocument($);if(d)return Promise.resolve(d);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const l=P.URI.revive(i);return(0,D.$Jf)(this.g.getDocument(l))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged($,d){const t=P.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(d),this.a.fire(i.document)}$acceptModelSaved($){const d=P.URI.revive($),t=this.g.getDocument(d);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,d){const t=P.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,d,t){const i=P.URI.revive($),l=this.g.getDocument(i);if(!l)throw new Error("unknown document");l._acceptIsDirty(t),l.onEvents(d);let p;d.isUndoing?p=R.TextDocumentChangeReason.Undo:d.isRedoing&&(p=R.TextDocumentChangeReason.Redo),this.c.fire((0,f.$8m)({document:l.document,contentChanges:d.changes.map(E=>({range:u.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:p}))}setWordDefinitionFor($,d){(0,A.$oM)($,d)}}e.$jcc=a}),define(Ae[60],Re([1,0,53,5,6,2,4,3,100,17,106,8,14,28,13,66,42]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(E,m){this.h=E,this.i=m,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new M.$Nd,this.e=new M.$Nd,this.f=new M.$Nd,this.g=new M.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const m=[],n=[],r=[];if(E.removedDocuments)for(const s of E.removedDocuments){const o=L.URI.revive(s),g=this.c.get(o);g?.unref()&&(this.c.delete(o),m.push(g.value))}if(E.addedDocuments)for(const s of E.addedDocuments){const o=L.URI.revive(s.uri);let g=this.c.get(o);if(g&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);g||(g=new i(new D.$pM(this.h.getProxy(u.$lK.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,g),n.push(g.value)),g.ref()}if(E.removedEditors)for(const s of E.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&r.push(o)}if(E.addedEditors)for(const s of E.addedEditors){const o=L.URI.revive(s.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const g=this.c.get(o).value,h=new R.$vM(s.id,this.h.getProxy(u.$lK.MainThreadTextEditors),this.i,new t.$V(()=>g.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(C=>k.Range.to(C)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,h)}E.newActiveEditor!==void 0&&(w.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,P.$Nc)(m),(0,P.$Nc)(r),E.removedDocuments&&this.e.fire(m),E.addedDocuments&&this.d.fire(n),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return d.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const m=this.b.get(this.a);return E?m:m?.value}allEditors(){return[...this.b.values()]}};e.$wM=l,e.$wM=l=qe([Ke(0,f.$mM),Ke(1,a.$0i)],l),e.$xM=(0,A.$Ph)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,15,234]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0,e.$Adc=(0,A.$Ph)("IExtHostEditorTabs");class k{constructor(t,i,l){this.e=l,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new u.$5L(P.URI.revive(this.b.input.uri));case 2:return new u.$6L(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new u.$7L(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new u.$8L(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new u.$9L(this.b.input.viewType);case 4:return new u.$0L(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new u.$$L(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new u.$_L;case 9:return new u.$aM(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const l of t.tabs)l.isActive&&(this.d=l.id),this.c.push(new k(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(l=>l.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(l=>l.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const l=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,l),t.tabDto.isActive&&(this.d=l.tabId),l}else if(t.kind===1){const l=this.c.splice(t.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(t.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,l),l}const i=this.c.find(l=>l.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let v=class{constructor(t){this.b=new L.$Nd,this.c=new L.$Nd,this.e=[],this.a=t.getProxy(M.$lK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(l=>l.apiObject))},get activeTabGroup(){const l=t.d;return(0,f.$Jf)(t.e.find(E=>E.groupId===l)?.apiObject)},close:async(l,p)=>{const E=Array.isArray(l)?l:[l];return E.length?$(E[0])?this.j(E,p):this.i(E,p):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),l=new Set(t.map(s=>s.groupId)),p=(0,R.$K)(i,l),E=this.e.filter(s=>p.removed.includes(s.groupId)).map(s=>s.apiObject),m=[],n=[];this.e=t.map(s=>{const o=new a(s,()=>this.d);return p.added.includes(o.groupId)?m.push(o.apiObject):n.push(o.apiObject),o});const r=(0,f.$Jf)(t.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:m,closed:E,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(l=>l.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(p=>p.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const l=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(t){for(const i of this.e)for(const l of i.tabs)if(l.apiObject===t)return l}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const l=[];for(const p of t){const E=this.g(p);if(!E)throw new Error("Tab close: Invalid tab not found!");l.push(E.tabId)}return this.a.$closeTab(l,i)}async j(t,i){const l=[];for(const p of t){const E=this.h(p);if(!E)throw new Error("Group close: Invalid group not found!");l.push(E.groupId)}return this.a.$closeGroup(l,i)}};e.$Bdc=v,e.$Bdc=v=qe([Ke(0,D.$mM)],v);function $(d){return d.tabs!==void 0}}),define(Ae[235],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$lK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,u,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const R=await f.provideEmbeddingVector(u,D);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,u,D){const f=this.b;return this.b++,this.a.set(f,D),this.c.$registerAiEmbeddingVectorProvider(u,f),new M.$nK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$nec=P}),define(Ae[236],Re([1,0,2,3,6,7,8,283,16,26,22,51]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class a{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const t=this.a.indexOf(d);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),t=[];let i,l,p=14,E=14;for(const m of d){let n=i?(0,D.$4e)(i,m):0;for(n===0?l=1:l=E;n<m.length;n++)n+1===m.length?(p=E,E=9):E+=1,t.push([l,m.toUpperCase().charCodeAt(n),E]),t.push([l,m.toLowerCase().charCodeAt(n),E]),l=E;i=m,E=p}t.push([9,58,10]),t.push([10,47,12]),this.b=new u.$6Y(t)}}provideDocumentLinks(d){this.c();const t=[],i=u.$7Y.computeLinks({getLineContent(l){return d.lineAt(l-1).text},getLineCount(){return d.lineCount}},this.b);for(const l of i){const p=A.DocumentLink.to(l);p.target&&t.push(p)}return t}}class v{constructor(d,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(M.$lK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,t,i,l={}){if(v.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const p=this.h++;this.b.add(t),this.d.add(t),this.c.set(p,i);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$hF)(d,"fsChunks"),E+=4);let m;l.isReadonly&&(0,k.$5j)(l.isReadonly)&&((0,R.$hF)(d,"readonlyMessage"),m={value:l.isReadonly.value,isTrusted:l.isReadonly.isTrusted,supportThemeIcons:l.isReadonly.supportThemeIcons,supportHtml:l.isReadonly.supportHtml,baseUri:l.isReadonly.baseUri,uris:l.isReadonly.uris}),this.a.$registerFileSystemProvider(p,t,E,m).catch(r=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${t}`),console.error(r)});const n=i.onDidChangeFile(r=>{const s=[];for(const o of r){const{uri:g,type:h}=o;if(g.scheme!==t)continue;let C;switch(h){case L.FileChangeType.Changed:C=0;break;case L.FileChangeType.Created:C=1;break;case L.FileChangeType.Deleted:C=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:g,type:C})}this.a.$onFileSystemChange(p,s)});return(0,P.$Qc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:t,ctime:i,mtime:l,size:p,permissions:E}=d;return{type:t,ctime:i,mtime:l,size:p,permissions:E}}$stat(d,t){return Promise.resolve(this.l(d).stat(w.URI.revive(t))).then(i=>v.k(i))}$readdir(d,t){return Promise.resolve(this.l(d).readDirectory(w.URI.revive(t)))}$readFile(d,t){return Promise.resolve(this.l(d).readFile(w.URI.revive(t))).then(i=>f.$be.wrap(i))}$writeFile(d,t,i,l){return Promise.resolve(this.l(d).writeFile(w.URI.revive(t),i.buffer,l))}$delete(d,t,i){return Promise.resolve(this.l(d).delete(w.URI.revive(t),i))}$rename(d,t,i,l){return Promise.resolve(this.l(d).rename(w.URI.revive(t),w.URI.revive(i),l))}$copy(d,t,i,l){const p=this.l(d);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(w.URI.revive(t),w.URI.revive(i),l))}$mkdir(d,t){return Promise.resolve(this.l(d).createDirectory(w.URI.revive(t)))}$watch(d,t,i,l){const p=this.l(d).watch(w.URI.revive(i),l);this.f.set(t,p)}$unwatch(d,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(d,t,i){const l=this.l(d);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(w.URI.revive(t),i))}$close(d,t){const i=this.l(d);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(d,t,i,l){const p=this.l(d);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const E=f.$be.alloc(l);return Promise.resolve(p.read(t,i,E.buffer,0,l)).then(m=>E.slice(0,m))}$write(d,t,i,l){const p=this.l(d);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(t,i,l.buffer,0,l.byteLength))}l(d){const t=this.c.get(d);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$0cc=v}),define(Ae[62],Re([1,0,3,39,7,26,4,17,40,6,12,24,13]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0;let $=v=class{constructor(t,i){this.b=new Map,this.c=new R.$3g,this.a=t.getProxy(w.$lK.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(p){try{let E;const m=l.b.get(p.scheme);return m?(await l.a.$ensureActivation(p.scheme),E=await m.impl.stat(p)):E=await l.a.$stat(p),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){v.e(E)}},async readDirectory(p){try{const E=l.b.get(p.scheme);return E?(await l.a.$ensureActivation(p.scheme),(await E.impl.readDirectory(p)).slice()):await l.a.$readdir(p)}catch(E){return v.e(E)}},async createDirectory(p){try{const E=l.b.get(p.scheme);return E&&!E.isReadonly?(await l.a.$ensureActivation(p.scheme),await l.d(E.impl,E.extUri,p)):await l.a.$mkdir(p)}catch(E){return v.e(E)}},async readFile(p){try{const E=l.b.get(p.scheme);return E?(await l.a.$ensureActivation(p.scheme),(await E.impl.readFile(p)).slice()):(await l.a.$readFile(p)).buffer}catch(E){return v.e(E)}},async writeFile(p,E){try{const m=l.b.get(p.scheme);return m&&!m.isReadonly?(await l.a.$ensureActivation(p.scheme),await l.d(m.impl,m.extUri,m.extUri.dirname(p)),await l.c.queueFor(p).queue(()=>Promise.resolve(m.impl.writeFile(p,E,{create:!0,overwrite:!0})))):await l.a.$writeFile(p,L.$be.wrap(E))}catch(m){return v.e(m)}},async delete(p,E){try{const m=l.b.get(p.scheme);return m&&!m.isReadonly?(await l.a.$ensureActivation(p.scheme),await m.impl.delete(p,{recursive:!1,...E})):await l.a.$delete(p,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(m){return v.e(m)}},async rename(p,E,m){try{return await l.a.$rename(p,E,{overwrite:!1,...m})}catch(n){return v.e(n)}},async copy(p,E,m){try{return await l.a.$copy(p,E,{overwrite:!1,...m})}catch(n){return v.e(n)}},isWritableFileSystem(p){const E=i.getCapabilities(p);if(typeof E=="number")return!(E&2048)}})}async d(t,i,l){const p=[];for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&M.FileType.Directory))throw P.$AL.FileExists(`Unable to create folder '${l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$ok(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;p.push(i.basename(l)),l=i.dirname(l)}for(let E=p.length-1;E>=0;E--){l=i.joinPath(l,p[E]);try{await t.createDirectory(l)}catch(m){if(M.$ok(m)!==M.FileSystemProviderErrorCode.FileExists)throw m}}}static e(t){if(t instanceof P.$AL)throw t;if(t instanceof M.$kk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw P.$AL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$AL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$AL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$AL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$AL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$AL.Unavailable(t.message);default:throw new P.$AL(t.message,t.name)}if(!(t instanceof Error))throw new P.$AL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$AL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw P.$AL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$AL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$AL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$AL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$AL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$AL.Unavailable(t.message);default:throw new P.$AL(t.message,t.name)}}addFileSystemProvider(t,i,l){return this.b.set(t,{impl:i,extUri:l?.isCaseSensitive?k.$lg:k.$ng,isReadonly:!!l?.isReadonly}),(0,f.$Qc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$lg}};e.$Pcc=$,e.$Pcc=$=v=qe([Ke(0,u.$mM),Ke(1,D.$lcc)],$),e.$Qcc=(0,A.$Ph)("IExtHostConsumerFileSystem")}),define(Ae[237],Re([1,0,5,38,2,3,8,7,42]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class f{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,$,d,t,i,l){this.a=Math.random(),this.b=new w.$Nd,this.c=new w.$Nd,this.d=new w.$Nd,this.h=0,l?.ignoreCreateEvents&&(this.h+=1),l?.ignoreChangeEvents&&(this.h+=2),l?.ignoreDeleteEvents&&(this.h+=4);const p=(0,M.$wj)(i),E=typeof i=="string",m=t(n=>{if(!(typeof n.session=="number"&&n.session!==this.a)){if(!l?.ignoreCreateEvents)for(const r of n.created){const s=P.URI.revive(r);p(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.b.fire(s)}if(!l?.ignoreChangeEvents)for(const r of n.changed){const s=P.URI.revive(r);p(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.c.fire(s)}if(!l?.ignoreDeleteEvents)for(const r of n.deleted){const s=P.URI.revive(r);p(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=u.$nK.from(this.i(v,d,i,l),this.b,this.c,this.d,m)}i(v,$,d,t){const i=u.$nK.from();if(typeof d=="string")return i;const l=v.getProxy(L.$lK.MainThreadFileSystemEventService);let p=!1;return(d.pattern.includes(M.$sj)||d.pattern.includes(M.$tj))&&(p=!0),l.$watch($.identifier.value,this.a,d.baseUri,{recursive:p,excludes:t?.excludes??[]}),u.$nK.from({dispose:()=>l.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(v){this.a=v,this.session=this.a.session,this.b=new D.$V(()=>this.a.created.map(P.URI.revive)),this.c=new D.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new D.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(v,$,d){this.j=v,this.k=$,this.l=d,this.a=new w.$Nd,this.b=new w.$Nd,this.c=new w.$Nd,this.d=new w.$Nd,this.g=new w.$Pd,this.h=new w.$Pd,this.i=new w.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,$,d,t){return new f(this.j,v,$,this.a.event,A.GlobPattern.from(d),t)}$onFileEvent(v){this.a.fire(new R(v))}$onDidRunFileOperation(v,$){switch(v){case 2:this.b.fire(Object.freeze({files:$.map(d=>({oldUri:P.URI.revive(d.source),newUri:P.URI.revive(d.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(d=>P.URI.revive(d.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(d=>P.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,$){return(d,t,i)=>{const l=function(E){d.call(t,E)};return l.extension=v,$.event(l,void 0,i)}}async $onWillRunFileOperation(v,$,d,t){switch(v){case 2:return await this.n(this.g,{files:$.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},d,t);case 1:return await this.n(this.i,{files:$.map(i=>P.URI.revive(i.target))},d,t);case 0:case 3:return await this.n(this.h,{files:$.map(i=>P.URI.revive(i.target))},d,t)}}async n(v,$,d,t){const i=new Set,l=[];if(await v.fireAsync($,t,async(E,m)=>{const n=Date.now(),r=await Promise.resolve(E);r instanceof u.$xK&&(l.push([m.extension,r]),i.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-n>d&&this.k.warn("SLOW file-participant",m.extension.identifier)}),t.isCancellationRequested||l.length===0)return;const p={edits:[]};for(const[,E]of l){const{edits:m}=A.WorkspaceEdit.from(E,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});p.edits=p.edits.concat(m)}return{edit:p,extensionNames:Array.from(i)}}}e.$$cc=k}),define(Ae[238],Re([1,0,6,2,3,8,7,31,12]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;class f{static{this.a=0}constructor(v,$){this.extension=v,this.provider=$,this.handle=f.a++}}class R{constructor(v){this.session=v,this.responses=[]}}class k{static{this.a=0}constructor(v,$,d,t){this.f=d,this.g=t,this.b=new Map,this.d=new Map,this.e=v.getProxy(P.$lK.MainThreadInlineChat),$.registerApiCommand(new u.$MM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new u.$KM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?L.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?L.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?L.Position.from(i.position):void 0}})],u.$LM.Void))}registerProvider(v,$,d){const t=new f(v,$);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,d.label,v.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function"),(0,w.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(v,$,d,t){const i=this.b.get(v);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const l=this.f.getDocument(M.URI.revive($)),p=L.Selection.to(d),E=await i.provider.prepareInteractiveEditorSession({document:l,selection:p},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(p))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const m=k.a++;return this.d.set(m,new R(E)),{id:m,placeholder:E.placeholder,input:E.input,slashCommands:E.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:L.Range.from(E.wholeRange),message:E.message}}async $provideResponse(v,$,d,t){const i=this.b.get(v);if(!i)return;const l=this.d.get($.id);if(!l)return;const p={prompt:d.prompt,selection:L.Selection.to(d.selection),wholeRange:L.Range.to(d.wholeRange),attempt:d.attempt,live:d.live};let E=!1;const m={report:async h=>{if(!d.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||await this.e.$handleProgressChunk(d.requestId,{message:h.message,edits:h.edits?.map(L.TextEdit.from),slashCommand:h.slashCommand?.command,markdownFragment:A.$NK.isMarkdownString(h.content)?h.content.value:h.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(l.session,p,m,t));let r;try{r=await(0,D.$Ig)(n,t)}finally{E=!0}if(!r)return;const s=l.responses.push(r)-1,o={wholeRange:L.Range.from(r.wholeRange),placeholder:r.placeholder};if(k.h(r))return{...o,id:s,type:"message",message:L.MarkdownString.from(r.contents)};const{edits:g}=r;return g instanceof A.$xK?{...o,id:s,type:"bulkEdit",edits:L.WorkspaceEdit.from(g)}:{...o,id:s,type:"editorEdit",edits:g.map(L.TextEdit.from)}}$handleFeedback(v,$,d,t){const i=this.b.get(v),l=this.d.get($),p=l?.responses[d];if(i&&p){const E=L.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(l.session,p,E)}}$releaseSession(v,$){}static h(v){return typeof v=="object"&&typeof v.contents=="object"}}e.$fec=k}),define(Ae[239],Re([1,0,2,31]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class P{constructor(A,u,D,f,R){this.a=u,this.b=D,this.c=f;const k=new M.$MM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$KM("showOptions","Show Options",a=>!0,a=>a),new M.$KM("resource","Interactive resource Uri",a=>!0,a=>a),new M.$KM("controllerId","Notebook controller Id",a=>!0,a=>a),new M.$KM("title","Interactive editor title",a=>!0,a=>a)],new M.$LM("Notebook and input URI",a=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const v=this.a.getEditorById(a.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri),notebookEditor:v.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:w.URI.revive(a.notebookUri),inputUri:w.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,u,D,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:u,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,u){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$bec=P}),define(Ae[240],Re([1,0,3,7]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class P{constructor(A){this.a=new Map,this.b=A.getProxy(w.$lK.MainThreadIssueReporter)}async $getIssueReporterUri(A,u){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(A);if(!D)throw new Error("Issue request handler not found");const f=await D.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,u){const D=A.identifier.value;return this.a.set(D,u),this.b.$registerIssueUriRequestHandler(D),new M.$nK(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$hec=P}),define(Ae[241],Re([1,0,6,3]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(M.$lK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const u=this.b++;return this.a.$registerResourceLabelFormatter(u,A),(0,w.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(u)})}}e.$udc=P}),define(Ae[242],Re([1,0,2,25,8,7,79,3,16,41,18,15,284,19,21,6,91,88,74,48,11,12,22,150]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class s{constructor(F,V){this.d=F,this.e=V}async provideDocumentSymbols(F,V){const G=this.d.getDocument(F),J=await this.e.provideDocumentSymbols(G,V);if(!(0,R.$Kb)(J))return J[0]instanceof L.$FK?J.map(P.DocumentSymbol.from):s.f(J)}static f(F){F=F.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const V=[],G=[];for(const J of F){const q={name:J.name||"!!MISSING: name!!",kind:P.SymbolKind.from(J.kind),tags:J.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:P.Range.from(J.location.range),selectionRange:P.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const x=G[G.length-1];if(f.$ts.containsRange(x.range,q.range)&&!f.$ts.equalsRange(x.range,q.range)){x.children?.push(q),G.push(q);break}G.pop()}}return V}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,V,G){this.g=F,this.h=V,this.j=G,this.e=new l.$icc("CodeLens"),this.f=new Map}async provideCodeLenses(F,V){const G=this.g.getDocument(F),J=await this.j.provideCodeLenses(G,V);if(!J||V.isCancellationRequested)return;const q=this.e.add(J),x=new d.$Rc;this.f.set(q,x);const ce={cacheId:q,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ce.lenses.push({cacheId:[q,Ne],range:P.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,x)});return ce}async resolveCodeLens(F,V){const G=F.cacheId&&this.e.get(...F.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,V),J||(J=G),V.isCancellationRequested)return;const q=F.cacheId&&this.f.get(F.cacheId[0]);if(q)return F.command=this.h.toInternal(J.command??o.d,q),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function g(Ce){return Array.isArray(Ce)?Ce.map(P.DefinitionLink.from):Ce?[P.DefinitionLink.from(Ce)]:[]}class h{constructor(F,V){this.d=F,this.e=V}async provideDefinition(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideDefinition(J,q,G);return g(x)}}class C{constructor(F,V){this.d=F,this.e=V}async provideDeclaration(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideDeclaration(J,q,G);return g(x)}}class I{constructor(F,V){this.d=F,this.e=V}async provideImplementation(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideImplementation(J,q,G);return g(x)}}class c{constructor(F,V){this.d=F,this.e=V}async provideTypeDefinition(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideTypeDefinition(J,q,G);return g(x)}}class y{constructor(F,V){this.d=F,this.e=V}async provideHover(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideHover(J,q,G);if(!(!x||(0,R.$Kb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new L.$pK(q,q)),P.Hover.from(x)}}class b{constructor(F,V){this.d=F,this.e=V}async provideEvaluatableExpression(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideEvaluatableExpression(J,q,G);if(x)return P.EvaluatableExpression.from(x)}}class S{constructor(F,V){this.d=F,this.e=V}async provideInlineValues(F,V,G,J){const q=this.d.getDocument(F),x=await this.e.provideInlineValues(q,P.Range.to(V),P.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(ce=>P.InlineValue.from(ce))}}class j{constructor(F,V){this.d=F,this.e=V}async provideDocumentHighlights(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(x))return x.map(P.DocumentHighlight.from)}}class O{constructor(F,V){this.d=F,this.e=V}async provideLinkedEditingRanges(F,V,G){const J=this.d.getDocument(F),q=P.Position.to(V),x=await this.e.provideLinkedEditingRanges(J,q,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Hb)(x.ranges.map(P.Range.from)),wordPattern:x.wordPattern}}}class K{constructor(F,V){this.d=F,this.e=V}async provideReferences(F,V,G,J){const q=this.d.getDocument(F),x=P.Position.to(V),ce=await this.e.provideReferences(q,x,G,J);if(Array.isArray(ce))return ce.map(P.location.from)}}class B{static{this.d=1e3}constructor(F,V,G,J,q,x,ce){this.g=F,this.h=V,this.j=G,this.k=J,this.l=q,this.m=x,this.n=ce,this.e=new l.$icc("CodeAction"),this.f=new Map}async provideCodeActions(F,V,G,J){const q=this.g.getDocument(F),x=a.$vs.isISelection(V)?P.Selection.to(V):P.Range.to(V),ce=[];for(const Ze of this.j.getDiagnostics(F))if(x.intersection(Ze.range)&&ce.push(Ze)>B.d)break;const Ne={diagnostics:ce,only:G.only?new L.$HK(G.only):void 0,triggerKind:P.CodeActionTriggerKind.to(G.trigger)},je=await this.k.provideCodeActions(q,x,Ne,J);if(!(0,R.$Lb)(je)||J.isCancellationRequested)return;const Qe=this.e.add(je),Ge=new d.$Rc;this.f.set(Qe,Ge);const _e=[];for(let Ze=0;Ze<je.length;Ze++){const xe=je[Ze];xe&&(B.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Ne.only&&(xe.kind?Ne.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Ze],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(P.Diagnostic.from),edit:xe.edit&&P.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,n.$gF)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(F,V){const[G,J]=F,q=this.e.get(G,J);if(!q||B.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,V)??q;let ce;x.edit&&(ce=P.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const je=this.f.get(G);je&&(Ne=this.h.toInternal(x.command,je))}return{edit:ce,command:Ne}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class T{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,G,J,q){this.d=F,this.e=V,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(F,V,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(F),x=V.map(je=>P.Range.to(je)),ce=P.DataTransfer.toDataTransfer(G,()=>{throw new E.$$});if(await this.f.prepareDocumentPaste(q,x,ce,J),J.isCancellationRequested)return;const Ne=Array.from(ce).filter(([,je])=>!(je instanceof L.$bL));return P.DataTransfer.from(Ne)}async providePasteEdits(F,V,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(V),ce=G.map(Qe=>P.Range.to(Qe)),Ne=P.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(x,ce,Ne,q);if(je)return{label:je.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:T.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class z{constructor(F,V){this.d=F,this.e=V}async provideDocumentFormattingEdits(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentFormattingEdits(J,V,G);if(Array.isArray(q))return q.map(P.TextEdit.from)}}class ie{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeFormattingEdits(F,V,G,J){const q=this.d.getDocument(F),x=P.Range.to(V),ce=await this.e.provideDocumentRangeFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,V,G,J){(0,k.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(F),x=V.map(P.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(q,x,G,J);if(Array.isArray(ce))return ce.map(P.TextEdit.from)}}class X{constructor(F,V){this.d=F,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,V,G,J,q){const x=this.d.getDocument(F),ce=P.Position.to(V),Ne=await this.e.provideOnTypeFormattingEdits(x,ce,G,J,q);if(Array.isArray(Ne))return Ne.map(P.TextEdit.from)}}class De{constructor(F,V){this.e=F,this.f=V,this.d=new l.$icc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,V){const G=await this.e.provideWorkspaceSymbols(F,V);if(!(0,R.$Lb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const ce=G[x];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}q.symbols.push({...P.WorkspaceSymbol.from(ce),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(F,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const G=this.d.get(...F.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,V);return J&&(0,M.$0m)(F,P.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class Pe{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,V,G){this.d=F,this.e=V,this.f=G}async provideRenameEdits(F,V,G,J){const q=this.d.getDocument(F),x=P.Position.to(V);try{const ce=await this.e.provideRenameEdits(q,x,G,J);return ce?P.WorkspaceEdit.from(ce):void 0}catch(ce){const Ne=Pe.g(ce);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(F),q=P.Position.to(V);try{const x=await this.e.prepareRename(J,q,G);let ce,Ne;if(L.$pK.isRange(x)?(ce=x,Ne=J.getText(x)):(0,k.$Af)(x)&&(ce=x.range,Ne=x.placeholder),!ce||!Ne)return;if(ce.start.line>q.line||ce.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(ce),text:Ne}}catch(x){const ce=Pe.g(x);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class ke{constructor(F,V){this.resultId=F,this.tokens=V}}class $e{constructor(F,V){this.f=F,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,V,G){const J=this.f.getDocument(F),q=V!==0?this.d.get(V):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(V),x?(x=$e.h(x),this.o($e.n(q,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return $e.j(F)?$e.k(F)?F:new L.$EL(new Uint32Array(F.data),F.resultId):$e.l(F)?$e.m(F)?F:new L.$GL(F.edits.map(V=>new L.$FL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const V of F.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(F,V){if(!$e.j(V)||!F||!F.tokens)return V;const G=F.tokens,J=G.length,q=V.data,x=q.length;let ce=0;const Ne=Math.min(J,x);for(;ce<Ne&&G[ce]===q[ce];)ce++;if(ce===J&&ce===x)return new L.$GL([],V.resultId);let je=0;const Qe=Ne-ce;for(;je<Qe&&G[J-je-1]===q[x-je-1];)je++;return new L.$GL([{start:ce,deleteCount:J-ce-je,data:q.subarray(ce,x-je)}],V.resultId)}o(F,V){if($e.j(F)){const G=this.e++;return this.d.set(G,new ke(F.resultId,F.data)),(0,t.$20)({id:G,type:"full",data:F.data})}if($e.l(F)){const G=this.e++;return $e.j(V)?this.d.set(G,new ke(V.resultId,V.data)):this.d.set(G,new ke(F.resultId)),(0,t.$20)({id:G,type:"delta",deltas:(F.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class ye{constructor(F,V){this.d=F,this.e=V}async provideDocumentRangeSemanticTokens(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideDocumentRangeSemanticTokens(J,P.Range.to(V),G);return q?this.f(q):null}f(F){return(0,t.$20)({id:0,type:"full",data:F.data})}}class ue{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,V,G,J,q){this.f=F,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new l.$icc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,V,G,J){const q=this.f.getDocument(F),x=P.Position.to(V),ce=q.getWordRangeAtPosition(x)||new L.$pK(x,x),Ne=ce.with({end:x}),je=new p.$Jd,Qe=await this.h.provideCompletionItems(q,x,J,P.CompletionContext.to(G));if(!Qe||J.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new L.$UK(Qe):Qe,_e=ue.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ze=new d.$Rc;this.e.set(_e,Ze);const xe=[],it={x:_e,b:xe,a:{replace:P.Range.from(ce),insert:P.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],ut=this.l(ze,[_e,tt],Ne,ce);xe.push(ut)}return it}async resolveCompletionItem(F,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...F);if(!G)return;const J=this.l(G,F),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const x=this.l(q,F);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,M.$$m)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V,G,J){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,q),ce={x:V,a:F.label,b:F.kind!==void 0?P.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(P.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:P.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(P.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=F.textEdit.newText):typeof F.insertText=="string"?ce.h=F.insertText:F.insertText instanceof L.$yK&&(ce.h=F.insertText.value,ce.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),L.$pK.isRange(Ne)?ce.j=P.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ce.j={insert:P.Range.from(Ne.inserting),replace:P.Range.from(Ne.replacing)}),ce}}class ae{async provideInlineCompletions(F,V,G,J){}disposeCompletions(F){}handleDidShowCompletionItem(F,V,G){}handlePartialAccept(F,V,G){}}class we extends ae{constructor(F,V,G,J){super(),this.f=F,this.g=V,this.h=G,this.j=J,this.d=new _,this.e=(0,n.$gF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$gF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,V,G,J){const q=this.g.getDocument(F),x=P.Position.to(V),ce=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:P.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ce||J.isCancellationRequested)return;const Ne=Array.isArray(ce)?ce:ce.items,je=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((Ze,xe)=>{let it;Ze.command&&(Ge||(Ge=new d.$Rc),it=this.j.toInternal(Ze.command,Ge));const tt=Ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ze.filterText,range:Ze.range?P.Range.from(Ze.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ze.completeBracketPairs:!1}}),commands:je.map(Ze=>(Ge||(Ge=new d.$Rc),this.j.toInternal(Ze,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,V,G){const J=this.d.get(F)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(F,V,G){const J=this.d.get(F)?.items[V];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const V=this.e++;return this.d.set(V,F),V}disposeReferenceId(F){const V=this.d.get(F);return this.d.delete(F),V}get(F){return this.d.get(F)}}class W{constructor(F,V){this.e=F,this.f=V,this.d=new l.$icc("SignatureHelp")}async provideSignatureHelp(F,V,G,J){const q=this.e.getDocument(F),x=P.Position.to(V),ce=this.g(G),Ne=await this.f.provideSignatureHelp(q,x,J,ce);if(Ne){const je=this.d.add([Ne]);return{...P.SignatureHelp.from(Ne),id:je}}}g(F){let V;if(F.activeSignatureHelp){const G=P.SignatureHelp.to(F.activeSignatureHelp),J=this.d.get(F.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...F,activeSignatureHelp:V}}releaseSignatureHelp(F){this.d.delete(F)}}class Z{constructor(F,V,G,J,q){this.f=F,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new l.$icc("InlayHints"),this.e=new Map}async provideInlayHints(F,V,G){const J=this.f.getDocument(F),q=P.Range.to(V),x=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(G.isCancellationRequested)return;const ce=this.d.add(x);this.e.set(ce,new d.$Rc);const Ne={hints:[],cacheId:ce};for(let je=0;je<x.length;je++)this.l(x[je],q)&&Ne.hints.push(this.m(x[je],[ce,je]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),Ne}async resolveInlayHint(F,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.h.resolveInlayHint(G,V);if(J&&this.l(J))return this.m(J,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,V){return F.label.length===0||Array.isArray(F.label)&&F.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(V&&!V.contains(F.position))}m(F,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:P.MarkdownString.fromStrict(F.tooltip),position:P.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(P.TextEdit.from),kind:F.kind&&P.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?J.label=F.label:J.label=F.label.map(q=>{const x={label:q.value};return x.tooltip=P.MarkdownString.fromStrict(q.tooltip),L.$zK.isLocation(q.location)&&(x.location=P.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,G)),x}),J}}class ee{constructor(F,V){this.e=F,this.f=V,this.d=new l.$icc("DocumentLink")}async provideLinks(F,V){const G=this.e.getDocument(F),J=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ee.g).map(P.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let ce=0;ce<J.length;ce++){if(!ee.g(J[ce]))continue;const Ne=P.DocumentLink.from(J[ce]);Ne.cacheId=[q,ce],x.links.push(Ne)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...F);if(!G)return;const J=await this.f.resolveDocumentLink(G,V);if(!(!J||!ee.g(J)))return P.DocumentLink.from(J)}releaseLinks(F){this.d.delete(F)}}class pe{constructor(F,V){this.d=F,this.e=V}async provideColors(F,V){const G=this.d.getDocument(F),J=await this.e.provideDocumentColors(G,V);return Array.isArray(J)?J.map(x=>({color:P.Color.from(x.color),range:P.Range.from(x.range)})):[]}async provideColorPresentations(F,V,G){const J=this.d.getDocument(F),q=P.Range.to(V.range),x=P.Color.to(V.color),ce=await this.e.provideColorPresentations(x,{document:J,range:q},G);if(Array.isArray(ce))return ce.map(P.ColorPresentation.from)}}class me{constructor(F,V){this.d=F,this.e=V}async provideFoldingRanges(F,V,G){const J=this.d.getDocument(F),q=await this.e.provideFoldingRanges(J,V,G);if(Array.isArray(q))return q.map(P.FoldingRange.from)}}class he{constructor(F,V,G){this.d=F,this.e=V,this.f=G}async provideSelectionRanges(F,V,G){const J=this.d.getDocument(F),q=V.map(P.Position.to),x=await this.e.provideSelectionRanges(J,q,G);if(!(0,R.$Lb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ne=0;Ne<q.length;Ne++){const je=[];ce.push(je);let Qe=q[Ne],Ge=x[Ne];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(P.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ce}}class Ee{constructor(F,V){this.f=F,this.g=V,this.d=new i.$rM(""),this.e=new Map}async prepareSession(F,V,G){const J=this.f.getDocument(F),q=P.Position.to(V),x=await this.g.prepareCallHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideCallsTo(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(ce=>P.Range.from(ce))}))}async provideCallsFrom(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(ce=>P.Range.from(ce))}))}releaseSession(F){this.e.delete(F)}h(F,V){const G=this.e.get(F),J=P.CallHierarchyItem.from(V,F,G.size.toString(36));return G.set(J._itemId,V),J}j(F,V){return this.e.get(F)?.get(V)}}class re{constructor(F,V){this.f=F,this.g=V,this.d=new i.$rM(""),this.e=new Map}async prepareSession(F,V,G){const J=this.f.getDocument(F),q=P.Position.to(V),x=await this.g.prepareTypeHierarchy(J,q,G);if(!x)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(x)?x.map(Ne=>this.h(ce,Ne)):[this.h(ce,x)]}async provideSupertypes(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(x=>this.h(F,x))}async provideSubtypes(F,V,G){const J=this.j(F,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,V){const G=this.e.get(F),J=P.TypeHierarchyItem.from(V,F,G.size.toString(36));return G.set(J._itemId,V),J}j(F,V){return this.e.get(F)?.get(V)}}class le{static toInternalProviderId(F,V){return F+"."+V}constructor(F,V,G,J,q){this.d=F,this.e=V,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(F,V,G,J,q){const x=this.e.getDocument(V),ce=P.Position.to(G),Ne=P.DataTransfer.toDataTransfer(J,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),je=await this.f.provideDocumentDropEdits(x,ce,Ne,q);if(je)return{label:je.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?P.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class ne{constructor(F,V){this.d=F,this.e=V}async provideMappedEdits(F,V,G,J){const q=w.URI.revive(F),x=this.d.getDocument(q),ce=G.documents.map(Qe=>Qe.map(Ge=>({uri:w.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>P.Range.to(_e))}))),Ne={documents:ce,selections:ce[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(x,V,Ne,J);return je?P.WorkspaceEdit.from(je):null}}class oe{constructor(F,V){this.adapter=F,this.extension=V}}class fe{static{this.d=0}constructor(F,V,G,J,q,x,ce,Ne){this.g=V,this.h=G,this.j=J,this.k=q,this.l=x,this.m=ce,this.n=Ne,this.f=new Map,this.e=F.getProxy(u.$lK.MainThreadLanguageFeatures)}o(F,V){return P.DocumentSelector.from(F,this.g,V)}p(F){return new L.$nK(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return fe.d++}async s(F,V,G,J,q,x=!1){const ce=this.f.get(F);if(!ce||!(ce.adapter instanceof V))return J;const Ne=Date.now();x||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(ce.adapter,ce.extension);return Promise.resolve(je).catch(Qe=>{(0,E.$4)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),v.CancellationToken.isCancellationToken(q)?(0,m.$Jg)(je,q):je}t(F,V){const G=this.q();return this.f.set(G,new oe(F,V)),G}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,V,G,J){const q=this.t(new s(this.h,G),F),x=J&&J.label||fe.u(F);return this.e.$registerDocumentSymbolProvider(q,this.o(V,F),x),this.p(q)}$provideDocumentSymbols(F,V,G){return this.s(F,s,J=>J.provideDocumentSymbols(w.URI.revive(V),G),void 0,G)}registerCodeLensProvider(F,V,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new oe(new o(this.h,this.j.converter,G),F)),this.e.$registerCodeLensSupport(J,this.o(V,F),q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));x=L.$nK.from(x,ce)}return x}$provideCodeLenses(F,V,G){return this.s(F,o,J=>J.provideCodeLenses(w.URI.revive(V),G),void 0,G)}$resolveCodeLens(F,V,G){return this.s(F,o,J=>J.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(F,V){this.s(F,o,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(F,V,G){const J=this.t(new h(this.h,G),F);return this.e.$registerDefinitionSupport(J,this.o(V,F)),this.p(J)}$provideDefinition(F,V,G,J){return this.s(F,h,q=>q.provideDefinition(w.URI.revive(V),G,J),[],J)}registerDeclarationProvider(F,V,G){const J=this.t(new C(this.h,G),F);return this.e.$registerDeclarationSupport(J,this.o(V,F)),this.p(J)}$provideDeclaration(F,V,G,J){return this.s(F,C,q=>q.provideDeclaration(w.URI.revive(V),G,J),[],J)}registerImplementationProvider(F,V,G){const J=this.t(new I(this.h,G),F);return this.e.$registerImplementationSupport(J,this.o(V,F)),this.p(J)}$provideImplementation(F,V,G,J){return this.s(F,I,q=>q.provideImplementation(w.URI.revive(V),G,J),[],J)}registerTypeDefinitionProvider(F,V,G){const J=this.t(new c(this.h,G),F);return this.e.$registerTypeDefinitionSupport(J,this.o(V,F)),this.p(J)}$provideTypeDefinition(F,V,G,J){return this.s(F,c,q=>q.provideTypeDefinition(w.URI.revive(V),G,J),[],J)}registerHoverProvider(F,V,G,J){const q=this.t(new y(this.h,G),F);return this.e.$registerHoverProvider(q,this.o(V,F)),this.p(q)}$provideHover(F,V,G,J){return this.s(F,y,q=>q.provideHover(w.URI.revive(V),G,J),void 0,J)}registerEvaluatableExpressionProvider(F,V,G,J){const q=this.t(new b(this.h,G),F);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,F)),this.p(q)}$provideEvaluatableExpression(F,V,G,J){return this.s(F,b,q=>q.provideEvaluatableExpression(w.URI.revive(V),G,J),void 0,J)}registerInlineValuesProvider(F,V,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new S(this.h,G),F);this.e.$registerInlineValuesProvider(x,this.o(V,F),q);let ce=this.p(x);if(q!==void 0){const Ne=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(q));ce=L.$nK.from(ce,Ne)}return ce}$provideInlineValues(F,V,G,J,q){return this.s(F,S,x=>x.provideInlineValues(w.URI.revive(V),G,J,q),void 0,q)}registerDocumentHighlightProvider(F,V,G){const J=this.t(new j(this.h,G),F);return this.e.$registerDocumentHighlightProvider(J,this.o(V,F)),this.p(J)}$provideDocumentHighlights(F,V,G,J){return this.s(F,j,q=>q.provideDocumentHighlights(w.URI.revive(V),G,J),void 0,J)}registerLinkedEditingRangeProvider(F,V,G){const J=this.t(new O(this.h,G),F);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,F)),this.p(J)}$provideLinkedEditingRanges(F,V,G,J){return this.s(F,O,async q=>{const x=await q.provideLinkedEditingRanges(w.URI.revive(V),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(F,V,G){const J=this.t(new K(this.h,G),F);return this.e.$registerReferenceSupport(J,this.o(V,F)),this.p(J)}$provideReferences(F,V,G,J,q){return this.s(F,K,x=>x.provideReferences(w.URI.revive(V),G,J,q),void 0,q)}registerCodeActionProvider(F,V,G,J){const q=new d.$Rc,x=this.t(new B(this.h,this.j.converter,this.k,G,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(V,F),{providedKinds:J?.providedCodeActionKinds?.map(ce=>ce.value),documentation:J?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,q)}))},fe.u(F),!!G.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(F,V,G,J,q){return this.s(F,B,x=>x.provideCodeActions(w.URI.revive(V),G,J,q),void 0,q)}$resolveCodeAction(F,V,G){return this.s(F,B,J=>J.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(F,V){this.s(F,B,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(F,V,G){const J=this.t(new z(this.h,G),F);return this.e.$registerDocumentFormattingSupport(J,this.o(V,F),F.identifier,F.displayName||F.name),this.p(J)}$provideDocumentFormattingEdits(F,V,G,J){return this.s(F,z,q=>q.provideDocumentFormattingEdits(w.URI.revive(V),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(F,V,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new ie(this.h,G),F);return this.e.$registerRangeFormattingSupport(q,this.o(V,F),F.identifier,F.displayName||F.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(F,V,G,J,q){return this.s(F,ie,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(V),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(F,V,G,J,q){return this.s(F,ie,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(V),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(F,V,G,J){const q=this.t(new X(this.h,G),F);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,F),J,F.identifier),this.p(q)}$provideOnTypeFormattingEdits(F,V,G,J,q,x){return this.s(F,X,ce=>ce.provideOnTypeFormattingEdits(w.URI.revive(V),G,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(F,V){const G=this.t(new De(V,this.l),F);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(F,V,G){return this.s(F,De,J=>J.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(F,V,G){return this.s(F,De,J=>J.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(F,V){this.s(F,De,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(F,V,G){const J=this.t(new Pe(this.h,G,this.l),F);return this.e.$registerRenameSupport(J,this.o(V,F),Pe.supportsResolving(G)),this.p(J)}$provideRenameEdits(F,V,G,J,q){return this.s(F,Pe,x=>x.provideRenameEdits(w.URI.revive(V),G,J,q),void 0,q)}$resolveRenameLocation(F,V,G,J){return this.s(F,Pe,q=>q.resolveRenameLocation(w.URI.revive(V),G,J),void 0,J)}registerDocumentSemanticTokensProvider(F,V,G,J){const q=this.t(new $e(this.h,G),F),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,F),J,x);let ce=this.p(q);if(x){const Ne=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));ce=L.$nK.from(ce,Ne)}return ce}$provideDocumentSemanticTokens(F,V,G,J){return this.s(F,$e,q=>q.provideDocumentSemanticTokens(w.URI.revive(V),G,J),null,J)}$releaseDocumentSemanticTokens(F,V){this.s(F,$e,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,V,G,J){const q=this.t(new ye(this.h,G),F);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,F),J),this.p(q)}$provideDocumentRangeSemanticTokens(F,V,G,J){return this.s(F,ye,q=>q.provideDocumentRangeSemanticTokens(w.URI.revive(V),G,J),null,J)}registerCompletionItemProvider(F,V,G,J){const q=this.t(new ue(this.h,this.j.converter,G,this.m,F),F);return this.e.$registerCompletionsProvider(q,this.o(V,F),J,ue.supportsResolving(G),F.identifier),this.p(q)}$provideCompletionItems(F,V,G,J,q){return this.s(F,ue,x=>x.provideCompletionItems(w.URI.revive(V),G,J,q),void 0,q)}$resolveCompletionItem(F,V,G){return this.s(F,ue,J=>J.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(F,V){this.s(F,ue,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(F,V,G,J){const q=new we(F,this.h,G,this.j.converter),x=this.t(q,F);return this.e.$registerInlineCompletionsSupport(x,this.o(V,F),q.supportsHandleEvents,$.$6l.toKey(F.identifier.value),J?.yieldTo?.map(ce=>$.$6l.toKey(ce))||[]),this.p(x)}$provideInlineCompletions(F,V,G,J,q){return this.s(F,ae,x=>x.provideInlineCompletions(w.URI.revive(V),G,J,q),void 0,q)}$handleInlineCompletionDidShow(F,V,G,J){this.s(F,ae,async q=>{q.handleDidShowCompletionItem(V,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,V,G,J){this.s(F,ae,async q=>{q.handlePartialAccept(V,G,J)},void 0,void 0)}$freeInlineCompletionsList(F,V){this.s(F,ae,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(F,V,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new W(this.h,G),F);return this.e.$registerSignatureHelpProvider(x,this.o(V,F),q),this.p(x)}$provideSignatureHelp(F,V,G,J,q){return this.s(F,W,x=>x.provideSignatureHelp(w.URI.revive(V),G,J,q),void 0,q)}$releaseSignatureHelp(F,V){this.s(F,W,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(F,V,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new Z(this.h,this.j.converter,G,this.l,F),F);this.e.$registerInlayHintsProvider(q,this.o(V,F),typeof G.resolveInlayHint=="function",J,fe.u(F));let x=this.p(q);if(J!==void 0){const ce=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));x=L.$nK.from(x,ce)}return x}$provideInlayHints(F,V,G,J){return this.s(F,Z,q=>q.provideInlayHints(w.URI.revive(V),G,J),void 0,J)}$resolveInlayHint(F,V,G){return this.s(F,Z,J=>J.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(F,V){this.s(F,Z,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(F,V,G){const J=this.t(new ee(this.h,G),F);return this.e.$registerDocumentLinkProvider(J,this.o(V,F),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(F,V,G){return this.s(F,ee,J=>J.provideLinks(w.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(F,V,G){return this.s(F,ee,J=>J.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(F,V){this.s(F,ee,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(F,V,G){const J=this.t(new pe(this.h,G),F);return this.e.$registerDocumentColorProvider(J,this.o(V,F)),this.p(J)}$provideDocumentColors(F,V,G){return this.s(F,pe,J=>J.provideColors(w.URI.revive(V),G),[],G)}$provideColorPresentations(F,V,G,J){return this.s(F,pe,q=>q.provideColorPresentations(w.URI.revive(V),G,J),void 0,J)}registerFoldingRangeProvider(F,V,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new oe(new me(this.h,G),F)),this.e.$registerFoldingRangeProvider(J,this.o(V,F),F.identifier,q);let x=this.p(J);if(q!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=L.$nK.from(x,ce)}return x}$provideFoldingRanges(F,V,G,J){return this.s(F,me,q=>q.provideFoldingRanges(w.URI.revive(V),G,J),void 0,J)}registerSelectionRangeProvider(F,V,G){const J=this.t(new he(this.h,G,this.l),F);return this.e.$registerSelectionRangeProvider(J,this.o(V,F)),this.p(J)}$provideSelectionRanges(F,V,G,J){return this.s(F,he,q=>q.provideSelectionRanges(w.URI.revive(V),G,J),[],J)}registerCallHierarchyProvider(F,V,G){const J=this.t(new Ee(this.h,G),F);return this.e.$registerCallHierarchyProvider(J,this.o(V,F)),this.p(J)}$prepareCallHierarchy(F,V,G,J){return this.s(F,Ee,q=>Promise.resolve(q.prepareSession(w.URI.revive(V),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(F,V,G,J){return this.s(F,Ee,q=>q.provideCallsTo(V,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(F,V,G,J){return this.s(F,Ee,q=>q.provideCallsFrom(V,G,J),void 0,J)}$releaseCallHierarchy(F,V){this.s(F,Ee,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(F,V,G){const J=this.t(new re(this.h,G),F);return this.e.$registerTypeHierarchyProvider(J,this.o(V,F)),this.p(J)}$prepareTypeHierarchy(F,V,G,J){return this.s(F,re,q=>Promise.resolve(q.prepareSession(w.URI.revive(V),G,J)),void 0,J)}$provideTypeHierarchySupertypes(F,V,G,J){return this.s(F,re,q=>q.provideSupertypes(V,G,J),void 0,J)}$provideTypeHierarchySubtypes(F,V,G,J){return this.s(F,re,q=>q.provideSubtypes(V,G,J),void 0,J)}$releaseTypeHierarchy(F,V){this.s(F,re,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(F,V,G,J){const q=this.q();this.f.set(q,new oe(new le(this.e,this.h,G,q,F),F));const x=(0,n.$gF)(F,"dropMetadata")&&J?le.toInternalProviderId(F.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,F),x,(0,n.$gF)(F,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(F,V,G,J,q,x){return this.s(F,le,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(V,w.URI.revive(G),J,q,x)),void 0,void 0)}registerMappedEditsProvider(F,V,G){const J=this.t(new ne(this.h,G),F);return this.e.$registerMappedEditsProvider(J,this.o(V,F)),this.p(J)}$provideMappedEdits(F,V,G,J,q){return this.s(F,ne,x=>Promise.resolve(x.provideMappedEdits(V,G,J,q)),null,q)}registerDocumentPasteEditProvider(F,V,G,J){const q=this.q();this.f.set(q,new oe(new T(this.e,this.h,G,q,F),F));const x=T.toInternalProviderId(F.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(V,F),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(F,V,G,J,q){return this.s(F,T,x=>x.prepareDocumentPaste(w.URI.revive(V),G,J,q),void 0,q)}$providePasteEdits(F,V,G,J,q,x){return this.s(F,T,ce=>ce.providePasteEdits(V,w.URI.revive(G),J,q,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:fe.w(F.decreaseIndentPattern),increaseIndentPattern:fe.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?fe.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?fe.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:fe.w(F.beforeText),afterText:F.afterText?fe.w(F.afterText):void 0,previousLineText:F.previousLineText?fe.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(fe.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(V=>L.SyntaxTokenType.toString(V)):void 0}}static D(F){return F.map(fe.C)}setLanguageConfiguration(F,V,G){const{wordPattern:J}=G;if(J&&(0,D.$Oe)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const q=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.w(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?fe.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,x),this.p(q)}$setWordDefinitions(F){for(const V of F)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$rcc=fe}),define(Ae[243],Re([1,0,3,8,7,29,12,6,22]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0;class f{constructor(k,a,v,$){this.c=a,this.d=v,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(w.$lK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,a){await this.a.$changeLanguage(k,a);const v=this.c.getDocumentData(k);if(!v)throw new Error(`document '${k.toString()}' NOT found`);return v.document}async tokenAtPosition(k,a){const v=k.version,$=M.Position.from(a),d=await this.a.$tokensAtPosition(k.uri,$),t={type:P.StandardTokenType.Other,range:k.getWordRangeAtPosition(a)??new P.$pK(a.line,a.character,a.line,a.character)};if(!d)return t;const i={range:M.Range.to(d.range),type:M.TokenType.to(d.type)};return!i.range.contains(a)||v!==k.version?t:i}createLanguageStatusItem(k,a,v){const $=this.f++,d=this.a,t=this.g,i=`${k.identifier.value}/${a}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);t.add(i);const l={selector:v,id:a,name:k.displayName??k.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const E=new u.$Rc,m=()=>{if(p?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${a}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}p=(0,A.$Vg)(()=>{E.clear(),this.a.$setLanguageStatus($,{id:i,name:l.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===P.LanguageStatusSeverity.Error?L.default.Error:l.severity===P.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},n={dispose(){E.dispose(),p?.dispose(),d.$removeLanguageStatus($),t.delete(i)},get id(){return l.id},get name(){return l.name},set name(r){l.name=r,m()},get selector(){return l.selector},set selector(r){l.selector=r,m()},get text(){return l.text},set text(r){l.text=r,m()},set text2(r){(0,D.$hF)(k,"languageStatusText"),l.text=r,m()},get text2(){return(0,D.$hF)(k,"languageStatusText"),l.text},get detail(){return l.detail},set detail(r){l.detail=r,m()},get severity(){return l.severity},set severity(r){l.severity=r,m()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(r){l.accessibilityInformation=r,m()},get command(){return l.command},set command(r){l.command=r,m()},get busy(){return l.busy},set busy(r){l.busy=r,m()}};return m(),n}}e.$_cc=f}),define(Ae[81],Re([1,0,23,16,2,4,14,3,27,17]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=void 0;let R=class{constructor(a,v,$){this.f=$,this.d=new Map,this.a=v.getProxy(u.$lK.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===w.$g}getMessage(a,v){const{message:$,args:d,comment:t}=v;if(this.c)return(0,M.$De)($,d??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const l=this.d.get(a)?.contents[i];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$De)(l??$,d??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let v;const $=await this.g(a);if(!$){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents($),t=JSON.parse(d);v=a.isBuiltin?t.contents?.bundle:t}catch(d){this.f.error(`Failed to load translations for ${a.identifier.value} from ${$}: ${d.message}`);return}v&&this.d.set(a.identifier.value,{contents:v,uri:$})}async g(a){if(a.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return P.URI.revive(v)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$1cc=R,e.$1cc=R=qe([Ke(0,D.$CM),Ke(1,f.$mM),Ke(2,A.$0i)],R),e.$2cc=(0,L.$Ph)("IExtHostLocalizationService")}),define(Ae[244],Re([1,0,14,3,27,17,2,68]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let D=class extends w.$ij{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(v=>(0,u.$mh)(v))),this.r=k.getProxy(M.$lK.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(A.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,v){return new f(this.r,k,a,v)}};e.$rec=D,e.$rec=D=qe([Ke(0,L.$mM),Ke(1,P.$CM)],D);class f extends w.$dj{constructor(k,a,v,$){super($?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(a,$).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const v=[[k,a]];this.m?this.u(v):this.n.push(...v)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,26]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=e.$3cc=void 0,e.$3cc=(0,M.$Ph)("IExtHostManagedSockets");let u=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(w.$lK.MainThreadManagedSockets)}setFactory(k,a){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,v=await this.c.makeConnection(),$=new P.$Rc;return this.d.set(a,new f(a,v,$)),$.add((0,P.$Qc)(()=>this.d.delete(a))),$.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),$.dispose()})),$.add(v.onDidClose(d=>{this.a.$onDidManagedSocketClose(a,d?.stack??d?.message),$.dispose()})),$.add(v.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(a,A.$be.wrap(d)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$4cc=u,e.$4cc=u=qe([Ke(0,L.$mM)],u);class D{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class f extends P.$Sc{constructor(k,a,v){super(),this.socketId=k,this.actual=a,this.B(v)}}}),define(Ae[245],Re([1,0,3,14,22]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=void 0;function L(u){return u&&u.title}let A=class{constructor(D,f){this.b=f,this.a=D.getProxy(w.$lK.MainThreadMessageService)}showMessage(D,f,R,k,a){const v={source:{identifier:D.identifier,label:D.displayName||D.name}};let $;typeof k=="string"||L(k)?$=[k,...a]:(v.modal=k?.modal,v.useCustom=k?.useCustom,v.detail=k?.detail,$=a),v.useCustom&&(0,P.$hF)(D,"resolvers");const d=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")d.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:l,isCloseAffordance:p}=i;d.push({title:l,isCloseAffordance:!!p,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,R,v,d).then(t=>{if(typeof t=="number")return $[t]})}};e.$adc=A,e.$adc=A=qe([Ke(1,M.$0i)],A)}),define(Ae[246],Re([1,0,152,26,5,6,28,16,15,2,39,74,3,31,8,7,47,208,104,11,25,13]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,g,h,C){this.q=g,this.r=h,this.s=C,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new P.$Nd({onListenerError:p.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Nd({onListenerError:p.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Nd({onListenerError:p.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Nd({onListenerError:p.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$icc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(a.$lK.MainThreadNotebook),this.c=s.getProxy(a.$lK.MainThreadNotebookDocuments),this.d=s.getProxy(a.$lK.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===13){const c=I.notebookEditor?.notebookUri,y=I.cell.handle,S=this.g.get(c)?.getCell(y);if(S)return S.apiCell}if(I&&I.$mid===14){const c=I.uri,y=this.g.get(c);if(y)return y.apiNotebook}return I}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,g]of this.h)if(g.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const g=this.g.get(s);if(!g&&!o)throw new Error(`NO notebook document for '${s}'`);return g}static t(s,o){if(!o)return;const g=o.filenamePattern.map(h=>$.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(o.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:g,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,g){const h=n.a++,C=typeof g.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(h,g),this.b.$registerNotebookCellStatusBarItemProvider(h,C,o);let I;return C!==void 0&&(I=g.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(C))),new d.$nK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,C),I?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&$.NotebookData.from(s.content)});return f.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const g=await this.c.$tryOpenNotebook(s),h=this.g.get(f.URI.revive(g));return(0,D.$Jf)(h?.apiNotebook)}async showNotebookDocument(s,o){f.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let g;typeof o=="object"?g={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:g={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,g),C=h&&this.h.get(h)?.apiEditor;if(C)return C;throw h?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,g,h){const C=this.f.get(s),I=f.URI.revive(o),c=this.g.get(I);if(!c||!C)return;const y=c.getCellFromIndex(g);if(!y)return;const b=await C.provideCellStatusBarItems(y.apiCell,h);if(!b)return;const S=new L.$Rc,j=this.p.add([S]),K=(Array.isArray(b)?b:[b]).map(B=>$.NotebookStatusBarItem.from(B,this.i,S));return{cacheId:j,items:K}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,g,h,C){if((0,u.$Be)(o))throw new Error("viewType cannot be empty or just whitespace");const I=this.u++;return this.w.set(I,{viewType:o,serializer:g,options:h}),this.b.$registerNotebookSerializer(I,{id:s.identifier,location:s.extensionLocation},o,$.NotebookDocumentContentOptions.from(h),n.t(s,C)),(0,L.$Qc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(s,o,g){const h=this.w.get(s);if(!h)throw new Error("NO serializer found");const C=await h.serializer.deserializeNotebook(o.buffer,g);return new t.$qv($.NotebookData.from(C))}async $notebookToData(s,o,g){const h=this.w.get(s);if(!h)throw new Error("NO serializer found");const C=await h.serializer.serializeNotebook($.NotebookData.to(o.value),g);return M.$be.wrap(C)}async $saveNotebook(s,o,g,h,C){const I=f.URI.revive(o),c=this.w.get(s);if(!c)throw new Error("NO serializer found");const y=this.g.get(I);if(!y)throw new Error("Document NOT found");if(y.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new R.$tk((0,w.localize)(0,null,this.y(I)),6);await this.x(I,h);const b={metadata:(0,E.$cn)(y.apiNotebook.metadata,B=>!(c.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of y.apiNotebook.getCells()){const T=new d.$LL(B.kind,B.document.getText(),B.document.languageId,B.mime,c.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);T.metadata=(0,E.$cn)(B.metadata,z=>!(c.options?.transientCellMetadata??{})[z]),b.cells.push(T)}const S=await c.serializer.serializeNotebook(b,C);await this.s.value.writeFile(I,S);const j=this.s.getFileSystemProviderExtUri(I.scheme),O=await this.s.value.stat(I);return{name:j.basename(I),isFile:(O.type&R.FileType.File)!==0,isDirectory:(O.type&R.FileType.Directory)!==0,isSymbolicLink:(O.type&R.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((O.permissions??0)&R.FilePermission.Locked),etag:R.$Ek({mtime:O.mtime,size:O.size}),children:void 0}}async x(s,o){const g=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Dk&&typeof g.mtime=="number"&&typeof g.size=="number"&&o.mtime<g.mtime&&o.etag!==R.$Ek({mtime:o.mtime,size:g.size}))throw new R.$tk((0,w.localize)(1,null),3,o)}y(s){return s.scheme===m.Schemas.file?s.fsPath:s.toString()}z(s,o,g){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const h=new l.$Tdc(o,this.d,s,g.visibleRanges.map($.NotebookRange.to),g.selections.map($.NotebookRange.to),typeof g.viewColumn=="number"?$.ViewColumn.to(g.viewColumn):void 0);this.h.set(o,h)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const g of s.value.removedDocuments){const h=f.URI.revive(g),C=this.g.get(h);C&&(C.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:C.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(C.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===h.toString()&&this.h.delete(I.id)}if(s.value.addedDocuments){const g=[];for(const h of s.value.addedDocuments){const C=f.URI.revive(h.uri);if(this.g.has(C))throw new Error(`adding EXISTING notebook ${C} `);const I=new i.$Sdc(this.c,this.q,this.r,C,h);g.push(...h.cells.map(c=>i.$Rdc.asModelAddData(I.apiNotebook,c))),this.g.get(C)?.dispose(),this.g.set(C,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(I.apiNotebook)}}if(s.value.addedEditors)for(const g of s.value.addedEditors){if(this.h.has(g.id))return;const h=f.URI.revive(g.documentUri),C=this.g.get(h);C&&this.z(C,g.id,g)}const o=[];if(s.value.removedEditors)for(const g of s.value.removedEditors){const h=this.h.get(g);h&&(this.h.delete(g),this.k?.id===h.id&&(this.k=void 0),o.push(h))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const g=new Set;this.l.forEach(h=>g.add(h.id));for(const h of this.h.values()){const C=g.has(h.id);h._acceptVisibility(C)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=v.$KM.String.with("notebookType","A notebook type"),g=new v.$MM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new v.$KM("data","Bytes to convert to data",C=>C instanceof Uint8Array,C=>M.$be.wrap(C))],new v.$LM("Notebook Data",C=>$.NotebookData.to(C.value))),h=new v.$MM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new v.$KM("NotebookData","Notebook data to convert to bytes",C=>!0,C=>new t.$qv($.NotebookData.from(C)))],new v.$LM("Bytes",C=>C.buffer));s.registerApiCommand(g),s.registerApiCommand(h)}}e.$Udc=n}),define(Ae[247],Re([1,0,18,12,19,5,6,28,2,21,14,3,31,8,7,77,199,22,47]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=void 0;let p=class{constructor(h,C,I,c,y){this.l=C,this.m=I,this.n=c,this.o=y,this.b=new u.$Ac,this.c=new u.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(k.$lK.MainThreadNotebookKernels);const b=new a.$MM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$KM("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const j=this.m.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:j}}else if(S&&"notebookEditor"in S){const j=this.m.getIdByEditor(S.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return S})],a.$LM.Void);this.n.registerApiCommand(b)}createNotebookController(h,C,I,c,y,b){for(const ye of this.i.values())if(ye.controller.id===C&&f.$6l.equals(h.identifier,ye.extensionId))throw new Error(`notebook controller with id '${C}' ALREADY exist`);const S=this.j++,j=this;this.o.trace(`NotebookController[${S}], CREATED by ${h.identifier.value}, ${C}`);const O=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${h.identifier}'`);let K=!1;const B=new L.$Nd,T=new L.$Nd,z={id:o(h.identifier,C),notebookType:I,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:c||h.identifier.value,preloads:b?b.map(v.NotebookRendererScript.from):[]};let ie=y??O,X;this.a.$addKernel(S,z).catch(ye=>{console.log(ye),K=!0});let De=0;const Pe=()=>{if(K)return;const ye=++De;Promise.resolve().then(()=>{ye===De&&this.a.$updateKernel(S,z)})},ke=new u.$Ac,$e={get id(){return C},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return z.label},set label(ye){z.label=ye??h.displayName??h.name,Pe()},get detail(){return z.detail??""},set detail(ye){z.detail=ye,Pe()},get description(){return z.description??""},set description(ye){z.description=ye,Pe()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(ye){z.supportedLanguages=ye,Pe()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(ye){z.supportsExecutionOrder=ye,Pe()},get rendererScripts(){return z.preloads?z.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ye){ie=ye??O},get interruptHandler(){return X},set interruptHandler(ye){X=ye,z.supportsInterrupt=!!ye,Pe()},createNotebookCellExecution(ye){if(K)throw new Error("notebook controller is DISPOSED");if(!ke.has(ye.notebook.uri))throw j.o.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.notebook.uri.toString()}`);return j._createNotebookCellExecution(ye,o(h.identifier,this.id))},createNotebookExecution(ye){if((0,i.$hF)(h,"notebookExecution"),K)throw new Error("notebook controller is DISPOSED");if(!ke.has(ye.uri))throw j.o.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.uri.toString()}`);return j._createNotebookExecution(ye,o(h.identifier,this.id))},dispose:()=>{K||(this.o.trace(`NotebookController[${S}], DISPOSED`),K=!0,this.i.delete(S),B.dispose(),T.dispose(),this.a.$removeKernel(S))},updateNotebookAffinity(ye,ue){ue===$.NotebookControllerAffinity2.Hidden&&(0,i.$hF)(h,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(S,ye.uri,ue)},onDidReceiveMessage:T.event,postMessage(ye,ue){return(0,i.$hF)(h,"notebookMessaging"),j.a.$postMessage(S,ue&&j.m.getIdByEditor(ue),ye)},asWebviewUri(ye){return(0,i.$hF)(h,"notebookMessaging"),(0,d.$dpb)(ye,j.l.remote)}};return this.i.set(S,{extensionId:h.identifier,controller:$e,onDidReceiveMessage:T,onDidChangeSelection:B,associatedNotebooks:ke}),$e}getIdByController(h){for(const[C,I]of this.i)if(I.controller===h)return o(I.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,C){const I=this.f++,c=this;this.o.trace(`NotebookControllerDetectionTask[${I}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(I,C);const y={dispose:()=>{this.e.delete(I),c.a.$removeKernelDetectionTask(I)}};return this.e.set(I,y),y}registerKernelSourceActionProvider(h,C,I){const c=this.h++,y=typeof I.onDidChangeNotebookKernelSourceActions=="function"?c:void 0,b=this;this.g.set(c,I),this.o.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(c,c,C);let S;return y!==void 0&&(S=I.onDidChangeNotebookKernelSourceActions(j=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.g.delete(c),b.a.$removeKernelSourceActionProvider(c,c),S?.dispose()}}}async $provideKernelSourceActions(h,C){const I=this.g.get(h);if(I){const c=new A.$Rc;return(await I.provideNotebookKernelSourceActions(C)??[]).map(b=>v.NotebookKernelSourceAction.from(b,this.n.converter,c))}return[]}$acceptNotebookAssociation(h,C,I){const c=this.i.get(h);if(c){const y=this.m.getNotebookDocument(D.URI.revive(C));I?c.associatedNotebooks.set(y.uri,!0):c.associatedNotebooks.delete(y.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,y.uri.toString(),I),c.onDidChangeSelection.fire({selected:I,notebook:y.apiNotebook})}}async $executeCells(h,C,I){const c=this.i.get(h);if(!c)return;const y=this.m.getNotebookDocument(D.URI.revive(C)),b=[];for(const S of I){const j=y.getCell(S);j&&b.push(j.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,y.uri.toString(),b.length),await c.controller.executeHandler.call(c.controller,b,y.apiNotebook,c.controller)}catch(S){this.o.error(`NotebookController[${h}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(h,C,I){const c=this.i.get(h);if(!c)return;const y=this.m.getNotebookDocument(D.URI.revive(C));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,y.apiNotebook);else for(const b of I){const S=y.getCell(b);S&&this.b.get(S.uri)?.cancel()}if(c.controller.interruptHandler){const b=this.c.get(y.uri);I.length&&Array.isArray(b)&&b.length&&b.forEach(S=>S.dispose())}}$acceptKernelMessageFromRenderer(h,C,I){const c=this.i.get(h);if(!c)return;const y=this.m.getEditorById(C);c.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:I}))}$cellExecutionChanged(h,C,I){const y=this.m.getNotebookDocument(D.URI.revive(h)).getCell(C);if(y){const b=I?v.NotebookCellExecutionState.to(I):$.NotebookCellExecutionState.Idle;b!==void 0&&this.k.fire({cell:y.apiCell,state:b})}}_createNotebookCellExecution(h,C){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!c)throw new Error("invalid cell");if(this.b.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const y=new m(C,c,this.a);this.b.set(c.uri,y);const b=y.onDidChangeState(()=>{y.state===E.Resolved&&(y.dispose(),b.dispose(),this.b.delete(c.uri))});return y.asApiObject()}_createNotebookExecution(h,C){const I=this.m.getNotebookDocument(h.uri),c=h.getCells().find(S=>{const j=I.getCellFromApiCell(S);return j&&this.b.has(j.uri)});if(c)throw new Error(`duplicate cell execution for ${c.document.uri}`);if(this.c.has(I.uri))throw new Error(`duplicate notebook execution for ${I.uri}`);const y=new r(C,I,this.a),b=y.onDidChangeState(()=>{y.state===n.Resolved&&(y.dispose(),b.dispose(),this.c.delete(I.uri))});return this.c.set(I.uri,[y,b]),y.asApiObject()}};e.$9dc=p,e.$9dc=p=qe([Ke(4,R.$0i)],p);var E;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(E||(E={}));class m extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(h,C,I){super(),this.m=C,this.n=I,this.b=m.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new P.$Xd),this.h=new s(10,c=>this.s(c)),this.j=C.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const C=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new l.$qv(C))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let C=this.m;if(h&&(C=this.m.notebook.getCellFromApiCell(h)),!C)throw new Error("INVALID cell");return C.handle}y(h){return h.map(C=>{const I=$.$OL.ensureUniqueMimeTypes(C.items,!0);return I===C.items?v.NotebookCellOutput.from(C):v.NotebookCellOutput.from({items:I,id:C.id,metadata:C.metadata})})}async z(h,C,I){const c=this.w(C),y=this.y((0,w.$3b)(h));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:c,append:I,outputs:y})}async C(h,C,I){return h=$.$OL.ensureUniqueMimeTypes((0,w.$3b)(h),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:C.id,append:I})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(I){h.j=I,h.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(I){if(h.f===E.Resolved||h.f===E.Started)throw new Error("Cannot call start again");h.f=E.Started,h.c.fire(),h.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:I})},end(I,c){if(h.f===E.Resolved)throw new Error("Cannot call resolve twice");h.f=E.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new l.$qv({runEndTime:c,lastRunSuccess:I}))},clearOutput(I){return h.t(),h.z([],I,!1)},appendOutput(I,c){return h.t(),h.z(I,c,!0)},replaceOutput(I,c){return h.t(),h.z(I,c,!1)},appendOutputItems(I,c){return h.t(),h.C(I,c,!0)},replaceOutputItems(I,c){return h.t(),h.C(I,c,!1)}})}}var n;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(n||(n={}));class r extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(h,C,I){super(),this.h=C,this.j=I,this.b=r.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$Xd),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(h,C){this.e=h,this.f=C,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new M.$ch,this.b=Date.now(),(0,M.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const C=this.a;return this.a=[],this.f(C).finally(()=>h.complete())}}function o(g,h){return`${g.value}/${h}`}e.$0dc=o}),define(Ae[248],Re([1,0,5,3,104]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;class L{constructor(u,D){this.c=D,this.a=new Map,this.b=u.getProxy(M.$lK.MainThreadNotebookRenderers)}$postRendererMessage(u,D,f){const R=this.c.getEditorById(u);this.a.get(D)?.fire({editor:R.apiEditor,message:f})}createRendererMessaging(u,D){if(!u.contributes?.notebookRenderer?.some(R=>R.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(R,k,a)=>this.d(D).event(R,k,a),postMessage:(R,k)=>{P.$Tdc.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const a=k&&P.$Tdc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,D,R)}}}d(u){let D=this.a.get(u);return D||(D=new w.$Nd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(u)}}),this.a.set(u,D),D)}}e.$$dc=L}),define(Ae[249],Re([1,0,6,15,2,22,3]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class u{constructor(f){this.b=new Map,this.a=f.getProxy(A.$lK.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,R,k){if((0,L.$hF)(f,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,k),this.a.$registerProfileContentHandler(R,k.name,k.description,f.identifier.value),(0,w.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(f,R,k,a){const v=this.b.get(f);if(!v)throw new Error(`Unknown handler with id: ${f}`);return v.saveProfile(R,k,a)}async $readProfile(f,R,k){const a=this.b.get(f);if(!a)throw new Error(`Unknown handler with id: ${f}`);return a.readProfile((0,M.$yf)(R)?R:P.URI.revive(R),k)}}e.$cec=u}),define(Ae[250],Re([1,0,2,3,12,8]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class A{static{this.a=0}constructor(D,f){this.d=f,this.c=new Map,this.b=D.getProxy(M.$lK.MainThreadQuickDiff)}$provideOriginalResource(D,f,R){const k=w.URI.revive(f),a=this.c.get(D);return a?(0,P.$Mg)(()=>a.provideOriginalResource(k,R)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(D,f,R,k){const a=A.a++;return this.c.set(a,f),this.b.$registerQuickDiffProvider(a,L.DocumentSelector.from(D,this.d),R,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$dec=A}),define(Ae[251],Re([1,0,19,5,6,3,2,7,11,18,29,43,22,8]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;function $(d,t,i){const l=d.getProxy(L.$lK.MainThreadQuickOpen);class p{constructor(C,I){this.e=new Map,this.f=0,this.a=C,this.b=I}showQuickPick(C,I,c,y=w.CancellationToken.None){this.c=void 0;const b=Promise.resolve(I),S=++this.f,j=l.$show(S,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},y),O={},K=j.then(()=>O);return Promise.race([K,b]).then(B=>{if(B===O)return;const T=(0,a.$gF)(C,"quickPickItemTooltip");return b.then(z=>{const ie=[];for(let X=0;X<z.length;X++){const De=z[X];if(typeof De=="string")ie.push({label:De,handle:X});else if(De.kind===u.QuickPickItemKind.Separator)ie.push({type:"separator",label:De.label});else{De.tooltip&&!T&&console.warn(`Extension '${C.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${C.identifier.value}`);const Pe=De.iconPath?s(De.iconPath):void 0;ie.push({label:De.label,iconPath:Pe?.iconPath,iconClass:Pe?.iconClass,description:De.description,detail:De.detail,picked:De.picked,alwaysShow:De.alwaysShow,tooltip:T?v.MarkdownString.fromStrict(De.tooltip):void 0,handle:X})}}return c&&typeof c.onDidSelectItem=="function"&&(this.c=X=>{c.onDidSelectItem(z[X])}),l.$setItems(S,ie),j.then(X=>{if(typeof X=="number")return z[X];if(Array.isArray(X))return X.map(De=>z[De])})})}).then(void 0,B=>{if(!(0,D.$4)(B))return l.$setError(S,B),Promise.reject(B)})}$onItemSelected(C){this.c?.(C)}showInput(C,I=w.CancellationToken.None){return this.d=C?.validateInput,l.$input(C,typeof this.d=="function",I).then(void 0,c=>{if(!(0,D.$4)(c))return Promise.reject(c)})}async $validateInput(C){if(!this.d)return;const I=await this.d(C);if(!I||typeof I=="string")return I;let c;switch(I.severity){case u.InputBoxValidationSeverity.Info:c=R.default.Info;break;case u.InputBoxValidationSeverity.Warning:c=R.default.Warning;break;case u.InputBoxValidationSeverity.Error:c=R.default.Error;break;default:c=I.message?R.default.Error:R.default.Ignore;break}return{content:I.message,severity:c}}async showWorkspaceFolderPick(C,I=w.CancellationToken.None){const c=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[C]);if(!c)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(b=>b.uri.toString()===c.uri.toString())}createQuickPick(C){const I=new o(C,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(C){const I=new g(C,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(C,I){this.e.get(C)?._fireDidChangeValue(I)}$onDidAccept(C){this.e.get(C)?._fireDidAccept()}$onDidChangeActive(C,I){const c=this.e.get(C);c instanceof o&&c._fireDidChangeActive(I)}$onDidChangeSelection(C,I){const c=this.e.get(C);c instanceof o&&c._fireDidChangeSelection(I)}$onDidTriggerButton(C,I){this.e.get(C)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(C,I,c){const y=this.e.get(C);y instanceof o&&y._fireDidTriggerItemButton(I,c)}$onDidHide(C){this.e.get(C)?._fireDidHide()}}class E{static{this.a=1}constructor(C,I){this.x=C,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Nd,this.q=new M.$Nd,this.r=new M.$Nd,this.s=new M.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(C){this.b=C,this.z({title:C})}get step(){return this.c}set step(C){this.c=C,this.z({step:C})}get totalSteps(){return this.d}set totalSteps(C){this.d=C,this.z({totalSteps:C})}get enabled(){return this.g}set enabled(C){this.g=C,this.z({enabled:C})}get busy(){return this.j}set busy(C){this.j=C,this.z({busy:C})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(C){this.k=C,this.z({ignoreFocusOut:C})}get value(){return this.l}set value(C){this.l=C,this.z({value:C})}get placeholder(){return this.m}set placeholder(C){this.m=C,this.z({placeholder:C})}get buttons(){return this.n}set buttons(C){this.n=C.slice(),this.o.clear(),C.forEach((I,c)=>{const y=I===u.$HL.Back?-1:c;this.o.set(y,I)}),this.z({buttons:C.map((I,c)=>({...s(I.iconPath),tooltip:I.tooltip,handle:I===u.$HL.Back?-1:c}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(C){this.l=C,this.q.fire(C)}_fireDidTriggerButton(C){const I=this.o.get(C);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(C){if(!this.v){for(const I of Object.keys(C)){const c=C[I];this.u[I]=c===void 0?null:c}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function m(h){if(h instanceof u.$hL)return{id:h.id};const C=r(h),I=n(h);return{dark:typeof C=="string"?A.URI.file(C):C,light:typeof I=="string"?A.URI.file(I):I}}function n(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function s(h){const C=m(h);let I,c;return"id"in C?c=k.ThemeIcon.asClassName(C):I=C,{iconPath:I,iconClass:c}}class o extends E{constructor(C,I){super(C.identifier,I),this.O=C,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Nd,this.L=[],this.M=new M.$Nd,this.N=new M.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(C){this.B=C.slice(),this.C.clear(),this.D.clear(),C.forEach((y,b)=>{this.C.set(b,y),this.D.set(y,b)});const I=(0,a.$gF)(this.O,"quickPickItemTooltip"),c=[];for(let y=0;y<C.length;y++){const b=C[y];if(b.kind===u.QuickPickItemKind.Separator)c.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const S=b.iconPath?s(b.iconPath):void 0;c.push({handle:y,label:b.label,iconPath:S?.iconPath,iconClass:S?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((j,O)=>({...s(j.iconPath),tooltip:j.tooltip,handle:O}))})}}this.z({items:c})}get canSelectMany(){return this.E}set canSelectMany(C){this.E=C,this.z({canSelectMany:C})}get matchOnDescription(){return this.F}set matchOnDescription(C){this.F=C,this.z({matchOnDescription:C})}get matchOnDetail(){return this.G}set matchOnDetail(C){this.G=C,this.z({matchOnDetail:C})}get sortByLabel(){return this.H}set sortByLabel(C){this.H=C,this.z({sortByLabel:C})}get keepScrollPosition(){return this.I}set keepScrollPosition(C){this.I=C,this.z({keepScrollPosition:C})}get activeItems(){return this.J}set activeItems(C){this.J=C.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(C){this.L=C.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(C){const I=(0,f.$Hb)(C.map(c=>this.C.get(c)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(C){const I=(0,f.$Hb)(C.map(c=>this.C.get(c)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(C,I){const c=this.C.get(C);if(!c||!c.buttons||!c.buttons.length)return;const y=c.buttons[I];y&&this.N.fire({button:y,item:c})}}class g extends E{constructor(C,I){super(C.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(C){this.B=C,this.z({password:C})}get prompt(){return this.C}set prompt(C){this.C=C,this.z({prompt:C})}get valueSelection(){return this.D}set valueSelection(C){this.D=C,this.z({valueSelection:C})}get validationMessage(){return this.E}set validationMessage(C){this.E=C,C?typeof C=="string"?this.z({validationMessage:C,severity:R.default.Error}):this.z({validationMessage:C.message,severity:C.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new p(t,i)}e.$edc=$}),define(Ae[252],Re([1,0,2,5,65,6,12,3,18,131,14,21,43,8,22,13]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=void 0;function i(b){if(b)return typeof b.iconPath=="string"?w.URI.file(b.iconPath):w.URI.isUri(b.iconPath)||a.ThemeIcon.isThemeIcon(b.iconPath)?b.iconPath:void 0}function l(b){if(b?.icon){if(w.URI.isUri(b.icon))return b.icon;if(a.ThemeIcon.isThemeIcon(b.icon))return b.icon;{const S=b.icon;return{light:S.light,dark:S.dark}}}else return}function p(b){if(b.icon){if(w.URI.isUri(b.icon))return b.icon;if(a.ThemeIcon.isThemeIcon(b.icon))return b.icon;{const S=b.icon;return{light:S.light,dark:S.dark}}}else return}function E(b,S){if(!b.iconPath&&!S.iconPath)return 0;if(b.iconPath){if(!S.iconPath)return 1}else return-1;const j=typeof b.iconPath=="string"?b.iconPath:w.URI.isUri(b.iconPath)?b.iconPath.fsPath:b.iconPath.id,O=typeof S.iconPath=="string"?S.iconPath:w.URI.isUri(S.iconPath)?S.iconPath.fsPath:S.iconPath.id;return(0,f.$rq)(j,O)}function m(b,S){let j=0;if(b.strikeThrough!==S.strikeThrough)return b.strikeThrough?1:-1;if(b.faded!==S.faded)return b.faded?1:-1;if(b.tooltip!==S.tooltip)return(b.tooltip||"").localeCompare(S.tooltip||"");if(j=E(b,S),j!==0)return j;if(b.light&&S.light)j=E(b.light,S.light);else{if(b.light)return 1;if(S.light)return-1}if(j!==0)return j;if(b.dark&&S.dark)j=E(b.dark,S.dark);else{if(b.dark)return 1;if(S.dark)return-1}return j}function n(b,S){if(b.command!==S.command)return b.command<S.command?-1:1;if(b.title!==S.title)return b.title<S.title?-1:1;if(b.tooltip!==S.tooltip){if(b.tooltip!==void 0&&S.tooltip!==void 0)return b.tooltip<S.tooltip?-1:1;if(b.tooltip!==void 0)return 1;if(S.tooltip!==void 0)return-1}if(b.arguments===S.arguments)return 0;if(b.arguments)if(S.arguments){if(b.arguments.length!==S.arguments.length)return b.arguments.length-S.arguments.length}else return 1;else return-1;for(let j=0;j<b.arguments.length;j++){const O=b.arguments[j],K=S.arguments[j];if(O!==K)return O<K?-1:1}return 0}function r(b,S){let j=(0,f.$rq)(b.resourceUri.fsPath,S.resourceUri.fsPath,!0);if(j!==0)return j;if(b.command&&S.command)j=n(b.command,S.command);else{if(b.command)return 1;if(S.command)return-1}if(j!==0)return j;if(b.decorations&&S.decorations)j=m(b.decorations,S.decorations);else{if(b.decorations)return 1;if(S.decorations)return-1}return j}function s(b,S){for(let j=0;j<b.length;j++)if(b[j]!==S[j])return!1;return!0}function o(b,S){return b.command===S.command&&b.title===S.title&&b.tooltip===S.tooltip&&(b.arguments&&S.arguments?s(b.arguments,S.arguments):b.arguments===S.arguments)}function g(b,S){return(0,D.$ub)(b,S,o)}function h(b,S){return b===S?!0:!b||!S?!1:b.id===S.id&&b.label===S.label&&b.upstream?.id===S.upstream?.id&&b.upstream?.label===S.upstream?.label}class C{#e;#t;get value(){return this.d}set value(S){S=S??"",this.#e.$setInputBoxValue(this.o,S),this.q(S)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(S){this.#e.$setInputBoxPlaceholder(this.o,S),this.f=S}get validateInput(){return(0,$.$hF)(this.m,"scmValidation"),this.g}set validateInput(S){if((0,$.$hF)(this.m,"scmValidation"),S&&typeof S!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=S,this.#e.$setValidationProviderIsEnabled(this.o,!!S)}get enabled(){return this.h}set enabled(S){S=!!S,this.h!==S&&(this.h=S,this.#e.$setInputBoxEnablement(this.o,S))}get visible(){return this.j}set visible(S){S=!!S,this.j!==S&&(this.j=S,this.#e.$setInputBoxVisibility(this.o,S))}get actionButton(){return(0,$.$hF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(S){(0,$.$hF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Rc,this.k=S;const j=S!==void 0?{command:this.n.converter.toInternal(S.command,this.l.value),icon:l(S),enabled:S.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,j??null)}get document(){return(0,$.$hF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(S,j,O,K,B,T){this.m=S,this.n=j,this.o=B,this.p=T,this.d="",this.e=new M.$Nd,this.f="",this.h=!0,this.j=!0,this.l=new L.$Tc,this.#t=O,this.#e=K}showValidationMessage(S,j){(0,$.$hF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,S,j)}$onInputBoxValueChange(S){this.q(S)}q(S){this.d=S,this.e.fire(S)}}e.$fdc=C;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(S){this.v=S,this.q.$updateGroupLabel(this.t,this.handle,S)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(S){this.p=S,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(S){this.f=[...S],this.k.fire()}constructor(S,j,O,K,B){this.q=S,this.s=j,this.t=O,this.u=K,this.v=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(S){return this.g.get(S)}$executeResourceCommand(S,j){const O=this.h.get(S);return O?(0,A.$Mg)(()=>this.s.executeCommand(O.command,...O.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const S=[...this.f].sort(r),O=(0,D.$Db)(this.o,S,r).map(T=>{const z=T.toInsert.map(ie=>{const X=this.e++;this.g.set(X,ie);const De=ie.resourceUri;let Pe;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"){const ee=new L.$Rc;Pe=this.s.converter.toInternal(ie.command,ee),this.j.set(X,ee)}else this.h.set(X,ie.command);const ke=i(ie.decorations),$e=ie.decorations&&i(ie.decorations.light)||ke,ye=ie.decorations&&i(ie.decorations.dark)||ke,ue=[$e,ye],ae=ie.decorations&&ie.decorations.tooltip||"",we=ie.decorations&&!!ie.decorations.strikeThrough,_=ie.decorations&&!!ie.decorations.faded,W=ie.contextValue||"";return{rawResource:[X,De,ue,ae,we,_,W,Pe],handle:X}});return{start:T.start,deleteCount:T.deleteCount,toInsert:z}}),K=O.map(({start:T,deleteCount:z,toInsert:ie})=>[T,z,ie.map(X=>X.rawResource)]),B=O.reverse();for(const{start:T,deleteCount:z,toInsert:ie}of B){const X=ie.map(Pe=>Pe.handle),De=this.n.splice(T,z,...X);for(const Pe of De)this.g.delete(Pe),this.h.delete(Pe),this.j.get(Pe)?.dispose(),this.j.delete(Pe)}return this.o=S,K}dispose(){this.l=!0,this.m.fire()}}class c{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(S){this.g!==S&&(this.g=S,this.#e.$updateSourceControl(this.x,{count:S}))}get quickDiffProvider(){return this.h}set quickDiffProvider(S){this.h=S;let j;(0,$.$gF)(this.y,"quickDiffProvider")&&(j=S?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!S,quickDiffLabel:j})}get historyProvider(){return(0,$.$hF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(S){(0,$.$hF)(this.y,"scmHistoryProvider"),this.j=S,this.k.value=new L.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!S}),S&&(this.k.value.add(S.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,S?.currentHistoryItemGroup)||(this.l=S?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(S.onDidChangeActionButton(()=>{(0,$.$hF)(this.y,"scmActionButton"),this.m.value=new L.$Rc;const j=S.actionButton!==void 0?{command:this.z.converter.toInternal(S.actionButton.command,this.m.value),description:S.actionButton.description,enabled:S.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,j??null)})))}get commitTemplate(){return this.n}set commitTemplate(S){S!==this.n&&(this.n=S,this.#e.$updateSourceControl(this.x,{commitTemplate:S}))}get acceptInputCommand(){return this.p}set acceptInputCommand(S){this.o.value=new L.$Rc,this.p=S;const j=this.z.converter.toInternal(S,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,$.$hF)(this.y,"scmActionButton"),this.s}set actionButton(S){(0,$.$hF)(this.y,"scmActionButton"),this.q.value=new L.$Rc,this.s=S;const j=S!==void 0?{command:this.z.converter.toInternal(S.command,this.q.value),secondaryCommands:S.secondaryCommands?.map(O=>O.map(K=>this.z.converter.toInternal(K,this.q.value))),description:S.description,enabled:S.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(S){if(this.u&&S&&g(this.u,S))return;this.t.value=new L.$Rc,this.u=S;const j=(S||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(S,j,O,K,B,T,z){this.y=S,this.z=K,this.A=B,this.B=T,this.C=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Tc,this.m=new L.$Tc,this.n=void 0,this.o=new L.$Tc,this.p=void 0,this.q=new L.$Tc,this.t=new L.$Tc,this.u=void 0,this.v=!1,this.w=new M.$Nd,this.onDidChangeSelection=this.w.event,this.x=c.d++,this.D=new Map,this.E=new Set,this.#e=O;const ie=w.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${B}/scm${this.x}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new C(S,K,j,this.#e,this.x,ie),this.#e.$registerSourceControl(this.x,B,T,z,ie)}createResourceGroup(S,j){const O=new I(this.#e,this.z,this.x,S,j),K=M.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,K),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const S=[],j=[];for(const[O,K]of this.D){K.dispose();const B=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});M.Event.once(O.onDidDispose)(()=>{this.E.delete(O),B.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),S.push([O.handle,O.id,O.label,O.features]);const T=O._takeResourceStateSnapshot();T.length>0&&j.push([O.handle,T]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,S,j),this.D.clear()}eventuallyUpdateResourceStates(){const S=[];this.E.forEach(j=>{const O=j._takeResourceStateSnapshot();O.length!==0&&S.push([j.handle,O])}),S.length>0&&this.#e.$spliceResourceStates(this.x,S),this.E.clear()}getResourceGroup(S){return this.e.get(S)}setSelectionState(S){this.v=S,this.w.fire(S)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(S=>S.dispose()),this.#e.$unregisterSourceControl(this.x)}}qe([(0,P.$ih)(100)],c.prototype,"eventuallyAddResourceGroups",null),qe([(0,P.$ih)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(S,j,O,K){this.l=j,this.m=O,this.n=K,this.g=new Map,this.h=new k.$8l,this.j=new M.$Nd,this.e=S.getProxy(u.$lK.MainThreadSCM),this.f=S.getProxy(u.$lK.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===3){const T=this.g.get(B.sourceControlHandle);if(!T)return B;const z=T.getResourceGroup(B.groupHandle);return z?z.getResourceState(B.handle):B}else if(B&&B.$mid===4){const T=this.g.get(B.sourceControlHandle);return T?T.getResourceGroup(B.groupHandle):B}else if(B&&B.$mid===5){const T=this.g.get(B.handle);return T||B}return B}})}createSourceControl(S,j,O,K){this.n.trace("ExtHostSCM#createSourceControl",S.identifier.value,j,O,K),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:S.identifier.value});const B=t.d++,T=new c(S,this.m,this.e,this.l,j,O,K);this.g.set(B,T);const z=this.h.get(S.identifier)||[];return z.push(T),this.h.set(S.identifier,z),T}getLastInputBox(S){this.n.trace("ExtHostSCM#getLastInputBox",S.identifier.value);const j=this.h.get(S.identifier),O=j&&j[j.length-1];return O&&O.inputBox}$provideOriginalResource(S,j,O){const K=w.URI.revive(j);this.n.trace("ExtHostSCM#$provideOriginalResource",S,K.toString());const B=this.g.get(S);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>B.quickDiffProvider.provideOriginalResource(K,O)).then(T=>T||null)}$onInputBoxValueChange(S,j){this.n.trace("ExtHostSCM#$onInputBoxValueChange",S);const O=this.g.get(S);return O&&O.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(S,j,O,K){this.n.trace("ExtHostSCM#$executeResourceCommand",S,j,O);const B=this.g.get(S);if(!B)return Promise.resolve(void 0);const T=B.getResourceGroup(j);return T?T.$executeResourceCommand(O,K):Promise.resolve(void 0)}$validateInput(S,j,O){this.n.trace("ExtHostSCM#$validateInput",S);const K=this.g.get(S);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>K.inputBox.validateInput(j,O)).then(B=>{if(!B)return Promise.resolve(void 0);const T=v.MarkdownString.fromStrict(B.message);return T?Promise.resolve([T,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(S){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",S),S!==void 0&&this.g.get(S)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=S,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(S,j,O){return await this.g.get(S)?.historyProvider?.resolveHistoryItemGroupBase(j,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(S,j,O,K){return await this.g.get(S)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,O,K)??void 0}async $provideHistoryItems(S,j,O,K){return(await this.g.get(S)?.historyProvider?.provideHistoryItems(j,O,K))?.map(z=>({id:z.id,parentIds:z.parentIds,label:z.label,description:z.description,icon:p(z),timestamp:z.timestamp}))??void 0}async $provideHistoryItemChanges(S,j,O){return await this.g.get(S)?.historyProvider?.provideHistoryItemChanges(j,O)??void 0}};e.$gdc=y,e.$gdc=y=t=qe([Ke(3,R.$0i)],y)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.$Xcc=void 0;class L{constructor(u){this.b=new M.$Nd,this.onDidChangePassword=this.b.event,this.a=u.getProxy(w.$lK.MainThreadSecretState)}async $onDidChangePassword(u){this.b.fire(u)}get(u,D){return this.a.$getPassword(u,D)}store(u,D,f){return this.a.$setPassword(u,D,f)}delete(u,D){return this.a.$deletePassword(u,D)}}e.$Xcc=L,e.$Ycc=(0,P.$Ph)("IExtHostSecretState")}),define(Ae[253],Re([1,0,3,8,2]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class L{static{this.a=0}constructor(u,D){this.d=D,this.c=new Map,this.b=u.getProxy(w.$lK.MainThreadShare)}async $provideShare(u,D,f){return await this.c.get(u)?.provideShare({selection:M.Range.to(D.selection),resourceUri:P.URI.revive(D.resourceUri)},f)??void 0}registerShareProvider(u,D){const f=L.a++;return this.c.set(f,D),this.b.$registerShareProvider(f,M.DocumentSelector.from(u,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$iec=L}),define(Ae[254],Re([1,0,19,6,3]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;class L{static{this.a=1}constructor(u){this.c=new Map,this.d=new Map,this.b=u.getProxy(P.$lK.MainThreadSpeech)}async $createSpeechToTextSession(u,D){const f=this.c.get(u);if(!f)return;const R=new M.$Rc,k=new w.$Xd;this.d.set(D,k);const a=R.add(f.provideSpeechToTextSession(k.token));R.add(a.onDidChange(v=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,v)})),R.add(k.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(u){this.d.get(u)?.dispose(!0),this.d.delete(u)}registerProvider(u,D,f){const R=L.a++;return this.c.set(R,f),this.b.$registerProvider(R,D,{extension:u,displayName:u.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$kec=L}),define(Ae[255],Re([1,0,7,3,154,6,8,15]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$iL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$iL("statusBarItem.warningForeground")]])}#e;#t;constructor(a,v,$,d,t,i=w.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new L.$Rc,this.#e=a,this.#t=v,t&&d){this.c=(0,w.$XK)(d.identifier,t);const p=$.get(this.c);p&&(i=p.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,l=p.priority,this.j=!0,this.name=p.name,this.text=p.text,this.tooltip=p.tooltip,this.command=p.command,this.accessibilityInformation=p.accessibilityInformation)}else this.c=String(D.a++);this.e=d,this.f=t,this.g=i,this.h=this.u(l)}u(a){if((0,u.$Cf)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!D.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new L.$Rc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=D.b.get(this.o.id));const d=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,v,this.k,d,this.r?.internal,$,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$hdc=D;class f{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const v={message:a};return this.b.unshift(v),this.c(),new w.$nK(()=>{const $=this.b.indexOf(v);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(a,v){this.e=new Map,this.a=a.getProxy(M.$lK.MainThreadStatusBar),this.b=v,this.c=new f(this)}$acceptStaticEntries(a){for(const v of a)this.e.set(v.entryId,v)}createStatusBarEntry(a,v,$,d){return new D(this.a,this.b,this.e,a,v,$,d)}setStatusBarMessage(a,v){const $=this.c.setMessage(a);let d;return typeof v=="number"?d=setTimeout(()=>$.dispose(),v):typeof v<"u"&&v.then(()=>$.dispose(),()=>$.dispose()),new w.$nK(()=>{$.dispose(),clearTimeout(d)})}}e.$idc=R}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=e.$Lcc=void 0;class L{constructor(u,D){this.c=D,this.b=new M.$Nd,this.onDidChangeStorage=this.b.event,this.a=u.getProxy(w.$lK.MainThreadStorage)}registerExtensionStorageKeysToSync(u,D){this.a.$registerExtensionStorageKeysToSync(u,D)}async initializeExtensionStorage(u,D,f){const R=await this.a.$initializeExtensionStorage(u,D);let k;return R&&(k=this.d(u,D,R)),k||f}setValue(u,D,f){return this.a.$setValue(u,D,f)}$acceptValue(u,D,f){const R=this.d(u,D,f);R&&this.b.fire({shared:u,key:D,value:R})}d(u,D,f){try{return JSON.parse(f)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${u}): ${R}`)}}}e.$Lcc=L,e.$Mcc=(0,P.$Ph)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0,e.$Rcc=(0,w.$Ph)("IExtensionStoragePaths");let u=class{constructor(f,R,k){this.d=R,this.f=k,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,R=await this.g(f);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Scc=u,e.$Scc=u=qe([Ke(0,M.$CM),Ke(1,P.$0i),Ke(2,L.$Qcc)],u)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,156,11,182,19,36,183,43,12,8,31]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=e.$Ucc=e.$Tcc=void 0,e.$Tcc=(0,P.$Ph)("IExtHostTerminalService");class p{constructor(c,y,b,S){this.l=c,this._id=y,this.m=b,this.n=S,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const j=this;this.value={get name(){return j.n||""},get processId(){return j.b},get creationOptions(){return j.m},get exitStatus(){return j.h},get state(){return j.j},get selection(){return j.k},sendText(O,K=!0){j.q(),j.l.$sendText(j._id,O,K)},show(O){j.q(),j.l.$show(j._id,O)},hide(){j.q(),j.l.$hide(j._id)},dispose(){j.a||(j.a=!0,j.l.$dispose(j._id))},get dimensions(){if(!(j.d===void 0||j.g===void 0))return{columns:j.d,rows:j.g}}}}async create(c,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:c.name,shellPath:c.shellPath??void 0,shellArgs:c.shellArgs??void 0,cwd:c.cwd??void 0,env:c.env??void 0,icon:g(c.iconPath)??void 0,color:d.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:c.message??void 0,strictEnv:c.strictEnv??void 0,hideFromUser:c.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(c.location,y?.resolvedExtHostIdentifier),isTransient:c.isTransient??void 0})}async createExtensionTerminal(c,y,b,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:b,color:d.ThemeColor.isThemeColor(S)?S.id:void 0,location:this.o(c,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(c,y){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in c?{viewColumn:i.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(c){this.n=c}setExitStatus(c,y){this.h=Object.freeze({code:c,reason:y})}setDimensions(c,y){return c===this.d&&y===this.g||c===0||y===0?!1:(this.d=c,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(c){this.k=c}_setProcessId(c){this.f?(this.f(c),this.f=void 0):this.b.then(y=>{y!==c&&(this.b=Promise.resolve(c))})}}e.$Ucc=p;class E{get onProcessReady(){return this.b.event}constructor(c){this.g=c,this.id=0,this.shouldPersist=!1,this.a=new w.$Nd,this.onProcessData=this.a.event,this.b=new w.$Nd,this.d=new w.$Nd,this.onDidChangeProperty=this.d.event,this.f=new w.$Nd,this.onProcessExit=this.f.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(c){this.g.handleInput?.(c)}resize(c,y){this.g.setDimensions?.({columns:c,rows:y})}clearBuffer(){}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(c){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(c||void 0),c&&this.g.setDimensions?.(c),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let m=1,n=class extends u.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(c=>c.value)}constructor(c,y,b){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new u.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new w.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new w.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new w.$Nd,this.onDidChangeShell=this.N.event,this.O=new w.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(M.$lK.MainThreadTerminalService),this.y=new $.$Zkb(this.a.$sendProcessData),this.a.$registerProcessSupport(c),this.Q.registerArgumentProcessor({processArgument:S=>{const j=O=>{const K=O;return this.W(K.instanceId)?.value};switch(S?.$mid){case 15:return j(S);default:{if(Array.isArray(S))for(let O=0;O<S.length&&S[O].$mid===15;O++)S[O]=j(S[O]);return S}}}}),this.B({dispose:()=>{for(const[S,j]of this.g)j.shutdown(!0)}})}getDefaultShell(c){return(c?this.u:this.s)?.path||""}getDefaultShellArgs(c){return(c?this.u:this.s)?.args||[]}createExtensionTerminal(c,y){const b=new p(this.a,(0,v.$eg)(),c,c.name),S=new E(c.pty);return b.createExtensionTerminal(c.location,this.R(c,y).resolvedExtHostIdentifier,g(c.iconPath),h(c.color)).then(j=>{const O=this.S(j,S);this.h[j]=O}),this.f.push(b),b.value}R(c,y){if(y=y||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const b=c.location.parentTerminal;if(b){const S=this.f.find(j=>j.value===b);S&&(y.resolvedExtHostIdentifier=S._id)}}else c.location&&typeof c.location!="object"?y.location=c.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(c,y){if(!this.W(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const S=new E(y),j=this.S(c,S);this.h[c]=j}async $acceptActiveTerminalChanged(c){const y=this.b;if(c===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const b=this.W(c);b&&(this.b=b,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(c,y){const b=this.W(c);b&&this.O.fire({terminal:b.value,data:y})}async $acceptTerminalDimensions(c,y,b){const S=this.W(c);S&&S.setDimensions(y,b)&&this.L.fire({terminal:S.value,dimensions:S.value.dimensions})}async $acceptDidExecuteCommand(c,y){const b=this.W(c);b&&this.P.fire({terminal:b.value,...y})}async $acceptTerminalMaximumDimensions(c,y,b){this.g.get(c)?.resize(y,b)}async $acceptTerminalTitleChange(c,y){const b=this.W(c);b&&(b.name=y)}async $acceptTerminalClosed(c,y,b){const S=this.Y(this.f,c);if(S!==null){const j=this.f.splice(S,1)[0];j.setExitStatus(y,b),this.H.fire(j.value)}}$acceptTerminalOpened(c,y,b,S){if(y){const K=this.Y(this.f,y);if(K!==null){this.f[K]._id=c,this.I.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const j={name:S.name,shellPath:S.executable,shellArgs:S.args,cwd:typeof S.cwd=="string"?S.cwd:L.URI.revive(S.cwd),env:S.env,hideFromUser:S.hideFromUser},O=new p(this.a,c,j,b);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(c,y){this.W(c)?._setProcessId(y)}async $startExtensionTerminal(c,y){const b=this.W(c);if(!b)return{message:(0,f.localize)(0,null,c)};b.isOpen||await new Promise(j=>{const O=this.onDidOpenTerminal(async K=>{K===b.value&&(O.dispose(),j())})});const S=this.g.get(c);S?S.startSendingEvents(y):this.j[c]={initialDimensions:y}}S(c,y){const b=new u.$Rc;b.add(y.onProcessReady(j=>this.a.$sendProcessReady(c,j.pid,j.cwd,j.windowsPty))),b.add(y.onDidChangeProperty(j=>this.a.$sendProcessProperty(c,j))),this.y.startBuffering(c,y.onProcessData),b.add(y.onProcessExit(j=>this.U(c,j))),this.g.set(c,y);const S=this.j[c];return S&&y instanceof E&&(y.startSendingEvents(S.initialDimensions),delete this.j[c]),b}$acceptProcessAckDataEvent(c,y){this.g.get(c)?.acknowledgeDataEvent(y)}$acceptProcessInput(c,y){this.g.get(c)?.input(y)}$acceptTerminalInteraction(c){const y=this.W(c);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(c,y){this.W(c)?.setSelection(y)}$acceptProcessResize(c,y,b){try{this.g.get(c)?.resize(y,b)}catch(S){if(S.code!=="EPIPE"&&S.code!=="ERR_IPC_CHANNEL_CLOSED")throw S}}$acceptProcessShutdown(c,y){this.g.get(c)?.shutdown(y)}$acceptProcessRequestInitialCwd(c){this.g.get(c)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(c,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(c){this.g.get(c)?.getCwd().then(y=>this.a.$sendProcessProperty(c,{type:"cwd",value:y}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this.z.add(c),this.z.size===1&&this.a.$startLinkProvider(),new D.$nK(()=>{this.z.delete(c),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(c,y,b){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,b),this.a.$registerProfileProvider(y,c.identifier.value),new D.$nK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(c,y,b){if(this.D.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this.D.set(c,b),this.a.$registerQuickFixProvider(c,y),new D.$nK(()=>{this.D.delete(c),this.a.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,y){const b=new a.$Xd().token;if(b.isCancellationRequested)return;const S=this.D.get(c);if(!S)return;const j=await S.provideTerminalQuickFixes(y,b);if(j===null||Array.isArray(j)&&j.length===0)return;const O=new u.$Rc;if(this.w.value=O,!Array.isArray(j))return j?i.TerminalQuickFix.from(j,this.Q.converter,O):void 0;const K=[];for(const B of j){const T=i.TerminalQuickFix.from(B,this.Q.converter,O);T&&K.push(T)}return K}async $createContributedProfileTerminal(c,y){const b=new a.$Xd().token;let S=await this.C.get(c)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(S&&!("options"in S)&&(S={options:S}),!S||!("options"in S))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in S.options){this.createExtensionTerminal(S.options,y);return}this.createTerminalFromOptions(S.options,y)}}async $provideLinks(c,y){const b=this.W(c);if(!b)return[];this.F.delete(c),this.G.get(c)?.dispose(!0);const j=new a.$Xd;this.G.set(c,j);const O=[],K={terminal:b.value,line:y},B=[];for(const ie of this.z)B.push(t.Promises.withAsyncBody(async X=>{j.token.onCancellationRequested(()=>X({provider:ie,links:[]}));const De=await ie.provideTerminalLinks(K,j.token)||[];j.token.isCancellationRequested||X({provider:ie,links:De})}));const T=await Promise.all(B);if(j.token.isCancellationRequested)return[];const z=new Map;for(const ie of T)ie&&ie.links.length>0&&O.push(...ie.links.map(X=>{const De={id:m++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return z.set(De.id,{provider:ie.provider,link:X}),De}));return this.F.set(c,z),O}$activateLink(c,y){const b=this.F.get(c)?.get(y);b&&b.provider.handleTerminalLink(b.link)}U(c,y){this.y.stopBuffering(c),this.g.delete(c),delete this.j[c];const b=this.h[c];b&&(b.dispose(),delete this.h[c]),this.a.$sendProcessExit(c,y)}W(c){return this.X(this.f,c)}X(c,y){const b=this.Y(c,y);return b!==null?c[b]:null}Y(c,y){const b=c.findIndex(S=>S._id===y);return b===-1?null:b}getEnvironmentVariableCollection(c){let y=this.n.get(c.identifier.value);return y||(y=new r,this.$(c.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(c,y){const b=(0,k.$kr)(y.map),S=(0,k.$lr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(c,y.persistent,b.length===0?void 0:b,S)}$initEnvironmentVariableCollections(c){c.forEach(y=>{const b=y[0],S=new r(y[1]);this.$(b,S)})}$acceptDefaultProfile(c,y){const b=this.s;this.s=c,this.u=y,b?.path!==c.path&&this.N.fire(c.path)}$(c,y){this.n.set(c,y),y.onDidChangeCollection(()=>{this.Z(c,y)})}};e.$Vcc=n,e.$Vcc=n=qe([Ke(1,l.$IM),Ke(2,A.$mM)],n);class r{get persistent(){return this.b}set persistent(c){this.b=c,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(c){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$Nd,this.map=new Map(c)}getScopedEnvironmentVariableCollection(c){const y=this.h(c);let b=this.a.get(y);return b||(b=new s(this,c),this.a.set(y,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(c,y,b,S){this.f(c,{value:y,type:D.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:S})}append(c,y,b,S){this.f(c,{value:y,type:D.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:S})}prepend(c,y,b,S){this.f(c,{value:y,type:D.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:S})}f(c,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(c,y.scope),S=this.map.get(b),j=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!S||S.value!==y.value||S.type!==y.type||S.options?.applyAtProcessCreation!==j.applyAtProcessCreation||S.options?.applyAtShellIntegration!==j.applyAtShellIntegration||S.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const O=this.g(c,y.scope),K={variable:c,...y,options:j};this.map.set(O,K),this.d.fire()}}get(c,y){const b=this.g(c,y),S=this.map.get(b);return S?C(S):void 0}g(c,y){const b=this.h(y);return b.length?`${c}:::${b}`:c}h(c){return this.j(c?.workspaceFolder)??""}j(c){return c?c.uri.toString():void 0}getVariableMap(c){const y=new Map;for(const[b,S]of this.map)this.h(S.scope)===this.h(c)&&y.set(S.variable,C(S));return y}delete(c,y){const b=this.g(c,y);this.map.delete(b),this.d.fire()}clear(c){if(c?.workspaceFolder){for(const[y,b]of this.map)b.scope?.workspaceFolder?.index===c.workspaceFolder.index&&this.map.delete(y);this.k(c)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(c,y){const b=this.h(y),S=this.descriptionMap.get(b);if(!S||S.description!==c){let j;typeof c=="string"?j=c:j=c?.value.split(`

`)[0];const O={description:j,scope:y};this.descriptionMap.set(b,O),this.d.fire()}}getDescription(c){const y=this.h(c);return this.descriptionMap.get(y)?.description}k(c){const y=this.h(c);this.descriptionMap.delete(y)}}class s{get persistent(){return this.b.persistent}set persistent(c){this.b.persistent=c}get onDidChangeCollection(){return this.a&&this.a.event}constructor(c,y){this.b=c,this.d=y,this.a=new w.$Nd}getScoped(c){return this.b.getScopedEnvironmentVariableCollection(c)}replace(c,y,b){this.b.replace(c,y,b,this.d)}append(c,y,b){this.b.append(c,y,b,this.d)}prepend(c,y,b){this.b.prepend(c,y,b,this.d)}get(c){return this.b.get(c,this.d)}forEach(c,y){this.b.getVariableMap(this.d).forEach((b,S)=>c.call(y,S,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(c){this.b.delete(c,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(c){this.b.setDescription(c,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(c,y){super(!1,c,y)}createTerminal(c,y,b){throw new R.$_}createTerminalFromOptions(c,y){throw new R.$_}};e.$Wcc=o,e.$Wcc=o=qe([Ke(0,l.$IM),Ke(1,A.$mM)],o);function g(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function h(I){return d.ThemeColor.isThemeColor(I)?I:void 0}function C(I){const c={...I};return delete c.scope,c.options=c.options??void 0,delete c.variable,c}}),define(Ae[256],Re([1,0,285,12,26,19,5,206,93,6,25,15,36,3,17,105,8,7,46,76,58]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=e.$5dc=e.$4dc=void 0;let m=class{constructor(O,K,B){this.j=B,this.c=new A.$Nd,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(v.$lK.MainThreadTesting),this.h=new y(this.f),this.g=new o(this.f),K.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const z=T,ie=z.tests[z.tests.length-1].item.extId;return this.d.get(l.$eJ.root(ie))?.collection.tree.get(ie)?.actual??(0,d.$yM)(T)}case 18:{const{extId:z,message:ie}=T;return{test:this.d.get(l.$eJ.root(z))?.collection.tree.get(z)?.actual,message:t.TestMessage.to(ie)}}default:return T}}}),K.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await K.executeCommand("_testing.getExplorerSelection"),z=ie=>{const X=this.d.get(l.$eJ.root(ie));if(X)return l.$eJ.isRoot(ie)?X.controller:X.collection.tree.get(ie)?.actual};return{include:T?.include.map(z).filter(k.$Gf)||[],exclude:T?.exclude.map(z).filter(k.$Gf)||[]}})}createTestController(O,K,B,T){if(this.d.has(K))throw new Error(`Attempt to insert a duplicate controller with ID "${K}"`);const z=new f.$Rc,ie=z.add(new d.$BM(K,B,this.j));ie.root.label=B;const X=new Map,De=this.f,Pe={items:ie.root.children,get label(){return B},set label($e){B=$e,ie.root.label=$e,De.$updateController(K,{label:B})},get refreshHandler(){return T},set refreshHandler($e){T=$e,De.$updateController(K,{canRefresh:!!$e})},get id(){return K},createRunProfile:($e,ye,ue,ae,we,_)=>{let W=(0,D.$Di)($e);for(;X.has(W);)W++;return new b(this.f,X,K,W,$e,ye,ue,ae,we,_)},createTestItem($e,ye,ue){return new d.$zM(K,$e,ye,ue)},createTestRun:($e,ye,ue=!0)=>this.g.createTestRun(O,K,ie,$e,ye,ue),invalidateTestResults:$e=>{if($e===void 0)this.f.$markTestRetired(void 0);else{const ye=$e instanceof Array?$e:[$e];this.f.$markTestRetired(ye.map(ue=>l.$eJ.fromExtHostTestItem(ue,K).toString()))}},set resolveHandler($e){ie.resolveHandler=$e},get resolveHandler(){return ie.resolveHandler},dispose:()=>{z.dispose()}};De.$registerTestController(K,B,!!T),z.add((0,f.$Qc)(()=>De.$unregisterTestController(K)));const ke={controller:Pe,collection:ie,profiles:X,extension:O};return this.d.set(K,ke),z.add((0,f.$Qc)(()=>this.d.delete(K))),z.add(ie.onDidGenerateDiff($e=>De.$publishDiff(K,$e.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.h.checkout()}async runTests(O,K=L.CancellationToken.None){const B=g(O);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.d.get(B.controllerId);if(!T)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(z=>l.$eJ.fromExtHostTestItem(z,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:S[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:O.exclude?.map(z=>z.id)},K)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,K,B){return(0,w.$rb)(this.g.trackers,z=>z.id===O?z.getCoverage(K):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(O,K,B,T){return(0,w.$rb)(this.g.trackers,ie=>ie.id===O?ie.getCoverage(K):void 0)?.resolveFileCoverage(B,T)??Promise.resolve([])}$configureRunProfile(O,K){this.d.get(O)?.profiles.get(K)?.configureHandler?.()}async $refreshTests(O,K){await this.d.get(O)?.controller.refreshHandler?.(K)}$publishTestResults(O){this.results=Object.freeze(O.map(K=>(0,R.$8m)(t.TestResults.to(K))).concat(this.results).sort((K,B)=>B.completedAt-K.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,K){const B=this.d.get(l.$eJ.fromString(O).controllerId)?.collection;B&&(await B.expand(O,K<0?1/0:K),B.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(E.TestsDiffOp.deserialize))}async $runControllerTests(O,K){return Promise.all(O.map(B=>this.k(B,!1,K)))}async $startContinuousRun(O,K){const B=new L.$Xd(K),T=await Promise.all(O.map(z=>this.k(z,!0,B.token)));return!K.isCancellationRequested&&!T.some(z=>z.error)&&await new Promise(z=>K.onCancellationRequested(z)),B.dispose(!0),T}async k(O,K,B){const T=this.d.get(O.controllerId);if(!T)return{};const{collection:z,profiles:ie,extension:X}=T,De=ie.get(O.profileId);if(!De)return{};const Pe=O.testIds.map(ue=>z.tree.get(ue)).filter(k.$Gf),ke=O.excludeExtIds.map(ue=>T.collection.tree.get(ue)).filter(k.$Gf).filter(ue=>Pe.some(ae=>ae.fullId.compare(ue.fullId)===2));if(!Pe.length)return{};const $e=new i.$VL(Pe.some(ue=>ue.actual instanceof d.$AM)?void 0:Pe.map(ue=>ue.actual),ke.map(ue=>ue.actual),De,K),ye=(0,E.$gJ)(O)&&this.g.prepareForMainThreadTestRun($e,h.fromInternal(O,T.collection),X,B);try{return await De.runHandler($e,B),{}}catch(ue){return{error:String(ue)}}finally{ye&&(ye.hasRunningTasks&&!B.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),ye.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};e.$4dc=m,e.$4dc=m=qe([Ke(0,$.$mM)],m);const n=1e4;var r;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(r||(r={}));class s extends f.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(O,K,B){super(),this.m=O,this.s=K,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Nd),this.onEnd=this.j.event,this.h=this.B(new L.$Xd(B));const T=this.B(new M.$6g(()=>this.u(),n));this.B(this.h.token.onCancellationRequested(()=>T.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const K=this.m.id,B=this.m.controllerId,T=(0,a.$eg)(),z=new C(this.s,K,T),ie=ke=>($e,...ye)=>{if(De){console.warn(`Setting the state of test "${$e.id}" is a no-op after the run ends.`);return}this.m.isIncluded($e)&&(this.y($e),ke($e,...ye))},X=(ke,$e)=>{const ye=$e instanceof Array?$e.map(t.TestMessage.from):[t.TestMessage.from($e)];if(ke.uri&&ke.range){const ue={range:t.Range.from(ke.range),uri:ke.uri};for(const ae of ye)ae.location=ae.location||ue}this.s.$appendTestMessagesInRun(K,T,l.$eJ.fromExtHostTestItem(ke,B).toString(),ye)};let De=!1;const Pe={isPersisted:this.m.isPersisted,token:this.h.token,name:O,get coverageProvider(){return z.coverageProvider},set coverageProvider(ke){z.coverageProvider=ke},enqueued:ie(ke=>{this.s.$updateTestStateInRun(K,T,l.$eJ.fromExtHostTestItem(ke,B).toString(),1)}),skipped:ie(ke=>{this.s.$updateTestStateInRun(K,T,l.$eJ.fromExtHostTestItem(ke,B).toString(),5)}),started:ie(ke=>{this.s.$updateTestStateInRun(K,T,l.$eJ.fromExtHostTestItem(ke,B).toString(),2)}),errored:ie((ke,$e,ye)=>{X(ke,$e),this.s.$updateTestStateInRun(K,T,l.$eJ.fromExtHostTestItem(ke,B).toString(),6,ye)}),failed:ie((ke,$e,ye)=>{X(ke,$e),this.s.$updateTestStateInRun(K,T,l.$eJ.fromExtHostTestItem(ke,B).toString(),4,ye)}),passed:ie((ke,$e)=>{this.s.$updateTestStateInRun(K,T,l.$eJ.fromExtHostTestItem(ke,this.m.controllerId).toString(),3,$e)}),appendOutput:(ke,$e,ye)=>{De||(ye&&(this.m.isIncluded(ye)?this.y(ye):ye=void 0),this.s.$appendOutputToRun(K,T,P.$be.fromString(ke),$e&&t.location.from($e),ye&&l.$eJ.fromExtHostTestItem(ye,B).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(K,T),this.f.delete(T),this.f.size||this.w())}};return this.f.set(T,{run:Pe,coverage:z}),this.s.$startedTestRunTask(K,{id:T,name:O,running:!0}),Pe}u(){for(const{run:O}of this.f.values())O.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(O){if(!(O instanceof d.$zM))throw new p.$eM(O.id);if(this.g.has(l.$eJ.fromExtHostTestItem(O,this.m.controllerId).toString()))return;const K=[],B=this.m.colllection.root;for(;;){const T=t.TestItem.from(O);if(K.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),O===B))break;O=O.parent||B}this.s.$addTestsToRun(this.m.controllerId,this.m.id,K)}dispose(){this.w(),super.dispose()}}class o{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,K,B,T){return this.f(O,K,B,T)}cancelRunById(O){for(const K of this.c.values())if(K.id===O){K.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,K,B,T,z,ie){const X=this.c.get(T);if(X)return X.createRun(z);const De=h.fromPublic(K,B,T,ie),Pe=g(T);this.d.$startedExtensionTestRun({controllerId:K,continuous:!!T.continuous,profile:Pe&&{group:S[Pe.kind],id:Pe.profileId},exclude:T.exclude?.map($e=>l.$eJ.fromExtHostTestItem($e,B.root.id).toString())??[],id:De.id,include:T.include?.map($e=>l.$eJ.fromExtHostTestItem($e,B.root.id).toString())??[B.root.id],persist:ie});const ke=this.f(T,De,O);return A.Event.once(ke.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),ke.dispose()}),ke.createRun(z)}f(O,K,B,T){const z=new s(K,this.d,T);return this.c.set(O,z),A.Event.once(z.onEnd)(()=>this.c.delete(O)),z}}e.$5dc=o;const g=j=>{if(j.profile){if(!(j.profile instanceof b))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class h{static fromPublic(O,K,B,T){return new h(O,(0,a.$eg)(),B.include?.map(z=>l.$eJ.fromExtHostTestItem(z,O).toString())??[O],B.exclude?.map(z=>l.$eJ.fromExtHostTestItem(z,O).toString())??[],T,K)}static fromInternal(O,K){return new h(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,K)}constructor(O,K,B,T,z,ie){this.controllerId=O,this.id=K,this.isPersisted=z,this.colllection=ie,this.c=B.map(X=>X+"\0"),this.d=T.map(X=>X+"\0")}isIncluded(O){const K=l.$eJ.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const B of this.d)if(K===B||K.startsWith(B))return!1;for(const B of this.c)if(K===B||K.startsWith(B))return!0;return!1}}e.$6dc=h;class C{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");O&&(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,K,B){this.f=O,this.g=K,this.h=B}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(K){throw this.d=void 0,K}}async resolveFileCoverage(O,K){const B=await this.d;let T=B?.[O];return!this.c||!B||!T?[]:(T.detailedCoverage||(T=B[O]=await this.c.resolveFileCoverage?.(T,K)??T),T.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class I{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,t.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const K=l.$eJ.parentId(O.item.extId);if(K&&this.g.has(K.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:K,f:B}=this;return{get added(){return[...O].map(T=>T.revived)},get updated(){return[...K].map(T=>T.revived)},get removed(){return[...B].map(T=>T.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class c extends E.$lJ{constructor(){super(...arguments),this.q=new A.$Nd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,K){return{...O,revived:t.TestItem.toPlain(O.item),depth:K?K.depth+1:0,children:new Set}}o(){return new I(this.q)}}class y{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(K=>K.revived)},dispose:(0,u.$db)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new c;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class b{#e;#t;get label(){return this.d}set label(O){O!==this.d&&(this.d=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?t.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,K,B,T,z,ie,X,De=!1,Pe=void 0,ke=!1){this.controllerId=B,this.profileId=T,this.d=z,this.kind=ie,this.runHandler=X,this.f=De,this._tag=Pe,this.g=ke,this.#e=O,this.#t=K,K.set(T,this);const $e=S[ie];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);this.#e.$publishTestRunProfile({profileId:T,controllerId:B,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:z,group:$e,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:ke})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$7dc=b;const S={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[257],Re([1,0,18,11,5,3,106,8,7]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class f{constructor(k,a){this.i=a,this.a=new P.$Nd({onListenerError:M.$2}),this.b=new P.$Nd({onListenerError:M.$2}),this.c=new P.$Nd({onListenerError:M.$2}),this.d=new P.$Nd({onListenerError:M.$2}),this.f=new P.$Nd({onListenerError:M.$2}),this.g=new P.$Nd({onListenerError:M.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(L.$lK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(v=>v.value)}async showTextDocument(k,a,v){let $;typeof a=="number"?$={position:u.ViewColumn.from(a),preserveFocus:v}:typeof a=="object"?$={position:u.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?u.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:$={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(k.uri,$),t=d&&this.i.getEditor(d);if(t)return t.value;throw d?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new A.$tM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const v=this.i.getEditor(k);if(!v)throw new Error("unknown text editor");if(a.options&&v._acceptOptions(a.options),a.selections){const $=a.selections.selections.map(u.Selection.to);v._acceptSelections($)}if(a.visibleRanges){const $=w.$Hb(a.visibleRanges.map(u.Range.to));v._acceptVisibleRanges($)}if(a.options&&this.b.fire({textEditor:v.value,options:{...a.options,lineNumbers:u.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const $=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),d=a.selections.selections.map(u.Selection.to);this.a.fire({textEditor:v.value,selections:d,kind:$})}if(a.visibleRanges){const $=w.$Hb(a.visibleRanges.map(u.Range.to));this.c.fire({textEditor:v.value,visibleRanges:$})}}$acceptEditorPositionData(k){for(const a in k){const v=this.i.getEditor(a);if(!v)throw new Error("Unknown text editor");const $=u.ViewColumn.to(k[a]);v.value.viewColumn!==$&&(v._acceptViewColumn($),this.d.fire({textEditor:v.value,viewColumn:$}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$jdc=f}),define(Ae[258],Re([1,0,2,4,3,6,7,8,21,15]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=void 0,e.$Xdc=(0,M.$Ph)("IExtHostTimeline");class R{constructor(v,$){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$lK.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(d,t)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&D.$6l.equals(t,this.b.get(d.source)?.extension)){const i=d.uri===void 0?void 0:w.URI.revive(d.uri);return this.c.get(d.source)?.get(k(i))?.get(d.handle)}else return;return d}})}async $getTimeline(v,$,d,t){return this.b.get(v)?.provider.provideTimeline(w.URI.revive($),d,t)}registerTimelineProvider(v,$,d,t){const i=new L.$Rc,l=this.d($.id,t,i).bind(this);let p;$.onDidChange&&(p=$.onDidChange(m=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...m,id:$.id}),this));const E=this.c;return this.f({...$,scheme:v,onDidChange:void 0,async provideTimeline(m,n,r){n?.resetCache&&(i.clear(),E.get($.id)?.clear());const s=await $.provideTimeline(m,n,r);if(s==null)return;const o=l(m,n);return{...s,source:$.id,items:s.items.map(o)}},dispose(){for(const m of E.values())m.get($.id)?.clear();p?.dispose(),i.dispose()}},d)}d(v,$,d){return(t,i)=>{let l;if(i?.cacheResults){let p=this.c.get(v);p===void 0&&(p=new Map,this.c.set(v,p));const E=k(t);l=p.get(E),l===void 0&&(l=new Map,p.set(E,l))}return p=>{const{iconPath:E,...m}=p,n=`${v}|${p.id??p.timestamp}`;l?.set(n,p);let r,s,o;p.iconPath&&(E instanceof A.$hL?o={id:E.id,color:E.color}:w.URI.isUri(E)?(r=E,s=E):{light:r,dark:s}=E);let g;return A.$NK.isMarkdownString(m.tooltip)?g=u.MarkdownString.from(m.tooltip):(0,f.$yf)(m.tooltip)?g=m.tooltip:A.$NK.isMarkdownString(m.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=u.MarkdownString.from(m.detail)):(0,f.$yf)(m.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=m.detail),{...m,id:m.id??void 0,handle:n,source:v,command:p.command?$.toInternal(p.command,d):void 0,icon:r,iconDark:s,themeIcon:o,tooltip:g,accessibilityInformation:p.accessibilityInformation}}}}f(v,$){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:$}),(0,L.$Qc)(()=>{for(const t of this.c.values())t.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Ydc=R;function k(a){return a?.toString()}}),define(Ae[86],Re([1,0,19,5,6,158,4,14,185,3,27,17,7]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dwb=e.$cwb=e.TunnelDtoConverter=void 0;class v extends D.$gv{}var $;(function(t){function i(p){return{remoteAddress:p.remoteAddress,localAddress:p.localAddress,public:!!p.public,privacy:p.privacy??(p.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:p.protocol}}t.fromApiTunnel=i;function l(p){return{remoteAddress:{host:p.tunnelRemoteHost,port:p.tunnelRemotePort},localAddress:p.localAddress,public:p.privacy!==D.TunnelPrivacyId.ConstantPrivate&&p.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:p.privacy,protocol:p.protocol}}t.fromServiceTunnel=l})($||(e.TunnelDtoConverter=$={})),e.$cwb=(0,A.$Ph)("IExtHostTunnelService");let d=class extends P.$Sc{constructor(i,l,p){super(),this.s=p,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$lK.MainThreadTunnelService)}async openTunnel(i,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const p=await this.a.$openTunnel(l,i.displayName);if(p){const E=new v(p.remoteAddress,p.localAddress,()=>this.a.$closeTunnel(p.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,l){const p=this.u();return this.r.set(p,{selector:i,provider:l}),this.a.$registerPortsAttributesProvider(i,p),new a.$nK(()=>{this.r.delete(p),this.a.$unregisterPortsAttributesProvider(p)})}async $providePortAttributes(i,l,p,E,m){const n=[];for(const s of i){const o=this.r.get(s);if(!o)return[];n.push(...await Promise.all(l.map(async g=>{let h;try{h=await o.provider.providePortAttributes({port:g,pid:p,commandLine:E},m)}catch{h=await o.provider.providePortAttributes(g,p,E,m)}return{providedAttributes:h,port:g}})))}const r=n.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,m)=>await i.provideTunnel(E,m,new w.$Xd().token)??void 0;const p=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(p),Promise.resolve((0,P.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,l){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const p=i.tunnelFactory??(l?this.w(l):void 0);if(p){this.b=p;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const m=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(m)}}else this.b=void 0;return(0,P.$Qc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,l){if(this.g.has(i.host)){const p=this.g.get(i.host);p.has(i.port)&&(l&&p.get(i.port).disposeListener.dispose(),await p.get(i.port).tunnel.dispose(),p.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const p=this.b(i,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),p!==void 0){const E=await p;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const m=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:m}),$.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(p){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),p instanceof Error)return p.message}}async $applyCandidateFilter(i){const l=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),p=i.filter((E,m)=>l[m]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${p.map(E=>E.port).join(", ")}`),p}};e.$dwb=d,e.$dwb=d=qe([Ke(0,k.$mM),Ke(1,R.$CM),Ke(2,u.$0i)],d)}),define(Ae[259],Re([1,0,6,13,2,3]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(L.$lK.MainThreadUriOpeners)}registerExternalUriOpener(D,f,R,k){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const a=k.schemes.find(v=>!A.a.has(v));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(f,R),this.b.$registerUriOpener(f,k.schemes,D,k.label),(0,w.$Qc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(D,f,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const a=P.URI.revive(f);return k.canOpenExternalUri(a,R)}async $openUri(D,f,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(P.URI.revive(f.resolvedUri),{sourceUri:P.URI.revive(f.sourceUri)},R)}}e.$8dc=A}),define(Ae[260],Re([1,0,3,2,6,11,21]),function(be,e,w,M,P,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class u{static{this.a=0}constructor(f){this.c=new A.$7l,this.d=new Map,this.b=f.getProxy(w.$lK.MainThreadUrls)}registerUriHandler(f,R){const k=f.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=u.a++;return this.c.add(k),this.d.set(a,R),this.b.$registerUriHandler(a,k,f.displayName||f.name),(0,P.$Qc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(f,R){const k=this.d.get(f);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(R))}catch(a){(0,L.$1)(a)}return Promise.resolve(void 0)}async createAppUri(f){return M.URI.revive(await this.b.$createAppUri(f))}}e.$ldc=u}),define(Ae[64],Re([1,0,5,6,13,25,2,170,192,77,3]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.$odc=e.$ndc=e.$mdc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,m,n,r,s,o,g){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$Nd,this._onDidDispose=this.#h.event,this.#e=E,this.#t=m,this.#r=n,this.#l=r,this.#u=s,this.#n=o,this.#c=a(o),this.#d=v(o),this.#i=g}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,f.$dpb)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===P.Schemas.https||E.scheme===P.Schemas.http){let m=E.toString();return m.endsWith("/")||(m+="/"),m+" "+f.$cpb}return f.$cpb}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),L.$$m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const m=(0,D.$Ecb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,m.message,...m.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const m=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,g,h,C)=>{const I=A.URI.from({scheme:g||"file",path:decodeURIComponent(h)}),c=(0,f.$dpb)(I,{isRemote:m,authority:n}).toString();return`${s}${c}${C}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,g,h,C)=>{const I=A.URI.from({scheme:g||"file",path:decodeURIComponent(h)}),c=(0,f.$dpb)(I,{isRemote:m,authority:n}).toString();return`${s}${c}${C}`})}}e.$mdc=k;function a(p){try{const E=(0,u.$No)((0,u.$Mo)(p.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$ndc=a;function v(p){try{const E=(0,u.$No)((0,u.$Mo)(p.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class $ extends M.$Sc{constructor(E,m,n,r,s){super(),this.c=m,this.f=n,this.g=r,this.h=s,this.b=new Map,this.a=E.getProxy(R.$lK.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,m,n){const r=this.j(E);if(r){const{message:s}=(0,D.$Fcb)(m,n.value);r._onMessageEmitter.fire(s)}}$onMissingCsp(E,m){this.g.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,m,n){const r=new k(E,this.a,i(m),this.c,this.f,n,this.h);this.b.set(E,r);const s=r._onDidDispose(()=>{s.dispose(),this.deleteWebview(E)});return r}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$odc=$;function d(p){return{id:p.identifier,location:p.extensionLocation}}e.$pdc=d;function t(p,E,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||l(p,E)}}e.$qdc=t;function i(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(E=>A.URI.from(E))}}function l(p,E){return[...(E?.getWorkspaceFolders()||[]).map(m=>m.uri),p.extensionLocation]}}),define(Ae[261],Re([1,0,19,93,6,13,24,2,8,64,74,3,7]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class v{constructor(r,s){this.document=r,this.b=s,this.a=1,this.c=new R.$icc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,s){await this.f(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.f(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=m(this.document.uri)+this.a++;return(0,A.$vg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const s=this.c.get(r,0);if(!s)throw new Error("No edit found");return s}}class ${constructor(){this.a=new Map}get(r,s){return this.a.get(this.b(r,s))}add(r,s,o){const g=this.b(r,s.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const h=new v(s,o);return this.a.set(g,h),h}delete(r,s){const o=this.b(r,s.uri);this.a.delete(o)}b(r,s){return`${r}@@@${s}`}}var d;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(d||(d={}));class t{constructor(){this.a=new Map}addTextProvider(r,s,o){return this.b(0,r,s,o)}addCustomProvider(r,s,o){return this.b(1,r,s,o)}get(r){return this.a.get(r)}b(r,s,o,g){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:r,extension:o,provider:g}),new a.$nK(()=>this.a.delete(s))}}class i{constructor(r,s,o,g,h){this.d=s,this.f=o,this.g=g,this.h=h,this.b=new t,this.c=new $,this.a=r.getProxy(k.$lK.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,o,g){const h=new P.$Rc;return p(o)?(h.add(this.b.addTextProvider(s,r,o)),this.a.$registerTextEditorProvider((0,f.$pdc)(r),s,g.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.$ndc)(r))):(h.add(this.b.addCustomProvider(s,r,o)),l(o)&&h.add(o.onDidChangeCustomDocument(C=>{const I=this.i(s,C.document.uri);if(E(C)){const c=I.addEdit(C);this.a.$onDidEdit(C.document.uri,s,c,C.label)}else this.a.$onContentChange(C.document.uri,s)})),this.a.$registerCustomEditorProvider((0,f.$pdc)(r),s,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,f.$ndc)(r))),a.$nK.from(h,new a.$nK(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,o,g,h){const C=this.b.get(s);if(!C)throw new Error(`No provider found for '${s}'`);if(C.type!==1)throw new Error(`Invalid provide type for '${s}'`);const I=u.URI.revive(r),c=await C.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:g?.buffer},h);let y;return l(C.provider)&&this.f&&(y=this.f.workspaceValue(C.extension)??this.f.globalValue(C.extension)),this.c.add(s,c,y),{editable:l(C.provider)}}async $disposeCustomDocument(r,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const g=u.URI.revive(r),{document:h}=this.i(s,g);this.c.delete(s,h),h.dispose()}async $resolveCustomEditor(r,s,o,g,h,C){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const c=D.ViewColumn.to(h),y=this.g.createNewWebview(s,g.contentOptions,I.extension),b=this.h.createNewWebviewPanel(s,o,g.title,c,g.options,y,g.active),S=u.URI.revive(r);switch(I.type){case 1:{const{document:j}=this.i(o,S);return I.provider.resolveCustomEditor(j,b,C)}case 0:{const j=this.d.getDocument(S);return I.provider.resolveCustomTextEditor(j,b,C)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,o){this.i(s,r).disposeEdits(o)}async $onMoveCustomEditor(r,s,o){const g=this.b.get(o);if(!g)throw new Error(`No provider found for '${o}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const C=u.URI.revive(s),I=this.d.getDocument(C);await g.provider.moveCustomTextEditor(I,h,w.CancellationToken.None)}async $undo(r,s,o,g){return this.i(s,r).undo(o,g)}async $redo(r,s,o,g){return this.i(s,r).redo(o,g)}async $revert(r,s,o){const g=this.i(s,r);await this.j(s).revertCustomDocument(g.document,o),g.disposeBackup()}async $onSave(r,s,o){const g=this.i(s,r);await this.j(s).saveCustomDocument(g.document,o),g.disposeBackup()}async $onSaveAs(r,s,o,g){const h=this.i(s,r);return this.j(s).saveCustomDocumentAs(h.document,u.URI.revive(o),g)}async $backup(r,s,o){const g=this.i(s,r),C=await this.j(s).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},o);return g.updateBackup(C),C.id}i(r,s){const o=this.c.get(r,u.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(r){const o=this.b.get(r)?.provider;if(!o||!l(o))throw new Error("Custom document is not editable");return o}}e.$2dc=i;function l(n){return!!n.onDidChangeCustomDocument}function p(n){return typeof n.resolveCustomTextEditor=="function"}function E(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function m(n){const r=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,M.$Di)(r)+""}}),define(Ae[262],Re([1,0,5,6,2,36,8,64,3,7]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class R extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,d,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=d,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,P.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!d})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Sc{static c(){return(0,L.$eg)()}constructor($,d,t){super(),this.j=d,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(D.$lK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,d,t,i,l={}){const p=typeof i=="object"?i.viewColumn:i,E={viewColumn:A.ViewColumn.from(p),preserveFocus:typeof i=="object"&&!!i.preserveFocus},m=(0,u.$ndc)($),n=k.c();this.f.$createWebviewPanel((0,u.$pdc)($),n,d,{title:t,panelOptions:a(l),webviewOptions:(0,u.$qdc)($,this.m,l),serializeBuffersForPostMessage:m},E);const r=this.j.createNewWebview(n,l,$);return this.createNewWebviewPanel(n,d,t,p,l,r,!0)}$onDidChangeWebviewPanelViewStates($){const d=Object.keys($);d.sort((t,i)=>{const l=$[t],p=$[i];return l.active?1:p.active?-1:+l.visible-+p.visible});for(const t of d){const i=this.getWebviewPanel(t);if(!i)continue;const l=$[t];i._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,d,t){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:t,extension:$}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,u.$ndc)($)}),new f.$nK(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel($,d,t,i){const l=this.h.get(d);if(!l)throw new Error(`No serializer found for '${d}'`);const{serializer:p,extension:E}=l,m=this.j.createNewWebview($,t.webviewOptions,E),n=this.createNewWebviewPanel($,d,t.title,i,t.panelOptions,m,t.active);await p.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel($,d,t,i,l,p,E){const m=new R($,this.f,p,{viewType:d,title:t,viewColumn:i,panelOptions:l,active:E});return this.g.set($,m),m}getWebviewPanel($){return this.g.get($)}}e.$1dc=k;function a(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ae[263],Re([1,0,5,6,64,8,3,7]),function(be,e,w,M,P,L,A,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class D extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,a,v,$,d,t){super(),this.#u=!1,this.#a=this.B(new w.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$Nd),this.onDidDispose=this.#c.event,this.#i=v,this.#s=$,this.#e=k,this.#t=a,this.#l=d,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(k,a){this.d=a,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$lK.MainThreadWebviewViews)}registerWebviewViewProvider(k,a,v,$){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:v,extension:k}),this.a.$registerWebviewViewProvider((0,P.$pdc)(k),a,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$ndc)(k)}),new u.$nK(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(k,a,v,$,d){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:l}=t,p=this.d.createNewWebview(k,{},l),E=new D(k,this.a,a,v,p,!0);this.c.set(k,E),await i.resolveWebviewView(E,{state:$},d)}async $onDidChangeWebviewViewVisibility(k,a){this.e(k)._setVisible(a)}async $disposeWebviewView(k){const a=this.e(k);this.c.delete(k),a.dispose(),this.d.deleteWebview(k)}e(k){const a=this.c.get(k);if(!a)throw new Error("No webview found");return a}}e.$Zdc=f}),define(Ae[108],Re([1,0,5,3,2,13,16,4,17,22]),function(be,e,w,M,P,L,A,u,D,f){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=e.$rdc=void 0;let k=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(v){const $=this.d;return{get focused(){return $.focused},get active(){return(0,f.$hF)(v,"windowActivity"),$.active}}}constructor(v){this.c=new w.$Nd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=v.getProxy(M.$lK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:d})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,$){$!==this.d[v]&&(this.d={...this.d,[v]:$},this.c.fire(this.d))}openUri(v,$){let d;if(typeof v=="string"){d=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,A.$Be)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,d,$)}async asExternalUri(v,$){if((0,A.$Be)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(v,$);return P.URI.from(d)}};e.$rdc=k,e.$rdc=k=R=qe([Ke(0,D.$mM)],k),e.$sdc=(0,u.$Ph)("IExtHostWindow")}),define(Ae[264],Re([1,0,229,27,17]),function(be,e,w,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;let L=class extends w.$sec{constructor(u,D){super(u,D)}f(u,D,f){D.apply(console,f)}};e.$zgc=L,e.$zgc=L=qe([Ke(0,P.$mM),Ke(1,M.$CM)],L)}),define(Ae[265],Re([1,0,12,26,19,11,5,6,132,217,47]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$I4b=e.ResponsiveState=e.RequestInitiator=e.$H4b=e.$G4b=void 0;function a(b,S){try{return JSON.stringify(b,S)}catch{return"null"}}const v="$$ref$$",$={[v]:-1};class d{constructor(S,j){this.jsonString=S,this.referencedBuffers=j}}function t(b,S=null,j=!1){const O=[];return{jsonString:(j?a:JSON.stringify)(b,(B,T)=>{if(typeof T>"u")return $;if(typeof T=="object"){if(T instanceof M.$be){const z=O.push(T)-1;return{[v]:z}}if(S)return S(B,T)}return T}),referencedBuffers:O}}e.$G4b=t;function i(b,S,j){return JSON.parse(b,(O,K)=>{if(K){const B=K[v];if(typeof B=="number")return S[B];if(j&&K.$mid===1)return j.transformIncoming(K)}return K})}e.$H4b=i;function l(b,S){return JSON.stringify(b,S)}function p(b){return b?(S,j)=>j&&j.$mid===1?b.transformOutgoing(j):j:null}var E;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var m;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const n=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends u.$Sc{static{k=r}static{this.a=3*1e3}constructor(S,j=null,O=null){super(),this[k]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=S,this.f=j,this.g=O,this.h=p(this.g),this.j=!1,this.m=[],this.s=[];for(let K=0,B=R.$nv.count;K<B;K++)this.m[K]=null,this.s[K]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$6g(()=>this.H(),1e3)),this.c.onMessage(K=>this.L(K))}dispose(){this.j=!0,Object.keys(this.w).forEach(S=>{const j=this.w[S];delete this.w[S],j.resolveErr(L.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(S){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(S){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(S){this.y!==S&&(this.y=S,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(S){return this.g?(0,D.$Om)(S,this.g):S}getProxy(S){const{nid:j,sid:O}=S;return this.s[j]||(this.s[j]=this.J(j,O)),this.s[j]}J(S,j){const O={get:(K,B)=>(typeof B=="string"&&!K[B]&&B.charCodeAt(0)===36&&(K[B]=(...T)=>this.U(S,B,T)),B===s?j:K[B])};return new Proxy(Object.create(null),O)}set(S,j){return this.m[S.nid]=j,j}assertRegistered(S){for(let j=0,O=S.length;j<O;j++){const K=S[j];if(!this.m[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}L(S){if(this.j)return;const j=S.byteLength,O=h.read(S,0),K=O.readUInt8(),B=O.readUInt32();switch(K){case 1:case 2:{let{rpcId:T,method:z,args:ie}=I.deserializeRequestJSONArgs(O);this.g&&(ie=(0,D.$Om)(ie,this.g)),this.M(j,B,T,z,ie,K===2);break}case 3:case 4:{let{rpcId:T,method:z,args:ie}=I.deserializeRequestMixedArgs(O);this.g&&(ie=(0,D.$Om)(ie,this.g)),this.M(j,B,T,z,ie,K===4);break}case 5:{this.f?.logIncoming(j,B,0,"ack"),this.G(B);break}case 6:{this.N(j,B);break}case 7:{this.O(j,B,void 0);break}case 9:{let T=I.deserializeReplyOKJSON(O);this.g&&(T=(0,D.$Om)(T,this.g)),this.O(j,B,T);break}case 10:{const T=I.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(j,B,T);break}case 8:{const T=I.deserializeReplyOKVSBuffer(O);this.O(j,B,T);break}case 11:{let T=I.deserializeReplyErrError(O);this.g&&(T=(0,D.$Om)(T,this.g)),this.P(j,B,T);break}case 12:{this.P(j,B,void 0);break}default:console.error("received unexpected message"),console.error(S)}}M(S,j,O,K,B,T){this.f?.logIncoming(S,j,1,`receiveRequest ${(0,R.$pv)(O)}.${K}(`,B);const z=String(j);let ie,X;if(T){const Pe=new P.$Xd;B.push(Pe.token),ie=this.Q(O,K,B),X=()=>Pe.cancel()}else ie=this.Q(O,K,B),X=n;this.u[z]=X;const De=I.serializeAcknowledged(j);this.f?.logOutgoing(De.byteLength,j,1,"ack"),this.c.send(De),ie.then(Pe=>{delete this.u[z];const ke=I.serializeReplyOK(j,Pe,this.h);this.f?.logOutgoing(ke.byteLength,j,1,"reply:",Pe),this.c.send(ke)},Pe=>{delete this.u[z];const ke=I.serializeReplyErr(j,Pe);this.f?.logOutgoing(ke.byteLength,j,1,"replyErr:",Pe),this.c.send(ke)})}N(S,j){this.f?.logIncoming(S,j,1,"receiveCancel");const O=String(j);this.u[O]?.()}O(S,j,O){this.f?.logIncoming(S,j,0,"receiveReply:",O);const K=String(j);if(!this.w.hasOwnProperty(K))return;const B=this.w[K];delete this.w[K],B.resolveOk(O)}P(S,j,O){this.f?.logIncoming(S,j,0,"receiveReplyErr:",O);const K=String(j);if(!this.w.hasOwnProperty(K))return;const B=this.w[K];delete this.w[K];let T;O&&(O.$isError?(T=new Error,T.name=O.name,T.message=O.message,T.stack=O.stack):T=O),B.resolveErr(T)}Q(S,j,O){try{return Promise.resolve(this.S(S,j,O))}catch(K){return Promise.reject(K)}}S(S,j,O){const K=this.m[S];if(!K)throw new Error("Unknown actor "+(0,R.$pv)(S));const B=K[j];if(typeof B!="function")throw new Error("Unknown method "+j+" on actor "+(0,R.$pv)(S));return B.apply(K,O)}U(S,j,O){if(this.j)return new f.$F4b;let K=null;if(O.length>0&&P.CancellationToken.isCancellationToken(O[O.length-1])&&(K=O.pop()),K&&K.isCancellationRequested)return Promise.reject(L.$6());const B=I.serializeRequestArguments(O,this.h),T=++this.t,z=String(T),ie=new f.$E4b,X=new u.$Rc;K&&X.add(K.onCancellationRequested(()=>{const Pe=I.serializeCancel(T);this.f?.logOutgoing(Pe.byteLength,T,0,"cancel"),this.c.send(I.serializeCancel(T))})),this.w[z]=new g(ie,X),this.F(T);const De=I.serializeRequest(T,S,j,B,!!K);return this.f?.logOutgoing(De.byteLength,T,0,`request: ${(0,R.$pv)(S)}.${j}(`,O),this.c.send(De),ie}}e.$I4b=o;class g{constructor(S,j){this.a=S,this.b=j}resolveOk(S){this.a.resolveOk(S),this.b.dispose()}resolveErr(S){this.a.resolveErr(S),this.b.dispose()}}class h{static alloc(S,j,O){const K=new h(M.$be.alloc(O+1+4),0);return K.writeUInt8(S),K.writeUInt32(j),K}static read(S,j){return new h(S,j)}get buffer(){return this.a}constructor(S,j){this.a=S,this.b=j}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(S){this.a.writeUInt8(S,this.b),this.b+=1}readUInt8(){const S=this.a.readUInt8(this.b);return this.b+=1,S}writeUInt32(S){this.a.writeUInt32BE(S,this.b),this.b+=4}readUInt32(){const S=this.a.readUInt32BE(this.b);return this.b+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this.a.writeUInt8(S.byteLength,this.b),this.b+=1,this.a.set(S,this.b),this.b+=S.byteLength}readShortString(){const S=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+S).toString();return this.b+=S,O}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}readLongString(){const S=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+S).toString();return this.b+=S,O}writeBuffer(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}readVSBuffer(){const S=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+S);return this.b+=S,j}static sizeMixedArray(S){let j=0;j+=1;for(let O=0,K=S.length;O<K;O++){const B=S[O];switch(j+=1,B.type){case 1:j+=this.sizeLongString(B.value);break;case 2:j+=this.sizeVSBuffer(B.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(B.value);for(let T=0;T<B.buffers.length;++T)j+=this.sizeVSBuffer(B.buffers[T]);break;case 4:break}}return j}writeMixedArray(S){this.a.writeUInt8(S.length,this.b),this.b+=1;for(let j=0,O=S.length;j<O;j++){const K=S[j];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let B=0;B<K.buffers.length;++B)this.writeBuffer(K.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this.a.readUInt8(this.b);this.b+=1;const j=new Array(S);for(let O=0;O<S;O++)switch(this.readUInt8()){case 1:j[O]=this.readLongString();break;case 2:j[O]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),T=this.readLongString(),z=[];for(let ie=0;ie<B;++ie)z.push(this.readVSBuffer());j[O]=new R.$qv(i(T,z,null));break}case 4:j[O]=void 0;break}return j}}var C;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(C||(C={}));class I{static a(S){for(let j=0,O=S.length;j<O;j++)if(S[j]instanceof M.$be||S[j]instanceof R.$qv||typeof S[j]>"u")return!0;return!1}static serializeRequestArguments(S,j){if(this.a(S)){const O=[];for(let K=0,B=S.length;K<B;K++){const T=S[K];if(T instanceof M.$be)O[K]={type:2,value:T};else if(typeof T>"u")O[K]={type:4};else if(T instanceof R.$qv){const{jsonString:z,referencedBuffers:ie}=t(T.value,j);O[K]={type:3,value:M.$be.fromString(z),buffers:ie}}else O[K]={type:1,value:M.$be.fromString(l(T,j))}}return{type:1,args:O}}return{type:0,args:l(S,j)}}static serializeRequest(S,j,O,K,B){switch(K.type){case 0:return this.b(S,j,O,K.args,B);case 1:return this.c(S,j,O,K.args,B)}}static b(S,j,O,K,B){const T=M.$be.fromString(O),z=M.$be.fromString(K);let ie=0;ie+=h.sizeUInt8(),ie+=h.sizeShortString(T),ie+=h.sizeLongString(z);const X=h.alloc(B?2:1,S,ie);return X.writeUInt8(j),X.writeShortString(T),X.writeLongString(z),X.buffer}static deserializeRequestJSONArgs(S){const j=S.readUInt8(),O=S.readShortString(),K=S.readLongString();return{rpcId:j,method:O,args:JSON.parse(K)}}static c(S,j,O,K,B){const T=M.$be.fromString(O);let z=0;z+=h.sizeUInt8(),z+=h.sizeShortString(T),z+=h.sizeMixedArray(K);const ie=h.alloc(B?4:3,S,z);return ie.writeUInt8(j),ie.writeShortString(T),ie.writeMixedArray(K),ie.buffer}static deserializeRequestMixedArgs(S){const j=S.readUInt8(),O=S.readShortString(),K=S.readMixedArray(),B=new Array(K.length);for(let T=0,z=K.length;T<z;T++){const ie=K[T];typeof ie=="string"?B[T]=JSON.parse(ie):B[T]=ie}return{rpcId:j,method:O,args:B}}static serializeAcknowledged(S){return h.alloc(5,S,0).buffer}static serializeCancel(S){return h.alloc(6,S,0).buffer}static serializeReplyOK(S,j,O){if(typeof j>"u")return this.d(S);if(j instanceof M.$be)return this.e(S,j);if(j instanceof R.$qv){const{jsonString:K,referencedBuffers:B}=t(j.value,O,!0);return this.g(S,K,B)}else return this.f(S,a(j,O))}static d(S){return h.alloc(7,S,0).buffer}static e(S,j){let O=0;O+=h.sizeVSBuffer(j);const K=h.alloc(8,S,O);return K.writeVSBuffer(j),K.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static f(S,j){const O=M.$be.fromString(j);let K=0;K+=h.sizeLongString(O);const B=h.alloc(9,S,K);return B.writeLongString(O),B.buffer}static g(S,j,O){const K=M.$be.fromString(j);let B=0;B+=h.sizeUInt32,B+=h.sizeLongString(K);for(const z of O)B+=h.sizeVSBuffer(z);const T=h.alloc(10,S,B);T.writeUInt32(O.length),T.writeLongString(K);for(const z of O)T.writeBuffer(z);return T.buffer}static deserializeReplyOKJSON(S){const j=S.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(S,j){const O=S.readUInt32(),K=S.readLongString(),B=[];for(let T=0;T<O;++T)B.push(S.readVSBuffer());return new R.$qv(i(K,B,j))}static serializeReplyErr(S,j){const O=j?a(L.$3(j),null):void 0;if(typeof O!="string")return this.h(S);const K=M.$be.fromString(O);let B=0;B+=h.sizeLongString(K);const T=h.alloc(11,S,B);return T.writeLongString(K),T.buffer}static deserializeReplyErrError(S){const j=S.readLongString();return JSON.parse(j)}static h(S){return h.alloc(12,S,0).buffer}}var c;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var y;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(y||(y={}))}),define(Ae[266],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;const w=function(L){const A=u=>{globalThis.removeEventListener("message",A);const D=u.data;Object.defineProperties(globalThis,{postMessage:{value(f,R){D.postMessage(f,R)}},onmessage:{get(){return D.onmessage},set(f){D.onmessage=f}}}),D.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(L,A,u){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${w})('${A}'))`,f=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(f),k=new MessageChannel,a=R,v={type:"_newWorker",id:a,port:k.port2,url:R,options:u};L(v,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{L({type:"_terminateWorker",id:a}),URL.revokeObjectURL(R),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set($){k.port1.onmessage=$}},onmessageerror:{get(){return k.port1.onmessageerror},set($){k.port1.onmessageerror=$}}}),k.port1.addEventListener("messageerror",$=>{const d=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(d)}),k.port1.addEventListener("message",$=>{const d=new MessageEvent("message",{data:$.data});this.dispatchEvent(d)}),k.port1.start()}}e.$Bgc=M}),define(Ae[267],Re([1,0,5,30,32,4]),function(be,e,w,M,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.OutputChannelUpdateMode=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=void 0,e.$wJ="text/x-code-output",e.$xJ="output",e.$yJ="Log",e.$zJ="text/x-code-log-output",e.$AJ="log",e.$BJ="workbench.panel.output",e.$CJ=new P.$7i("inOutput",!1),e.$DJ=new P.$7i("activeLogOutput",!1),e.$EJ=new P.$7i("outputView.scrollLock",!1),e.$FJ=(0,L.$Ph)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$GJ={OutputChannels:"workbench.contributions.outputChannels"};class u{constructor(){this.a=new Map,this.b=new w.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new w.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(R=>f.push(R)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}M.$gn.add(e.$GJ.OutputChannels,new u),e.$HJ=new P.$7i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,21,14,267,62,27,40,129,26,15,39,5,6]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=void 0;class i extends A.$dj{get disposed(){return this.n}constructor(m,n,r,s,o){super(),this.id=m,this.name=n,this.r=r,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(m){this.append(m+`
`)}append(m){this.info(m)}clear(){const m=this.m;this.r.flush(),this.s.$update(this.id,u.OutputChannelUpdateMode.Clear,m)}replace(m){const n=this.m;this.info(m),this.s.$update(this.id,u.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(m,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof m=="boolean"?m:n))}hide(){this.s.$close(this.id)}g(m,n){this.m+=a.$be.fromString(n).byteLength,(0,A.log)(this.r,m,n),this.visible&&(this.r.flush(),this.s.$update(this.id,u.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends i{appendLine(m){this.append(m)}}let p=class{constructor(m,n,r,s,o,g){this.i=n,this.j=r,this.k=s,this.l=o,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=m.getProxy(w.$lK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.$em)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.h=m;for(const[n,r]of this.g)r.visible=n===this.h}createOutputChannel(m,n,r){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,v.$yf)(n)?n:void 0;if((0,v.$yf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const h=this.i.environment.extensionLogLevel?.find(([I])=>L.$6l.equals(r.identifier,I))?.[1];h&&(g=(0,A.$nj)(h));const C=s?this.o(m,g,r):this.n(m,o,r);return C.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),s?this.r(m,g??this.m.getLevel(),C):this.q(m,C)}async n(m,n,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(m,o,n,r.identifier.value);return new i(h,m,g,this.a,r)}async o(m,n,r){const s=await this.p(r),o=m.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(s,`${o}.log`),h=`${r.identifier.value}.${o}`,C=this.l.createLogger(g,{id:h,name:m,logLevel:n,extensionId:r.identifier.value});return new l(h,m,C,this.a,r)}p(m){let n=this.d.get(m.identifier.value);if(!n){const r=this.k.extUri.joinPath(this.i.logsLocation,m.identifier.value);this.d.set(m.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(r)}catch(s){if((0,$.$ok)(s)!==$.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return n}q(m,n){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return m},append(o){s(),n.then(g=>g.append(o))},appendLine(o){s(),n.then(g=>g.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(g=>g.replace(o))},show(o,g){s(),n.then(h=>h.show(o,g))},hide(){s(),n.then(o=>o.hide())},dispose(){r=!0,n.then(o=>o.dispose())}}}r(m,n,r){const s=new t.$Rc,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},g=s.add(new d.$Nd);function h(C){n=C,g.fire(C)}return r.then(C=>{s.add(C),C.logLevel!==n&&h(C.logLevel),s.add(C.onDidChangeLogLevel(I=>h(I)))}),{...this.q(m,r),get logLevel(){return n},onDidChangeLogLevel:g.event,trace(C,...I){o(),r.then(c=>c.trace(C,...I))},debug(C,...I){o(),r.then(c=>c.debug(C,...I))},info(C,...I){o(),r.then(c=>c.info(C,...I))},warn(C,...I){o(),r.then(c=>c.warn(C,...I))},error(C,...I){o(),r.then(c=>c.error(C,...I))},dispose(){s.dispose()}}}};e.$bdc=p,e.$bdc=p=qe([Ke(0,P.$mM),Ke(1,f.$CM),Ke(2,D.$Qcc),Ke(3,R.$lcc),Ke(4,A.$$i),Ke(5,A.$0i)],p),e.$cdc=(0,M.$Ph)("IExtHostOutputService")}),define(Ae[268],Re([1,0,4,12]),function(be,e,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$tm=(0,w.$Ph)("remoteAgentService"),e.$um=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let L=1/0;for(let u=0;u<this.maxSampleCount;u++){const D=await P.getRoundTripTime();if(D===void 0)return;L=Math.min(L,D/2),await(0,M.$Ug)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((u,D)=>u+D,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((u,D)=>u+D,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[269],Re([1,0,44,13,20,23,24,2,4,187,56,204,268]),function(be,e,w,M,P,L,A,u,D,f,R,k,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=void 0,e.$ZJ=(0,D.$Ph)("pathService");let $=v=class{constructor(t,i,l,p){this.d=t,this.e=i,this.f=l,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,l){return typeof i=="string"||typeof i>"u"?this.a.then(p=>this.h(t,p,i)):this.h(t,i,l)}h(t,i,l){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,w.$Vf)(l??(0,A.$sg)(t),i===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const l=(0,f.$WJ)(i.getWorkspace());if(l)return l;const p=i.getWorkspace().folders[0];if(p)return p.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$fc:P.$gc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const p=t.indexOf("/",2);p===-1?(i=t.substring(2),t="/"):(i=t.substring(2,p),t=t.substring(p)||"/")}return u.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$1J=$,e.$1J=$=v=qe([Ke(1,a.$tm),Ke(2,k.$IJ),Ke(3,R.$Yh)],$)}),define(Ae[110],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GI=e.$FI=void 0;class w{constructor(A,u){this.line=A,this.character=u}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,u){return new w(0,0)}with(A){return new w(0,0)}}e.$FI=w;class M{constructor(A,u,D,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,u),this.end=new w(D,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$GI=M;var P;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ae[49],Re([1,0,18,38,25,44,16,4,20,11,110,12]),function(be,e,w,M,P,L,A,u,D,f,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.SearchErrorCode=e.$VI=e.$UI=e.SearchSortOrder=e.ViewMode=e.$TI=e.$SI=e.$RI=e.$QI=e.SearchCompletionExitCode=e.$PI=e.$OI=e.$NI=e.QueryType=e.SearchProviderType=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$HI="workbench.view.search",e.$II="workbench.panel.search",e.$JI="workbench.view.search",e.$KI="search-result",e.$LI="search.exclude";const a="\u27EA ",v=" characters skipped \u27EB",$=(a.length+v.length+5)*2;e.$MI=(0,u.$Ph)("searchService");var d;(function($e){$e[$e.file=0]="file",$e[$e.text=1]="text"})(d||(e.SearchProviderType=d={}));var t;(function($e){$e[$e.File=1]="File",$e[$e.Text=2]="Text"})(t||(e.QueryType=t={}));function i($e){return!!$e.preview}e.$NI=i;function l($e){return!!$e.resource}e.$OI=l;function p($e){return!!$e.message}e.$PI=p;var E;(function($e){$e[$e.Normal=0]="Normal",$e[$e.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class m{constructor(ye){this.resource=ye,this.results=[]}}e.$QI=m;class n{constructor(ye,ue,ae,we){this.ranges=ue,this.webviewIndex=we;const _=Array.isArray(ue)?ue:[ue];if(ae&&ae.matchLines===1&&r(_)){ye=(0,A.$rf)(ye,ae.matchLines);let W="",Z=0,ee=0;const pe=Math.floor(ae.charsPerLine/5),me=[];for(const he of _){const Ee=Math.max(he.startColumn-pe,0),re=he.startColumn+ae.charsPerLine;if(Ee>ee+pe+$){const le=a+(Ee-ee)+v;W+=le+ye.slice(Ee,re),Z+=Ee-(ee+le.length)}else W+=ye.slice(ee,re);me.push(new o(0,he.startColumn-Z,he.endColumn-Z)),ee=re}this.preview={text:W,matches:Array.isArray(this.ranges)?me:me[0]}}else{const W=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:ye,matches:(0,w.$2b)(ue,Z=>new s(Z.startLineNumber-W,Z.startColumn,Z.endLineNumber-W,Z.endColumn))}}}}e.$RI=n;function r($e){const ye=$e[0].startLineNumber;for(const ue of $e)if(ue.startLineNumber!==ye||ue.endLineNumber!==ye)return!1;return!0}class s{constructor(ye,ue,ae,we){this.startLineNumber=ye,this.startColumn=ue,this.endLineNumber=ae,this.endColumn=we}}e.$SI=s;class o extends s{constructor(ye,ue,ae){super(ye,ue,ye,ae)}}e.$TI=o;var g;(function($e){$e.List="list",$e.Tree="tree"})(g||(e.ViewMode=g={}));var h;(function($e){$e.Default="default",$e.FileNames="fileNames",$e.Type="type",$e.Modified="modified",$e.CountDescending="countDescending",$e.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function C($e,ye=!0){const ue=$e&&$e.files&&$e.files.exclude,ae=ye&&$e&&$e.search&&$e.search.exclude;if(!ue&&!ae)return;if(!ue||!ae)return ue||ae;let we=Object.create(null);return we=P.$0m(we,P.$7m(ue)),we=P.$0m(we,P.$7m(ae),!0),we}e.$UI=C;function I($e,ye){return $e.excludePattern&&M.$vj($e.excludePattern,ye)?!1:$e.includePattern||$e.usingSearchPaths?$e.includePattern&&M.$vj($e.includePattern,ye)?!0:$e.usingSearchPaths?!!$e.folderQueries&&$e.folderQueries.some(ue=>{const ae=ue.folder.fsPath;if(L.$Xf(ye,ae)){const we=D.$lc(ae,ye);return!ue.includePattern||!!M.$vj(ue.includePattern,we)}else return!1}):!1:!0}e.$VI=I;var c;(function($e){$e[$e.unknownEncoding=1]="unknownEncoding",$e[$e.regexParseError=2]="regexParseError",$e[$e.globParseError=3]="globParseError",$e[$e.invalidLiteral=4]="invalidLiteral",$e[$e.rgProcessError=5]="rgProcessError",$e[$e.other=6]="other",$e[$e.canceled=7]="canceled"})(c||(e.SearchErrorCode=c={}));class y extends Error{constructor(ye,ue){super(ye),this.code=ue}}e.$WI=y;function b($e){const ye=$e.message;if((0,f.$4)($e))return new y(ye,c.canceled);try{const ue=JSON.parse(ye);return new y(ue.message,ue.code)}catch{return new y(ye,c.other)}}e.$XI=b;function S($e){const ye={message:$e.message,code:$e.code};return new Error(JSON.stringify(ye))}e.$YI=S;function j($e){return $e.type==="error"?!0:$e.type==="success"}e.$ZI=j;function O($e){return $e.type==="success"}e.$1I=O;function K($e){return!!$e.path}e.$2I=K;function B($e,ye){const ue=$e.searchPath?$e.searchPath:$e.relativePath;return(0,A.$of)(ue,ye)}e.$3I=B;class T{constructor(ye){this.path=ye,this.results=[]}addMatch(ye){this.results.push(ye)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$4I=T;function z($e,ye){const ue={...$e||{},...ye||{}};return Object.keys(ue).filter(ae=>{const we=ue[ae];return typeof we=="boolean"&&we})}e.$5I=z;class ie{constructor(ye,ue){this.c=null,this.a={...ye.excludePattern||{},...ue.excludePattern||{}},this.b=M.$wj(this.a);let ae=ye.includePattern;ue.includePattern&&(ae?ae={...ae,...ue.includePattern}:ae=ue.includePattern),ae&&(this.c=M.$wj(ae))}matchesExcludesSync(ye,ue,ae){return!!(this.b&&this.b(ye,ue,ae))}includedInQuerySync(ye,ue,ae){return!(this.b&&this.b(ye,ue,ae)||this.c&&!this.c(ye,ue,ae))}includedInQuery(ye,ue,ae){const we=this.b(ye,ue,ae),_=()=>this.c?!!this.c(ye,ue,ae):!0;return(0,k.$Gg)(we)?we.then(W=>W?!1:_()):_()}hasSiblingExcludeClauses(){return X(this.a)}}e.$6I=ie;function X($e){for(const ye in $e)if(typeof $e[ye]!="boolean")return!0;return!1}function De($e){if(!$e)return;let ye;return ue=>(ye||(ye=($e()||Promise.resolve([])).then(ae=>ae?ke(ae):{})),ye.then(ae=>!!ae[ue]))}e.$7I=De;function Pe($e){if(!$e)return;let ye;return ue=>{if(!ye){const ae=$e();ye=ae?ke(ae):{}}return!!ye[ue]}}e.$8I=Pe;function ke($e){const ye={};for(const ue of $e)ye[ue]=!0;return ye}}),define(Ae[33],Re([1,0,18,12,19,5,6,50,13,117,24,16,2,159,4,14,176,56,40,27,17,8,7,57,49,3]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m,n,r,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;function g(j,O,K){return new R.$kg(B=>c(B,K)).isEqual(j,O)}function h(j,O,K){return g(j.uri,O.uri,K)?0:(0,k.$Ue)(j.uri.toString(),O.uri.toString())}function C(j,O,K){return j.index!==O.index?j.index<O.index?-1:1:g(j.uri,O.uri,K)?(0,k.$Ue)(j.name,O.name):(0,k.$Ue)(j.uri.toString(),O.uri.toString())}function I(j,O,K,B){const T=j.slice(0).sort((ie,X)=>K(ie,X,B)),z=O.slice(0).sort((ie,X)=>K(ie,X,B));return(0,w.$Eb)(T,z,(ie,X)=>K(ie,X,B))}function c(j,O){const K=O.getCapabilities(j.scheme);return!(K&&K&1024)}class y extends i.$9h{static toExtHostWorkspace(O,K,B,T){if(!O)return{workspace:null,added:[],removed:[]};const{id:z,name:ie,folders:X,configuration:De,transient:Pe,isUntitled:ke}=O,$e=[],ye=K;K?X.forEach((_,W)=>{const Z=a.URI.revive(_.uri),ee=y.o(B||K,Z,T);ee?(ee.name=_.name,ee.index=_.index,$e.push(ee)):$e.push({uri:Z,name:_.name,index:W})}):$e.push(...X.map(({uri:_,name:W,index:Z})=>({uri:a.URI.revive(_),name:W,index:Z}))),$e.sort((_,W)=>_.index<W.index?-1:1);const ue=new y(z,ie,$e,!!Pe,De?a.URI.revive(De):null,!!ke,_=>c(_,T)),{added:ae,removed:we}=I(ye?ye.workspaceFolders:[],ue.workspaceFolders,h,T);return{workspace:ue,added:ae,removed:we}}static o(O,K,B){for(let T=0;T<O.folders.length;T++){const z=O.workspaceFolders[T];if(g(z.uri,K,B))return z}}constructor(O,K,B,T,z,ie,X){super(O,B.map(De=>new i.$0h(De)),T,z,X),this.t=K,this.u=ie,this.q=[],this.s=u.$Vh.forUris(X),B.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,K){return K&&this.s.get(O)&&(O=(0,R.$ug)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let b=class{constructor(O,K,B,T,z){this.c=new L.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Pd,this.B=new Map,this.h=T,this.s=B,this.t=z,this.j=new f.$Ql,this.k=new M.$Sg,this.o=O.getProxy(o.$lK.MainThreadWorkspace),this.q=O.getProxy(o.$lK.MainThreadMessageService);const ie=K.workspace;this.l=ie?new y(ie.id,ie.name,[],!!ie.transient,ie.configuration?a.URI.revive(ie.configuration):null,!!ie.isUntitled,X=>c(X,B)):void 0}$initializeWorkspace(O,K){this.v=K,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,R.$sg)((0,R.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,K,B,...T){const z=[];if(Array.isArray(T)&&T.forEach(ke=>{a.URI.isUri(ke.uri)&&!z.some($e=>g($e.uri,ke.uri,this.s))&&z.push({uri:ke.uri,name:ke.name||(0,R.$rg)(ke.uri)})}),this.n||[K,B].some(ke=>typeof ke!="number"||ke<0)||B===0&&z.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(K+B>ie.length)return!1;const X=ie.slice(0);X.splice(K,B,...z.map(ke=>({uri:ke.uri,name:ke.name||(0,R.$rg)(ke.uri),index:void 0})));for(let ke=0;ke<X.length;ke++){const $e=X[ke];if(X.some((ye,ue)=>ue!==ke&&g($e.uri,ye.uri,this.s)))return!1}X.forEach((ke,$e)=>ke.index=$e);const{added:De,removed:Pe}=I(ie,X,C,this.s);if(De.length===0&&Pe.length===0)return!1;if(this.o){const ke=O.displayName||O.name;this.o.$updateWorkspaceFolders(ke,K,B,z).then(void 0,$e=>{this.n=void 0;const ye={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(t.Severity.Error,(0,v.localize)(0,null,ke,$e.toString()),ye,[])})}return this.y(X),!0}getWorkspaceFolder(O,K){if(this.x)return this.x.getWorkspaceFolder(O,K)}async getWorkspaceFolder2(O,K){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,K)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,K){let B,T="";if(typeof O=="string"?(B=a.URI.file(O),T=O):typeof O<"u"&&(B=O,T=O.fsPath),!B)return T;const z=this.getWorkspaceFolder(B,!0);if(!z)return T;typeof K>"u"&&this.x&&(K=this.x.folders.length>1);let ie=(0,R.$xg)(z.uri,B);return K&&z.name&&(ie=`${z.name}/${ie}`),ie}y(O){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:K,added:B,removed:T}=y.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=K||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:T}))}findFiles(O,K,B,T,z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let ie;if(K===null?ie=!1:K&&(typeof K=="string"?ie=K:ie=K.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:X,folder:De}=S(m.GlobPattern.from(O));return this.o.$startFileSearch(X??null,De??null,ie??null,B??null,z).then(Pe=>Array.isArray(Pe)?Pe.map(ke=>a.URI.revive(ke)):[])}async findTextInFiles(O,K,B,T,z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),X=typeof K.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:K.previewOptions,{includePattern:De,folder:Pe}=S(m.GlobPattern.from(K.include)),ke=typeof K.exclude=="string"?K.exclude:K.exclude?K.exclude.pattern:void 0,$e={ignoreSymlinks:typeof K.followSymlinks=="boolean"?!K.followSymlinks:void 0,disregardIgnoreFiles:typeof K.useIgnoreFiles=="boolean"?!K.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof K.useGlobalIgnoreFiles=="boolean"?!K.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof K.useParentIgnoreFiles=="boolean"?!K.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof K.useDefaultExcludes=="boolean"?!K.useDefaultExcludes:!0,fileEncoding:K.encoding,maxResults:K.maxResults,previewOptions:X,afterContext:K.afterContext,beforeContext:K.beforeContext,includePattern:De,excludePattern:ke},ye=!1;if(this.u[ie]=ue=>{if(ye)return;const ae=a.URI.revive(ue.resource);ue.results.forEach(we=>{(0,s.$NI)(we)?B({uri:ae,preview:{text:we.preview.text,matches:(0,w.$2b)(we.preview.matches,_=>new n.$pK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,w.$2b)(we.ranges,_=>new n.$pK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):B({uri:ae,text:we.text,lineNumber:we.lineNumber})})},z.isCancellationRequested)return{};try{const ue=await this.o.$startTextSearch(O,Pe??null,$e,ie,z);return delete this.u[ie],ue||{}}catch(ue){throw delete this.u[ie],ue}}$handleTextSearchResult(O,K){this.u[K]?.(O)}async save(O){const K=await this.o.$save(O,{saveAs:!1});return a.URI.revive(K)}async saveAs(O){const K=await this.o.$save(O,{saveAs:!0});return a.URI.revive(K)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,K){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,K);const B=this.t.transformOutgoingScheme(O),T=this.z++;return this.o.$registerEditSessionIdentityProvider(T,B),(0,A.$Qc)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(O,K){this.h.info("Getting edit session identifier for workspaceFolder",O);const B=await this.resolveWorkspaceFolder(a.URI.revive(O));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const T=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!T),!T)return;const z=await T.provideEditSessionIdentity(B,K);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(O,K,B,T){this.h.info("Getting edit session identifier for workspaceFolder",O);const z=await this.resolveWorkspaceFolder(a.URI.revive(O));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const ie=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!ie),!ie)return;const X=await ie.provideEditSessionIdentityMatch?.(K,B,T);if(this.h.info("Provider returned edit session identifier match result: ",X),!!X)return X}getOnWillCreateEditSessionIdentityEvent(O){return(K,B,T)=>{const z=function(X){K.call(B,X)};return z.extension=O,this.A.event(z,void 0,T)}}async $onWillCreateEditSessionIdentity(O,K,B){const T=await this.resolveWorkspaceFolder(a.URI.revive(O));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:T},K,async(z,ie)=>{const X=Date.now();await Promise.resolve(z),Date.now()-X>B&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),K.isCancellationRequested}registerCanonicalUriProvider(O,K){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,K);const B=this.t.transformOutgoingScheme(O),T=this.z++;return this.o.$registerCanonicalUriProvider(T,B),(0,A.$Qc)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(O,K,B){const T=this.B.get(O.scheme);if(!T)return;const z=await T.provideCanonicalUri?.(a.URI.revive(O),K,B);if(z)return z}async $provideCanonicalUri(O,K,B){return this.provideCanonicalUri(a.URI.revive(O),{targetScheme:K},B)}};e.$xcc=b,e.$xcc=b=qe([Ke(0,E.$mM),Ke(1,p.$CM),Ke(2,l.$lcc),Ke(3,d.$0i),Ke(4,r.$vcc)],b),e.$ycc=(0,$.$Ph)("IExtHostWorkspace");function S(j){let O,K;return j&&(typeof j=="string"?O=j:(O=j.pattern,K=a.URI.revive(j.baseUri))),{includePattern:O,folder:K}}}),define(Ae[34],Re([1,0,25,5,33,3,7,178,96,15,12,4,17,14,2]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=e.$Acc=e.$zcc=void 0;function d(r,s){if(s){const o=s.split(".");let g=r;for(let h=0;g&&h<o.length;h++)g=g[o[h]];return g}}function t(r){return r instanceof $.URI}function i(r){return r&&r.uri instanceof $.URI&&r.languageId&&typeof r.languageId=="string"}function l(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function p(r){return r&&r.uri instanceof $.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function E(r){if(t(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(l(r))return{overrideIdentifier:r.languageId};if(p(r))return{resource:r.uri};if(r===null)return{resource:null}}let m=class{constructor(s,o,g){this.a=s.getProxy(L.$lK.MainThreadConfiguration),this.c=o,this.b=g,this.d=new R.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(s,o))}};e.$zcc=m,e.$zcc=m=qe([Ke(0,a.$mM),Ke(1,P.$ycc),Ke(2,v.$0i)],m);class n{constructor(s,o,g,h){this.a=new M.$Nd,this.b=s,this.f=h,this.c=o,this.e=u.$En.parse(g),this.d=this.k(g.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const g={data:this.e.toData(),workspace:this.c.workspace};this.e=u.$En.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,g))}getConfiguration(s,o,g){const h=E(o)||{},C=this.g(s?d(this.e.getValue(void 0,h,this.c.workspace),s):this.e.getValue(void 0,h,this.c.workspace));s&&this.h(s,h,g?.identifier);function I(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const c={has(y){return typeof d(C,y)<"u"},get:(y,b)=>{this.h(s?`${s}.${y}`:y,h,g?.identifier);let S=d(C,y);if(typeof S>"u")S=b;else{let j;const O=(K,B)=>{if((0,f.$Af)(K)){let T;const z=()=>{j=j||(0,w.$7m)(C),T=T||d(j,B)};return new Proxy(K,{get:(ie,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return z(),()=>T;if(j)return T=T||d(j,B),T[X];const De=ie[X];return typeof X=="string"?O(De,`${B}.${X}`):De},set:(ie,X,De)=>(z(),T&&(T[X]=De),!0),deleteProperty:(ie,X)=>(z(),T&&delete T[X],!0),defineProperty:(ie,X,De)=>(z(),T&&Object.defineProperty(T,X,De),!0)})}return Array.isArray(K)?(0,w.$7m)(K):K};S=O(S,y)}return S},update:(y,b,S,j)=>{y=s?`${s}.${y}`:y;const O=I(S);return b!==void 0?this.b.$updateConfigurationOption(O,y,b,h,j):this.b.$removeConfigurationOption(O,y,h,j)},inspect:y=>{y=s?`${s}.${y}`:y;const b=this.e.inspect(y,h,this.c.workspace);if(b)return{key:y,defaultValue:(0,w.$7m)(b.policy?.value??b.default?.value),globalValue:(0,w.$7m)(b.user?.value??b.application?.value),workspaceValue:(0,w.$7m)(b.workspace?.value),workspaceFolderValue:(0,w.$7m)(b.workspaceFolder?.value),defaultLanguageValue:(0,w.$7m)(b.default?.override),globalLanguageValue:(0,w.$7m)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,w.$7m)(b.workspace?.override),workspaceFolderLanguageValue:(0,w.$7m)(b.workspaceFolder?.override),languageIds:(0,w.$7m)(b.overrideIdentifiers)}}};return typeof C=="object"&&(0,w.$0m)(c,C,!1),Object.freeze(c)}g(s){const o=g=>(0,f.$Af)(g)?new Proxy(g,{get:(h,C)=>o(h[C]),set:(h,C,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(C)}' of object`)},deleteProperty:(h,C)=>{throw new Error(`TypeError: Cannot delete read only property '${String(C)}' of object`)},defineProperty:(h,C)=>{throw new Error(`TypeError: Cannot define property '${String(C)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return o(s)}h(s,o,g){const h=D.$vn.test(s)?4:this.d.get(s),C=g?`[${g.value}] `:"";if(h===4){typeof o?.resource>"u"&&this.f.warn(`${C}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){o?.resource&&this.f.warn(`${C}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const g=new u.$Gn(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,C)=>g.affectsConfiguration(h,E(C))})}k(s){return s.reduce((o,g)=>(o.set(g[0],g[1]),o),new Map)}}e.$Acc=n,e.$Bcc=(0,k.$Ph)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,19,63,17,27,4,13,23,14,80,216,11]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=e.$xdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var m;(function(O){function K(T){if(T!=null)return T}O.from=K;function B(T){if(T!=null)return T}O.to=B})(m||(m={}));var n;(function(O){function K(T){if(T!=null)return T}O.from=K;function B(T){if(T!=null)return T}O.to=B})(n||(n={}));var r;(function(O){function K(T){if(T!=null)return T}O.from=K;function B(T){if(T!=null)return T}O.to=B})(r||(r={}));var s;(function(O){function K(z){if(z){const ie=z;return ie&&!!ie.process}else return!1}O.is=K;function B(z){if(z==null)return;const ie={process:z.process,args:z.args};return z.options&&(ie.options=r.from(z.options)),ie}O.from=B;function T(z){if(z!=null)return new A.$8K(z.process,z.args,z.options)}O.to=T})(s||(s={}));var o;(function(O){function K(T){if(T!=null)return T}O.from=K;function B(T){if(T!=null)return T}O.to=B})(o||(o={}));var g;(function(O){function K(z){if(z){const ie=z;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}O.is=K;function B(z){if(z==null)return;const ie={};return z.commandLine!==void 0?ie.commandLine=z.commandLine:(ie.command=z.command,ie.args=z.args),z.options&&(ie.options=o.from(z.options)),ie}O.from=B;function T(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$9K(z.commandLine,z.options):new A.$9K(z.command,z.args?z.args:[],z.options)}O.to=T})(g||(g={}));var h;(function(O){function K(z){if(z){const ie=z;return ie&&ie.customExecution==="customExecution"}else return!1}O.is=K;function B(z){return{customExecution:"customExecution"}}O.from=B;function T(z,ie){return ie.get(z)}O.to=T})(h||(e.CustomExecutionDTO=h={}));var C;(function(O){function K(B,T){let z;return B.scope!==void 0&&typeof B.scope!="number"?z=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&T&&T.workspaceFile?z=T.workspaceFile:z=p.$SF),{id:B._id,workspaceFolder:z}}O.from=K})(C||(e.TaskHandleDTO=C={}));var I;(function(O){function K(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}O.from=K})(I||(I={}));var c;(function(O){function K(z,ie){if(z==null)return[];const X=[];for(const De of z){const Pe=B(De,ie);Pe&&X.push(Pe)}return X}O.fromMany=K;function B(z,ie){if(z==null)return;let X;z.execution instanceof A.$8K?X=s.from(z.execution):z.execution instanceof A.$9K?X=g.from(z.execution):z.execution&&z.execution instanceof A.$0K&&(X=h.from(z.execution));const De=m.from(z.definition);let Pe;return z.scope?typeof z.scope=="number"?Pe=z.scope:Pe=z.scope.uri:Pe=A.TaskScope.Workspace,!De||!Pe?void 0:{_id:z._id,definition:De,name:z.name,source:{extensionId:ie.identifier.value,label:z.source,scope:Pe},execution:X,isBackground:z.isBackground,group:I.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}O.from=B;async function T(z,ie,X){if(z==null)return;let De;s.is(z.execution)?De=s.to(z.execution):g.is(z.execution)?De=g.to(z.execution):h.is(z.execution)&&(De=h.to(z._id,X));const Pe=m.to(z.definition);let ke;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ke=z.source.scope:ke=await ie.resolveWorkspaceFolder(w.URI.revive(z.source.scope)):ke=A.TaskScope.Workspace),!Pe||!ke)return;const $e=new A.$$K(Pe,ke,z.name,z.source.label,De,z.problemMatchers);return z.isBackground!==void 0&&($e.isBackground=z.isBackground),z.group!==void 0&&($e.group=A.$7K.from(z.group._id),$e.group&&z.group.isDefault&&($e.group=new A.$7K($e.group.id,$e.group.label),z.group.isDefault===!0&&($e.group.isDefault=z.group.isDefault))),z.presentationOptions&&($e.presentationOptions=n.to(z.presentationOptions)),z._id&&($e._id=z._id),z.detail&&($e.detail=z.detail),$e}O.to=T})(c||(e.TaskDTO=c={}));var y;(function(O){function K(T){return T}O.from=K;function B(T){if(T)return Object.assign(Object.create(null),T)}O.to=B})(y||(y={}));class b{#e;constructor(K,B,T){this._id=B,this.a=T,this.#e=K}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(K){}fireDidEndProcess(K){}}let S=class{constructor(K,B,T,z,ie,X,De,Pe){this.q=new P.$Nd,this.r=new P.$Nd,this.s=new P.$Nd,this.t=new P.$Nd,this.a=K.getProxy(L.$lK.MainThreadTask),this.b=T,this.c=z,this.d=ie,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=De,this.g=Pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(K,B,T){if(!T)return new A.$nK(()=>{});const z=this.w();return this.j.set(z,{type:B,provider:T,extension:K}),this.a.$registerTaskProvider(z,B),new A.$nK(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(K,B){this.a.$registerTaskSystem(K,B)}fetchTasks(K){return this.a.$fetchTasks(y.from(K)).then(async B=>{const T=[];for(const z of B){const ie=await c.to(z,this.b,this.m);ie&&T.push(ie)}return T})}get taskExecutions(){const K=[];return this.k.forEach(B=>K.push(B)),K}terminateTask(K){if(!(K instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(K._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(K,B,T){const z=this.m.get(K.id);z&&(this.o.set(K.id,z),this.e.attachPtyToTerminal(B,await z.callback(T))),this.p=K.id,this.q.fire({execution:await this.y(K)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(K){const B=await this.y(K);this.l.delete(K.id),this.k.delete(K.id),this.A(K),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(K){const B=await this.y(K.id);this.s.fire({execution:B,processId:K.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(K){const B=await this.y(K.id);this.t.fire({execution:B,exitCode:K.exitCode})}$provideTasks(K,B){const T=this.j.get(K);if(!T)return Promise.reject(new Error("no handler found"));const z=[],ie=(0,M.$Mg)(()=>T.provider.provideTasks(R.CancellationToken.None)).then(X=>this.u(B,z,T,X));return new Promise(X=>{ie.then(De=>{Promise.all(z).then(()=>{X(De)})})})}async $resolveTask(K,B){const T=this.j.get(K);if(!T)return Promise.reject(new Error("no handler found"));if(B.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${T.type}].`);const z=await c.to(B,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ie=await T.provider.resolveTask(z,R.CancellationToken.None);if(!ie)return;this.z(ie,T);const X=c.from(ie,T.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(X.execution)&&await this.x(X,ie,!0),await this.v(X)}w(){return this.h++}async x(K,B,T){const z=await this.a.$createTaskId(K);!T&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,B.execution)),this.m.set(z,B.execution)}async y(K,B){if(typeof K=="string"){const ie=this.l.get(K);if(!ie)throw new E.$bb("Unexpected: The specified task is missing an execution");return ie}const T=this.l.get(K.id);if(T)return T;const z=new Promise((ie,X)=>{function De(Pe,ke,$e){$e?ie(new b(Pe,ke.id,$e)):X("Unexpected: Task does not exist.")}B?De(this,K,B):c.to(K.task,this.b,this.m).then(Pe=>De(this,K,Pe))});return this.l.set(K.id,z),z.then(ie=>(this.k.set(K.id,ie),ie),ie=>Promise.reject(ie))}z(K,B){K._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(K){this.o.get(K.id)&&this.o.delete(K.id),this.n.has(K.id)&&this.p!==K.id&&(this.m.delete(K.id),this.n.delete(K.id));const T=this.n.values();let z=T.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=T.next()}};e.$xdc=S,e.$xdc=S=qe([Ke(0,a.$mM),Ke(1,v.$CM),Ke(2,u.$ycc),Ke(3,D.$xM),Ke(4,f.$Bcc),Ke(5,k.$Tcc),Ke(6,i.$0i),Ke(7,l.$occ)],S);let j=class extends S{constructor(K,B,T,z,ie,X,De,Pe){super(K,B,T,z,ie,X,De,Pe),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(K,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const T=c.from(B,K);if(T===void 0)throw new Error("Task is not valid");if(h.is(T.execution))await this.x(T,B,!1);else throw new E.$_;const z=await this.y(await this.a.$getTaskExecution(T),B);return this.a.$executeTask(T).catch(ie=>{throw new Error(ie)}),z}u(K,B,T,z){const ie=[];if(z)for(const X of z){this.z(X,T),(!X.definition||!K[X.definition.type])&&this.f.warn(`The task [${X.source}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`);const De=c.from(X,T.extension);De&&h.is(De.execution)?(ie.push(De),B.push(this.x(De,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:T.extension}}async v(K){if(h.is(K.execution))return K;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(K,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(K,B,T){}};e.$ydc=j,e.$ydc=j=qe([Ke(0,a.$mM),Ke(1,v.$CM),Ke(2,u.$ycc),Ke(3,D.$xM),Ke(4,f.$Bcc),Ke(5,k.$Tcc),Ke(6,i.$0i),Ke(7,l.$occ)],j),e.$zdc=(0,$.$Ph)("IExtHostTask")}),define(Ae[270],Re([1,0,20,19,37,38,24,48,49]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class f{constructor(a,v,$){this.k=a,this.l=v,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&L.$wj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&L.$wj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const v=this.k.folderQueries||[];return new Promise(($,d)=>{const t=i=>{this.f++,a(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const l=i.toString(),p=w.$nc(l);this.j&&this.j(l,p)||this.v(t,{base:i,basename:p})}),Promise.all(v.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{d(new Error((0,P.$Ai)(i)))})})}async p(a,v){const $=new M.$Xd,d=this.q(a),t=this.r(),i=new D.$6I(this.k,a),l=!i.hasSiblingExcludeClauses();let p;try{this.h.add($),p=u.$Jd.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,$.token),m=p.elapsed(),n=u.$Jd.create();return this.g&&!this.e||(E&&E.forEach(r=>{const s=w.$gc.relative(a.folder.path,r.path);if(l){const o=w.$nc(r.path);this.v(v,{base:a.folder,relativePath:s,basename:o});return}this.s(t,a.folder,s,v)}),this.g&&!this.e)?null:(this.u(t,i,v),{providerTime:m,postProcessTime:n.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(a){const v=(0,D.$5I)(this.k.includePattern,a.includePattern),$=(0,D.$5I)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:$,includes:v,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},v,$,d){if($===this.a){const i=w.$nc(this.a);this.v(d,{base:v,relativePath:this.a,basename:i})}function t(i){const l=w.$nc(i),p=w.$mc(i);let E=a[p];E||(E=a[p]=[],t(p)),E.push({base:v,relativePath:i,basename:l})}t($)}u({rootEntries:a,pathToEntries:v},$,d){const t=this,i=this.a;function l(p){const E=(0,D.$8I)(()=>p.map(m=>m.basename));for(let m=0,n=p.length;m<n;m++){const r=p[m],{relativePath:s,basename:o}=r;if($.matchesExcludesSync(s,o,i!==o?E:void 0))continue;const g=v[s];if(g)l(g);else{if(s===i)continue;t.v(d,r)}if(t.e)break}}l(a)}v(a,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(v))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,v,$,d){const t=this.c(a.cacheKey),i=new f(a,v,t&&t.token);let l=0;const p=E=>{l+=E.length,$(E.map(m=>this.d(m)))};return this.e(i,R.a,p,d).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:E.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new M.$Xd),this.b.get(a)}d(a){return a.relativePath?{resource:A.$vg(a.base,a.relativePath)}:{resource:a.base}}e(a,v,$,d){const t=d.onCancellationRequested(()=>{a.cancel()}),i=p=>{p&&(l.push(p),v>0&&l.length>=v&&($(l),l=[]))};let l=[];return a.search(i).then(p=>(l.length&&$(l),t.dispose(),p),p=>(l.length&&$(l),t.dispose(),Promise.reject(p)))}}e.$Jdc=R}),define(Ae[271],Re([1,0,18,234,38,90,28,13,20,24,16,15,2,286,168,45,14,56,102,269,49]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.$2J=void 0;let m=class{constructor(y,b,S,j,O){this.a=y,this.b=b,this.c=S,this.d=j,this.e=O}text(y,b,S={}){y=this.f(y,S);const j=this.a.getValue(),O=b&&b.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(b?.map(i.$$h),S),type:2,contentPattern:y,previewOptions:S.previewOptions,maxFileSize:S.maxFileSize,usePCRE2:j.search.usePCRE2||O||!1,beforeContext:S.beforeContext,afterContext:S.afterContext,userDisabledExcludesAndIgnoreFiles:S.disregardExcludeSettings&&S.disregardIgnoreFiles}}f(y,b){const S=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const j={...y,wordSeparators:S.editor.wordSeparators};return this.j(y,b)&&(j.isCaseSensitive=!0),this.k(y)&&(j.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(j.notebookInfo||(j.notebookInfo={}),j.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),j}file(y,b={}){return{...this.h(y,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}g(y,b){return y?(y=Array.isArray(y)?y.map(g):g(y),b?this.parseSearchPaths(y):{pattern:r(...Array.isArray(y)?y:[y])}):{}}h(y=[],b={}){const S=this.g(b.includePattern,b.expandPatterns),j=this.g(b.excludePattern,b.expandPatterns),O=y.length>1,K=(S.searchPaths&&S.searchPaths.length?S.searchPaths.map(z=>this.q(z,b,j)):y.map(z=>this.r(z,b,j,O))).filter(z=>!!z),B={_reason:b._reason,folderQueries:K,usingSearchPaths:!!(S.searchPaths&&S.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:j.pattern,includePattern:S.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const z=w.$Hb(w.$Rb(this.c.groups.map(De=>De.editors.map(Pe=>Pe.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const ie=z.filter(De=>(0,E.$VI)(B,De.fsPath)),X=this.i(ie);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...B,...X}}const T=b.extraFileResources&&b.extraFileResources.filter(z=>(0,E.$VI)(B,z.fsPath));return B.extraFileResources=T&&T.length?T:void 0,B}i(y){const b=[],S=new A.$Ac,j={};let O=!1;return y.forEach(K=>{if(K.scheme===u.Schemas.walkThrough)return;if((0,f.$zg)(K)){const T=this.b.getWorkspaceFolder(K)?.uri??K.with({path:D.$mc(K.fsPath)});let z=S.get(T);z||(O=!0,z={folder:T,includePattern:{}},b.push(z),S.set(T,z));const ie=D.$lc(T.fsPath,K.fsPath);(0,k.$Jf)(z.includePattern)[ie.replace(/\\/g,"/")]=!0}else K.fsPath&&(O=!0,j[K.fsPath]=!0)}),{folderQueries:b,includePattern:j,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(y,b){if(b.isSmartCase){if(y.isRegExp){if(R.$pf(y.pattern,!0))return!0}else if(R.$pf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,v.$vB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const b=X=>D.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),j=(Array.isArray(y)?y:s(y)).map(X=>{const De=this.e.resolvedUserHome;return De?(0,L.$uv)(X,De.scheme===u.Schemas.file?De.fsPath:De.path):X}),O=M.$J(j,X=>b(X)?"searchPaths":"exprSegments"),K=(O.exprSegments||[]).map(X=>R.$Ke(X,"/")).map(X=>R.$Ke(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),o(X))),B={},T=this.m(O.searchPaths||[]);T&&T.length&&(B.searchPaths=T);const z=w.$Rb(K),ie=r(...z);return ie&&(B.pattern=ie),B}l(y,b){return b.disregardExcludeSettings?void 0:(0,E.$UI)(y,!b.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const b=y.flatMap(j=>{let{pathPortion:O,globPortion:K}=n(j);return K&&(K=h(K)),this.n(O).flatMap(T=>this.o(T,K))}),S=new Map;return b.forEach(j=>{const O=j.searchPath.toString(),K=S.get(O);K?j.pattern&&(K.pattern=K.pattern||{},K.pattern[j.pattern]=!0):S.set(O,{searchPath:j.searchPath,pattern:j.pattern?r(j.pattern):void 0})}),Array.from(S.values())}n(y){if(D.$ic(y)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==u.Schemas.file?[{searchPath:b[0].uri.with({path:y})}]:[{searchPath:a.URI.file(D.$hc(y))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(y=g(y),y.startsWith("../")||y===".."){const j=D.$gc.resolve(b.path,y);return[{searchPath:b.with({path:j})}]}const S=h(y);return[{searchPath:b,pattern:S}]}else{if(y==="./"||y===".\\")return[];{const b=y.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(O=>{const K=b.match(new RegExp(`^${R.$Fe(O.name)}(?:/(.*)|$)`));return K?{match:K,folder:O}:null}).filter(k.$Gf);if(j.length)return j.map(O=>{const K=O.match[1];return{searchPath:O.folder.uri,pattern:K&&h(K)}});{const O=y.match(/\.[\/\\](.+)[\/\\]?/),K=O?O[1]:y,B=$.localize(0,null,K);throw new Error(B)}}}}o(y,b){const S=y.pattern&&b?`${y.pattern}/${b}`:y.pattern||b,j=[{searchPath:y.searchPath,pattern:S}];return S&&!S.endsWith("**")&&j.push({searchPath:y.searchPath,pattern:S+"/**"}),j}q(y,b,S){const j=this.r((0,i.$$h)(y.searchPath),b,S,!1);return j?{...j,includePattern:y.pattern}:null}r(y,b,S,j){let O;const K=a.URI.isUri(y)?y:y.uri;if(S.searchPaths){const X=S.searchPaths.filter(De=>(0,f.$og)(De.searchPath,K))[0];if(X&&!X.pattern)return null;X&&(O=X.pattern)}const B=this.a.getValue({resource:K}),z={...this.l(B,b)||{},...O||{}},ie=a.URI.isUri(y)?(0,f.$sg)(y):y.name;return{folder:K,folderName:j?ie:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!B.search.followSymlinks}}};e.$2J=m,e.$2J=m=qe([Ke(0,d.$ji),Ke(1,i.$Yh),Ke(2,l.$nC),Ke(3,t.$0i),Ke(4,p.$ZJ)],m);function n(c){const y=c.match(/[\*\{\}\(\)\[\]\?]/);if(y){const b=y.index,S=c.substr(0,b).match(/[/|\\][^/\\]*$/);if(S){let j=c.substr(0,S.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:c.substr((S.index||0)+1)}}}return{pathPortion:c}}function r(...c){return c.length?c.reduce((y,b)=>(y[b]=!0,y),Object.create(null)):void 0}function s(c){return P.$uj(c,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(c){return[`**/${c}/**`,`**/${c}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function g(c){return c.replace(/\\/g,"/")}function h(c){return g(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function C(c){return c.replace(/([?*[\]])/g,"[$1]")}function I(c,y){c=w.$Mb(c,j=>j.toString());const b=[],S=y.getWorkspace();return c&&c.forEach(j=>{let O;if(y.getWorkbenchState()===2)O=(0,f.$xg)(S.folders[0].uri,j),O&&O!=="."&&(O="./"+O);else{const K=y.getWorkspaceFolder(j);if(K){const B=K.name;if(S.folders.filter(z=>z.name===B).length===1){const z=(0,f.$xg)(K.uri,j);z===""?O=`./${K.name}`:O=`./${K.name}/${z}`}else O=j.fsPath}}O&&b.push(C(O))}),b}e.$3J=I}),define(Ae[272],Re([1,0,24,2,19,11,4,271,49,56]),function(be,e,w,M,P,L,A,u,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glb=e.$Flb=void 0;const R=7e3;function k(d,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const l=[],p=[];for(const o of i)if(/^workspaceContains:/.test(o)){const g=o.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||d.forceUsingSearch?p.push(g):l.push(g)}if(l.length===0&&p.length===0)return Promise.resolve(void 0);let E;const m=new Promise((o,g)=>{E=o}),n=o=>E({activationEvent:o}),r=Promise.all(l.map(o=>a(d,o,n))).then(()=>{}),s=v(d,t.identifier,p,n);return Promise.all([r,s]).then(()=>{E(void 0)}),m}e.$Flb=k;async function a(d,t,i){for(const l of d.folders)if(await d.exists(w.$vg(M.URI.revive(l),t))){i(`workspaceContains:${t}`);return}}async function v(d,t,i,l){if(i.length===0)return Promise.resolve(void 0);const p=new P.$Xd,E=d.checkExists(d.folders,i,p.token),m=setTimeout(async()=>{p.cancel(),d.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let n=!1;try{n=await E}catch(r){L.$4(r)||L.$1(r)}p.dispose(),clearTimeout(m),n&&l(`workspaceContains:${i.join(",")}`)}function $(d,t,i,l){const p=d.get(A.$Oh),E=d.get(D.$MI),n=p.createInstance(u.$2J).file(t.map(r=>(0,f.$$h)(M.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(n,l).then(r=>!!r.limitHit,r=>L.$4(r)?!1:Promise.reject(r))}e.$Glb=$}),define(Ae[35],Re([1,0,149,20,87,24,12,6,50,2,14,3,34,205,84,33,22,103,11,21,26,189,7,97,4,27,85,17,71,86,63,5,272,83,191,13,81,48,23,82]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m,n,r,s,o,g,h,C,I,c,y,b,S,j,O,K,B,T,z){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=e.$6cc=e.$5cc=void 0,e.$5cc=(0,s.$Ph)("IHostUtils");let X=ie=class extends u.$Sc{constructor(_,W,Z,ee,pe,me,he,Ee,re,le,ne,oe){super(),this.X=oe,this.a=this.B(new y.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=Z,this.f=he,this.j=ee,this.m=pe,this.s=me,this.t=re,this.u=le,this.w=ne,this.y=this.g.getProxy(k.$lK.MainThreadWorkspace),this.z=this.g.getProxy(k.$lK.MainThreadTelemetry),this.C=this.g.getProxy(k.$lK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new ae(this.f.extensions.activationEvents),this.L=new i.$z4b(this.I,this.f.extensions.allExtensions);const fe=new p.$7l(this.f.extensions.myExtensions);this.J=new i.$z4b(this.I,ye(this.L,fe)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new $.$Lcc(this.g,this.s),this.N=new S.$Xcc(this.g),this.O=Ee,this.h=_.createChild(new C.$Nh([$.$Mcc,this.M],[S.$Ycc,this.N])),this.P=this.B(new v.$Kcc(this.J,this.L,{onExtensionActivationError:(Ce,F,V)=>{this.C.$onExtensionActivationError(Ce,l.$3(F),V)},actualActivateExtension:async(Ce,F)=>{if(i.$z4b.isHostExtension(Ce,this.J,this.L))return await this.C.$activateExtension(Ce,F),new v.$Jcc;const V=this.J.getExtensionDescription(Ce);return this.db(V,F)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){l.$1(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this.cb(pe))}catch{}await Promise.all(_)}terminate(_,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(ee=>{this.s.error(ee)}),this.g.dispose();const Z=this.Y();Promise.race([(0,A.$Ug)(5e3),Z]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const W=await this.C.$getExtension(_);return W&&{...W,identifier:new p.$6l(W.identifier.value),extensionLocation:f.URI.revive(W.extensionLocation)}}Z(_,W){return this.P.activateByEvent(_,W)}$(_,W){return this.P.activateById(_,W)}activateByIdWithErrors(_,W){return this.$(_,W).then(()=>{const Z=this.P.getActivatedExtension(_);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===O.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(_.fsPath);return f.URI.file(W)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new ue(_))),this.Q}async bb(_){const W=D.$Vh.forUris(Z=>L.$mg.ignorePathCasing(Z));return await Promise.all(_.map(async Z=>{if(this.ub(Z)){const ee=await this.ab(Z.extensionLocation);W.set(ee,Z)}})),W}cb(_){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return W;const Z=this.P.getActivatedExtension(_);if(!Z)return W;try{typeof Z.module.deactivate=="function"&&(W=Promise.resolve(Z.module.deactivate()).then(void 0,ee=>(this.s.error(ee),Promise.resolve(void 0))))}catch(ee){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(ee)}try{(0,u.$Nc)(Z.subscriptions)}catch(ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(ee)}return W}async db(_,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,W).then(Z=>{const ee=Z.activationTimes;return this.C.$onDidActivateExtension(_.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,W),this.eb(_,W,"success",ee),Z},Z=>{throw this.eb(_,W,"failure"),Z})}eb(_,W,Z,ee){const pe=Pe(_,W);this.z.$publicLog2("extensionActivationTimes",{...pe,...ee||{},outcome:Z})}fb(_,W){const Z=Pe(_,W);this.z.$publicLog2("activatePlugin",Z);const ee=this.ub(_);if(!ee)return Promise.resolve(new v.$Icc(v.$Fcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${_.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const pe=new v.$Gcc(W.startup);return Promise.all([this.vb(_,(0,L.$vg)(_.extensionLocation,ee),pe),this.gb(_)]).then(me=>(P.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),ie.hb(this.s,_.identifier,me[0],me[1],pe))).then(me=>(P.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),me))}gb(_){const W=new m.$Occ(_,this.M),Z=new m.$Ncc(_.identifier.value,!1,this.M),ee=new j.$Zcc(_,this.N),pe=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,me=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([W.whenReady,Z.whenReady,this.O.whenReady]).then(()=>{const he=this;let Ee,re;const le=(0,t.$gF)(_,"ipc")?this.f.messagePorts?.get(p.$6l.toKey(_.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:Z,secrets:ee,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(ne){return M.$jc(_.extensionLocation.fsPath,ne)},get storagePath(){return he.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return he.O.globalValue(_).fsPath},get logPath(){return M.$jc(he.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return f.URI.joinPath(he.f.logsLocation,_.identifier.value)},get storageUri(){return he.O.workspaceValue(_)},get globalStorageUri(){return he.O.globalValue(_)},get extensionMode(){return pe},get extension(){return Ee===void 0&&(Ee=new $e(he,_.identifier,_,me,!1)),Ee},get extensionRuntime(){return(0,t.$hF)(_,"extensionRuntime"),he.extensionRuntime},get environmentVariableCollection(){return he.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!re){if(!le)return;const ne=y.Event.buffer(y.Event.fromDOMEventEmitter(le,"message",oe=>oe.data));le.start(),re={onDidReceiveMessage:ne,postMessage:le.postMessage.bind(le)}}return re}})})}static hb(_,W,Z,ee,pe){return Z=Z||{activate:void 0,deactivate:void 0},this.ib(_,W,Z,ee,pe).then(me=>new v.$Hcc(!1,null,pe.build(),Z,me,ee.subscriptions))}static ib(_,W,Z,ee,pe){if(typeof Z.activate=="function")try{pe.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${W.value}`);const me=typeof global=="object"?global:self,he=Z.activate.apply(me,[ee]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(he).then(Ee=>(pe.activateResolveStop(),Ee))}catch(me){return Promise.reject(me)}else return Promise.resolve(Z)}jb(_,W){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:W}).then(void 0,Z=>{this.s.error(Z)})}kb(_,W=0){const ee=Date.now();(0,T.$B)(()=>{for(let pe=W;pe<_.length;pe+=1){const me=_[pe];for(const he of me.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-ee>50){this.kb(_,pe);break}else this.jb(me,he)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(_=>{const W=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.J.getAllExtensionDescriptions();if(W)this.kb(Z);else for(const ee of Z)if(ee.activationEvents)for(const pe of ee.activationEvents)pe==="onStartupFinished"&&this.jb(ee,pe)})}mb(){const _=this.Z("*",!0).then(void 0,me=>{this.s.error(me)});this.B(this.j.onDidChangeWorkspace(me=>this.nb(me.added)));const W=this.j.workspace?this.j.workspace.folders:[],Z=this.nb(W),ee=this.pb(),pe=Promise.all([ee,_,Z]).then(()=>{});return Promise.race([pe,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),pe}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(_,W))).then(()=>{})}async ob(_,W){if(this.isActivated(W.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,ee={logService:this.s,folders:_.map(me=>me.uri),forceUsingSearch:Z||!this.c.fsExists,exists:me=>this.c.fsExists(me.fsPath),checkExists:(me,he,Ee)=>this.y.$checkExists(me,he,Ee)},pe=await(0,b.$Flb)(ee,W);if(pe)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:pe.activationEvent}).then(void 0,me=>this.s.error(me))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:W}=this.f.environment;if(!_||!W)throw new Error(w.localize(0,null));const Z=await this.vb(null,W,new v.$Gcc(!1));if(!Z||typeof Z.run!="function")throw new Error(w.localize(1,null,W.toString()));return new Promise((ee,pe)=>{const me=(re,le)=>{re?(T.$t&&this.s.error("Test runner called back with error",re),pe(re)):(T.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),ee(typeof le=="number"&&le>0?1:0))},he=(0,L.$jg)(W),Ee=Z.run(he,me);Ee&&Ee.then&&Ee.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),ee(0)}).catch(re=>{T.$t&&this.s.error("Test runner finished with error",re),pe(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,W){return this.R[_]=W,(0,u.$Qc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:W}=await this.sb(_);return W?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const W=_.indexOf("+");if(W===-1)throw new n.$tK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Z=_.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.R[Z]}}async $resolveAuthority(_,W){const Z=B.$Jd.create(!1),ee=()=>`[resolveAuthority(${(0,r.$Tk)(_)},${W})][${Z.elapsed()}ms] `,pe=J=>this.s.info(`${ee()}${J}`),me=J=>this.s.warn(`${ee()}${J}`),he=(J,q=void 0)=>this.s.error(`${ee()}${J}`,q),Ee=J=>{if(J instanceof n.$tK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},re=async J=>{pe(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw he(`no resolver for ${x}`),new n.$tK(`No remote extension installed to resolve ${x}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},le=_.split(/@|%40/g).reverse();pe(`activating remote resolvers ${le.join(" -> ")}`);let ne;try{ne=await Promise.all(le.map(re)).catch(async J=>{if(!(J instanceof n.$tK)||J._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return me(`resolving nested authorities failed: ${J.message}`),[await re(_)]})}catch(J){return Ee(J)}const oe=new A.$5g;oe.cancelAndSet(()=>pe("waiting..."),1e3);let fe,Ce;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:ce}]of ne.entries())try{if(J===ne.length-1)pe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),fe=await x.resolve(ce,{resolveAttempt:W,execServer:Ce}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),pe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$sK.isManagedResolvedAuthority(fe)?fe:void 0));else{if(pe(`invoking resolveExecServer() for ${ce}`),P.mark(`code/extHost/willResolveExecServer/${q}`),Ce=await x.resolveExecServer?.(ce,{resolveAttempt:W,execServer:Ce}),!Ce)throw new n.$tK(`Exec server was not available for ${ce}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),he("returned an error",Ne),oe.dispose(),Ee(Ne)}oe.dispose();const F={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},V={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};pe(`returned ${n.$sK.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(n.$sK.isManagedResolvedAuthority(fe)){const J=W;this.X.setFactory(J,fe.makeConnection),G={authority:_,connectTo:new r.$Qk(J),connectionToken:fe.connectionToken}}else G={authority:_,connectTo:new r.$Rk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:F}}}async $getCanonicalURI(_,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Tk)(_)})`);const{resolver:Z}=await this.sb(_);if(!Z)return null;const ee=f.URI.revive(W);if(typeof Z.getCanonicalURI>"u")return ee;const pe=await(0,A.$Mg)(()=>Z.getCanonicalURI(ee));return pe||ee}$startExtensionHost(_){_.toAdd.forEach(ee=>ee.extensionLocation=f.URI.revive(ee.extensionLocation));const{globalRegistry:W,myExtensions:Z}=De(this.I,this.L,this.J,_);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(Z),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(_,W){return W===1?this.D.wait().then(Z=>this.Z(_,!1)):this.G.wait().then(Z=>this.Z(_,!1))}async $activate(_,W){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,W),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(me=>me.extensionLocation=f.URI.revive(me.extensionLocation));const{globalRegistry:W,myExtensions:Z}=De(this.I,this.L,this.J,_),ee=await this.bb(Z);return(await this.getExtensionPathIndex()).setSearchTree(ee),this.L.set(W.getAllExtensionDescriptions()),this.J.set(Z),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const W=E.$be.alloc(_),Z=Math.random()%256;for(let ee=0;ee<_;ee++)W.writeUInt8(Z,ee);return W}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$6cc=X,e.$6cc=X=ie=qe([Ke(0,s.$Oh),Ke(1,e.$5cc),Ke(2,h.$mM),Ke(3,d.$ycc),Ke(4,a.$Bcc),Ke(5,R.$0i),Ke(6,o.$CM),Ke(7,g.$Rcc),Ke(8,I.$cwb),Ke(9,c.$Tcc),Ke(10,K.$2cc),Ke(11,z.$3cc)],X);function De(we,_,W,Z){we.addActivationEvents(Z.addActivationEvents);const ee=new i.$z4b(we,_.getAllExtensionDescriptions());ee.deltaExtensions(Z.toAdd,Z.toRemove);const pe=new p.$7l(W.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of Z.myToRemove)pe.delete(he);for(const he of Z.myToAdd)pe.add(he);const me=ye(ee,pe);return{globalRegistry:ee,myExtensions:me}}function Pe(we,_){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function ke(we){return we.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$7cc=(0,s.$Ph)("IExtHostExtensionService");class $e{#e;#t;#i;constructor(_,W,Z,ee,pe){this.#e=_,this.#t=W,this.#i=Z.identifier,this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=M.$hc((0,L.$jg)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ee,this.isFromDifferentExtensionHost=pe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$8cc=$e;function ye(we,_){return we.getAllExtensionDescriptions().filter(W=>_.has(W.identifier))}class ue{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$9cc=ue;class ae{constructor(_){this.a=new p.$8l,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)}addActivationEvents(_){for(const W of Object.keys(_))this.a.set(W,_[W])}}}),define(Ae[273],Re([1,0,87,2,3,34,22,21,17,27,4,35,14,16]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;let d=class{constructor(E,m,n,r,s,o,g){this.c=E,this.d=m,this.e=n,this.f=r,this.g=s,this.h=o,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const m=await this.g.getExtensionPathIndex();this.register(new i(this.c,m,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,m,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const m of E.nodeModuleName)this.a.set(m,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(m=>E.alternativeModuleName(m))}};e.$uec=d,e.$uec=d=qe([Ke(2,R.$Oh),Ke(3,L.$Bcc),Ke(4,k.$7cc),Ke(5,f.$CM),Ke(6,a.$0i)],d);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&$.a.size){const m=(0,v.$Fe)(this.c(E.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${m}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const m=this.b.exec(this.c(E));if(!m)return;const[,n,r,s]=m,o=$.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),n+o+s}c(E){return E.replace(/\\/g,"/")}};t=$=qe([Ke(0,f.$CM)],t);class i{constructor(E,m,n,r,s){this.c=E,this.d=m,this.e=n,this.f=r,this.g=s,this.nodeModuleName="vscode",this.a=new u.$8l}load(E,m){const n=this.d.findSubstr(m);if(n){let r=this.a.get(n.identifier);return r||(r=this.c(n,this.e,this.f),this.a.set(n.identifier,r)),r}if(!this.b){let r="";this.d.forEach((s,o)=>r+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${m}. These are the extension path mappings: 
${r}`),this.b=this.c(A.$bF,this.e,this.f)}return this.b}}let l=class{constructor(E,m,n){this.e=E,this.f=m,this.nodeModuleName=["open","opn"],this.d=n.getProxy(P.$lK.MainThreadTelemetry);const r=n.getProxy(P.$lK.MainThreadWindow);this.c=(s,o)=>{const g=M.URI.parse(s);return o?this.g(s,o):g.scheme==="http"||g.scheme==="https"?r.$openUri(g,s,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?r.$openUri(g,s,{}):this.g(s,o)}}load(E,m,n){const r=this.e.findSubstr(m);return r&&(this.a=r.identifier.value,this.h()),this.b=n(E),this.c}g(E,m){return this.i(),this.b(E,m)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=qe([Ke(2,D.$mM)],l)}),define(Ae[112],Re([1,0,42,6,20,73,4,60,61,35,7,33,202,34]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,A.$Ph)("IExtHostVariableResolverProvider");class $ extends a.$nN{constructor(i,l,p,E,m,n,r){function s(){if(p){const o=p.activeEditor();if(o)return o.document.uri;const g=E.tabGroups.all.find(h=>h.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof R.$6L||g.input instanceof R.$$L)return g.input.modified;if(g.input instanceof R.$5L||g.input instanceof R.$0L||g.input instanceof R.$8L)return g.input.uri}}}super({getFolderUri:o=>{const g=n.folders.filter(h=>h.name===o);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,g)=>m.getConfiguration(void 0,o).get(g),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return P.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const o=s();if(o){const g=l.getWorkspaceFolder(o);if(g)return P.$hc(g.uri.fsPath)}}},getSelectedText:()=>{if(p){const o=p.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(p){const o=p.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let d=class extends M.$Sc{constructor(i,l,p,E,m){super(),this.b=i,this.c=l,this.g=p,this.h=E,this.j=m,this.a=new w.$V(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,n,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Ddc=d,e.$Ddc=d=qe([Ke(0,f.$7cc),Ke(1,k.$ycc),Ke(2,u.$xM),Ke(3,v.$Bcc),Ke(4,D.$Adc)],d)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,195,197,34,112]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=e.$Gdc=e.$Fdc=e.$Edc=void 0,e.$Edc=(0,L.$Ph)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,s,o,g,h,C){this.E=s,this.F=o,this.G=g,this.H=h,this.I=C,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Nd,this.n=new M.$Nd,this.o=new M.$Nd,this.u=new M.$Nd,this.k=r.getProxy(A.$lK.MainThreadDebugService),this.y=new M.$Nd,this.A=new M.$Nd,this.v=new l(this.k),this.w=new Map,this.F.getExtensionRegistry().then(I=>{I.onDidChange(c=>{this.J(I)}),this.J(I)})}asDebugSourceUri(r,s){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let g=`debug:${encodeURIComponent(o.path||"")}`,h="?";return s&&(g+=`${h}session=${encodeURIComponent(s.id)}`,h="&"),g+=`${h}ref=${o.sourceReference}`,P.URI.parse(g)}else{if(o.path)return P.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const s=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const g=o.contributes.debuggers;if(g&&g.length>0)for(const h of g)(0,v.$vF)(h)&&s.push(h.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(h=>{const C=h.id;return this.w.has(C)?!1:(this.w.set(C,h),!0)});this.U(s,[],[]);const o=[],g=new Map;for(const h of s)if(h instanceof R.$mL){let C=g.get(h.location.uri.toString());C||(C={type:"sourceMulti",uri:h.location.uri,lines:[]},g.set(h.location.uri.toString(),C),o.push(C)),C.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof R.$nL&&o.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){const s=r.filter(C=>this.w.delete(C.id));this.U([],s,[]);const o=s.filter(C=>C instanceof R.$mL).map(C=>C.id),g=s.filter(C=>C instanceof R.$nL).map(C=>C.id),h=s.filter(C=>C instanceof R.$oL).map(C=>C.id);return this.k.$unregisterBreakpoints(o,g,h)}startDebugging(r,s,o){return this.k.$startDebugging(r?r.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,o){if(!s)return new R.$nK(()=>{});const g=this.d++;return this.f.push({type:r,handle:g,provider:s}),this.k.$registerDebugConfigurationProvider(r,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,g),new R.$nK(()=>{this.f=this.f.filter(h=>h.provider!==s),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(r,s,o){if(!o)return new R.$nK(()=>{});if(!this.Q(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:s,handle:g,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,g),new R.$nK(()=>{this.h=this.h.filter(h=>h.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new R.$nK(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:s}),new R.$nK(()=>{this.j=this.j.filter(g=>g.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let o;const g=await this.W(r);return g&&(o={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(r,s){if(r.type==="implementation")return new E(r.implementation)}L(){}async $startDASession(r,s){const o=this,g=await this.V(s);return this.S(this.N(g.type),g).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const C=this.M(h),I=this.K(C,g);if(!I)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const c=I;return this.B.set(r,c),this.R(g).then(y=>(y&&this.C.set(r,y),c.onMessage(async b=>{if(b.type==="request"&&b.command==="handshake"){const S=b,j={type:"response",seq:0,command:S.command,request_seq:S.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(S.arguments.value);j.body={signature:O},c.sendResponse(j)}else throw new Error("no signer")}catch(O){j.success=!1,j.message=O.message,c.sendResponse(j)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(b),b=(0,v.$AF)(b,!0),o.k.$acceptDAMessage(r,b)}),c.onError(b=>{y&&y.onError&&y.onError(b),this.k.$acceptDAError(r,b.name,b.message,b.stack)}),c.onExit(b=>{y&&y.onExit&&y.onExit(b??void 0,void 0),this.k.$acceptDAExit(r,b??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),c.startSession()))})}$sendDAMessage(r,s){s=(0,v.$zF)(s,!1);const o=this.C.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(r)?.sendMessage(s)}$stopDASession(r){const s=this.C.get(r);this.C.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(r);return this.B.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],o=[],g=[];if(r.added)for(const h of r.added){const C=h.id;if(C&&!this.w.has(C)){let I;if(h.type==="function")I=new R.$nL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")I=new R.$oL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const c=P.URI.revive(h.uri);I=new R.$mL(new R.$zK(c,new R.$oK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,R.$kL)(I,C),this.w.set(C,I),s.push(I)}}if(r.removed)for(const h of r.removed){const C=this.w.get(h);C&&(this.w.delete(h),o.push(C))}if(r.changed){for(const h of r.changed)if(h.id){const C=this.w.get(h.id);if(C){if(C instanceof R.$nL&&h.type==="function"){const I=C;I.enabled=h.enabled,I.condition=h.condition,I.hitCondition=h.hitCondition,I.logMessage=h.logMessage,I.functionName=h.functionName}else if(C instanceof R.$mL&&h.type==="source"){const I=C;I.enabled=h.enabled,I.condition=h.condition,I.hitCondition=h.hitCondition,I.logMessage=h.logMessage,I.location=new R.$zK(P.URI.revive(h.uri),new R.$oK(h.line,h.character))}g.push(C)}}}this.U(s,o,g)}async $acceptStackFrameFocus(r){let s;const o=r.sessionId?await this.V(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new R.$uL(o,r.threadId):s=new R.$tL(o,r.threadId,r.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(r,s,o){return(0,w.$Mg)(async()=>{const g=this.P(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(s);return g.provideDebugConfigurations(h,o)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(r,s,o,g){return(0,w.$Mg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.W(s);return h.resolveDebugConfiguration(C,o,g)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,o,g){return(0,w.$Mg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.W(s);return h.resolveDebugConfigurationWithSubstitutedVariables(C,o,g)})}async $provideDebugAdapter(r,s){const o=this.O(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.V(s);return this.S(o,g).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const s=await this.V(r);this.m.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.V(r);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,s){(await this.V(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const g={session:await this.V(r),event:s.event,body:s.body};this.u.fire(g)}M(r){if(r instanceof R.$pL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$qL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$rL)return{type:"pipeServer",path:r.path};if(r instanceof R.$sL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const s=this.h.filter(o=>o.type===r);if(s.length>0)return s[0].factory}O(r){const s=this.h.filter(o=>o.handle===r);if(s.length>0)return s[0].factory}P(r){const s=this.f.filter(o=>o.handle===r);if(s.length>0)return s[0].provider}Q(r,s){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const g of o)if(g.label&&g.type&&g.type===s)return!0}}return!1}R(r){const o=r.configuration.type,g=this.j.filter(h=>h.type===o||h.type==="*").map(h=>(0,w.$Mg)(()=>h.factory.createDebugAdapterTracker(r)).then(C=>C,C=>null));return Promise.race([Promise.all(g).then(h=>{const C=h.filter(I=>!!I);if(C.length>0)return new p(C)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$qL(o));if(r){const h=await this.F.getExtensionRegistry();return(0,w.$Mg)(()=>r.createDebugAdapterDescriptor(s,this.T(s,h))).then(C=>{if(C)return C})}const g=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,g))}T(r,s){}U(r,s,o){(r.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:r,removed:s,changed:o}))}async V(r){if(r)if(typeof r=="string"){const s=this.l.get(r);if(s)return s}else{let s=this.l.get(r.id);if(!s){const o=await this.W(r.folderUri),g=r.parent?this.l.get(r.parent):void 0;s=new i(this.k,r.id,r.type,r.name,o,r.configuration,g),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(r){if(r){const s=P.URI.revive(r);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$Fdc=t,e.$Fdc=t=qe([Ke(0,f.$mM),Ke(1,k.$ycc),Ke(2,D.$7cc),Ke(3,$.$Bcc),Ke(4,u.$Adc),Ke(5,d.$Cdc)],t);class i{constructor(r,s,o,g,h,C,I){this.d=r,this.f=s,this.g=o,this.h=g,this.i=h,this.j=C,this.k=I}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,s){return this.d.$customDebugAdapterRequest(this.f,r,s)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Gdc=i;class l{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$Hdc=l;class p{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.d.forEach(o=>o.onExit?o.onExit(r,s):void 0)}}class E extends a.$$cb{constructor(r){super(),this.h=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let m=class extends t{constructor(r,s,o,g,h,C){super(r,s,o,g,h,C)}};e.$Idc=m,e.$Idc=m=qe([Ke(0,f.$mM),Ke(1,k.$ycc),Ke(2,D.$7cc),Ke(3,$.$Bcc),Ke(4,u.$Adc),Ke(5,d.$Cdc)],m)}),define(Ae[274],Re([1,0,11,87,2,3,265,14,70,71,27,173,17,57,35,59]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;class t{static async installEarlyHandler(p){Error.stackTraceLimit=100;const E=p.get(u.$0i),n=p.get(a.$mM).getProxy(L.$lK.MainThreadErrors);w.setUnexpectedErrorHandler(r=>{E.error(r);const s=w.$3(r);n.$onUnexpectedError(s)})}static async installFullHandler(p){const E=p.get(u.$0i),m=p.get(a.$mM),n=p.get($.$7cc),r=p.get(d.$GM),s=m.getProxy(L.$lK.MainThreadExtensionService),o=m.getProxy(L.$lK.MainThreadErrors),g=await n.getExtensionPathIndex(),h=new WeakMap;function C(y,b){if(h.has(y))return h.get(y).stack;let S="",j,O;for(const B of b)S+=`
	at ${B.toString()}`,O=B.getFileName(),!j&&O&&(j=g.findSubstr(P.URI.file(O)));const K=`${y.name||"Error"}: ${y.message||""}${S}`;return h.set(y,{extensionIdentifier:j?.identifier,stack:K}),K}const I=Symbol("prepareStackTrace wrapped");let c=C;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return c},set(y){if(y===C||!y||y[I]){c=y||C;return}c=function(b,S){return C(b,S),y.call(Error,b,S)},Object.assign(c,{[I]:!0})}}),w.setUnexpectedErrorHandler(y=>{E.error(y);const b=w.$3(y),S=h.get(y);if(!S?.extensionIdentifier){o.$onUnexpectedError(b);return}s.$onExtensionRuntimeError(S.extensionIdentifier,b);const j=r.onExtensionError(S.extensionIdentifier,y);E.trace("forwarded error to extension?",j,S)})}}e.$vec=t;class i{constructor(p,E,m,n,r){this.a=m,this.b=new A.$I4b(p,null,n),E=i.e(E,this.b);const s=new f.$Nh(...(0,D.$xr)());s.set(R.$CM,{_serviceBrand:void 0,...E,messagePorts:r}),s.set(a.$mM,new a.$nM(this.b)),s.set(v.$vcc,new v.$wcc(n)),s.set($.$5cc,m);const o=new k.$dq(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(g=>g.get(u.$0i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(g=>g.get($.$7cc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(p){const E=this.b.getProxy(L.$lK.MainThreadExtensionService);return P.URI.revive(await E.$asBrowserUri(p))}terminate(p){this.c.terminate(p)}static e(p,E){p.extensions.allExtensions.forEach(n=>{n.extensionLocation=P.URI.revive(E.transformIncomingURIs(n.extensionLocation))}),p.environment.appRoot=P.URI.revive(E.transformIncomingURIs(p.environment.appRoot));const m=p.environment.extensionDevelopmentLocationURI;return m&&(p.environment.extensionDevelopmentLocationURI=m.map(n=>P.URI.revive(E.transformIncomingURIs(n)))),p.environment.extensionTestsLocationURI=P.URI.revive(E.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=P.URI.revive(E.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=P.URI.revive(E.transformIncomingURIs(p.environment.workspaceStorageHome)),p.environment.extensionTelemetryLogResource=P.URI.revive(E.transformIncomingURIs(p.environment.extensionTelemetryLogResource)),p.nlsBaseUrl=P.URI.revive(E.transformIncomingURIs(p.nlsBaseUrl)),p.logsLocation=P.URI.revive(E.transformIncomingURIs(p.logsLocation)),p.workspace=E.transformIncomingURIs(p.workspace),p}}e.$wec=i}),define(Ae[275],Re([1,0,18,12,19,37,13,20,24,2,49]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=e.$Ldc=e.$Kdc=void 0;class k{constructor(l,p,E,m){this.d=l,this.e=p,this.f=E,this.g=m,this.a=null,this.b=!1,this.c=0}search(l,p){const E=this.d.folderQueries||[],m=new P.$Xd(p);return new Promise((n,r)=>{this.a=new v(l);let s=!1;const o=(g,h)=>{if(!s&&!this.b){const C=this.h(g);d(g)&&typeof this.d.maxResults=="number"&&this.c+C>this.d.maxResults&&(this.b=!0,s=!0,m.cancel(),g=this.j(g,this.d.maxResults-this.c));const I=this.h(g);this.c+=I,(I>0||!d(g))&&this.a.add(g,h)}};Promise.all(E.map((g,h)=>this.k(g,C=>o(C,h),m.token))).then(g=>{m.dispose(),this.a.flush();const h=g.some(C=>!!C&&!!C.limitHit);n({limitHit:this.b||h,messages:(0,w.$Rb)(g.map(C=>C?.message?Array.isArray(C.message)?C.message:[C.message]:[])),stats:{type:this.g}})},g=>{m.dispose();const h=(0,L.$Ai)(g);r(new Error(h))})})}h(l){return d(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,p){const E=Array.isArray(l.ranges)?l.ranges:[l.ranges],m=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:E.slice(0,p),preview:{matches:m.slice(0,p),text:l.preview.text},uri:l.uri}}async k(l,p,E){const m=new R.$6I(this.d,l),n=[],r={report:g=>{if(!this.l(g))return;const h=l.folder.scheme===A.Schemas.file?(0,R.$7I)(()=>this.f.readdir(D.$ug(g.uri))):void 0,C=D.$xg(l.folder,g.uri);if(C){const I=m.includedInQuery(C,u.$nc(C),h);(0,M.$Gg)(I)?n.push(I.then(c=>{c&&p(g)})):I&&p(g)}}},s=this.n(l),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),s,r,E);return n.length&&await Promise.all(n),o}l(l){if(d(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const p=(0,R.$5I)(this.d.includePattern,l.includePattern),E=(0,R.$5I)(this.d.excludePattern,l.excludePattern),m={folder:f.URI.from(l.folder),excludes:E,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.f.toCanonicalName(l.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return m.usePCRE2=this.d.usePCRE2,m}}e.$Kdc=k;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class v{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new t(512,p=>this.g(p))}add(l,p){this.d&&(this.b!==p||!D.$og(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=p,this.d={resource:l.uri,results:[]}),this.d.results.push($(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$Ldc=v;function $(i){return d(i)?{preview:{matches:(0,w.$2b)(i.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:i.preview.text},ranges:(0,w.$2b)(i.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function d(i){return!!i.preview}e.$Mdc=d;class t{static{this.a=4e3}static{this.b=50}constructor(l,p){this.g=l,this.h=p,this.c=0,this.d=[],this.e=0}addItem(l,p){l&&this.j(l,p)}addItems(l,p){l&&this.k(l,p)}j(l,p){this.d.push(l),this.e+=p,this.l()}k(l,p){this.d=this.d.concat(l),this.e+=p,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Ndc=t}),define(Ae[114],Re([1,0,6,3,4,270,17,57,14,2,275]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=e.$Odc=void 0,e.$Odc=(0,P.$Ph)("IExtHostSearch");let k=class{constructor(d,t,i){this.k=d,this.l=t,this.n=i,this.c=this.k.getProxy(M.$lK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$Jdc}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,t){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(d)),(0,w.$Qc)(()=>{this.g.delete(d),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(d,t){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(d)),(0,w.$Qc)(()=>{this.i.delete(d),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(d,t,i,l){const p=a(i),E=this.h.get(d);if(E)return this.j.fileSearch(p,E,m=>{this.c.$handleFileMatch(d,t,m.map(n=>n.resource))},l);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,t,i,l){const p=this.e.get(d);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const E=a(i);return this.q(E,p).search(n=>this.c.$handleTextMatch(d,t,n),l)}$enableExtensionHostSearch(){}q(d,t){return new R.$Kdc(d,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Pdc=k,e.$Pdc=k=qe([Ke(0,A.$mM),Ke(1,u.$vcc),Ke(2,D.$0i)],k);function a($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(v),extraFileResources:$.extraFileResources&&$.extraFileResources.map(d=>f.URI.revive(d))}}e.$Qdc=a;function v($){return{...$,folder:f.URI.revive($.folder)}}}),define(Ae[276],Re([1,0,19,11,5,29,2,135,287,124,133,39,3,78,227,226,31,228,34,230,231,232,207,233,60,35,236,237,242,243,245,109,211,251,252,255,84,63,257,212,8,7,55,260,64,108,33,21,200,241,54,107,111,113,114,14,57,17,27,246,198,86,80,219,258,85,62,263,261,262,220,40,256,259,83,61,59,247,110,248,13,95,210,190,239,6,22,196,81,186,249,250,221,238,209,240,82,253,224,254,225,218,235,222,223]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m,n,r,s,o,g,h,C,I,c,y,b,S,j,O,K,B,T,z,ie,X,De,Pe,ke,$e,ye,ue,ae,we,_,W,Z,ee,pe,me,he,Ee,re,le,ne,oe,fe,Ce,F,V,G,J,q,x,ce,Ne,je,Qe,Ge,_e,Ze,xe,it,tt,ze,ut,Y,Q,ve,Be,Oe,Xe,nt,$t,bt,Pt,qt,Ht,vt,Ut,Nt,Gt,jt,kt,Lt,Bt,Jt,Wt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=void 0;function Ot(at){const dt=at.get(re.$CM),At=at.get(Ne.$lcc),Vt=at.get(G.$Qcc),Rt=at.get(o.$7cc),ot=at.get(ye.$ycc),wt=at.get(Ze.$GM),Tt=at.get(l.$Bcc),Ct=at.get(he.$vcc),We=at.get(Ee.$mM),Qt=at.get(K.$Mcc),Ie=at.get(V.$Rcc),Fe=at.get(me.$$i),ge=at.get(me.$0i),H=at.get(oe.$cwb),Me=at.get(fe.$occ),Ue=at.get($e.$sdc),Je=at.get(Ge.$Ycc),Ve=at.get(_e.$Adc),et=at.get(Nt.$3cc);We.set(a.$mK.ExtHostFileSystemInfo,At),We.set(a.$mK.ExtHostLogLevelServiceShape,Fe),We.set(a.$mK.ExtHostWorkspace,ot),We.set(a.$mK.ExtHostConfiguration,Tt),We.set(a.$mK.ExtHostExtensionService,Rt),We.set(a.$mK.ExtHostStorage,Qt),We.set(a.$mK.ExtHostTunnelService,H),We.set(a.$mK.ExtHostWindow,Ue),We.set(a.$mK.ExtHostSecretState,Je),We.set(a.$mK.ExtHostTelemetry,wt),We.set(a.$mK.ExtHostEditorTabs,Ve),We.set(a.$mK.ExtHostManagedSockets,et);const Et=We.set(a.$mK.ExtHostDecorations,at.get(W.$wdc)),Dt=We.set(a.$mK.ExtHostDocumentsAndEditors,at.get(s.$xM)),gt=We.set(a.$mK.ExtHostCommands,at.get(t.$IM)),ht=We.set(a.$mK.ExtHostTerminalService,at.get(B.$Tcc)),ft=We.set(a.$mK.ExtHostDebugService,at.get(ee.$Edc)),mi=We.set(a.$mK.ExtHostSearch,at.get(pe.$Odc)),St=We.set(a.$mK.ExtHostTask,at.get(Z.$zdc)),Si=We.set(a.$mK.ExtHostOutputService,at.get(y.$cdc)),ui=We.set(a.$mK.ExtHostLocalization,at.get(nt.$2cc)),$i=We.set(a.$mK.ExtHostUrls,new Pe.$ldc(We)),It=We.set(a.$mK.ExtHostDocuments,new r.$jcc(We,Dt)),fn=We.set(a.$mK.ExtHostDocumentContentProviders,new m.$Dcc(We,Dt,ge)),ri=We.set(a.$mK.ExtHostDocumentSaveParticipant,new n.$Ecc(ge,It,We.getProxy(a.$lK.MainThreadBulkEdits))),yt=We.set(a.$mK.ExtHostNotebook,new le.$Udc(We,gt,Dt,It,Vt)),pi=We.set(a.$mK.ExtHostNotebookDocuments,new Q.$aec(yt)),vi=We.set(a.$mK.ExtHostNotebookEditors,new Y.$_dc(ge,yt)),si=We.set(a.$mK.ExtHostNotebookKernels,new xe.$9dc(We,dt,yt,gt,ge)),Ii=We.set(a.$mK.ExtHostNotebookRenderers,new tt.$$dc(We,yt)),Ci=We.set(a.$mK.ExtHostNotebookDocumentSaveParticipant,new vt.$gec(ge,yt,We.getProxy(a.$lK.MainThreadBulkEdits))),Mt=We.set(a.$mK.ExtHostEditors,new T.$jdc(We,Dt)),bi=We.set(a.$mK.ExtHostTreeViews,new z.$kdc(We.getProxy(a.$lK.MainThreadTreeViews),gt,ge)),Pi=We.set(a.$mK.ExtHostEditorInsets,new ae.$tdc(We.getProxy(a.$lK.MainThreadEditorInsets),Mt,dt.remote)),oi=We.set(a.$mK.ExtHostDiagnostics,new p.$ncc(We,ge,At,Dt)),li=We.set(a.$mK.ExtHostLanguages,new I.$_cc(We,It,gt.converter,Ct)),ct=We.set(a.$mK.ExtHostLanguageFeatures,new C.$rcc(We,Ct,It,gt,oi,ge,Me,wt)),Ai=We.set(a.$mK.ExtHostFileSystem,new g.$0cc(We,ct)),Zt=We.set(a.$mK.ExtHostFileSystemEventService,new h.$$cc(We,ge,Dt)),ii=We.set(a.$mK.ExtHostQuickOpen,(0,S.$edc)(We,ot,gt)),Ri=We.set(a.$mK.ExtHostSCM,new j.$gdc(We,gt,It,ge)),Mi=We.set(a.$mK.ExtHostQuickDiff,new Pt.$dec(We,Ct)),Fi=We.set(a.$mK.ExtHostShare,new Gt.$iec(We,Ct)),Xi=We.set(a.$mK.ExtHostComments,(0,i.$ucc)(We,gt,It)),Li=We.set(a.$mK.ExtHostProgress,new b.$ddc(We.getProxy(a.$lK.MainThreadProgress))),Yi=We.set(a.$mK.ExtHosLabelService,new we.$udc(We)),Ti=We.set(a.$mK.ExtHostTheming,new ne.$Vdc(We)),ai=We.set(a.$mK.ExtHostAuthentication,new Ce.$Wdc(We)),gn=We.set(a.$mK.ExtHostTimeline,new F.$Ydc(We,gt)),Ni=We.set(a.$mK.ExtHostWebviews,new ke.$odc(We,dt.remote,ot,ge,Me)),hi=We.set(a.$mK.ExtHostWebviewPanels,new x.$1dc(We,Ni,ot)),Oi=We.set(a.$mK.ExtHostCustomEditors,new q.$2dc(We,It,Ie,Ni,hi)),mn=We.set(a.$mK.ExtHostWebviewViews,new J.$Zdc(We,Ni)),di=We.set(a.$mK.ExtHostTesting,new je.$4dc(We,gt,Dt)),Zi=We.set(a.$mK.ExtHostUriOpeners,new Qe.$8dc(We)),zi=We.set(a.$mK.ExtHostProfileContentHandlers,new bt.$cec(We));We.set(a.$mK.ExtHostInteractive,new ve.$bec(We,yt,Dt,gt,ge));const xi=We.set(a.$mK.ExtHostInlineChat,new Ht.$fec(We,gt,It,ge)),fi=We.set(a.$mK.ExtHostChatProvider,new jt.$jec(We,ge)),_i=We.set(a.$mK.ExtHostChatAgents,new Wt.$oec(We,fi,ge)),$n=We.set(a.$mK.ExtHostChatAgents2,new Kt.$pec(We,fi,ge)),Ui=We.set(a.$mK.ExtHostChatVariables,new Lt.$lec(We)),gi=We.set(a.$mK.ExtHostChat,new qt.$eec(We,ge)),xt=We.set(a.$mK.ExtHostAiRelatedInformation,new Bt.$mec(We)),wi=We.set(a.$mK.ExtHostAiEmbeddingVector,new Jt.$nec(We)),pn=We.set(a.$mK.ExtHostIssueReporter,new Ut.$hec(We)),Xt=We.set(a.$mK.ExtHostStatusBar,new O.$idc(We,gt.converter)),yi=We.set(a.$mK.ExtHostSpeech,new kt.$kec(We)),en=Object.values(a.$mK);We.assertRegistered(en);const tn=new ce.$3dc(We,Dt),nn=new d.$tcc(We),Ei=new c.$adc(We,ge),rn=new E.$Ccc(We);return $.$scc.register(gt),function(Te,_t,sn){const mt=function(){let te=!Te.isUnderDevelopment;function de(){te||(ge.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")de();else{const pt=rt;typeof pt.scheme>"u"&&de(),typeof pt.exclusive=="boolean"&&(0,Oe.$hF)(Te,"documentFiltersExclusive")}return rt}}(),ji={getSession(te,de,Le){return ai.getSession(Te,te,de,Le)},getSessions(te,de){return(0,Oe.$hF)(Te,"authGetSessions"),ai.getSessions(Te,te,de)},async hasSession(te,de){return(0,Oe.$hF)(Te,"authSession"),!!await ai.getSession(Te,te,de,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,de,Le,rt){return ai.registerAuthenticationProvider(te,de,Le,rt)}},on={registerCommand(te,de,Le){return gt.registerCommand(!0,te,de,Le,void 0,Te)},registerTextEditorCommand(te,de,Le){return gt.registerCommand(!0,te,(...rt)=>{const pt=Mt.getActiveTextEditor();if(!pt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return pt.edit(Ft=>{de.apply(Le,[pt,Ft,...rt])}).then(Ft=>{Ft||ge.warn("Edits from command "+te+" were not applied.")},Ft=>{ge.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Te)},registerDiffInformationCommand:(te,de,Le)=>((0,Oe.$hF)(Te,"diffCommand"),gt.registerCommand(!0,te,async(...rt)=>{const pt=Dt.activeEditor(!0);if(!pt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await Mt.getDiffInformation(pt.id);de.apply(Le,[Ft,...rt])},void 0,void 0,Te)),executeCommand(te,...de){return gt.executeCommand(te,...de)},getCommands(te=!1){return gt.getCommands(te)}},Bi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return ht.getDefaultShell(!1)},get onDidChangeShell(){return ht.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$hF)(Te,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$hF)(Te,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ze.$FM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Ze.$EM.validateSender(te),wt.instantiateLogger(Te,te,de)},openExternal(te,de){return Ue.openUri(te,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===dt.environment.appUriScheme)return $i.createAppUri(te);try{return await Ue.asExternalUri(te,{allowTunneling:!!dt.remote.authority})}catch(de){if((0,ut.$kU)(te,ze.Schemas.http)||(0,ut.$kU)(te,ze.Schemas.https))return te;throw de}},get remoteName(){return(0,_.$Vk)(dt.remote.authority)},get remoteAuthority(){return(0,Oe.$hF)(Te,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$hF)(Te,"handleIssueUri"),pn.registerIssueUriRequestHandler(Te,te)},get appQuality(){return(0,Oe.$hF)(Te,"resolvers"),dt.quality},get appCommit(){return(0,Oe.$hF)(Te,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(te,de,Le){return di.createTestController(Te,te,de,Le)},createTestObserver(){return(0,Oe.$hF)(Te,"testObserver"),di.createTestObserver()},runTests(te){return(0,Oe.$hF)(Te,"testObserver"),di.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$hF)(Te,"testObserver"),di.onResultsChanged},get testResults(){return(0,Oe.$hF)(Te,"testObserver"),di.results}},Di=dt.remote.isRemote?X.ExtensionKind.Workspace:X.ExtensionKind.UI,vn={getExtension(te,de){(0,Oe.$gF)(Te,"extensionsAny")||(de=!1);const Le=_t.mine.getExtensionDescription(te);if(Le)return new o.$8cc(Rt,Te.identifier,Le,Di,!1);if(de){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$8cc(Rt,Te.identifier,rt,Di,!0)}},get all(){const te=[];for(const de of _t.mine.getAllExtensionDescriptions())te.push(new o.$8cc(Rt,Te.identifier,de,Di,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$hF)(Te,"extensionsAny");const te=new ue.$7l(_t.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),de=[];for(const Le of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Le.identifier);de.push(new o.$8cc(Rt,Te.identifier,Le,Di,rt))}return de},get onDidChange(){return(0,Oe.$gF)(Te,"extensionsAny")?P.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Te.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(te,de){return li.changeLanguage(te.uri,de)},match(te,de){const Le=It.getDocumentData(de.uri)?.notebook;return(0,R.$tE)(ie.LanguageSelector.from(te),de.uri,de.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(te,de,Le){return ct.registerCodeActionProvider(Te,mt(te),de,Le)},registerDocumentPasteEditProvider(te,de,Le){return(0,Oe.$hF)(Te,"documentPaste"),ct.registerDocumentPasteEditProvider(Te,mt(te),de,Le)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Te,mt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Te,mt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Te,mt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Te,mt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Te,mt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Te,mt(te),de,Te.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Te,mt(te),de,Te.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Te,mt(te),de,Te.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Te,mt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Te,mt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Te,mt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Te,mt(te),de)},registerDocumentSymbolProvider(te,de,Le){return ct.registerDocumentSymbolProvider(Te,mt(te),de,Le)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Te,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Te,mt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Te,mt(te),de)},registerOnTypeFormattingEditProvider(te,de,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Te,mt(te),de,[Le].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Le){return ct.registerDocumentSemanticTokensProvider(Te,mt(te),de,Le)},registerDocumentRangeSemanticTokensProvider(te,de,Le){return ct.registerDocumentRangeSemanticTokensProvider(Te,mt(te),de,Le)},registerSignatureHelpProvider(te,de,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Te,mt(te),de,Le):ct.registerSignatureHelpProvider(Te,mt(te),de,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(te,de,...Le){return ct.registerCompletionItemProvider(Te,mt(te),de,Le)},registerInlineCompletionItemProvider(te,de,Le){return de.handleDidShowCompletionItem&&(0,Oe.$hF)(Te,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$hF)(Te,"inlineCompletionsAdditions"),Le&&(0,Oe.$hF)(Te,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Te,mt(te),de,Le)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Te,mt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Te,mt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Te,mt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Te,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Te,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Te,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Te,te,de),getTokenInformationAtPosition(te,de){return(0,Oe.$hF)(Te,"tokenInformation"),li.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Te,te,de)},createLanguageStatusItem(te,de){return li.createLanguageStatusItem(Te,te,de)},registerDocumentDropEditProvider(te,de,Le){return ct.registerDocumentOnDropEditProvider(Te,te,de,(0,Oe.$gF)(Te,"dropMetadata")?Le:void 0)}},un={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(te,de,Le){const rt=await(A.URI.isUri(te)?Promise.resolve(ki.openTextDocument(te)):Promise.resolve(te));return Mt.showTextDocument(rt,de,Le)},createTextEditorDecorationType(te){return Mt.createTextEditorDecorationType(Te,te)},onDidChangeActiveTextEditor(te,de,Le){return Mt.onDidChangeActiveTextEditor(te,de,Le)},onDidChangeVisibleTextEditors(te,de,Le){return Mt.onDidChangeVisibleTextEditors(te,de,Le)},onDidChangeTextEditorSelection(te,de,Le){return Mt.onDidChangeTextEditorSelection(te,de,Le)},onDidChangeTextEditorOptions(te,de,Le){return Mt.onDidChangeTextEditorOptions(te,de,Le)},onDidChangeTextEditorVisibleRanges(te,de,Le){return Mt.onDidChangeTextEditorVisibleRanges(te,de,Le)},onDidChangeTextEditorViewColumn(te,de,Le){return Mt.onDidChangeTextEditorViewColumn(te,de,Le)},onDidCloseTerminal(te,de,Le){return ht.onDidCloseTerminal(te,de,Le)},onDidOpenTerminal(te,de,Le){return ht.onDidOpenTerminal(te,de,Le)},onDidChangeActiveTerminal(te,de,Le){return ht.onDidChangeActiveTerminal(te,de,Le)},onDidChangeTerminalDimensions(te,de,Le){return(0,Oe.$hF)(Te,"terminalDimensions"),ht.onDidChangeTerminalDimensions(te,de,Le)},onDidChangeTerminalState(te,de,Le){return ht.onDidChangeTerminalState(te,de,Le)},onDidWriteTerminalData(te,de,Le){return(0,Oe.$hF)(Te,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(te,de,Le)},onDidExecuteTerminalCommand(te,de,Le){return(0,Oe.$hF)(Te,"terminalExecuteCommandEvent"),ht.onDidExecuteTerminalCommand(te,de,Le)},get state(){return Ue.getState(Te)},onDidChangeWindowState(te,de,Le){return Ue.onDidChangeWindowState(te,de,Le)},showInformationMessage(te,...de){return Ei.showMessage(Te,L.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return Ei.showMessage(Te,L.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return Ei.showMessage(Te,L.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Le){return ii.showQuickPick(Te,te,de,Le)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return rn.showOpenDialog(Te,te)},showSaveDialog(te){return rn.showSaveDialog(te)},createStatusBarItem(te,de,Le){let rt,pt,Ft;return typeof te=="string"?(rt=te,pt=de,Ft=Le):(pt=te,Ft=de),Xt.createStatusBarEntry(Te,rt,pt,Ft)},setStatusBarMessage(te,de){return Xt.setStatusBarMessage(te,de)},withScmProgress(te){return Me.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Li.withProgress(Te,{location:X.ProgressLocation.SourceControl},(de,Le)=>te({report(rt){}}))},withProgress(te,de){return Li.withProgress(Te,te,de)},createOutputChannel(te,de){return Si.createOutputChannel(te,de,Te)},createWebviewPanel(te,de,Le,rt){return hi.createWebviewPanel(Te,te,de,Le,rt)},createWebviewTextEditorInset(te,de,Le,rt){return(0,Oe.$hF)(Te,"editorInsets"),Pi.createWebviewEditorInset(te,de,Le,rt,Te)},createTerminal(te,de,Le){return typeof te=="object"?"pty"in te?ht.createExtensionTerminal(te):ht.createTerminalFromOptions(te):ht.createTerminal(te,de,Le)},registerTerminalLinkProvider(te){return ht.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return ht.registerProfileProvider(Te,te,de)},registerTerminalQuickFixProvider(te,de){return(0,Oe.$hF)(Te,"terminalQuickFixProvider"),ht.registerTerminalQuickFixProvider(te,Te.identifier.value,de)},registerTreeDataProvider(te,de){return bi.registerTreeDataProvider(te,de,Te)},createTreeView(te,de){return bi.createTreeView(te,de,Te)},registerWebviewPanelSerializer:(te,de)=>hi.registerWebviewPanelSerializer(Te,te,de),registerCustomEditorProvider:(te,de,Le={})=>Oi.registerCustomEditorProvider(Te,te,de,Le),registerFileDecorationProvider(te){return Et.registerFileDecorationProvider(te,Te)},registerUriHandler(te){return $i.registerUriHandler(Te,te)},createQuickPick(){return ii.createQuickPick(Te)},createInputBox(){return ii.createInputBox(Te)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(te,de,Le){return Ti.onDidChangeActiveColorTheme(te,de,Le)},registerWebviewViewProvider(te,de,Le){return mn.registerWebviewViewProvider(Te,te,de,Le?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Le){return yt.onDidChangeActiveNotebookEditor(te,de,Le)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Le){return vi.onDidChangeNotebookEditorSelection(te,de,Le)},onDidChangeNotebookEditorVisibleRanges(te,de,Le){return vi.onDidChangeNotebookEditorVisibleRanges(te,de,Le)},showNotebookDocument(te,de){return yt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Le){return(0,Oe.$hF)(Te,"externalUriOpener"),Zi.registerExternalUriOpener(Te.identifier,te,de,Le)},registerProfileContentHandler(te,de){return(0,Oe.$hF)(Te,"profileContentHandlers"),zi.registrProfileContentHandler(Te,te,de)},registerQuickDiffProvider(te,de,Le,rt){return(0,Oe.$hF)(Te,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(te),de,Le,rt)},get tabGroups(){return Ve.tabGroups},registerShareProvider(te,de){return(0,Oe.$hF)(Te,"shareProvider"),Fi.registerShareProvider(mt(te),de)}},ki={get rootPath(){return Me.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw new M.$9("rootPath")},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw new M.$9("name")},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(te,de,...Le)=>ot.updateWorkspaceFolders(Te,te,de||0,...Le),onDidChangeWorkspaceFolders:function(te,de,Le){return ot.onDidChangeWorkspace(te,de,Le)},asRelativePath:(te,de)=>ot.getRelativePath(te,de),findFiles:(te,de,Le,rt)=>ot.findFiles(te,de,Le,Te.identifier,rt),findTextInFiles:(te,de,Le,rt)=>{(0,Oe.$hF)(Te,"findTextInFiles");let pt,Ft;return typeof de=="object"?(pt=de,Ft=Le):(pt={},Ft=de,rt=Le),ot.findTextInFiles(te,pt||{},Ft,Te.identifier,rt)},save:te=>((0,Oe.$hF)(Te,"saveEditor"),ot.save(te)),saveAs:te=>((0,Oe.$hF)(Te,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,de){return tn.applyWorkspaceEdit(te,Te,de)},createFileSystemWatcher:(te,de,Le,rt)=>{let pt;return typeof de=="boolean"?pt={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt}:de&&((0,Oe.$hF)(Te,"createFileSystemWatcher"),pt=de),Zt.createFileSystemWatcher(ot,Te,te,pt)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$9("textDocuments")},openTextDocument(te){let de;const Le=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Le||typeof Le=="object")de=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>It.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(te,de,Le)=>It.onDidAddDocument(te,de,Le),onDidCloseTextDocument:(te,de,Le)=>It.onDidRemoveDocument(te,de,Le),onDidChangeTextDocument:(te,de,Le)=>It.onDidChangeDocument(te,de,Le),onDidSaveTextDocument:(te,de,Le)=>It.onDidSaveDocument(te,de,Le),onWillSaveTextDocument:(te,de,Le)=>ri.getOnWillSaveTextDocumentEvent(Te)(te,de,Le),get notebookDocuments(){return yt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Le;if(A.URI.isUri(te))Le=te,await yt.openNotebookDocument(te);else if(typeof te=="string")Le=A.URI.revive(await yt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(te,de,Le){return pi.onDidSaveNotebookDocument(te,de,Le)},onDidChangeNotebookDocument(te,de,Le){return pi.onDidChangeNotebookDocument(te,de,Le)},onWillSaveNotebookDocument(te,de,Le){return Ci.getOnWillSaveNotebookDocumentEvent(Te)(te,de,Le)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Le,rt){return yt.registerNotebookSerializer(Te,te,de,Le,(0,Oe.$gF)(Te,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Le)=>sn.onDidChangeConfiguration(te,de,Le),getConfiguration(te,de){return de=arguments.length===1?void 0:de,sn.getConfiguration(te,de,Te)},registerTextDocumentContentProvider(te,de){return fn.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Me.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Te,te,de)),registerFileSystemProvider(te,de,Le){return(0,Be.$Pc)(Ai.registerFileSystemProvider(Te,te,de,Le),Vt.addFileSystemProvider(te,de,Le))},get fs(){return Vt.value},registerFileSearchProvider:(te,de)=>((0,Oe.$hF)(Te,"fileSearchProvider"),mi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Oe.$hF)(Te,"textSearchProvider"),mi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Oe.$hF)(Te,"resolvers"),Rt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Oe.$hF)(Te,"resolvers"),Yi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$hF)(Te,"resolvers"),Rt.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Le)=>Zt.onDidCreateFile(te,de,Le),onDidDeleteFiles:(te,de,Le)=>Zt.onDidDeleteFile(te,de,Le),onDidRenameFiles:(te,de,Le)=>Zt.onDidRenameFile(te,de,Le),onWillCreateFiles:(te,de,Le)=>Zt.getOnWillCreateFileEvent(Te)(te,de,Le),onWillDeleteFiles:(te,de,Le)=>Zt.getOnWillDeleteFileEvent(Te)(te,de,Le),onWillRenameFiles:(te,de,Le)=>Zt.getOnWillRenameFileEvent(Te)(te,de,Le),openTunnel:te=>((0,Oe.$hF)(Te,"tunnels"),H.openTunnel(Te,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Oe.$hF)(Te,"tunnels"),H.getTunnels()},onDidChangeTunnels:(te,de,Le)=>((0,Oe.$hF)(Te,"tunnels"),H.onDidChangeTunnels(te,de,Le)),registerPortAttributesProvider:(te,de)=>((0,Oe.$hF)(Te,"portsAttributes"),H.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,Oe.$hF)(Te,"tunnelFactory"),H.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Oe.$hF)(Te,"timeline"),gn.registerTimelineProvider(te,de,Te.identifier,gt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,Oe.$hF)(Te,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Le)=>ot.onDidGrantWorkspaceTrust(te,de,Le),registerEditSessionIdentityProvider:(te,de)=>((0,Oe.$hF)(Te,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Le)=>((0,Oe.$hF)(Te,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Te)(te,de,Le)),registerCanonicalUriProvider:(te,de)=>((0,Oe.$hF)(Te,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Le)=>((0,Oe.$hF)(Te,"canonicalUriProvider"),ot.provideCanonicalUri(te,de,Le))},Wi={get inputBox(){return Me.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Te)},createSourceControl(te,de,Le){return Ri.createSourceControl(Te,te,de,Le)}},Ki={createCommentController(te,de){return Xi.createCommentController(Te,te,de)}},ci={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,de,Le){return ft.onDidStartDebugSession(te,de,Le)},onDidTerminateDebugSession(te,de,Le){return ft.onDidTerminateDebugSession(te,de,Le)},onDidChangeActiveDebugSession(te,de,Le){return ft.onDidChangeActiveDebugSession(te,de,Le)},onDidReceiveDebugSessionCustomEvent(te,de,Le){return ft.onDidReceiveDebugSessionCustomEvent(te,de,Le)},onDidChangeBreakpoints(te,de,Le){return ft.onDidChangeBreakpoints(te,de,Le)},onDidChangeStackFrameFocus(te,de,Le){return(0,Oe.$hF)(Te,"debugFocus"),ft.onDidChangeStackFrameFocus(te,de,Le)},registerDebugConfigurationProvider(te,de,Le){return ft.registerDebugConfigurationProvider(te,de,Le||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return ft.registerDebugAdapterDescriptorFactory(Te,te,de)},registerDebugAdapterTrackerFactory(te,de){return ft.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Le){return!Le||typeof Le=="object"&&"configuration"in Le?ft.startDebugging(te,de,{parentSession:Le}):ft.startDebugging(te,de,Le||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,de){return ft.asDebugSourceUri(te,de)}},Vi={registerTaskProvider:(te,de)=>St.registerTaskProvider(Te,te,de),fetchTasks:te=>St.fetchTasks(te),executeTask:te=>St.executeTask(Te,te),get taskExecutions(){return St.taskExecutions},onDidStartTask:(te,de,Le)=>St.onDidStartTask(te,de,Le),onDidEndTask:(te,de,Le)=>St.onDidEndTask(te,de,Le),onDidStartTaskProcess:(te,de,Le)=>St.onDidStartTaskProcess(te,de,Le),onDidEndTaskProcess:(te,de,Le)=>St.onDidEndTaskProcess(te,de,Le)},qi={createNotebookController(te,de,Le,rt,pt){return si.createNotebookController(Te,te,de,Le,rt,(0,Oe.$gF)(Te,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>yt.registerNotebookCellStatusBarItemProvider(Te,te,de),createRendererMessaging(te){return Ii.createRendererMessaging(Te,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$hF)(Te,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Te,te)},registerKernelSourceActionProvider(te,de){return(0,Oe.$hF)(Te,"notebookKernelSource"),si.registerKernelSourceActionProvider(Te,te,de)},onDidChangeNotebookCellExecutionState(te,de,Le){return(0,Oe.$hF)(Te,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,de,Le)}},Hi={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Le=!te||typeof te[0]!="object"?te:te[0];return ui.getMessage(Te.identifier.value,{message:de,args:Le})}return ui.getMessage(Te.identifier.value,te[0])},get bundle(){return ui.getBundle(Te.identifier.value)},get uri(){return ui.getBundleUri(Te.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,Oe.$hF)(Te,"interactive"),xi.registerProvider(Te,te,de={label:de?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(te,de){return(0,Oe.$hF)(Te,"interactive"),gi.registerChatProvider(Te,te,de)},sendInteractiveRequestToProvider(te,de){return(0,Oe.$hF)(Te,"interactive"),gi.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,Oe.$hF)(Te,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(te,de){return(0,Oe.$hF)(Te,"interactive"),gi.transferChatSession(te,de)}},ln={getRelatedInformation(te,de){return(0,Oe.$hF)(Te,"aiRelatedInformation"),xt.getRelatedInformation(Te,te,de)},registerRelatedInformationProvider(te,de){return(0,Oe.$hF)(Te,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Te,te,de)},registerEmbeddingVectorProvider(te,de){return(0,Oe.$hF)(Te,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Te,te,de)}},hn={registerChatResponseProvider(te,de,Le){return(0,Oe.$hF)(Te,"chatProvider"),fi.registerProvider(Te.identifier,te,de,Le)},requestChatAccess(te){return(0,Oe.$hF)(Te,"chatRequestAccess"),fi.requestChatResponseProvider(Te.identifier,te)},registerVariable(te,de,Le){return(0,Oe.$hF)(Te,"chatVariables"),Ui.registerVariableResolver(Te,te,de,Le)},registerMappedEditsProvider(te,de){return(0,Oe.$hF)(Te,"mappedEditsProvider"),ct.registerMappedEditsProvider(Te,te,de)},createChatAgent(te,de){return(0,Oe.$hF)(Te,"chatAgents2"),$n.createChatAgent(Te,te,de)},registerAgent(te,de,Le){return(0,Oe.$hF)(Te,"chatAgents"),_i.registerAgent(Te.identifier,te,de,Le)}},dn={registerSpeechProvider(te,de){return(0,Oe.$hF)(Te,"speech"),yi.registerProvider(Te.identifier,te,de)}};return{version:dt.version,ai:ln,authentication:ji,commands:on,comments:Ki,chat:hn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:cn,notebooks:qi,scm:Wi,speech:dn,tasks:Vi,tests:an,window:un,workspace:ki,Breakpoint:X.$lL,TerminalOutputAnchor:X.TerminalOutputAnchor,ChatAgentResultFeedbackKind:X.ChatAgentResultFeedbackKind,ChatMessage:X.$bM,ChatMessageRole:X.ChatMessageRole,ChatVariableLevel:X.ChatVariableLevel,CallHierarchyIncomingCall:X.$KK,CallHierarchyItem:X.$JK,CallHierarchyOutgoingCall:X.$LK,CancellationError:M.$5,CancellationTokenSource:w.$Xd,CandidatePortSource:a.CandidatePortSource,CodeAction:X.$GK,CodeActionKind:X.$HK,CodeActionTriggerKind:X.CodeActionTriggerKind,CodeLens:X.$MK,Color:X.$ZK,ColorInformation:X.$1K,ColorPresentation:X.$2K,ColorThemeKind:X.ColorThemeKind,CommentMode:X.CommentMode,CommentState:X.CommentState,CommentThreadCollapsibleState:X.CommentThreadCollapsibleState,CommentThreadState:X.CommentThreadState,CompletionItem:X.$TK,CompletionItemKind:X.CompletionItemKind,CompletionItemTag:X.CompletionItemTag,CompletionList:X.$UK,CompletionTriggerKind:X.CompletionTriggerKind,ConfigurationTarget:X.ConfigurationTarget,CustomExecution:X.$0K,DebugAdapterExecutable:X.$pL,DebugAdapterInlineImplementation:X.$sL,DebugAdapterNamedPipeServer:X.$rL,DebugAdapterServer:X.$qL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:X.DebugConsoleMode,DecorationRangeBehavior:X.DecorationRangeBehavior,Diagnostic:X.$BK,DiagnosticRelatedInformation:X.$AK,DiagnosticSeverity:X.DiagnosticSeverity,DiagnosticTag:X.DiagnosticTag,Disposable:X.$nK,DocumentHighlight:X.$DK,DocumentHighlightKind:X.DocumentHighlightKind,DocumentLink:X.$YK,DocumentSymbol:X.$FK,EndOfLine:X.EndOfLine,EnvironmentVariableMutatorType:X.EnvironmentVariableMutatorType,EvaluatableExpression:X.$vL,InlineValueText:X.$wL,InlineValueVariableLookup:X.$xL,InlineValueEvaluatableExpression:X.$yL,InlineCompletionTriggerKind:X.InlineCompletionTriggerKind,EventEmitter:P.$Nd,ExtensionKind:X.ExtensionKind,ExtensionMode:X.ExtensionMode,ExternalUriOpenerPriority:X.ExternalUriOpenerPriority,FileChangeType:X.FileChangeType,FileDecoration:X.$IL,FileDecoration2:X.$IL,FileSystemError:X.$AL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:X.$BL,FoldingRangeKind:X.FoldingRangeKind,FunctionBreakpoint:X.$nL,InlineCompletionItem:X.$VK,InlineCompletionList:X.$WK,Hover:X.$CK,IndentAction:f.IndentAction,Location:X.$zK,MarkdownString:X.$NK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:X.$OK,PortAutoForwardAction:X.PortAutoForwardAction,Position:X.$oK,ProcessExecution:X.$8K,ProgressLocation:X.ProgressLocation,QuickInputButtons:X.$HL,Range:X.$pK,RelativePattern:X.$jL,Selection:X.$qK,SelectionRange:X.$IK,SemanticTokens:X.$EL,SemanticTokensBuilder:X.$DL,SemanticTokensEdit:X.$FL,SemanticTokensEdits:X.$GL,SemanticTokensLegend:X.$CL,ShellExecution:X.$9K,ShellQuoting:X.ShellQuoting,SignatureHelp:X.$QK,SignatureHelpTriggerKind:X.SignatureHelpTriggerKind,SignatureInformation:X.$PK,SnippetString:X.$yK,SourceBreakpoint:X.$mL,StandardTokenType:X.StandardTokenType,StatusBarAlignment:X.StatusBarAlignment,SymbolInformation:X.$EK,SymbolKind:X.SymbolKind,SymbolTag:X.SymbolTag,Task:X.$$K,TaskGroup:X.$7K,TaskPanelKind:X.TaskPanelKind,TaskRevealKind:X.TaskRevealKind,TaskScope:X.TaskScope,TerminalLink:X.$3K,TerminalQuickFixExecuteTerminalCommand:X.$5K,TerminalQuickFixOpener:X.$4K,TerminalLocation:X.TerminalLocation,TerminalProfile:X.$6K,TerminalExitReason:X.TerminalExitReason,TextDocumentSaveReason:X.TextDocumentSaveReason,TextEdit:X.$uK,SnippetTextEdit:X.$wK,TextEditorCursorStyle:u.TextEditorCursorStyle,TextEditorLineNumbersStyle:X.TextEditorLineNumbersStyle,TextEditorRevealType:X.TextEditorRevealType,TextEditorSelectionChangeKind:X.TextEditorSelectionChangeKind,SyntaxTokenType:X.SyntaxTokenType,TextDocumentChangeReason:X.TextDocumentChangeReason,ThemeColor:X.$iL,ThemeIcon:X.$hL,TreeItem:X.$_K,TreeItemCheckboxState:X.TreeItemCheckboxState,TreeItemCollapsibleState:X.TreeItemCollapsibleState,TypeHierarchyItem:X.$4L,UIKind:v.UIKind,Uri:A.URI,ViewColumn:X.ViewColumn,WorkspaceEdit:X.$xK,DocumentDropEdit:X.$fL,DocumentPasteEdit:X.$gL,InlayHint:X.$SK,InlayHintLabelPart:X.$RK,InlayHintKind:X.InlayHintKind,RemoteAuthorityResolverError:X.$tK,ResolvedAuthority:X.$rK,ManagedResolvedAuthority:X.$sK,SourceControlInputBoxValidationType:X.SourceControlInputBoxValidationType,ExtensionRuntime:X.ExtensionRuntime,TimelineItem:X.$SL,NotebookRange:X.$KL,NotebookCellKind:X.NotebookCellKind,NotebookCellExecutionState:X.NotebookCellExecutionState,NotebookCellData:X.$LL,NotebookData:X.$ML,NotebookRendererScript:X.$QL,NotebookCellStatusBarAlignment:X.NotebookCellStatusBarAlignment,NotebookEditorRevealType:X.NotebookEditorRevealType,NotebookCellOutput:X.$OL,NotebookCellOutputItem:X.$NL,NotebookCellStatusBarItem:X.$PL,NotebookControllerAffinity:X.NotebookControllerAffinity,NotebookControllerAffinity2:X.NotebookControllerAffinity2,NotebookEdit:X.$vK,NotebookKernelSourceAction:X.$RL,PortAttributes:X.$UL,LinkedEditingRanges:X.$TL,TestResultState:X.TestResultState,TestRunRequest:X.$VL,TestMessage:X.$WL,TestMessage2:X.$WL,TestTag:X.$XL,TestRunProfileKind:X.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:X.$eL,DataTransferItem:X.$aL,CoveredCount:X.$YL,FileCoverage:X.$ZL,StatementCoverage:X.$1L,BranchCoverage:X.$2L,FunctionCoverage:X.$3L,WorkspaceTrustState:X.WorkspaceTrustState,LanguageStatusSeverity:X.LanguageStatusSeverity,QuickPickItemKind:X.QuickPickItemKind,InputBoxValidationSeverity:X.InputBoxValidationSeverity,TabInputText:X.$5L,TabInputTextDiff:X.$6L,TabInputTextMerge:X.$7L,TabInputCustom:X.$8L,TabInputNotebook:X.$0L,TabInputNotebookDiff:X.$$L,TabInputWebview:X.$9L,TabInputTerminal:X.$_L,TabInputInteractiveWindow:X.$aM,TelemetryTrustedValue:De.$jo,LogLevel:me.LogLevel,EditSessionIdentityMatch:$t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:X.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:X.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:X.InteractiveEditorResponseFeedbackKind,StackFrameFocus:X.$tL,ThreadFocus:X.$uL,RelatedInformationType:X.RelatedInformationType,SpeechToTextStatus:X.SpeechToTextStatus}}}e.$qec=Ot}),define(Ae[277],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,40,83,59,61,244,14,112,81,82]),function(be,e,w,M,P,L,A,u,D,f,R,k,a,v,$,d,t,i,l,p,E,m,n,r,s,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$wr)(o.$2cc,o.$1cc,1),(0,w.$wr)(r.$$i,n.$rec,1),(0,w.$wr)(d.$occ,d.$pcc,1),(0,w.$wr)(u.$IM,u.$HM,0),(0,w.$wr)(A.$Bcc,A.$zcc,0),(0,w.$wr)(i.$Qcc,i.$Pcc,0),(0,w.$wr)(k.$Edc,k.$Idc,0),(0,w.$wr)(L.$wdc,L.$vdc,0),(0,w.$wr)(D.$xM,D.$wM,0),(0,w.$wr)(g.$3cc,g.$4cc,0),(0,w.$wr)(l.$lcc,l.$kcc,0),(0,w.$wr)(M.$cdc,M.$bdc,1),(0,w.$wr)(a.$Odc,a.$Pdc,0),(0,w.$wr)(v.$Mcc,v.$Lcc,0),(0,w.$wr)(R.$zdc,R.$ydc,0),(0,w.$wr)(f.$Tcc,f.$Wcc,0),(0,w.$wr)($.$cwb,$.$dwb,0),(0,w.$wr)(t.$sdc,t.$rdc,0),(0,w.$wr)(P.$ycc,P.$xcc,0),(0,w.$wr)(p.$Ycc,p.$Xcc,0),(0,w.$wr)(E.$GM,E.$DM,0),(0,w.$wr)(m.$Adc,m.$Bdc,0),(0,w.$wr)(s.$Cdc,s.$Ddc,0)}),define(Ae[278],Re([1,0,276,35,2,273,7,12,264]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class f extends L.$uec{j(){}getModule(v,$){for(const d of this.b){const t=d(v);if(t){v=t;break}}if(this.a.has(v))return this.a.get(v).load(v,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$6cc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$zgc);const v=this.h.invokeFunction(w.$qec);this.r=this.h.createInstance(f,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,$,d){$=$.with({path:k($.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri($)),l=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),l.status!==200)throw new Error(l.statusText);const p=await l.text(),E=`${$.toString(!0)}#vscode-extension`,m=`${p}
//# sourceURL=${E}`;let n;try{n=new Function("module","exports","require",m)}catch(g){throw console.error(t?`Loading code for extension ${t} failed: ${g.message}`:`Loading code failed: ${g.message}`),console.error(`${$.toString(!0)}${typeof g.line=="number"?` line ${g.line}`:""}${typeof g.column=="number"?` column ${g.column}`:""}`),console.error(g),g}v&&await this.w.initializeLocalizedMessages(v);const r={},s={exports:r},o=g=>{const h=this.r.getModule(g,$);if(h===void 0)throw new Error(`Cannot load module '${g}'`);return h};try{return d.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,r,o),s.exports!==r?s.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),d.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+v;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,u.$Ug)(10)}}e.$Agc=R;function k(a,v){return a.endsWith(v)?a:a+v}}),define(Ae[279],Re([1,0,69,70,14,35,188,85,278]),function(be,e,w,M,P,L,A,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$wr)(P.$0i,new w.$Mh(A.$tec,[!0],!0)),(0,M.$wr)(L.$7cc,D.$Agc,0),(0,M.$wr)(u.$Rcc,u.$Scc,0)}),define(Ae[288],Re([1,0,26,5,78,274,266,20,87,13,2,277,279]),function(be,e,w,M,P,L,A,u,D,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(n){return/^(file|vscode-remote):/i.test(n)}const $=fetch.bind(self);function d(n){self.fetch=async function(r,s){return r instanceof Request||v(String(r))&&(r=(await n(R.URI.parse(String(r)))).toString(!0)),$(r,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,s,o,g,h){(async()=>(v(s.toString())&&(s=(await n(R.URI.parse(s.toString()))).toString(!0)),super.open(r,s,o??!0,g,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(r,s){if(/^file:/i.test(r.toString()))r=f.$cg.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const g=`(${function(c){function y(j){return typeof j=="string"||j instanceof URL?String(j).replace(/^file:\/\//i,"vscode-file://vscode-app"):j}const b=fetch.bind(self);self.fetch=function(j,O){return j instanceof Request?b(j,O):b(y(j),O)},self.XMLHttpRequest=class extends XMLHttpRequest{open(j,O,K,B,T){return super.open(j,y(O),K??!0,B,T)}};const S=importScripts.bind(self);self.importScripts=(...j)=>{S(...j.map(y))},S(c)}.toString()}('${r}'))`;s=s||{},s.name=s.name||u.$nc(r.toString());const h=new Blob([g],{type:"application/javascript"}),C=URL.createObjectURL(h);return new n(C,s)}}else self.Worker=class extends A.$Bgc{constructor(n,r){super(a,n,{name:u.$nc(n.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(n){k()}};class i{constructor(){const r=new MessageChannel,s=new M.$Nd;let o=!1;a(r.port2,[r.port2]),r.port1.onmessage=g=>{const{data:h}=g;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const C=w.$be.wrap(new Uint8Array(h,0,h.byteLength));if((0,P.$cm)(C,2)){o=!0,p("received terminate message from renderer");return}s.fire(C)},this.protocol={onMessage:s.event,send:g=>{if(!o){const h=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);r.port1.postMessage(h,[h])}}}}}function l(n){return new Promise(r=>{const s=n.onMessage(o=>{s.dispose();const g=JSON.parse(o.toString());n.send((0,P.$bm)(0)),r({protocol:n,initData:g})});n.send((0,P.$bm)(1))})}let p=n=>k();function E(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function m(){D.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(r){E(r)&&l(n.protocol).then(s=>{D.mark("code/extHost/didWaitForInitData");const o=new L.$wec(s.protocol,s.initData,t,null,r.data);d(g=>o.asBrowserUri(g)),p=g=>o.terminate(g)})}}}e.create=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cbd09078e6221fa1553c5a59dd25e63ad767911a/core/vs/workbench/api/worker/extensionHostWorker.js.map
