/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(q){for(var e=[],N=0,k=q.length;N<k;N++)e[N]=z[q[N]];return e};define(z[21],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const y=new Map,O=new Map,s=new Map,d=new Map;function t(c,n){c.has(n.detail)||c.set(n.detail,-n.timestamp)}function r(c,n){const i=c.get(n.detail);i&&(i>=0||c.set(n.detail,i+n.timestamp))}let o=[];typeof q=="function"&&typeof q.getStats=="function"&&(o=q.getStats().slice(0).sort((c,n)=>c.timestamp-n.timestamp));for(const c of o)switch(c.type){case 10:t(y,c);break;case 11:case 12:r(y,c);break;case 21:t(O,c);break;case 22:r(O,c);break;case 33:t(s,c);break;case 34:r(s,c);break;case 31:t(d,c);break;case 32:r(d,c);break}let h=0;s.forEach(c=>h+=c);function g(c){const n=[];return c.forEach((i,a)=>n.push([a,i])),n}return{amdLoad:g(y),amdInvoke:g(O),nodeRequire:g(s),nodeEval:g(d),nodeRequireTotal:h}}static toMarkdownTable(y,O){let s="";const d=[];return y.forEach((t,r)=>{d[r]=t.length}),O.forEach(t=>{t.forEach((r,o)=>{typeof r>"u"&&(r=t[o]="-");const h=r.toString().length;d[o]=Math.max(h,d[o])})}),y.forEach((t,r)=>{s+=`| ${t+" ".repeat(d[r]-t.toString().length)} `}),s+=`|
`,y.forEach((t,r)=>{s+=`| ${"-".repeat(d[r])} `}),s+=`|
`,O.forEach(t=>{t.forEach((r,o)=>{typeof r<"u"&&(s+=`| ${r+" ".repeat(d[o]-r.toString().length)} `)}),s+=`|
`}),s}}e.$U=N}),define(z[4],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rd=e.$qd=e.$pd=void 0;let N;function k(i){N=i}e.$pd=k;function y(){return N}e.$qd=y;class O{constructor(){this.a=0,this.d=new WeakMap}b(a){return s([d(c("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[d(" "),r(o(a.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),r(o(a.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),r(o(a.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(a,v){console.log(...this.b([t("observable value changed"),r(a.debugName,{color:"BlueViolet"}),...this.c(v)]))}formatChanges(a){if(a.size!==0)return r(" (changed deps: "+[...a].map(v=>v.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const v=a.handleChange;this.d.set(a,new Set),a.handleChange=(A,B)=>(this.d.get(a).add(A),v.apply(a,[A,B]))}handleDerivedRecomputed(a,v){const A=this.d.get(a);console.log(...this.b([t("derived recomputed"),r(a.debugName,{color:"BlueViolet"}),...this.c(v),this.formatChanges(A),{data:[{fn:a._computeFn}]}])),A.clear()}handleFromEventObservableTriggered(a,v){console.log(...this.b([t("observable from event triggered"),r(a.debugName,{color:"BlueViolet"}),...this.c(v),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const v=a.handleChange;this.d.set(a,new Set),a.handleChange=(A,B)=>(this.d.get(a).add(A),v.apply(a,[A,B]))}handleAutorunTriggered(a){const v=this.d.get(a);console.log(...this.b([t("autorun"),r(a.debugName,{color:"BlueViolet"}),this.formatChanges(v),{data:[{fn:a._runFn}]}])),v.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let v=a.getDebugName();v===void 0&&(v=""),console.log(...this.b([t("transaction"),r(v,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$rd=O;function s(i){const a=new Array,v=[];let A="";function B(T){if("length"in T)for(const $ of T)$&&B($);else"text"in T?(A+=`%c${T.text}`,a.push(T.style),T.data&&v.push(...T.data)):"data"in T&&v.push(...T.data)}B(i);const P=[A,...a];return P.push(...v),P}function d(i){return r(i,{color:"black"})}function t(i){return r(n(`${i}: `,10),{color:"black",bold:!0})}function r(i,a={color:"black"}){function v(B){return Object.entries(B).reduce((P,[T,$])=>`${P}${T}:${$};`,"")}const A={color:a.color};return a.strikeThrough&&(A["text-decoration"]="line-through"),a.bold&&(A["font-weight"]="bold"),{text:i,style:v(A)}}function o(i,a){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=a?`"${i}"`:`"${i.substr(0,a-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?h(i,a):g(i,a);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function h(i,a){let v="[ ",A=!0;for(const B of i){if(A||(v+=", "),v.length-5>a){v+="...";break}A=!1,v+=`${o(B,a-v.length)}`}return v+=" ]",v}function g(i,a){let v="{ ",A=!0;for(const[B,P]of Object.entries(i)){if(A||(v+=", "),v.length-5>a){v+="...";break}A=!1,v+=`${B}: ${o(P,a-v.length)}`}return v+=" }",v}function c(i,a){let v="";for(let A=1;A<=a;A++)v+=i;return v}function n(i,a){for(;i.length<a;)i+=" ";return i}}),define(z[5],W([0,1,4]),function(q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=void 0;let k;function y(m){k=m}e.$xd=y;class O{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,w){const M=w===void 0?void 0:l,f=w===void 0?l:w;return k({owner:M,debugName:()=>{const S=A(f);if(S!==void 0)return S;const D=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(f.toString());if(D)return`${this.debugName}.${D[2]}`;if(!M)return`${this.debugName} (mapped)`}},S=>f(this.read(S),S))}}e.$yd=O;class s extends O{constructor(){super(...arguments),this.c=new Set}addObserver(l){const w=this.c.size;this.c.add(l),w===0&&this.f()}removeObserver(l){this.c.delete(l)&&this.c.size===0&&this.g()}f(){}g(){}}e.$zd=s;function d(m,l){const w=new r(m,l);try{m(w)}finally{w.finish()}}e.$Ad=d;function t(m,l,w){m?l(m):d(l,w)}e.$Bd=t;class r{constructor(l,w){this._fn=l,this.b=w,this.a=[],(0,N.$qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():A(this._fn)}updateObserver(l,w){this.a.push({observer:l,observable:w}),l.beginUpdate(w)}finish(){const l=this.a;this.a=null;for(const{observer:w,observable:M}of l)w.endUpdate(M);(0,N.$qd)()?.handleEndTransaction()}}e.$Cd=r;const o=new Map,h=new WeakMap;function g(m,l,w,M,f){const S=h.get(m);if(S)return S;const L=c(m,l,w,M,f);if(L){let D=o.get(L)??0;D++,o.set(L,D);const I=D===1?L:`${L}#${D}`;return h.set(m,I),I}}e.$Dd=g;function c(m,l,w,M,f){const S=h.get(m);if(S)return S;const L=M?a(M)+".":"";let D;if(l!==void 0)if(typeof l=="function"){if(D=l(),D!==void 0)return L+D}else return L+l;if(w!==void 0&&(D=A(w),D!==void 0))return L+D;if(M!==void 0){for(const I in M)if(M[I]===f)return L+I}}const n=new Map,i=new WeakMap;function a(m){const l=i.get(m);if(l)return l;const w=v(m);let M=n.get(w)??0;M++,n.set(w,M);const f=M===1?w:`${w}#${M}`;return i.set(m,f),f}function v(m){const l=m.constructor;return l?l.name:"Object"}function A(m){const l=m.toString(),M=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(l);return(M?M[1]:void 0)?.trim()}e.$Ed=A;function B(m,l){return typeof m=="string"?new P(void 0,m,l):new P(m,void 0,l)}e.$Fd=B;class P extends s{get debugName(){return g(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(l,w,M){super(),this.b=l,this.d=w,this.a=M}get(){return this.a}set(l,w,M){if(this.a===l)return;let f;w||(w=f=new r(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.a;this.e(l),(0,N.$qd)()?.handleObservableChanged(this,{oldValue:S,newValue:l,change:M,didChange:!0,hadValue:!0});for(const L of this.c)w.updateObserver(L,this),L.handleChange(this,M)}finally{f&&f.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(l){this.a=l}}e.$Gd=P;function T(m,l){return typeof m=="string"?new $(void 0,m,l):new $(m,void 0,l)}e.$Hd=T;class $ extends P{e(l){this.a!==l&&(this.a&&this.a.dispose(),this.a=l)}dispose(){this.a?.dispose()}}e.$Id=$}),define(z[9],W([0,1,42,2,5,4]),function(q,e,N,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=void 0;function s(n,i){return new g(n.debugName,i,void 0,void 0)}e.$8c=s;function d(n){return new g(void 0,n,void 0,void 0)}e.$9c=d;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$0c=t;function r(n,i){const a=new k.$Rc,v=t({debugName:n.debugName??(()=>(0,y.$Ed)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(A,B)=>{a.clear(),i(A,B,a)});return(0,k.$Qc)(()=>{v.dispose(),a.dispose()})}e.$$c=r;function o(n){const i=new k.$Rc,a=s({debugName:()=>(0,y.$Ed)(n)||"(anonymous)"},v=>{i.clear(),n(v,i)});return(0,k.$Qc)(()=>{a.dispose(),i.dispose()})}e.$_c=o;var h;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(h||(h={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const a=this.h();if(a!==void 0)return a}const i=(0,y.$Ed)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,a,v,A){this.h=i,this._runFn=a,this.i=v,this.j=A,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$qd)()?.handleAutorunCreated(this),this.k(),(0,k.$Jc)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,k.$Kc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,O.$qd)()?.handleAutorunTriggered(this);const a=this.g;this.g=this.i?.(),this._runFn(this,a)}}finally{(0,O.$qd)()?.handleAutorunFinished(this);for(const a of this.f)a.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,N.$6c)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,a){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:a,didChange:A=>A===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const a=i.get();return this.e.add(i),this.f.delete(i),a}}e.$ad=g,function(n){n.Observer=g}(d||(e.$9c=d={}));function c(n,i){let a;return s({debugName:()=>(0,y.$Ed)(i)},v=>{const A=n.read(v),B=a;a=A,i({lastValue:B,newValue:A})})}e.$bd=c}),define(z[10],W([0,1,6,2,5,4]),function(q,e,N,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wd=e.$vd=e.$ud=e.$td=e.$sd=void 0;const s=(c,n)=>c===n;function d(c,n){return n!==void 0?new g(c,void 0,n,void 0,void 0,void 0,s):new g(void 0,void 0,c,void 0,void 0,void 0,s)}e.$sd=d;function t(c,n){return new g(c.owner,c.debugName,n,void 0,void 0,void 0,c.equalityComparer??s)}e.$td=t;function r(c,n){return new g(c.owner,c.debugName,n,c.createEmptyChangeSummary,c.handleChange,void 0,c.equalityComparer??s)}e.$ud=r;function o(c,n){let i,a;n===void 0?(i=c,a=void 0):(a=c,i=n);const v=new k.$Rc;return new g(a,()=>(0,y.$Ed)(i)??"(anonymous)",A=>(v.clear(),i(A,v)),void 0,void 0,()=>v.dispose(),s)}e.$vd=o,(0,y.$xd)(t);var h;(function(c){c[c.initial=0]="initial",c[c.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",c[c.stale=2]="stale",c[c.upToDate=3]="upToDate"})(h||(h={}));class g extends y.$zd{get debugName(){return(0,y.$Dd)(this,this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,a,v,A,B=void 0,P){super(),this.m=n,this.n=i,this._computeFn=a,this.p=v,this.q=A,this.s=B,this.t=P,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,O.$qd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,a=this.h;this.e=3;const v=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,v)}finally{for(const B of this.k)B.removeObserver(this);this.k.clear()}const A=i&&!this.t(a,this.h);if((0,O.$qd)()?.handleDerivedRecomputed(this,{oldValue:a,newValue:this.h,change:void 0,didChange:A,hadValue:i}),A)for(const B of this.c)B.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const a of this.c)a.handlePossibleChange(this);if(i)for(const a of this.c)a.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const a of i)a.endUpdate(this)}if(this.i<0)throw new N.$cb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const a=this.q?this.q({changedObservable:n,change:i,didChange:A=>A===n},this.l):!0,v=this.e===3;if(a&&(this.e===1||v)&&(this.e=2,v))for(const A of this.c)A.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$wd=g}),define(z[22],W([0,1,2,9,5,10,4]),function(q,e,N,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=void 0;function d(l){return new t(l)}e.$cd=d;class t extends y.$yd{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function r(l){const w=(0,y.$Fd)("promiseValue",{});return l.then(M=>{w.set({value:M},void 0)}),w}e.$dd=r;function o(l,w){return new Promise(M=>{let f=!1,S=!1;const L=(0,k.$9c)(D=>{const I=l.read(D);w(I)&&(f?L.dispose():S=!0,M(I))});f=!0,S&&L.dispose()})}e.$ed=o;function h(l,w){return new g(l,w)}e.$fd=h;class g extends y.$zd{constructor(w,M){super(),this.h=w,this._getValue=M,this.b=!1,this.k=f=>{const S=this._getValue(f),L=!this.b||this.a!==S;(0,s.$qd)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:S,change:void 0,didChange:L,hadValue:this.b}),L&&(this.a=S,this.b&&(0,y.$Ad)(D=>{for(const I of this.c)D.updateObserver(I,this),I.handleChange(this,void 0)},()=>{const D=this.i();return"Event fired"+(D?`: ${D}`:"")}),this.b=!0)}}i(){return(0,y.$Ed)(this._getValue)}get debugName(){const w=this.i();return"From Event"+(w?`: ${w}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$gd=g,function(l){l.Observer=g}(h||(e.$fd=h={}));function c(l,w){return new n(l,w)}e.$hd=c;class n extends y.$zd{constructor(w,M){super(),this.debugName=w,this.b=M,this.h=()=>{(0,y.$Ad)(f=>{for(const S of this.c)f.updateObserver(S,this),S.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(l){return typeof l=="string"?new a(l):new a(void 0,l)}e.$id=i;class a extends y.$zd{get debugName(){return(0,y.$Dd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(w,M){super(),this.a=w,this.b=M}trigger(w,M){if(!w){(0,y.$Ad)(f=>{this.trigger(f,M)},()=>`Trigger signal ${this.debugName}`);return}for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,M)}get(){}}function v(l,w,M){const f=(0,y.$Fd)("debounced",void 0);let S;return M.add((0,k.$9c)(L=>{const D=l.read(L);S&&clearTimeout(S),S=setTimeout(()=>{(0,y.$Ad)(I=>{f.set(D,I)})},w)})),f}e.$jd=v;function A(l,w,M){const f=(0,y.$Fd)("triggeredRecently",!1);let S;return M.add(l(()=>{f.set(!0,void 0),S&&clearTimeout(S),S=setTimeout(()=>{f.set(!1,void 0)},w)})),f}e.$kd=A;function B(l){const w=new T(!1);return l.addObserver(w),(0,N.$Qc)(()=>{l.removeObserver(w)})}e.$ld=B;function P(l){const w=new T(!0);return l.addObserver(w),l.reportChanges(),(0,N.$Qc)(()=>{l.removeObserver(w)})}e.$md=P;class T{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,M){}}function $(l){let w;return(0,O.$sd)(f=>(w=l(f,w),w))}e.$nd=$;function m(l,w){let M;const f=(0,y.$Fd)("derivedObservableWithWritableCache.counter",0),S=(0,O.$sd)(l,L=>(f.read(L),M=w(L,M),M));return Object.assign(S,{clearCache:L=>{M=void 0,f.set(f.get()+1,L)}})}e.$od=m}),define(z[11],W([0,1,5,10,9,22,4]),function(q,e,N,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return N.$Fd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return N.$Hd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return N.$Ad}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return N.$Bd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$sd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return k.$td}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$ud}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return k.$vd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return y.$9c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return y.$bd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return y.$0c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return y.$_c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return y.$8c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return y.$$c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$cd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$jd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$nd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$od}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.$ld}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$md}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$fd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$dd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$id}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$hd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.$ed}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$kd}}),!1&&(0,s.$pd)(new s.$rd)}),define(z[23],W([0,1,6,2]),function(q,e,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function y(P){const T=P;return T?typeof T.read=="function":!1}e.$Yd=y;function O(P){const T=P;return T?[T.on,T.pause,T.resume,T.destroy].every($=>typeof $=="function"):!1}e.$Zd=O;function s(P){const T=P;return T?O(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.$1d=s;function d(P,T){return new t(P,T)}e.$2d=d;class t{constructor(T,$){this.e=T,this.f=$,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(T){if(!this.a.destroyed){if(this.a.flowing)this.g(T);else if(this.b.data.push(T),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise($=>this.d.push($))}}error(T){this.a.destroyed||(this.a.flowing?this.h(T):this.b.error.push(T))}end(T){this.a.destroyed||(typeof T<"u"&&this.write(T),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(T){this.c.data.slice(0).forEach($=>$(T))}h(T){this.c.error.length===0?(0,N.$1)(T):this.c.error.slice(0).forEach($=>$(T))}i(){this.c.end.slice(0).forEach(T=>T())}on(T,$){if(!this.a.destroyed)switch(T){case"data":this.c.data.push($),this.resume();break;case"end":this.c.end.push($),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push($),this.a.flowing&&this.k();break}}removeListener(T,$){if(this.a.destroyed)return;let m;switch(T){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const l=m.indexOf($);l>=0&&m.splice(l,1)}}j(){if(this.b.data.length>0){const T=this.e(this.b.data);this.g(T),this.b.data.length=0;const $=[...this.d];this.d.length=0,$.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const T of this.b.error)this.h(T);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(P,T){const $=[];let m;for(;(m=P.read())!==null;)$.push(m);return T($)}e.$3d=r;function o(P,T,$){const m=[];let l;for(;(l=P.read())!==null&&m.length<$;)m.push(l);return l===null&&m.length>0?T(m):{read:()=>{if(m.length>0)return m.shift();if(typeof l<"u"){const w=l;return l=void 0,w}return P.read()}}}e.$4d=o;function h(P,T){return new Promise(($,m)=>{const l=[];g(P,{onData:w=>{T&&l.push(w)},onError:w=>{T?m(w):$(void 0)},onEnd:()=>{$(T?T(l):void 0)}})})}e.$5d=h;function g(P,T,$){P.on("error",m=>{$?.isCancellationRequested||T.onError(m)}),P.on("end",()=>{$?.isCancellationRequested||T.onEnd()}),P.on("data",m=>{$?.isCancellationRequested||T.onData(m)})}e.$6d=g;function c(P,T){return new Promise(($,m)=>{const l=new k.$Rc,w=[],M=L=>{if(w.push(L),w.length>T)return l.dispose(),P.pause(),$({stream:P,buffer:w,ended:!1})},f=L=>(l.dispose(),m(L)),S=()=>(l.dispose(),$({stream:P,buffer:w,ended:!0}));l.add((0,k.$Qc)(()=>P.removeListener("error",f))),P.on("error",f),l.add((0,k.$Qc)(()=>P.removeListener("end",S))),P.on("end",S),l.add((0,k.$Qc)(()=>P.removeListener("data",M))),P.on("data",M)})}e.$7d=c;function n(P,T){const $=d(T);return $.end(P),$}e.$8d=n;function i(){const P=d(()=>{throw new Error("not supported")});return P.end(),P}e.$9d=i;function a(P){let T=!1;return{read:()=>T?null:(T=!0,P)}}e.$0d=a;function v(P,T,$){const m=d($);return g(P,{onData:l=>m.write(T.data(l)),onError:l=>m.error(T.error?T.error(l):l),onEnd:()=>m.end()}),m}e.$$d=v;function A(P,T,$){let m=!1;return{read:()=>{const l=T.read();return m?l:(m=!0,l!==null?$([P,l]):P)}}}e.$_d=A;function B(P,T,$){let m=!1;const l=d($);return g(T,{onData:w=>m?l.write(w):(m=!0,l.write($([P,w]))),onError:w=>l.error(w),onEnd:()=>{m||(m=!0,l.write(P)),l.end()}}),l}e.$ae=B}),define(z[12],W([0,1,43,23]),function(q,e,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const y=typeof Buffer<"u",O=new N.$V(()=>new Uint8Array(256));let s,d;class t{static alloc(b){return y?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return y&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,U){return!(U?.dontUseNodeBuffer||!1)&&y?new t(Buffer.from(b)):(s||(s=new TextEncoder),new t(s.encode(b)))}static fromByteArray(b){const U=t.alloc(b.length);for(let p=0,V=b.length;p<V;p++)U.buffer[p]=b[p];return U}static concat(b,U){if(typeof U>"u"){U=0;for(let G=0,H=b.length;G<H;G++)U+=b[G].byteLength}const p=t.alloc(U);let V=0;for(let G=0,H=b.length;G<H;G++){const K=b[G];p.set(K,V),V+=K.byteLength}return p}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return y?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(b,U){return new t(this.buffer.subarray(b,U))}set(b,U){if(b instanceof t)this.buffer.set(b.buffer,U);else if(b instanceof Uint8Array)this.buffer.set(b,U);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),U);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,U){c(this.buffer,b,U)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,U){i(this.buffer,b,U)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,U){v(this.buffer,b,U)}indexOf(b,U=0){return r(this.buffer,b instanceof t?b.buffer:b,U)}}e.$be=t;function r(I,b,U=0){const p=b.byteLength,V=I.byteLength;if(p===0)return 0;if(p===1)return I.indexOf(b[0]);if(p>V-U)return-1;const G=O.value;G.fill(b.length);for(let X=0;X<b.length;X++)G[b[X]]=b.length-X-1;let H=U+b.length-1,K=H,_=-1;for(;H<V;)if(I[H]===b[K]){if(K===0){_=H;break}H--,K--}else H+=Math.max(b.length-K,G[I[H]]),K=b.length-1;return _}e.$ce=r;function o(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$de=o;function h(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255}e.$ee=h;function g(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$fe=g;function c(I,b,U){I[U+3]=b,b=b>>>8,I[U+2]=b,b=b>>>8,I[U+1]=b,b=b>>>8,I[U]=b}e.$ge=c;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$he=n;function i(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255,b=b>>>8,I[U+2]=b&255,b=b>>>8,I[U+3]=b&255}e.$ie=i;function a(I,b){return I[b]}e.$je=a;function v(I,b,U){I[U]=b}e.$ke=v;function A(I){return k.$3d(I,b=>t.concat(b))}e.$le=A;function B(I){return k.$0d(I)}e.$me=B;function P(I){return k.$5d(I,b=>t.concat(b))}e.$ne=P;async function T(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await P(I.stream)])}e.$oe=T;function $(I){return k.$8d(I,b=>t.concat(b))}e.$pe=$;function m(I){return k.$$d(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$qe=m;function l(I){return k.$2d(b=>t.concat(b),I)}e.$re=l;function w(I,b){return k.$_d(I,b,U=>t.concat(U))}e.$se=w;function M(I,b){return k.$ae(I,b,U=>t.concat(U))}e.$te=M;function f(I){let b=0,U=0,p=0;const V=new Uint8Array(Math.floor(I.length/4*3)),G=K=>{switch(U){case 3:V[p++]=b|K,U=0;break;case 2:V[p++]=b|K>>>2,b=K<<6,U=3;break;case 1:V[p++]=b|K>>>4,b=K<<4,U=2;break;default:b=K<<2,U=1}};for(let K=0;K<I.length;K++){const _=I.charCodeAt(K);if(_>=65&&_<=90)G(_-65);else if(_>=97&&_<=122)G(_-97+26);else if(_>=48&&_<=57)G(_-48+52);else if(_===43||_===45)G(62);else if(_===47||_===95)G(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${I[K]}`)}}const H=p;for(;U>0;)G(0);return t.wrap(V).slice(0,H)}e.$ue=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:I},b=!0,U=!1){const p=U?L:S;let V="";const G=I.byteLength%3;let H=0;for(;H<I.byteLength-G;H+=3){const K=I[H+0],_=I[H+1],X=I[H+2];V+=p[K>>>2],V+=p[(K<<4|_>>>4)&63],V+=p[(_<<2|X>>>6)&63],V+=p[X&63]}if(G===1){const K=I[H+0];V+=p[K>>>2],V+=p[K<<4&63],b&&(V+="==")}else if(G===2){const K=I[H+0],_=I[H+1];V+=p[K>>>2],V+=p[(K<<4|_>>>4)&63],V+=p[_<<2&63],b&&(V+="=")}return V}e.$ve=D}),define(z[24],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(z[13],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.StringEOL=void 0;var N;(function(y){y[y.Unknown=0]="Unknown",y[y.Invalid=3]="Invalid",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(N||(e.StringEOL=N={}));function k(y){let O=0,s=0,d=0,t=0;for(let r=0,o=y.length;r<o;r++){const h=y.charCodeAt(r);h===13?(O===0&&(s=r),O++,r+1<o&&y.charCodeAt(r+1)===10?(t|=2,r++):t|=3,d=r+1):h===10&&(t|=1,O===0&&(s=r),O++,d=r+1)}return O===0&&(s=y.length),[O,s,y.length-d,t]}e.$6s=k}),define(z[14],W([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var N;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(N||(e.LanguageId=N={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var y;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(y||(e.ColorId=y={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class d{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let h="mtk"+this.getForeground(r);const g=this.getFontStyle(r);return g&1&&(h+=" mtki"),g&2&&(h+=" mtkb"),g&4&&(h+=" mtku"),g&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(r,o){const h=this.getForeground(r),g=this.getFontStyle(r);let c=`color: ${o[h]};`;g&1&&(c+="font-style: italic;"),g&2&&(c+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(c+=`text-decoration:${n};`),c}static getPresentationFromMetadata(r){const o=this.getForeground(r),h=this.getFontStyle(r);return{foreground:o,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.$4s=d}),define(z[25],W([0,1,26]),function(q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=void 0;class k{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,d){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=d}replace(s,d,t){if(s>=this.a.length)return;if(d===0){this.insert(s,t);return}else if(t===0){this.delete(s,d);return}const r=this.a.slice(0,s),o=this.a.slice(s+d),h=y(t,this.b);this.a=r.concat(h,o)}delete(s,d){d===0||s>=this.a.length||this.a.splice(s,d)}insert(s,d){if(d===0||s>=this.a.length)return;const t=[];for(let r=0;r<d;r++)t[r]=this.b;this.a=(0,N.$Wb)(this.a,s,t)}}e.$KB=k;function y(O,s){const d=[];for(let t=0;t<O;t++)d[t]=s;return d}}),define(z[7],W([0,1,14]),function(q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=void 0;class k{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,d){const t=k.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=s.length,r[1]=t,new k(r,s,d)}constructor(s,d,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(s){return s instanceof k?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,d,t){if(this.c!==s.c||this.b!==s.b)return!1;const r=d<<1,o=r+(t<<1);for(let h=r;h<o;h++)if(this.a[h]!==s.a[h])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const d=this.a[(s<<1)+1],t=N.$4s.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const d=this.a[(s<<1)+1];return N.$4s.getTokenType(d)}getForeground(s){const d=this.a[(s<<1)+1];return N.$4s.getForeground(d)}getClassName(s){const d=this.a[(s<<1)+1];return N.$4s.getClassNameFromMetadata(d)}getInlineStyle(s,d){const t=this.a[(s<<1)+1];return N.$4s.getInlineStyleFromMetadata(t,d)}getPresentation(s){const d=this.a[(s<<1)+1];return N.$4s.getPresentationFromMetadata(d)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return k.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,d,t){return new y(this,s,d,t)}static convertToEndOffset(s,d){const r=(s.length>>>1)-1;for(let o=0;o<r;o++)s[o<<1]=s[o+1<<1];s[r<<1]=d}static findIndexInTokensArray(s,d){if(s.length<=2)return 0;let t=0,r=(s.length>>>1)-1;for(;t<r;){const o=t+Math.floor((r-t)/2),h=s[o<<1];if(h===d)return o+1;h<d?t=o+1:h>d&&(r=o)}return t}withInserted(s){if(s.length===0)return this;let d=0,t=0,r="";const o=new Array;let h=0;for(;;){const g=d<this.b?this.a[d<<1]:-1,c=t<s.length?s[t]:null;if(g!==-1&&(c===null||g<=c.offset)){r+=this.c.substring(h,g);const n=this.a[(d<<1)+1];o.push(r.length,n),d++,h=g}else if(c){if(c.offset>h){r+=this.c.substring(h,c.offset);const n=this.a[(d<<1)+1];o.push(r.length,n),h=c.offset}r+=c.text,o.push(r.length,c.tokenMetadata),t++}else break}return new k(new Uint32Array(o),r,this.d)}}e.$7s=k;class y{constructor(s,d,t,r){this.a=s,this.b=d,this.c=t,this.d=r,this.e=s.findTokenIndexAtOffset(d),this.f=0;for(let o=this.e,h=s.getCount();o<h&&!(s.getStartOffset(o)>=t);o++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof y?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const d=this.a.getEndOffset(this.e+s);return Math.min(this.c,d)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,d){return this.a.getInlineStyle(this.e+s,d)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(z[27],W([0,1,7]),function(q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=void 0,e.$8s=new Uint32Array(0).buffer;class k{static deleteBeginning(s,d){return s===null||s===e.$8s?s:k.delete(s,0,d)}static deleteEnding(s,d){if(s===null||s===e.$8s)return s;const t=y(s),r=t[t.length-2];return k.delete(s,d,r)}static delete(s,d,t){if(s===null||s===e.$8s||d===t)return s;const r=y(s),o=r.length>>>1;if(d===0&&r[r.length-2]===t)return e.$8s;const h=N.$7s.findIndexInTokensArray(r,d),g=h>0?r[h-1<<1]:0,c=r[h<<1];if(t<c){const A=t-d;for(let B=h;B<o;B++)r[B<<1]-=A;return s}let n,i;g!==d?(r[h<<1]=d,n=h+1<<1,i=d):(n=h<<1,i=g);const a=t-d;for(let A=h+1;A<o;A++){const B=r[A<<1]-a;B>i&&(r[n++]=B,r[n++]=r[(A<<1)+1],i=B)}if(n===r.length)return s;const v=new Uint32Array(n);return v.set(r.subarray(0,n),0),v.buffer}static append(s,d){if(d===e.$8s)return s;if(s===e.$8s)return d;if(s===null)return s;if(d===null)return null;const t=y(s),r=y(d),o=r.length>>>1,h=new Uint32Array(t.length+r.length);h.set(t,0);let g=t.length;const c=t[t.length-2];for(let n=0;n<o;n++)h[g++]=r[n<<1]+c,h[g++]=r[(n<<1)+1];return h.buffer}static insert(s,d,t){if(s===null||s===e.$8s)return s;const r=y(s),o=r.length>>>1;let h=N.$7s.findIndexInTokensArray(r,d);h>0&&r[h-1<<1]===d&&h--;for(let g=h;g<o;g++)r[g<<1]+=t;return s}}e.$9s=k;function y(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$0s=y}),define(z[28],W([0,1,26,12,44,13,27,15]),function(q,e,N,k,y,O,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class t{static deserialize(o,h,g){const c=new Uint32Array(o.buffer),n=(0,k.$fe)(o,h);h+=4;const i=(0,k.$fe)(o,h);h+=4;const a=[];for(let v=0;v<i;v++){const A=(0,k.$fe)(o,h);h+=4,a.push(c.subarray(h/4,h/4+A/4)),h+=A}return g.push(new t(n,a)),h}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(o,h){this.a=o,this.b=h}getLineRange(){return new d.$Cs(this.a,this.a+this.b.length)}getLineTokens(o){return this.b[o-this.a]}appendLineTokens(o){this.b.push(o)}serializeSize(){let o=0;o+=4,o+=4;for(let h=0;h<this.b.length;h++){const g=this.b[h];if(!(g instanceof Uint32Array))throw new Error("Not supported!");o+=4,o+=g.byteLength}return o}serialize(o,h){(0,k.$ge)(o,this.a,h),h+=4,(0,k.$ge)(o,this.b.length,h),h+=4;for(let g=0;g<this.b.length;g++){const c=this.b[g];if(!(c instanceof Uint32Array))throw new Error("Not supported!");(0,k.$ge)(o,c.byteLength,h),h+=4,o.set(new Uint8Array(c.buffer),h),h+=c.byteLength}return h}applyEdit(o,h){const[g,c]=(0,O.$6s)(h);this.c(o),this.d(new y.$ss(o.startLineNumber,o.startColumn),g,c)}c(o){if(o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn)return;const h=o.startLineNumber-this.a,g=o.endLineNumber-this.a;if(g<0){const c=g-h;this.a-=c;return}if(!(h>=this.b.length)){if(h<0&&g>=this.b.length){this.a=0,this.b=[];return}if(h===g){this.b[h]=s.$9s.delete(this.b[h],o.startColumn-1,o.endColumn-1);return}if(h>=0)if(this.b[h]=s.$9s.deleteEnding(this.b[h],o.startColumn-1),g<this.b.length){const c=s.$9s.deleteBeginning(this.b[g],o.endColumn-1);this.b[h]=s.$9s.append(this.b[h],c),this.b.splice(h+1,g-h)}else this.b[h]=s.$9s.append(this.b[h],null),this.b=this.b.slice(0,h+1);else{const c=-h;this.a-=c,this.b[g]=s.$9s.deleteBeginning(this.b[g],o.endColumn-1),this.b=this.b.slice(g)}}}d(o,h,g){if(h===0&&g===0)return;const c=o.lineNumber-this.a;if(c<0){this.a+=h;return}if(!(c>=this.b.length)){if(h===0){this.b[c]=s.$9s.insert(this.b[c],o.column-1,g);return}this.b[c]=s.$9s.deleteEnding(this.b[c],o.column-1),this.b[c]=s.$9s.insert(this.b[c],o.column-1,g),this.e(o.lineNumber,h)}}e(o,h){if(h===0)return;const g=[];for(let c=0;c<h;c++)g[c]=null;this.b=N.$Wb(this.b,o,g)}}e.$$s=t}),define(z[16],W([0,1,12,28]),function(q,e,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=void 0;class y{static deserialize(s){let d=0;const t=(0,N.$fe)(s,d);d+=4;const r=[];for(let o=0;o<t;o++)d=k.$$s.deserialize(s,d,r);return r}constructor(){this.a=[]}add(s,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(d);return}}this.a.push(new k.$$s(s,[d]))}finalize(){return this.a}serialize(){const s=this.b(),d=new Uint8Array(s);return this.c(d),d}b(){let s=0;s+=4;for(let d=0;d<this.a.length;d++)s+=this.a[d].serializeSize();return s}c(s){let d=0;(0,N.$ge)(s,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(s,d)}}e.$LB=y}),define(z[29],W([0,1,30,3,31,45]),function(q,e,N,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function s(f){return f===47||f===92}e.$Qf=s;function d(f){return f.replace(/[\\/]/g,N.$gc.sep)}e.$Rf=d;function t(f){return f.indexOf("/")===-1&&(f=d(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Sf=t;function r(f,S=N.$gc.sep){if(!f)return"";const L=f.length,D=f.charCodeAt(0);if(s(D)){if(s(f.charCodeAt(1))&&!s(f.charCodeAt(2))){let b=3;const U=b;for(;b<L&&!s(f.charCodeAt(b));b++);if(U!==b&&!s(f.charCodeAt(b+1))){for(b+=1;b<L;b++)if(s(f.charCodeAt(b)))return f.slice(0,b+1).replace(/[\\/]/g,S)}}return S}else if(v(D)&&f.charCodeAt(1)===58)return s(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let I=f.indexOf("://");if(I!==-1){for(I+=3;I<L;I++)if(s(f.charCodeAt(I)))return f.slice(0,I+1)}return""}e.$Tf=r;function o(f){if(!k.$j||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let L=2;const D=L;for(;L<f.length&&(S=f.charCodeAt(L),S!==92);L++);return!(D===L||(S=f.charCodeAt(L+1),isNaN(S)||S===92))}e.$Uf=o;const h=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,S=k.$j){const L=S?h:g;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||S&&c.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$Vf=n;function i(f,S,L){const D=f===S;return!L||D?D:!f||!S?!1:(0,y.$2e)(f,S)}e.$Wf=i;function a(f,S,L,D=N.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(L){if(!(0,y.$3e)(f,S))return!1;if(S.length===f.length)return!0;let b=S.length;return S.charAt(S.length-1)===D&&b--,f.charAt(b)===D}return S.charAt(S.length-1)!==D&&(S+=D),f.indexOf(S)===0}e.$Xf=a;function v(f){return f>=65&&f<=90||f>=97&&f<=122}e.$Yf=v;function A(f,S){return k.$j&&f.endsWith(":")&&(f+=N.sep),(0,N.$ic)(f)||(f=(0,N.$jc)(S,f)),f=(0,N.$hc)(f),k.$j?(f=(0,y.$Ke)(f,N.sep),f.endsWith(":")&&(f+=N.sep)):(f=(0,y.$Ke)(f,N.sep),f||(f=N.sep)),f}e.$Zf=A;function B(f){const S=(0,N.$hc)(f);return k.$j?f.length>3?!1:P(S)&&(f.length===2||S.charCodeAt(2)===92):S===N.$gc.sep}e.$1f=B;function P(f,S=k.$j){return S?v(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$2f=P;function T(f,S=k.$j){return P(f,S)?f[0]:void 0}e.$3f=T;function $(f,S,L){return S.length>f.length?-1:f===S?0:(L&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$4f=$;function m(f){const S=f.split(":");let L,D,I;for(const b of S){const U=Number(b);(0,O.$Cf)(U)?D===void 0?D=U:I===void 0&&(I=U):L=L?[L,b].join(":"):b}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:D!==void 0?D:void 0,column:I!==void 0?I:D!==void 0?1:void 0}}e.$5f=m;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function M(f,S,L=8){let D="";for(let b=0;b<L;b++){let U;b===0&&k.$j&&!S&&(L===3||L===4)?U=w:U=l,D+=U.charAt(Math.floor(Math.random()*U.length))}let I;return S?I=`${S}-${D}`:I=D,f?(0,N.$jc)(f,I):I}e.$6f=M}),define(z[17],W([0,1,6,3,8]),function(q,e,N,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var O;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$7f="vscode-tkn",e.$8f="tkn";class s{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o){this.f=`${o}/${O.vscodeRemoteResource}`}set(o,h,g){this.a[o]=h,this.b[o]=g}setConnectionToken(o,h){this.c[o]=h}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(a){return N.$1(a),o}const h=o.authority;let g=this.a[h];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const c=this.b[h],n=this.c[h];let i=`path=${encodeURIComponent(o.path)}`;return typeof n=="string"&&(i+=`&${e.$8f}=${encodeURIComponent(n)}`),y.URI.from({scheme:k.$p?this.d:O.vscodeRemoteResource,authority:`${g}:${c}`,path:this.f,query:i})}}e.$9f=new s,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class d{static{this.a=e.$bg}asBrowserUri(o){const h=this.b(o,q);return this.uriToBrowserUri(h)}uriToBrowserUri(o){return o.scheme===O.vscodeRemote?e.$9f.rewrite(o):o.scheme===O.file&&(k.$n||k.$q&&k.$h.origin===`${O.vscodeFileResource}://${d.a}`)?o.with({scheme:O.vscodeFileResource,authority:o.authority||d.a,query:null,fragment:null}):o}asFileUri(o){const h=this.b(o,q);return this.uriToFileUri(h)}uriToFileUri(o){return o.scheme===O.vscodeFileResource?o.with({scheme:O.file,authority:o.authority!==d.a?o.authority:null,query:null,fragment:null}):o}b(o,h){return y.URI.isUri(o)?o:y.URI.parse(h.toUrl(o))}}e.$cg=new d;var t;(function(r){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(o.get("3"));const h="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:y.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const a=i?.get(h);if(a)return o.get(a)}r.getHeadersFromQuery=g;function c(n,i,a){if(!globalThis.crossOriginIsolated)return;const v=i&&a?"3":a?"2":"1";n instanceof URLSearchParams?n.set(h,v):n[h]=v}r.addSearchParam=c})(t||(e.COI=t={}))}),define(z[32],W([0,1,21,17,3,8]),function(q,e,N,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=void 0;class s{constructor(g,c,n){this.id=g,this.dependencies=c,this.callback=n}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,c,n)=>{typeof g!="string"&&(n=c,c=g,g=null),(typeof c!="object"||!Array.isArray(c))&&(n=c,c=null),this.c.push(new s(g,c,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const c=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!c)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h(g){return new Promise((c,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const a=()=>{i.removeEventListener("load",v),i.removeEventListener("error",A)},v=B=>{a(),c(this.c.pop())},A=B=>{a(),n(B)};i.addEventListener("load",v),i.addEventListener("error",A),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((c,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),c(this.c.pop())}catch(i){n(i)}})}async j(g){try{const c=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,a=O.URI.parse(g).fsPath,v=c.readFileSync(a).toString(),A=i.wrap(v.replace(/^#!.*/,""));return new n.Script(A).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function o(h,g,c){if(N.$T){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[h]&&(h=r[h]);const n=`${h}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const B=`${c&&!y.$p?k.$_f:k.$$f}/${n}`;i=k.$cg.asBrowserUri(B).toString(!0)}const a=d.INSTANCE.load(i);return t.set(n,a),a}else return await new Promise((n,i)=>{q([h],n,i)})}e.$vC=o}),define(z[18],W([0,1,29,17,30,3,31,8]),function(q,e,N,k,y,O,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function t(c){return(0,d.$wc)(c,!0)}e.$jg=t;class r{constructor(n){this.a=n}compare(n,i,a=!1){return n===i?0:(0,s.$Ue)(this.getComparisonKey(n,a),this.getComparisonKey(i,a))}isEqual(n,i,a=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,a)===this.getComparisonKey(i,a)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,a=!1){if(n.scheme===i.scheme){if(n.scheme===k.Schemas.file)return N.$Xf(t(n),t(i),this.a(n))&&n.query===i.query&&(a||n.fragment===i.fragment);if((0,e.$Ag)(n.authority,i.authority))return N.$Xf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(a||n.fragment===i.fragment)}return!1}joinPath(n,...i){return d.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$sg)(n)||n.authority}basename(n){return y.$gc.basename(n.path)}extname(n){return y.$gc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===k.Schemas.file?i=d.URI.file(y.$mc(t(n))).path:(i=y.$gc.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===k.Schemas.file?i=d.URI.file(y.$hc(t(n))).path:i=y.$gc.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$Ag)(n.authority,i.authority))return;if(n.scheme===k.Schemas.file){const A=y.$lc(t(n),t(i));return O.$j?N.$Rf(A):A}let a=n.path||"/";const v=i.path||"/";if(this.a(n)){let A=0;for(const B=Math.min(a.length,v.length);A<B&&!(a.charCodeAt(A)!==v.charCodeAt(A)&&a.charAt(A).toLowerCase()!==v.charAt(A).toLowerCase());A++);a=v.substr(0,A)+a.substr(A)}return y.$gc.relative(a,v)}resolvePath(n,i){if(n.scheme===k.Schemas.file){const a=d.URI.file(y.$kc(t(n),i));return n.with({authority:a.authority,path:a.path})}return i=N.$Sf(i),n.with({path:y.$gc.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,s.$2e)(n,i)}hasTrailingPathSeparator(n,i=y.sep){if(n.scheme===k.Schemas.file){const a=t(n);return a.length>N.$Tf(a).length&&a[a.length-1]===i}else{const a=n.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=y.sep){return(0,e.$Bg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=y.sep){let a=!1;if(n.scheme===k.Schemas.file){const v=t(n);a=v!==void 0&&v.length===N.$Tf(v).length&&v[v.length-1]===i}else{i="/";const v=n.path;a=v.length===1&&v.charCodeAt(v.length-1)===47}return!a&&!(0,e.$Bg)(n,i)?n.with({path:n.path+"/"}):n}}e.$kg=r,e.$lg=new r(()=>!1),e.$mg=new r(c=>c.scheme===k.Schemas.file?!O.$l:!0),e.$ng=new r(c=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function o(c,n){const i=[];for(let a=0;a<c.length;a++){const v=n(c[a]);c.some((A,B)=>B===a?!1:(0,e.$pg)(v,n(A)))||i.push(c[a])}return i}e.$Eg=o;var h;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function n(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(B=>{const[P,T]=B.split(":");P&&T&&a.set(P,T)});const A=i.path.substring(0,i.path.indexOf(";"));return A&&a.set(c.META_DATA_MIME,A),a}c.parseMetaData=n})(h||(e.DataUri=h={}));function g(c,n,i){if(n){let a=c.path;return a&&a[0]!==y.$gc.sep&&(a=y.$gc.sep+a),c.with({scheme:i,authority:n,path:a})}return c.with({scheme:i})}e.$Fg=g}),define(z[19],W([0,1,46,6,33,2,18,3,24]),function(q,e,N,k,y,O,s,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gh=e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function r(j){return!!j&&typeof j.then=="function"}e.$Gg=r;function o(j){const u=new N.$Xd,E=j(u.token),C=new Promise((R,F)=>{const Q=u.token.onCancellationRequested(()=>{Q.dispose(),u.dispose(),F(new k.$5)});Promise.resolve(E).then(Z=>{Q.dispose(),u.dispose(),R(Z)},Z=>{Q.dispose(),u.dispose(),F(Z)})});return new class{cancel(){u.cancel()}then(R,F){return C.then(R,F)}catch(R){return this.then(void 0,R)}finally(R){return C.finally(R)}}}e.$Hg=o;function h(j,u,E){return new Promise((C,R)=>{const F=u.onCancellationRequested(()=>{F.dispose(),C(E)});j.then(C,R).finally(()=>F.dispose())})}e.$Ig=h;function g(j,u){return new Promise((E,C)=>{const R=u.onCancellationRequested(()=>{R.dispose(),C(new k.$5)});j.then(E,C).finally(()=>R.dispose())})}e.$Jg=g;async function c(j){let u=-1;const E=j.map((C,R)=>C.then(F=>(u=R,F)));try{return await Promise.race(E)}finally{j.forEach((C,R)=>{R!==u&&C.cancel()})}}e.$Kg=c;function n(j,u,E){let C;const R=setTimeout(()=>{C?.(void 0),E?.()},u);return Promise.race([j.finally(()=>clearTimeout(R)),new Promise(F=>C=F)])}e.$Lg=n;function i(j){return new Promise((u,E)=>{const C=j();r(C)?C.then(u,E):u(C)})}e.$Mg=i;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const E=()=>{if(this.b=null,this.f)return;const C=this.queue(this.d);return this.d=null,C};this.b=new Promise(C=>{this.a.then(E,E).then(C)})}return new Promise((E,C)=>{this.b.then(E,C)})}return this.a=u(),new Promise((E,C)=>{this.a.then(R=>{this.a=null,E(R)},R=>{this.a=null,C(R)})})}dispose(){this.f=!0}}e.$Ng=a;class v{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$Og=v;class A{constructor(){this.a=new Map}queue(u,E){const R=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(u)===R&&this.a.delete(u)});return this.a.set(u,R),R}}e.$Pg=A;const B=(j,u)=>{let E=!0;const C=setTimeout(()=>{E=!1,u()},j);return{isTriggered:()=>E,dispose:()=>{clearTimeout(C),E=!1}}},P=j=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,j())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class T{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,E=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((R,F)=>{this.d=R,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const C=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$Kd?P(C):B(E,C),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=T;class ${constructor(u){this.a=new T(u),this.b=new a}trigger(u,E){return this.a.trigger(()=>this.b.queue(u),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=$;class m{constructor(){this.a=!1,this.b=new Promise((u,E)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=m;class l extends m{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$Tg=l;function w(j,u){return u?new Promise((E,C)=>{const R=setTimeout(()=>{F.dispose(),E()},j),F=u.onCancellationRequested(()=>{clearTimeout(R),F.dispose(),C(new k.$5)})}):o(E=>w(j,E))}e.$Ug=w;function M(j,u=0,E){const C=setTimeout(()=>{j(),E&&R.dispose()},u),R=(0,O.$Qc)(()=>{clearTimeout(C),E?.deleteAndLeak(R)});return E?.add(R),R}e.$Vg=M;function f(j){const u=[];let E=0;const C=j.length;function R(){return E<C?j[E++]():null}function F(Q){Q!=null&&u.push(Q);const Z=R();return Z?Z.then(F):Promise.resolve(u)}return Promise.resolve(null).then(F)}e.$Wg=f;function S(j,u=C=>!!C,E=null){let C=0;const R=j.length,F=()=>{if(C>=R)return Promise.resolve(E);const Q=j[C++];return Promise.resolve(Q()).then(J=>u(J)?Promise.resolve(J):F())};return F()}e.$Xg=S;function L(j,u=C=>!!C,E=null){if(j.length===0)return Promise.resolve(E);let C=j.length;const R=()=>{C=-1;for(const F of j)F.cancel?.()};return new Promise((F,Q)=>{for(const Z of j)Z.then(J=>{--C>=0&&u(J)?(R(),F(J)):C===0&&F(E)}).catch(J=>{--C>=0&&(R(),Q(J))})})}e.$Yg=L;class D{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new y.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((E,C)=>{this.f.push({factory:u,c:E,e:C}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const E=u.factory();E.then(u.c,u.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=D;class I extends D{constructor(){super(1)}}e.$1g=I;class b{constructor(){this.a=new ee,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$2g=b;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,E=s.$lg){const C=E.getComparisonKey(u);let R=this.a.get(C);if(!R){R=new I;const F=this.f++,Q=y.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(C),this.h(),this.d?.deleteAndDispose(F),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$1c),this.d.set(F,Q),this.a.set(C,R)}return R}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=U;class p{constructor(u,E){this.a=-1,typeof u=="function"&&typeof E=="number"&&this.setIfNotSet(u,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},E)}setIfNotSet(u,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},E))}}e.$4g=p;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(u,E){this.cancel(),this.a=setInterval(()=>{u()},E)}}e.$5g=V;class G{constructor(u,E){this.b=-1,this.a=u,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=G;class H{constructor(u,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=u,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=H;class K extends G{constructor(u,E){super(u,E),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$8g=K;class _ extends O.$Sc{constructor(u,E){super(),this.g=u,this.h=E,this.a=[],this.b=this.B(new O.$Tc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of u)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=j=>{(0,d.$B)(()=>{if(u)return;const E=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let u=!1;return{dispose(){u||(u=!0)}}}:e.$0g=(j,u)=>{const E=requestIdleCallback(j,typeof u=="number"?{timeout:u}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(E))}}}}();class X{constructor(u){this.d=!1,this.a=()=>{try{this.f=u()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=X;async function re(j,u,E){let C;for(let R=0;R<E;R++)try{return await j()}catch(F){C=F,await w(u)}throw C}e.$_g=re;class ee{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,E,C){return this.a={taskId:u,cancel:()=>C?.(),promise:E},E.then(()=>this.d(u),()=>this.d(u)),E}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let E,C;const R=new Promise((F,Q)=>{E=F,C=Q});this.b={run:u,promise:R,promiseResolve:E,promiseReject:C}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=ee;class ae{constructor(u,E=()=>Date.now()){this.d=u,this.f=E,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$bh=ae;var te;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(te||(te={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,E)=>{this.a=u,this.b=E})}complete(u){return new Promise(E=>{this.a(u),this.d={outcome:0,value:u},E()})}error(u){return new Promise(E=>{this.b(u),this.d={outcome:1,value:u},E()})}cancel(){return this.error(new k.$5)}}e.$ch=x;var ne;(function(j){async function u(C){let R;const F=await Promise.all(C.map(Q=>Q.then(Z=>Z,Z=>{R||(R=Z)})));if(typeof R<"u")throw R;return F}j.settled=u;function E(C){return new Promise(async(R,F)=>{try{await C(R,F)}catch(Q){F(Q)}})}j.withAsyncBody=E})(ne||(e.Promises=ne={}));var ie;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ie||(ie={}));class Y{static fromArray(u){return new Y(E=>{E.emitMany(u)})}static fromPromise(u){return new Y(async E=>{E.emitMany(await u)})}static fromPromises(u){return new Y(async E=>{await Promise.all(u.map(async C=>E.emitOne(await C)))})}static merge(u){return new Y(async E=>{await Promise.all(u.map(async C=>{for await(const R of C)E.emitOne(R)}))})}static{this.EMPTY=Y.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new y.$Nd,queueMicrotask(async()=>{const E={emitOne:C=>this.g(C),emitMany:C=>this.h(C),reject:C=>this.k(C)};try{await Promise.resolve(u(E)),this.j()}catch(C){this.k(C)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(u,E){return new Y(async C=>{for await(const R of u)C.emitOne(E(R))})}map(u){return Y.map(this,u)}static filter(u,E){return new Y(async C=>{for await(const R of u)E(R)&&C.emitOne(R)})}filter(u){return Y.filter(this,u)}static coalesce(u){return Y.filter(u,E=>!!E)}coalesce(){return Y.coalesce(this)}static async toPromise(u){const E=[];for await(const C of u)E.push(C);return E}toPromise(){return Y.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$dh=Y;class se extends Y{constructor(u,E){super(E),this.l=u}cancel(){this.l.cancel()}}e.$eh=se;function he(j){const u=new N.$Xd,E=j(u.token);return new se(u,async C=>{const R=u.token.onCancellationRequested(()=>{R.dispose(),u.dispose(),C.reject(new k.$5)});try{for await(const F of E){if(u.token.isCancellationRequested)return;C.emitOne(F)}R.dispose(),u.dispose()}catch(F){R.dispose(),u.dispose(),C.reject(F)}})}e.$fh=he;class oe{constructor(){this.a=new x,this.b=new Y(C=>{if(u){C.reject(u);return}return E&&C.emitMany(E),this.d=R=>C.reject(R),this.f=R=>C.emitOne(R),this.a.p});let u,E;this.f=C=>{E||(E=[]),E.push(C)},this.d=C=>{u||(u=C)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$gh=oe}),define(z[20],W([0,1,34]),function(q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=e.$IB=e.$HB=void 0,e.$HB=new class{clone(){return this}equals(O){return this===O}};function k(O,s){return new N.$bt([new N.$at(0,"",O)],s)}e.$IB=k;function y(O,s){const d=new Uint32Array(2);return d[0]=0,d[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new N.$ct(d,s===null?e.$HB:s)}e.$JB=y}),define(z[35],W([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(q,e,N,k,y,O,s,d,t,r,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=e.$QB=e.$PB=e.$OB=e.$NB=e.$MB=void 0;var c;(function(T){T[T.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(c||(c={}));class n{constructor($,m){this.tokenizationSupport=m,this.a=this.tokenizationSupport.getInitialState(),this.store=new a($)}getStartState($){return this.store.getStartState($,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$MB=n;class i extends n{constructor($,m,l,w){super($,m),this._textModel=l,this._languageIdCodec=w}updateTokensUntilLine($,m){const l=this._textModel.getLanguageId();for(;;){const w=this.getFirstInvalidLine();if(!w||w.lineNumber>m)break;const M=this._textModel.getLineContent(w.lineNumber),f=B(this._languageIdCodec,l,this.tokenizationSupport,M,!0,w.startState);$.add(w.lineNumber,f.tokens),this.store.setEndState(w.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter($,m){const l=this.getStartState($.lineNumber);if(!l)return 0;const w=this._textModel.getLanguageId(),M=this._textModel.getLineContent($.lineNumber),f=M.substring(0,$.column-1)+m+M.substring($.column-1),S=B(this._languageIdCodec,w,this.tokenizationSupport,f,!0,l),L=new g.$7s(S.tokens,f,this._languageIdCodec);if(L.getCount()===0)return 0;const D=L.findTokenIndexAtOffset($.column-1);return L.getStandardTokenType(D)}tokenizeLineWithEdit($,m,l){const w=$.lineNumber,M=$.column,f=this.getStartState(w);if(!f)return null;const S=this._textModel.getLineContent(w),L=S.substring(0,M-1)+l+S.substring(M-1+m),D=this._textModel.getLanguageIdAtPosition(w,0),I=B(this._languageIdCodec,D,this.tokenizationSupport,L,!0,f);return new g.$7s(I.tokens,L,this._languageIdCodec)}isCheapToTokenize($){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return $<m||$===m&&this._textModel.getLineLength($)<2048}tokenizeHeuristically($,m,l){if(l<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine($,l),{heuristicTokens:!1};let w=this.b(m);const M=this._textModel.getLanguageId();for(let f=m;f<=l;f++){const S=this._textModel.getLineContent(f),L=B(this._languageIdCodec,M,this.tokenizationSupport,S,!0,w);$.add(f,L.tokens),w=L.endState}return{heuristicTokens:!0}}b($){let m=this._textModel.getLineFirstNonWhitespaceColumn($);const l=[];let w=null;for(let S=$-1;m>1&&S>=1;S--){const L=this._textModel.getLineFirstNonWhitespaceColumn(S);if(L!==0&&L<m&&(l.push(this._textModel.getLineContent(S)),m=L,w=this.getStartState(S),w))break}w||(w=this.tokenizationSupport.getInitialState()),l.reverse();const M=this._textModel.getLanguageId();let f=w;for(const S of l)f=B(this._languageIdCodec,M,this.tokenizationSupport,S,!1,f).endState;return f}}e.$NB=i;class a{constructor($){this.d=$,this.a=new v,this.b=new A,this.b.addRange(new t.$As(1,$+1))}getEndState($){return this.a.getEndState($)}setEndState($,m){if(!m)throw new k.$cb("Cannot set null/undefined state");this.b.delete($);const l=this.a.setEndState($,m);return l&&$<this.d&&this.b.addRange(new t.$As($+1,$+2)),l}acceptChange($,m){this.d+=m-$.length,this.a.acceptChange($,m),this.b.addRangeAndResize(new t.$As($.startLineNumber,$.endLineNumberExclusive),m)}acceptChanges($){for(const m of $){const[l]=(0,s.$6s)(m.text);this.acceptChange(new d.$Cs(m.range.startLineNumber,m.range.endLineNumber+1),l+1)}}invalidateEndStateRange($){this.b.addRange(new t.$As($.startLineNumber,$.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState($,m){return $===1?m:this.getEndState($-1)}getFirstInvalidLine($){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const l=this.getStartState(m,$);if(!l)throw new k.$cb("Start state must be defined");return{lineNumber:m,startState:l}}}e.$OB=a;class v{constructor(){this.a=new o.$KB(null)}getEndState($){return this.a.get($)}setEndState($,m){const l=this.a.get($);return l&&l.equals(m)?!1:(this.a.set($,m),!0)}acceptChange($,m){let l=$.length;m>0&&l>0&&(l--,m--),this.a.replace($.startLineNumber,l,m)}acceptChanges($){for(const m of $){const[l]=(0,s.$6s)(m.text);this.acceptChange(new d.$Cs(m.range.startLineNumber,m.range.endLineNumber+1),l+1)}}}e.$PB=v;class A{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const $=this.a[0];return $.start+1===$.endExclusive?this.a.shift():this.a[0]=new t.$As($.start+1,$.endExclusive),$.start}delete($){const m=this.a.findIndex(l=>l.contains($));if(m!==-1){const l=this.a[m];l.start===$?l.endExclusive===$+1?this.a.splice(m,1):this.a[m]=new t.$As($+1,l.endExclusive):l.endExclusive===$+1?this.a[m]=new t.$As(l.start,$):this.a.splice(m,1,new t.$As(l.start,$),new t.$As($+1,l.endExclusive))}}addRange($){t.$As.addRange($,this.a)}addRangeAndResize($,m){let l=0;for(;!(l>=this.a.length||$.start<=this.a[l].endExclusive);)l++;let w=l;for(;!(w>=this.a.length||$.endExclusive<this.a[w].start);)w++;const M=m-$.length;for(let f=w;f<this.a.length;f++)this.a[f]=this.a[f].delta(M);if(l===w){const f=new t.$As($.start,$.start+m);f.isEmpty||this.a.splice(l,0,f)}else{const f=Math.min($.start,this.a[l].start),S=Math.max($.endExclusive,this.a[w-1].endExclusive),L=new t.$As(f,S+M);L.isEmpty?this.a.splice(l,w-l):this.a.splice(l,w-l,L)}}toString(){return this.a.map($=>$.toString()).join(" + ")}}e.$QB=A;function B(T,$,m,l,w,M){let f=null;if(m)try{f=m.tokenizeEncoded(l,w,M.clone())}catch(S){(0,k.$1)(S)}return f||(f=(0,r.$JB)(T.encodeLanguageId($),M)),g.$7s.convertToEndOffset(f.tokens,l.length),f}class P{constructor($,m){this.b=$,this.d=m,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,N.$0g)($=>{this.f=!1,this.h($)}))}h($){const m=Date.now()+$.timeRemaining(),l=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<m?(0,y.$B)(l):this.g())};l()}j(){const $=this.b._textModel.getLineCount(),m=new h.$LB,l=O.$Jd.create(!1);do if(l.elapsed()>1||this.l(m)>=$)break;while(this.k());this.d.setTokens(m.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l($){const m=this.b?.getFirstInvalidLine();return m?(this.b.updateTokensUntilLine($,m.lineNumber),m.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens($,m){this.b.store.invalidateEndStateRange(new d.$Cs($,m))}}e.$RB=P}),define(z[37],W([0,1,33,2,36,14,34]),function(q,e,N,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CEb=void 0;class d extends k.$Sc{constructor(r,o,h,g,c,n,i){super(),this.c=r,this.f=o,this.g=h,this.h=g,this.j=c,this.m=n,this.n=i,this.a=[],this.b=this.B(new N.$Nd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(r,o,h){throw new Error("Not supported!")}createBackgroundTokenizer(r,o){if(this.h)return this.h(r,o)}tokenizeEncoded(r,o,h){const g=Math.random()*1e4<1,c=this.n||g,n=c?new y.$Jd(!0):void 0,i=this.c.tokenizeLine2(r,h,500);if(c){const v=n.elapsed();(g||v>32)&&this.m(v,r.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new s.$ct(i.tokens,h);if(this.g){const v=this.a,A=i.tokens;for(let B=0,P=A.length>>>1;B<P;B++){const T=A[(B<<1)+1],$=O.$4s.getLanguageId(T);v[$]||(v[$]=!0,this.b.fire($))}}let a;return h.equals(i.ruleStack)?a=h:a=i.ruleStack,new s.$ct(i.tokens,a)}}e.$CEb=d}),define(z[38],W([0,1,20,2,11]),function(q,e,N,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DEb=void 0;class O extends k.$Sc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,r){super(),this.a=d,this.b=t,this.c=r,this.B((0,y.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,r){throw new Error("Not supported!")}tokenizeEncoded(d,t,r){return d.length>=this.c.get()?(0,N.$JB)(this.a,r):this.b.tokenizeEncoded(d,t,r)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$DEb=O}),define(z[39],W([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(q,e,N,k,y,O,s,d,t,r,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IEb=void 0;class c extends d.$Vu{constructor(a,v,A,B,P,T,$,m){super(a,v,A,B),this.s=P,this.t=T,this.u=$,this.a=null,this.b=!1,this.c=(0,y.observableValue)(this,-1),this.q=new k.$6g(()=>this.w(),10),this.c.set(m,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,v){this.t=a,this.u=v,this.v()}onEvents(a){super.onEvents(a),this.a?.store.acceptChanges(a.changes),this.q.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,v){this.a&&(this.a.store.invalidateEndStateRange(new s.$Cs(a,v)),this.q.schedule())}async v(){this.a=null;const a=this.t,v=this.u,A=await this.s.getOrCreateGrammar(a,v);if(!(this.b||a!==this.t||v!==this.u||!A)){if(A.grammar){const B=new g.$DEb(this.u,new h.$CEb(A.grammar,A.initialState,!1,void 0,()=>!1,(P,T,$)=>{this.s.reportTokenizationTime(P,a,A.sourceExtensionId,T,$)},!1),this.c);this.a=new t.$MB(this.f.length,B)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:v}=await(0,N.$vC)("vscode-textmate","release/main.js");this.m=v}const a=new Date().getTime();for(;;){let v=0;const A=new r.$LB,B=new n;for(;;){const $=this.a.getFirstInvalidLine();if($===null||v>200)break;v++;const m=this.f[$.lineNumber-1],l=this.a.tokenizationSupport.tokenizeEncoded(m,!0,$.startState);if(this.a.store.setEndState($.lineNumber,l.endState)){const M=this.m($.startState,l.endState);B.setState($.lineNumber,M)}else B.setState($.lineNumber,null);if(o.$7s.convertToEndOffset(l.tokens,m.length),A.add($.lineNumber,l.tokens),new Date().getTime()-a>20)break}if(v===0)break;const P=B.getStateDeltas();if(this.s.setTokensAndStates(this.h,A.serialize(),P),new Date().getTime()-a>20){(0,O.$B)(()=>this.w());return}}}}e.$IEb=c;class n{constructor(){this.a=-1,this.b=[]}setState(a,v){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(v):this.b.push({startLineNumber:a,stateDeltas:[v]}),this.a=a}getStateDeltas(){return this.b}}}),define(z[40],W([0,1,18]),function(q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FEb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const s=this.a[O.scopeName];N.$og(s.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$FEb=k}),define(z[41],W([0,1,2,40]),function(q,e,N,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HEb=e.$GEb=void 0,e.$GEb="No TM Grammar registered for this language.";class y extends N.$Sc{constructor(s,d,t,r){super(),this.a=s,this.b=t.INITIAL,this.c=new k.$FEb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async o=>{const h=this.c.getGrammarDefinition(o);if(!h)return this.a.logTrace(`No grammar found for scope ${o}`),null;const g=h.location;try{const c=await this.a.readFile(g);return t.parseRawGrammar(c,g.path)}catch(c){return this.a.logError(`Unable to load and parse grammar for scope ${o} from ${g}`,c),null}},getInjections:o=>{const h=o.split(".");let g=[];for(let c=1;c<=h.length;c++){const n=h.slice(0,c).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const o of d){if(this.c.register(o),o.injectTo){for(const h of o.injectTo){let g=this.f[h];g||(this.f[h]=g=[]),g.push(o.scopeName)}if(o.embeddedLanguages)for(const h of o.injectTo){let g=this.g[h];g||(this.g[h]=g=[]),g.push(o.embeddedLanguages)}}o.language&&this.h.set(o.language,o.scopeName)}}has(s){return this.h.has(s)}setTheme(s,d){this.j.setTheme(s,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,d){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$GEb);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.$GEb);const o=r.embeddedLanguages;if(this.g[t]){const c=this.g[t];for(const n of c)for(const i of Object.keys(n))o[i]=n[i]}const h=Object.keys(o).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:o,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(c){throw c.message&&c.message.startsWith("No grammar provided for")?new Error(e.$GEb):c}return{languageId:s,grammar:g,initialState:this.b,containsEmbeddedLanguages:h,sourceExtensionId:r.sourceExtensionId}}}e.$HEb=y}),define(z[49],W([0,1,8,41,39]),function(q,e,N,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(d,t){return new s(d,t)}e.create=O;class s{constructor(t,r){this.f=r,this.b=new Map,this.c=[],this.a=t.host;const o=r.grammarDefinitions.map(h=>({location:N.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this.d=this.g(o)}async g(t){const r=this.f.textmateMainUri,o=await new Promise((i,a)=>{q([r],i,a)}),h=await new Promise((i,a)=>{q([this.f.onigurumaMainUri],i,a)}),c=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(c);const n=Promise.resolve({createOnigScanner:i=>h.createOnigScanner(i),createOnigString:i=>h.createOnigString(i)});return new k.$HEb({logTrace:i=>{},logError:(i,a)=>console.error(i,a),readFile:i=>this.a.readFile(i)},t,o,n)}acceptNewModel(t){const r=N.URI.revive(t.uri),o=this;this.b.set(t.controllerId,new y.$IEb(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(h,g){const c=await o.d;return c?(o.c[g]||(o.c[g]=c.createGrammar(h,g)),o.c[g]):Promise.resolve(null)},setTokensAndStates(h,g,c){o.a.setTokensAndStates(t.controllerId,h,g,c)},reportTokenizationTime(h,g,c,n,i){o.a.reportTokenizationTime(h,g,c,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this.b.get(t).onEvents(r)}retokenize(t,r,o){this.b.get(t).retokenize(r,o)}acceptModelLanguageChanged(t,r,o){this.b.get(t).onLanguageId(r,o)}acceptRemovedModel(t){const r=this.b.get(t);r&&(r.dispose(),this.b.delete(t))}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cbd09078e6221fa1553c5a59dd25e63ad767911a/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
